/*
 Promitnuti zmeny uctu na polozce skladu na navazane doklady

 Autor:        Jan Besta
*/
create or replace function dPolSkladUpdateUcty() returns trigger as $$
declare nelzeZmena int;
begin
  -- test zda smi dojit ke zmene na dokladu
  if ((select zamek from dDoklSklad where idDoklSklad = NEW.idDoklSklad) = true) then
    raise exception 'dPolSkladUpdateUcty(): Dochz ke zmn na poloce skladovho dokladu, kter je zamen.';
  end if;

  if ((select typPohybuK from dDoklSklad where idDoklSklad = NEW.idDoklSklad) = 'typPohybu.prijem') then
    if (compareId(NEW.idZklDalUcet, OLD.idZklDalUcet) = false and NEW.kopZklDalUcet = false) then
      select count(*) into nelzeZmena from dPolFak where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and kopZklMdUcet = true and
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl');
      if (nelzeZmena = 0) then
        update dPolFak set idZklMdUcet = NEW.idZklDalUcet where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl');
      else
        raise exception 'dPolSkladUpdateUcty(): Nelze zmnit et u navzan poloky.';
      end if;
    end if;
  end if;

  return NEW;
end;
$$ LANGUAGE plpgsql;


drop trigger if exists dPolSkladUpdateUcty on dpolsklad;

create trigger dPolSkladUpdateUcty after update on dpolsklad
for each row execute procedure dPolSkladUpdateUcty();