/*
 Vrac true v ppad e dan poloka pjde uloit 
 a false v ppad e nkde dojde k chyb
 @param i_SkladKartaId - id skladov karty
 @param i_datum - datum zauctovani polozky kterou chceme vlozit
 @param i_PolSkladId - id poloky skladoveho dokladu
 @param i_MnozMj - mnozstvi MJ ktere chceme na skladovou kartu vlozit/odebrat
 @param i_TypPohybuK - typPohybuK z hlavicky dokladu naleziciho k polozce

 Autor:  Karel Bel
*/
CREATE OR REPLACE FUNCTION dcanulozitpolozku(i_skladkartaid integer, i_datum date, i_polskladid integer, i_mnozmj numeric, i_typpohybuk character varying)
  RETURNS boolean AS
$BODY$
declare
  _stavMjKDatu numeric(19,6);
  zaznam Record;
  loc_MnozMj numeric(19,6);
  _sklzapor boolean; 
begin
  /* nahrajeme stav skladu pred danou menenou nebo pridavanou prijmenkou nebo vydejkou */
  _stavMjKDatu := (select dGetStavNaSklade(i_SkladKartaId, i_datum, i_PolSkladId));

  loc_MnozMj := i_MnozMj;
  /* pokud jde o vydej musim odecitat */  
  if i_TypPohybuK = 'typPohybu.vydej' then  
    loc_MnozMj := 0-loc_MnozMj;  
  end if;
  
  /* pridam k tomuto stavu mnozstvi mj na pridavane polozce*/
  _stavMjKDatu := _stavMjKDatu + loc_MnozMj;

  /* provedu kontrolu na zaporny stav skladu */
  if _stavMjKDatu < 0 then 
    select sklzapor into _sklzapor from nNastav where i_datum >= PlatiOdData order by PlatiOdData desc limit 1; 
    if (_sklzapor is null) then 
      select sklzapor into _sklzapor from nNastav where PlatiOdData is null limit 1;  
    end if; 
    if _sklzapor is null or _sklzapor = false then 
      return false; 
    end if; 
  end if; 
  
  /*-------------------------------------------------------------------------------------------------------------------------------------------*/
  /* a zacnu se pokouset pricist nasledujici polozky */
  for zaznam in select * from dPolSklad ps LEFT OUTER JOIN dDoklSklad ds ON ps.idDoklSklad = ds.idDoklSklad
    where ps.datUcto >= i_datum and ps.idKarty = i_SkladKartaId and ps.idPolSklad > i_PolSkladId order by ps.datUcto asc 
    loop  
    
    loc_MnozMJ := zaznam.MnozMJ;
    
    /* pokud jde o vydej musim odecitat */  
    if zaznam.typPohybuK = 'typPohybu.vydej' then  
      loc_MnozMJ := 0-loc_MnozMJ;  
    end if;

    /* prictu mnozstvi an dane polozce */ 
    _stavMjKDatu = _stavMjKDatu + loc_MnozMJ;

    /* provedu kontrolu na zaporny stav skladu */
    if _stavMjKDatu < 0 then 
      select sklzapor into _sklzapor from nNastav where zaznam.DatUcto >= PlatiOdData order by PlatiOdData desc limit 1; 
      if (_sklzapor is null) then 
	select sklzapor into _sklzapor from nNastav where PlatiOdData is null limit 1;  
      end if; 
      if _sklzapor is null or _sklzapor = false then 
        return false; 
      end if; 
    end if; 

  end loop; 

  return true; 
end
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;