CREATE FUNCTION obchodrealizovatelnost(idDokl integer) RETURNS numeric(6,2) AS $$ 
declare
  zbyvaNakl numeric(15,2);
  moznoSklad numeric(15,2);
  moznoNesklad numeric(15,2);
  vysledek numeric(6,2);
  _idUcetniObdobi integer;
begin 
  select idUcetObdobi into _idUcetniObdobi from nUcetObdobi where (DATE(NOW()) >= PlatiOdData and DATE(NOW()) <= PlatiDoData) limit 1;
  
  select coalesce(sum((mnozMj-mnozMjReal) * cenaMj), 0) into zbyvaNakl from dPolObch where idDoklObch = idDokl;

  select coalesce(sum(
    minValue(
        maxValue(dgetstavnasklade((select idKarty from sKarty where idCenik = P.idCenik AND idTypDokl = P.idSkladu AND idUcetObdobi = _idUcetniObdobi), DATE(NOW()), -1), 0),
        (mnozMj-mnozMjReal))
    * cenaMj), 0) into moznoSklad
    from dPolObch as P where idDoklObch = idDokl and typPolozkyK = 'typPolozky.katalog';

  select coalesce(sum((mnozMj-mnozMjReal) * cenaMj), 0) into moznoNesklad from dPolObch where idDoklObch = idDokl and typPolozkyK <> 'typPolozky.katalog';

  if (zbyvaNakl = 0) then
    vysledek := 100 ;
  else
    vysledek := ((moznoSklad + moznoNesklad) / zbyvaNakl) * 100;
  end if;
  
  return vysledek;
end; 
$$ LANGUAGE plpgsql;