--
-- PostgreSQL database dump
--

-- Started on 2008-05-27 17:41:55

SET standard_conforming_strings = off;
SET check_function_bodies = false;
SET client_min_messages = warning;
SET escape_string_warning = off;

SET standard_conforming_strings = off;
SET check_function_bodies = false;
SET client_min_messages = warning;
SET escape_string_warning = off;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

-- sekvence

CREATE SEQUENCE seq_csfirma
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;

CREATE SEQUENCE seq_cspristup
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;

CREATE SEQUENCE seq_csuzivatel
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;

CREATE SEQUENCE seq_dbversion
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;

CREATE SEQUENCE seq_csskupina
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;

CREATE SEQUENCE seq_cslicense
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;

CREATE SEQUENCE seq_cscert
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;

CREATE SEQUENCE seq_cssetting
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;

CREATE SEQUENCE seq_csprefirma
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;

CREATE SEQUENCE seq_csexternalapp
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;

-- tabulky (vcetne primarnich klicu a unique constraintu)

CREATE TABLE csfirma (
    idcsfirma integer DEFAULT nextval('seq_csfirma'::regclass) NOT NULL PRIMARY KEY,
    dbhost character varying(255) NOT NULL,
    dbnazev character varying(255) NOT NULL,
    nazev character varying(255) NOT NULL,
    show boolean DEFAULT true NOT NULL,
    create_dt timestamp DEFAULT now() NOT NULL,
    idcsskupina integer NOT NULL,
    last_dt timestamp,
    autostart boolean DEFAULT false,
    watching_changes boolean DEFAULT false,
    stav character varying(255) DEFAULT 'ESTABLISHED' NOT NULL,
    CONSTRAINT csfirma_dbnazev_key UNIQUE (dbnazev)
);

CREATE TABLE cspristup (
    idcspristup integer DEFAULT nextval('seq_cspristup'::regclass) NOT NULL PRIMARY KEY,
    idcsfirma integer,
    idcsuzivatel integer,
    isAdmin boolean DEFAULT false NOT NULL,
    connectiontype varchar(16) default 'RW' NOT NULL,
    create_dt timestamp DEFAULT now() NOT NULL,
    CONSTRAINT cspristup_kod_key UNIQUE (idcsfirma,idcsuzivatel)
);

CREATE TABLE csuzivatel (
    idcsuzivatel integer DEFAULT nextval('seq_csuzivatel'::regclass) NOT NULL PRIMARY KEY,
    heslo character varying(255) NOT NULL,
    dbpassword character varying(255),
    otpsecret character varying(255),
    otpprefix character varying(255),
    jmeno character varying(255) NOT NULL,
    create_company boolean DEFAULT false NOT NULL,
    manage_all boolean DEFAULT false NOT NULL,
    create_user boolean DEFAULT false NOT NULL,
    change_password boolean DEFAULT false NOT NULL,
    delete_company boolean DEFAULT false NOT NULL,
    grant_permission boolean DEFAULT false NOT NULL,
    license_mgmt boolean DEFAULT false NOT NULL,
    deleted boolean DEFAULT false NOT NULL,
    blocked boolean DEFAULT false NOT NULL,
    blocked_text varchar(256),
    create_dt timestamp DEFAULT now() NOT NULL,
    idcsskupina integer NOT NULL,
    sso_identifier varchar(255),
    dbusername character varying(63),
    default_role character varying(63),
    given_name varchar(255),
    family_name varchar(255),
    email varchar(255),
    mobile varchar(255),
    system_user boolean DEFAULT false NOT NULL,
    last_dt timestamp,
    user_type varchar(63),
    CONSTRAINT csuzivatel_kod_key UNIQUE (jmeno),
    CONSTRAINT csuzivatel_dbusername_key UNIQUE (dbusername)
);

CREATE TABLE dbversion (
    iddbversion integer DEFAULT nextval('seq_dbversion'::regclass) NOT NULL PRIMARY KEY,
    dbversion integer DEFAULT 0 NOT NULL,
    needreimport boolean DEFAULT false
);

CREATE TABLE csskupina (
    idcsskupina integer DEFAULT nextval('seq_csskupina'::regclass) NOT NULL PRIMARY KEY,
    nazev varchar(64),
    idcslicense integer,
    is_default boolean default false
);

CREATE TABLE cslicense (
    idcslicense integer DEFAULT nextval('seq_cslicense'::regclass) NOT NULL PRIMARY KEY,
    license oid
);

CREATE TABLE cscert (
    idlogo integer DEFAULT nextval('seq_cscert'::regclass) NOT NULL PRIMARY KEY,
    certificate bytea
);

CREATE TABLE cssetting (
    idSetting integer DEFAULT nextval('seq_cssetting'::regclass) NOT NULL PRIMARY KEY,
    klic character varying(50) NOT NULL,
    hodnota character varying(255),
    CONSTRAINT cssetting_klic_key UNIQUE (klic)
);

create table csprefirma (
    idcsprefirma integer DEFAULT nextval('seq_csprefirma'::regclass) NOT NULL,
    dbnazev character varying(255) NOT NULL,
    dbversion integer NULL,
    lastmodify timestamp without time zone NOT NULL,
    legislativa character varying(255) NOT NULL,
    stav character varying(255) NOT NULL,
    CONSTRAINT idcsprefirma_pkey PRIMARY KEY (idcsprefirma),
    CONSTRAINT dbnazev_key UNIQUE (dbnazev)
);

create table csexternalapp (
    idexternalapp integer default nextval('seq_csexternalapp'::regclass) not null primary key,
    idcsfirma integer not null,
    kod character varying(30) not null,
    jmeno character varying(255),
    url character varying(255) not null,
    enabled boolean default true not null,
    constraint csexternalapp_kod_idcsfirma unique (idcsfirma, kod)
);

-- cizi klice

ALTER TABLE ONLY csfirma
    ADD CONSTRAINT fk5116bd53d75a2a20 FOREIGN KEY (idcsskupina) REFERENCES csskupina(idcsskupina);

ALTER TABLE ONLY cspristup
    ADD CONSTRAINT fk5116bd53d75a2a1e FOREIGN KEY (idcsfirma) REFERENCES csfirma(idcsfirma);

ALTER TABLE ONLY cspristup
    ADD CONSTRAINT fk5116bd53dacc4600 FOREIGN KEY (idcsuzivatel) REFERENCES csuzivatel(idcsuzivatel);

ALTER TABLE ONLY csuzivatel
    ADD CONSTRAINT fk5116bd53d75a2a1f FOREIGN KEY (idcsskupina) REFERENCES csskupina(idcsskupina);

ALTER TABLE ONLY csskupina
    ADD CONSTRAINT fk5116bd53d75a2a21 FOREIGN KEY (idcslicense) REFERENCES cslicense(idcslicense);

ALTER TABLE ONLY csexternalapp
    ADD CONSTRAINT csexternalapp_idcsfirma FOREIGN KEY (idcsfirma) REFERENCES csfirma (idcsfirma);

CREATE OR REPLACE FUNCTION delete_license_lo()
  RETURNS trigger AS
$BODY$
declare
  z Record;
begin
  select lo_unlink(old.license) into z;
  return old;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;

CREATE TRIGGER delete_license
  AFTER DELETE
  ON cslicense
  FOR EACH ROW
  EXECUTE PROCEDURE delete_license_lo();

-- ostatni

REVOKE ALL ON SCHEMA public FROM PUBLIC;
REVOKE ALL ON SCHEMA public FROM dba;
GRANT ALL ON SCHEMA public TO dba;

insert into csskupina (nazev, is_default) values ('default', true);

insert into dbversion(iddbversion, dbversion, needreimport)
    values (nextval('seq_dbversion'), 24, 't');
