--------------------------------------------------------------------------------
-- Bug 23919 – [WinStrom] Pridat podporu pro vice aplikacnich serveru nad stejnou databazi
--------------------------------------------------------------------------------

CREATE SEQUENCE seq_csprefirma
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;

create table csprefirma (
    idcsprefirma integer DEFAULT nextval('seq_csprefirma'::regclass) NOT NULL,
    dbnazev character varying(255) NOT NULL,
    dbversion integer NULL,
    lastmodify timestamp without time zone NOT NULL,
    legislativa character varying(255) NOT NULL,
    stav character varying(255) NOT NULL,
    CONSTRAINT idcsprefirma_pkey PRIMARY KEY (idcsprefirma),
    CONSTRAINT dbnazev_key UNIQUE (dbnazev)
);

-- migrace stavajicich zalozenych firem
insert into csprefirma (dbnazev, lastmodify, legislativa, stav)
select datname, now(), regexp_replace(datname, '_.$', ''), 'ESTABLISHED' from pg_database where datname like '#_%';

insert into dbversion(iddbversion, dbversion, needreimport)
    values (nextval('seq_dbversion'), 10, 't');