--------------------------------------------------------------------------------
-- Bug 18728 comment 1 – [WinStrom] Permission denied pri rozpadu kusovniku
-- -> Po obnoveni ze zalohy je nutne rekontruovat prava tam, kde firmarole nema
--    byt vlastnikem.
--------------------------------------------------------------------------------

create or replace function runupgrade()
    returns void as $$
declare
  version integer;
begin
  select max(dbversion) into version from dbversion;

  -- pristupova prava pro triggery
  if (version > 270) then
    ALTER TABLE public.seq_wzurnal OWNER TO %admin%;
    ALTER TABLE public.wzurnal OWNER TO %admin%;
    GRANT SELECT ON TABLE wzurnal TO %firmaRole%;

    ALTER FUNCTION putglotxvariable(i_kod character varying, i_hodnota character varying) OWNER TO %firmaRole%;
    ALTER FUNCTION removeglotxvariable(i_kod character varying) OWNER TO %firmaRole%;
    ALTER FUNCTION getglotxvariable(i_kod character varying) OWNER TO %firmaRole%;

    ALTER FUNCTION public.logzurnal() OWNER TO %admin%;

    ALTER FUNCTION create_or_drop_zurnal_triggers(docreate boolean) OWNER TO %admin%;
    GRANT EXECUTE ON FUNCTION create_or_drop_zurnal_triggers(docreate boolean) TO %firmaRole%;
    ALTER FUNCTION exist_zurnal_triggers() OWNER TO %admin%;
    GRANT EXECUTE ON FUNCTION exist_zurnal_triggers() TO %firmaRole%;
  end if;

  if (version > 612) then
    ALTER TABLE changelog OWNER TO %admin%;
    GRANT SELECT ON TABLE changelog TO %firmaRole%;
    
    ALTER FUNCTION logchanges() OWNER TO %admin%;

    ALTER FUNCTION create_or_drop_changes_triggers(docreate boolean) OWNER TO %admin%;
    GRANT EXECUTE ON FUNCTION create_or_drop_changes_triggers(docreate boolean) TO %firmaRole%;
    ALTER FUNCTION exist_changes_triggers() OWNER TO %admin%;
    GRANT EXECUTE ON FUNCTION exist_changes_triggers() TO %firmaRole%;
  end if;
  
  if (version >= 824) then
    ALTER FUNCTION saveextid() OWNER TO %admin%;
  end if;

end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

--------------------------------------------------------------------------------

select runupgrade();

drop function runupgrade();
