-----------------------------------------------------------------------
-- Bug 44870 - Odpočet ZDD, faktura zahr. - stejný kurz
------------------------------------------------------------------------


CREATE OR REPLACE FUNCTION dpolfakdeletevazba() RETURNS trigger
    AS $$
declare _dokl record;
        _idzal integer;
        _idKorekce integer;
        uhrad integer;
        _stavUhrK varchar;
        _idPomInt integer; 
        _idVazbaOdpocFak integer;
        _idVazbaUhrFak integer;
begin  
  if (OLD.typPolozkyK in ('typPolozky.odpocetZalohy', 'typPolozky.odpocetZdd')) then
    select idtabb into _idzal from dvazebtab where idtaba = OLD.idPolFak and (typVazbyK = 'typVazbyDokl.odpocetZALOHY' or typVazbyK = 'typVazbyDokl.odpocetZDD');
    
    -- v případě odpočtu zálohové položky je ve vazební tabulce odkazována položka faktury, my ale chceme hlavičku faktury
    if (_idzal is null) then
        select pf.iddoklfak into _idzal from dvazebtab vt inner join dpolfak pf on vt.idtabb = pf.idpolfak where vt.idtaba = OLD.idPolFak and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY';
    end if;
    
    
        -- SK - pomocný interní doklad
    select d.iddoklint, vtz.idvazby, vtf.idvazby into _idPomInt, _idVazbaOdpocFak, _idVazbaUhrFak from ddoklint d 
        inner join dvazebtab vtz on vtz.idtaba = d.iddoklint
        inner join dvazebtab vtf on vtf.idtaba = d.iddoklint 
        where 
        vtz.idtabb = _idzal and vtz.typvazbyk = 'typVazbyDokl.odpocitavanaFaktura' and 
            vtf.idtabb =  OLD.idDoklFak and vtf.typvazbyk = 'typVazbyDokl.uhrazovanaFaktura';

    if (_idVazbaOdpocFak is not null and _idVazbaUhrFak is not null) then
        delete from dvazebtab where idvazby in (_idVazbaOdpocFak, _idVazbaUhrFak);
        delete from dpolint  where iddoklint = _idPomInt;
        delete from ddoklint where iddoklint = _idPomInt;
    end if;
    -- /SK - pomocný interní doklad
    
    delete from dVazebTab where idtaba = OLD.idPolFak and (typVazbyK = 'typVazbyDokl.odpocetZALOHY' or typVazbyK = 'typVazbyDokl.odpocetZDD' or typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');
    
    select * into _dokl from dDoklFak where idDoklFak = OLD.idDoklFak;
    
    if (_dokl.stavUhrK = 'stavUhr.uhrazeno' and OLD.sumZkl < 0) then
      select count(*) into uhrad from dVazebTab where idTabA = _dokl.idDoklFak and modulA = _dokl.modul and typVazbyK = 'typVazbyDokl.uhrada';
      
      _stavUhrK = null;
      if (uhrad > 0) then
        _stavUhrK = 'stavUhr.castUhr';
      end if;
      
      update dDoklFak set stavUhrK = _stavUhrK where idDoklFak = _dokl.idDoklFak;
    end if;
    
    if _idzal is not null then
      _stavUhrK = null;
      select count(*) into uhrad from dVazebTab where idtabb = _idzal and (typVazbyK = 'typVazbyDokl.odpocetZALOHY' or typVazbyK = 'typVazbyDokl.odpocetZDD');
      if (uhrad > 0) then
        _stavUhrK = 'stavOdp.cast';
      end if;
    end if;
    
    update ddoklfak set StavOdpocetK = _stavUhrK where iddoklfak = _idzal and not comparevarchar(StavOdpocetK, _stavUhrK);
    
    -- smazání vazeb a položek korekce KR odpočtu
    select idtabb into _idKorekce from dvazebtab where idtaba = OLD.idPolFak and typVazbyK = 'typVazbyDokl.KROdpoctu';

    if (_idKorekce is not null) then 
        -- aktualizace juhSum
        update ddoklfak set juhSum = juhSum - (select sumZkl + sumDph from dpolfak where idpolfak = _idKorekce) where iddoklfak in (select iddoklfak from dpolfak where idpolfak = _idKorekce and not storno);
        delete from dVazebTab where idtaba = OLD.idPolFak and typVazbyK = 'typVazbyDokl.KROdpoctu';
        delete from dpolfak where idpolfak = _idKorekce;
    end if;
  end if;  
  
  return OLD;  
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.dpolfakdeletevazba() OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
values (nextval('seq_dbversion'), 1001, 't', %appVersion%, clock_timestamp());