----------------------------------------------------------------------------------------------------
-- Bug 45401 - V režimu plně automatických rezervací nedojde při naskladnění k vytvoření rezervace
----------------------------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION srezervujzprijemky(_idCenik integer, _idSkladu integer, prijato numeric(19,6))
  RETURNS void AS $$
declare
  _zbyva numeric(19,6);
  _uber numeric(19,6);
  _rezer record;
  _idUcetObd integer;
  _sklad numeric(19,6);

  _plneAutomat boolean;
  _rezimRezervaciK varchar(50);
  _noveMnozstvi numeric(19,6);
  _rezervovat numeric(19,6);
  _volnosklad numeric (19,6);
begin
  _zbyva = prijato;
  if (prijato > 0) then
    for _rezer in select * from 
        (select r.idrezervace, r.idpolobch, r.mnozstvi as mnozstvi, po.rezervovatMj as rezervovatMj, r.skladmj as skladMj, po.mnozMj as polMnozMj, date(r.datumOd) as datum
            from srezervace r left join dpolobch po on po.idpolobch = r.idpolobch
            where r.idcenik = _idCenik  and r.idSklad =  _idskladu
            
            union all

         select -1 as idrezervace, idpolobch, -1, rezervovatMj, 0 as SkladMj, mnozMj as polMnozMj, date(d.datVyst) as datum
            from dpolobch po
            inner join ddoklobch d on po.iddoklobch = d.iddoklobch
            where rezervovat = true and rezervovatMj = 0 and idbspskl =  _idskladu  and idCenik =  _idCenik
            and (d.stavuzivk is null or d.stavuzivk not in ('stavDoklObch.vydano', 'stavDoklObch.hotovo', 'stavDoklObch.storno'))
            and not d.storno and not po.storno and (mnozMj - mnozMjReal) > 0)
         as vysledek order by vysledek.datum, vysledek.idpolobch loop 

        select rezimRezervaciK into _rezimRezervaciK from nnastav 
            where coalesce(platioddata, '1900-01-01') <= _rezer.datum order by coalesce(platioddata, '1900-01-01') desc limit 1;

        _plneAutomat = _rezimRezervaciK = 'rezimRezervaci.zObjPriNaskladneni';   

        if( _rezer.idrezervace > 0) then

            if(_plneAutomat and _rezer.idpolobch is not null and _rezer.rezervovatMj < _rezer.polMnozMj) then

                _noveMnozstvi = minvalue(_rezer.skladMj + _zbyva, _rezer.polMnozMj);
                _uber = minvalue(_zbyva,  _noveMnozstvi - _rezer.skladmj); 
                _zbyva = _zbyva - _uber; 
 
                perform putglotxvariable('rezerDisableTrigger', '1');
                update sRezervace set skladmj = skladmj + _uber, mnozstvi = _noveMnozstvi where idrezervace = _rezer.idrezervace;    
                update dpolobch set rezervovatMj = _noveMnozstvi where idpolobch = _rezer.idpolobch;
                perform removeglotxvariable('rezerDisableTrigger'); 

            elsif (_rezer.mnozstvi > _rezer.skladmj) then 
                _uber = minvalue(_zbyva, _rezer.mnozstvi - _rezer.skladmj); 
                _zbyva = _zbyva - _uber; 
                update sRezervace set skladmj = skladmj + _uber where idrezervace = _rezer.idrezervace; 
            end if; 

        elseif (_plneAutomat) then
            if(_rezer.polMnozMj < _zbyva) then
                select dgetstavnaskladeaktualni(_idcenik, _idskladu, date(now()), -1) into _volnosklad;
                _rezervovat := minvalue(_rezer.polMnozMj, _volnoSklad); 
            else
                _rezervovat := _zbyva;
            end if;
            _zbyva = _zbyva - _rezervovat;

            update dpolobch set rezervovatMj = _rezervovat where idpolobch = _rezer.idpolobch;
    end if;

        if (_zbyva = 0) then 
            return; 
        end if;
    end loop;
  else
    select idUcetObdobi into _idUcetObd from nUcetObdobi where platioddata <= date(now()) and platidodata >= date(now()); 
    select stavmj into _sklad from skarty where iducetobdobi = _idUcetObd and idskladu = _idSkladu and idcenik = _idCenik;
    select sum(skladmj) into _zbyva from srezervace where idCenik = _idCenik and idSklad = _idSkladu;
    
    if (_zbyva > _sklad) then
      _zbyva = _zbyva - _sklad;
      
      for _rezer in select * from sRezervace where idCenik = _idCenik and idSklad = _idSkladu order by datumod DESC loop
        if (_rezer.skladmj > 0) then
          _uber = minvalue(_zbyva, _rezer.skladmj);
          _zbyva = _zbyva - _uber;
          
          update sRezervace set skladmj = skladmj - _uber where idrezervace = _rezer.idrezervace;
          
          if (_zbyva = 0) then
            return;
          end if;
        end if;
      end loop;
    end if;
  end if;
end; 
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.srezervujzprijemky(integer, integer, numeric) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
values (nextval('seq_dbversion'), 1007, 't', %appVersion%, clock_timestamp());