--------------------------------------------------
-- Bug 46615 - EET - věta EET má obsahovat údaje zakl_nepohl_DPH jen v některých případech  
--------------------------------------------------

CREATE OR REPLACE FUNCTION dvazebtabinsertuhradazal()
  RETURNS trigger AS $$
declare _idProti integer; 
        _typPohybu varchar; 
        _pocetPol integer; 
        _idUcetPol integer; 
        _idMdPol integer; 
begin 
  if NEW.typVazbyK = 'typVazbyDokl.uhradaZALOHY' then 
    select idProtiUcet, typPohybuK into _idProti, _typPohybu from ddoklint where iddoklint = NEW.idTabB; 
     
    -- pokud na uhrazujicih dokladu ucet neni a vysledna polozka je jenom jedna pouzijeme ucet z polozky 
    if (_idProti is null) then 
      select count(*), min(idZklDalUcet), min(idZklMdUcet) into _pocetPol, _idUcetPol, _idMdPol 
        from dPolFak as P inner join dVazebTab as V on P.idPolFak = V.idTabA and V.typVazbyK = 'typVazbyDokl.odpocetZALOHY' where V.idTabB = NEW.idTabA; 
      if (_typPohybu <> 'typPohybu.prijem') then 
        _idUcetPol = _idMdPol; 
      end if; 
       
      if (_pocetPol = 1 and _idUcetPol is not null) then
        update ddoklint set idProtiUcet = _idUcetPol where iddoklint = NEW.idTabB; 

        --podle PolDoklBLImpl copyZklMdUcet a copyZklDalUcet
        if(_typPohybu = 'typPohybu.prijem') then
          update dpolint set idZklDalUcet = _idUcetPol where iddoklint = NEW.idTabB and kopZklDalUcet = true;
        end if;
        if(_typPohybu = 'typPohybu.vydej') then
          update dpolint set idZklMdUcet = _idUcetPol where iddoklint = NEW.idTabB and kopZklMdUcet = true;
        end if;

        return NEW; 
      end if; 
    end if; 
     
    if (_typPohybu = 'typPohybu.prijem') then 
      update dPolFak set lastupdate = now(), idZklDalUcet = _idProti where idPolFak in (select idTabA from dVazebTab where typVazbyK = 'typVazbyDokl.odpocetZALOHY' and idTabB = NEW.idTabA) 
        and compareId(idZklDalUcet, _idProti) = false; 
    else 
      update dPolFak set lastupdate = now(), idZklMdUcet  = _idProti where idPolFak in (select idTabA from dVazebTab where typVazbyK = 'typVazbyDokl.odpocetZALOHY' and idTabB = NEW.idTabA) 
        and compareId(idZklMdUcet,  _idProti) = false; 
    end if; 
  end if; 
   
  return NEW; 
end;    
$$ LANGUAGE plpgsql;
ALTER FUNCTION dvazebtabinsertuhradazal() OWNER TO %firmaRole%;



CREATE OR REPLACE FUNCTION isdokladzuctovan(iddokl integer, doklpostfix character varying) RETURNS boolean
    AS $$ 
declare  
  _modul varchar(100); 
  _podvojucto boolean;  
  _ucetni boolean;  
  _storno boolean;  
  _bezpol boolean;  
  _datUcto date;   
  _doklOk integer;  
  _polozek integer;  
  _polOk integer;  
  _idDoklVazbaArray integer[];  
  _idPolVazbaArray integer[];  
  _idPolVazbaArrayCnt integer;  
  _idPolVazbaArrayCntOk integer;  
  idDoklColumn varchar(100);  
  doklTable varchar(100);  
  polTable varchar(100);  
begin  
  idDoklColumn := 'idDokl' || doklPostfix;  
  doklTable := 'dDokl' || doklPostfix;  
  polTable := 'dPol' || doklPostfix;  
  
  execute 'select modul, datUcto, ucetni, bezpolozek, storno from ' || doklTable || ' where ' || idDoklColumn || ' = ' || idDokl  
   into _modul, _datUcto, _ucetni, _bezpol, _storno;  
  execute 'select count(*) from ' || polTable || ' where ' || idDoklColumn || ' = ' || idDokl into _polozek;  
  _doklOk := 0;  
  
  if (_ucetni = true and _storno = false) then  
    -- zjistime zda firma vede ucetnictvi  
    select podvojucto into _podvojucto from nNastav where PlatiOdData <= _datUcto order by PlatiOdData desc limit 1;  
    if (_podvojucto is null) then  
      select podvojucto into _podvojucto from nNastav where PlatiOdData is null limit 1;   
    end if;  
  
    if (_podvojucto = true) then  
      -- ucetnictvi  
      if (_polozek = 0) then  
	if (_modul = 'INT') then 
          execute 
            'select count(*) from ' || doklTable || ' where ' || idDoklColumn || ' = ' || idDokl || ' and 
              idstred is not null and datucto is not null and 
              ((sumosv = 0 and sumzklsniz = 0 and sumzklzakl = 0) or idprimucet is not null) and 
              ((sumosv = 0 and sumzklsniz = 0 and sumzklzakl = 0) or idprotiucet is not null) and 
              ((sumdphsniz = 0 and sumdphzakl = 0) or (iddphsnizucet is not null and iddphzaklucet is not null))' 
            into _doklOk; 
	else 
          execute 
            'select count(*) from ' || doklTable || ' where ' || idDoklColumn || ' = ' || idDokl || ' and 
              idstred is not null and datucto is not null and 
              ((sumcelkem = 0) or idprimucet is not null) and 
              ((sumosv = 0 and sumzklsniz = 0 and sumzklzakl = 0) or idprotiucet is not null) and 
              (sumdphsniz = 0 or iddphsnizucet is not null) and 
              (sumdphsniz2 = 0 or iddphsniz2ucet is not null) and  
              (sumdphzakl = 0 or iddphzaklucet is not null)' 
            into _doklOk; 
	end if; 
      else  
        execute  
          'select count(*) from ' || polTable || ' where ' || idDoklColumn || ' = ' || idDokl || ' and  
            (ucetni = false or   
            (idstred is not null and datucto is not null and 
              (sumZkl = 0 or (idzkldalucet is not null and idzklmducet is not null)) and 
              (modul = ''SKL'' or typszbdphk is null or typszbdphk = ''typSzbDph.dphOsv'' or sumDph = 0 or ( 
                iddphmducet is not null and iddphdalucet is not null))))'  
          into _polOk;  
        if (_polOk = _polozek) then  
          _doklOk := 1;  
        end if;  
      end if;  
    else  
      -- danova evidence  
      if (doklTable = 'dDoklFak' or doklTable = 'dDoklInt') then  
        if (_bezpol = true or _polozek = 0) then  
          execute 'select count(*) from ' || doklTable || ' where ' || idDoklColumn || ' = ' || idDokl || '  
            and datucto is not null and danevidk is not null' into _doklOk;  
        else  
          execute 'select count(*) from ' || polTable || ' where ' || idDoklColumn || ' = ' || idDokl || '  
            and (ucetni = false or (datucto is not null and danevidk is not null))' into _polOk;  
          if (_polOk = _polozek) then 
            _doklOk := 1; 
          end if; 
        end if;  
         
       --uhrada je zauctovana pokud jsou vsechny polozky vsech navazanych faktur zauctovany 
        _idPolVazbaArrayCnt := 0; 
        _idPolVazbaArrayCntOk := 0; 
        if (doklTable = 'dDoklInt' and _doklOk != 1) then 
 
          -- navazane faktury 
          _idDoklVazbaArray := array(select idTabA from dVazebTab where idTabB = idDokl and typVazbyK in ('typVazbyDokl.uhrada')); 
          if (coalesce(array_upper(_idDoklVazbaArray, 1), 0) != 0) then 
            
            --navazane polozky 
            _idPolVazbaArray := array(select idpolfak from dpolfak where iddoklfak = any(_idDoklVazbaArray)); 
            _idPolVazbaArrayCnt := coalesce(array_upper(_idPolVazbaArray, 1), 0); 
             
            --zda jsou vsechny polozky zauctovane 
            if (_idPolVazbaArrayCnt != 0) then 
              _idPolVazbaArrayCntOk := (select count(*) from dpolfak where danevidk is not null and idpolfak = any(_idPolVazbaArray)); 
              if (_idPolVazbaArrayCnt = _idPolVazbaArrayCntOk) then 
                _doklOk := 1; 
              end if; 
            end if; 
             
          end if; 
        end if; 
         
      end if;  
    end if;  
  end if;  
    
  return (_doklOk = 1);  
end;   
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.isdokladzuctovan(iddokl integer, doklpostfix character varying) OWNER TO %firmaRole%;

 -- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 1105, 't', %appVersion%, clock_timestamp());
