--------------------------------------------------------------------------------
-- Bug 37287 - Import kontaktů ponechá více označených jako primární záznam     
--------------------------------------------------------------------------------

--kontakty
CREATE OR REPLACE FUNCTION akontaktyupdateprimarni()
  RETURNS trigger AS $$
begin

  if NEW.primarni = true then
    update akontakty set primarni = false where primarni = true and idfirmy = NEW.idfirmy and idkontakt <> NEW.idkontakt; -- zajisteni unikatnosti primarniho
  end if;

  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.akontaktyupdateprimarni() OWNER TO %firmaRole%;

CREATE TRIGGER akontaktyupdateprimarni AFTER INSERT OR UPDATE ON akontakty
FOR EACH ROW EXECUTE PROCEDURE akontaktyupdateprimarni();

--ban. spoj.
CREATE OR REPLACE FUNCTION abanspojupdateprimarni()
  RETURNS trigger AS $$
begin

  if NEW.primarni = true then
    update abanspoj set primarni = false where primarni = true and idfirmy = NEW.idfirmy and idbanspoj <> NEW.idbanspoj; -- zajisteni unikatnosti primarniho
  end if;

  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION abanspojupdateprimarni() OWNER TO %firmaRole%;

CREATE TRIGGER abanspojupdateprimarni AFTER INSERT OR UPDATE ON abanspoj
FOR EACH ROW EXECUTE PROCEDURE abanspojupdateprimarni();

--mista urceni
CREATE OR REPLACE FUNCTION amisturcupdateprimarni()
  RETURNS trigger AS $$
begin

  if NEW.primarni = true then
    update amisturc set primarni = false where primarni = true and idfirmy = NEW.idfirmy and idmur <> NEW.idmur; -- zajisteni unikatnosti primarniho
  end if;

  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION amisturcupdateprimarni() OWNER TO %firmaRole%;

CREATE TRIGGER amisturcupdateprimarni AFTER INSERT OR UPDATE ON amisturc
FOR EACH ROW EXECUTE PROCEDURE amisturcupdateprimarni();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
 values (nextval('seq_dbversion'), 1106, 't', %appVersion%, clock_timestamp());
