------------------------------------------------------------------------------
--Bug 46964 - Atribut removeAll nad skladovým pohybem způsobí špatný přepočet master.sumCelkem 
------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION dpolskladdelete()
  RETURNS trigger AS
$BODY$
declare
  _rozsirenaPolozka record;
  _mazatTmpTable boolean; 
  _polSklad record;  
begin
  
  if(not OLD.storno) then
    -- generuji rozsirene polozky
    select skladGenerujRozsirenePolozky(OLD.datSklad, OLD.idPolSklad, OLD.idKarty) into _mazatTmpTable;

    execute putglotxvariable('zurnalTxName', 'prepocetSkladu');

    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop
      if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then 
        if(_rozsirenaPolozka.cenyRucne = true) then
          select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
          execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, -1); 
        else
          execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);
        end if;
      else 
        --raise exception 'v rozsirenych polozkach je mazana polozka s id %', _rozsirenaPolozka; 
      end if;
    end loop;

    -- musim jeste odpocist mazanou polozku
    --execute skladOdpoctiRozsirenouPolozku(OLD.idPolSklad);
    execute sprepoctiskladkartu(OLD.mnozMj, OLD.cenaMj, OLD.sumZkl, OLD.datVyst, OLD.idKarty, OLD.idDoklSklad, OLD.idBspSkl, -1);
  
    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop
      if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then
        if(_rozsirenaPolozka.cenyRucne = true) then
          select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
          execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, 1); 
        else
          execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);
        end if;
      else
        --raise exception 'v rozsirenych polozkach je mazana polozka s id %', _rozsirenaPolozka; 
      end if;
    end loop;
    
    execute sfifostorno(OLD.idPolSklad, OLD.idDoklSklad);
    
    execute sprepoctisumydokladu(OLD.idDoklSklad);

    if(_mazatTmpTable) then
      drop table tmp_RozsirenePolozky;
      drop table tmp_SkladoveKarty;
      execute removeglotxvariable('zurnalTxName');
    end if;
  end if; 
  
  return NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladdelete() OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
values (nextval('seq_dbversion'), 1111, 't', %appVersion%, clock_timestamp());