--------------------------------------------------------------------------------------------------------------------
-- Bug 46985 - Načítání bankovních výpisů je pomalé - přidání indexů
--------------------------------------------------------------------------------------------------------------------

-- hledání dokladu podle čísla výpisu
DROP INDEX IF EXISTS ddoklint_cisSouhrnne_bsp_ban_index;
CREATE INDEX ddoklint_cisSouhrnne_bsp_ban_index ON ddoklint (idBsp, upper(cast(cisSouhrnne as text))) where Modul='BAN' and zapocet = false;
-- hledání dokladu podle hashe výpisu
DROP INDEX IF EXISTS ddoklint_vypisHash_bsp_ban_index;
CREATE INDEX ddoklint_vypisHash_bsp_ban_index ON ddoklint(vypisHash, idbsp) where Modul='BAN';

drop index if exists wcolumn_iduzivatel_beankey_index;
CREATE INDEX wcolumn_iduzivatel_beankey_index ON wcolumn(iduzivatel, beankey);

drop index if exists wExtId_Tabulka_ExtId_index;
CREATE INDEX wExtId_Tabulka_ExtId_index ON wExtId USING btree (Tabulka, upper(cast(ExtId AS text)));

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 1112, 't', %appVersion%, clock_timestamp());