-------------------------------------------------------------------------
-- FB-489 ČSOB - logování komunikace
-------------------------------------------------------------------------

CREATE SEQUENCE seq_wzarizenikom
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wzarizenikom OWNER TO %firmaRole%;

CREATE TABLE wzarizenikom
(
  idzarizenikom integer NOT NULL DEFAULT nextval('seq_wzarizenikom'::regclass),
  iddokl integer,
  formid integer,
  iduzivatel integer NOT NULL,
  identifikace character varying(50) NOT NULL,
  caszprava timestamp without time zone NOT NULL,
  casodpoved timestamp without time zone,
  zprava text,
  odpoved text,
  chyba text,

  CONSTRAINT wzarizenikom_pkey PRIMARY KEY (idzarizenikom),
  CONSTRAINT wzarizenikom_uzivatel FOREIGN KEY (iduzivatel)
  REFERENCES wUzivatel(iduzivatel) MATCH SIMPLE
  ON UPDATE NO ACTION ON DELETE NO ACTION
);

ALTER TABLE wzarizenikom OWNER TO %firmaRole%;

CREATE INDEX wZarizeniKom_IdUzivatel_index ON wZarizeniKom USING btree (IdUzivatel);

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 1124, 't', %appVersion%, clock_timestamp());
