----------------------------------------------------------------
-- Bug 16744 – [WinStrom] pořízení pokladna výdej - problém
----------------------------------------------------------------

-- Function: dpolskladupdateucty()
-- DROP FUNCTION dpolskladupdateucty();
CREATE OR REPLACE FUNCTION dpolskladupdateucty()
  RETURNS trigger AS
$BODY$   
declare 
  nelzeZmena int;
  _modul character varying;
begin   
  if ((select typPohybuK from dDoklSklad where idDoklSklad = NEW.idDoklSklad) = 'typPohybu.prijem') then   
    if (compareId(NEW.idZklDalUcet, OLD.idZklDalUcet) = false and NEW.kopZklDalUcet = false) then
      select modulA into _modul from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl';
      if(_modul like 'POK') then
        select count(*) into nelzeZmena from dPolInt where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and kopZklMdUcet = true and   
          idPolInt in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl');   
        --raise exception 'nelze zmena je % ....', nelzeZmena;
        if (nelzeZmena = 0) then   
          update dPolInt set idZklMdUcet = NEW.idZklDalUcet where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and   
            idPolInt in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl');   
        else   
          raise exception 'dPolSkladUpdateUcty(): Nelze zmenit ucet u navazane polozky.';   
        end if;
      else
        select count(*) into nelzeZmena from dPolFak where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and kopZklMdUcet = true and   
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl');   
        --raise exception 'nelze zmena je % ....', nelzeZmena;
        if (nelzeZmena = 0) then   
          update dPolFak set idZklMdUcet = NEW.idZklDalUcet where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and   
            idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl');   
        else   
          raise exception 'dPolSkladUpdateUcty(): Nelze zmenit ucet u navazane polozky.';   
        end if;
      end if;
    end if;   
  end if;   
   
  return NEW;   
end;   
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladupdateucty() OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 180, 't');
