------------------------------------------------------------------
-- Bug 16904 – [WinStrom] Pri generovani skladu se nevyplnuje pole ucetni
------------------------------------------------------------------


-- Function: createpolsklad(integer, character varying)
-- DROP FUNCTION createpolsklad(integer, character varying);
CREATE OR REPLACE FUNCTION createpolsklad(_idpoldokl integer, _modul character varying)
  RETURNS integer AS
$BODY$ 
declare 
  _idDoklSklad integer; 
  _idDoklad integer; 
  _polDokl record; 
  _iducetobdobi integer; 
  _idkarty integer; 
  _idPolSklad integer; 
  _cenaMj numeric(19,6); 
  _cenaMjTuz numeric(19,6); 
  _typPohybuK character varying; 
  _prumCenaTuz numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _kurz numeric(19,6); 
  _idZklMdUcet integer; 
  _idZklDalUcet integer; 
  _kopZklMdUcet boolean; 
  _kopZklDalUcet boolean; 
  _sklad record; 
  _typDoklK character varying; 
  _mnozMj numeric(19,6); 
  _isCiziMena boolean; 
begin 
  if(_modul like 'FAV' or _modul like 'FAP') then 
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl; 
    _idDoklad = _polDokl.idDoklFak; 
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak); 
  else 
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl; 
    _idDoklad = _polDokl.idDoklInt; 
    _typDoklK = null; -- pro pokladnu dobropisy nejsou 
  end if; 
 
  select findParovanyDoklSklad(_idDoklad, _modul) into _idDoklSklad; 
   
  if(_idDoklSklad is null) then 
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad; 
  end if; 
 
  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi; 
  select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idtypdokl = _polDokl.idskladu and iducetobdobi = _iducetobdobi; 
  select * into _sklad from dTypDokl where idTypDokl = _polDokl.idSkladu; 
   
  select typPohybuK into _typPohybuK from dDoklSklad where idDoklSklad = _idDoklSklad; 
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz; 
  select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty; 
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena; 
     
  if(_typPohybuK like 'typPohybu.vydej') then 
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena 
    _cenaMj = _prumCenaTuz / _kurz; 
    _mnozMj = _polDokl.mnozMj; 
    _sumZkl = _prumCenaTuz * _mnozMj; 
    if(_isCiziMena) then 
      _sumZklMen = _mnozMj * _cenaMj; 
    else 
      _sumZklMen = 0.0; 
    end if; 
    -- nastaveni uctu pro polSklad vydej 
    select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet; 
    _idZklDalUcet = _sklad.idPrimUcet; 
  else 
    if(_typDoklK like 'typDokladu.dobropis') then 
      -- pokud se jedna o dobropis tak doplnuji nakupni ceny; 
      _mnozMj = -_polDokl.mnozMj; 
      _cenaMjTuz = _prumCenaTuz; 
      if(_cenaMjTuz = 0.0) then 
        _cenaMjTuz = (select nakupCena from ccenik where idCenik = _polDokl.idCenik); 
        if(_cenaMj = 0.0) then 
          _cenaMj = _polDokl.cenaMj * _kurz; 
        end if; 
      end if; 
      _cenaMj = _cenaMjTuz / _kurz; 
      _sumZkl = _mnozMj * _cenaMjTuz; 
      if(_isCiziMena) then 
        _sumZklMen = _mnozMj * _cenaMj; 
      else 
        _sumZklMen = 0.0; 
      end if; 
    else 
      -- pokud na sklad prijmam zkopiruji se ceny z faktury 
      _mnozMj = _polDokl.mnozMj; 
      _sumZkl = _polDokl.sumZkl; 
      if(_mnozMj <> 0.0) then 
        _cenaMj = _sumZkl / _mnozMj; 
      else 
        _cenaMj = _sumZkl; 
      end if; 
      -- TODO[kb] doplnit vypocet sum zkl men 
      --_sumZklMen = _polDokl.sumZklMen; 
      _sumZklMen = 0.0; 
    end if; 
    -- nastaveni uctu pro polSklad prijem 
    _idZklMdUcet = _sklad.idPrimUcet; 
    _idZklDalUcet = _polDokl.idZklMdUcet; 
  end if; 
   
  select nextval('seq_dpolsklad') into _idPolSklad; 
  insert into dpolsklad(idPolSklad, idcenik, idskladu, idkarty, datVyst, datUcto, modul, typPolozkyK, idDoklSklad,  
        mnozMj, cenaMj, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni, 
        nazev, nazevA, nazevB, nazevC, sarze, expirace, cisRad, ucetni,
        idStred, idZakazky, idMeny) 
      values (_idPolSklad, _polDokl.idcenik, _polDokl.idskladu, _idkarty, _polDokl.datVyst, _polDokl.datUcto, 'SKL', 'typPolozky.katalog', _idDoklSklad,  
        _mnozMj, _cenaMj, _sumZkl, _sumZklMen, _idZklMdUcet, _idZklDalUcet, false, false, _polDokl.baleniid, _polDokl.mnozBaleni,  
        _polDokl.nazev, _polDokl.nazevA, _polDokl.nazevB, _polDokl.nazevC, _polDokl.sarze, _polDokl.expirace, _polDokl.cisRad, true,
        _polDokl.idStred, _polDokl.idZakazky, _sklad.idMeny); 
 
  -- TODO mozna doresit storno 
  insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK) 
       values (0.0, _idPolDokl, _idPolSklad, _modul, 'SKL', false, 'typVazbyDokl.polozkaSkl'); 
 
  -- prepocteni sum na dokladu 
  execute sprepoctiSumyDokladu(_idDoklSklad); 
 
  return _idPolSklad; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION createpolsklad(integer, character varying) OWNER TO %firmaRole%;





-- Function: fillpolsklad(integer, integer, character varying)
-- DROP FUNCTION fillpolsklad(integer, integer, character varying);
CREATE OR REPLACE FUNCTION fillpolsklad(_idpolsklad integer, _idpoldokl integer, _modul character varying)
  RETURNS integer AS
$BODY$ 
declare 
  _polDokl record; 
  _polSklad record; 
  _idDoklad integer; 
  _typPohybuK character varying; 
  _typPohybuSklad character varying; 
  _cenaMj numeric(19,6); 
  _cenaMjTuz numeric(19,6); 
  _mnozMj numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _idDoklSklad integer; 
  _idUcetObdobi integer; 
  _idKarty integer; 
  _sklad record; 
  _kurz numeric(19,6); 
  _prumCenaTuz numeric(19,6); 
  _isCiziMena boolean; 
  _typDoklK character varying; 
  _idZklMdUcet integer; 
  _idZklDalUcet integer; 
begin 
  if(_modul like 'POK') then 
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl; 
    select idDoklInt, typPohybuK into _idDoklad, _typPohybuK from dDoklInt where idDoklInt = _polDokl.idDoklInt; 
    _typDoklK = null; -- pro pokladnu dobropisy nejsou 
  else 
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl; 
    select idDoklFak, typPohybuK into _idDoklad, _typPohybuK from dDoklFak where idDoklFak = _polDokl.idDoklFak; 
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak); 
  end if; 
 
  select findParovanyDoklSklad(_idDoklad, _modul) into _idDoklSklad; 
   
  if(_idDoklSklad is null) then 
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad; 
  end if; 
 
  select * into _polSklad from dPolSklad where idPolSklad = _idPolSklad; 
  select typPohybuK into _typPohybuSklad from dDoklSklad where idDoklSklad = _polSklad.idDoklSklad; 
 
  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi; 
  select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idtypdokl = _polDokl.idskladu and iducetobdobi = _iducetobdobi; 
  select * into _sklad from dTypDokl where idTypDokl = _polDokl.idSkladu; 
   
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz; 
  select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty; 
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena; 
 
  if(_typPohybuSklad like 'typPohybu.vydej') then 
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena 
    _cenaMj = _polSklad.cenaMj; 
    _mnozMj = _polDokl.mnozMj; 
    _sumZkl = _polSklad.sumZkl; 
    _sumZklMen = _polSklad.sumZklMen; 
    -- nastaveni uctu pro polSklad vydej 
    select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet; 
    _idZklDalUcet = _sklad.idPrimUcet; 
  else 
    if(_typDoklK like 'typDokladu.dobropis') then 
      -- pokud se jedna o dobropis tak doplnuji nakupni ceny; 
      _mnozMj = -_polDokl.mnozMj; 
      _cenaMjTuz = _prumCenaTuz; 
      if(_cenaMjTuz = 0.0) then 
        _cenaMjTuz = (select nakupCena from ccenik where idCenik = _polDokl.idCenik); 
        if(_cenaMj = 0.0) then 
          _cenaMj = _polDokl.cenaMj * _kurz; 
        end if; 
      end if; 
      _cenaMj = _cenaMjTuz / _kurz; 
      _sumZkl = _mnozMj * _cenaMjTuz; 
      if(_isCiziMena) then 
        _sumZklMen = _mnozMj * _cenaMj; 
      else 
        _sumZklMen = 0.0; 
      end if; 
    else 
      -- pokud na sklad prijmam zkopiruji se ceny z faktury 
      _mnozMj = _polDokl.mnozMj; 
      _sumZkl = _polDokl.sumZkl; 
      if(_mnozMj <> 0.0) then 
        _cenaMj = _sumZkl / _mnozMj; 
      else 
        _cenaMj = _sumZkl; 
      end if; 
      -- TODO[kb] doplnit vypocet sum zkl men 
      --_sumZklMen = _polDokl.sumZklMen; 
      _sumZklMen = 0.0; 
    end if; 
    -- nastaveni uctu pro polSklad prijem 
    _idZklMdUcet = _sklad.idPrimUcet; 
    _idZklDalUcet = _polDokl.idZklMdUcet; 
  end if; 
   
  update dPolSklad set 
    cenaMj = _cenaMj, 
    mnozMj = _mnozMj, 
    sumZkl = _sumZkl, 
    sumZklMen = _sumZklMen, 
    nazev = _polDokl.nazev, 
    nazevA = _polDokl.nazevA, 
    nazevB = _polDokl.nazevB, 
    nazevC = _polDokl.nazevC, 
    datVyst = _polDokl.datVyst, 
    baleniId = _polDokl.baleniId, 
    mnozBaleni = _polDokl.mnozBaleni, 
    sarze = _polDokl.sarze, 
    expirace = _polDokl.expirace, 
    cisRad = _polDokl.cisRad, 
    eankod = _polDokl.eanKod, 
    idmj = _polDokl.idmj, 
    idStred = _polDokl.idStred, 
    idMeny = _polDokl.idMeny, 
    idZakazky = _polDokl.idZakazky, 
    idZklMdUcet = _idZklMdUcet, 
    idZklDalUcet = _idZklDalUcet,
    ucetni = true
    where idPolSklad = _idPolSklad; 
 
  return _idPolSklad; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION fillpolsklad(integer, integer, character varying) OWNER TO %firmaRole%;

update dpolsklad set ucetni = true where ucetni = false;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 187, 't');
