--------------------------------------------------------------------------------
-- Bug 17281 – [WinStrom] SQL výjimka při pokusu o smazání položky příjemky ve vazbě na přijatou fakturu
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION dzkontrolujvazebnitab(i_iddokl integer, i_isdoklad boolean, i_modul character varying)
  RETURNS boolean AS $$
declare
  _pocetVazeb integer;
begin

  /* Jedná se o položku dokladu */
  if (i_isDoklad = false) then
    /* idtaba i idtabb jsou položky */
    select count(*) into _pocetVazeb from dVazebTab where (typvazbyk in ('typVazbyDokl.polozkaSkl',
                                                             'typVazbyDokl.polozkaSklSada', 'typVazbyDokl.polozkaSklKus',
                                                             'typVazbyDokl.obchod_obchod_pol', 'typVazbyDokl.obchod_faktura_pol',
                                                             'typVazbyDokl.obchod_zaloha_pol', 'typVazbyDokl.obchod_sklad_pol'))
                                                      and ((idtaba = i_idDokl and modula = i_modul) or (idtabb = i_idDokl and modulb = i_modul));
    if (_PocetVazeb <> 0) then
      return false;
    end if;

    /* kontrola, kde je pro položku dokladu jen u idtaba, jedná se o "typVazbyDokl.odpocetZALOHY" a "typVazbyDokl.odpocetZDD" */
    select count(*) into _pocetVazeb from dVazebTab where (typvazbyk = 'typVazbyDokl.odpocetZALOHY' or typvazbyk = 'typVazbyDokl.odpocetZDD')
                                                      and ((idtaba = i_idDokl and modula = i_modul and modulb = i_modul));
    if (_pocetVazeb <> 0) then
      return false;
    end if;

    return true;
  else

   /* Jedná se o doklad, kde je hlavička */
   select count(*) into _pocetVazeb from dVazebTab where (typvazbyk not in ('typVazbyDokl.polozkaSkl',
                            'typVazbyDokl.polozkaSklSada', 'typVazbyDokl.polozkaSklKus',
                            'typVazbyDokl.obchod_obchod_pol', 'typVazbyDokl.obchod_faktura_pol',
                            'typVazbyDokl.obchod_zaloha_pol', 'typVazbyDokl.obchod_sklad_pol')
                        ) and (not (
                            (modula='FAV' and modulb='FAV' and typvazbyk='typVazbyDokl.odpocetZALOHY') or
                            (modula='FAV' and modulb='FAV' and typvazbyk='typVazbyDokl.odpocetZDD') or
                            (modula='FAP' and modulb='FAP' and typvazbyk='typVazbyDokl.odpocetZALOHY') or
                            (modula='FAP' and modulb='FAP' and typvazbyk='typVazbyDokl.odpocetZDD'))) and
                        ((idtaba = i_idDokl and modula = i_modul) or (idtabb = i_idDokl and modulb=i_modul));
   if (_pocetVazeb <> 0) then
     return false;
   end if;

   return true;
  end if;
end;
$$ LANGUAGE plpgsql;

ALTER FUNCTION public.dzkontrolujvazebnitab(i_iddokl integer, i_isdoklad boolean, i_modul character varying) OWNER TO %firmaRole%;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 209, 't');