-- Bug 17489 – [WinStrom] Uzaverka neprojde pokud se uctuje na ucet 431
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION uuzavriucetniobdobi(idoldobdobi integer, idnewobdobi integer, iducet701 integer, iducet702 integer, iducet710 integer, iducet431 integer)
  RETURNS void AS
$BODY$
declare
  nDatum date;
  newObrat record;
  pom integer;
begin
  select platiOdData into nDatum from nUcetObdobi where idUcetObdobi = idNewObdobi;
  /*smazani pripadne predchozi zaverky*/
  delete from uObraty where idUcetObdobi = idOldObdobi and obdobi = 99;
  delete from uObraty where idUcetObdobi = idNewObdobi and obdobi = 0;

  /*sesumovani obratu ma dati/dal a provedeni opacne operace v obdobi 99*/
  insert into uObraty( idMeny,idUcet,idStred,Rok,Obdobi,ObrDal,ObrMd,idUcetObdobi,LastUpdate) (
    select O.idMeny,O.idUcet,O.idStred,min(O.Rok) as Rok,99 as Obdobi,sum(O.ObrMd) as ObrDal,sum(O.ObrDal) as ObrMd,O.idUcetObdobi,now() as LastUpdate from
      uObraty as O left outer join uUcty as U on U.idUcet = O.idUcet where
      O.idUcetObdobi = idOldObdobi and U.typUctuK <> 'typUctu.zaverkovy'
      group by O.idMeny,O.idUcet,O.idStred,O.idUcetObdobi);

  /*rozvahove ucty
   presun sum na ucty v novem obdobi */
  insert into uObraty( idMeny,idUcet,idStred,Rok,Obdobi,ObrDal,ObrMd,idUcetObdobi,LastUpdate) (
    select O.idMeny,O.idUcet,O.idStred,date_part('year', nDatum) as Rok,0 as Obdobi,sum(O.ObrMd) as ObrDal,sum(O.ObrDal) as ObrMd,idNewObdobi as idUcetObdobi,now() as LastUpdate from
      uObraty as O left outer join uUcty as U on U.idUcet = O.idUcet where
      O.idUcetObdobi = idOldObdobi and O.obdobi = 99 and U.typUctuK in( 'typUctu.rozvahovy','typUctu.podrozvahovy','typUctu.vnitropodnikovy')
      group by O.idMeny,O.idUcet,O.idStred,O.idUcetObdobi,U.typUctuK);

  /*sumace na zaverkovy ucet 702*/
  insert into uObraty( idMeny,idUcet,idStred,Rok,Obdobi,ObrDal,ObrMd,idUcetObdobi,LastUpdate) (
    select O.idMeny,idUcet702 as idUcet,O.idStred,min(Rok) as Rok,99 as Obdobi,sum(O.ObrMd) as ObrDal,sum(O.ObrDal) as ObrMd,O.idUcetObdobi,now() as LastUpdate from
      uObraty as O left outer join uUcty as U on U.idUcet = O.idUcet where
      O.idUcetObdobi = idOldObdobi and O.obdobi = 99 and U.typUctuK in( 'typUctu.rozvahovy','typUctu.podrozvahovy','typUctu.vnitropodnikovy')
      group by O.idMeny,O.idStred,O.idUcetObdobi);

  /*presun uctu 702 na ucet 701 v novem roce*/
  insert into uObraty( idMeny,idUcet,idStred,Rok,Obdobi,ObrDal,ObrMd,idUcetObdobi,LastUpdate) (
    select idMeny,idUcet701 as idUcet,idStred,date_part('year', nDatum) as Rok,0 as Obdobi,sum(O.ObrMd) as ObrDal,sum(O.ObrDal) as ObrMd,idNewObdobi as idUcetObdobi,now() as LastUpdate from
      uObraty as O where O.idUcetObdobi = idOldObdobi and O.obdobi = 99 and O.idUcet = idUcet702 group by O.idMeny,O.idStred,O.idUcetObdobi);

  /*vysledkove ucty
  sumace na protiucet 710*/
  insert into uObraty( idMeny,idUcet,idStred,Rok,Obdobi,ObrDal,ObrMd,idUcetObdobi,LastUpdate) (
    select O.idMeny,idUcet710 as idUcet,O.idStred,min(Rok) as Rok,99 as Obdobi,sum(O.ObrMd) as ObrDal,sum(O.ObrDal) as ObrMd,O.idUcetObdobi,now() as LastUpdate from
      uObraty as O left outer join uUcty as U on U.idUcet = O.idUcet where
      O.idUcetObdobi = idOldObdobi and O.obdobi = 99 and U.typUctuK = 'typUctu.vysledkovy'
      group by O.idMeny,O.idStred,O.idUcetObdobi);

  /*presun uctu 710 na ucet 710 v novem roce*/
  insert into uObraty( idMeny,idUcet,idStred,Rok,Obdobi,ObrDal,ObrMd,idUcetObdobi,LastUpdate) (
    select idMeny,idUcet710 as idUcet,idStred,date_part('year', nDatum) as Rok,0 as Obdobi,sum(O.ObrMd) as ObrDal,sum(O.ObrDal) as ObrMd,idNewObdobi as idUcetObdobi,now() as LastUpdate from
      uObraty as O where O.idUcetObdobi = idOldObdobi and O.obdobi = 99 and O.idUcet = idUcet710 group by O.idMeny,O.idStred,O.idUcetObdobi);

  /*presun uctu 710 v novem roce na ucet 431*/
  for newObrat in (select idMeny,idUcet431 as idUcet,idStred,date_part('year', nDatum) as Rok,0 as Obdobi,sum(O.ObrMd) as ObrDal,sum(O.ObrDal) as ObrMd,idNewObdobi as idUcetObdobi,now() as LastUpdate from
      uObraty as O where O.idUcetObdobi = idNewObdobi and O.obdobi = 0 and O.idUcet = idUcet710 group by O.idMeny,O.idStred,O.idUcetObdobi) loop
	/** idUcet je 431 a ten jiz mohl byt zalozen, pokud na nej jiz uctovali
      * take nesmim prohazovat md a Dal to se dela uz v selectu*/
	select count(1) into pom from uObraty
		where obdobi = newObrat.Obdobi and rok = newObrat.Rok and idmeny = newObrat.idMeny
		and iducet = newObrat.idUcet and idstred = newObrat.idStred and iducetobdobi = newObrat.idUcetObdobi;
	if (pom > 0) then
		update uObraty set obrdal = obrdal + newObrat.ObrDal, obrmd = obrmd + newObrat.ObrMd
			where obdobi = newObrat.Obdobi and rok = newObrat.Rok and idmeny = newObrat.idMeny
			and iducet = newObrat.idUcet and idstred = newObrat.idStred and iducetobdobi = newObrat.idUcetObdobi;
	else
		insert into uObraty( idMeny,idUcet,idStred,Rok,Obdobi,ObrDal,ObrMd,idUcetObdobi,LastUpdate)
			values (newObrat.idMeny, newObrat.idUcet, newObrat.idStred, newObrat.Rok, newObrat.Obdobi, newObrat.ObrDal, newObrat.ObrMd, newObrat.idUcetObdobi, newObrat.LastUpdate);
	end if;
  end loop;

end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION uuzavriucetniobdobi(integer, integer, integer, integer, integer, integer) OWNER TO %firmaRole%;;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 221, 't');