--------------------------------------------------------------------------------
-- Bug 14356 – [WinStrom] Další tabulky a formuláře pro mzdy
--------------------------------------------------------------------------------

-- pridani sloupcu na stalou mzdovou slozku
ALTER TABLE pstalamzdsloz ADD COLUMN castmzd numeric(15,2) DEFAULT 0.0;
ALTER TABLE pstalamzdsloz ADD COLUMN dnykal numeric(15,2) DEFAULT 0.0;
ALTER TABLE pstalamzdsloz ADD COLUMN dnyprac numeric(15,2) DEFAULT 0.0;
ALTER TABLE pstalamzdsloz ADD COLUMN dnysvatek numeric(15,2) DEFAULT 0.0;
ALTER TABLE pstalamzdsloz ADD COLUMN hodiny numeric(15,2) DEFAULT 0.0;
ALTER TABLE pstalamzdsloz ADD COLUMN hodinysvatek numeric(15,2) DEFAULT 0.0;
ALTER TABLE pstalamzdsloz ADD COLUMN prumnadennem numeric(15,2) DEFAULT 0.0;
ALTER TABLE pstalamzdsloz ADD COLUMN prumnahodnem numeric(15,2) DEFAULT 0.0;

-- jejich kopirovani na beznou slozku
CREATE OR REPLACE FUNCTION pupdatemzdslozfromstalasloz(_idMzdSloz integer, _idStalaSloz integer)
  RETURNS void AS $$
declare
  S record;
begin
  select * into S from pstalamzdsloz where idstalamzdsloz = _idStalaSloz;

  if (S.idstalamzdsloz is not null) then
    -- pokud nesouhlasi ciselnik vyplnime ho
    perform pupdatemzdslozfromcis(idMzdSloz, S.idcismzdsloz) from pmzdsloz where idmzdsloz = _idMzdSloz and idcismzdsloz <> S.idcismzdsloz;
    -- preneseme data ze stale mzdove slozky
    update pmzdsloz set idstalamzdsloz = _idStalaSloz,
        castkaden = S.castkaden, castkahod = S.castkahod, kod = S.kod, nazev = S.nazev, pocetmes = S.pocetmes, poznam = S.poznam,
        procmzd = S.procmzd, skupslozkyk = S.skupslozkyk, typslozkyk = S.typslozkyk, zakljekracen = S.zakljekracen, zaklmzd = S.zaklmzd,
        castmzd = S.castmzd, dnykal = S.dnykal, dnyprac = S.dnyprac, dnysvatek = S.dnysvatek, hodiny = S.hodiny, hodinysvatek = S.hodinysvatek,
        prumnadennem = S.prumnadennem, prumnahodnem = S.prumnahodnem,
        idcismzdsloz = S.idcismzdsloz, idstredisko = S.idstredisko, idzakazka = S.idzakazka
  -- NEW.podil, NEW.typpodilk,
      where idmzdsloz = _idMzdSloz;
  end if;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pupdatemzdslozfromstalasloz(integer, integer) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 233, 't');
