-----------------------------------------------------------
-- Bug 19547 – [WinStrom] výdejka k VF má chybné položky
-----------------------------------------------------------

-- Function: dpolskladupdate()
-- DROP FUNCTION dpolskladupdate();
CREATE OR REPLACE FUNCTION dpolskladupdate()
  RETURNS trigger AS
$BODY$ 
declare 
  tmp_rozsirenepolozky_exists boolean; 
  _updatuj boolean; 
  _pocetPolozek integer; 
  _rozsirenaPolozka record; 
  _sklFifo boolean; 
  _vypnutySklad character varying;
  _mazatTmpTable boolean; 
begin 
  /* 
    prepocet skladu budeme provadet jen v okamziku kdy neexistuje tabulka tmp_rozsirenePolozky 
    nebo kdyz tato tabulka existuje ale neni v ni obsazeno polozka kteoru chceme updatovat 
  */ 
  select getglotxvariable('vypniSklad') into _vypnutySklad; 
  if(_vypnutySklad is null or _vypnutySklad <> 'true') then 
    _updatuj = true; 
    tmp_rozsirenepolozky_exists := (select istableexist('tmp_RozsirenePolozky')); 
    if(tmp_rozsirenepolozky_exists = true) then 
      select count(*) into _pocetPolozek from tmp_rozsirenePolozky where idPolSklad = NEW.idPolSklad; 
      if(_pocetPolozek > 0) then 
        _updatuj = false; 
      end if; 
    end if; 
 
    if(OLD.idPolSklad < 0 and NEW.idPolSklad > 0) then 
      _updatuj = false; 
    end if; 
   
    _sklfifo := (select isfifosklad(NEW.datvyst));   
    if (_sklfifo) then   
      --fifo   
      if (OLD.storno=false and NEW.storno=true) then   
        execute sfifoStorno(OLD.idpolsklad, OLD.iddoklsklad);   
      end if;     
      if (OLD.cenamj <> NEW.cenamj) then   
        execute sfifocenamj(OLD.idpolsklad, OLD.iddoklsklad, NEW.cenamj);   
      end if;     
      --fifo konec   
    end if;   
 
    if(_updatuj) then 
 
      -- generuji rozsirene polozky 
      select skladGenerujRozsirenePolozky(NEW.datVyst, NEW.idPolSklad, NEW.idKarty) into _mazatTmpTable; 
     
      execute putglotxvariable('zurnalTxName', 'prepocetSkladu'); 
  
      for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
        if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then 
          execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
        end if; 
      end loop; 
 
      execute sprepoctiskladkartu(OLD.mnozMj, OLD.cenaMj, OLD.datVyst, OLD.idKarty, OLD.idDoklSklad, OLD.idSkladu, -1); 
     
      for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
        if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then 
          execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
        else
          execute sprepoctiskladkartu(NEW.mnozMj, NEW.cenaMj, NEW.datVyst, NEW.idKarty, NEW.idDoklSklad, NEW.idSkladu, 1); 
        end if;
      end loop; 
 
      if(_mazatTmpTable) then 
        drop table tmp_RozsirenePolozky; 
        drop table tmp_SkladoveKarty; 
        execute removeglotxvariable('zurnalTxName'); 
      end if; 
        
    end if; 
  end if;
  return NEW; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladupdate() OWNER TO %firmaRole%;


CREATE OR REPLACE FUNCTION svyrobnicisloinsertupdatezavyrobneno()
  RETURNS trigger AS
$BODY$ 
declare 
  _pocetVyrCisel integer; 
  _mnozMj numeric(19,6); 
  _vyrobniCislaOK boolean; 
  _oldId integer; 
  _newId integer; 
begin 
  -- prijemka 
  if(tg_op = 'INSERT') then 
    _oldId = null; 
    _newId = NEW.idPolSkladPrijem; 
  else 
    _oldId = OLD.idPolSkladPrijem; 
    _newId = NEW.idPolSkladPrijem; 
  end if; 
  if(_newId is not null and _oldId is null) or (_newId <> _oldId) then  
    select count(*) into _pocetVyrCisel from svyrobniCislo where idPolSkladPrijem = _newId;  
    select vyrobniCislaOK, mnozMj into _vyrobniCislaOK, _mnozMj from dPolSklad where idPolSklad = _newId;  
    if(_pocetVyrCisel <> _mnozMj and _vyrobniCislaOK = true) then  
      execute putglotxvariable('vypniSklad', 'true');
      update dPolSklad set VyrobniCislaOk = false where idPolSklad = _newId;  
      execute removeglotxvariable('vypniSklad');
    end if;  
    if(_pocetVyrCisel = _mnozMj and _vyrobniCislaOK = false) then  
      execute putglotxvariable('vypniSklad', 'true');
      update dPolSklad set VyrobniCIslaOK = true where idPolSklad = _newId;  
      execute removeglotxvariable('vypniSklad');
    end if;  
  end if;  
  -- vydejka  
  if(tg_op = 'INSERT') then 
    _oldId = null; 
    _newId = NEW.idPolSkladVydej; 
  else 
    _oldId = OLD.idPolSkladVydej; 
    _newId = NEW.idPolSkladVydej; 
  end if; 
  if(_newId is not null and _oldId is null) or (_newId <> _oldId) then  
    select count(*) into _pocetVyrCisel from svyrobniCislo where idPolSkladVydej = _newId;  
    select vyrobniCislaOK, mnozMj into _vyrobniCislaOK, _mnozMj from dPolSklad where idPolSklad = _newId;  
    if(_pocetVyrCisel <> _mnozMj and _vyrobniCislaOK = true) then  
      execute putglotxvariable('vypniSklad', 'true');
      update dPolSklad set VyrobniCislaOk = false where idPolSklad = _newId;  
      execute removeglotxvariable('vypniSklad');
    end if;  
    if(_pocetVyrCisel = _mnozMj and _vyrobniCislaOK = false) then  
      execute putglotxvariable('vypniSklad', 'true');
      update dPolSklad set VyrobniCIslaOK = true where idPolSklad = _newId;  
      execute removeglotxvariable('vypniSklad');
    end if;  
  end if;  
 
  -- prijata faktura 
  if(tg_op = 'INSERT') then 
    _oldId = null; 
    _newId = NEW.idPolFakPrijem; 
  else 
    _oldId = OLD.idPolFakPrijem; 
    _newId = NEW.idPolFakPrijem; 
  end if; 
  if(_newId is not null and _oldId is null) or (_newId <> _oldId) then  
    select count(*) into _pocetVyrCisel from svyrobniCislo where idPolFakPrijem = _newId;  
    select vyrobniCislaOK, mnozMj into _vyrobniCislaOK, _mnozMj from dPolFak where idPolFak = _newId;  
    if(_pocetVyrCisel <> _mnozMj and _vyrobniCislaOK = true) then  
      execute putglotxvariable('vypniSklad', 'true');
      update dPolFak set VyrobniCislaOk = false where idPolFak = _newId;  
      execute removeglotxvariable('vypniSklad');
    end if;  
    if(_pocetVyrCisel = _mnozMj and _vyrobniCislaOK = false) then  
      execute putglotxvariable('vypniSklad', 'true');
      update dPolFak set VyrobniCislaOK = true where idPolFak = _newId;  
      execute removeglotxvariable('vypniSklad');
    end if;  
  end if;  
  -- vydana faktura  
  if(tg_op = 'INSERT') then 
    _oldId = null; 
    _newId = NEW.idPolFakVydej; 
  else 
    _oldId = OLD.idPolFakVydej; 
    _newId = NEW.idPolFakVydej; 
  end if; 
  if(_newId is not null and _oldId is null) or (_newId <> _oldId) then  
    select count(*) into _pocetVyrCisel from svyrobniCislo where idPolFakVydej = _newId;  
    select vyrobniCislaOK, mnozMj into _vyrobniCislaOK, _mnozMj from dPolFak where idPolFak = _newId;  
    if(_pocetVyrCisel <> _mnozMj and _vyrobniCislaOK = true) then  
      execute putglotxvariable('vypniSklad', 'true');
      update dPolFak set VyrobniCislaOk = false where idPolFak = _newId;  
      execute removeglotxvariable('vypniSklad');
    end if;  
    if(_pocetVyrCisel = _mnozMj and _vyrobniCislaOK = false) then  
      execute putglotxvariable('vypniSklad', 'true');
      update dPolFak set VyrobniCislaOK = true where idPolFak = _newId; 
      execute removeglotxvariable('vypniSklad'); 
    end if;  
  end if;  
 
  -- vydajovy pokladni doklad 
  if(tg_op = 'INSERT') then 
    _oldId = null; 
    _newId = NEW.idPolIntPrijem; 
  else 
    _oldId = OLD.idPolIntPrijem; 
    _newId = NEW.idPolIntPrijem; 
  end if; 
  if(_newId is not null and _oldId is null) or (_newId <> _oldId) then  
    select count(*) into _pocetVyrCisel from svyrobniCislo where idPolIntPrijem = _newId;  
    select vyrobniCislaOK, mnozMj into _vyrobniCislaOK, _mnozMj from dPolInt where idPolInt = _newId;  
    if(_pocetVyrCisel <> _mnozMj and _vyrobniCislaOK = true) then  
      execute putglotxvariable('vypniSklad', 'true');
      update dPolInt set VyrobniCislaOk = false where idPolInt = _newId; 
      execute removeglotxvariable('vypniSklad'); 
    end if;  
    if(_pocetVyrCisel = _mnozMj and _vyrobniCislaOK = false) then  
      execute putglotxvariable('vypniSklad', 'true');
      update dPolInt set VyrobniCislaOK = true where idPolInt = _newId; 
      execute removeglotxvariable('vypniSklad'); 
    end if;  
  end if;  
  -- prijmovy pokladni doklad  
  if(tg_op = 'INSERT') then 
    _oldId = null; 
    _newId = NEW.idPolIntVydej; 
  else 
    _oldId = OLD.idPolIntVydej; 
    _newId = NEW.idPolIntVydej; 
  end if; 
  if(_newId is not null and _oldId is null) or (_newId <> _oldId) then  
    select count(*) into _pocetVyrCisel from svyrobniCislo where idPolIntVydej = _newId;  
    select vyrobniCislaOK, mnozMj into _vyrobniCislaOK, _mnozMj from dPolInt where idPolInt = _newId;  
    if(_pocetVyrCisel <> _mnozMj and _vyrobniCislaOK = true) then  
      execute putglotxvariable('vypniSklad', 'true');
      update dPolInt set VyrobniCislaOk = false where idPolInt = _newId; 
      execute removeglotxvariable('vypniSklad');
    end if;  
    if(_pocetVyrCisel = _mnozMj and _vyrobniCislaOK = false) then  
      execute putglotxvariable('vypniSklad', 'true');
      update dPolInt set VyrobniCislaOK = true where idPolInt = _newId;  
      execute removeglotxvariable('vypniSklad');
    end if;  
  end if;  
  RETURN NEW;  
end;  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION svyrobnicisloinsertupdatezavyrobneno() OWNER TO %firmaRole%;


-- Function: fillpolsklad(integer, integer, character varying)
-- DROP FUNCTION fillpolsklad(integer, integer, character varying);
CREATE OR REPLACE FUNCTION fillpolsklad(_idpolsklad integer, _idpoldokl integer, _modul character varying)
  RETURNS integer AS
$BODY$ 
declare 
  _polDokl record; 
  _polSklad record; 
  _idDoklad integer; 
  _typPohybuK character varying; 
  _typPohybuSklad character varying; 
  _cenaMj numeric(19,6); 
  _cenaMjTuz numeric(19,6); 
  _mnozMj numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _idDoklSklad integer; 
  _idUcetObdobi integer; 
  _idKarty integer; 
  _sklad record; 
  _kurz numeric(19,6); 
  _prumCenaTuz numeric(19,6); 
  _isCiziMena boolean; 
  _typDoklK character varying; 
  _idZklMdUcet integer; 
  _idZklDalUcet integer; 
begin 
  if(_modul like 'POK') then 
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl; 
    select idDoklInt, typPohybuK into _idDoklad, _typPohybuK from dDoklInt where idDoklInt = _polDokl.idDoklInt; 
    _typDoklK = null; -- pro pokladnu dobropisy nejsou 
  else 
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl; 
    select idDoklFak, typPohybuK into _idDoklad, _typPohybuK from dDoklFak where idDoklFak = _polDokl.idDoklFak; 
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak); 
  end if; 
 
  select findParovanyDoklSklad(_idDoklad, _modul) into _idDoklSklad; 
   
  if(_idDoklSklad is null) then 
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad; 
  end if; 
 
  select * into _polSklad from dPolSklad where idPolSklad = _idPolSklad; 
  select typPohybuK into _typPohybuSklad from dDoklSklad where idDoklSklad = _polSklad.idDoklSklad; 
 
  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi; 
  select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idtypdokl = _polDokl.idskladu and iducetobdobi = _iducetobdobi; 
  select * into _sklad from dTypDokl where idTypDokl = _polDokl.idSkladu; 
   
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz; 
  select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty; 
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena; 
 
  if(_typPohybuSklad like 'typPohybu.vydej') then 
    -- vsechny dobropisy generuji prijemky 
    --if(_typDoklK like 'typDokladu.dobropis') then 
    --  _mnozMj = -_polDokl.mnozMj; 
    --else 
      _mnozMj = _polDokl.mnozMj; 
    --end if; 
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena 
    _cenaMj = _polSklad.cenaMj; 
    _sumZkl = _polSklad.sumZkl; 
    _sumZklMen = _polSklad.sumZklMen; 
    -- nastaveni uctu pro polSklad vydej 
    select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet; 
    _idZklDalUcet = _sklad.idPrimUcet; 
  else 
    if(_typDoklK like 'typDokladu.dobropis' and _modul like 'FAV') then 
      -- pokud se jedna o dobropis tak doplnuji nakupni ceny; 
      _mnozMj = -_polDokl.mnozMj; 
      _cenaMjTuz = _polDokl.cenaMjNakup;  
      if(_cenaMjTuz = 0.0) then 
        _cenaMjTuz = (select nakupCena from ccenik where idCenik = _polDokl.idCenik); 
        if(_cenaMj = 0.0) then 
          _cenaMj = _polDokl.cenaMj * _kurz; 
        end if; 
      end if; 
      _cenaMj = _cenaMjTuz / _kurz; 
      _sumZkl = _mnozMj * _cenaMjTuz; 
      if(_isCiziMena) then 
        _sumZklMen = _mnozMj * _cenaMj; 
      else 
        _sumZklMen = 0.0; 
      end if; 
    else 
      -- pokud na sklad prijmam zkopiruji se ceny z faktury 
      _mnozMj = _polDokl.mnozMj; 
      _sumZkl = _polDokl.sumZkl; 
      if(_mnozMj <> 0.0) then 
        _cenaMj = _sumZkl / _mnozMj; 
      else 
        _cenaMj = _sumZkl; 
      end if; 
      _cenaMj = _cenaMj / _kurz; 
      if(_isCiziMena) then 
        if(_mnozMj <> 0.0) then 
          _sumZklMen = _cenaMj * _mnozMj;   
        else 
          _sumZklMen = _cenaMj; 
        end if; 
      else 
        _sumZklMen = 0.0;   
      end if;  
    end if; 
    -- nastaveni uctu pro polSklad prijem 
    _idZklMdUcet = _sklad.idPrimUcet; 
    _idZklDalUcet = _polDokl.idZklMdUcet; 
  end if; 
   
  update dPolSklad set  
    cenaMj = _cenaMj,  
    --mnozMj = _mnozMj,  
    sumZkl = _sumZkl,  
    sumZklMen = _sumZklMen,  
    nazev = _polDokl.nazev,  
    nazevA = _polDokl.nazevA,  
    nazevB = _polDokl.nazevB,  
    nazevC = _polDokl.nazevC,  
    datVyst = _polDokl.datVyst,  
    datUcto = _polDokl.datVyst, 
    baleniId = _polDokl.baleniId,  
    mnozBaleni = _polDokl.mnozBaleni,  
    sarze = _polDokl.sarze,  
    expirace = _polDokl.expirace,  
    cisRad = _polDokl.cisRad,  
    eankod = _polDokl.eanKod,  
    idmj = _polDokl.idmj,  
    idStred = _polDokl.idStred,  
    idMeny = _polSklad.idMeny,  
    idZakazky = _polDokl.idZakazky,  
    idZklMdUcet = _idZklMdUcet,  
    idZklDalUcet = _idZklDalUcet, 
    ucetni = true 
    where idPolSklad = _idPolSklad; 
 
  return _idPolSklad; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION fillpolsklad(integer, integer, character varying) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 321, 't');