-------------------------------------------------------------------
-- Bug 16383 – [WinStrom] Doplnit na polozku faktury nakupni cenu
-- oprava fixopie NTB004 [GRKXMR6DK6] z 28.6.2010 16:15
-------------------------------------------------------------------

create or replace function skladGetCenaMjNakup(i_idPolFak integer, i_modul character varying, i_mnozMj numeric(19,6)) returns numeric(19, 6) as
$BODY$
declare
  _result numeric(19,6);
  _polSklad record;
  _fifoPolSklad record;
  _mnozMj numeric(19,6);
  _cenik record;
  _polDokl record;
  _isDobropis boolean;
  _typDoklK character varying;
begin
  _isDobropis = false;
  if(i_modul = 'FAV') then
    select * into _polDokl from dPolFak where idPolFak = i_idPolFak;
    select * into _cenik from ccenik where idcenik = _polDokl.idCenik; 
    select typDoklK into _typDoklK from dtypdokl where idtypdokl = (select idtypdokl from ddoklfak where iddoklfak = _polDokl.idDoklFak);
    if(_typDoklK = 'typDokladu.dobropis') then
      _isDobropis = true;
    end if;
  elsif(i_modul = 'POK') then
    select * into _polDokl from dPolInt where idPolInt = i_idPolFak;
    select * into _cenik from ccenik where idcenik = _polDokl.idCenik; 
  else
    select null into _cenik; 
  end if;
  
  if(_cenik is null) then
    return 0.0;
  end if;

  if(_isDobropis) then
    _mnozMj = 0 - i_mnozMj;
  else
    _mnozMj = i_mnozMj;
  end if;
  
  if(_cenik.typZasobyK <> 'typZasoby.skladem' and _cenik.typZasobyK <> 'typZasoby.vyrobek') then
    return _cenik.nakupCena;
  end if;
  _result = 0.0;
  --_mnozMj = 0.0;
  for _polSklad in (select * from dpolsklad where idPolSklad in 
    (select idTabB from dVazebTab where idTabA = i_idPolFak and modulA = i_modul and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSkl')) loop
    if(_polSklad.mnozMj = 0.0) then
      _result = _result + _polSklad.cenaMj;
    else
      _result = _result + _polSklad.sumZkl;
    end if;
    --_mnozMj = _mnozMj + _polSklad.mnozMj;
    for _fifoPolSklad in (select * from dpolsklad where idPolSklad in 
      (select idpolskladcil from svazbypolsklad where idPolSkladZdroj = _polSklad.idPolSklad)) loop
        if(_fifoPolSklad.mnozMj = 0.0) then
          _result = _result + _fifoPolSklad.cenaMj;
        else
          _result = _result + _fifoPolSklad.sumZkl;
        end if;
        --_mnozMj = _mnozMj + _fifoPolSklad.mnozMj;
    end loop;
  end loop;

  for _polSklad in (select * from dpolsklad where idPolSklad in 
    (select idTabB from dVazebTab where idTabA = i_idPolFak and modulA = i_modul and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklSada')) loop
    if(_polSklad.mnozMj = 0.0) then
      _result = _result + _polSklad.cenaMj;
    else
      _result = _result + _polSklad.sumZkl;
    end if;
    --_mnozMj = _mnozMj + _polSklad.mnozMj;
    for _fifoPolSklad in (select * from dpolsklad where idPolSklad in 
      (select idpolskladcil from svazbypolsklad where idPolSkladZdroj = _polSklad.idPolSklad)) loop
        if(_fifoPolSklad.mnozMj = 0.0) then
          _result = _result + _fifoPolSklad.cenaMj;
        else
          _result = _result + _fifoPolSklad.sumZkl;
        end if;
        --_mnozMj = _mnozMj + _fifoPolSklad.mnozMj;
    end loop;
  end loop;
  

  if(_mnozMj = 0) then
  else
    _result = _result / _mnozMj;
  end if;
  return _result;
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladGetCenaMjNakup(integer, character varying, numeric(19,6)) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 332, 't');
