------------------------------------------------------------------------------------------------------
-- Bug 20404 – [WinStrom] Datum posledního pohybu na kartě zboží bývá chybné
------------------------------------------------------------------------------------------------------

-- Function: skladprepoctirozsirenoupolozku(integer, integer)
-- DROP FUNCTION skladprepoctirozsirenoupolozku(integer, integer);
CREATE OR REPLACE FUNCTION skladprepoctirozsirenoupolozku(i_idrozsirenepolozky integer, sign integer)
  RETURNS void AS
$BODY$ 
declare 
  _skladKarta record; 
  _rozsirenaPolozka record; 
  _polSklad record; 
  _navazanaPolSklad record; 
  _stavMj numeric(19,6); 
  _stavTuz numeric(19,6); 
  _stavMen numeric(19,6); 
  _prumCenaTuz numeric(19,6); 
  _prumCenaMen numeric(19,6); 
  _pocetNavazanych integer; 
  _cenaMj numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _kurzDokladu numeric(19,6); 
  _kurzSkladKarty numeric(19,6); 
  _isCiziMena boolean; 
  _sklfifo boolean;
  _datPosl date; 
begin 
  select * into _rozsirenaPolozka from tmp_RozsirenePolozky where idpolsklad = i_idrozsirenepolozky; 
  select * into _polSklad from dPolSklad where idPolSklad = i_idrozsirenepolozky; 
  if(_polSklad is null) then 
    -- muze se stat ze v rozsirenych polozkach je uz polozka ktera byla v ramci transakce smazana 
    return; 
  end if; 
   
  select * into _skladKarta from sKarty where idKarty = _rozsirenaPolozka.idskladkarty; 
  select getKurzFromDoklad(_rozsirenaPolozka.idDoklSkladPolozky, _rozsirenaPolozka.datum) into _kurzDokladu; 
 
  if(sign = 1) then 
    if(_rozsirenaPolozka.skupina = 1) then 
      if(_polSklad.mnozMj = 0.0) then 
        _stavTuz = _polSklad.cenaMj * _kurzDokladu; 
      else 
        select sumZkl into _stavTuz from dpolsklad where idPolSklad = _rozsirenaPolozka.idPolSklad; 
      end if; 
    else 
      -- pokud se jedna o prijemku z prevodky nebo vyroby tak se musi cena nastavit podle navazane vydejky 
      if(_rozsirenaPolozka.skupina = 2 and _rozsirenaPolozka.typPohybuK = 'typPohybu.prijem') then 
        select * into _navazanaPolSklad from dPolSklad  
            where idPolSklad = (select idTabA from dvazebtab where idTabB = _rozsirenaPolozka.idPolSklad and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklPrevod'); 
        if(_navazanaPolSklad is null) then 
          _cenaMj = 0.0; 
          _sumZkl = 0.0; 
          for _navazanaPolSklad in (select * from dPolSklad 
	        where idPolSklad in  
            (select idTabB from dvazebtab where idTabA = _rozsirenaPolozka.idPolSklad and modulA = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklKus') ) 
            loop 
	        if(_navazanaPolSklad.mnozMj <> 0.0) then 
              _cenaMj = _cenaMj + (_navazanaPolSklad.sumZkl / _navazanaPolSklad.mnozMj) / _kurzDokladu; 
            else 
              raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit 
            end if; 
            _sumZkl = _sumZkl + _navazanaPolSklad.sumZkl; 
          end loop; 
        else 
          if(_navazanaPolSklad.mnozMj <> 0.0) then 
            _cenaMj = (_navazanaPolSklad.sumZkl / _navazanaPolSklad.mnozMj) / _kurzDokladu; 
          else 
            raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit 
          end if; 
          _sumZkl = _navazanaPolSklad.sumZkl; 
        end if; 
        _sumZklMen = 0.0; 
        select isdoklskladmenacizi(_rozsirenaPolozka.idDoklSkladPolozky, _rozsirenaPolozka.datum) into _isCiziMena; 
        if(_isCiziMena) then 
          _sumZklMen = _polSklad.mnozMj * _cenaMj; 
        end if; 
      else 
        _cenaMj = _skladKarta.prumCenaTuz; 
        if(_kurzDokladu is not null and _kurzDokladu <> 0.0) then 
          _cenaMj = _cenaMj / _kurzDokladu; 
        end if; 
        _sumZkl = _polSklad.mnozMj * _skladKarta.prumCenaTuz; 
        _sumZklMen = 0.0; 
        select isdoklskladmenacizi(_rozsirenaPolozka.idDoklSkladPolozky, _rozsirenaPolozka.datum) into _isCiziMena; 
        if(_isCiziMena) then 
          _sumZklMen = _polSklad.mnozMj * _cenaMj;  
        end if; 
      end if; 
 
      _sklfifo := (select isfifosklad(_rozsirenaPolozka.datum));   
      if (not _sklfifo) then 
        update dPolSklad set 
          cenaMj = _cenaMj, 
          sumZkl = _sumZkl, 
          sumZklMen = _sumZklMen 
          where idPolSklad = _rozsirenaPolozka.idPolSklad; 
      end if; 
 
      execute sprepoctisumydokladu(_rozsirenaPolozka.idDoklSkladPolozky); 
 
      select sumZkl into _stavTuz from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad; 
    end if; 
  else 
    if(_polSklad.mnozMj = 0.0) then 
      _stavTuz = _polSklad.cenaMj * _kurzDokladu; 
    else 
      select sumZkl into _stavTuz from dpolsklad where idPolSklad = i_idrozsirenepolozky; 
    end if; 
  end if; 
 
  if(_rozsirenaPolozka.typpohybuk = 'typPohybu.vydej') then 
    _stavMj = _skladKarta.stavMj - (sign*_polSklad.mnozMj); 
    _stavTuz = _skladKarta.stavTuz - (sign*_stavTuz); 
  else 
    _stavMj = _skladKarta.stavMj + (sign*_polSklad.mnozMj); 
    _stavTuz = _skladKarta.stavTuz + (sign*_stavTuz); 
  end if; 
 
  if(_stavMj is null) then 
    raise exception 'stav mj je null a idpolsklad je % a\\n _skladkarta je % \\na _polSklad je %',i_idrozsirenepolozky, _skladkarta, _polSklad; 
  end if; 
 
  _prumCenaTuz = 0.0; 
  if(_stavMj <> 0.0) then 
    _prumCenaTuz = _stavTuz / _stavMj; 
  end if; 
  if(_prumCenaTuz is null) then 
    raise exception 'prumCenaTuz je null, _stavTuz je %, _stavMj je %', _stavTuz, _stavMj; 
  end if; 
 
  _datPosl = _skladKarta.datPosl;
  if(_datPosl is null or _datPosl < _polSklad.datVyst) then
    _datPosl = _polSklad.datVyst;
  end if;

  _KurzSkladKarty := (select getKurzFromSklad(_skladKarta.idTypDokl, _rozsirenaPolozka.datum)); 
  if (not _rozsirenaPolozka.storno) then 
    update skarty set  
      stavmj = _stavMj, 
      stavTuz = _stavTuz, 
      stavMen = _stavTuz / _kurzSkladKarty, 
      prumCenaTuz = _prumCenaTuz, 
      prumCenaMen = _prumCenaTuz / _kurzSkladKarty, 
      datPosl = _datPosl
      where idkarty = _rozsirenaPolozka.idSkladKarty; 
  end if; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladprepoctirozsirenoupolozku(integer, integer) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 363, 't');
