--------------------------------------------------------------------------------
-- Bug 20573 – [winstrom] - Podnikatel_Online - jemnější členění správy firem
--------------------------------------------------------------------------------

alter table wuzivatel add column adduser boolean DEFAULT false NOT NULL;

CREATE OR REPLACE FUNCTION runupgrade() RETURNS void AS $$
declare
  _idUziv integer;
begin
  -- pridavat dalsi uzivatele povolime jen tem uzivatelum, kteri maji roli (nebo jejiho potomka)
  -- admin nebo superUzivatel
  for _idUziv in    (select u.iduzivatel
                    from wuzivatel u
                    where exists
                            (select 1
                            from wrole r
                            where u.idrole = r.idrole
                                    and r.standard = true
                                    and r.pristupk in ('typPrav.admin', 'typPrav.superUzivatel'))
                          or exists
                            (select 1
                            from wrole r
                            inner join wrole strole on strole.idrole = r.idstandardrole
                                    where u.idrole = r.idrole
                                    and strole.pristupk in ('typPrav.admin', 'typPrav.superUzivatel'))) loop
    update wuzivatel set adduser = true
            where iduzivatel = _idUziv;
  end loop;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

CREATE OR REPLACE FUNCTION runupgrade() RETURNS void AS $$
declare
  _role record;
  _idstrole integer;
  _idotec integer;
begin
  for _role in (select * from wrole where standard = false) loop
    select null into _idstrole;
    select _role.idotecrole into _idotec;

    while (_idstrole is null) loop
	select idrole into _idstrole from wrole r where r.idrole = _idotec and r.standard = true;
	select idotecrole into _idotec from wrole r where r.idrole = _idotec;
    end loop;

    update wrole set idstandardrole = _idstrole
	where idrole = _role.idrole;
  end loop;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 382, 't');
