--------------------------------------------------------------------------------
-- Bug 20658 – [WinStrom] Uložené SQL dotazy - Datový model + editor dotazů
--------------------------------------------------------------------------------

CREATE SEQUENCE seq_wdotazy
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_wdotazy OWNER TO %firmaRole%;

CREATE TABLE wdotazy
(
  iddotaz integer DEFAULT nextval('seq_wdotazy'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  kod character varying(20) NOT NULL,
  nazev character varying(255) NOT NULL,
  nazeva character varying(255),
  nazevb character varying(255),
  nazevc character varying(255),
  popis text,
  poznam text,
  show boolean NOT NULL DEFAULT true,
  dotaz text NOT NULL,
  masterbeankey character varying(100),
  privatni boolean NOT NULL DEFAULT false,
  report character varying(255),
  showbeankeys text,
  iduzivatel integer NOT NULL,
  CONSTRAINT wdotazy_pkey PRIMARY KEY (iddotaz),
  CONSTRAINT fk11617ccefc33e99b FOREIGN KEY (iduzivatel)
      REFERENCES wuzivatel (iduzivatel) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE wdotazy OWNER TO %firmaRole%;


CREATE SEQUENCE seq_wdotazyparam
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_wdotazyparam OWNER TO %firmaRole%;

CREATE TABLE wdotazyparam
(
  iddotazparam integer DEFAULT nextval('seq_wdotazyparam'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  kod character varying(20) NOT NULL,
  nazev character varying(255) NOT NULL,
  nazeva character varying(255),
  nazevb character varying(255),
  nazevc character varying(255),
  popis text,
  poznam text,
  show boolean NOT NULL DEFAULT true,
  beankey character varying(100),
  cisrad integer NOT NULL DEFAULT 0,
  mohutnostn boolean NOT NULL DEFAULT false,
  typparamk character varying(50),
  vychozi character varying(100),
  iddotaz integer NOT NULL,
  CONSTRAINT wdotazyparam_pkey PRIMARY KEY (iddotazparam),
  CONSTRAINT fka0477c5f7634c721 FOREIGN KEY (iddotaz)
      REFERENCES wdotazy (iddotaz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE wdotazyparam OWNER TO %firmaRole%;


CREATE SEQUENCE seq_wdotazyprop
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_wdotazyprop OWNER TO %firmaRole%;

CREATE TABLE wdotazyprop
(
  iddotazprop integer DEFAULT nextval('seq_wdotazyprop'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  kod character varying(20) NOT NULL,
  nazev character varying(255) NOT NULL,
  nazeva character varying(255),
  nazevb character varying(255),
  nazevc character varying(255),
  popis text,
  poznam text,
  show boolean NOT NULL DEFAULT true,
  beankeyopen character varying(100),
  cisrad integer NOT NULL DEFAULT 0,
  hidecolumn boolean NOT NULL DEFAULT false,
  resourcebeankey character varying(100),
  resourcepropname character varying(100),
  typpropk character varying(50),
  width integer NOT NULL DEFAULT 0,
  iddotaz integer NOT NULL,
  CONSTRAINT wdotazyprop_pkey PRIMARY KEY (iddotazprop),
  CONSTRAINT fk57c07d517634c721 FOREIGN KEY (iddotaz)
      REFERENCES wdotazy (iddotaz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE wdotazyprop OWNER TO %firmaRole%;

CREATE INDEX wDotazy_IdUzivatel_index ON wDotazy USING btree (IdUzivatel);
CREATE INDEX wDotazyParam_IdDotaz_index ON wDotazyParam USING btree (IdDotaz);
CREATE INDEX wDotazyProp_IdDotaz_index ON wDotazyProp USING btree (IdDotaz);

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 410, 't', %appVersion%, clock_timestamp());