--------------------------------------------------------------------------------
-- Bug 21343 – [WinStrom] Doplnění sloupečků
--------------------------------------------------------------------------------

alter table cdodavatele add column stavmj numeric(19,6) DEFAULT NULL;
alter table wpriloha add column exportnaeshop boolean NOT NULL DEFAULT false;

-- vsechny ceniky exportovane na eshop budou jako vychozi exportovat i svoje prilohy
update wpriloha p
set exportnaeshop = c.exportnaeshop
from ccenik c
where p.idcenik = c.idcenik;

alter table akontakty 
    add column osloveni character varying(255),
    add column oddeleni character varying(255);

--------------------------------------------------------------------------------
-- Bug 21343 – [WinStrom] Doplnění sloupečků 2
--------------------------------------------------------------------------------

alter table aadresar
    add column osloveni character varying(255),
    add column idzodposoba integer,
    add constraint aadresar_iduzivatel_fk foreign key (idzodposoba)
        references wuzivatel (iduzivatel) match simple
        on update no action on delete no action;

alter table ddoklfak
    add column idzodposoba integer,
    add constraint ddoklfak_iduzivatel_fk foreign key (idzodposoba)
        references wuzivatel (iduzivatel) match simple
        on update no action on delete no action;

alter table ddoklint
    add column idzodposoba integer,
    add constraint ddoklfak_iduzivatel_fk foreign key (idzodposoba)
        references wuzivatel (iduzivatel) match simple
        on update no action on delete no action;

alter table ddoklobch
    add column idzodposoba integer,
    add constraint ddoklfak_iduzivatel_fk foreign key (idzodposoba)
        references wuzivatel (iduzivatel) match simple
        on update no action on delete no action;

alter table ddoklsklad
    add column idzodposoba integer,
    add constraint ddoklfak_iduzivatel_fk foreign key (idzodposoba)
        references wuzivatel (iduzivatel) match simple
        on update no action on delete no action;

CREATE INDEX aAdresar_IdZodpOsoba_index ON aAdresar USING btree (IdZodpOsoba);
CREATE INDEX dDoklFak_IdZodpOsoba_index ON dDoklFak USING btree (IdZodpOsoba);
CREATE INDEX dDoklInt_IdZodpOsoba_index ON dDoklInt USING btree (IdZodpOsoba);
CREATE INDEX dDoklObch_IdZodpOsoba_index ON dDoklObch USING btree (IdZodpOsoba);
CREATE INDEX dDoklSklad_IdZodpOsoba_index ON dDoklSklad USING btree (IdZodpOsoba);

--------------------------------------------------------------------------------
-- Bug 21344 – [WinStrom] Doplnění sloupečků 3
--------------------------------------------------------------------------------

alter table codberatele
    add column platioddata date,
    add column platidodata date,
    add column rucnevybrat boolean NOT NULL DEFAULT FALSE,
    add column idstred integer,
    add constraint codberatele_idstred_fk foreign key (idstred)
        references ustrediska (idstred) match simple
        on update no action on delete no action;

alter table ccenhlad
    add column rucnevybrat boolean NOT NULL DEFAULT FALSE,
    add column idstred integer,
    add constraint ccenhlad_idstred_fk foreign key (idstred)
        references ustrediska (idstred) match simple
        on update no action on delete no action;

CREATE INDEX cCenHlad_IdStred_index ON cCenHlad USING btree (IdStred);
CREATE INDEX cOdberatele_IdStred_index ON cOdberatele USING btree (IdStred);

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 413, 't', %appVersion%, clock_timestamp());