--------------------------------------------------------------------------------
-- Bug 23742 – [WinStrom] Opravit strom ceniku
--------------------------------------------------------------------------------

create or replace function containscount(substr character varying, str character varying) returns integer
as $$
declare
  count integer;
  parse character varying;
begin
  count = 0;
  parse = str;
  while (position(substr in parse) != 0) loop
    count = count + 1;
    parse = substring(parse from position(substr in parse) + 1);
  end loop;

  return count;
end;
$$ LANGUAGE 'plpgsql' VOLATILE cost 100;
ALTER FUNCTION containscount(character varying, character varying) OWNER TO %firmaRole%;

create or replace function getuzelpath(_iduzel integer, _cesta character varying) returns character varying
as $$
declare
  _idotec integer;
  _poradi integer;
begin
  select idotec, poradi into _idotec, _poradi from wuzel where iduzel = _iduzel;
  if (_idotec is null) then
    return '1/';
  else
    return getuzelpath(_idotec, _cesta) || _poradi || '/';
  end if;
end;
$$ LANGUAGE 'plpgsql' VOLATILE cost 100;
ALTER FUNCTION getuzelpath(integer, character varying) OWNER TO %firmaRole%;

-- zadny nesmi ukazovat sam na sebe
update wuzel
set idotec = (select iduzel from wuzel where cesta = '1/1/')
where iduzel = idotec;


update wuzel
set cesta = replace(cesta, '//', '/')
where position('//' in cesta) != 0;

create or replace function runupgrade()
returns void as $$
declare
  chybnych integer;
  pruchodu integer;
begin
  select count(1) into chybnych from wuzel where cesta != getuzelpath(iduzel, '');
  select 0 into pruchodu;
  while (chybnych != 0 and pruchodu < 10) loop
    update wuzel
    set cesta = getuzelpath(iduzel, ''),
    hladina = containscount('/', cesta)
    where cesta != getuzelpath(iduzel, '');

    select count(1) into chybnych from wuzel where cesta != getuzelpath(iduzel, '');
    pruchodu = pruchodu + 1;
  end loop;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();


drop function containscount(character varying, character varying);
drop function getuzelpath(integer, character varying);
drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 475, 't', %appVersion%, clock_timestamp());
