--------------------------------------------------------------------------------
-- Bug 24158 – [WinStrom] Přenos účtu ze skladu rozbíjí doklady v tabulce ddoklint
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION ddoklskladupdateucty() RETURNS trigger
    AS $$
declare idFak int;
declare idSklad int;
declare idPok int;
begin
  if (NEW.typPohybuK = 'typPohybu.prijem' and compareId(NEW.idProtiUcet, OLD.idProtiUcet) = false) then
    -- musime testovat i jestli je modul FAP protoze u dobropisu muze byt prijem/vydej opacne
    for idFak in (select idTabA from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSkl' and idTabB = NEW.idDoklSklad and modulA = 'FAP' and
            compareId((select idProtiUcet from dDoklFak where idDoklFak = idTabA), NEW.idProtiUcet) = false)
    loop
        execute dNastavUcetDokladu(0, idFak, 1, NEW.idProtiUcet);
    end loop;

    for idPok in (select idTabA from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSkl' and idTabB = NEW.idDoklSklad and modulA = 'POK' and 
            compareId((select idProtiUcet from dDoklInt where idDoklInt = idTabA), NEW.idProtiUcet) = false) 
    loop 
        execute dNastavUcetDokladu(1, idPok, 1, NEW.idProtiUcet); 
    end loop; 
 
    for idSklad in (select idTabA from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSklPrevod' and idTabB = NEW.idDoklSklad and 
            compareId((select idProtiUcet from dDoklSklad where idDoklSklad = idTabA), NEW.idProtiUcet) = false) 
    loop 
        execute dNastavUcetDokladu(2, idSklad, 1, NEW.idProtiUcet); 
    end loop;

   /*for idSklad in (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSklKus' and idTabA = NEW.idDoklSklad and
            compareId((select idProtiUcet from dDoklSklad where idDoklSklad = idTabB), NEW.idProtiUcet) = false)
    loop
        execute dNastavUcetDokladu(2, idSklad, 1, NEW.idProtiUcet);
    end loop;*/

  else
    /*if (NEW.typPohybuK = 'typPohybu.vydej' and compareId(NEW.idProtiUcet, OLD.idProtiUcet) = false) then

      for idSklad in (select idTabA from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSklKus' and idTabB = NEW.idDoklSklad and
              compareId((select idProtiUcet from dDoklSklad where idDoklSklad = idTabA), NEW.idProtiUcet) = false)
      loop
          execute dNastavUcetDokladu(2, idSklad, 1, NEW.idProtiUcet);
      end loop;

    end if;*/

    if (NEW.typPohybuK = 'typPohybu.vydej' and compareId(NEW.idProtiUcet, OLD.idProtiUcet) = false) then

      for idSklad in (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSklPrevod' and idTabA = NEW.idDoklSklad and 
              compareId((select idProtiUcet from dDoklSklad where idDoklSklad = idTabB), NEW.idProtiUcet) = false) 
      loop 
          execute dNastavUcetDokladu(2, idSklad, 1, NEW.idProtiUcet); 
      end loop; 

    end if;
  end if;

  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.ddoklskladupdateucty() OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 479, 't', %appVersion%, clock_timestamp());
