--------------------------------------------------------------------------------
-- Bug 24546 – [WinStrom] Pridat nove banky do ciselniku
--------------------------------------------------------------------------------

create or replace function runupgrade()
    returns void as $$
declare
    stat character varying(10);
    userbankid integer;
begin
  select a.uuid into stat from nnastav n  left join utyporg u on u.idtyporg = n.idtyporg left join astaty a on a.idstatu = u.idstatu
    where ((select max(platioddata) from nnastav) is null or (select max(platioddata) from nnastav) = platioddata);

  -- zmeny v ciselniku ceskych smerovych kodu
  if (stat = 'CZ_CZ') then
    -- zajimaji nas penezni ustav se stejnym kodem, jehoz platnost byla v obdobi 2011-2012
    select idsmerkod INTO userbankid FROM asmerkod akod where akod.kod = '2310' and akod.platiod < 2012 and akod.platido > 2010;
    if (userbankid is null) then
        INSERT INTO asmerkod (Kod, Nazev, PlatiOd, PlatiDo, LastUpdate, Show, Uuid)
        VALUES ('2310', 'ZUNO BANK AG, organizační složka', 2011, 9999, '2011-07-25', true, 'CZ_2310');
    else
        UPDATE asmerkod set uuid = 'CZ_2310' where idsmerkod = userbankid;
    end if;

    select idsmerkod INTO userbankid FROM asmerkod akod where akod.kod = '3030' and akod.platiod < 2012 and akod.platido > 2010;
    if (userbankid is null) then
        INSERT INTO asmerkod (Kod, Nazev, PlatiOd, PlatiDo, LastUpdate, Show, Uuid)
        VALUES ('3030', 'Air Bank a.s.', 2011, 9999, '2011-07-25', true, 'CZ_3030');
    else
        UPDATE asmerkod set uuid = 'CZ_3030' where idsmerkod = userbankid;
    end if;

    -- banco popolare se prejmenovala na Equa Bank
    update asmerkod akod set platido = 2010 where akod.uuid = 'CZ_6100';
    INSERT INTO asmerkod (Kod, Nazev, PlatiOd, PlatiDo, Popis, Poznam, LastUpdate, Show, Uuid)
    VALUES ('6100', 'Equa bank a.s.', 2011, 9999, (select ak.popis from asmerkod ak where ak.uuid = 'CZ_6100'),
    (select ak.poznam from asmerkod ak where ak.uuid = 'CZ_6100'), '2011-07-29', (select ak.show from asmerkod ak where ak.uuid = 'CZ_6100'), 'CZ_6100_2');
  -- konec ceskeho bloku
  end if;

  -- zmeny v ciselniku slovenskych smerovych kodu
  if (stat = 'SK_SK') then
    UPDATE asmerkod set nazev = 'Komerční banka, a.s., pobočka zahraničnej banky' where uuid = 'SK_8100' and nazev = '+Komerční banka, a.s., pobočka zahraničnej banky';
    UPDATE asmerkod set uuid = 'SK_8380' where uuid = 'CZ_8380';
    UPDATE asmerkod set uuid = 'SK_8410' where uuid = 'CZ_8410';

    select idsmerkod INTO userbankid FROM asmerkod akod where akod.kod = '8390' and akod.platiod < 2012 and akod.platido > 2010;
    if (userbankid is null) then
        INSERT INTO asmerkod (Kod, Nazev, PlatiOd, PlatiDo, LastUpdate, Show, Uuid)
        VALUES ('8390', 'AKCENTA, spořitelní a uvěrové družstvo, pobočka Košice', 2011, 9999, '2011-07-25', true, 'SK_8390');
    else
        UPDATE asmerkod set uuid = 'SK_8390' where idsmerkod = userbankid;
    end if;

    select idsmerkod INTO userbankid FROM asmerkod akod where akod.kod = '8420' and akod.platiod < 2012 and akod.platido > 2010;
    if (userbankid is null) then
        INSERT INTO asmerkod (Kod, Nazev, PlatiOd, PlatiDo, LastUpdate, Show, Uuid)
        VALUES ('8420', 'BKS Bank AG, pobočka zahraničnej banky v SR', 2011, 9999, '2011-07-25', true, 'SK_8420');
    else
        UPDATE asmerkod set uuid = 'SK_8420' where idsmerkod = userbankid;
    end if;
  -- konec slovenskeho bloku
  end if;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 509, 't', %appVersion%, clock_timestamp());