------------------------------------------------------------------------------------
-- Bug none - index pro vyhledavani podle cesty ve stromu
------------------------------------------------------------------------------------

-- varchar_pattern_ops umozni pouzit index pri vyhledavani podle prefixu: cesta like 'xxx%'
--
-- problem by mohl byt, ze varchar_pattern_ops nepouziva collation podle locale, ale jenom porovnava znaky
-- 
-- to ale v tomhle pripade nevadi, protoze sloupecek cesta obsahuje jenom hodnoty slozene z cisel a znaku '/'
-- (napr. '1/1/2') a podle stejnych hodnot se take vyhledava
--
-- viz tez dokumentaci k operator classes: http://www.postgresql.org/docs/8.3/static/indexes-opclass.html

CREATE INDEX wuzel_cesta_index ON wuzel USING btree (cesta varchar_pattern_ops);

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 520, 't', %appVersion%, clock_timestamp());
