--------------------------------------------------------------------------------
-- Bug 25495 – [WinStrom] V číselníku Státy rozdělit Srbsko a Černá Hora
--------------------------------------------------------------------------------

create or replace function runupgrade()
    returns void as $$
declare
  stat character varying(10);
begin
  select a.uuid into stat from nnastav n  left join utyporg u on u.idtyporg = n.idtyporg left join astaty a on a.idstatu = u.idstatu
    where ((select max(platioddata) from nnastav) is null or (select max(platioddata) from nnastav) = platioddata);

  -- cesky blok
  if (stat = 'CZ_CZ') then
    if ((select 1 from astaty where nazev = 'Černá Hora') is null) then 
        INSERT INTO astaty (Kod,Nazev,NazevA,NazevB,NazevC,Popis,Poznam,PlatiOd,PlatiDo,LastUpdate,Show,ClenEu,uuid)
          VALUES ('ME','Černá Hora','Montenegro','','','','',2006,9999,'2006-01-01',true,false,'CZ_ME');
    end if;

    if ((select 1 from astaty where nazev = 'Srbsko') is null) then 
        INSERT INTO astaty (Kod,Nazev,NazevA,NazevB,NazevC,Popis,Poznam,PlatiOd,PlatiDo,LastUpdate,Show,ClenEu,uuid)    
          VALUES ('RS','Srbsko','Serbia','','','','',2006,9999,'2006-01-01',true,false,'CZ_RS');
    end if;

    update astaty set platido=2006 where uuid = 'CZ_CS' and platido=9999;

  -- slovensky blok
  else
    if ((select 1 from astaty where nazev = 'Čierna Hora') is null) then
        INSERT INTO astaty (Kod,Nazev,NazevA,NazevB,NazevC,Popis,Poznam,PlatiOd,PlatiDo,LastUpdate,Show,ClenEu,uuid)
          VALUES ('ME','Čierna Hora','Montenegro','','','','',2006,9999,'2006-01-01',true,false,'SK_ME');
    end if;
  end if;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 532, 't', %appVersion%, clock_timestamp());
