--------------------------------------------------------------------------------
-- Bug 25949 – [winstrom] - ** Bankovní účty - nastavení banky.-obsah textu v příkazu
-- Bug 25969 – [winstrom] - **skladové karty - pohled - doplnit o poznámku a popis z ceníku
-- Bug 18035 – [Winstrom] - mzdy chybné počítání svátků - NUTNÉ
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Bug 25949 – [winstrom] - ** Bankovní účty - nastavení banky.-obsah textu v příkazu
--------------------------------------------------------------------------------


ALTER TABLE dbsp DROP COLUMN buckonverze;

ALTER TABLE dbsp ADD COLUMN prikpopklient boolean NOT NULL DEFAULT true;
ALTER TABLE dbsp ADD COLUMN prikpoppopis boolean NOT NULL DEFAULT true;


---------------------------------------------------------------------------------------
-- Bug 25969 – [winstrom] - **skladové karty - pohled - doplnit o poznámku a popis z ceníku
---------------------------------------------------------------------------------------

ALTER TABLE skarty
  ADD COLUMN cenpopis text,
  ADD COLUMN cenpopisa text,
  ADD COLUMN cenpopisb text,
  ADD COLUMN cenpopisc text,
  ADD COLUMN cenpoznam text;


UPDATE skarty AS k
SET cenpopis = c.popis, cenpopisa = c.popisa, cenpopisb = c.popisb, cenpopisc = c.popisc,
    cenpoznam = c.poznam
FROM ccenik AS c
WHERE k.idcenik = c.idcenik AND
  ( NOT ((k.cenpopis IS NULL AND c.popis IS NULL) OR (k.cenpopis IS NOT NULL AND c.popis IS NOT NULL AND k.cenpopis = c.popis)) OR
    NOT ((k.cenpopisa IS NULL AND c.popisa IS NULL) OR (k.cenpopisa IS NOT NULL AND c.popisa IS NOT NULL AND k.cenpopisa = c.popisa)) OR
    NOT ((k.cenpopisb IS NULL AND c.popisb IS NULL) OR (k.cenpopisb IS NOT NULL AND c.popisb IS NOT NULL AND k.cenpopisb = c.popisb)) OR
    NOT ((k.cenpopisc IS NULL AND c.popisc IS NULL) OR (k.cenpopisc IS NOT NULL AND c.popisc IS NOT NULL AND k.cenpopisc = c.popisc)) OR
    NOT ((k.cenpoznam IS NULL AND c.poznam IS NULL) OR (k.cenpoznam IS NOT NULL AND c.poznam IS NOT NULL AND k.cenpoznam = c.poznam)) );


CREATE OR REPLACE FUNCTION ccenikupdateskarta()
  RETURNS trigger AS $$
begin
  IF ( not compareVarchar(NEW.nazev, OLD.nazev) OR
       not compareVarchar(NEW.nazeva, OLD.nazeva) OR
       not compareVarchar(NEW.nazevb, OLD.nazevb) OR
       not compareVarchar(NEW.nazevc, OLD.nazevc) OR
       not compareVarchar(NEW.popis,  OLD.popis) OR
       not compareVarchar(NEW.popisa, OLD.popisa) OR
       not compareVarchar(NEW.popisb, OLD.popisb) OR
       not compareVarchar(NEW.popisc, OLD.popisc) OR
       not compareVarchar(NEW.poznam, OLD.poznam) ) THEN 
    UPDATE skarty
    SET nazev = NEW.nazev, nazeva = NEW.nazeva,
        nazevb = NEW.nazevb, nazevc = NEW.nazevc,
        cenpopis = NEW.popis, cenpopisa = NEW.popisa, 
        cenpopisb = NEW.popisb, cenpopisc = NEW.popisc,
        cenpoznam = NEW.poznam,
        lastUpdate = LOCALTIMESTAMP
    WHERE idcenik = NEW.idcenik;
  END IF; 
  
  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.ccenikupdateskarta() OWNER TO %firmaRole%;

---------------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION skartyinsertzceniku()
  RETURNS trigger AS $$
declare  
  _nazev character varying; 
  _nazeva character varying; 
  _nazevb character varying; 
  _nazevc character varying; 
  _popis character varying; 
  _popisa character varying; 
  _popisb character varying; 
  _popisc character varying; 
  _poznam character varying; 
begin
  IF ( NEW.idcenik IS NOT NULL ) THEN
    SELECT nazev, nazeva, nazevb, nazevc, popis, popisa, popisb, popisc, poznam
     INTO _nazev, _nazeva, _nazevb, _nazevc, _popis, _popisa, _popisb, _popisc, _poznam
    FROM ccenik
    WHERE idcenik = NEW.idcenik;
    
    NEW.nazev = _nazev;
    NEW.nazeva = _nazeva;
    NEW.nazevb = _nazevb;
    NEW.nazevc = _nazevc;
    NEW.cenpopis = _popis;
    NEW.cenpopisa = _popisa;
    NEW.cenpopisb = _popisb;
    NEW.cenpopisc = _popisc;
    NEW.cenpoznam = _poznam;
  END IF;
  
  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.skartyinsertzceniku() OWNER TO %firmaRole%;


--------------------------------------------------------------------------------
-- Bug 18035 – [Winstrom] - mzdy chybné počítání svátků - NUTNÉ
--------------------------------------------------------------------------------

create or replace function runupgrade()
    returns void as $$
declare
    stat character varying(10);
    pocet integer;
begin
  select a.uuid into stat from nnastav n  left join utyporg u on u.idtyporg = n.idtyporg left join astaty a on a.idstatu = u.idstatu
    where ((select max(platioddata) from nnastav) is null or (select max(platioddata) from nnastav) = platioddata);
  
  -- kalkulacku aktualizujeme jen pro cechy
  if (stat = 'CZ_CZ') then
-- zacatek ceskeho bloku
-- update slozek
-- update hlavicky kalkulacky
-- update inicializacnich radek kalkulacky

-- update radek kalkulacky
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 60 WHERE idmzdcalc = 1056;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 61 WHERE idmzdcalc = 1057;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 63 WHERE idmzdcalc = 1058;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 64 WHERE idmzdcalc = 1059;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 65 WHERE idmzdcalc = 1060;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 66 WHERE idmzdcalc = 1061;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 67 WHERE idmzdcalc = 1062;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', nazev = '----- vrácení pole ODPRACOVÁNO VÝPOČET  do původního stavu', cisrad = 68 WHERE idmzdcalc = 1063;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 70 WHERE idmzdcalc = 1064;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 71 WHERE idmzdcalc = 1065;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 72 WHERE idmzdcalc = 1066;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 73 WHERE idmzdcalc = 1067;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 74 WHERE idmzdcalc = 1068;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 75 WHERE idmzdcalc = 1069;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 76 WHERE idmzdcalc = 1070;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 77 WHERE idmzdcalc = 1071;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 78 WHERE idmzdcalc = 1072;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 79 WHERE idmzdcalc = 1073;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 80 WHERE idmzdcalc = 1074;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 81 WHERE idmzdcalc = 1075;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 82 WHERE idmzdcalc = 1076;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 83 WHERE idmzdcalc = 1077;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 84 WHERE idmzdcalc = 1078;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 85 WHERE idmzdcalc = 1079;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 86 WHERE idmzdcalc = 1080;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 87 WHERE idmzdcalc = 1081;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 88 WHERE idmzdcalc = 1082;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 89 WHERE idmzdcalc = 1083;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 90 WHERE idmzdcalc = 1084;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 91 WHERE idmzdcalc = 1085;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 92 WHERE idmzdcalc = 1086;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 93 WHERE idmzdcalc = 1087;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 94 WHERE idmzdcalc = 1088;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 95 WHERE idmzdcalc = 1089;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 96 WHERE idmzdcalc = 1090;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 97 WHERE idmzdcalc = 1091;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 98 WHERE idmzdcalc = 1092;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 99 WHERE idmzdcalc = 1093;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 100 WHERE idmzdcalc = 1094;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 101 WHERE idmzdcalc = 1095;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 102 WHERE idmzdcalc = 1096;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 103 WHERE idmzdcalc = 1097;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 104 WHERE idmzdcalc = 1098;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 105 WHERE idmzdcalc = 1099;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 106 WHERE idmzdcalc = 1100;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 107 WHERE idmzdcalc = 1101;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 108 WHERE idmzdcalc = 1102;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 109 WHERE idmzdcalc = 1103;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 110 WHERE idmzdcalc = 1104;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 111 WHERE idmzdcalc = 1105;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 112 WHERE idmzdcalc = 1106;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 113 WHERE idmzdcalc = 1107;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 114 WHERE idmzdcalc = 1108;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 115 WHERE idmzdcalc = 1109;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 116 WHERE idmzdcalc = 1110;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 117 WHERE idmzdcalc = 1111;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 118 WHERE idmzdcalc = 1112;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 119 WHERE idmzdcalc = 1113;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 120 WHERE idmzdcalc = 1114;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 121 WHERE idmzdcalc = 1115;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 122 WHERE idmzdcalc = 1116;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 159 WHERE idmzdcalc = 1117;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 123 WHERE idmzdcalc = 1118;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 124 WHERE idmzdcalc = 1119;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 125 WHERE idmzdcalc = 1120;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 126 WHERE idmzdcalc = 1121;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 127 WHERE idmzdcalc = 1122;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 128 WHERE idmzdcalc = 1123;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 129 WHERE idmzdcalc = 1124;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 130 WHERE idmzdcalc = 1125;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 131 WHERE idmzdcalc = 1126;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 132 WHERE idmzdcalc = 1127;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 133 WHERE idmzdcalc = 1128;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 134 WHERE idmzdcalc = 1129;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 135 WHERE idmzdcalc = 1130;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 136 WHERE idmzdcalc = 1131;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 137 WHERE idmzdcalc = 1132;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 138 WHERE idmzdcalc = 1133;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 139 WHERE idmzdcalc = 1134;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 140 WHERE idmzdcalc = 1135;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 141 WHERE idmzdcalc = 1136;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 142 WHERE idmzdcalc = 1137;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 143 WHERE idmzdcalc = 1138;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 144 WHERE idmzdcalc = 1139;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 145 WHERE idmzdcalc = 1140;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 146 WHERE idmzdcalc = 1141;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 147 WHERE idmzdcalc = 1142;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 148 WHERE idmzdcalc = 1143;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 149 WHERE idmzdcalc = 1144;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 150 WHERE idmzdcalc = 1145;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 151 WHERE idmzdcalc = 1146;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 152 WHERE idmzdcalc = 1147;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 153 WHERE idmzdcalc = 1148;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 154 WHERE idmzdcalc = 1149;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 155 WHERE idmzdcalc = 1150;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 156 WHERE idmzdcalc = 1151;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 157 WHERE idmzdcalc = 1152;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 158 WHERE idmzdcalc = 1153;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 160 WHERE idmzdcalc = 1154;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 161 WHERE idmzdcalc = 1155;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 162 WHERE idmzdcalc = 1156;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 163 WHERE idmzdcalc = 1157;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 164 WHERE idmzdcalc = 1158;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 165 WHERE idmzdcalc = 1159;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 166 WHERE idmzdcalc = 1160;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 167 WHERE idmzdcalc = 1161;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 168 WHERE idmzdcalc = 1162;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 169 WHERE idmzdcalc = 1163;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 170 WHERE idmzdcalc = 1164;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 171 WHERE idmzdcalc = 1165;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 172 WHERE idmzdcalc = 1166;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 173 WHERE idmzdcalc = 1167;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 174 WHERE idmzdcalc = 1168;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 175 WHERE idmzdcalc = 1169;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 176 WHERE idmzdcalc = 1170;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 177 WHERE idmzdcalc = 1171;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 178 WHERE idmzdcalc = 1172;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 179 WHERE idmzdcalc = 1173;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 180 WHERE idmzdcalc = 1174;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 181 WHERE idmzdcalc = 1175;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 182 WHERE idmzdcalc = 1176;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 183 WHERE idmzdcalc = 1177;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 184 WHERE idmzdcalc = 1178;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 185 WHERE idmzdcalc = 1179;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 186 WHERE idmzdcalc = 1180;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 187 WHERE idmzdcalc = 1181;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 188 WHERE idmzdcalc = 1182;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 189 WHERE idmzdcalc = 1183;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 190 WHERE idmzdcalc = 1184;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 191 WHERE idmzdcalc = 1185;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 192 WHERE idmzdcalc = 1186;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 193 WHERE idmzdcalc = 1187;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 194 WHERE idmzdcalc = 1188;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 195 WHERE idmzdcalc = 1189;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 196 WHERE idmzdcalc = 1190;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 199 WHERE idmzdcalc = 1191;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 200 WHERE idmzdcalc = 1192;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 201 WHERE idmzdcalc = 1193;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 202 WHERE idmzdcalc = 1194;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 203 WHERE idmzdcalc = 1195;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 204 WHERE idmzdcalc = 1196;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 205 WHERE idmzdcalc = 1197;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 206 WHERE idmzdcalc = 1198;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 207 WHERE idmzdcalc = 1199;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 208 WHERE idmzdcalc = 1200;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 209 WHERE idmzdcalc = 1201;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 210 WHERE idmzdcalc = 1202;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 211 WHERE idmzdcalc = 1203;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 212 WHERE idmzdcalc = 1204;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 213 WHERE idmzdcalc = 1205;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 214 WHERE idmzdcalc = 1206;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 215 WHERE idmzdcalc = 1207;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 216 WHERE idmzdcalc = 1208;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 217 WHERE idmzdcalc = 1209;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 218 WHERE idmzdcalc = 1210;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 219 WHERE idmzdcalc = 1211;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 220 WHERE idmzdcalc = 1212;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 221 WHERE idmzdcalc = 1213;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 222 WHERE idmzdcalc = 1214;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 223 WHERE idmzdcalc = 1215;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 224 WHERE idmzdcalc = 1216;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 225 WHERE idmzdcalc = 1217;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 226 WHERE idmzdcalc = 1218;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 227 WHERE idmzdcalc = 1219;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 228 WHERE idmzdcalc = 1220;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 229 WHERE idmzdcalc = 1221;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 230 WHERE idmzdcalc = 1222;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 231 WHERE idmzdcalc = 1223;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 232 WHERE idmzdcalc = 1224;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 233 WHERE idmzdcalc = 1225;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 234 WHERE idmzdcalc = 1226;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 235 WHERE idmzdcalc = 1227;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 236 WHERE idmzdcalc = 1228;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 237 WHERE idmzdcalc = 1229;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 238 WHERE idmzdcalc = 1230;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 239 WHERE idmzdcalc = 1231;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 240 WHERE idmzdcalc = 1232;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 241 WHERE idmzdcalc = 1233;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 242 WHERE idmzdcalc = 1234;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 243 WHERE idmzdcalc = 1235;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 244 WHERE idmzdcalc = 1236;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 245 WHERE idmzdcalc = 1237;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 246 WHERE idmzdcalc = 1238;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 247 WHERE idmzdcalc = 1239;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 248 WHERE idmzdcalc = 1240;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 249 WHERE idmzdcalc = 1241;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 250 WHERE idmzdcalc = 1242;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 251 WHERE idmzdcalc = 1243;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 252 WHERE idmzdcalc = 1244;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 253 WHERE idmzdcalc = 1245;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 254 WHERE idmzdcalc = 1246;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 255 WHERE idmzdcalc = 1247;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 256 WHERE idmzdcalc = 1248;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 257 WHERE idmzdcalc = 1249;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 258 WHERE idmzdcalc = 1250;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 259 WHERE idmzdcalc = 1251;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 260 WHERE idmzdcalc = 1252;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 261 WHERE idmzdcalc = 1253;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 262 WHERE idmzdcalc = 1254;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 263 WHERE idmzdcalc = 1255;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 264 WHERE idmzdcalc = 1256;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 265 WHERE idmzdcalc = 1257;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 266 WHERE idmzdcalc = 1258;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 267 WHERE idmzdcalc = 1259;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 268 WHERE idmzdcalc = 1260;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 269 WHERE idmzdcalc = 1261;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 270 WHERE idmzdcalc = 1262;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 271 WHERE idmzdcalc = 1263;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 273 WHERE idmzdcalc = 1264;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 274 WHERE idmzdcalc = 1265;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 275 WHERE idmzdcalc = 1266;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 276 WHERE idmzdcalc = 1267;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 277 WHERE idmzdcalc = 1268;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 278 WHERE idmzdcalc = 1269;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 279 WHERE idmzdcalc = 1270;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 280 WHERE idmzdcalc = 1271;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 281 WHERE idmzdcalc = 1272;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 282 WHERE idmzdcalc = 1273;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 283 WHERE idmzdcalc = 1274;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 284 WHERE idmzdcalc = 1275;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 285 WHERE idmzdcalc = 1276;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 286 WHERE idmzdcalc = 1277;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 287 WHERE idmzdcalc = 1278;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 292 WHERE idmzdcalc = 1279;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 293 WHERE idmzdcalc = 1280;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 294 WHERE idmzdcalc = 1281;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 295 WHERE idmzdcalc = 1282;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 296 WHERE idmzdcalc = 1283;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 288 WHERE idmzdcalc = 1284;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 297 WHERE idmzdcalc = 1285;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 298 WHERE idmzdcalc = 1286;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 299 WHERE idmzdcalc = 1287;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 300 WHERE idmzdcalc = 1288;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 301 WHERE idmzdcalc = 1289;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 302 WHERE idmzdcalc = 1290;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 303 WHERE idmzdcalc = 1291;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 304 WHERE idmzdcalc = 1292;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 305 WHERE idmzdcalc = 1293;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 306 WHERE idmzdcalc = 1294;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 307 WHERE idmzdcalc = 1295;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 308 WHERE idmzdcalc = 1296;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 309 WHERE idmzdcalc = 1297;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 310 WHERE idmzdcalc = 1298;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 311 WHERE idmzdcalc = 1299;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 312 WHERE idmzdcalc = 1300;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 313 WHERE idmzdcalc = 1301;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 314 WHERE idmzdcalc = 1302;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 315 WHERE idmzdcalc = 1303;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 316 WHERE idmzdcalc = 1304;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 317 WHERE idmzdcalc = 1305;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 318 WHERE idmzdcalc = 1306;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 319 WHERE idmzdcalc = 1307;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 320 WHERE idmzdcalc = 1308;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 321 WHERE idmzdcalc = 1309;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 322 WHERE idmzdcalc = 1310;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 323 WHERE idmzdcalc = 1311;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 324 WHERE idmzdcalc = 1312;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 325 WHERE idmzdcalc = 1313;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 326 WHERE idmzdcalc = 1314;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 327 WHERE idmzdcalc = 1315;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 328 WHERE idmzdcalc = 1316;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 329 WHERE idmzdcalc = 1317;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 330 WHERE idmzdcalc = 1318;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 331 WHERE idmzdcalc = 1319;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 332 WHERE idmzdcalc = 1320;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 333 WHERE idmzdcalc = 1321;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 334 WHERE idmzdcalc = 1322;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 335 WHERE idmzdcalc = 1323;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 336 WHERE idmzdcalc = 1324;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 337 WHERE idmzdcalc = 1325;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 338 WHERE idmzdcalc = 1326;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 339 WHERE idmzdcalc = 1327;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 340 WHERE idmzdcalc = 1328;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 341 WHERE idmzdcalc = 1329;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 342 WHERE idmzdcalc = 1330;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 343 WHERE idmzdcalc = 1331;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 344 WHERE idmzdcalc = 1332;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 345 WHERE idmzdcalc = 1333;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 346 WHERE idmzdcalc = 1334;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 347 WHERE idmzdcalc = 1335;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 348 WHERE idmzdcalc = 1336;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 349 WHERE idmzdcalc = 1337;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 350 WHERE idmzdcalc = 1338;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 351 WHERE idmzdcalc = 1339;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 352 WHERE idmzdcalc = 1340;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 353 WHERE idmzdcalc = 1341;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 354 WHERE idmzdcalc = 1342;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 355 WHERE idmzdcalc = 1343;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 356 WHERE idmzdcalc = 1344;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 357 WHERE idmzdcalc = 1345;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 358 WHERE idmzdcalc = 1346;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 359 WHERE idmzdcalc = 1347;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 360 WHERE idmzdcalc = 1348;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 361 WHERE idmzdcalc = 1349;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 362 WHERE idmzdcalc = 1350;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 363 WHERE idmzdcalc = 1351;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 364 WHERE idmzdcalc = 1352;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 365 WHERE idmzdcalc = 1353;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 366 WHERE idmzdcalc = 1354;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 367 WHERE idmzdcalc = 1355;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 368 WHERE idmzdcalc = 1356;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 369 WHERE idmzdcalc = 1357;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 370 WHERE idmzdcalc = 1358;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 371 WHERE idmzdcalc = 1359;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 372 WHERE idmzdcalc = 1360;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 373 WHERE idmzdcalc = 1361;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 374 WHERE idmzdcalc = 1362;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 375 WHERE idmzdcalc = 1363;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 376 WHERE idmzdcalc = 1364;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 377 WHERE idmzdcalc = 1365;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 378 WHERE idmzdcalc = 1366;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 379 WHERE idmzdcalc = 1367;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 380 WHERE idmzdcalc = 1368;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 381 WHERE idmzdcalc = 1369;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 382 WHERE idmzdcalc = 1370;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 383 WHERE idmzdcalc = 1371;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 384 WHERE idmzdcalc = 1372;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 385 WHERE idmzdcalc = 1373;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 386 WHERE idmzdcalc = 1374;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 387 WHERE idmzdcalc = 1375;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 388 WHERE idmzdcalc = 1376;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 389 WHERE idmzdcalc = 1377;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 390 WHERE idmzdcalc = 1378;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 391 WHERE idmzdcalc = 1379;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 392 WHERE idmzdcalc = 1380;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 393 WHERE idmzdcalc = 1381;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 394 WHERE idmzdcalc = 1382;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 395 WHERE idmzdcalc = 1383;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 396 WHERE idmzdcalc = 1384;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 397 WHERE idmzdcalc = 1385;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 398 WHERE idmzdcalc = 1386;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 399 WHERE idmzdcalc = 1387;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 400 WHERE idmzdcalc = 1388;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 407 WHERE idmzdcalc = 1391;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 408 WHERE idmzdcalc = 1392;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 410 WHERE idmzdcalc = 1393;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 411 WHERE idmzdcalc = 1394;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 412 WHERE idmzdcalc = 1395;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 413 WHERE idmzdcalc = 1396;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 414 WHERE idmzdcalc = 1397;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 415 WHERE idmzdcalc = 1398;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 416 WHERE idmzdcalc = 1399;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 417 WHERE idmzdcalc = 1400;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 418 WHERE idmzdcalc = 1401;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 419 WHERE idmzdcalc = 1402;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 420 WHERE idmzdcalc = 1403;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 421 WHERE idmzdcalc = 1404;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 422 WHERE idmzdcalc = 1405;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 423 WHERE idmzdcalc = 1406;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 424 WHERE idmzdcalc = 1407;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 425 WHERE idmzdcalc = 1408;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 426 WHERE idmzdcalc = 1409;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 427 WHERE idmzdcalc = 1410;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 428 WHERE idmzdcalc = 1411;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 429 WHERE idmzdcalc = 1412;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 431 WHERE idmzdcalc = 1413;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 432 WHERE idmzdcalc = 1414;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 433 WHERE idmzdcalc = 1415;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 434 WHERE idmzdcalc = 1416;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 435 WHERE idmzdcalc = 1417;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 436 WHERE idmzdcalc = 1418;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 437 WHERE idmzdcalc = 1419;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 438 WHERE idmzdcalc = 1420;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 439 WHERE idmzdcalc = 1421;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 440 WHERE idmzdcalc = 1422;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 441 WHERE idmzdcalc = 1423;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 442 WHERE idmzdcalc = 1424;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 443 WHERE idmzdcalc = 1425;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 444 WHERE idmzdcalc = 1426;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 445 WHERE idmzdcalc = 1427;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 446 WHERE idmzdcalc = 1428;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 447 WHERE idmzdcalc = 1429;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 448 WHERE idmzdcalc = 1430;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 449 WHERE idmzdcalc = 1431;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 450 WHERE idmzdcalc = 1432;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 451 WHERE idmzdcalc = 1433;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 452 WHERE idmzdcalc = 1434;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 453 WHERE idmzdcalc = 1436;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 454 WHERE idmzdcalc = 1437;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 455 WHERE idmzdcalc = 1438;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 456 WHERE idmzdcalc = 1439;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 457 WHERE idmzdcalc = 1440;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 458 WHERE idmzdcalc = 1441;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 459 WHERE idmzdcalc = 1442;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 460 WHERE idmzdcalc = 1443;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 461 WHERE idmzdcalc = 1444;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 462 WHERE idmzdcalc = 1445;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 463 WHERE idmzdcalc = 1446;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 464 WHERE idmzdcalc = 1447;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 465 WHERE idmzdcalc = 1448;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 466 WHERE idmzdcalc = 1449;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 467 WHERE idmzdcalc = 1450;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 468 WHERE idmzdcalc = 1451;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 469 WHERE idmzdcalc = 1452;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 470 WHERE idmzdcalc = 1453;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 471 WHERE idmzdcalc = 1454;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 472 WHERE idmzdcalc = 1455;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 473 WHERE idmzdcalc = 1456;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 474 WHERE idmzdcalc = 1457;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 475 WHERE idmzdcalc = 1458;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 476 WHERE idmzdcalc = 1459;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 477 WHERE idmzdcalc = 1460;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 478 WHERE idmzdcalc = 1461;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 479 WHERE idmzdcalc = 1462;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 480 WHERE idmzdcalc = 1463;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 481 WHERE idmzdcalc = 1464;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 482 WHERE idmzdcalc = 1465;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 483 WHERE idmzdcalc = 1466;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 484 WHERE idmzdcalc = 1467;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 485 WHERE idmzdcalc = 1468;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 486 WHERE idmzdcalc = 1469;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 487 WHERE idmzdcalc = 1470;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 488 WHERE idmzdcalc = 1471;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 489 WHERE idmzdcalc = 1472;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 490 WHERE idmzdcalc = 1473;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 491 WHERE idmzdcalc = 1474;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 492 WHERE idmzdcalc = 1475;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 493 WHERE idmzdcalc = 1476;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 494 WHERE idmzdcalc = 1477;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 495 WHERE idmzdcalc = 1478;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 496 WHERE idmzdcalc = 1479;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 497 WHERE idmzdcalc = 1480;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 498 WHERE idmzdcalc = 1481;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 499 WHERE idmzdcalc = 1482;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 500 WHERE idmzdcalc = 1483;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 501 WHERE idmzdcalc = 1484;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 502 WHERE idmzdcalc = 1485;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 503 WHERE idmzdcalc = 1486;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 504 WHERE idmzdcalc = 1487;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 505 WHERE idmzdcalc = 1488;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 506 WHERE idmzdcalc = 1489;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 507 WHERE idmzdcalc = 1490;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 508 WHERE idmzdcalc = 1491;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 509 WHERE idmzdcalc = 1492;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 510 WHERE idmzdcalc = 1493;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 511 WHERE idmzdcalc = 1494;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 512 WHERE idmzdcalc = 1495;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 513 WHERE idmzdcalc = 1496;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 514 WHERE idmzdcalc = 1497;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 515 WHERE idmzdcalc = 1498;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 516 WHERE idmzdcalc = 1499;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 517 WHERE idmzdcalc = 1500;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 518 WHERE idmzdcalc = 1501;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 519 WHERE idmzdcalc = 1502;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 520 WHERE idmzdcalc = 1503;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 521 WHERE idmzdcalc = 1504;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 522 WHERE idmzdcalc = 1505;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 523 WHERE idmzdcalc = 1506;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 524 WHERE idmzdcalc = 1507;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 525 WHERE idmzdcalc = 1508;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 526 WHERE idmzdcalc = 1509;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 527 WHERE idmzdcalc = 1510;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 528 WHERE idmzdcalc = 1511;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 529 WHERE idmzdcalc = 1512;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 530 WHERE idmzdcalc = 1513;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 531 WHERE idmzdcalc = 1514;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 532 WHERE idmzdcalc = 1515;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 533 WHERE idmzdcalc = 1516;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 534 WHERE idmzdcalc = 1517;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 535 WHERE idmzdcalc = 1518;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 536 WHERE idmzdcalc = 1519;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 537 WHERE idmzdcalc = 1520;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 538 WHERE idmzdcalc = 1521;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 539 WHERE idmzdcalc = 1522;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 540 WHERE idmzdcalc = 1523;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 541 WHERE idmzdcalc = 1524;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 542 WHERE idmzdcalc = 1525;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 543 WHERE idmzdcalc = 1526;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 544 WHERE idmzdcalc = 1527;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 545 WHERE idmzdcalc = 1528;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 546 WHERE idmzdcalc = 1529;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 547 WHERE idmzdcalc = 1530;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 548 WHERE idmzdcalc = 1531;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 549 WHERE idmzdcalc = 1532;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 550 WHERE idmzdcalc = 1533;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 551 WHERE idmzdcalc = 1534;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 552 WHERE idmzdcalc = 1535;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 553 WHERE idmzdcalc = 1536;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 554 WHERE idmzdcalc = 1537;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 555 WHERE idmzdcalc = 1538;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 556 WHERE idmzdcalc = 1539;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 557 WHERE idmzdcalc = 1540;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 558 WHERE idmzdcalc = 1541;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 559 WHERE idmzdcalc = 1542;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 560 WHERE idmzdcalc = 1543;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 561 WHERE idmzdcalc = 1544;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 562 WHERE idmzdcalc = 1545;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 563 WHERE idmzdcalc = 1546;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 564 WHERE idmzdcalc = 1547;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 565 WHERE idmzdcalc = 1548;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 430 WHERE idmzdcalc = 1549;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 272 WHERE idmzdcalc = 1550;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 401 WHERE idmzdcalc = 1551;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 409 WHERE idmzdcalc = 1552;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 402 WHERE idmzdcalc = 1553;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 403 WHERE idmzdcalc = 1554;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 404 WHERE idmzdcalc = 1555;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 405 WHERE idmzdcalc = 1556;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 406 WHERE idmzdcalc = 1557;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 289 WHERE idmzdcalc = 1562;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 290 WHERE idmzdcalc = 1563;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 291 WHERE idmzdcalc = 1564;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 197 WHERE idmzdcalc = 1565;
UPDATE pmzdcalc SET lastupdate = '2011-10-06 00:00:00.000', cisrad = 198 WHERE idmzdcalc = 1566;
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (1567, '2011-10-08 00:00:00.000', 'SVÁTEK V NEMOCI', '----- nulování hodin svátek', true, 59, 1.0, 0.0, 0.0, 'procMzd', 'hodinySvatek', 'procMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 2, 256, 343, 343);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (1568, '2011-10-08 00:00:00.000', '2', 'svátek sumovaná z nemoci', 'přidáno 6.10.2011', true, 62, -1.0, 1.0, 0.0, 'procMzd', '', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 2, 343, 179);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (1569, '2011-10-06 00:00:00.000', '2', '----- vrácení pole ODPRACOVÁNO VÝPOČET  do původního stavu', 'přidáno 6.10.2011', true, 69, 1.0, 1.0, 0.0, 'procMzd', '', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 2, 3, 179);

PERFORM pg_catalog.setval('seq_pmzdcalc', 1569, true);

-- pracovni pomery
-- parametry pro typ prac pom

-- konec ceskeho bloku
  end if; 
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 534, 't', %appVersion%, clock_timestamp());
