--------------------------------------------------------------------------------
-- Bug 22323 – [winstrom] 8 - Mzdy - Náklady členit podle zakázek, zjemnění na více středisek
--------------------------------------------------------------------------------

CREATE SEQUENCE seq_ppracestred
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_ppracestred OWNER TO %firmaRole%;

CREATE TABLE ppracestred
(
  idpracestred integer DEFAULT nextval('seq_ppracestred'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  datumdo date,
  datumod date,
  hodin integer,
  mesic smallint DEFAULT 0,
  poznam text,
  procento numeric(6,2) DEFAULT 0.0,
  rok integer,
  idcinnost integer,
  idosoba integer NOT NULL,
  idpracpom integer NOT NULL,
  idstredisko integer,
  idzakazka integer,
  CONSTRAINT ppracestred_pkey PRIMARY KEY (idpracestred),
  CONSTRAINT ppracestred_idpracpom FOREIGN KEY (idpracpom)
      REFERENCES ppracpomhlav (idpracpomhlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT ppracestred_idosoba FOREIGN KEY (idosoba)
      REFERENCES posobahlav (idosobahlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT ppracestred_idcinnost FOREIGN KEY (idcinnost)
      REFERENCES ucinnost (idcinnost) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT ppracestred_idstredisko FOREIGN KEY (idstredisko)
      REFERENCES ustrediska (idstred) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT ppracestred_idzakazka FOREIGN KEY (idzakazka)
      REFERENCES uzakazky (idzakazky) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE ppracestred OWNER TO %firmaRole%;

CREATE INDEX pPraceStred_IdOsoba_index ON pPraceStred USING btree (IdOsoba);
CREATE INDEX pPraceStred_IdPracPom_index ON pPraceStred USING btree (IdPracPom);
CREATE INDEX pPraceStred_IdStredisko_index ON pPraceStred USING btree (IdStredisko);
CREATE INDEX pPraceStred_IdZakazka_index ON pPraceStred USING btree (IdZakazka);
CREATE INDEX pPraceStred_IdCinnost_index ON pPraceStred USING btree (IdCinnost);

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 550, 't', %appVersion%, clock_timestamp());
