--------------------------------------------------------------------------------
-- Bug 25209 – [WinStrom] Doplnit v.s. do skladového dokladu
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION createdoklsklad(_idpoldokl integer, _iddoklad integer, _modul character varying)
  RETURNS integer AS
$BODY$
declare
  _doklad record;
  _polDokl record;
  _doklSklad record;
  _idDoklSklad integer;
  _cisDoklad character varying;
  _idrada integer;
  _rada record;
  _sklad record;
  _idUcetObd integer;
  _radaRok record;
  _typPohybuSklad character varying;
  _idTypUcOp integer;
  _cisloDokladuCursor refCursor;
  _typDoklFak record;
  _typDoklSkl record;
  _idUcetSklad integer;
  _idProtiUcet integer;
  _typUcOp record;
  _kurz numeric(19,6);
  _idMenyTuzemsko integer;
  _idMenySklad integer;
  _kurzMnozstvi numeric(19,6);
  _typVazby character varying;
  _stavSklad character varying;
  _typPohybuSkladK character varying;
  _isDobropis boolean;
  _datSklad date; 
  _ucetObdPlatiOd date;
  _ucetObdPlatiDo date;
begin
  if(_modul like 'POK') then
    select * into _doklad from dDoklInt where idDoklInt = _idDoklad;
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;
    _stavSklad = 'stavSklad.vygenPokl';
  elsif (_modul like 'FAV' or _modul like 'FAP') then
    select * into _doklad from dDoklFak where idDoklFak = _idDoklad;
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;
    _stavSklad = 'stavSklad.vygenFakt';
  else
    select * into _doklad from dDoklSklad where idDoklSklad = _idDoklad;
    select * into _polDokl from dPolSklad where idPolSklad = _idPolDokl;
    _stavSklad = 'stavSklad.vyroba';
  end if;

  --select * into _sklad from dTypDokl where idTypDokl = _polDokl.idskladu;
  select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl;
  select * into _typDoklFak from dTypDokl where idTypDokl = _doklad.idTypDokl;

  if(_typDoklFak.typDoklK like 'typDokladu.dobropis') then
    _isDobropis = true;
  else
    _isDobropis = false;
  end if;
 
  if(_doklad.idTypDoklSkl is null) then 
    if((_modul like 'FAV' and _isDobropis) or (_modul like 'FAP')) then
      --pro dobropisy vydanych faktur a prijate faktury budeme mit prijemku
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuprijem;
    elsif((_modul like 'FAV' and not _isDobropis)) then
      --pro dobropisy prijatych faktur a vydane faktury budeme mit vydejku
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuvydej;
    elsif(_modul like 'POK' and _doklad.typPohybuK like 'typPohybu.prijem') then
      --pro prijmovy pokladni doklad budeme mit vydejku
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuvydej;
    elsif(_modul like 'POK' and _doklad.typPohybuK like 'typPohybu.vydej') then
      --pro vydajovy pokladni doklad budeme mit prijemku
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuprijem;
    elsif(_modul like 'SKL') then
      -- vyroba
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuvydej;
    else
      raise exception 'createdoklsklad:Nespravny modul %', _modul;
    end if;
    if(_typDoklSkl is null) then
      return null;
    end if;
  else
    select * into _typDoklSkl from dTypDokl where idTypDokl = _doklad.idTypDoklSkl;
  end if;

  -- urceni spravneho typu pohybu
  if((_typDoklFak.modul like 'FAV') and (_typDoklFak.typDoklK like 'typDokladu.dobropis')) then
    _typPohybuSklad = _doklad.typPohybuK;
  else
    if(_doklad.typPohybuK like 'typPohybu.prijem') then
      _typPohybuSklad = 'typPohybu.vydej';
    else
      _typPohybuSklad = 'typPohybu.prijem';
    end if;
  end if;

  -- doplneni zbyvajicich veci zavislich na typu pohybu
  if(_typPohybuSklad like 'typPohybu.prijem') then
    _idrada = _typDoklSkl.idRadyPrijem;
    if(_idrada is null) then
      _idRada = _sklad.idRadyPrijem;
    end if;
    if(_idRada is null) then
      raise exception 'Neni odkud natahnout dokladovou radu.';
    end if;
    _idTypUcOp = _typDoklSkl.idTypUcOpP;
    if(_modul = 'FAV' or _modul = 'FAP' or _modul = 'POK') then
      _typPohybuSkladK = 'typPohybuSklad.prijemPoFak';
    else
      _typPohybuSkladK = 'typPohybuSklad.prijemVyrob';
    end if;
  else
    _idrada = _typDoklSkl.idRadyVydej;
    if(_idrada is null) then
      _idRada = _sklad.idRadyVydej;
    end if;
    if(_idRada is null) then
      raise exception 'Neni odkud natahnout dokladovou radu.';
    end if;
    _idTypUcOp = _typDoklSkl.idTypUcOpV;
    if(_modul = 'FAV' or _modul = 'FAP' or _modul = 'POK') then
      _typPohybuSkladK = 'typPohybuSklad.vydejPoFak';
    else
      _typPohybuSkladK = 'typPohybuSklad.vydejVyrob';
    end if;
  end if;

  _idUcetSklad = _sklad.idPrimUcet;
  select * into _typUcOp from utypucop where idtypucop = _idTypUcOp;
  if(_typPohybuSklad like 'typPohybu.prijem') then
    _idProtiUcet = _typUcOp.idProtiucetP;
  else
    _idProtiUcet = _typUcOp.idProtiucetV;
  end if;
  if(_modul = 'FAP') then
    _idProtiUcet = _doklad.idProtiUcet;
  end if;

  select * into _rada from drady where idRady = _idrada;
  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _idUcetObd;
  select * into _radaRok from dRadyRok where iducetobdobi = _idUcetObd and idrady = _idrada;

  select nextval('seq_ddoklsklad') into _idDoklSklad;
  select dgetcisdokl(null, _idrada, _idUcetObd, 'SKL', _typPohybuSklad) into _cisloDokladuCursor;
  fetch _cisloDokladuCursor into _cisDoklad;

  -- ziskani kurzu pro menu skladu
  -- select getKurzFromSklad(_polDokl.idSkladu, _polDokl.datVyst) into _kurz;
  -- nejde pouzit protoze potrebuju jak kurz tak kurzove mnozstvi a ne prepocteny nna kurzove mnozstvi 1
  select idMeny into _idMenyTuzemsko from nNastav where _polDokl.datVyst >= PlatiOdData order by PlatiOdData desc limit 1;
  if (_idMenyTuzemsko is null) then
    select idMeny into _idMenyTuzemsko from nNastav where PlatiOdData is null limit 1;
  end if;
  --select idMeny into _idMenySklad from dTypDokl where idTypDokl = _polDokl.idSkladu;

  if(_sklad.idMeny is null or _sklad.idMeny = _idMenyTuzemsko) then
    _kurz = 0.0;
    _kurzMnozstvi = 1;
  else
    select nbStred, kurzMnozstvi into _kurz, _kurzMnozstvi from uKurzy
      where idMeny = _sklad.idMeny and _polDokl.datVyst >= PlatiOdData and typkurzuk = 'typKurzu.obecny'
      order by PlatiOdData desc limit 1;
    if(_kurz is null) then
      select nbStred, kurzMnozstvi into _kurz, _kurzMnozstvi from uKurzy
        where idMeny = _sklad.idMeny and PlatiOdData is null and typkurzuk = 'typKurzu.obecny'
        limit 1;
    end if;
    if(_kurz is null) then
      raise exception '0001:getKurzFromSklad : neexistuje kurz!';
    end if;
  end if;

  /*select CURRENT_DATE into _datSklad;
  select platiOdData, platiDoData into _ucetObdPlatiOd, _ucetObdPlatiDo from nucetobdobi where idUcetObdobi = _idUcetObd;
  if(_datSklad < _ucetObdPlatiOd) then
    _datSklad = _ucetObdPlatiOd;
  elsif (_datSklad > _ucetObdPlatiDo) then
    _datSklad = _ucetObdPlatiDo;
  else
    -- datSklad je v pohode
  end if;*/
  _datSklad = _doklad.datVyst;
 
  if(_isDobropis) then
    if(_modul like 'FAV') then
      _typPohybuSkladK = 'typPohybuSklad.prijemVratka';
    else
      _typPohybuSkladK = 'typPohybuSklad.prijemVydejVratka';
    end if;
  end if;

  -- vytvoreni noveho skladoveho dokladu
  insert into dDoklSklad (idDoklSklad, lastUpdate, datVyst, datSklad, datUcto, kod, modul, typPohybuK, idTypDokl, idBsp,ucetni, varSym,
         idFirmy, nazFirmy, ulice, mesto, psc, idStatu, ic, dic, vatId,
         idMur, idKrajUrc, idStatUrc, idTypUcOp, cisObj, cisDodak, doprava, idDruhDopr, popis, poznam,
         idStred, idZakazky, idMeny, kurz, kurzMnozstvi,
         eanKod, idstatpuvod, idstatodesl,
         idPrimUcet, idProtiUcet, idRady, idPolRady, zdrojProFak, stavSkladK , typPohybuSkladK,
         idCinnost, idKontaktOsoba, idZodpOsoba
         )
       values (_idDoklSklad, LOCALTIMESTAMP, _doklad.datVyst, _datSklad, _doklad.datVyst, _cisDoklad, 'SKL', _typPohybuSklad, _typDoklSkl.idTypDokl, _sklad.idBsp, _typDoklSkl.ucetni, _doklad.varSym,
         _doklad.idFirmy, _doklad.nazFirmy, _doklad.ulice, _doklad.mesto, _doklad.psc, _doklad.idStatu, _doklad.ic, _doklad.dic, _doklad.vatId,
         _doklad.idMur, _doklad.idKrajUrc, _doklad.idStatUrc, _idTypUcOp, _doklad.cisObj, null, _doklad.doprava, _doklad.idDruhDopr, _doklad.popis, _doklad.poznam,
         _doklad.idStred, _doklad.idZakazky, _sklad.idMeny, _kurz, _kurzMnozstvi,
         _doklad.eanKod, _doklad.idstatpuvod, _doklad.idstatodesl,
         _idUcetSklad, _idProtiUcet, _idRada, _radaRok.idRadyRok, false, _stavSklad, _typPohybuSkladK,
         _doklad.idCinnost, _doklad.idKontaktOsoba, _doklad.idZodpOsoba
         );


  if (_modul = 'SKL') then
    _typVazby = 'typVazbyDokl.hlavaSklKus';
  else
    _typVazby = 'typVazbyDokl.hlavaSkl';
  end if;

  insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK)
       values (0.0, _idDoklad, _idDoklSklad, _doklad.modul, 'SKL', false, _typVazby);

  return _idDoklSklad;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION createdoklsklad(integer, integer, character varying) OWNER TO %firmaRole%;

create or replace function ddokladupdatesklad() returns trigger as
$BODY$
declare
  _polFak record;
  _idPolSklad integer;
  _idDoklSklad integer;
  _idDoklad integer;
  _doklSklad record;
  _pocetPolozek integer;
  _typZasobyK character varying;
  _skladove boolean;
  _sadaItemCount integer;
begin
  if(OLD.generovatSkl <> NEW.generovatSkl) then
    if(NEW.generovatSkl = false and NEW.zdrojProSkl = true) then
      -- pokud se nema podle noveho nastaveni z typu dokladu generovat skladove doklady
      -- a tento doklad je zdrojovy pro generovani skladovych dokladu tak tyto automaticky
      -- vygenerovane doklady musim smazat

      -- nejdriv smazeme polozky navazanych dokladu
      _idDoklad = null;
      if(NEW.modul = 'FAV' or NEW.modul = 'FAP') then
        _idDoklad = NEW.idDoklFak;
        for _polFak in select * from dPolFak where idDoklFak = NEW.idDoklFak loop
          execute deleteNavazanePolSklad(_polFak.idPolFak, _polFak.modul, OLD.generovatSkl);
        end loop;
      elsif(NEW.modul = 'POK') then
        _idDoklad = NEW.idDoklInt;
        for _polFak in select * from dPolInt where idDoklInt = NEW.idDoklInt loop
          execute deleteNavazanePolSklad(_polFak.idPolInt, _polFak.modul, OLD.generovatSkl);
        end loop;
      end if;

      if(_idDoklad is not null) then
        for _idDoklSklad in select idTabB from dVazebTab where idTabA = _idDoklad and modulA = NEW.modul and modulB = 'SKL' and (typVazbyK = 'typVazbyDokl.hlavaSkl') loop
          select * into _doklSklad from dDoklSklad where idDoklSklad = _idDoklSklad;
          select count(idPolSklad) into _pocetPolozek from dPolSklad where idDoklSklad = _idDoklSklad;
          -- smazeme pouze takove doklady, ktere maji pocet polozek = 0 nejsou zdrojove pro generovani faktur
          if(_doklSklad.zdrojProFak = false and _pocetPolozek = 0) then
            delete from dvazebtab where idTabA = _idDoklad and modulA = NEW.modul and idTabB = _idDoklSklad and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.hlavaSkl';
            delete from dDoklSklad where idDoklSklad = _idDoklSklad;
          end if;
        end loop;
      end if;
    elsif (NEW.generovatSkl = true and NEW.zdrojProSkl = true) then
      -- bylo false a nastavi se true tak musime zajistit vygenerovani skladoveho dokladu k polozkam, ktere nejste nejsou vyskladneny
      if(NEW.modul = 'FAV' or NEW.modul = 'FAP') then
        for _polFak in select * from dPolFak where idDoklFak = NEW.idDoklFak loop
          if(_polFak.typPolozkyK like 'typPolozky.katalog' and _polFak.zdrojProSkl) then
            select skladove into _skladove from cCenik where idCenik = _polFak.idCenik;
            if (_skladove and _polFak.idBspSkl is not null) then
              select findParovanyPolSklad(_polFak.idPolFak, NEW.modul) into _idPolSklad;
              if(_idPolSklad is null) then
                select count(*) into _sadaItemCount from csady where idceniksada = _polFak.idCenik;
                if(_sadaItemCount > 0) then
                  execute createPolSkladSada(_polFak.idPolFak, NEW.modul);
                else
                  select createPolSklad(_polFak.idPolFak, NEW.modul) into _idPolSklad;
                end if;
              else
                -- nejspis nebudeme delat nic
              end if;
            end if;
          end if;
        end loop;
      elsif (NEW.modul = 'POK') then
        for _polFak in select * from dPolInt where idDoklInt = NEW.idDoklInt loop
          if(_polFak.typPolozkyK like 'typPolozky.katalog' and _polFak.zdrojProSkl) then
            select skladove into _skladove from cCenik where idCenik = _polFak.idCenik;
            if (_skladove and _polFak.idBspSkl is not null) then
              select findParovanyPolSklad(_polFak.idPolInt, NEW.modul) into _idPolSklad;
              if(_idPolSklad is null) then
                select count(*) into _sadaItemCount from csady where idceniksada = _polFak.idCenik;
                if(_sadaItemCount > 0) then
                  execute createPolSkladSada(_polFak.idPolInt, NEW.modul);
                else
                  select createPolSklad(_polFak.idPolInt, NEW.modul) into _idPolSklad;
                end if;
              else
                -- nejspis nebudeme delat nic
              end if;
            end if;
          end if;
        end loop;
      end if;
    else
    end if;
  end if;

  if(OLD.idtypdoklskl is null and NEW.idtypdoklskl is not null) then
    if (NEW.generovatSkl = true and NEW.zdrojProSkl = true) then
      -- bylo false a nastavi se true tak musime zajistit vygenerovani skladoveho dokladu k polozkam, ktere nejste nejsou vyskladneny
      if(NEW.modul = 'FAV' or NEW.modul = 'FAP') then
        for _polFak in select * from dPolFak where idDoklFak = NEW.idDoklFak loop
          if(_polFak.typPolozkyK like 'typPolozky.katalog' and _polFak.zdrojProSkl) then
            select skladove into _skladove from cCenik where idCenik = _polFak.idCenik;
            if (_skladove and _polFak.idBspSkl is not null) then
              select findParovanyPolSklad(_polFak.idPolFak, NEW.modul) into _idPolSklad;
              if(_idPolSklad is null) then
                select count(*) into _sadaItemCount from csady where idceniksada = _polFak.idCenik;
                if(_sadaItemCount > 0) then
                  execute createPolSkladSada(_polFak.idPolFak, NEW.modul);
                else
                  select createPolSklad(_polFak.idPolFak, NEW.modul) into _idPolSklad;
                end if;
              else
                -- nejspis nebudeme delat nic
              end if;
            end if;
          end if;
        end loop;
      elsif (NEW.modul = 'POK') then
        for _polFak in select * from dPolInt where idDoklInt = NEW.idDoklInt loop
          if(_polFak.typPolozkyK like 'typPolozky.katalog' and _polFak.zdrojProSkl) then
            select skladove into _skladove from cCenik where idCenik = _polFak.idCenik;
            if (_skladove and _polFak.idBspSkl is not null) then
              select findParovanyPolSklad(_polFak.idPolInt, NEW.modul) into _idPolSklad;
              if(_idPolSklad is null) then
                select count(*) into _sadaItemCount from csady where idceniksada = _polFak.idCenik;
                if(_sadaItemCount > 0) then
                  execute createPolSkladSada(_polFak.idPolInt, NEW.modul);
                else
                  select createPolSklad(_polFak.idPolInt, NEW.modul) into _idPolSklad;
                end if;
              else
                -- nejspis nebudeme delat nic
              end if;
            end if;
          end if;
        end loop;
      end if;
    else
    end if;
  end if;

  -- propasovani zmen na dokladu faktury do skladoveho dokladu...
  -- napr. zmena firmy, cinnosti...
  if(NEW.generovatSkl = true and NEW.zdrojProSkl = true) then
    if(not compareId(OLD.idFirmy, NEW.idFirmy)
       or not compareVarchar(OLD.nazFirmy, NEW.nazFirmy)
       or not compareVarchar(OLD.ulice, NEW.ulice)
       or not compareVarchar(OLD.mesto, NEW.mesto)
       or not compareVarchar(OLD.psc, NEW.psc)
       or not compareId(OLD.idStatu, NEW.idStatu)
       or not compareVarchar(OLD.ic, NEW.ic)
       or not compareVarchar(OLD.dic, NEW.dic)
       or not compareVarchar(OLD.vatId, NEW.vatId)
       or not compareId(OLD.idMur, NEW.idMur)
       or not compareId(OLD.idKrajUrc, NEW.idKrajUrc)
       or not compareId(OLD.idStatUrc, NEW.idStatUrc)
       or not compareVarchar(OLD.cisObj, NEW.cisObj)
       or not compareVarchar(OLD.doprava, NEW.doprava)
       or not compareId(OLD.idDruhDopr, NEW.idDruhDopr)
       or not compareVarchar(OLD.popis, NEW.popis)
       or not compareVarchar(OLD.poznam, NEW.poznam)
       or not compareId(OLD.idcinnost, NEW.idCinnost)
       or not compareId(OLD.idStred, NEW.idStred)
       or not compareVarchar(OLD.varSym, NEW.varSym)
       or not compareId(OLD.idZakazky, NEW.idZakazky)
       or not compareVarchar(OLD.eanKod, NEW.eanKod)
       or not compareId(OLD.idstatpuvod, NEW.idStatPuvod)
       or not compareId(OLD.idstatodesl, NEW.idStatOdesl) 
       or not compareId(OLD.idKontaktOsoba, NEW.idKontaktOsoba)
       or not compareId(OLD.idZodpOsoba, NEW.idZodpOsoba)
    ) then
      if(NEW.modul = 'FAV' or NEW.modul = 'FAP') then
        _idDoklad = NEW.idDoklFak;
      elsif(NEW.modul = 'POK') then
        _idDoklad = NEW.idDoklInt;
      else
      end if;
    
      for _doklSklad in select * from dvazebtab vt join ddoklsklad ds on vt.idtabb = ds.iddoklsklad 
        where typVazbyK = 'typVazbyDokl.hlavaSkl' and idTabA = _idDoklad and modulA = NEW.modul loop
          update ddoklsklad set
            lastUpdate = LOCALTIMESTAMP,
            idFirmy = NEW.idFirmy,
            nazFirmy = NEW.nazFirmy,
            ulice = NEW.ulice,
            mesto = NEW.mesto,
            psc = NEW.psc,
            idStatu = NEW.idStatu,
            ic = NEW.ic,
            dic = NEW.dic,
            vatId = NEW.vatId,
            idMur = NEW.idMur,
            idKrajUrc = NEW.idKrajUrc,
            idStatUrc = NEW.idStatUrc,
            cisObj = NEW.cisObj,
            doprava = NEW.doprava,
            idDruhDopr = NEW.idDruhDopr,
            popis = NEW.popis,
            poznam = NEW.poznam,
            idcinnost = NEW.idCinnost,
            idStred = NEW.idStred,
            varSym = NEW.varSym, 
            idZakazky = NEW.idZakazky,
            eanKod = NEW.eanKod,
            idstatpuvod = NEW.idStatPuvod,
            idstatodesl = NEW.idStatOdesl, 
            idKontaktOsoba = NEW.idKontaktOsoba,
            idZodpOsoba = NEW.idZodpOsoba
          where idDoklSklad = _doklSklad.idDoklSklad;
      end loop;
    end if;
  end if;

  return NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION ddokladupdatesklad() OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 552, 't', %appVersion%, clock_timestamp());
