--------------------------------------------------------------------------------
-- Bug 27890 – [winstrom] - vydané faktury - Rezervace - prodej je nerespektuje
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION dgetrezervovano(_cenik integer, _sklad integer, i_firmaid integer)
  RETURNS numeric AS $$  
declare  
  _celkemRezerMj numeric(19,6);  
begin  
  -- vymazeme jiz neplatne rezervace  
  delete from srezervace where datumdo is not null and datumdo < date(now());  
  -- zjistime kolik je celkem rezervovano - od/do ignorujeme (bug 25844, 25789), muselo by se zohlednovat uz pri plneni pole skladmj a nebo toto pole idealne vyhodit 
  select coalesce(sum(skladmj), 0) into _celkemRezerMj from srezervace where idcenik = _cenik and idsklad = _sklad and idfirmy <> i_firmaid; 
    
  RETURN _celkemRezerMj;  
end  
$$ LANGUAGE plpgsql;
ALTER FUNCTION dgetrezervovano(integer, integer, integer) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 579, 't', %appVersion%, clock_timestamp());
