-- Bug 12957 – [WinStrom] FIFO

-- Function: sprepoctiskladkartu(numeric, numeric, date, integer, integer, integer, integer)
-- DROP FUNCTION sprepoctiskladkartu(numeric, numeric, date, integer, integer, integer, integer);
CREATE OR REPLACE FUNCTION sprepoctiskladkartu(i_mnozmj numeric, i_cenamj numeric, i_datvyst date, i_skladkartaid integer, i_doklskladid integer, i_skladid integer, i_nasobic integer)
  RETURNS void AS
$BODY$   
/* Prepocte stavy na skladove karte s id = iSkladKartaId */   
declare   
  /* Deklarace promennych */   
  _PomMnozMJ numeric(19,2);   
  _StavMJ numeric(19,2);   
  _StavTuz numeric(19,2);   
  _StavMen numeric(19,2);   
  _PrumCenaTuz numeric(19,2);   
  _PrumCenaMen numeric(19,2);   
  _PoslCenaTuz numeric(19,2);   
  _PoslCenaMen numeric(19,2);   
  _TypPohybuK varchar(50);   
  _DatPosl date;   
  _kurzSkladKarty numeric(19,6);  
  _kurzDokladu numeric(19,6);  
  loc_MnozMJ numeric(19,6);  
  _sklzapor boolean; 
  _sklfifo boolean;   
   
  /* Deklarace kurzoru pro nacteni potrebnych dat ze skladove karty a dokladu */   
  declare ThisDoklSklad cursor for select TypPohybuK from dDoklSklad where idDoklSklad = i_DoklSkladId;   
  declare ThisSkladKarta cursor for select StavMJ,StavTuz,StavMen,PrumCenaTuz,PrumCenaMen,DatPosl from sKarty where idKarty = i_SkladKartaId;     
begin   
  loc_MnozMJ:= i_MnozMJ;   
   
  /* Nacteni dat ze skladove karty */   
  open ThisSkladKarta;   
  fetch ThisSkladKarta into _StavMJ,   
    _StavTuz,_StavMen,_PrumCenaTuz,_PrumCenaMen,_DatPosl;   
  close ThisSkladKarta;   
     
  /* Zjisteni typPohybuK */   
  open ThisDoklSklad;   
  fetch ThisDoklSklad into _TypPohybuK;   
  close ThisDoklSklad;   
  
  /* zjisteni meny skladove karty */  
  _KurzSkladKarty := (select getKurzFromSklad(i_skladId, i_DatVyst));  
  _KurzDokladu := (select getKurzFromDoklad(i_doklSkladId, i_DatVyst));  
    
  /* pokud jde o vydej musim odecitat */   
  if _TypPohybuK = 'typPohybu.vydej' then   
    loc_MnozMJ:= 0-loc_MnozMJ;   
  end if;   
     
  /* Vypocet StavMJ */   
  _StavMJ:=_StavMJ+loc_MnozMJ*i_Nasobic;   
  
  if _StavMJ < 0 then  
    select sklzapor into _sklzapor from nNastav where i_DatVyst >= PlatiOdData order by PlatiOdData desc limit 1;  
	if (_sklzapor is null) then  
		select sklzapor into _sklzapor from nNastav where PlatiOdData is null limit 1;   
	end if;  
    if _sklzapor is null or _sklzapor = false then  
        /*raise exception '0002:sPreporctiSkladKartu: neni povolen zaporny stav skladu';*/  
    end if;  
  end if;  
	  
     
  /* Vypocet StavTuz */   
  if loc_MnozMJ = 0 then   
    _PomMnozMJ:=1;   
  else   
    _PomMnozMJ:=loc_MnozMJ;   
  end if;   
  _StavTuz:=_StavTuz+(_PomMnozMJ*i_CenaMJ*i_Nasobic*_KurzDokladu);
  /* Vypocet StavMen */   
  _StavMen:=_StavMen+(_PomMnozMJ*i_CenaMJ*i_Nasobic*_KurzDokladu)/_KurzSkladKarty;   
  
  /* Vypocet prumernych cen ma byt proveden jen pri prijmu*/  
  if _TypPohybuK = 'typPohybu.prijem' then
    /* Vypocet PrumCenaTuz */   
    if _StavMJ > 0 then   
      _PrumCenaTuz:=_StavTuz/_StavMJ;   
    end if;   
    /* Vypocet PrumCenaMen */   
    if _StavMJ > 0 then   
      _PrumCenaMen:=_StavMen/_StavMJ;   
    end if;   
  end if;   
   
  /* Prepocteni stavu skladu pro FIFO */ 
  _sklfifo := (select isfifosklad(i_DatVyst)); 
  if (_sklfifo) then 
    if(_StavMJ <> 0.0) then
      _PrumCenaTuz := _StavTuz / _StavMJ; 
      _PrumCenaMen := _StavMen / _StavMJ;
    end if;
  end if; 
   
  /* Nastaveni posledni ceny */   
  _PoslCenaTuz:= i_CenaMJ * _KurzDokladu;   
  _PoslCenaMen:= i_CenaMJ;   
  
  /* Nastaveni data posledniho pohybu na karte */   
  if _DatPosl is null then   
    _DatPosl:= i_DatVyst;   
  end if;   
  if _DatPosl < i_DatVyst then   
    _DatPosl:=i_DatVyst;   
  end if;   
  
  /* Update v databazi */
  update sKarty set StavMJ = _StavMJ,   
    StavTuz = _StavTuz,   
    StavMen = _StavMen,   
    PrumCenaTuz = _PrumCenaTuz,   
    PrumCenaMen = _PrumCenaMen,   
    PoslCenaTuz = _PoslCenaTuz,   
    PoslCenaMen = _PoslcenaMen,   
    DatPosl = _DatPosl where   
    idKarty = i_SkladKartaId;   
end;   
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION sprepoctiskladkartu(numeric, numeric, date, integer, integer, integer, integer) OWNER TO %firmaRole%;

-- Function: sfifovydej(integer, integer, integer, integer, numeric)
-- DROP FUNCTION sfifovydej(integer, integer, integer, integer, numeric);
CREATE OR REPLACE FUNCTION sfifovydej(idvydej integer, idcenikvydej integer, idskladvydej integer, idkartyvydej integer, vyd numeric)
  RETURNS void AS
$BODY$   
declare   
	_zaznam Record;   
         _vybrano numeric(19,6); 
         _i integer; 
         _novevydcelkem numeric(19,6); 
         _pocet numeric(19,6); 
         _cenamjP numeric(19,6);
	 _kurzDokladuP numeric(19,6);
	 _idDoklSkladP integer;
         _idrozlozeni integer; 
         _vydexpir boolean; 
         _vyrcis character varying(255); 
         _sklfifo boolean;   
begin   
  _vybrano := 0; 
  _i := 1; 
  _novevydcelkem := vyd; 
  if (idvydej>0) then 
           select vydexpir into _vydexpir from skarty where idkarty=idkartyvydej limit 1; 
           if (not _vydexpir) then 
                    --pořadí výdeje dle datvyst (dále se bude řeit upřednostněný výdej mimo FIFO) 
	           for _zaznam in select * from dPolSkladF where idCenik=idCenikVydej and idSkladu=idSkladVydej order by datVyst,idpolsklad loop   
	                  if (_vybrano<_novevydcelkem) then 
	                   _pocet := _zaznam.pocet; 
	                   if( _vybrano+_pocet) > _novevydcelkem then 
	                     _pocet := _novevydcelkem-_vybrano; 
	                   end if; 
	                   _vybrano := _vybrano+_pocet; 
                            --pokud je výrobní číslo, tak jeho kód zaznamenám na výdejku (otázka je, zda tam nedat rovnou idvyrobnicislo 
                            _vyrcis := ''; 
                            if (_zaznam.idvyrobnicislo>0) then 
                            	select kod into _vyrcis from svyrobnicislo where idvyrobnicislo = _zaznam.idvyrobnicislo; 
                            end if; 
                            -- 
	                   if (_i = 1) then 
	                     insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, _pocet,_zaznam.idvyrobnicislo) ; 
                             _sklfifo := (select isfifosklad(_zaznam.datvyst)); 
                             if (_sklfifo) then 
	                       select cenamj, idDoklSklad  into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad); 
	                       select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);
			       if (_kurzDokladuP <> 0.0) then
	                         _cenamjP := _cenamjP * _kurzDokladuP; 
	                       end if;
	                       update dpolsklad set mnozmj = _pocet,cenamj = _cenamjP, sumzkl = _pocet*_cenamjP, vyrcis=_vyrcis  where idpolsklad = idvydej; 
                             end if; 
	                   else 
                             _sklfifo := (select isfifosklad(_zaznam.datvyst)); 
                             if (_sklfifo) then 
	                       select nextval('seq_dpolsklad') into _idrozlozeni; 
	                       select cenamj, idDoklSklad into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);
			       select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);
			       if (_kurzDokladuP <> 0.0) then
	                         _cenamjP := _cenamjP * _kurzDokladuP; 
	                       end if;
	                       insert into dpolsklad(idpolsklad,mnozmj,autozaokr,autogen,baleniid,cenjednotka,cenamj,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,sumzkl,sumzklmen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idskladu,idfirmy,vyrcis)  
	                                          (select (-1*_idrozlozeni),_pocet,autozaokr,autogen,baleniid,cenjednotka,_cenamjP,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,_pocet*_cenamjP,sumzklmen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idskladu,idfirmy,_vyrcis from dpolsklad where idpolsklad=idVydej); 
	                       -- 
	                       insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,_idrozlozeni,_pocet,_zaznam.idvyrobnicislo); 
                               insert into svazbypolsklad(idpolskladzdroj,idpolskladcil) values (idvydej, _idrozlozeni); 
                             else 
                               insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,idvydej,_pocet,_zaznam.idvyrobnicislo); 
                             end if; 
	                   end if; 
	                   -- 
	                   _i:=_i+1; 
	                  end if; 
	           end loop; 
           else 
                    --pořadí výdeje dle expirace (dále se bude řeit upřednostněný výdej mimo FIFO) 
	           for _zaznam in select * from dPolSkladF where idCenik=idCenikVydej and idSkladu=idSkladVydej order by expirace, idpolsklad loop   
	                  if (_vybrano<_novevydcelkem) then 
	                   _pocet := _zaznam.pocet; 
	                   if( _vybrano+_pocet) > _novevydcelkem then 
	                     _pocet := _novevydcelkem-_vybrano; 
	                   end if; 
	                   _vybrano := _vybrano+_pocet; 
                            --pokud je výrobní číslo, tak jeho kód zaznamenám na výdejku (otázka je, zda tam nedat rovnou idvyrobnicislo 
                            _vyrcis := ''; 
                            if (_zaznam.idvyrobnicislo>0) then 
                            	select kod into _vyrcis from svyrobnicislo where idvyrobnicislo = _zaznam.idvyrobnicislo; 
                            end if; 
                            -- 
	                   if (_i = 1) then 
	                     insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, _pocet,_zaznam.idvyrobnicislo) ; 
	                     select cenamj  into _cenamjP from dpolsklad where(idpolsklad = _zaznam.idPolSklad); 
	                     update dpolsklad set mnozmj = _pocet,cenamj = _cenamjP, sumzkl = _pocet*_cenamjP, vyrcis=_vyrcis where idpolsklad = idvydej; 
	                   else 
	                     select nextval('seq_dpolsklad') into _idrozlozeni; 
	                     select cenamj  into _cenamjP from dpolsklad where(idpolsklad = _zaznam.idPolSklad); 
	                     insert into dpolsklad(idpolsklad,mnozmj,autozaokr,autogen,baleniid,cenjednotka,cenamj,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,sumzkl,sumzklmen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idskladu,idfirmy,vyrcis)  
	                                          (select (-1*_idrozlozeni),_pocet,autozaokr,autogen,baleniid,cenjednotka,cenamj,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,_pocet*_cenamjP,sumzklmen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idskladu,idfirmy,_vyrcis from dpolsklad where idpolsklad=idVydej); 
	                     -- 
	                     insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,_idrozlozeni,_pocet,_zaznam.idvyrobnicislo); 
                             insert into svazbypolsklad(idpolskladzdroj,idpolskladcil) values (idvydej, _idrozlozeni); 
	                   end if; 
	                   -- 
	                   _i:=_i+1; 
	                  end if; 
	           end loop; 
           end if; 
  else 
  	--nepoutím fifo do rekurze, příznak záporného id udělám opět kladný 
         update dpolsklad set idPolSklad = -1*idVydej where idpolsklad=idVydej;          
  end if; 
end;   
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION sfifovydej(integer, integer, integer, integer, numeric) OWNER TO %firmaRole%;

-- Function: snastavstavkartydne(integer, date, integer)
-- DROP FUNCTION snastavstavkartydne(integer, date, integer);
CREATE OR REPLACE FUNCTION snastavstavkartydne(i_skladkartaid integer, i_datum date, i_polskladid integer)
  RETURNS void AS
$BODY$   
declare   
  zaznam Record;
  _idPolSklad integer;   
begin
  _idPolSklad := i_polskladid;
  if(_idPolSklad < 0) then
    _idPolSklad := -1*_idPolSklad;
  end if;   
  for zaznam in select * from dPolSklad where ((DatVyst > i_Datum) or (DatVyst = i_Datum and idPolSklad > _idPolSklad))   
  and idKarty = i_SkladKartaId order by DatVyst, idPolSklad asc loop   
    execute sOdectiSkladKartu(zaznam.MnozMJ,zaznam.CenaMj,zaznam.DatVyst,zaznam.idKarty,zaznam.idDoklSklad,zaznam.idskladu,-1);   
  end loop;   
end   
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION snastavstavkartydne(integer, date, integer) OWNER TO %firmaRole%;

-- Function: szapoctipolozkyoddata(integer, date, integer)
-- DROP FUNCTION szapoctipolozkyoddata(integer, date, integer);
CREATE OR REPLACE FUNCTION szapoctipolozkyoddata(i_skladkartaid integer, i_datum date, i_polskladid integer)
  RETURNS void AS
$BODY$   
declare   
  zaznam Record;   
  _sklfifo boolean; 
  _idPolSklad integer;
begin   
  _idPolSklad := i_polskladid;
  if(_idPolSklad < 0) then
    _idPolSklad := -1*_idPolSklad;
  end if;   
  for zaznam in select * from dPolSklad where ((DatVyst > i_Datum) or (DatVyst = i_Datum and idPolSklad > _idPolSklad))  
  and idKarty = i_SkladKartaId order by DatVyst, idPolSklad asc LOOP  
    _sklfifo := (select isfifosklad(zaznam.datvyst)); 
    if (_sklfifo <> true) then 
      execute sZmenCenyNaPolSklad(zaznam.idPolSklad, i_SkladKartaId, zaznam.iddoklsklad);   
    end if; 
    execute sPrepoctiSkladKartu(zaznam.MnozMJ,zaznam.CenaMj,zaznam.DatVyst,zaznam.idKarty,zaznam.idDoklSklad,zaznam.idSkladu,1);   
  end loop;   
end;   
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION szapoctipolozkyoddata(integer, date, integer) OWNER TO %firmaRole%;

-- Zvyseni verze aplikace
insert into dbversion(iddbversion, dbversion, needreimport) values (nextval('seq_dbversion'), 60, 't')
