--------------------------------------------------------------------------------
-- Bug 30270 – [WinStrom] Upravit datový model do REST API
--------------------------------------------------------------------------------

CREATE TABLE wkli_cdodavatele (
    iddodavatel integer NOT NULL,
    idvybklic integer NOT NULL,

    CONSTRAINT wkli_cdodavatele_pkey PRIMARY KEY (iddodavatel, idvybklic),
    CONSTRAINT wkli_cdodavatele_iddodavatel FOREIGN KEY (iddodavatel)
      REFERENCES cdodavatele (iddodavatel) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT wkli_cdodavatele_idvybklic FOREIGN KEY (idvybklic)
        REFERENCES wvybklice(idvybklice) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE public.wkli_cdodavatele OWNER TO %firmaRole%;

CREATE INDEX wkli_cdodavatele_iddodavatel_index ON wkli_cdodavatele USING btree (iddodavatel);
CREATE INDEX wkli_cdodavatele_idvybklic_index ON wkli_cdodavatele USING btree (idvybklic);


CREATE TABLE wkli_dformauhrady (
    idformauhrady integer NOT NULL,
    idvybklic integer NOT NULL,

    CONSTRAINT wkli_dformauhrady_pkey PRIMARY KEY (idformauhrady, idvybklic),
    CONSTRAINT wkli_dformauhrady_idformauhrady FOREIGN KEY (idformauhrady)
      REFERENCES dformauhrady (idformauhrady) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT wkli_dformauhrady_idvybklic FOREIGN KEY (idvybklic)
        REFERENCES wvybklice(idvybklice) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE public.wkli_dformauhrady OWNER TO %firmaRole%;

CREATE INDEX wkli_dformauhrady_idformauhrady_index ON wkli_dformauhrady USING btree (idformauhrady);
CREATE INDEX wkli_dformauhrady_idvybklic_index ON wkli_dformauhrady USING btree (idvybklic);


CREATE TABLE wkli_dformauhradycis (
    idformauhradycis integer NOT NULL,
    idvybklic integer NOT NULL,

    CONSTRAINT wkli_dformauhradycis_pkey PRIMARY KEY (idformauhradycis, idvybklic),
    CONSTRAINT wkli_dformauhradycis_idformauhradycis FOREIGN KEY (idformauhradycis)
      REFERENCES dformauhradycis (idformauhradycis) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT wkli_dformauhradycis_idvybklic FOREIGN KEY (idvybklic)
        REFERENCES wvybklice(idvybklice) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE public.wkli_dformauhradycis OWNER TO %firmaRole%;

CREATE INDEX wkli_dformauhradycis_idformauhradycis_index ON wkli_dformauhradycis USING btree (idformauhradycis);
CREATE INDEX wkli_dformauhradycis_idvybklic_index ON wkli_dformauhradycis USING btree (idvybklic);


CREATE TABLE wkli_dformadopravy (
    idformadopravy integer NOT NULL,
    idvybklic integer NOT NULL,

    CONSTRAINT wkli_dformadopravy_pkey PRIMARY KEY (idformadopravy, idvybklic),
    CONSTRAINT wkli_dformadopravy_idformadopravy FOREIGN KEY (idformadopravy)
      REFERENCES dformadopravy (idformadopravy) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT wkli_dformadopravy_idvybklic FOREIGN KEY (idvybklic)
        REFERENCES wvybklice(idvybklice) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE public.wkli_dformadopravy OWNER TO %firmaRole%;

CREATE INDEX wkli_dformadopravy_idformadopravy_index ON wkli_dformadopravy USING btree (idformadopravy);
CREATE INDEX wkli_dformadopravy_idvybklic_index ON wkli_dformadopravy USING btree (idvybklic);


CREATE TABLE wkli_dbsp (
    idbsp integer NOT NULL,
    idvybklic integer NOT NULL,

    CONSTRAINT wkli_dbsp_pkey PRIMARY KEY (idbsp, idvybklic),
    CONSTRAINT wkli_dbsp_idbsp FOREIGN KEY (idbsp)
      REFERENCES dbsp (idbsp) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT wkli_dbsp_idvybklic FOREIGN KEY (idvybklic)
        REFERENCES wvybklice(idvybklice) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE public.wkli_dbsp OWNER TO %firmaRole%;

CREATE INDEX wkli_dbsp_idbsp_index ON wkli_dbsp USING btree (idbsp);
CREATE INDEX wkli_dbsp_idvybklic_index ON wkli_dbsp USING btree (idvybklic);


CREATE TABLE wkli_cskupzboz (
    idskupzboz integer NOT NULL,
    idvybklic integer NOT NULL,

    CONSTRAINT wkli_cskupzboz_pkey PRIMARY KEY (idskupzboz, idvybklic),
    CONSTRAINT wkli_cskupzboz_idskupzboz FOREIGN KEY (idskupzboz)
      REFERENCES cskupzboz (idskupzboz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT wkli_cskupzboz_idvybklic FOREIGN KEY (idvybklic)
        REFERENCES wvybklice(idvybklice) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE public.wkli_cskupzboz OWNER TO %firmaRole%;

CREATE INDEX wkli_cskupzboz_idskupzboz_index ON wkli_cskupzboz USING btree (idskupzboz);
CREATE INDEX wkli_cskupzboz_idvybklic_index ON wkli_cskupzboz USING btree (idvybklic);


CREATE TABLE wkli_dstavsml (
    idstavsml integer NOT NULL,
    idvybklic integer NOT NULL,

    CONSTRAINT wkli_dstavsml_pkey PRIMARY KEY (idstavsml, idvybklic),
    CONSTRAINT wkli_dstavsml_idstavsml FOREIGN KEY (idstavsml)
      REFERENCES dstavsml (idstavsml) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT wkli_dstavsml_idvybklic FOREIGN KEY (idvybklic)
        REFERENCES wvybklice(idvybklice) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE public.wkli_dstavsml OWNER TO %firmaRole%;

CREATE INDEX wkli_dstavsml_idstavsml_index ON wkli_dstavsml USING btree (idstavsml);
CREATE INDEX wkli_dstavsml_idvybklic_index ON wkli_dstavsml USING btree (idvybklic);


CREATE TABLE wkli_dtypsml (
    idtypsml integer NOT NULL,
    idvybklic integer NOT NULL,

    CONSTRAINT wkli_dtypsml_pkey PRIMARY KEY (idtypsml, idvybklic),
    CONSTRAINT wkli_dtypsml_idtypsml FOREIGN KEY (idtypsml)
      REFERENCES dtypsml (idtypsml) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT wkli_dtypsml_idvybklic FOREIGN KEY (idvybklic)
        REFERENCES wvybklice(idvybklice) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE public.wkli_dtypsml OWNER TO %firmaRole%;

CREATE INDEX wkli_dtypsml_idtypsml_index ON wkli_dtypsml USING btree (idtypsml);
CREATE INDEX wkli_dtypsml_idvybklic_index ON wkli_dtypsml USING btree (idvybklic);


CREATE TABLE wkli_ustredisko (
    idstred integer NOT NULL,
    idvybklic integer NOT NULL,

    CONSTRAINT wkli_ustredisko_pkey PRIMARY KEY (idstred, idvybklic),
    CONSTRAINT wkli_ustredisko_idstred FOREIGN KEY (idstred)
      REFERENCES ustrediska (idstred) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT wkli_ustredisko_idvybklic FOREIGN KEY (idvybklic)
        REFERENCES wvybklice(idvybklice) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE public.wkli_ustredisko OWNER TO %firmaRole%;

CREATE INDEX wkli_ustredisko_idstred_index ON wkli_ustredisko USING btree (idstred);
CREATE INDEX wkli_ustredisko_idvybklic_index ON wkli_ustredisko USING btree (idvybklic);


CREATE TABLE wkli_atypakt (
    idtypakt integer NOT NULL,
    idvybklic integer NOT NULL,

    CONSTRAINT wkli_atypakt_pkey PRIMARY KEY (idtypakt, idvybklic),
    CONSTRAINT wkli_atypakt_idtypakt FOREIGN KEY (idtypakt)
      REFERENCES atypakt (idtypakt) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT wkli_atypakt_idvybklic FOREIGN KEY (idvybklic)
        REFERENCES wvybklice(idvybklice) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE public.wkli_atypakt OWNER TO %firmaRole%;

CREATE INDEX wkli_atypakt_idtypakt_index ON wkli_atypakt USING btree (idtypakt);
CREATE INDEX wkli_atypakt_idvybklic_index ON wkli_atypakt USING btree (idvybklic);


CREATE TABLE wkli_ucinnost (
    idcinnost integer NOT NULL,
    idvybklic integer NOT NULL,

    CONSTRAINT wkli_ucinnost_pkey PRIMARY KEY (idcinnost, idvybklic),
    CONSTRAINT wkli_ucinnost_idcinnost FOREIGN KEY (idcinnost)
      REFERENCES ucinnost (idcinnost) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT wkli_ucinnost_idvybklic FOREIGN KEY (idvybklic)
        REFERENCES wvybklice(idvybklice) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE public.wkli_ucinnost OWNER TO %firmaRole%;

CREATE INDEX wkli_ucinnost_idcinnost_index ON wkli_ucinnost USING btree (idcinnost);
CREATE INDEX wkli_ucinnost_idvybklic_index ON wkli_ucinnost USING btree (idvybklic);


ALTER TABLE wvybklice
  ADD COLUMN vsbcis boolean DEFAULT false;

-- nastaveni standartnich stitku, aby byli pristupne
UPDATE wvybklice SET vsbcis = true WHERE uuid IS NOT NULL;


--------------------------------------------------------------------------------

-- pridame datum trvanlivosti
-- pridame datum vyroby
ALTER TABLE dpolfak
  ADD COLUMN dattrvan date,
  ADD COLUMN datvyroby date;

ALTER TABLE dpolint
  ADD COLUMN dattrvan date,
  ADD COLUMN datvyroby date;

ALTER TABLE dpolobch
  ADD COLUMN dattrvan date,
  ADD COLUMN datvyroby date;

ALTER TABLE dpolsklad
  ADD COLUMN dattrvan date,
  ADD COLUMN datvyroby date;

-- upgrade skript, ktery naplni trvanlivost na hodnotu expirace
UPDATE dpolfak SET dattrvan = expirace WHERE expirace IS NOT NULL;
UPDATE dpolint SET dattrvan = expirace WHERE expirace IS NOT NULL;
UPDATE dpolobch SET dattrvan = expirace WHERE expirace IS NOT NULL;
UPDATE dpolsklad SET dattrvan = expirace WHERE expirace IS NOT NULL;


ALTER TABLE ccenik
  ADD COLUMN dnyTrvanPoExpir integer DEFAULT 0 NOT NULL;


--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION fillPolSkladSada(_idpoldokl integer, _modul character varying)
  RETURNS void AS
$BODY$ 
declare 
  _polDokl record; 
  _polSklad record; 
  _idDoklad integer; 
  _typPohybuK character varying; 
  _typPohybuSklad character varying; 
  _cenaMj numeric(19,6); 
  _cenaMjTuz numeric(19,6); 
  _mnozMj numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _idDoklSklad integer; 
  _idUcetObdobi integer; 
  _idKarty integer; 
  _sklad record; 
  _kurz numeric(19,6); 
  _prumCenaTuz numeric(19,6); 
  _isCiziMena boolean; 
  _typDoklK character varying; 
  _idZklMdUcet integer; 
  _idZklDalUcet integer; 
  _idStredDoklSklad integer;
  _idCinnostDoklSklad integer;
  _idZakazkyDoklSklad integer;
  _kopStred boolean;
  _kopCinnost boolean;
  _kopZakazku boolean;
begin
  if(_modul like 'POK') then 
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl; 
    select idDoklInt, typPohybuK into _idDoklad, _typPohybuK from dDoklInt where idDoklInt = _polDokl.idDoklInt; 
    _typDoklK = null; -- pro pokladnu dobropisy nejsou 
  else 
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl; 
    select idDoklFak, typPohybuK into _idDoklad, _typPohybuK from dDoklFak where idDoklFak = _polDokl.idDoklFak; 
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak); 
  end if; 

  select findparovanydoklsklad(_iddoklad, _modul, 'typVazbyDokl.hlavaSkl', true) into _idDoklSklad; 
  if(_idDoklSklad is null) then 
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad; 
  end if; 

  for _polSklad in  
    select * from dPolSklad where idPolSklad in ( 
      select idTabB from dvazebtab where 
        typVazbyK like 'typVazbyDokl.polozkaSklSada'  
        and idTabA = _idPolDokl and modulA = _modul and modulB = 'SKL' 
    ) 
  loop 
    select typPohybuK, idStred, idCinnost, idZakazky
      into _typPohybuSklad, _idStredDoklSklad, _idCinnostDoklSklad, _idZakazkyDoklSklad
      from dDoklSklad where idDoklSklad = _polSklad.idDoklSklad;
 
    select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi; 
    select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idskladu = _polDokl.idbspskl and iducetobdobi = _iducetobdobi; 
    select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl; 
   
    select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz; 
    select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty; 
    select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena; 
 
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena 
    _cenaMj = _polSklad.cenaMj; 
    _mnozMj = _polSklad.mnozMj; 
    _sumZkl = _polSklad.sumZkl; 
    _sumZklMen = _polSklad.sumZklMen; 
    -- nastaveni uctu pro polSklad vydej 
    --TODO doresit zklMdUcet;
    --select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet; 
    _idZklDalUcet = _sklad.idPrimUcet; 
   
    _kopStred = _polSklad.kopStred;
    if(not compareId(_idStredDoklSklad, _polDokl.idStred)) then
      _kopStred = false;
    end if;
    _kopCinnost = _polSklad.kopCinnost;
    if(not compareId(_idCinnostDoklSklad, _polDokl.idCinnost)) then
      _kopCinnost = false;
    end if;
    _kopZakazku = _polSklad.kopZakazku;
    if(not compareId(_idZakazkyDoklSklad, _polDokl.idZakazky)) then
      _kopZakazku = false;
    end if;

    update dPolSklad set  
      lastUpdate = LOCALTIMESTAMP,  
      cenaMj = _cenaMj,  
      mnozMj = _mnozMj,  
      sumZkl = _sumZkl,  
      sumZklMen = _sumZklMen,  
      --nazev = _polDokl.nazev,  
      --nazevA = _polDokl.nazevA,  
      --nazevB = _polDokl.nazevB,  
      --nazevC = _polDokl.nazevC,  
      datVyst = _polDokl.datVyst,  
      datUcto = _polDokl.datVyst,
      baleniId = _polDokl.baleniId,  
      mnozBaleni = _polDokl.mnozBaleni,  
      --sarze = _polDokl.sarze,  
      --expirace = _polDokl.expirace,  
      --cisRad = _polDokl.cisRad,  
      --eankod = _polDokl.eanKod,  
      --idmj = _polDokl.idmj,
      datTrvan = _polDokl.datTrvan,
      datVyroby = _polDokl.datVyroby,
      idStred = _polDokl.idStred,  
      kopStred = _kopStred,
      idCinnost = _polDokl.idCinnost,
      kopCinnost = _kopCinnost,   
      idMeny = _polSklad.idMeny,  
      idZakazky = _polDokl.idZakazky,  
      kopZakazku = _kopZakazku,   
      --idZklMdUcet = _idZklMdUcet,  
      --idZklDalUcet = _idZklDalUcet,
      ucetni = true 
      where idPolSklad = _polSklad.idPolSklad; 
  end loop;
  --return _idPolSklad; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION fillpolskladsada(integer, character varying) OWNER TO %firmaRole%;




CREATE OR REPLACE FUNCTION fillPolSklad(_idPolSklad integer, _idPolDokl integer, _modul character varying) RETURNS integer AS
$BODY$
declare
  _polDokl record;
  _polSklad record;
  _idDoklad integer;
  _typPohybuK character varying;
  _typPohybuSklad character varying;
  _cenaMj numeric(19,6);
  _cenaMjPoriz numeric(19,6);
  _cenaMjTuz numeric(19,6);
  _mnozMj numeric(19,6);
  _sumZkl numeric(19,6);
  _sumZklMen numeric(19,6);
  _idDoklSklad integer;
  _idUcetObdobi integer;
  _idKarty integer;
  _sklad record;
  _kurz numeric(19,6);
  _prumCenaTuz numeric(19,6);
  _isCiziMena boolean;
  _typDoklK character varying;
  _idZklMdUcet integer;
  _idZklDalUcet integer;
  _idStredDoklSklad integer;
  _idCinnostDoklSklad integer;
  _idZakazkyDoklSklad integer;
  _kopStred boolean;
  _kopCinnost boolean;
  _kopZakazku boolean;
begin
  if(_modul like 'POK') then
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;
    select idDoklInt, typPohybuK into _idDoklad, _typPohybuK from dDoklInt where idDoklInt = _polDokl.idDoklInt;
    _typDoklK = null; -- pro pokladnu dobropisy nejsou
  else
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;
    select idDoklFak, typPohybuK into _idDoklad, _typPohybuK from dDoklFak where idDoklFak = _polDokl.idDoklFak;
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak);
  end if;

  select findparovanydoklsklad(_iddoklad, _modul, 'typVazbyDokl.hlavaSkl', true) into _idDoklSklad;
  
  if(_idDoklSklad is null) then
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad;
  end if;

  select * into _polSklad from dPolSklad where idPolSklad = _idPolSklad;
  select typPohybuK, idStred, idCinnost, idZakazky 
    into _typPohybuSklad, _idStredDoklSklad, _idCinnostDoklSklad, _idZakazkyDoklSklad
    from dDoklSklad where idDoklSklad = _polSklad.idDoklSklad; 

  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi;
  select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idskladu = _polDokl.idbspskl and iducetobdobi = _iducetobdobi;
  select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl;
  
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz;
  select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty;
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena;

  if(_typPohybuSklad like 'typPohybu.vydej') then
    -- vsechny dobropisy generuji prijemky
    --if(_typDoklK like 'typDokladu.dobropis') then
    --  _mnozMj = -_polDokl.mnozMj;
    --else
      _mnozMj = _polDokl.mnozMj;
    --end if;
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena
    _cenaMj = _polSklad.cenaMj;
    _cenaMjPoriz = _polSklad.cenaMjPoriz;
    _sumZkl = _polSklad.sumZkl;
    _sumZklMen = _polSklad.sumZklMen;
    -- nastaveni uctu pro polSklad vydej
    select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet;
    _idZklDalUcet = _sklad.idPrimUcet;
  else
    if(_typDoklK like 'typDokladu.dobropis' and _modul like 'FAV') then
      -- pokud se jedna o dobropis tak doplnuji nakupni ceny;
      _mnozMj = -_polDokl.mnozMj;
      _cenaMjTuz = _polDokl.cenaMjNakup; 
      if(_cenaMjTuz = 0.0) then
        _cenaMjTuz = (select nakupCena from ccenik where idCenik = _polDokl.idCenik);
        if(_cenaMj = 0.0) then
          _cenaMj = _polDokl.cenaMj * _kurz;
        end if;
      end if;
      _cenaMjPoriz = _cenaMjTuz / _kurz;
      _cenaMj = _polSklad.cenaMjNakl + _cenaMjPoriz;
      _sumZkl = _mnozMj * (_cenaMjTuz + (_polSklad.cenaMjNakl * _kurz));
      if(_isCiziMena) then
        _sumZklMen = _mnozMj * _cenaMj;
      else
        _sumZklMen = 0.0;
      end if;
    else
      -- pokud na sklad prijmam zkopiruji se ceny z faktury
      _mnozMj = _polDokl.mnozMj;
      _sumZkl = _polDokl.sumZkl;
      if(_mnozMj <> 0.0) then
        _cenaMjPoriz = _sumZkl / _mnozMj;
      else
        _cenaMjPoriz = _sumZkl;
      end if;
      _cenaMjPoriz = _cenaMjPoriz / _kurz;
      if(_isCiziMena) then
        if(_mnozMj <> 0.0) then
          _sumZklMen = (_cenaMjPoriz + _polSklad.cenaMjNakl) * _mnozMj;
        else
          _sumZklMen = (_cenaMjPoriz + _polSklad.cenaMjNakl);
        end if;
      else
        _sumZklMen = 0.0;  
      end if;
      _sumZkl = _sumZkl + (_polSklad.cenaMjNakl * _kurz * _mnozMj);
      _cenaMj = _cenaMjPoriz + _polSklad.cenaMjNakl;
    end if;
    -- nastaveni uctu pro polSklad prijem
    _idZklMdUcet = _sklad.idPrimUcet;
    _idZklDalUcet = _polDokl.idZklMdUcet;
  end if;

  if(_polSklad.cenaMj <> _cenaMj
    or _polSklad.cenaMjPoriz <> _cenaMjPoriz
    or _polSklad.sumZkl <> _sumZkl
    or _polSklad.sumZklMen <> _sumZklMen
    or not compareVarchar(_polSklad.nazev, _polDokl.nazev)
    or not compareVarchar(_polSklad.nazevA, _polDokl.nazevA)
    or not compareVarchar(_polSklad.nazevB, _polDokl.nazevB)
    or not compareVarchar(_polSklad.nazevC, _polDokl.nazevC)
    or not compareDate(_polSklad.datVyst, _polDokl.datVyst)
    or not compareDate(_polSklad.datUcto, _polDokl.datVyst)
    or not compareId(_polSklad.baleniId, _polDokl.baleniId)
    or not compareNumeric(_polSklad.mnozBaleni, _polDokl.mnozBaleni)
    or not compareVarchar(_polSklad.sarze, _polDokl.sarze)
    or not compareDate(_polSklad.expirace, _polDokl.expirace)
    or not compareDate(_polSklad.datTrvan, _polDokl.datTrvan)
    or not compareDate(_polSklad.datVyroby, _polDokl.datVyroby)
    or not compareId(_polSklad.cisRad, _polDokl.cisRad)
    or not compareVarchar(_polSklad.eankod, _polDokl.eanKod)
    or not compareId(_polSklad.idmj, _polDokl.idmj)
    or not compareId(_polSklad.idStred, _polDokl.idStred)
    or not compareId(_polSklad.idCinnost, _polDokl.idCinnost)
    or not compareId(_polSklad.idZakazky, _polDokl.idZakazky)
    or not compareId(_polSklad.idZklMdUcet, _idZklMdUcet)
    or not compareId(_polSklad.idZklDalUcet, _idZklDalUcet) )
  then
    _kopStred = _polSklad.kopStred;
    if(not compareId(_idStredDoklSklad, _polDokl.idStred)) then
      _kopStred = false;
    end if;
    _kopCinnost = _polSklad.kopCinnost;
    if(not compareId(_idCinnostDoklSklad, _polDokl.idCinnost)) then
      _kopCinnost = false;
    end if;
    _kopZakazku = _polSklad.kopZakazku;
    if(not compareId(_idZakazkyDoklSklad, _polDokl.idZakazky)) then
      _kopZakazku = false;
    end if;

    update dPolSklad set
      lastUpdate = LOCALTIMESTAMP,
      cenaMj = _cenaMj,
      cenaMjPoriz = _cenaMjPoriz,
      --mnozMj = _mnozMj,
      sumZkl = _sumZkl,
      sumZklMen = _sumZklMen,
      nazev = _polDokl.nazev,
      nazevA = _polDokl.nazevA,
      nazevB = _polDokl.nazevB,
      nazevC = _polDokl.nazevC,
      datVyst = _polDokl.datVyst,
      datUcto = _polDokl.datVyst,
      baleniId = _polDokl.baleniId,
      mnozBaleni = _polDokl.mnozBaleni,
      sarze = _polDokl.sarze,
      expirace = _polDokl.expirace,
      datTrvan = _polDokl.datTrvan,
      datVyroby = _polDokl.datVyroby,
      cisRad = _polDokl.cisRad,
      eankod = _polDokl.eanKod,
      idmj = _polDokl.idmj,
      idStred = _polDokl.idStred,
      kopStred = _kopStred,
      idCinnost = _polDokl.idCinnost,
      kopCinnost = _kopCinnost,
      idMeny = _polSklad.idMeny,
      idZakazky = _polDokl.idZakazky,
      kopZakazku = _kopZakazku, 
      --idZklMdUcet = _idZklMdUcet,
      --idZklDalUcet = _idZklDalUcet,
      ucetni = true
      where idPolSklad = _idPolSklad;
  end if;

  return _idPolSklad;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION fillPolSklad(integer, integer, character varying) OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION createPolSkladSada(_idPolDokl integer, _modul character varying)
  RETURNS void AS
$BODY$ 
declare
  _polDokl record;
  _doklad record;
  _polozkaSady record;
  _skladKarta record;
  _cenik record;
  _sklad record;
  _idDoklSklad integer;
  _idDoklad integer;
  _idMeny integer;
  _idUcetObdobi integer;
  _idKarty integer;
  _idPolSklad integer;
  _idZklMdUcet integer;
  _idZklDalUcet integer;
  _i integer;
  _cisRad integer;
  _typDoklK character varying;
  _mnozMj numeric(19,6);
  _sumZkl numeric(19,6);
  _sumZklMen numeric(19,6);
  _cenaMj numeric(19,6);
  _kurz numeric(19,6);
  _isCiziMena boolean;
  _nasobic integer;
  _idSkladu integer;
  _kopZklMdUcet boolean;
  _kopZklDalUcet boolean;
  _idTypUcOp integer;
  _kopStred boolean;
  _kopCinnost boolean;
  _kopZakazku boolean;
  _idStredDoklSklad integer;
  _idCinnostDoklSklad integer;
  _idZakazkyDoklSklad integer;
begin

  if(_modul like 'FAV' or _modul like 'FAP') then 
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl; 
    _idDoklad = _polDokl.idDoklFak;
    select * into _doklad from dDoklFak where idDoklFak = _idDoklad;
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak); 
  else 
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl; 
    _idDoklad = _polDokl.idDoklInt;
    select * into _doklad from dDoklInt where idDoklInt = _idDoklad;
    _typDoklK = null; -- pro pokladnu dobropisy nejsou 
  end if;

  select findparovanydoklsklad(_iddoklad, _modul, 'typVazbyDokl.hlavaSkl', true) into _idDoklSklad; 
  
  if(_idDoklSklad is null) then 
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad; 
    if(_idDoklSklad is null) then
      return;
    end if;
  end if;

  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz;
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena; 

  select idMeny, idTypUcOp, idstred, idcinnost, idZakazky
   into _idMeny, _idTypUcOp, _idStredDoklSklad, _idCinnostDoklSklad, _idZakazkyDoklSklad 
   from dDoklSklad where idDoklSklad = _idDoklSklad; 

  select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl;

  _i = 0;

  FOR _polozkaSady IN
    select * from cSady where idCenikSada = _polDokl.idCenik
  LOOP
    select * into _cenik from cCenik where idCenik = _polozkaSady.idCenik;

    if(_cenik.skladove) then
      _i = _i + 1;
      _cisRad = 100 * _polDokl.cisRad + _i;
  
      select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi; 

      _idSkladu = _polDokl.idBspSkl;

      select * into _skladKarta from skarty 
        where idSkladu = _idSkladu and idCenik = _polozkaSady.idCenik and idUcetObdobi = _idUcetObdobi;

      -- pokud neexistuje skladova karta pokusim se ji najit pomoci mapovani skladu
      if(_skladKarta is null) then
        select getPrefIdSkladu(_polDokl.idStred, _cenik.idSkupZboz, _cenik.idCenik) into _idSkladu;
        select * into _skladKarta from skarty
          where idSkladu = _idSkladu and idCenik = _cenik.idCenik and idUcetObdobi = _idUcetObdobi;
        if(_skladKarta is null) then
          -- pokud ani podle mapovani skladu se skladova karta nenajde tak vyhazuju vyjimku
          raise exception '0007:Skladová karta neexistuje pro ceník % a sklad % a nebo je špatně nastaveno mapovaní skladu.', _cenik.nazev, _sklad.nazev;
        end if;
      else
        _idSkladu = _skladKarta.idSkladu;
      end if;
      _nasobic = 1;
      if(_typDoklK like 'typDokladu.dobropis') then
        _nasobic = -1;
      end if;
      _mnozMj = _polozkaSady.mnozMj * _polDokl.mnozMj * _nasobic;
      _cenaMj = _skladKarta.prumCenaTuz / _kurz;
      _sumZkl = _mnozMj * _skladKarta.prumCenaTuz;
      if(_isCiziMena) then 
        _sumZklMen = _mnozMj * _cenaMj; 
      else 
        _sumZklMen = 0.0; 
      end if;
    
      -- nastaveni uctu pro polSklad vydej 
      _kopZklMdUcet = false;
      _kopZklDalUcet = false;
      if(_typDoklK like 'typDokladu.dobropis') then
        -- dal ucet je ze skupiny zbozi nebo z hlavicky pokud neni ve skupine zbozi nastaven
        select idProtiUcetSklV into _idZklDalUcet from cSkupZboz where idSkupZboz = _cenik.idSkupZboz;
        if(_idZklDalUcet is null) then
          select idProtiUcet into _idZklDalUcet from dDoklSklad where idDoklSklad = _idDoklSklad;
          --pokud je z hlavicky tak se bude kopirovat
          _kopZklDalUcet = true;
        end if;
        -- md ucet musi byt primarni ucet skladu ze ktereho se kousky sady vydavaji
        select idPrimUcet into _idZklMdUcet from dBsp where idBsp = _idSkladu;
      else
        -- md ucet je ze skupiny zbozi nebo z hlavicky pokud neni ve skupine zbozi nastaven
        select idProtiUcetSklV into _idZklMdUcet from cSkupZboz where idSkupZboz = _cenik.idSkupZboz;
        if(_idZklMdUcet is null) then
          select idProtiUcet into _idZklMdUcet from dDoklSklad where idDoklSklad = _idDoklSklad;
          --pokud je z hlavicky tak se bude kopirovat
          _kopZklMdUcet = true;
        end if;
        -- dal ucet musi byt primarni ucet skladu ze ktereho se kousky sady vydavaji
        select idPrimUcet into _idZklDalUcet from dBsp where idBsp = _idSkladu;
      end if; 
 
      _kopStred = true;
      if(not compareId(_idStredDoklSklad, _polDokl.idStred)) then
        _kopStred = false;
      end if;
      _kopCinnost = true;
      if(not compareId(_idCinnostDoklSklad, _polDokl.idCinnost)) then
        _kopCinnost = false;
      end if;
      _kopZakazku = true;
      if(not compareId(_idZakazkyDoklSklad, _polDokl.idZakazky)) then
        _kopZakazku = false;
      end if;

      select nextval('seq_dpolsklad') into _idPolSklad;
      insert into dpolsklad(idPolSklad, lastUpdate, idcenik, idBspSkl, idkarty, datVyst, datSklad, datUcto, modul, typPolozkyK, idDoklSklad,
          mnozMj, cenaMj, cenaMjPoriz, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni, idmj,
          nazev, nazevA, nazevB, nazevC, sarze, expirace, datTrvan, datVyroby, cisRad, ucetni,  
          idStred, kopStred, idZakazky, kopZakazku, idMeny, zdrojProFak, idCinnost, kopCinnost, idTypUcOp)
        values (_idPolSklad, LOCALTIMESTAMP, _polozkaSady.idcenik, _idSkladu, _skladKarta.idKarty, _polDokl.datVyst, LOCALTIMESTAMP, _polDokl.datVyst, 'SKL', 'typPolozky.katalog', _idDoklSklad,    
          _mnozMj, _cenaMj, _cenaMj, _sumZkl, _sumZklMen, _idZklMdUcet, _idZklDalUcet, _kopZklMdUcet, _kopZklDalUcet, _polDokl.baleniid, 0.0, _cenik.idmj1,
          _cenik.nazev, _cenik.nazevA, _cenik.nazevB, _cenik.nazevC, null, null, _polDokl.datTrvan, _polDokl.datVyroby, _cisRad, true,  
          _polDokl.idStred, _kopStred, _polDokl.idZakazky, _kopZakazku, _idMeny, false, _polDokl.idCinnost, _kopCinnost, _idTypUcOp);

      insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK)  
        values (0.0, _idPolDokl, _idPolSklad, _modul, 'SKL', false, 'typVazbyDokl.polozkaSklSada');  
    end if; 
  END LOOP; 

  execute sprepoctiSumyDokladu(_idDoklSklad); 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION createPolSkladSada(integer, character varying) OWNER TO %firmaRole%;

--drop function createPolSklad(integer, character varying);
CREATE OR REPLACE FUNCTION createPolSklad(_idPolDokl integer, _modul character varying) RETURNS integer AS
$BODY$
declare
  _idDoklSklad integer;
  _idDoklad integer;
  _polDokl record;
  _iducetobdobi integer;
  _idkarty integer;
  _idPolSklad integer;
  _cenaMj numeric(19,6);
  _cenaMjTuz numeric(19,6);
  _typPohybuK character varying;
  _prumCenaTuz numeric(19,6);
  _sumZkl numeric(19,6);
  _sumZklMen numeric(19,6);
  _kurz numeric(19,6);
  _idZklMdUcet integer;
  _idZklDalUcet integer;
  _kopZklMdUcet boolean;
  _kopZklDalUcet boolean;
  _sklad record;
  _typDoklK character varying;
  _mnozMj numeric(19,6);
  _isCiziMena boolean;
  _idMeny integer;  
  _skupZboz record;
  _idTypUcOp integer;
  _kopStred boolean;
  _kopCinnost boolean;
  _kopZakazku boolean;
  _idStredDoklSklad integer;
  _idCinnostDoklSklad integer;
  _idZakazkyDoklSklad integer;
begin
  _kopZklMdUcet =false;
  _kopZklDalUcet = false;
  if(_modul like 'FAV' or _modul like 'FAP') then
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;
    _idDoklad = _polDokl.idDoklFak;
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak);
  else
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;
    _idDoklad = _polDokl.idDoklInt;
    _typDoklK = null; -- pro pokladnu dobropisy nejsou
  end if;

  select findparovanydoklsklad(_iddoklad, _modul, 'typVazbyDokl.hlavaSkl', true) into _idDoklSklad; 
  
  if(_idDoklSklad is null) then
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad;
    if(_idDoklSklad is null) then
      return null;
    end if;
  end if;

  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi;
  select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idskladu = _polDokl.idbspskl and iducetobdobi = _iducetobdobi;
  select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl;
  
  select typPohybuK, idstred, idcinnost, idZakazky
    into _typPohybuK, _idStredDoklSklad, _idCinnostDoklSklad, _idZakazkyDoklSklad
    from dDoklSklad where idDoklSklad = _idDoklSklad; 
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz;
  select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty;
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena;
  select idMeny, idTypUcOp into _idMeny, _idTypUcOp from dDoklSklad where idDoklSklad = _idDoklSklad;
      
  if(_typPohybuK like 'typPohybu.vydej') then
    -- vsechny dobropisy generuji prijemky
    --if(_typDoklK like 'typDokladu.dobropis') then
    --  _mnozMj = -_polDokl.mnozMj;
    --else
      _mnozMj = _polDokl.mnozMj;
    --end if;
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena
    _cenaMj = _prumCenaTuz / _kurz;
    _sumZkl = _prumCenaTuz * _mnozMj;
    if(_isCiziMena) then
      _sumZklMen = _mnozMj * _cenaMj;
    else
      _sumZklMen = 0.0;
    end if;
    -- nastaveni uctu pro polSklad vydej
    select * into _skupZboz from cskupzboz where idskupzboz = (select idskupzboz from ccenik where idcenik = _polDokl.idCenik);
    if(_skupZboz.idProtiUcetSklV is not null) then
      -- pokud je ve skupine zbozi nastaven protiucet pro vydej ze skladu pouzije se ten a kopirovani se necha na false;
      _idZklMdUcet = _skupZboz.idProtiUcetSklV;
    else
      -- pokud neni ve skupine zbozi nastaven protiucet tak vemu protiucet z hlavicky a dam kopirovat na true
      select idProtiUcet into _idZklMdUcet from dDoklSklad where idDoklSklad = _idDoklSklad;
      _kopZklMdUcet = true;
    end if;
    _idZklDalUcet = _sklad.idPrimUcet;
  else
    if(_typDoklK like 'typDokladu.dobropis' and _modul like 'FAV') then
      -- pokud se jedna o dobropis tak doplnuji nakupni ceny;
      _mnozMj = -_polDokl.mnozMj;
      --_cenaMjTuz = _prumCenaTuz;
      _cenaMjTuz = _polDokl.cenaMjNakup;
      if(_cenaMjTuz = 0.0) then
        _cenaMjTuz = (select nakupCena from ccenik where idCenik = _polDokl.idCenik);
        if(_cenaMj = 0.0) then
          _cenaMj = _polDokl.cenaMj * _kurz;
        end if;
      end if;
      _cenaMj = _cenaMjTuz / _kurz;
      _sumZkl = _mnozMj * _cenaMjTuz;
      if(_isCiziMena) then
        _sumZklMen = _mnozMj * _cenaMj;
      else
        _sumZklMen = 0.0;
      end if;
      select * into _skupZboz from cskupzboz where idskupzboz = (select idskupzboz from ccenik where idcenik = _polDokl.idCenik);
      if(_skupZboz.idProtiUcetSklV is not null) then
        -- pokud je ve skupine zbozi nastaven protiucet pro vydej ze skladu pouzije se ten a kopirovani se necha na false;
        _idZklDalUcet = _skupZboz.idProtiUcetSklV;
      else
        -- pokud neni ve skupine zbozi nastaven protiucet tak vemu protiucet z hlavicky a dam kopirovat na true
        select idProtiUcet into _idZklDalUcet from dDoklSklad where idDoklSklad = _idDoklSklad;
        _kopZklDalUcet = true;
      end if;
    else
      -- pokud na sklad prijmam zkopiruji se ceny z faktury
      _mnozMj = _polDokl.mnozMj;
      _sumZkl = _polDokl.sumZkl;
      if(_mnozMj <> 0.0) then
        _cenaMj = _sumZkl / _mnozMj;
      else
        _cenaMj = _sumZkl;
      end if;
      _cenaMj = _cenaMj / _kurz;
      if(_isCiziMena) then
        if(_mnozMj <> 0.0) then
          _sumZklMen = _cenaMj * _mnozMj;  
        else
          _sumZklMen = _cenaMj;
        end if;
      else
        _sumZklMen = 0.0;  
      end if;
      _idZklDalUcet = _polDokl.idZklMdUcet;
    end if;
    -- nastaveni uctu pro polSklad prijem
    _idZklMdUcet = _sklad.idPrimUcet;
  end if; 

  _kopStred = true;
  if(not compareId(_idStredDoklSklad, _polDokl.idStred)) then
    _kopStred = false;
  end if;
  _kopCinnost = true;
  if(not compareId(_idCinnostDoklSklad, _polDokl.idCinnost)) then
    _kopCinnost = false;
  end if;
  _kopZakazku = true;
  if(not compareId(_idZakazkyDoklSklad, _polDokl.idZakazky)) then
    _kopZakazku = false;
  end if;
  
  select nextval('seq_dpolsklad') into _idPolSklad;  
  insert into dpolsklad(idPolSklad, lastUpdate, idcenik, idbspskl, idkarty, datVyst, datSklad, datUcto, modul, typPolozkyK, idDoklSklad,
        mnozMj, cenaMj, cenaMjPoriz, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni, idmj,
        nazev, nazevA, nazevB, nazevC, sarze, expirace, datTrvan, datVyroby, cisRad, ucetni, 
        idStred, kopStred, idZakazky, kopZakazku, idMeny, zdrojProFak, idCinnost, kopCinnost, idTypUcOp)
      values (_idPolSklad, LOCALTIMESTAMP, _polDokl.idcenik, _polDokl.idbspskl, _idkarty, _polDokl.datVyst, LOCALTIMESTAMP, _polDokl.datVyst, 'SKL', 'typPolozky.katalog', _idDoklSklad,
        _mnozMj, _cenaMj, _cenaMj, _sumZkl, _sumZklMen, _idZklMdUcet, _idZklDalUcet, _kopZklMdUcet, _kopZklDalUcet, _polDokl.baleniid, _polDokl.mnozBaleni, _polDokl.idmj,
        _polDokl.nazev, _polDokl.nazevA, _polDokl.nazevB, _polDokl.nazevC, _polDokl.sarze, _polDokl.expirace, _polDokl.datTrvan, _polDokl.datVyroby, _polDokl.cisRad, true, 
        _polDokl.idStred, _kopStred, _polDokl.idZakazky, _kopZakazku, _idMeny, false, _polDokl.idCinnost, _kopCinnost, _idTypUcOp);
 
  insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK)
       values (0.0, _idPolDokl, _idPolSklad, _modul, 'SKL', false, 'typVazbyDokl.polozkaSkl');

  -- prepocteni sum na dokladu
  execute sprepoctiSumyDokladu(_idDoklSklad);

  return _idPolSklad;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION createPolSklad(integer, character varying) OWNER TO %firmaRole%;


--------------------------------------------------------------------------------


DROP VIEW dpolskladf;
DROP VIEW dpolskladfbezvc;
DROP VIEW dpolskladdoklad;


CREATE OR REPLACE VIEW dpolskladdoklad AS
 SELECT p.idpolsklad, p.lastupdate, p.autozaokr, p.autogen, p.baleniid, p.cenjednotka, p.cenamj,
   p.cenamjnakup, p.cenamjprodej, p.cisrad, p.datucto, p.datvyst, p.datsklad, p.dattrvan, p.datvyroby, p.eankod, p.expirace, 
   p.kod, p.kopclendph, p.kopdphdalucet, p.kopdphmducet, p.kopklice, p.kopstred, p.kopzakazku, p.kopzkldalucet,
   p.kopzklmducet, p.mnozbaleni, p.mnozmj, p.mnozmjplan, p.mnozmjreal, p.modul, p.nazev, p.objednatk, p.objem,
   p.poznam, p.proczakl, p.rezervovat, p.sarze, p.slevadokl, p.slevamnoz, p.slevapol, p.stavuzivk,
   p.storno, p.stornopol, p.sumdph, p.sumdphmen, p.sumzkl, p.sumzklmen, p.szbdph, p.typcenydphk, p.typpolozkyk,
   p.typszbdphk, p.typvypcenyk, p.ucetni, p.uplslevadokl, p.zaokrjakk, p.zaokrnak,
   p.idzkldalucet, p.iddphdalucet, p.idmjobjem, p.idmeny, p.idstred, p.idkarty, p.idcenik, p.idzklmducet, p.iddphmducet,
   p.idsazbydph, p.idclendph, p.idzakazky, p.idmj, p.iddoklsklad, p.idbspskl as idskladu, p.idfirmy, d.typpohybuk
   FROM dpolsklad p
   LEFT JOIN ddoklsklad d ON p.iddoklsklad = d.iddoklsklad;

ALTER TABLE dpolskladdoklad OWNER TO %firmaRole%;


CREATE OR REPLACE VIEW dpolskladf AS 
         SELECT p.idpolsklad, 
                CASE
                    WHEN p.typpohybuk::text = 'typPohybu.prijem'::text THEN p.mnozmj - jevydano(p.idpolsklad)
                    ELSE (- p.mnozmj) - jevydano(p.idpolsklad)
                END AS pocet, p.cenamj, p.datvyst, p.datsklad, p.dattrvan, p.datvyroby, p.expirace, p.idzakazky, p.idskladu, p.idcenik, p.sarze, NULL::integer AS idvyrobnicislo, c.evidvyrcis, p.typpohybuk
           FROM dpolskladdoklad p
      JOIN ccenik c ON c.idcenik = p.idcenik
     WHERE (p.typpohybuk::text = 'typPohybu.prijem'::text AND p.mnozmj >= 0.0 AND (p.mnozmj - jevydano(p.idpolsklad)) > 0::numeric OR p.typpohybuk::text = 'typPohybu.vydej'::text AND p.mnozmj < 0.0 AND ((- p.mnozmj) - jevydano(p.idpolsklad)) > 0::numeric) AND c.evidvyrcis = false AND p.storno <> true
UNION ALL 
         SELECT p.idpolsklad, 1 AS pocet, p.cenamj, p.datvyst, p.datsklad, p.dattrvan, p.datvyroby, p.expirace, p.idzakazky, p.idskladu, p.idcenik, p.sarze, v.idvyrobnicislo, c.evidvyrcis, p.typpohybuk
           FROM svyrobnicislo v
      JOIN dpolskladdoklad p ON p.idpolsklad = v.idpolskladprijem
   JOIN ccenik c ON c.idcenik = p.idcenik
  WHERE p.typpohybuk::text = 'typPohybu.prijem'::text AND c.evidvyrcis = true AND NOT (v.idvyrobnicislo IN ( SELECT sfifovazby.idvyrobnicislo
         FROM sfifovazby
        WHERE sfifovazby.idpolskladprijem = p.idpolsklad)) AND p.storno <> true;

ALTER TABLE dpolskladf OWNER TO %firmaRole%;


CREATE OR REPLACE VIEW dpolskladfbezvc AS 
 SELECT p.idpolsklad, 
        CASE
            WHEN p.typpohybuk::text = 'typPohybu.prijem'::text THEN p.mnozmj - jevydano(p.idpolsklad)
            ELSE (- p.mnozmj) - jevydano(p.idpolsklad)
        END AS pocet, p.cenamj, p.datvyst, p.datsklad, p.dattrvan, p.datvyroby, p.expirace, p.idzakazky, p.idskladu, p.idcenik, p.sarze, NULL::integer AS idvyrobnicislo, false AS evidvyrcis, p.typpohybuk
   FROM dpolskladdoklad p
  WHERE (p.typpohybuk::text = 'typPohybu.prijem'::text AND p.mnozmj >= 0.0 AND (p.mnozmj - jevydano(p.idpolsklad)) > 0::numeric OR p.typpohybuk::text = 'typPohybu.vydej'::text AND p.mnozmj < 0.0 AND ((- p.mnozmj) - jevydano(p.idpolsklad)) > 0::numeric) AND p.storno <> true;

ALTER TABLE dpolskladfBezVC OWNER TO %firmaRole%;


--------------------------------------------------------------------------------


DROP FUNCTION skladfindcenamjnakup(numeric, integer, integer, date, character varying, date, integer, integer);

-- Function: skladfindcenamjnakup
-- DROP FUNCTION skladfindcenamjnakup(numeric, integer, integer, date, character varying, date, date, integer, integer);
CREATE OR REPLACE FUNCTION skladfindcenamjnakup(i_mnozmj numeric, i_idcenik integer, i_idskladu integer, i_datum date, i_sarze character varying, i_expirace date, i_dattrvan date, i_idvyrobnihocisla integer, i_idstred integer)
  RETURNS numeric AS
$BODY$
declare
  _sklfifo boolean;
  _mazatTmpTable boolean;
  _idkarty integer;
  _rozsirenaPolozka record;
  _iducetobdobi integer;
  _result numeric(19,6);
  _pomocDPolSkladF record;
  _mnozstvi numeric(19,6);
  _potrebnyPocet numeric(19,6);
  _sadaItemCount integer;
  _polozkaSady record;
  _pomoc numeric(19,6);

  _sumSumZkl numeric(19,6);
  _sumMnozMj numeric(19,6);
  _sumTuz numeric(19,6);
  _mnozMj numeric(19,6);
  _typPohybuK character varying;
  _karta record;
  _idskupzboz integer;
  _idSkladuPref integer;
  _cenik record;
  _sklad record;
  _query character varying;
begin
  _result = 0.0;
  _mnozstvi = 0.0;

  if(i_mnozMj > 0) then
    select count(*) into _sadaItemCount from csady where idceniksada = i_idcenik;
    if(_sadaItemCount > 0) then
      FOR _polozkaSady IN (select * from cSady where idCenikSada = i_idcenik) LOOP
        -- TODO doresit sarze expirace a vyrobni cisla
        select skladfindcenamjnakup(i_mnozmj * _polozkaSady.mnozMj, _polozkaSady.idcenik, i_idskladu, i_datum, null, null, null, null, i_idstred) into _pomoc;
        _result = _result + (_pomoc * _polozkaSady.mnozMj);
      end loop;
    else
      select findiducetniobdobikdatu(i_datum) into _iducetobdobi;
      _sklfifo := (select isfifosklad(i_datum));
      if (_sklfifo) then
        if(i_idvyrobnihocisla is not null and i_idvyrobnihocisla > 0) then
          -- pokud je zadano vyrobni cislo ma nejvetsi prioritu
          select cenaMj into _result from dpolsklad where idpolsklad = (select idpolskladprijem from svyrobnicislo where idvyrobnicislo = i_idvyrobnihocisla);
        else
          _query = 'select * from dpolskladf' ||
              ' where idcenik = ''' || i_idcenik || '''' ||
              ' and idSkladu = ''' || i_idSkladu || '''';
             
           if (i_sarze is not null) then
             _query = _query ||
                 ' and sarze = ''' || i_sarze || '''';
           end if;
           if (i_expirace is not null) then
             _query = _query ||
                 ' and expirace = ''' || i_expirace || '''';
           end if;
           if (i_dattrvan is not null) then
             _query = _query ||
                 ' and dattrvan = ''' || i_dattrvan || '''';
           end if;

          _query = _query ||
              ' order by datSklad,idpolsklad';

          for _pomocDPolSkladF in execute _query loop
            if (i_mnozMj > _mnozstvi) then
              _potrebnyPocet = _pomocDPolSkladF.pocet;
              if ((_mnozstvi + _potrebnyPocet) > i_mnozMj) then
                _potrebnyPocet = i_mnozMj - _mnozstvi;
              end if;
              _mnozstvi = _mnozstvi + _potrebnyPocet;
              _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMj;
            end if;
          end loop;
          if(_mnozstvi != 0.0) then
            _result = _result / _mnozstvi;
          else
            _result = 0.0;
          end if;
        end if;
      else
        -- generuji rozsirene polozky
        select * into _karta from skarty where idcenik = i_idcenik and idskladu = i_idskladu and iducetobdobi = _iducetobdobi;
        -- pokud neexistuje skladova karta pokusim se ji najit pomoci mapovani skladu
        if(_karta is null) then
          select idskupzboz into _idskupzboz from ccenik where idcenik = i_idcenik;
          select getPrefIdSkladu(i_idstred, _idskupzboz, i_idcenik) into _idSkladuPref;
          select * into _karta from skarty
            where idSkladu = _idSkladuPref and idCenik = i_idCenik and idUcetObdobi = _idUcetObdobi;
          if(_karta is null) then
            -- pokud ani podle mapovani skladu se skladova karta nenajde tak vyhazuju vyjimku
            select * into _cenik from ccenik where idCenik = i_idcenik;
            select * into _sklad from dbsp where idBsp = i_idSkladu;
            raise exception '0007:Skladová karta neexistuje pro ceník % a sklad % a nebo je špatně nastaveno mapovaní skladu.', _cenik.nazev, _sklad.nazev;
          end if;
        end if;

	if(_karta is null) then
	  raise exception 'Nenalezena sklad karta';
	end if;
        _sumTuz = 0.0;
        _mnozMj = 0.0;

        _sumTuz = _karta.stavTuz - _sumTuz;
        _mnozMj = _karta.stavMj - _mnozMj;
        if(_mnozMj = 0.0) then
          _result = 0.0;
        else
          _result = _sumTuz / _mnozMj;
        end if;
      end if;
    end if;
  end if;
  return _result;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladfindcenamjnakup(numeric, integer, integer, date, character varying, date, date, integer, integer) OWNER TO %firmaRole%;


--------------------------------------------------------------------------------


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 640, 't', %appVersion%, clock_timestamp());
