--------------------------------------------------------------------------------
-- Bug 31160 – [WinStrom] - Evidence odpadu EkoKom
--------------------------------------------------------------------------------

create sequence seq_cekokom
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
alter table public.seq_cekokom owner to %firmaRole%;

create table cEkoKom(
    idEkoKom integer default nextval('seq_cekokom'::regclass) not null,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,

    hmotnost numeric(16,6),
    mjHmotK character varying(50),
    typObaluK character varying(50),
    typVznikuK character varying(50),
    typPouzitiK character varying(50),
    materialK character varying(50),

    idcenik integer,

    CONSTRAINT cekokom_pkey PRIMARY KEY (idEkoKom),
    CONSTRAINT cekokom_idcenik FOREIGN KEY (idcenik)
      REFERENCES ccenik (idcenik)
      ON UPDATE NO ACTION ON DELETE cascade
);
alter table cekokom owner to %firmaRole%;

CREATE INDEX cEkoKom_IdCenik_index ON cEkoKom USING btree (IdCenik);

ALTER TABLE dtypdokl
    ADD COLUMN ekokomk character varying(50);

ALTER TABLE ddoklfak
    ADD COLUMN ekokomk character varying(50);
ALTER TABLE dpolfak
    ADD COLUMN ekokomk character varying(50),
    ADD COLUMN kopekokom boolean DEFAULT true NOT NULL;

ALTER TABLE ddoklint
    ADD COLUMN ekokomk character varying(50);
ALTER TABLE dpolint
    ADD COLUMN ekokomk character varying(50),
    ADD COLUMN kopekokom boolean DEFAULT true NOT NULL;

ALTER TABLE ddoklobch
    ADD COLUMN ekokomk character varying(50);
ALTER TABLE dpolobch
    ADD COLUMN ekokomk character varying(50),
    ADD COLUMN kopekokom boolean DEFAULT true NOT NULL;

ALTER TABLE ddoklsklad
    ADD COLUMN ekokomk character varying(50);
ALTER TABLE dpolsklad
    ADD COLUMN ekokomk character varying(50),
    ADD COLUMN kopekokom boolean DEFAULT true NOT NULL;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 686, 't', %appVersion%, clock_timestamp());
