drop view dpolskladf;
drop view dpolskladdoklad;

alter table dpolfak alter column sarze type varchar(255);
alter table dpolfak drop column expirace;
alter table dpolfak add column expirace date;

alter table dpolint alter column sarze type varchar(255);
alter table dpolint drop column expirace;
alter table dpolint add column expirace date;

alter table dpolobch alter column sarze type varchar(255);
alter table dpolobch drop column expirace;
alter table dpolobch add column expirace date;

alter table dpolsklad alter column sarze type varchar(255);
alter table dpolsklad drop column expirace;
alter table dpolsklad add column expirace date;

-- View: dpolskladdoklad
-- DROP VIEW dpolskladdoklad;
CREATE OR REPLACE VIEW dpolskladdoklad AS 
 SELECT p.idpolsklad, p.lastupdate, p.autozaokr, p.autogen, p.baleniid, p.cenjednotka, p.cenamj, p.cenamjnakup, p.cenamjprodej, p.cisrad, p.datucto, p.datvyst, p.eankod, p.expirace, p.kod, p.kopclendph, p.kopdphdalucet, p.kopdphmducet, p.kopklice, p.kopstred, p.kopzakazku, p.kopzkldalucet, p.kopzklmducet, p.mnozbaleni, p.mnozmj, p.mnozmjplan, p.mnozmjreal, p.modul, p.nazev, p.objednatk, p.objem, p.poznam, p.proczakl, p.rezervovat, p.sarze, p.slevadokl, p.slevamnoz, p.slevapol, p.stavuzivk, p.storno, p.stornopol, p.sumdph, p.sumdphmen, p.sumzkl, p.sumzklmen, p.szbdph, p.typcenydphk, p.typpolozkyk, p.typszbdphk, p.typvypcenyk, p.ucetni, p.uplslevadokl, p.vyrcis, p.zaokrjakk, p.zaokrnak, p.idzkldalucet, p.iddphdalucet, p.idmjobjem, p.idmeny, p.idstred, p.idkarty, p.idcenik, p.idzklmducet, p.iddphmducet, p.idsazbydph, p.idclendph, p.idzakazky, p.idmj, p.iddoklsklad, p.idskladu, p.idfirmy, d.typpohybuk
   FROM dpolsklad p
   LEFT JOIN ddoklsklad d ON p.iddoklsklad = d.iddoklsklad;

ALTER TABLE dpolskladdoklad OWNER TO %firmaRole%;

-- View: dpolskladf
-- DROP VIEW dpolskladf;
CREATE OR REPLACE VIEW dpolskladf AS 
 SELECT p.idpolsklad, p.mnozmj - jevydano(p.idpolsklad) AS pocet, p.cenamj, p.datvyst, p.expirace, p.idzakazky, p.idskladu, p.idcenik, p.sarze, (-1) AS idvyrobnicislo, ( SELECT c.evidvyrcis
           FROM ccenik c
          WHERE c.idcenik = p.idcenik) AS evidvyrcis
   FROM dpolskladdoklad p
  WHERE p.typpohybuk::text = 'typPohybu.prijem'::text AND (p.mnozmj - jevydano(p.idpolsklad)) > 0::numeric AND (( SELECT c.evidvyrcis
           FROM ccenik c
          WHERE c.idcenik = p.idcenik)) = false AND p.storno <> true
UNION ALL 
 SELECT p.idpolsklad, 1 AS pocet, p.cenamj, p.datvyst, p.expirace, p.idzakazky, p.idskladu, p.idcenik, p.sarze, v.idvyrobnicislo, ( SELECT c.evidvyrcis
           FROM ccenik c
          WHERE c.idcenik = p.idcenik) AS evidvyrcis
   FROM svyrobnicislo v
   LEFT JOIN dpolskladdoklad p ON p.idpolsklad = v.idpolsklad
  WHERE p.typpohybuk::text = 'typPohybu.prijem'::text AND (( SELECT c.evidvyrcis
      FROM ccenik c
     WHERE c.idcenik = p.idcenik)) = true AND NOT (v.idvyrobnicislo IN ( SELECT sfifovazby.idvyrobnicislo
      FROM sfifovazby
     WHERE sfifovazby.idpolskladprijem = p.idpolsklad)) AND p.storno <> true;

ALTER TABLE dpolskladf OWNER TO %firmaRole%;

-- Function: sfifovydej(integer, integer, integer, integer, numeric)
-- DROP FUNCTION sfifovydej(integer, integer, integer, integer, numeric);
CREATE OR REPLACE FUNCTION sfifovydej(idvydej integer, idcenikvydej integer, idskladvydej integer, idkartyvydej integer, vyd numeric)
  RETURNS void AS
$BODY$     
declare     
	_zaznam Record;     
         _vybrano numeric(19,6);   
         _i integer;   
         _novevydcelkem numeric(19,6);   
         _pocet numeric(19,6);   
         _cenamjP numeric(19,6);  
	 _kurzDokladuP numeric(19,6); 
	 _kurzDokladuV numeric(19,6); 
	 _idDoklSkladP integer;  
         _idDoklSkladV integer; 
         _datVystV date; 
         _idrozlozeni integer;   
         _vydexpir boolean;   
         _vyrcis character varying(255);   
         _sklfifo boolean;
         _sarze character varying(255);     
begin     
  _vybrano := 0;   
  _i := 1;   
  _novevydcelkem := vyd;   
  if (idvydej>0) then   
           select vydexpir into _vydexpir from skarty where idkarty=idkartyvydej limit 1;
           select sarze into _sarze from dpolsklad where idpolsklad = idvydej;   
           if (not _vydexpir) then   
                    --pořadí výdeje dle datvyst (dále se bude řeit upřednostněný výdej mimo FIFO)   
	           for _zaznam in select * from dPolSkladF where idCenik=idCenikVydej and idSkladu=idSkladVydej order by datVyst,idpolsklad loop     
                      if(_sarze is null or _sarze = '' or _sarze = _zaznam.sarze) then
	                  if (_vybrano<_novevydcelkem) then   
	                   _pocet := _zaznam.pocet;   
	                   if( _vybrano+_pocet) > _novevydcelkem then   
	                     _pocet := _novevydcelkem-_vybrano;   
	                   end if;   
	                   _vybrano := _vybrano+_pocet;   
                            --pokud je výrobní číslo, tak jeho kód zaznamenám na výdejku (otázka je, zda tam nedat rovnou idvyrobnicislo   
                            _vyrcis := '';   
                            if (_zaznam.idvyrobnicislo>0) then   
                            	select kod into _vyrcis from svyrobnicislo where idvyrobnicislo = _zaznam.idvyrobnicislo;   
                            end if;   
                            --   
	                   if (_i = 1) then   
	                     insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, _pocet,_zaznam.idvyrobnicislo) ;   
                             _sklfifo := (select isfifosklad(_zaznam.datvyst));   
                             if (_sklfifo) then   
	                       select cenamj, idDoklSklad  into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);   
	                       select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);  
			       if (_kurzDokladuP <> 0.0) then  
	                         _cenamjP := _cenamjP * _kurzDokladuP;   
	                       end if; 
	                       select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = idvydej; 
	                       _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV)); 
	                       _cenamjP := _cenamjP / _kurzDokladuV; 
	                       update dpolsklad set mnozmj = _pocet,cenamj = _cenamjP, sumzkl = _pocet*_cenamjP*_kurzDokladuV, vyrcis=_vyrcis  where idpolsklad = idvydej;   
                             end if;   
	                   else   
                             _sklfifo := (select isfifosklad(_zaznam.datvyst));   
                             if (_sklfifo) then   
	                       select nextval('seq_dpolsklad') into _idrozlozeni;   
	                       select cenamj, idDoklSklad into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);  
			       select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);  
			       if (_kurzDokladuP <> 0.0) then  
	                         _cenamjP := _cenamjP * _kurzDokladuP;   
	                       end if;  
	                       select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = idvydej; 
	                       _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV)); 
	                       _cenamjP := _cenamjP / _kurzDokladuV; 
	                       insert into dpolsklad(idpolsklad,mnozmj,autozaokr,autogen,baleniid,cenjednotka,cenamj,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,sumzkl,sumzklmen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idskladu,idfirmy,vyrcis)    
	                                          (select (-1*_idrozlozeni),_pocet,autozaokr,autogen,baleniid,cenjednotka,_cenamjP,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,_pocet*_cenamjP,sumzklmen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idskladu,idfirmy,_vyrcis from dpolsklad where idpolsklad=idVydej);   
	                       --   
	                       insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,_idrozlozeni,_pocet,_zaznam.idvyrobnicislo);   
                               insert into svazbypolsklad(idpolskladzdroj,idpolskladcil) values (idvydej, _idrozlozeni);   
                             else   
                               insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,idvydej,_pocet,_zaznam.idvyrobnicislo);   
                             end if;   
	                   end if;   
	                   --   
	                   _i:=_i+1;   
	                  end if;
                      end if;   
	           end loop;   
           else   
                    --pořadí výdeje dle expirace (dále se bude řeit upřednostněný výdej mimo FIFO)   
	           for _zaznam in select * from dPolSkladF where idCenik=idCenikVydej and idSkladu=idSkladVydej order by expirace, idpolsklad loop     
                      if(_sarze is null or _sarze = '' or _sarze = _zaznam.sarze) then
	                  if (_vybrano<_novevydcelkem) then   
	                   _pocet := _zaznam.pocet;   
	                   if( _vybrano+_pocet) > _novevydcelkem then   
	                     _pocet := _novevydcelkem-_vybrano;   
	                   end if;   
	                   _vybrano := _vybrano+_pocet;   
                            --pokud je výrobní číslo, tak jeho kód zaznamenám na výdejku (otázka je, zda tam nedat rovnou idvyrobnicislo   
                            _vyrcis := '';   
                            if (_zaznam.idvyrobnicislo>0) then   
                            	select kod into _vyrcis from svyrobnicislo where idvyrobnicislo = _zaznam.idvyrobnicislo;   
                            end if;   
                            --   
	                   if (_i = 1) then   
	                     insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, _pocet,_zaznam.idvyrobnicislo) ;   
                             _sklfifo := (select isfifosklad(_zaznam.datvyst));   
                             if (_sklfifo) then   
	                       select cenamj, idDoklSklad  into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);   
	                       select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);  
			       if (_kurzDokladuP <> 0.0) then  
	                         _cenamjP := _cenamjP * _kurzDokladuP;   
	                       end if; 
	                       select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = idvydej; 
	                       _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV)); 
	                       _cenamjP := _cenamjP / _kurzDokladuV; 
	                       update dpolsklad set mnozmj = _pocet,cenamj = _cenamjP, sumzkl = _pocet*_cenamjP*_kurzDokladuV, vyrcis=_vyrcis  where idpolsklad = idvydej;   
                             end if;   
	                   else   
                             _sklfifo := (select isfifosklad(_zaznam.datvyst));   
                             if (_sklfifo) then   
	                       select nextval('seq_dpolsklad') into _idrozlozeni;   
	                       select cenamj, idDoklSklad into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);  
			       select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);  
			       if (_kurzDokladuP <> 0.0) then  
	                         _cenamjP := _cenamjP * _kurzDokladuP;   
	                       end if;  
	                       select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = idvydej; 
	                       _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV)); 
	                       _cenamjP := _cenamjP / _kurzDokladuV; 
	                       insert into dpolsklad(idpolsklad,mnozmj,autozaokr,autogen,baleniid,cenjednotka,cenamj,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,sumzkl,sumzklmen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idskladu,idfirmy,vyrcis)    
	                                          (select (-1*_idrozlozeni),_pocet,autozaokr,autogen,baleniid,cenjednotka,_cenamjP,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,_pocet*_cenamjP,sumzklmen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idskladu,idfirmy,_vyrcis from dpolsklad where idpolsklad=idVydej);   
	                       --   
	                       insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,_idrozlozeni,_pocet,_zaznam.idvyrobnicislo);   
                               insert into svazbypolsklad(idpolskladzdroj,idpolskladcil) values (idvydej, _idrozlozeni);   
                             else   
                               insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,idvydej,_pocet,_zaznam.idvyrobnicislo);   
                             end if;   
	                   end if;   
	                   --   
	                   _i:=_i+1;   
	                  end if;
                      end if;   
	           end loop;   
           end if;   
  else   
  	--nepoutím fifo do rekurze, příznak záporného id udělám opět kladný   
         update dpolsklad set idPolSklad = -1*idVydej where idpolsklad=idVydej;            
  end if;   
end;     
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sfifovydej(integer, integer, integer, integer, numeric) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 69, 't');
