drop function if exists dgetstavnasklade(integer, date, integer, integer);
drop function if exists dgetstavnasklade(integer, date, integer);
drop function if exists dcanulozitpolozku(integer, date, integer, numeric, character varying);

-- Function: dgetstavnasklade(integer, date, integer, character varying)
-- DROP FUNCTION dgetstavnasklade(integer, date, integer, character varying);
CREATE OR REPLACE FUNCTION dgetstavnasklade(i_skladkartaid integer, i_datum date, i_polskladid integer, i_sarze character varying)
  RETURNS numeric AS
$BODY$   
declare  
  _pocMj numeric(19,6);  
  _obratMj numeric(19,6);  
  _stavMj numeric(19,6);  
  _idcenik integer;
  _idskladu integer;
begin  
  SELECT pocatMj INTO _pocMj  
  FROM sKarty  
  WHERE idKarty = i_skladkartaid;  
  
  if (i_datum is null) then  
    raise exception '0005:dGetStavNaSklade : Vstupni parametr datum je null.';   
  end if;
  
  if (i_sarze is null or i_sarze = '') then
    if (i_polSkladId < 0) then   
      SELECT sum(CASE ds.typPohybuK WHEN 'typPohybu.prijem' THEN ps.mnozMj ELSE -ps.mnozMj END) INTO _obratMj   
      FROM dPolSklad ps LEFT OUTER JOIN dDoklSklad ds ON ps.idDoklSklad = ds.idDoklSklad   
      WHERE idkarty = i_skladkartaid AND ps.datUcto <= i_datum;   
    else   
      SELECT sum(CASE ds.typPohybuK WHEN 'typPohybu.prijem' THEN ps.mnozMj ELSE -ps.mnozMj END) INTO _obratMj   
      FROM dPolSklad ps LEFT OUTER JOIN dDoklSklad ds ON ps.idDoklSklad = ds.idDoklSklad   
      WHERE idkarty = i_skladkartaid AND (ps.datUcto < i_datum OR (ps.datUcto = i_datum AND ps.idPolSklad < i_polskladid));   
    end if;
    if(_obratMj is null) then _obratMj = 0.0; end if;   
    if(_pocMj is null) then _pocMj = 0.0; end if;    
    _stavMj = _pocMj + _obratMj;
  else
    select idcenik, idtypdokl into _idcenik, _idskladu from skarty where idkarty = i_skladkartaid;
    select pocet into _stavMj from dpolskladf where idcenik = _idcenik and idskladu = _idskladu and sarze = i_sarze;
  end if;   
  
  RETURN _stavMj;   
end   
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dgetstavnasklade(integer, date, integer, character varying) OWNER TO %firmaRole%;

-- Function: dgetstavnasklade(integer, date, integer, integer, character varying)
-- DROP FUNCTION dgetstavnasklade(integer, date, integer, integer, character varying);
CREATE OR REPLACE FUNCTION dgetstavnasklade(i_skladkartaid integer, i_datum date, i_polskladid integer, i_firmaid integer, i_sarze character varying)
  RETURNS numeric AS
$BODY$ 
declare 
  _sklad integer; 
  _cenik integer; 
  _stavMj numeric(19,6); 
  _firmaRezerMj numeric(19,6); 
  _celkemRezerMj numeric(19,6); 
begin
  SELECT dgetstavnasklade(i_skladkartaid, i_datum, i_polskladid, i_sarze) INTO _stavMj; 
 
  IF (i_firmaid > 0) THEN 
    -- vymazeme jiz neplatne rezervace 
    delete from srezervace where datumdo is not null and datumdo < date(now()); 
    -- nacteme si info ze skladove karty 
    SELECT idCenik, idTypDokl INTO _cenik, _sklad FROM sKarty WHERE idKarty = i_skladkartaid; 
    -- zjistime kolik ma firma rezervovano 
    select coalesce(sum(mnozstvi), 0) into _firmaRezerMj from srezervace where idfirmy = i_firmaid and idcenik = _cenik and idsklad = _sklad; 
    -- zjistime kolik je celkem rezervovano 
    select coalesce(sum(mnozstvi), 0) into _celkemRezerMj from srezervace where idcenik = _cenik and idsklad = _sklad; 
     
    -- spocteme kolik mu muzeme dat 
    _stavMj := minValue(_stavMj, maxValue(_stavMj - _celkemRezerMj, 0) + _firmaRezerMj); 
  END IF; 
   
  RETURN _stavMj;   
end 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dgetstavnasklade(integer, date, integer, integer, character varying) OWNER TO %firmaRole%;

-- Function: dcanulozitpolozku(integer, date, integer, numeric, character varying, integer, character varying)
-- DROP FUNCTION dgetstavnasklade(integer, date, integer, integer, character varying);
CREATE OR REPLACE FUNCTION dcanulozitpolozku(i_skladkartaid integer, i_datum date, i_polskladid integer, i_mnozmj numeric, i_typpohybuk character varying, i_adresarid integer, i_sarze character varying) RETURNS boolean
    AS $$ 
declare 
  _stavMjKDatu numeric(19,6); 
  zaznam Record; 
  loc_MnozMj numeric(19,6); 
  _sklzapor boolean;  
begin 
  /* nahrajeme stav skladu pred danou menenou nebo pridavanou prijmenkou nebo vydejkou */ 
  _stavMjKDatu := (select dGetStavNaSklade(i_SkladKartaId, i_datum, i_PolSkladId, i_adresarid, i_sarze)); 
 
  loc_MnozMj := i_MnozMj; 
  /* pokud jde o vydej musim odecitat */   
  if i_TypPohybuK = 'typPohybu.vydej' then   
    loc_MnozMj := 0-loc_MnozMj;   
  end if; 
   
  /* pridam k tomuto stavu mnozstvi mj na pridavane polozce*/ 
  _stavMjKDatu := _stavMjKDatu + loc_MnozMj; 
 
  /* provedu kontrolu na zaporny stav skladu */ 
  if _stavMjKDatu < 0 then  
    select sklzapor into _sklzapor from nNastav where i_datum >= PlatiOdData order by PlatiOdData desc limit 1;  
    if (_sklzapor is null) then  
      select sklzapor into _sklzapor from nNastav where PlatiOdData is null limit 1;   
    end if;  
    if _sklzapor is null or _sklzapor = false then  
      return false;  
    end if;  
  end if;  
   
  /*-------------------------------------------------------------------------------------------------------------------------------------------*/ 
  /* a zacnu se pokouset pricist nasledujici polozky */ 
  for zaznam in select * from dPolSklad ps LEFT OUTER JOIN dDoklSklad ds ON ps.idDoklSklad = ds.idDoklSklad 
    where ps.datUcto >= i_datum and ps.idKarty = i_SkladKartaId and ps.idPolSklad > i_PolSkladId order by ps.datUcto asc  
    loop   
     
    loc_MnozMJ := zaznam.MnozMJ; 
     
    /* pokud jde o vydej musim odecitat */   
    if zaznam.typPohybuK = 'typPohybu.vydej' then   
      loc_MnozMJ := 0-loc_MnozMJ;   
    end if; 
 
    /* prictu mnozstvi an dane polozce */  
    _stavMjKDatu = _stavMjKDatu + loc_MnozMJ; 
 
    /* provedu kontrolu na zaporny stav skladu */ 
    if _stavMjKDatu < 0 then  
      select sklzapor into _sklzapor from nNastav where zaznam.DatUcto >= PlatiOdData order by PlatiOdData desc limit 1;  
      if (_sklzapor is null) then  
	select sklzapor into _sklzapor from nNastav where PlatiOdData is null limit 1;   
      end if;  
      if _sklzapor is null or _sklzapor = false then  
        return false;  
      end if;  
    end if;  
 
  end loop;  
 
  return true;  
end 
$$
    LANGUAGE plpgsql;
ALTER FUNCTION public.dcanulozitpolozku(i_skladkartaid integer, i_datum date, i_polskladid integer, i_mnozmj numeric, i_typpohybuk character varying, i_adresarid integer, i_sarze character varying) OWNER TO %firmaRole%;

-- TOC entry 71 (class 1255 OID 241909)
-- Dependencies: 673 3
-- Name: obchodrealizovatelnost(integer); Type: FUNCTION; Schema: public; Owner: %firmaRole%
CREATE OR REPLACE FUNCTION obchodrealizovatelnost(iddokl integer) RETURNS numeric
    AS $$  
declare 
  zbyvaNakl numeric(15,2); 
  moznoSklad numeric(15,2); 
  moznoNesklad numeric(15,2); 
  vysledek numeric(6,2); 
  _idUcetniObdobi integer; 
  _idadresar integer;
begin  
  select idUcetObdobi into _idUcetniObdobi from nUcetObdobi where (DATE(NOW()) >= PlatiOdData and DATE(NOW()) <= PlatiDoData) limit 1; 
   
  select coalesce(sum((mnozMj-mnozMjReal) * cenaMj), 0) into zbyvaNakl from dPolObch where idDoklObch = idDokl; 
  
  select idfirmy into _idadresar from ddoklobch where iddoklobch = iddokl;
  
  select coalesce(sum( 
    minValue( 
        maxValue(dgetstavnasklade((select idKarty from sKarty where idCenik = P.idCenik AND idTypDokl = P.idSkladu AND idUcetObdobi = _idUcetniObdobi), DATE(NOW()), -1, _idadresar, null), 0), 
        (mnozMj-mnozMjReal)) 
    * cenaMj), 0) into moznoSklad 
    from dPolObch as P where idDoklObch = idDokl and typPolozkyK = 'typPolozky.katalog'; 
 
  select coalesce(sum((mnozMj-mnozMjReal) * cenaMj), 0) into moznoNesklad from dPolObch where idDoklObch = idDokl and typPolozkyK <> 'typPolozky.katalog'; 
 
  if (zbyvaNakl = 0) then 
    vysledek := 100 ; 
  else 
    vysledek := ((moznoSklad + moznoNesklad) / zbyvaNakl) * 100; 
  end if; 
   
  return vysledek; 
end;  
$$
    LANGUAGE plpgsql;
ALTER FUNCTION public.obchodrealizovatelnost(iddokl integer) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 71, 't');
