--------------------------------------------------------------------------------
-- Bug 31902 – [WinStrom] - Příjemky x Přijaté faktury - Cena
--------------------------------------------------------------------------------

DROP TRIGGER dpolskladupdatecenamjnafap ON dpolsklad;

CREATE OR REPLACE FUNCTION fillPolSklad(_idPolSklad integer, _idPolDokl integer, _modul character varying) RETURNS integer AS
$BODY$
declare
  _polDokl record;
  _polSklad record;
  _idDoklad integer;
  _typPohybuK character varying;
  _typPohybuSklad character varying;
  _cenaMj numeric(19,6);
  _cenaMjPoriz numeric(19,6);
  _cenaMjTuz numeric(19,6);
  _mnozMj numeric(19,6);
  _sumZkl numeric(19,6);
  _sumZklMen numeric(19,6);
  _idDoklSklad integer;
  _idUcetObdobi integer;
  _idKarty integer;
  _sklad record;
  _kurz numeric(19,6);
  _prumCenaTuz numeric(19,6);
  _isCiziMena boolean;
  _typDoklK character varying;
  _idZklMdUcet integer;
  _idZklDalUcet integer;
  _idStredDoklSklad integer;
  _idCinnostDoklSklad integer;
  _idZakazkyDoklSklad integer;
  _kopStred boolean;
  _kopCinnost boolean;
  _kopZakazku boolean;
  _zdrojProFak boolean;
begin
  if(_modul like 'POK') then
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;
    select idDoklInt, typPohybuK into _idDoklad, _typPohybuK from dDoklInt where idDoklInt = _polDokl.idDoklInt;
    _typDoklK = null; -- pro pokladnu dobropisy nejsou
  else
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;
    select idDoklFak, typPohybuK into _idDoklad, _typPohybuK from dDoklFak where idDoklFak = _polDokl.idDoklFak;
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak);
  end if;

  select findparovanydoklsklad(_iddoklad, _modul, 'typVazbyDokl.hlavaSkl', false) into _idDoklSklad;
  
  if(_idDoklSklad is null) then
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad;
  end if;

  select * into _polSklad from dPolSklad where idPolSklad = _idPolSklad;
  select typPohybuK, idStred, idCinnost, idZakazky 
    into _typPohybuSklad, _idStredDoklSklad, _idCinnostDoklSklad, _idZakazkyDoklSklad
    from dDoklSklad where idDoklSklad = _polSklad.idDoklSklad; 

  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi;
  select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idskladu = _polDokl.idbspskl and iducetobdobi = _iducetobdobi;
  select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl;
  
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz;
  select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty;
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena;

  if(_typPohybuSklad like 'typPohybu.vydej') then
    -- vsechny dobropisy generuji prijemky
    --if(_typDoklK like 'typDokladu.dobropis') then
    --  _mnozMj = -_polDokl.mnozMj;
    --else
      _mnozMj = _polDokl.mnozMj;
    --end if;
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena
    _cenaMj = _polSklad.cenaMj;
    _cenaMjPoriz = _polSklad.cenaMjPoriz;
    _sumZkl = _polSklad.sumZkl;
    _sumZklMen = _polSklad.sumZklMen;
    -- nastaveni uctu pro polSklad vydej
    select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet;
    _idZklDalUcet = _sklad.idPrimUcet;
  else
    if(_typDoklK like 'typDokladu.dobropis' and _modul like 'FAV') then
      -- pokud se jedna o dobropis tak doplnuji nakupni ceny;
      _mnozMj = -_polDokl.mnozMj;
      _cenaMjTuz = _polDokl.cenaMjNakup; 
      if(_cenaMjTuz = 0.0) then
        _cenaMjTuz = (select nakupCena from ccenik where idCenik = _polDokl.idCenik);
        if(_cenaMj = 0.0) then
          _cenaMj = _polDokl.cenaMj * _kurz;
        end if;
      end if;
      _cenaMjPoriz = _cenaMjTuz / _kurz;
      _cenaMj = _polSklad.cenaMjNakl + _cenaMjPoriz;
      _sumZkl = _mnozMj * (_cenaMjTuz + (_polSklad.cenaMjNakl * _kurz));
      if(_isCiziMena) then
        _sumZklMen = _mnozMj * _cenaMj;
      else
        _sumZklMen = 0.0;
      end if;
    else
      -- pokud na sklad prijmam zkopiruji se ceny z faktury
      _mnozMj = _polDokl.mnozMj;
      _sumZkl = _polDokl.sumZkl;
      if(_mnozMj <> 0.0) then
        _cenaMjPoriz = _sumZkl / _mnozMj;
      else
        _cenaMjPoriz = _sumZkl;
      end if;
      _cenaMjPoriz = _cenaMjPoriz / _kurz;
      if(_isCiziMena) then
        if(_mnozMj <> 0.0) then
          _sumZklMen = (_cenaMjPoriz + _polSklad.cenaMjNakl) * _mnozMj;
        else
          _sumZklMen = (_cenaMjPoriz + _polSklad.cenaMjNakl);
        end if;
      else
        _sumZklMen = 0.0;  
      end if;
      _sumZkl = _sumZkl + (_polSklad.cenaMjNakl * _kurz * _mnozMj);
      _cenaMj = _cenaMjPoriz + _polSklad.cenaMjNakl;
    end if;
    -- nastaveni uctu pro polSklad prijem
    _idZklMdUcet = _sklad.idPrimUcet;
    _idZklDalUcet = _polDokl.idZklMdUcet;
  end if;
 
  _zdrojProFak = not _polDokl.zdrojProSkl;

  if(_polSklad.cenaMj <> _cenaMj
    or _polSklad.cenaMjPoriz <> _cenaMjPoriz
    or _polSklad.sumZkl <> _sumZkl
    or _polSklad.sumZklMen <> _sumZklMen
    or not compareVarchar(_polSklad.nazev, _polDokl.nazev)
    or not compareVarchar(_polSklad.nazevA, _polDokl.nazevA)
    or not compareVarchar(_polSklad.nazevB, _polDokl.nazevB)
    or not compareVarchar(_polSklad.nazevC, _polDokl.nazevC)
    or not compareDate(_polSklad.datVyst, _polDokl.datVyst)
    or not compareDate(_polSklad.datUcto, _polDokl.datVyst)
    or not compareId(_polSklad.baleniId, _polDokl.baleniId)
    or not compareNumeric(_polSklad.mnozBaleni, _polDokl.mnozBaleni)
    or not compareVarchar(_polSklad.sarze, _polDokl.sarze)
    or not compareDate(_polSklad.expirace, _polDokl.expirace)
    or not compareDate(_polSklad.datTrvan, _polDokl.datTrvan)
    or not compareDate(_polSklad.datVyroby, _polDokl.datVyroby)
    or not compareId(_polSklad.cisRad, _polDokl.cisRad)
    or not compareVarchar(_polSklad.eankod, _polDokl.eanKod)
    or not compareId(_polSklad.idmj, _polDokl.idmj)
    or not compareId(_polSklad.idStred, _polDokl.idStred)
    or not compareId(_polSklad.idCinnost, _polDokl.idCinnost)
    or not compareId(_polSklad.idZakazky, _polDokl.idZakazky)
    or not compareId(_polSklad.idZklMdUcet, _idZklMdUcet)
    or not compareId(_polSklad.idZklDalUcet, _idZklDalUcet) 
    or _zdrojProFak <> _polSklad.zdrojProFak
    ) 
  then
    _kopStred = _polSklad.kopStred;
    if(not compareId(_idStredDoklSklad, _polDokl.idStred)) then
      _kopStred = false;
    end if;
    _kopCinnost = _polSklad.kopCinnost;
    if(not compareId(_idCinnostDoklSklad, _polDokl.idCinnost)) then
      _kopCinnost = false;
    end if;
    _kopZakazku = _polSklad.kopZakazku;
    if(not compareId(_idZakazkyDoklSklad, _polDokl.idZakazky)) then
      _kopZakazku = false;
    end if;

    update dPolSklad set
      lastUpdate = LOCALTIMESTAMP,
      cenaMj = _cenaMj,
      cenaMjPoriz = _cenaMjPoriz,
      --mnozMj = _mnozMj,
      sumZkl = _sumZkl,
      sumZklMen = _sumZklMen,
      nazev = _polDokl.nazev,
      nazevA = _polDokl.nazevA,
      nazevB = _polDokl.nazevB,
      nazevC = _polDokl.nazevC,
      datVyst = _polDokl.datVyst,
      datUcto = _polDokl.datVyst,
      baleniId = _polDokl.baleniId,
      mnozBaleni = _polDokl.mnozBaleni,
      sarze = _polDokl.sarze,
      expirace = _polDokl.expirace,
      datTrvan = _polDokl.datTrvan,
      datVyroby = _polDokl.datVyroby,
      cisRad = _polDokl.cisRad,
      eankod = _polDokl.eanKod,
      idmj = _polDokl.idmj,
      idStred = _polDokl.idStred,
      kopStred = _kopStred,
      idCinnost = _polDokl.idCinnost,
      kopCinnost = _kopCinnost,
      idMeny = _polSklad.idMeny,
      idZakazky = _polDokl.idZakazky,
      kopZakazku = _kopZakazku, 
      --idZklMdUcet = _idZklMdUcet,
      --idZklDalUcet = _idZklDalUcet,
      zdrojProFak = _zdrojProFak,
      ucetni = true
      where idPolSklad = _idPolSklad;
  end if;

  return _idPolSklad;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION fillPolSklad(integer, integer, character varying) OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION dpoldoklupdatesklad() RETURNS trigger AS
$BODY$
declare
  _idPolDokl integer;
  _idDoklad integer;
  _idPolSklad integer;
  _idDoklSklad integer;
  _dokladGenerovatSkl boolean;
  _typDoklGenerovatSkl boolean;
  _typZasobyK character varying;
  _skladove boolean;
  _vyrobniCislo record;
  _typPohybuK character varying;
  _sadaItemCount integer;
  _vypnutySklad character varying; 
  _typDoklK character varying;
  _idPolSkladProPrepocetDokladu integer;
begin
  select getglotxvariable('vypniSklad') into _vypnutySklad;
  if(_vypnutySklad is null or _vypnutySklad <> 'true') then
    --raise exception 'sem sem se nemel dostat';
    if(NEW.storno <> OLD.storno or NEW.stornoPol <> OLD.stornoPol) then
      return NEW;
    end if;

    _typDoklK = '';

    if(NEW.modul like 'POK') then
      _idPolDokl = NEW.idPolInt;
      _idDoklad = NEW.idDoklInt;
      select generovatSkl into _dokladGenerovatSkl from dDoklInt where idDoklInt = NEW.idDoklInt;
      select generovatSkl into _typDoklGenerovatSkl from dTypDokl where idTypDokl = (select idTypDokl from dDoklInt where idDoklInt = NEW.idDoklInt);

      select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolInt where idpolint = NEW.idPolInt);
    elsif (NEW.modul like 'FAV' or NEW.modul like 'FAP') then
      _idPolDokl = NEW.idPolFak;
      _idDoklad = NEW.idDoklFak;
      select generovatSkl into _dokladGenerovatSkl from dDoklFak where idDoklFak = NEW.idDoklFak;
      select generovatSkl, typDoklK into _typDoklGenerovatSkl, _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = NEW.idDoklFak);

      select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolfak where idpolfak = NEW.idPolFak);
    else 
      return NEW;  
    end if;

    -- pokud se lisi sklad, cenik, typPolozky, mnozMj, sarze, expirace
    -- tak skladovou polozku musim smazat a vytvorit znovu kvuli fifu
    if((not compareId(NEW.idBspSkl, OLD.idBspSkl)
       or not compareId(NEW.idCenik, OLD.idCenik)
       or not compareVarchar(NEW.typPolozkyK, OLD.typPolozkyK)
       or NEW.mnozMj <> OLD.mnozMj
       or not compareVarchar(NEW.sarze, OLD.sarze)
       or not compareDate(NEW.expirace, OLD.expirace)
       )
       and _dokladGenerovatSkl and NEW.zdrojProSkl) then  
      --raise exception 'mazu polSklad';
      execute deleteNavazanePolSklad(_idPolDokl, NEW.modul);
    end if;

    if(NEW.typPolozkyK like 'typPolozky.katalog' and _dokladGenerovatSkl and _typDoklGenerovatSkl and NEW.zdrojProSkl) then  
      select skladove into _skladove from cCenik where idCenik = NEW.idCenik;
    
      if (_skladove and NEW.idBspSkl is not null) then
        select findParovanyPolSklad(_idPolDokl, NEW.modul) into _idPolSklad;
        if(_idPolSklad is null) then
          --select createPolSklad(_idPolDokl, NEW.modul) into _idPolSklad; 
          if(_sadaItemCount > 0) then
            execute createPolSkladSada(_idPolDokl, NEW.modul);
          else
            select createPolSklad(_idPolDokl, NEW.modul) into _idPolSklad; 
          end if;
        else
          if(_sadaItemCount > 0) then
            execute fillPolSkladSada(_idPolDokl, NEW.modul);
          else
            select fillPolSklad(_idPolSklad, _idPolDokl, NEW.modul) into _idPolSklad; 
          end if;
        end if;
        -- provedeni upgradu vyrobnich cisel
        if((NEW.modul like 'FAV' and _typDoklK not like 'typDokladu.dobropis') or (NEW.modul like 'FAP' and _typDoklK like 'typDokladu.dobropis')) then
          for _vyrobniCislo in select * from sVyrobniCislo where idPolFakVydej = NEW.idPolFak and (idPolSkladVydej is null or idPolSkladVydej <> _idPolSklad) loop
            update sVyrobniCislo set idPolSkladVydej = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo;
          end loop;
        end if;
        if((NEW.modul like 'FAP' and _typDoklK not like 'typDokladu.dobropis') or (NEW.modul like 'FAV' and _typDoklK like 'typDokladu.dobropis')) then
          for _vyrobniCislo in select * from sVyrobniCislo where idPolFakPrijem = NEW.idPolFak and (idPolSkladPrijem is null or idPolSkladPrijem <> _idPolSklad) loop
            update sVyrobniCislo set idPolSkladPrijem = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo;
          end loop;
        end if;
        if(NEW.modul like 'POK') then
          select typPohybuK into _typPohybuK from dDoklInt where idDoklInt = _idDoklad;
          if(_typPohybuK like 'typPohybu.prijem') then
            for _vyrobniCislo in select * from sVyrobniCislo where idPolIntVydej = NEW.idPolInt and (idPolSkladVydej is null or idPolSkladVydej <> _idPolSklad) loop
              update sVyrobniCislo set idPolSkladVydej = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo;
            end loop;
          else
            for _vyrobniCislo in select * from sVyrobniCislo where idPolIntPrijem = NEW.idPolInt and (idPolSkladPrijem is null or idPolSkladPrijem <> _idPolSklad) loop
              update sVyrobniCislo set idPolSkladPrijem = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo;
            end loop;
          end if;
        end if;

      end if;
      -- prepocteni sum na dokladu
      --select findParovanyDoklSklad(_idDoklad, NEW.modul) into _idDoklSklad;
      select findParovanyPolSklad(_idPolDokl, NEW.modul) into _idPolSkladProPrepocetDokladu;
      select idDoklSklad into _idDoklSklad from dPolSklad where idPolSklad = _idPolSkladProPrepocetDokladu;
      execute sprepoctiSumyDokladu(_idDoklSklad, NEW.datVyst);
    end if;
  end if;

  return NEW;
end
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpoldoklupdatesklad() OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 711, 't', %appVersion%, clock_timestamp());

