---------------------------------------------------------------------------------------------------
-- Bug 34604 – [FlexiBee] - Pohyby na kartách - synchronizovat datum vyskladnění s datem vystavení
---------------------------------------------------------------------------------------------------

DROP FUNCTION IF EXISTS sprepoctisklad(integer);

-- Function: sprepoctisklad(integer)
-- DROP FUNCTION sprepoctisklad(integer);
CREATE OR REPLACE FUNCTION sprepoctisklad(i_ucetobd integer, i_idskladkarty integer)
  RETURNS void AS
$BODY$
declare
  _rozsirenaPolozka record;
  --_zaznam record;
  _vyrobniCislo record;
  _pocatek_ucetobd date;
  _konec_ucetobd date;
  _evidVyrCis boolean;
  _mazatTmpTable boolean;
  _citac integer;
  _pocetPred integer;
  _pocetPo integer;
  _polSklad record;
begin
  -- pokud nechceme volat prepocet celeho skladu predame parametr i_idskladkarta
  -- pokud chceme volat prepocet celeho skladu dame za parametr i_idskladkarta -1

  execute putglotxvariable('zurnalTxName', 'prepocetSkladuFull');
  execute putglotxvariable('probihaPrepocetSkladu', 'true');

  -- nacteni datumu zacatku ucetniho obdobi
  select platioddata, platidodata into _pocatek_ucetobd, _konec_ucetobd from nucetobdobi where iducetobdobi = i_ucetobd;

  -- nagenerovani pomocnych tabulek
  select skladGenerujRozsirenePolozky(_pocatek_ucetobd, -1, i_idskladkarty) into _mazatTmpTable;

  --select count(*) into _pocetPred from tmp_RozsirenePolozky;
  --raise notice 'pocet pred %', _pocetPred;
 
  -- smazani tabulky fifo vazeb
  /*delete from sfifovazby where idpolskladvydej in
    (select idpolsklad from dpolsklad where
            datVyst >= _pocatek_ucetobd); */

  if(i_idskladkarty is not null and i_idskladkarty = -1) then
    delete from sfifovazby fv using dpolsklad ps
      where fv.idpolskladvydej = ps.idpolsklad and ps.datVyst >= _pocatek_ucetobd;

    -- fifo vazby maji constrainty toto neni potreba
    /*delete from sfifovazby f 
      where f.idpolskladvydej not in (select p.idpolsklad from dpolsklad p); */

    -- provedu fifovani rozsirenych polozek
    for _rozsirenaPolozka in (
         select * from tmp_RozsirenePolozky 
           where storno = false 
             and (typPohybuK = 'typPohybu.vydej' or (typPohybuk = 'typPohybu.prijem' and mnozMj < 0.0))
           order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop
      --select * into _zaznam from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
      if (_rozsirenaPolozka.typPohybuk = 'typPohybu.vydej'  or (_rozsirenaPolozka.typPohybuk = 'typPohybu.prijem' and _rozsirenaPolozka.mnozMj < 0.0)) then
        if (not _rozsirenaPolozka.evidVyrCis) then
          execute sfifoVydej(_rozsirenaPolozka.idPolSklad, _rozsirenaPolozka.idCenik, _rozsirenaPolozka.idBspSkl,
              _rozsirenaPolozka.idSkladKarty, _rozsirenaPolozka.mnozmj, _rozsirenaPolozka.cenyrucne);
        else
          for _vyrobniCislo in select * from svyrobnicislo where idpolskladvydej = _rozsirenaPolozka.idPolSklad loop
            update svyrobnicislo set idpolskladvydej = null where idvyrobnicislo = _vyrobniCislo.idvyrobnicislo;
            update svyrobnicislo set idpolskladvydej = _rozsirenaPolozka.idPolSklad where idvyrobnicislo = _vyrobniCislo.idvyrobnicislo;
          end loop;
        end if;
        execute sPrepoctiSumyDokladu(_rozsirenaPolozka.iddoklskladpolozky);
      end if;
    end loop;
  end if;

  --select count(*) into _pocetPo from tmp_RozsirenePolozky;

  -- vynulovani skladovych karet
  execute skladVynulujSkladoveKarty();

  -- zafifovane veci zapoctu na skladove karty
  for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky where storno = false order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop
    if(_rozsirenaPolozka.cenyRucne = true) then
      select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
      execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, 1); 
    else
      execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);
    end if;
  end loop;

  if(_mazatTmpTable) then
    drop table tmp_RozsirenePolozky;
    drop table tmp_SkladoveKarty;
    execute removeglotxvariable('zurnalTxName');
    execute removeglotxvariable('probihaPrepocetSkladu');
  end if;

end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sprepoctisklad(integer, integer) OWNER TO %firmaRole%;


-- Function: dpolskladupdate()
-- DROP FUNCTION dpolskladupdate();
CREATE OR REPLACE FUNCTION dpolskladupdate()
  RETURNS trigger AS
$BODY$ 
declare 
  tmp_rozsirenepolozky_exists boolean; 
  _updatuj boolean; 
  _pocetPolozek integer; 
  _rozsirenaPolozka record; 
  _sklFifo boolean; 
  _vypnutySklad character varying;
  _mazatTmpTable boolean; 
  _polSklad record;
  _datPosl date;
  _newDatPosl date;
begin 

  if(NEW.idBspSkl = OLD.idBspSkl and NEW.idCenik = OLD.idCenik
    and comparevarchar(NEW.typPolozkyK, OLD.typPolozkyK)
    and comparevarchar(NEW.sarze, OLD.sarze) and comparedate(NEW.expirace, OLD.expirace)
    and NEW.mnozMj = OLD.mnozMj and NEW.cenaMj = OLD.cenaMj and NEW.sumZkl = OLD.sumZkl and NEW.sumZklMen = OLD.sumZklMen
    and NEW.storno = OLD.storno 
  ) then
    if(not comparedate(NEW.datVyst, OLD.datVyst)) then
      -- pokud se nezmenilo nic jinyho jen datum vystaveni
      select datPosl into _datPosl from skarty where idkarty = NEW.idkarty;
      select max(datVyst) into _newDatPosl from dPolSklad where idKarty = NEW.idKarty;
      
      if(_newDatPosl is not null and _datPosl is not null and _newDatPosl <> _datPosl) then
        update skarty set datPosl = _newDatPosl where idKarty = NEW.idKarty;
      end if;
    end if;
    return NEW;
  end if;

  /* 
    prepocet skladu budeme provadet jen v okamziku kdy neexistuje tabulka tmp_rozsirenePolozky 
    nebo kdyz tato tabulka existuje ale neni v ni obsazeno polozka kteoru chceme updatovat 
  */ 
  select getglotxvariable('vypniSklad') into _vypnutySklad; 
  if(_vypnutySklad is null or _vypnutySklad <> 'true') then 
    _updatuj = true; 
    tmp_rozsirenepolozky_exists := (select istableexist('tmp_RozsirenePolozky')); 
    if(tmp_rozsirenepolozky_exists = true) then 
      --select count(*) into _pocetPolozek from tmp_rozsirenePolozky where idPolSklad = NEW.idPolSklad; 
      --if(_pocetPolozek > 0) then 
      select 1 into _pocetPolozek from tmp_rozsirenePolozky where idPolSklad = NEW.idPolSklad limit 1; 
      if(_pocetPolozek is not null) then 
        _updatuj = false; 
      end if; 
    end if; 
 
    if(OLD.idPolSklad < 0 and NEW.idPolSklad > 0) then 
      _updatuj = false; 
    end if; 
   
    if (OLD.storno=false and NEW.storno=true) then
      execute sfifoStorno(OLD.idpolsklad, OLD.iddoklsklad);
    end if;

    _sklfifo := (select isfifosklad(NEW.datVyst));   
    if (_sklfifo) then   
      --fifo   
      if (OLD.cenamj <> NEW.cenamj) then   
        execute sfifocenamj(OLD.idpolsklad, OLD.iddoklsklad, NEW.cenamj);   
      end if;     
      --fifo konec   
    end if;   
 
    -- tohle musi byt i pro prumerne ceny protoze jinak se negeneruji fifo vazby
    if (OLD.mnozMj = 0.0 and NEW.mnozMj != 0.0) then
      execute sfifovydej(NEW.idPolSklad, NEW.idCenik, NEW.idBspSkl, NEW.idkarty, NEW.mnozMjPlan, NEW.cenyRucne);
    end if;
    
    if(_updatuj) then 
 
      -- generuji rozsirene polozky 
      select skladGenerujRozsirenePolozky(NEW.datSklad, NEW.idPolSklad, NEW.idKarty) into _mazatTmpTable; 
     
      execute putglotxvariable('zurnalTxName', 'prepocetSkladu'); 
  
      for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
        if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then 
          if(_rozsirenaPolozka.cenyRucne = true) then
            if(_rozsirenaPolozka.storno = false) then 
              select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
              execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, -1); 
            end if;
          else 
            execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
          end if;
        end if; 
      end loop; 

      if(OLD.storno = false) then
        execute sprepoctiskladkartu(OLD.mnozMj, OLD.cenaMj, OLD.sumZkl, OLD.datVyst, OLD.idKarty, OLD.idDoklSklad, OLD.idBspSkl, -1);
      end if;

      for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
        if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then 
          if(_rozsirenaPolozka.cenyRucne = true) then
            if(_rozsirenaPolozka.storno = false) then 
              select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
              execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, 1); 
            end if;
          else
            execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
          end if;
        else
          if(NEW.storno = false) then
            execute sprepoctiskladkartu(NEW.mnozMj, NEW.cenaMj, NEW.sumZkl, NEW.datVyst, NEW.idKarty, NEW.idDoklSklad, NEW.idBspSkl, 1);
          end if;
        end if;
      end loop; 
 
      if(_mazatTmpTable) then 
        drop table tmp_RozsirenePolozky; 
        drop table tmp_SkladoveKarty; 
        execute removeglotxvariable('zurnalTxName'); 
      end if; 
        
    end if; 
  end if;

  execute sprepoctisumydokladu(NEW.idDoklSklad); 

  return NEW; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladupdate() OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION skladgenerujrozsirenepolozky(i_datum timestamp, i_idpolsklad integer, i_idskladkarty integer)
  RETURNS boolean AS
$BODY$
declare
  tmp_skladovekarty_exists boolean;
  tmp_rozsirenepolozky_exists boolean;
  _polSklad record;
  _skladKarta record;
  _pocetSkladKarty integer;
  _result boolean;
  _idUcetObd integer;
begin
  -- pokud se zde nebyli tabulky vytvoreny tak se vrati false a pokud ano tak se true
  _result = false;

  -- vytvoreni temporary tabulky pro ulozeni seznamu skladovych karet na kterych dochazi k prepoctu
  tmp_skladovekarty_exists := (select istableexist('tmp_SkladoveKarty'));
  if(tmp_skladovekarty_exists <> true) then
    --raise exception 'tmp_skladoveKarty se vytvari';
    CREATE TEMPORARY TABLE tmp_SkladoveKarty (
      idskladkarty integer
    ) WITH (OIDS=TRUE) ON COMMIT DROP;

    CREATE INDEX tmp_SkladoveKarty_idskladkarty_index ON tmp_SkladoveKarty USING btree (idskladkarty );
  end if;

  -- vytvoreni temporary tabulky pro ulozeni seznamu polozek, ktere budou prepocitavat skladove karty
  tmp_rozsirenepolozky_exists := (select istableexist('tmp_RozsirenePolozky'));
  if(tmp_rozsirenepolozky_exists <> true) then
    CREATE TEMPORARY TABLE tmp_RozsirenePolozky (
      idpolsklad integer,
      iddoklskladMaster integer,
      iddoklskladpolozky integer,
      datum timestamp, 
      skupina integer,
      typPohybuK character varying,
      idskladkarty integer,
      storno boolean,
      cenyRucne boolean,
      evidVyrCis boolean,
      idcenik integer,
      idbspskl integer,
      mnozMj numeric(19,6)
      --cenaMj numeric(19,6),
      --sumZkl numeric(19,6)
    ) WITH (OIDS=TRUE) ON COMMIT DROP;

    CREATE INDEX tmp_RozsirenePolozky_idpolsklad_index ON tmp_RozsirenePolozky USING btree (idpolsklad );
    
    -- tabulky zde byli vytvoreny tim padem se musi vracet true  
    _result = true;
  end if;
  
  if(i_idSkladKarty is not null and i_idSkladKarty <> -1) then
    -- pokud se jedna o prepocet po vlozeni jedna polozky nebo o rekurzi tak se vse dela jen s jednou skladovou kartou
    --select count(*) into _pocetSkladKarty from tmp_SkladoveKarty where idskladkarty = i_idSkladKarty;
    --if(_pocetSkladKarty = 0) then
    select 1 into _pocetSkladKarty from tmp_SkladoveKarty where idskladkarty = i_idSkladKarty limit 1;
    if (_pocetSkladKarty is null) then
      insert into tmp_SkladoveKarty (idskladkarty) values (i_idSkladKarty);
      for _polSklad in (select * from dpolsklad where datSklad >= i_datum and idkarty = i_idSkladKarty) loop
        execute skladInsertRozsirenouPolozku(_polSklad.idPolSklad);
      end loop;
    else
      -- do something stupid - kdyz je skladkarta v seznamu
    end if;
  else
    -- pokud se jedna o celkovy prepocet skladu tak do tmp tabulky skladovych karet dam vsechny pro dane obdobi
    select iducetobdobi into _idUcetObd from nucetobdobi where platioddata <= i_datum and platidodata >= i_datum;
    for _skladKarta in (select * from skarty where iducetobdobi = _idUcetObd) loop
      insert into tmp_SkladoveKarty(idskladkarty) values (_skladKarta.idKarty);
      --for _polSklad in (select * from dpolsklad where datSklad >= i_datum and idkarty = _skladKarta.idKarty) loop
      -- tento for cyklus je spatne protoze pokud jsou spatna data (dat vyst je 2010 a karta 2011) tak k prepoctu nedojde
      for _polSklad in (select * from dpolsklad where idkarty = _skladKarta.idKarty) loop
        execute skladInsertRozsirenouPolozku(_polSklad.idPolSklad);
      end loop;
    end loop;
  end if;

  return _result;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladGenerujRozsirenePolozky(timestamp, integer, integer ) OWNER TO %firmaRole%;

create or replace function skladInsertRozsirenouPolozku(i_idPolSklad integer) returns void as
$BODY$
declare
  _polSklad record;
  _navazanaPolSklad record;
  _pocetRozsirenePolSklad integer;
  _typPohybuK character varying;
  _pocetProSkupinu integer;
  _skupina integer;
  _idDoklSkladMaster integer;
  _idDoklSkladMasterPom integer;
  _mazatTmpTable boolean;
  _evidVyrCis boolean;
begin
  --select count(*) into _pocetRozsirenePolSklad from tmp_RozsirenePolozky where idPolSklad = i_idPolSklad;
  --if(_pocetRozsirenePolSklad = 0) then
  select 1 into _pocetRozsirenePolSklad from tmp_RozsirenePolozky where idPolSklad = i_idPolSklad limit 1;
  if(_pocetRozsirenePolSklad is null) then
    select * into _polSklad from dPolSklad where idPolSklad = i_idPolSklad;
    select typPohybuK into _typPohybuK from dDoklSklad where idDoklSklad = _polSklad.idDoklSklad;

    -- urceni skupiny do ktere dana polozka patri
    _skupina = 2;
    select 1 into _pocetProSkupinu from dvazebtab
         where (idtabA = _polSklad.idPolSklad and modulA = 'SKL' and (typVazbyK = 'typVazbyDokl.polozkaSklPrevod' or typVazbyK = 'typVazbyDokl.polozkaSklKus'))
             or (idtabB = _polSklad.idPolSklad and modulB = 'SKL' and (typVazbyK = 'typVazbyDokl.polozkaSklPrevod' or typVazbyK = 'typVazbyDokl.polozkaSklKus'))
         limit 1;
    if(_pocetProSkupinu is null) then
      if(_typPohybuK = 'typPohybu.prijem') then
        _skupina = 1;
      else
        _skupina = 3;
      end if;
    end if;

    -- urceni id skladoveho doklad ktery je master
    _idDoklSkladMaster = _polSklad.idDoklSklad;
    if(_skupina = 2) then
      -- _idDoklSkladMasterPom
      select idtabA into _idDoklSkladMasterPom from dvazebtab where idtabB = _polSklad.idDoklSklad and modulB = 'SKL' and modulA = 'SKL' and 
          (typVazbyK = 'typVazbyDokl.hlavaSklPrevod' or typVazbyK = 'typVazbyDokl.hlavaSklKus');
      if(_idDoklSkladMasterPom is not null) then
        _idDoklSkladMaster = _idDoklSkladMasterPom;
      end if;
    end if;

    -- rekurzi spoustim pro prevodku a kusovnik
    if(_skupina = 2 and _typPohybuK = 'typPohybu.vydej') then
      select * into _navazanaPolSklad from dPolSklad 
        where idPolSklad = (select idTabB from dvazebtab where idTabA = _polSklad.idPolSklad and modulA = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklPrevod');

      -- pokud neni soucasti prevodky tak se jedna o kusovnik
      if(_navazanaPolSklad is null) then
        select * into _navazanaPolSklad from dPolSklad
          where idPolSklad = (select idTabA from dVazebTab where idTabB = _polSklad.idPolSklad and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklKus');
      end if;
      
      if(_navazanaPolSklad is null) then
        --raise notice 'navazana je null';
      else
        --raise notice 'volam rekurzi';
        select skladGenerujRozsirenePolozky(_navazanaPolSklad.datSklad, _navazanaPolSklad.idPolSklad, _navazanaPolSklad.idKarty ) into _mazatTmpTable;
      end if;
    end if;

    select evidVyrCis into _evidVyrCis from ccenik where idcenik = _polSklad.idcenik;
    -- vlozeni zaznamu o polozce do tmp tabulky
    insert into tmp_RozsirenePolozky (idpolsklad, iddoklskladMaster, datum, skupina, typPohybuK, idskladkarty, mnozMj, /*cenaMj, sumZkl,*/ iddoklskladpolozky, storno, cenyRucne, evidVyrCis, idcenik, idbspskl)
            values (_polSklad.idPolSklad, _idDoklSkladMaster, _polSklad.datSklad, _skupina, _typPohybuK, _polSklad.idkarty, _polSklad.mnozMj, /*_polSklad.cenaMj, _polSklad.sumZkl,*/ _polSklad.idDoklSklad, _polSklad.storno, _polSklad.cenyRucne, _evidVyrCis, _polSklad.idcenik, _polSklad.idbspskl);
  else
    -- do something stupid - kdyz je polozka v seznamu
  end if;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladInsertRozsirenouPolozku(integer) OWNER TO %firmaRole%;


create or replace function skladVynulujSkladoveKarty() returns void as
$BODY$
declare
  _prumCenaTuz numeric(19,6);
  _prumCenaMen numeric(19,6);
  _skladKarta record;
begin
  update skarty set 
    stavMj = pocatMj,
    stavTuz = pocatTuz,
    stavMen = pocatMen,
    prumCenaTuz = (case when pocatMj = 0 then 0.0 else pocatTuz / pocatMj end),
    prumCenaMen = (case when pocatMj = 0 then 0.0 else pocatMen / pocatMj end),
    lastUpdate = LOCALTIMESTAMP
    where idkarty in (select idskladkarty from tmp_SkladoveKarty);
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladVynulujSkladoveKarty() OWNER TO %firmaRole%;

create or replace function skladPrepoctiRozsirenouPolozku(i_idrozsirenepolozky integer, sign integer) returns void as
$BODY$
declare
  _skladKarta record;
  _rozsirenaPolozka record;
  _polSklad record;
  _navazanaPolSklad record;
  _stavMj numeric(19,6);
  _stavTuz numeric(19,6);
  _stavMen numeric(19,6);
  _prumCenaTuz numeric(19,6);
  _prumCenaMen numeric(19,6);
  _pocetNavazanych integer;
  _cenaMj numeric(19,6);
  _sumZkl numeric(19,6);
  _sumZklMen numeric(19,6);
  _kurzDokladu numeric(19,6);
  _kurzSkladKarty numeric(19,6);
  _isCiziMena boolean;
  _sklfifo boolean;
  _datPosl date; 
  _PoslCenaTuz numeric(19,6);     
  _PoslCenaMen numeric(19,6);     
  _cenaMjSkl numeric(19,6);
  _updateCena boolean;
  _rozpadlaPolSklad record;
  _sumZklProCenaMj numeric(19,6);
  _mnozMjProCenaMj numeric(19,6);
  _cenaMjPoriz numeric(19,6);
  --_cenaMjNakl numeric(19,6);
begin
  select * into _rozsirenaPolozka from tmp_RozsirenePolozky where idpolsklad = i_idrozsirenepolozky;
  select * into _polSklad from dPolSklad where idPolSklad = i_idrozsirenepolozky;
  if(_polSklad is null) then
    -- muze se stat ze v rozsirenych polozkach je uz polozka ktera byla v ramci transakce smazana
    return;
  end if;
  
  select * into _skladKarta from sKarty where idKarty = _rozsirenaPolozka.idskladkarty;
  select getKurzFromDoklad(_rozsirenaPolozka.idDoklSkladPolozky, _polSklad.datVyst) into _kurzDokladu;

  if(sign = 1) then
    if(_rozsirenaPolozka.skupina = 1) then
      if(_polSklad.mnozMj = 0.0) then
        _stavTuz = _polSklad.cenaMj * _kurzDokladu;
      else
        --select sumZkl into _stavTuz from dpolsklad where idPolSklad = _rozsirenaPolozka.idPolSklad;
        _stavTuz = _polSklad.sumZkl;
      end if;
    else
      -- pokud se jedna o prijemku z prevodky nebo vyroby tak se musi cena nastavit podle navazane vydejky
      _cenaMjSkl = 0.0;
      _sklfifo := (select isfifosklad(_polSklad.datVyst));
      -- menit cenu budeme jen pokud to neni fifo
      _updateCena = not _sklFifo;
      if(_rozsirenaPolozka.skupina = 2 and _rozsirenaPolozka.typPohybuK = 'typPohybu.prijem') then
        select * into _navazanaPolSklad from dPolSklad 
            where idPolSklad = (select idTabA from dvazebtab where idTabB = _rozsirenaPolozka.idPolSklad and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklPrevod');
        if(_navazanaPolSklad is null) then
          _cenaMj = _polSklad.cenaMjNeskl;
          _cenaMjSkl = 0.0;
          _cenaMjPoriz = _cenaMj;
          _sumZkl = _polSklad.cenaMjNeskl * _polSklad.mnozMj;
          for _navazanaPolSklad in (select * from dPolSklad where idPolSklad in 
            (select idTabB from dvazebtab where idTabA = _rozsirenaPolozka.idPolSklad and modulA = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklKus') )
            loop
            if(_navazanaPolSklad.mnozMj <> 0.0) then
              _cenaMj = _cenaMj + (_navazanaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
              _cenaMjSkl = _cenaMjSkl + (_navazanaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
            else
              raise exception 'mnozMj je 0.0 - 1'; -- TODO vyresit co se bude dit
            end if;
            _sumZkl = _sumZkl + _navazanaPolSklad.sumZkl;

            -- musime zohlednit i pripadne rozpady skladovych polozek
            for _rozpadlaPolSklad in (select * from dPolSklad where idPolSklad in
              (select idpolskladcil from svazbypolsklad where idpolskladzdroj = _navazanaPolSklad.idPolSklad))
            loop
              if(_rozpadlaPolSklad.mnozMj <> 0.0) then
                _cenaMj = _cenaMj + (_rozpadlaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
                _cenaMjSkl = _cenaMjSkl + (_rozpadlaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
              else
                raise exception 'mnozMj je 0.0 - 2'; -- TODO vyresit co se bude dit
              end if;
              _sumZkl = _sumZkl + _rozpadlaPolSklad.sumZkl;
            end loop;

            _cenaMjPoriz = _cenaMj;

            -- ovsem pokud se jedna o vyrobu musime zmenit cenu prijmky z vyroby
            _updateCena = true;
          end loop;
          _cenaMj = _cenaMjPoriz + _polSklad.cenaMjNakl;
          _sumZkl = _sumZkl + (_polSklad.mnozMj * _polSklad.cenaMjNakl);
        else
          _sumZklProCenaMj = 0.0;
          _mnozMjProCenaMj = 0.0;
          if((_navazanaPolSklad.mnozMj <> 0.0) and (_polSklad.mnozMj <> 0.0)) then
            _sumZklProCenaMj = _sumZklProCenaMj + _navazanaPolSklad.sumZkl / _kurzDokladu;
            _mnozMjProCenaMj = _mnozMjProCenaMj + _navazanaPolSklad.mnozMj;
            _sumZkl = _navazanaPolSklad.sumZkl; 
          else
            _sumZklProCenaMj = 0.0;
            _mnozMjProCenaMj = 0.0;
            _sumZkl = 0.0; 
          end if;
          -- musime zohlednit i pripadne rozpady skladovych polozek
          for _rozpadlaPolSklad in (select * from dPolSklad where idPolSklad in
            (select idpolskladcil from svazbypolsklad where idpolskladzdroj = _navazanaPolSklad.idPolSklad order by idpolskladcil desc)
            order by idpolsklad desc) 
          loop
            if(_polSklad.mnozMj > _mnozMjProCenaMj) then
              if(_rozpadlaPolSklad.mnozMj <> 0.0) then
                _sumZklProCenaMj = _sumZklProCenaMj + _rozpadlaPolSklad.sumZkl / _kurzDokladu;
                _mnozMjProCenaMj = _mnozMjProCenaMj + _rozpadlaPolSklad.mnozMj;
              else
                raise exception 'mnozMj je 0.0 - 4'; -- TODO vyresit co se bude dit
              end if;
              _sumZkl = _sumZkl + _rozpadlaPolSklad.sumZkl;
            end if;
          end loop;

          if(_mnozMjProCenaMj <> 0.0) then
            _cenaMjPoriz = _sumZklProCenaMj / _mnozMjProCenaMj;
          else
            _cenaMjPoriz = _sumZklProCenaMj;
          end if;
          _cenaMj = _cenaMjPoriz + _polSklad.cenaMjNakl;
          _sumZkl = _sumZkl + (_polSklad.mnozMj * _polSklad.cenaMjNakl);
          --_sumZkl = _polSklad.mnozMj * _cenaMj;
          -- ovsem pokud se jedna o prevodku musime zmenit cenu prijmky z prevodky
          _updateCena = true;
        end if;
        _sumZklMen = 0.0;
        select isdoklskladmenacizi(_rozsirenaPolozka.idDoklSkladPolozky, _polSklad.datVyst) into _isCiziMena;
        if(_isCiziMena) then
          _sumZklMen = _polSklad.mnozMj * _cenaMj;
        end if;
      else
        _cenaMj = _skladKarta.prumCenaTuz;
        _cenaMjPoriz = _skladKarta.prumCenaTuz;
        if(_kurzDokladu is not null and _kurzDokladu <> 0.0) then
          _cenaMj = _cenaMj / _kurzDokladu;
        end if;
        _sumZkl = _polSklad.mnozMj * _skladKarta.prumCenaTuz;
        _sumZklMen = 0.0;
        select isdoklskladmenacizi(_rozsirenaPolozka.idDoklSkladPolozky, _polSklad.datVyst) into _isCiziMena;
        if(_isCiziMena) then
          _sumZklMen = _polSklad.mnozMj * _cenaMj; 
        end if;
      end if;

      if (_updateCena) then
        if(_polSklad.cenaMjPoriz <> _cenaMjPoriz or
          _polSklad.cenaMj <> _cenaMj or
          _polSklad.cenaMjSkl <> _cenaMj or
          _polSklad.sumZkl <> _sumZkl or
          _polSklad.sumZklMen <> _sumZklMen
        ) then
          update dPolSklad set
            cenaMjPoriz = _cenaMjPoriz,
            cenaMj = _cenaMj,
            cenaMjSkl = _cenaMjSkl,
            sumZkl = _sumZkl,
            sumZklMen = _sumZklMen
          where idPolSklad = _rozsirenaPolozka.idPolSklad;
        end if;
      end if;

      --execute sprepoctisumydokladu(_rozsirenaPolozka.idDoklSkladPolozky);

      select sumZkl into _stavTuz from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
    end if;
  else
    if(_polSklad.mnozMj = 0.0 and _rozsirenaPolozka.typpohybuk = 'typPohybu.prijem') then
      _stavTuz = _polSklad.cenaMj * _kurzDokladu;
    else
      select sumZkl into _stavTuz from dpolsklad where idPolSklad = i_idrozsirenepolozky;
    end if;
  end if;

  if(_rozsirenaPolozka.typpohybuk = 'typPohybu.vydej') then
    _stavMj = _skladKarta.stavMj - (sign*_polSklad.mnozMj);
    _stavTuz = _skladKarta.stavTuz - (sign*_stavTuz);
  else
    _stavMj = _skladKarta.stavMj + (sign*_polSklad.mnozMj);
    _stavTuz = _skladKarta.stavTuz + (sign*_stavTuz);
  end if;

  if(_stavMj is null) then
    raise exception 'stav mj je null a idpolsklad je % a _skladkarta je % a _polSklad je %',i_idrozsirenepolozky, _skladkarta, _polSklad;
  end if;

  _prumCenaTuz = _skladKarta.prumCenaTuz;
  if(_stavMj <> 0.0) then
    _prumCenaTuz = _stavTuz / _stavMj;
  end if;
  if(_prumCenaTuz is null) then
    raise exception 'prumCenaTuz je null, _stavTuz je %, _stavMj je %', _stavTuz, _stavMj;
  end if; 
 
  _datPosl = _skladKarta.datPosl;
  if(_datPosl is null or _datPosl < _polSklad.datVyst) then
    _datPosl = _polSklad.datVyst;
  end if;

  _poslCenaTuz = _skladKarta.poslCenaTuz;
  _poslCenaMen = _skladKarta.poslCenaMen;
  if(_rozsirenaPolozka.typpohybuk = 'typPohybu.prijem') then
    _PoslCenaTuz := _polSklad.cenaMj * _KurzDokladu;   
    _PoslCenaMen := _polSklad.cenaMj; 
  end if;
 
  _KurzSkladKarty := (select getKurzFromSklad(_skladKarta.idSkladu, _polSklad.datVyst));
  if (not _rozsirenaPolozka.storno) then
    update skarty set 
      stavmj = _stavMj,
      stavMjSPozadavky = _stavMj - _skladKarta.pozadavkyMj,
      stavTuz = _stavTuz,
      stavMen = round(_stavTuz / _kurzSkladKarty, 2),
      prumCenaTuz = _prumCenaTuz,
      prumCenaMen = _prumCenaTuz / _kurzSkladKarty,
      datPosl = _datPosl,
      poslCenaTuz = _poslCenaTuz,
      poslCenaMen = _poslCenaMen,
      lastUpdate = LOCALTIMESTAMP
      where idkarty = _rozsirenaPolozka.idSkladKarty;
  end if;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladPrepoctiRozsirenouPolozku(integer, integer) OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION szkontrolujsklad(i_ucetobd integer)
  RETURNS void AS
$BODY$ 
declare 
  _pocatek_ucetobd date;
  _konec_ucetobd date; 
  _mazatTmpTable boolean;
  _pocetPred integer; 
  _skladKartaId integer;
  _rozsirenaSkladKarta record;
  _stavMj numeric(19,6);
  _rozsirenaPolozka record;
  _index integer;
  _typVypisu integer;
begin 
  -- 1 = vypis skladovych karet, ktere jsou spatne
  -- 2 = vypis skladovych karet, ktere jsou spatne i s polozkama, ktere je do tohoto spatne privadeji
  -- else = exception
  _typVypisu = 1; --2;

  
  select platioddata, platidodata into _pocatek_ucetobd, _konec_ucetobd from nucetobdobi where iducetobdobi = i_ucetobd; 
 
  -- nagenerovani pomocnych tabulek 
  select skladGenerujRozsirenePolozky(_pocatek_ucetobd, -1, -1) into _mazatTmpTable; 
 
  select count(*) into _pocetPred from tmp_SkladoveKarty;
  raise notice 'pocet skladkaret pred %', _pocetPred;

  select count(*) into _pocetPred from tmp_RozsirenePolozky; 
  raise notice 'pocet pred %', _pocetPred;

  _index = 0;
  for _skladKartaId in (select * from tmp_SkladoveKarty) loop
    select * into _rozsirenaSkladKarta from (
      select idkarty, c.kod as cenikKod, s.kod as skladKod
        from skarty k
        left join ccenik c on k.idcenik = c.idcenik
        left join dbsp s on s.idbsp = k.idskladu
      where idkarty = _skladKartaId) as sklkar;
    _index = _index + 1;
    --raise notice 'pocitam skladovou kartu id = % a je to jiz %. karta', _skladKartaId, _index;
    select pocatMj into _stavMj from skarty where idkarty = _skladKartaId;
    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky 
        where storno = false and idskladkarty = _skladKartaId
        order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
      if(_rozsirenaPolozka.typPohybuK = 'typPohybu.prijem') then
        _stavMj = _stavMj + _rozsirenaPolozka.mnozMj;
      else
        _stavMj = _stavMj - _rozsirenaPolozka.mnozMj;
      end if;
      if(_stavMj < 0.0) then
        if(_typVypisu = 1) then
          raise notice 'v zaporu je skladova karta id=%, sklad=%, cenik=%', _skladKartaId, _rozsirenaSkladKarta.skladKod, _rozsirenaSkladKarta.cenikKod;
          exit;
        elsif(_typVypisu = 2) then
          raise notice 'skladova karta id=% je v minusu po polozce id=%', _skladKartaId, _rozsirenaPolozka.idPolSklad;
        else
          raise exception 'Nepodporovany typ vypisu ale skladov karta s id % je v zaporu po polozce id %', _skladKartaId, _rozsirenaPolozka.idPolSklad;
        end if;
      end if;
    end loop;
  end loop;

  if(_mazatTmpTable) then 
    drop table tmp_RozsirenePolozky; 
    drop table tmp_SkladoveKarty; 
    execute removeglotxvariable('zurnalTxName'); 
    execute removeglotxvariable('probihaPrepocetSkladu'); 
  end if; 
 
end; 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION szkontrolujsklad(integer) OWNER TO %firmaRole%;

-- zvyseni verze databaze
INSERT INTO dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  VALUES (nextval('seq_dbversion'), 741, 't', %appVersion%, clock_timestamp());
