-- Doplněna podmínka aby šli mazat doklady bez řady (zmigrované z W6)
-- Podmínka if (OLD.idRady is not null) je nutná kvůli importu z W6 na W10.

create or replace function dDoklDelete() returns trigger as $$
declare
  _idUcetObdobi integer;
  _navratHodnota boolean;
begin
  /* !!! Důležité !!! Podmínka na následující řádce nutná kvůli importu z W6 na W10. */
  if (OLD.idRady is not null) then
    /* Podle idPolRady na dokladu vyhledej příslušné účetní období */
    select idUcetobdobi into _idUcetObdobi from dRadyRok where idRadyRok = OLD.idPolRady limit 1;
    if (_idUcetObdobi is not null) then
      _navratHodnota:= (select dVratCisDokl (OLD.idRady, _idUcetObdobi, OLD.kod));
    else
      raise exception 'dDoklDelete(): Nebylo nalezeno platné účetní období pro datum zaúčtování.';
    end if;
  end if;

  return OLD;
end;
$$ LANGUAGE plpgsql;


drop trigger if exists dDoklFakDelete on ddoklfak;
drop trigger if exists dDoklIntDelete on ddoklint;
drop trigger if exists dDoklSkladDelete on ddoklsklad;

create trigger dDoklFakDelete before delete on ddoklfak 
for each row execute procedure dDoklDelete();

create trigger dDoklIntDelete before delete on ddoklint
for each row execute procedure dDoklDelete();

create trigger dDoklSkladDelete before delete on ddoklsklad
for each row execute procedure dDoklDelete();

insert into dbversion(iddbversion, dbversion, needreimport) values (nextval('seq_dbversion'), 8, 't');