-----------------------------------------------------------------------------------------
-- Bug 37110 – [FlexiBee] Nefunguje include majetku pro evidenci AdrUdalost (Emeldi)
-----------------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION dactiviticreatetask()
  RETURNS trigger AS
$BODY$  
declare 
    _idfirmy integer;
    _idzakazky integer;
    _iddoklfak integer; 
    _iddoklint integer;
    _iddoklobch integer;
    _iddoklsklad integer;
    _idcenik integer;
    _idkontakt integer;
    _idkonektor integer; 
    _idreport integer;
    _idsmlouvy integer; 
    _idpolsml integer;
    _idmajetek integer;

begin
    SELECT long_ INTO _idfirmy FROM act_ru_variable where (execution_id_ = NEW.execution_id_ or proc_inst_id_ = NEW.proc_inst_id_ or task_id_ = NEW.id_) and name_ = 'Adresar' limit 1;
    SELECT long_ INTO _idzakazky FROM act_ru_variable where (execution_id_ = NEW.execution_id_ or proc_inst_id_ = NEW.proc_inst_id_ or task_id_ = NEW.id_) and name_ = 'Zakazka' limit 1;
    SELECT long_ INTO _iddoklfak FROM act_ru_variable where (execution_id_ = NEW.execution_id_ or proc_inst_id_ = NEW.proc_inst_id_ or task_id_ = NEW.id_) and name_ = 'DoklFak' limit 1;
    SELECT long_ INTO _iddoklint FROM act_ru_variable where (execution_id_ = NEW.execution_id_ or proc_inst_id_ = NEW.proc_inst_id_ or task_id_ = NEW.id_) and name_ = 'DoklInt' limit 1;
    SELECT long_ INTO _iddoklobch FROM act_ru_variable where (execution_id_ = NEW.execution_id_ or proc_inst_id_ = NEW.proc_inst_id_ or task_id_ = NEW.id_) and name_ = 'DoklObch' limit 1;
    SELECT long_ INTO _iddoklsklad FROM act_ru_variable where (execution_id_ = NEW.execution_id_ or proc_inst_id_ = NEW.proc_inst_id_ or task_id_ = NEW.id_) and name_ = 'DoklSklad' limit 1;
    SELECT long_ INTO _idkontakt FROM act_ru_variable where (execution_id_ = NEW.execution_id_ or proc_inst_id_ = NEW.proc_inst_id_ or task_id_ = NEW.id_) and name_ = 'Kontakt' limit 1;
    SELECT long_ INTO _idkonektor FROM act_ru_variable where (execution_id_ = NEW.execution_id_ or proc_inst_id_ = NEW.proc_inst_id_ or task_id_ = NEW.id_) and name_ = 'Konektor' limit 1;
    SELECT long_ INTO _idreport FROM act_ru_variable where (execution_id_ = NEW.execution_id_ or proc_inst_id_ = NEW.proc_inst_id_ or task_id_ = NEW.id_) and name_ = 'Report' limit 1;
    SELECT long_ INTO _idsmlouvy FROM act_ru_variable where (execution_id_ = NEW.execution_id_ or proc_inst_id_ = NEW.proc_inst_id_ or task_id_ = NEW.id_) and name_ = 'Smlouva' limit 1;
    SELECT long_ INTO _idpolsml FROM act_ru_variable where (execution_id_ = NEW.execution_id_ or proc_inst_id_ = NEW.proc_inst_id_ or task_id_ = NEW.id_) and name_ = 'PolSmlouvy' limit 1;
    SELECT long_ INTO _idmajetek FROM act_ru_variable where (execution_id_ = NEW.execution_id_ or proc_inst_id_ = NEW.proc_inst_id_ or task_id_ = NEW.id_) and name_ = 'Majetek' limit 1;

    INSERT INTO audalosti (
        druhudalk, celodenni, termin, predmet, prioritak, stavudalk, zahajeni, popis, idtypakt, iduzivatel, taskDefinitionKey, processDefinitionId, actRuTask, idfirmy, idzakazky, iddoklfak, iddoklint, iddoklobch, iddoklsklad, idcenik, idkontakt, idkonektor, idreport, idsmlouvy, idpolsml, idmajetek
    ) VALUES (
        'druhUdal.workflow', 
        false, 
        date_trunc('minute', NEW.due_date_), 
        NEW.name_, 
        CASE 
            WHEN NEW.priority_ >= 80 THEN 'priorita.kriticka'
            WHEN NEW.priority_ >= 60 THEN 'priorita.vysoka'
            WHEN NEW.priority_ >= 40 THEN 'priorita.stredni'
            WHEN NEW.priority_ >= 20 THEN 'priorita.nizka'
            ELSE 'priorita.velmiNizka' 
        END,
        'stavUdal.nove',
        date_trunc('minute', NEW.create_time_),
        NEW.description_,
        (select idtypakt from atypakt where druhudalk = 'druhUdal.workflow' limit 1),
        (select iduzivatel from wuzivatel where kod = NEW.assignee_ limit 1),
        NEW.task_def_key_,
        substring(NEW.proc_def_id_ from 0 for position(':' in NEW.proc_def_id_)),
        NEW.id_,
        _idfirmy, 
        _idzakazky, 
        _iddoklfak, 
        _iddoklint, 
        _iddoklobch, 
        _iddoklsklad, 
        _idcenik, 
        _idkontakt, 
        _idkonektor, 
        _idreport, 
        _idsmlouvy, 
        _idpolsml,
        _idmajetek
    );

    return NEW;
end;  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 801, 't', %appVersion%, clock_timestamp());
