--------------------------------------------------------------------------------
-- Bug 37283 – [FlexiBee] Logovat změny ve štítkách (emeldi)
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION create_or_drop_zurnal_triggers(docreate boolean)
  RETURNS void AS
$BODY$
BEGIN
  IF docreate THEN
    PERFORM create_or_drop_ucto_zurnal_triggers(true);
    PERFORM create_or_drop_majetek_zurnal_triggers(true);
    PERFORM create_or_drop_mzdy_zurnal_triggers(true);
    PERFORM create_or_drop_ostatni_zurnal_triggers(true);
  ELSE
    PERFORM create_or_drop_ucto_zurnal_triggers(false);
    PERFORM create_or_drop_majetek_zurnal_triggers(false);
    PERFORM create_or_drop_mzdy_zurnal_triggers(false);
    PERFORM create_or_drop_ostatni_zurnal_triggers(false);
  END IF;
END;
$BODY$
LANGUAGE 'plpgsql' VOLATILE SECURITY DEFINER;

ALTER FUNCTION create_or_drop_zurnal_triggers(docreate boolean) OWNER TO %admin%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 806, 't', %appVersion%, clock_timestamp());
