--------------------------------------------------------------------------------
-- Bug 37564 – winstrom mzdy - hlavička osoby ztratí jméno
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION posobaupdatehlavicka()
  RETURNS trigger AS $$
begin
  if (NEW.platido is null) then
    UPDATE posobahlav SET lastupdate = localtimestamp, osbcis = NEW.osbcis, jmeno = NEW.jmeno, prijmeni = NEW.prijmeni, titul = NEW.titul WHERE idosobahlav = NEW.idosobahlav
       AND (osbcis <> NEW.osbcis or not comparevarchar(jmeno, NEW.jmeno) or not comparevarchar(prijmeni, NEW.prijmeni) or not comparevarchar(titul, NEW.titul)); 
  end if;
  
  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.posobaupdatehlavicka() OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 809, 't', %appVersion%, clock_timestamp());
