--------------------------------------------------------------------------------
-- Bug 38144 – [FlexiBee] Při změně skladu zůstane doklad bez hlavičky (emeldi) (P2)
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION dpoldoklupdatesklad() RETURNS trigger AS
$BODY$
declare
  _idPolDokl integer;
  _idDoklad integer;
  _idPolSklad integer;
  _idDoklSklad integer;
  _dokladGenerovatSkl boolean;
  _typDoklGenerovatSkl boolean;
  _typZasobyK character varying;
  _skladove boolean;
  _vyrobniCislo record;
  _typPohybuK character varying;
  _sadaItemCount integer;
  _vypnutySklad character varying; 
  _typDoklK character varying;
  _idPolSkladProPrepocetDokladu integer;
  _idPolSkladPuvodni integer;
  _idDoklSkladPuvodni integer;
  _pocetPolozekSklDokl integer;
begin
  select getglotxvariable('vypniSklad') into _vypnutySklad;
  if(_vypnutySklad is null or _vypnutySklad <> 'true') then
    --raise exception 'sem sem se nemel dostat';
    if(NEW.storno <> OLD.storno or NEW.stornoPol <> OLD.stornoPol) then
      return NEW;
    end if;

    _typDoklK = '';

    if(NEW.modul like 'POK') then
      _idPolDokl = NEW.idPolInt;
      _idDoklad = NEW.idDoklInt;
      select generovatSkl into _dokladGenerovatSkl from dDoklInt where idDoklInt = NEW.idDoklInt;
      select generovatSkl into _typDoklGenerovatSkl from dTypDokl where idTypDokl = (select idTypDokl from dDoklInt where idDoklInt = NEW.idDoklInt);

      select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolInt where idpolint = NEW.idPolInt);
    elsif (NEW.modul like 'FAV' or NEW.modul like 'FAP') then
      _idPolDokl = NEW.idPolFak;
      _idDoklad = NEW.idDoklFak;
      select generovatSkl into _dokladGenerovatSkl from dDoklFak where idDoklFak = NEW.idDoklFak;
      select generovatSkl, typDoklK into _typDoklGenerovatSkl, _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = NEW.idDoklFak);

      select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolfak where idpolfak = NEW.idPolFak);
    else 
      return NEW;  
    end if;

    -- pokud se lisi sklad, cenik, typPolozky, mnozMj, sarze, expirace
    -- tak skladovou polozku musim smazat a vytvorit znovu kvuli fifu
    if((not compareId(NEW.idBspSkl, OLD.idBspSkl)
       or not compareId(NEW.idCenik, OLD.idCenik)
       or not compareVarchar(NEW.typPolozkyK, OLD.typPolozkyK)
       or NEW.mnozMj <> OLD.mnozMj
       or not compareVarchar(NEW.sarze, OLD.sarze)
       or not compareDate(NEW.expirace, OLD.expirace)
       )
       and _dokladGenerovatSkl and NEW.zdrojProSkl) then  
           
      -- Bug 38144 – [FlexiBee] Při změně skladu zůstane doklad bez hlavičky (emeldi) (P2)
      if (not compareId(NEW.idBspSkl, OLD.idBspSkl)) then
        select findParovanyPolSklad(_idPolDokl, NEW.modul) into _idPolSkladPuvodni;
        select idDoklSklad into _idDoklSkladPuvodni from dPolSklad where idPolSklad = _idPolSkladPuvodni;
      end if;
      
      --raise exception 'mazu polSklad';
      execute deleteNavazanePolSklad(_idPolDokl, NEW.modul);
      
      -- Bug 38144 – [FlexiBee] Při změně skladu zůstane doklad bez hlavičky (emeldi) (P2)
      if (not compareId(NEW.idBspSkl, OLD.idBspSkl)) then
        -- Vymaž skladový doklad pokud zůstal po změně skladu na položce prázdný.
        -- ( změna skladu = přehození položky na nový skladový doklad, resp. na již existující doklad pro nový sklad )
        -- Očekáváme, že se vzniklá díra použije pro nově vytvářený doklad, případně zůstane volná pro příští použití.
        SELECT count(*) into _pocetPolozekSklDokl from dPolSklad where idDoklSklad = _idDoklSkladPuvodni;
        
        if _pocetPolozekSklDokl = 0 then
          DELETE from dVazebTab where modulA = NEW.modul and idTabA = _idDoklad and modulB = 'SKL' and idTabB = _idDoklSkladPuvodni and typVazbyK = 'typVazbyDokl.hlavaSkl';   
          DELETE from dDoklSklad where idDoklSklad = _idDoklSkladPuvodni;
        elseif _pocetPolozekSklDokl > 0 then
          -- Po výmazu položky při změně skladu je třeba přepočítat původní (neprázdný) doklad.
          EXECUTE sprepoctiSumyDokladu(_idDoklSkladPuvodni);
        end if;
      end if;
    end if;

    if(NEW.typPolozkyK like 'typPolozky.katalog' and _dokladGenerovatSkl and _typDoklGenerovatSkl and NEW.zdrojProSkl) then  
      select skladove into _skladove from cCenik where idCenik = NEW.idCenik;
    
      if (_skladove and NEW.idBspSkl is not null) then
        select findParovanyPolSklad(_idPolDokl, NEW.modul) into _idPolSklad;
        if(_idPolSklad is null) then
          --select createPolSklad(_idPolDokl, NEW.modul) into _idPolSklad; 
          if(_sadaItemCount > 0) then
            execute createPolSkladSada(_idPolDokl, NEW.modul);
          else
            select createPolSklad(_idPolDokl, NEW.modul) into _idPolSklad; 
          end if;
        else
          if(_sadaItemCount > 0) then
            execute fillPolSkladSada(_idPolDokl, NEW.modul);
          else
            select fillPolSklad(_idPolSklad, _idPolDokl, NEW.modul) into _idPolSklad; 
          end if;
        end if;
        -- provedeni upgradu vyrobnich cisel
        if((NEW.modul like 'FAV' and _typDoklK not like 'typDokladu.dobropis') or (NEW.modul like 'FAP' and _typDoklK like 'typDokladu.dobropis')) then
          for _vyrobniCislo in select * from sVyrobniCislo where idPolFakVydej = NEW.idPolFak and (idPolSkladVydej is null or idPolSkladVydej <> _idPolSklad) loop
            update sVyrobniCislo set idPolSkladVydej = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo;
          end loop;
        end if;
        if((NEW.modul like 'FAP' and _typDoklK not like 'typDokladu.dobropis') or (NEW.modul like 'FAV' and _typDoklK like 'typDokladu.dobropis')) then
          for _vyrobniCislo in select * from sVyrobniCislo where idPolFakPrijem = NEW.idPolFak and (idPolSkladPrijem is null or idPolSkladPrijem <> _idPolSklad) loop
            update sVyrobniCislo set idPolSkladPrijem = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo;
          end loop;
        end if;
        if(NEW.modul like 'POK') then
          select typPohybuK into _typPohybuK from dDoklInt where idDoklInt = _idDoklad;
          if(_typPohybuK like 'typPohybu.prijem') then
            for _vyrobniCislo in select * from sVyrobniCislo where idPolIntVydej = NEW.idPolInt and (idPolSkladVydej is null or idPolSkladVydej <> _idPolSklad) loop
              update sVyrobniCislo set idPolSkladVydej = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo;
            end loop;
          else
            for _vyrobniCislo in select * from sVyrobniCislo where idPolIntPrijem = NEW.idPolInt and (idPolSkladPrijem is null or idPolSkladPrijem <> _idPolSklad) loop
              update sVyrobniCislo set idPolSkladPrijem = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo;
            end loop;
          end if;
        end if;

      end if;
      -- prepocteni sum na dokladu
      --select findParovanyDoklSklad(_idDoklad, NEW.modul) into _idDoklSklad;
      select findParovanyPolSklad(_idPolDokl, NEW.modul) into _idPolSkladProPrepocetDokladu;
      select idDoklSklad into _idDoklSklad from dPolSklad where idPolSklad = _idPolSkladProPrepocetDokladu;
      execute sprepoctiSumyDokladu(_idDoklSklad, NEW.datVyst);
    end if;
  end if;

  return NEW;
end
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpoldoklupdatesklad() OWNER TO %firmaRole%;


CREATE OR REPLACE FUNCTION dpoldokldeletesklad() RETURNS trigger AS
$BODY$
declare
  _idPolDokl integer;
  _idDoklad integer;
  _idDoklSklad integer;
  _idPolSklad integer; 
  _pocetPozadavku integer;
  _stavSkladK character varying; 
  _zdrojProFak boolean;
  _pocetPolozek integer;
begin
  if(OLD.modul like 'POK') then
    _idPolDokl = OLD.idPolInt;
    _idDoklad = OLD.idDoklInt;
  elsif(OLD.modul like 'FAP' or OLD.modul like 'FAV') then
    _idPolDokl = OLD.idPolFak;
    _idDoklad = OLD.idDoklFak;
  else
    _idPolDokl = null;
    _idDoklad = null;
  end if;

  _idPolSklad = null;
  _idDoklSklad = null;
  if(_idPolDokl is not null) then
    select findParovanyPolSklad(_idPolDokl, OLD.modul) into _idPolSklad;
    --raise exception 'iddoklsklad neni null ale je %', _idPolSklad; 

    if(_idPolSklad is not null) then
      select idDoklSklad into _idDoklSklad from dPolSklad where idPolSklad = _idPolSklad;
    end if;
  end if;
 
  if(_idPolDokl is not null) then
    execute deleteNavazanePolSklad(_idPolDokl, OLD.modul);
  end if;
 
  -- Bug 38144 – [FlexiBee] Při změně skladu zůstane doklad bez hlavičky (emeldi) (P2)
  if _idDoklSklad is not null then
    -- Vymaž skladový doklad pokud zůstal po vymazání navázané položky prázdný.
    SELECT count(*) into _pocetPolozek from dPolSklad where idDoklSklad = _idDoklSklad;
    if _pocetPolozek = 0 then
      DELETE from dVazebTab where modulA = OLD.modul and idTabA = _idDoklad and modulB = 'SKL' and idTabB = _idDoklSklad and typVazbyK = 'typVazbyDokl.hlavaSkl';   
      DELETE from dDoklSklad where idDoklSklad = _idDoklSklad;
      _idDoklSklad = null;
    end if;
  end if;
 
  if(_idDoklSklad is not null) then
    execute sprepoctiSumyDokladu(_idDoklSklad);

    select stavSkladK, zdrojProFak into _stavSkladK, _zdrojProFak from ddoklsklad where idDoklSklad = _idDoklSklad; 
    select count(*) into _pocetPozadavku from dpolSklad where idDoklSklad = _idDoklSklad and mnozMj = 0.0 and mnozMjPlan != 0.0;
  
    if(_pocetPozadavku = 0) then
      if(compareVarchar(_stavSkladK, 'stavSklad.vygenFaktNeuplny')) then
        update ddoklsklad set stavSkladK = 'stavSklad.vygenFakt' where idDoklSklad = _idDoklSklad;
      end if;
      if(compareVarchar(_stavSkladK, 'stavSklad.vygenPoklNeuplny')) then
        update ddoklsklad set stavSkladK = 'stavSklad.vygenPokl' where idDoklSklad = _idDoklSklad;
      end if;
    end if; 

    if(_zdrojProFak) then
      --select count(*) into _pocetPolozek from dpolsklad where iddoklsklad = _idDoklSklad;
      select count(*) into _pocetPolozek from dpolsklad ps join dvazebtab vt 
        on ps.idpolsklad = vt.idtabb and vt.modulb = 'SKL' and typvazbyk = 'typVazbyDokl.polozkaSkl'
        where ps.iddoklsklad = _idDoklSklad;
      if(compareVarchar(_stavSkladK, 'stavSklad.vyfaktCast')) then
        if(_pocetPolozek > 0) then 
        else
          update ddoklsklad set stavSkladK = null where idDoklSklad = _idDoklSklad; 
        end if;
      end if; 
      if(compareVarchar(_stavSkladK, 'stavSklad.vyfakt')) then 
        if(_pocetPolozek > 0) then 
          update ddoklsklad set stavSkladK = 'stavSklad.vyfaktCast' where idDoklSklad = _idDoklSklad; 
        else
          update ddoklsklad set stavSkladK = null where idDoklSklad = _idDoklSklad; 
        end if;
      end if; 
      if(compareVarchar(_stavSkladK, 'stavSklad.vyfaktHromCast')) then
        if(_pocetPolozek > 0) then 
        else
          update ddoklsklad set stavSkladK = null where idDoklSklad = _idDoklSklad; 
        end if;
      end if; 
      if(compareVarchar(_stavSkladK, 'stavSklad.vyfaktHrom')) then 
        if(_pocetPolozek > 0) then 
          update ddoklsklad set stavSkladK = 'stavSklad.vyfaktHromCast' where idDoklSklad = _idDoklSklad; 
        else
          update ddoklsklad set stavSkladK = null where idDoklSklad = _idDoklSklad; 
        end if;
      end if; 
      if(compareVarchar(_stavSkladK, 'stavSklad.uhrazenCast')) then
        if(_pocetPolozek > 0) then 
        else
          update ddoklsklad set stavSkladK = null where idDoklSklad = _idDoklSklad; 
        end if;
      end if; 
      if(compareVarchar(_stavSkladK, 'stavSklad.uhrazen')) then 
        if(_pocetPolozek > 0) then 
          update ddoklsklad set stavSkladK = 'stavSklad.uhrazenCast' where idDoklSklad = _idDoklSklad; 
        else
          update ddoklsklad set stavSkladK = null where idDoklSklad = _idDoklSklad; 
        end if;
      end if; 
      if(compareVarchar(_stavSkladK, 'stavSklad.uhrazenHromCast')) then
        if(_pocetPolozek > 0) then 
        else
          update ddoklsklad set stavSkladK = null where idDoklSklad = _idDoklSklad; 
        end if;
      end if; 
      if(compareVarchar(_stavSkladK, 'stavSklad.uhrazenHrom')) then 
        if(_pocetPolozek > 0) then 
          update ddoklsklad set stavSkladK = 'stavSklad.uhrazenHromCast' where idDoklSklad = _idDoklSklad; 
        else
          update ddoklsklad set stavSkladK = null where idDoklSklad = _idDoklSklad; 
        end if;
      end if; 

      -- pokud uz neexistuje zadna polozka ktera by byla navazana smazeme i vazbu mezi hlavickama
      if(OLD.modul like 'POK') then
        select count(*) into _pocetPolozek from dpolsklad ps join dvazebtab vt on ps.idpolsklad = vt.idtabb and vt.modulb = 'SKL' and typvazbyk = 'typVazbyDokl.polozkaSkl' 
          join dpolint pf on vt.idtaba = pf.idpolint and vt.modulA = OLD.modul and typvazbyk = 'typVazbyDokl.polozkaSkl'
          where ps.iddoklsklad = _idDoklSklad and pf.iddoklint = _idDoklad; 
      elsif(OLD.modul like 'FAP' or OLD.modul like 'FAV') then
        select count(*) into _pocetPolozek from dpolsklad ps join dvazebtab vt on ps.idpolsklad = vt.idtabb and vt.modulb = 'SKL' and typvazbyk = 'typVazbyDokl.polozkaSkl' 
          join dpolfak pf on vt.idtaba = pf.idpolfak and vt.modulA = OLD.modul and typvazbyk = 'typVazbyDokl.polozkaSkl'
          where ps.iddoklsklad = _idDoklSklad and pf.iddoklfak = _idDoklad; 
      else
        _pocetPolozek = 9999; -- tohle je tady aby se nasledujici delete fakt nepoustel
      end if;
  
      if(_pocetPolozek = 0) then
        delete from dvazebtab where idtaba = _idDoklad and idtabb = _idDoklSklad and typVazbyK = 'typVazbyDokl.hlavaSkl' and modulB = 'SKL' and modulA = OLD.modul;
      end if;
    end if;
  end if;
  
  return OLD;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpoldokldeletesklad() OWNER TO %firmaRole%;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 830, 't', %appVersion%, clock_timestamp());
