-- Bug 41748 - Flexibee mzdy - úprava názvu složky

create or replace function runupgrade()
    returns void as $$
declare
    stat character varying(10);
begin
  select a.uuid into stat from nnastav n 
    left join utyporg u on u.idtyporg = n.idtyporg
    left join astaty a on a.idstatu = u.idstatu
  order by coalesce(n.platioddata, '1900-01-01') desc limit 1;

  if (stat = 'CZ_CZ') then

    -- zacatek ceskeho bloku
    alter table pmzdsloz disable trigger pmzdslozupdatedatumvypoctu;
    
    update pcismzdsloz set nazev = 'Záloha daně pro solidární zdanění' where idcismzdsloz = 355;
    update pcismzdsloz set nazev = 'Záloha daně pro solidární zdanění' where idcismzdsloz = 380; 

    update pmzdcalc set nazev = 'Základ daně pro solidární zdanění' where idmzdcalc = 3611;
    update pmzdcalc set nazev = 'Základ daně pro solidární zdanění' where idmzdcalc = 4345;
    update pmzdcalc set nazev = 'Základ daně pro solidární zdanění' where idmzdcalc = 5371;
    update pmzdcalc set nazev = 'Základ daně pro solidární zdanění' where idmzdcalc = 6375;

    alter table pmzdsloz enable trigger pmzdslozupdatedatumvypoctu;
    -- konec ceskeho bloku
    
  end if;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 897, 't', %appVersion%, clock_timestamp());
