--------------------------------------------------------------
-- Bug 42894 - Doplnit plně automatický režim rezervací
--------------------------------------------------------------
-- přidání sloupečku do  nastavení
ALTER TABLE nnastav ADD column rezervovatplneautom boolean NOT NULL DEFAULT false;

-- úprava funkce rezervujici z prijemky
CREATE OR REPLACE FUNCTION srezervujzprijemky(_idCenik integer, _idSkladu integer, prijato numeric(19,6))
  RETURNS void AS $$
declare
  _zbyva numeric(19,6);
  _uber numeric(19,6);
  _rezer record;
  _idUcetObd integer;
  _sklad numeric(19,6);

  _plneAutomat boolean;
  _noveMnozstvi numeric(19,6);
  _rezervovat numeric(19,6);
begin
  _zbyva = prijato;
  if (prijato > 0) then
    for _rezer in select * from 
        (select r.idrezervace, r.idpolobch, r.mnozstvi as mnozstvi, po.rezervovatMj as rezervovatMj, r.skladmj as skladMj, po.mnozMj as polMnozMj, date(r.datumOd) as datum
            from srezervace r left join dpolobch po on po.idpolobch = r.idpolobch
            where r.idcenik = _idCenik  and r.idSklad =  _idskladu
            
            union all

         select -1 as idrezervace, idpolobch, -1, rezervovatMj, 0 as SkladMj, mnozMj as polMnozMj, date(d.datVyst) as datum
            from dpolobch po
            inner join ddoklobch d on po.iddoklobch = d.iddoklobch
            where rezervovat = true and rezervovatMj = 0 and idbspskl =  _idskladu  and idCenik =  _idCenik
            and (d.stavuzivk is null or d.stavuzivk not in ('stavDoklObch.vydano', 'stavDoklObch.hotovo', 'stavDoklObch.storno'))
            and not d.storno and not po.storno and (mnozMj - mnozMjReal) > 0)
         as vysledek order by vysledek.datum, vysledek.idpolobch loop 

        select rezervovatplneautom into _plneAutomat from nnastav where platioddata <= _rezer.datum order by platioddata desc limit 1; -- TODO podmínka na datum!!!
        if(_plneAutomat is null) then
            select rezervovatplneautom into _plneAutomat from nnastav where platioddata is null limit 1;
        end if;

        if( _rezer.idrezervace > 0) then

            if(_plneAutomat and _rezer.idpolobch is not null and _rezer.rezervovatMj < _rezer.polMnozMj) then

                _noveMnozstvi = minvalue(_rezer.skladMj + _zbyva, _rezer.polMnozMj);
                _uber = minvalue(_zbyva,  _noveMnozstvi - _rezer.skladmj); 
                _zbyva = _zbyva - _uber; 
 
                perform putglotxvariable('rezerDisableTrigger', '1');
                update sRezervace set skladmj = skladmj + _uber, mnozstvi = _noveMnozstvi where idrezervace = _rezer.idrezervace;    
                update dpolobch set rezervovatMj = _noveMnozstvi where idpolobch = _rezer.idpolobch;
                perform removeglotxvariable('rezerDisableTrigger'); 

            elsif (_rezer.mnozstvi > _rezer.skladmj) then 
                _uber = minvalue(_zbyva, _rezer.mnozstvi - _rezer.skladmj); 
                _zbyva = _zbyva - _uber; 
                update sRezervace set skladmj = skladmj + _uber where idrezervace = _rezer.idrezervace; 
            end if; 

        elseif (_plneAutomat) then
            if(_rezer.polMnozMj < _zbyva) then
                _rezervovat := _rezer.skladMj;
            else
                _rezervovat := _zbyva;
            end if;
            _zbyva = _zbyva - _rezervovat;

            update dpolobch set rezervovatMj = _rezervovat where idpolobch = _rezer.idpolobch;
	end if;

        if (_zbyva = 0) then 
            return; 
        end if;
    end loop;
  else
    select idUcetObdobi into _idUcetObd from nUcetObdobi where platioddata <= date(now()) and platidodata >= date(now()); 
    select stavmj into _sklad from skarty where iducetobdobi = _idUcetObd and idskladu = _idSkladu and idcenik = _idCenik;
    select sum(skladmj) into _zbyva from srezervace where idCenik = _idCenik and idSklad = _idSkladu;
    
    if (_zbyva > _sklad) then
      _zbyva = _zbyva - _sklad;
      
      for _rezer in select * from sRezervace where idCenik = _idCenik and idSklad = _idSkladu order by datumod DESC loop
        if (_rezer.skladmj > 0) then
          _uber = minvalue(_zbyva, _rezer.skladmj);
          _zbyva = _zbyva - _uber;
          
          update sRezervace set skladmj = skladmj - _uber where idrezervace = _rezer.idrezervace;
          
          if (_zbyva = 0) then
            return;
          end if;
        end if;
      end loop;
    end if;
  end if;
end; 
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.srezervujzprijemky(integer, integer, numeric) OWNER TO %firmaRole%;

----------------------------------------------------------------------------
-- Bug 42772 - Zvláštní chování % realizovatelnosti u objednávek přijatých
-----------------------------------------------------------------------------
CREATE OR REPLACE FUNCTION dgetstavnaskladeaktualni(
    i_idcenik integer, i_idsklad integer, i_datum date, i_idfirma integer)
  RETURNS numeric AS
$BODY$ 
declare 
  _stavMj numeric(19,6); 
begin   
  select dgetstavnaskladeaktualni(i_idcenik, i_idsklad, i_datum, i_idfirma, -1) into _stavMj;
  return _stavMj;  
end;  
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION dgetstavnaskladeaktualni(integer, integer, date, integer)
  OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION dgetstavnaskladeaktualni(
    i_idcenik integer,
    i_idsklad integer,
    i_datum date,
    i_idfirma integer,
    i_iddoklobch integer)
  RETURNS numeric AS
$BODY$ 
declare 
  _stavMj numeric(19,6);  
  _firmaRezerMj numeric(19,6);  
  _celkemRezerMj numeric(19,6);  
begin 
  SELECT dgetstavnaskladeaktualni(i_idcenik, i_idsklad, i_datum) INTO _stavMj;  
   
  -- zjistime kolik je celkem rezervovano - od/do ignorujeme (bug 25844, 25789), muselo by se zohlednovat uz pri plneni pole skladmj a nebo toto pole idealne vyhodit 
  select coalesce(sum(skladmj), 0) into _celkemRezerMj from srezervace where idcenik = i_idcenik and idsklad = i_idsklad; 
    
  IF (i_idfirma > 0) THEN  
    IF (i_iddoklobch > 0) THEN
        -- zjistime kolik ma firma rezervovano  
        select coalesce(sum(r.skladmj), 0) into _firmaRezerMj from srezervace r 
            left join dpolobch po on r.idpolobch = po.idpolobch
            where r.idfirmy = i_idfirma and r.idcenik = i_idcenik and r.idsklad = i_idsklad and (po.iddoklobch is null or po.iddoklobch = i_iddoklobch); 
    ELSE
        select coalesce(sum(skladmj), 0) into _firmaRezerMj from srezervace where idfirmy = i_idfirma and idcenik = i_idcenik and idsklad = i_idsklad; 
    END IF;
 
  ELSE  
    _firmaRezerMj := 0;  
  END IF;  
    
  -- spocteme kolik mu muzeme dat  
  _stavMj := minValue(_stavMj, maxValue(_stavMj - _celkemRezerMj, 0) + _firmaRezerMj);  
    
  RETURN _stavMj;  
end;  
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION dgetstavnaskladeaktualni(integer, integer, date, integer, integer)
  OWNER TO %firmaRole%;


CREATE OR REPLACE FUNCTION obchodrealizovatelnost(iddokl integer)
  RETURNS numeric AS
$BODY$   
declare  
  zbyvaNakl numeric(15,2);  
  moznoSklad numeric(15,2);  
  moznoNesklad numeric(15,2);  
  vysledek numeric(20,2);  
  _idadresar integer; 
begin   
  select coalesce(sum((mnozMj-mnozMjReal) * cenaMj), 0) into zbyvaNakl from dPolObch where idDoklObch = idDokl and mnozmj > 0 and cenamj > 0;  
   
  select idfirmy into _idadresar from ddoklobch where iddoklobch = iddokl; 
   
  select coalesce(sum(a.procpol), 0) into moznoSklad from  
   (select minValue(  
        maxValue(dgetstavnaskladeaktualni(P.idCenik, P.idBspSkl, DATE(NOW()), _idadresar, idDokl), 0), 
        sum(mnozMj-mnozMjReal))  
    * (sum(cenamj * (mnozMj-mnozMjReal)) / sum(mnozMj-mnozMjReal)) as procpol 
    from dPolObch as P left outer join ccenik as C on P.idcenik = C.idcenik  
      where idDoklObch = idDokl and C.skladove = true and mnozMj-mnozMjReal > 0 
    group by P.idcenik, idbspskl) as a; 
  
  select coalesce(sum((mnozMj-mnozMjReal) * cenaMj), 0) into moznoNesklad  
    from dPolObch as P left outer join ccenik as C on P.idcenik = C.idcenik  where idDoklObch = idDokl and cenaMj > 0 and mnozmj > 0 and  (C.skladove is null or C.skladove = false);  
  
  if (zbyvaNakl = 0) then  
    vysledek := 100 ;  
  else  
    vysledek := ((moznoSklad + moznoNesklad) / zbyvaNakl) * 100;  
  end if;   
  if (vysledek < 0.0) then  
     vysledek := -1.0; 
  end if;	 
  if (vysledek > 999) then  
     vysledek := 999; 
  end if;  
    
  return vysledek;  
end;   
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION obchodrealizovatelnost(integer)
  OWNER TO %firmaRole%;

--------------------------------------------------------------------------------
-- Bug 42928 - Doladit plně automatický režim rezervací v nastavení
--------------------------------------------------------------------------------

-- náhrada booleanů za lokalizovaný číselník

alter table nnastav add column rezimrezervacik character varying(50) NOT NULL DEFAULT 'rezimRezervaci.rucni';

-- převod existujících hodnot 
create function prevedNastaveni()
  RETURNS void AS $$
declare
  _nastaveni record;
begin
   for _nastaveni in select * from nnastav 
    loop
        if(_nastaveni.rezervovatAutom) THEN
            update nnastav set rezimRezervaciK = 'rezimRezervaci.zObj' where idnastav = _nastaveni.idnastav;
        elsif(_nastaveni.rezervovatPlneAutom) THEN
            update nnastav set rezimRezervaciK = 'rezimRezervaci.zObjPriNaskladneni' where idnastav = _nastaveni.idnastav;
        ELSE
            update nnastav set rezimRezervaciK = 'rezimRezervaci.rucni' where idnastav = _nastaveni.idnastav;
        END IF;
    end loop;
end; 
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.prevedNastaveni() OWNER TO %firmaRole%;

select prevedNastaveni();
drop function prevedNastaveni();

ALTER TABLE nnastav drop column rezervovatplneautom;
ALTER TABLE nnastav drop column rezervovatautom;


-- úprava funkce rezervujici z prijemky
CREATE OR REPLACE FUNCTION srezervujzprijemky(_idCenik integer, _idSkladu integer, prijato numeric(19,6))
  RETURNS void AS $$
declare
  _zbyva numeric(19,6);
  _uber numeric(19,6);
  _rezer record;
  _idUcetObd integer;
  _sklad numeric(19,6);

  _plneAutomat boolean;
  _rezimRezervaciK varchar(50);
  _noveMnozstvi numeric(19,6);
  _rezervovat numeric(19,6);
begin
  _zbyva = prijato;
  if (prijato > 0) then
    for _rezer in select * from 
        (select r.idrezervace, r.idpolobch, r.mnozstvi as mnozstvi, po.rezervovatMj as rezervovatMj, r.skladmj as skladMj, po.mnozMj as polMnozMj, date(r.datumOd) as datum
            from srezervace r left join dpolobch po on po.idpolobch = r.idpolobch
            where r.idcenik = _idCenik  and r.idSklad =  _idskladu
            
            union all

         select -1 as idrezervace, idpolobch, -1, rezervovatMj, 0 as SkladMj, mnozMj as polMnozMj, date(d.datVyst) as datum
            from dpolobch po
            inner join ddoklobch d on po.iddoklobch = d.iddoklobch
            where rezervovat = true and rezervovatMj = 0 and idbspskl =  _idskladu  and idCenik =  _idCenik
            and (d.stavuzivk is null or d.stavuzivk not in ('stavDoklObch.vydano', 'stavDoklObch.hotovo', 'stavDoklObch.storno'))
            and not d.storno and not po.storno and (mnozMj - mnozMjReal) > 0)
         as vysledek order by vysledek.datum, vysledek.idpolobch loop 

        select rezimRezervaciK into _rezimRezervaciK from nnastav 
            where coalesce(platioddata, '1900-01-01') <= _rezer.datum order by platioddata desc limit 1;

        _plneAutomat = _rezimRezervaciK = 'rezimRezervaci.zObjPriNaskladneni';

        if( _rezer.idrezervace > 0) then

            if(_plneAutomat and _rezer.idpolobch is not null and _rezer.rezervovatMj < _rezer.polMnozMj) then

                _noveMnozstvi = minvalue(_rezer.skladMj + _zbyva, _rezer.polMnozMj);
                _uber = minvalue(_zbyva,  _noveMnozstvi - _rezer.skladmj); 
                _zbyva = _zbyva - _uber; 
 
                perform putglotxvariable('rezerDisableTrigger', '1');
                update sRezervace set skladmj = skladmj + _uber, mnozstvi = _noveMnozstvi where idrezervace = _rezer.idrezervace;    
                update dpolobch set rezervovatMj = _noveMnozstvi where idpolobch = _rezer.idpolobch;
                perform removeglotxvariable('rezerDisableTrigger'); 

            elsif (_rezer.mnozstvi > _rezer.skladmj) then 
                _uber = minvalue(_zbyva, _rezer.mnozstvi - _rezer.skladmj); 
                _zbyva = _zbyva - _uber; 
                update sRezervace set skladmj = skladmj + _uber where idrezervace = _rezer.idrezervace; 
            end if; 

        elseif (_plneAutomat) then
            if(_rezer.polMnozMj < _zbyva) then
                _rezervovat := _rezer.skladMj;
            else
                _rezervovat := _zbyva;
            end if;
            _zbyva = _zbyva - _rezervovat;

            update dpolobch set rezervovatMj = _rezervovat where idpolobch = _rezer.idpolobch;
	end if;

        if (_zbyva = 0) then 
            return; 
        end if;
    end loop;
  else
    select idUcetObdobi into _idUcetObd from nUcetObdobi where platioddata <= date(now()) and platidodata >= date(now()); 
    select stavmj into _sklad from skarty where iducetobdobi = _idUcetObd and idskladu = _idSkladu and idcenik = _idCenik;
    select sum(skladmj) into _zbyva from srezervace where idCenik = _idCenik and idSklad = _idSkladu;
    
    if (_zbyva > _sklad) then
      _zbyva = _zbyva - _sklad;
      
      for _rezer in select * from sRezervace where idCenik = _idCenik and idSklad = _idSkladu order by datumod DESC loop
        if (_rezer.skladmj > 0) then
          _uber = minvalue(_zbyva, _rezer.skladmj);
          _zbyva = _zbyva - _uber;
          
          update sRezervace set skladmj = skladmj - _uber where idrezervace = _rezer.idrezervace;
          
          if (_zbyva = 0) then
            return;
          end if;
        end if;
      end loop;
    end if;
  end if;
end; 
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.srezervujzprijemky(integer, integer, numeric) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 932, 't', %appVersion%, clock_timestamp());
