----------------------------------------------------------------------------------------
-- Bug 44121 - Propisování účtů DPH na pomocné interí doklady při změně účtu na faktuře 
----------------------------------------------------------------------------------------


CREATE OR REPLACE FUNCTION dpolfakupdateucty() RETURNS trigger
    AS $$  
declare typPohyb character varying(50);  
        nelzeZmena int;  
        idDokl int;  
        pol record;
        df record;
        ds record;
        ucetFak varchar;
        ucetSkl varchar;
        osUpravaDoklad boolean;
begin  
  -- nacteni typu pohybu  
  select typPohybuK into typPohyb from dDoklFak where idDoklFak = NEW.idDoklFak;
  
  -- kopírování účtů DPH pro potřeby pomocných dokladů osobitné úpravy 
  if (typPohyb = 'typPohybu.prijem') then
      -- meni se ucet dane   
      if (compareId(NEW.idDphDalUcet, OLD.idDphDalUcet) = false) then

          select d.osobupravadph into osUpravaDoklad from ddoklfak d where d.iddoklfak = NEW.iddoklfak; 
          if (osUpravaDoklad) then
              update dPolInt set idDphMdUcet = NEW.idDphDalUcet where compareId(idDphMdUcet, NEW.idDphDalUcet) = false and idpolint in 
                  (select pi.idPolInt from ddoklfak ddf inner join dvazebtab vt on vt.idtabB = ddf.iddoklfak inner join ddoklint di on vt.idtaba = di.iddoklint 
                       inner join dpolint pi on pi.iddoklint = di.iddoklint where vt.typVazbyK = 'typVazbyDokl.uhrazovanaFaktura' and ddf.iddoklfak = NEW.iddoklfak and pi.idSazbydph = NEW.idSazbydph);
          end if;
      end if;
  end if;
  
  -- kopírování účtů DPH pro potřeby pomocných dokladů osobitné úpravy
  if (typPohyb = 'typPohybu.vydej') then
      -- meni se ucet dane   
      if (compareId(NEW.idDphMdUcet, OLD.idDphMdUcet) = false) then

          select d.osobupravadph into osUpravaDoklad from ddoklfak d where d.iddoklfak = NEW.iddoklfak; 
          if (osUpravaDoklad) then
              update dPolInt set idDphDalUcet = NEW.idDphMdUcet where compareId(idDphDalUcet, NEW.idDphMdUcet) = false and idpolint in 
                  (select pi.idPolInt from ddoklfak ddf inner join dvazebtab vt on vt.idtabB = ddf.iddoklfak inner join ddoklint di on vt.idtaba = di.iddoklint 
                       inner join dpolint pi on pi.iddoklint = di.iddoklint where vt.typVazbyK = 'typVazbyDokl.uhrazovanaFaktura' and ddf.iddoklfak = NEW.iddoklfak and pi.idSazbydph = NEW.idSazbydph);
          end if;
      end if;
  end if;
  
  if (NEW.typPolozkyK = 'typPolozky.katalog' and compareid(NEW.idzklmducet, OLD.idzklmducet) = false) then  
  
      -- prijata faktura  
      if (typPohyb = 'typPohybu.vydej') then  
        -- zjistime zda neexistujou nake co nesmime zmenit  
        select count(*) into nelzeZmena from dPolSklad where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and kopZklDalUcet = true and  
            idPolSklad in (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.polozkaSkl');  
        -- pokud smime zmenit vsechny polozky co potrebujeme menime  
        if (nelzeZmena = 0) then  
          update dPolSklad set lastupdate = now(), idZklDalUcet = NEW.idZklMdUcet where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and idPolSklad in  
            (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.polozkaSkl');  
        else  
          select * into pol from dPolSklad where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and kopZklDalUcet = true and idPolSklad in  
            (select idTabB from dVazebTab where idTabA = NEW.idPolFak and typVazbyK = 'typVazbyDokl.polozkaSkl') limit 1;
          select * into df from ddoklfak where iddoklfak = NEW.iddoklfak;
          select * into ds from ddoklsklad where iddoklsklad = pol.iddoklsklad;
          
          select kod into ucetFak from uucty where iducet = NEW.idZklMdUcet;
          select kod into ucetSkl from uucty where iducet = pol.idZklDalUcet;
        
          raise exception '0008:dPolFakUpdateUcty(): Nelze zmenit ucet u navazane polozky. FAK: zdroj-% hrom-% pol: kop-% % zdroj-% SKL: zdroj-% hrom-% pol: kop-% % zdroj-%', 
            df.zdrojProSkl, df.hromFakt, NEW.kopZklMdUcet, ucetFak, NEW.zdrojProSkl, ds.zdrojProFak, ds.hromFakt, true, ucetSkl, pol.ZdrojProFak;  
        end if;  
      end if;  
  end if;  
  
  if (NEW.typPolozkyK in ('typPolozky.odpocetZdd','typPolozky.odpocetZalohy')) then  
      -- nacteni typu pohybu  
      select typPohybuK into typPohyb from dDoklFak where idDoklFak = NEW.idDoklFak;  
  
      -- vydana faktura  
      if (typPohyb = 'typPohybu.prijem') then  
        -- meni se ucet zakladu  
        if (compareId(NEW.idZklDalUcet, OLD.idZklDalUcet) = false) then  
          -- polozka odpocitava zdd  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZdd') then  
            for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                compareId((select idProtiUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idZklDalUcet) = false)  
            loop  
                execute dNastavUcetDokladu(0, idDokl, 1, NEW.idZklDalUcet);  
            end loop;  
          end if;  
          -- polozka odpocitava zalohu  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZalohy') then  
            for idDokl in (select idDoklInt from dDoklInt where compareId(idProtiUcet, NEW.idZklDalUcet) = false and idDoklInt in  
                (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.uhradaZALOHY' and idTabA in  
                  (select idTabB from dVazebTab where idTabA = NEW.idPolFak and typVazbyK = 'typVazbyDokl.odpocetZALOHY')))  
            loop  
                execute dNastavUcetDokladu(1, idDokl, 1, NEW.idZklDalUcet);  
            end loop;  

            select count(*) into nelzeZmena from dPolFak where compareId(idZklDalUcet, NEW.idZklDalUcet) = false and kopZklDalUcet = true and  
                idPolFak in (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');  
            -- pokud smime zmenit vsechny polozky co potrebujeme menime  
            if (nelzeZmena = 0) then  
              update dPolFak set lastupdate = now(), idZklDalUcet = NEW.idZklDalUcet where compareId(idZklDalUcet, NEW.idZklDalUcet) = false and idPolFak in  
                (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');  
            else  
              raise exception '0008:dPolFakUpdateUcty(): Nelze zmenit ucet u navazane polozky. Odpocet zalohove polozky - ucet Dal Zkl.';
            end if;
          end if;  
        end if;    -- konec zmena uctu zakladu  
  
        -- meni se ucet dane  
        if (compareId(NEW.idDphDalUcet, OLD.idDphDalUcet) = false) then  
          -- polozka odpocitava zdd  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZdd') then  
            -- dph je zakladni  
            if (NEW.typSzbDphK = 'typSzbDph.dphZakl') then  
              for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                compareId((select idDphZaklUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idDphDalUcet) = false)  
              loop  
                  execute dNastavUcetDokladu(0, idDokl, 2, NEW.idDphDalUcet);  
              end loop;  
            end if;   -- konec dph zakladni  
  
            -- dph je snizena  
            if (NEW.typSzbDphK = 'typSzbDph.dphSniz') then  
              for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                    compareId((select idDphSnizUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idDphDalUcet) = false)  
              loop  
                  execute dNastavUcetDokladu(0, idDokl, 3, NEW.idDphDalUcet);  
              end loop;  
            end if;-- konec dph snizena  
          end if;  -- konec odpocet zdd  

          if (NEW.typPolozkyK = 'typPolozky.odpocetZalohy') then
            select count(*) into nelzeZmena from dPolFak where compareId(idDphDalUcet, NEW.idDphDalUcet) = false and kopDphDalUcet = true and
                idPolFak in (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');
            -- pokud smime zmenit vsechny polozky co potrebujeme menime
            if (nelzeZmena = 0) then
              update dPolFak set lastupdate = now(), idDphDalUcet = NEW.idDphDalUcet where compareId(idDphDalUcet, NEW.idDphDalUcet) = false and idPolFak in
                (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');
            else
              raise exception '0008:dPolFakUpdateUcty(): Nelze zmenit ucet u navazane polozky. Odpocet zalohove polozky - ucet Dal Dph.';
            end if;
          end if;
        end if;    -- konec zmena uctu dane  
  
      end if;      -- konec jedna se o vydanou fakturu  
  
      --------------------------------------------------------------------------  
      -- prijata faktura  
      if (typPohyb = 'typPohybu.vydej') then  
        -- meni se ucet zakladu  
        if (compareId(NEW.idZklMdUcet, OLD.idZklMdUcet) = false) then  
          -- polozka odpocitava zdd  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZdd') then  
            for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                compareId((select idProtiUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idZklMdUcet) = false)  
            loop  
                execute dNastavUcetDokladu(0, idDokl, 1, NEW.idZklMdUcet);  
            end loop;  
          end if;  
  
          -- polozka odpocitava zalohu  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZalohy') then  
            for idDokl in (select idDoklInt from dDoklInt where compareId(idProtiUcet, NEW.idZklMdUcet) = false and idDoklInt in  
                (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.uhradaZALOHY' and idTabA in  
                  (select idTabB from dVazebTab where idTabA = NEW.idPolFak and typVazbyK = 'typVazbyDokl.odpocetZALOHY')))  
            loop  
                execute dNastavUcetDokladu(1, idDokl, 1, NEW.idZklMdUcet);  
            end loop;  

            select count(*) into nelzeZmena from dPolFak where compareId(idZklMdUcet, NEW.idZklMdUcet) = false and kopZklMdUcet = true and  
                idPolFak in (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');  
            -- pokud smime zmenit vsechny polozky co potrebujeme menime  
            if (nelzeZmena = 0) then  
              update dPolFak set lastupdate = now(), idZklMdUcet = NEW.idZklMdUcet where compareId(idZklMdUcet, NEW.idZklMdUcet) = false and idPolFak in  
                (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');  
            else  
              raise exception '0008:dPolFakUpdateUcty(): Nelze zmenit ucet u navazane polozky. Odpocet zalohove polozky - ucet Md Zkl.';
            end if;
          end if;  
        end if;    -- konec zmena uctu zakladu  
  
        -- meni se ucet dane  
        if (compareId(NEW.idDphMdUcet, OLD.idDphMdUcet) = false) then  
          -- polozka odpocitava zdd  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZdd') then  
            -- dph je zakladni  
            if (NEW.typSzbDphK = 'typSzbDph.dphZakl') then  
              for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                compareId((select idDphZaklUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idDphMdUcet) = false)  
              loop  
                  execute dNastavUcetDokladu(0, idDokl, 2, NEW.idDphMdUcet);  
              end loop;  
  
            end if;   -- konec dph zakladni  
  
            -- dph je snizena  
            if (NEW.typSzbDphK = 'typSzbDph.dphSniz') then  
              for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                    compareId((select idDphSnizUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idDphMdUcet) = false)  
              loop  
                  execute dNastavUcetDokladu(0, idDokl, 3, NEW.idDphMdUcet);  
              end loop;  
            end if;-- konec dph snizena  
          end if;  -- konec odpocet zdd  

          if (NEW.typPolozkyK = 'typPolozky.odpocetZalohy') then
            select count(*) into nelzeZmena from dPolFak where compareId(idDphMdUcet, NEW.idDphMdUcet) = false and kopDphMdUcet = true and
                idPolFak in (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');
            -- pokud smime zmenit vsechny polozky co potrebujeme menime
            if (nelzeZmena = 0) then
              update dPolFak set lastupdate = now(), idDphMdUcet = NEW.idDphMdUcet where compareId(idDphMdUcet, NEW.idDphMdUcet) = false and idPolFak in
                (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');
            else
              raise exception '0008:dPolFakUpdateUcty(): Nelze zmenit ucet u navazane polozky. Odpocet zalohove polozky - ucet Dal Dph.';
            end if;
          end if;
        end if;    -- konec zmena uctu dane  
  
      end if;      -- konec jedna se o prijatou fakturu  
  
  end if;       -- konec podminky na typ dokladu  

  if (NEW.zaloha = true) then
    -- nacteni typu pohybu
    select typPohybuK into typPohyb from dDoklFak where idDoklFak = NEW.idDoklFak;

    if (typPohyb = 'typPohybu.prijem') then
      if (compareId(NEW.idZklDalUcet, OLD.idZklDalUcet) = false or compareId(NEW.idDphDalUcet, OLD.idDphDalUcet) = false) then
        select count(*) into nelzeZmena from dPolFak where 
          ((compareId(NEW.idZklDalUcet, OLD.idZklDalUcet) = false and compareId(idZklDalUcet, NEW.idZklDalUcet) = false and kopZklDalUcet = true) or
          (compareId(NEW.idDphDalUcet, OLD.idDphDalUcet) = false and compareId(idDphDalUcet, NEW.idDphDalUcet) = false and kopDphDalUcet = true))
          and idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idPolFak and modulB = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');  
        -- pokud smime zmenit vsechny polozky co potrebujeme menime  
        if (nelzeZmena = 0) then  
          update dPolFak set lastupdate = now(), idZklDalUcet = NEW.idZklDalUcet, idDphDalUcet = NEW.idDphDalUcet 
            where (compareId(idZklDalUcet, NEW.idZklDalUcet) = false or compareId(idDphDalUcet, NEW.idDphDalUcet) = false) and idPolFak in  
            (select idTabA from dVazebTab where idTabB = NEW.idPolFak and modulB = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');  
        else  
          raise exception '0008:dPolFakUpdateUcty(): Nelze zmenit ucet u navazane polozky. Zalohova polozka - ucet Dal.';
        end if;
      end if;
    end if;
    if (typPohyb = 'typPohybu.vydej') then
      if (compareId(NEW.idZklMdUcet, OLD.idZklMdUcet) = false or compareId(NEW.idDphMdUcet, OLD.idDphMdUcet) = false) then
        select count(*) into nelzeZmena from dPolFak where 
          ((compareId(NEW.idZklMdUcet, OLD.idZklMdUcet) = false and compareId(idZklMdUcet, NEW.idZklMdUcet) = false and kopZklMdUcet = true) or
          (compareId(NEW.idDphMdUcet, OLD.idDphMdUcet) = false and compareId(idDphMdUcet, NEW.idDphMdUcet) = false and kopDphMdUcet = true))
          and idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idPolFak and modulB = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');  
        -- pokud smime zmenit vsechny polozky co potrebujeme menime  
        if (nelzeZmena = 0) then  
          update dPolFak set lastupdate = now(), idZklMdUcet = NEW.idZklMdUcet, idDphMdUcet = NEW.idDphMdUcet 
            where (compareId(idZklMdUcet, NEW.idZklMdUcet) = false or compareId(idDphMdUcet, NEW.idDphMdUcet) = false) and idPolFak in  
            (select idTabA from dVazebTab where idTabB = NEW.idPolFak and modulB = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');  
        else  
          raise exception '0008:dPolFakUpdateUcty(): Nelze zmenit ucet u navazane polozky. Zalohova polozka - ucet Dal.';
        end if;
      end if;
    end if;
  end if;
  
  return NEW;  
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.dpolfakupdateucty() OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 959, 't', %appVersion%, clock_timestamp());