-- Bug 44559 - Doplnit na doklady cizí klíč na účet 2. snížené sazby DPH

ALTER TABLE ddoklfak   DISABLE TRIGGER USER;
ALTER TABLE ddoklint   DISABLE TRIGGER USER;
ALTER TABLE ddoklobch  DISABLE TRIGGER USER;
ALTER TABLE ddoklsklad DISABLE TRIGGER USER;

-- vymažeme reference na případné neexistující účty (jinak by přidání constraint padalo)
UPDATE ddoklfak   SET iddphsniz2ucet = NULL WHERE iddphsniz2ucet NOT IN (SELECT iducet FROM uucty);
UPDATE ddoklint   SET iddphsniz2ucet = NULL WHERE iddphsniz2ucet NOT IN (SELECT iducet FROM uucty);
UPDATE ddoklobch  SET iddphsniz2ucet = NULL WHERE iddphsniz2ucet NOT IN (SELECT iducet FROM uucty);
UPDATE ddoklsklad SET iddphsniz2ucet = NULL WHERE iddphsniz2ucet NOT IN (SELECT iducet FROM uucty);

ALTER TABLE ONLY ddoklfak   ADD CONSTRAINT   ddoklfak_iddphsniz2ucet FOREIGN KEY (iddphsniz2ucet) REFERENCES uucty(iducet);
ALTER TABLE ONLY ddoklint   ADD CONSTRAINT   ddoklint_iddphsniz2ucet FOREIGN KEY (iddphsniz2ucet) REFERENCES uucty(iducet);
ALTER TABLE ONLY ddoklobch  ADD CONSTRAINT  ddoklobch_iddphsniz2ucet FOREIGN KEY (iddphsniz2ucet) REFERENCES uucty(iducet);
ALTER TABLE ONLY ddoklsklad ADD CONSTRAINT ddoklsklad_iddphsniz2ucet FOREIGN KEY (iddphsniz2ucet) REFERENCES uucty(iducet);
    
ALTER TABLE ddoklfak   ENABLE TRIGGER USER;
ALTER TABLE ddoklint   ENABLE TRIGGER USER;
ALTER TABLE ddoklobch  ENABLE TRIGGER USER;
ALTER TABLE ddoklsklad ENABLE TRIGGER USER;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 978, 't', %appVersion%, clock_timestamp());
