-------------------------------------------------------------------------
-- Bug 44058 - Nové kódy přenesení daňové povinnosti od 1.2.2016
-------------------------------------------------------------------------
create or replace function runupgrade()
    returns void as $$
declare
    cnt integer;
begin
    -- 18: § 92f - dodání certifikátů elektřiny
    cnt := (select count(*) from udphpren where kod = '18');
    if (cnt = 0) then
        insert into udphpren (kod, nazev, omezPrenDanPovK, platiod, platido, uuid)
        values ('18', '§ 92f – dodání certifikátů elektřiny','omezPrenDanPov.bezOmezeni', 2016, 9999, 'CZ_§92_18_2016');
    else
        update udphpren set nazev = '§ 92f – dodání certifikátů elektřiny', omezPrenDanPovK = 'omezPrenDanPov.bezOmezeni', 
            platiod = 2016, platido = 9999, uuid = 'CZ_§92_18_2016' where kod = '18';
    end if;
    -- 19: § 92f - dodání elektřiny soustavami nebo sítěmi obchodníkovi
    cnt := (select count(*) from udphpren where kod = '19');
    if (cnt = 0) then
        insert into udphpren (kod, nazev, omezPrenDanPovK, platiod, platido, uuid)
        values ('19', '§ 92f – dodání elektřiny soustavami nebo sítěmi obchodníkovi','omezPrenDanPov.bezOmezeni', 2016, 9999, 'CZ_§92_19_2016');
    else
        update udphpren set nazev = '§ 92f – dodání elektřiny soustavami nebo sítěmi obchodníkovi', omezPrenDanPovK = 'omezPrenDanPov.bezOmezeni', 
            platiod = 2016, platido = 9999, uuid = 'CZ_§92_19_2016' where kod = '19';
    end if;
    -- 20: § 92f - dodání plynu soustavami nebo sítěmi obchodníkovi
    cnt := (select count(*) from udphpren where kod = '20');
    if (cnt = 0) then
        insert into udphpren (kod, nazev, omezPrenDanPovK, platiod, platido, uuid)
        values ('20', '§ 92f – dodání plynu soustavami nebo sítěmi obchodníkovi','omezPrenDanPov.bezOmezeni', 2016, 9999, 'CZ_§92_20_2016');
    else
        update udphpren set nazev = '§ 92f – dodání plynu soustavami nebo sítěmi obchodníkovi', omezPrenDanPovK = 'omezPrenDanPov.bezOmezeni', 
            platiod = 2016, platido = 9999, uuid = 'CZ_§92_20_2016' where kod = '20';
    end if;
 end;
 $$ LANGUAGE plpgsql;
 ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();
-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 985, 't', %appVersion%, clock_timestamp());