<#ftl encoding="utf-8" />
<#escape x as x?default("")?html>
<#assign title="Podporované formáty"/>
<#include "/i-devdoc-header.ftl" />

<p>REST API FlexiBee dokáže exportovat a importovat data v&nbsp;různých formátech. Typ výstupního formátu může být určen příponou (<code>.xml</code>, <code>.json</code>) nebo pomocí hlavičky v&nbsp;HTTP požadavku (<code>Accept</code>). Formát jako přípona je nepovinný a má přednost před HTTP hlavičkou. Pokud je uvedeno <code>Accept: */*</code> je vrácena HTML forma.</p>

<p>FlexiBee podporuje tyto formáty:</p>

<table class="table table-striped table-condensed" summary="Přehled podporovaných formátů">
    <thead>
	<tr>
	    <th>Název</th>
	    <th>Poznámka</th>
	    <th>Přípona</th>
	    <th>Content-Type</th>
	    <th>Import?</th>
	</tr>
    </thead>
    <tbody>
	<tr>
	    <th>HTML</th>
	    <td>HTML stránka pro zobrazení informací na webové stránce.</td>
	    <td><code>.html</code></td>
	    <td><code>text/html</code></td>
	    <td>ne</td>
	</tr>
	<tr>
	    <th><a href="http://cs.wikipedia.org/wiki/XML">XML</a></th>
	    <td>Strojově čitelná struktura ve formátu XML.</td>
	    <td><code>.xml</code></td>
	    <td><code>application/xml</code></td>
	    <td><strong>ano</strong></td>
	</tr>
	<tr>
	    <th><a href="http://cs.wikipedia.org/wiki/JSON">JSON</a></th>
	    <td>Strojově čitelná struktura ve formátu JSON. <!-- Podporuje i JSONP pomocí parametru <code>callback</code>.--></td>
	    <td><code>.js<br/>
.json<br/></code></td>
	    <td><code>text/javascript<br/>
application/json</code></td>
	    <td><strong>ano</strong></td>
	</tr>
	<tr>
	    <th><a href="http://cs.wikipedia.org/wiki/CSV">CSV</a></th>
	    <td>Tabulkový výstup do formátu CSV (Column Separated Values).</td>
	    <td><code>.csv<br/>.csv?encoding=iso-8859-2</code></code></td>
	    <td><code>text/csv</code></td>
	    <td><strong>ano</strong></td>
	</tr>
	<tr>
	    <th><a href="http://cs.wikipedia.org/wiki/DBase">DBF</a></th>
	    <td>Databázový výstup ve formátu DBF (dBase).</td>
	    <td><code>.dbf<br/>.dbf?encoding=iso-8859-2</code></code></td>
	    <td><code>application/dbf</code></td>
	    <td><strong>ano</strong></td>
	</tr>
	<tr>
	    <th>XLS</th>
	    <td>Tabulkový výstup ve formátu Excel.</td>
	    <td><code>.xls</code></code></td>
	    <td><code>application/ms-excel</code></td>
	    <td><strong>ano</strong></td>
	</tr>
	<tr>
	    <th><a href="http://cs.wikipedia.org/wiki/ISDOC">ISDOC</a></th>
	    <td>e-faktura ISDOC.</td>
	    <td><code>.isdoc<br/>
.isdocx</code></td>
	    <td><code>application/x-isdoc<br/>
application/x-isdocx</code></td>
	    <td>zatím ne (jen z aplikace)</td>
	</tr>
	<tr>
	    <th><a href="http://cs.wikipedia.org/wiki/ISDOC">EDI</a></th>
	    <td>Elektronická výměna data (EDI) ve formátu INHOUSE.</td>
	    <td><code>.edi</code></td>
	    <td><code>application/x-edi-inhouse</code></td>
	    <td>jen objednávky přijaté</td>
	</tr>
	<tr>
	    <th><a href="http://cs.wikipedia.org/wiki/Portable_Document_Format">PDF</a></th>
	    <td>Generování tiskového reportu. Jedná se o stejnou funkci, která je dostupná v&nbsp;aplikaci. <a href="pdf">Export do PDF</a>.</td>
	    <td><code>.pdf<br/>
.pdf?report-name=vydejka</code></td>
	    <td><code>application/pdf</code></td>
	    <td>ne</td>
	</tr>
<!--	<tr>
	    <th><a href="http://cs.wikipedia.org/wiki/XLS">XLS</a></th>
	    <td>Tabulkový výstup do formátu Excel.</td>
	    <td><code>.xls</code></td>
	    <td><code>application/ms-excel</code></td>
	    <td>ne (jen z aplikace)</td>
	</tr>
-->
	<tr>
	    <th><a href="http://en.wikipedia.org/wiki/VCard">vCard</a></th>
	    <td>Výstup adresáře do formátu elektronické vizitky vCard.</td>
	    <td><code>.vcf</code></td>
	    <td><code>text/vcard</code></td>
	    <td>ne</td>
	</tr>
	<tr>
	    <th><a href="http://cs.wikipedia.org/wiki/ICalendar">iCalendar</a></th>
	    <td>Výstup do kalendáře ve formátu iCalendar. Lze takto exportovat události, ale také třeba splatnosti u přijatých či vydaných faktur.</td>
	    <td><code>.ical</code></td>
	    <td><code>text/calendar</code></td>
	    <td>ne</td>
	</tr>
    </tbody>
</table>

<#include "/i-devdoc-footer.ftl" />
</#escape>