<#ftl encoding="utf-8" />
<#escape x as x?default("")?html>
<#assign title="Párování plateb"/>
<#include "/i-devdoc-header.ftl" />

<p>Pokladnu nebo banku lze spárovat s fakturou vydanou nebo přijatou následujícím způsobem:</p>

<pre class="brush: xml">&lt;winstrom version="1.0"&gt;
  &lt;banka&gt; &lt;!-- uhrazující doklad; může být i "pokladni-pohyb" --&gt;
    &lt;id&gt;code:BANKA1&lt;/id&gt;
    &lt;!-- lze normálně uvést další vlastnosti dokladu jako při běžném importu --&gt;

    &lt;sparovani&gt;
      &lt;uhrazovanaFak type="faktura-vydana"&gt;code:FV1&lt;/uhrazovanaFak&gt; &lt;!-- uhrazovaný doklad --&gt;
      &lt;zbytek&gt;ignorovat&lt;/zbytek&gt; &lt;!-- co dělat se zbytkem, pokud nastane --&gt;
    &lt;/sparovani&gt;
  &lt;/banka&gt;
&lt;/winstrom&gt;</pre>

<p>Může se stát, že částky na uhrazujícím a uhrazovaném dokladu nesouhlasí (např. při kurzovém rozdílu a nebo schází doplatit pár korun), v takovém případě se import řídí hodnotou v tagu <code>zbytek</code>. Lze zvolit tyto hodnoty:</p>

<ul>
    <li><code>ne</code>: zbytek nesmí nastat; pokud k němu dojde, jedná se o chybu</li>
    <li><code>zauctovat</code>: zbytek se <em>zaúčtuje</em></li>
    <li><code>ignorovat</code>: zbytek se <em>ignoruje</em></li>
    <li><code>castecnaUhrada</code>: pokud je částka na uhrazujícím dokladu <em>menší</em> než na uhrazovaném, jedná se o částečnou úhradu</li>
    <li><code>castecnaUhradaNeboZauctovat</code>: pokud je částka na uhrazujícím dokladu <em>větší</em> než na uhrazovaném, zbytek se zaúčtuje; pokud je <em>menší</em>, jedná se o částečnou úhradu</li>
    <li><code>castecnaUhradaNeboIgnorovat</code>: pokud je částka na uhrazujícím dokladu <em>větší</em> než na uhrazovaném, zbytek se ignoruje; pokud je <em>menší</em>, jedná se o částečnou úhradu</li>
</ul>

<p>V tagu <code>&lt;sparovani/&gt;</code> lze navíc uvést ještě i následující. Není to povinné a standardně se bere z nastavení firmy.</p>

<pre class="brush: xml">
  &lt;!-- kurzový rozdíl, defaultně z nastavení firmy --&gt;
  &lt;krTypDokl&gt;&lt;/krTypDokl&gt; &lt;!-- typ dokladu pro kurzový rozdíl --&gt;
  &lt;krRada&gt;&lt;/krRada&gt; &lt;!-- řada pro kurzový rozdíl --&gt;

  &lt;!-- zbytek, defaultně z nastavení firmy --&gt;
  &lt;zbTypDokl&gt;&lt;/zbTypDokl&gt; &lt;!-- typ dokladu pro zbytek --&gt;
  &lt;zbRada&gt;&lt;/zbRada&gt; &lt;!-- řada pro zbytek --&gt;
</pre>

<p>Analogicky lze provádět i odpárování:</p>

<pre class="brush: xml">
&lt;winstrom version="1.0"&gt;
  &lt;banka&gt;
    &lt;id&gt;code:BANKA1&lt;/id&gt;
    &lt;odparovani&gt;
      &lt;uhrazovanaFak type="faktura-vydana"&gt;code:FV1&lt;/uhrazovanaFak&gt; &lt;!-- nepovinné, lze vícekrát --&gt;
    &lt;/odparovani&gt;
  &lt;/banka&gt;
&lt;/winstrom&gt;
</pre>

<p>Pokud žádný uhrazovaný doklad není uveden, odpárují se všechny, které jsou s daným uhrazujícím dokladem spárovány.</p>

<p>Párování je idempotentní (tj. lze opakovat jeho volání).</p>

<h3>Automatické párování</h3>
<p>Přes API lze vyvolat i automatické párování plateb. Zatím nelze řídit postup párování (např. ignorovanou částku apod.).</p>

<pre>curl -H "Accept: application/xml" -u winstrom:winstrom -X PUT -L https://demo.flexibee.eu:5434/c/demo/banka/automaticke-parovani</pre>

<h3>Původní způsob párování pouze přes REST API</h3>

<p>Je podporován i zastaralý způsob, kterým šlo párovat pouze přes REST API (nikoliv XML importem) na URL <code>/c/{firma}/parovani-uhrad</code>.</p>

<pre class="brush: xml">&lt;winstrom version="1.0"&gt;
  &lt;sparovani&gt;
    &lt;uhrazovanaFak type="faktura-prijata"&gt;code:FP1&lt;/uhrazovanaFak&gt; &lt;!-- faktura --&gt;
    &lt;uhrazujiciDokl type="banka"&gt;code:BANKA1&lt;/uhrazujiciDokl&gt;  &lt;!-- bankovní doklad --&gt;
    &lt;zbytek&gt;ignorovat&lt;/zbytek&gt; &lt;!-- zbytek ignorovat --&gt;
  &lt;/sparovani&gt;
&lt;/winstrom&gt;</pre>

<pre class="brush: xml">&lt;winstrom version="1.0"&gt;
  &lt;odparovani&gt;
    &lt;uhrazujiciDokl&gt;code:foo&lt;/uhrazujiciDokl&gt; &lt;!-- povinné --&gt;
    &lt;uhrazovanaFak&gt;code:bar&lt;/uhrazovanaFak&gt; &lt;!-- nepovinné, lze vícekrát --&gt;
  &lt;/odparovani&gt;
&lt;/winstrom&gt;</pre>

<#include "/i-devdoc-footer.ftl" />
</#escape>