<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java" >
  <xsl:output method="xml" indent="yes" encoding="utf-8" />

  <xsl:template match="winstrom">
    <winstrom version="1.0">
    <xsl:apply-templates select="adresar"/>
    </winstrom>
  </xsl:template>

  <xsl:template match="adresar">
	<adresar>
            <id>ext:BUG-ADR:<xsl:value-of select="java:flexibee.Tool.toUpper(CISLO)"/></id>
            <id>code:<xsl:value-of select="java:flexibee.Tool.toUpper(CISLO)"/></id>
            <kod><xsl:value-of select="java:flexibee.Tool.toUpper(CISLO)"/></kod>
            <xsl:choose>
                <xsl:when test="FIRMA != ''">
                    <nazev><xsl:value-of select="FIRMA"/></nazev>
                </xsl:when>
                <xsl:otherwise>
                    <nazev><xsl:value-of select="CISLO"/></nazev>
                </xsl:otherwise>
            </xsl:choose>
            <ulice><xsl:value-of select="ULICE"/></ulice>
            <psc><xsl:value-of select="PSC"/></psc>
            <mesto><xsl:value-of select="MISTO"/></mesto>
            <tel><xsl:value-of select="TLF"/></tel>
            <fax><xsl:value-of select="FAX"/></fax>
            <ic><xsl:value-of select="ICO"/></ic>
            <dic><xsl:value-of select="DIC"/></dic>
            <poznam><xsl:value-of select="POZN"/></poznam>
            <xsl:choose>
                <xsl:when test="STAT != ''">
                    <stat if-not-found="null">code:<xsl:value-of select="java:flexibee.Tool.toUpper(STAT)"/></stat>
                </xsl:when>
                <xsl:otherwise>
                </xsl:otherwise>
            </xsl:choose>
            <xsl:choose>
                <xsl:when test="PLATCEDPH = 'PRAVDA'">
                    <platceDph>true</platceDph>
                </xsl:when>
                <xsl:otherwise>
                    <platceDph>false</platceDph>
                </xsl:otherwise>
            </xsl:choose>
            <email><xsl:value-of select="EMAIL"/></email>
            <www><xsl:value-of select="WWW"/></www>
            <xsl:choose>
                <xsl:when test="SPLATNOST != ''">
                    <splatDny><xsl:value-of select="SPLATNOST"/></splatDny>
                </xsl:when>
                <xsl:otherwise>
                </xsl:otherwise>
            </xsl:choose>
    	</adresar>
        <xsl:if test="UCET != ''">
            <adresar-bankovni-ucet>
                <id>ext:BUG-ADR:<xsl:value-of select="UCET"/></id>
                <firma>code:<xsl:value-of select="CISLO"/></firma>
                <buc><xsl:value-of select="substring-before(UCET, '/')"/></buc>
                <smerKod if-not-found="nearest-invalid">code:<xsl:value-of select="substring-after(UCET, '/')"/></smerKod>
                <nazBanky><xsl:value-of select="BANKA"/></nazBanky>
                <primarni>true</primarni>
            </adresar-bankovni-ucet>
        </xsl:if>
  </xsl:template>
</xsl:stylesheet>
