<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java" >
  <xsl:output method="xml" indent="yes" encoding="utf-8" />

  <!-- prvni element nejen okopirujeme, ale i vlozime do nej prikaz pro smazani ostatnich internich dokladu -->
  <xsl:template match="/*[1]">
      <winstrom>
          <interni-doklad>
              <xsl:attribute name="action">
                  <xsl:value-of select="'delete'"/>
              </xsl:attribute>
              <xsl:attribute name="filter">datVyst &lt;= <xsl:value-of select="substring($maxDatVyst, 1, 10)"/> and datVyst &gt;= <xsl:value-of select="substring($minDatVyst, 1, 10)"/> and typDokl = 'code:INT. DOKLAD'</xsl:attribute>
          </interni-doklad>
     </winstrom>
  </xsl:template>

  <xsl:variable name="maxDatVyst">
    <xsl:for-each select="/winstrom/interni-doklad/datVyst">
        <xsl:sort data-type="value" order="descending"/>
        <xsl:if test="position()=1"><xsl:value-of select="."/></xsl:if>
    </xsl:for-each>
  </xsl:variable>

  <xsl:variable name="minDatVyst">
    <xsl:for-each select="/winstrom/interni-doklad/datVyst">
        <xsl:sort data-type="value" order="ascending"/>
        <xsl:if test="position()=1"><xsl:value-of select="."/></xsl:if>
    </xsl:for-each>
  </xsl:variable>
</xsl:stylesheet>