<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
  <xsl:output method="xml" indent="yes" encoding="utf-8" />
  <xsl:template match="MoneyData">
  <winstrom version="1.0">
    <!-- projdeme vsechny pokladnich dokladech serazene podle pokladen -->
    <xsl:for-each select="./SeznamPokDokl/PokDokl">
      <xsl:sort select="Pokl"/>
      <!-- pokud se jedna o prvni vyskyt teto pokladny zalozime ji + pokladni doklad na jeji stav -->
      <xsl:variable name="Pokl" select="Pokl"/>
      <xsl:if test="not(following-sibling::PokDokl[Pokl=$Pokl])">
        <pokladna update="ignore">
          <id>ext:mS3pokTyp:<xsl:value-of select="java:flexibee.Tool.toUpper(Pokl)"/></id>
          <kod><xsl:value-of select="java:flexibee.Tool.toUpper(Pokl)"/></kod>
          <nazev><xsl:value-of select="Pokl"/></nazev>
        </pokladna>
        
        <pokladni-pohyb>
          <id>ext:mS3pok:<xsl:value-of select="java:flexibee.Tool.toUpper(Pokl)"/><xsl:value-of select="java:flexibee.Tool.params('rokMigrace')"/>/<xsl:value-of select="java:flexibee.Tool.params('poradiSouboru')"/></id>

          <xsl:for-each select="//PokDokl[Pokl=$Pokl]">
            <xsl:sort select="DatVyst" order="descending"/>
            <xsl:if test="position()=1">
              <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(DatVyst, 'y-M-d')"/></datVyst>
              <xsl:if test="DatUcPr">
                <duzpPuv><xsl:value-of select="java:flexibee.Tool.parseDate(DatUcPr, 'y-M-d')"/></duzpPuv>
              </xsl:if>
              <duzpUcto><xsl:value-of select="java:flexibee.Tool.parseDate(DatPln, 'y-M-d')"/></duzpUcto>            
            </xsl:if>
          </xsl:for-each>
          
          <typPohybuK>typPohybu.prijem</typPohybuK>
          <typDokl>code:STANDARD</typDokl>
          <pokladna>ext:mS3pokTyp:<xsl:value-of select="java:flexibee.Tool.toUpper(Pokl)"/></pokladna>
          <rada>code:POKLADNA+</rada>
          
          <xsl:variable name="pSumOsv" select="sum(//PokDokl[Pokl=$Pokl and Vydej=0]/SouhrnDPH/Zaklad0)"/>
          <xsl:variable name="vSumOsv" select="sum(//PokDokl[Pokl=$Pokl and Vydej=1]/SouhrnDPH/Zaklad0)"/>
          
          <xsl:variable name="pSumZklSniz" select="sum(//PokDokl[Pokl=$Pokl and Vydej=0]/SouhrnDPH/Zaklad5)"/>
          <xsl:variable name="vSumZklSniz" select="sum(//PokDokl[Pokl=$Pokl and Vydej=0]/SouhrnDPH/Zaklad5)"/>
          
          <xsl:variable name="pSumZklZakl" select="sum(//PokDokl[Pokl=$Pokl and Vydej=0]/SouhrnDPH/Zaklad22)"/>
          <xsl:variable name="vSumZklZakl" select="sum(//PokDokl[Pokl=$Pokl and Vydej=1]/SouhrnDPH/Zaklad22)"/>
          
          <xsl:variable name="pSumDphSniz" select="sum(//PokDokl[Pokl=$Pokl and Vydej=0]/SouhrnDPH/DPH5)"/>
          <xsl:variable name="vSumDphSniz" select="sum(//PokDokl[Pokl=$Pokl and Vydej=1]/SouhrnDPH/DPH5)"/>
          
          <xsl:variable name="pSumDphZakl" select="sum(//PokDokl[Pokl=$Pokl and Vydej=0]/SouhrnDPH/DPH22)"/>
          <xsl:variable name="vSumDphZakl" select="sum(//PokDokl[Pokl=$Pokl and Vydej=1]/SouhrnDPH/DPH22)"/>
          
          <sumOsv><xsl:value-of select="format-number($pSumOsv - $vSumOsv, '#.00')"/></sumOsv>
          <sumZklSniz><xsl:value-of select="format-number($pSumZklSniz - $vSumZklSniz, '#.00')"/></sumZklSniz>
          <sumZklZakl><xsl:value-of select="format-number($pSumZklZakl - $vSumZklZakl, '#.00')"/></sumZklZakl>
          <sumDphSniz><xsl:value-of select="format-number($pSumDphSniz - $vSumDphSniz, '#.00')"/></sumDphSniz>
          <sumDphZakl><xsl:value-of select="format-number($pSumDphZakl - $vSumDphZakl, '#.00')"/></sumDphZakl>
          
          <bezPolozek>true</bezPolozek>
        </pokladni-pohyb>
      </xsl:if>
    </xsl:for-each>
  </winstrom>
  </xsl:template>
</xsl:stylesheet>
