<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
  <xsl:output method="xml" indent="yes" encoding="utf-8" />
  <xsl:template match="winstrom">
    <winstrom version="1.0">
      <xsl:apply-templates select="faktura-prijata-zaloha"/>
    </winstrom>
  </xsl:template>

    <!--
	    
	INTER,N,8,0	ok
	DOKLAD,C,3	ok
	CISLO,N,12,0	ok
	ZKKOD,N,12,0	ok
	STKOD,N,12,0	
	K_SYMBOL,C,4	ok
	OBJEDNAVKA,C,24	
	DOD_LIST,C,24	
	PLATCE_DPH,L	
	DATUM_USK,D	ok
	DATUM_VYS,D	ok
	DATUM_SPL,D	ok
	CELKEM,N,15,2	ok
	ZALOHA,N,15,2	
	ZAOK,N,6,2	
	PRIJAL,C,24	
	CISLO_ODB,C,10	ok
	NAZEV_ODB,C,64	ok
	NAZEV_OD2,C,64	ign
	ULICE_ODB,C,64	ok
	PSC_ODB,C,10	ok
	MESTO_ODB,C,28	ok
	STAT_ODB,C,24	
	ICO_ODB,C,8	ok
	DIC_ODB,C,14	ok
	UCET_ODB,C,40	ok
	KOD_ODB,C,4	ok
	VARIABL,C,24	ok
	POPIS,C,48	ok
	POZNAMKA,C,48	
	PRILOHY,C,48	
	MENA,C,3	ok
	OZN_MENY,C,3	
	MENA_PRED,L	
	SAZ_DPH1,N,5,2	ok
	SAZ_DPH2,N,5,2	ok
	UC_VF,C,3	
	UC_VFA,C,3	
	UC_Z,C,3	
	UC_ZA,C,3	
	UC_OK,C,3	
	UC_OKA,C,3	
	KURS,N,18,10	ok
	M_KURS,N,5,0	ok
	PUB_ZINT,N,8,0	
	US_ADD,C,16	
	US_EDI,C,16	
	USD_ADD,C,16	
	USD_EDI,C,16	
	Z_OPERACE,C,2	
	Z_ANALYT,C,2	
	IS_DOKLAD,L	
	FORMA,C,20	ok
	OVERENO,L	
	OVERIL,C,24	
	DAN1,N,12,0	
	DAN2,N,12,0	
	DAN3,C,12	
	SPEC,C,12	
	PUB_OINT,N,8,0	
	ZADRZENO,N,15,2	
	TS,C,40	ID,C,36	
	ZAL_VS,C,12	
	JAKE_USK,N,1,0	
	DATUM_DPH,D	
	DIC_EU,C,24	
	UC_OKST,N,12,0	
	KURS_DPH,N,18,10
	KOR_MENA,N,4,2	
	KURS_EU,N,18,10	
	BARVA,N,8,0	
	ID_KON,C,36	
	WORK_STAT,C,2	
	WORK_ID,C,36	
	WORK_KOD,C,12	
	C_KOD,C,32

    -->

  <xsl:template match="faktura-prijata-zaloha">
  
    <faktura-prijata>
      <id>ext:PREMIER:Zfak<xsl:value-of select="INTER"/></id>
      <kod>FP<xsl:value-of select="CISLO"/></kod>
      <nazev><xsl:value-of select="POPIS"/></nazev>
      <typDokl>code:ZÁLOHA</typDokl>
      <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(DATUM_VYS, 'd.M.y')"/></datVyst>
      <datSplat><xsl:value-of select="java:flexibee.Tool.parseDate(DATUM_SPL, 'd.M.y')"/></datSplat>
      <bezPolozek>true</bezPolozek>
      <xsl:if test="OBJEDNAVKA != ''">
        <cisObj><xsl:value-of select="OBJEDNAVKA"/></cisObj>
      </xsl:if>
      <xsl:if test="DATUM_USK != ''">
        <duzpPuv><xsl:value-of select="java:flexibee.Tool.parseDate(DATUM_USK, 'd.M.y')"/></duzpPuv>
      </xsl:if>
      <cisDosle>
        <xsl:choose>
          <xsl:when test="ZKKOD != '0' and ZKKOD != ''">
            <xsl:value-of select="ZKKOD"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="DOKLAD"/>/<xsl:value-of select="CISLO"/>
          </xsl:otherwise>
        </xsl:choose>
      </cisDosle>
      <!-- bankovní věci -->
      <varSym><xsl:value-of select="VARIABL"/></varSym>
      <xsl:if test="K_SYMBOL != ''">
        <konSym>code:<xsl:value-of select="K_SYMBOL"/></konSym>
      </xsl:if>
      <szbDphSniz><xsl:value-of select="java:flexibee.Tool.parseMoney(SAZ_DPH1)"/></szbDphSniz>
      <szbDphZakl><xsl:value-of select="java:flexibee.Tool.parseMoney(SAZ_DPH2)"/></szbDphZakl>
      <xsl:choose>
        <xsl:when test="MENA != ''">
          <sumOsvMen><xsl:value-of select="java:flexibee.Tool.parseMoney(CELKEM)"/></sumOsvMen>
          <mena>code:<xsl:value-of select="java:flexibee.Tool.toUpper(MENA)"/></mena>
          <kurz><xsl:value-of select="java:flexibee.Tool.parseMoney(KURS)"/></kurz>
          <kurzMnozstvi><xsl:value-of select="java:flexibee.Tool.parseMoney(M_KURS)"/></kurzMnozstvi>
        </xsl:when>
        <xsl:otherwise>
          <sumOsv><xsl:value-of select="java:flexibee.Tool.parseMoney(CELKEM)"/></sumOsv>
        </xsl:otherwise>
      </xsl:choose>
      <xsl:if test="CISLO_ODB != ''">
        <firma>code:<xsl:value-of select="java:flexibee.Tool.toUpper(CISLO_ODB)"/></firma>
        <nazFirmy><xsl:value-of select="NAZEV_ODB"/></nazFirmy>
        <ulice><xsl:value-of select="ULICE_ODB"/></ulice>
        <mesto><xsl:value-of select="MESTO_ODB"/></mesto>
        <psc><xsl:value-of select="PSC_ODB"/></psc>
        <ic><xsl:value-of select="ICO_ODB"/></ic>
        <dic><xsl:value-of select="DIC_ODB"/></dic>
        <stat></stat>
      </xsl:if>
      <xsl:if test="java:flexibee.Tool.isNumber(UCET_ODB)">
        <buc><xsl:value-of select="UCET_ODB"/></buc>
        <smerKod>code:<xsl:value-of select="KOD_ODB"/></smerKod>
      </xsl:if>
      <xsl:if test="not(java:flexibee.Tool.isNumber(UCET_ODB))">
        <iban><xsl:value-of select="UCET_ODB"/></iban>
        <bic><xsl:value-of select="KOD_ODB"/></bic>
      </xsl:if>
      <formaUhrK>
        <xsl:choose>
          <xsl:when test="FORMA = 'Hotově'">formaUhr.hotove</xsl:when>
          <xsl:otherwise>formaUhr.prevod</xsl:otherwise>
        </xsl:choose>
      </formaUhrK>
    </faktura-prijata>
    
  </xsl:template>
</xsl:stylesheet>