<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java"
>
    <xsl:output method="xml" indent="yes" encoding="utf-8" />

    <xsl:template match="/winstrom">
        <winstrom version="1.0">
            <xsl:apply-templates select="*"/>
        </winstrom>
    </xsl:template>

<!--
flexibee2xml -c firmy.csv -d\; -e utf-8 -t adresar-in.xslt -o adresar.xml

-->

    <xsl:template match="row">
		<xsl:if test="subjekt != ''">
        <adresar update="fail">
            <nazev><xsl:value-of select="subjekt"/></nazev>

            <ulice><xsl:value-of select="ulica"/> <xsl:value-of select="building_number"/></ulice>
            <psc><xsl:value-of select="psc"/></psc>
            <mesto><xsl:value-of select="obec"/></mesto>
			<xsl:if test="stat != ''">
            	<stat>code:<xsl:value-of select="stat"/></stat>
			</xsl:if>
            <tel><xsl:value-of select="tel"/></tel>
            <fax><xsl:value-of select="fax"/></fax>
            <mobil><xsl:value-of select="mobil"/></mobil>
            <email><xsl:value-of select="email"/></email>
            <www><xsl:value-of select="url"/></www>
            <ic><xsl:value-of select="ico"/></ic>
            <dic><xsl:value-of select="dic"/></dic>

            <xsl:choose>
                <xsl:when test="je_platca_dph = 't'">
                    <platceDph>false</platceDph>
                </xsl:when>
                <xsl:otherwise>
                    <platceDph>true</platceDph>
                </xsl:otherwise>
            </xsl:choose>

            <xsl:choose>
                <xsl:when test="je_dodavatel = 't' and je_odberatel = 't'">
                    <typVztahuK>typVztahu.odberDodav</typVztahuK>
                </xsl:when>
                <xsl:when test="je_dodavatel = 't'">
                    <typVztahuK>typVztahu.dodavatel</typVztahuK>
                </xsl:when>
                <xsl:otherwise>
                    <typVztahuK>typVztahu.odberatel</typVztahuK>
                </xsl:otherwise>
            </xsl:choose>
                
			<xsl:if test="firma != ''">
            <id>code:<xsl:value-of select="java:flexibee.Tool.toUpper(java:flexibee.Tool.substring(firma, 0, 20))"/></id>
            <kod><xsl:value-of select="java:flexibee.Tool.toUpper(java:flexibee.Tool.substring(firma, 0, 20))"/></kod>
			</xsl:if>

            <poznam><xsl:value-of select="poznamka"/></poznam>
            <slevaDokl><xsl:value-of select="zlava"/></slevaDokl>


        </adresar>
	</xsl:if>
    </xsl:template>

</xsl:stylesheet>
