<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java"
>
    <xsl:output method="xml" indent="yes" encoding="utf-8" />

    <xsl:variable name="radkyDoc" select="document('knihavf-radky.xml')"/>

    <xsl:key name="cisloKey" match="_Řádky_vyd.fa" use="_Č.faktury"/>

    <xsl:template match="/Root">
        <winstrom version="1.0" atomic="false">
            <!--<xsl:apply-templates select="*[local-name() = 'Kniha_VF' and position() &lt; 100]"/> -->
            <xsl:apply-templates select="Kniha_VF"/>
        </winstrom>
    </xsl:template>


<!--
/usr/share/flexibee/bin/flexibee2xml -t knihavf-skladova-karta-in.xslt -x knihavf.xml -o knihavf-karta.xml
kod, nazev
-->

    <xsl:template match="Kniha_VF">
            <xsl:variable name="cislo" select="_Č.faktury"/>
	    <xsl:variable name="datum" select="java:flexibee.Tool.formatDate(java:flexibee.Tool.parseDate(Datum_pořízení, 'd.M.y'), 'yyyy')"/>

	<xsl:for-each select="$radkyDoc">
	    <xsl:for-each select="key('cisloKey',$cislo)">
                <xsl:if test="Kód_položky != '' and Kód_položky != ' '">
		    <skladova-karta update="ignore">
			<id>ext:4DD-SKL-<xsl:value-of select="$datum"/>-<xsl:value-of select="java:flexibee.Tool.toUpper(Sklad)"/>-<xsl:value-of select="java:flexibee.Tool.toUpper(Kód_položky)"/></id>
        		<ucetObdobi>code:<xsl:value-of select="$datum"/></ucetObdobi>
			<cenik>code:<xsl:value-of select="java:flexibee.Tool.toUpper(Kód_položky)"/></cenik>
				<xsl:if test="Sklad = ''">
				<sklad>code:XXX_HISTORIE</sklad>
				</xsl:if>
				<xsl:if test="Sklad != ''">
				<sklad>code:<xsl:value-of select="java:flexibee.Tool.toUpper(Sklad)"/>_HISTORIE</sklad>
				</xsl:if>
		    </skladova-karta>
                </xsl:if>
	    </xsl:for-each>
	</xsl:for-each>
    </xsl:template>

</xsl:stylesheet>
