<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java"
>
    <xsl:output method="xml" indent="yes" encoding="utf-8" />

    <xsl:variable name="radkyDoc" select="document('obj-vyd-radky.xml')"/>

    <xsl:key name="cisloKey" match="Řádky_vl.obj." use="Vl.objednávka"/>

    <xsl:template match="/Objedn.vl.">
        <winstrom version="1.0">
<!--		<xsl:apply-templates select="*[local-name() = 'Objedn.vl.' and position() &lt; 100]"/>  -->
        	<xsl:apply-templates select="Objedn.vl."/> 
        </winstrom>
    </xsl:template>


<!--
/usr/share/flexibee/bin/flexibee2xml -t objednavka-vydana-skladova-karta-in.xslt -x obj-vyd.xml -o 5-objednavka-vydana-karta.xml
-->

    <xsl:template match="Objedn.vl.">
	    <xsl:variable name="cislo" select="Vl.objednávka"/>
	    <xsl:variable name="datum" select="java:flexibee.Tool.formatDate(java:flexibee.Tool.parseDate(Datum_vyst., 'd.M.y'), 'yyyy')"/>

	<xsl:for-each select="$radkyDoc">
	    <xsl:for-each select="key('cisloKey',$cislo)">
		    <skladova-karta update="ignore">
			<id>ext:4DD-SKL-<xsl:value-of select="$datum"/>-<xsl:value-of select="java:flexibee.Tool.toUpper(Sklad)"/>-<xsl:value-of select="java:flexibee.Tool.toUpper(Kód_položky)"/></id>
        		<ucetObdobi>code:<xsl:value-of select="$datum"/></ucetObdobi>
			<cenik>ean:<xsl:value-of select="java:flexibee.Tool.toUpper(Kód_položky)"/></cenik>
			    <xsl:choose>
				<xsl:when test="Sklad != ''">
				    <sklad>code:<xsl:value-of select="java:flexibee.Tool.toUpper(Sklad)"/>_HISTORIE</sklad>
				</xsl:when>
				<xsl:otherwise>
				    <sklad>code:XXX_HISTORIE</sklad>
				</xsl:otherwise>
			    </xsl:choose>
		    </skladova-karta>
	    </xsl:for-each>
	</xsl:for-each>
    </xsl:template>

</xsl:stylesheet>
