--------------------------------------------------------------------------------
-- Bug 20569 – [winstrom] Intrastat
--------------------------------------------------------------------------------

alter table ccenik add column inkodsled character varying(50);

create or replace function runupgrade()
    returns void as $$
declare
    stat character varying(10);
    pocet integer;
begin
  select a.uuid into stat from nnastav n  left join utyporg u on u.idtyporg = n.idtyporg left join astaty a on a.idstatu = u.idstatu
    where ((select max(platioddata) from nnastav) is null or (select max(platioddata) from nnastav) = platioddata);
  
  -- intrastat jen pro cechy
  if (stat = 'CZ_CZ') then
INSERT INTO idodpodm(kod, nazev, platiod, platido, nazeva)
 VALUES
('CFR', 'Náklady a dopravné placeny', 2005, 2008, 'Cost and freight (C&F)'),
('CIF', 'Náklady, pojištění, přepravné', 2005, 2008, 'Cost, insurance and freight'),
('CIP', 'Přeprava a pojistné placeno do', 2005, 2008, 'Carriage and insurance paid to'),
('CPT', 'Přeprava placena do', 2005, 2008, 'Carriage paid to'),
('DAF', 'Dodáno na hranici', 2005, 2008, 'Delivered at frontier'),
('DDP', 'S dodáním clo placeno', 2005, 2008, 'Delivered duty paid'),
('DDU', 'S dodáním clo neplaceno', 2005, 2008, 'Delivered duty unpaid'),
('DEQ', 'S dodáním z nábřeží', 2005, 2008, 'Delivered ex-quay'),
('DES', 'Z lodě', 2005, 2008, 'Delivered ex-ship'),
('EXW', 'Ze závodu', 2005, 2008, 'Ex-works'),
('FAS', 'Vyplacené k boku lodi', 2005, 2008, 'Free alongside ship'),
('FCA', 'Vyplacené dopravci', 2005, 2008, 'Free carrier'),
('FOB', 'Vyplacené na palubu', 2005, 2008, 'Free on board'),
('K', 'Hlavní přepravu hradí kupující', 2009, 2999, 'Cost+freight-mainly paid by buyer'),
('L', 'Prodávající vše do přístavu určení', 2009, 2999, 'Cost+freight-paid by seller to port of destination'),
('M', 'Hlavní přepravu hradí prodávající', 2009, 2999, 'Cost+freight-mainly paid by seller'),
('N', 'DAF a podmínky mimo Incoterms', 2009, 2999, 'DAF and no INCOTERMS delivery terms'),
('XXX', 'Jiná dod.podm.jinde neuvedena', 2005, 2008, 'Delivery terms other than the above');

INSERT INTO idruhdopr(kod, nazev, platiod, platido, nazeva)
 VALUES
('0', 'Ostatní', 2005, 2005, 'Other'),
('2', 'Železniční (vč. kamionů na vagónu)', 2005, 2999, 'Rail transport'),
('3', 'Silniční', 2005, 2999, 'Road transport'),
('4', 'Letecká', 2005, 2999, 'Air transport'),
('5', 'Poštovní, kurýrní a speciální zásilkové služby', 2005, 2999, 'Postal consignment, mail, courier and special mail'),
('7', 'Zabudované zařízení (potrubí a vedení)', 2005, 2999, 'Fixed transport installations'),
('8', 'Vnitrozemská říční', 2005, 2999, 'Inland waterway transport'),
('9', 'Vlastní pohon (po vlastní ose)', 2005, 2999, 'Own propulsion');

INSERT INTO iintrmerjed(kod, nazev, platiod, platido, nazeva)
 VALUES
('ASV', '% obsah', 2005, 2999, '% volume'),
('CCT', 'Nosnost v tunách', 2005, 2999, 'Carrying capacity in tonnes'),
('CEN', 'Sto kusů', 2005, 2999, 'Hundred items'),
('CTM', 'Karáty (1 metrický karát = 2 x 10-4 kg)', 2005, 2999, 'Carats (1 metric carat = 2 x 10-4 kg)'),
('DHS', 'Kilogram dihydrostreptomicinu', 2005, 2999, 'Kilogram of dihydrostreptomicinum'),
('DTN', 'Sto kilogramů', 2005, 2999, 'Hundred kilograms'),
('EUR', 'Euro (používá se pro statistické účely)', 2005, 2999, 'Euro (for statistical use)'),
('GFI', 'Gram štěpných izotopů', 2005, 2999, 'Gram of fissile isotopes'),
('GRM', 'Gram', 2005, 2999, 'Gram'),
('GRT', 'Hrubá hmotnost', 2005, 2999, 'Gross weight'),
('GTO', 'Hrubá prostornost (tonáž)', 2005, 2999, 'Gross tonnage'),
('HLT', 'Hektolitr', 2005, 2999, 'Hectolitre'),
('HMT', 'Sto metrů', 2005, 2999, 'Hundred metres'),
('KCC', 'Kilogram cholin chloridu', 2005, 2999, 'Kilogram of choline chloride'),
('KCL', 'Tuna chloridu draselného', 2005, 2999, 'Tonne of potassium chloride'),
('KGM', 'Kilogram', 2005, 2999, 'Kilogram'),
('KHO', 'Kilogram peroxidu vodíku', 2005, 2999, 'Kilogram of hydrogen peroxide'),
('KLT', '1000 litrů', 2005, 2999, 'Thousand litres'),
('KMA', 'Kilogram methylaminu', 2005, 2999, 'Kilogram of methylamines'),
('KNE', 'Kilogram odkapané čisté hmotnosti', 2005, 2999, 'Kilogram drained net weight'),
('KNI', 'Kilogram dusíku', 2005, 2999, 'Kilogram of nitrogen'),
('KNS', 'Kilogram jmenovité substance', 2005, 2999, 'Kilogram of nominal substance'),
('KPH', 'Kilogram hydroxidu draselného (louh draselný)', 2005, 2999, 'Kilogram of potassium hydroxide (caustic potash)'),
('KPO', 'Kilogram oxidu draselného', 2005, 2999, 'Kilogram of potassium oxide'),
('KPP', 'Kilogram oxidu fosforečného', 2005, 2999, 'Kilogram of diphosphorus pentaoxide'),
('KSD', 'Kilogram přepočtený na 90% sušiny', 2005, 2999, 'Kilogram of substance 90% dry'),
('KSH', 'Kilogram hydroxidu sodného (louh sodný)', 2005, 2999, 'Kilogram of sodium hydroxide (caustic soda)'),
('KUR', 'Kilogram uranu', 2005, 2999, 'Kilogram of uranium'),
('LPA', 'Litr čistého (100%) alkoholu', 2005, 2999, 'Litre pure (100%) alcohol'),
('LTR', 'Litr', 2005, 2999, 'Litre'),
('MIL', 'Tisíc kusů', 2005, 2999, 'Thousand items'),
('MPR', 'Tisíc párů (používá se pro statistické účely)', 2005, 2999, 'Thousand pairs (for statistical use)'),
('MQM', '1000 metrů krychlových', 2005, 2999, 'Thousand cubic metres'),
('MTK', 'Metr čtvereční', 2005, 2999, 'Square metre'),
('MTQ', 'Metr krychlový', 2005, 2999, 'Cubic metre'),
('MTR', 'Metr', 2005, 2999, 'Metre'),
('MWH', 'Tisíc kilowatthodin', 2005, 2999, 'Thousand kilowatt hours'),
('NCL', 'Počet elementů', 2005, 2999, 'Number of elements'),
('NEL', 'Počet článků', 2005, 2999, 'Number of cells'),
('NPR', 'Počet párů', 2005, 2999, 'Number of pairs'),
('PCE', 'Počet kusů', 2005, 2999, 'Number of items'),
('TJO', 'Terajoule (spalné teplo)', 2005, 2999, 'Terajoule (gross calorific value)'),
('TNE', 'Tuna', 2005, 2999, 'Tonne'),
('ZZZ', 'Bez doplňkové jednotky', 2005, 2999, 'No additional unit');

INSERT INTO ikrajurc(kod, nazev, platiod, platido, nazeva)
 VALUES
('10', 'Hlavní město Praha', 2005, 2999, 'Capital of Prague'),
('11', 'Hlavní město Praha', 2005, 2005, 'Hlavní město Praha Region'),
('20', 'Středočeský kraj', 2005, 2999, 'Central Bohemia Region'),
('21', 'Středočeský kraj', 2005, 2005, 'Středočeský Region'),
('31', 'Jihočeský kraj', 2005, 2999, 'South Bohemia Region'),
('32', 'Plzeňský kraj', 2005, 2999, 'Plzen (Pilsen) Region'),
('41', 'Karlovarský kraj', 2005, 2999, 'Karlovy Vary Region'),
('42', 'Ústecký kraj', 2005, 2999, 'Usti nad Labem Region'),
('51', 'Liberecký kraj', 2005, 2999, 'Liberec Region'),
('52', 'Královéhradecký kraj', 2005, 2999, 'Hradec Kralove Region'),
('53', 'Pardubický kraj', 2005, 2999, 'Pardubice Region'),
('61', 'Vysočina', 2005, 2008, 'Vysocina Region'),
('62', 'Jihomoravský kraj', 2005, 2008, 'South Moravia Region'),
('63', 'Kraj Vysočina', 2009, 2999, 'Vysocina Region'),
('64', 'Jihomoravský kraj', 2009, 2999, 'South Moravia Region'),
('71', 'Olomoucký kraj', 2005, 2999, 'Olomouc Region'),
('72', 'Zlínský kraj', 2005, 2999, 'Zlin Region'),
('80', 'Moravskoslezský kraj', 2005, 2999, 'Moravia-Silesian Region'),
('81', 'Moravskoslezský kraj', 2005, 2005, 'Moravskoslezský Region'),
('99', 'Kraj nelze určit', 2005, 2999, 'Unspecified Region');

INSERT INTO inomen(kod, platiod, platido, idintrmerjed, nazev, nazeva)
VALUES
('01011010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Koně,živí,plemenní,čistokrevní', 'Pure-bred breeding horses'),
('01011090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Osli,živí,plemenní,čistokrevní', 'Pure-bred breeding asses'),
('01019011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Koně,živí,k porážce,ne:plemenní,čistokrevní', 'Horses for slaughter'),
('01019019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Koně,živí,ne:plemenní,čistokrevní,k porážce', 'Live horses (excl. those pure bred for breeding and for slaughter)'),
('01019030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Osli,živí,ne:plemenní,čistokrevní', 'Live asses (excl. pure-bred for breeding)'),
('01019090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Muly a mezci,živí', 'Live mules and hinnies'),
('01021010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Jalovice (samice skotu,které se nikdy neotelily),živé,plemenné,čistokrevné', 'Pure-bred breeding heifers "female bovines that have never calved"'),
('01021030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Krávy,živé,plemenné,čistokrevné,ne:jalovice', 'Pure-bred breeding cows (excl. heifers)'),
('01021090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Skot kromě krav a jalovic,živý,plemenný,čistokrevný', 'Pure-bred breeding bovines (excl. heifers and cows)'),
('01029005', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Skot (domácí druhy),živý,hmot.<=80kg,ne:plemenný,čistokrevný', 'Live domestic bovines of a weight <= 80 kg (excl. pure-bred breeding animals)'),
('01029021', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Skot (domácí druhy),živý,hmot.>80kg,<=160kg,k porážce,ne:plemenný,čistokrevný', 'Domestic bovines of a weight of > 80 kg and <= 160 kg, for slaughter'),
('01029029', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Skot (domácí druhy),živý,hmot.>80kg,<=160kg,ostatní,ne:plemenný,čistokrevný,k porážce', 'Live domestic bovines of a weight of > 80 kg and <= 160 kg (excl. animals for sl'),
('01029041', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Skot (domácí druhy),živý,hmot.>160kg,<=300kg,k porážce,ne:plemenný,čistokrevný', 'Domestic bovines of a weight of > 160 kg and <= 300 kg, for slaughter'),
('01029049', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Skot (domácí druhy),živý,hmot.>160kg,<=300kg,ostatní,ne:plemenný,čistokrevný,k porážce', 'Live domestic bovines of a weight of > 160 kg and <= 300 kg (excl. animals for s'),
('01029051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Jalovice,živé,hmot.>300kg,k porážce,ne:plemenné,čistokrevné', 'Heifers "female domestic bovines that have never calved" of a weight of > 300 kg'),
('01029059', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Jalovice,živé,hmot.>300kg,ostatní,ne:plemenné,čistokrevné,k porážce', 'Live heifers "female domestic bovines that have never calved" of a weight of > 3'),
('01029061', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Krávy,živé,hmot.>300kg,k porážce,ne:plemenné,čistokrevné,jalovice', 'Cows "female domestic bovines" of a weight of > 300 kg, for slaughter (excl. hei'),
('01029069', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Krávy,živé,hmot.>300kg,ostatní,ne:plemenné,čistokrevné,k porážce,jalovice', 'Live cows "female domestic bovines" of a weight of > 300 kg (excl. animals for s'),
('01029071', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Skot (domácí druhy) kromě krav a jalovic,živý,hmot.>300kg,k porážce,ne:plemenný,čistokrevný', 'Live domestic bovines of a weight of > 300 kg, for slaughter (excl. heifers and'),
('01029079', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Skot (domácí druhy) kromě krav a jalovic,živý,hmot.>300kg,ostatní,ne:plemenný,čistokrevný,k porážce', 'Live domestic bovines of a weight of > 300 kg (excl. animals for slaughter, heif'),
('01029090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Skot ostatní,živý,ne:domácí druhy,plemenný,čistokrevný', 'Live non-domestic bovines (excl. pure-bred for breeding)'),
('01031000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Prasata,živá,plemenná,čistokrevná', 'Pure-bred breeding swine'),
('01039110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Prasata (domácí druhy),živá,hmot.<50kg,ne:plemenná,čistokrevná', 'Domestic swine, weighing < 50 kg (excl. pure-bred for breeding)'),
('01039190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Prasata ostatní,živá,hmot.<50kg,ne:domácí druhy,plemenná,čistokrevná', 'Live non-domestic swine, weighing < 50 kg'),
('01039211', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Prasnice (domácí druhy),živé,min.1x oprasené,hmot.>=160kg,ne:plemenné,čistokrevné', 'Live domestic sows, having farrowed at least once, weighing >= 160 kg (excl. pur'),
('01039219', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Prasata (domácí druhy) kromě prasnic,živá,hmot.>=50kg,ne:plemenná,čistokrevná', 'Live domestic swine, weighing >= 50 kg (excl. sows having farrowed at least once'),
('01039290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Prasata ostatní,živá,hmot.>=50kg,ne:domácí druhy,plemenná,čistokrevná', 'Live non-domestic swine, weighing >= 50 kg'),
('01041010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Ovce,živé,plemenné,čistokrevné', 'Pure-bred sheep for breeding'),
('01041030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Jehňata do stáří jednoho roku,živá,ne:plemenná,čistokrevná', 'Live lambs "sheep up to a year old" (excl. purebred breeding animals)'),
('01041080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Ovce,živé,ne:plemenné,čistokrevné,jehňata do stáří jednoho roku', 'Live sheep (excl. lambs and pure-bred breeding animals)'),
('01042010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kozy,živé,plemenné,čistokrevné', 'Pure-bred breeding goats'),
('01042090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kozy,živé,ne:plemenné,čistokrevné', 'Live goats (excl. pure-bred for breeding)'),
('01051111', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kuřata (Gallus domesticus) samičí,živá,hmot.<=185g,chovná,reprodukční,pro snášení vajec', 'Grandparent and parent female chicks of fowls of the species Gallus domesticus l'),
('01051119', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kuřata (Gallus domesticus) samičí,živá,hmot.<=185g,chovná,reprodukční,ostatní,ne:pro snášení vajec', 'Grandparent and parent female chicks fowls of the species Gallus domesticus of a'),
('01051191', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kuřata (Gallus domesticus) ostatní,živá,hmot.<=185g,pro snášení vajec,ne:samičí chovná,reprodukční', 'Laying stock "fowls of the species Gallus domesticus" of a weight of <= 185 g (e'),
('01051199', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kuřata (Gallus domesticus) ostatní,živá,hmot.<=185g,ne:samičí chovná,reprodukční,pro snášení vajec', 'Live fowls of the species Gallus domesticus of a weight of <= 185 g (excl. turke'),
('01051200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Krůty a krocani domácí,živí,hmot.<=185g', 'Live domestic turkeys, weighing <= 185 g'),
('01051920', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Husy domácí,živé,hmot.<=185g', 'Live domestic geese, weighing <= 185 g'),
('01051990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kachny a perličky domácí,živé,hmot.<=185g', 'Live domestic ducks and guinea fowls, weighing <= 185 g'),
('01059400', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Slepice a kohouti (Gallus domesticus),živé,hmot.>185g', 'Live fowls of the species Gallus domesticus, weighing > 185'),
('01059910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kachny domácí,živé,hmot.>185g', 'Live domestic ducks, weighing > 185 g'),
('01059920', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Husy domácí,živé,hmot.>185g', 'Live domestic geese, weighing > 185 g'),
('01059930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Krůty a krocani domácí,živí,hmot.>185g', 'Live domestic turkeys, weighing > 185 g'),
('01059950', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Perličky,živé,hmot.>185g', 'Live domestic guinea fowls, weighing > 185 g'),
('01061100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Primáti,živí', 'Live primates'),
('01061200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Velryby,delfíni,sviňuchy (savci řádu Cetacea),kapustňáci a dugongové (savci řádu Sirenia),živí', 'Live whales, dolphins and purpoises "mammals of the order Cetacea" and manatees'),
('01061910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Králíci domácí,živí', 'Live domestic rabbits'),
('01061990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Savci ostatní,živí,ne:primáti,velryby,delfíni,sviňuchy,kapustňáci,dugongové,králíci', 'Live mammals (excl. primates, whales, dolphins and purpoises "mammals of the ord'),
('01062000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Plazi (vč.hadů a želv),živí', 'Live reptiles "e.g. snakes, turtles, alligators, caymans, iguanas, gavials and l'),
('01063100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Ptáci draví,živí', 'Live birds of prey'),
('01063200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Ptáci papouškovití (vč.papoušků,makaů,kakadu),živí', 'Live psittaciformes "incl. parrots, parrakeets, macaws and cockatoos"'),
('01063910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Holubi,živí', 'Live pigeons'),
('01063990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ptáci ostatní,živí,ne:draví,papouškovití,holubi', 'Live birds (excl. birds of prey, psittaciformes "incl. parrots, parrakeets, maca'),
('01069000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zvířata ostatní,živá,ne:savci,plazi,ptáci,ryby,korýši,měkkýši a jiní vodní bezobratlí', 'Live animals (excl. mammals, reptiles, birds, fish, crustaceans, molluscs and ot'),
('02011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso hovězí čerstvé,chlazené,v celku nebo půlené', 'Carcases or half-carcases of bovine animals, fresh or chilled'),
('02012020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso hovězí čerstvé,chlazené,čtvrti zvané kompenzované,nevykostěné', '"Compensated" quarters of bovine animals with bone in, fresh or chilled'),
('02012030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso hovězí čerstvé,chlazené,přední čtvrti oddělené i neoddělené,nevykostěné', 'Unseparated or separated forequarters of bovine animals, with bone in, fresh or'),
('02012050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso hovězí čerstvé,chlazené,zadní čtvrti oddělené i neoddělené,nevykostěné', 'Unseparated or separated hindquarters of bovine animals, with bone in, fresh or'),
('02012090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso hovězí čerstvé,chlazené nevykostěné ostatní,ne:v celku,půlené,čtvrti', 'Fresh or chilled bovine cuts, with bone in (excl. carcases and half-carcases, "c'),
('02013000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso hovězí čerstvé, chlazené vykostěné', 'Fresh or chilled bovine meat, boneless'),
('02021000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso hovězí zmrazené v celku nebo půlené', 'Frozen bovine carcases and half-carcases'),
('02022010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso hovězí čtvrti zvané kompenzované,zmrazené,nevykostěné', 'Frozen "compensated" bovine quarters, with bone in'),
('02022030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso hovězí zmrazené oddělené nebo neoddělené,přední čtvrti nevykostěné', 'Frozen unseparated or separated bovine forequarters, with bone in'),
('02022050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso hovězí zmrazené oddělené nebo neoddělené,zadní čtvrti nevykostěné', 'Frozen unseparated or separated bovine hindquarters, with bone in'),
('02022090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso hovězí zmrazené nevykostěné ostatní,ne:v celku,půlené,čtvrti', 'Frozen bovine cuts, with bone in (excl. carcases and half-carcases, "compensated'),
('02023010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso hovězí zmrazené vykostěné,čtvrti, celé, dělené maximálně na 5 kusů', 'Frozen bovine boneless forequarters, whole or cut in max. 5 pieces, each quarter'),
('02023050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso hovězí zmrazené vykostěné,přední čtvrti s částí boku nebo bez něj', 'Frozen bovine boneless crop, chuck and blade and brisket cuts'),
('02023090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso hovězí zmrazené vykostěné ostatní,ne čtvrti', 'Frozen bovine boneless meat (excl. forequarters, whole or cut into a maximum of'),
('02031110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso z vepřů domácích, čerstvé, chlazené v celku nebo půlené', 'Fresh or chilled domestic swine carcases and half-carcases'),
('02031190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso z vepřů ostat.,čerstvé,chlazené v celku nebo půlené,ne:z vepřů domácích', 'Fresh or chilled non-domestic swine carcases and half-carcases'),
('02031211', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kýty a kusy z nich z vepřů domácích,čerstvé,chlazené,nevykostěné', 'Fresh or chilled with bone in, domestic swine hams and cuts thereof'),
('02031219', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plece a kusy z nich z vepřů domácích,čerstvé,chlazené,nevykostěné', 'Fresh or chilled with bone in, domestic swine shoulders and cuts thereof'),
('02031290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kýty,plece a jejich části z vepřů ost.,čerstvé,chlaz.,nevykosť.,ne:vepř domácí', 'Fresh or chilled hams, shoulders and cuts thereof with bone in of non-domestic s'),
('02031911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části přední a kusy z nich z vepřů domacích,čerstvé,chlazené', 'Fresh or chilled fore-ends and cuts thereof of domestic swine'),
('02031913', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hřbety s kostí a kusy z nich z vepřů domácích,čerstvé,chlazené', 'Fresh or chilled loins and cuts thereof of domestic swine'),
('02031915', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Boky bez kostí a kusy z nich z vepřů domácích,čerstvé,chlazené', 'Fresh or chilled bellies "streaky" and cuts thereof of domestic swine'),
('02031955', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso z vepřů domácích ostatní,čerstvé,chlazené,vykostěné,ne:viz sazebník', 'Fresh or chilled boneless meat of domestic swine (excl. bellies and cuts thereof'),
('02031959', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso z vepřů domácích ostatní,čerstvé,chlazené,nevykostěné,ne:viz sazebník', 'Fresh or chilled boneless meat of domestic swine (excl. carcases and half-carcas'),
('02031990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso z vepřů ostatních čerstvé,chlazené,ne:z vepřů domácích,v celku,půlky', 'Fresh or chilled meat of non-domestic swine (excl. carcases and half-carcases, h'),
('02032110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso z vepřů domácích zmrazené v celku nebo půlené', 'Frozen domestic swine carcases and half-carcases'),
('02032190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso z vepřů ostatních zmrazené v celku nebo půlené,ne:z vepřů domácích', 'Frozen non-domestic swine carcases and half-carcases'),
('02032211', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kýty a kusy z nich z vepřů domácích,zmrazené,nevykostěné', 'Frozen boneless hams and cuts thereof of domestic swine'),
('02032219', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plece a kusy z nich z vepřů domácích,zmrazené,nevykostěné', 'Frozen boneless shoulders and cuts thereof of domestic swine'),
('02032290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kýty a plece z vepřů ostatních zmrazené,nevykostěné,ne:z vepřů domácích', 'Frozen boneless hams, shoulders and cuts thereof of non-domestic swine'),
('02032911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části přední a kusy z nich z vepřů domácích,zmrazené', 'Frozen fore-ends and cuts thereof of domestic swine'),
('02032913', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hřbety s kostí a kusy z nich z vepřů domácích,zmrazené', 'Frozen loins and cuts thereof of domestic swine, with bone in'),
('02032915', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Boky bez kostí a kusy z nich z vepřů domácích,zmrazené', 'Frozen bellies "streaky" and cuts thereof of domestic swine'),
('02032955', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso z vepřů domácích ostatní zmrazené,vykostěné,ne:boky', 'Frozen boneless meat of domestic swine (excl. bellies and cuts thereof)'),
('02032959', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso z vepřů domácích ostatní zmrazené,nevykostěné,ne:kýty,plece,hřbety,před.', 'Frozen boneless meat of domestic swine, with bone in (excl. carcases and half-ca'),
('02032990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso z vepřů ostatních,zmrazené,ne:z vepřů domácích,v celku,půlené', 'Frozen meat of non-domestic swine (excl. carcases and half-carcases and hams, sh'),
('02041000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jehně čerstvé chlazené v celku nebo půlené', 'Fresh or chilled lamb carcases and half-carcases'),
('02042100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso skopové ostatní čerstvé chlazené v celku nebo půlené,ne:jehněčí', 'Fresh or chilled sheep carcases and half-carcases (excl. lambs)'),
('02042210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso skopové předky a půlené předky čerstvé,chlazené,nevykostěné', 'Fresh or chilled sheep short forequarters'),
('02042230', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso skopové hřbety,pečeně,i půlené čerstvé,chlazené,nevykostěné', 'Fresh or chilled sheep chines and/or best ends'),
('02042250', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso skopové kýty spojené i oddělené čerstvé,chlazené,nevykostěné', 'Fresh or chilled sheep legs'),
('02042290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso skopové ostatní čerstvé,chlazené,nevykostěné,ne:předky,hřbety,pečeně,kýty', 'Fresh or chilled boneless cuts of sheep, with bone in (excl. carcases and half-c'),
('02042300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso skopové čerstvé,chlazené,vykostěné', 'Fresh or chilled boneless cuts of sheep'),
('02043000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jehně zmrazené v celku nebo půlené', 'Frozen lamb carcases and half-carcases'),
('02044100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso skopové ostatní zmrazené v celku nebo půlené,ne:jehněčí', 'Frozen sheep carcases and half-carcases (excl. lambs)'),
('02044210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso skopové předky i půlené,zmrazené,nevykostěné', 'Frozen sheep short forequarters'),
('02044230', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso skopové hřbety a šrůtka i půlené zmrazené,nevykostěné', 'Frozen sheep chines and/or best ends'),
('02044250', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso skopové kýty spojené i oddělené zmrazené,nevykostěné', 'Frozen sheep legs'),
('02044290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso skopové ost.zmrazené,nevykosť.,ne:v celku,půlky,předky,hřbety,kýty,pečeně', 'Frozen cuts of sheep, with bone in (excl. carcases and half-carcases, short fore'),
('02044310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso jehněčí zmrazené,vykostěné', 'Frozen meat of lambs, boneless, frozen'),
('02044390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso skopové ostatní zmrazené,vykostěné,ne:jehněčí', 'Frozen meat of sheep, boneless (excl. lamb)'),
('02045011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso kozí kýty spojené i oddělené čerstvé, chlazené', 'Fresh or chilled goat carcases and half-carcases'),
('02045013', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso kozí předky i půlené čerstvé, chlazené', 'Fresh or chilled goat short forequarters'),
('02045015', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso kozí hřbety a šrůtka i půlené čerstvé, chlazené', 'Fresh or chilled goat chines and/or best ends'),
('02045019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso kozí kýty spojené i oddělené čerstvé, chlazené', 'Fresh or chilled legs of goat'),
('02045031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso kozí ost.čerstvé,chlaz.nevykosť.,ne:v celku,půlky.předky,kýty,hřbet,šrůtka', 'Fresh or chilled cuts of goat, with bone in (excl. carcases and half-carcases, s'),
('02045039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso kozí ostatní čerstvé,chlazené vykostěné', 'Fresh or chilled boneless cuts of goat'),
('02045051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso kozí zmrazené v celku,půlené', 'Frozen goat carcases and half-carcases'),
('02045053', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso kozí předky i půlené zmrazené', 'Frozen goat short forequarters'),
('02045055', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso kozí hřbety a šrůtka i půlené zmrazené', 'Frozen goat chines and/or best ends'),
('02045059', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso kozí kýty spojené i oddělené zmrazené', 'Frozen goat legs'),
('02045071', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso kozí ostatní zmrazené nevykostěné,ne:celé,půlky,předky,hřbety,kýty,šrůtka', 'Frozen cuts of goat, with bone in (excl. carcases and half-carcases, short foreq'),
('02045079', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso kozí ostatní zmrazené vykostěné', 'Frozen boneless cuts of goat'),
('02050020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso koňské čerstvé, chlazené', 'Fresh or chilled meat of horses, asses, mules or hinnies'),
('02050080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso oslí, mulí nebo z mezků čerstvé, chlazené, zmrazené', 'Frozen meat of horses, asses, mules or hinnies'),
('02061010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Droby jedlé hovězí čerstvé,chlazené,k výrobě farmaceut.produktů', 'Fresh or chilled edible bovine offal for manufacture of pharmaceutical products'),
('02061095', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Okruží a bránice hovězí čerstvé,chlazené', 'Fresh or chilled edible bovine thick and thin skirt (excl. for manufacture of ph'),
('02061098', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Droby jedlé hovězí ostatní čerstvé,chlazené,ne:okruží,bránice,k výrobě farmaceut.produktů', 'Fresh or chilled edible bovine offal (excl. for manufacture of pharmaceutical pr'),
('02062100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jazyky hovězí zmrazené', 'Frozen edible bovine tongues'),
('02062200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Játra hovězí zmrazená', 'Frozen edible bovine livers'),
('02062910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Droby jedlé hovězí ostatní zmrazené k výrobě farmaceut.produktů,ne:játra,jazyky', 'Frozen edible bovine offal for manufacture of pharmaceutical products (excl. ton'),
('02062991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Okruží a bránice hovězí zmrazené', 'Frozen edible bovine thick and thin skirt (excl. for manufacture of pharmaceutic'),
('02062999', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Droby jedlé hovězí ostatní zmrazené,ne:játra,jazyky,okruží,bránice,k výrobě farmaceut.produktů', 'Frozen edible bovine offal (excl. for manufacture of pharmaceutical products, to'),
('02063000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Droby jedlé vepřové čerstvé,chlazené', 'Fresh or chilled edible offal of swine'),
('02064100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Játra vepřová zmrazená', 'Frozen edible livers of swine'),
('02064900', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Droby vepřové jedlé ostatní,zmrazené,ne:játra', 'Edible offal of swine, frozen (excl. livers)'),
('02068010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Droby jedlé ostatní čerstvé,chlazené k výrobě farmaceutické,ne:hovězí,vepřové', 'Fresh or chilled edible offal of sheep, goats, horses, asses, mules and hinnies,'),
('02068091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Droby jedlé koňské,oslí,z mul,mezků čerstvé,chlazené', 'Fresh or chilled edible offal of horses, asses, mules and hinnies (excl. for man'),
('02068099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Droby jedlé skopové,kozí čerstvé,chlazené', 'Fresh or chilled edible offal of sheep and goats (excl. for manufacture of pharm'),
('02069010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Droby jedlé ostatní zmrazené k výrobě farmaceutické,ne:hovězí,vepřové', 'Frozen edible offal of sheep, goats, horses, mules and hinnies, for manufacture'),
('02069091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Droby jedlé koňské,oslí,z mul,mezků zmrazené,ne:k výrobě farmauceutické', 'Frozen edible offal of horses, asses, mules and hinnies (excl. for manufacture o'),
('02069099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Droby jedlé skopové,kozí,jedlé zmrazené,ne:k výrobě farmaceutické', 'Frozen edible offal of sheep and goats (excl. for manufacture of pharmaceutical'),
('02071110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kohouti,slepice čerstvé,chlazené nedělené oškubané,kuchané zvané kuřata 83%', 'Fresh or chilled, plucked and gutted fowls of species Gallus domesticus, with he'),
('02071130', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kohouti,slepice čerstvé,chlaz.,nedělené oškubané,kuchané s droby tzv.kuřata 70%', 'Fresh or chilled, plucked and drawn fowls of species Gallus domesticus, without'),
('02071190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kohouti,slepice čerstvé,chlaz.,nedělené oškubané,kuchané zvané kuřata 65%', 'Fresh or chilled, plucked and drawn fowls of species Gallus domesticus, without'),
('02071210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kohouti,slepice zmrazené nedělené oškubané,kuchané,s droby zvané kuřata 70%', 'Frozen fowls of species Gallus domesticus, plucked and drawn, without heads and'),
('02071290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kohouti,slepice zmrazené nedělené oškubané,kuchané,zvané kuřata 65%', 'Frozen fowls of species Gallus domesticus, plucked and drawn, without heads, fee'),
('02071310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kohouti,slepice dělené-maso vykostěné čerstvé, chlazené', 'Fresh or chilled boneless cuts of fowls of the species Gallus domesticus'),
('02071320', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kohouti,slepice dělené-nevykostěné půlky,čtvrtky čerstvé,chlazené', 'Fresh or chilled halves or quarters of fowls of the species Gallus domesticus'),
('02071330', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kohouti,slepice dělené-nevykostěná křídla též bez špiček čerstvá,chlazená', 'Fresh or chilled whole wings, with or without tips, of fowls of the species Gall'),
('02071340', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kohouti,slepice dělené-nevykostěné hřbety,krky biskupy a pod.čerstvé,chlazené', 'Fresh or chilled backs, necks, backs with necks attached, rumps and wing-tips of'),
('02071350', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kohouti,slepice dělené-nevykostěná prsa a části prsíček čerstvé,chlazené', 'Fresh or chilled breasts and cuts thereof of fowls of the species Gallus domesti'),
('02071360', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kohouti,slepice dělené-nevykostěná stehna čerstvá,chlazená', 'Fresh or chilled legs and cuts thereof of fowls of the species Gallus domesticus'),
('02071370', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kohouti,slepice dělené ost.nevykostěné čerstvé,chlaz.,ne:viz sazebník', 'Fresh or chilled cuts of fowls of the species Gallus domesticus, with bone in (e'),
('02071391', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Játra z kohoutů,slepic čerstvá,chlazená', 'Fresh or chilled edible livers of fowls of the species Gallus domesticus'),
('02071399', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Droby ostatní z kohoutů,slepic čerstvé,chlazené,ne:játra', 'Fresh or chilled edible offal of fowls of the species Gallus domesticus (excl. l'),
('02071410', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kohouti,slepice dělené-vykostěné maso zmrazené', 'Frozen boneless cuts of fowls of the species Gallus domesticus'),
('02071420', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kohouti,slepice dělené-nevykostěné půlky,čtvrtky zmrazené', 'Frozen halves or quarters of fowls of the species Gallus domesticus'),
('02071430', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kohouti,slepice dělené-nevykostěná křídla též bez špiček zmrazená', 'Frozen whole wings, with or without tips, of fowls of the species Gallus domesti'),
('02071440', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kohouti,slepice dělené-nevykostěné hřbety,krky,biskupy,špičky křídel zmrazené', 'Frozen backs, necks, backs with necks attached, rumps and wing-tips of fowls of'),
('02071450', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kohouti,slepice dělené-nevykostěná prsa zmrazená', 'Frozen breasts and cuts thereof of fowls of the species Gallus domesticus, with'),
('02071460', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kohouti,slepice dělené-nevykostěná stehna zmrazená', 'Frozen legs and cuts thereof of fowls of the species Gallus domesticus, with bon'),
('02071470', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kohouti,slepice dělené-nevykosť.části ost.zmrazené,ne:viz sazebník', 'Frozen cuts of fowls of the species Gallus domesticus, with bone in (excl. halve'),
('02071491', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Játra z kohoutů,slepic zmrazená', 'Frozen edible livers of fowls of the species Gallus domesticus'),
('02071499', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Droby ostatní z kohoutů,slepic zmrazené,ne:játra', 'Frozen edible offal of fowls of the species Gallus domesticus (excl. livers)'),
('02072410', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krocani,krůty oškubané,kuchané čerstvé,chlazené nedělené,zvané krůty 80%', 'Fresh or chilled, plucked and drawn turkeys of the species domesticus, without h'),
('02072490', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krocani,krůty oškubané,kuchané čerstvé,chlazené nedělené,zvané krůty 73%', 'Fresh or chilled, plucked and drawn turkeys of the species domesticus, without h'),
('02072510', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krocani,krůty oškubané,kuchané zmrazené,nedělené,zvané krůty 80%', 'Frozen turkeys of the species domesticus, plucked and drawn, without heads and f'),
('02072590', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krocani,krůty oškubané,kuchané zmrazené,nedělené,zvané krůty 73%', 'Frozen turkeys of the species domesticus, plucked and drawn, without heads, feet'),
('02072610', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krocani,krůty dělené-vykostěné maso čerstvé,chlazené', 'Fresh or chilled boneless cuts of turkeys of the species domesticus'),
('02072620', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krocani,krůty dělené-nevykostěné půlky,čtvrtky čerstvé,chlazené', 'Fresh or chilled halves or quarters of turkeys of the species domesticus'),
('02072630', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krocani,krůty dělené-nevykostěná křídla čerstvá,chlazená', 'Fresh or chilled whole wings, with or without tips, of turkeys of the species do'),
('02072640', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krocani,krůty dělené-nevykostěné hřbety,krky biskupy apod.čerstvé,chlazené', 'Fresh or chilled backs, necks, backs with necks attached, rumps and wing-tips of'),
('02072650', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krocani,krůty dělené-nevykostěná prsa čerstvá,chlazená', 'Fresh or chilled breasts and cuts thereof of turkeys of the species domesticus,'),
('02072660', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krocani,krůty dělené-nevykostěná stehna spodní čerstvá,chlazená', 'Fresh or chilled drumsticks and cuts thereof of turkeys of the species domesticu'),
('02072670', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krocani,krůty dělené-nevykostěná stehna ost.čerstvá,chlazená,ne:stehna spodní', 'Fresh or chilled legs and cuts thereof of turkeys of the species domesticus, wit'),
('02072680', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krocani,krůty dělené-nevykostěné části ost.čerstvé,chlaz.,ne:viz sazebník', 'Fresh or chilled cuts of turkeys of the species domesticus, with bone in (excl.'),
('02072691', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Játra z krocanů,krůt čerstvá,chlazená', 'Fresh or chilled edible livers of turkeys of the species domesticus'),
('02072699', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Droby ostatní z krocanů,krůt čerstvé,chlazené,ne:játra', 'Fresh or chilled edible offal of turkeys of the species domesticus (excl. livers'),
('02072710', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krocani,krůty dělené-vykostěné maso zmrazené', 'Frozen boneless cuts of turkeys of the species domesticus'),
('02072720', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krocani,krůty dělené-nevykostěné půlky,čtvrtky zmrazené', 'Frozen halves and quarters of turkeys of the species domesticus'),
('02072730', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krocani,krůty dělené-nevykostěná křídla zmrazená', 'Frozen whole wings, with or without tips, of turkeys of the species domesticus'),
('02072740', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krocani,krůty dělené-nevykostěné hřbety,krky biskupy,špičky křídel zmrazené', 'Frozen backs, necks, backs with necks attached, rumps and wing-tips of turkeys o'),
('02072750', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krocani,krůty dělené-nevykostěná prsa zmrazená', 'Frozen breasts and cuts thereof of turkeys of the species domesticus, with bone'),
('02072760', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krocani,krůty dělené-nevykostěná stehna spodní zmrazená', 'Frozen drumsticks and cuts thereof of turkeys of the species domesticus, with bo'),
('02072770', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krocani,krůty dělené-nevykostěná stehna ostatní zmrazená,ne:spodní', 'Frozen legs and cuts thereof of turkeys of the species domesticus, with bone in'),
('02072780', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krocani,krůty dělené-nevykostěné části ostatní zmrazené,ne:viz sazebník', 'Frozen cuts of turkeys of the species domesticus, with bone in (excl. halves or'),
('02072791', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Játra z krocanů,krůt zmrazená', 'Frozen edible livers of turkeys of the species domesticus'),
('02072799', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Droby ostatní z krocanů,krůt zmrazené,ne:játra', 'Frozen edible offal of turkeys of the species domesticus (excl. livers)'),
('02073211', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kachny nedělené čerstvé,chlazené oškubané,kuchané i s droby zvané kachny 85%', 'Fresh or chilled, plucked, bled, gutted or not drawn ducks of the species domest'),
('02073215', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kachny nedělené čerstvé,chlazené oškubané,kuchané s droby zvané kachny 70%', 'Fresh or chilled, plucked and drawn ducks of the species domesticus, without hea'),
('02073219', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kachny nedělené čerstvé,chlazené oškubané,kuchané zvané kachny 63%', 'Fresh or chilled, plucked and drawn ducks of the species domesticus, without hea'),
('02073251', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Husy nedělené čerstvé,chlazené oškubané,nekuchané zvané husy 82%', 'Fresh or chilled, plucked, bled, not drawn geese of the species domesticus with'),
('02073259', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Husy nedělené čerstvé,chlazené oškubané,kuchané zvané husy 75%', 'Fresh or chilled, plucked and drawn geese of the species domesticus without head'),
('02073290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Perličky nedělené čerstvé,chlazené', 'Fresh or chilled guinea fowls, not cut into pieces'),
('02073311', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kachny nedělené zmrazené,oškubané,vykuchané zvané kachny 70%', 'Frozen ducks of the species domesticus, plucked and drawn, without heads and fee'),
('02073319', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kachny nedělené zmrazené,oškubané,vykuchané zvané kachny 63%', 'Frozen ducks of the species domesticus, plucked and drawn, without heads, feet,'),
('02073351', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Husy nedělené zmrazené,oškubané,nevykuchané zvané husy 82%', 'Frozen, plucked, bled, not drawn geese of the species domesticus with head and f'),
('02073359', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Husy nedělené zmrazené,oškubané,vykuchané zvané husy 75%', 'Frozen, plucked and drawn geese of the species domesticus without heads and feet'),
('02073390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Perličky nedělené zmrazené', 'Frozen guinea fowls, not cut into pieces'),
('02073410', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tučná játra z hus čerstvá nebo chlazená', 'Fatty livers of domestic geese, edible, fresh or chilled'),
('02073490', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tučná játra z kachen čerstvá nebo chlazená', 'Fatty livers of domestic ducks, edible, fresh or chilled'),
('02073511', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Husy dělené vykostěné čerstvé,chlazené', 'Fresh or chilled boneless cuts of geese of the species domesticus'),
('02073515', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kachny, perličky dělené vykostěné,čerstvé,chlazené', 'Fresh or chilled boneless cuts of ducks and guinea fowls of the species domestic'),
('02073521', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kachny dělené-půlky,čtvrtky nevykostěné čerstvé,chlazené', 'Fresh or chilled halves or quarters of ducks of the species domesticus'),
('02073523', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Husy dělené-půlky,čtvrtky nevykostěné čerstvé,chlazené', 'Fresh or chilled halves or quarters of geese of the species domesticus'),
('02073525', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Perličky dělené-půlky,čtvrtky nevykostěné čerstvé,chlazené', 'Fresh or chilled halves or quarters of guinea fowls of the species domesticus'),
('02073531', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kachny,husy,perličky dělené-křídla i bez špiček nevykostěná čerstvá,chlazená', 'Fresh or chilled whole wings, with or without tips, of ducks, geese and guinea f'),
('02073541', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kachny,husy,perličky dělené-hřbety,krky,biskupy nevykostěné čerstvé,chlazené', 'Fresh or chilled backs, neck, backs with neck attached, rumps and wing-tips of d'),
('02073551', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Husy dělené-prsa a jejich části nevykostěná čerstvá,chlazená', 'Fresh or chilled breasts and cuts thereof of geese of the species domesticus, wi'),
('02073553', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kachny,perličky dělené-prsa a jejich části nevykostěná čerstvá,chlazená', 'Fresh or chilled breasts and cuts thereof of duck and guinea fowl of the species'),
('02073561', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Husy dělené-stehna a jejich části nevykostěná čerstvá, chlazená', 'Fresh or chilled legs and cuts thereof of geese of the species domesticus, with'),
('02073563', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kachny,perličky dělené-stehna a jejich části nevykostěná čerstvá,chlazená', 'Fresh or chilled legs and cuts thereof of ducks and guinea fowls of the species'),
('02073571', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kachny,husy,perličky dělené-tzv.Paleta husí,kachní nevykostěná čerstvá,chlazená', 'Fresh or chilled paletots of the species domesticus'),
('02073579', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kachny,husy,perličky - části ost.nevykostěné čerstvé,chlazené,ne:viz sazebník', 'Fresh or chilled cuts of ducks, geese and guinea fowls of the species domesticus'),
('02073591', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Játra z kachen,hus,perliček čerstvá,chlazená,ne:tučná játra', 'Fresh or chilled edible livers of ducks, geese or guinea fowls (excl. fatty live'),
('02073599', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Droby kachen,hus,perliček čerstvé,chlazené,ne:játra', 'Fresh or chilled edible offal of ducks, geese and guinea fowls of the species do'),
('02073611', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Husy-maso dělené-vykostěné zmrazené', 'Frozen boneless cuts of geese of the species domesticus'),
('02073615', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kachny,perličky-maso dělené vykostěné zmrazené', 'Frozen boneless cuts of ducks and guinea fowls of the species domesticus'),
('02073621', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kachny dělené-půlky,čtvrtky nevykostěné zmrazené', 'Frozen halves or quarters of ducks of the species domesticus'),
('02073623', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Husy dělené-půlky,čtvrtky nevykostěné zmrazené', 'Frozen halves or quarters of geese of the species domesticus'),
('02073625', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Perličky dělené-čtvrtky,půlky nevykostěné zmrazené', 'Frozen halves or quarters of guinea fowls of the species domesticus'),
('02073631', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kachny,husy,perličky dělené-křídla též bez špiček nevykostěná zmrazená', 'Frozen whole wings, with or without tips, of ducks, geese and guinea fowls of th'),
('02073641', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kachny,husy,perličky dělené-hřbety,krky,biskupy a pod.nevykostěné zmrazené', 'Frozen backs, necks, backs with necks attached, rumps and wing-tips of ducks, ge'),
('02073651', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Husy dělené-prsa a jejich části nevykostěná zmrazená', 'Frozen breasts and cuts thereof of geese of the species domesticus, with bone in'),
('02073653', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kachny,perličky dělené-prsa a jejich části nevykostěná zmrazená', 'Frozen breasts and cuts thereof of ducks and guinea fowls of the species domesti'),
('02073661', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Husy dělené-stehna a jejich části nevykostěná zmrazená', 'Frozen legs and cuts thereof of geese of the species domesticus, with bone in'),
('02073663', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kachny,perličky dělené-stehna a jejich části nevykostěná zmrazená', 'Frozen legs and cuts thereof of ducks and guinea fowls of the species domesticus'),
('02073671', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kachny,husy,perličky dělené-části tzv.Paleta husí,kachní nevykostěné zmrazené', 'Frozen paletots of geese or ducks of the species domesticus'),
('02073679', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Husy,kachny,perličky dělené-části ost.nevykostěné zmrazené,ne:viz sazebník', 'Frozen cuts of ducks, geese and guinea fowls of the species domesticus, with bon'),
('02073681', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Játra tučná z hus zmrazená', 'Frozen edible fatty livers of geese of the species domesticus'),
('02073685', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Játra tučná z kachen zmrazená', 'Frozen edible fatty livers of ducks of the species domesticus'),
('02073689', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Játra z perliček tučná zmrazená', 'Frozen edible livers of ducks, geese or guinea fowls of the species domesticus ('),
('02073690', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Droby ostatní z hus,kachen,perliček zmrazené,ne:tučná játra', 'Frozen edible offal of ducks, geese and guinea fowls of the species domesticus ('),
('02081010', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso,droby jedlé z králíka domácího čerstvé,chlazené,zmrazené', 'Fresh, chilled or frozen meat and edible meat offal of domestic rabbits'),
('02081090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso,droby jedlé z králíků ost.,zajíců čerstvé,chlazené,zmrazené,ne:králík domácí', 'Fresh, chilled or frozen meat and edible offal of non-domestic rabbits and hares'),
('02083000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso,droby jedlé z primátů čerstvé,chlazené,zmrazené', 'Fresh, chilled or frozen meat and edible offal of primates'),
('02084010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso,droby jedlé z velryb čerstvé,chlazené,zmrazené', 'Fresh, chilled or frozen whales meat'),
('02084090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso,droby jedlé z delfínů,sviňuch,kapustňáků,dugongů čerstvé,chlaz.,zmraz.', 'Edible offal of whales and meat and edible offal of dolphins and purpoises "mamm'),
('02085000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso,droby jedlé z plazů (vč.hadů,želv) čerstvé,chlazené,zmrazené', 'Fresh, chilled or frozen meat and edible offal of reptiles "e.g. snakes, turtles'),
('02089010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso,droby jedlé z holubů domácích čerstvé,chlazené,zmrazené', 'Fresh, chilled or frozen domestic pigeon meat and edible offal'),
('02089030', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso,droby jedlé ze zvěřiny jiné než králíků,zajíců', 'Fresh, chilled or frozen meat and edible meat offal of game (excl. rabbits, hare'),
('02089055', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso,droby jedlé z tuleňů čerstvé,chlazené,zmrazené', 'Fresh, chilled or frozen seal meat'),
('02089060', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso,droby jedlé ze sobů čerstvé,chlazené, zmrazené', 'Fresh, chilled or frozen reindeer meat and edible offal thereof'),
('02089070', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Žabí stehýnka čerstvá,chlazená,zmrazená', 'Fresh, chilled or frozen frogs'' legs'),
('02089095', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso,droby jedlé osatní čerstvé,chlazené,zmrazené,ne:viz sazebník', 'Meat and edible offal, fresh, chilled or frozen (excl. bovine animals, swine, sh'),
('02090011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slanina vepřová neprorostlá čerstvá,chlazená,zmrazená,solená,ve slaném nálevu', 'Fresh, chilled or frozen subcutaneous pig fat, salted or in brine'),
('02090019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slanina vepřová neprorostlá sušená,uzená', 'Dried or smoked subcutaneous pig fat'),
('02090030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sádlo vepřové ostatní,ne:slanina čerstvá,chlaz.,zmraz.,solená,sušená,uzená', 'Pig fat, not rendered or otherwise extracted'),
('02090090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sádlo drůbeží', 'Poultry fat, not rendered or otherwise extracted'),
('02101111', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plece a jejich části z vepřů domácích nevykostěné nasolené,ve slaném nálevu', 'Domestic swine hams and cuts thereof, salted or in brine, with bone in'),
('02101119', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plece a jejich části z vepřů domácích nevykostěné nasolené,ve slaném nálevu', 'Domestic swine shoulders and cuts thereof, salted or in brine, with bone in'),
('02101131', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kýty a jejich části z vepřů domácích nevykostěné sušené,uzené', 'Domestic swine hams and cuts thereof, dried or smoked, with bone in'),
('02101139', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plece a jejich části z vepřů domácích nevykostěné sušené,uzené', 'Domestic swine shoulders and cuts thereof, dried or smoked, with bone in'),
('02101190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kýty,plece a jejich části z vepřů ost.,nevykostěné solené,uzené ne:vepř domácí', 'Hams, shoulders and cuts thereof of non-domestic swine, salted, in brine, dried'),
('02101211', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bůčky prorostlé z vepřů domácích nasolené,v nálevu', 'Bellies "streaky" and cuts thereof of domestic swine, salted or in brine'),
('02101219', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bůčky prorostlé z vepřů domácích sušené,uzené', 'Bellies "streaky" and cuts thereof of domestic swine, dried or smoked'),
('02101290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bůčky prorostlé z vepřů ostatních nasolené,sušené,uzené,ne:vepř domácí', 'Bellies "streaky" and cuts thereof of non-domestic swine, salted, in brine, drie'),
('02101910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Boky slanin,přední tři čtvrti z vepřů domácích,nasolené, ve slaném nálevu', 'Bacon sides or spencers of domestic swine, salted or in brine'),
('02101920', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zadní tři čtvrti,půlky z vepřů domácích nasolené, ve slaném nálevu', 'Three-quarter-sides or middles of domestic swine, salted or in brine'),
('02101930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části přední,kusy z nich z vepřů domácích,nasolené,ve slaném nálevu', 'Fore-ends and cuts thereof of domestic swine, salted or in brine'),
('02101940', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hřbety s kostí,kusy z nich z vepřů domácích,nasolené,ve slaném nálevu', 'Loins and cuts thereof of domestic swine, salted or in brine'),
('02101950', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso ost.z vepřů domácích nasolené,v nálevu,ne:viz sazebník', 'Meat of domestic swine, salted or in brine (excl. hams, shoulders and cuts there'),
('02101960', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části přední a kusy z nich z vepřů domácích sušené,uzené', 'Domestic swine fore-ends and cuts thereof, dried or smoked'),
('02101970', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hřbety s kostí a kusy z nich z vepřů domácích sušené,uzené', 'Domestic swine loins and cuts thereof, dried or smoked'),
('02101981', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso ostatní z vepřů domácích vykostěné sušené,uzené,ne:přední část', 'Dried or smoked boneless domestic swine meat (excl. bellies and cuts thereof)'),
('02101989', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso ostatní z vepřů domácích nevykostěné sušené,uzené,ne:přední část,hřbet', 'Dried or smoked domestic swine meat, with bone in (excl. hams, shoulders and cut'),
('02101990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso z vepřů ostatních solené,ve slaném nálevu,sušené,uzené,ne:z vepřů domácích', 'Meat of non-domestic swine, salted, in brine, dried or smoked (excl. hams, shoul'),
('02102010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso hovězí nevykostěné,solené,ve slaném nálevu,sušené,uzené', 'Meat of bovine animals, salted, in brine, dried or smoked, with bone in'),
('02102090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso hovězí vykostěné solené,ve slaném nálevu,sušené,uzené', 'Boneless meat of bovine animals, salted, in brine, dried or smoked'),
('02109100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso z primátů solené,ve slaném nálevu,sušené,uzené', 'Meat and edible offal, salted, in brine, dried or smoked, and edible flours and'),
('02109200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso z velryb,delfínů,sviňuch,kapustňáků,dugongů solené,sušené,uzené', 'Meat and edible offal, salted, in brine, dried or smoked, and edible flours and'),
('02109300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso z plazů(vč,hadů,želv) solené,ve slaném nálevu,sušené,uzené', 'Meat and edible offal, salted, in brine, dried or smoked, and edible flours and'),
('02109910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso koňské solené,ve slaném nálevu,sušené', 'Horsemeat, salted, in brine or dried'),
('02109921', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso skopové,kozí nevykostěné,solené,ve slaném nálevu,sušené uzené', 'Meat of sheep and goats, salted, in brine, dried or smoked, with bone in'),
('02109929', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso skopové,kozí vykostěné,solené,ve slaném nálevu,sušené,uzené', 'Boneless meat of sheep and goats, salted, in brine, dried or smoked'),
('02109931', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso sobí solené,ve slaném nálevu,sušené,uzené', 'Reindeer meat, salted, in brine, dried or smoked'),
('02109939', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso ostatní solené,v nálevu,sušené,uzené,ne:viz sazebník', 'Meat, salted, in brine, dried or smoked (excl. of swine, bovine animals, reindee'),
('02109941', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Játra z vepřů domácích,solená,ve slaném nálevu,sušená,uzená', 'Edible domestic swine livers, salted, in brine, dried or smoked'),
('02109949', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Droby jedlé ost.z vepřů domácích,solené,ve slaném nálevu,sušené,uzené,ne:játra', 'Edible domestic swine offal, salted, in brine, dried or smoked (excl. livers)'),
('02109951', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Okruží a bránice hovězí tlustá,tenká,solená,ve slaném nálevu,sušená,uzená', 'Edible thick skirt and thin skirt of bovine animals, salted, in brine, dried or'),
('02109959', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Droby jedlé hovězí ostatní solené,v nálevu,sušené,uzené,ne:okruží a bránice', 'Edible offal of bovine animals, salted, in brine, dried or smoked (excl. thick s'),
('02109960', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Droby jedlé skopové,kozí,solené,ve slaném nálevu,sušené,uzené', 'Edible offal of sheep and goats, salted, in brine, dried or smoked'),
('02109971', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Játra z vykrmených hus,kachen solená,ve slaném nálevu', 'Edible fatty goose or duck livers, salted or in brine'),
('02109979', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Játra drůbeží ostatní solená,ve slaném nálevu,ne:z vykrmených hus,kachen', 'Edible poultry liver, salted, in brine, dried or smoked (excl. fatty goose or du'),
('02109980', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Droby drůbeží jedlé ostatní solené,ve slaném nálevu,ne:játra', 'Edible offal, salted, in brine, dried or smoked (excl. of domestic swine, bovine'),
('02109990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Moučky,prášky jedlé z masa,drobů', 'Edible flours and meals, of meat and meat offal'),
('03011010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ryby akvarijní živé sladkovodní', 'Live ornamental freshwater fish'),
('03011090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ryby akvarijní živé mořské', 'Live ornamental saltwater fish'),
('03019110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pstruzi druhu Oncorhynchus apache,chrysogaster živí', 'Live trout "Oncorhynchus apache and Oncorhynchus chrysogaster"'),
('03019190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pstruzi ostatní živí,ne:Oncorhyncus apache,chrysogaster', 'Live trout "Salmo trutta, Oncorhynchus mykiss, Oncorhynchus clarki, Oncorhynchus'),
('03019200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Úhoři živí', 'Live eels "Anguilla spp."'),
('03019300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kapři živí', 'Live carp'),
('03019400', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuňák obecný,živý', 'Live bluefin tunas "Thunnus thynnus"'),
('03019500', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuňák australský,živý', 'Live southern bluefin tunas "Thunnus maccoyii"'),
('03019911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lososi druhu Oncorhynchus,obecní,hlavatka obec.podunajská,živí,ne:viz sazebník', 'Live Pacific salmon "Oncorhynchus nerka, Oncorhynchus gorbuscha, Oncorhynchus ke'),
('03019919', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ryby sladkovodní živé ostatní,ne:akvarijní,pstruh,úhoř,kapr,losos,hlavatka', 'Live freshwater fish (excl. ornamental fish, trout, eels, carp, Pacific salmon "'),
('03019980', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ryby mořské živé ostatní,ne:viz sazebník', 'Live saltwater fish (excl. ornamental fish, trout [Salmo trutta, Oncorhynchus my'),
('03021110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pstruzi druhu Oncorhynchus apache,chryso.čerstvé,chlazené,ne:játra,jikry,mlíčí', 'Fresh or chilled trout "Oncorhynchus apache and Oncorhynchus chrysogaster"'),
('03021120', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pstruzi druhu Oncorhynchus mikiss,čerství,chlaz.,ne:játra,jikry,mlíčí', 'Fresh or chilled trout of the species "Oncorhynchus mykiss", with heads on and g'),
('03021180', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pstruzi ostatní,čerství,chlaz.,ne:viz sazebník', 'Fresh or chilled trout "Salmo trutta, Oncorhynchus mykiss, Oncorhynchus clarki,'),
('03021200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lososi druhu Oncorhynchus,obecní,hlavatka obec.podunaj.,čerst.,chlaz.,ne:játra,jikry,mlíčí', 'Fresh or chilled Pacific salmon "Oncorhynchus nerka, Oncorhynchus gorbuscha, Onc'),
('03021900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ryby lososovité ostatní,čerstvé,chlazené,ne:losos,pstruh,játra,jikry,mlíčí', 'Fresh or chilled salmonidae (excl. trout "Salmo trutta, Oncorhynchus mykiss, Onc'),
('03022110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Platýs černý,čerstvý,chlazený,ne:játra,jikry,mlíčí', 'Fresh or chilled lesser or Greenland halibut "Hippoglossus hippoglossus"'),
('03022130', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Platýs obecný (atlant.),čerstvý,chlazený,ne:játra,jikry,mlíčí', 'Fresh or chilled Atlantic halibut "Hippoglossus hippoglossus"'),
('03022190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Platýs tichomořský,čerstvý,chlazený,ne:játra,jikry,mlíčí', 'Fresh or chilled Pacific halibut "Hippoglossus stenolepis"'),
('03022200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Platýs velký (Pleuoronectes platessa) čerstvý,chlazený,ne:játra,jikry,mlíčí', 'Fresh or chilled plaice "Pleuronectes platessa"'),
('03022300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jazíry (mořské jazyky) čerství,chlazení,ne:játra,jikry,mlíčí', 'Fresh or chilled sole "Solea spp."'),
('03022910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kambaly (Lepidorhombus spp.),čerstvé,chlazené,ne:játra,jikry,mlíčí', 'Fresh or chilled megrim "Lepidorhombus spp."'),
('03022990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ryby platýsovité ostatní čerstvé,chlazené,ne:platýsi,platýs velký,jazíry,játra', 'Fresh or chilled flat fish "Pleuronectidae, Bothidae, Cynoglossidae, Soleidae, S'),
('03023110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuňáci bílí (křídlatí),čerství,chlazení k průmys.zprac.,ne:játra,jikry,mlíčí', 'Fresh or chilled albacore or longfinned tunas "Thunnus alalunga" for industrial'),
('03023190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuňáci bílí (křídlatí),čerství,chlazení,ne:k průmysl.zprac.,játra,jikry,mlíčí', 'Fresh or chilled albacore or longfinned tunas "Thunnus alalunga" (excl. for indu'),
('03023210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuňáci žlutoploutví čerství,chlazení k průmysl.zprac.,ne:játra,jikry,mlíčí', 'Fresh or chilled yellowfin tunas "Thunnus albacares" for industrial processing o'),
('03023290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuňáci žlutoploutví čerství,chlazení,ne:k průmysl.zprac.,játra,jikry,mlíčí', 'Fresh or chilled yellowfin tunas "Thunnus albacares" (excl. for industrial proce'),
('03023310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skipjack,tuňák pruhovaný,čerství,chlaz.k prům.zprac.,ne:játra,jikry,mlíčí', 'Fresh or chilled skipjack or stripe-bellied bonito for industrial processing or'),
('03023390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skipjack,tuňák pruhovaný,čerství,chlaz.,ne:k prům.zprac.,játra,jikry,mlíčí', 'Fresh or chilled skipjack or stripe-bellied bonito (excl. for industrial process'),
('03023410', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuňák velkooký čerstvý,chlazený k prům.zpracování,ne:játra,jikry,mlíčí', 'Fresh or chilled bigeye tunas "Thunnus obesus" for industrial processing or pres'),
('03023490', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuňák velkooký ostatní čerstvý,chlazený,ne:k prům.zprac.,jatra,jikry,mlíčí', 'Fresh or chilled bigeye tunas "Thunnus obesus" (excl. tunas for industrial proce'),
('03023510', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuňák obecný čerstvý,chlazený k průmysl.zpracování,ne:játra,jikry,mlíčí', 'Fresh or chilled bluefin tunas ''Thunnus thynnus'', for industrial processing or'),
('03023590', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuňák obecný čerstvý,chlazenýost.,ne:k prům.zpracování,játra,jikry,mlíčí', 'Fresh or chilled bluefin tunas ''Thunnus thynnus'' (excl. tunas for industrial p'),
('03023610', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuňák australský,čerstvý,chlaz.k průmysl.zprac.,ne:játra,jikry,mlíčí', 'Fresh or chilled Southern bluefin tunas "Thunnus maccoyii" for industrial proces'),
('03023690', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuňák australský ost.čerstvý,chlaz.ne:k prům.zprac.,játra,jikry,mlíčí', 'Fresh or chilled Southern bluefin tunas "Thunnus maccoyii" (excl. tunas for indu'),
('03023910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuňáci ostatní čerství,chlazení k prům.zpracování', 'Fresh or chilled tunas of the genus "Thunnus" for industrial processing or prese'),
('03023990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuňáci ostatní čerství,chlazení,ne k prům.zpracování', 'Fresh or chilled tunas of the genus "Thunnus" (excl. tunas for industrial proces'),
('03024000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sleď(Clupea harengus,Clupea pallasii) čerstvý,chlaz.;ne:játra,jikry,mlíčí', 'Fresh or chilled herrings "Clupea harengus, clupea pallasii"'),
('03025010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Treska baltská (Gadus morhua) čerstvá,chlazená,ne:játra,jikry,mlíčí', 'Fresh or chilled cod "Gadus morhua"'),
('03025090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tresky ostatní čerstvé,chlazené,ne:baltská (Gadus morhua),játra,jikry,mlíčí', 'Fresh or chilled cod "Gadus ogac, Gadus macrocephalus"'),
('03026110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sardinky (Sardina pilchardus) čerstvé,chlazené,ne:játra,jikry,mlíčí', 'Fresh or chilled sardines "Sardina pilchardus"'),
('03026130', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sardinky rodu Sardinops a sardinky malé,čerstvé,chlazené,ne:játra,jikry,mlíčí', 'Fresh or chilled sardines "Sardinops spp." and sardinella "Sardinella spp."'),
('03026180', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šproty (Sprattus sprattus) čerstvé,chlazené;ne:játra,jikry,mlíčí', 'Fresh or chilled brisling or sprats "Sprattus sprattus"'),
('03026200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tresky jednoskvrnné,čerstvé,chlazené,ne:játra,jikry,mlíčí', 'Fresh or chilled haddock "Melanogrammus aeglefinus"'),
('03026300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tresky tmavé (Pollachius virens) čerstvé,chlazené,ne:játra,jikry,mlíčí', 'Fresh or chilled coalfish "Pollachius virens"'),
('03026400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Makrela (druhy viz sazebník)čerstvá,chlazená;ne:játra,jikry,mlíčí', 'Fresh or chilled mackerel "Scomber scombrus, Scomber australasicus, Scomber japo'),
('03026520', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostrouni obecní (Squalus acanthias),čerství,chlazení,ne:játra,jikry,mlíčí', 'Fresh or chilled dogfish of the species "squalus acanthias"'),
('03026550', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Máčky Scyliorhinus čerstvé,chlazené,ne:játra,jikry,mlíčí', 'Fresh or chilled dogfish of the species "scyliorhinus spp."'),
('03026560', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Žralok nosatý (Lamna nasus) čerstvý,chlazený;ne:játra,jikry,mlíčí', 'Fresh or chilled porbeagle shark (Lamna nasus)'),
('03026595', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostrouni,máčky,žraloci ost.,čerství,chlaz.,ne:druhy viz sazebník,játra,jikry,mlíčí', 'Fresh or chilled sharks (excl. dogfish of the species "Squalus acanthias", "Scyl'),
('03026600', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Úhoři (Anquila) čerství,chlazení,ne:játra,jikry,mlíčí', 'Fresh or chilled eels "Anguilla spp."'),
('03026700', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mečoun obecný (Xiphias gladius),čerstvý,chlazený,ne:játra,jikry,mlíčí', 'Fresh or chilled swordfish "Xiphias gladius"'),
('03026800', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zubatka (Dissostichus spp.),čerstvá,chlazená,ne:játra,jikry,mlíčí', 'Fresh or chilled toothfish "Dissostichus spp."'),
('03026911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kapři čerství,chlazení,ne:játra,jikry,mlíčí', 'Fresh or chilled carp'),
('03026915', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Okounovci (Oreochromis spp.) čerství,chlazení,ne:játra,jikry,mlíčí', 'Fresh or chilled tilapia (Oreochromis spp.)'),
('03026918', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ryby sladkovodní ostatní čerstvé,chlazené,ne:kapři,okounovci,játra,jikry,mlíčí', 'Fresh or chilled freshwater fish (excl. salmonidae, eels, carp and tilapia)'),
('03026921', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ryby Euthynnus čerstvé,chlaz.k prům.zprac.,ne:skipjack,tuňák pruhovaný,játra,jikry,mlíčí', 'Fresh or chilled saltwater fish of the genus Euthynnus for industrial processing'),
('03026925', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ryby Euthynnus čerstvé,chlaz.ne:k prům.zprac.,skipjack,tuňák pruhovaný,játra,jikry,mlíčí', 'Fresh or chilled saltwater fish of the genus Euthynnus (excl. for industrial pro'),
('03026931', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Okouník mořský (Sebastes marinus) čerstvý,chlazené,ne:játra,jikry,mlíčí', 'Fresh or chilled redfish "Sebastes marinus"'),
('03026933', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ropušnice severní ostatní čerstvá,chlazená,ne:játra,jikry,mlíčí', 'Fresh or chilled redfish "Sebastes spp." (excl. Sebastes marinus)'),
('03026935', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Treska polární (Boreogadus saida) čerstvá,chlazená,ne:játra,jikry,mlíčí', 'Fresh or chilled saltwater fish of the species Boreogadus saida'),
('03026941', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Treska merlan (bezvousá),čerstvá,chlazená,ne:játra,jikry,mlíčí', 'Fresh or chilled whiting "Merlangus merlangus"'),
('03026945', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mník mořský čerstvý,chlazený,ne:játra,jikry,mlíčí', 'Fresh or chilled ling "Molva spp."'),
('03026951', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Treska pestrá,evropská,čerstvá,chlazená,ne:játra,jikry,mlíčí', 'Fresh or chilled Alaska pollack "Theragra chalcogramma" and pollack "Pollachius'),
('03026955', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sardele (ančovičky),čerstvé,chlazené,ne:játra,jikry,mlíčí', 'Fresh or chilled anchovies "Engraulis spp."'),
('03026961', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zubatec obecný,růžichy rodu Pegellus,čerstvé,chlaz.,ne:játra,jikry,mlíčí', 'Fresh or chilled sea bream "Dentex dentex and Pagellus spp."'),
('03026966', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Treska štikozubec kapský,čerstvá,chlazená,ne:játra,jikry,mlíčí', 'Fresh or chilled Cape hake "shallow-water hake" "Merluccius capensis" and deepwa'),
('03026967', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Štikozubec novozélandský,čerstvý,chlazený,ne:játra,jikry,mlíčí', 'Fresh or chilled Southern hake "Merluccius australis"'),
('03026968', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Treska štikozubec,čerstvá,chlazená,ne:kapský,jižní,ne:játra,jikry,mlíčí', 'Fresh or chilled hake of the genus "Merluccius" (excl. Cape hake "shallow-water'),
('03026969', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Treska štikozubec rodu Urophycis,čerstvá,chlazená,ne:játra,jikry,mlíčí', 'Fresh or chilled hake of the genus "Urophycis"'),
('03026975', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pražmy,čerstvé,chlazené,ne:játra,jikry,mlíčí', 'Fresh or chilled ray''s bream "Brama spp."'),
('03026981', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mořský ďas,čerstvý,chlazený,ne:játra,jikry,mlíčí', 'Fresh or chilled monkfish "Lophius spp."'),
('03026982', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Treska modravá,treska patagonská,čerstvé,chlazené,ne:játra,jikry,mlíčí', 'Fresh or chilled blue whiting "Micromesistius poutassou or Gadus poutassou) and'),
('03026991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kranas obecný čerstvý,chlazený,ne:játra,jikry,mlíčí', 'Horse mackerel in "scad" "Caranx trachurus, Trachurus trachurus", fresh or chill'),
('03026992', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ryby čeledi Ophididae (Gyneptyrus blacodea) čerstvé,chlaz.,ne:játra,jikry,mlíčí', 'Fresh or chilled pink cusk-eel "Genypterus blacodes"'),
('03026994', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Okoun mořský,čerstvý,chlazený,ne:játra,jikry,mlíčí', 'Fresh or chilled sea bass "Dicentrarchus labrax"'),
('03026995', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cejn mořský,čerstvý,chlazený,ne:játra,jikry,mlíčí', 'Fresh or chilled gilt-head seabreams "Sparus aurata"'),
('03026999', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní ryby mořské, ne: viz sazebník, játra, jikry, mlíčí', 'Fresh or chilled saltwater fish, edible (excl. salmonidae, flat fish, tunas, ski'),
('03027000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Játra,jikry,mlíčí čerstvé,chlazené', 'Fresh or chilled fish livers and roes'),
('03031100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Losos nerka (červený),zmrazený,ne:játra,jikry,mlíčí', 'Frozen sockeye salmon [red salmon] "Oncorhynchus nerka"'),
('03031900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Losos ostatní zmrazený,ne:viz sazebník', 'Frozen Pacific salmon "Oncorhynchus gorbuscha, Oncorhynchus keta, Oncorhynchus t'),
('03032110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pstruzi druhu Oncorhynchus apache,chrysogaster zmrazení,ne:játra,jikry,mlíčí', 'Frozen trout "Oncorhynchus apache and Oncorhynchus chrysogaster"'),
('03032120', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ryby zmrazené druhu Oncorhynchus mikiss', 'Frozen trout of the species "Oncorhynchus mykiss", with heads on and gills on, g'),
('03032180', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní ryby zmrazené, vyjma rybího masa číslo 0304', 'Frozen trout "Salmo trutta, Oncorhynchus mykiss, Oncorhynchus clarki, Oncorhynch'),
('03032200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Losos obecný,hlavatka obec.podunajská,zmrazení,ne:játra,jikry,mlíčí', 'Frozen Atlantic salmon "Salmo salar" and Danube salmon "Hucho hucho"'),
('03032900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lososovité ryby ost.zmrazené,ne:losos obecný,hlavatka obec.podunaj.,játra,jikry,mlíčí', 'Frozen salmonidae (excl. Pacific salmon, Atlantic salmon, Danube salmon and trou'),
('03033110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Platýs černý,zmrazený,ne:játra,jikry,mlíčí', 'Frozen lesser or Greenland halibut "Reinhardtius hippoglossoides"'),
('03033130', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Platýs obecný (atlant.),zmrazený,ne:játra,jikry,mlíčí', 'Frozen Atlantic halibut "Hippoglossus hippoglossus"'),
('03033190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Platýs tichomořský,zmrazený,ne:játra,jikry,mlíčí', 'Frozen Pacific halibut "Hippoglossus stenolepis"'),
('03033200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Platýs velký (Pleuronectes platessa),zmrazený,ne:játra,jikry,mlíčí', 'Frozen plaice "Pleuronectes platessa"'),
('03033300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jazíry (mořské jazyky) zmrazené,ne:játra,jikry,mlíčí', 'Frozen sole "Solea spp."'),
('03033910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Platýs malý (Platichtys flesus) zmrazený,ne:játra,jikry,mlíčí', 'Frozen flounder "Platichthys flesus"'),
('03033930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Platýsi rodu Rhombosolea zmrazení,ne:játra,jikry,mlíčí', 'Frozen fish of the genus Rhombosolea'),
('03033970', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Platýs zmraz. ost.,ne:malý,Lepidorhombus,Rhombosolea,játra,jikry,mlíčí', 'Frozen flat fish "Pleuronectidae, Bothidae, Cynoglossidae, Soleidae, Scophthalmi'),
('03034110', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuňáci bílí (křídlatí),zmraz.k prům.zprac.,ne:játra,jikry,mlíčí', 'Frozen albacore or longfinned tunas "Thunnus alalunga" for industrial manufactur'),
('03034190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuňáci bílí (křídlatí),zmraz.,ne:k průmysl.zpracování,ne:játra,jikry,mlíčí', 'Frozen albacore or longfinned tunas "Thunnus alalunga" (excl. for industrial pro'),
('03034212', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuňáci žlutoploutví zmrazení k prům.zprac.celí nad 10 kg,ne:játra,jikry,mlíčí', 'Frozen yellowfin tunas "Thunnus albacares" for industrial manufacture of product'),
('03034218', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuňáci žlutoploutví zmrazení k prům.zprac.celí do 10 kg,ne:játra,jikry,mlíčí', 'Frozen yellowfin tunas "Thunnus albacares" for industrial manufacture of product'),
('03034242', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuňáci žlutoploutví,zmraz.,>10kg,k prům.zprac.,ne:celí,játra,jikry,mlíčí', 'Frozen yellowfin tunas "Thunnus albacares" for industrial manufacture of product'),
('03034248', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuňáci žlutoploutví,zmraz.,<=10kg,k prům.zprac.,ne:celí,játra,jikry,mlíčí', 'Frozen yellowfin tunas "Thunnus albacares" for industrial manufacture of product'),
('03034290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuňáci žlutoploutví zmrazení ostatní,ne:k průmysl.zpracování,játra,jikry,mlíčí', 'Frozen yellowfin tunas "Thunnus albacares" (excl. for industrial processing or p'),
('03034310', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skipjack,tuňák pruhovaný,zmrazení,k prům.zprac.,ne:játra,jikry,mlíčí', 'Frozen skipjack or stripe-bellied bonito "Euthynnus -Katsuwonus- pelamis" for in'),
('03034390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skipjack,tuňák pruhovaný,ost.zmraz.,ne:k průmysl.zprac.,játra,jikry,mlíčí', 'Frozen skipjack or stripe-bellied bonito "Euthynnus -Katsuwonus- pelamis" (excl.'),
('03034410', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuňák velkooký zmrazený,k prům.zprac,ne:játra,jikry,mlíčí', 'Frozen bigeye tunas "Thunnus obesus" for industrial processing or preservation'),
('03034490', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuňák velkooký zmrazený ostaní,ne:k prům.zpracování,játra,jikry,mlíčí', 'Frozen bigeye tunas "Thunnus obesus" (excl. for industrial processing or preserv'),
('03034510', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuňák obecný zmrazený,k prům.zprac.,ne:játra,jikry,mlíčí', 'Frozen bluefin tunas "Thunnus thynnus" for industrial processing or preservation'),
('03034590', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuňák obecný zmrazený ostaní,ne:k průmyslovému zpracování,játra,jikry,mlíčí', 'Frozen bluefin tunas "Thunnus thynnus" (excl. for industrial processing or prese'),
('03034610', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuňák australský zmrazený,k prům.zprac.,ne:játra,jikry,mlíčí', 'Frozen Southern bluefin tunas "Thunnus maccoyii" for industrial processing or pr'),
('03034690', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuňák australský,zmrazený,ostaní,ne:k průmyslovému zpracování,játra,jikry,mlíčí', 'Frozen Southern bluefin tunas "Thunnus maccoyii" (excl. for industrial processin'),
('03034930', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuňák ostatní zmrazený,k prům.zprac.,ne:játra,jikry,mlíčí', 'Frozen tunas of the genus "Thunnus" for industrial processing or preservation (e'),
('03034980', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuňák zmrazený ostatní,ne:k průmyslovému zpracování,játra,jikry,mlíčí', 'Frozen tunas of the genus "Thunnus" (excl. tunas for industrial processing or pr'),
('03035100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sleď (Clupea harengus,Clupea pallasii),zmrazený,ne:játra, jikry,mlíčí', 'Frozen herrings "Clupea harengus, Clupea pallasii"'),
('03035210', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tresky (Gadus morhua) zmrazené,ne:játra,jikry,mlíčí', 'Frozen cod "Gadus Morhua"'),
('03035230', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tresky (Gadus ogac),zmrazené,ne:játra,jikry,mlíčí', 'Frozen cod "Gadus Ogac"'),
('03035290', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tresky (Gadus macrocephalus),zmrazené,ne:játra,jikry,mlíčí', 'Frozen cod "Gadus macrocephalus"'),
('03036100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mečoun obecný (Xiphias gladius),zmrazený,ne:játra,jikry,mlíčí', 'Frozen swordfish "Xiphias gladius"'),
('03036200', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zubatka (Dissostichus spp.),zmrazená,ne:játra,jikry,mlíčí', 'Frozen toothfish "Dissostichus spp."'),
('03037110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sardinka obecná (sardina pilchardus) zmrazená,ne:játra,jikry,mlíčí', 'Frozen sardines "Sardina pilchardus"'),
('03037130', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sardinky (Sardinops),sardinky malé zmrazené,ne:játra,jikry,mlíčí', 'Frozen sardines "Sardinops spp." and sardinella "Sardinella spp."'),
('03037180', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šprot obecný (Sprattus sprattus) zmrazený,ne:játra, jikry,mlíčí', 'Frozen brisling or sprats "Sprattus sprattus"'),
('03037200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Treska jednoskvrnná (Melanogrammus aeglefinus),zmrazené,ne:játra,jikry,mlíčí', 'Frozen haddock "Melanogrammus aeglefinus"'),
('03037300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Treska tmavá(Pollachius virens) zmrazená,ne:játra,jikry,mlíčí', 'Frozen coalfish "Pollachius virens"'),
('03037430', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Makrela (Scomber scombrus,-japonicus) zmrazená,ne:játra, jikry,mlíčí', 'Frozen mackerel "Scomber scombrus" and "Scomber japonicus"'),
('03037490', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Makrely Scomber australasicus zmrazené,ne:játra,jikry,mlíčí', 'Frozen mackerel "Scomber australasicus"'),
('03037520', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostrouni obecní (Squalus acanthias),zmrazení,ne:játra,jikry,mlíčí', 'Frozen dogfish of the species "squalus acanthias"'),
('03037550', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Máčky (Scyliorchinus) zmrazené,ne:játra,jikry,mlíčí', 'Frozen dogfish of the species "scyliorhinus spp."'),
('03037560', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Žralok nosatý (Lamna nasus) zmrazený,ne:játra,jikry,mlíčí', 'Frozen porbeagle shark (Lamna nasus)'),
('03037595', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostrouni,máčky,žraloci ost.,zmrazení,ne:druhy viz sazebník,játra,jikry,mlíčí', 'Frozen sharks (excl. dogfish of the species "Squalus acanthias", "Scyliorhinus s'),
('03037600', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Úhoři (Anquilla) zmrazení,ne:játra,jikry,mlíčí', 'Frozen eels "Anguilla spp."'),
('03037700', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Okouni mořstí zmrazení,ne:játra,jikry,mlíčí', 'Frozen sea bass "Dicentrarchus labrax, Dicentrarchus punctatus"'),
('03037811', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Štikozubec kapský,namibijský,zmrazený,ne:játra,jikry,mlíčí', 'Frozen Cape hake "shallow-water hake" "Merluccius capensis" and deepwater hake "'),
('03037812', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Štikozubec argentinský,zmrazený,ne:játra,jikry,mlíčí', 'Frozen Argentine hake "Southwest Atlantic hake" "Merluccius hubbsi"'),
('03037813', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Štikozubec novozélandský,zmrazený,ne:játra,jikry,mlíčí', 'Frozen Southern hake "Merluccius australis"'),
('03037819', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Štikozubci Merluccius ost.,ne:kapský,namibijský,argentinský,novozélandský,játra,jikry,mlíčí', 'Frozen hake of the genus "Merluccius" (excl. Cape hake "shallow-water hake", dee'),
('03037890', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Štikozubci Urophycis,zmrazení,ne:játra,jikry,mlíčí', 'Frozen hake "Urophycis spp."'),
('03037911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kapři zmrazení,ne:játra,jikry,mlíčí', 'Frozen carp'),
('03037919', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ryby sladkovodní ostatní zmrazené,ne:kapr,játra,jikry,mlíčí', 'Frozen freshwater fish (excl. salmonidae, eels and carp)'),
('03037920', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ryby Euthynnus zmraz.,k prům.zprac.,ne:skipjack,tuňák pruhovaný,játra,jikry,mlíčí', 'Frozen saltwater fish of the genus Euthynnus, for industrial processing or prese'),
('03037931', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ryby Euthynnus zmraz.,ne:skipjack,tuňák pruhovaný,k prům.zprac.játra,jikry,mlíčí', 'Frozen saltwater fish of the genus Euthynnus (excl. skipjack or stripe-bellied b'),
('03037935', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Okouníci (Sebastes marinus),zmrazení,ne:játra,jikry,mlíčí', 'Frozen redfish "Sebastes marinus"'),
('03037937', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Okouníci ost.,zmrazení,ne:Sebastes marinus,játra,jikry,mlíčí', 'Frozen redfish "Sebastes spp." (excl. Sebastes marinus)'),
('03037941', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ryby Boreogadus saida (treska polární) zmrazené,ne:játra,jikry,mlíčí', 'Frozen saltwater fish of the species Boreogadus saida'),
('03037945', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Treska merlan (bezvousá),zmrazená,ne:játra,jikry,mlíčí', 'Frozen whiting "Merlangius merlangus"'),
('03037951', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mník (Molva) zmrazený,ne:játra,jikry,mlíčí', 'Frozen ling "Molva spp."'),
('03037955', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Treska pestrá,evropská,zmrazená,ne:játra,jikry,mlíčí', 'Frozen Alaska pollack "Theragra chalcogramma" and pollack "Pollachius pollachius'),
('03037958', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ryby druhu Orcynopsis unicolor zmrazené;ne:játra, jikry,mlíčí', 'Frozen saltwater fish of the species "Orcynopsis unicolor"'),
('03037965', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sardele (ančovičky),zmrazené,ne:játra,jikry,mlíčí', 'Frozen anchovies "Engraulis spp."'),
('03037971', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zubatec obecný (Dentex dentex),růžichy (Pagellus),zmrazené,ne:játra,jikry,mlíčí', 'Frozen sea bream "Dentex dentex and Pagellus spp."'),
('03037975', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pražmy (Brama spp.),zmrazené,ne:játra,jikry,mlíčí', 'Frozen Ray''s bream "Brama spp."'),
('03037981', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mořský ďas (Lophius spp.),zmrazený,ne:játra, jikry,mlíčí', 'Frozen monkfish "Lophius spp."'),
('03037983', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Treska modravá (Micromesistius/Gadus poutassou),zmrazená,ne:játra,jikry,mlíčí', 'Frozen blue whiting "Micromesistius poutassou or Gadus poutassou"'),
('03037985', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Treska patagonská (Micromesistius australis) zmrazená,ne:játra,jikry,mlíčí', 'Frozen southern blue whiting "Micromesistius australis"'),
('03037991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kranas obecný (Caranx trachurus,trachurus trachurus) zmraz.,ne:játra,jikry,mlíčí', 'Horse mackerel "scad" "Caranx trachurus, Trachurus trachurus", frozen'),
('03037992', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Treskovník novozélandský (Macruronus novaezelandiae),zmraz.,ne:játra,jikry,mlíčí', 'Frozen blue grenadier "Macruronus novaezelandiae"'),
('03037993', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hruj černá (Gynepterus blacodes),zmrazená,ne:játra,jikry,mlíčí', 'Frozen pink cusk-eel "Genypterus blacodes"'),
('03037994', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ryby rodu Pelotreis flavilatus a Peltorhamphus zmrazené,ne:játra,jikry,mlíčí', 'Frozen fish of the species Pelotreis flavilatus and Peltorhamphus novaezelandiae'),
('03037998', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ryby ostatní zmrazené,ne:viz sazebník', 'Frozen saltwater fish, edible (excl. salmonidae, flat fish, tunas, skipjack or s'),
('03038010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jikry tvrdé a měkké,mlíčí pro výr.kys.deoxyribonukleózové a sulfátu protaminu', 'Frozen hard and soft fish roes, for the manufacture of deoxyribonucleic acid or'),
('03038090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Játra,ostatní jikry,mlíčí,ne:játra pro výr.kys.deoxyribonukleózové a sulfátu protaminu', 'Frozen edible fish livers and roes (excl. hard and soft roes, for the manufactur'),
('03041110', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z mečouna obecného (Xiphias gladius),čerstvé,chlazené', 'Fresh or chilled fillets of swordfish "Xiphias gladius"'),
('03041190', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso ost.(i mleté) z mečouna obecného (Xiphias gladius),čerstvé,chlazené,ne:filé', 'Fresh or chilled meat "whether or not minced" of swordfish "Xiphias gladius" (ex'),
('03041210', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé ze zubatky (Dissostichus spp.),čerstvé,chlazené', 'Fresh or chilled fillets of toothfish "Dissostichus spp."'),
('03041290', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso ost.(i mleté) ze zubatky (Dissostichus spp.),čerstvé,chlazené,ne:filé', 'Fresh or chilled meat "whether or not minced" of toothfish "Dissostichus spp." ('),
('03041901', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z nilského okouna (Lates niloticus),čerstvé,chlazené', 'Fresh or chilled fillets of Nile perch (Lates niloticus)'),
('03041903', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z pangase (Pangasius spp.),čerstvé,chlazené', 'Fresh or chilled fillets of pangasius (Pangasius spp.)'),
('03041913', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z lososů Oncorhynchus,obecných,hlavatky obec.podunajské,čerstvé,chlazené', 'Fresh or chilled fillets of Pacific salmon "Oncorhynchus nerka, Oncorhynchus gor'),
('03041915', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé ze pstruhů Oncorhynchus mikiss,čerstvé,chlazené,o hmot.>400g/ks', 'Fresh or chilled fillets of trout of the species "Oncorhynchus mykiss" weighing'),
('03041917', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé ze pstruhů ost.,čerstvé,chlazené,ne:Oncorhynchus mikiss o hmot.>400g/ks', 'Fresh or chilled fillets of trout "Salmo trutta", "Oncorhynchus mykiss" weighing'),
('03041918', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z ryb sladkovodních ost.,čerstvé,chlazené,ne:druhy viz sazebník', 'Fresh or chilled fillets of freshwater fish (excl. trout "Salmo trutta, Oncorhyn'),
('03041931', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z tresek (Gadus morhua,ogac,macrocephalus),ryb Boreogadus saida,čerstvé,chlazené', 'Fresh or chilled fillets of cod "Gadus morhua, Gadus ogac, Gadus macrocephalus"'),
('03041933', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z tresky tmavé (Pollachius virens),čerstvé,chlazené', 'Fresh or chilled fillets of coalfish "Pollachius virens"'),
('03041935', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z okouníků (Sebastes spp.),čerstvé,chlazené', 'Fresh or chilled fillets of redfish "Sebastes spp."'),
('03041939', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé ost.,čerstvé,chlazené,ne:z ryb sladkovodních,mořských-viz sazebník', 'Fresh or chilled fillets of saltwater fish (excl. swordfish, toothfish, cod, fis'),
('03041991', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso ost.(i mleté) z ryb sladkovodních,čerstvé,chlazené', 'Fresh or chilled meat, whether or not minced, of freshwater fish (excl. fillets)'),
('03041997', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Řezy ze sleďů,čerstvé,chlazené', 'Fresh or chilled flaps of herring'),
('03041999', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso ost.(i mleté) z ryb ost.,čerstvé,chlazené,ne:z ryb sladkovodních,sleďů,filé', 'Fresh or chilled fish meat "whether or not minced", of saltwater fish (excl. swo'),
('03042100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z mečouna obecného (Xiphias gladius),zmrazené', 'Frozen fillets of swordfish "Xiphias gladius"'),
('03042200', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé ze zubatky (Dissostichus spp.),zmrazené', 'Frozen fillets of toothfish "Dissostichus spp."'),
('03042901', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z nilského okouna (Lates niloticus),zmrazené', 'Frozen fillets of Nile perch (Lates niloticus)'),
('03042903', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z pangase (Pangasius spp.),zmrazené', 'Frozen fillets of pangasius (Pangasius spp.)'),
('03042905', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z okounovců (Oreochromis spp.),zmrazené', 'Frozen fillets of tilapia (Oreochromis spp.)'),
('03042913', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z lososů Oncorhynchus,obecných,hlavatky obec.podunajské,zmrazené', 'Frozen fillets of Pacific salmon "Oncorhynchus nerka, Oncorhynchus gorbuscha, On'),
('03042915', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé ze pstruhů Oncorhynchus mikiss,zmrazené,o hmot.>400g/ks', 'Frozen fillets of trout of the species "Oncorhynchus mykiss" weighing > 400 g ea'),
('03042917', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé ze pstruhů ost.,zmrazené,ne:Oncorhynchus mikiss o hmot.>400g/ks', 'Frozen fillets of trout "Salmo trutta", "Oncorhynchus mykiss" weighing <= 400 g'),
('03042918', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z ryb sladkovodních ost.,zmrazené,ne:druhy viz sazebník', 'Frozen fillets of freshwater fish (excl. trout "Salmo trutta, Oncorhynchus mykis'),
('03042921', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z tresek (Gadus macrocephalus),zmrazené', 'Frozen fillets of cod "Gadus macrocephalus"'),
('03042929', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z tresek (Gadus morhua,ogac),ryb Boreogadus saida,zmrazené', 'Frozen fillets of cod "Gadus morhua, Gadus ogac" and of fish of species "Boreoga'),
('03042931', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z tresky tmavé (Pollachius virens),zmrazené', 'Frozen fillets of coalfish "Pollachius virens"'),
('03042933', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z tresky obecné (Melanogrammus aeglefinus),zmrazené', 'Frozen fillets of haddock "Melanogrammus aeglefinus"'),
('03042935', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z okouníků (Sebastes marinus),zmrazené', 'Frozen fillets of redfish "Sebastes marinus"'),
('03042939', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z okouníků (Sebastes spp.),zmrazené,ne:Sebastes marinus', 'Frozen fillets of redfish "Sebastes spp." (excl. Sebastes marinus)'),
('03042941', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z tresky merlan (bezvousé),zmrazené', 'Frozen fillets of whiting "Merlangius merlangus"'),
('03042943', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z mníků (Molva),zmrazené', 'Frozen fillets of ling "Molva spp."'),
('03042945', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'File z tuňáků (Thunus),ryb Euthynnus,zmrazené', 'Frozen fillets of tuna of the genus "Thunnus" and of fish of the genus "Euthynnu'),
('03042951', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z makrel (Scomber australasicus),zmrazené', 'Frozen fillets of mackerel "Scomber australasicus"'),
('03042953', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z makrel (Scomber scombrus,japonicus),ryb Orcinopsis unicolor,zmrazené', 'Frozen fillets of mackerel "Scomber scombrus, Scomber japonicus" and of fish of'),
('03042955', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé ze štikozubce kapského,namibijského,zmrazené', 'Frozen fillets of Cape hake "shallow-water hake" "Merluccius capensis" and of de'),
('03042956', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé ze štikozubce argentinského,zmrazené', 'Frozen fillets of argentine hake "Southwest Atlantic hake" "Merluccius hubbsi"'),
('03042958', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé ze štikozubců Merluccius ost.,zmraz.,ne:štikozubec kapský,namibijský,argentinský', 'Frozen fillets of hake of the genus "Merluccius" (excl. of Cape hake "shallow-wa'),
('03042959', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé ze štikozubců Urophycis,zmrazené', 'Frozen fillets of hake "Urophycis"'),
('03042961', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z ostrounů,máček (Squalus acanthias,Scyliorchinus),zmrazené', 'Frozen fillets of dogfish "Squalus acanthias and Scyliorhinus spp."'),
('03042965', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé ze žraloka sleďového (Obroun nosatý) (Lamna nasus),zmrazené', 'Frozen fillets of porbeagle shark (Lamna nasus)'),
('03042968', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé ze žraloků ost.,zmrazené,ne:ostrouni,máčky,žralok sleďový', 'Frozen fillets of sharks (excl. dogfish of the species "Squalus acanthias", "Scy'),
('03042971', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z platýsů (Pleuronectes platessa),zmrazené', 'Frozen fillets of plaice "Pleuronectes platessa"'),
('03042973', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z platýsů malých (Platychtis flesus),zmrazené', 'Frozen fillets of flounder "Platichthys flesus"'),
('03042975', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé ze sleďů (Clupea harengus, pallasii),zmrazené', 'Frozen fillets of herring "Clupea harengus, Clupea pallasii"'),
('03042979', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z kambaly (Lepidorhombus),zmrazené', 'Frozen fillets of megrim "Lepidorhombus spp."'),
('03042983', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z mořských ďasů (Lophius),zmrazené', 'Frozen fillets of monkfish "Lophius spp."'),
('03042985', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z tresky pestré (Theragra chalcogramma),zmrazené', 'Frozen fillets of Alaska pollack "Theragra chalcogramma"'),
('03042991', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé z treskovníka novozélandského (Macruronus novaezealandiae),zmrazené', 'Frozen fillets of blue grenadier "Macruronus novaezelandiae"'),
('03042999', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé ost.,zmrazené', 'Frozen fillets of saltwater fish (excl. swordfish, toothfish, cod, fish of the s'),
('03049100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso ost.(i mleté) z mečouna obecného (Xiphias gladius),zmrazené,ne:filé', 'Frozen meat "whether or not minced" of swordfish "Xiphias gladius" (excl. fillet'),
('03049200', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso ost.(i mleté) ze zubatky (Dissostichus spp.),zmrazené,ne:filé', 'Frozen meat "whether or not minced" of toothfish "Dissostichus spp." (excl. fill'),
('03049910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso ost.(i mleté) ze surimi,zmrazené,ne:filé', 'Frozen surimi'),
('03049921', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso ost.(i mleté) z ryb sladkovodních,zmrazené,ne:filé', 'Frozen meat "whether or not minced" of freshwater fish (excl. fillets)'),
('03049923', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso ost.(i mleté) ze sleďů (Clupea harengus,-pallasii),zmrazené,ne:filé', 'Frozen meat "whether or not minced" of herring "Clupea harengus, Clupea pallasii'),
('03049929', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso ost.(i mleté) z okouníků (Sebastes),zmrazené,ne:filé', 'Frozen meat "whether or not minced" of redfish "Sebastes spp." (excl. fillets)'),
('03049931', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso ost.(i mleté) z tresek (Gadus macrocephalus),zmrazené,ne:filé', 'Frozen meat "whether or not minced" of cod "Gadus macrocephalus" (excl. fillets)'),
('03049933', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso ost.(i mleté) z tresek (Gadus morhua),zmrazené,ne:filé', 'Frozen meat "whether or not minced" of cod "Gadus Morhua" (excl. fillets)'),
('03049939', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso ost.(i mleté) z tresek (Gadus ogac),ryb Borgeadus saida,zmrazené,ne:filé', 'Frozen meat "whether or not minced" of cod "Gadus Ogac" and of fish of the speci'),
('03049941', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso ost.(i mleté) z tresky tmavé (Pollachius virens),zmrazené,ne:filé', 'Frozen meat "whether or not minced" of coalfish "Pollachius virens" (excl. fille'),
('03049945', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso ost.(i mleté) z tresky jednoskvrnné (Melanogrammus aeglefinus),zmraz.,ne:filé', 'Frozen meat "whether or not minced" of haddock "Melanogrammus aeglefinus" (excl.'),
('03049951', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso ost.(i mleté) ze štikozubců (Merluccius,Urophycis),zmrazené,ne:filé', 'Frozen meat "whether or not minced" of hake "Merluccius spp., Urophycis spp." (e'),
('03049955', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso ost.(i mleté) z kambaly (Lepidorhombus),zmrazené,ne:filé', 'Frozen meat "whether or not minced" of megrim (excl. fillets)'),
('03049961', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso ost.(i mleté) z pražmy (Brama),zmrazené,ne:filé', 'Frozen meat "whether or not minced" of Ray''s bream "Brama spp." (excl. fillets)'),
('03049965', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso ost.(i mleté) z mořských ďasů (Lophius),zmrazené,ne:filé', 'Frozen meat "whether or not minced" of monkfish "Lophius spp." (excl. fillets)'),
('03049971', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso ost.(i mleté) z tresek modravých (Micromesistius/Gadus poutassou),zmrazené,ne:filé', 'Frozen meat "whether or not minced" of blue whiting "Micromesistius poutassou or'),
('03049975', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso ost.(i mleté) z tresky pestré (Theragra chalcogramma),zmrazené,ne:filé', 'Fish meat "whether or not minced" of Alaska pollack ''Theragra chalcogramma'', f'),
('03049999', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maso ost.(i mleté) z ryb mořských ostatních,zmrazené,ne:druhy viz sazebník,filé', 'Frozen meat "whether or not minced" of saltwater fish (excl. swordfish, toothfis'),
('03051000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rybí mouka,moučka a peleta vhodná k lidskému požívání', 'Flours, meals and pellets of fish, fit for human consumption'),
('03052000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rybí játra,jikry,mlíčí sušené,uzené,solené,ve slaném nálevu', 'Fish livers and roes, dried, smoked, salted or in brine'),
('03053011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'File z tresky Gadus morhua sušené,solené,v nálevu,ne:uzené', 'Fillets of cod "Gadus macrocephalus", dried, salted or in brine, but not smoked'),
('03053019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'File z tresek ost.,ryb Boreogadus saida sušené,solené,v nálevu,ne:Gadus morhua', 'Fillets of cod "Gadus morhua, Gadus ogac" and of fish of the species "Boreogadus'),
('03053030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'File z lososa obecného,altantického,hlavatky dunajské solené,v nálevu', 'Fillets of Pacific salmon "Oncorhynchus nerka, Oncorhynchus gorbuscha, Oncorhync'),
('03053050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'File z platýše černého solené,ve slaném nálevu,ne:uzené', 'Fillets of lesser or Greenland halibut "Reinhardtius hippoglossoides", salted or'),
('03053090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'File rybí ostatní sušené,solené,v nálevu,ne:druhy ryb viz sazebník', 'Fillets of fish, dried, salted or in brine, but smoked (excl. cod, and fish fill'),
('03054100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Losos obecný,atlantický,hlavatka podunajská uzený vč.uzeného file', 'Pacific salmon "Oncorhynchus nerka, Oncorhynchus gorbuscha, Oncorhynchus keta, O'),
('03054200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sledi uzení vč. uzeného file', 'Herrings "Clupea harengus, Clupea pallasii", smoked, incl. fillets'),
('03054910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Platýš černý uzený vč.uzeného file', 'Lesser or Greenland halibut "Reinhardtius hippoglossoides", smoked, incl. fillet'),
('03054920', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Platýš obecný uzený vč.uzeného file', 'Atlantic halibut "Hippoglossus hippoglossus", smoked, incl. fillets'),
('03054930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Makrely uzené vč.uzeného file', 'Mackerel "Scomber scombrus, Scomber australasicus, Scomber japonicus", smoked, i'),
('03054945', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pstruzi uzení vč.uzeného file', 'Trout "Salmo trutta, Oncorhynchus mykiss, Oncorhynchus clarki, Oncorhynchus agua'),
('03054950', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Úhoři uzení vč.uzeného file', 'Eels "Anguilla spp.", smoked, incl. fillets'),
('03054980', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ryby uzené ostatní vč.uzeného file,ne:druhy viz sazebník', 'Smoked fish, incl. fillets (excl. Pacific salmon, Atlantic salmon, Danube salmon'),
('03055110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tresky (Gadus morhua,ogac,macrocephalus) sušené,nesolené,ne:uzené', 'Cod "Gadus morhua, Gadus ogac, Gadus macrocephalus", dried, unsalted and unsmoke'),
('03055190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tresky (Gadus morhua,ogac,macrocephalus) sušené,solené,ne:uzené', 'Cod "Gadus morhua, Gadus ogac, Gadus macrocephalus", dried, salted, not smoked k'),
('03055910', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ryby Boreogadus saida sušené,ne:uzené', 'Fish of the species Boreogadus saida, dried, whether or not salted, not smoked s'),
('03055930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sledi (Clupea harengus,pallasii) sušení,též nasolení,ne:uzení', 'Herrings "Clupea harengus, Clupea pallasii", dried, whether or not salted, not s'),
('03055950', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ančovičky (Engraulis) sušené,též nasolené,ne:uzené', 'Anchovies "Engraulis spp." dried, whether or not salted, not smoked (excl. fille'),
('03055970', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Platýs obecný (Hippoglossus hippoglossus) sušený,též nasolený,ne:uzený', 'Atlantic Halibut "Hippoglossus Hippoglossus", dried, whether or not salted, not'),
('03055980', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ryby ostatní sušené,též solené,ne:druhy viz sazebník, ne uzené', 'Fish, dried, whether or not salted, not smoked (excl. cod, fish of the species B'),
('03056100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sledi (Clutea harengus,pallasii) solení,ve slaném nálevu,ne:sušení,uzení', 'Herrings "Clupea harengus, Clupea pallasii", salted or in brine only (excl. fill'),
('03056200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tresky (Gadus mohua,ogac,macrocephalus) solené,v slaném nálevu,ne:sušené,uzené', 'Cod "Gadus morhua, Gadus ogac, Gadus macrocephalus", salted or in brine only (ex'),
('03056300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ančovičky (Engraulis) solené,v slaném nálevu,ne:sušené,uzené', 'Anchovies "Engraulis spp.", salted or in brine only (excl. fillets)'),
('03056910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ryby Boreogadus saida solené,v slaném nálevu,ne:sušené,uzené', 'Fish of the species Boreogadus saida, salted or in brine only (excl. fillets)'),
('03056930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Platýs obecný (Hipoglossus hipoglossus) solený,v nálevu,ne:sušený,uzený', 'Atlantic halibut "Hippoglossus hippoglossus", salted or in brine only (excl. fil'),
('03056950', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Losos obecný,atlantický,hlavatka podunajská solený,v nálevu,ne:sušený,uzený', 'Pacific salmon "Oncorhynchus nerka, Oncorhynchus gorbuscha, Oncorhynchus keta, O'),
('03056980', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ryby ostatní solené,v slaném nálevu,ne:druhy viz sazebník,sušené,uzené', 'Fish, salted or in brine, but neither dried nor smoked (excl. herrings, cod, anc'),
('03061110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Langustí ocásky zmrazené', 'Frozen crawfish tails "Palinurus spp., Panulirus spp., Jasus spp.", whether in s'),
('03061190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Langusty a jiní mořští raci zmrazené,ne:ocásky', 'Frozen rock lobster and other sea crawfish "Palinurus spp., Panulirus spp. and J'),
('03061210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Humři (Homarus) zmrazení celí', 'Frozen lobsters "Homarus spp.", whole, incl. lobsters in shell, cooked by steami'),
('03061290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Humři (Homarus) ostatní zmrazení,ne:celí', 'Frozen lobsters "Homarus spp." (excl. whole)'),
('03061310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krevety Pandalidae zmrazené', 'Frozen shrimps and prawns of the Pandalidae family, whether in shell or not, inc'),
('03061330', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krevety šedé Crangon zmrazené', 'Frozen shrimps of the genus Crangon, whether in shell or not, incl. shrimps in s'),
('03061340', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krevety červené žijící v hlubinách zmrazené (Parapenaeus longirostris)', 'Frozen deepwater rose shrimps "Parapenaeus longirostris", whether in shell or no'),
('03061350', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krevety rodu Penaeus zmrazené', 'Frozen shrimps of the genus "Penaeus", whether in shell or not, incl. shrimps in'),
('03061380', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krevety ost.zmrazené,ne:rodu Pandalidae,Crangon,Parapenaeus longirostris,Penaeus', 'Frozen shrimps and prawns, whether in shell or not, incl. shrimps and prawns in'),
('03061410', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krabi Paralithodes,Chionoecetes,Callinectes zmrazené', 'Frozen crabs "Paralithodes camchaticus, Chionoecetes spp." and "Callinectes sapi'),
('03061430', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krab německý (Cancer pagurus) zmrazený', 'Frozen crabs "Cancer pagurus", whether in shell or not, incl. crabs in shell, co'),
('03061490', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krabi ostatní zmrazení,ne:Paralithodes,Chinoecetes,Callinectes,německý', 'Frozen crabs, whether in shell or not, incl. crabs in shell, cooked by steaming'),
('03061910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Raci zmrazení', 'Frozen freshwater crayfish, whether in shell or not, incl. crayfish in shell, co'),
('03061930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Raci mořští malí-langustiny (Nephrops norvegicus) zmrazení', 'Frozen Norway lobsters "Nephrops norvegicus", whether in shell or not, incl. Nor'),
('03061990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Korýši ost.zmrazení vč.mouk,mouček,pelet k lidskému pož.,ne:druhy viz sazebník', 'Frozen crustaceans, fit for human consumption, whether in shell or not, incl. cr'),
('03062100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Langusty živé i vařené čerstvé,chlazené,sušené,solené,ve slaném nálevu,ne:zmrazené', 'Rock lobster and other sea crawfish "Palinurus spp., Panulirus spp. and Jasus sp'),
('03062210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Humři živí', 'Live lobsters "Homarus spp."'),
('03062291', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Humři ostatní celí čerství,chlaz.,sušení,solení,ve sl.nálevu,ne:celí,zmrazení', 'Whole lobsters, dried, salted or in brine, incl. lobsters in shell, cooked by st'),
('03062299', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Humři ost.čerství,chlaz.,sušení,solení,ve sl.nálevu,ne:živí,celí,zmrazení', 'Parts of lobsters "Homarus spp." dried, salted or in brine, incl. parts of lobst'),
('03062310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krevety Pandalidae živé,čerstvé,chlazené,sušené,solené,ve sl.nálevu,ne:zmrazené', 'Shrimps and prawns of the Pandalidae family, whether in shell or not, live, drie'),
('03062331', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krevety šedé Crangon čerstvé,chlazené,vařené', 'Shrimps of the genus Crangon, whether in shell or not, fresh, chilled or cooked'),
('03062339', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krevety šedé Crangon sušené,solené,v nálevu,ne:čerstvé,chlaz.,vařené,zmrazené', 'Shrimps of the genus Crangon, whether in shell or not, live, dried, salted or in'),
('03062390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krevety ost.živé,čerstvé,chlaz.,suš.,solené,vařené apod.,ne:Pandalidae,Crangon', 'Shrimps and prawns, whether in shell or not, live, dried, salted or in brine, in'),
('03062430', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krab německý živý,čerstvý,chlazený,sušený,solený,v nálevu,vařený,ne:zmrazený', 'Crabs "Cancer pagurus", whether in shell or not, live, dried, salted or in brine'),
('03062480', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní krabi,ne:viz sazebník', 'Crabs, whether in shell or not, live, dried, salted or in brine, incl. crabs in'),
('03062910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Raci živí,čerství,chlaz.sušení,solení atd.vč.mouk,pelet k lidsk.pož,ne:zmrazení', 'Freshwater crayfish, whether in shell or not, live, dried, salted or in brine, i'),
('03062930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Raci mořstí malí-langustiny živí,čerství,sušení atd vč.mouček,pelet,ne:zmrazení', 'Norway lobsters "Nephrops norvegicus", whether in shell or not, live, dried, sal'),
('03062990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Korýši ostatní živí,čerství,sušení,solení apod.vč. mouk,pelet,ne:viz sazebník', 'Crustaceans fit for human consumption, whether in shell or not, live, fresh, chi'),
('03071010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ústřice ploché (Ostrea) živé do 40 g včetně lastury', 'Live flat oysters "Ostrea spp.", weighing <= 40 g each incl. shell'),
('03071090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ústřice ost.živé,čerstvé,chlazené,zmrazené nasolené apod.ne:Ostrea živé do 40g', 'Oysters, live, fresh, chilled, frozen, dried, salted or in brine (excl. live fla'),
('03072100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hřebenatky,druhu Pecten,Chlamys,Placopecten živé,čerstvé,chlazené', 'Live, fresh or chilled scallops, incl. queen scallops, of the genera Pecten, Chl'),
('03072910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hřebenatky svatojakubské (Pecten maximus) zmrazené', 'Coquilles St. Jacques "Pecten maximus", with or without shell, frozen'),
('03072990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hřebenatka kuch.,druhu Pecten,Chlamys,Placopecten ostatní.,ne:viz sazebník', 'Scallops, incl. queen scallops, of the genera Pecten, Chlamys or Placopecten, fr'),
('03073110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Škeble (Mytilus) živé, čerstvé, chlazené', 'Mussels "Mytilus spp.", live, fresh or chilled, with or without shell'),
('03073190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Škeble (Perna) živé, čerstvé, chlazené', 'Mussels "Perna spp.", live, fresh or chilled, with or without shell'),
('03073910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Škeble (Mytilus) zmrazené,sušené,solené,apod.,ne:živé,čestvé,chlazené', 'Mussels "Mytilus spp.", frozen, dried, salted or in brine, with or without shell'),
('03073990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Škeble (Perna) zmrazené,sušené,solené,apod.,ne:živé,čerstvé,chlazené', 'Mussels "Perna spp.", frozen, dried, salted or in brine, with or without shell'),
('03074110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sépie (Sepia officinalis,Rossia macrosoma, Sepiola) živé,čerstvé,chlazené', 'Cuttle fish "Sepia officinalis, Rossia macrosoma, Sepiola spp.", live, fresh or'),
('03074191', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oliheň Loligo,Ommastrephes sagittatus živá,čerstvá,chlazená', 'Squid "Loligo spp., Ommastrephes sagittatus", live, fresh or chilled, with or wi'),
('03074199', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oliheň Nototodarus,Sepiotheutis živá,čerstvá,chlazená', 'Squid "Ommastrephes spp.", "Nototodarus spp. and Sepioteuthis spp.", live, fresh'),
('03074901', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kalmaři (Sepiola rondoleti) zmrazení', 'Frozen lesser cuttle fish "Sepiola rondeleti", with or without shell'),
('03074911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sepie ostatní zmrazené,ne:Sepiola', 'Frozen cuttle fish "Sepiola", with or without shell (excl. "Sepiola rondeleti")'),
('03074918', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sepie ostatní zmrazené,ne:Sepiola', 'Frozen cuttle fish "Sepia officinalis" and "Rossia macrosoma", with or without s'),
('03074931', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oliheň Loligo vulgaris zmrazená', 'Frozen squid "Loligo vulgaris", with or without shell'),
('03074933', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oliheň Loligo pealei zmrazená', 'Frozen squid "Loligo pealei", with or without shell'),
('03074935', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oliheň Loligo patagonica zmrazená', 'Squid "loligo patagonica", frozen'),
('03074938', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oliheň Loligo ostatní zmrazená,ne:vulgaris,pealei,patagonica', 'Squid "loligo spp.", frozen (excl. loligo vulgaris, pealei and patagonica)'),
('03074951', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oliheň Ommastrephes sagittatus zmrazené', 'Frozen squid "Ommastrephes sagittatus", with or without shell'),
('03074959', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oliheň ostatní zmrazené,ne:rod Loligo,Ommastrephes sagittatus', 'Frozen squid "Ommastrephes spp.", "Nototodarus spp." and "Sepioteuthis spp.", wi'),
('03074971', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sépie (Sepia officinalis apod.) sušené,solené apod.,ne:živé,čestvé,chlazené,zmrazené', 'Cuttle fish "Sepia officinalis, Rossia macrosoma, Sepiola spp.", dried, salted o'),
('03074991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oliheň Loligo,Ommastrephes sušená,solená apod.,ne:živá,čerstvá,chlazená,zmrazená', 'Squid "Loligo spp., Ommastrephes sagittatus", dried, salted or in brine, with or'),
('03074999', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sepie ostatní suš.,solená apod.,ne:druhy viz sazebník,živé,čerstvé,chlazené,zmrazené', 'Squid "Ommastrephes spp.", "Nototodarus spp.", "Sepioteuthis spp.", dried, salte'),
('03075100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chobotnice živé,čerstvé,chlazené', 'Live, fresh or chilled octopus "Octopus spp.", with or without shell'),
('03075910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chobotnice zmrazené', 'Frozen octopus "Octopus spp.", with or without shell'),
('03075990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chobotnice ostatní, ne:živé,čerstvé,chlazené,zmrazené', 'Octopus "Octopus spp." dried, salted or in brine, with or without shell'),
('03076000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hlemýždi jiní než mořští', 'Snails, live, fresh, chilled, frozen, salted, dried or in brine, with or without'),
('03079100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Měkkýši,jiní vodní bezobratlovci ostatní živí,čerství,chlazení,ne:viz sazebník', 'Live, fresh or chilled molluscs, fit for human consumption, whether in shell or'),
('03079911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Měkkýši Illex zmrazení', '"Illex spp.", with or without shell, frozen'),
('03079913', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Škeble mořské-zaděnky,druhy Veneridae zmrazené', 'Striped venus and other "Veneridae", with or without shell, frozen'),
('03079915', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Medůzy (Rhopilema spp.) zmrazené', 'Frozen jellyfish "Rhopilema spp."'),
('03079918', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bezobratlí vodní jiní zmrazení,ne:viz sazebník', 'Frozen molluscs, fit for human consumption, whether in shell or not, incl. sea u'),
('03079990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Měkkýši,vodní bezobratlovci ost.vč.mouk,mouček,pelet,ne:viz sazebník,zmrazení', 'Molluscs, fit for human consumption, whether in shell or not, dried, salted or i'),
('04011010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mléko nezahuštěné neslazené,tuk do 1%,obsah do 2l', 'Milk and cream of a fat content by weight of <= 1%, in immediate packings of <='),
('04011090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mléko nezahuštěné neslazené ostatní,tuk do 1%,obsah nad 2l', 'Milk and cream of a fat content by weight of <= 1%, not concentrated nor contain'),
('04012011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mléko nezahuštěné neslazené,tuk přes 1% max 3%,obsah do 2l', 'Milk and cream of a fat content by weight of <= 3% but > 1%, in immediate packin'),
('04012019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mléko nezahuštěné neslazené ostatní,tuk přes 1% max.3%,obsah nad 2l', 'Milk and cream of a fat content by weight of <= 3% but > 1%, not concentrated no'),
('04012091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mléko,smetana nezahušťené neslazené,tuk přes 3% max. 6%,obsah do 2l', 'Milk and cream of a fat content by weight of > 3% but <= 6%, in immediate packin'),
('04012099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mléko,smetana nazahuštěné neslazené,tuk přes 3% max 6%,obsah nad 2l', 'Milk and cream of a fat content by weight of > 3% but <= 6%, not concentrated no'),
('04013011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Smetana nezahuštěná neslazená,tuk přes 6% max. 21%,obsah do 2l', 'Milk and cream of a fat content by weight of <= 21% but > 6%, in immediate packi'),
('04013019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Smetana nezahuštěná neslazená,tuk přes 6% max. 21%,obsah nad 2l', 'Milk and cream of a fat content by weight of <= 21% but > 6%, not concentrated n'),
('04013031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Smetana nezahuštěná neslazená,tuk přes 21% max. 45%,obsah do 2l', 'Milk and cream of a fat content by weight of > 21% but <= 45%, in immediate pack'),
('04013039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Smetana nezahuštěná neslazená,tuk přes 21% max. 45%,obsah nad 2l', 'Milk and cream of a fat content by weight of > 21% but <= 45%, not concentrated'),
('04013091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Smetana nezahuštěná neslazená,tuk přes 45%,obsah do 2l', 'Milk and cream of a fat content by weight of > 45%, in immediate packings of <='),
('04013099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Smetana nezahuštěná neslazená,tuk přes 45%,obsah nad 2l', 'Milk and cream of a fat content by weight of > 45%, not concentrated nor contain'),
('04021011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mléko v prášku ap.neslazené,tuk do 1,5%,obsah do 2,5 kg', 'Milk and cream in solid forms, of a fat content by weight of <= 1,5%, unsweetene'),
('04021019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mléko v prášku ap.neslazené,tuk do 1,5%,obsah nad 2,5 kg', 'Milk and cream in solid forms, of a fat content by weight of <= 1,5%, unsweetene'),
('04021091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mléko v prášku ap.slazené,tuk do 1,5%,obsah nad 2,5 kg', 'Milk and cream in solid forms, of a fat content by weight of <= 1,5%, sweetened,'),
('04021099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mléko v prášku ap.slazené,tuk do 1,5%,obsah nad 2,5 kg', 'Milk and cream in solid forms, of a fat content by weight of <= 1,5%, sweetened,'),
('04022111', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mléko,smetana v prášku neslazené,tuk přes 1,5% max.27%,obsah do 2,5 kg', 'Milk and cream in solid forms, of a fat content by weight of > 1,5%, unsweetened'),
('04022117', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mléko,smetana v prášku neslazená,tuk přes 1,5% max.11%,obsah nad 2,5 kg', 'Milk and cream in solid forms, of a fat content by weight of <= 11% but > 1,5%,'),
('04022119', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Smetana v prášku neslazená,tuk přes 11% max.27%,obsah nad 2,5 kg', 'Milk and cream in solid forms, of a fat content by weight of > 11% but <= 27%, u'),
('04022191', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Smetana v prášku neslazená,tuk přes 27%,obsah do 2,5 kg', 'Milk and cream in solid forms, of a fat content by weight of > 27%, unsweetened,'),
('04022199', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Smetana v prášku neslazená,tuk přes 27%,obsah nad 2,5 kg', 'Milk and cream in solid forms, of a fat content by weight of > 27%, unsweetened,'),
('04022911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mléko pro kojence v prášku,tuk přes 10%,obsah do 500 g,hermeticky uzavřené', 'Special milk for infants, in solid forms, sweetened, of a fat content by weight'),
('04022915', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mléko,smetana v prášku slazená,tuk přes 1,5% max. 27%,obsah do 2,5 kg', 'Milk and cream in solid forms, of a fat content by weight of <= 27% but > 1,5%,'),
('04022919', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mléko,smetana v prášku slazená,tuk přes 1,5% max. 27%,obsah nad 2,5 kg', 'Milk and cream in solid forms, of a fat content by weight of <= 27% but > 1,5%,'),
('04022991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Smetana v prášku slazená,tuk přes 27%,obsah do 2,5 kg', 'Milk and cream in solid forms, of a fat content by weight of > 27%, sweetened, i'),
('04022999', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Smetana v prášku slazená,tuk přes 27%,obsah nad 2,5 kg', 'Milk and cream in solid forms, of a fat content by weight of > 27%, sweetened, i'),
('04029110', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mléko,smetana zahuštěné neslazené,tuk do 8%', 'Milk and cream, concentrated, of a fat content by weight of <= 8%, unsweetened ('),
('04029130', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Smetana zahuštěná neslazená,tuk přes 8% max. 10%', 'Milk and cream, concentrated, of a fat content by weight of > 8% but <= 10%, uns'),
('04029151', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Smetana zahuštěná neslazená,tuk přes 10% max. 45%,obsah nad 2,5 kg', 'Milk and cream, concentrated, of a fat content by weight of > 10% but <= 45%, un'),
('04029159', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Smetana zahuštěná neslazená,tuk přes 10% max. 45%,obsah nad 2,5 kg', 'Milk and cream, concentrated, of a fat content by weight of > 10% but <= 45%, un'),
('04029191', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Smetana zahuštěná neslazená,tuk přes 45%,obsah do 2,5 kg', 'Milk and cream, concentrated, of a fat content by weight of > 45%, unsweetened,'),
('04029199', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Smetana zahuštěná neslazená,tuk přes 45%,obsah nad 2,5 kg', 'Milk and cream, concentrated, of a fat content by weight of > 45%, unsweetened,'),
('04029910', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mléko,smetana zahuštěné slazené,tuk do 9,5%', 'Milk and cream, concentrated, of a fat content by weight of <= 9,5%, sweetened ('),
('04029931', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Smetana zahuštěná slazená,tuk přes 9,5% max. 45%,obsah do 2,5 kg', 'Milk and cream, concentrated, of a fat content by weight of > 9,5% but <= 45%, s'),
('04029939', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Smetana zahuštěná slazená,tuk přes 9,5% max. 45%,obsah nad 2,5 kg', 'Milk and cream, concentrated, of a fat content by weight of > 9,5% but <= 45%, s'),
('04029991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Smetana zahuštěná slazená,tuk přes 45%,obsah do 2,5 kg', 'Milk and cream, concentrated, of a fat content by weight of > 45%, sweetened, in'),
('04029999', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Smetana zahuštěná slazená,tuk přes 45%,obsah nad 2,5 kg', 'Milk and cream, concentrated, of a fat content by weight of > 45%, sweetened, in'),
('04031011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jogurt neochucený tekutý neslazený,tuk do 3%', 'Yogurt (excl. flavoured or with added fruit, nuts or cocoa, not containing added'),
('04031013', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jogurt neochucený tekutý neslazený,tuk přes 3% max. 6%', 'Yogurt (excl. flavoured or with added fruit, nuts or cocoa, not containing added'),
('04031019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jogurt neochucený tekutý neslazený,tuk přes 6%', 'Yogurt (excl. flavoured or with added fruit, nuts or cocoa, not containing added'),
('04031031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jogurt neochucený tekutý slazený,tuk do 3%', 'Yogurt (excl. flavoured or with added fruit, nuts or cocoa, with added sugar or'),
('04031033', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jogurt neochucený tekutý slazený,tuk přes 3% max. 6 %', 'Yogurt (excl. flavoured or with added fruit, nuts or cocoa), with added sugar or'),
('04031039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jogurt neochucený tekutý slazený,tuk přes 6%', 'Yogurt (excl. flavoured or with added fruit, nuts or cocoa), with added sugar or'),
('04031051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jogurt v prášku apod. pevné formě ochucený (ovoce,ořechy,kakao),tuk přes 27%', 'Yogurt, whether or not concentrated, flavoured or with added fruit, nuts or coco'),
('04031053', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jogurt v prášku apod.pevné formě ochucený (ovoce,ořechy,kakao),tuk nad 1,5%-27%', 'Yogurt, whether or not concentrated, flavoured or with added fruit, nuts or coco'),
('04031059', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jogurt v prášku apod. pevné formě ochucený (ovoce,ořechy,kakao),tuk přes 27%', 'Yogurt, whether or not concentrated, flavoured or with added fruit, nuts or coco'),
('04031091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jogurt ost.ochucený (ovoce,ořechy,kakao),tuk do 3%,ne:v prášku,pevná forma', 'Yogurt, whether or not concentrated, flavoured or with added fruit, nuts or coco'),
('04031093', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jogurt ost.ochucený (ovoce,ořechy,kakao),tuk nad 3-6%,ne:v prášku,pevná forma', 'Yogurt, whether or not concentrated, flavoured or with added fruit, nuts or coco'),
('04031099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jogurt ost.ochucený (ovoce,ořechy,kakao),tuk přes 6%,ne:v prášku,pevná forma', 'Yogurt, whether or not concentrated, flavoured or with added fruit, nuts or coco'),
('04039011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kefír apod.v prášku neochucený,neslazený,tuk do 1,5%,ne:mléko,smetana,jogurt', 'Buttermilk, curdled milk and cream, kephir and other fermented or acidified milk'),
('04039013', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kefír apod.v prášku neochucený neslaz.,tuk nad 1,5-27%,ne:mléko,smetana,jogurt', 'Buttermilk, curdled milk and cream, kephir and other fermented or acidified milk'),
('04039019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kefír apod.v prášku neochucený neslaz.,tuk přes 27%,ne:mléko,smetana,jogurt', 'Buttermilk, curdled milk and cream, kephir and other fermented or acidified milk'),
('04039031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kefír apod.v prášku neochucený slazený,tuk přes 27%,ne:mléko,smetana,jogurt', 'Buttermilk, curdled milk and cream, kephir and other fermented or acidified milk'),
('04039033', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kefír apod.v prášku neochucený slaz.,tuk nad 1,5-27%,ne:mléko,smetana,jogurt', 'Buttermilk, curdled milk and cream, kephir and other fermented or acidified milk'),
('04039039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kefír apod.v prášku neochucený slazený,tuk přes 27%,ne:mléko,smetana,jogurt', 'Buttermilk, curdled milk and cream, kephir and other fermented or acidified milk'),
('04039051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kefír apod.neochucený neslazený,tuk do 3%,ne:prášek,mléko,smetana jogurt', 'Buttermilk, curdled milk and cream, kephir and other fermented or acidified milk'),
('04039053', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kefír apod.neochucený neslazený,tuk nad 3-6%,ne:prášek,mléko,smetana,jogurt', 'Buttermilk, curdled milk and cream, kephir and other fermented or acidified milk'),
('04039059', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kefír apod.neochucený neslazený,tuk nad 6%,ne:prášek,mléko,smetana,jogurt', 'Buttermilk, curdled milk and cream, kephir and other fermented or acidified milk'),
('04039061', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kefír apod.neochucený slazený,tuk do 3%,ne:prášek,mléko,smetana,jogurt', 'Buttermilk, curdled milk and cream, kephir and other fermented or acidified milk'),
('04039063', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kefír apod.neochucený slazený,tuk přes 3% max.6%,ne:prášek,mléko,smetana,jogurt', 'Buttermilk, curdled milk and cream, kephir and other fermented or acidified milk'),
('04039069', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kefír apod.neochucený slazený,tuk přes 6%,ne:prášek,mléko,smetana,jogurt', 'Buttermilk, curdled milk and cream, kephir and other fermented or acidified milk'),
('04039071', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kefír apod.v prášku ochucený (ovoce atd.),tuk do 1,5%,ne:mléko,smetana,jogurt', 'Buttermilk, curdled milk and cream, kephir and other fermented or acidified milk'),
('04039073', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kefír apod.v prášku ochucený (ovoce atd.),tuk nad 1,5-27%,ne:mléko,smetana,jogurt', 'Buttermilk, curdled milk and cream, kephir and other fermented or acidified milk'),
('04039079', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kefír apod.v prášku ochucený (ovoce atd.),tuk přes 27%,ne:mléko,smetana,jogurt', 'Buttermilk, curdled milk and cream, kephir and other fermented or acidified milk'),
('04039091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kefír apod.ost.ochucený (ovoce atd.),tuk do 3%,ne:prášek,mléko,smetana,jogurt', 'Buttermilk, curdled milk and cream, kephir and other fermented or acidified milk'),
('04039093', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kefír apod.ost.ochucený (ovoce atd.),tuk přes 3% max.6%,ne:prášek,smetana,jogurt', 'Buttermilk, curdled milk and cream, kephir and other fermented or acidified milk'),
('04039099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kefír apod.ost.ochucený (ovoce atd.),tuk přes 6%,ne:prášek,smetana,jogurt', 'Buttermilk, curdled milk and cream, kephir and other fermented or acidified milk'),
('04041002', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Syrovátka pevná neslazená,bílkoviny do 15%,tuk do 1,5%', 'Whey and modified whey, in powder, granules or other solid forms, without added'),
('04041004', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Syrovátka pevná neslazená,bílkoviny do 15%,tuk přes 1,5% max.27%', 'Whey and modified whey, in powder, granules or other solid forms, without added'),
('04041006', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Syrovátka pevná neslazená,bílkoviny do 15%,tuk přes 27%', 'Whey and modified whey, in powder, granules or other solid forms, without added'),
('04041012', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Syrovátka pevná neslazená,bílkoviny přes 15%,tuk přes 27%', 'Whey and modified whey, in powder, granules or other solid forms, without added'),
('04041014', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Syrovátka pevná neslazená,bílkoviny přes 15%,tuk přes 1,5% max.27%', 'Whey and modified whey, in powder, granules or other solid forms, without added'),
('04041016', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Syrovátka pevná neslazená,bílkoviny přes 15%,tuk přes 27%', 'Whey and modified whey, in powder, granules or other solid forms, without added'),
('04041026', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Syrovátka pevná slazená,bílkoviny do 15%,tuk do 1,5%', 'Whey and modified whey, in powder, granules or other solid forms, with added sug'),
('04041028', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Syrovátka pevná slazená,bílkoviny do 15%,tuk přes 1,5% max.27%', 'Whey and modified whey, in powder, granules or other solid forms, with added sug'),
('04041032', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Syrovátka pevná slazená,bílkoviny do 15%,tuk přes 27%', 'Whey and modified whey, in powder, granules or other solid forms, with added sug'),
('04041034', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Syrovátka pevná slazená,bílkoviny přes 15%,tuk do 1,5%', 'Whey and modified whey, in powder, granules or other solid forms, with added sug'),
('04041036', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Syrovátka pevná slazená,bílkoviny přes 15%,tuk přes 1,5% max.27%', 'Whey and modified whey, in powder, granules or other solid forms, with added sug'),
('04041038', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Syrovátka pevná slazená,bílkoviny přes 15%,tuk přes 27%', 'Whey and modified whey, in powder, granules or other solid forms, with added sug'),
('04041048', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Syrovátka tekutá neslazená,bílkoviny do 15%,tuk do 1,5%', 'Whey and modified whey, whether or not concentrated, not containing added sugar'),
('04041052', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Syrovátka tekutá neslazená,bílkoviny do 15%,tuk přes 1,5% max.27%', 'Whey and modified whey, whether or not concentrated, not containing added sugar'),
('04041054', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Syrovátka tekutá neslazená,bílkoviny do 15%,tuk přes 27%', 'Whey and modified whey, whether or not concentrated, not containing added sugar'),
('04041056', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Syrovátka tekutá neslazená,bílkoviny přes 15%,tuk do 1,5%', 'Whey and modified whey, whether or not concentrated, not containing added sugar'),
('04041058', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Syrovátka tekutá neslazená,bílkoviny přes 15%,tuk přes 1,5% max.27%', 'Whey and modified whey, whether or not concentrated, not containing added sugar'),
('04041062', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Syrovátka tekutá neslazená,bílkoviny přes 15%,tuk přes 27%', 'Whey and modified whey, whether or not concentrated, not containing added sugar'),
('04041072', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Syrovátka tekutá slazená,bílkoviny do 15%,tuk do 1,5%', 'Whey and modified whey, whether or not concentrated, containing added sugar or o'),
('04041074', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Syrovátka tekutá slazená,bílkoviny do 15%,tuk přes 1,5% max.27%', 'Whey and modified whey, whether or not concentrated, containing added sugar or o'),
('04041076', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Syrovátka tekutá slazená,bílkoviny do 15%,tuk nad 27%', 'Whey and modified whey, whether or not concentrated, containing added sugar or o'),
('04041078', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Syrovátka tekutá slazená,bílkoviny přes 15%,tuk do 1,5%', 'Whey and modified whey, whether or not concentrated, containing added sugar or o'),
('04041082', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Syrovátka tekutá slazená,bílkoviny přes 15%,tuk přes 1,5% max.27%', 'Whey and modified whey, whether or not concentrated, containing added sugar or o'),
('04041084', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Syrovátka tekutá slazená,bílkoviny přes 15%,tuk přes 27%', 'Whey and modified whey, whether or not concentrated, containing added sugar or o'),
('04049021', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ost.ze složek mléka neslazené,tuk do 1,5%,ne:syrovátkajogurt,kefír', 'Products consisting of natural milk constituents, not containing added sugar or'),
('04049023', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ost.ze složek mléka neslazené,tuk nad 1,5-27%,ne:syrovátka,jogurt,kefír', 'Products consisting of natural milk constituents, not containing added sugar or'),
('04049029', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ost.ze složek mléka neslazené,tuk přes 27%,ne:syrovátka,jogurt,kefír', 'Products consisting of natural milk constituents, not containing added sugar or'),
('04049081', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ost.ze složek mléka slazené,tuk do 1,5%,ne:syrovátka,jogurt,kefír', 'Products consisting of natural milk constituents, with added sugar or other swee'),
('04049083', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ost.ze složek mléka slazené,tuk nad 1,5-27%,ne:syrovátka,jogurt,kefír', 'Products consisting of natural milk constituents, with added sugar or other swee'),
('04049089', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ost.ze složek mléka slazené,tuk přes 27%,ne:syrovátka,jogurt,kefír', 'Products consisting of natural milk constituents, with added sugar or other swee'),
('04051011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Máslo přírodní k okamžité spotřebě,tuk do 85%,balení do 1kg', 'Natural butter of a fat content, by weight, of >= 80% but <= 85%, in immediate p'),
('04051019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Máslo přírodní k okamžité spotřebě,tuk do 85%,balení nad 1kg', 'Natural butter of a fat content, by weight, of >= 80% but <= 85% (excl. in immed'),
('04051030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Máslo rekombinované,tuk do 85%', 'Recombined butter of a fat content, by weight, of >= 80% but <= 85% (excl. dehyd'),
('04051050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Máslo syrovátkové,tuk do 85%', 'Whey butter of a fat content, by weight, of >= 80% but <= 85% (excl. dehydrated'),
('04051090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Máslo ostatní,tuk nad 85%,', 'Butter of a fat content, by weight, of > 85% but <= 95% (excl. dehydrated butter'),
('04052010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pomazánky z mléčných tuků,tuky přes 39% max.60 %', 'Dairy spreads of a fat content, by weight, of >= 39% but < 60%'),
('04052030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pomazánky z mléčných tuků,tuky přes 60% max.75 %', 'Dairy spreads of a fat content, by weight, of >= 60% but <= 75%'),
('04052090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pomazánky z mléčných tuků,tuky přes 75% max.80%', 'Dairy spreads of a fat content, by weight, of > 75% but < 80%'),
('04059010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuky,oleje z mléka ostatní,tuky přes 99,3%,voda do 0,5%,ne:máslo,pomazánky', 'Fats and oils derived from milk, of a fat content, by weight, of >= 99,3% and of'),
('04059090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuky,oleje z mléka ost.,ne:máslo,pomazánky,obsah tuku nad 99,3%,vody do 0,5%', 'Fats and oils derived from milk, dehydrated butter and ghee (excl. of a fat cont'),
('04061020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry a tvaroh,čerstvé,tuk do 40%', 'Fresh cheese "unripened or uncured cheese", incl. whey cheese and curd of a fat'),
('04061080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry a tvaroh,čerstvé,tuk nad 40%', 'Fresh cheese "unripened or uncured cheese", incl. whey cheese and curd of a fat'),
('04062010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry Glarus s bylinkami z odstředěného mléka strouhané,práškové', 'Glarus herb cheese, grated or powdered'),
('04062090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry strouhané ostatní,práškové všech druhů,ne:sýry Glarus', 'Grated or powdered cheese (excl. glarus herb cheese, known as Schabziger)'),
('04063010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry tavené (z Ementálu,Gruyére,Appenzel) pro maloobchod,tuk v sušině do 56%', 'Processed cheese, not grated or powdered, in the manufacture of which no cheeses'),
('04063031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry tavené ost.,tuk do 36%,tuk v sušině do 48%,ne:z Ementálu,Gruyére,Appenzel', 'Processed cheese, not grated or powdered, of a fat content, by weight, of <= 36%'),
('04063039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry tavené ost.,tuk do 36%,tuk v suš.přes 48%,ne:z Ementálu,Gruyére,Appenzel', 'Processed cheese, not grated or powdered, of a fat content, by weight, of <= 36%'),
('04063090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry tavené ost.,tuk nad 36%,ne:z Ementálu,Gruyére,Appenzel', 'Processed cheese, not grated or powdered, of a fat content, by weight, of > 36%'),
('04064010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry Roquefort', 'Roquefort'),
('04064050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry Gorgonzola', 'Gorgonzola'),
('04064090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry s modrou plísní či plísní vytv.pomocí Penicillium roqueforti ost.,ne:Roquefort,Gorgonzola', 'Blue-veined cheese and other cheese containing veins produced by "Penicillium ro'),
('04069001', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry ostatní k dalšímu zpracování,ne:tavené,s modrou plísní', 'Cheese for processing (excl. fresh cheese, incl. whey cheese, curd, processed ch'),
('04069013', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry Ementál ostatní,ne:k dalšímu zpracování,tuk přes 45%', 'Emmentaler (excl. grated or powdered and that for processing)'),
('04069015', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry Gruyére,Sbrinz ostatní,ne:k dalšímu zpracování,tuk přes 45%', 'Gruyere and Sbrinz (excl. grated or powdered and those for processing)'),
('04069017', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry Bergkase,Appenzell ostatní,ne:k dalšímu zpracování,tuk přes 45%', 'BergkĂ¤se and Appenzell (excl. grated or powdered and those for processing)'),
('04069018', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry Fromage fribourgeois,Vacherin Mont dOr,Tete de Moine', 'Fromage fribourgeois, Vacherin Mont d''Or and Tete de Moine (excl. grated or pow'),
('04069019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry Glaris s bylinkami z odstředěného mléka', 'Glarus herb cheese "known as Schabziger" made from skimmed milk and mixed with f'),
('04069021', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry Kashkaval', 'Cheddar (excl. grated or powdered and for processing)'),
('04069023', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry Eidam', 'Edam (excl. grated or powdered and for processing)'),
('04069025', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry Tilsit', 'Tilsit (excl. grated or powdered and for processing)'),
('04069027', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry Butterkase', 'ButterkĂ¤se (excl. grated or powdered and for processing)'),
('04069029', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry Kashkaval', 'Kashkaval (excl. grated or powdered and for processing)'),
('04069032', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry Feta', 'Feta (excl. for processing)'),
('04069035', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry Kefalo-Tyri', 'Kefalo-Tyri (excl. grated or powdered and for processing)'),
('04069037', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry Finlandia', 'Finlandia (excl. grated or powdered and for processing)'),
('04069039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry Jarlsberg', 'Jarlsberg (excl. grated or powdered and for processing)'),
('04069050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry ovčí,bůvolí ost.v nádobách se slaným nálevem,v měších z kůže,ne:feta', 'Sheep''s or buffalo milk cheese, in containers containing brine, or in sheepskin'),
('04069061', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry Grana,Parmigiano,tuk do 40%,voda do 47%', 'Grana Padano and Parmigiano Reggiano, of a fat content by weight of <= 40% and a'),
('04069063', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry Fiore Sardo,Pecorino,tuk do 40%,voda do 47%', 'Fiore Sardo and Pecorino, of a fat content by weight of <= 40% and a water conte'),
('04069069', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry ostatní,tuk do 40%,voda do 47%,ne:Grana,Parmigiano,Fiore Sardo,Pecorino', 'Cheese of a fat content by weight of <= 40% and a water content, by weight, of n'),
('04069073', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry Provolone,tuk do 40%,voda přes 47% max.72%', 'Provolone of a fat content by weight of <= 40% and a water content, by weight, o'),
('04069075', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry Asiago,Caciocavallo,Montasio,Ragusano,tuk do 40%,voda přes 47% max.72%', 'Asiago, Caciocavallo, Montasio and Ragusano, of a fat content by weight of <= 40'),
('04069076', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry Danbo,Fontal,FontinaFynbo,Havarti,Maribo,Samsotuk do 40 %,voda přes 47%max.72%', 'Danbo, Fontal, Fontina, Fynbo, Havarti, Maribo and Samso, of a fat content by we'),
('04069078', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry Gouda,tuk do 40%,voda přes 47% max72%', 'Gouda, of a fat content by weight of <= 40% and a water content, by weight, of n'),
('04069079', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry Esrom,Italico,Kernhem,Saint-Nectaire,-Paulin,Taleggio,tuk do 40%,voda 47%až72%', 'Esrom, Italico, Kernhem, Saint-Nectaire, Saint-Paulin and Taleggio, of a fat con'),
('04069081', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry Cantal,Cheshire,další druhy viz sazebník,tuk do 40%,voda přes 47% max.72%', 'Cantal, Cheshire, Wensleydale, Lancashire, Double Gloucester, Blarney, Colby and'),
('04069082', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry Camembert,tuk do 40%,voda přes 47% max.72%', 'Camembert, of a fat content by weight of <= 40% and a water content, by weight,'),
('04069084', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry Brie,tuk do 40%,voda přes 47% max72%', 'Brie, of a fat content by weight of <= 40% and a water content, by weight, of no'),
('04069085', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry Kefalograviera,Kasseri,tuk do 40%,voda přes 47% max.72%', 'Kefalograviera and Kasseri (excl. grated or powdered and for processing)'),
('04069086', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry ostatní,tuk do 40%,voda přes 47% max52%,ne:čerstvé,druhy viz sazebník', 'Cheese, of a fat content by weight of <= 40% and a water content, by weight, of'),
('04069087', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry ostatní,tuk do 40%,voda přes 52% max.62%,ne:čerstvé,druhy viz sazebník', 'Cheese, of a fat content by weight of <= 40% and a water content, by weight, of'),
('04069088', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry ostatní,tuk do 40%,voda přes 62% max.72%,ne:čerstvé,druhy viz sazebník', 'Cheese, of a fat content by weight of <= 40% and a water content, by weight, of'),
('04069093', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry ostatní,tuk do 40%,voda přes 72%,ne:čerstvé,druhy viz sazebník', 'Cheese, of a fat content by weight of <= 40% and a water content, by weight, of'),
('04069099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sýry ostatní,tuk přes 40%,ne:čerstvé,druhy viz sazebník', 'Cheese of a fat content by weight of > 40%, n.e.s.'),
('04070011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vejce krůtí,husí na násadu', 'Turkey or goose eggs for hatching'),
('04070019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vejce drůbeže domácí ostatní na násadu,ne:krůtí,husí', 'Poultry eggs for hatching (excl. turkey or goose)'),
('04070030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MIL'), 'Vejce drůbeže domácí čerstvá,konzervovaná,vařená', 'Poultry eggs, in shell, fresh, preserved or cooked (excl. for hatching)'),
('04070090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vejce ostatní čerstvá,konzervovaná,vařená,ne:drůbeže domácí', 'Birds'' eggs, in shell, fresh, preserved or cooked (excl. poultry)'),
('04081120', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Žloutky ptačí sušené,ne pro lidské požívání', 'Egg yolks, dried, not suitable for human consumption, whether or not containing'),
('04081180', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Žloutky ptačí sušené pro lidské požívání', 'Egg yolks, dried, for human consumption, whether or not containing added sugar o'),
('04081920', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Žloutky ptačí ost.čerstvé,konzervované apod.,ne:k lidskému požívání,sušené', 'Egg yolks, fresh, cooked by steaming or boiling in water, moulded, frozen or oth'),
('04081981', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Žloutky ptačí tekuté čerstvé,konzervované,k lidskému požívání,ne:sušené', 'Egg yolks, liquid, suitable for human consumption, whether or not containing add'),
('04081989', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Žloutky ptačí ost. vč.zmrazených k lidskému požívání,ne:sušené,tekuté', 'Egg yolks (other than liquid), frozen or otherwise preserved, suitable for human'),
('04089120', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vejce ptačí sušené bez skořápek nezpůsobilé k lidskému požívání,ne:žloutky', 'Dried birds'' eggs, not in shell, whether or not containing added sugar or other'),
('04089180', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vejce ptačí sušené bez skořápek ostatní k lidskému požívání,ne:žloutky', 'Dried birds'' eggs, not in shell, whether or not containing added sugar or other'),
('04089920', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vejce ptačí ostatní bez skořápek nezpůs.k lidskému požívání,ne:žloutky,sušené', 'Birds'' eggs, not in shell, fresh, cooked by steaming or by boiling in water, mo'),
('04089980', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vejce ptačí ostatní bez skořápek k lidskému požívání,ne:žloutky,sušené', 'Birds'' eggs, not in shell, fresh, cooked by steaming or by boiling in water, mo'),
('04090000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Med přírodní', 'Natural honey'),
('04100000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky živočišného původu jedlé,jinde neuvedené ani nezahrnuté', 'Turtles'' eggs, birds'' nests and other edible products of animal origin, n.e.s.'),
('05010000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlasy nezpracované,i prané nebo bez tuku,odpad vlasů', 'Human hair, unworked, whether or not washed or scoured; waste of human hair'),
('05021000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Štětiny,chlupy z domácích nebo divokých prasat vč.odpadu', 'Pigs'', hogs'' or boars'' bristles and waste of such bristles'),
('05029000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlupy jezevčí a jiné k výrobě kartáčnického zboží vč.odpadu', 'Badger and other brush making hair and waste thereof'),
('05040000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Střeva,měchýře,žaludky zvířat celé,části,ne:z ryb', 'Guts, bladders and stomachs of animals (other than fish), whole and pieces there'),
('05051010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pera ptačí k vycpávání,peří prachové surové', 'Raw feathers used for stuffing and down, whether or not de-dusted, disinfected o'),
('05051090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pera ptačí k vycpávání,peří prachové,ne:surové', 'Feathers used for stuffing and down, thoroughly cleaned and treated for preserva'),
('05059000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kůže a jiné části ptačího těla i s péry,péra,odpad,ne:peří k vycpávání,prachové', 'Skins and other parts of birds, with their feathers or down, feathers and parts'),
('05061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ossein,kosti upravené kyselinou', 'Ossein and bones treated with acid'),
('05069000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kosti,kosti rohové,prach,odpad,ne:ossein,kosti upravené kyselinou', 'Bones and horn-cores and their powder and waste, unworked, defatted, degelatinis'),
('05071000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slonovina,prach,odpad', 'Ivory, unworked or simply prepared, its powder and waste (excl. cut to shape)'),
('05079000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Želvovina,kostice,rohy,parohy,kopyta,paznechty,drápy,zobáky,prach,odpad', 'Tortoiseshell, whalebone and whalebone hair, horns, antlers, hooves, nails, claw'),
('05080000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Korály,ulity,lastury,krunýře,sepiové kosti,prach,odpad neopracované', 'Coral and similar materials, shells of molluscs, crustaceans or echinoderms, cut'),
('05100000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ambra,kastoreum,cibet,pižmo,žluč,žlázy apod.', 'Ambergris, castoreum, civet and musk; cantharides; bile, whether or not dried; g'),
('05111000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sperma býčí', 'Bovine semen'),
('05119110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad z ryb', 'Fish waste'),
('05119190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky živočiš.pův. nezp.k lidskému požívání,mrtvá zvířata,ne:odpad z ryb', 'Products of fish or crustaceans, molluscs or other aquatic invertebrates (excl.'),
('05119910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šlachy,odřezky a jiný odpad ze surových kůží', 'Sinews or tendons of animal origin, parings and similar waste of raw hides or sk'),
('05119931', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Houba mycí živočišného původu,surová', 'Raw natural sponges of animal origin'),
('05119939', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Houba mycí živočišného původu,ostatní,ne:surová', 'Natural sponges of animal origin (excl. raw)'),
('05119985', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky živočišného původu jiné jinde neuvedené ani nezahrnuté', 'Animal products, n.e.s.; dead animals, unfit for human consumption (excl. fish,'),
('06011010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Cibule hyacintu ve vegetačním klidu', 'Dormant hyacinth bulbs'),
('06011020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Cibule narcisu ve vegetačním klidu', 'Dormant narcissi bulbs'),
('06011030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Cibule tulipánu ve vegetačním klidu', 'Dormant tulip bulbs'),
('06011040', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Cibule gladiolu ve vegetačním klidu', 'Dormant gladioli bulbs'),
('06011090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hlízy,cibule,kořeny,oddenky ost.ve veget.klidu,ne:hyacint,narcis,tulipán,gladiola', 'Dormant bulbs, tubers, tuberous roots, corms, crowns and rhizomes (excl. those u'),
('06012010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rostliny,kořeny čekanky ve vegetaci', 'Chicory plants and roots (excl. chicory roots of the variety cichorium intybus s'),
('06012030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Orchideje,hyacinty,narcisy,tulipány ve vegetaci nebo květu', 'Orchid, hyacinth, narcissi and tulip bulbs, in growth or in flower'),
('06012090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hlízy,cibule,oddenky,sazenice apod.ve vegetaci,květu,ne:viz sazebník', 'Bulbs, tubers, tuberous roots, corms, crowns and rhizomes, in growth or in flowe'),
('06021010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nekořenovité řízky,rouby vinné révy', 'Unrooted vine cuttings and slips'),
('06021090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nekořenovité řízky,rouby ostatních živých rostlin,ne:vinná réva', 'Unrooted cuttings and slips (excl. vines)'),
('06022010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Keře vinné roubované,kořenovité', 'Vine slips, grafted or rooted'),
('06022090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stromy,zákrsky,keře,keříky též roubované,ne:vinná réva', 'Trees, shrubs and bushes, grafted or not, of kinds which bear edible fruit or nu'),
('06023000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rododendrony,azalky též roubované', 'Rhododendrons and azaleas, grafted or not'),
('06024000', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Keře růží', 'Roses, whether or not grafted'),
('06029010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Podhoubí', 'Mushroom spawn'),
('06029020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sazenice ananasu', 'Pineapple plants'),
('06029030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sazenice zeleniny,jahodníku', 'Vegetable and strawberry plants'),
('06029041', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sazenice stromů lesních', 'Live forest trees'),
('06029045', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Řízky kořenové,rostliny mladé rostlin venkovních,ne:lesní', 'Outdoor rooted cuttings and young plants of trees, shrubs and bushes (excl. frui'),
('06029049', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stromy,keře,ost.rostlin venkovních,ne:stromy lesní,řízky kořenovité,mladé rostliny', 'Outdoor trees, shrubs and bushes, incl. their roots (excl. cuttings, slips and y'),
('06029050', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rostliny venkovní ostatní,ne:stromy,keře,keříky', 'Live outdoor plants, incl. their roots (excl. bulbs, tubers, tuberous roots, cor'),
('06029070', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Řízky kořenovité,rostliny mladé pokojové,ne:kaktus', 'Indoor rooted cuttings and young plants (excl. cacti)'),
('06029091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rostliny kvetoucí pokojové s poupaty nebo květy,ne:kaktus', 'Indoor flowering plants with buds or flowers (excl. cacti)'),
('06029099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rostliny pokojové ostatní,ne:kvetoucí nebo s poupaty,kaktus', 'Live indoor plants and cacti (excl. rooted cuttings, young plants and flowering'),
('06031100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Růže řezané,čerstvé', 'Fresh cut roses and buds, of a kind suitable for bouquets or for ornamental purp'),
('06031200', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Karafiáty řezané,čerstvé', 'Fresh cut carnations and buds, of a kind suitable for bouquets or for ornamental'),
('06031300', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Orchideje řezané,čerstvé', 'Fresh cut orchids and buds, of a kind suitable for bouquets or for ornamental pu'),
('06031400', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Chryzantémy řezané,čerstvé', 'Fresh cut chrysanthemums and buds, of a kind suitable for bouquets or for orname'),
('06031910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Gladioly řezané,čerstvé', 'Fresh cut gladioli and buds, of a kind suitable for bouquets or for ornamental p'),
('06031990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní květiny řezané,čerstvé', 'Fresh cut flowers and buds, of a kind suitable for bouquets or for ornamental pu'),
('06039000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Květiny,poupata řezané ostatní sušené,bílené,barvené,napuštěné a jinak upravené', 'Dried, dyed, bleached, impregnated or otherwise prepared cut flowers and buds, f'),
('06041010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lišejníky sobí k okras.účelům sušené,bílené,napuštěné a jinak uprav.,ne:čerstvé', 'Reindeer moss, for bouquets or ornamental purposes, fresh, dried, dyed, bleached'),
('06041090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mechy,lišejníky k okr.účelům suš.,bílené a jinak upr.,ne:čerstvé,lišejník sobí', 'Mosses and lichens, for bouquets or ornamental purposes, fresh, dried, dyed, ble'),
('06049120', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vánoční stromky čerstvé', 'Fresh Christmas trees'),
('06049140', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Větve jehličnanů čerstvé k okras.účelům', 'Fresh conifer branches, for bouquets or ornamental purposes'),
('06049190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Listy,větve a ost.části bez květu k okr.účelu čerstvé,ne:vánoční stromky,větve jehličnanů', 'Foliage, branches and other parts of plants, without flowers or flower buds, gra'),
('06049910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Listy,větve a jiné části rostlin bez květu sušené,dál neupravované', 'Dried foliage, branches and other parts of plants, without flowers or flower bud'),
('06049990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Listy,větve a jiné části rostlin bez květu ostatní,ne:sušené,jedle Nordmannova', 'Dyed, bleached, impregnated or otherwise prepared foliage, branches and other pa'),
('07011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brambory sadbové čerstvé,chlazené', 'Seed potatoes'),
('07019010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brambory k výrobě škrobu čerstvé,chlazené,ne:sadbové', 'Potatoes for manufacture of starch, fresh or chilled'),
('07019050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brambory rané, čerstvé, chlazené', 'Fresh or chilled new potatoes from 1 January to 30 June'),
('07019090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brambory ostatní,ne:sadbové,k výrobě škrobu,rané čerstvé,chlazené', 'Old potatoes, fresh or chilled (excl. new potatoes, seed potatoes and potatoes f'),
('07020000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rajčata čerstvá nebo chlazená', 'Tomatoes, fresh or chilled'),
('07031011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cibule sazečka čerstvá,chlazená', 'Onion sets, fresh or chilled'),
('07031019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cibule ostatní čerstvá,chlazená,ne:sazečka', 'Onions, fresh or chilled (excl. sets)'),
('07031090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šalotka čerstvá,chlazená', 'Shallots, fresh or chilled'),
('07032000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Česnek čerstvý,chlazený', 'Garlic, fresh or chilled'),
('07039000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pór a jiná česnekovitá zelenina čerstvý,chlazený,ne:cibule,česnek', 'Leeks and other alliaceous vegetables, fresh or chilled (excl. onions, shallots'),
('07041000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Květák', 'Fresh or chilled cauliflowers and headed broccoli'),
('07042000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kapusta růžičková čerstvá,chlazená', 'Brussels sprouts, fresh or chilled'),
('07049010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zelí bílé a zelí červené', 'White and red cabbages, fresh or chilled'),
('07049090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kedluben a jiné jedlé rostliny rodu Brassica čerstvé,chlazené,ne:viz sazebník', 'Kohlrabi, kale and similar edible brassicas, fresh or chilled (excl. cauliflower'),
('07051100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Salát hlávkový, čerstvý, chlazený', 'Fresh or chilled cabbage lettuce'),
('07051900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Salát hlávkový ostatní čerstvý,chlazený,ne:salát obecný', 'Fresh or chilled lettuce (excl. cabbage lettuce)'),
('07052100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Čekanka Witloof (Cichorium intybus) čerstvá,chlazená', 'Fresh or chilled witloof chicory'),
('07052900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Čekanka ostatní čerstvá,chlazená,ne:Witloof', 'Fresh or chilled chicory (excl. witloof chicory)'),
('07061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mrkev, vodnice a tuřín', 'Fresh or chilled carrots and turnips'),
('07069010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Celer hlízový, čerstvý, chlazený', 'Fresh or chilled celeriac "rooted celery or German celery"'),
('07069030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Křen čerstvý,chlazený', 'Fresh or chilled horse-radish "Cochlearia armoracia"'),
('07069090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ředkvička,řepa salát.apod.koř.jedlé čerstvé,chlaz.,ne:mrkev,vodnice,tuřín,celer,křen', 'Fresh or chilled salad beetroot, salsify, radishes and similar edible roots (exc'),
('07070005', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Okurky', 'Cucumbers, fresh or chilled'),
('07070090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nakládačky a malé nakládací okurčičky', 'Fresh or chilled gherkins'),
('07081000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hrách (Pisum sativum) čerstvý,chlazený', 'Fresh or chilled peas "Pisum sativum", shelled or unshelled'),
('07082000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fazole (Vigna spp.,Phaseolus spp.) čerstvé,chlazené', 'Fresh or chilled beans "Vigna spp., Phaseolus spp.", shelled or unshelled'),
('07089000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Luštěniny ostatní i vyluštěné čerstvé,chlazené,ne:fazole,hrách', 'Fresh or chilled leguminous vegetables, shelled or unshelled (excl. peas "Pisum'),
('07092000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chřest čerstvý,chlazený', 'Fresh or chilled asparagus'),
('07093000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lilek čerstvý,chlazený', 'Fresh or chilled aubergines "eggplants"'),
('07094000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Celer čerstvý,chlazený,ne:hlízový', 'Fresh or chilled celery (excl. celeriac)'),
('07095100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Houby rodu Agaricus (žampióny) čerstvé,chlazené', 'Fresh or chilled mushrooms of the genus "Agaricus"'),
('07095910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lišky čerstvé,chlazené', 'Fresh or chilled chanterelles'),
('07095930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hřiby čerstvé,chlazené', 'Fresh or chilled flap mushrooms'),
('07095950', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lanýže čerstvé,chlazené', 'Fresh or chilled truffles'),
('07095990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Houby ostatní čerstvé,chlazené,ne:žampión,lanýž,hřib,liška', 'Fresh or chilled edible mushrooms (excl. chanterelles, flap mushrooms, mushrooms'),
('07096010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plody rodu Capsium nebo Pimenta, sladká paprika', 'Fresh or chilled sweet peppers'),
('07096091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Paprika Capsicum k výrobě kapsaicinu a aditiv čerstvá,chlazená', 'Fresh or chilled fruits of genus Capsicum for industrial manufacture of capsicin'),
('07096095', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Paprika Capsicum,Pimenta k výrobě olejů,živic čerstvá,chlazená', 'Fresh or chilled fruits of genus Capsicum or Pimenta for industrial manufacture'),
('07096099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Paprika Capsicum,Pimenta ost.čerstvá,chlaz.,ne:sladká,k výrobě kapsaicinu,oleje,živic', 'Fresh or chilled fruits of genus Capsicum or Pimenta (excl. for industrial manuf'),
('07097000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Špenát,i novozélandský,zahradní čerstvý,chlazený', 'Fresh or chilled spinach, New Zealand spinach and orache spinach'),
('07099010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Salát ostatní čerstvý,chlazený,ne:hlávkový,čekanka', 'Fresh or chilled salad vegetables (excl. lettuce and chicory)'),
('07099020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kardy,kardony (artyčok kardový) čerstvé,chlazené', 'Fresh or chilled chard "white beet" and cardoons'),
('07099031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olivy čerstvé,chlazené,ne:pro výrobu oleje', 'Fresh or chilled olives (excl. for oil production)'),
('07099039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olivy k výrobě oleje čerstvé,chlazené', 'Fresh or chilled olives for oil production'),
('07099040', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kapary čerstvé,chlazené', 'Fresh or chilled capers'),
('07099050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fenykl-zdužnatělé řepíky čerstvý,chlazený', 'Fresh or chilled fennel'),
('07099060', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kukuřice sladká čerstvá,chlazená', 'Fresh or chilled sweetcorn'),
('07099070', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tykve', 'Fresh or chilled courgettes'),
('07099080', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Artyčoky', 'Fresh or chilled globe artichokes'),
('07099090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zelenina ostatní čerstvá,chlazená,ne:viz sazebník', 'Fresh or chilled vegetables (excl. potatoes, tomatoes, vegetables of the Allium'),
('07101000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brambory i vařené zmrazené', 'Potatoes, uncooked or cooked by steaming or by boiling in water, frozen'),
('07102100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hrách i vařený (i vyluštěný) zmrazený', 'Shelled or unshelled peas "Pisum sativum", uncooked or cooked by steaming or by'),
('07102200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fazole i vařené (i vyluštěné) zmrazené', 'Shelled or unshelled beans "Vigna spp., Phaseolus spp.", uncooked or cooked by s'),
('07102900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Luštěniny ostatní i vařené (i vyluštěné) zmrazené, ne:fazole,hrách', 'Leguminous vegetables, shelled or unshelled, uncooked or cooked by steaming or b'),
('07103000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Špenát,i novozélandský,zahradní i vařený,zmrazený', 'Spinach, New Zealand spinach and orache spinach, uncooked or cooked by steaming'),
('07104000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kukuřice sladká i vařená zmrazená', 'Sweetcorn, uncooked or cooked by steaming or by boiling in water, frozen'),
('07108010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olivy i vařené zmrazené', 'Olives, uncooked or cooked by steaming or by boiling in water, frozen'),
('07108051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papriky Capsicum,Pimenta sladké i vařené,zmrazené', 'Sweet peppers, uncooked or cooked by steaming or by boiling in water, frozen'),
('07108059', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papriky Capsicum,Pimenta i vařené zmrazené,ne:sladké', 'Fruits of genus Capsicum or Pimenta, uncooked or cooked by steaming or by boilin'),
('07108061', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Houby rodu Agaricus (žampiony) i vařené zmrazené', 'Frozen mushrooms of the genus Agaricus, uncooked or cooked by steaming or by boi'),
('07108069', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Houby ostatní i vařené zmrazené,ne:žampiony', 'Frozen mushrooms, uncooked or cooked by steaming or by boiling in water (excl. o'),
('07108070', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rajčata i vařená zmrazená', 'Tomatoes, uncooked or cooked by steaming or by boiling in water, frozen'),
('07108080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Artyčoky i vařené zmrazené', 'Artichokes, uncooked or cooked by steaming or by boiling in water, frozen'),
('07108085', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chřest i vařený zmrazený', 'Asparagus, whether or not cooked by boiling in water or by steaming, frozen'),
('07108095', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zelenina ostatní i vařená zmrazená,ne:viz sazebník', 'Vegetables, whether or not cooked by boiling in water or by steaming, frozen (ex'),
('07109000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi zeleninové i vařené zmrazené', 'Mixtures of vegetables, uncooked or cooked by steaming or by boiling in water, f'),
('07112010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olivy prozatímně konzervované,nevhodné k požívání,ne:k výrobě oleje', 'Olives provisionally preserved, e.g. by sulphur dioxide gas, in brine, in sulphu'),
('07112090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olivy prozatímně konzervované k výrobě oleje nevhodné k požívání', 'Olives provisionally preserved, e.g. by sulphur dioxide gas, in brine, in sulphu'),
('07114000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Okurky,nakládačky prozatímně konzervované,nevhodné k požívání', 'Cucumbers and gherkins provisionally preserved, e.g. by sulphur dioxide gas, in'),
('07115100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KNE'), 'Houby rodu Agaricus (žampióny) prozatímně konzervované,nevhodné k požívání', 'Mushrooms of the genus "Agaricus", provisionally preserved, e.g., by sulphur dio'),
('07115900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Houby ost.,lanýže prozatímně konzerv.,nevh.k požívání,ne:rodu Agaricus', 'Mushrooms and truffles, provisionally preserved, e.g., by sulphur dioxide gas, i'),
('07119010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papriky Capsicum,Pimenta prozatímně konzervované,nevhodné k požívání,ne:sladké', 'Fruits of genus Capsicum or Pimenta provisionally preserved, e.g. by sulphur dio'),
('07119030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kukuřice sladká prozatímně konzervovaná,nevhodná k požívání', 'Sweetcorn provisionally preserved, e.g. by sulphur dioxide gas, in brine, in sul'),
('07119050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cibule prozatímně konzervovaná,nevhodná k požívání', 'Onions provisionally preserved, e.g. by sulphur dioxide gas, in brine, in sulphu'),
('07119070', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kapary prozatímně konzervované,nevhodné k požívání', 'Capers provisionally preserved, e.g. by sulphur dioxide gas, in brine, in sulphu'),
('07119080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zelenina ostatní prozatímně konzervovaná,nevhodná k požívání,ne:viz sazebník', 'Vegetables provisionally preserved, e.g., by sulphur dioxide gas, in brine, in s'),
('07119090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi zeleninové prozatímně konzervované,nevhodné k požívání', 'Mixture of vegetables provisionally preserved, e.g. by sulphur dioxide gas, in b'),
('07122000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cibule sušená i kousky,plátky,prášek', 'Dried onions, whole, cut, sliced, broken or in powder, but not further prepared'),
('07123100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Houby rodu agaricus (žampióny) sušené i kousky,plátky,prášek', 'Dried mushrooms of the genus "Agaricus", whole, cut, sliced, broken or in powder'),
('07123200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Wood ears (auricularia spp.) sušené i kousky,plátky,prášek', 'Dried wood ears "Auricularia spp.", whole, cut, sliced, broken or in powder, but'),
('07123300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jelly fungi (Tremella spp.) sušené i kousky,plátky,prášek', 'Dried jelly fungi "Tremella spp.", whole, cut, sliced, broken or in powder, but'),
('07123900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Houby ostatní,lanýže sušené i kousky,plátky,prášek', 'Dried mushrooms and truffles, whole, cut, sliced, broken or in powder, but not f'),
('07129005', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brambory sušené i kousky,plátky jinak neupravené', 'Dried potatoes, whether or not cut or sliced, but not further prepared'),
('07129011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kukuřice sladká sušená-hybridy k setí', 'Dried sweetcorn, hybrid, for sowing'),
('07129019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kukuřice sladká ostatní sušená i kousky,prášek,ne:hybridy k setí', 'Dried sweetcorn "Zea mays var. saccharata", whether or nor cut or sliced, but no'),
('07129030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rajčata sušená i kousky,plátky,prášek', 'Dried tomatoes, whole, cut, sliced, broken or in powder, but not further prepare'),
('07129050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mrkev sušená i kousky,plátky,prášek', 'Dried carrots, whole, cut, sliced, broken or in powder, but not further prepared'),
('07129090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zelenina suš.ost.,směsi zeleninové suš.,i kousky,plátky,prášek,ne:viz sazebník', 'Dried vegetables and mixtures of vegetables, whole, cut, sliced, broken or in po'),
('07131010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hrách suchý,vyluštěný k setí', 'Peas, "Pisum sativum", dried and shelled, for sowing'),
('07131090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hrách suchý vyluštěný i loupaný,drcený,ne:k setí', 'Peas, "Pisum sativum", dried and shelled, whether or not skinned or split (excl.'),
('07132000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cizrna (Garbanzos) suchá,vyluštěná,loupaná,drcená,též k setí', 'Dried, shelled chickpeas "garbanzos", whether or not skinned or split'),
('07133100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fazole Vigna,Hepper,Wilczek,též k setí', 'Dried, shelled beans of species "Vigna mungo [L.] Hepper or Vigna radiata [L.] W'),
('07133200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fazole malé červené Adzuki,Phaseolus,Vigna,též k setí', 'Dried, shelled small red "Adzuki" beans "Phaseolus or Vigna angularis", whether'),
('07133310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fazole obecné (Phaseolus vulgaris) k setí', 'Dried, shelled kidney beans "Phaseolus vulgaris", for sowing'),
('07133390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fazole obecné (Phaseolus vulgaris) suché vyluštěné i loupané,drcené,ne:k setí', 'Dried, shelled kidney beans "Phaseolus vulgaris", whether or not skinned or spli'),
('07133900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fazole ostatní,ne:Vigna,Hepper,Wilczek,malé červené,obecné', 'Dried, shelled beans "Vigna and Phaseolus", whether or not skinned or split (exc'),
('07134000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Čočka suchá,vyluštěná,loupaná,drcená,též k setí', 'Dried, shelled lentils, whether or not skinned or split'),
('07135000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Boby a koňské boby suché,vyluštěné,loupané,drcené,též k setí', 'Dried, shelled broad beans "Vicia faba var. major" and horse beans "Vicia faba v'),
('07139000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní luštěniny suché, vyluštěné,ne:hrách,cizrna,fazole,čočka,boby', 'Dried, shelled leguminous vegetables, whether or not skinned or split (excl. pea'),
('07141091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kořeny manioku k lidské výživě,do 28kg,čerstvé,zmrazené', 'Fresh and whole or without skin and frozen manioc, whether or not sliced, for hu'),
('07141098', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kořeny manioku ostatní,ne:k lidské výživě,do 28kg,čerstvé,zmrazené', 'Fresh or dried whole or sliced manioc or in the form of pellets (excl. fresh and'),
('07142010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Batáty čerstvé k lidské výživě', 'Sweet potatoes, fresh, whole, for human consumption'),
('07142090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Batáty ostatní,ne:čerstvé k lidské výživě', 'Sweet potatoes, fresh, chilled, frozen or dried, whether or not sliced or in the'),
('07149011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kořeny marantové,salepové apod.k lidské výživě,do 28 kg,čerstvé,zmrazené', 'Fresh and whole or without skin and frozen arrowroot, salep and similar roots an'),
('07149019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kořeny marantové,salepové apod.ostatní,ne:k lidské výživě,do 28kg,čerstvé,zmrazené', 'Roots and tubers of arrowroot, salep and similar roots and tubers with high star'),
('07149090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kořeny,hlízy jedlé ostatní čerstvé,chlazené,mrazené,sušené,ne:viz sazebník', 'Roots and tubers of Jerusalem artichokes and similar roots and tubers with high'),
('08011100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ořechy kokosové - sušená nastrouhaná dužina (moučka,plátky),ne:kopra', 'Desiccated coconuts'),
('08011900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ořechy kokosové,čerstvé či sušené,ostatní,ne:sušená nastrouhaná dužina,kopra', 'Fresh coconuts, whether or not shelled or peeled'),
('08012100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ořechy para,čerstvé či sušené,ve skořápce', 'Fresh or dried brazil nuts, in shell'),
('08012200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ořechy para,čerstvé či sušené,bez skořápky', 'Fresh or dried brazil nuts, shelled'),
('08013100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ořechy akažuové (kešu),čerstvé či sušené,ve skořápce', 'Fresh or dried cashew nuts, in shell'),
('08013200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ořechy akažuové (kešu),čerstvé či sušené,bez skořápky', 'Fresh or dried cashew nuts, shelled'),
('08021110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mandle,čerstvé či sušené,ve skořápce,hořké', 'Fresh or dried bitter almonds in shell'),
('08021190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mandle,čerstvé či sušené,ve skořápce,ostatní,ne:hořké', 'Fresh or dried almonds in shell (excl. bitter)'),
('08021210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mandle,čerstvé či sušené,bez skořápky,hořké', 'Fresh or dried bitter almonds, shelled'),
('08021290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mandle,bez skořápky,ostatní,ne:hořké', 'Fresh or dried almonds, shelled (excl. bitter)'),
('08022100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ořechy lískové (Corylus spp.),čerstvé či sušené,ve skořápce', 'Fresh or dried hazelnuts or filberts "Corylus spp.", in shell'),
('08022200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ořechy lískové (Corylus spp.),čerstvé či sušené,bez skořápky', 'Fresh or dried hazelnuts or filberts "Corylus spp.", shelled and peeled'),
('08023100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ořechy vlašské,čerstvé či sušené,ve skořápce', 'Fresh or dried walnuts in shell'),
('08023200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ořechy vlašské,čerstvé či sušené,bez skořápky', 'Fresh or dried walnuts, shelled and peeled'),
('08024000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kaštany jedlé (Castanea spp.),čerstvé či sušené', 'Fresh or dried chestnuts "Castanea spp.", whether or not shelled or peeled'),
('08025000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pistácie,čerstvé či sušené', 'Fresh or dried pistachios, whether or not shelled or peeled'),
('08026000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ořechy makadamia,čerstvé či sušené', 'Macadamia nuts, fresh or dried, whether or not shelled or peeled'),
('08029020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ořechy arekové (nebo betelové),kola a pekanové,čerstvé či sušené', 'Fresh or dried areca "betel", cola and pecans, whether or not shelled or peeled'),
('08029050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oříšky piniové,čerstvé či sušené', 'Pine nuts, fresh or dried, whether or not shelled or peeled'),
('08029085', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skořápkové ovoce ostatní,čerstvé či sušené,ne:viz sazebník', 'Nuts, fresh or dried, whether or not shelled or peeled (excl. coconuts, Brazil n'),
('08030011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Banány - plantejny,čerstvé', 'Plantains, fresh'),
('08030019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Banány ostatní,čerstvé,ne:plantejny', 'Bananas, fresh (excl. plantains)'),
('08030090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Banány,vč.plantejnů,sušené', 'Dried bananas, incl. plantains'),
('08041000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Datle,čerstvé či sušené', 'Fresh or dried dates'),
('08042010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fíky,čerstvé', 'Fresh figs'),
('08042090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fíky,sušené', 'Dried figs'),
('08043000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ananas,čerstvý či sušený', 'Fresh or dried pineapples'),
('08044000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Avokádo,čerstvé či sušené', 'Fresh or dried avocados'),
('08045000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kvajávy,manga a mangostany,čerstvé či sušené', 'Fresh or dried guavas, mangoes and mangosteens'),
('08051020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pomeranče sladké,čerstvé', 'Fresh sweet oranges'),
('08051080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pomeranče ostatní,čerstvé či sušené,ne:čerstvé sladké', 'Fresh or dried oranges (excl. fresh sweet oranges)'),
('08052010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Klementinky,čerstvé či sušené', 'Fresh or dried clementines'),
('08052030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Monreale a satsuma,čerstvé či sušené', 'Fresh or dried monreales and satsumas'),
('08052050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mandarinky a wilkingy,čerstvé či sušené', 'Fresh or dried mandarins and wilkings'),
('08052070', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tangerinky,čerstvé či sušené', 'Fresh or dried tangerines'),
('08052090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mandarinkám podobné citrusové hybridy,čerstvé či sušené,ne:viz sazebník', 'Fresh or dried tangelos, ortaniques, malaquinas and similar citrus hybrids (excl'),
('08054000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Grapefruity,vč.pomel (šedoků),čerstvé či sušené', 'Fresh or dried grapefruit'),
('08055010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Citrony (Citrus limon,Citrus limonum),čerstvé či sušené', 'Fresh or dried lemons "Citrus limon, Citrus limonum"'),
('08055090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Limety (Citrus aurantifolia,Citrus latifolia),čerstvé či sušené', 'Fresh or dried limes "Citrus aurantifolia, Citrus latifolia"'),
('08059000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plody citrusové ostatní,čerstvé či sušené,ne:viz sazebník', 'Fresh or dried citrus fruit (excl. oranges, lemons "Citrus limon, Citrus limonum'),
('08061010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hrozny vinné,čerstvé,stolní', 'Fresh table grapes'),
('08061090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hrozny vinné,čerstvé,ostatní,ne:stolní', 'Fresh grapes (excl. table grapes)'),
('08062010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hrozny vinné,sušené - korintky', 'Currants'),
('08062030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hrozny vinné,sušené - sultánky', 'Sultanas'),
('08062090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hrozny vinné,sušené,ostatní,ne:korintky,sultánky', 'Dried grapes (excl. currants and sultanas)'),
('08071100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Melouny vodní,čerstvé', 'Fresh watermelons'),
('08071900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Melouny ostatní,čerstvé,ne:vodní', 'Fresh melons (excl. watermelons)'),
('08072000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papáje,čerstvé', 'Fresh pawpaws "papayas"'),
('08081010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jablka k výrobě moštu,volně ložená,16.9.-15.12.,čerstvá', 'Fresh cider apples, in bulk, from 16 September to 15 December'),
('08081080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jablka ostatní,čerstvá,ne:k výrobě moštu (podmínky viz sazebník)', 'Fresh apples (excl. cider apples, in bulk, from 16 September to 15 December)'),
('08082010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hrušky k výrobě moštu,volně ložené,1.8.-31.12.,čerstvé', 'Fresh perry pears, in bulk, from 1 August to 31 December'),
('08082050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hrušky ostatní,čerstvé,ne:k výrobě moštu (podmínky viz sazebník)', 'Fresh pears (excl. perry pears, in bulk, from 1 August to 31 December)'),
('08082090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kdoule,čerstvé', 'Fresh quinces'),
('08091000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Meruňky,čerstvé', 'Fresh apricots'),
('08092005', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Višně (Prunus cerasus),čerstvé', 'Fresh sour cherries "Prunus cerasus"'),
('08092095', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Třešně,višně ostatní,čestvé,ne:Prunus cerasus', 'Fresh cherries (excl. sour cherries "Prunus cerasus")'),
('08093010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Broskve - nektarinky,čerstvé', 'Fresh nectarines'),
('08093090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Broskve ostatní,čerstvé,ne:nektarinky', 'Fresh peaches (excl. nectarines)'),
('08094005', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Švestky,čerstvé', 'Fresh plums'),
('08094090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trnky,čerstvé', 'Fresh sloes'),
('08101000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jahody,čerstvé', 'Fresh strawberries'),
('08102010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maliny,čerstvé', 'Fresh raspberries'),
('08102090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Moruše,ostružiny,ostružino-maliny,čerstvé', 'Fresh blackberries, mulberries and loganberries'),
('08104010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brusinky (Vaccinium vitis-idaea),čerstvé', 'Fresh cowberries, foxberries or mountain cranberries "fruit of the species Vacci'),
('08104030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Borůvky (Vaccinium myrtillus),čerstvé', 'Fresh fruit of species Vaccinium myrtillus'),
('08104050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plody druhů Vaccinium macrocarpon,corymbosum,čerstvé', 'Fresh fruit of species Vaccinium macrocarpum and Vaccinium corymbosum'),
('08104090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plody rodu Vaccinium ostatní,čerstvé,ne:vitis-idea,myrtillus,macrocarpon,corymbosum', 'Fresh fruits of genus Vaccinium (excl. of species Vaccinium vitis-idaea, myrtill'),
('08105000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kiwi,čerstvé', 'Fresh kiwifruit'),
('08106000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Duriany,čerstvé', 'Fresh durians'),
('08109020', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tamarindy,jablíčka kešu,liči,jackfruit,sapoty,mučenky,karamboly,pitahaje,čerstvé', 'Fresh tamarinds, cashew apples, lychees, jackfruit, sapodillo plums, passion fru'),
('08109050', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rybíz černý,čerstvý', 'Fresh black currants'),
('08109060', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rybíz červený,čerstvý', 'Fresh red currants'),
('08109070', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rybíz bílý,angrešt,čerstvý', 'Fresh white currants and gooseberries'),
('08109095', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ovoce čerstvé ostatní,ne:viz sazebník', 'Fresh fruit, edible (excl. nuts, bananas, dates, figs, pineapples, avocados, gua'),
('08111011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jahody (též vařené),zmrazené,slazené,cukr >13% hmot.', 'Strawberries, uncooked or cooked by steaming or boiling in water, sweetened, wit'),
('08111019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jahody (též vařené),zmrazené,slazené,cukr <=13% hmot.', 'Strawberries, uncooked or cooked by steaming or boiling in water, sweetened, wit'),
('08111090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jahody (též vařené),zmrazené,neslazené', 'Strawberries, uncooked or cooked by steaming or boiling in water, unsweetened, f'),
('08112011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maliny,ostružiny,moruše,ostruž.-maliny,rybíz,angrešt (též vařené),zmrazené,slazené,cukr >13% hmot.', 'Raspberries, blackberries, mulberries, loganberries, black, white or red currant'),
('08112019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maliny,ostružiny,moruše,ostruž.-maliny,rybíz,angrešt (též vařené),zmrazené,slazené,cukr <=13% hmot.', 'Raspberries, blackberries, mulberries, loganberries, black, white or red currant'),
('08112031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maliny (též vařené),zmrazené,neslazené', 'Raspberries, uncooked or cooked by steaming or boiling in water, frozen, unsweet'),
('08112039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rybíz černý (též vařený),zmrazený,neslazený', 'Black currants, uncooked or cooked by steaming or boiling in water, frozen, unsw'),
('08112051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rybíz červený (též vařený),zmrazený,neslazený', 'Red currants, uncooked or cooked by steaming or boiling in water, frozen, unswee'),
('08112059', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostružiny,moruše,ostružino-maliny (též vařené),zmrazené,neslazené', 'Blackberries and mulberries, uncooked or cooked by steaming or boiling in water,'),
('08112090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rybíz bílý,angrešt (též vařené),zmrazené,neslazené', 'Loganberries, white currants and gooseberries, uncooked or cooked by steaming or'),
('08119011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ovoce,ořechy,tropické (též vařené),zmrazené,slazené,cukr >13% hmot.', 'Guavas, mangoes, mangosteens, papaws "papayas", tamarinds, cashew apples, lychee'),
('08119019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ovoce,ořechy,ostatní (též vařené),zmrazené,slazené,cukr >13% hmot.,ne:tropické', 'Frozen fruit and nuts, edible, uncooked or cooked by steaming or boiling in wate'),
('08119031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ovoce,ořechy,tropické (též vařené),zmrazené,slazené,cukr <=13% hmot.', 'Guavas, mangoes, mangosteens, papaws "papayas", tamarinds, cashew apples, lychee'),
('08119039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ovoce,ořechy,ostatní (též vařené),zmrazené,slazené,cukr <=13% hmot.,ne:tropické', 'Frozen fruit and nuts, edible, uncooked or cooked by steaming or boiling in wate'),
('08119050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Borůvky (Vaccinium myrtillus) (též vařené),zmrazené,neslazené', 'Fruit of species vaccinium myrtillus, uncooked or cooked by steaming or boiling'),
('08119070', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Borůvky druhů Vaccinium myrtilloides,augustifolium (též vařené),zmrazené,neslazené', 'Fruit of species vaccinium myrtilloides and vaccinium angustifolium, uncooked or'),
('08119075', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Višně (Prunus cerasus) (též vařené),zmrazené,neslazené', 'Sour cherries "Prunus cerasus", whether or not boiled or steamed, frozen, not co'),
('08119080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Třešně,višně ostatní (též vařené),zmrazené,neslazené,ne:Prunus cerasus', 'Cherries, whether or not boiled or steamed, frozen, not containing added sugar o'),
('08119085', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ovoce,ořechy,tropické (též vařené),zmrazené,neslazené', 'Guavas, mangoes, mangosteens, papaws "papayas", tamarinds, cashew apples, lychee'),
('08119095', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ovoce,ořechy,ostatní (též vařené),zmrazené,neslazené,ne:tropické', 'Frozen fruit and nuts, edible, uncooked or cooked by steaming or boiling in wate'),
('08121000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Třešně,višně,prozatímně konzervované,nevhodné k požívání', 'Cherries, provisionally preserved, e.g. by sulphur dioxide gas, in brine, in sul'),
('08129010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Meruňky,prozatímně konzervované,nevhodné k požívání', 'Apricots, provisionally preserved, e.g. by sulphur dioxide gas, in brine, in sul'),
('08129020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pomeranče,prozatímně konzervované,nevhodné k požívání', 'Oranges, provisionally preserved, e.g. by sulphur dioxide gas, in brine, in sulp'),
('08129030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papáje,prozatímně konzervované,nevhodné k požívání', 'Pawpaws, provisionally preserved, e.g. by sulphur dioxide gas, in brine, in sulp'),
('08129040', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Borůvky (Vaccinium myrtillus),prozatímně konzervované,nevhodné k požívání', 'Fruit of species vaccinium myrtillus, provisionally preserved, e.g. by sulphur d'),
('08129070', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kvajávy,manga,mangostany,tamarindy apod.,tropické ořechy,prozatímně konzervované,nevhodné k požívání', 'Guavas, mangoes, mangosteens, tamarinds, cashew apples, lychees, jackfruit, sapo'),
('08129098', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ovoce,ořechy,ostatní,prozatímně konzervované,nevhodné k požívání,ne:viz sazebník', 'Fruit and nuts, provisionally preserved, e.g. by sulphur dioxide gas, in brine,'),
('08131000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Meruňky,sušené', 'Dried apricots'),
('08132000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Švestky,sušené', 'Dried prunes'),
('08133000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jablka,sušená', 'Dried apples'),
('08134010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Broskve,vč.nektarinek,sušené', 'Dried peaches, incl. nectarines'),
('08134030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hrušky,sušené', 'Dried pears'),
('08134050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papáje,sušené', 'Dried pawpaws'),
('08134065', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tamarindy,jablíčka kešu,liči,jackfruit,sapoty,mučenky,karamboly,pitahaje,sušené', 'Dried tamarinds, cashew apples, lychees, jackfruit, sapodillo plums, passion fru'),
('08134095', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ovoce ostatní,sušené,ne:viz sazebník', 'Dried fruit, edible (excl. nuts, bananas, dates, figs, pineapples, avocados, gua'),
('08135012', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi sušených papájí,tamarid,jablíček kešu,liči apod.,bez švestek', 'Mixtures of dried papaws "papayas", tamarinds, cashew apples, lychees, jackfruit'),
('08135015', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi sušeného ovoce ostatního,bez švestek,ne:viz sazebník', 'Mixtures of dried fruit, not containing prunes (excl. mixtures of nuts, bananas,'),
('08135019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi sušeného ovoce,se švestkami,ne:viz sazebník', 'Mixtures of dried apricots, apples, peaches, incl. prunus persica nectarina and'),
('08135031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi ořechů tropických', 'Mixtures exclusively of dried coconuts, cashew nuts, brazil nuts, areca "betel"'),
('08135039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi ořechů ostatních,ne:tropických', 'Mixtures exclusively of edible and dried nuts of heading 0802 (excl. of coconuts'),
('08135091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi sušeného ovoce a ořechů ostatní,ne:se švestkami,fíky,viz sazebník', 'Mixtures of edible and dried nuts, bananas, dates, pineapples, avocados, guavas,'),
('08135099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi sušeného ovoce a ořechů ostatní,se švestkami,fíky,ne:viz sazebník', 'Mixtures of edible and dried nuts, bananas, dates, figs, pineapples, avocados, g'),
('08140000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kůry citrusových plodů,slupky melounů,čerstvé,zmrazené,sušené,konzervované', 'Peel of citrus fruit or melons, incl. watermelons, fresh, frozen, dried or provi'),
('09011100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Káva nepražená s kofeinem', 'Coffee (excl. roasted and decaffeinated)'),
('09011200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Káva nepražená dekofeinovaná', 'Decaffeinated coffee (excl. roasted)'),
('09012100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Káva pražená s kofeinem', 'Roasted coffee (excl. decaffeinated)'),
('09012200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Káva pražená dekofeinovaná', 'Roasted, decaffeinated coffee'),
('09019010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kávové slupky a pulpy', 'Coffee husks and skins'),
('09019090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kávové náhražky obsahující kávu', 'Coffee substitutes containing coffee in any proportion'),
('09021000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Čaj zelený (nefermentovaný),balení do 3 kg', 'Green tea in immediate packings of <= 3 kg'),
('09022000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Čaj zelený (nefermentovaný),balení přes 3 kg', 'Green tea in immediate packings of > 3 kg'),
('09023000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Čaj černý fermentovaný,částečně fermentovaný,balení do 3 kg', 'Black fermented tea and partly fermented tea, whether or not flavoured, in immed'),
('09024000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Čaj černý fermentovaný,částečně fermentovaný,balení nad 3 kg', 'Black fermented tea and partly fermented tea, whether or not flavoured, in immed'),
('09030000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maté', 'Mate'),
('09041100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pepř nedrcený ani nemletý', 'Pepper of the genus Piper, neither crushed nor ground'),
('09041200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pepř (Piper) sušený drcený,v prášku', 'Pepper of the genus Piper, crushed or ground'),
('09042010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Paprika sladká sušená nedrcená', 'Dried sweet peppers (excl. crushed or ground)'),
('09042030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Paprika ostatní sušená nedrcená,ne:sladká', 'Dried fruits of genus Capsicum or Pimenta, neither crushed or ground (excl. swee'),
('09042090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Paprika (Capsicum,Pimenta) sušená drcená,prášek', 'Crushed or ground fruits of genus Capsicum or Pimenta'),
('09050000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vanilka', 'Vanilla'),
('09061100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skořice (Cinnamomum zeylanicum Blume) nedrcená,nemletá', 'Cinnamon "Cinnamomum zeylanicum Blume" (excl. crushed and ground)'),
('09061900', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skořice ostatní nedrcená,nemletá', 'Cinnamon and cinnamon-tree flowers (excl. cinnamon "Cinnamomum zeylanicum Blume"'),
('09062000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skořice,květy skořicovníku drcené,v prášku', 'Crushed or ground cinnamon and cinnamon-tree flowers'),
('09070000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hřebíček-plody,květy,stopky', 'Cloves, whole fruit, cloves and stems'),
('09081000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oříšek muškátový', 'Nutmeg'),
('09082000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Květ muškátový', 'Mace'),
('09083000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Amomy,kardamomy', 'Cardamoms'),
('09091000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena anýzu nebo badyánu', 'Seeds of anise or badian'),
('09092000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena koriandru', 'Coriander seeds'),
('09093000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena kmínu', 'Cumin seeds'),
('09094000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena kořenného kmínu', 'Caraway seeds'),
('09095000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena fenyklu, jalovcové bobulky', 'Seeds of fennel; juniper berries'),
('09101000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zázvor', 'Ginger'),
('09102010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šafrán nedrcený,ne:v prášku', 'Saffron (excl. crushed or ground)'),
('09102090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šafrán drcený,v prášku', 'Crushed or ground saffron'),
('09103000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kurkuma', 'Turmeric "curcuma"'),
('09109105', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kari', 'Curry'),
('09109110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi koření (viz pozn.1b) nedrcené,ne:v prášku,kari', 'Mixtures of different types of spices (excl. crushed or ground)'),
('09109190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi koření (viz pozn.1b) drcené,v prášku,ne:kari', 'Crushed or ground mixtures of different types of spices'),
('09109910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena pískavice', 'Fenugreek seed'),
('09109931', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tymián-mateřídouška nedrcený,ne:v prášku', 'Wild thyme "Thymus serpyllum" (excl. crushed or ground)'),
('09109933', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tymián ostatní nedrcený,ne:v prášku,mateřídouška', 'Thyme (excl. crushed or ground and wild thyme)'),
('09109939', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tymián drcený,v prášku', 'Crushed or ground thyme'),
('09109950', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bobkový list', 'Bay leaves'),
('09109991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Koření ostatní nedrcené ani v prášku,ne:viz sazebník', 'Spices, neither crushed nor ground (excl. pepper of the genus Piper, fruit of th'),
('09109999', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Koření ostatní drcené,v prášku,ne:viz sazebník', 'Spices, crushed or ground (excl. pepper of the genus Piper, fruit of the genus C'),
('10011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pšenice durum (tvrdá)', 'Durum wheat'),
('10019010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Špalda k setí', 'Spelt for sowing'),
('10019091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Osivo běžné pšenice a sourži', 'Common wheat and meslin seed'),
('10019099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pšenice špalda, ne k setí', 'Spelt, common wheat and meslin (excl. seed)'),
('10020000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Žito', 'Rye'),
('10030010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ječmen-osivo', 'Barley seed'),
('10030090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ječmen ne k setí', 'Barley (excl. seed)'),
('10040000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oves', 'Oats'),
('10051011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kukuřice-zrna k setí hybridní dvakrát křížená,hybrid top-cross', 'Double and top cross hybrid maize seed'),
('10051013', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kukuřice-zrna k setí hybridní třikrát křížená', 'Three-cross hybrid maize seed'),
('10051015', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kukuřice-zrna k setí jednoduché hybridy', 'Simple hybrid maize seed'),
('10051019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kukuřice-zrna k setí hybridní ostatní,ne: 1x, 2x, 3x křížená,hybrid top-cross', 'Hybrid maize seed (excl. double, top cross, three-cross and simple hybrid maize'),
('10051090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kukuřice ostatní k setí,ne:hybridní', 'Maize seed (excl. hybrid)'),
('10059000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kukuřice ostatní,ne:k setí', 'Maize (excl. seed)'),
('10061010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže v plevách (paddy, surová) k setí', 'Rice in husk for sowing'),
('10061021', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže v plevách-kulatá zrna předpařená', 'Round grain rice in husk, parboiled'),
('10061023', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže v plevách-průměrná zrna předpařená', 'Medium grain rice in husk, parboiled'),
('10061025', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže v plevách-dlouhá zrna (délka:šířce=2-3:1) předpařená', 'Long grain rice in husk, length-width ratio > 2 but < 3, parboiled'),
('10061027', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže v plevách-dlouhá zrna (délka:šířce=nad 3:1) předpařená', 'Long grain rice in husk, length-width ratio >= 3, parboiled'),
('10061092', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže v plevách-kulatá zrna,ne:předpařená,k setí', 'Round grain rice in husk (excl. parboiled and that for sowing)'),
('10061094', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže v plevách-průměrná zrna,ne:předpařená,k setí', 'Medium grain rice in husk (excl. parboiled and that for sowing)'),
('10061096', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže v plevách-dlouhá zrna (délka:šířce=2-3:1),ne:předpařená,k setí', 'Long grain rice in husk, length-width ratio > 2 but < 3 (excl. parboiled and tha'),
('10061098', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže v plevách-dlouhá zrna (délka:šířce=nad 3:1),ne:předpařená,k setí', 'Long grain rice in husk, length-width ratio >= 3 (excl. parboiled and that for s'),
('10062011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže bez plev-kulatá zrna předpařená', 'Round grain husked [brown] rice, parboiled'),
('10062013', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže bez plev-průměrná zrna předpařená', 'Medium grain husked [brown] rice, parboiled'),
('10062015', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže bez plev-dlouhá zrna (délka:šířce=2-3:1) předpařená', 'Long grain husked [brown] rice, length-width ratio > 2 but < 3, parboiled'),
('10062017', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže bez plev-dlouhá zrna (délka:šířce=nad 3:1)předpařená', 'Long grain husked [brown] rice, length-width ratio >= 3, parboiled'),
('10062092', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže bez plev-kulatá zrna,ne:předpařená', 'Round grain husked [brown] rice (excl. parboiled)'),
('10062094', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže bez plev-průměrná zrna,ne:předpařená', 'Medium grain husked [brown] rice (excl. parboiled)'),
('10062096', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže bez plev-dlouhá zrna (délka:šířce=2-3:1),ne:předpařená', 'Long grain husked [brown] rice, length-width ratio > 2 but < 3 (excl. parboiled)'),
('10062098', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže bez plev-dlouhá zrna (délka:šířce=nad 3:1),ne:předpařená', 'Long grain husked [brown] rice, length-width ratio >= 3 (excl. parboiled)'),
('10063021', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže poloomletá-kulatá zrna dušená', 'Semi-milled round grain rice, parboiled'),
('10063023', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže poloomletá-průměrná zrna dušená', 'Semi-milled medium grain rice, parboiled'),
('10063025', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže poloomletá-dlouhá zrna (délka:šířce=2-3:1) dušená', 'Semi-milled long grain rice, length-width ratio > 2 but < 3, parboiled'),
('10063027', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže poloomletá-dlouhá zrna (délka:šířce=nad 3:1) dušená', 'Semi-milled long grain rice, length-width ratio >= 3, parboiled'),
('10063042', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže poloomletá-dlouhá zrna (délka:šířce=nad 3:1),ne:dušená', 'Semi-milled round grain rice (excl. parboiled)'),
('10063044', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže poloomletá-průměrná zrna,ne:dušená', 'Semi-milled medium grain rice (excl. parboiled)'),
('10063046', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže poloomletá-dlouhá zrna (délka:šířce=2-3:1),ne:dušená', 'Semi-milled long grain rice, length-width ratio > 2 but < 3 (excl. parboiled)'),
('10063048', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže poloomletá-dlouhá zrna (délka:šířce=nad 3:1),ne:dušená', 'Semi-milled long grain rice, length-width ratio >= 3 (excl. parboiled)'),
('10063061', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže omletá-kulatá zrna předpařená', 'Wholly milled round grain rice, parboiled, whether or not polished or glazed'),
('10063063', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže omletá-průměrná zrna předpařená', 'Wholly milled medium grain rice, parboiled, whether or not polished or glazed'),
('10063065', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže omletá-dlouhá zrna (délka:šířce=2-3:1) předpařená', 'Wholly milled long grain rice, length-width ratio > 2 but < 3, parboiled, whethe'),
('10063067', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže omletá-dlouhá zrna (délka:šířce=nad 3:1) předpařená', 'Wholly milled long grain rice, length-width ratio >= 3, parboiled, whether or no'),
('10063092', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže omletá-kulatá zrna,ne:předpařená', 'Wholly milled round grain rice, whether or not polished or glazed (excl. parboil'),
('10063094', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže omletá-průměrná zrna,ne:předpařená', 'Wholly milled medium grain rice, whether or not polished or glazed (excl. parboi'),
('10063096', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže omletá-dlouhá zrna (délka:šířce=2-3:1),ne:předpařená', 'Wholly milled long grain rice, length-width > 2 but < 3, whether or not polished'),
('10063098', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže omletá-dlouhá zrna (délka:šířce=nad 3:1),ne:předpařená', 'Wholly milled long grain rice, length-width ratio >= 3, whether or not polished'),
('10064000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže zlomková', 'Broken rice'),
('10070010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna čiroku-hybridy k setí', 'Hybrid grain sorghum, for sowing'),
('10070090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna čiroku ostatní,ne:hybridy k setí', 'Grain sorghum (excl. hybrid for sowing)'),
('10081000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pohanka', 'Buckwheat'),
('10082000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Proso', 'Millet (excl. grain sorghum)'),
('10083000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lesknice kanárská', 'Canary seed'),
('10089010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Triticale', 'Triticale'),
('10089090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Obiloviny ostatní,ne:viz sazebník', 'Cereals (excl. wheat and meslin, rye, barley, oats, maize, rice, buckwheat, mill'),
('11010011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mouka pšeničná z pšenice durum', 'Durum wheat flour'),
('11010015', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mouka pšeničná z obyčejné pšenice a pšenice špaldy,ne:z pšenice durum', 'Flour of common wheat and spelt'),
('11010090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mouka ze sourži', 'Meslin flour'),
('11021000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mouka žitná', 'Rye flour'),
('11022010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mouka kukuřičná,tuk do 1,5%', 'Maize flour, with fat content of <= 1,5% by weight'),
('11022090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mouka kukuřičná,tuk nad 1,5%', 'Maize flour, with fat content of > 1,5% by weight'),
('11029010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mouka ječná', 'Barley flour'),
('11029030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mouka ovesná', 'Oat flour'),
('11029050', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mouka rýžová', 'Rice flour'),
('11029090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mouka ostatní,ne:pšeničná,ze soureži,žitná,kukuřičná,rýžová,ječná,ovesná', 'Cereal flours (excl. wheat, meslin, rye, maize, rice, barley and oat)'),
('11031110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krupice,krupička z tvrdé pšenice', 'Groats and meal, of durum wheat'),
('11031190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krupice,krupička z měkké pšenice,špaldy', 'Common wheat and spelt groats and meal'),
('11031310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krupice,krupička z kukuřice,tuk do 1,5%', 'Groats and meal of maize, "corn", with a fat content, by weight, of <= 1,5%'),
('11031390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krupice,krupička z kukuřice,tuk přes 1,5%', 'Groats and meal of maize, "corn", with a fat content, by weight, of > 1,5%'),
('11031910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krupice,krupička z žita', 'Rye groats and meal'),
('11031930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krupice,krupička z ječmene', 'Barley groats and meal'),
('11031940', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krupice,krupička z ovsa', 'Groats and meal of oats'),
('11031950', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krupice,krupička z rýže', 'Rice groats and meal'),
('11031990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krupice,krupička ostatní,ne:pšenice,oves,kukuřice,rýže,žito,ječmen', 'Groats and meal of cereals (excl. wheat, oats, maize, rice, rye and barley)'),
('11032010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pelety z žita', 'Rye pellets'),
('11032020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pelety z ječmene', 'Barley pellets'),
('11032030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pelety z ovsa', 'Pellets of oats'),
('11032040', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pelety z kukuřice', 'Maize pellets'),
('11032050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pelety z rýže', 'Rice pellets'),
('11032060', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pelety z pšenice', 'Wheat pellets'),
('11032090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pelety z obilí ostatní,ne:pšenice, žito, ječmen, oves, kukuřice, rýže', 'Cereal pellets (excl. rye, barley, oats, maize, rice and wheat)'),
('11041210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna z ovsa drcená na válcích', 'Rolled oat grains'),
('11041290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna z ovsa ve vločkách', 'Flaked oat grains'),
('11041910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna z pšenice drcená,ve vločkách', 'Rolled or flaked wheat grains'),
('11041930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna z žita drcená,ve vločkách', 'Rolled or flaked rye grains'),
('11041950', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna z kukuřice drcená,ve vločkách', 'Rolled or flaked maize grains'),
('11041961', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna z ječmene drcená na válcích', 'Rolled barley grains'),
('11041969', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna z ječmene ve vločkách', 'Flaked barley grains'),
('11041991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vločky rýžové', 'Flaked rice grains'),
('11041999', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna drcená,ve vločkách ost.,ne:ječmen,oves,pšenice,žito,kukuřice,vločky rýžové', 'Rolled or flaked cereal grains (excl. grains of oats, wheat, rye, maize and barl'),
('11042220', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna z ovsa loupaná', 'Oat grains, hulled [shelled or husked] (excl. clipped)'),
('11042230', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna z ovsa loupaná a řezaná,šrotovaná,zvaná Grutze nebo grutten', 'Hulled, sliced or kibbled oat grains'),
('11042250', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna z ovsa perlovitá', 'Pearled oat grains'),
('11042290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna z ovsa pouze šrotovaná', 'Kibbled oat grains'),
('11042298', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Obilná zrna zpracovaná ostatní,ne:viz sazebník', 'Oat grains (excl. clipped, hulled [shelled or husked] and sliced or kibbled ["Gr'),
('11042310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna z kukuřice loupaná i řezaná,šrotovaná', 'Hulled [shelled or husked], maize grains, whether or not sliced or kibbled'),
('11042330', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna z kukuřice perlovitá', 'Pearled maize grains'),
('11042390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna z kukuřice pouze šrotovaná', 'Kibbled maize grains'),
('11042399', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna z kukuřice zprac.ost.,ne:loupaná (i řezaná,šrotovaná),perlovitá,řezaná,šrotovaná', 'Cereal grains of maize (other than hulled [shelled or husked], sliced or kibbled'),
('11042901', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna z ječmene loupaná', 'Hulled [shelled or husked] barley grains'),
('11042903', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna z ječmene loupaná a řezaná,šrotovaná (zvaná "Grutze" nebo "grutten")', 'Hulled and sliced or kibbled barley grains [''GrĂĽtze'' or ''grutten'']'),
('11042905', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna z ječmene perlovitá', 'Pearled barley grains'),
('11042907', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna z ječmene pouze šrotovaná', 'Barley grains, only kibbled'),
('11042909', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna z ječmene zpracovaná ostatní,ne:viz sazebník', 'Barley grains (other than hulled [shelled or husked] and sliced or kibbled [''Gr'),
('11042911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna z pšenice loupaná i řezaná,šrotovaná', 'Hulled [shelled or husked] wheat grains'),
('11042918', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna z ost.obilí loupaná i řezaná,šrotovaná,ne:ječmen,oves,pšenice,kukuřice', 'Hulled [shelled or husked] cereal grains (excl. barley, oats, maize, rice or whe'),
('11042930', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna z ostatního obilí perlovitá,ne:ječmen,oves,kukuřice', 'Pearled cereal grains (excl. barley, oats, maize or rice)'),
('11042951', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna z pšenice pouze šrotovaná', 'Cereal grains of wheat, not otherwise worked than kibbled'),
('11042955', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna ze žita pouze šrotovaná', 'Cereal grains of rye, not otherwise worked than kibbled'),
('11042959', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna z ostatního obilí pouze šrotovaná,ne:ječmen,oves,kukuřice,pšenice,žito', 'Cereal grains, not otherwise worked than kibbled (other than barley, oats, maize'),
('11042981', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna z pšenice zprac.ost.,ne:loupaná (i řezaná,šrotovaná),perlovitá,pouze šrotovaná', 'Cereal grains of wheat (other than hulled [shelled or husked], sliced or kibbled'),
('11042985', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna ze žita zprac.ost.,ne:loupaná (i řezaná,šrotovaná),perlovitá,pouze šrotovaná', 'Cereal grains of rye (other than hulled [shelled or husked], sliced or kibbled,'),
('11042989', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrna z ostatního obilí zpracovaná ostatní,ne:viz sazebník', 'Cereal grains (other than of barley, oats, maize, wheat and rye, hulled [shelled'),
('11043010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Klíčky z pšenice celé,drcené,ve vločkách,mleté', 'Wheat germ, whole, rolled, flaked or ground'),
('11043090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Klíčky z ostatního obilí celé,drcené,ve vločkách,mleté,ne:pšenice', 'Cereal germ, whole, rolled, flaked or ground (excl. wheat)'),
('11051000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mouka,krupice,prášek z brambor', 'Flour, meal and powder of potatoes'),
('11052000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vločky,granule,peleta z brambor', 'Flakes, granules and pellets of potatoes'),
('11061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mouka,krupice,prášek ze sušených luštěnin č.0713', 'Flour, meal and powder of peas, beans, lentils and the other dried leguminous ve'),
('11062010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mouka,krupice,prášek denaturované ze sága,kořenů a hlíz č.0714', 'Denatured flour, meal and powder of sago or of manioc, arrowroot, salep, Jerusal'),
('11062090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mouka,krupice,prášek ostatní ze sága,kořenů a hlíz č.0714,ne:denaturované', 'Flour, meal and powder of sago and of root or tubers of manioc, arrowroot, salep'),
('11063010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mouka,krupice,prášek z banánu', 'Flour, meal and powder of bananas'),
('11063090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mouka,krupice,prášek z výrobků kapitoly 8,ne:z banánů', 'Flour, meal and powder of produce of chapter 8 "Edible fruit and nuts; peel of c'),
('11071011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slad nepražený z pšenice ostatní,ne:ve formě mouky', 'Wheat malt in flour form (excl. roasted)'),
('11071019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slad nepražený z pšenice ostatní,ne:ve formě mouky', 'Wheat malt (excl. flour and roasted)'),
('11071091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slad nepražený ve formě mouky,ne:z pšenice', 'Malt in flour form (excl. roasted and wheat)'),
('11071099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slad nepražený ostatní,ne:z pšenice,ve formě mouky', 'Malt (excl. roasted, wheat and flour)'),
('11072000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slad pražený', 'Roasted malt'),
('11081100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Škrob pšeničný', 'Wheat starch'),
('11081200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Škrob kukuřičný', 'Maize starch'),
('11081300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Škrob bramborový', 'Potato starch'),
('11081400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Škrob maniokový', 'Manioc starch'),
('11081910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Škrob rýžový', 'Rice starch'),
('11081990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Škrob ostatní,ne:z pšenice,kukuřice,brambor,manioku,rýže', 'Starch (excl. wheat, maize, potato, manioc and rice)'),
('11082000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Inulin', 'Inulin'),
('11090000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lepek pšeničný i sušený', 'Wheat gluten, whether or not dried'),
('12010010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Boby sojové k setí', 'Soya beans for sowing'),
('12010090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Boby sojové ostatní i drcené,ne:k setí', 'Soya beans (excl. for sowing)'),
('12021010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Podzemnicová jádra (oříšky arašídové) neloupaná k setí', 'Groundnuts in shell for sowing'),
('12021090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Podzemnicová jádra (oříšky arašídové) neloupaná ostatní,ne:k setí', 'Groundnuts in shell (excl. roasted or otherwise cooked and for sowing)'),
('12022000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Podzemnicová jádra (oříšky arašídové) loupaná i drcená,ne:neloupaná,pražená', 'Shelled groundnuts, whether or not broken (excl. roasted or otherwise cooked)'),
('12030000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kopra', 'Copra'),
('12040010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena lněná k setí', 'Linseed for sowing'),
('12040090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena lněná i drcená ostatní,ne:k setí', 'Linseed (excl. for sowing)'),
('12051010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena řepky,i olejky,s nízkým obsahem kyseliny erukové, k setí', 'Low erucic acid rape or colza seeds "yielding a fixed oil which has an erucic ac'),
('12051090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena řepky,i olejky,s nízkým obsahem kyseliny erukové ost.,ne:k setí', 'Low erucic rape or colza seeds "yielding a fixed oil which has an erucic acid co'),
('12059000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena řepky ostatní i drcená,ne:s nízkým obsahem kyseliny erukové', 'High erucic rape or colza seeds "yielding a fixed oil which has an erucic acid c'),
('12060010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena slunečnicová k setí', 'Sunflower seeds for sowing'),
('12060091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena slunečnicová loupaná i ve slupce šedě a bíle proužkovaná,ne:k setí', 'Sunflower seeds, whether or not shelled and in grey and white striped shell (exc'),
('12060099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena slunečnicová loupaná i drcená ost.,ne:k setí,loupaná,ve slupce proužkovaná', 'Sunflower seeds, whether or not broken (excl. for sowing, whether or not shelled'),
('12072010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena bavlníková k setí', 'Cotton seeds for sowing'),
('12072090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena bavlníková i drcená ostatní,ne:k setí', 'Cotton seeds, whether or not broken (excl. for sowing)'),
('12074010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena sezamová k setí', 'Sesamum seeds for sowing'),
('12074090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena sezamová i drcená ostatní,ne:k setí', 'Sesamum seeds, whether or not broken (excl. for sowing)'),
('12075010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena hořčičná k setí', 'Mustard seeds for sowing'),
('12075090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena horčičná i drcená ostatní,ne:k setí', 'Mustard seeds, whether or not broken (excl. for sowing)'),
('12079110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena maková k setí', 'Poppy seeds for sowing'),
('12079190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena maková i drcená ostatní,ne:k setí', 'Poppy seeds, whether or not broken (excl. for sowing)'),
('12079915', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena,plody olejnaté ostatní k setí,ne:viz sazebník', 'Oil seeds and oleaginous fruits, for sowing (excl. edible nuts, olives, soya bea'),
('12079991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena konopí i drcená,ne:k setí', 'Hemp seeds, whether or not broken (excl. for sowing)'),
('12079997', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena,plody olejnaté ostatní i drcené,ne:k setí,druhy viz sazebník', 'Oil seeds and oleaginous fruits, whether or not broken (excl. for sowing and edi'),
('12081000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mouka,šrot ze sojových bobů', 'Soya bean flour and meal'),
('12089000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mouka,šrot z olejnatých semen a plodů ostatní,ne:hořčičná,sojových bobů', 'Flours and meal of oil seeds or oleaginous fruit (excl. soya and mustard)'),
('12091000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena cukrové řepy k setí', 'Sugar beet seed, for sowing'),
('12092100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena vojtěšky k setí', 'Alfalfa seed for sowing'),
('12092210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena jetele červeného k setí', 'Red clover "Trifolium pratense L." seed for sowing'),
('12092280', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena jetele ostatní k setí,ne:červeného', 'Clover "Trifolium spp." seed for sowing (excl. red clover [Trifolium pratense L.'),
('12092311', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena kostřavy luční k setí', 'Meadow fescue seed for sowing'),
('12092315', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena kostřavy červené k setí', 'Red fescue seed "Festuca rubra L." for sowing'),
('12092380', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena kostřavy ostatní k setí,ne:luční,červené', 'Fescue seed, for sowing (excl. meadow fescue "Festuca pratensis Huds" seed and r'),
('12092400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena Kentucké lipnice k setí', 'Kentucky blue grass "Poa pratensis L." seed for sowing'),
('12092510', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena Jílku italského k setí', 'Italian ryegrass, incl. westerwolds "Lolium multiflorum L.", seed for sowing'),
('12092590', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena víceletého jílku k setí', 'Perennial ryegrass "Lolium perenne L.", seed for sowing'),
('12092910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena vikve,druhu Poa palustris,trivialis,srhy,psinečku k setí', 'Vetch seed, seeds of the genus Poa palustris L. and Poa trivialis L., seeds of c'),
('12092935', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena bojínku k setí', 'Timothy grass seed for sowing'),
('12092950', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena bobu vlčího k setí', 'Lupine seed for sowing'),
('12092960', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena krmné řepy (Beta vulgaris var. Alba)', 'Fodder beet seed "Beta vulgaris var. alba", for sowing'),
('12092980', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena pícnin ostatní k setí,ne:viz sazebník', 'Seeds of forage plants, for sowing (excl. cereals and fodder beet seed "Beta vul'),
('12093000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena bylin pěstovaných pro květy k setí', 'Seeds of herbaceous plants cultivated mainly for flowers, for sowing'),
('12099110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena kedlubnu k setí', 'Kohlrabi seed "Brassica oleracea, var. caulorapa and gongylodes L." for sowing'),
('12099130', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena salátové řepy nebo semena červené řepy (Beta vulgaris var. Conditiva)', 'Salad beet seed or beetroot seed "Beta vulgaris var. conditiva", for sowing'),
('12099190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena zeleniny ostatní k setí,ne:kedlubnu', 'Vegetable seed for sowing (excl. kohlrabi "Brassica oleracea, var. caulorapa and'),
('12099910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena lesních stromů k setí', 'Forest-tree seed for sowing'),
('12099991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena rostlin pěstovaných pro květy k setí,ne:bylin čísla 1209 30 00', 'Seeds of non-herbaceous plants cultivated mainly for flowers, for sowing'),
('12099999', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena,plody,výtrusy k setí ost.,ne:řepa,pícniny,květiny,zelenina,lesní stromy', 'Seeds, fruit and spores, for sowing (excl. leguminous vegetables and sweetcorn,'),
('12101000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šištice chmelové čerstvé sušené nerozdrcené', 'Hop cones, fresh or dried (excl. ground, powdered or in the form of pellets)'),
('12102010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šištice chmelové s vyšším obsahem lupulinu drcené,prášek,kuličky,válečky', 'Hop cones, ground, powdered or in the form of pellets, with higher lupulin conte'),
('12102090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šištice chmelové ostatní čerstvé,sušené drcené,ne:vyšší obsah lupulinu', 'Hop cones, ground powdered or in the form of pellets (excl. with higher lupulin'),
('12112000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kořeny ginsengu (ženšen) čerstvé,sušené i drcené,řezané,prášek', 'Ginseng roots, fresh or dried, whether or not cut, crushed or powdered'),
('12113000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Listy koky', 'Coca leaf, fresh or dried, whether or not cut, crushed or powdered'),
('12114000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sláma maková', 'Poppy straw, fresh or dried, whether or not cut, crushed or powdered'),
('12119030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena tonková čerstvá,sušená i drcená,prášek', 'Tonquin beans, fresh or dried, whether or not cut, crushed or powdered'),
('12119085', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní rostliny a části,pro farmaceut.,voňavkářský průmysl,ne:viz sazebník', 'Plants and parts of plants, incl. seeds and fruits, used primarily in perfumery,'),
('12122000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Řasy a jiné chaluhy čerstvé,chlazené,mrazené,sušené,v prášku', 'Seaweeds and other algae, fresh, chilled, frozen or dried, whether or not ground'),
('12129120', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Řepa cukrová sušená i v prášku', 'Sugar beet, dried, whether or not ground'),
('12129180', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Řepa cukrová čerstvá,chlazená,zmrazená', 'Sugar beet, fresh, chilled or frozen'),
('12129920', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Třtina cukrová čerstvá,chlazená,zmrazená,sušená i v prášku', 'Sugar cane, fresh, chilled, frozen or dried, whether or not ground'),
('12129930', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chléb svatojánský čerstvý,sušený,v prášku', 'Locust beans, fresh, chilled, frozen or dried, whether or not ground'),
('12129941', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena svatojánského chleba se slupkou nedrcená,nemletá', 'Locust bean seed, fresh or dried (excl. decorticated, crushed or ground)'),
('12129949', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Semena svatojánského chleba ostatní,ne:se slupkou nedrcená,nemletá', 'Locust bean seed, decorticated, crushed or ground, fresh or dried'),
('12129970', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Produkty rostlinné ost.,používané hlavně pro lidskou výživu,ne:viz sazebník', 'Fruit stones and kernels and other vegetable products, incl. unroasted chicory r'),
('12130000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sláma,plevy nezpracované i řezané,mleté lisované,aglomerované', 'Cereal straw and husks, unprepared, whether or not chopped, ground, pressed or i'),
('12141000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Moučka z vojtěšky,aglomerované výrobky z ní ve tvaru válečků,kuliček apod.', 'Alfalfa meal and pellets'),
('12149010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Řepa krmná,tuřín a jiné kořeny krmné i aglomerovované ve tvaru válečků apod.', 'Swedes, mangolds, fodder roots'),
('12149090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní pícniny, ne:krmná řepa, kořeny, tuřín, moučka z vojtěšky', 'Hay, lucerne, clover, sainfoin, forage kale, lupines, vetches and similar forage'),
('13012000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Guma arabská přírodní', 'Natural gum Arabic'),
('13019000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.přír.pryskyřice,klejopryskyř.,balzámy,gumy,oleje,šelak,ne:arab.guma', 'Lac; natural gums, resins, gum-resins, balsams and other natural oleoresins (exc'),
('13021100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Opium i upravené', 'Opium'),
('13021200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťávy,výtažky z lékořice i upravené', 'Extracts of liquorice (excl. that with a sucrose content by weight of > 10% or i'),
('13021300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťávy,výtažky z chmele i upravené', 'Extracts of hops'),
('13021905', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výtažky z vanilky i upravené', 'Vanilla oleoresin'),
('13021980', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťávy a výtažky rostlinné jinde neuvedené,ostatní', 'Vegetable saps and extracts (excl. liquorice, hops, vanilla oleoresin and opium)'),
('13022010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Látky pektinové,pektináty,pektany v suchém stavu i upravené', 'Dry pectic substances, pectinates and pectates in powder form'),
('13022090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Látky pektinové,pektináty,pektany ostatní i upravené,ne:v suchém stavu', 'Liquid pectic substances, pectinates and pectates'),
('13023100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Agar-agar i upravený', 'Agar-agar, whether or not modified'),
('13023210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slizy,zahušťovadla ze svatojánského chleba,i upravené', 'Mucilages and thickeners of locust beans or bean seeds, whether or not modified'),
('13023290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slizy,zahušťovadla ze semen guarových i upravené', 'Mucilages and thickeners of guar seeds, whether or not modified'),
('13023900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slizy,zahušťovadla z rostlin ost.i upravené,ne:ze svatoj.chleba,semen guarových', 'Mucilages and thickeners derived from vegetable products, whether or not modifie'),
('14011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bambus', 'Bamboos'),
('14012000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rákos', 'Rattans'),
('14019000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Materiály rostlinné ostatní k výrobě košíkářského zboží,ne:bambus,rákos', 'Reeds, rushes, osier, raffia, cleaned, bleached or dyed cereal straw, lime bark'),
('14042000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bavlna krátká (z druhého vyzrňování)', 'Cotton linters'),
('14049000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky rostlinné ostatní jinde neuvedené,nezahrnuté,ne:viz sazebník', 'Vegetable products n.e.s'),
('15010011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sádlo vepřové,tuk jiný vepřový k průmyslovému účelu,ne:pro lidskou výživu', 'Pig fat, incl. lard, rendered or otherwise extracted, for industrial uses (excl.'),
('15010019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sádlo vepřové,tuk jiný vepřový pro výrobu potravin pro lidskou výživu', 'Pig fat, incl. lard, rendered or otherwise extracted (excl. for technical/indust'),
('15010090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuk drůbeží', 'Poultry fat, rendered or otherwise extracted'),
('15020010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lůj hovězí,ovčí,kozí k průmyslovému účelu,ne:pro potraviny pro lidskou výživu', 'Fats of bovine animals, sheep or goats, for industrial uses (other than the manu'),
('15020090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lůj hovězí,ovčí,kozí pro výrobu potravin pro lidskou výživu', 'Fats of bovine animals, sheep or goats (excl. for industrial uses, lard stearin,'),
('15030011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stearin z vepřového sádla,oleostearin pro průmyslové účely', 'Lard stearin and oleostearin for industrial uses (excl. emulsified, mixed or oth'),
('15030019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stearin z vepřového sádla,oleostearin ostatní,ne:pro průmyslové účely', 'Lard stearin and oleostearin (excl. for industrial uses and emulsified, mixed or'),
('15030030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olein z loje k průmyslovým účelům,ne:pro potraviny pro lidskou výživu', 'Tallow oil for industrial uses (excl. for production of foodstuffs and emulsifie'),
('15030090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olein,oleomargarin neupravený,nesmíchaný,ne:olein z loje pro průmyslové účely', 'Tallow oil, oleo-oil and lard oil (excl. emulsified, mixed or otherwise prepared'),
('15041010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje,frakce z rybích jater chem.neuprav.,vitamin A max.2500 mezinár.jedn./g', 'Fish-liver oils and their fractions with vitamin A content of <= 2.500 internati'),
('15041091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje,frakce z jater platýše chem.neuprav.,ne:vitamin A nad 2500 mezin.jedn./g', 'Fish-liver oils and their fractions, of halibut, whether or not refined, but not'),
('15041099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje,frakce z ryb.jater ost.neupr.,ne:platýš,vitaminu A nad 2500 mezin.jedn./g', 'Fish-liver oils and their fractions, whether or not refined but not chemically m'),
('15042010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuky,oleje-pevné frakce olejů z ryb chem.neupravené,ne:z jater', 'Solid fractions of fish fats and oils, whether or not refined (excl. chemically'),
('15042090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuky,oleje,frakce ostatní z ryb chem.neupravené,ne:z jater,pevné frakce', 'Fish fats and oils and liquid fractions, whether or not refined (excl. chemicall'),
('15043010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pevné frakce tuků a olejů z mořských savců', 'Solid marine mammal fat and oil fractions, whether or not refined (excl. chemica'),
('15043090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuky,oleje,frakce z mořských savců ostatní,ne:pevné frakce', 'Marine mammal fats, oils and their liquid fractions, whether or not refined (exc'),
('15050010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuk z ovčí vlny surový', 'Crude wool grease'),
('15050090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Látky tukové ostatní získané z ovčí vlny včetně lanolínu,ne:tuk surový', 'Wool grease and fatty substances derived therefrom, incl. lanolin (excl. crude w'),
('15060000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuky,oleje,frakce ostatní živočišné chemicky neupravené,ne:viz sazebník', 'Other animal fats and oils and their fractions, whether or not refined, but not'),
('15071010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej sojový surový i odslizený k průmysl.účelu,ne:pro lidskou výživu', 'Crude soya-bean oil, whether or not degummed, for technical or industrial uses ('),
('15071090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej sojový surový i odslizený pro výrobu potravin pro lidskou výživu', 'Crude soya-bean oil, whether or not degummed (excl. for technical or industrial'),
('15079010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce sojový k průmysl.účelu,ne:surový,pro lidskou výživu', 'Soya-bean oil and its fractions, whether or not refined, for technical or indust'),
('15079090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce sojový pro výrobu potravin pro lidskou výživu,ne:surový', 'Soya-bean oil and its fractions, whether or not refined (excl. for technical or'),
('15081010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej podzemnicový surový k průmysl.účelu,ne:pro lidskou výživu', 'Crude groundnut oil for technical or industrial uses (excl. for production of fo'),
('15081090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej podzemnicový surový pro výrobu potravin pro lidskou výživu', 'Crude groundnut oil (excl. for technical or industrial uses)'),
('15089010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce podzemnicový k průmysl.účelu,ne:surový,pro lidskou výživu', 'Groundnut oil and its fractions, whether or not refined, for industrial uses (ex'),
('15089090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce podzemnicový pro výrobu potravin pro lidskou výživu,ne:surový', 'Groundnut oil and its fractions, whether or not refined (excl. chemically modifi'),
('15091010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce olivový panenský na svícení chemicky neupravený', 'Virgin lampante olive oil obtained from the fruit of the olive tree solely by me'),
('15091090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce olivový panenský ostatní chemicky neupravený,ne:na svícení', 'Olive oil obtained from the fruit of the olive tree solely by mechanical or othe'),
('15099000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce olivový ostatní chemicky neupravený,ne:panenský', 'Olive oil and fractions obtained from the fruit of the olive tree solely by mech'),
('15100010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje,frakce,směsi surové ostatní z oliv chemicky neupravené,ne:olej č.1509', 'Crude olive oils and blends, incl. blends with those of heading 1509'),
('15100090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje,frakce,směsi ostatní z oliv chemicky neupravené,ne:surové,olej č.1509', 'Other oils and their fractions, obtained solely from olives, whether or not refi'),
('15111010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce palmový surový k průmysl.účelu chem.neupr.,ne:pro lidskou výživu', 'Crude palm oil, for technical or industrial uses (excl. for manufacture of foods'),
('15111090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce palmový surový pro výrobu potravin pro lidskou výživu chem.neupravený', 'Crude palm oil (excl. for technical or industrial uses)'),
('15119011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej palmový-pevné frakce,balení do 1 kg pro okamžitou spotřebu', 'Solid palm oil fractions, whether or not refined, but not chemically modified, i'),
('15119019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej palmový-pevné frakce ostatní,ne:balení do 1 kg pro okamžitou spotřebu', 'Solid palm oil fractions, whether or not refined, but not chemically modified, i'),
('15119091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej palmový ost.k průmysl.účelu,ne:surový,pevné frakce,pro lidskou výživu', 'Palm oil and its liquid fractions, whether or not refined, but not chemically mo'),
('15119099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej palmový ost.pro výrobu potravin pro lidskou výživu,ne:surový,pevné frakce', 'Palm oil and its liquid fractions, whether or not refined, but not chemically mo'),
('15121110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slunečnicový,světlicový olej surový pro průmysl.účely,ne:viz sazebník', 'Crude sunflower-seed or safflower oil, for technical or industrial uses (excl. f'),
('15121191', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej slunečnicový surový pro výrobu potravin pro lidskou výživu', 'Crude sunflower-seed oil (excl. for technical or industrial uses)'),
('15121199', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej světlicový surový pro výrobu potravin pro lidskou výživu', 'Crude safflower oil (excl. for technical or industrial uses)'),
('15121910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slunečnicový,světlicový olej ostatní pro průmysl.účely,ne:viz sazebník', 'Sunflower-seed or safflower oil and their fractions, whether or not refined, but'),
('15121990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.slunečnic.a světlic.olej,frakce,pro lidskou výživu', 'Sunflower-seed or safflower oil and their fractions, whether or not refined, but'),
('15122110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej bavlníkový surový i bez gossypolu k prům.účelu,ne:pro lidskou výživu', 'Crude cotton-seed oil, for technical or industrial uses (excl. for manufacture o'),
('15122190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej bavlníkový surový i bez gossypolu pro výrobu potravin pro lidskou výživu', 'Crude cotton-seed oil (excl. for technical or industrial uses)'),
('15122910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej bavlníkový k průmyslovému účelu,ne:surový,pro lidskou výživu', 'Cotton-seed oil and its fractions, whether or not refined, but not chemically mo'),
('15122990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej bavlníkový pro výrobu potravin pro lidskou výživu,ne:surový', 'Cotton-seed oil and its fractions, whether or not refined, but not chemically mo'),
('15131110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce kokosový surový k průmyslovému účelu,ne:pro lidskou výživu', 'Crude coconut oil, for technical or industrial uses (excl. for manufacture of fo'),
('15131191', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce kokosový surový balení do 1 kg pro okamžitou spotřebu', 'Crude coconut oil, in immediate packings of <= 1 kg (excl. for technical or indu'),
('15131199', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce kokosový surový balení nad 1 kg pro okamžitou spotřebu', 'Crude coconut oil, in immediate packings of > 1 kg or put up otherwise (excl. fo'),
('15131911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej kokosový-pevné frakce balení do 1 kg pro okamžitou spotřebu,ne:surový', 'Solid coconut oil fractions, whether or not refined, but not chemically modified'),
('15131919', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej kokosový-pevné frakce balení nad 1 kg pro okamžitou spotřebu,ne:surový', 'Solid coconut oil fractions, whether or not refined, but not chemically modified'),
('15131930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce kokosový k průmy.účelu,ne:surový,pevné frakce,pro lidskou výživu', 'Coconut oil and its liquid fractions, whether or not refined, but not chemically'),
('15131991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce kokosový balení do 1 kg pro okamžitou spotřebu,ne:surový,pevné frakce', 'Coconut oil and its liquid fractions, whether or not refined, but not chemically'),
('15131999', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce kokosový balení nad 1 kg pro okamž.spotřebu,ne:surový,pevné frakce', 'Coconut oil and its liquid fractions, whether or not refined, but not chemically'),
('15132110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Surový palmový a babass.olej,pro průmysl.účely,ne:pro lidskou výživu', 'Crude palm kernel and babassu oil, for technical or industrial uses (excl. for m'),
('15132130', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce palmojádrový,babassuový surový balení do 1 kg pro okamžitou spotřebu', 'Crude palm kernel and babassu oil, in immediate packings of <= 1 kg (excl. for t'),
('15132190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce palmojádrový,babassuový surový ost.,ne:bal.do 1 kg pro okamžitou spotřebu', 'Raw palm kernel oil and babassu oil in immediate packings of a net content of >'),
('15132911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej palmojádrový,babassuový-pevné frakce,bal.do 1 kg okamžitou spotřebu,ne:surový', 'Solid palm kernel and babassu oil fractions, whether or not refined, but not che'),
('15132919', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej palmojádrový,babassuový-pevné frakce,ne:surový,bal.do 1 kg pro okamžitou spotřebu', 'Solid palm kernel and babassu oil fractions, whether or not refined, but not che'),
('15132930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej palmojádrový,babassuový ost.k prům.učelům,ne:surový,pro lidskou výživu', 'Palm kernel and babassu oil and their liquid fractions, whether or not refined,'),
('15132950', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej palmojádrový,babassuový ost.bal.do 1 kg okamž.spotř.,ne:surový,pevné frakce', 'Palm kernel and babassu oil and their liquid fractions, whether or not refined,'),
('15132990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.palmový a babassuový olej,pro výrobu potravin pro lidskou výživu,ne:surový,bal.do 1 kg', 'Palm kernel and babassu oil and their liquid fractions, whether or not refined,'),
('15141110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej řepky surový,nízký obs.kys.erukové, k prům.účelům,ne:pro lidskou výživu', 'Low erucic acid rape or colza oil "fixed oil which has an erucic acid content of'),
('15141190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej řepky surový ost.,nízký obs.kys.erukové,ne:k průmysl.účelům', 'Low erucic acid rape or colza oil "fixed oil which has an erucic acid content of'),
('15141910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce řepky,nízký obs.kys.erukové, k prům.účelům,ne:surový,pro lidskou výživu', 'Low erucic acid rape or colza oil "fixed oil which has an erucic acid content of'),
('15141990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej řepky ostatní,nízký obs.kys.erukové,ne:surový,k průmysl.účelům', 'Low erucic acid rape or colza oil "fixed oil which has an erucic acid content of'),
('15149110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej hořčičný surový k průmyslovým účelům,ne:pro lidskou výživu', 'High erucic acid rape or colza oil "fixed oil which has an erucic acid content o'),
('15149190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej hořčičný surový ostatní,ne:k průmyslovým účelům', 'High erucic acid rape or colza oil "fixed oil which has an erucic acid content o'),
('15149910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce řepkový,hořčičný ostatní k prům.účelům,ne:viz sazebník', 'High erucic acid rape or colza oil "fixed oil which has an erucic acid content o'),
('15149990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce řepkový,hořčičný ostatní,ne:viz sazebník', 'High erucic acid rape or colza oil "fixed oil which has an erucic acid content o'),
('15151100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce lněný surový,stálý,chemicky neupravený', 'Crude linseed oil'),
('15151910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce lněný,stálý,k prům.účelům,ne:surový,pro lidskou výživu', 'Linseed oil and fractions thereof, whether or not refined, but not chemically mo'),
('15151990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce lněný,stálý,chem.neuprav.pro výrobu potravin pro lidskou výživu,ne:surový', 'Linseed oil and fractions thereof, whether or not refined, but not chemically mo'),
('15152110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce kukuřičný surový,stálý,k prům.účelům,ne:pro lidskou výživu', 'Crude maize oil, for technical or industrial uses (excl. for manufacture of food'),
('15152190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce kukuřičný surový,stálý,pro výrobu potravin pro lidskou výživu', 'Crude maize oil (excl. for technical or industrial uses)'),
('15152910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce kukuřičný,stálý,k prům.účelům,ne:surový,pro lidskou výživu', 'Maize oil and fractions thereof, whether or not refined, but not chemically modi'),
('15152990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce kukuřičný,stálý,pro výrobu potravin pro lidskou výživu,ne:surový', 'Maize oil and fractions thereof, whether or not refined, but not chemically modi'),
('15153010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce ricinový k výrobě aminoundekanové kyseliny', 'Castor oil and fractions thereof, whether or not refined, but not chemically mod'),
('15153090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce ricinový ostatní,ne:k výrobě aminoundekanové kyseliny', 'Castor oil and fractions thereof, whether or not refined, but not chemically mod'),
('15155011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce sezamový surový pro výrobu potravin pro lidskou výživu', 'Crude sesame oil, for technical or industrial uses (excl. for manufacture of foo'),
('15155019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce sezamový surový pro výrobu potravin pro lidskou výživu', 'Crude sesame oil (excl. for technical or industrial uses)'),
('15155091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce sezamový k průmyslovým účelům,ne:surový,pro lidskou výživu', 'Sesame oil and its fractions, whether or not refined, but not chemically modifie'),
('15155099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce sezamový pro výrobu potravin pro lidskou výživu,ne:surový', 'Sesame oil and its fractions, whether or not refined, but not chemically modifie'),
('15159011', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce tungový,jojobový,ojticikový,vosk myrtový,japonský,chem.neupr.', 'Tung, jojoba and oiticica oils, myrtle and Japan wax and their fractions, whethe'),
('15159021', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce z tabákových semen surový k prům.účelům,ne:pro lidskou výživu', 'Crude tobacco-seed oil, for technical or industrial uses (excl. for manufacture'),
('15159029', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce z tabákových semen surový pro výrobu potravin pro lidskou výživu', 'Crude tobacco-seed oil (excl. for technical or industrial uses)'),
('15159031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '0lej,frakce z tabákových semen k prům.účelům,ne:surový,pro lidskou výživu', 'Tobacco-seed oil and its fractions, whether or not refined, but not chemically m'),
('15159039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej,frakce z tabákových semen pro výrobu potravin pro lidskou výživu,ne:surový', 'Tobacco-seed oil and its fractions, whether or not refined, but not chemically m'),
('15159040', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuky,oleje,frakce rostlinné ost.surové k prům.účelům,ne:viz sazebník', 'Crude fixed vegetable fats and oils and their fractions, for technical or indust'),
('15159051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuky,oleje rostlinné ost.sur.stálé,bal.do 1kg,pro okamž.spotř.,ne:viz sazebník', 'Solid crude fixed vegetable fats and oils, in immediate packings of <= 1 kg (exc'),
('15159059', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuky,oleje,frakce rostlinné ostatní surové stálé,tekuté,ne:viz sazebník', 'Crude fixed vegetable fats and oils, in immediate packings of a content of > 1 k'),
('15159060', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuky,oleje rostlinné ostatní k průmyslovým účelům,ne:surové,viz sazebník', 'Vegetable fats and oils and their fractions, whether or not refined (excl. chemi'),
('15159091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuky,oleje rostlinné ostatní,stálé,bal.do 1kg,pro okamž.spotř.,ne:viz sazebník', 'Solid fixed vegetable fats and oils and their fractions, whether or not refined,'),
('15159099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuky,oleje,frakce rostlinné ostatní,stálé,tekuté,ne:surové,viz sazebník', 'Solid fixed vegetable fats and oils and their fractions, whether or not refined,'),
('15161010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Živočišné tuky a oleje a jejich frakce v balení pro okamž.spotř.do 1kg netto', 'Animal fats, oils and their fractions, partly or wholly hydrogenated, inter-este'),
('15161090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Živočišné tuky a oleje a jejich frakce ost.,ne:bal.pro okamž.spotř.do 1kg netto', 'Animal fats, oils and their fractions, partly or wholly hydrogenated, inter-este'),
('15162010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej ricinový hydrogenovaný zvaný opalwax (opálový vosk)', 'Hydrogenated castor oil, so called "opal wax"'),
('15162091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuky,oleje,frakce rostlinné,frakce hydrogenované apod.do 1kg pro okamž.spotřebu', 'Vegetable fats and oils and their fractions, partly or wholly hydrogenated, inte'),
('15162095', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje z řepky,lnu,slunečnice,viz sazebník pro prům.účely,ne:pro lidskou výživu', 'Rapeseed, colza, linseed, sunflower-seed, illipe, karite, makore, touloucouna or'),
('15162096', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje z podz.olejné,bavl.semen,viz sazebník,obsah do 50% mast.kys,ne:viz sazebník', 'Groundnut, cotton-seed, soya-bean or sunflower-seed oil and their fractions (exc'),
('15162098', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje,tuky,frakce ostatní,ne:viz sazebník', 'Vegetable fats and oils and their fractions, partly or wholly hydrogenated, inte'),
('15171010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Margarin,tuk z mléka nad 10%-15% hmotnosti,ne:tekutý', 'Margarine containing > 10% but <= 15% milkfats (excl. liquid)'),
('15171090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Margarin ostatní,ne:tekutý,tuk z mléka nad 10-15% hmotnosti', 'Margarine containing <= 10% milkfats (excl. liquid)'),
('15179010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,směsi pokrmových rostl.nebo živočiš.tuků,olejů,tuk nad 10-15% hmotnosti', 'Edible mixtures or preparations of animal or vegetable fats or oils or of fracti'),
('15179091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,směsi olejů rostl.pevné,tekuté jednoduše smíšené,ne:tuk nad 10-15% hmotnosti', 'Edible fixed vegetable oils, fluid, mixed, containing <= 10% milkfats (excl. oil'),
('15179093', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi jedlé,přípravky potravinářské užívané jako tvarovací', 'Edible mixtures or preparations for mould-release preparations, containing <= 10'),
('15179099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi,přípravky pokrmových rostlinných,živočiš.tuků,olejů ost.,ne:viz sazebník', 'Edible mixtures or preparations of animal or vegetable fats or oils and edible f'),
('15180010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Linoxyn', 'Linoxyn'),
('15180031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuky rostlinné ostatní,ne:surové,pevné,tekuté k prům.účelům', 'Crude fixed vegetable oils, fluid, mixed, inedible, n.e.s., for technical or ind'),
('15180039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuky rostlinné ostatní,ne:surové,pevné,tekuté k prům.účelům', 'Fixed vegetable oils, fluid, mixed, inedible, n.e.s., for technical or industria'),
('15180091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuk,olej,frakce živočišný,rostlinný chemicky upravené-podmínky viz sazebník', 'Animal or vegetable fats and oils and their fractions, boiled, oxidised, dehydra'),
('15180095', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi,přípravky živočišných,rostlinných tuků,olejů,frakcí nepoživatelné', 'Inedible mixtures or preparations "yellow grease" of animal or of animal and veg'),
('15180099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi,přípravky živočišných,rostlinných tuků,olejů,frakcí ostatní,ne:viz sazebník', 'Mixtures and preparations of animal or vegetable fats and oils and of fractions'),
('15200000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Glycerol surový,glycerolové vody,glycelorové louhy', 'Glycerol, crude; glycerol waters and glycerol lyes'),
('15211000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vosk rostlinný', 'Vegetable waxes, whether or not refined or coloured (excl. triglycerides)'),
('15219010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vorvanina (spermacet) i rafinovaná,barvená', 'Spermaceti, whether or not refined or coloured'),
('15219091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vosk včelí,jiný hmyzí surový', 'Beeswax and other insect waxes, crude'),
('15219099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vosk včelí,jiný hmyzí i rafinovaný,barvený,ne:surový', 'Beeswax and other insect waxes, whether or not refined or coloured (excl. crude)'),
('15220010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Degras', 'Degras'),
('15220031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mýdlové kaly (soap stocks) obsahující olej s vlastností olivového oleje', 'Soapstocks containing oil with characteristics of olive oil'),
('15220039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zbytky po zprac.tuků,vosků obsah.olej s vlastn.olivového oleje,ne:mýdlové kaly', 'Residues from treatment of fatty substances containing oil with characteristics'),
('15220091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Destil.zbytky,usazeniny po zprac.živočiš.roslin.tuku,vosku:ne:vlastn.oliv olej', 'Oil foots and dregs; soapstocks (excl. those containing oil with characteristics'),
('15220099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zbytky,usazeniny po zprac.živočiš.,rostlin.tuku,vosku ostatní,ne:viz sazebník', 'Residues from treatment of fatty substances or animal and vegetable waxes (excl.'),
('16010010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uzenky,salámy a podobné výrobky z jater', 'Liver sausages and similar products and food preparations based thereon'),
('16010091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uzenky,salámy a podobné výrobky suché,pomazánkové tepelně neupravené', 'Uncooked sausages of meat, offal or blood (excl. liver)'),
('16010099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uzenky,salámy a podobné výrobky z masa,drobů,krve ostatní,ne:z jater,tepelně neupravené', 'Sausages and similar products of meat, offal or blood and food preparations base'),
('16021000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky jiné,konzervy homogenizované z masa,drobů,krve,ne:salámy,uzenky apod.', 'Homogenised prepared meat, offal or blood, put up for retail sale as infant food'),
('16022010', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky jiné,konzervy z jater hus,kachen,ne:salámy,uzenky apod.', 'Preparations of goose or duck liver (excl. sausages and similar products and fin'),
('16022090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky jiné,konzervy z jater ost.,ne:z hus,kachen,salámy,uzenky apod.', 'Preparations of liver (excl. sausages and similar products, finely homogenised p'),
('16023111', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky jiné,konzervy výlučně z krůtího masa tepelně neupravené', 'Preparations containing exclusively uncooked turkey meat (excl. sausages and sim'),
('16023119', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky jiné,konzervy obsah 57% a více krůtí maso,droby', 'Meat or offal of turkeys "Gallus domesticus", prepared or preserved, containing'),
('16023130', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky jiné,konzervy obsah nad 25-pod 57% krůtí maso,droby', 'Meat or offal of turkeys "Gallus domesticus", prepared or preserved, containing'),
('16023190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky jiné,konzervy obsah do 25% krůtí maso,droby', 'Meat or offal of turkeys "Gallus domesticus", prepared or preserved (excl. conta'),
('16023211', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky jiné,konzervy obs.57% a více maso,droby kohout,slepice tepelně neupravené', 'Uncooked, prepared or preserved meat or meat offal of fowls of the species Gallu'),
('16023219', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky jiné,konzervy obs.57% a více maso,droby kohout,slepice tepelně upravené', 'Cooked, prepared or preserved meat or meat offal of fowls of the species Gallus'),
('16023230', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky jiné,konzervy obs.nad 25-57% maso,droby kohout,slepice', 'Prepared or preserved meat or meat offal of fowls of the species Gallus domestic'),
('16023290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky jiné,konzervy obs.do 25% maso,droby kohout,slepice', 'Prepared or preserved meat or meat offal of fowls of the species Gallus domestic'),
('16023921', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy obs.od 57% drůb.maso,droby tepel.neupr.,ne:krůta,kohout,slepice', 'Uncooked, prepared or preserved meat or meat offal of ducks, geese and guinea fo'),
('16023929', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy obs.od 57% drůb.maso,droby tepel.upr.,ne:krůta,kohout,slepice', 'Cooked, prepared or preserved meat or meat offal of ducks, geese and guinea fowl'),
('16023940', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy obs.nad 25-57% drůbeží maso,droby,ne:krůta,kohout,slepice', 'Prepared or preserved meat or meat offal of ducks, geese and guinea fowl of the'),
('16023980', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy obs.do 25% drůbeží maso,droby ost.,ne:krůta,kohout,slepice', 'Prepared or preserved meat or meat offal of ducks, geese and guinea fowl of the'),
('16024110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky jiné,konzervy z šunky a jejich částí z vepřů domácích', 'Hams and cuts thereof, of domestic swine, prepared or preserved'),
('16024190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky jiné,konzervy z šunky a jejich částí z vepřů ostatních,ne:domácích', 'Prepared or preserved hams and cuts thereof, of swine (excl. domestic)'),
('16024210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky jiné,konzervy z plece a jejich částí z vepřů domácích', 'Prepared or preserved shoulders and cuts thereof, of domestic swine'),
('16024290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky jiné,konzervy z plece a jejich částí z vepřů ostatních,ne:domácích', 'Prepared or preserved shoulders and cuts thereof, of swine (excl. domestic)'),
('16024911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky jiné,konzervy obs.od 80% hřbety,šunky z vepřů domácích,ne:krkovička', 'Prepared or preserved domestic swine loins and parts thereof, incl. mixtures of'),
('16024913', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky jiné,konzervy obs.od 80% krkovička,plec z vepřů domácích', 'Prepared or preserved domestic swine collars and parts thereof, incl. mixtures o'),
('16024915', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy obs.od 80% směs hřbet,šunka,krkovička,plec z vepřů domácích', 'Prepared or preserved mixtures of domestic swine hams, shoulders, loins, collars'),
('16024919', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy obs.od 80% masa,drobů z vepřů domácích,ne:viz sazebník', 'Meat or offal, incl. mixtures, of domestic swine, prepared or preserved, contain'),
('16024930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy obs.nad 40-80% masa,drobů vč.sádla,tuků z vepřů domácích', 'Prepared or preserved meat, offal and mixtures, of domestic swine, containing >='),
('16024950', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy obs.do 40% maso,droby vč.sádla,tuků z vepřů domácích', 'Prepared or preserved meat, offal and mixtures of domestic swine containing < 40'),
('16024990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy ostatní z masa,drobů,tuků z vepřů ostatních,ne:domácích', 'Prepared or preserved meat, offal and mixtures of swine (excl. domestic, hams, s'),
('16025010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy z hovězího masa tepel.neupr.,směsi masa,drobů tepel.neupr.s upr.', 'Prepared or preserved meat or offal of bovine animals, uncooked, incl. mixtures'),
('16025031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Konzervy z hovězího masa tepel.upr.,v hermet.uzavřených obalech', 'Corned beef, in airtight containers'),
('16025095', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy z hovězího masa tepel.upr.,ostatní,ne:hermet.uzavřené,ve směsi s tepel.neupr.', 'Meat or offal of bovine animals, prepared or preserved, cooked (excl. corned bee'),
('16029010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy z krve všech zvířat', 'Preparations of blood of any animal (excl. sausages and similar products)'),
('16029031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy ze zvěřiny,králíků', 'Prepared or preserved meat or meat offal of game or rabbits (excl. of wild pigs,'),
('16029051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy ostatní obsahující maso,droby vepřů domácích,ne:viz sazebník', 'Prepared or preserved meat or meat offal containing meat or offal of domestic sw'),
('16029061', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy ost.obsahující hovězí maso,droby tepel.neupr.,směsi masa,drobů i tepel.upravených', 'Prepared or preserved meat or meat offal, uncooked, containing meat or offal of'),
('16029069', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy ostatní obsahující hovězí maso,droby,ne:viz sazebník', 'Prepared or preserved meat or meat offal, cooked, containing meat or offal of bo'),
('16029072', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy z masa ovcí tepel.neupr.,směsi masa a drobů tepelně neupravených', 'Prepared or preserved meat or offal of sheep, uncooked, incl. mixtures of cooked'),
('16029074', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy z masa koz tepel.neupr.,směsi masa a drobů tepelně neupravených.', 'Prepared or preserved meat or offal of goats, uncooked, incl. mixtures of cooked'),
('16029076', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy z masa a drobů ovcí ostatní,ne:viz sazebník', 'Prepared or preserved meat or offal of sheep, cooked (excl. sausages and similar'),
('16029078', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy z masa a drobů koz ostatní,ne:viz sazebník', 'Prepared or preserved meat or offal of goats, cooked (excl. sausages and similar'),
('16029099', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy ostatní z masa,drobů,ne:z krve,vepřové,hov.,zvěřina,ovce,kozy', 'Prepared or preserved meat or meat offal (excl. of poultry, swine, bovine animal'),
('16030010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výtažky,šťávy z masa,ryb,korýšů,ost.bezobratlých bal.do 1 kg pro okamž.spotřebu', 'Extracts and juices of meat, fish, crustaceans, molluscs and other aquatic inver'),
('16030080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výtažky,šťávy z masa,ryb,korýšů,bezobratlých ost.ne:bal.do 1 kg pro okamž.spotřebu', 'Extracts and juices of meat, fish, crustaceans, molluscs and other aquatic inver'),
('16041100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Konzervy,přípravky z lososů celých i části,ne:na drobno rozřezané', 'Prepared or preserved salmon, whole or in pieces (excl. minced)'),
('16041210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filé ze sledě syrové obalené i předsmažené zmrazené', 'Fillets of herring, raw, merely coated with butter or breadcrumbs, whether or no'),
('16041291', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sledi celí i části v hermeticky uzavřených obalech,ne:filé obalené i předsmažené', 'Herrings, prepared or preserved, whole or in pieces, in airtight containers (exc'),
('16041299', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sledi celí i části ost.-přípravky,ne:hermeticky uzavřené,filé obalené i předsmažené', 'Herrings, prepared or preserved, whole or in pieces (excl. minced herrings and h'),
('16041311', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy z celých sardinek i částí v olivovém oleji', 'Sardines, prepared or preserved, whole or in pieces, in olive oil (excl. minced'),
('16041319', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy z celých sardinek i částí ostatní,ne:v olivovém oleji', 'Sardines, prepared or preserved, whole or in pieces (excl. minced sardines and s'),
('16041390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy z celých šprotů i částí', 'Prepared or preserved sardinella, brisling or sprats, whole or in pieces (excl.'),
('16041411', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky, konzervy z tuňáka,skipjacka v rostlinném oleji', 'Prepared or preserved tunas and skipjack, whole or in pieces, in vegetable oil ('),
('16041416', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy-hřbety z tuňáků,skipjack,ne:v rostlinném oleji', 'Fillets known as "loins" of tunas or skipjack, prepared or preserved (excl. such'),
('16041418', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy z tuňáků,skipjack ostatní,ne:v rostlinném oleji,hřbety', 'Prepared or preserved tunas and skipjack (excl. minced, fillets known as "loins"'),
('16041490', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy z bonito (Sarda) celých i částí', 'Prepared or preserved bonito "sarda spp.", whole or in pieces (excl. minced)'),
('16041511', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy-filé z makrel (Scomber scombrus,japonicus)', 'Fillets of mackerel of the species Scomber scombrus and Scomber japonicus, prepa'),
('16041519', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy ostatní z makrel (Scomber scombrus,japonicus),ne:filé', 'Mackerel of the species Scomber scombrus and Scomber japonicus, prepared or pres'),
('16041590', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy z makrel Scomber australasicus celých i částí', 'Prepared or preserved mackerel of species Scomber australasicus, whole or in pie'),
('16041600', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Konzervy,přípravky ze sardelí (ančoviček) celých i částí', 'Prepared or preserved anchovies, whole or in pieces (excl. minced)'),
('16041910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy z lososovitých ryb celých i částí,ne:lososů', 'Prepared or preserved salmonidae, whole or in pieces (excl. salmon and minced)'),
('16041931', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy-hřbety z ryb rodu Euthynus,ne:skipjack', 'Fillets known as "loins" of fish of the genus "Euthynnus" prepared or preserved'),
('16041939', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy ostatní z ryb rodu Euthynus,ne:skipjack,hřbet', 'Prepared or preserved fish of the genus "Euthynnus", whole or in pieces (excl. m'),
('16041950', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy z ryb druhu Orcynopsis unicolor celých i částí', 'Prepared or preserved fish of species Orcynopsis unicolor, whole or in pieces (e'),
('16041991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'File syrové obalené i předsmažené zmrazené,ne:sleď,makrely', 'Frozen raw fish fillets, coated with batter or breadcrumbs, whether or not pre-f'),
('16041992', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy z tresek (Gadus morhua,ogac,macrocephalus) celých i částí', 'Cod of the species Gadus morhua, Gadus ogac, Gadus macrocephalus, prepared or pr'),
('16041993', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy z tresky černé (Pollachius virens) celé i částí', 'Coalfish "Pollachius virens", prepared or preserved, whole or in pieces (excl. f'),
('16041994', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy ze štikozubců (Merluccius,Urophycis) celých i částí', 'Hake "Merluccius spp., Urophycis spp.", prepared or preserved, whole or in piece'),
('16041995', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy z tresky aljašské (Theragra chalcogramma),evropské (Pollachius)', 'Alaska pollack "Theragra chalcogramma" and pollack "Pollachius pollachius", prep'),
('16041998', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy z tresek ostatních,ne:filé obalené,druhy viz sazebník', 'Fish, prepared or preserved, whole or in pieces (excl. finely minced, fillets, r'),
('16042005', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky ze surimi', 'Preparations of surimi'),
('16042010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy z lososů', 'Prepared or preserved salmon (excl. whole or in pieces)'),
('16042030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy ryb lososovitých nadrobno rozřezaných,ne:lososů,celých,částí', 'Prepared or preserved salmonidae (excl. salmon and whole or in pieces)'),
('16042040', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy z ančoviček,ne:celých,částí', 'Prepared or preserved anchovies (excl. whole or in pieces)'),
('16042050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy ze sardinek,bonit,makrel,druhu Ocynopsis unicolor,ne:celých,částí', 'Prepared or preserved sardines, bonito, mackerel of species Scomber scombrus and'),
('16042070', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy z tuňáků,skipjacků,rodu Euthynnus,ne:celých,částí', 'Prepared or preserved tunas, skipjack or other fish of genus Euthynnus (excl. wh'),
('16042090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,konzervy z ryb ostaních,ne:celých,částí,druhy viz sazebník', 'Fish, prepared or preserved (excl. fish whole or in pieces, preparations of suri'),
('16043010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kaviár (jikry jesetera)', 'Caviar'),
('16043090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kaviárové náhražky', 'Caviar substitutes prepared from fish eggs'),
('16051000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krabi upravení,v konzervách', 'Crab, prepared or preserved'),
('16052010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krevety upravené,v obalech hermeticky uzavřených', 'Shrimps and prawns, prepared or preserved, in airtight containers'),
('16052091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krevety upravené balení do 2 kg pro okamž.spotřebu,ne:obaly hermeticky uzavřené', 'Shrimps and prawns, prepared or preserved, in immediate packings of a net conten'),
('16052099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krevety upravené balení nad 2 kg pro okamž.spotř.,ne:obaly hermeticky uzavřené', 'Shrimps and prawns, prepared or preserved, in immediate packings of a net conten'),
('16053010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Humří maso,vařené,pro výr.humřího másla,past,paštik,polévek,omáček', 'Lobster meat, cooked, for the manufacture of lobster butter or of lobster pastes'),
('16053090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Humři ost.,ne:humří maso,vařené,pro výr.humřího másla,past,paštik,polévek,omáček', 'Lobster, prepared or preserved (excl. lobster meat, cooked, for the manufacture'),
('16054000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Korýši ostatní upravení,v konzervách,ne:krab,kreveta,humr', 'Crustaceans, prepared or preserved (excl. crabs, shrimps, prawns and lobster)'),
('16059011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slávky (Mytilus,Perna) upravené v hermeticky uzavřených obalech', 'Mussels of the species Mytilus and of the species Perna, prepared or preserved,'),
('16059019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slávky (Mytilus,Perna) upravené ostatní,ne:v hermeticky uzavřených obalech', 'Mussels of the species Mytilus and of the species Perna, prepared or preserved ('),
('16059030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Měkkýši upravení,v konzervách ostatní,ne:slávky (Mitilus,Perna)', 'Mussels, snails and other molluscs, prepared or preserved (excl. mussels of the'),
('16059090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bezobratlovci vodní ostatní upravení,v konzervách,ne:viz sazebník', 'Sea urchins, sea cucumbers, jellyfish and other aquatic invertebrates, prepared'),
('17011110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cukr třtinový surový pevný bez přísad,barviv k rafinaci', 'Raw cane sugar, for refining (excl. added flavouring or colouring)'),
('17011190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cukr třtinový surový pevný bez přísad,barviv ostatní,ne:k rafinaci', 'Raw cane sugar (excl. for refining and added flavouring or colouring)'),
('17011210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cukr řepný surový pevný bez přísad,barviv k rafinaci', 'Raw beet sugar, for refining (excl. added flavouring or colouring)'),
('17011290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cukr řepný surový pevný bez přísad,barviv ostatní,ne:k rafinaci', 'Raw beet sugar (excl. for refining and added flavouring or colouring)'),
('17019100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cukr třtinový,řepný,čistá sacharóza s přísadou aromatických přípravků,barviva', 'Refined cane or beet sugar, containing added flavouring or colouring, in solid f'),
('17019910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cukr rafinovaný (bílý)', 'White sugar, containing in dry state>= 99,5% sucrose (excl. flavoured or coloure'),
('17019990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cukr třtinový,řepný,sacharóza ostatní,ne:cukr rafinovaný,s přísadou', 'Cane or beet sugar and chemically pure sucrose, in solid form (excl. cane and be'),
('17021100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Laktóza,sirup laktózový obsahující 99% a více laktozy (v sušině)', 'Lactose in solid form and lactose syrup, not containing added flavouring or colo'),
('17021900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Laktóza,sirup laktózový obsahující méně než 99% laktozy (v sušině)', 'Lactose in solid form and lactose syrup, not containing added flavouring or colo'),
('17022010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cukr javorový pevný s přísadou aromatických přípravků,barviva', 'Maple sugar, in solid form, flavoured or coloured'),
('17022090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cukr,sirup javorový ostatní,ne:cukr pevný s přísadou aromat.přípravků,barviva', 'Maple sugar, in solid form, and maple syrup (excl. flavoured or coloured)'),
('17023010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Isoglukoza obsah fruktózy 0%-20%', 'Isoglucose in the solid form, not containing fructose or containing in the dry s'),
('17023050', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Glukóza,sirup glukózový,obsah fruktózy do 20%,prášek bílý krystalický,ne:isoglukóza', 'Glucose "dextrose" in the form of white crystalline powder, whether or not agglo'),
('17023090', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Glukóza,sirup glukózový,obsah fruktózy do 20%,ne:prášek bílý krystalický,isoglukóza', 'Glucose in solid form and glucose syrup, not containing added flavouring or colo'),
('17024010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Isoglukóza obsah fruktózy nad 20 - 50%', 'Isoglucose in solid form, containing in the dry state >= 20% and < 50% by weight'),
('17024090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Glukóza,sirup glukózový ostatní,obsah fruktózy nad 20 - 50%,ne:isoglukóza', 'Glucose in solid form and glucose syrup, not containing added flavouring or colo'),
('17025000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fruktóza chemicky čistá pevná', 'Chemically pure fructose in solid form'),
('17026010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Isoglukóza obsah fruktózy nad 50% (v sušině)', 'Isoglucose in solid form, containing in the dry state > 50% by weight of fructos'),
('17026080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Inulinový sirup', 'Inulin syrup obtained directly by hydrolysis of inulin or oligofructoses, contai'),
('17026095', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fruktóza a fruktózový sirup ostatní,v sušině nad 50% hmotn.fruktózy,ne:viz sazebník', 'Fructose in solid form and fructose syrup not containing added flavouring or col'),
('17029010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maltóza chemicky čistá', 'Chemically pure maltose, in solid form'),
('17029030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Isoglukóza ostatní,ne:obsahující fruktózu', 'Isoglucose in solid form, containing in the dry state 50% by weight of fructose,'),
('17029050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maltodextrin,sirup maltodextrinový', 'Maltodextrine in solid form and maltodextrine syrup (excl. flavoured or coloured'),
('17029071', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Karamel obsah sacharózy nad 50% (v sušině)', 'Sugar and molasses, caramelised, containing in the dry state >= 50% by weight of'),
('17029075', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Karamel v prášku i aglomerovaný,ne:obsah sacharózy nad 50%', 'Sugar and molasses, caramelised, containing in the dry state < 50% by weight of'),
('17029079', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Karamel ostatní,ne:obsah sacharózy nad 50%,prášek', 'Sugar and molasses, caramelised, containing in the dry state < 50% by weight of'),
('17029080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Inulinový sirup', 'Inulin syrup, obtained directly by hydrolysis of inulin or oligofructoses, conta'),
('17029095', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cukry ost.vč.invertního,ne:javorový,inulínový,laktóza,glukóza,fruktóza,karamel', 'Sugars in solid form, incl. invert sugar, and sugar and sugar syrup blends conta'),
('17031000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Melasa třtinová po extrakci,rafinaci cukru', 'Cane molasses resulting from the extraction or refining of sugar'),
('17039000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Melasa ostatní po extrakci,rafinaci cukru,ne:třtinová', 'Beet molasses resulting from the extraction or refining of sugar'),
('17041010', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Guma žvýkací i obalená cukrem,obsah sacharózy < 60%', 'Chewing gum, whether or not sugar-coated, containing < 60% sucrose, incl. invert'),
('17041090', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Guma žvýkací i obalená cukrem,obsah sacharózy >= 60%', 'Chewing gum, whether or not sugar-coated, containing >= 60% sucrose, incl. inver'),
('17049010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výtažky z lékořice bez přísad,obsah sacharózy nad 10%', 'Liquorice extract containing > 10% sucrose, without other added substances'),
('17049030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Čokoláda bílá', 'White chocolate'),
('17049051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Těsta,pasty vč.marcipánu balení do 1 kg pro okamž.spotřebu,ne:obsahující kakao', 'Pastes, incl. marzipan, in immediate packings of >= 1 kg'),
('17049055', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pastilky,dropsy zdravotní proti kašli', 'Throat pastilles and cough drops'),
('17049061', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dražé a podobné cukrovinky ve formě dražé,ne:obsahující kakao', 'Sugar-coated "panned" goods, not containing cocoa'),
('17049065', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Želé,gumovité cukrovinky typu želé vč.ovocných součástí', 'Gum and jelly confectionery, incl. fruit pastes in the form of sugar confectione'),
('17049071', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tvrdé bonbony, též plněné', 'Boiled sweets, whether or not filled'),
('17049075', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Karamely a podobné cukrovinky,ne:obsahující kakao', 'Toffees, caramels and similar sweets'),
('17049081', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cukrovinky bez kakaa ostatní vyrobené kompresí,ne:viz sazebník', 'Compressed tablets of sugar confectionery, whether or not manufactured with bind'),
('17049099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cukrovinky bez kakaa ostatní,ne:vyrobené kompresí,druhy viz sazebník', 'Pastes, marzipan, nougat and other prepared sugar confectionery, not containing'),
('18010000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kakaové boby i ve zlomcích surové,pražené', 'Cocoa beans, whole or broken, raw or roasted'),
('18020000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kakaové skořápky,slupky,ostatní odpady', 'Cocoa shells, husks, skins and other cocoa waste'),
('18031000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kakaová hmota neodtučněná', 'Cocoa paste (excl. defatted)'),
('18032000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kakaová hmota odtučněná zcela,zčásti', 'Cocoa paste, wholly or partly defatted'),
('18040000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kakaové máslo,tuk,olej', 'Cocoa butter, fat and oil'),
('18050000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kakaový prášek bez přísady cukru a jiných sladidel', 'Cocoa powder, not containing added sugar or other sweetening matter'),
('18061015', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kakaový prášek slazený obsah sacharózy 0-pod 5%', 'Cocoa powder, containing added sugar or other sweetening matter but containing n'),
('18061020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kakaový prášek slazený obsah sacharózy 5-pod 65%', 'Cocoa powder, containing added sugar or other sweetening matter, containing >= 5'),
('18061030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kakaový prášek slazený obsah sacharózy 65-pod 80%', 'Sweetened cocoa powder, containing >= 65% but < 80% sucrose, incl. inverted suga'),
('18061090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kakaový prášek slazený obsah sacharózy 80% a více', 'Sweetened cocoa powder, containing >= 80% sucrose, incl. inverted sugar expresse'),
('18062010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky s kakaem balení nad 2 kg obsah 31% a více máslo kakaové i s mléčným tukem', 'Chocolate and other food preparations containing cocoa, in blocks, slabs or bars'),
('18062030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky s kakaem balení nad 2kg obsah 25-31% máslo kakaové i s mléčným tukem', 'Chocolate and other food preparations containing cocoa, in blocks, slabs or bars'),
('18062050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky s kakaem ost.bal.nad 2kg,obsah máslo kakaové 18% a více,ne:viz sazebník', 'Chocolate and other food preparations containing cocoa, in blocks, slabs or bars'),
('18062070', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky s kakaem zvané čokoládové mléčné drobky,balení nad 2 kg', 'Chocolate milk crumb preparations in containers or immediate packings of a conte'),
('18062080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Čokoládové polevy balení nad 2 kg', 'Chocolate flavour coating in containers or immediate packings of a content > 2 k'),
('18062095', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky s kakaem ostatní balení nad 2 kg,ne:viz sazebník', 'Chocolate and other food preparations containing cocoa, in blocks, slabs or bars'),
('18063100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Čokoláda plněná v blocích,tyčinkách,tabulkách', 'Chocolate and other preparations containing cocoa, in blocks, slabs or bars of <'),
('18063210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Čokoláda neplněná v blocích,tabulkách,tyčinkách s přídavkem obilí,ořechů,ovoce', 'Chocolate and other preparations containing cocoa, in blocks, slabs or bars of <'),
('18063290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Čokoláda neplněná ost.v blocích,tabulkách,tyčinkách,ne:s obilím,ořechy,ovocem', 'Chocolate and other preparations containing cocoa, in blocks, slabs or bars of <'),
('18069011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Čokoládové cukrovinky i plněné s alkoholem', 'Chocolate and chocolate products in the form of chocolates, whether or not fille'),
('18069019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Čokoládové cukrovinky i plněné ostatní,ne:s alkoholem', 'Chocolate and chocolate products in the form of chocolates, whether or not fille'),
('18069031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Čokoláda,výrobky čokoládové ostatní plněné,ne:cukrovinky', 'Chocolate and chocolate products, filled (excl. in blocks, slabs or bars and cho'),
('18069039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Čokoláda,výrobky čokoládové ostatní neplněné,ne:cukrovinky', 'Chocolates and chocolate products, unfilled (excl. in blocks, slabs or bars, cho'),
('18069050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cukrovinky a náhražky vyrobené z náhražek cukru s kakaem', 'Sugar confectionery and substitutes therefor made from sugar substitution produc'),
('18069060', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pasty (pomazánky) s kakaem', 'Spreads containing cocoa'),
('18069070', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky k výrobě nápojů s kakaem', 'Preparations containing cocoa, for making beverages'),
('18069090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Potravinové přípravky ostatní obsahující kakao,ne:viz sazebník', 'Preparations containing cocoa, in containers or immediate packings of <= 2 kg (e'),
('19011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky z mouky,krupice apod.pro dětskou výživu,balení pro drobný prodej', 'Food preparations for infant use, put up for retail sale, of flour, groats, meal'),
('19012000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi,těsta pro přípravu zboží pekařského,pečiva jemného i trvanlivého č.1905', 'Mixes and doughs of flour, groats, meal, starch or malt extract, not containing'),
('19019011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výtažek sladový obsah 90% a více suchého výtažku', 'Malt extract with a dry extract content of >= 90%'),
('19019019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výtažek sladový obsah pod 90% suchého výtažku', 'Malt extract with a dry extract content of < 90%'),
('19019091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky z mouky apod.obsah do 1,5%.mléč.tuky,do 5% sacharozy,glukózy,škrobu', 'Food preparations of flour, groats, meal, starch or malt extract, containing no'),
('19019099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípr.potravin z mouky,krupice apod. ostatní,ne:viz sazebník', 'Food preparations of flour, groats, meal, starch or malt extract, not containing'),
('19021100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Těstoviny nevařené,nenadívané,jinak nepřipravené obsahující vejce', 'Uncooked pasta, not stuffed or otherwise prepared, containing eggs'),
('19021910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Těstoviny nevařené,nenadívané,jinak nepřipravené,ne:s vejci,pšenič.moukou,krupičkou', 'Uncooked pasta, not stuffed or otherwise prepared, not containing common wheat f'),
('19021990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Těstoviny,nevařené,nenadívané,nepřipravené s pšenič.moukou,krupičkou,ne:s vejci', 'Uncooked pasta, not stuffed or otherwise prepared, containing common wheat flour'),
('19022010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Těstoviny nadívané i vařené,připravené,obsah.nad 20% ryby,korýše,měkkýše,bezobratlé', 'Pasta, stuffed with meat or other substances, whether or not cooked or otherwise'),
('19022030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Těstoviny nadívané i vařené,připravené,obsah.nad 20% uzenář.výrobky vč.tuků', 'Pasta, stuffed with meat or other substances, whether or not cooked or otherwise'),
('19022091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Těstoviny nadívané vařené ostatní,ne:viz sazebník', 'Cooked pasta, stuffed with meat or other substances (excl. containing > 20% by w'),
('19022099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Těstoviny nadívané,připravené ost.,ne:vařené,obsah.nad 20% ryby,korýše apod.,uz.výrobky', 'Pasta, otherwise prepared, stuffed with meat or other substances (excl. cooked,'),
('19023010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Těstoviny ostatní sušené,ne:viz sazebník', 'Dried, prepared pasta (excl. stuffed)'),
('19023090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Těstoviny ostatní,ne:viz sazebník', 'Pasta, cooked or otherwise prepared (excl. stuffed or dried pasta)'),
('19024010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kuskus nepřipravený', 'Couscous unprepared'),
('19024090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kuskus připravený', 'Couscous, cooked or otherwise prepared'),
('19030000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tapioka a náhražky ze škrobů ve tvaru vloček,zrn,perel,prachu apod.', 'Tapioca and substitutes therefor prepared from starch, in the form of flakes, gr'),
('19041010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z kukuřice získané bobtnáním,pražením', 'Prepared foods obtained by swelling or roasting cereals or cereal products based'),
('19041030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z rýže získané bobtnáním,pražením', 'Prepared foods obtained by swelling or roasting cereals or cereal products based'),
('19041090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z obilí ostatního, získané bobtnáním,pražením,ne:z kukuřice,rýže', 'Prepared foods obtained by swelling or roasting cereals or cereal products (excl'),
('19042010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky typu Musli z nepražených obilných vloček', 'Preparations of the MĂĽsli type based on unroasted cereal flakes'),
('19042091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky získané z nepražené kukuřice,směsi praž.a nepraž.vloček,bobtnáním', 'Prepared foods obtained from unroasted cereal flakes or from mixtures of unroast'),
('19042095', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky získané z nepražené rýže,směsi praž.a nepraž.vloček,bobtnáním', 'Prepared foods obtained from unroasted cereal flakes or from mixtures of unroast'),
('19042099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky z obilí ost.získané z vloček,bobtnáním apod.,ne:z kukuřice,rýže', 'Prepared foods obtained from unroasted cereal flakes or from mixtures of unroast'),
('19043000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pšenice bulgur', 'Bulgur wheat in the form of worked grains, obtained by cooking hard wheat grains'),
('19049010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rýže v zrnech ostatní předvařená,jinak upravená', 'Rice, pre-cooked or otherwise prepared, n.e.s. (excl. flour, groats and meal, fo'),
('19049080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Obilí ostatní v zrnech předvařené, jinak upravené,ne:rýže', 'Cereals in grain or flake form or other worked grains, pre-cooked or otherwise p'),
('19051000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chléb křupavý zvaný knackebrot', 'Crispbread'),
('19052010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Perník obsah sacharózy méně než 30%', 'Gingerbread and the like, whether or not containing cocoa, containing < 30% sucr'),
('19052030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Perník obsah sacharózy 30% do méně něž 50%', 'Gingerbread and the like, whether or not containing cocoa, containing >= 30% but'),
('19052090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Perník obsah sacharózy 50% a více', 'Gingerbread and the like, whether or not containing cocoa, containing >= 50% suc'),
('19053111', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sušenky sladké,oplatky polévané čokoládou,bal.do 85g pro okamž.spotřebu', 'Sweet biscuits, whether or not containing cocoa, coated or covered with chocolat'),
('19053119', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sušenky sladké,oplatky polévané čokoládou i část.bal.nad 85g pro okamž.spotřebu', 'Sweet biscuits, whether or not containing cocoa, coated or covered with chocolat'),
('19053130', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sušenky sladké,mléčný tuk 8% a více,ne:polévané i částečně čokoládou', 'Sweet biscuits, whether or not containing cocoa, containing >= 8% milkfats (excl'),
('19053191', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sušenky sladké dvojité (slepované) plněné,ne:polévané čokoládou,mléčný tuk nad 8%', 'Sweet sandwich biscuits, whether or not containing cocoa, containing < 8% milkfa'),
('19053199', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sušenky sladké ostatní,ne:polévané čokoládou,mléčný tuk nad 8%,slepované', 'Sweet biscuits, whether or not containing cocoa, containing < 8% milkfats (excl.'),
('19053205', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oplatky a malé oplatky s obsahem vody nad 10% hmotnostních', 'Waffles and wafers of a water content, by weight, of > 10%'),
('19053211', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oplatky,i malé oplatky polévané čokoládou,balení do 85g pro okamž.spotřebu', 'Waffles and wafers, whether or not containing cocoa, coated or covered with choc'),
('19053219', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oplatky,i malé oplatky polévané čokoládou ost.,ne:bal.do 85g pro okamž.spotřebu', 'Waffles and wafers, whether or not containing cocoa, coated or covered with choc'),
('19053291', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oplatky,i malé oplatky slané,i plněné', 'Waffles and wafers, salted, whether or not filled (excl. of a water content, by'),
('19053299', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oplatky,i malé oplatky ostaní,ne:viz sazebník', 'Waffles and wafers, whether or not containing cocoa, whether or not filled (excl'),
('19054010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Suchary', 'Rusks'),
('19054090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Opékaný chléb a podobné opékané výrobky', 'Toasted bread and similar toasted products (excl. rusks)'),
('19059010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chléb nekvašený (macesy)', 'Matzos'),
('19059020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hostie,prázdné oplatky pro farmaceut.účely,rýžový papír a podobné výrobky', 'Communion wafers, empty cachets for pharmaceutical use, sealing wafers, rice pap'),
('19059030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chléb obsah cukru,tuků do 5%, bez medu,vajec,sýra,ovoce', 'Bread, not containing added honey, eggs, cheese or fruit, whether or not contain'),
('19059045', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sušenky nesladké i s malým obsahem cukru,tuku', 'Biscuits (excl. sweet biscuits)'),
('19059055', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pekařské výrobky vytlačené,pěnové,aromatizované,solené', 'Extruded or expanded products, savoury or salted (excl. crispbread, rusks, toast'),
('19059060', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky pekařské,pečivo ostatní slazené,ne:viz sazebník', 'Fruit tarts, currant bread, panettone, meringues, Christmas stollen, croissants'),
('19059090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky pekařské,pečivo ostatní neslazené,ne:viz sazebník', 'Pizzas, quiches and other unsweetened bakers'' wares (excl. crispbread, gingerbr'),
('20011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KNE'), 'Okurky,okurčičky,nakládačky konzervované v octě,kyselině octové', 'Cucumbers and gherkins, prepared or preserved by vinegar or acetic acid'),
('20019010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chutney z manga konzervované v octě,kyselině octové', 'Mango chutney, prepared or preserved by vinegar or acetic acid'),
('20019020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plody Capsicum konzervované v octě,kyselině octové,ne:sladké lusky', 'Fruit of genus capsicum, prepared or preserved by vinegar or acetic acid (excl.'),
('20019030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kukuřice sladká konzervovaná v octě,kyselině octové', 'Sweetcorn "Zea Mays var. Saccharata", prepared or preserved by vinegar or acetic'),
('20019040', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hlízy smldince (jam),brambory sladké apod. konzervované v octě,kyselině octové', 'Yams, sweet potatoes and similar parts of plants containing >= 5% starch, prepar'),
('20019050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Houby konzervované v octě,kyselině octové', 'Mushrooms, prepared or preserved by vinegar or acetic acid'),
('20019060', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jádra palmová konzervovaná v octě,kyselině octové', 'Palm hearts, prepared or preserved by vinegar or acetic acid'),
('20019065', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olivy připravené,konzervované v octě,kyselině octové', 'Olives, prepared or preserved by vinegar or acetic acid'),
('20019070', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sladké papriky připravené,konzervované v octě,kyselině octové', 'Sweet peppers, prepared or preserved by vinegar or acetic acid'),
('20019091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tropické ovoce,tropické ořechy připravené,konzervované v octě,kyselině octové', 'Guavas, mangoes, mangosteens, papaws "papayas", tamarinds, cashew apples, lychee'),
('20019097', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní zelenina, ovoce a ořechy konzervované v octě,kyselině octové', 'Vegetables, fruit, nuts and other edible parts of plants, prepared or preserved'),
('20021010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rajčata celá,krájená loupaná konzervovaná,ne:v octě,kyselině octové', 'Peeled tomatoes, whole or in pieces, prepared or preserved otherwise than by vin'),
('20021090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rajčata celá,krájená neloupaná konzervovaná,ne:v octě,kyselině octové', 'Unpeeled tomatoes, whole or in pieces, prepared or preserved otherwise than by v'),
('20029011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rajčata ost.,konzervovaná,sušina pod 12%,bal.nad 1 kg,ne:v octě,celá,krájená', 'Tomatoes, prepared or preserved otherwise than by vinegar or acetic acid, with d'),
('20029019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rajčata ost.,konzervovaná,sušina pod 12%,bal.do 1 kg,ne:v octě,celá,krájená', 'Tomatoes, prepared or preserved otherwise than by vinegar or acetic acid, with d'),
('20029031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rajčata ost.,konzervovaná,sušina 12-30%,bal.nad 1 kg,ne:v octě,celá,krájená', 'Tomatoes, prepared or preserved otherwise than by vinegar or acetic acid, with d'),
('20029039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rajčata ost.,konzervovaná,sušina 12-30%,bal.do 1 kg,ne:v octě,celá,krájená', 'Tomatoes, prepared or preserved otherwise than by vinegar or acetic acid, with d'),
('20029091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rajčata ost.,konzervovaná,sušina nad 30%,balení nad 1kg,ne:v octě,celá,krájená', 'Tomatoes, prepared or preserved otherwise than by vinegar or acetic acid, with d'),
('20029099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rajčata ost.,konzervovaná,sušina nad 30%,balení do 1 kg,ne:v octě,celá,krájená', 'Tomatoes, prepared or preserved otherwise than by vinegar or acetic acid, with d'),
('20031020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KNE'), 'Houby druhu Agaricus prozatímně konzervované uvařené,ne:v octě,kyselině octové', 'Mushrooms of the genus Agaricus, provisionally preserved otherwise than by vineg'),
('20031030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KNE'), 'Houby druhu Agaricus prozatímněkonzervované,ne:zcela uvařené,v octě,kys.octové', 'Mushrooms of the genus Agaricus, prepared or preserved otherwise than by vinegar'),
('20032000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lanýže konzervované,ne:v octě,kyselině octové', 'Truffles, prepared or preserved otherwise than by vinegar or acetic acid'),
('20039000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Houby ostatní konzervované,ne:druh Agaricus,v octě,kyselině octové', 'Mushrooms, prepared or preserved otherwise than by vinegar or acetic acid (excl.'),
('20041010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brambory vařené,jinak neupravené zmrazené', 'Cooked potatoes, frozen'),
('20041091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brambory ve formě mouky,krupice,vloček zmrazené,ne:vařené', 'Potatoes, prepared or preserved in the form of flour, meal or flakes, frozen'),
('20041099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brambory ostatní konzervované,zmrazené,ne:vařené,forma mouky apod.,v octě', 'Potatoes, prepared or preserved otherwise than by vinegar or acetic acid, frozen'),
('20049010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kukuřice sladká připravená,konzervovaná,zmrazená,ne:v octě,kyselině octové', 'Sweetcorn "Zea Mays var. Zaccharata", prepared or preserved otherwise than by vi'),
('20049030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zelí kyselé,kapary,olivy připravené,konzervované,zmrazené,ne:v octě,kys.octové', 'Sauerkraut, capers and olives, prepared or preserved otherwise than by vinegar o'),
('20049050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hrách,zelené fazole v lusku připrav.konzervovaný,zmrazený,ne:v octě,kys.octové', 'Peas "Pisum sativum" and immature beans "Phaseolus spp.", prepared or preserved'),
('20049091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zelenina a směsi ostatní konzervované ne v octě zmrazené', 'Frozen cooked onions'),
('20049098', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zelenina a směsi ost.připravená,konzervovaná,zmrazená,ne:v octě,kys.octové', 'Vegetables and mixtures of vegetables, prepared or preserved otherwise than by v'),
('20051000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zelenina homogenizovaná připravená,konzervovaná,ne:zmrazená,v octě,kys.octové', 'Homogenised vegetables put up for retail sale as infant food or for dietetic pur'),
('20052010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brambory ve formě mouky,krupice,vloček konzervované,ne:zmrazené,v octě,kys.octové', 'Potatoes in the form of flour, meal or flakes (excl. frozen)'),
('20052020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brambory-tenké plátky,smaž.nebo peč.,i solené v herm.obalech pro okamž.spotřebu', 'Potatoes in thin slices, cooked in fat or oil, whether or not salted or flavoure'),
('20052080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brambory ostatní konzervované,ne:viz sazebník', 'Potatoes, prepared or preserved otherwise than by vinegar or acetic acid, not fr'),
('20054000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hrách připravený,konzervovaný,ne:zmrazený,v octě,kyselině octové', 'Peas "Pisum Sativum", prepared or preserved otherwise than by vinegar or acetic'),
('20055100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fazole vyloupané připravené,konzervované,ne:zmrazené,v octě,kyselině octové', 'Shelled beans "Vigna spp., Phaseolus spp.", prepared or preserved otherwise than'),
('20055900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fazole ostatní připravené,konzervované,ne:vyloupané,zmrazené,v octě,kys.octové', 'Unshelled beans "Vigna spp., Phaseolus spp.", prepared or preserved otherwise th'),
('20056000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chřest připravený,konzervovaný,ne:zmrazený,v octě,kyselině octové', 'Asparagus, prepared or preserved otherwise than by vinegar or acetic acid (excl.'),
('20057000', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'KNE'), 'Olivy připravené,konzervované,ne:zmrazené,v octě,kys.octové', 'Olives, prepared or preserved otherwise than by vinegar or acetic acid (excl. fr'),
('20058000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kukuřice sladká připravená,konzervovaná,ne:zmrazená,v octě,kyselině octové', 'Sweetcorn "Zea Mays var. Saccharata", prepared or preserved otherwise than by vi'),
('20059100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bambusové výhonky', 'Bamboo shoots, prepared or preserved otherwise than by vinegar or acetic acid (e'),
('20059910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plody Capsicum připravené,konzervované,ne:sladké,zmrazené,v octě,kys.octové', 'Fruit of genus capsicum, prepared or preserved otherwise than by vinegar or acet'),
('20059920', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kapary připravené,konzervované,ne:zmrazené,v octě,kyselině octové', 'Capers, prepared or preserved otherwise than by vinegar or acetic acid (excl. fr'),
('20059930', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Artyčoky připravené,konzervované,ne:zmrazené,v octě,kyselině octové', 'Artichokes, prepared or preserved otherwise than by vinegar or acetic acid (excl'),
('20059940', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mrkev připravená,konzervovaná,ne:zmrazená,v octě,kyselině octové', 'Carrots, prepared or preserved otherwise than by vinegar or acetic acid, not fro'),
('20059950', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zeleninové směsi připravené,konzervované,ne:zmrazené,v octě,kyselině octové', 'Mixtures of vegetables, prepared or preserved otherwise than by vinegar or aceti'),
('20059960', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zelí kyselé připravené,konzervované,ne:zmrazené,v octě,kyselině octové', 'Sauerkraut, non-frozen'),
('20059990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zelenina ost.připravená,konzervovaná,ne:viz sazebník', 'Vegetables, prepared or preserved otherwise than by vinegar or acetic acid, not'),
('20060010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zázvor konzervovaný cukrem', 'Ginger, preserved by sugar, drained, glacĂ© or crystallised'),
('20060031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Třešně konzervované cukrem, obsah cukru nad 13%', 'Cherries, with a sugar content of > 13%, preserved by sugar, drained, glacĂ© or'),
('20060035', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tropické ořechy a tropické ovoce konzervované cukrem, obsah cukru nad 13%', 'Guavas, mangoes, mangosteens, papaws "papayas", tamarinds, cashew apples, lychee'),
('20060038', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zelenina,ovoce,ořechy ost.konzerv.cukrem obsah cukru nad 13%,ne:viz sazebník', 'Vegetables, fruit, nuts, fruit-peel and other edible parts of plants, preserved'),
('20060091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tropické ořechy a tropické ovoce konzervované cukrem, obsah cukru do 13%', 'Guavas, mangoes, mangosteens, papaws "papayas", tamarinds, cashew apples, lychee'),
('20060099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zelenina,ovoce,ořechy ost.konzerv.cukrem,cukr do 13%,ne:trop.ovoce,trop.ořechy', 'Vegetables, fruit, nuts, fruit-peel and other edible parts of plants, preserved'),
('20071010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky homogenizované-džemy apod.ovocné,ořechové,cukr nad 13%', 'Homogenised preparations of jams, fruit jellies, marmalades, fruit or nut purĂ©e'),
('20071091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky homogenizované-džemy apod.z tropického ovoce,cukr do 13%', 'Jams, jellies, marmalades, purĂ©e and pastes, of guavas, mangoes, mangosteens, p'),
('20071099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky homogenizované-džemy apod.ostatní,cukr do 13%,ne:tropické ovoce', 'Jams, fruit jellies, marmalades, fruit purĂ©e and pastes, obtained by cooking, w'),
('20079110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zavařeniny apod.z citrusového ovoce,cukr nad 30%,ne:homogenizované', 'Citrus fruit jams, jellies, marmalades, purĂ©es or pastes, obtained by cooking,'),
('20079130', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zavařeniny apod.z citrusového ovoce,cukr více než 13%-30%,ne:homogenizované', 'Citrus fruit jams, jellies, marmalades, purĂ©es or pastes, obtained by cooking,'),
('20079190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zavařeniny apod.z citrusového ovoce,cukr do 13%,ne:homogenizované', 'Citrus fruit jams, jellies, marmalades, purĂ©es or pastes, obtained by cooking,'),
('20079910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Protlaky (pyré),pasty ze švestek,cukr nad 30%,obal nad 100 kg k prům.zpracování', 'Plum purĂ©e and paste, obtained by cooking, with sugar content of > 30% by weigh'),
('20079920', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Protlaky (pyré),pasty z jedlých kaštanů,cukr nad 30%', 'Chestnut purĂ©e and paste, obtained by cooking, with sugar content of > 30% by w'),
('20079931', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zavařeniny,marmelády apod.z třešní,cukr nad 30%', 'Cherry jams, jellies, marmalades, purĂ©es or pastes, obtained by cooking, with s'),
('20079933', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zavařeniny,marmelády apod.z jahod,cukr nad 30%', 'Strawberry jams, jellies, marmalades, purĂ©es or pastes, obtained by cooking, wi'),
('20079935', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zavařeniny,marmelády apod.z malin,cukr nad 30%', 'Raspberry jams, jellies, marmalades, purĂ©es or pastes, obtained by cooking, wit'),
('20079939', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Džemy apod.z ovoce ost.,cukr nad 30%,ne:z citrusů,švestek,třešní,jahod,malin,kaštanů', 'Jams, jellies, marmalades, fruit purĂ©es or pastes, obtained by cooking, with su'),
('20079950', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zavařeniny,pyré apod.,obsah cukru 13-30%,ne:z citrusů', 'Jams, fruit jellies, marmalades, fruit purĂ©e and fruit pastes, obtained by cook'),
('20079993', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zavařeniny,pyré apod.,obsah cukru do 13%,z tropického ovoce a tropických ořechů', 'Jams, fruit jellies, marmalades, fruit purĂ©e and pastes of guavas, mangoes, man'),
('20079997', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zavařeniny,pyré apod.,obsah cukru do 13%,ostatní,ne:z tropického ovoce a tropických ořechů', 'Jams, fruit jellies, marmalades, fruit purĂ©e and pastes, obtained by cooking, w'),
('20081110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Máslo arašídové', 'Peanut butter'),
('20081191', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Arašídy upravené i konzervované i slazené,obal nad 1kg', 'Groundnuts, prepared or preserved, in immediate packings of a net content of > 1'),
('20081196', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Arašídy upravené-pražené i konzervované i slazené,obal do 1kg', 'Groundnuts, roasted, in immediate packings of a net content <= 1 kg'),
('20081198', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Arašídy ostatní upravené,konzervované i slazené,obal do 1kg,ne:pražené', 'Groundnuts, prepared or preserved, in immediate packings of a content of <= 1 kg'),
('20081911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tropické ořechy,směsi obsah.50% a více trop.ořechů,ovoce uprav.,obal nad 1kg', 'Coconuts, cashew nuts, brazil nuts, areca "betel" nuts, cola nuts and macadamia'),
('20081913', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mandle,pistácie pražené,obal nad 1kg', 'Roasted almonds and pistachios, in immediate packings of a net content > 1 kg'),
('20081919', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ořechy,semena ost.upravené,obal nad 1 kg,ne:trop.ořechy,pražené mandle,pistacie', 'Nuts and other seeds, incl. mixtures, prepared or preserved, in immediate packin'),
('20081991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tropické ořechy, směsi s min. 50% trop.ořechů a ovoce, bal. do 1 kg', 'Coconuts, cashew nuts, brazil nuts, areca "betel" nuts, cola nuts and macadamia'),
('20081993', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mandle,pistácie pražené,obal do 1 kg', 'Roasted almonds and pistachios, in immediate packings of a net content <= 1 kg'),
('20081995', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ořechy,semena ostatní pražené,obal do 1 kg,ne:tropické ořechy,mandle,pistacie', 'Roasted nuts, in immediate packings of a net content <= 1 kg (excl. groundnuts,'),
('20081999', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ořechy,semena ostatní upravené i slazené,obal do lkg,ne:trop.ořechy,pražené', 'Nuts and other seeds, incl. mixtures, prepared or preserved, in immediate packin'),
('20082011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ananasy konzervované s alkoholem,cukr nad 17%,balení nad 1kg', 'Pineapples, prepared or preserved, containing added spirit, with sugar content o'),
('20082019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ananasy konzervované s alkoholem,cukr do 17%,balení nad 1kg', 'Pineapples, prepared or preserved, containing added spirit, in immediate packing'),
('20082031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ananasy konzervované s alkoholem,cukr do 19%,balení do 1kg', 'Pineapples, prepared or preserved, containing added spirit, with sugar content o'),
('20082039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ananasy konzervované s alkoholem,cukr do 19%,balení do 1kg', 'Pineapples, prepared or preserved, containing added spirit, in immediate packing'),
('20082051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ananasy konzervované bez alkoholu,cukr nad 17%,balení nad 1kg', 'Pineapples, prepared or preserved, containing added sugar but no added spirit, w'),
('20082059', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ananasy konzervované bez alkoholu,cukr do 17%,balení nad 1kg', 'Pineapples, prepared or preserved, containing added sugar but no added spirit, w'),
('20082071', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ananasy konzervované bez alkoholu,cukr nad 19%,balení do 1kg', 'Pineapples, prepared or preserved, containing added sugar but no added spirit, w'),
('20082079', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ananasy konzervované bez alkoholu,cukr do 19%,balení do 1kg', 'Pineapples, prepared or preserved, containing added sugar but no added spirit, w'),
('20082090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ananas konzervovaný, bez přísady alkoholu a bez přídavku cukru', 'Pineapples, prepared or preserved, not containing added spirit or added sugar'),
('20083011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plody citrusové konzervované,obsah alkoholu 11,85% a více,obsah cukru nad 9%', 'Citrus fruit, prepared or preserved, containing added spirit, with sugar content'),
('20083019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plody citrusové konzervované,obsah alkoholu 11,85% a více,obsah cukru nad 9%', 'Citrus fruit, prepared or preserved, containing added spirit, with sugar content'),
('20083031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plody citrusové konzervované,obsah alkoholu do 11,85%,obsah cukru do 9%', 'Citrus fruit, prepared or preserved, containing added spirit, with actual alcoho'),
('20083039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plody citrusové konzervované,obsah alkoholu 11,85% a více,obsah cukru do 9%', 'Citrus fruit, prepared or preserved, containing added spirit, with actual alcoho'),
('20083051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Grapefruity vč.pomel-kousky konzervované bez alkoholu,slazené,balení nad 1kg', 'Grapefruit segments, prepared or preserved, containing added sugar but no added'),
('20083055', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mandarinky a pod.citrusové hybridy konzerv.bez alkoholu,slazené,balení nad 1kg', 'Mandarins, incl. tangerines and satsumas, clementines, wilkings and similar citr'),
('20083059', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plody citrusové ost.konzerv.bez alkoholu,slazené,bal.nad 1 kg,ne:viz sazebník', 'Citrus fruits, prepared or preserved, containing added sugar but no added spirit'),
('20083071', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Grapefruity vč.pomel-kousky konzervované bez alkoholu,slazené,balení do 1 kg', 'Grapefruit segments, prepared or preserved, containing added sugar but no added'),
('20083075', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mandarinky a pod.citrusové hybridy konzerv.,bez alkoholu,slazené,balení do 1kg', 'Mandarins, incl. tangerines and satsumas, clementines, wilkings and similar citr'),
('20083079', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plody citrusové ost.konzerv.bez alkoholu,slazené,bal.do 1 kg,ne:viz sazebník', 'Citrus fruits, prepared or preserved, containing added sugar but no added spirit'),
('20083090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plody citrusové konzervované bez alkoholu, bez přídavku cukru', 'Citrus fruit, prepared or preserved, not containing added spirit or added sugar'),
('20084011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hrušky konzervované,obsah alkoholu do 11,85%,obsah cukru nad 13%,bal.nad 1kg', 'Pears, prepared or preserved, containing added spirit, with sugar content of > 1'),
('20084019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hrušky konzervované,obsah alkoholu nad 11,85%,obsah cukru nad 13%,bal.nad 1kg', 'Pears, prepared or preserved, containing added spirit, with sugar content of > 1'),
('20084021', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hrušky konzervované,obsah alkoholu do 11,85%,obsah cukru do 13%,bal.nad 1kg', 'Pears, prepared or preserved, containing added spirit, with actual alcoholic str'),
('20084029', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hrušky konzervované,obsah alkoholu nad 11,85%,obsah cukru do 13%,bal.nad 1kg', 'Pears, prepared or preserved, containing added spirit, with actual alcoholic str'),
('20084031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hrušky konzervované s alkoholem,obsah cukru nad 15%,balení do 1kg', 'Pears, prepared or preserved, containing added spirit, with sugar content of > 1'),
('20084039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hrušky konzervované s alkoholem,obsah cukru do 15%,balení do 1kg', 'Pears, prepared or preserved, containing added spirit, in immediate packings of'),
('20084051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hrušky konzervované bez alkoholu,cukr nad 13%,balení nad 1kg', 'Pears, prepared or preserved, containing no spirit but with added sugar, with su'),
('20084059', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hrušky konzervované bez alkoholu,cukr do 13%,balení nad 1kg', 'Pears, prepared or preserved, containing no spirit but with added sugar, with su'),
('20084071', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hrušky konzervované bez alkoholu,cukr nad 15%,balení do 1kg', 'Pears, prepared or preserved, containing no spirit but with added sugar, with su'),
('20084079', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hrušky konzervované bez alkoholu,cukr do 15%,balení do 1kg', 'Pears, prepared or preserved, containing no spirit but with added sugar, with su'),
('20084090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hrušky konzervované, bez přísady alkoholu a bez přídavku cukru', 'Pears, prepared or preserved, not containing added spirit or added sugar'),
('20085011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Meruňky konzervované,obsah alkoholu do 11,85%,obsah cukru nad 13%,bal.nad 1kg', 'Apricots, prepared or preserved, containing added spirit, with sugar content of'),
('20085019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Meruňky konzervované,obsah alkoholu nad 11,85%,obsah cukru nad 13%,bal.nad 1kg', 'Apricots, prepared or preserved, containing added spirit, with sugar content of'),
('20085031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Meruňky konzervované,obsah alkoholu do 11,85%,obsah cukru do 13%,bal.nad 1kg', 'Apricots, prepared or preserved, containing added spirit, with actual alcoholic'),
('20085039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Meruňky konzervované,obsah alkoholu nad 11,85%,obsah cukru do 13%,bal.nad 1kg', 'Apricots, prepared or preserved, containing added spirit, with actual alcoholic'),
('20085051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Meruňky konzervované s alkoholem,obsah cukru do 15%,balení do 1 kg', 'Apricots, prepared or preserved, containing added spirit, with sugar content of'),
('20085059', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Meruňky konzervované s alkoholem,obsah cukru do 15%,balení do 1 kg', 'Apricots, prepared or preserved, containing added spirit, in immediate packings'),
('20085061', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Meruňky konzervované bez alkoholu,obsah cukru nad 13%,balení nad 1 kg', 'Apricots, prepared or preserved, containing no spirit but with added sugar, with'),
('20085069', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Meruňky konzervované bez alkoholu,obsah cukru do 13%,balení nad 1 kg', 'Apricots, prepared or preserved, containing no spirit but with added sugar, with'),
('20085071', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Meruňky konzervované bez alkoholu,obsah cukru nad 15%,balení do 1 kg', 'Apricots, prepared or preserved, containing no spirit but with added sugar, with'),
('20085079', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Meruňky konzervované bez alkoholu,obsah cukru do 15%,balení do 1 kg', 'Apricots, prepared or preserved, containing no spirit but with added sugar, with'),
('20085092', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Meruňky konzervované bez alkoholu,neslazené,balení 5kg a více', 'Apricots, prepared or preserved, not containing added spirit or added sugar, in'),
('20085094', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Meruňky konzervované bez alkoholu,neslazené,balení 4,5-5kg', 'Apricots, prepared or preserved, not containing added spirit or added sugar, in'),
('20085099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Meruňky konzervované bez alkoholu,neslazené,balení pod 4,5kg', 'Apricots, prepared or preserved, not containing added spirit or added sugar, in'),
('20086011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Třešně konzervované,obsah alkoholu do 11,85%,obsah cukru nad 9%', 'Cherries, prepared or preserved, containing added spirit, with sugar content of'),
('20086019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Třešně konzervované,obsah alkoholu nad 11,85%,obsah cukru nad 9%', 'Cherries, prepared or preserved, containing added spirit, with sugar content of'),
('20086031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Třešně konzervované,obsah alkoholu do 11,85%,obsah cukru do 9%', 'Cherries, prepared or preserved, containing added spirit, with actual alcoholic'),
('20086039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Třešně konzervované,obsah alkoholu nad 11,85%,obsah cukru do 9%', 'Cherries, prepared or preserved, containing added spirit, with actual alcoholic'),
('20086050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Třešně konzervované bez alkoholu slazené,balení nad 1kg', 'Cherries, prepared or preserved, containing no spirit but with added sugar, in i'),
('20086060', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Třešně konzervované bez alkoholu slazené,balení do 1kg', 'Cherries, prepared or preserved, containing no spirit but with added sugar, in i'),
('20086070', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Třešně konzervované bez alkoholu neslazené,balení nad 4,5kg', 'Cherries, prepared or preserved, not containing added spirit or added sugar, in'),
('20086090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Třešně konzervované bez alkoholu neslazené,balení do 4,5kg', 'Cherries, prepared or preserved, not containing added spirit or added sugar, in'),
('20087011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Broskve konzervované,obsah alkoholu do 11,85%,obsah cukru nad 13%,bal.nad 1kg', 'Peaches incl. nectarines, prepared or preserved, containing added spirit, with s'),
('20087019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Broskve konzervované,obsah alkoholu nad 11,85%,obsah cukru nad 13%,bal.nad 1kg', 'Peaches incl. nectarines, prepared or preserved, containing added spirit, with s'),
('20087031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Broskve konzervované,obsah alkoholu do 11,85%,obsah cukru do 13%,bal.nad 1kg', 'Peaches incl. nectarines, prepared or preserved, containing added spirit, with a'),
('20087039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Broskve konzervované,obsah alkoholu nad 11,85%,obsah cukru do 13%,bal.nad 1kg', 'Peaches incl. nectarines, prepared or preserved, containing added spirit, with a'),
('20087051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Broskve konzervované s alkoholem,obsah cukru nad 15%,balení do 1kg', 'Peaches incl. nectarines, prepared or preserved, containing added spirit, with s'),
('20087059', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Broskve konzervované s alkoholem,obsah cukru do 15%,balení do 1kg', 'Peaches incl. nectarines, prepared or preserved, containing added spirit, in imm'),
('20087061', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Broskve konzervované bez alkoholu,obsah cukru nad 13%,balení nad 1kg', 'Peaches incl. nectarines, prepared or preserved, containing no spirit but with a'),
('20087069', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Broskve konzervované bez alkoholu,obsah cukru do 13%,balení nad 1kg', 'Peaches incl. nectarines, prepared or preserved, containing no spirit but with a'),
('20087071', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Broskve konzervované bez alkoholu,obsah cukru nad 15%,balení do 1kg', 'Peaches incl. nectarines, prepared or preserved, containing no spirit but with a'),
('20087079', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Broskve konzervované bez alkoholu,obsah cukru do 15%,balení do 1kg', 'Peaches incl. nectarines, prepared or preserved, containing no spirit but with a'),
('20087092', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Broskve konzervované bez alkoholu neslazené,balení 5kg a více', 'Peaches incl. nectarines, prepared or preserved, not containing added spirit or'),
('20087098', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Broskve konzervované,bez přídavku alkoholu a cukru,balení do 5 kg', 'Peaches incl. nectarines, prepared or preserved, in immediate packings of a net'),
('20088011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jahody konzervované,obsah alkoholu do 11,85%,obsah cukru nad 9%', 'Strawberries, prepared or preserved, containing added spirit, with sugar content'),
('20088019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jahody konzervované,obsah alkoholu nad 11,85%,obsah cukru nad 9%', 'Strawberries, prepared or preserved, containing added spirit, with sugar content'),
('20088031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jahody konzervované,obsah alkoholu do 11,85%,obsah cukru do 9%', 'Strawberries, prepared or preserved, containing added spirit, with actual alcoho'),
('20088039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jahody konzervované,obsah alkoholu nad 11,85%,obsah cukru do 9%', 'Strawberries, prepared or preserved, with sugar content <= 9%, of actual alcohol'),
('20088050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jahody konzervované bez alkoholu slazené,balení nad 1kg', 'Strawberries, prepared or preserved, containing no spirit but with added sugar,'),
('20088070', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jahody konzervované bez alkoholu slazené,balení do 1kg', 'Strawberries, prepared or preserved, containing no spirit but with added sugar,'),
('20088090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jahody konzervované, bez přísady alkoholu a bez přídavku cukru', 'Strawberries, prepared or preserved, not containing added spirit or added sugar'),
('20089100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jádra palmová upravená,konzervovaná i slazená i s alkoholem', 'Palm hearts, prepared or preserved, whether or not containing added sugar or oth'),
('20089212', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi ovocné konzervované,alkohol nad 11,85%,cukr nad 9%', 'Mixtures of guavas, mangoes, mangosteens, papaws "papayas", tamarinds, cashew ap'),
('20089214', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi ovoce ost.konzervované,obsah alkoholu do 11,85%,cukru nad 9%,ne:tropické', 'Mixtures of fruit or other edible parts of plants, prepared or preserved, contai'),
('20089216', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi trop.ovoce konzervované,obsah alkoholu nad 11,85%,obsah cukru nad 9%', 'Mixtures of guavas, mangoes, mangosteens, papaws "papayas", tamarinds, cashew ap'),
('20089218', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi ovoce ost.konzervované,obsah alkoholu nad 11,85%,cukr nad 9%,ne:tropické', 'Mixtures of fruit or other edible parts of plants, prepared or preserved, contai'),
('20089232', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi trop.ovoce konzervované,obsah alkoholu do 11,85%,obsah cukru do 9%', 'Mixtures of guavas, mangoes, mangosteens, papaws "papayas", tamarinds, cashew ap'),
('20089234', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi ovoce ost.konzervované,obsah alkoholu do 11,85%,cukr do 9%,ne:tropické', 'Mixtures of fruit or other edible parts of plants, prepared or preserved, contai'),
('20089236', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi trop.ovoce konzervované,obsah alkoholu nad 11,85%,obsah cukru do 9%', 'Mixtures of guavas, mangoes, mangosteens, papaws "papayas", tamarinds, cashew ap'),
('20089238', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi ovoce ost.konzervované,obsah alkoholu nad 11,85%,cukr do 9%,ne:tropické', 'Mixtures of fruit or other edible parts of plants, prepared or preserved, contai'),
('20089251', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi tropického ovoce,ořechů konzerv.bez alkoholu slazené,balení nad 1kg', 'Mixtures of guavas, mangoes, mangosteens, papaws "papayas", tamarinds, cashew ap'),
('20089259', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi ovoce,ořechů konzerv.bez alkoholu slazené,balení nad 1kg,ne:tropické', 'Mixtures of fruit or other edible parts of plants, prepared or preserved, not co'),
('20089272', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi trop.ovoce(jedno ovoce do 50%)konzervované bez alkoholu slazené', 'Mixtures of guavas, mangoes, mangosteens, papaws "papayas", tamarinds, cashew ap'),
('20089274', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi ovoce ost.(jedno ovoce do 50%) konzerv.bez alkoholu slazené,ne:tropické', 'Mixtures of fruit, in which the weight of no single fruit exceeds 50% of the tot'),
('20089276', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi trop.ovoce(jedno ovoce nad 50%) konzervované bez alkoholu slazené', 'Mixtures of guavas, mangoes, mangosteens, papaws "papayas", tamarinds, cashew ap'),
('20089278', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi ovoce ost.(jedno ovoce nad 50%) konzezv.bez alkoholu slazené,ne:tropické', 'Mixtures of fruit or other edible parts of plants, prepared or preserved, not co'),
('20089292', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi tropického ovoce,ořechů konzervované bez alkoholu neslazené,bal.nad 5kg', 'Mixtures of guavas, mangoes, mangosteens, papaws "papayas", tamarinds, cashew ap'),
('20089293', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi ovoce ost.konzervované bez alkoholu neslazené,bal.nad 5kg,ne:tropické', 'Mixtures of fruit or other edible parts of plants, prepared or preserved, not co'),
('20089294', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi tropického ovoce,ořechů konzervované bez alkoholu neslazené,bal.4,5-5kg', 'Mixtures of guavas, mangoes, mangosteens, papaws "papayas", tamarinds, cashew ap'),
('20089296', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi ovoce ost.konzervované bez alkoholu neslazené,bal.4,5-5kg,ne:tropické', 'Mixtures of fruit or other edible parts of plants, prepared or preserved, not co'),
('20089297', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi tropického ovoce,ořechů konzervované bez alkoholu neslaz.,bal.pod 4,5kg', 'Mixtures of guavas, mangoes, mangosteens, papaws "papayas", tamarinds, cashew ap'),
('20089298', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi ovoce ost.konzervované bez alkoholu neslazené,bal.pod 4,5kg,ne:tropické', 'Mixtures of fruit or other edible parts of plants, prepared or preserved, not co'),
('20089911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zázvor konzervovaný i slazený,obsah alkoholu do 11,85%', 'Ginger, prepared or preserved, containing added spirit, with actual alcoholic st'),
('20089919', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zázvor ostatní konzervovaný i slazený,obsah alkoholu nad 11,85%', 'Ginger, prepared or preserved, containing added spirit, with actual alcoholic st'),
('20089921', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hrozny konzervované s alkoholem,obsah cukru nad 13%', 'Grapes, prepared or preserved, containing added spirit, with sugar content of >'),
('20089923', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hrozny konzervované s alkoholem,obsah cukru do 13%', 'Grapes, prepared or preserved, with added spirit, with sugar content <= 13% (exc'),
('20089924', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ovoce tropické konzervované,obsah alkoholu do 11,85%,obsah cukru nad 9%', 'Guavas, mangoes, mangosteens, papaws "papayas", tamarinds, cashew apples, lychee'),
('20089928', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ovoce ost.konzervované,obsah alkoholu do 11,85%,cukru nad 9%,ne:viz sazebník', 'Fruit and other edible parts of plants, prepared or preserved, containing added'),
('20089931', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ovoce tropické konzervované,obsah alkoholu nad 11,85%,cukr nad 9%', 'Guavas, mangoes, mangosteens, papaws "papayas", tamarinds, cashew apples, lychee'),
('20089934', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ovoce ost.konzervované,obsah alkoholu nad 11,85%,cukr nad 9%,ne:viz sazebník', 'Fruit and other edible parts of plants, prepared or preserved, containing added'),
('20089936', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tropické ovoce konzervované,obsah alkoholu do 11,85%,obsah cukru do 9%', 'Guavas, mangoes, mangosteens, papaws "papayas", tamarinds, cashew apples, lychee'),
('20089937', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ovoce ostatní konzervované,obsah alkoholu do 11,85%,cukru do 9%,ne:tropické', 'Fruit and other edible parts of plants, prepared or preserved, containing added'),
('20089938', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tropické ovoce konzervované,obsah alkoholu nad 11,85%,obsah cukru do 9%', 'Guavas, mangoes, mangosteens, papaws "papayas", tamarinds, cashew apples, lychee'),
('20089940', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ovoce ostatní konzervované,obsah alkoholu nad 11,85%,cukru do 9%,ne:tropické', 'Fruit and other edible parts of plants, prepared or preserved, containing added'),
('20089941', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zázvor konzervovaný bez alkoholu slazený,balení nad 1kg', 'Ginger, prepared or preserved, containing no spirit but with added sugar, in imm'),
('20089943', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hrozny konzervované bez alkoholu slazené,balení nad 1kg', 'Grapes, prepared or preserved, containing no spirit but with added sugar, in imm'),
('20089945', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Švestky konzervované bez alkoholu slazené,balení nad 1kg', 'Plums, prepared or preserved, containing no spirit but with added sugar, in imme'),
('20089948', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tropické ovoce konzervované bez alkoholu slazené,balení nad 1kg', 'Guavas, mangoes, mangosteens, papaws "papayas", tamarinds, cashew apples, lychee'),
('20089949', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ovoce ostatní konzervované bez alkoholu slazené,balení nad 1kg,ne:viz sazebník', 'Fruit and other edible parts of plants, prepared or preserved, not containing ad'),
('20089951', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zázvor konzervovaný bez alkoholu slazený,balení do 1kg', 'Ginger, prepared or preserved, containing no spirit but with added sugar, in imm'),
('20089963', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tropické ovoce konzervované bez alkoholu slazené,balení do 1kg', 'Guavas, Mangoes, mangosteens, papaws "papayas", tamarinds, cashew apples, lychee'),
('20089967', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní ovoce konzervované bez alkoholu  slazené,balení do 1kg', 'Fruit and other edible parts of plants, prepared or preserved, not containing ad'),
('20089972', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Švestky konzervované bez alkoholu neslazené,balení 5kg a více', 'Plums, prepared or preserved, not containing added spirit or added sugar, in imm'),
('20089978', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Švestky konzervované bez alkoholu neslazené, balení pod 5kg', 'Plums, prepared or preserved, not containing added spirit or added sugar, in imm'),
('20089985', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kukuřice konzervovaná bez alkoholu neslazená,ne:sladká', 'Maize "corn", prepared or preserved, not containing added spirit or added sugar'),
('20089991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hlízy smldince,sladké brambory a pod.jedlé části rostlin,obs.škrobu nad 5%', 'Yams, sweet potatoes and similar edible parts of plants, containing >= 5% starch'),
('20089999', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ovoce ostatní konzervované bez alkoholu neslazené,ne:viz sazebník', 'Fruit and other edible part of plants, prepared or preserved, not containing add'),
('20091111', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva pomerančová zmrazená,hodnota Brix nad 67,hodnota do 30 Euro/100kg', 'Frozen orange juice, unfermented, Brix value > 67 at 20Â°C, value of <= 30 ? per'),
('20091119', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva pomerančová zmrazená,hodnota Brix nad 67,hodnota nad 30 Euro/100kg', 'Frozen orange juice, unfermented, Brix value > 67 at 20Â°C, value of > 30 ? per'),
('20091191', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva pomerančová zmrazená,hodnota Brix do 67,hodnota do 30 Euro/100kg,cukr nad 30%', 'Frozen orange juice, unfermented, Brix value <= 67 at 20Â°C, value of <= 30 ? pe'),
('20091199', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva pomerančová zmrazená,hodnota Brix do 67,ne:hodnota do 30 Euro/100kg,cukr nad 30%', 'Frozen orange juice, unfermented, Brix value <= 67 at 20Â°C, whether or not cont'),
('20091200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva pomerančová nezmrazená,hodnota Brix do 20', 'Orange juice, unfermented, Brix value <= 20 at 20Â°C, whether or not containing'),
('20091911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva pomerančová,hodnota Brix nad 67,hodnota do 30 Euro/100kg,ne:zmrazená', 'Orange juice, unfermented, Brix value > 67 at 20Â°C, value of <= 30 ? per 100 kg'),
('20091919', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva pomerančová,hodnota Brix nad 67,hodnota nad 30 Euro/100kg,ne:zmrazená', 'Orange juice, unfermented, Brix value > 67 at 20Â°C, value of > 30 ? per 100 kg,'),
('20091991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva pomerančová,hodnota Brix nad 20-67,hodnota do 30 Euro/100kg+cukr nad 30%,ne:zmrazená', 'Orange juice, unfermented, Brix value > 20 but <= 67 at 20Â°C, value of <= 30 ?'),
('20091998', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva pomerančová,hodnota Brix nad 20-67,ne:zmrazená,hodnota do 30 Euro/100kg,cukr nad 30%', 'Orange juice, unfermented, Brix value > 20 but <= 67 at 20Â°C, whether or not co'),
('20092100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva grapefruitová (vč.pomelové),hodnota Brix do 20', 'Grapefruit juice, unfermented, Brix value <= 20 at 20Â°C, whether or not contain'),
('20092911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva grapefruitová (vč.pomelové),hodnota Brix nad 67,hodnota do 30 Euro/100', 'Grapefruit juice, unfermented, Brix value > 67 at 20Â°C, value of <= 30 ? per 10'),
('20092919', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva grapefruitová (vč.pomelové),hodnota Brix nad 67,hodnota nad 30 Euro/100kg', 'Grapefruit juice, unfermented, Brix value > 67 at 20Â°C, value of > 30 ? per 100'),
('20092991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva grapefruitová (vč.pomelové),hodnota Brix nad 20-67,hodnota do 30 Euro/100kg,cukr nad 30%', 'Grapefruit juice, unfermented, Brix value > 20 but <= 67 at 20Â°C, value of <= 3'),
('20092999', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva grapefruitová (vč.pomelové),hodnota Brix nad 20-67,ne:hodnota do 30 Euro/100kg,cukr nad 30%', 'Grapefruit juice, unfermented, Brix value > 20 but <= 67 at 20Â°C, whether or no'),
('20093111', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva z citrusového ovoce ostatní,hodnota Brix do 20,hodnota nad 30 Euro/100kg,slazená', 'Single citrus fruit juice, unfermented, Brix value <= 20 at 20Â°C, value of > 30'),
('20093119', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva z citrusového ovoce ostatní,hodnota Brix do 20,hodnota nad 30 Euro/100kg,neslazená', 'Single citrus fruit juice, unfermented, Brix value <= 20 at 20Â°C, with a value'),
('20093151', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva citronová,hodnota Brix do 20,hodnota do 30 Euro/100kg,slazená', 'Lemon juice, unfermented, Brix value <= 20 at 20Â°C, value of <= 30 ? per 100 kg'),
('20093159', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva citronová,hodnota Brix do 20,hodnota do 30 Euro/100kg,neslazená', 'Lemon juice, unfermented, Brix value <= 20 at 20Â°C, value of <= 30 ? per 100 kg'),
('20093191', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva z citrusového ovoce ostatní,hodnota Brix do 20,hodnota do 30 Euro/100kg,slazená', 'Single citrus fruit juice, unfermented, Brix value <= 20 at 20Â°C, value of <= 3'),
('20093199', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva z citrusového ovoce ostatní,hodnota Brix do 20,hodnota do 30 Euro/100kg,neslazená', 'Single citrus fruit juice, unfermented, Brix value <= 20 at 20Â°C, value of <= 3'),
('20093911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva z citrusového ovoce ostatní,hodnota Brix nad 67,hodnota do 30 Euro/100kg', 'Single citrus fruit juice, unfermented, Brix value > 67 at 20Â°C, value of <= 30'),
('20093919', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva z citrusového ovoce ostatní,hodnota Brix nad 67,hodnota nad 30 Euro/100kg', 'Single citrus fruit juice, unfermented, Brix value > 67 at 20Â°C, value of > 30'),
('20093931', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva z citrusového ovoce ostatní,hodnota Brix nad 20-67,hodnota nad 30 Euro/100kg,slazená', 'Single citrus fruit juice, unfermented, Brix value > 20 but <= 67 at 20Â°C, valu'),
('20093939', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva z citrusového ovoce ostatní,hodnota Brix nad 20-67,hodnota nad 30 Euro/100kg,neslazená', 'Single citrus fruit juice, unfermented, Brix value > 20 but <= 67 at 20Â°C, with'),
('20093951', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva citrónová,hodnota Brix nad 20-67,hodnota do 30 Euro/100kg,cukr nad 30%', 'Lemon juice, unfermented, Brix value > 20 but <= 67 at 20Â°C, value of <= 30 ? p'),
('20093955', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva citrónová,hodnota Brix nad 20-67,hodnota do 30 Euro/100kg,cukr do 30%', 'Lemon juice, unfermented, Brix value > 20 but <= 67 at 20Â°C, value of <= 30 ? p'),
('20093959', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva citrónová,hodnota Brix nad 20-67,hodnota do 30 Euro/100kg,neslazená', 'Lemon juice, unfermented, Brix value > 20 but <= 67 at 20Â°C, value of <= 30 ? p'),
('20093991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva z citrusového ovoce ostatní,hodnota Brix nad 20-67,hodnota do 30 Euro/100kg,cukr nad 30%', 'Single citrus fruit juice, unfermented, Brix value > 20 but <= 67 at 20Â°C, valu'),
('20093995', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva z citrusového ovoce ostatní,hodnota Brix nad 20-67,hodnota do 30 Euro/100kg,cukr do 30%', 'Single citrus fruit juice, unfermented, Brix value > 20 but <= 67 at 20Â°C, valu'),
('20093999', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva z citrusového ovoce ostatní,hodnota Brix nad 20-67,hodnota do 30 Euro/100kg,neslazená', 'Single citrus fruit juice, unfermented, Brix value > 20 but <= 67 at 20Â°C, valu'),
('20094110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva ananasová,hodnota Brix do 20,hodnota nad 30 Euro/100kg,slazená', 'Pineapple juice, unfermented, Brix value <= 20 at 20Â°C, value of > 30 ? per 100'),
('20094191', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva ananasová,hodnota Brix do 20,hodnota do 30 Euro/100kg,slazená', 'Pineapple juice, unfermented, Brix value <= 20 at 20Â°C, value of <= 30 ? per 10'),
('20094199', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva ananasová,hodnota Brix do 20,hodnota do 30 Euro/100kg,neslazená', 'Pineapple juice, unfermented, Brix value <= 20 at 20Â°C (excl. containing added'),
('20094911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva ananasová,hodnota Brix nad 67,hodnota do 30 Euro/100kg', 'Pineapple juice, unfermented, Brix value > 67 at 20Â°C, value of <= 30 ? per 100'),
('20094919', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva ananasová,hodnota Brix nad 67,hodnota nad 30 Euro/100kg', 'Pineapple juice, unfermented, Brix value > 67 at 20Â°C, value of > 30 ? per 100'),
('20094930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva ananasová,hodnota Brix nad 20-67,hodnota nad 30 Euro/100kg', 'Pineapple juice, unfermented, Brix value > 20 but <= 67 at 20Â°C, value of > 30'),
('20094991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva ananasová,hodnota Brix nad 20-67,hodnota do 30 Euro/100kg,cukr nad 30%', 'Pineapple juice, unfermented, Brix value > 20 but <= 67 at 20Â°C, value of <= 30'),
('20094993', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva ananasová,hodnota Brix nad 20-67,hodnota do 30 Euro/100kg,cukr do 30%', 'Pineapple juice, unfermented, Brix value > 20 but <= 67 at 20Â°C, value of <= 30'),
('20094999', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva ananasová,hodnota Brix nad 20-67,neslazená', 'Pineapple juice, unfermented, Brix value > 20 but <= 67 at 20Â°C (excl. containi'),
('20095010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva z rajských jablek,nezkvašená,slazená', 'Tomato juice of a dry extract content < 7% by weight, containing added sugar, un'),
('20095090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva z rajských jablek,nezkvašená,neslazená', 'Tomato juice of a dry extract content < 7% by weight, unfermented (excl. contain'),
('20096110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva hroznová,hodnota Brix do 30,hodnota nad 18 Euro/100kg', 'Grape juice, incl. grape must, unfermented, Brix value <= 30 at 20Â°C, value of'),
('20096190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva hroznová,hodnota Brix do 30,hodnota do 18 Euro/100kg', 'Grape juice, incl. grape must, unfermented, Brix value <= 30 at 20Â°C, value of'),
('20096911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva hroznová,hodnota Brix nad 67,hodnota do 22 Euro/100kg', 'Grape juice, incl. grape must, unfermented, Brix value > 67 at 20Â°C, value of <'),
('20096919', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva hroznová,hodnota Brix nad 67,hodnota nad 22 Euro/100kg', 'Grape juice, incl. grape must, unfermented, Brix value > 67 at 20Â°C, value of >'),
('20096951', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva hroznová koncentrovaná,hodnota Brix nad 30-67,hodnota nad 18 Euro/100kg', 'Concentrated grape juice, incl. grape must, unfermented, Brix value > 30 but <='),
('20096959', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva hroznová ostatní,hodnota Brix nad 30-67,hodnota nad 18 Euro/100kg,ne:koncentrovaná', 'Grape juice, incl. grape must, unfermented, Brix value > 30 but <= 67 at 20Â°C,'),
('20096971', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva hroznová koncentrovaná,hodnota Brix nad 30-67,hodnota do 18 Euro/100kg,cukr nad 30%', 'Concentrated grape juice, incl. grape must, unfermented, Brix value > 30 but <='),
('20096979', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva hroznová ostatní,hodnota Brix nad 30-67,hodnota do 18 Euro/100kg,cukr nad 30%', 'Grape juice, incl. grape must, unfermented, Brix value > 30 but <= 67 at 20Â°C,'),
('20096990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva hroznová,hodnota Brix nad 30-67,hodnota do 18 Euro/100kg,cukr do 30%', 'Grape juice, incl. grape must, unfermented, Brix value > 30 but <= 67 at 20Â°C,'),
('20097120', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva jablečná,hodnota Brix do 20,slazená', 'Apple juice, unfermented, Brix value <= 20 at 20Â°C, containing added sugar (exc'),
('20097199', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva jablečná,hodnota Brix do 20,neslazená', 'Apple juice, unfermented, Brix value <= 20 at 20Â°C (excl. containing added suga'),
('20097911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva jablečná,hodnota Brix nad 67,hodnota do 22 Euro/100kg', 'Apple juice, unfermented, Brix value > 67 at 20Â°C, value of <= 22 ? per 100 kg,'),
('20097919', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva jablečná,hodnota Brix nad 67,hodnota nad 22 Euro/100kg', 'Apple juice, unfermented, Brix value > 67 at 20Â°C, value of > 22 ? per 100 kg,'),
('20097930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva jablečná,hodnota Brix nad 20-67,hodnota nad 18 Euro/100kg,slazená', 'Apple juice, unfermented, Brix value > 20 but <= 67 at 20Â°C, value of > 18 ? pe'),
('20097991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva jablečná,hodnota Brix nad 20-67,hodnota do 18 Euro/100kg,cukr do 30%', 'Apple juice, unfermented, Brix value > 20 but <= 67 at 20Â°C, value of <= 18 ? p'),
('20097993', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva jablečná,hodnota Brix nad 20-67,hodnota do 18 Euro/100kg,cukr nad 30%', 'Apple juice, unfermented, Brix value > 20 but <= 67 at 20Â°C, value of <= 18 ? p'),
('20097999', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva jablečná,hodnota Brix nad 20-67,neslazená', 'Apple juice, unfermented, Brix value > 20 but <= 67 at 20Â°C (excl. containing a'),
('20098011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva hrušková,hodnota Brix nad 67,hodnota do 22 Euro/100kg', 'Pear juice, unfermented, Brix value > 67 at 20Â°C, value of <= 22 ? per 100 kg,'),
('20098019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva hrušková,hodnota Brix nad 67,hodnota nad 22 Euro/100kg', 'Pear juice, unfermented, Brix value > 67 at 20Â°C, value of > 22 ? per 100 kg, w'),
('20098034', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva z ovoce tropického,hodnota Brix nad 67,hodnota do 30 Euro/100kg', 'Juice of guavas, mangoes, mangosteens, papaws "papayas", tamarinds, cashew apple'),
('20098035', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva zeleninová,ovocná ost.,hodnota Brix nad 67,hodnota do 30 Euro/100kg,ne:viz sazebník', 'Juice of fruit or vegetables, unfermented, not containing added spirit, whether'),
('20098036', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva z tropického ovoce,hodnota Brix nad 67,hodnota nad 30 Euro/100kg', 'Juice of guavas, mangoes, mangosteens, papaws "papayas", tamarinds, cashew apple'),
('20098038', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva zeleninová,ovocná ost.,hodnota Brix nad 67,hodnota nad 30 Euro/100kg,ne:viz sazebník', 'Juice of fruit or vegetables, unfermented, whether or not containing added sugar'),
('20098050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva hrušková,hodnota Brix do 67,hodnota nad 18 Euro/100kg', 'Pear juice, unfermented, Brix value <= 67 at 20Â°C, value of > 18 ? per 100 kg,'),
('20098061', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva hrušková,hodnota Brix do 67,hodnota do 18 Euro/100kg,cukr nad 30%', 'Pear juice, unfermented, Brix value <= 67 at 20Â°C, value of <= 18 ? per 100 kg,'),
('20098063', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva hrušková,hodnota Brix do 67,hodnota do 18 Euro/100kg,cukr do 30%', 'Pear juice, unfermented, Brix value <= 67 at 20Â°C, value of <= 18 ? per 100 kg,'),
('20098069', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva hrušková,hodnota Brix do 67,hodnota nad 18 Euro/100kg,neslazená', 'Pear juice, unfermented, Brix value <= 67 at 20Â°C (excl. containing added sugar'),
('20098071', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva třešňová,hodnota Brix do 67,hodnota nad 30 Euro/100kg,slazená', 'Cherry juice, unfermented, Brix value <= 67 at 20Â°C, value of > ? 30 per 100 kg'),
('20098073', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva z tropického ovoce,hodnota Brix do 67,hodnota nad 30 Euro/100kg,slazená', 'Juice of guavas, mangoes, mangosteens, papaws "papayas", tamarinds, cashew apple'),
('20098079', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva zeleninová,ovocná ost.,hodnota Brix do 67,hodnota nad 30 Euro/100kg,slazená,ne:viz sazebník', 'Juice of fruit or vegetables, unfermented, Brix value <= 67 at 20Â°C, value of >'),
('20098085', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva z ovoce tropického,hodnota Brix nad 67,hodnota do 30 Euro/100kg,cukr nad 30%', 'Juice of guavas, mangoes, mangosteens, papaws "papayas", tamarinds, cashew apple'),
('20098086', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva zeleninová,ovocná ost.,hodnota Brix nad 67,hodnota do 30 Euro/100kg,cukr nad 30%,ne:viz sazebník', 'Juice of fruit or vegetables, unfermented, Brix value <= 67 at 20Â°C, value of <'),
('20098088', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva z tropického ovoce,hodnota Brix nad 67,hodnota do 30 Euro/100kg,cukr do 30%', 'Juice of guavas, mangoes, mangosteens, papaws "papayas", tamarinds, cashew apple'),
('20098089', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva zeleninová,ovocná ost.,hodnota Brix nad 67,hodnota do 30 Euro/100kg,cukr do 30%,ne:viz sazebník', 'Juice of fruit or vegetables, unfermented, Brix value <= 67 at 20Â°C, value of <'),
('20098095', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva z ovoce Vaccinium macrocarpon,hodnota Brix nad 67,hodnota do 30 Euro/100kg,neslazená', 'Juice of fruit of the species Vaccinium macrocarpum, unfermented, Brix value <='),
('20098096', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva třešňová,hodnota Brix nad 67,hodnota do 30 Euro/100kg,neslazená', 'Cherry juice, unfermented, Brix value <= 67 at 20Â°C (excl. containing added sug'),
('20098097', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva z tropického ovoce,hodnota Brix nad 67,hodnota do 30 Euro/100kg,neslazená', 'Juice of guavas, mangoes, mangosteens, papaws "papayas", tamarinds, cashew apple'),
('20098099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šťáva zeleninová,ovocná ost.,hodnota Brix do 67,hodnota do 30 Euro/100kg,neslazená,ne:viz sazebník', 'Juice of fruit or vegetables, unfermented, Brix value <= 67 at 20Â°C (excl. cont'),
('20099011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi šťávy jablečné,hruškové,hodnota Brix nad 67,hodnota do 22 Euro/100kg', 'Mixtures of apple and pear juice, unfermented, Brix value > 67 at 20Â°C, value o'),
('20099019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi šťávy jablečné,hruškové,hodnota Brix nad 67,hodnota nad 22 Euro/100kg', 'Mixtures of apple and pear juice, unfermented, Brix value > 67 at 20Â°C, value o'),
('20099021', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi šťáv ostatních,hodnota Brix nad 67,hodnota do 30 Euro/100kg,ne:viz sazebník', 'Mixtures of fruit juices, incl. grape must, and vegetable juices, unfermented, B'),
('20099029', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi šťáv ostatních,hodnota Brix nad 67,hodnota nad 30 Euro/100kg,ne:hruška+jablko', 'Mixtures of fruit juices, incl. grape must, and vegetable juices, unfermented, B'),
('20099031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi šťávy jablečné,hruškové,hodnota Brix do 67,hodnota do 18 Euro/100kg', 'Mixtures of apple and pear juice, unfermented, Brix value <= 67 at 20Â°C, value'),
('20099039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi šťávy jablečné,hruškové,hodnota Brix do 67,hodnota nad 18 Euro/100kg', 'Mixtures of apple and pear juice, unfermented, Brix value <= 67 at 20Â°C, whethe'),
('20099041', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi šťáv citrus.plodů,ananasu,hodnota Brix do 67,hodnota nad 30 Euro/100kg,slazené', 'Mixtures of citrus and pineapple juice, unfermented, Brix value <= 67 at 20Â°C,'),
('20099049', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi šťáv citrus.plodů,ananasu,hodnota Brix do 67,hodnota nad 30 Euro/100kg,neslazené', 'Mixtures of citrus and pineapple juice, unfermented, Brix value <= 67 at 20Â°C,'),
('20099051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi šťáv ostatních,hodnota Brix do 67,hodnota nad 30 Euro/100kg,slazené,ne:viz sazebník', 'Mixtures of fruit juices, incl. grape must, and vegetable juices, unfermented, B'),
('20099059', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi šťáv ostatních,hodnota Brix do 67,hodnota nad 30 Euro/100kg,neslazené,ne:viz sazebník', 'Mixtures of fruit juices, incl. grape must, and vegetable juices, unfermented, B'),
('20099071', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi šťáv citrus.plodů,ananasu,hodnota Brix do 67,hodnota do 30 Euro/100kg,cukr nad 30%', 'Mixtures of citrus and pineapple juice, unfermented, Brix value <= 67 at 20Â°C,'),
('20099073', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi šťáv citrus.plodů,ananasu,hodnota Brix do 67,hodnota do 30 Euro/100kg,cukr do 30%', 'Mixtures of citrus and pineapple juice, unfermented, Brix value <= 67 at 20Â°C,'),
('20099079', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi šťáv citrus.plodů,ananasu,hodnota Brix do 67,hodnota do 30 Euro/100kg,neslazené', 'Mixtures of citrus and pineapple juice, unfermented, Brix value <= 67 at 20Â°C,'),
('20099092', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi šťáv tropického ovoce,hodnota Brix do 67,hodnota do 30 Euro/100kg,cukr nad 30%', 'Mixtures of juices of guavas, mangoes, mangosteens, papaws "papayas", tamarinds,'),
('20099094', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi šťáv ostatní,hodnota Brix do 67,hodnota do 30 Euro/100kg,cukr nad 30%,ne:viz sazebník', 'Mixtures of fruit juices, incl. grape must and juices of vegetables, unfermented'),
('20099095', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi šťáv tropického ovoce,hodnota Brix do 67,hodnota do 30 Euro/100kg,cukr do 30%', 'Mixtures of juices of guavas, mangoes, mangosteens, papaws "papayas", tamarinds,'),
('20099096', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi šťáv ostatní,hodnota Brix do 67,hodnota do 30 Euro/100kg,cukr do 30%,ne:viz sazebník', 'Mixtures of fruit juices, incl. grape must and juices of vegetables, unfermented'),
('20099097', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi šťáv tropického ovoce,hodnota Brix do 67,hodnota do 30 Euro/100kg,neslazené', 'Mixtures of juices of guavas, mangoes, mangosteens, papaws "papayas", tamarinds,'),
('20099098', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi šťáv ostatní,hodnota Brix do 67,hodnota do 30 Euro/100kg,neslazené,ne:viz sazebník', 'Mixtures of fruit juices, incl. grape must and juices of vegetables, unfermented'),
('21011100', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výtažky,esence,koncentráty z kávy', 'Extracts, essences and concentrates, of coffee'),
('21011292', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky se základem z výtažků,esencí,koncentrátů kávy', 'Preparations with a basis of extracts, essences and concentrates of coffee'),
('21011298', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky na podkladě kávy ostatní,ne:z výtažků,esencí,koncentrátů', 'Preparations with a basis of coffee'),
('21012020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výtažky,esence,koncentráty z čaje,maté', 'Extracts, essences and concentrates, of tea or matĂ©'),
('21012092', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky na základě výtažků,esencí,koncentrátů čaje,maté', 'Preparations with a basis of extracts, essences and concentrates of tea or matĂ©'),
('21012098', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky ostatní na podkladě čaje nebo maté,ne:základ výtažků,esencí,koncentrátů', 'Preparations with a basis of tea or matĂ©'),
('21013011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Náhražky kávové pražené,ne:čekanka', 'Roasted chicory'),
('21013019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Náhražky kávové pražené,ne:čekanka', 'Roasted coffee substitutes (excl. chicory)'),
('21013091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výtažky,esence,koncentráty z pražené čekanky', 'Extracts, essences and concentrates, of roasted chicory'),
('21013099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výtažky,esence,koncentráty ostatní z pražených kávových náhražek,ne:čekanka', 'Extracts, essences and concentrates, of roasted coffee substitutes (excl. chicor'),
('21021010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kvasinky násadové kultivované', 'Culture yeasts'),
('21021031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kvasnice chlebové sušené', 'Dried bakers'' yeast'),
('21021039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kvasnice chlebové ostatní,ne:sušené', 'Bakers'' yeast (excl. dried)'),
('21021090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Droždí aktivní ostatní,ne:kvasinky násadové kultivované,kvasnice chlebové', 'Active yeasts (excl. culture yeasts and bakers'' yeasts)'),
('21022011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Droždí neaktivní v tabletách,kostkách apod.,balení do 1kg pro okamžitou spotřebu', 'Inactive yeasts, in tablet, cube or similar form, or in immediate packings of <='),
('21022019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Droždí neaktivní ostatní,ne:v tabletách,kostkách apod.,balení do 1kg pro okamžitou spotřebu', 'Inactive yeasts (excl. in tablet, cube or similar form, or in immediate packings'),
('21022090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mikroorganismy jednobuněčné neaktivní ostatní,ne:droždí aktivní i neaktivní', 'Single-cell micro-organisms, dead (excl. packaged as medicaments and yeasts)'),
('21023000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prášky do pečiva hotové', 'Prepared baking powders'),
('21031000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Omáčka sojová', 'Soya sauce'),
('21032000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kečup a jiné omáčky z rajčat', 'Tomato ketchup and other tomato sauces'),
('21033010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Moučka hořčičná', 'Mustard flour and meal (excl. prepared)'),
('21033090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hořčice připravená', 'Mustard, incl. prepared flour and meal'),
('21039010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chutney-tekutý přípravek z manga', 'Mango chutney, liquid'),
('21039030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Aromatické přípravky,výtažek z hořce,koření apod.-složení viz sazebník', 'Aromatic bitters of an alcoholic strength of >= 44,2% but <= 49,2% vol containin'),
('21039090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Omáčky,přípravky pro omáčky,směsi přísad apod.ostatní,ne:viz sazebník', 'Sauces and preparations therefor, mixed condiments and mixed seasonings (excl. s'),
('21041000', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polévky,bujóny,přípravky pro polévky,bujóny', 'Soups and broths and preparations therefor'),
('21042000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi potravinových přípravků homogenizované', 'Food preparations consisting of finely homogenised mixtures of two or more basic'),
('21050010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zmrzlina,eskymo apod.výrobky obsahující mléčné tuky 0-méně něž 3%', 'Ice cream and other edible ice, whether or not containing cocoa, not containing'),
('21050091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zmrzlina,eskymo apod.výrobky,mléčné tuky 3-méně než 7%', 'Ice cream and other edible ice, containing >= 3% but < 7% milkfats'),
('21050099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zmrzlina,eskymo apod.výrobky,mléčné tuky 7% a více', 'Ice cream and other edible ice, containing >= 7% milkfats'),
('21061020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bílkovinné koncentráty,textur.látky obsah.0-1,5% ml.tuky,do 5% sacharóza apod.', 'Protein concentrates and textured protein substances, not containing milkfats, s'),
('21061080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bílkovinné koncentráty,texturované látky ostatní,ne:viz sazebník', 'Protein concentrates and textured protein substances, containing, by weight, >='),
('21069020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Složené alkoholické přípravky k výrobě nápojů,ne:na základě vonných látek', 'Compound alcoholic preparations of a kind used for the manufacture of beverages'),
('21069030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sirupy z isoglukózy ochucené aromatickými látkami i barvené', 'Flavoured or coloured isoglucose syrups'),
('21069051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sirupy z laktózy ochucené aromatickými látkami i barvené', 'Flavoured or coloured lactose syrups'),
('21069055', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sirupy z glukózy,maltodextrinu ochucené aromatickými látkami i barvené', 'Flavoured or coloured glucose and maltodextrine syrups'),
('21069059', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sirupy ost.ochuc.aromat.látkami i barvené,ne:z (iso)glukózy,laktózy,maltodextrinu', 'Flavoured or coloured sugar syrups (excl. isoglucose, lactose, glucose and malto'),
('21069092', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky potravinářské ost.obsah.0-1,5% ml.tuků,0-5% sacharózy,glukózy apod.', 'Food preparations, n.e.s., not containing milkfats, sucrose, isoglucose starch o'),
('21069098', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky potravinářské ost.obsah.1,5% a víc ml.tuků,5% a víc sacharózy,glukózy apod.', 'Food preparations, n.e.s., containing, by weight, >= 1,5% milkfat, >= 5% sucrose'),
('22011011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Minerální vody přírodní bez oxidu uhličitého,neslazené,nearomatizované', 'Mineral waters, natural, not containing added sugar or other sweetening matter n'),
('22011019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Minerální vody přírodní s oxidem uhličitým,neslazené,nearomatizované', 'Mineral waters, natural, not containing added sugar or other sweetening matter n'),
('22011090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Minerální vody jiné než přírodní a sodovky', 'Mineral waters, artificial, not containing added sugar or other sweetening matte'),
('22019000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vody neslazené,nearomatizované ostatní,led,sníh,ne:minerální vody', 'Ordinary natural water, not containing added sugar, other sweetening matter or f'),
('22021000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Voda včetně minerální,sodovky slazené,aromatizované', 'Waters, incl. mineral and aerated, with added sugar, sweetener or flavour, for d'),
('22029010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Nápoje nealkoholické neobsahující mléko,smetanu,tuky,ne:zeleninové,ovocné', 'Non-alcoholic beverages, not containing milk, milk products and fats derived the'),
('22029091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Nápoje nealkoholické,obsah.tuky z mléka apod.méně než 0,2%', 'Non-alcoholic beverages containing < 0,2% fats derived from milk or milk product'),
('22029095', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Nápoje nealkoholické,obsah.tuky z mléka apod.0,2% do méně než 2%', 'Non-alcoholic beverages containing >= 0,2% but < 2% fats derived from milk or mi'),
('22029099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Nápoje nealkoholické,obsah.tuky z mléka apod.2% a více', 'Non-alcoholic beverages containing >= 2% fats derived from milk or milk products'),
('22030001', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Pivo ze sladu v lahvích o obsahu nepřesahujícím 10 litrů', 'Beer made from malt, in bottles holding <= 10 l'),
('22030009', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Pivo ze sladu v nádobách o obsahu nepřesahujícím 10 litrů,ne:v lahvích', 'Beer made from malt, in containers holding <= 10 l (excl. in bottles)'),
('22030010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Pivo ze sladu v nádobách o obsahu převyšujícím 10 litrů', 'Malt beer, in containers holding > 10 l'),
('22041011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno šampaňské', 'Champagne, with PDO'),
('22041091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno šumivé-Asti spumante', 'Asti spumante of actual alcoholic strength of < 8,5% vol'),
('22041093', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno šumivé s chráněným označením původu (ChOP) ost.,ne:šampaňské,Asti spumante', 'Sparkling wine of fresh grapes with a protected designation of origin (PDO) (exc'),
('22041094', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno šumivé s chráněným zeměpisným označením (ChZO)', 'Sparkling wine of fresh grapes with a protected geographical indication (PGI)'),
('22041096', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno šumivé odrůdové ostatní', 'Varietal sparkling wines of fresh grapes without PDO and PGI'),
('22041098', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno šumivé ostatní,ne:viz sazebník', 'Sparkling wine of fresh grapes (excl. varietal wines)'),
('22042106', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno,přetlak >=1 <3 bary,láhve se svorkou,<=2l,s chr.ozn.původu (ChOP),ne:položka 2204 10', 'Wine of fresh grapes, incl. fortified wines, in bottles with "mushrooms" stopper'),
('22042107', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno,přetlak >=1 <3 bary,láhve se svorkou,<=2l,s chr.zeměp.ozn.(ChZO),ne:položka 2204 10', 'Wine of fresh grapes, incl. fortified wines, in bottles with "mushrooms" stopper'),
('22042108', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno,přetlak >=1 <3 bary,láhve se svorkou,<=2l,odrůdové ostatní,ne:položka 2204 10,ChOP,ChZO', 'Wine of fresh grapes, incl. fortified wines, in bottles with "mushrooms" stopper'),
('22042109', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno,přetlak >=1 <3 bary,láhve se svorkou,<=2l,ostatní,ne:viz sazebník', 'Other wine of fresh grapes, incl. fortified wines, in bottles with "mushrooms" s'),
('22042111', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé <=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Alsace', 'White wines produced in Alsace, in containers holding <= 2 l and of an actual al'),
('22042112', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé <=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Bordeaux', 'White wines produced in Bordeaux, in containers holding <= 2 l and of an actual'),
('22042113', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé <=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Bourgogne', 'White wines produced in Burgundy, in containers holding <= 2 l and of an actual'),
('22042117', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé <=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP)Val De Loire', 'White wines produced in Val de Loire, in containers holding <= 2 l and of an act'),
('22042118', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé <=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Mosel-Saar-Ruwer', 'White wines produced in Mosel, in containers holding <= 2 l and of an actual alc'),
('22042119', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé <=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Pfalz', 'White wines produced in Pfalz, in containers holding <= 2 l and of an actual alc'),
('22042122', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé <=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Rheinhessen', 'White wines produced in Rheinhessen, in containers holding <= 2 l and of an actu'),
('22042123', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé <=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Tokaj', 'White wines produced in Tokaj "e.g. Aszu, Szamorodni, MĂˇslĂˇs, FordĂ­tĂˇs", in'),
('22042124', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé <=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Lazio', 'White wines produced in Lazio [Latium], in containers holding <= 2 l and of an a'),
('22042126', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé <=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Toscana', 'White wines produced in Toscana [Tuscany], in containers holding <= 2 l and of a'),
('22042127', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé <=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Trentino,Alto Adige a Friuli', 'White wines produced in Trentino, Alto Adige and Friuli, in containers holding <'),
('22042128', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé <=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Veneto', 'White wines produced in Veneto, in containers holding <= 2 l and of an actual al'),
('22042132', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé <=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Vinho Verde', 'White wines of the "vinho verde" category, produced in the Community, in contain'),
('22042134', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé <=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Penedés', 'White wines produced in PenedĂ©s, in containers holding <= 2 l and of an actual'),
('22042136', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé <=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Rioja', 'White wines produced in Rioja, in containers holding <= 2 l and of an actual alc'),
('22042137', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé <=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Valencia', 'White wines produced in Valencia, in containers holding <= 2 l and of an actual'),
('22042138', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé <=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP),ne:viz sazebník', 'White wines produced in the Community, in containers holding <= 2 l and of an ac'),
('22042142', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.<=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Bordeaux,ne:bílé', 'Wines produced in Bordeaux, in containers holding <= 2 l and of an actual alcoho'),
('22042143', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.<=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Bourgogne,ne:bílé', 'Wines produced in Bourgogne (Burgundy), in containers holding <= 2 l and of an a'),
('22042144', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.<=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Beaujolais,ne:bílé', 'Wines produced in Beaujolais, in containers holding <= 2 l and of an actual alco'),
('22042146', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.<=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Cotes Du Rhone,ne:bílé', 'Wines produced in CĂ´tes-du-RhĂ´ne, in containers holding <= 2 l and of an actua'),
('22042147', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.<=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Languedoc Rouss.,ne:bílé', 'Wines produced in Languedoc-Roussillon, in containers holding <= 2 l and of an a'),
('22042148', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.<=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Val de Loire,ne:bílé', 'Wines produced in Val de Loire, in containers holding <= 2 l and of an actual al'),
('22042162', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.<=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Piemonte,ne:bílé', 'Wines produced in Piemonte [Piedmont], in containers holding <= 2 l and of an ac'),
('22042166', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.<=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Toscana,ne:bílé', 'Wines produced in Toscana [Tuscany], in containers holding <= 2 l and of an actu'),
('22042167', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.<=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Trentino,Alto Ad,ne:bílé', 'Wines produced in Trentino and Alto Adige, in containers holding <= 2 l and of a'),
('22042168', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.<=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Veneto,ne:bílé', 'Wines produced in Veneto, in containers holding <= 2 l and of an actual alcoholi'),
('22042169', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.<=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Dao,Bairrada,Douro,ne:bílé', 'Wines produced in DÄ�o, Bairrada and Douro, in containers holding <= 2 l and of'),
('22042171', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.<=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Navarra,ne:bílé', 'Wines produced in Navarra, in containers holding <= 2 l and of an actual alcohol'),
('22042174', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.<=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Penedés,ne:bílé', 'Wines produced in PenedĂ©s, in containers holding <= 2 l and of an actual alcoho'),
('22042176', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.<=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Rioja,ne:bílé', 'Wines produced in Rioja, in containers holding <= 2 l and of an actual alcoholic'),
('22042177', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.<=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Valdepenas,ne:bílé', 'Wines produced in ValdepeĹ"as, in containers holding <= 2 l and of an actual alc'),
('22042178', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.<=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP),ne:bílé,obl.viz sazebník', 'Wines produced in the Community, in containers holding <= 2 l and of an actual a'),
('22042179', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé <=15% vol,obaly <=2l,z ES,s chr.zeměp.ozn.(ChZO)', 'White wine produced in the Community, in containers holding <= 2 l and of an act'),
('22042180', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.<=15% vol,obaly <=2l,z ES,s chr.zeměp.ozn.(ChZO),ne:bílé', 'Wine produced in the Community, in containers holding <= 2 l and of an actual al'),
('22042181', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé <=15% vol,obaly <=2l,z ES,odrůdové ostatní,ne:ChOP,ChZO', 'Varietal white wines without PDO and PGI, produced in the Community, in containe'),
('22042182', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.<=15% vol,obaly <=2l,z ES,odrůdové ostatní,ne:bílé,ChOP,ChZO', 'Varietal wines without PDO and PGI, produced in the Community, in containers hol'),
('22042183', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé <=15% vol,obaly <=2l,z ES,ostatní,ne:ChOP,ChZO,odrůdové', 'White wines produced in the Community, in containers holding <= 2 l and of an ac'),
('22042184', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.<=15% vol,obaly <=2l,z ES,ostatní,ne:bílé,ChOP,ChZO,odrůdové', 'Wines produced in the Community, in containers holding <= 2 l and of an actual a'),
('22042185', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno >15 <=22% vol,obaly <=2l,z ES,s chr.ozn.pův.(ChOP),chr.zem.ozn.(ChZO) Madeira,Setubal muscatel', 'Madeira and Setubal muscatel, in containers holding <= 2 l and of an actual alco'),
('22042186', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno >15 <=22% vol,obaly <=2l,z ES,s chr.ozn.pův.(ChOP),chr.zem.ozn.(ChZO) Sherry', 'Sherry, in containers holding <= 2 l and of an actual alcoholic strength of > 15'),
('22042187', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno >15 <=22% vol,obaly <=2l,z ES,s chr.ozn.pův.(ChOP),chr.zem.ozn.(ChZO) Marsala', 'Marsala, in containers holding <= 2 l and of an actual alcoholic strength of > 1'),
('22042188', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno >15 <=22% vol,obaly <=2l,z ES,s chr.ozn.pův.(ChOP),chr.zem.ozn.(ChZO) Samos,Muscat de Lemnos', 'Samos and Muscat de Lemnos, in containers holding <= 2 l and of an actual alcoho'),
('22042189', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno >15 <=22% vol,obaly <=2l,z ES,s chr.ozn.pův.(ChOP),chr.zem.ozn.(ChZO) Porto', 'Port, in containers holding <= 2 l and of an actual alcoholic strength of > 15%'),
('22042190', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno >15 <=22% vol,obaly <=2l,z ES,s chr.ozn.pův.(ChOP),chr.zem.ozn.(ChZO) ostatní,ne:viz sazebník', 'Wines produced in the Community, in containers holding <= 2 l and of an actual a'),
('22042191', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno >15 <=22% vol,obaly <=2l,z ES,ostatní,ne:s chr.ozn.pův.(ChOP),chr.zem.ozn.(ChZO)', 'Wines without PDO and PGI, produced in the Community, in containers holding <= 2'),
('22042192', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno >22% vol,obaly <=2l,z ES', 'Wine of fresh grapes, incl. fortified wine, produced in the Community, in contai'),
('22042193', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé,obaly <=2l,s chr.ozn.pův.(ChOP),chr.zem.ozn.(ChZO),ne:z ES', 'White wines not produced in the Community, in containers holding <= 2 l, with PD'),
('22042194', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.,obaly <=2l,s chr.ozn.pův.(ChOP),chr.zem.ozn.(ChZO),ne:z ES,bílé', 'Wines not produced in the Community, in containers holding <= 2 l, with PDO or P'),
('22042195', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé,obaly <=2l,odrůdové ostatní,ne:z ES,s chr.ozn.pův.(ChOP),chr.zem.ozn.(ChZO)', 'Varietal white wines without PDO and PGI, not produced in the Community, in cont'),
('22042196', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.,obaly <=2l,odrůdové ostatní,ne:z ES,s chr.ozn.pův.(ChOP),chr.zem.ozn.(ChZO),bílé', 'Varietal wines without PDO and PGI, not produced in the Community, in containers'),
('22042197', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé,obaly <=2l,ostatní,ne:zES,s chr.ozn.pův.(ChOP),chr.zem.ozn.(ChZO),odrůdové', 'White wines not produced in the Community, in containers holding <= 2 l (other t'),
('22042198', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.,obaly <=2l,ostatní,ne:z ES,s chr.ozn.pův.(ChOP),chr.zem.ozn.(ChZO),odrůdové,bílé', 'Wines not produced in the Community, in containers holding <= 2 l (other than sp'),
('22042910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno,přetlak >=1 <3 bary,láhve se svorkou,>2l,ne:položka 2204 10', 'Wine of fresh grapes, incl. fortified wines, in bottles with "mushroom" stoppers'),
('22042911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé <=15% vol,obaly >2l,z ES,s chr.ozn.původu (ChOP) Tokaj', 'White wines produced in Tokaj "e.g. Aszu, Szamorodni, MĂˇslĂˇs, FordĂ­tĂˇs", in'),
('22042912', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé <=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Bordeaux', 'White wines produced in Bordeaux, in containers holding > 2 l and of an actual a'),
('22042913', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé <=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Burgogne', 'Quality white wines produced in Bourgogne (Burgundy), in containers holding > 2'),
('22042917', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé <=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Val de Loire', 'White wines produced in Val de Loire, in containers holding > 2 l and of an actu'),
('22042918', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé <=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP),ne:viz sazebník', 'White wines produced in the Community, in containers holding > 2 l and of an act'),
('22042942', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.<=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Bordeaux,ne:bílé', 'Wines produced in Bordeaux, in containers holding > 2 l and of an actual alcohol'),
('22042943', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.<=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Bourgogne,ne:bílé', 'Wines produced in Bourgogne (Burgundy), in containers holding > 2 l and of an ac'),
('22042944', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.<=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Beaujolais,ne:bílé', 'Wines produced in Beaujolais, in containers holding > 2 l and of an actual alcoh'),
('22042946', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.<=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Cotes du Rhone,ne:bílé', 'Wines produced in CĂ´tes-du-RhĂ´ne, in containers holding > 2 l and of an actual'),
('22042947', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.<=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Languedoc-Rous.,ne:bílé', 'Wines produced in Languedoc-Roussillon, in containers holding > 2 l and of an ac'),
('22042948', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.<=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP) Val de Loire,ne:bílé', 'Wines produced in Val de Loire, in containers holding > 2 l and of an actual alc'),
('22042958', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.<=15% vol,obaly <=2l,z ES,s chr.ozn.původu (ChOP),ne:bílé,viz sazebník', 'Wines produced in the Community, in containers holding > 2 l and of an actual al'),
('22042979', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé <=15% vol,obaly >2l,z ES,s chr.zeměp.ozn.(ChZO)', 'White wine of fresh grapes, produced in the Community, in containers holding > 2'),
('22042980', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.<=15% vol,obaly >2l,z ES,s chr.zeměp.ozn.(ChZO),ne:bílé', 'Wines of fresh grapes, produced in the Community, in containers holding > 2 l an'),
('22042981', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé <=15% vol,obaly >2l,z ES,odrůdové ostatní,ne:ChOP,ChZO', 'Varietal white wines without PDO and PGI, produced in the Community, in containe'),
('22042982', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.<=15% vol,obaly >2l,z ES,odrůdové ostatní,ne:bílé,ChOP,ChZO', 'Varietal wines without PDO and PGI, produced in the Community, in containers hol'),
('22042983', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé <=15% vol,obaly >2l,z ES,ostatní,ne:ChOP,ChZO,odrůdové', 'White wines produced in the Community, in containers holding > 2 l and of an act'),
('22042984', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.<=15% vol,obaly >2l,z ES,ostatní,ne:bílé,ChOP,ChZO,odrůdové', 'Wines produced in the Community, in containers holding > 2 l and of an actual al'),
('22042985', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno >15 <=22% vol,obaly >2l,z ES,s chr.ozn.pův.(ChOP),chr.zem.ozn.(ChZO) Madeira,Setubal muscatel', 'Madeira and Setubal muscatel, in containers holding > 2 l and of an actual alcoh'),
('22042986', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno >15 <=22% vol,obaly >2l,z ES,s chr.ozn.pův.(ChOP),chr.zem.ozn.(ChZO) Sherry', 'Sherry, in containers holding > 2 l and of an actual alcoholic strength of  > 15'),
('22042987', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno >15 <=22% vol,obaly >2l,z ES,s chr.ozn.pův.(ChOP),chr.zem.ozn.(ChZO) Marsala', 'Marsala, in containers holding > 2 l and of an actual alcoholic strength of > 15'),
('22042988', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno >15 <=22% vol,obaly >2l,z ES,s chr.ozn.pův.(ChOP),chr.zem.ozn.(ChZO) Samos,Muscat de Lemnos', 'Samos and Muscat de Lemnos, in containers holding > 2 l and of an actual alcohol'),
('22042989', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno >15 <=22% vol,obaly >2l,z ES,s chr.ozn.pův.(ChOP),chr.zem.ozn.(ChZO) Porto', 'Port, in containers holding > 2 l and of an actual alcoholic strength of > 15% v'),
('22042990', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno >15 <=22% vol,obaly >2l,z ES,s chr.ozn.pův.(ChOP),chr.zem.ozn.(ChZO),ne:viz sazebník', 'Wines produced in the Community, in containers holding > 2 l and of an actual al'),
('22042991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno >15 <=22% vol,obaly >2l,z ES,ostatní,ne:s chr.ozn.pův.(ChOP),chr.zem.ozn.(ChZO)', 'Wines without PDO and PGI, produced in the Community, in containers holding > 2'),
('22042992', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno >22% vol,obaly >2l,z ES', 'Wine of fresh grapes, incl. fortified wine, produced in the Community, in contai'),
('22042993', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé,obaly >2l,s chr.ozn.pův.(ChOP),chr.zem.ozn.(ChZO),ne:z ES', 'White wines not produced in the Community, in containers holding > 2 l, with PDO'),
('22042994', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.,obaly >2l,s chr.ozn.pův.(ChOP),chr.zem.ozn.(ChZO),ne:z ES,bílé', 'Wines not produced in the Community, in containers holding > 2 l, with PDO or PG'),
('22042995', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé,obaly >2l,odrůdové ostatní,ne:z ES,s chr.ozn.pův.(ChOP),chr.zem.ozn.(ChZO)', 'Varietal white wines without PDO and PGI, not produced in the Community, in cont'),
('22042996', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.,obaly >2l,odrůdové ostatní,ne:z ES,s chr.ozn.pův.(ChOP),chr.zem.ozn.(ChZO),bílé', 'Varietal wines without PDO and PGI, not produced in the Community, in containers'),
('22042997', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno bílé,obaly >2l,ostatní,ne:zES,s chr.ozn.pův.(ChOP),chr.zem.ozn.(ChZO),odrůdové', 'White wines not produced in the Community, in containers holding > 2 l (other th'),
('22042998', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Víno ost.,obaly >2l,ostatní,ne:z ES,s chr.ozn.pův.(ChOP),chr.zem.ozn.(ChZO),odrůdové,bílé', 'Wines not produced in the Community, in containers holding > 2 l (other than spa'),
('22043010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Mošt vinný částečně kvašený (fermentovaný) i zastav.kvaš.,ne:přidáním alkoholu', 'Grape must, arrested otherwise than by addition of alcohol, of an actual alcohol'),
('22043092', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Mošt vinný,do 1,33g/cm3,alkohol do 1%,koncentrovaný', 'Grape must, unfermented, concentrated within the meaning of Additional Note 7 to'),
('22043094', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Mošt vinný ostatní,do 1,33g/cm3,alkohol do 1%,ne:koncentrovaný', 'Grape must, unfermented, non-concentrated, of a density <= 1,33 g/cm3 at 20Â°C a'),
('22043096', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Mošt vinný,nad 1,33g/cm3,alkohol nad 1%,koncentrovaný', 'Grape must, unfermented, concentrated within the meaning of Additional Note 7 to'),
('22043098', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Mošt vinný ostatní,nad 1,33g/cm3,alkohol nad 1%,ne:koncentrovaný', 'Grape must, unfermented, non-concentrated, of a density > 1,33 g/cm3 at 20Â°C an'),
('22051010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Vermut,víno s bylinami,aromatickými látkami,alkohol do 18%,nádoby do 2 l', 'Vermouth and other wine of fresh grapes, flavoured with plants or aromatic subst'),
('22051090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Vermut,víno s bylinami,aromatickými látkami,alkohol nad 18%,nádoby do 2 l', 'Vermouth and other wine of fresh grapes, flavoured with plants or aromatic subst'),
('22059010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Vermut,víno s bylinami,aromatickými látkami,alkohol do 18%,nádoby nad 2 l', 'Vermouth and other wine of fresh grapes, flavoured with plants or aromatic subst'),
('22059090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Vermut,víno s bylinami,aromatickými látkami,alkohol nad 18%,nádoby nad 2 l', 'Vermouth and other wine of fresh grapes, flavoured with plants or aromatic subst'),
('22060010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Matolinovice', 'Piquette, obtained by grape marc'),
('22060031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Zkvašené nápoje šumivé jablečné a hruškové', 'Cider and perry, sparkling'),
('22060039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Směsi ostatních nápojů s révovými víny', 'Mead and other fermented beverages and mixtures of fermented beverages and mixtu'),
('22060051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Nápoje zkvašené ostatní (medovina,jablečné apod.)', 'Cider and perry, not sparkling, in containers holding <= 2 l'),
('22060059', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Směsi ostatních nápojů s víny,ne:šumivé,do 2 l', 'Mead and other fermented beverages and mixtures of fermented beverages and mixtu'),
('22060081', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Nápoje zkvašené jablečné a hruškové,ne:šumivé,nad 2 l', 'Cider and perry, not sparkling, in containers holding > 2 l'),
('22060089', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Směsi ostatních nápojů s víny,ne:šumivé,nad 2 l', 'Mead and other fermented beverages and mixtures of fermented beverages and mixtu'),
('22071000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Ethylalkohol nedenatur.ost.,objem alkoholu 80% vol a víc,ne:sazebník', 'Undenatured ethyl alcohol, of actual alcoholic strength of >= 80%'),
('22072000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Destiláty denaturované s jakýmkoliv alkoholometrickým titrem', 'Denatured ethyl alcohol and other spirits of any strength'),
('22082012', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Koňak,nádoba do 2 l', 'Cognac, in containers holding <= 2 l'),
('22082014', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Armagnac,nádoba do 2 l', 'Armagnac, in containers holding <= 2 l'),
('22082026', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Grappa,nádoba do 2 l', 'Grappa, in containers holding <= 2 l'),
('22082027', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Brandy de Jerez,nádoba do 2l', 'Brandy de Jerez in containers holding <= 2 l'),
('22082029', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Destiláty z vinných matolin,hroznů ost.,ne:koňak,Armagnac,Grappa,Brandy de Jerez', 'Spirits obtained by distilling grape wine or grape marc, in containers holding <'),
('22082040', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Čisté destiláty,nádoba nad 2 l', 'Raw distillate, in containers holding > 2 l'),
('22082062', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Koňak,nádoba nad 2 l', 'Cognac, in containers holding > 2 l'),
('22082064', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Armagnac,nádoba nad 2 l', 'Armagnac, in containers holding > 2 l'),
('22082086', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Grappa,nádoba nad 2 l', 'Grappa, in containers holding > 2 l'),
('22082087', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Brandy de Jerez,nádoba nad 2l', 'Brandy de Jerez in containers holding > 2 l'),
('22082089', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Destiláty z vinných matolin,hroznů,ostatní,obal nad 2l,ne:viz sazebník', 'Spirits obtained by distilling grape wine or grape marc, in containers holding >'),
('22083011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Whisky bourbon,nádoba do 2 l', 'Bourbon whiskey, in containers holding <= 2 l'),
('22083019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Whisky bourbon,nádoba nad 2l', 'Bourbon whiskey, in containers holding > 2 l'),
('22083030', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Whisky skotská sladová čistá', 'Single malt Scotch whisky'),
('22083041', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Whisky skotská sladová míchaná,nádoba <=2l', 'Blended malt Scotch whisky, in containers holding <= 2Â l'),
('22083049', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Whisky skotská sladová míchaná,nádoba >2l', 'Blended malt Scotch whisky, in containers holding > 2 l'),
('22083061', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Whisky skotská obilná čistá,míchaná,nádoba <=2l', 'Single grain and blended grain Scotch whisky, in containers holding <= 2 l'),
('22083069', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Whisky skotská obilná čistá,míchaná,nádoba >2l', 'Single grain and blended grain Scotch whisky, in containers holding > 2 l'),
('22083071', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Whisky skotská ostatní míchaná,nádoba <=2l', 'Scotch whisky, in containers holding <= 2 l (other than single malt, blended mal'),
('22083079', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Whisky skotská ostatní míchaná,nádoba <=2l', 'Scotch whisky, in containers holding > 2 l (other than single malt, blended malt'),
('22083082', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Whisky ostatní,nádoba <=2l,ne:bourbon,skotská', 'Whisky, in containers holding <= 2 l (other than Bourbon whiskey and Scotch whis'),
('22083088', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Whisky ostatní,nádoba >2l,ne:bourbon,skotská', 'Whisky, in containers holding > 2 l (other than Bourbon whiskey and Scotch whisk'),
('22084011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Rum,nádoba do 2 l-podmínky viz sazebník', 'Rum with a content of volatile substances (other than ethyl and methyl alcohol)'),
('22084031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Rum ost.,obal do 2 ltr,hodnota nad 7,9 Euro/LPA,ne:viz sazebník', 'Rum and other spirits obtained by distilling fermented sugar-cane products, of a'),
('22084039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Rum,nádoba do 2 l ostatní,ne:viz sazebník', 'Rum and other spirits obtained by distilling fermented sugar-cane products, of a'),
('22084051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Rum,nádoba nad 2 l-podmínky viz sazebník', 'Rum with a content of volatile substances (other than ethyl and methyl alcohol)'),
('22084091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Rum ost.,obal nad 2 ltr,hodnota nad 7,9 Euro/LPA,ne:viz sazebník', 'Rum and other spirits obtained by distilling fermented sugar-cane products, of a'),
('22084099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Rum,nádoba nad 2 l ostatní,ne:viz sazebník', 'Rum and other spirits obtained by distilling fermented sugar-cane products, of a'),
('22085011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Džin,nádoba do 2 l', 'Gin, in containers holding <= 2 l'),
('22085019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Džin,nádoba nad 2 l', 'Gin, in containers holding > 2 l'),
('22085091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Jalovcová,nádoba do 2 l', 'Geneva, in containers holding <= 2 l'),
('22085099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Jalovcová,nádoba nad 2 l', 'Geneva, in containers holding > 2 l'),
('22086011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Vodka-alkohol do 45,4%vol,nádoba do 2 l', 'Vodka of an alcoholic strength of <= 45,4% vol, in containers holding <= 2 l'),
('22086019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Vodka-alkohol do 45,4%vol,nádoba nad 2l', 'Vodka of an alcoholic strength of <= 45,4% vol, in containers holding > 2 l'),
('22086091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Vodka-alkohol nad 45,4%vol,nádoba do 2l', 'Vodka of an alcoholic strength of > 45,4% vol, in containers holding <= 2 l'),
('22086099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Vodka-alkohol nad 45,4%vol,nádoba nad 2 l', 'Vodka of an alcoholic strength of > 45,4% vol, in containers holding > 2 l'),
('22087010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Likéry,cordialy,nádoba do 2 l', 'Liqueurs and cordials, in containers holding <= 2 l'),
('22087090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Likéry,cordialy,nádoba nad 2 l', 'Liqueurs and cordials, in containers holding > 2 l'),
('22089011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Arak,nádoba do 2 l', 'Arrack, in containers holding <= 2 l'),
('22089019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Arak,nádoba nad 2 l', 'Arrack, in containers holding > 2 l'),
('22089033', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Slivovice,hruškovice,třešňovice,nádoba do 2 l,ne:likéry', 'Plum, pear or cherry spirit, in containers holding <= 2 l'),
('22089038', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Slivovice,hruškovice,třešňovice,nádoba nad 2 l,ne:likéry', 'Plum, pear or cherry spirit, in containers holding > 2 l'),
('22089041', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Ouzo,nádoba do 2 l', 'Ouzo, in containers holding <= 2 l'),
('22089045', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Kalvados,nádoba do 2 l', 'Calvados, in containers holding <= 2 l'),
('22089048', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Destiláty z ovoce ostatní,nádoba do 2 l,ne:likéry,druhy viz sazebník', 'Spirits distilled from fruit, in containers holding <= 2 l (excl. plum, pear or'),
('22089052', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Korn,nádoba do 2 l', 'Korn, in containers holding <= 2 l'),
('22089054', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Tequila v nádobách o obsahu nepřesahujícím 2 litry', 'Tequila in containers holding <= 2 l'),
('22089056', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Ostatní destiláty (vyjma likéry) v nádobách o obsahu nepřesahujícím 2 litry', 'Spirits in containers holding <= 2 l (excl. spirits distilled from grape wine or'),
('22089069', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Nápoje lihové ostatní,nádoby do 2 l,ne:likéry,destiláty', 'Spirituous beverages, in containers holding <= 2 l (excl. ouzo, spirits, liqueur'),
('22089071', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Destiláty z ovoce,obal nad 2 l,ne:likéry,druhy viz sazebník', 'Spirits distilled from fruit, in containers holding > 2 l (excl. spirits distill'),
('22089075', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Tequila v nádobách o obsahu převyšujícím 2 litry', 'Tequila in containers holding > 2 l'),
('22089077', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Ostatní destiláty (vyjma likéry) v nádobách o obsahu převyšujícím 2 litry', 'Spirits in containers holding > 2 l (excl. spirits obtained by distilling grape'),
('22089078', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Nápoje lihové ostatní,nádoby nad 2l,ne:viz sazebník', 'Spirituous beverages, in containers holding > 2 l (excl. spirits, liqueurs and c'),
('22089091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Ethylalkohol nedenaturovaný,alkohol méně něž 80%vol,nádoba do 2 l', 'Undenatured ethyl alcohol, of an alcoholic strength of < 80% vol, in containers'),
('22089099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LPA'), 'Ethylalkohol nedenaturovaný,alkohol méně než 80%vol,nádoba nad 2 l', 'Undenatured ethyl alcohol, of an alcoholic strength of < 80% vol, in containers'),
('22090011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Ocet vinný,nádoba do 2 l', 'Wine vinegar, in containers holding <= 2 l'),
('22090019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Ocet vinný,nádoba nad 2 l', 'Wine vinegar, in containers holding > 2 l'),
('22090091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Ocet stolní,náhražky z kyseliny octové,nádoba do 2 l,ne:vinný', 'Vinegar and substitutes for vinegar obtained from acetic acid, in containers hol'),
('22090099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'LTR'), 'Ocet stolní,náhražky z kyseliny octové,nádoba nad 2 l,ne:vinný', 'Vinegar and substitutes for vinegar obtained from acetic acid, in containers hol'),
('23011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Moučka,šrot,peleta z masa,drobů,škvarky nezpůsobilé k lidskému požívání', 'Flours, meals and pellets, of meat or offal, unfit for human consumption; greave'),
('23012000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Moučka,šrot,peleta z ryb,korýšů,jiných bezobratlých,nezp.k lidskému požívání', 'Flours, meals and pellets of fish or crustaceans, molluscs or other aquatic inve'),
('23021010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Otruby,výrobky vedlejší mlýnské,jiné zbytky kukuřičné,škrob do 35%', 'Bran, sharps and other residues of maize, whether or not in the form of pellets,'),
('23021090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Otruby,výrobky vedlejší mlýnské,jiné zbytky kukuřičné,škrob nad 35%', 'Bran, sharps and other residues of maize, whether or not in the form of pellets,'),
('23023010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Otruby,výrobky vedlejší mlýnské,jiné zbytky pšeničné,škrob do 28% + sazebník', 'Bran, sharps and other residues, whether or not in the form of pellets, derived'),
('23023090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Otruby,výrobky vedlejší mlýnské,jiné zbytky pšeničné,škrob nad 28% + sazebník', 'Bran, sharps and other residues of wheat, whether or not in the form of pellets,'),
('23024002', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Otruby,výrobky vedlejší mlýnské,jiné zbytky rýžové,škrob do 35%', 'Bran, sharps and other residues of rice, whether or not in the form of pellets,'),
('23024008', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Otruby,výrobky vedlejší mlýnské,jiné zbytky rýžové,škrob nad 35%', 'Bran, sharps and other residues of rice, whether or not in the form of pellets,'),
('23024010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Otruby,výrobky vedlejší mlýnské,jiné zbytky z obilí ost.,škrob do 28%+sazebník', 'Bran, sharps and other residues, in the form of pellets or not, derived from the'),
('23024090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Otruby,výrobky vedlejší mlýnské,jiné zbytky z obilí ost.,škrob nad 28%+sazebník', 'Bran, sharps and other residues of cereals, whether or not in the form of pellet'),
('23025000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Otruby,výrobky vedlejší mlýnské,jiné zbytky luštěninové', 'Bran, sharps and other residues of leguminous plants, whether or not in the form'),
('23031011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zbytky z výroby kukuřičného škrobu,protein nad 40%,ne:koncentrované likéry', 'Residues from the manufacture of starch from maize, of a protein content, calcul'),
('23031019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zbytky z výroby kukuřičného škrobu,protein do 40%,ne:koncentrované likéry', 'Residues from the manufacture of starch from maize, of a protein content, calcul'),
('23031090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zbytky škrobárenské a jiné ostatní,ne:kukuřičné', 'Residues of starch manufacture and similar residues, incl. concentrated steeping'),
('23032010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Řízky řepné s obsahem', 'Beet-pulp'),
('23032090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bagasa a jiné cukrovarnické odpady,ne:řízky řepné', 'Bagasse and other waste of sugar manufacture (excl. beet pulp)'),
('23033000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mláto,odpady pivovarnické,lihovarnické', 'Brewing or distilling dregs and waste'),
('23040000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pokrutiny,odpad i drcené,ve tvaru pelet po extrahování sojového oleje', 'Oilcake and other solid residues, whether or not ground or in the form of pellet'),
('23050000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pokrutiny,odpad i drcené,ve tvaru pelet po extrahování arašídového oleje', 'Oilcake and other solid residues, whether or not ground or in the form of pellet'),
('23061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pokrutiny,odpad i drcené,ve tvaru pelet po extrahování oleje z bavlník.semen', 'Oilcake and other solid residues, whether or not ground or in the form of pellet'),
('23062000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pokrutiny,odpad i drcené ve tvaru pelet po extrahování oleje z lněných semen', 'Oilcake and other solid residues, whether or not ground or in the form of pellet'),
('23063000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pokrutiny,odpad i drcené,ve tvaru pelet po extrahování oleje ze slunečnic.semen', 'Oilcake and other solid residues, whether or not ground or in the form of pellet'),
('23064100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pokrutiny,odpad po extr.oleje ze semen řepky,nízký obs.kys.erukové', 'Oilcake and other solid residues, whether or not ground or in the form of pellet'),
('23064900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pokrutiny,odpad po extr.oleje ze semen řepky ost.,ne:nízký obs.kys.erukové', 'Oilcake and other solid residues, whether or not ground or in the form of pellet'),
('23065000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pokrutiny,odpad i drcené,pelety po extrahování oleje z ořechů kokosových,kopry', 'Oilcake and other solid residues, whether or not ground or in the form of pellet'),
('23066000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pokrutiny,odpad i drcené,pelety po extrahování oleje z palmových ořechů,jader', 'Oilcake and other solid residues, whether or not ground or in the form of pellet'),
('23069005', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pokrutiny,odpad i drcené,pelety po extrakci olejů z kukuřičných klíčků', 'Oilcake and other solid residues, whether or not ground or in the form of pellet'),
('23069011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pokrutiny olivové a jiné zbytky po extrakci olivového oleje,olivový olej do 3%', 'Oilcake and other solid residues from the extraction of olive oil, whether or no'),
('23069019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pokrutiny olivové a jiné zbytky po extrakci oliv.oleje,olivový olej nad 3%', 'Oilcake and other solid residues from the extraction of olive oil, whether or no'),
('23069090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pokrutiny,odpad i drcené,ve tvaru pelet ostatní,ne:viz sazebník', 'Oilcake and other solid residues, whether or not ground or in the form of pellet'),
('23070011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kal vinný,alkohol do 7,9%,hmotnost sušiny 25% a více', 'Wine lees, having a total alcoholic strength of <= 7,9% mas and a dry matter con'),
('23070019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kal vinný ostatní,ne:alkohol do 7,9% + hmotnost sušiny 25% a více', 'Wine lees (excl. wine lees having a total alcoholic strength of <= 7,9% and a dr'),
('23070090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kámen vinný surový', 'Argol'),
('23080011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výlisky z hroznů, obsah alkoholu do 4,3%, hmotnost v sušině 40% a více', 'Grape marc, of a kind used in animal feeding, whether or not in the form of pell'),
('23080019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výlisky z hroznů ost.,ne:obsah alkoholu do 4,3%+hmotn.sušiny 40% a více', 'Grape marc, of a kind used in animal feeding, whether or not in the form of pell'),
('23080040', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výlisky ovocné ostatní, kaštany, žaludy pro výživu zvířat,ne:z hroznů', 'Acorns and horse-chestnuts and pomace or marc of fruit, for animal feeding, whet'),
('23080090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zbytky, odpady rostlinné ostatní pro výživu zvířat,ne:viz sazebník', 'Maize stalks, maize leaves, fruit peel and other vegetable materials, waste, res'),
('23091011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výživa pro psy,kočky,drobný prodej,škrob 0-10%,mléčné výrobky 0-méně než 10%', 'Dog or cat food, put up for retail sale, containing glucose, glucose syrup, malt'),
('23091013', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výživa pro psy,kočky,drobný prodej,škrob 0-10%,mléčné výrobky 10%-méně než 50%', 'Dog or cat food, put up for retail sale, containing glucose, glucose syrup, malt'),
('23091015', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výživa pro psy,kočky,drobný prodej,škrob 0-10%,mléčné výrobky 50%-méně než 75%', 'Dog or cat food, put up for retail sale, containing glucose, glucose syrup, malt'),
('23091019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výživa pro psy,kočky,drobný prodej,škrob 0-10%,mléčné výrobky 75% a více', 'Dog or cat food, put up for retail sale, containing glucose, glucose syrup, malt'),
('23091031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výživa pro psy,kočky,drobný prodej,škrob nad 10-30%,mléčné výrobky 0-pod 10%', 'Dog or cat food, put up for retail sale, containing glucose, glucose syrup, malt'),
('23091033', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výživa pro psy,kočky,drobný prodej,škrob nad 10-30%,mléčné výr.10%-pod 50%', 'Dog or cat food, put up for retail sale, containing glucose, glucose syrup, malt'),
('23091039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výživa pro psy,kočky,drobný prodej,škrob nad 10-30%,mléčné výrobky 50% a více', 'Dog or cat food, put up for retail sale, containing glucose, glucose syrup, malt'),
('23091051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výživa pro psy,kočky,drobný prodej,škrob nad 30%,mléčné výrobky 0-méně něž 10%', 'Dog or cat food, put up for retail sale, containing glucose, glucose syrup, malt'),
('23091053', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výživa pro psy,kočky,drobný prodej,škrob nad 30%,mléčné výr.10%-méně než 50%', 'Dog or cat food, put up for retail sale, containing glucose, glucose syrup, malt'),
('23091059', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výživa pro psy,kočky,drobný prodej,škrob nad 30%,mléčné výrobky 50% a více', 'Dog or cat food, put up for retail sale, containing glucose, glucose syrup, malt'),
('23091070', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výživa pro psy,kočky,drobný prodej,obsah.mléčné výr.,ne:škrob,glukóza apod.', 'Dog or cat food put up for retail sale, containing no starch, glucose, maltodext'),
('23091090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výživa pro psy,kočky ostatní balení pro drobný prodej,ne:viz sazebník', 'Dog or cat food put up for retail sale, containing no starch, glucose, maltodext'),
('23099010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rozpustné výrobky z ryb,mořských savců k výživě zvířat,ne:kočky,psi-drobný prodej', 'Fish or marine mammal solubles, to supplement feedingstuffs produced in the agri'),
('23099020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky uvedené v poznámce 5 k této kapitole-viz sazebník', 'Residues from the manufacture of starch from maize referred to in Additional Not'),
('23099031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky k výživě zvířat,škrob 0-10%,mléčné výrobky 0-méně něž 10%', 'Preparations, incl. premixes, for animal food, containing glucose, glucose syrup'),
('23099033', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky k výživě zvířat,škrob 0-10%,mléčné výrobky 10%-méně něž 50%', 'Preparations, incl. premixes, for animal food, containing glucose, glucose syrup'),
('23099035', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky k výživě zvířat,škrob 0-10%,mléčné výrobky 50%-méně něž 75%', 'Preparations, incl. premixes, for animal food, containing glucose, glucose syrup'),
('23099039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky k výživě zvířat,škrob 0-10%,mléčné výrobky 75% a více', 'Preparations, incl. premixes, for animal food, containing glucose, glucose syrup'),
('23099041', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky k výživě zvířat,škrob nad 10-30%,mléčné výrobky 50% a více', 'Preparations, incl. premixes, for animal food, containing glucose, glucose syrup'),
('23099043', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky k výživě zvířat,škrob nad 10-30%,mléčné výrobky 10%-méně něž 50%', 'Preparations, incl. premixes, for animal food, containing glucose, glucose syrup'),
('23099049', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky k výživě zvířat,škrob nad 10-30%,mléčné výrobky 50% a více', 'Preparations, incl. premixes, for animal food, containing glucose, glucose syrup'),
('23099051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky k výživě zvířat,škrob nad 30%,mléčné výrobky 0-méně něž 10%', 'Preparations, incl. premixes, for animal food, containing glucose, glucose syrup'),
('23099053', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky k výživě zvířat,škrob nad 30%,mléčné výrobky 10%-méně něž 50%', 'Preparations, incl. premixes, for animal food, containing glucose, glucose syrup'),
('23099059', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky k výživě zvířat,škrob nad 30%,mléčné výrobky 50% a více', 'Preparations, incl. premixes, for animal food, containing glucose, glucose syrup'),
('23099070', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky k výživě zvířat obsahující mléčné výrobky,ne:škrob,glukózu apod.', 'Preparations, incl. premixes, for animal food, containing no starch, glucose, ma'),
('23099091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Řízky řepné s přidanou melasou', 'Beef-pulp with added molasses of a kind used in animal feeding'),
('23099095', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KCC'), 'Přípravky k výživě zvířat,obsah.45%a více chlorid chlorinu', 'Preparations of a kind used in animal feeding, containing by weight >=49% of cho'),
('23099099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní přípravky používané k výživě zvířat, jiné než pro psy a kočky, jinde nezahrnuté', 'Preparations of a kind used in animal feeding, containing no starch, glucose, gl'),
('24011035', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tabák neodřapíkovaný,sušený přirozenou cirkulací vzduchu (light air-cured)', 'Light air-cured tobacco, unstemmed or unstripped'),
('24011060', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tabák neodřapíkovaný,sušený při denním světle (sun-cured),orientálního typu', 'Sun-cured oriental type tobacco, unstemmed or unstripped'),
('24011070', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tabák neodřapíkovaný,sušený bez denního světla (dark air-cured)', 'Dark air-cured tobacco, unstemmed or unstripped'),
('24011085', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tabák neodřapíkovaný,sušený teplým vzduchem (flue-cured)', 'Flue-cured tobacco, unstemmed or unstripped'),
('24011095', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tabák neodřapíkovaný,ostatní,ne:viz sazebník', 'Tobacco, unstemmed or unstripped (excl. light air-cured, sun-cured oriental, dar'),
('24012035', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tabák částečně nebo úplně odřapíkovaný,sušený přirozenou cirkulací vzduchu (light air-cured)', 'Partly or wholly stemmed or stripped light air-cured tobacco, otherwise unmanufa'),
('24012060', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tabák částečně nebo úplně odřapíkovaný,sušený při denním světle (sun-cured),orientálního typu', 'Partly or wholly stemmed or stripped sun-cured oriental type tobacco, otherwise'),
('24012070', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tabák částečně nebo úplně odřapíkovaný,sušený bez denního světla (dark air-cured)', 'Partly or wholly stemmed or stripped dark air-cured tobacco, otherwise unmanufac'),
('24012085', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tabák částečně nebo úplně odřapíkovaný,sušený teplým vzduchem (flue-cured)', 'Partly or wholly stemmed or stripped flue-cured tobacco, otherwise unmanufacture'),
('24012095', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tabák částečně nebo úplně odřapíkovaný,ostatní,ne:viz sazebník', 'Partly or wholly stemmed or stripped tobacco, otherwise unmanufactured (excl. li'),
('24013000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad tabákový', 'Tobacco refuse'),
('24021000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MIL'), 'Doutníky, doutníčky obsahující tabák', 'Cigars, cheroots and cigarillos containing tobacco'),
('24022010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MIL'), 'Cigarety obsahující tabák a hřebíček', 'Cigarettes, containing tobacco and cloves'),
('24022090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MIL'), 'Cigarety obsahující tabák', 'Cigarettes, containing tobacco (excl. containing cloves)'),
('24029000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Doutníky,doutníčky,cigarety z náhražek tabákových', 'Cigars, cheroots, cigarillos and cigarettes consisting wholly of tobacco substit'),
('24031010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tabák cigaretový balený okamžitá spotřeba nepřesahující 500g', 'Smoking tobacco, whether or not containing tobacco substitutes in any proportion'),
('24031090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tabák cigaretový ostatní', 'Smoking tobacco, whether or not containing tobacco substitutes in any proportion'),
('24039100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tabák "homogenizovaný","rekonstituovaný"', 'Tobacco, "homogenised" or "reconstituted" from finely-chopped tobacco leaves, to'),
('24039910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tabák žvýkací, šňupací', 'Chewing tobacco and snuff'),
('24039990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tabákové výrobky,výtažky,tresti,náhražky ostatní,ne:viz sazebník', 'Manufactured tobacco and tobacco substitutes, and tobacco powder, tobacco extrac'),
('25010010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Voda mořská,roztoky soli', 'Sea water and salt liquors'),
('25010031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlorid sodný čistý pro chemickou reakci (separaci sodíku od chloru)', 'Salt for chemical transformation "separation of Na from Cl" for the manufacture'),
('25010051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sůl denaturovaná,soli k průmyslovým účelům,ne:potraviny pro výživu lidí,zvířat', 'Salt, denatured or for other industrial uses, incl. refining (excl. for chemical'),
('25010091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sůl vhodná pro lidskou výživu', 'Salt suitable for human consumption'),
('25010099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sůl,chlorid sodný ostatní,ne:pro lidskou výživu,přípr.potravin pro lidi,zvířat', 'Salt and pure sodium chloride, whether or not in aqueous solution or containing'),
('25020000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pyrit (kyz železný) nepražený', 'Unroasted iron pyrites'),
('25030010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Síra surová i nerafinovaná', 'Crude or unrefined sulphur (excl. sublimed sulphur, precipitated sulphur and col'),
('25030090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Síra ostatní,ne:surová i rafinovaná,sublimovaná,srážená,koloidní', 'Sulphur of all kinds (excl. crude or unrefined, and sublimed sulphur, precipitat'),
('25041000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuha přírodní (grafit) v prášku,vločkách', 'Natural graphite in powder or in flakes'),
('25049000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuha přírodní (grafit) ostatní,ne:prášek,vločky', 'Natural graphite (excl. in powder or in flakes)'),
('25051000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Písky křemičité, křemenné i barvené neobsahující kovy', 'Silica sands and quartz sands, whether or not coloured'),
('25059000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Písky přírodní barvené neobsahující kovy ostatní,ne:křemenné,křemičité', 'Natural sands of all kinds, whether or not coloured (excl. silica sands, quartz'),
('25061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Křemen,ne:písky přírodní', 'Quartz (excl. quartz sands)'),
('25062000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Křemec,též opracovaný,řezaný do pravoúhlých bloků,desek', 'Quartzite, merely cut, by sawing or otherwise, in blocks or slabs of a square or'),
('25070020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kaolin', 'Kaolin'),
('25070080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jiný kaolinitický jíl,ne:kaolin', 'Kaolinic clays (other than kaolin)'),
('25081000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bentonit', 'Bentonite'),
('25083000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jíl žáruvzdorný (šamotový)', 'Fireclay (excl. kaolin and other kaolinic clays and expanded clay)'),
('25084000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jíly ostatní,ne:viz sazebník', 'Clays (excl. fireclay, bentonite, kaolin and other kaolinic clays and expanded c'),
('25085000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Andaluzit,kyanit,sillimanit', 'Andalusite, kyanite and sillimanite'),
('25086000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mullit', 'Mullite'),
('25087000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šamotové nebo dinasové zeminy', 'Chamotte or dinas earths'),
('25090000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Křída', 'Chalk'),
('25101000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fosfáty přírodní vápenaté,hlinitovápenaté,křída fosfátová nemleté', 'Natural calcium phosphates and natural aluminium calcium phosphates, natural and'),
('25102000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fosfáty přírodní vápenaté,hlinitovápenaté,křída fosfátová mleté', 'Natural calcium phosphates and natural aluminium calcium phosphates, natural and'),
('25111000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Síran barnatý přírodní (těživec,baryt)', 'Natural barium sulphate "barytes"'),
('25112000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uhličitan barnatý přírodní (witherit) i kalcinovaný', 'Natural barium carbonate "witherite", whether or not calcined (excl. barium oxid'),
('25120000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Moučky fosilní křemičité a podobné zeminy křemičité kalcinované', 'Siliceous fossil meals, e.g. kieselguhr, tripolite and diatomite, and similar si'),
('25131000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pemza', 'Pumice stone'),
('25132000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Smirek,přírodní korund,granát a ostatní brusiva přírodní', 'Emery; natural corundum, natural garnet and other natural abrasives, whether or'),
('25140000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Břidlice i zhruba opracovaná,řezaná do pravoúhlých desek,bloků', 'Slate, whether or not roughly trimmed or merely cut, by sawing or otherwise, int'),
('25151100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mramor,travertin surový,zhruba opracovaný', 'Marble and travertine, crude or roughly trimmed'),
('25151200', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mramor,travertin rozřezaný do bloků,desek pravoúhlého tvaru (vč.čtvercového)', 'Marble and travertine, merely cut, by sawing or otherwise, into blocks or slabs'),
('25152000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ecaussin a jiné kameny vápenaté pro práce výtvarné,stavební,alabastr', 'Ecaussine and other calcareous monumental or building stone of an apparent speci'),
('25161100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Žula surová,zhruba opracovaná', 'Granite, crude or roughly trimmed (excl. already with the characteristics of set'),
('25161200', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Žula rozřezaná do bloků,desek pravoúhlého tvaru (vč.čtvercového)', 'Granite, merely cut, by sawing or otherwise, into blocks or slabs of a square or'),
('25162000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pískovec,též opracovaný,řezaný do pravoúhlých bloků,desek', 'Sandstone, whether or not roughly trimmed or merely cut, by sawing or otherwise,'),
('25169000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní kameny pro výtvarné práce nebo stavební účely;ne:viz sazebník', 'Porphyry, basalt and other monumental or building stone, whether or not roughly'),
('25171010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oblázky,štěrk,struska a pazourek', 'Pebbles and gravel for concrete aggregates, for road metalling or for railway or'),
('25171020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vápenec,dolomit a další vápenaté horniny lámané nebo drcené', 'Broken or crushed dolomite and limestone flux, for concrete aggregates, for road'),
('25171080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní kameny jiné než vpředu uvedené,ne:viz sazebník', 'Broken or crushed stone, for concrete aggregates, for road metalling or for rail'),
('25172000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Makadam ze strusky, pěny a podobných odpadů průmyslových', 'Macadam of slag, dross or similar industrial waste, whether or not incorporating'),
('25173000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Makadam dehtový', 'Tarred macadam'),
('25174100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Granuly,drť,prach z mramoru i tepelně zpracované', 'Marble granules, chippings and powder, whether or not heat-treated'),
('25174900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Granuly,drť,prach z kamenů ostatních i tepelně zpracované,ne:mramor', 'Granules, chippings and powder, whether or not heat-treated, of travertine, ecau'),
('25181000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dolomit nekalcinovaný i řezaný do pravoúhlých bloků,desek,', 'Crude dolomite, not calcined or not sintered, incl. dolomite roughly trimmed or'),
('25182000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dolomit kalcinovaný i řezaný do pravoúhlých bloků,desek', 'Calcined or sintered dolomite (excl. broken or crushed dolomite for concrete agg'),
('25183000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dolomit aglomerovaný včetně dolomitu dehtového', 'Dolomite ramming mix'),
('25191000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uhličitan hořečnatý přírodní (magnezit)', 'Natural magnesium carbonate "magnesite"'),
('25199010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxid hořečnatý,ne:uhličitan hořečnatý přírodní kalcinovaný', 'Magnesium oxide, whether or not pure (excl. calcined natural magnesium carbonate'),
('25199030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Magnézie (oxid hořečnatý) přepálená (slinutá)', 'Dead-burned "sintered" magnesia, whether or not containing small quantities of o'),
('25199090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Magnézie ostatní,tavená,ne:přepálená', 'Fused magnesia'),
('25201000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sádrovec,anhydrit', 'Gypsum; anhydrite'),
('25202000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sádra (z kalcinovaného sádrovce či síranu vápenatého),i barvená,s urychlovačem,zpomalovačem', 'Plasters consisting of calcined gypsum or calcium sulphate, whether or not colou'),
('25210000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vápenec a jiné kameny vápenaté k výrobě cementu,vápna', 'Limestone flux; limestone and other calcareous stone, of a kind used for the man'),
('25221000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vápno nehašené', 'Quicklime'),
('25222000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vápno hašené', 'Slaked lime'),
('25223000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vápno hydraulické', 'Hydraulic lime (excl. pure calcium oxide and calcium hydroxide)'),
('25231000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slínky cementové', 'Cement clinkers'),
('25232100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cement portlandský bílý i uměle barvený', 'White portland cement, whether or not artificially coloured'),
('25232900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cementy portlandské ostatní,ne:bílé,uměle barvené', 'Portland cement (excl. white, whether or not artificially coloured)'),
('25233000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cement hlinitanový', 'Aluminous cement'),
('25239000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cementy hydraulické ostatní', 'Cement, whether or not coloured (excl. portland cement and aluminous cement)'),
('25241000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krokydolit', 'Crocidolite asbestos (excl. products made from crocidolite)'),
('25249000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Osinek (azbest) ostatní', 'Asbestos (excl. crocidolite and products made from asbestos)'),
('25251000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slída surová i štípaná do lístků,nepravidelných destiček', 'Crude mica and mica rifted into sheets or splittings'),
('25252000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prach slídový', 'Mica powder'),
('25253000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpady slídové', 'Mica waste'),
('25261000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Steatit přírodní,mastek i rozřezaný do pravoúhlých desek,bloků nedrcený,nemletý', 'Natural steatite, whether or not roughly trimmed or merely cut, by sawing or oth'),
('25262000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Steatit přírodní,mastek drcený,rozemletý', 'Natural steatite and talc, crushed or powdered'),
('25281000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Boritany sodné přírodní,koncentráty,i kalcinované', 'Sodium borates, natural, and concentrates thereof, whether or not calcined (excl'),
('25289000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina boritá,obsahující do 85% H3BO3 v sušině', 'Borates, natural, and concentrates thereof, whether or not calcined, and natural'),
('25291000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Živec', 'Feldspar'),
('25292100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kazivec obsahující fluorid vápenatý 97% a méně', 'Fluorspar containing by weight <= 97% calcium fluoride'),
('25292200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kazivec obsahující fluorid vápenatý nad 97%', 'Fluorspar containing by weight > 97% calcium fluoride'),
('25293000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Leucit,nefelin,syenit nefelinický', 'Leucite, nepheline and nepheline syenite'),
('25301000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vermikulit,perlit,chlority,neexpandované', 'Vermiculite, perlite and chlorites, unexpanded'),
('25302000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kieserit,epsomit (sírany hořečnaté přírodní)', 'Kieserite and epsomite "natural magnesium sulphates"'),
('25309000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Látky nerostné ostatní,ne:viz sazebník', 'Arsenic sulfides, alunite, pozzuolana, earth colours and other mineral substance'),
('26011100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rudy železné,koncentráty neaglomerované,ne:kyzové výpražky (výpalky)', 'Non-agglomerated iron ores and concentrates (excl. roasted iron pyrites)'),
('26011200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rudy železné,koncentráty aglomerované,ne:kyzové výpražky (výpalky)', 'Agglomerated iron ores and concentrates (excl. roasted iron pyrites)'),
('26012000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyzové výpražky (výpalky)', 'Roasted iron pyrites'),
('26020000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rudy manganové,železonosné mangan.rudy s obsahem nanganu 20% a více,koncentráty', 'Manganese ores and concentrates, incl. ferruginous manganese ores and concentrat'),
('26030000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rudy měděné,koncentráty', 'Copper ores and concentrates'),
('26040000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rudy niklové,koncentráty', 'Nickel ores and concentrates'),
('26050000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rudy kobaltové,koncentráty', 'Cobalt ores and concentrates'),
('26060000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rudy hliníkové,koncentráty', 'Aluminium ores and concentrates'),
('26070000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rudy olovnaté,koncentráty', 'Lead ores and concentrates'),
('26080000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rudy zinkové,koncentráty', 'Zinc ores and concentrates'),
('26090000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rudy cínové,koncentráty', 'Tin ores and concentrates'),
('26100000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rudy chromové,koncentráty', 'Chromium ores and concentrates'),
('26110000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rudy wolframové,koncentráty', 'Tungsten ores and concentrates'),
('26121010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rudy uranové,smolinec,koncentráty obsah uranu nad 5%', 'Uranium ores and pitchblende, with a uranium content of > 5% by weight [Euratom]'),
('26121090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rudy uranové ostatní,obsah uranu do 5%', 'Uranium ores and concentrates (excl. uranium ores and pitchblende, with a uraniu'),
('26122010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Monazit,uranithorainit,ost.rudy thoriové,koncentráty,obsah thoria nad 20%', 'Monazite; urano-thorianite and other thorium ores, with a thorium content of > 2'),
('26122090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rudy thoriové ostatní,obsah thoria do 20%', 'Thorium ores and concentrates (excl. monazite, urano-thorianite and other thoriu'),
('26131000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rudy molybdenové,koncentráty pražené', 'Roasted molybdenum ores and concentrates'),
('26139000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rudy molybdenové,koncentráty,ne:pražené', 'Molybdenum ores and concentrates (excl. roasted)'),
('26140000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rudy titanové,koncentráty', 'Titanium ores and concentrates'),
('26151000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rudy zirkonové,koncentráty', 'Zirconium ores and concentrates'),
('26159000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rudy niobové,tantalové,vanadové,koncentráty', 'Niobium, tantalum or vanadium ores and concentrates'),
('26161000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rudy stříbrné,koncentráty', 'Silver ores and concentrates'),
('26169000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rudy drahých kovů ostatní,koncentráty,ne:stříbrné', 'Precious-metal ores and concentrates (excl. silver ores and oncentrates)'),
('26171000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rudy antimonové,koncentráty', 'Antimony ores and concentrates'),
('26179000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rudy,koncentráty ostatní,ne:viz sazebník', 'Ores and concentrates (excl. iron, manganese, copper, nickel, cobalt, aluminium,'),
('26180000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Struska granulovaná (struskový písek) z výroby železa,oceli', 'Granulated slag "slag sand" from the manufacture of iron or steel'),
('26190020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad při zpracování železa a oceli vhodný k rekuperaci Fe nebo Mn', 'Waste from the manufacture of iron or steel suitable for the recovery of iron or'),
('26190090', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Struska,i zpěněná (ne granulovaná),okuje aj.odpady z výroby železa,oceli,ne:k rekuperaci Fe nebo Mn', 'Slag, dross, scalings and other waste from the manufacture of iron or steel (exc'),
('26201100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kamínek zinkový', 'Hard zinc spelter'),
('26201900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Struska,popel,zbytky obsah.hlavně zinek,ne:kamínek', 'Slag, ash and residues containing mainly zinc (excl. hard zinc spelter)'),
('26202100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kaly olovnatého benzínu,kaly olovnatých antidetonačních sloučenin', 'Leaded gasoline sludges and leaded anti-knock compound sludges, obtained from st'),
('26202900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Struska,popel,zbytky obsah.hlavně olovo,ne:kaly benzinu a antideton.sloučenin', 'Slag, ash and residues containing mainly lead (excl. leaded gasoline sludges and'),
('26203000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Struska,popel,zbytky obsah.hlavně měď', 'Slag, ash and residues containing mainly copper'),
('26204000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Struska,popel,zbytky obsah.hlavně hliník', 'Slag, as and residues containing mainly aluminium'),
('26206000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Struska,popel,zbytky obsah.arsen,rtuť,thalium,i směsi použ.pro získání arsenu', 'Slag, ash and residues, containing arsenic, mercury, thallium or their mixtures,'),
('26209100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Struska,popel,zbytky obsah.antimon,berylium,kadmium,chrom,i jejich směsi', 'Slag, ash and residues, containing antimony, beryllium, cadmium, chromium or the'),
('26209910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Struska,popel,zbytky obsah.hlavně nikl', 'Slag, ash and residues containing mainly nickel'),
('26209920', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Struska,popel,zbytky obsah.hlavně niob,tantal', 'Slag, ash and residues containing mainly niobium or tantalum'),
('26209940', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Struska,popel,zbytky obsah.hlavně cín', 'Slag, ash and residues containing mainly tin'),
('26209960', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Struska,popel,zbytky obsah.hlavně titan', 'Slag, ash and residues containing mainly titanium'),
('26209995', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Struska,popel,zbytky obsah.ostatní kovy', 'Slag, ash and residues containing metals or metal compounds (excl. those from th'),
('26211000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Popel a zbytky ze spalování komunálního odpadu', 'Ash and residues from the incineration of municipal waste'),
('26219000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Struska,popel jiný včetně popela mořských chaluh,ne:viz sazebník', 'Slag and ash, incl. seaweed ash "kelp" (excl. slag, incl. granulated, from the m'),
('27011110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Antracit i v prášku neaglomerovaný,těkavé látky do 10%', 'Anthracite, whether or not pulverised, having a volatile matter limit of <= 10%'),
('27011190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Antracit i v prášku neaglomerovaný ostatní,ne:těkavé látky do 10%', 'Anthracite, whether or not pulverised, having a volatile matter limit of > 10% b'),
('27011210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uhlí živičné koksovatelné i v prášku neaglomerované', 'Coking coal, whether or not pulverised, non-agglomerated'),
('27011290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uhlí živičné (bituminózní) ostatní i v prášku neaglomerované,ne:koksovatelné', 'Bituminous coal, whether or not pulverised, non-agglomerated (excl. coking)'),
('27011900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uhlí černé ostatní i v prášku neaglomerované,ne:antracit,živičné', 'Coal, whether or not pulverised, non-agglomerated (excl. anthracite and bitumino'),
('27012000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brikety,bulety a podobná paliva tuhá z černého uhlí', 'Briquettes, ovoids and similar solid fuels manufactured from coal'),
('27021000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uhlí hnědé i v prášku neaglomerované,ne:gagát', 'Lignite, whether or not pulverised, non-agglomerated (excl. jet)'),
('27022000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uhlí hnědé i v prášku aglomerované,ne:gagát', 'Agglomerated lignite (excl. jet)'),
('27030000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rašelina včetně rašelinného steliva i aglomerovaná', 'Peat, incl. peat litter, whether or not agglomerated'),
('27040011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Koks,polokoks z uhlí černého,hnědého i aglomerovaný na výrobu elektrod', 'Coke and semi-coke of coal, whether or not agglomerated, for the manufacture of'),
('27040019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Koks,polokoks z uhlí černého,hnědého i aglomerovaný,ne:na výrobu elektrod', 'Coke and semi-coke of coal, whether or not agglomerated (excl. for the manufactu'),
('27040030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Koks,polokoks z lignitu i aglomerovaný', 'Coke and semi-coke of lignite, whether or not agglomerated'),
('27040090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Koks,polokoks ostatní i aglomerovaný,retortové uhlí,ne:uhlí černé,hnědé,lignit', 'Coke and semi-coke of peat, whether or not agglomerated; retort carbon'),
('27050000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MQM'), 'Svítiplyn,plyn vodní,generátorový apod.,ne:zemní plyn,plynné uhlovodíky', 'Coal gas, water gas, producer gas, lean gas and similar gases (excl. petroleum g'),
('27060000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dehet černouhelný,hnědouhelný,rašelinový,ost.minerální i dehydratovaný,rekonstituovaný', 'Tar distilled from coal, from lignite or from peat, and other mineral tars, whet'),
('27071010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Benzol (surový benzen) pro účely energetické,topné', 'Benzol "benzene" containing > 50% of benzene, for use as a power or heating fuel'),
('27071090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Benzol (surový benzen) ostatní,ne:pro účely energetické,topné', 'Benzol "benzene" containing > 50% of benzene (excl. chemically defined and for p'),
('27072010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Toluol (surový toluen) pro účely energetické,topné', 'Toluol "toluene" containing > 50% of toluene, for use as a power or heating fuel'),
('27072090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Toloul (surový toluen) ostatní,ne:pro účely energetické,topné', 'Toluol "toluene" containing > 50% of toluene (excl. chemically defined and for p'),
('27073010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Xylol (surový xylen) pro účely energetické,topné', 'Xylol "xylenes" containing > 50% of xylenes, for use as a power or heating fuels'),
('27073090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Xylol (surový xylen) ostatní,ne:pro účely energetické,topné', 'Xylol "xylenes" containing > 50% of xylenes (excl. chemically defined and for po'),
('27074000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Naftalen', 'Naphthalene containing > 50% of naphthalene (excl. chemically defined)'),
('27075010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směs aromatických uhlovodíků pro účely energetické,topné', 'Aromatic hydrocarbon mixtures of which >= 65% by volume, incl. losses, distils a'),
('27075090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi aromat.uhlovodíků z nichž 65% a více destiluje do 250°C,ne:viz sazebník', 'Aromatic hydrocarbon mixtures of which >= 65% by volume, incl. losses, distils a'),
('27079100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje kreozotové', 'Creosote oils (excl. chemically defined)'),
('27079911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje lehké surové,nejméně 90% objemových destiluje do 200°C', 'Crude light oils from the distillation of high temperature coal tars, of which >'),
('27079919', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje lehké surové ostatní,do 90% objemových destiluje do 200°C', 'Crude light oils from the distillation of high temperature coal tars (excl. thos'),
('27079930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vrstva sirnatá vrchní (z dehtu černého,hnědého uhlí)', 'Sulphuretted toppings from the first distillation of high temperature coal tars'),
('27079950', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Produkty zásadité z uhelného dehtu', 'Pyridine, quinoline, acridine, aniline bases and other basic products of the fir'),
('27079970', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Antracén', 'Anthracene (excl. chemically defined)'),
('27079980', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fenoly', 'Phenols containing > 50% of phenols (excl. chemically defined)'),
('27079991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje a produkty ost.(aromat.složky převaž.nad nearomat.)pro výr.č.2803,ne:viz sazebník', 'Oils and other products of the distillation of high temperature coal tars and si'),
('27079999', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Produkty destilace černouhelného dehtu ostatní,ne:viz sazebník', 'Oils and other products of the distillation of high temperature coal tars and si'),
('27081000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Smola z dehtu černouhelného,dehtů minerálních', 'Pitch obtained from coal tar or from other mineral tars'),
('27082000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Koks smolný z dehtu černouhelného,dehtů minerálních', 'Pitch coke obtained from coal tar or from other mineral tars'),
('27090010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kondenzáty přírodního plynu', 'Natural gas condensates'),
('27090090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ropa-oleje mineralni a z ner.zivicnych surove', 'Petroleum oils and oils obtained from bituminous minerals, crude (excl. natural'),
('27101111', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje lehké a přípravky pro specifické zpracování', 'Light oils of petroleum or bituminous minerals for undergoing a specific process'),
('27101115', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje lehké a přípravky pro chemické zpracování,ne:specifické', 'Light oils of petroleum or bituminous minerals, for undergoing chemical transfor'),
('27101121', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Benzin lakový (White spirit)', 'White spirit'),
('27101125', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Benzin speciální ostatní', 'Special spirits (excl. white spirit) of petroleum or bituminous minerals'),
('27101131', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Benzin letecký', 'Aviation spirit'),
('27101141', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KLT'), 'Benzin motorový, obsah olova do 0,013 g/l, oktanové číslo do 95', 'Motor spirit, with a lead content <= 0,013 g/l, with an research octane number "'),
('27101145', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KLT'), 'Benzin motorový,obsah olova do 0,013 g/l,oktanové číslo 95 a více,méně než 98', 'Motor spirit, with a lead content <= 0,013 g/l, with an research octane number "'),
('27101149', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KLT'), 'Benzin motorový,obsah olova do 0,013 g/l,oktanové číslo 98 a více', 'Motor spirit, with a lead content <= 0,013 g/l, with an research octane number "'),
('27101151', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KLT'), 'Benzin motorový,obsah olova nad 0,013 g/l,oktanové číslo nižší než 98', 'Motor spirit, with a lead content > 0,013 g/l, with an research octane number "R'),
('27101159', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KLT'), 'Benzin motorový,obsah olova nad 0,013 g/l,oktanové číslo 98 a více', 'Motor spirit, with a lead content > 0,013 g/l, with an research octane number "R'),
('27101170', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Palivo do tryskových motorů benzinového typu', 'Jet fuel, spirit type (excl. aviation spirit)'),
('27101190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní lehké oleje, ne: viz sazebník', 'Light oils and preparations, of petroleum or bituminous minerals, n.e.s. (excl.'),
('27101911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje ostatní střední pro specifické zpracování,ne:petroleje', 'Medium oils of petroleum or bituminous minerals for undergoing a specific proces'),
('27101915', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje ostatní střední pro chemické zpracování,ne:zpracování specifické', 'Medium oils of petroleum or bituminous minerals, for undergoing chemical transfo'),
('27101921', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Petrolej(kerosen)-palivo pro tryskové motory (letecký petrolej)', 'Jet fuel, kerosene type'),
('27101925', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje střední pro jiné účely-kerosen ostatní,ne:viz sazebník', 'Kerosene (excl. jet fuel)'),
('27101929', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní střední oleje, ne: viz sazebník', 'Medium oils and preparations, of petroleum or bituminous minerals, n.e.s. (excl.'),
('27101931', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje těžké plynové pro specifické zpracování', 'Gas oils of petroleum or bituminous minerals for undergoing a specific process a'),
('27101935', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje těžké plynové pro chemické zpracování,ne:specifické', 'Gas oils of petroleum or bituminous minerals, for undergoing chemical transforma'),
('27101941', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje těžké plynové, pro jiné účely, obsah síry do 0,05% hmotnostních', 'Gas oils of petroleum or bituminous minerals, with a sulphur content of <= 0,05%'),
('27101945', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje těžké plynové, pro jiné účely, obsah síry 0,05 - 0,2% hmotnostních', 'Gas oils of petroleum or bituminous minerals, with a sulphur content of > 0,05%'),
('27101949', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje těžké plynové, pro jiné účely, obsah síry převyšující 0,2% hmotnostních', 'Gas oils of petroleum or bituminous minerals, with a sulphur content of > 0,2% b'),
('27101951', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje těžké topné pro specifické zpracování', 'Fuel oils of petroleum or bituminous minerals for undergoing a specific process'),
('27101955', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje těžké topné pro chemické zpracování,ne:zpracování specifické', 'Fuel oils obtained from bituminous materials, for undergoing chemical transforma'),
('27101961', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje těžké topné, pro jiné účely, obsah síry do 1 % hmotnostních', 'Fuel oils obtained from bituminous materials, with a sulphur content of <= 1% by'),
('27101963', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje těžké topné, pro jiné účely, obsah síry 1 - 2% hmotnostních', 'Fuel oils obtained from bituminous materials, with a sulphur content of > 1% to'),
('27101965', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje těžké topné, pro jiné účely, obsah síry 2 - 2,8% hmotnostních', 'Fuel oils obtained from bituminous materials, with a sulphur content of > 2% to'),
('27101969', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje těžké topné, pro jiné účely, obsah síry převyšující 2,8% hmotnostních', 'Fuel oils obtained from bituminous materials, with a sulphur content of > 2,8% b'),
('27101971', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje mazací a oleje ostatní pro specifické zpracování', 'Lubricating oils and other preparations containing by weight >= 70% of petroleum'),
('27101975', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje mazací a oleje ostatní pro chemické zpracování', 'Lubricating oils and other preparations containing by weight >= 70% of petroleum'),
('27101981', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje motorové, mazací pro kompresory a turbiny', 'Motor oils, compressor lube oils and turbine lube oils containing by weight >= 7'),
('27101983', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje kapalné pro hydraulické účely', 'Liquids for hydraulic purposes containing by weight >= 70% of petroleum oils or'),
('27101985', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje bílé, kapalný parafín', 'White oils, liquid paraffin containing by weight >= 70% of petroleum oils or of'),
('27101987', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje převodové a pro reduktory', 'Gear oils and reductor oils containing by weight >= 70% of petroleum oils or of'),
('27101991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje používané při obrábění kovů, uvolňování odlitků z forem, antikorozní', 'Metalworking compounds, mould-release oils, anti-corrosion oils containing by we'),
('27101993', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje elektroizolační', 'Electrical insulating oils containing by weight >= 70% of petroleum oils or of o'),
('27101999', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní mazací oleje a ostatní oleje, ne: viz sazebník', 'Lubricating oils and other heavy oils and preparations n.e.s., containing by wei'),
('27109100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje odpadní, obsahující polychlorované bifenyly,terfenyly,polybrom.bifenyly', 'Waste oils containing polychlorinated biphenyls [PCBs], polychlorinated terpheny'),
('27109900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleje odpadní ostatní,ne:viz sazebník', 'Waste oils containing mainly petroleum or bituminous minerals (excl. those conta'),
('27111100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'TJO'), 'Plyn zemní zkapalněný', 'Natural gas, liquefied'),
('27111211', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Propan zkapalněný,čistota nejméně 99%,pro účely energetické,topné', 'Propane of a purity of >= 99%, for use as a power or heating fuel, liquefied'),
('27111219', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Propan zkapalněný,nad 99%,ne pro energet,otop', 'Propane of a purity of >= 99%, liquefied (excl. for use as a power or heating fu'),
('27111291', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Propan zkapalněný,čistota do 99% pro specifické zpracování', 'Propane of a purity of < 99%, liquefied, for undergoing a specific process as de'),
('27111293', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Propan zkapalněný,čistota do 99% pro chemické zpracování,ne:specifické', 'Propane of a purity of < 99%, liquefied, for undergoing chemical transformation'),
('27111294', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Propan o čistotě nad 90 % a pod 99 %', 'Liquid propane of a purity of > 90%, but < 99% (excl. for undergoing chemical tr'),
('27111297', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní propan pro jiné účely', 'Liquefied propane of a purity of <= 90% (excl. for undergoing chemical transform'),
('27111310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Butan zkapalněný pro specifické zpracování', 'Butanes for undergoing a specific process as defined in Additional Note 4 to cha'),
('27111330', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Butan zkapalněný pro chemické zpracování,ne:zpracování specifické', 'Butanes for undergoing chemical transformation, liquefied (excl. for specific pr'),
('27111391', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Butan o čistotě převyšující 90 %, menší než 95%', 'Liquefied butane of a purity of > 90% but < 95% (excl. for undergoing chemical t'),
('27111397', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní butan pro jiné účely', 'Liquefied butane of a purity of <= 90% (excl. for undergoing chemical transforma'),
('27111400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ethylen, propylen, butylen, butadien zkapalněný', 'Ethylene, propylene, butylene and butadiene, liquefied (excl. ethylene of a puri'),
('27111900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uhlovodíky plynné ostatní zkapalněné', 'Gaseous hydrocarbons, liquefied, n.e.s. (excl. natural gas, propane, butane, eth'),
('27112100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'TJO'), 'Plyn zemní v plynném stavu', 'Natural gas in gaseous state'),
('27112900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uhlovodíky plynné ostatní v plynném stavu', 'Hydrocarbons in gaseous state, n.e.s. (excl. natural gas)'),
('27121010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vazelína surová získaná synteticky a jinak i barvená', 'Crude petroleum jelly'),
('27121090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vazelína ostatní získaná synteticky a jinak i barvená,ne:surová', 'Petroleum jelly (excl. crude)'),
('27122010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Parafin syntet.,relat.molekul.hmotn.od 460 do 1560,méně než 75% oleje', 'Synthetic paraffin wax containing < 0,75% by weight of oil and of a molecular we'),
('27122090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Parafin ostat.,ne:syntet.o relat.molekul.hmotn.od 460 do 1560,méně než 75% oleje', 'Paraffin wax containing < 0,75% by weight of oil (excl. synthetic paraffin wax o'),
('27129011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vosk montánní,rašelinový,ozokerit surový', 'Crude ozokerite, lignite wax or peat wax "natural products"'),
('27129019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vosk montánní,rašelinový,ozokerit ostatní,ne:surový', 'Ozokerite, lignite wax or peat wax "natural products", whether or not coloured ('),
('27129031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vosk ropný,jiný minerální ostatní surový,ne:specifické,chemické zpracování', 'Crude paraffin wax, microcrystalline petroleum wax, slack wax, other mineral wax'),
('27129033', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vosk ropný,jiný minerální surový pro chemické zpracování,ne:zprac.specifické', 'Crude paraffin wax, microcrystalline petroleum wax, slack wax, other mineral wax'),
('27129039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vosk ropný,jiný minerální ostatní surový,ne:specifické,chemické zpracování', 'Crude paraffin wax, microcrystalline petroleum wax, slack wax, other mineral wax'),
('27129091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vosk ostatní,80% a víc délka řetězce 24-28 atomů,ne:ozokerit,montánní a rašelinový vosk', 'Blend of 1-alkenes containing by weight >= 80% of 1-alkenes of a chain-length of'),
('27129099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vosk ostatní,ne:80% a více délka řetězce 24-28 atomů,ozokerit,montánní a rašelinový vosk', 'Paraffin wax, microcrystalline petroleum wax, slack wax, ozokerite, lignite wax,'),
('27131100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Koks petrolejový nekalcinovaný', 'Petroleum coke, non-calcined'),
('27131200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Koks petrolejový kalcinovaný', 'Petroleum coke, calcined'),
('27132000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Živice petrolejová', 'Petroleum bitumen'),
('27139010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zbytky destilace olejů minerálních,ze živičných nerostů k výrobě uhlíku č.2803', 'Residues of petroleum oil or of oil obtained from bituminous minerals for the ma'),
('27139090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zbytky destilace olejů minerálních,ze živič.nerostů ostatní,ne:výroba uhlíku', 'Residues of petroleum oil or of oil obtained from bituminous minerals (excl. for'),
('27141000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Živičné břidlice a živičné písky', 'Bituminous or oil-shale and tar sands'),
('27149000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Živice přírodní (bitumen),asfalt přírodní,asfaltity,horniny asfaltové', 'Bitumen and asphalt, natural; asphaltites and asphaltic rocks'),
('27150000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi živičné na bázi asfaltu, živice, dehtu', 'Bituminous mastics, cut-backs and other bituminous mixtures based on natural asp'),
('27160000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MWH'), 'Energie elektrická', 'Electrical energy'),
('28011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlór', 'Chlorine'),
('28012000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jód', 'Iodine'),
('28013010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fluór', 'Fluorine'),
('28013090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bróm', 'Bromine'),
('28020000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Síra sublimovaná,srážená,koloidní', 'Sulphur, sublimed or precipitated; colloidal sulphur'),
('28030000', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uhlík (uhlíkové saze a jiné formy uhlíku jinde neuvedené),ne:viz sazebník', 'Carbon "carbon blacks and other forms of carbon", n.e.s.'),
('28041000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Vodík', 'Hydrogen'),
('28042100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Argon', 'Argon'),
('28042910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Helium', 'Helium'),
('28042990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Vzácné plyny ostatní,ne:argon,helium', 'Neon, krypton and xenon'),
('28043000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dusík', 'Nitrogen'),
('28044000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Kyslík', 'Oxygen'),
('28045010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bór', 'Boron'),
('28045090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tellur', 'Tellurium'),
('28046100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Křemík obsahující nejméně 99,99 % křemíku', 'Silicon containing >= 99,99% by weight of silicon'),
('28046900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Křemík obsahujcí méně něž 99,99 % křemíku', 'Silicon containing < 99,99% by weight of silicon'),
('28047000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fosfor', 'Phosphorus'),
('28048000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Arsen', 'Arsenic'),
('28049000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Selen', 'Selenium'),
('28051100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sodík', 'Sodium'),
('28051200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vápník', 'Calcium'),
('28051910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroncium a baryum', 'Strontium and barium'),
('28051990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kovy alkalické a alkalických zemí ostatní,ne:sodík,vápník,stroncium,baryum', 'Alkali metals (excl. sodium)'),
('28053010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kovy vzácných zemin,skandium,yttrium vzájemně smíšené nebo legované', 'Intermixtures or interalloys of rare-earth metals, scandium and yttrium'),
('28053090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kovy vzácných zemin,skandium,yttrium ostatní,ne:vzájemně smíšené nebo legované', 'Rare-earth metals, scandium and yttrium (excl. intermixtures or interalloys)'),
('28054010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rtuť v lahvích,netto obsah 34,5kg,FOB hodnota do 224 Euro/láhev', 'Mercury in flasks of a net content of 34,5 kg "standard weight", of a fob value'),
('28054090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rtuť ostatní,ne:v lahvích o netto obsahu 34,5kg,FOB hodnota do 224 Euro/láhev', 'Mercury (excl. in flasks of a net content of 34,5 kg "standard weight", of a fob'),
('28061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlorovodík (kyselina chlorovodíková)', 'Hydrogen chloride "hydrochloric acid"'),
('28062000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina chlorsírová (chlorsulfonová)', 'Chlorosulphuric acid'),
('28070010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina sírová', 'Sulphuric acid'),
('28070090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oleum', 'Oleum'),
('28080000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina dusičná,směs kyseliny sírové a dusičné (nitrační směs)', 'Nitric acid; sulphonitric acids'),
('28091000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KPP'), 'Oxid fosforečný', 'Diphosphorus pentaoxide'),
('28092000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KPP'), 'Kyselina fosforečná,kyseliny polyfosforečné', 'Phosphoric acid; polyphosphoric acids, whether or not chemically defined'),
('28100010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxid boritý', 'Diboron trioxide'),
('28100090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxidy boru,kyseliny borité,ne:oxid boritý', 'Oxides of boron and boric acids (excl. diboron trioxide)'),
('28111100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fluorovodík (kyselina fluorovodíková)', 'Hydrogen fluoride "hydrofluoric acid"'),
('28111910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bromovodík (kyselina bromovodíková)', 'Hydrogen bromide "hydrobromic acid"'),
('28111920', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyanovodík (kyselina kyanovodíková)', 'Hydrogen cyanide "hydrocyanic acid"'),
('28111980', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní anorganické kyseliny', 'Inorganic acids (excl. hydrogen chloride "hydrochloric acid", chlorosulphuric ac'),
('28112100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxid uhličitý', 'Carbon dioxide'),
('28112200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxid křemičitý', 'Silicon dioxide'),
('28112905', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxid siřičitý', 'Sulphur dioxide'),
('28112910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxid sírový (anhydrid kyseliny sírové),oxid arzenitý', 'Sulphur trioxide "sulphuric anhydride"; diarsenic trioxide'),
('28112930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxidy dusíku', 'Nitrogen oxides'),
('28112990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slouc.nekovu organ.kysl,ne oxidy C,Si,S,As,N', 'Inorganic oxygen compounds of non-metals (excl. diphosphorus pentaoxide, oxides'),
('28121011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trichlorid-oxid fosforečný', 'Phosphorus trichloride oxide "phosphoryl trichloride"'),
('28121015', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlorid fosforitý', 'Phosphorus trichloride'),
('28121016', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlorid fosforečný', 'Phosphorus pentachloride'),
('28121018', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chloridy a chlorid-oxidy fosforu ostatní,ne:viz sazebník', 'Chlorides and chloride oxides of phosphorus (excl. trichloride, trichloride oxid'),
('28121091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dichlorid disíry', 'Disulphur dichloride'),
('28121093', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dichlorid síry', 'Sulphur dichloride'),
('28121094', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fosgen (dichlorid kyseliny uhličité)', 'Phosgene "carbonyl chloride"'),
('28121095', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Thionyl dichlorid (thionyl chlorid)', 'Thionyl dichloride "thionyl chloride"'),
('28121099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chloridy a chlorid-oxidy ostatní,ne:viz sazebník', 'Chlorides and chloride oxides (excl. phosphorus, and disulphur dichloride, sulph'),
('28129000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Halogenidy,halogenid-oxidy nekovů ostatní', 'Halides and halide oxides of non-metals (excl. chlorides and chloride oxides)'),
('28131000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sirouhlík', 'Carbon disulphide'),
('28139010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sulfidy fosforu,sulfid fosforitý komerční', 'Phosphorus sulphides, incl. commercial phosphorus trisulphide'),
('28139090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sulfidy (sirníky) nekovů ostatní,ne:sirouhlík,sulfidy fosforu', 'Sulphides of non-metals (excl. phosphorus sulphides, incl. commercial phosphorus'),
('28141000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Amoniak bezvodý (čpavek)', 'Anhydrous ammonia'),
('28142000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Amoniak (čpavek) ve vodném roztoku', 'Ammonia in aqueous solution'),
('28151100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hydroxid sodný (žíravý natron) tuhý', 'Sodium hydroxide "caustic soda" solid'),
('28151200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KSH'), 'Hydroxid sodný ve vodném roztoku (louh sodný)', 'Sodium hydroxide "caustic soda" in aqueous solution "soda lye or liquid soda"'),
('28152000', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'KPH'), 'Hydroxid draselný (louh draselný)', 'Potassium hydroxide "caustic potash"'),
('28153000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Peroxid sodíku,peroxid draslíku', 'Peroxides of sodium or potassium'),
('28161000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hydroxid,peroxid horčíku', 'Hydroxide and peroxide of magnesium'),
('28164000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxid,hydroxid,peroxid stroncia nebo barya', 'Oxides, hydroxides and peroxides, of strontium or barium'),
('28170000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxid zinečnatý,peroxid zinku', 'Zinc oxide; zinc peroxide'),
('28181011', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Umělý korund,obsah oxidu hlinitého >= 98,5%,současně < 50% částic je > 10mm', 'Artificial corundum, whether or not chemically defined, with < 50Â % of the tota'),
('28181019', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Umělý korund,obsah oxidu hlinitého >= 98,5%,současně >= 50% částic je > 10mm', 'Artificial corundum, whether or not chemically defined, with >= 50Â % of the tot'),
('28181091', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Umělý korund,obsah oxidu hlinitého < 98,5%,současně < 50% částic je > 10mm', 'Artificial corundum, whether or not chemically defined, with < 50Â % of the tota'),
('28181099', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Umělý korund,obsah oxidu hlinitého < 98,5%,současně >= 50% částic je > 10mm', 'Artificial corundum, whether or not chemically defined, with >= 50Â % of the tot'),
('28182000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxid hlinitý jiný,ne:korund umělý', 'Aluminium oxide (excl. artificial corundum)'),
('28183000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hydroxid hlinitý', 'Aluminium hydroxide'),
('28191000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxid chromový', 'Chromium trioxide'),
('28199010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxid chromitý', 'Chromium dioxide'),
('28199090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxidy,hydroxidy chromu ostatní,ne:oxid chromový,oxid chromitý', 'Chromium oxides and hydroxides (excl. chromium trioxide and chromium dioxide)'),
('28201000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxid manganičitý', 'Manganese dioxide'),
('28209010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxid manganatý obsahující 77% a více manganu', 'Manganese oxide containing by weight >= 77% of manganese'),
('28209090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxidy manganu ostatní,ne:manganičitý,manganatý obsahující 77% a více manganu', 'Manganese oxides (excl. manganese dioxide and manganese oxide containing by weig'),
('28211000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxidy,hydroxidy železa', 'Iron oxides and hydroxides'),
('28212000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hlinky barevné obsahující nad 70% vázaného železa vyhodnoceného jako Fe2O3', 'Earth colours containing >= 70% by weight of combined iron evaluated as Fe2O3'),
('28220000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxidy,hydroxidy kobaltu,oxidy kobaltu komerční', 'Cobalt oxides and hydroxides; commercial cobalt oxides'),
('28230000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxidy titanu', 'Titanium oxides'),
('28241000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxid olovnatý (klejt,masikot)', 'Lead monoxide "litharge, massicot"'),
('28249010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Suřík,suřík oranžový', 'Red lead and orange lead'),
('28249090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxidy olova ostatní,ne:oxid olovnatý,suřík', 'Lead oxides (excl. monoxide "litharge, massicot")'),
('28251000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hydrazin,hydroxylamin a jejich anorganické soli', 'Hydrazine and hydroxylamine and their inorganic salts'),
('28252000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxid,hydroxid lithný', 'Lithium oxide and hydroxide'),
('28253000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxidy,hydroxidy vanadu', 'Vanadium oxides and hydroxides'),
('28254000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxidy,hydroxidy niklu', 'Nickel oxides and hydroxides'),
('28255000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxidy,hydroxidy mědi', 'Copper oxides and hydroxides'),
('28256000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxidy germania,oxid zirkoničitý', 'Germanium oxides and zirconium dioxide'),
('28257000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxidy,hydroxidy molybdenu', 'Molybdenum oxides and hydroxides'),
('28258000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxidy antimonu', 'Antimony oxides'),
('28259011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hydroxid vápenatý,98% a více čistoty v sušině,velikost částic-viz sazebník', 'Calcium hydroxide of a purity of >= 98% calculated on the dry weight, in the for'),
('28259019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxid,hydroxid,peroxid vápenatý,ne:hydroxid vápen.98% a více čistoty v sušině,velikost částic-viz sazebník', 'Calcium oxide, hydroxide and peroxide (excl. calcium hydroxide of a purity of >='),
('28259020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxid,hydroxid berylnatý', 'Beryllium oxide and hydroxide'),
('28259040', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxidy,hydroxidy wolframu', 'Tungsten oxides and hydroxides'),
('28259060', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxid kademnatý', 'Cadmium oxide'),
('28259085', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxidy,hydroxidy,peroxidy kovů ostatní,ne:viz sazebník', 'Inorganic bases and metal oxides, hydroxides and peroxides, n.e.s.'),
('28261200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fluorid hlinitý', 'Fluoride of aluminium'),
('28261910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fluorid amonný,sodný', 'Fluorides of ammonium or of sodium'),
('28261990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fluoridy ostatní,ne:amonný,sodný,hlinitý', 'Fluorides (excl. of ammonium, sodium, aluminium and mercury)'),
('28263000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hexafluorohlinitan sodný (kryolit syntetický)', 'Sodium hexafluoroaluminate "synthetic cryolite"'),
('28269010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hexafluorozirkoničitan draselný', 'Dipotassium hexafluorozirconate'),
('28269080', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Soli fluóru komplexní ostatní,ne:viz sazebník', 'Fluorosilicates, fluoroaluminates and other complex fluorine salts (excl. sodium'),
('28271000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlorid amonný', 'Ammonium chloride'),
('28272000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlorid vápenatý', 'Calcium chloride'),
('28273100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chloridy hořčíku', 'Magnesium chloride'),
('28273200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chloridy hliníku', 'Aluminium chloride'),
('28273500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chloridy niklu', 'Nickel chloride'),
('28273910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chloridy cínu', 'Tin chlorides'),
('28273920', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chloridy železa', 'Iron chlorides'),
('28273930', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chloridy kobaltu', 'Cobalt chlorides'),
('28273985', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chloridy ostatní, ne:amonný,vápenatý,Mg,Al,Fe,Co,Ni,Sn', 'Chlorides (excl. ammonium, calcium, magnesium, aluminium, iron, cobalt, nickel,'),
('28274100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlorid-oxidy,chlorid-hydroxidy mědi', 'Chloride oxides and chloride hydroxides of copper'),
('28274910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlorid-oxidy,chlorid-hydroxidy olova', 'Chloride oxides and chloride hydroxides of lead'),
('28274990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlorid-oxidy,chlorid-hydroxidy ostatní,ne:mědi,olova', 'Chloride oxides and chloride hydroxides (excl. copper, lead and mercury)'),
('28275100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bromidy sodíku,draslíku', 'Bromides of sodium or of potassium'),
('28275900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bromidy,brom-oxidy ostatní,ne:bromidy sodíku,draslíku', 'Bromides and bromide oxides (excl. of sodium, potassium and mercury)'),
('28276000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jodidy,jodid-oxidy', 'Iodides and iodide oxides (excl. inorganic or organic compounds of mercury)'),
('28281000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlornan vápenatý komerční,ostatní chlornany vápenaté', 'Calcium hypochlorites, incl. commercial calcium hypochlorite'),
('28289000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlornany,chloritany,bromnany ostatní,ne:chlornany vápenaté', 'Hypochlorites, chlorites and hypobromites (excl. calcium hypochlorites)'),
('28291100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlorečnany sodíku', 'Chlorate of sodium'),
('28291900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlorečnany ostatní,ne:sodíku', 'Chlorates (excl. sodium)'),
('28299010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chloristany', 'Perchlorates (excl. inorganic or organic compounds of mercury)'),
('28299040', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bromičnan draselný nebo sodný', 'Bromates of potassium or of sodium'),
('28299080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jodistany,jodičnany,bromistany,bromičnany ostatní,ne:bromičnan draselný,sodný', 'Bromates and perbromates (excl. potassium bromate and sodium bromate); iodates a'),
('28301000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sulfidy (sirníky) sodíku', 'Sodium sulphides'),
('28309011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sulfidy (sirníky) vápníku,antimonu,železa', 'Sulphides of calcium, of antimony and of iron'),
('28309085', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sulfidy (sirníky),polysulfidy ostatní,ne:viz sazebník', 'Sulphides; polysulphides, whether or not chemically defined (excl. sulphides of'),
('28311000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dithioničitany,sulfoxyláty sodíku', 'Dithionite and sulfoxylate of sodium'),
('28319000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dithioničitany,sulfoxyláty ostatní,ne:sodíku', 'Dithionites and sulfoxylates (excl. sodium)'),
('28321000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Siřičitany sodíku', 'Sodium sulphites'),
('28322000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Siřičitany ostatní,ne:sodíku', 'Sulphites (excl. sodium)'),
('28323000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Thiosírany', 'Thiosulphates'),
('28331100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Síran sodný', 'Disodium sulphate'),
('28331900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sírany sodíku ostatní,ne:síran sodný', 'Sodium sulphates (excl. disodium)'),
('28332100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sírany hořčíku', 'Sulphate of magnesium'),
('28332200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sírany hliníku', 'Sulphate of aluminium'),
('28332400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sírany niklu', 'Sulphates of nickel'),
('28332500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sírany mědi', 'Sulphates of copper'),
('28332700', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sírany baria', 'Sulphate of barium'),
('28332920', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sírany kadmia,chromu,zinku', 'Sulphates of cadmium, of chromium and of zinc'),
('28332930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sírany kobaltu,titanu', 'Sulphates of cobalt and of titanium'),
('28332960', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sírany olova', 'Sulphates of lead'),
('28332980', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sírany ostatní,ne:Na,Mg,Al,Ni,Cu,Ba,Cd,Cr,Zn,Co,Ti,Pb,Hg', 'Sulphates (excl. of sodium, magnesium, aluminium,  nickel, copper, barium, cadmi'),
('28333000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kamence', 'Alums'),
('28334000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Peroxosírany (persírany)', 'Peroxosulphates "persulphates"'),
('28341000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dusitany', 'Nitrites'),
('28342100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dusičnany draslíku', 'Nitrate of potassium'),
('28342920', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dusičnany baria,berylia,kadmia,kobaltu,niklu,olova', 'Nitrates of barium, of beryllium, of cadmium, of cobalt, of nickel and of lead'),
('28342940', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dusičnany mědi', 'Nitrates of copper'),
('28342980', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dusičnany ostatní,ne:K,Ba,Be,Cd,Co,Ni,Cu,Hg,Pb', 'Nitrates (excl. of potassium, barium, beryllium, cadmium, cobalt, nickel, copper'),
('28351000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fosfornany (hypofosfity),fosforitany (fosfity)', 'Phosphinates "hypophosphites" and phosphonates "phosphites"'),
('28352200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fosforečnany monosodné,disodné', 'Mono- or disodium phosphate'),
('28352400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fosforečnany draselné', 'Phosphates of potassium'),
('28352500', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hydrogenortofosforečnan vápenatý (fosforečnan divápenatý)', 'Calcium hydrogenorthophosphate "dicalcium phosphate"'),
('28352600', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fosforečnany vápníku ostatní,ne:hydrogenortofosforečnan vápenatý (fosforečnan divápenatý)', 'Phosphates of calcium (excl. calcium hydrogenorthophosphate "dicalcium phosphate'),
('28352910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fosforečnany triamonné', 'Phosphate of triammonium'),
('28352930', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fosforečnany trisodné', 'Phosphate of trisodium'),
('28352990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fosforečnany ostatní,ne:mono-,di-,trisodné,draselné,vápníku,triamonné', 'Phosphates (excl. phosphates of triammonium, monosodium, disodium, trisodium, of'),
('28353100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trifosforečnan sodný', 'Sodium triphosphate "sodium tripolyphosphate", whether or not chemically defined'),
('28353900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fosfornany,fosforitany,fosforečnany a polyfosforečnany ost.,ne:viz sazebník', 'Polyphosphates, whether or not chemically defined (excl. sodium triphosphate "so'),
('28362000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uhličitan sodný', 'Disodium carbonate'),
('28363000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hydrogenuhličitan sodný', 'Sodium hydrogencarbonate "sodium bicarbonate"'),
('28364000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uhličitany draselné', 'Potassium carbonates'),
('28365000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uhličitan vápenatý', 'Calcium carbonate'),
('28366000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uhličitan barnatý', 'Barium carbonate'),
('28369100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uhličitany lithia', 'Lithium carbonates'),
('28369200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uhličitan strontnatý', 'Strontium carbonate'),
('28369911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uhličitan hořčíku,mědi', 'Carbonates of magnesium and of copper'),
('28369917', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uhličitany ostatní,ne:Na,K,Ca,Ba,Li,Sr,Mg,Cu', 'Carbonates; commercial ammonium carbonate containing ammonium carbamate (excl. d'),
('28369990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Peroxouhličitany (perouhličitany)', 'Peroxocarbonates "percarbonates"'),
('28371100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyanidy,kyanid-oxidy sodíku', 'Sodium cyanide'),
('28371900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyanidy,kyanid-oxidy ostatní,ne:sodíku', 'Cyanides and cyanide oxides (excl. sodium and mercury)'),
('28372000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyanidy komplexní', 'Complex cyanides (excl. inorganic or organic compounds of mercury)'),
('28391100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Metakřemičitany sodné', 'Metasilicates of sodium, incl. commercial metasilicates'),
('28391900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Křemičitany sodíku ostatní,ne:metakřemičitany sodné', 'Silicates of sodium, incl. commercial silicates (excl. sodium metasilicates)'),
('28399010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Křemičitany draslíku', 'Silicates of potassium, incl. commercial silicates'),
('28399090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Křemičitany alkalických kovů ostatní i komerční,ne:sodíku,draslíku', 'Silicates, incl. commercial alkali metal silicates (excl. sodium and potassium s'),
('28401100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tetraboritan sodný (rafinovaný borax),bezvodý', 'Anhydrous disodium tetraborate "refined borax"'),
('28401910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tetraboritan sodný pentahydrát', 'Disodium tetraborate pentahydrate'),
('28401990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tetraboritan sodný (rafinovaný borax),ne:bezvodý,tetraboritan sodný pentahydrát', 'Disodium tetraborate "refined borax" (excl. anhydrous and disodium tetraborate p'),
('28402010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Boritany sodíku ostatní bezvodé,ne:tetraboritan sodný', 'Borates of sodium, anhydrous (excl. disodium tetraborate "refined borax")'),
('28402090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Boritany,ne:sodíku', 'Borates (excl. of sodium, anhydrous, and disodium tetraborate "refined borax")'),
('28403000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Peroxoboritany (perboritany)', 'Peroxoborates "perborates"'),
('28413000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dichroman sodný', 'Sodium dichromate'),
('28415000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chromany,dichromany ost.,peroxochromany,ne:dichroman sodný', 'Chromates and dichromates; peroxochromates (excl. sodium dichromate and  inorgan'),
('28416100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Manganistan draselný (hypermangan)', 'Potassium permanganate'),
('28416900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Manganitany,manganany,manganistany ostatní,ne:manganistan draselný', 'Manganites, manganates and permanganates (excl. potassium permanganate)'),
('28417000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Molybdenany', 'Molybdates'),
('28418000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Wolframany', 'Tungstates "wolframates"'),
('28419030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zinečnany,vanadičnany', 'Zincates and vanadates'),
('28419085', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Soli kyselin oxokovových,peroxokovových ostatní,ne:viz sazebník', 'Salts of oxometallic or peroxometallic acids (excl. chromates, dichromates, pero'),
('28421000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Křemičitany podvojné,komplexní', 'Double or complex silicates of inorganic acids or peroxoacids, incl. aluminosili'),
('28429010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Soli,i podvojné,komplexní kyselin selenu,telluru', 'Salts, double salts or complex salts of selenium or tellurium acids'),
('28429080', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Soli kyselin anorg.,poroxokyselin,ne:selenu,telluru', 'Salts of inorganic acids or peroxoacids (excl. of oxometallic or peroxometallic'),
('28431010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stříbro v koloidním stavu', 'Colloidal silver'),
('28431090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kovy drahé ostatní v koloidním stavu,ne:stříbro', 'Colloidal precious metals (excl. silver)'),
('28432100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dusičnan stříbrný', 'Silver nitrate'),
('28432900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sloučeniny stříbra ostatní,ne:dusičnan stříbrný', 'Silver compounds, inorganic or organic, whether or not chemically defined (excl.'),
('28433000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Sloučeniny zlata', 'Gold compounds, inorganic or organic, whether or not chemically defined'),
('28439010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Amalgamy drahých kovů,ne:stříbra,zlata', 'Amalgams of precious metals'),
('28439090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Sloučeniny drahých kovů,ne:zlata,stříbra', 'Inorganic or organic compounds of precious metals, whether or not chemically def'),
('28441010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KUR'), 'Uran přírodní surový,odpad,zbytky', 'Natural uranium, crude; waste and scrap, of natural uranium [Euratom]'),
('28441030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KUR'), 'Uran přírodní zpracovaný', 'Natural uranium, worked [Euratom]'),
('28441050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KUR'), 'Ferrouran', 'Alloys, dispersions incl. cermets, ceramic products and mixtures containing natu'),
('28441090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KUR'), 'Uran přírodní-sloučeniny,slitiny,disperze,cermety,keramické výr.apod.', 'Compounds of natural uranium; alloys, dispersions incl. cermets, ceramic product'),
('28442025', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GFI'), 'Ferro-uran obohacený U 235', 'Alloys, dispersions incl. cermets, ceramic products and mixtures containing uran'),
('28442035', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GFI'), 'Uran obohacený U 235 ostatní,ne:ferro-uran', 'Uranium enriched in U 235 and its compounds; alloys, dispersions incl. cermets,'),
('28442051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GFI'), 'Ferrouran obsahující plutonium', 'Mixtures of uranium and plutonium with iron "ferro-uranium"'),
('28442059', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GFI'), 'Směsi uranu,plutonia-sloučeniny,slitiny,směsi apod.,ne:ferrouran obsah.plutonium', 'Mixtures of uranium and plutonium [Euratom] (excl. ferro-uranium)'),
('28442099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GFI'), 'Radioaktivní chemické prvky a izotopy ostatní,jejich směsi a odpady,ne:viz sazebník', 'Plutonium and its compounds; alloys, dispersions incl. cermets, ceramic products'),
('28443011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cermety uranu', 'Cermets containing uranium depleted in U 235 or compounds of this product'),
('28443019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uran ochuzený o U 235,slitiny,disperze,výrobky,směsi apod.,ne:cermety', 'Uranium depleted in U 235; alloys, dispersions, ceramic products and mixtures, c'),
('28443051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cermety thoria', 'Cermets containing thorium or compounds of this product'),
('28443055', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Thorium surové,odpad,zbytky', 'Thorium, crude; waste and scrap, of thorium [Euratom]'),
('28443061', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Thorium ve tvaru tyčí,prutů,úhelníků,tvarovek,profilů,drátů,desek,pásů', 'Bars, rods, angles, shapes and sections, sheets and strips, of thorium [Euratom]'),
('28443069', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Thorium ostatní,ne:surové,odpad,zbytky,tyč,úhelník,tvarovka,drát,deska apod.', 'Thorium, worked; alloys, dispersions, ceramic products and mixtures containing t'),
('28443091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sloučeniny uranu ochuzeného o U 235,sloučeniny thoria,ne:thoriové soli', 'Compounds of thorium or of uranium depleted in U 235, whether or not intermixed'),
('28443099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Thoriové soli', 'Thorium salts'),
('28444010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uran získaný z U 233 a slouč.,disperzní slitiny,keram.výr.,směsi,slouč.z U 233', 'Uranium derived from U 233 and its compounds; alloys, dispersions incl. cermets,'),
('28444020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Umělé radioaktivní izotopy', 'Artificial radioactive isotopes [Euratom]'),
('28444030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sloučeniny umělých radioaktivních izotopů', 'Compounds of artificial radioactive isotopes [Euratom]'),
('28444080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Radioakt.slouč.,disperzní slitiny,keram.výr.,směsi,slouč.z U 233 ost.,ne:viz sazebík', 'Radioactive elements, isotopes and compounds (excl. subheading 2844.10, 2844.20,'),
('28445000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GFI'), 'Články palivové jaderných reaktorů vyhořelé', 'Spent "irradiated" fuel elements "cartridges" of nuclear reactors [Euratom]'),
('28451000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Voda těžká (deuterium oxide)', 'Heavy water "deuterium oxide" [Euratom]'),
('28459010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Deuterium a slouč.,vodík a slouč.,směsi,roztoky', 'Deuterium and other compounds of deuterium; hydrogen and compounds thereof, enri'),
('28459090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Izotopy neradioaktivní,sloučeniny,ne:viz sazebník', 'Isotopes and inorganic or organic compounds of such isotopes, whether or not che'),
('28461000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sloučeniny ceru', 'Cerium compounds'),
('28469000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Anorg.i org.sloučeniny kovů vzácných zemin,yttria,skandia,směsi,ne:slouč.ceru', 'Compounds, inorganic or organic, of rare-earth metals, of yttrium or of scandium'),
('28470000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KHO'), 'Peroxid vodíku i ztužený močovinou', 'Hydrogen peroxide, whether or not solidified with urea'),
('28480000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fosfidy, chemicky definované i nedefinované, vyjma ferofosfor', 'Phosphides, whether or not chemically defined (excl. ferrophosphorus)'),
('28491000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Karbidy vápníku chemicky definované i nedefinované', 'Carbides of calcium, whether or not chemically defined'),
('28492000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Karbidy křemíku chemicky definované i nedefinované', 'Carbides of silicon, whether or not chemically defined'),
('28499010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Karbidy boru chemicky definované i nedefinované', 'Carbides of boron, whether or not chemically defined'),
('28499030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Karbidy wolframu chemicky definované i nedefinované', 'Carbides of tungsten, whether or not chemically defined'),
('28499050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Karbidy hliníku,chromu,molybdenu,vanadu,tantalu,titanu', 'Carbides of aluminium, of chromium, of molybdenum, of vanadium, of tantalum, and'),
('28499090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Karbidy ostatní,ne:Ca,Si,B,W,Al,Cr,Mo,V,Ta,Ti', 'Carbides, whether or not chemically defined (excl. of calcium, silicon, boron, t'),
('28500020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hydridy; nitridy', 'Hydrides and nitrides, whether or not chemically defined (excl. compounds which'),
('28500060', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Azidy; silicidy', 'Azides, silicides, whether or not chemically defined (excl. compounds which are'),
('28500090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Boridy', 'Borides, whether or not chemically defined (excl. compounds which are also carbi'),
('28520000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sloučeniny rtuti,anorg i org,kromě amalgamů', 'Compounds, inorganic or organic, of mercury (excl. amalgams)'),
('28530010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Voda destilovaná,vodivostní a obdobné čistoty', 'Distilled and conductivity water and water of similar purity'),
('28530030', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vzduch kapalný i po odstranění vzácných plynů,stlačený', 'Liquid air, whether or not rare gases have been removed; compressed air'),
('28530050', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlorkyan', 'Cyanogen chloride'),
('28530090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní amalgamy, jiné než amalgamy drahých kovů', 'Inorganic compounds, n.e.s.; amalgams (excl. of precious metals)'),
('29011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní nasycené acyklické uhlovodíky', 'Saturated acyclic hydrocarbons'),
('29012100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ethylen', 'Ethylene'),
('29012200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Propen (propylen)', 'Propene "propylene"'),
('29012300', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Buten (butylen) a jeho isomery', 'Butene "butylene" and isomers thereof'),
('29012400', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '1,3-Butadien a isopren', 'Buta-1,3-diene and isoprene'),
('29012900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní nenasycené acyklické uhlovodíky', 'Hydrocarbons, acyclic, unsaturated (excl. ethylene, propene "propylene", butene'),
('29021100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cyklohexan', 'Cyclohexane'),
('29021900', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cykloalkany, cykloalkeny a cykloterpeny,ostatní,ne:cyklohexan', 'Cyclanes, cyclenes and cycloterpenes (excl. cyclohexane)'),
('29022000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Benzen', 'Benzene'),
('29023000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Toluen', 'Toluene'),
('29024100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'O-xylen', 'o-Xylene'),
('29024200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'M-xylen', 'm-Xylene'),
('29024300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'P-xylen', 'p-Xylene'),
('29024400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Xylen-směs isomerů', 'Mixed xylene isomers'),
('29025000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Styren', 'Styrene'),
('29026000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ethylbenzen', 'Ethylbenzene'),
('29027000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kumen', 'Cumene'),
('29029000', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cyklické uhlovodíky ostatní,ne:viz sazebník', 'Cyclic hydrocarbons (excl. cyclanes, cyclenes, benzene, toluene, xylenes, styren'),
('29031100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlormethan (methylchlorid),chlorethan (ethylchlorid)', 'Chloromethane "methyl chloride" and chloroethane "ethyl chloride"'),
('29031200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dichlormethan (methylenchlorid)', 'Dichloromethane "methylene chloride"'),
('29031300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chloroform (trichlomethan)', 'Chloroform "trichloromethane"'),
('29031400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tetrachlormethan (chlorid uhličitý)', 'Carbon tetrachloride'),
('29031500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ethylendichlorid (ISO) (1,2-dichlorethan)', 'Ethylene dichloride "ISO" "1,2 dichloroethane"'),
('29031910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '1,1,1- Trichlorethan (methylchloroform)', '1,1,1-Trichloroethane "methylchloroform"'),
('29031980', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlorderiváty acyklických uhlovodíků nasycené ostatní', 'Saturated chlorinated derivatives of acyclic hydrocarbons (excl. chloromethane ['),
('29032100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vinylchlorid (chlorethylen)', 'Vinyl chloride "chloroethylene"'),
('29032200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trichlorethylen', 'Trichloroethylene'),
('29032300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tetrachlorethylen (perchlorethylen)', 'Tetrachloroethylene "perchloroethylene"'),
('29032900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlorderiváty acyklických uhlovodíků nenasycené ostatní', 'Unsaturated chlorinated derivatives of acyclic hydrocarbons (excl. vinyl chlorid'),
('29033100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ethylendibromid (ISO) (1,2-dibromethan)', 'Ethylene dibromide "ISO" "1,2-dibromoethane"'),
('29033911', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brommethan (methylbromid)', 'Bromomethane "methyl bromide"'),
('29033915', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dibrommethan', 'Dibromomethane'),
('29033919', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bromidy acyklických uhlovodíků ost.,ne:viz sazebník', 'Bromides "brominated derivatives" of acyclic hydrocarbons (excl. ethylene dibrom'),
('29033990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fluoridy,jodidy acyklických uhlovodíků', 'Fluorides "fluorinated derivatives" and iodides "iodinated derivatives" of acycl'),
('29034100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trichlorfluormethan', 'Trichlorofluoromethane'),
('29034200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dichlordifluormethan', 'Dichlorodifluoromethane'),
('29034300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trichlortrifluorethany', 'Trichlorotrifluoroethanes'),
('29034410', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dichlortetrafluorethany', 'Dichlorotetrafluoroethanes'),
('29034490', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlorpentafluorethan', 'Chloropentafluoroethane'),
('29034510', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlortrifluormethan', 'Chlorotrifluoromethane'),
('29034515', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pentachlorfluorethan', 'Pentachlorofluoroethane'),
('29034520', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tetrachlordifluorethany', 'Tetrachlorodifluoroethanes'),
('29034525', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Heptachlorfluorpropany', 'Heptachlorofluoropropanes'),
('29034530', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hexachlordifluorpropany', 'Hexachlorodifluoropropanes'),
('29034535', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pentachlortrifluorpropany', 'Pentachlorotrifluoropropanes'),
('29034540', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tetrachlortetrafluorpropany', 'Tetrachlorotetrafluoropropanes'),
('29034545', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trichlorpentefluorpropany', 'Trichloropentafluoropropanes'),
('29034550', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dichlorhexafluorpropany', 'Dichlorohexafluoropropanes'),
('29034555', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlorheptafluorpropany', 'Chloroheptafluoropropanes'),
('29034590', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Halogenderiváty acykl.uhlovod.ost.,obsah.pouze chlor,fluor,ne:viz sazebník', 'Derivatives of acyclic hydrocarbons, perhalogenated only with fluorine and chlor'),
('29034610', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bromchloridfluormethan', 'Bromochlorodifluoromethane'),
('29034620', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bromtrifluormethan', 'Bromotrifluoromethane'),
('29034690', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dibromtetrafluorethany', 'Dibromotetrafluoroethanes'),
('29034700', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Perhalogennované deriváty acyklických uhlovodíků ostatní,ne:viz sazebník', 'Perhalogenated derivatives of acyclic hydrocarbons with two or more different ha'),
('29034911', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlordifluormethan (HCFC-22)', 'Chlorodifluoromethane (HCFC-22)'),
('29034915', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '1,1-Dichlor-1-fluorethan (HCFC-141b)', '1,1-Dichloro-1-fluoroethane (HCFC-141b)'),
('29034919', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Halogenderiváty methanu,ethanu,propanu (HCFC) halogenované pouze fluorem a chlorem,ostatní,ne:viz sazebník', 'Halogenated derivatives of methane, ethane or propane, halogenated only with flu'),
('29034920', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Halogenderiváty (pouze fluorem,chlorem) acyklic.uhlovod.ost.,ne:viz sazebník', 'Halogenated derivatives of acyclic hydrocarbons, halogenated only with fluorine'),
('29034930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Halogenderiváty methanu,ethanu nebo propanu,halogenované pouze fluorem a bromem', 'Halogenated derivatives of methane, ethane or propane, halogenated only with flu'),
('29034940', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Halogenderiváty acykl.uhlovod.,pouze fluorem a bromem,ne:methan,ethan,propan', 'Halogenated derivatives of acyclic hydrocarbons, halogenated only with fluorine'),
('29034980', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Halogenderiváty acyklických uhlovodíků ostatní,ne:viz sazebník', 'Halogenated derivatives of acyclic hydrocarbons with two or more different halog'),
('29035100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '1,2,3,4,5,6-hexachlorcyklohexan (HCH (ISO)),vč.lindanu (ISO,INN)', '1,2,3,4,5,6-Hexachlorocyclohexane [HCH "ISO"], incl. lindane "ISO" "INN"'),
('29035200', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Aldrin (ISO),chlordan (ISO) a heptachlor (ISO)', 'Aldrin "ISO", chlordane "ISO" and heptachlor "ISO"'),
('29035920', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '1,2-Dibrom-4-(1,2-dibromethyl)cyklohexan; tetrabromcyklooktany', '1,2-Dibromo-4-(1,2-dibromoethyl)cyclohexane; tetrabromocyclooctanes'),
('29035980', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní halogenderiváty cykloalkanických uhlovodíků', 'Halogenated derivatives of cyclanic, cyclenic or cycloterpenic hydrocarbons (exc'),
('29036100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlorbenzen,o-dichlorbenzen, p-dichlorbenzen', 'Chlorobenzene, o-dichlorobenzene and p-dichlorobenzene'),
('29036200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hexachlorbenzen (ISO) a DDT (ISO) (klofenotan (INN),1,1,1-trichlor-2,2-bis(p-chlorfenyl)ethan)', 'Hexachlorobenzene "ISO" and DDT "ISO" "clofenotane "INN", "1,1,1-trichloro-2,2-b'),
('29036910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '2,3,4,5,6-Pentabromethylbenzen', '2,3,4,5,6-Pentabromoethylbenzene'),
('29036990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní halogenderiváty aromat.uhlovodíků', 'Halogenated derivatives of aromatic hydrocarbons (excl. chlorobenzene, o-dichlor'),
('29041000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Deriváty uhlovodíků obsahující pouze sulfoskupiny,jejich soli,ethylestery', 'Derivatives of hydrocarbons containing only sulpho groups, their salts and ethyl'),
('29042000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Deriváty uhlovodíků,obsahující pouze nitro- nebo pouze nitroso skupiny', 'Derivatives of hydrocarbons containing only nitro or nitroso groups'),
('29049040', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trichlornitromethan (chlorpikrin)', 'Trichloronitromethane "chloropicrin"'),
('29049095', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sulfo-,nitro-,nitrosoderiváty uhlovodíků,též halogenované,ostatní,ne:viz sazebník', 'Sulphonated, nitrated or nitrosated derivatives of hydrocarbons, whether or not'),
('29051100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Methanol (methylalkohol)', 'Methanol "methyl alcohol"'),
('29051200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '1-propanol (propylalkohol),2-propanol (izopropylalkohol)', 'Propan-1-ol "propyl alcohol" and propan-2-ol "isopropyl alcohol"'),
('29051300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '1-butanol (n-butylalkohol)', 'Butan-1-ol "n-butyl alcohol"'),
('29051410', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '2-methyl-2-propanol (terc.butylalkohol)', '2-Methylpropan-2-ol "tert-butyl alcohol"'),
('29051490', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Butanoly ostatní,ne:2-methyl-2-propanol (terc.butylalkohol)', 'Butanols (excl. butan-1-ol "n-butyl alcohol" and 2-Methylpropan-2-ol "tert-butyl'),
('29051620', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '2-Oktanol', 'Octan-2-ol'),
('29051685', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oktanol (oktylalkohol) a jeho izomery,ne:2-oktanol', 'Octanol "octyl alcohol" and isomers thereof (excl. octan-2-ol)'),
('29051700', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '1-dodekanol,1-hexadekanol,1-oktadekanol', 'Dodecan-1-ol "lauryl alcohol", hexadecan-1-ol "cetyl alcohol" and octadecan-1-ol'),
('29051900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nasycené jednosytné acyklické alkoholy ostatní,ne:viz sazebník', 'Saturated monohydric acyclic alcohols (excl. methanol "methyl alcohol", propan-1'),
('29052200', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Acyklické terpenické alkoholy', 'Acyclic terpene alcohols'),
('29052910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Allylalkohol', 'Allyl alcohol'),
('29052990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Alkoholy jednosytné nenasycené ostatní,ne:viz sazebník', 'Unsaturated monohydric acyclic alcohols (excl. allyl alcohol and acyclic terpene'),
('29053100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ethylenglykol (ethandiol)', 'Ethylene glycol "ethanediol"'),
('29053200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Propylenglykol (1,2-propandiol)', 'Propylene glycol "propane-1,2-diol"'),
('29053920', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '1,3-Butandiol', 'Butane-1,3-diol'),
('29053925', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '1,4-Butandiol', 'Butane-1,4-diol'),
('29053930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '4,7-Dihydroxy-2,4,7,9-tetramethyl-5-decin', '2,4,7,9-Tetramethyldec-5-yne-4,7-diol'),
('29053995', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dioly ostatní,ne:viz sazebník', 'Acyclic diols (excl. ethylene glycol "ethanediol", propylene glycol "propane-1,2'),
('29054100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '2-ethyl-2-(hydroxymethyl) 1,3-propandiol (trimethylopropan)', '2-Ethyl-2-"hydroxymethyl" propane-1,3-diol "trimethylolpropane"'),
('29054200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pentaerythritol (pentaerythrit)', 'Pentaerythritol'),
('29054300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mannitol (mannit)', 'Mannitol'),
('29054411', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'D-glucitol ve vodném roztoku, mannitol do 2 %', 'D-glucitol "sorbitol", in aqueous solution containing <= 2% by weight of d-manni'),
('29054419', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'D-glucitol ve vodném roztoku, mannitol nad 2 %', 'D-glucitol "sorbitol" in aqueous solution (excl. containing <= 2% by weight of d'),
('29054491', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'D-glucitol ne ve vodném roztoku, mannitol do 2 %', 'D-glucitol "sorbitol", containing <= 2% by weight of d-mannitol, calculated on t'),
('29054499', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'D-glucitol ne ve vodném roztoku, mannitol nad 2 %', 'D-glucitol "sorbitol" (excl. in aqueous solution and containing <= 2% by weight'),
('29054500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Glycerol', 'Glycerol'),
('29054900', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní vícesytné alkoholy', 'Tri- and other polyhydric acyclic alcohols (excl. 2-ethyl-2-"hydroxymethyl" prop'),
('29055100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Etchlorvynol (INN)', 'Ethchlorvynol "INN"'),
('29055991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '2,2-bis(brommethyl)propandiol', '2,2-Bis"bromomethyl"propanediol'),
('29055998', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Halogen-,sulfo-,nitro-nitrosoderiváty acyklických alkoholů,ne:viz sazebník', 'Halogenated, sulphonated, nitrated or nitrosated derivatives of acyclic alcohols'),
('29061100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Menthol', 'Menthol'),
('29061200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cyklohexanol,methylcyklohexanoly,dimethylcyklohexanoly', 'Cyclohexanol, methylcyclohexanols and dimethylcyclohexanols'),
('29061310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Steroly (steriny)', 'Sterols'),
('29061390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Inositoly (inosity)', 'Inositols'),
('29061900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Alkoholy cykloalkanické,cykloalkenické,cykloterpenické ostatní,ne:viz sazebník', 'Cyclanic, cyclenic or cycloterpenic alcohols and their halogenated, sulphonated,'),
('29062100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Benzylalkohol', 'Benzyl alcohol'),
('29062900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cyklické alkoholy,jejich halogen-,sulfo-,nitro(so)deriváty ost.,ne:viz sazebník', 'Aromatic cyclic alcohols and their halogenated, sulphonated, nitrated or nitrosa'),
('29071100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fenol (hydroxybenzen),soli', 'Phenol "hydroxybenzene" and its salts'),
('29071200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kresoly,soli', 'Cresols and their salts'),
('29071300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oktylfenol,nonylfenol,izomery, soli', 'Octylphenol, nonylphenol and their isomers; salts thereof'),
('29071510', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '1-Naftol', '1-Naphthol'),
('29071590', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Naftoly,jejich soli ostatní,ne:1-Naftol', 'Naphthols and their salts (excl. 1-naphthol)'),
('29071910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Xylenoly,soli', 'Xylenols and their salts'),
('29071990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Monofenoly ostatní,ne:viz sazebník', 'Monophenols (excl. phenol "hydroxybenzene" and its salts, cresols and their salt'),
('29072100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Resorcinol (resorcin),soli', 'Resorcinol and its salts'),
('29072200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hydrochinon (chinon) a jeho soli', 'Hydroquinone "quinol" and its salts'),
('29072300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '4,4´-isopropylidendifenol a jeho soli', '4,4-Isopropylidenediphenol "bisphenol A, diphenylolpropane" and its salts'),
('29072900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polyfenoly ostatní,ne:viz sazebník', 'Polyphenols and phenol-alcohols (excl. resorcinol and hydroquinone "quinol" and'),
('29081100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pentachlorfenol (ISO)', 'Pentachlorophenol "ISO"'),
('29081900', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Derifáty fenolů,fenolalkoholů,obsah.jen halogen.substit.a jejich soli,ne:pentachlorfenol', 'Derivatives containing only halogen substituents and their salts, of phenols or'),
('29089100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dinoseb (ISO) a jeho soli', 'Dinoseb "ISO" and its salts'),
('29089910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Deriváty fenolů,fenolalkoholů obsah.pouze sulfoskupiny,soli,estery,ne:viz sazebník', 'Sulphonated derivatives, their salts and esters, of phenols or phenol-alcohols'),
('29089990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Deriváty fenolů,fenolalkoholů,obsah.jen nitroskupiny,nitrosoderiváty,ne:viz sazebník', 'Halogenated, sulphonated, nitrated or nitrosated derivatives of phenols or pheno'),
('29091100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Diethylether', 'Diethyl ether'),
('29091910', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Terc-butyl(ethyl)ether (ethyl-tercio-butyl-ether, ETBE)', 'Tert-butyl ethyl ether (ethyl-tertio-butyl-ether, ETBE)'),
('29091990', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ethery acyklické ostatní,deriváty,ne:viz sazebník', 'Acyclic ethers and their halogenated, sulphonated, nitrated or nitrosated deriva'),
('29092000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ethery cykloalkanické,-alkenické,-terpenické,sulfo-,nitro-,nitrosoderiváty', 'Cyclanic, cyclenic or cycloterpenic ethers and their halogenated, sulphonated, n'),
('29093010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Difenylether', 'Diphenyl ether'),
('29093031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pentabromodifenyloxid,tetradekabromodifenoxybenzen', 'Pentabromodiphenyl ether; 1,2,4,5-tetrabromo-3,6-bis"pentabromophenoxy"benzene'),
('29093035', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '1,2-Bis(2,4,6-tribromfenoxy)ethan pro výrobu akrylonitril-butadien-styrenu', '1,2-Bis"2,4,6-tribromophenoxy"ethane for the manufacture of acrylonitrile-butadi'),
('29093038', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bromderiváty cykloalkanické,-alkenické,-terpentické etherů ost.,ne:viz sazebník', 'Brominated derivatives of aromatic ethers (excl. pentabromodiphenyl ether, 1,2,4'),
('29093090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ethery aromatické,halogen-,sulfo-,nitro-,nitrosoderiváty,ne:difenylether,bromderiváty', 'Aromatic ethers and their halogenated, sulphonated, nitrated or nitrosated deriv'),
('29094100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '2,2-oxydiethanol (diethylenglykol,digol)', '2,2''-Oxydiethanol "diethylene glycol, digol"'),
('29094300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Monobutylethery ethylenglykolu,diethylenglykolu', 'Monobutyl ethers of ethylene glycol or of diethylene glycol'),
('29094400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Monoalkylethery ethylenglykolu,diethylenglykolu ostatní,ne:viz sazebník', 'Monoalkylethers of ethylene glycol or of diethylene glycol (excl. monobutyl ethe'),
('29094911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '2-(2-chloretoxy)ethanol', '2-"2-Chloroethoxy"ethanol'),
('29094980', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Etheralkoholy a jejich halogen-,sulfo-,nitro- nebo nitrosoderiváty,cyklické,ostatní,ne:viz sazebník', 'Cyclic ether-alcohols and their halogenated, sulphonated, nitrated or nitrosated'),
('29095000', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Etherfenoly, etheralkoholfenoly a jejich halogen-, sulfo-, nitro- nebo nitrosoderiváty', 'Ether-phenols, ether-alcohol-phenols and their halogenated, sulphonated, nitrate'),
('29096000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Alkohol-,ether-,ketoperoxidy a jejich halogen-,sulfo-,nitro-,nitrosoderiváty', 'Alcohol peroxides, ether peroxides, ketone peroxides and their halogenated, sulp'),
('29101000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oxiran (ethylenoxid)', 'Oxirane "ethylene oxide"'),
('29102000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Methyloxiran (propylenoxid)', 'Methyloxirane "propylene oxide"'),
('29103000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '1-chlor-2,3-epoxypropan (epichlorhydrin)', '1-Chloro-2,3-epoxypropane "epichlorohydrin"'),
('29104000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dieldrin (ISO,INN)', 'Dieldrin "ISO" "INN"'),
('29109000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Epoxidy,epoxyalkoholy,-fenoly,-ethery ost.,ne:viz sazebník', 'Epoxides, epoxyalcohols, epoxyphenols and epoxyethers, with a three-membered rin'),
('29110000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Acetaly,poloacetaly (hemiacetaly), jejich halogen-,sulfo-,nitro-,nitrosoderiváty', 'Acetals and hemiacetals, whether or not with other oxygen function, and their ha'),
('29121100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Methanal (formaldehyd)', 'Methanal "formaldehyde"'),
('29121200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ethanal (acetaldehyd)', 'Ethanal "acetaldehyde"'),
('29121910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Butanal (butyraldehyd,normální izomer)', 'Butanal "butyraldehyde, normal isomer"'),
('29121990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Aldehydy acyklické bez jiné kyslíkaté funkce ost.,ne:viz sazebník', 'Acyclic aldehydes, without other oxygen function (excl. methanal [formaldehyde],'),
('29122100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Benzaldehyd', 'Benzaldehyde'),
('29122900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Aldehydy cyklické bez jiné kyslíkaté funkce ostatní,ne:benzaldehyd', 'Cyclic aldehydes, without other oxygen function (excl. benzaldehyde)'),
('29123000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Aldehydalkoholy', 'Aldehyde-alcohols'),
('29124100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vanilin (4-hydroxy-3-methoxybenzaldehyd)', 'Vanillin "4-hydroxy-3-methoxybenzaldehyde"'),
('29124200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ethylvanilin (3-ethoxy-4-hydroxybenzaldehyd)', 'Ethylvanillin "3-ethoxy-4-hydroxybenzaldehyde"'),
('29124900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Aldehydethery,-fenoly,aldehydy s jinou kyslíkatou funkcí ostatní,ne:viz sazebník', 'Aldehyde-ethers, aldehyde-phenols and aldehydes with other oxygen function (excl'),
('29125000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polymery aldehydu cyklické', 'Cyclic polymers of aldehydes'),
('29126000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Paraformaldehyd', 'Paraformaldehyde'),
('29130000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Derivaty aldehydu,polymeru,paraformaldehydu', 'Halogenated, sulphonated, nitrated or nitrosated derivatives of cyclic polymers'),
('29141100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Aceton', 'Acetone'),
('29141200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Butanon (ethylmethylketon)', 'Butanone "methyl ethyl ketone"'),
('29141300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '4-methyl-2-pentanon (methylisobutylketon)', '4-Methylpentan-2-one "methyl isobutyl ketone"'),
('29141910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '5-methyl-2-hexanon', '5-Methylhexan-2-one'),
('29141990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Acyklické ketony bez kyslíkaté funkce ostatní,ne:viz sazebník', 'Acyclic ketones without other oxygen function (excl. acetone, butanone "methyl e'),
('29142100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kafr', 'Camphor'),
('29142200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cyklohexanon,methylcyklohexanony', 'Cyclohexanone and methylcyclohexanones'),
('29142300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jonony,methyljonony', 'Ionones and methylionones'),
('29142900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ketony cykloalkanické,-alkenické,-terpenické bez jiné kysl.funkce ost.ne:viz sazebník', 'Cyclanic, cyclenic or cycloterpenic ketones, without other oxygen function (excl'),
('29143100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fenylaceton ostaní,ne:viz sazebník', 'Phenylacetone "phenylpropan-2-one"'),
('29143900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ketony aromatické bez kyslíkaté funkce ostatní,ne:fenylaceton', 'Ketones, aromatic, without other oxygen function (excl. phenylacetone [phenylpro'),
('29144010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '4-hydroxy-4-methyl-2-pentanon (diacetonalkohol)', '4-Hydroxy-4-methylpentan-2-one "diacetone alcohol"'),
('29144090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ketoalkoholy,ketoaldehydy ostatní,ne:4-hydroxy-4-methyl-2-pentanon', 'Ketone-alcohols and ketone-aldehydes (excl. 4-Hydroxy-4-methylpentan-2-one "diac'),
('29145000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ketofenoly,ketony s jinou kyslíkatou funkcí', 'Ketone-phenols and ketones with other oxygen function'),
('29146100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Antrachinon', 'Anthraquinone'),
('29146910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '1,4-Naftochinon', '1,4-Naphthoquinone'),
('29146990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chinony ostatní,ne:Antrachinon,1,4-Naftochinon', 'Quinones (excl. anthraquinone and 1,4-naphthoquinone)'),
('29147000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Halogen-, sulfo-, nitro- nebo nitrosoderiváty', 'Halogenated, sulphonated, nitrated or nitrosated derivatives of ketones or quino'),
('29151100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina mravenčí', 'Formic acid'),
('29151200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Soli kyseliny mravenčí', 'Salts of formic acid'),
('29151300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Estery kyseliny mravenčí', 'Esters of formic acid'),
('29152100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina octová', 'Acetic acid'),
('29152400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Acetanhydrid', 'Acetic anhydride'),
('29152900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Soli kyseliny octové', 'Salts of acetic acid (excl. inorganic or organic compounds of mercury)'),
('29153100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ethylacetát', 'Ethyl acetate'),
('29153200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vinylacetát', 'Vinyl acetate'),
('29153300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'N-butylacetát', 'n-Butyl acetate'),
('29153600', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dinoseb (ISO) acetát', 'Dinoseb acetate "ISO"'),
('29153900', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Estery kyseliny octové ostatní,ne:ethylacetát,vinylacetát,N-butylacetát,dinoseb (ISO) acetát', 'Esters of acetic acid (excl. ethyl, vinyl, n-butyl and dinoseb [ISO] acetates)'),
('29154000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyseliny mono-,di-,trichloroctové,soli,estery', 'Mono- di- or trichloroacetic acids, their salts and esters'),
('29155000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina propionová,soli,estery', 'Propionic acid, its salts and esters'),
('29156011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '1-Isopropyl-2,2-dimethyltrimethylendiisobutyrat', '1-Isopropyl-2,2-dimethyltrimethylene diisobutyrate'),
('29156019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyseliny máselné,isomáselné,soli,estery ostatní,ne:viz sazebník', 'Butanoic acids and their salts and esters (excl. 1-isopropyl-2,2-dimethyltrimeth'),
('29156090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina valerová,její izomery,soli,estery', 'Pentanoic acids and their salts and esters'),
('29157000', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina palmitová, kyselina stearová, jejich soli a estery', 'Palmitic acid, stearic acid, their salts and esters'),
('29159000', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.nas.acykl.monokarb.kyseliny,anhydridy,halogenidy,peroxidy,peroxykys.,deriváty,ne:viz sazebník', 'Saturated acyclic monocarboxylic acids, their anhydrides, halides, peroxides and'),
('29161100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina akrylová (2-propenová) a její soli', 'Acrylic acid and its salts'),
('29161200', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Estery kyseliny akrylové', 'Esters of acrylic acid'),
('29161300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina methakrylová (2-methyl-2-propenová),soli', 'Methacrylic acid and its salts'),
('29161400', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Estery kyseliny methakrylové', 'Esters of methacrylic acid'),
('29161500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina olejová,linolová,linolenová,soli,estery', 'Oleic, linoleic or linolenic acids, their salts and esters (excl. inorganic or o'),
('29161910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyseliny undekanové,soli,estery', 'Undecenoic acids and their salts and esters'),
('29161940', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina krotonová (kyselina-2-butenová)', 'Crotonic acid'),
('29161950', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Binapakryl (ISO)', 'Binapacryl "ISO"'),
('29161995', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.nenas.acykl.monokarb.kyseliny,anhydridy,halogenidy,peroxidy,peroxykys.,deriváty,ne:viz sazebník', 'Unsaturated acyclic monocarboxylic acids, their anhydrides, halides, peroxides,'),
('29162000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kys.monokarboxylové cykloalkanické,- alkenické,-terpenické,anhydridy apod.', 'Cyclanic, cyclenic or cycloterpenic monocarboxylic acids, their anhydrides, hali'),
('29163100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina benzoová,soli,estery', 'Benzoic acid, its salts and esters (excl. inorganic or organic compounds of merc'),
('29163200', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Benzoylperoxid a benzoylchlorid', 'Benzoyl peroxide and benzoyl chloride'),
('29163400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina fenyloctová,soli', 'Phenylacetic acid and its salts'),
('29163500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Estery kyseliny fenyloctové', 'Esters of phenylacetic acid'),
('29163900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyseliny monokarboxylové aromat.ost.,halogenidy,deriváty apod.ne:viz sazebník', 'Aromatic monocarboxylic acids, their anhydrides, halides, peroxides, peroxyacids'),
('29171100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina šťavelová,soli, estery', 'Oxalic acid, its salts and esters (excl. inorganic or organic compounds of mercu'),
('29171200', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina adipová, její soli a estery', 'Adipic acid, its salts and esters'),
('29171310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina sebaková', 'Sebacic acid'),
('29171390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina azelaová,soli a estery i kys.sebakové,ne:kyselina sebaková', 'Azelaic acid, their salts and esters and salts and esters of sebacic acid'),
('29171400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Maleinanhydrid', 'Maleic anhydride'),
('29171910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina malonová,soli,estery', 'Malonic acid, its salts and esters'),
('29171990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyseliny polykarboxylové acyklické ostatní,anhydridy,deriváty apod.,ne:viz sazebník', 'Acyclic polycarboxylic acids, their anhydrides, halides, peroxides, peroxyacids'),
('29172000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kys.polykarboxylové cykloalkanické,-alkenické,-terpenické,anhydridy apod.ne:viz sazebník', 'Cyclanic, cyclenic or cycloterpenic polycarboxylic acids, their anhydrides, hali'),
('29173200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dioktylorthoftaláty', 'Dioctyl orthophthalates'),
('29173300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dinonyl,didecylorthoftaláty', 'Dinonyl or didecyl orthophthalates'),
('29173410', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dibutylorthoftaláty', 'Dibutyl orthophthalates'),
('29173490', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Estery kyseliny orthoftalové ostatní', 'Esters of orthophthalic acid (excl. dibutyl, dioctyl, dinonyl or didecyl orthoph'),
('29173500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ftalanhydrid', 'Phthalic anhydride'),
('29173600', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina tereftalová,soli', 'Terephthalic acid and its salts'),
('29173700', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dimethyltereftalát', 'Dimethyl terephthalate'),
('29173920', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ester,anhydrid kyseliny tetrabromftalové;kyselina 1,2,4-benzentrikarboxylová;isoftaloyldichlorid obsah.<=0,8% hmot.tereftaloyldichloridu;kyselina 1,4,', 'Ester or anhydride of tetrabromophthalic acid; benzene-1,2,4-tricarboxylic acid;'),
('29173995', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.arom.polykarb.kyseliny,anhydridy,halogenidy,peroxidy,peroxykys.,deriváty,ne:viz sazebník', 'Aromatic polycarboxylic acids, their anhydrides, halides, peroxides, peroxyacids'),
('29181100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina mléčná,soli,estery', 'Lactic acid, its salts and esters (excl. inorganic or organic compounds of mercu'),
('29181200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina vinná', 'Tartaric acid'),
('29181300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Soli,estery kyseliny vinné', 'Salts and esters of tartaric acid'),
('29181400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina citronová', 'Citric acid'),
('29181500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Soli,estery kyseliny citronové', 'Salts and esters of citric acid (excl. inorganic or organic compounds of mercury'),
('29181600', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina glukonová,soli, estery', 'Gluconic acid, its salts and esters'),
('29181800', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlorbenzilát (ISO)', 'Chlorobenzilate "ISO"'),
('29181930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina cholová,3-alfa,12-alfa-dihydrxy-5-beta-cholanová,soli,estery', 'Cholic acid and 3-alpha, 12-alpha-dihydroxy-5-beta-cholan-24-oic acid "deoxychol'),
('29181940', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina 2,2-Bis(hydroxymethyl)propionová', '2,2-Bis"hydroxymethyl"propionic acid'),
('29181950', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '2,2-Difenyl-2-hydroxyoctová kyselina (kyselina benzilová)', '2,2-Diphenyl-2-hydroxyacetic acid (benzilic acid)'),
('29181998', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Karboxylové kyseliny s alkohol.funkcí ale bez jiné kyslík.funkce,ostatní,ne:viz sazebník', 'Carboxylic acids with additional oxygen function and their anhydrides, halides,'),
('29182100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina salicylová,soli', 'Salicylic acid and its salts (excl. inorganic or organic compounds of mercury)'),
('29182200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'O-acetylsalicylová kyselina,soli,estery', 'o-Acetylsalicylic acid, its salts and esters'),
('29182300', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní estery kyseliny salicylové a jejich soli,ne:viz sazebník', 'Esters of salicylic acid and their salts (excl. o-acetylsalicylic acid, its salt'),
('29182900', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Karbox.kys.jen s fenol.funkcí,anhydridy,halogenidy,peroxidy,peroxykys.,deriváty,ost.,ne:viz sazebník', 'Carboxylic acids with phenol function but without other oxygen function, their a'),
('29183000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyseliny karboxylové s aldehydickou,ketonickou funkcí,bez jiné kysl,soli apod.', 'Carboxylic acids with aldehyde or ketone function but without other oxygen funct'),
('29189100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '2,4,5-T (ISO) (kys.2,4,5-trichlorfenoxyoctová),soli,estery', '2,4,5-T "ISO" "2,4,5-trichlorophenoxyacetic acid", its salts and esters'),
('29189940', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '2,6-Dimethoxybenzoová kyselina; dikamba (ISO); fenoxyacetát sodný', '2,6-Dimethoxybenzoic acid; dicamba (ISO); sodium phenoxyacetate'),
('29189990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Karboxylové kyseliny s přidanou kyslík.funkcí ost.,soli apod.,ne:viz sazebník', 'Carboxylic acids with additional oxygen function, their anhydrides, halides, per'),
('29191000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tris(2,3-dibrompropyl) fosfát', 'Tris"2,3-dibromopropyl" phosphate'),
('29199000', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Estery kys.fosforečné,soli,vč.laktofosfátů,jejich deriváty,ostatní,ne:tris(2,3-dibrompropyl) fosfát', 'Phosphoric esters and their salts, incl. lactophosphates; their halogenated, sul'),
('29201100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Parathion (ISO),parathion-methyl (ISO) (methyl-parathion)', 'Parathion "ISO" and parathion-methyl "ISO" "methyl-parathion"'),
('29201900', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Estery thiofosforečné,jejich soli,deriváty,ost.', 'Thiophosphoric esters "phosphorothioates" and their salts; their halogenated, su'),
('29209010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Estery kyseliny sírové,uhličité,soli,deriváty', 'Sulphuric esters and carbonic esters and their salts, and their halogenated, sul'),
('29209020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dimethylfosfát', 'Dimethyl phosphonate "dimethyl phosphite"'),
('29209030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trimethylfosfát', 'Trimethyl phosphite "trimethoxyphosphine"'),
('29209040', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Triethylfosfit', 'Triethyl phosphite'),
('29209050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Diethylfosfonat(diethylhydrogenfosfit)(diethylfosfit)', 'Diethyl phosphonate "diethyl hydrogenphosphite" "diethyl phosphite"'),
('29209085', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní výrobky skupiny estery ostatních anorganic.kyselin', 'Esters of inorganic acids of non-metals and their salts; their halogenated, sulp'),
('29211100', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'KMA'), 'Methylamin, dimethylamin nebo trimethylamin a jejich soli', 'Methylamine, dimethylamine or trimethylamine and their salts'),
('29211940', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '1,1,3,3-Tetramethylbutylamin', '1,1,3,3-Tetramethylbutylamine'),
('29211950', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Diethylamin,soli', 'Diethylamine and its salts'),
('29211960', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '2-(N,N-Diethylamino)ethylchlorid-hydrochlorid,2-(N,N-diisopropylamino)ethylchloridhydrochlorid,2-(N,N-dimethylamino)ethylchlorid-hydrochlorid', '2-(N,N-Diethylamino)ethyl chloride hydrochloride, 2-(N,N-diisopropylamino)ethyl'),
('29211999', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní acyklické polyaminy a jejich deriváty,jejich soli,ne:viz sazebník', 'Acyclic monoamines and their derivatives; salts thereof (excl. methylamine, dime'),
('29212100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ethylendiamin,soli', 'Ethylenediamine and its salts'),
('29212200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hexamethylendiamin,soli', 'Hexamethylenediamine and its salts'),
('29212900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polyaminy acykl.ostatní,deriváty,soli,ne:ethylendiamin,hexamethylendiamin,soli', 'Acyclic polyamines and their derivatives; salts thereof (excl. ethylenediamine a'),
('29213010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cyklohexylamin,cyklohexyldimethylamin,soli', 'Cyclohexylamine and cyclohexyldimethylamine, and their salts'),
('29213091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cyklohexylen-1,3-diamin', 'Cyclohex-1,3-ylenediamine "1,3-diaminocyclohexane"'),
('29213099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mono-,polyaminy cykloalkanické,-enické,-terpenické),soli ostatní,ne:viz sazebník', 'Cyclanic, cyclenic or cycloterpenic mono- or polyamines, and their derivatives;'),
('29214100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Anilin,soli', 'Aniline and its salts (excl. inorganic or organic compounds of mercury)'),
('29214200', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Deriváty anilinu a jejich soli', 'Aniline derivatives and their salts'),
('29214300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Toluidiny a jejich deriváty,jejich soli', 'Toluidines and their derivatives; salts thereof'),
('29214400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Difenylamin,deriváty,soli', 'Diphenylamine and its derivatives; salts thereof'),
('29214500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '1-naftylamin,2-naftylamin,derivaty,soli', '1-Naphthylamine "alpha-naphthylamine", 2-naphthylamine "beta-naphthylamine" and'),
('29214600', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Amfetamin,benzfetamin,dexamfetam.,etilamfetam.,lefetamin aj.viz sazebník,soli', 'Amfetamine "INN", benzfetamine "INN", dexamfetamine "INN", etilamfetamine "INN",'),
('29214900', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Aromatické monoaminy,deriváty,jejich soli,ostatní,ne:viz sazebník', 'Aromatic monoamines and derivatives; salts thereof (excl. aniline, toluidines, d'),
('29215111', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'm-Fenylendiamin,čistota >=99%hmot.,obsah.<=1% vody,<=200mg/kg o-fenylendiaminu,<=450mg/kg p-fenylendiaminu', 'm-Phenylenediamine of a purity by weight of >= 99% and containing <= 1% by weigh'),
('29215119', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'o-,m-,p-Fenylendiamin,diaminotolueny,jejich halogen-,sulfo-,nitro-nitroso-deriváty ostatní,ne:m-fenylendiamin čistý', 'o-Phenylenediamine, m-phenylenediamine, p-phenylenediamine, diaminotoluenes, and'),
('29215190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'o-,m-,p-Fenylendiamin,diaminotolueny,deriváty ostatní,ne:viz sazebník', 'Derivatives of o-phenylenediamine, m-phenylenediamine, p-phenylenediamine or dia'),
('29215950', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'm-Fenylenbis(methylamin); 2,2-dichlor-4,4-methylendianilin; 4,4-o-bitoluidin; 1,8-naftylendiamin', 'm-Phenylenebis(methylamine); 2,2-dichloro-4,4-methylenedianiline; 4,4-bi-o-tolui'),
('29215990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sloučeniny s aminovou funkcí ost.,ne:acyklické a aromatické mono(poly)aminy,viz sazebník', 'Aromatic polyamines and their derivatives; salts thereof (excl. o-phenylenediami'),
('29221100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Monoethanolamin,soli', 'Monoethanolamine and its salts'),
('29221200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Diethanolamin,soli', 'Diethanolamine and its salts'),
('29221310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Triethanolamin', 'Triethanolamine'),
('29221390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Soli triethanolaminu', 'Salts of triethanolamine'),
('29221400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dextropropoxyfen (INN) a jeho soli', 'Dextropropoxyphene "INN" and its salts'),
('29221910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'N-ethyldiethanolamin', 'N-Ethyldiethanolamine'),
('29221920', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '2,2-methyliminodiethanol(N-methyldiethanolamin)', '2,2-Methyliminodiethanol "N-methyldiethanolamine"'),
('29221930', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '2-(N,N-Diisopropylamino)ethanol', '2-(N,N-Diisopropylamino)ethanol'),
('29221985', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Aminoalkoholy ostatní,jejich ethery,estery,soli,ne:viz sazebník', 'Amino-alcohols, their ethers and esters; salts thereof (other than those contain'),
('29222100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyseliny aminohydroxynaftalensulfonové,soli', 'Aminohydroxynaphthalenesulphonic acids and their salts'),
('29222900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Aminonaftoly aj aminofenoly ost,ethery,soli', 'Amino-naphthols and other amino-phenols, their ethers and esters; salts thereof'),
('29223100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Amfepramon (INN), methadon (INN), normethadon (INN), jejich soli', 'Amfepramone "INN", methadone "INN" and normethadone "INN", and salts thereof'),
('29223900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Aminoaldehydy, aminoketony, aminochinony ostatní, jejich soli', 'Amino-aldehydes, amino-ketones and amino-quinones; salts thereof (excl. those co'),
('29224100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lysin,estery,soli', 'Lysine and its esters; salts thereof'),
('29224200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina glutamová a její soli', 'Glutamic acid and its salts'),
('29224300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina anthranilová (2-aminobenzoová kyselina) a její soli', 'Anthranilic acid and its salts'),
('29224400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tilidin', 'Tilidine "INN" and its salts'),
('29224920', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'B-alanin', 'beta-Alanine'),
('29224985', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Aminokyseliny obsahující jeden druh kyslíkaté funkce,estery,jejich soli,ostatní,ne:viz sazebník', 'Amino-acids and their esters; salts thereof (excl. those containing > one kind o'),
('29225000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Aminoalkoholfenoly,-kyselinfenoly aj slouc.', 'Amino-alcohol-phenols, amino-acid-phenols and other amino-compounds with oxygen'),
('29231000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cholin a jeho soli', 'Choline and its salts'),
('29232000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lecithiny,jiné fosfoaminolipidy', 'Lecithins and other phosphoaminolipids, whether or not chemically defined'),
('29239000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Soli,hydroxidy kvarterni amonne ostatni', 'Quaternary ammonium salts and hydroxides (excl. choline and its salts)'),
('29241100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Meprobamat', 'Meprobamate "INN"'),
('29241200', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fluoracetamid (ISO),monokrotofos (ISO),fosfamidon (ISO)', 'Fluoroacetamide "ISO", monocrotophos "ISO" and phosphamidon "ISO"'),
('29241900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Amidy acyklické ostatní, jejich deriváty, soli', 'Acyclic amides, incl. acyclic carbamates, and their derivatives, and salts there'),
('29242100', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ureiny a jejich deriváty; jejich soli', 'Ureines and their derivatives; salts thereof'),
('29242300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '2-acetamidobenzoová kyselina (N-acetylantranilová kyselina),její soli', '2-Acetamidobenzoic acid "N-acetylanthranilic acid" and its salts'),
('29242400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Etinamát (INN)', 'Ethinamate "INN"'),
('29242910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lidokain (INN)', 'Lidocaine "INN"'),
('29242998', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cyklické amidy (vč.cyklických karbamátů),deriváty,jejich soli,ostatní,ne:viz sazebník', 'Cyclic amides, incl. cyclic carbamates, and their derivatives; salts thereof (ex'),
('29251100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sacharin,soli', 'Saccharin and its salts'),
('29251200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Glutethimid (INN)', 'Glutethimide "INN"'),
('29251920', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '3,3,4,4,5,5,6,6-Oktabrom-N,N-ethylendiftalimid; N,N-Ethylenbis(4,5-dibromhexahydro-3,6-methanoftalimid)', '3,3,4,4,5,5,6,6-Octabromo-N,N-ethylenediphthalimide; N,N-ethylenebis(4,5-dibromo'),
('29251995', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Imidy ostatní, jejich deriváty, soli', 'Imides and their derivatives; salts thereof (excl. saccharin, its salts, gluteth'),
('29252100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlordimeform (ISO)', 'Chlordimeform "ISO"'),
('29252900', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Iminy,deriváty,soli ost.,ne:chlordimeform (ISO)', 'Imines and their derivatives; salts thereof (excl. chlordimeform [ISO])'),
('29261000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Akrylonitril', 'Acrylonitrile'),
('29262000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '1-kyanoguanidin (dikyandiamid)', '1-Cyanoguanidine "dicyandiamide"'),
('29263000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fenproporex,soli,methadon meziprodukt (4-kyano-2-dimethylamino-4,4-difenylbutan)', 'Fenproporex "INN" and its salts; methadone "INN"-intermediate "4-cyano-2-dimethy'),
('29269020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Isoftalonitril', 'Isophthalonitrile'),
('29269095', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní sloučeniny s nitrilovou funkcí', 'Nitrile-function compounds (excl. acrylonitrile, 1-cyanoguanidine "dicyandiamide'),
('29270000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Diazo-,azo-,azoxyslouceniny', 'Diazo-, azo- or azoxy-compounds'),
('29280010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'N,N-Bis(2-methoxyetyl)hydroxylamin', 'N,N-Bis"2-methoxyethyl"hydroxylamine'),
('29280090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní deriváty hydrazinu nebo hydroxylaminu', 'Organic derivatives of hydrazine or of hydroxylamine (excl. N,N-bis"2-methoxyeth'),
('29291000', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Isokyanáty', 'Isocyanates'),
('29299000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sloučeniny s jinou dusíkatou funkcí ostatní,ne:isikyanáty', 'Compounds with nitrogen function (excl. amine-function compounds; oxygen-functio'),
('29302000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Thiokarbamáty,dithiokarbamáty', 'Thiocarbamates and dithiocarbamates (excl. inorganic or organic compounds of mer'),
('29303000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Thiurammono-,thiuramdi-,thiuramtetrasulfidy', 'Thiuram mono-, di- or tetrasulphides'),
('29304010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Methionin(INN)', 'Methionine "INN"'),
('29304090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Methionin ostatní,ne:methionin(INN)', 'Methionine (excl. methionine "INN")'),
('29305000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kaptafol (ISO),methamidofos (ISO)', 'Captafol "ISO" and methamidophos "ISO"'),
('29309013', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cystein a cystin', 'Cysteine and cystine'),
('29309016', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Deriváty cisteinu nebo cistinu', 'Derivatives of cysteine or of cystine'),
('29309020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Thiodiglycol (INN) (2,2-thiodiethanol)', 'Thiodiglycol "INN" "2,2''-thiodiethanol"'),
('29309030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina DL-2-hydroxy-4-(methyltio)butanová', 'DL-2-hydroxy-4-"methylthio"butyric acid'),
('29309040', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '2,2-Thiodiethyl-bis/3-(3,5,-di-terc-butyl-4-hydroxyfenyl)propionát/', '2,2''-Thiodiethyl bis[3-"3,5-di-tert-butyl-4-hydroxyphenyl"propionate]'),
('29309050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směs izomerů z určitých organických sloučenin síry', 'Mixture of isomers consisting of 4-methyl-2,6-bis"methylthio"-m-phenylenediamine'),
('29309060', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '2-(N,N-Diethylamino)ethanthiol', '2-(N,N-Diethylamino)ethanethiol'),
('29309099', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Organické sloučeniny síry ostatní,ne:viz sazebník', 'Organo-sulphur compounds (excl. thiocarbamates and dithiocarbamates, thiuram mon'),
('29310010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dimethylmethylfosfát', 'Dimethyl methylphosphonate'),
('29310020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Difluorodimethylfosfát', 'Methylphosphonoyl difluoride "methylphosphonic difluoride"'),
('29310030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dichlormethylfosfát', 'Methylphosphonoyl dichloride "methylphosphonic dichloride"'),
('29310040', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '(5-Ethyl-2-methyl-2-oxido-1,3,2-dioxafosfinan-5-yl)methyl-methyl-methylfosfonát; bis[(5-ethyl-2-methyl-2-oxido-1,3,2-dioxafosfinan-5-yl)methyl]-methyl', '(5-Ethyl-2-methyl-2-oxido-1,3,2-dioxaphosphinan-5-yl)methyl methyl methylphospho'),
('29310099', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Organicko-anorganické sloučeniny ostatní,ne:viz sazebník', 'Separate chemically defined organo-inorganic compounds (excl. organo-sulphur com'),
('29321100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tetrahydrofuran', 'Tetrahydrofuran'),
('29321200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '2-furaldehyd (furfural)', '2-Furaldehyde "furfuraldehyde"'),
('29321300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Furfurylalkohol,tetrahydrofurfurylalkohol', 'Furfuryl alcohol and tetrahydrofurfuryl alcohol'),
('29321900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slouceniny s furanovym nekondenz.kruhem ost.', 'Heterocyclic compounds with oxygen hetero-atom[s] only, containing an unfused fu'),
('29322100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kumarin,methylkumariny,ethylkumariny', 'Coumarin, methylcoumarins and ethylcoumarins'),
('29322910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fenolftalein', 'Phenolphthalein'),
('29322920', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina 1-hydroxy-4-/1-(4-hydroxy-3-methoxykarbonyl-1-naftyl)/-3oxo-1H,3H-bezo(de)iso-1-chromenyl)-6-oktadecylosy-2-naftoová', '1-Hydroxy-4-[1-"4-hydroxy-3-methoxycarbonyl-1-naphthyl"-3-oxo-1H, 3H-benzo[de]is'),
('29322930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina 3´-Chloro-6´-cyklohexylaminospiro/isobenzofuran-1(3h)-9´-xanthen/-3-on', '3-Chloro-6-cyclohexylaminospiro[isobenzofuran-1"3H", 9-xanthen]-3-one'),
('29322940', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina 6´-(N-Ethyl-p-toluidin)-2´-methylspirolisobenzofuran-1(3H),9´-xanthen/-3-on', '6-"N-Ethyl-p-toluidino"-2-methylspiro[isobenzofuran-1"3H", 9-xanthen]-3-one'),
('29322950', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina Methyl-6-dokosyloxy-1-hydroxy-4-/1-(4-hydroxy-3-methyl-1-fenanthryl)-3-oxo-1H,3H-nafto(1,8-cd)-1-pyranyl)naftalen-2-karboxylát', 'Methyl-6-docosyloxy-1-hydroxy-4-[1-"4-hydroxy-3-methyl-1-phenanthryl"-3-oxo-1H,'),
('29322960', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Gama-butyrolakton', 'gamma-Butyrolactone'),
('29322985', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní laktony jinam nezařazené,ne:viz sazebník', 'Lactones (excl. coumarin, methylcoumarins, ethylcoumarins, phenolphthalein, 1-hy'),
('29329100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Isosafrol', 'Isosafrole'),
('29329200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '1-(1,3,-benzodioxol-5-yl)-2-propanon (3,4-Methylendioxyfenyl-2-propanon)', '1-"1,3-Benzodioxol-5-yl"propan-2-one'),
('29329300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Piperonal', 'Piperonal'),
('29329400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Safrol', 'Safrole'),
('29329500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tetrahydrocannabinoly (všechny izomery)', 'Tetrahydrocannabinols "all isomers"'),
('29329900', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Heterocyklické sloučeniny pouze s kyslíkatým(i) heteroatomem (heteroatomy),ostatní,ne:viz sazebník', 'Heterocyclic compounds with oxygen hetero-atom[s] only (excl. compounds containi'),
('29331110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Propyfenazon (INN)', 'Propyphenazone'),
('29331190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fenazon,deriváty ostatní,ne:propyfenazon', 'Phenazone "antipyrin" and its derivatives (excl. propyphenazone "INN")'),
('29331910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fenylbutazon (INN)', 'Phenylbutazone "INN"'),
('29331990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sloučeniny s pyrazolovým nekondenzovaným kruhem ostat.,ne:(propy)fenazon,fenylbutazon', 'Heterocyclic compounds with nitrogen hetero-atom[s] only, containing an unfused'),
('29332100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hydantoin,deriváty', 'Hydantoin and its derivatives'),
('29332910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nafazolinhydrochlorid,nafazolinnitrát,fentolamin,telazolinhydrochlorid', 'Naphazoline hydrochloride "INNM" and naphazoline nitrate "INNM"; phentolamine "I'),
('29332990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sloučeniny s imidazolovým nekondenzovaným kruhem ostatní,ne:viz sazebník', 'Heterocyclic compounds with nitrogen hetero-atom[s] only, containing an unfused'),
('29333100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pyridin,soli', 'Pyridine and its salts'),
('29333200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Piperidin,soli', 'Piperidine and its salts'),
('29333300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Alfentanil,anileridin,bezitramid,bromazepam,difenoxin,difenoxyl.aj.viz sazebník,soli', 'Alfentanil "INN", anileridine "INN", bezitramide "INN", bromazepam "INN", difeno'),
('29333910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Iproniazid (INNM),ketobemidonhydrochlorid (INNM),pyridostigminbromid (INN)', 'Iproniazid "INN"; ketobemidone hydrochloride "INNM"; pyrodostigmine bromide "INN'),
('29333920', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '2,3,5,6-Tetrachlorpyridin', '2,3,5,6-Tetrachloropyridine'),
('29333925', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina 3,6-chloropyridin-2-karboxylová', '3,6-Dichloropyridine-2-carboxylic acid'),
('29333935', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '2-hydroxyethylamnomium-3,6-dichlorpyridin-2-karboxylát', '2-Hydroxyethylammonium-3,6-dichloropyridine-2-carboxylate'),
('29333940', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '2-Butoxyethyl(3,5,6-trichlor-2-pyridiloxy)acetát', '2-Butoxyethyl"3,5,6-trichloro-2-pyridyloxy"acetate'),
('29333945', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '3,5-Dichlor-2,4,6-trifluorpyridin', '3,5-Dichloro-2,4,6-trifluoropyridine'),
('29333950', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fluroxypyr(ISO),methylester', 'Fluroxypyr "ISO" methyl ester'),
('29333955', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '4-methylpyridin', '4-Methylpyridine'),
('29333999', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Heterocyklické slouč.obsah. nekondenzovaný pyridinový kruh ostatní,ne:viz sazebník', 'Heterocyclic compounds with nitrogen hetero-atom[s] only, containing an unfused'),
('29334100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Levorfanol (INN) a jeho soli', 'Levorphanol "INN" and its salts'),
('29334910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Halogenderiváty chinolinu, deriváty kyseliny chinolinkarboxylové', 'Halogen derivatives of quinoline; quinolinecarboxylic acid derivatives'),
('29334930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dextromethorfan (INN) a, jeho soli', 'Dextromethorphan "INN" and its salts'),
('29334990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Heterocyklické slouč.s (iso)chinolinovým nekondenzovaným kruhem ost.,ne:viz sazebník', 'Heterocyclic compounds with nitrogen hetero-atom[s] only, containing in the stru'),
('29335200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Malonylmočovina (kyselina barbiturová) a její soli', 'Malonylurea "barbituric acid" and its salts'),
('29335310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fenobarbital(INN),barbital(INN) a jejich soli', 'Phenobarbital "INN", barbital "INN", and salts thereof'),
('29335390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Allobarbital,amobarbital,butalbital,butobarbital,cyklobarbital aj. viz sazebník,soli', 'Allobarbital "INN", amobarbital "INN", butalbital "INN", butobarbital "INN", cyc'),
('29335400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Deriváty malonylmočoviny(kyselina barbiturová)ostatní, jejich soli,ne:viz sazebník', 'Derivatives of malonylurea "barbituric acid" and salts thereof (excl. salts of m'),
('29335500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Loprazolam (INN),mecloqualon (INN),metaqualon (INN),zipeprol (INN),jejich soli', 'Loprazolam "INN", mecloqualone "INN", methaqualone "INN" and zipeprol "INN", and'),
('29335910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Diazinon (ISO)', 'Diazinon "ISO"'),
('29335920', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '1,4-Diazabicyklo(2.2.2)loktan(triethylendiamin)', '1,4-Diazabicyclo[2.2.2]octane "triethylenediamine"'),
('29335995', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Heterocyklické slouč.obsah.pyrimidinový nebo piperazinový kruh ost.,ne:viz sazebník', 'Heterocyclic compounds with nitrogen hetero-atom"s" only, containing a pyrimidin'),
('29336100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Melamin', 'Melamine'),
('29336910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Atrazin,propazin,simazin,hexahydro-1,3,5-trinitro-1,3,5-triazin', 'Atrazine "ISO"; propazine "ISO"; simazine "ISO"; hexahydro-1,3,5-trinitro-1,3,5-'),
('29336940', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Methenamin (INN) (hexamethylentetramin); 2,6-di-terc-butyl-4-{[4,6-bis(oktylthio)-1,3,5-triazin-2-yl]amino}fenol', 'Methenamine (INN) (hexamethylenetetramine); 2,6-Di-tert-butyl-4-[4,6-bis(octylth'),
('29336980', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slouč.s trizinovým kruhem ost.,ne:melamin,atrazin,propazin,methenamin', 'Heterocyclic compounds with nitrogen hetero-atom[s] only, containing an unfused'),
('29337100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '6-hexanlaktam (E-kaprolaktam)', '6-Hexanelactam "epsilon-caprolactam"'),
('29337200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Clobazam (INN), methyprylon (INN), jejich soli', 'Clobazam "INN" and methyprylon "INN"'),
('29337900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Laktamy ostatni', 'Lactams (excl. 6-hexanelactam "epsilon-caprolactam", clobazam "INN", methyprylon'),
('29339110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlordiazepoxid (INN)', 'Chlorodiazepoxide "INN"'),
('29339190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Alprazolam,camazepam,clonazepam,clorazepát,delorazepam,diazep.aj.viz sazebník,soli', 'Alprazolam "INN", camazepam "INN", clonazepam "INN", clorazepate, delorazepam "I'),
('29339920', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Indol,3-methylindol(skatol,6-allyl-6 a další viz sazebník', 'Indole, 3-methylindole "skatole", 6-allyl-6,7-dihydro-5H-dibenz"c,e"azepine "aza'),
('29339950', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '2,4-Di-terc-butyl-6-(5-chlorbenzotriazol-2-yl)fenol', '2,4-Di-tert-butyl-6-"5-chlorobenzotriazol-2-yl"phenol'),
('29339980', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Heterocyklické sloučeniny pouze s dusíkatým(i) heteroatomem (heteroatomy),ostatní,ne:viz sazebník', 'Heterocyclic compounds with nitrogen hetero-atom[s] only (excl. those containing'),
('29341000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nukleové kyseliny,soli s thiazolovým nekondenzovaným kruhem', 'Heterocyclic compounds containing an unfused thiazole ring, whether or not hydro'),
('29342020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Di(benzothiazol-2-yl)disulfid,benzothiazol-2-thiol a jeho soli', 'Di"benzothiazol-2-yl"disulphide; benzothiazol-2-thiol "mercaptobenzothiazole" an'),
('29342080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sloučeniny obsahující benzothialozový kruhový systém ostatní,ne:viz sazebník', 'Heterocyclic compounds containing in the structure a benzothiazole ring-system,'),
('29343010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Thiethylperazin (INN),thioridazin (INN) a jeho soli', 'Thiethylperazine "INN"; thioridazine "INN" and its salts'),
('29343090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sloučeniny s fenothiazinovým nekondenzovaným kruhem ostatní,ne:viz sazebník', 'Heterocyclic compounds containing in the structure a phenothiazine ring-system,'),
('29349100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Aminorex,brotizolam,clotiazepam,cloxazolam,dextromoramid aj.viz sazebník,soli', 'Aminorex "INN", brotizolam "INN", clotiazepam "INN", cloxazolam "INN", dextromor'),
('29349960', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlorprothixen (INN); thenalidin (INN) a jejich tartaráty a maleáty; furazolidon (INN); kyselina 7-aminocefalosporanová; soli a estery (6R,7R)-3-(acet', 'Chlorprothixene (INN); thenalidine (INN) and its tartrates and maleates; furazol'),
('29349990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nukleové kyseliny a jejich soli ostatní,heterocykl.slouč.ostatní,ne:viz sazebník', 'Nucleic acids and their salts, whether or not chemically defined; heterocyclic c'),
('29350030', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '3-{1-[7-(Hexadecylsulfonylamino)-1H-indol-3-yl]-3-oxo-1H,3H-nafto[1,8-cd]-1-pyranyl}-N,N-dimethyl-1H-indol-7-sulfonamid; metosulam (ISO)', '3-{1-[7-(Hexadecylsulphonylamino)-1H-indole-3-yl]-3-oxo-1H,3H-naphtho[1,8-cd]pyr'),
('29350090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sulfonamidy ostatní,ne:položka 29350010,metosulam (ISO)', 'Sulphonamides (excl. 3-{1-[7-"hexadecylsulphonylamino"-1H-indole-3-yl]-3-oxo-1H,'),
('29362100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vitaminy A,deriváty,nesmíšené', 'Vitamins A and their derivatives, used primarily as vitamins'),
('29362200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vitamin B1,deriváty,nesmíšené', 'Vitamin B1 and its derivatives, used primarily as vitamins'),
('29362300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vitamin B2,deriváty,nesmíšené', 'Vitamin B2 and its derivatives, used primarily as vitamins'),
('29362400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'D-,DL-pantothenová kyselina (vitamin B3,B5),deriváty,nesmíšené', 'D-Pantothenic or DL-pantothenic acid "Vitamin B3 or B5" and their derivatives, u'),
('29362500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vitamin B6,deriváty,nesmíšené', 'Vitamin B6 and its derivatives, used primarily as vitamins'),
('29362600', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vitamin B12,deriváty,nesmíšené', 'Vitamin B12 and its derivatives, used primarily as vitamins'),
('29362700', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vitamin C,deriváty,nesmíšené', 'Vitamin C and its derivatives, used primarily as vitamins'),
('29362800', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vitamin E,deriváty,nesmíšené', 'Vitamin E and its derivatives, used primarily as vitamins'),
('29362900', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vitaminy a jejich deriváty,nesmíšené,ostatní,ne:viz sazebník', 'Vitamins and their derivatives, used primarily as vitamins, unmixed (excl. vitam'),
('29369000', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Provitaminy a vitaminy smíšené,jejich deriváty,ne:viz sazebník', 'Provitamins and mixtures of vitamins, of provitamins or of concentrates, whether'),
('29371100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Somatotropin, jeho deriváty a strukturní analoga', 'Somatropin, its derivatives and structural analogues, used primarily as hormones'),
('29371200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Insulin a jeho soli', 'Insulin and its salts, used primarily as hormones'),
('29371900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Polypeptidy hormonů ostatní,ne:viz sazebník', 'Polypeptide hormones, protein hormones and glycoprotein hormones, their derivati'),
('29372100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Kortison,hydrokortison,prednison,prednisolon', 'Cortisone, hydrocortisone, prednisone "dehydrocortisone" and prednisolone "dehyd'),
('29372200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Halogenderiváty hormonů kůry nadledvinek', 'Halogenated derivatives of corticosteroidal hormones'),
('29372300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Estrogeny, progestogeny', 'Oestrogens and progestogens'),
('29372900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'ormony kůry nadledvinek a jejich deriváty ostatní,ne:viz sazebník', 'Steroidal hormones, their derivatives and structural analogues, used primarily a'),
('29373100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Epinefrin', 'Epinephrine'),
('29373900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Hormony katecholamenové ostatní,ne:viz sazebník', 'Catecholamine hormones, their derivatives and structural analogues, used primari'),
('29374000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Deriváty aminokyselin', 'Amino-acid derivatives, used primarily as hormones'),
('29375000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Prostaglandiny, tromboxany a leukotrieny, deriváty,strukturní analoga', 'Prostaglandins, thromboxanes and leukotrienes, their derivatives and structural'),
('29379000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Hormony ostatní,ne:viz sazebník', 'Hormones, natural or reproduced by synthesis; derivatives and structural analogu'),
('29381000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rutin (rutoside),deriváty', 'Rutoside "rutin" and its derivatives'),
('29389010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Glykosidy náprstníkové', 'Digitalis glycosides'),
('29389030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina glycyrrhizinová,glycyrrhizáty', 'Glycyrrhizic acid and glycyrrhizates'),
('29389090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Glykosidy,ne:náprstníkové ap.,soli,ethery,estery aj.', 'Glycosides, natural or reproduced by synthesis, and their salts, ethers, esters'),
('29391100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Koncentráty makové slámy,buprenorfin,kodein,dihydrokodein aj.viz sazebník,soli', 'Concentrates of poppy straw; buprenorphine "INN", codeine, dihydrocodeine "INN",'),
('29391900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Opiové alkaloidy ostatní, jejich deriváty, soli, ne:viz sazebník', 'Alkaloids of opium and their derivatives, and salts thereof (excl. concentrates'),
('29392000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Alkaloidy kůry chininové,deriváty,soli', 'Alkaloids of cinchona and their derivatives; salts thereof'),
('29393000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kofein,soli', 'Caffeine and its salts'),
('29394100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Efedrin,soli', 'Ephedrine and its salts'),
('29394200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pseudoefedrin (INN),soli', 'Pseudoephedrine "INN" and its salts'),
('29394300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cathin (INN) a jeho soli', 'Cathine "INN" and its salts'),
('29394900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Efedriny,soli ostatní,ne:efedrin,pseudoefedrin a jejich soli', 'Ephedrines and their salts (excl. ephedrine, pseudoephedrine "INN", cathine "INN'),
('29395100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fenetyllin (INN) a jeho soli', 'Fenetylline "INN" and its salts'),
('29395900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Theofylin a aminofylin (theofylinethylendiamin) a jejich deriváty, jejich soli', 'Theophylline and aminophylline "theophylline-ethylenediamine" and their derivati'),
('29396100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ergometrin (INN),soli', 'Ergometrine "INN" and its salts'),
('29396200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ergotamin (INN),soli', 'Ergotamine "INN" and its salts'),
('29396300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina lysergová,soli', 'Lysergic acid and its salts'),
('29396900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost. rostlinné alkaloidy přírodní nebo syntetické; jejich soli', 'Alkaloids of rye ergot and their derivatives; salts thereof (excl. lysergic acid'),
('29399100', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kokain,ekgonin,levometamfetamin,metamfetamin (INN),racemát metamfetaminu,soli,estery,ost.deriváty', 'Cocaine, ecgonine, levometamfetamine, metamfetamine "INN", metamfetamine racemat'),
('29399900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rostlinné alkaloidy,přírodní,syntetetické,soli,ethery,estery,deriváty,ostatní', 'Vegetable alkaloids, natural or reproduced by synthesis, and their salts, ethers'),
('29400000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní cukry,chemicky čisté,ethery,acetaly a estery cukrů,jejich soli', 'Sugars, chemically pure (excl. sucrose, lactose, maltose, glucose and fructose);'),
('29411000', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Peniciliny a jejich deriváty se strukturou kyseliny penicilanové; jejich soli', 'Penicillins and their derivatives with a penicillanic acid structure; salts ther'),
('29412030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dihydrostreptomycin,jeho soli,estery a hydráty', 'Dihydrostreptomycin, its salts, esters and hydrates'),
('29412080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Streptomyciny,deriváty,soli ostatní,ne:dihydrostreptomycin,soli,estery,hydráty', 'Streptomycins and their derivatives; salts thereof (excl. dihydrostreptomycin an'),
('29413000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tetracykliny,deriváty,soli', 'Tetracyclines and their derivatives; salts thereof'),
('29414000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chloramfenikol,deriváty,soli', 'Chloramphenicol and its derivatives; salts thereof'),
('29415000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Erythromycin,deriváty,soli', 'Erythromycin and its derivatives; salts thereof'),
('29419000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Antibiotika ostatní,ne:viz sazebník', 'Antibiotics (excl. penicillins and their derivatives with a penicillanic acid st'),
('29420000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sloučeniny organické ostatní,ne:viz sazebník', 'Separate chemically defined organic compounds, n.e.s.'),
('30012010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výtažky ze žláz,jiných orgánů,jejich výměšků lidského původu', 'Extracts of glands or other organs or of their secretions, of human origin, for'),
('30012090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výtažky ze žláz,jiných orgánů,jejich výměšků ostatní,ne:lidského původu', 'Extracts of glands or other organs or of their secretions, of animals, for organ'),
('30019020', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Žlázy,látky k terapeutickým,profylaktickým účelům lidského původu', 'Dried glands and other organs for organo-therapeutic uses, whether or not powder'),
('30019091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Heparin,soli', 'Heparin and its salts'),
('30019098', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Žlázy,látky k terapeutickým,profylaktickým účelům ost.,ne:lidského původu', 'Dried glands and other organs for organo-therapeutic uses, whether or not powder'),
('30021010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Antisera', 'Antisera'),
('30021091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hemoglobin,globuliny krevni,sérove,ne pouze z lidské krve', 'Haemoglobin, blood globulins and serum globulins'),
('30021095', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Složky krevní,modifikované imunologické výrobky ostatní lidského původu', 'Blood fractions and modified immunological products, whether or not obtained by'),
('30021099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Složky krevní,modifikované imunologické výrobky ostatní,ne:viz sazebník', 'Blood fractions and modified immunological products, whether or not obtained by'),
('30022000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Očkovací látky pro lékařství humánní', 'Vaccines for human medicine'),
('30023000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Očkovací látky pro lékařství veterinární', 'Vaccines for veterinary medicine'),
('30029010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krev lidská', 'Human blood'),
('30029030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krev zvířecí k terapeutickým,profylaktickým,diagnostickým účelům', 'Animal blood prepared for therapeutic, prophylactic or diagnostic uses'),
('30029050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kultury mikroorganismů,ne:kvasnice', 'Cultures of micro-organisms (excl. yeasts)'),
('30029090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Toxiny a podobné výrobky', 'Toxins and similar products, e.g. plasmodia (excl. vaccines and cultures of micr'),
('30031000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Léky s peniciliny,strukturou penicilanové kys.,streptomyciny,deriváty neodměřené', 'Medicaments containing penicillins or derivatives thereof with a penicillanic ac'),
('30032000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Léky s jinými antibiotiky neodměřené', 'Medicaments containing antibiotics, not in measured doses or put up for retail s'),
('30033100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Léky s insulinem neodměřené', 'Medicaments containing insulin, not in measured doses or put up for retail sale'),
('30033900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Léky s hormony,steroidy ostatní neodměřené,ne:s antibiotiky,insulinem', 'Medicaments containing hormones or steroids used as hormones, not containing ant'),
('30034000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Léky s alkaloidy a jejich deriváty neodměř.,ne:s antibiotiky,insulinem,hormony', 'Medicaments containing alkaloids or derivatives thereof, not containing hormones'),
('30039000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Léky vícesložkové ostatní neodměřené,ne:viz sazebník', 'Medicaments consisting of two or more constituents mixed together for therapeuti'),
('30041000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Léky s peniciliny,deriváty kyseliny penicilanové; léky se streptomyciny,deriváty', 'Medicaments containing penicillins or derivatives thereof with a penicillanic ac'),
('30042000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Léky s antibiotiky ostatními,ne:viz sazebník', 'Medicaments containing antibiotics, put up in measured doses "incl. those in the'),
('30043100', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Léky s insulinem,ne:obsahující antibiotika', 'Medicaments containing insulin but not antibiotics, put up in measured doses "in'),
('30043200', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Léky s hormony kůry nadledvinek,ne:s antibiotiky', 'Medicaments containing corticosteroid hormones, their derivatives or structural'),
('30043900', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Léky s hormony ostatními,ne:s antibiotiky,druhy-viz sazebník', 'Medicaments containing hormones or steroids used as hormones but not antibiotics'),
('30044000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Léky s alkaloidy,deriváty,ne:s hormony,antibiotiky', 'Medicaments containing alkaloids or derivatives thereof, not containing hormones'),
('30045000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Léky s vitaminy,provitaminy apod.', 'Medicaments containing provitamins, vitamins, incl. natural concentrates and der'),
('30049000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Léky ze smíšených,nesmíšených výr.k terapeut.,profylakt.účelům,odměřené,k MO,ost.,ne:viz sazebník', 'Medicaments consisting of mixed or unmixed products for therapeutic or prophylac'),
('30051000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Náplasti a jiné zboží s přilnavou vrstvou', 'Adhesive dressings and other articles having an adhesive layer, impregnated or c'),
('30059010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vata,zboží z vaty', 'Wadding and articles of wadding, impregnated or coated with pharmaceutical subst'),
('30059031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Gáza (tyl),zboží z gázy (tylu)', 'Gauze and articles of gauze, impregnated or covered with pharmaceutical substanc'),
('30059050', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Obinadla,obvazy,náplasti a podobné výrobky z textil.materiálu', 'Bandages and similar articles of textile materials, impregnated or covered with'),
('30059099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ostatní impregnované i potažené farmaceut.látkami,ne:textil.materiály', 'Bandages and similar articles impregnated or covered with pharmaceutical substan'),
('30061010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Katgut sterilní chirurgický', 'Sterile surgical catgut'),
('30061030', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bariéry adhézní sterilní pro chirurgii,zubní lékařství,též absorbovatelné', 'Sterile surgical or dental adhesion barriers, whether or not absorbable'),
('30061090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sterilní šicí materiál ostatní,laminaria sterilní a další-viz sazebník', 'Sterile suture materials, incl. sterile absorbable surgical or dental yarns (exc'),
('30062000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Reagencie k určování krevních skupin,krevních faktorů', 'Reagents for determining blood groups or blood factors'),
('30063000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prostředky kontrastní k RTG vyšetření,diagnost.reagencie určené pro pacienta', 'Opacifying preparations for x-ray examinations; diagnostic reagents for administ'),
('30064000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cementy a jiné výplně zubní,cementy kostní rekonstrukční', 'Dental cements and other dental fillings; bone reconstruction cements'),
('30065000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brašny,krabice s první pomocí', 'First-aid boxes and kits'),
('30066010', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky antikoncepční chemické na bázi hormonů', 'Chemical contraceptive preparations based on hormones, prostaglandins, thromboxa'),
('30066090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky antikoncepční chemické na bázi spermicidů', 'Chemical contraceptive preparations based on spermicides'),
('30067000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky gelové určené pro použití v lékařství jako lubrikanty', 'Gel preparations designed to be used  in human or veterinary medicine as a lubri'),
('30069100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zařízení rozpoznatelná pro stomické použití', 'Appliances identifiable for ostomy use'),
('30069200', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Farmaceutický odpad', 'Waste pharmaceuticals'),
('31010000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hnojiva živočišná i rostlinná,smíchaná,nesmíchaná,upravená,neupravená', 'Animal or vegetable fertilisers, whether or not mixed together or chemically tre'),
('31021010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KNI'), 'Močovina,obsah dusíku nad 45% v suchém produktu', 'Urea, whether or not in aqueous solution, containing > 45% nitrogen in relation'),
('31021090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KNI'), 'Močovina ostatní,obsah dusíku maximálně 45% v suchém produktu', 'Urea, whether or not in aqueous solution, containing <= 45% by weight of nitroge'),
('31022100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KNI'), 'Síran amonný', 'Ammonium sulphate (excl. that in pellet or similar forms, or in packages with a'),
('31022900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KNI'), 'Podvojné soli síranu,směsi síranu amonného a dusičnanu amonného', 'Double salts and mixtures of ammonium sulphate and ammonium nitrate (excl. goods'),
('31023010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KNI'), 'Dusičnan amonný ve vodném roztoku', 'Ammonium nitrate in aqueous solution (excl. that in packages with a gross weight'),
('31023090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KNI'), 'Dusičnan amonný ostatní,ne:ve vodném roztoku', 'Ammonium nitrate (excl. that in aqueous solution, in pellet or similar forms, or'),
('31024010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KNI'), 'Směsi dusičnanu amonného s uhličitanem vápenatým,obsah dusíku do 28%', 'Mixtures of ammonium nitrate with calcium carbonate or other inorganic non-ferti'),
('31024090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KNI'), 'Směsi dusičnanu amonného s uhličitanem vápenatým,obsah dusíku nad 28%', 'Mixtures of ammonium nitrate with calcium carbonate or other inorganic non-ferti'),
('31025010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dusičnan sodný přírodní', 'Natural sodium nitrate (excl. that in pellet or similar forms, or in packages wi'),
('31025090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KNI'), 'Dusičnan sodný ostatní,ne:přírodní', 'Sodium nitrate (excl. natural sodium nitrate and sodium nitrate in pellet or sim'),
('31026000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KNI'), 'Soli podvojné,směsi dusičnanu vápenatého a amonného', 'Double salts and mixtures of calcium nitrate and ammonium nitrate (excl. those i'),
('31028000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KNI'), 'Směsi močoviny a dusičnanu amonného v roztoku vodném,amoniakálním', 'Mixtures of urea and ammonium nitrate in aqueous or ammoniacal solution (excl. t'),
('31029000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KNI'), 'Hnojiva dusíkatá minerální,chemická ostatní,ne:viz sazebník', 'Mineral or chemical nitrogen fertilisers (excl. urea; ammonium sulphate; ammoniu'),
('31031010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KPP'), 'Superfosfáty,obsah oxidu fosforečného nad 35%', 'Superphosphates containing > 35 by weight of diphosphorus pentoxide (excl. such'),
('31031090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KPP'), 'Superfosfáty ostatní,ne:obsah oxidu fosforečného nad 35%', 'Superphosphates (excl. such products containing > 35 by weight of diphosphorus p'),
('31039000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KPP'), 'Hnojiva fosforečná minerální,chemická ostatní,ne:superfosfáty', 'Mineral or chemical phosphatic fertilisers (excl. superphosphates, those in pell'),
('31042010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KPO'), 'Chlorid draselný,obsah potaše (jako K2O) do 40% v sušině', 'Potassium chloride containing <= 40% potassium monoxide in relation to the weigh'),
('31042050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KPO'), 'Chlorid draselný,obsah potaše (jako K2O) více než 40% do 62% v sušině', 'Potassium chloride containing > 40% but <= 62% potassium monoxide in relation to'),
('31042090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KPO'), 'Chlorid draselný,obsah potaše (jako K20) nad 62% v sušině', 'Potassium chloride containing > 62% potassium monoxide in relation to the weight'),
('31043000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KPO'), 'Síran draselný', 'Potassium sulphate (excl. that in tablets or similar forms, or in packages with'),
('31049000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KPO'), 'Hnojiva draselná minerální,chemická ostatní,ne:viz sazebník', 'Carnallite, sylvite and other crude natural potassium salts, potassium magnesium'),
('31051000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hnojiva minerální,chemická-tablety apod.,balení do 10 kg', 'Mineral or chemical fertilisers of animal or vegetable origin, in tablets or sim'),
('31052010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hnojiva minerální,chemická obsahující dusík,fosfor,draslík,dusík nad 10%', 'Mineral or chemical fertilisers containing the three fertilising elements nitrog'),
('31052090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hnojiva minerální,chemická ost.,obsah.dusík,fosfor,draslík,ne:dusík nad 10%', 'Mineral or chemical fertilisers containing the three fertilising elements nitrog'),
('31053000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hydrogenorthofosforečnan diamonný (diamonium phosphate)', 'Diammonium hydrogenorthophosphate "diammonium phosphate" (excl. that in tablets'),
('31054000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Název viz sazebník', 'Ammonium dihydrogenorthophosphate "monoammonium phosphate", whether or not mixed'),
('31055100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hnojiva minerální,chemická obsahující dusičnany a fosforečnany', 'Mineral or chemical fertilisers containing nitrates and phosphates (excl. ammoni'),
('31055900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hnojiva minerální,chemická obsahující dusík,fosfor,ne:dusičnany a fosforečnany', 'Mineral or chemical fertilisers containing the two fertilising elements nitrogen'),
('31056010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Superfosfáty draselné', 'Potassic superphosphates (excl. those in tablets or similar forms, or in package'),
('31056090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hnojiva minerální,chemická obsahující fosfor a draslík,ne:superfosfáty', 'Mineral or chemical fertilisers containing the two fertilising elements phosphor'),
('31059010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dusičnan sodnodraselný přírodní,dusík do 16,3%,dusičnan draselný do 44%', 'Natural potassium sodium nitrate consisting of natural mixtures of sodium nitrat'),
('31059091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hnojiva minerální,chemická ostatní,obsah dusíku nad 10%', 'Mineral or chemical fertilisers containing the two fertilising elements nitrogen'),
('31059099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hnojiva minerální,chemická ostatní,ne:viz sazebník', 'Mineral or chemical fertilisers containing the two fertilising elements nitrogen'),
('32011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výtažek tříselný kebračový', 'Quebracho extract'),
('32012000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výtažek tříselný mimózový', 'Wattle extract'),
('32019020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výtažek tříselný ze škumpy,z valonek,dubový,kaštanový', 'Sumach, valonea, oak or chestnut extract'),
('32019090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výtažky tříselné ostatní,taniny a jejich soli,deriváty apod.,ne:viz sazebník', 'Tanning extracts of vegetable origin; tannins and their salts, ethers, esters an'),
('32021000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Třísliva organická syntetická', 'Synthetic organic tanning substances'),
('32029000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Třísliva anorganická,přípravky tříselné,přípravky enzymatické pro předčinění', 'Inorganic tanning substances; tanning preparations, whether or not containing na'),
('32030010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Barviva rostlinného původu a přípravky na nich založené', 'Dyes of vegetable origin, incl. dye extracts, whether or not chemically defined;'),
('32030090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Barviva živočišného původu,přípravky na jejich základě', 'Dyes of animal origin, incl. dye extracts but excl. animal black, whether or not'),
('32041100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Barviva disperzní,přípravky na nich založené-viz pozn.3 ke kapitole', 'Synthetic organic disperse dyes; preparations based on synthetic organic dispers'),
('32041200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Barviva kyselá,mořidlová,přípravky na nich založené-viz pozn.3 ke kapitole', 'Synthetic organic acid dyes, whether or not metallised, and synthetic organic mo'),
('32041300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Barviva zásaditá,přípravky na nich založené-viz pozn.3 ke kapitole', 'Basic synthetic organic dyes; preparations based on basic synthetic organic dyes'),
('32041400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Barviva přímá,přípravky na nich založené-viz poz.3 ke kapitole', 'Direct synthetic organic dyes; preparations based on direct synthetic organic dy'),
('32041500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Barviva kypová (vč.pigmentů),přípravky na nich založené-viz pozn.3 ke kapitole', 'Synthetic organic vat dyes, incl. those usable in that state as pigments; prepar'),
('32041600', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Barviva reaktivní,přípravky na nich založené-viz pozn.3 ke kapitole', 'Synthetic organic reactive dyes; preparations based on synthetic organic reactiv'),
('32041700', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pigmenty,přípravky na nich založené-viz pozn.3 ke kapitole', 'Synthetic organic pigments; preparations based on synthetic organic pigments of'),
('32041900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Barviva syntetická organická ost.,směsi-viz pozn.3 ke kapitole,ne:viz sazebník', 'Synthetic organic colouring matter (excl. disperse dyes, acid dyes, mordant dyes'),
('32042000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prostředky fluorescenční zjasňovací,luminofory', 'Synthetic organic products of a kind used as fluorescent brightening agents, whe'),
('32049000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Barviva,přípravky organické syntetické ostatní,ne:viz sazebník', 'Synthetic organic products of a kind used as luminophores, whether or not chemic'),
('32050000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Laky barevné,přípravky na nich založené-viz pozn.3 ke kapitole', 'Colour lakes (other than Chinese or Japanese lacquer and paints); preparations b'),
('32061100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pigmenty,přípravky obsahující nejméně 80% oxidu titaničitého v sušině', 'Pigments and preparations based on titanium dioxide of a kind used for colouring'),
('32061900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pigmenty,přípravky obsahující méně než 80% oxidu titaničitého', 'Pigments and preparations based on titanium dioxide of a kind used for colouring'),
('32062000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pigmenty,přípravky na bázi sloučenin chromu', 'Pigments and preparations of a kind used for colouring any material or used as i'),
('32064100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ultramarin,přípravky na jeho bázi', 'Ultramarine and preparations based thereon of a kind used for colouring any mate'),
('32064200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Litopon,pigmenty na bázi sulfidu zinečnatého', 'Lithopone and other pigments and preparations based on zinc sulphide of a kind u'),
('32064910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Magnetit', 'Magnetite, fine-ground'),
('32064930', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pigmenty,přípravky na báhi sloučenin kadmia', 'Pigments and preparations based on cadmium compounds of a kind used for colourin'),
('32064980', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Barviva,pigmenty,přípravky ostatní,ne:viz sazebník', 'Inorganic or mineral colouring matter, n.e.s.; preparations based on inorganic o'),
('32065000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky anorganické používané jako luminofory', 'Inorganic products of a kind used as luminophores, whether or not chemically def'),
('32071000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Připravené pigmenty,kalidla,barvy a podobné přípravky', 'Prepared pigments, prepared opacifiers, prepared colours and similar preparation'),
('32072010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Engoby', 'Engobes "slips"'),
('32072090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Smalty,glazury a podobné přípravky sklotvorné,ne:engoby', 'Vitrifiable enamels and glazes and similar preparations (excl. englobes)'),
('32073000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Listry tekuté a podobné přípravky', 'Liquid lustres and similar preparations of the kind used in the ceramic, enamell'),
('32074040', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sklo ve formě vloček,d.>=0,1 <=3,5mm,tl.>=2 <=5?m,ve formě prášku,granulí obs.>= 99% ox.křemičitého', 'Glass in the form of flakes of a length of >= 0,1 mm but <= 3,5 mm and of a thic'),
('32074085', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skleněné frity aj.sklo,ve formě prášku,granulí,šupinek,vloček,ne:viz sazebník', 'Glass frit and other glass in the form of powder, granules or flakes (excl. glas'),
('32081010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Roztoky barev,laků apod.na bázi polyesterů-viz pozn.4 ke kapitole', 'Polyester-based solutions in volatile organic solvents, containing > 50% solvent'),
('32081090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Barvy,laky apod.na bázi polyesterů ostatní,ne:roztoky-viz pozn.4 ke kapitole', 'Paints and varnishes, incl. enamels and lacquers, based on polyesters, dispersed'),
('32082010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Roztoky barev,laků apod.na bázi akrylových,vinylových polymerů-pozn.4 ke kapitole', 'Solutions based on acrylic or vinyl polymers in volatile organic solvents, conta'),
('32082090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Barvy,laky apod.na bázi akrylových,vinylových polymerů ostatní,ne:viz sazebník', 'Paints and varnishes, incl. enamels and lacquers, based on acrylic or vinyl poly'),
('32089011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Roztoky barev na bázi polyuretanu,obsah 48% a více polymeru,viz pozn.4 ke kapitole', 'Polyurethane of 2,2''-"tert-butylimino"diethanol and 4,4''-methylenedicyclohexyl'),
('32089013', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kopolymer p-kresolu a divynilbenzenu v roztoku,obsah 48% a více polymeru', 'Copolymer of p-cresol and divinylbenzene, in the form of a solution in N,N-dimet'),
('32089019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Roztoky barev ostatní,viz pozn.4 ke kapitole,ne:viz sazebník', 'Solutions of products of headings 3901 to 3913 in volatile organic solvents, con'),
('32089091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Barvy,laky apod.na bázi polymerů syntetických,ne:roztoky-viz pozn.4 ke kapitole', 'Paints and varnishes, incl. enamels and lacquers, based on synthetic polymers, d'),
('32089099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Barvy,laky apod.na bázi chemicky upravených přírodních polymerů,ne:viz sazebník', 'Paints and varnishes, incl. enamels and lacquers, based on chemically modified n'),
('32091000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Barvy,laky a pod.na bázi polymerů akrylových,vinylových ve vodném prostředí', 'Paints and varnishes, incl. enamels and lacquers, based on acrylic or vinyl poly'),
('32099000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Barvy,laky apod.ost.na bázi polymerů ve vodném prostředí,ne:viz sazebník', 'Paints and varnishes, incl. enamels and lacquers, based on synthetic or chemical'),
('32100010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Barvy,laky nátěrové olejové včetně emailů,jemných laků', 'Oil paints and varnishes, incl. enamels and lacquers'),
('32100090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pigmenty vodní připravené používané pro konečnou úpravu kůže', 'Paints and varnishes, incl. enamels, lacquers and distempers (excl. those based'),
('32110000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sikativy připravené', 'Prepared driers'),
('32121000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fólie ražební', 'Stamping foils of a kind used in the printing of book bindings or hatband leathe'),
('32129000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pigmenty rozptýl.v nevod.prostř.,pro výr.nátěr.barev;barviva a ost.barvicí látky,pro drobný prodej', 'Pigments, incl. metallic powders and flakes, dispersed in non-aqueous media, in'),
('32131000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Barvy školní,plakátovací,umělecké,tónovací a podobné v soupravách', 'Sets of artist''s, student''s or signboard painter''s colours, modifying tints,'),
('32139000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Barvy školní,plakátovací,umělecké,tónovací a podobné,ne:soupravy', 'Artist''s, student''s or signboard painter''s colours, modifying tints, amusemen'),
('32141010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tmely sklářské,štěpařské,pryskyřičné,těsnicí a jiné', 'Glaziers'' putty, grafting putty, resin cements, caulking compounds and other ma'),
('32141090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tmely malířské', 'Painter''s fillings'),
('32149000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky nežáruvzdorné k povrchové úpravě fasád,stěn,podlah,stropů apod.', 'Non-refractory surfacing preparations for facades, inside walls, floors, ceiling'),
('32151100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Barva tiskařská černá', 'Black printing ink, whether or not concentrated or solid'),
('32151900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Barva tiskařská ostatní,ne:černá', 'Printing ink, whether or not concentrated or solid (excl. black ink)'),
('32159000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Inkousty,tuše všech druhů, též koncentrované,tuhé,ne:barva tiskařská', 'Ink, whether or not concentrated or solid (excl. printing ink)'),
('33011210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Silice pomerančová nedeterpenovaná', 'Terpenic oils of sweet and bitter orange, incl. concretes and absolutes (excl. o'),
('33011290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Silice pomerančová deterpenovaná', 'Terpeneless oils of sweet and bitter orange, incl. concretes and absolutes (excl'),
('33011310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Silice citronová nedeterpenovaná', 'Terpenic essential oils of lemon, incl. concretes and absolutes'),
('33011390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Silice citronová deterpenovaná', 'Terpeneless oils of lemon, incl. concretes and absolutes'),
('33011920', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Silice z citrusového ovoce ostatní,nedeterpenované,ne:viz sazebník', 'Terpenic essential oils of citrus fruit, incl. concretes and absolutes (excl. th'),
('33011980', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Silice z citrusového ovoce ostatní,deterpenované,ne:viz sazebník', 'Terpeneless essential oils of citrus fruit, incl. concretes and absolutes (excl.'),
('33012410', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Silice máty peprné (Mentha piperita) nedeterpenovaná', 'Terpenic oils of peppermint "Mentha piperita", incl. concretes and absolutes'),
('33012490', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Silice máty peprné (Mentha piperita) deterpenovaná', 'Terpeneless oils of peppermint "Mentha piperita", incl. concretes and absolutes'),
('33012510', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Silice z máty ostatní nedeterpenovaná,ne:z máty peprné', 'Terpenic oils of mints, incl. concretes and absolutes (excl. those of peppermint'),
('33012590', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Silice z máty ostatní deterpenovaná,ne:z máty peprné', 'Terpeneless oils of mints, incl. concretes and absolutes (excl. those of pepperm'),
('33012911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Silice hřebíčková,niaouliová,ylan-ylangová nedeterpenovaná', 'Terpenic oils of clove, niaouli and ylang-ylang, incl. concretes and absolutes'),
('33012931', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Silice hřebíčková,niaouliová,ylan-ylangová deterpenovaná', 'Terpeneless oils of clove, niaouli and ylang-ylang, incl. concretes and absolute'),
('33012941', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Silice ostatní,nedeterpenované,ne:viz sazebník', 'Essential oils, not deterpenated, incl. concretes and absolutes (except of citru'),
('33012971', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Silice geraniové,jasmínové,vetiverové,deterpenované', 'Terpeneless oils of geranium, jasmine and vetiver, incl. concretes and absolutes'),
('33012979', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Silice levandulové,lavandinové,deterpenované', 'Terpeneless oils of lavender or of lavandin, incl. concretes and absolutes'),
('33012991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Silice ostatní,deterpenované,ne:viz sazebník', 'Terpeneless essential oils, incl. concretes and absolutes (excl. of citrus fruit'),
('33013000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pryskyřice', 'Resinoids'),
('33019010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Produkty vedlejší terpenické vznikající při deterpenaci silic', 'Terpenic by-products of the deterpenation of essential oils'),
('33019021', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Extrahované olejové pryskyřice z lékořice a chmele', 'Extracted oleoresins of liquorice and hops'),
('33019030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pryskyřice vonné extrahované ostatní,ne:z lékořice a chmele', 'Extracted oleoresins of quassia wood, aloe, manna and other plants (excl. vanill'),
('33019090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Koncentráty,vodné roztoky silic,destiláty aromatické apod.-viz sazebník', 'Concentrates of essential oils in fats, fixed oils, waxes or the like, obtained'),
('33021010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi jedné i více vonných látek k výr.nápojů,obsah alkoholu nad 0,5vol', 'Preparations based on odoriferous substances, containing all flavouring agents c'),
('33021021', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi jedné i více vonných látek k výr.nápojů,alkohol do 0,5vol,-viz sazebník', 'Preparations based on odoriferous substances, containing all flavouring agents c'),
('33021029', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi jedné i více vonných látek k výr.nápojů,alkohol do 0,5vol,-viz sazebník', 'Preparations based on odoriferous substances, containing all flavouring agents c'),
('33021040', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi jedné i více vonných látek k výr.nápojů ostatní,ne:viz sazebník', 'Mixtures of odoriferous substances and mixtures, incl. alcoholic solutions, with'),
('33021090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi jedné i více vonných látek pro potravinářský průmysl,ne:výroba nápojů', 'Mixtures of odoriferous substances and mixtures, incl. alcoholic solutions, with'),
('33029010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lihové roztoky vonných látek ostatní,ne:užívané v potravinářském průmyslu', 'Mixtures of odoriferous substances and mixtures based on one or more of these su'),
('33029090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi vonných látek ostatní, užívané v potravinářkém průmyslu,ne:viz sazebník', 'Mixtures of odoriferous substances and mixtures based on one or more of these su'),
('33030010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Parfémy', 'Perfumes (excl. aftershave lotions and personal deodorants)'),
('33030090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vody toaletní', 'Toilet waters (excl. aftershave lotions, deodorants and hair lotions)'),
('33041000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Líčidla na rty', 'Lip make-up preparations'),
('33042000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky na líčení očí', 'Eye make-up preparations'),
('33043000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky pro manikůru,pedikůru kosmetické', 'Manicure or pedicure preparations'),
('33049100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pudry kompaktní,nekompaktní', 'Make-up or skin care powders, incl. baby powders, whether or not compressed (exc'),
('33049900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky kosmetické ostatní,ne:léky,viz sazebník', 'Beauty or make-up preparations and preparations for the care of the skin (other'),
('33051000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šampony', 'Shampoos'),
('33052000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky na trvalou ondulaci,narovnávání vlasů', 'Preparations for permanent waving or straightening'),
('33053000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Laky na vlasy', 'Hair lacquers'),
('33059000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky na vlasy ostatní,ne:šampon,přípr.na ondulaci či narovnávání vlasů,lak na vlasy', 'Preparations for use on the hair (excl. shampoos, preparations for permanent wav'),
('33061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky k čištění zubů,ne:zubní nit', 'Dentifrices, incl. those used by dental practitioners'),
('33062000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nit k čištění mezizubních prostor (zubní nit)', 'Yarn used to clean between the teeth "dental floss", in individual retail packag'),
('33069000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky pro ústní,zubní hygienu ostatní,ne:k čištění zubů,zubní nit', 'Preparations for oral or dental hygiene, incl. denture fixative pastes and powde'),
('33071000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky holicí užívané před holením,při holení,po holení', 'Shaving preparations, incl. pre-shave and aftershave products'),
('33072000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dezodoranty osobní,přípravky proti pocení', 'Personal deodorants and antiperspirants'),
('33073000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Soli koupelové parfémované,jiné přípravky koupelové', 'Perfumed bath salts and other bath and shower preparations'),
('33074100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Agarbatti a jiné přípravky vonné působící při hoření', '"Agarbatti" and other odoriferous preparations which operate by burning'),
('33074900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky pro parfémování,dezodoraci místností vč.náboženských ost.,ne:viz sazebník', 'Preparations for perfuming or deodorising rooms, incl. odoriferous preparations'),
('33079000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Depilátory,přípravky voňavkářské,kosmetické,toaletní ostatní,ne:viz sazebník', 'Depilatories and other perfumery, toilet or cosmetic preparations, n.e.s.'),
('34011100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mýdlo apod.,papír,textilie a jiné pokryté mýdlem pro toaletní užití vč.medicinálních', 'Soap and organic surface-active products and preparations, in the form of bars,'),
('34011900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mýdlo apod.,papír,textilie a jiné pokryté mýdlem ostatní,ne:toaletní použití', 'Soap and organic surface-active products and preparations, in the form of bars,'),
('34012010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mýdlo ve formě vloček,šupinek,granulí,prášku', 'Soap in the form of flakes, granules or powders'),
('34012090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mýdlo ostatní,ne:kusy,výlisky,odlévané tvary,vločky,šupinky,granule,prášek', 'Soap in paste form "soft soap" or in aqueous solution "liquid soap"'),
('34013000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.org.povrchově aktivní pro mytí pokožky,upr.pro dr.prodej,i s mýdlem', 'Organic surface-active products and preparations for washing the skin, in the fo'),
('34021110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Org.povrch.aktivní prostř.anionaktivní,roztok obsahující 30-50% hmotnosti', 'Aqueous solution containing by weight >= 30% but <= 50% of disodium alkyl[oxydi"'),
('34021190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Org.povrch.aktivní prostř.anionaktivní ostatní,ne:obsahující 30-50% hmotnosti', 'Anionic organic surface-active agents, whether or not put up for retail sale (ex'),
('34021200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prostředky povrchově aktivní organické kationaktivní', 'Cationic organic surface-active agents, whether or not put up for retail sale (e'),
('34021300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prostředky povrchově aktivní organické neionogenní', 'Non-ionic organic surface-active agents, whether or not put up for retail sale ('),
('34021900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prostředky povrchově aktivní organické ost.,ne:anion-,kationaktivní,neionogenní', 'Organic surface-active agents, whether or not put up for retail sale (excl. anio'),
('34022020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Povrchově aktivní přípravky upravené pro drobný prodej', 'Surface-active preparations put up for retail sale (excl. organic surface-active'),
('34022090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prostředky prací,čistící upravené pro drobný prodej', 'Washing preparations, incl. auxiliary washing preparations and cleaning preparat'),
('34029010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky povrchově aktivní ostatní,ne:organické,upravené pro drobný prodej', 'Surface-active preparations (excl. those put up for retail sale, organic surface'),
('34029090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prostředky prací,čisticí ostatní,ne:upravené pro drobný prodej', 'Washing preparations, incl. auxiliary washing preparations and cleaning preparat'),
('34031100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky pro úpravu textilních materiálů,kůže,kožišin apod.,ne:jako pohonná hmota', 'Textile lubricant preparations and preparations of a kind used for the oil or gr'),
('34031910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mazací prostředky,přípravky ostatní,obsah miner.olejů >= 70%,ne:viz sazebník', 'Lubricant preparations, incl. cutting-oil preparations, bolt or nut release prep'),
('34031990', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mazací prostředky,přípravky ostatní,obsah miner.olejů < 70%,ne:viz sazebník', 'Lubricating preparations, incl. cutting-oil preparations, bolt or nut release pr'),
('34039100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky mazací ost.pro úpravu materiálů textil.,kůže,kožešin apod.,ne:viz sazebník', 'Textile lubricant preparations and preparations of a kind used for the oil or gr'),
('34039900', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky mazací ostatní,ne:viz sazebník', 'Lubricant preparations, incl. cutting-oil preparations, bolt or nut release prep'),
('34042000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vosky syntetické,připravené z polyethylenglykolu', 'Poly"oxyethylene" [polyethylene glycol] waxes'),
('34049000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vosky syntetické,připravené ost.,ne:z polyethylenglykolu', 'Artificial waxes and prepared waxes (excl. poly"oxyethylene" [polyethylene glyco'),
('34051000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Leštidla,krémy a podobné přípravky na obuv,kůži', 'Polishes, creams and similar preparations, for footwear or leather, whether or n'),
('34052000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Leštidla,krémy a podobné přípravky pro údržbu nábytku,podlah a jiných dřev.výrobků', 'Polishes, creams and similar preparations, for the maintenance of wooden furnitu'),
('34053000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Leštidla a podobné výrobky na karoserie,jiné než na kov', 'Polishes and similar preparations for coachwork, whether or not in the form of p'),
('34054000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Čistící pasty,prášky a jiné přípravky', 'Scouring pastes and powders and other scouring preparations, whether or not in t'),
('34059010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Leštidla na kovy', 'Metal polishes, whether or not in the form of paper, wadding, felt, nonwovens, c'),
('34059090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky lešticí,čisticí i na podložce z papíru,textilu apod.ost.,ne:viz sazebník', 'Glass polishes, whether or not in the form of paper, wadding, felt, nonwovens, c'),
('34060000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Svíčky, svíce a podobné výrobky', 'Candles, tapers and the like'),
('34070000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pasty modelovací,dětské,zubolékařské a jiné přípravky-viz sazebník', 'Modelling pastes, incl. those put up for children''s amusement; preparations kno'),
('35011010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kasein pro výrobu regenerovaných textilních vláken', 'Casein for the manufacture of artificial textile fibres'),
('35011050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kasein pro jiné průmysl.užití,ne:výroba regener.textil.vláken,potravin,krmiv', 'Casein for industrial uses (excl. the manufacture of foodstuffs or fodder and ar'),
('35011090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kasein pro výrobu potravin,krmiv', 'Casein for the manufacture of foodstuffs and fodder and other types of casein (e'),
('35019010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Klihy kaseinové', 'Casein glues (excl. those put up for retail sale as glue and weighing <= 1 kg)'),
('35019090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kaseináty,deriváty kaseinu ostatní,ne:kasein,kaseinové klihy', 'Caseinates and other casein derivatives'),
('35021110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Albumin vaječný nevhodný k lidskému požívání sušený', 'Egg albumin, dried "e.g. in sheets, scales, flakes, powder", unfit, or to be ren'),
('35021190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Albumin vaječný ostatní sušený,ne:nevhodný k lidskému požívání', 'Egg albumin, dried "e.g. in sheets, scales, flakes, powder", fit for human consu'),
('35021910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Albumin vaječný nevhodný k lidskému požívání,ne:sušený', 'Egg albumin, unfit, or to be rendered unfit, for human consumption (excl. dried'),
('35021990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Albumin vaječný ostatní,ne:sušený,nevhodný k lidskému požívání', 'Egg albumin, fit for human consumption (excl. dried [e.g. in sheets, flakes, cry'),
('35022010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Albumin mléčný nevhodný k lidskému požívání', 'Milk albumin "lactalbumin", incl. concentrates of two or more whey proteins, con'),
('35022091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Albumin mléčný sušený ve vločkách,prášku a podobně pro lidskou spotřebu', 'Milk albumin "lactalbumin", incl. concentrates of two or more whey proteins, con'),
('35022099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Albumin mléčný ostatní pro lidskou spotřebu,ne:sušený', 'Milk albumin "lactalbumin", incl. concentrates of two or more whey proteins, con'),
('35029020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Albuminy ostatní nevhodné k lidskému požívání,ne:vaječný,mléčný', 'Albumins, unfit, or to be rendered unfit, for human consumption (excl. egg album'),
('35029070', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Albuminy ostatní pro lidskou spotřebu,ne:vaječný,mléčný', 'Albumins, fit for human consumption (excl. egg albumin and milk albumin [incl. c'),
('35029090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Albumináty a jiné deriváty albuminu', 'Albuminates and other albumin derivatives'),
('35030010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Želatina,deriváty želatiny', 'Gelatin, whether or not in square or rectangular sheets, whether or not surface-'),
('35030080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vyzina,ostatní klihy živočišné,ne:želatina,kaseinové klihy č.3501', 'Isinglass; other glues of animal origin (excl. casein glues of heading 3501)'),
('35040010', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Koncentrované mléčné proteiny,obsah proteinu >85% hmot.,počítáno v sušině', 'Concentrated milk proteins with a protein content >Â 85Â % by weight, calculated'),
('35040090', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Peptony,látky proteinové ostatní,deriváty,kožový prášek,též chromovaný,ne:viz sazebník', 'Peptones and their derivatives; other albuminous substances and their derivative'),
('35051010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dextriny', 'Dextrins'),
('35051050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Škroby esterifikované,etherifikované', 'Starches, etherified or esterified (excl. dextrins)'),
('35051090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Škroby modifikované ostatní,ne:esterifikované,etherifikované', 'Modified starches (excl. etherified starches, esterified starches and dextrins)'),
('35052010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Klihy obsahující méně než 25% škrobů,dextrinů a jiných modifikovaných škrobů', 'Glues containing < 25% starches, dextrins or other modified starches by weight ('),
('35052030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Klihy obsah.25% a více,ale méně než 55% škrobů,dextrinů a jiných modif.škrobů', 'Glues containing >= 25% but < 55% starches, dextrins or other modified starches'),
('35052050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Klihy obsah.55% a více,méně než 80% škrobů,dextrinů nebo jiných modif.škrobů', 'Glues containing >= 55% but < 80% starches, dextrins or other modified starches'),
('35052090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Klihy obsah.80% a více škrobů, dextrinů a jiných modifikovaných škrobů', 'Glues containing >= 80% starches, dextrins or other modified starches by weight'),
('35061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky užívané jako lepidla,klihy pro prodej v balení do 1kg', 'Products suitable for use as glues or adhesives put up for retail sale as glues'),
('35069100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lepidla na bázi kaučuku,plastů včetně syntetických pryskyřic', 'Adhesives based on polymers of heading 3901 to 3913 or on rubber (excl. products'),
('35069900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lepidla ostatní,ne:klihy a lepidla do 1kg,báze kaučuku,plastů,syntetických pryskyřic', 'Glues, prepared, and other prepared adhesives, n.e.s.'),
('35071000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Syřidlo,koncentráty syřidlové', 'Rennet and concentrates thereof'),
('35079030', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lipoproteinová lipáza; alkalická proteináza (produkt bakterií rodu Aspergillus)', 'Lipoprotein lipase and aspergillus alkaline protease'),
('35079090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní enzymy jinde neuvedené', 'Enzymes and prepared enzymes, n.e.s. (excl. rennet and concentrates thereof, lip'),
('36010000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výbušniny výmětné práškové', 'Propellent powders'),
('36020000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výbušniny připravené ostatní,ne:práškové výmětné', 'Prepared explosives (excl. propellent powders)'),
('36030010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zápalnice,bleskovice', 'Safety fuses and detonating fuses'),
('36030090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Roznětky,rozbušky,zažehovače,elektrické rozbušky', 'Percussion or detonating caps, igniters and electric detonators (excl. grenade d'),
('36041000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ohňostroje', 'Fireworks'),
('36049000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rakety signalizační,dešťové,signály mlhové a podobné pyrotechnické výrobky', 'Signalling flares, rain rockets, fog signals and other pyrotechnic articles (exc'),
('36050000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zápalky,ne:pyrotechnické výrobky č.3604', 'Matches (excl. pyrotechnic articles of heading 3604)'),
('36061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Paliva tekutá,ze zkapalněného plynu pro zapalovače,obsah do 300 cm3', 'Liquid or liquefied-gas fuels in containers of a kind used for filling or refill'),
('36069010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ferocer a jiné slitiny pyroforické ve všech formách', 'Ferro-cerium and other pyrophoric alloys in all forms'),
('36069090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Metaldehyd a jiná paliva připravená tuhá,polotuhá-viz pozn.2 ke kapitole', 'Metaldehyde, hexamethylenetetramine and similar products in tablets, sticks or s'),
('37011000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Desky,ploché filmy fotografické citlivé,neexponované pro RTG', 'Photographic plates and film in the flat, sensitised, unexposed, for X-ray (excl'),
('37012000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Filmy kopírovací okamžité neexponované', 'Instant print film in the flat, sensitised, unexposed, whether or not in packs'),
('37013000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Desky,ploché filmy citlivé,neexponované ost.,strana nad 255 mm,ne:viz sazebník', 'Photographic plates and film in the flat, sensitised, unexposed, with any side >'),
('37019100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,ploché filmy pro barevnou fotografii (polychromní) citlivé,neexponované', 'Photographic plates and film in the flat, sensitised, unexposed, of any material'),
('37019900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,ploché filmy fotografické citlivé,neexponované ostatní,ne:viz sazebník', 'Photographic plates and film in the flat for monochrome photography, sensitised,'),
('37021000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Filmy fotografické ve svitcích pro RTG citlivé,neexponované', 'Photographic film in rolls, unexposed, for X-ray (excl. of paper, paperboard or'),
('37023120', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Filmy pro barevnou fotografii neperfor.,neexpon.,šířka do 105mm,délka do 30m', 'Photographic film "incl. instant print film", in rolls, sensitised, unexposed, w'),
('37023191', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTR'), 'Filmy pro barevnou fotografii,neperforované,rozměry viz sazebník', 'Colour negative film of a width of >= 75 mm but <= 105 mm and of a length of >='),
('37023198', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTR'), 'Filmy pro barevnou fotografii ostatní,neperforované,rozměry viz sazebník', 'Photographic film "incl. instant print film", in rolls, sensitised, unexposed, w'),
('37023210', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mikrofilmy,filmy pro graf.umění s halogenidy stříbra neperfor.,šířka do 35mm', 'Microfilm and photographic film "incl. instant print film" for the graphic arts,'),
('37023220', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filmy ve svitcích ost.s halogenidy stříbra neprfor.,šířka do 35mm,ne:viz sazebník', 'Photographic film "incl. instant print film", sensitised, in rolls, unexposed, w'),
('37023285', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filmy ve svitcích ost.s halogenidy stříbra neprfor.,šířka nad 35mm,ne:viz sazebník', 'Photographic film "incl. instant print film", sensitised, in rolls, unexposed, w'),
('37023900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filmy ve svitcích ostatní neperfor.neexpon.,šířka do 105mm,ne:viz sazebník', 'Photographic film "incl. instant print film", sensitised, in rolls, unexposed, w'),
('37024100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Filmy pro barev.fotografii neperfor.neexpon,šířka nad 610mm,délka nad 200m', 'Photographic film "incl. instant print film", sensitised, in rolls, unexposed, w'),
('37024200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Filmy ostatní neperfor.neexpon.šířka nad 610mm,délka nad 200m,ne:pro barev.fotografii', 'Photographic film "incl. instant print film", sensitised, in rolls, unexposed, w'),
('37024300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Filmy ve svitku neperfor.neexpon.šířka nad 610mm,délka do 200m', 'Photographic film "incl. instant print film", sensitised, in rolls, unexposed, w'),
('37024400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Filmy ve svitku neperforované neexponované šířka nad 105mm-610mm', 'Photographic film "incl. instant print film"m, sensitised, in rolls, unexposed,'),
('37025100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Filmy ve svitku pro barev.fotografii neperfor.neexpon.šířka do 16mm,délka do 14m', 'Films, photographic, sensitised, in rolls, unexposed, with perforations, for col'),
('37025200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filmy ve svitku pro barev. fotografii neperfor.neexpon.,šířka do 16mm,délka nad 14m', 'Photographic film, sensitised, in rolls, unexposed, with perforations, for colou'),
('37025300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Filmy ve svitku pro barev.diapozit.neperfor.neexpon.šířka 16-35mm,délka do 30m', 'Photographic film, sensitised, in rolls, unexposed, with perforations, for colou'),
('37025400', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Filmy jiné pro barevnou fotografii,šíře nad 16-35mm,délka do 30m,ne:pro diapozitivy', 'Photographic film, sensitised, in rolls, unexposed, with perforations, for colou'),
('37025500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTR'), 'Filmy ve svitku pro barev.fotografie neperfor.neexpon.,šířka 16-35 mm,délka nad 30m', 'Photographic film, sensitised, in rolls, unexposed, with perforations, for colou'),
('37025600', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filmy ve svitku pro barev. fotografii neperfor.neexpon.,šířka nad 35mm', 'Photographic film, sensitised, in rolls, unexposed, with perforations, for colou'),
('37029120', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filmy pro grafické umění neperfor.neexpon.svitek,šířka do 16mm', 'Photographic film, sensitised, in rolls, unexposed, with perforations, for monoc'),
('37029180', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filmy neperfor.neexpon.ost.svitek,šířka do 16mm,ne:pro grafické umění', 'Photographic film, sensitised, in rolls, unexposed, with perforations, for monoc'),
('37029310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mikrofilmy,filmy pro grafické umění neperfor.neexpon.,šířka 16-35mm,délka do 30 m', 'Microfilm and film for the graphic arts, sensitised, in rolls, unexposed, with p'),
('37029390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Filmy ve svitku ost.neperfor.neexpon.,šířka 16-35mm,délka do 30m,ne:viz sazebník', 'Photographic film, sensitised, in rolls, unexposed, with perforations, for monoc'),
('37029410', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mikrofilmy,filmy pro graf.umění neperfor.neexpon.,šířka 16-35mm,délka nad 30m', 'Microfilm and film for the graphic arts, sensitised, in rolls, unexposed, with p'),
('37029490', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTR'), 'Filmy ve svitku ost.neperfor.neexpon.,šířka 16-35mm,délka nad 30m,ne:viz sazebník', 'Photographic film, sensitised, in rolls, unexposed, with perforations, for monoc'),
('37029500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filmy ve svitku ostatní neperfor.neexpon.,šířka nad 35mm,ne:viz sazebník', 'Photographic film, sensitised, in rolls, unexposed, with perforations, for monoc'),
('37031000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír,karton,textilie fotografické neexpon.ve svitku šířka nad 610 mm', 'Photographic paper, paperboard and textiles, sensitised, unexposed, in rolls > 6'),
('37032000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír,karton,textilie fotografické neexpon.ost.,pro barev.fotografii,ne:ve svitku šířka nad 610 mm', 'Photographic paper, paperboard and textiles, sensitised, unexposed, for colour p'),
('37039000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír,karton,textilie fotografické neexpon.ost.,pro čb fotografii,ne:ve svitku šířka nad 610 mm', 'Photographic paper, paperboard and textiles, sensitised, unexposed, for monochro'),
('37040010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,filmy fotografické exponované nevyvolané', 'Photographic plates and film, exposed but not developed (excl. products made of'),
('37040090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír,kartón,textilie fotografické exponované nevyvolané', 'Photographic paper, paperboard and textiles, exposed but not developed'),
('37051000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,filmy fotografické pro ofsetovou reprodukci exponované vyvolané', 'Photographic plates and film, exposed and developed, for offset reproduction (ex'),
('37059010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mikrofilmy exponované,vyvolané', 'Microfilm, exposed and developed (excl. microfilm for offset reproduction)'),
('37059090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fotografické desky,filmy exponované,vyvolané ost.,ne:viz sazebník', 'Photographic plates and film, exposed and developed (excl. products made of pape'),
('37061010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTR'), 'Kinematografické filmy exponované,vyvolané,šíře od 35mm,obsah.pouze zvuk.záznam', 'Cinematographic film, exposed and developed, consisting only of soundtrack, widt'),
('37061091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTR'), 'Filmy kinematografické o šířce nejméně 35 mm pozitivní,ne:pomocné pozitivní', 'Negatives and intermediate positives of cinematographic film, exposed and develo'),
('37061099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTR'), 'Filmy kinematografické o šířce nejméně 35 mm pozitivní,ne:pomocné pozitivní', 'Positives of cinematographic film, exposed and developed, whether or not incorpo'),
('37069010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTR'), 'Kinematografické filmy exponované,vyvolané,šíře pod 35mm,obsah.pouze zvuk.záznam', 'Cinematographic film, exposed and developed, consisting only of soundtrack, widt'),
('37069031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTR'), 'Filmy kinematografické méně než 35 mm negativní,pomocné pozitivní', 'Negatives and intermediate positives of cinematographic film, exposed and develo'),
('37069051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTR'), 'Filmy kinematografické positivní,šíře do 35mm,námět:Aktuality,týdeníky', 'Positives of newsreels, exposed and developed, whether or not incorporating soun'),
('37069091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTR'), 'Filmy kinematografické šířka méně než 10 mm pozitivní', 'Positives of cinematographic film, exposed and developed, whether or not incorpo'),
('37069099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTR'), 'Filmy kinematografické pozitivní ostatní,šířka 10mm a víc,ne:viz sazebník', 'Positives of cinematographic film, exposed and developed, whether or not incorpo'),
('37071000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Emulze citlivé k fotografickým účelům', 'Sensitising emulsions "for photographic uses"'),
('37079020', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vývojky,ustalovače pro fotografii', 'Developers and fixers in the form of chemical preparations for photographic use,'),
('37079090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,výrobky nesmíšené k fotografickým účelům ost.odměřené,drobný prodej', 'Preparation of chemicals for photographic uses, incl. unmixed products put up in'),
('38011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Grafit umělý', 'Artificial graphite (excl. retort graphite, retort carbon and goods of artificia'),
('38012010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Grafit koloidní v olejové suspenzi,semikoloidní', 'Colloidal graphite in suspension in oil; semi-colloidal graphite'),
('38012090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Grafit koloidní ostatní,ne:v olejové suspenzi,semikoloidní', 'Colloidal graphite (excl. in suspension in oil and semi-colloidal graphite)'),
('38013000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uhlíkaté pasty pro elektrody a podobné pasty pro vyzdívky pecí', 'Carbonaceous pastes for electrodes and similar pastes for furnace linings'),
('38019000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky na bázi grafitu a jiného uhlíku ost.,ne:pasty pro elektrody,vyzdívky', 'Preparations based on graphite or other carbon in the form of pastes, blocks, pl'),
('38021000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uhlí aktivní', 'Activated carbon (excl. medicaments or deodorant products for fridges, vehicles'),
('38029000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Produkty přírodní minerální aktivní,živočišné uhlí i použité', 'Activated kieselguhr and other activated natural mineral products; animal black,'),
('38030010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej tallový surový', 'Crude tall oil'),
('38030090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej tallový rafinovaný', 'Tall oil, whether or not refined (excl. crude tall oil)'),
('38040000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Louhy odpadní z výr.dřevné buničiny,vč.ligninsulfonátů,ne:tallový olej čísla 3803', 'Residual lyes from the manufacture of wood pulp, whether or not concentrated, de'),
('38051010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Silice terpentýnová', 'Gum turpentine'),
('38051030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Silice borová', 'Wood turpentine'),
('38051090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Silice sulfátová terpentýnová', 'Sulphate turpentine'),
('38059010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olej borový', 'Pine oil containing alpha-terpineol as the main constituent'),
('38059090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Silice ostatní,dipenten surový apod.,ne:viz sazebník', 'Crude dipentene; sulphite turpentine and other crude para-cymene; terpenic oils'),
('38061000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kalafuna,kyseliny pryskyřičné', 'Rosin and resin acids'),
('38062000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Soli kalafuny,kyselin pryskyřičných,soli jejich derivátů', 'Salts of rosin, of resin acids or of derivatives of rosin or resin acids (excl.'),
('38063000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Estery pryskyřice', 'Ester gums'),
('38069000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Silice,oleje pryskyřičné,tavená pryskyřice', 'Derivatives of rosin, incl. salts of rosin adducts, and of resin acids, light an'),
('38070010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dehet dřevný', 'Wood tar'),
('38070090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevný kreosot,líh,smola rostlinná,pivovarská a podobné přípravky z kalafuny', 'Brewer''s pitch and similar preparations based on rosin, resin acids or vegetabl'),
('38085000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pesticidy obsah.látky specif.v pozn.1 (aldrin...DDT...2,4,5-T)', 'Goods containing one or more of aldrin "ISO", binapacryl "ISO", camphechlor "ISO'),
('38089110', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Insekticidy na bázi pyretroidů,ne:viz 3808 50 00', 'Insecticides based on pyrethroids, put up in forms or packings for retail sale o'),
('38089120', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Insekticidy na bázi chlorovaných uhlovodíků,ne:viz 3808 50 00', 'Insecticides based on chlorinated hydrocarbons, put up in forms or packings for'),
('38089130', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Insekticidy na bázi karbamátů,ne:viz 3808 50 00', 'Insecticides based on carbamates, put up in forms or packings for retail sale or'),
('38089140', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Insekticidy na bázi organofosforečných sloučenin,ne:viz 3808 50 00', 'Insecticides based on organophosphorus compounds, put up in forms or packings fo'),
('38089190', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Insekticidy ostatní,ne:viz sazebník', 'Insecticides put up in forms or packings for retail sale or as preparations or a'),
('38089210', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fungicidy na bázi sloučenin mědi,ne:viz 3808 50 00', 'Fungicide preparations based on copper compounds, inorganic (excl. goods of subh'),
('38089220', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fungicidy anorg.ost.,ne:viz 3808 50 00,na bázi sloučenin mědi', 'Fungicides, put up in forms or packings for retail sale or as preparations or ar'),
('38089230', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fungicidy na bázi dithiokarbamátů,ne:viz 3808 50 00', 'Fungicides based on dithiocarbamates, put up in forms or packings for retail sal'),
('38089240', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fungicidy na bázi benzimidazolů,ne:viz 3808 50 00', 'Fungicides based on benzimidazoles, put up in forms or packings for retail sale'),
('38089250', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fungicidy na bázi diazolů nebo triazolů,ne:viz 3808 50 00', 'Fungicides based on diazoles or triazoles, put up in forms or packings for retai'),
('38089260', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fungicidy na bázi diazinů nebo morfolinů,ne:viz 3808 50 00', 'Fungicides based on diazines or morpholines, put up in forms or packings for ret'),
('38089290', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fungicidy ostatní,ne:viz sazebník', 'Fungicides put up in forms or packings for retail sale or as preparations or art'),
('38089311', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Herbicidy na bázi karbamátů,ne:viz 3808 50 00', 'Herbicides based on phenoxy-phytohormones, put up in forms or packings for retai'),
('38089313', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Herbicidy na bázi triazinů,ne:viz 3808 50 00', 'Herbicides based on triazines, put up in forms or packings for retail sale or as'),
('38089315', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Herbicidy na bázi amidů,ne:viz 3808 50 00', 'Herbicides based on amides, put up in forms or packings for retail sale or as pr'),
('38089317', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Herbicidy na bázi karbamátů,ne:viz 3808 50 00', 'Herbicides based on carbamates, put up in forms or packings for retail sale or a'),
('38089321', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Herbicidy na bázi derivátů dinitroanilinu,ne:viz 3808 50 00', 'Herbicides based on dinitroaniline derivatives, put up in forms or packings for'),
('38089323', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Herbicidy na bázi derivátů močoviny,uracilu,sulfonylmočoviny,ne:viz 3808 50 00', 'Herbicides based on derivatives of urea, uracil or of sulphonylurea, put up in f'),
('38089327', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Herbicidy ostatní,ne:viz sazebník', 'Herbicides put up in forms or packings for retail sale or as preparations or art'),
('38089330', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky proti klíčení,ne:viz 3808 50 00', 'Anti-sprouting products put up for retail sale or as preparations or articles (e'),
('38089390', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Regulátory růstu rostlin,ne:viz 3808 50 00', 'Plant-growth regulators put up for retail sale or as preparations or articles (e'),
('38089410', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dezinfekční prostředky na bázi kvartérních amonných solí,ne:viz 3808 50 00', 'Disinfectants, based on quaternary ammonium salts, put up for retail sale or as'),
('38089420', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dezinfekční prostředky na bázi halových sloučenin,ne:viz 3808 50 00', 'Disinfectants, based on halogenated compounds, put up for retail sale or as prep'),
('38089490', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dezinfekční prostředky ostatní,ne:viz sazebník', 'Disinfectants, put up for retail sale or as preparations or articles (excl. such'),
('38089910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rodenticidy,ne:viz 3808 50 00', 'Rodenticides, put up for retail sale or as preparations or articles (excl. goods'),
('38089990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sirné pásy,knoty,svíčky,mucholapky apod.', 'Plant protection products, put up in forms or packings for retail sale or as pre'),
('38091010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky k úpravě povrchu,apretaci apod.,obsahu škrobu méně než 55%', 'Finishing agents, dye carriers to accelerate the dyeing or fixing of dyestuffs a'),
('38091030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky k úpravě povrchu,apretaci apod.,obsah škrobu 55% a více,méně než 70%', 'Finishing agents, dye carriers to accelerate the dyeing or fixing of dyestuffs a'),
('38091050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky k úpravě povrchu,apretaci apod.,obsah škrobu 70% a více,méně než 83%', 'Finishing agents, dye carriers to accelerate the dyeing or fixing of dyestuffs a'),
('38091090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky k úpravě povrchu,apretaci apod.,obsah škrobu 83% a více', 'Finishing agents, dye carriers to accelerate the dyeing or fixing of dyestuffs a'),
('38099100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky k úpravě povrchu,apretaci apod.,pro textilní průmysl,ne:se škrobem', 'Finishing agents, dye carriers to accelerate the dyeing or fixing of dyestuffs,'),
('38099200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky k úpravě povrchu,apretaci apod.,pro papírenský průmysl,ne:se škrobem', 'Finishing agents, dye carriers to accelerate the dyeing or fixing of dyestuffs,'),
('38099300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky k úpravě povrchu,apretaci apod.,pro kožedělný průmysl,ne:se škrobem', 'Finishing agents, dye carriers to accelerate the dyeing or fixing of dyestuffs,'),
('38101000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky k čištění kovových povrchů,prášky,pasty apod.k pájení,svařování', 'Pickling preparations for metal surfaces; soldering, brazing or welding pastes a'),
('38109010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky k výplni svářecích elektrod,trubek,k oplášťování svářecích tyčí', 'Preparations of a kind used as coatings or cores for welding electrodes or rods'),
('38109090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tavidla a jiné pomocné přípravky pro pájení a svařování ostatní,ne:viz sazebník', 'Fluxes and other auxiliary preparations for soldering, brazing or welding (excl.'),
('38111110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky antidetonační na bázi tetraethylolova', 'Anti-knock preparations for motor fuels based on tetraethyl-lead'),
('38111190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky antidetonační na bázi sloučenin olova ostatní,ne:tetraethylolova', 'Anti-knock preparations for motor fuels based on lead compounds (excl. tetraethy'),
('38111900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky antidetonační ostatní,ne:na bázi sloučenin olova', 'Anti-knock preparations for motor fuels (excl. those based on lead compounds)'),
('38112100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přísady do olejů mazacích obsahující oleje minerální,ze živičných minerálů', 'Prepared additives for oil lubricants containing petroleum oil or bituminous min'),
('38112900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přísady do olejů mazacích ostatní,ne:s oleji minerálními,ze živičných minerálů', 'Prepared additives for oil lubricants not containing petroleum oil or bituminous'),
('38119000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Inhibitory,zlepšovače viskozity,antikorozní prostředky apod.', 'Oxidation inhibitors, gum inhibitors, viscosity improvers, anti-corrosive prepar'),
('38121000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Urychlovače vulkanizace syntetické', 'Prepared rubber accelerators'),
('38122010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsné plastifikátory pro kaučuk a plasty,složení viz sazebník', 'Reaction mixture containing benzyl 3-isobutyryloxy-1-isopropyl-2,2-dimethylpropy'),
('38122090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsné plastifikátory pro kaučuk a plasty,složení viz sazebník', 'Composite plasticisers for rubber or plastics, n.e.s. (excl. reaction mixture co'),
('38123021', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky antioxidač.pro kaučuk,plasty,ve formě směsí oligomerů 2,2,4-trimethyl-1,2-dihydrochinolinu', 'Mixtures of oligomers of 1,2-dihydro-2,2,4-trimethyl-quinoline'),
('38123029', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky antioxidač.pro kaučuk,plasty,ost.,ne:směsi oligomerů 2,2,4-trimethyl-1,2-dihydrochinolinu', 'Anti-oxidising preparations for rubber or plastics (excl. mixtures of oligomers'),
('38123080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsné stabilizátory pro kaučuk,plasty', 'Compound stabilisers for rubber or plastics (excl. anti-oxidising preparations)'),
('38130000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky,náplně pro hasicí přístroje,naplněné hasicí granáty,bomby', 'Preparations and charges for fire-extinguishers; charged fire-extinguishing gren'),
('38140010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rozpouštědla,ředidla složená organická jinde neuvedená na bázi butylacetátu', 'Organic composite solvents and thinners and prepared paint or varnish removers,'),
('38140090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rozpouštědla,ředidla složená org.jinde neuved.ost.,ne:na bázi butylacetátu', 'Organic composite solvents and thinners and prepared paint or varnish removers ('),
('38151100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Katalyzátory na nosiči-nikl,sloučenina niklu jako aktivní látka', 'Supported catalysts with nickel or a nickel compound as the active substance, n.'),
('38151200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Katalyzátory na nosiči-drahý kov,sloučenina drahého kovu jako aktivní látka', 'Supported catalysts with precious metal or a precious-metal compound as the acti'),
('38151910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Katalyzátory na nosiči ve formě zrn,parametry viz sazebník', 'Catalysts in the form of grains of which >= 90% by weight have a particle-size <'),
('38151990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Katalyzátory na nosiči ostatní,parametry viz sazebník', 'Supported catalysts, n.e.s. (excl. supported catalysts with precious metal, a pr'),
('38159010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Katalyzátory z ethyltrifenylfosfoniumacetátu v methanol.roztoku,ne:na nosiči', 'Catalysts consisting of ethyltriphenylphosphonium acetate in the form of a solut'),
('38159090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Katalyzátory ostatní,ne:na nosiči,z ethyltrifenylfosfoniumacetátu v roztoku', 'Reaction initiators, reaction accelerators and catalytic preparations, n.e.s. (e'),
('38160000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ohnivzdorné cementy,malty,betony a podobné směsi,ne:uhlík,grafit', 'Refractory cements, mortars, concretes and similar compositions (excl. preparati'),
('38170050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Alkylbenzen lineární', 'Linear alkylbenzene'),
('38170080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní směsi alkylbenzenů a alkylnaftalenů', 'Mixed alkylbenzenes and mixed alkylnaphthalenes, produced by the alkylation of b'),
('38180010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Křemík (silikon) upravený (dopovaný) příměsí', 'Silicon doped for use in electronics, in the form of discs, wafers, cylinders, r'),
('38180090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prvky chemické zušlechtěné,dopované pro použití v elektronice,ne:křemík', 'Chemical elements and compounds doped for use in electronics, in the form of dis'),
('38190000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kapaliny pro hydraulické brzdy,převody,obsah miner.oleje méně než 70%', 'Hydraulic brake fluids and other prepared liquids for hydraulic transmission not'),
('38200000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky proti zamrzání,tekutiny upravené k odmrazování', 'Anti-freezing preparations and prepared de-icing fluids (excl. prepared additive'),
('38210000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Půdy živné pro vývoj/vyživování mikroorganismů,buněk', 'Prepared culture media for the development or maintenance of micro-organisms "in'),
('38220000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi diagnostické, laboratorní reagencie', 'Diagnostic or laboratory reagents on a backing, prepared diagnostic or laborator'),
('38231100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina stearová technická', 'Stearic acid, industrial'),
('38231200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina olejová technická', 'Oleic acid, industrial'),
('38231300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyseliny mastné z tallového oleje technické', 'Tall oil fatty acids, industrial'),
('38231910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Destilované monokarboxylové mastné kyseliny', 'Fatty acids, distilled'),
('38231930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Destiláty monokarboxylových mastných kyselin', 'Fatty acid distillate'),
('38231990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatni technické monokarboxylové mastné kyseliny,ne:viz sazebník', 'Fatty acids, industrial, monocarboxylic; acid oils from refining (excl. stearic'),
('38237000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Technické mastné alkoholy', 'Fatty alcohols, industrial'),
('38241000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pojidla připravená pro licí formy,jádra', 'Prepared binders for foundry moulds or cores'),
('38243000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Karbidy kovů neaglomerované smíšené navzájem nebo s kovovým pojidlem', 'Non-agglomerated metal carbides mixed together or with metallic binders'),
('38244000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přísady do cementů,malt,betonů připravené', 'Prepared additives for cements, mortars or concretes'),
('38245010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Beton připravený pro lití,ne:ohnivzdorný', 'Concrete ready to pour'),
('38245090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Malty,betony ostatní,ne:ohnivzdorné,beton připravený pro lití', 'Non-refractory mortars and concretes (excl. concrete ready to pour)'),
('38246011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sorbitol ve vodném roztoku,obsah D-mannitolu do 2 %,ne:položka 2905 44', 'Sorbitol in aqueous solution, containing <= 2% by weight of D-mannitol, calculat'),
('38246019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sorbitol ve vodném roztoku,obsah D-mannitolu nad 2 %,ne:položka 2905 44', 'Sorbitol in aqueous solution, containing > 2% by weight of D-mannitol, calculate'),
('38246091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sorbitol ostatní,obsah D-mannitolu do 2%,ne:ve vodném roztoku,položka 2905 44', 'Sorbitol containing <= 2% by weight of D-mannitol, calculated on the D-glucitol'),
('38246099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sorbitol ostatní,obsah D-mannitolu nad 2%,ne:ve vodném roztoku,položka 2905 44', 'Sorbitol containing > 2% by weight of D-mannitol, calculated on the D-glucitol c'),
('38247100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi obs.chlorfluoruhlovodíky (CFC)', 'Mixtures containing chlorofluorocarbons "CFCs", whether or not containing hydroc'),
('38247200', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi obs.bromchlor2-,brom3fluormethan,2brom4fluorethan', 'Mixtures containing bromochlorodifluoromethane, bromotrifluoromethane or dibromo'),
('38247300', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi obs.hydrobromfluoruhlovodíky (HBFC)', 'Mixtures containing hydrobromofluorocarbons "HBFCs"'),
('38247400', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi obs.hydrochlorfluoruhlovodíky (HCFC),neobs.CFC', 'Mixtures containing hydrochlorofluorocarbons "HCFCs", whether or not containing'),
('38247500', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi obs.chlorid uhličitý', 'Mixtures containing carbon tetrachloride'),
('38247600', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi obs.1,1,1-trichlorethan', 'Mixtures containing 1,1,1-trichloroethane "methyl chloroform"'),
('38247700', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi obs.brommethan (methylbromid) nebo bromchlormethan', 'Mixtures containing bromomethane "methyl bromide" or bromochloromethane'),
('38247800', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi obs.perfluoruhlovodíky/hydrofluoruhlovodíky,neobs.CFC/HCFC', 'Mixtures containing perfluorocarbons "PFCs" or hydrofluorocarbons "HFCs", but no'),
('38247900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi obs.halogenované deriváty methanu,ethanu,propanu,ost.,ne:viz sazebník', 'Mixtures containing halogenated derivatives of methane, ethane or propane (excl.'),
('38248100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi a přípr.obs.oxiran (ethylenoxid)', 'Mixtures and preparations containing oxirane "ethylene oxide"'),
('38248200', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi a přípr.obs.PCB,PCT,PBB', 'Mixtures and preparations containing polychlorinated biphenyls "PCBs", polychlor'),
('38248300', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi a přípr.obs.tris(2,3-dibrompropyl)fosfát', 'Mixtures and preparations containing tris"2,3-dibromopropyl" phosphate'),
('38249010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sulfonáty ropné,kyseliny thiofenické sulfonované,soli,ne:viz sazebník', 'Thiophenated sulphonic acids of bituminous mineral oil, and salts thereof; petro'),
('38249015', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Iontoměniče', 'Ion-exchangers (excl. polymers of chapter 39)'),
('38249020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Getry (pohlcovače plynů) pro vakuové trubice', 'Getters for electric vacuum tubes'),
('38249025', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pyrolignity,surový tartaran (vinan) vápenatý,surový citran vápenatý', 'Pyrolignites, e.g. of calcium; crude calcium tartrate; crude calcium citrate'),
('38249030', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyseliny naftenové,soli nerozpustné ve vodě,estery', 'Naphthenic acids and the water-insoluble salts and esters thereof'),
('38249035', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky antikorozní-aktivní složka aminy', 'Anti-rust preparations containing amines as active constituents'),
('38249040', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rozpouštědla,ředidla anorganická směsná pro laky a podobné produkty', 'Inorganic composite solvents and thinners for varnishes and similar products'),
('38249045', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi zabraňující tvorbě kotelního kamene a podobných usazenin', 'Anti-scaling and similar compounds'),
('38249050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky pro elektrolytické pokovování', 'Preparations for electroplating for the chemical and allied industries'),
('38249055', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi mono-,di-,triesterů mastných kyselin glycerolu (emulgátory pro tuky)', 'Mixtures of mono-, di- and tri-, fatty acid esters of glycerol "emulsifiers for'),
('38249061', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Meziprodukty z výroby antibiotika,též sušené,na výrobu humánních léků č. 3004', 'Intermediate products of the antibiotics manufacturing process obtained from the'),
('38249062', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Meziprodukty z výroby monensinových solí', 'Intermediate products from the manufacture of monensin salts for pharmaceutical'),
('38249064', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Produkty pro farmaceut.účely,ne:meziprodukt při výr.antibiotik a monensinových solí', 'Products and preparations for the chemical and allied industries for pharmaceuti'),
('38249065', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Produkty pomocné pro slévárny', 'Auxiliary products in the form of chemical preparations of a kind used in foundr'),
('38249070', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přípravky ohni-,vodovzdorné a podobné ochranné pro stavebnictví', 'Fire-proofing, water-proofing and similar chemical protective preparations used'),
('38249075', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lithiumniobové destičky,nedopované', 'Lithium niobate wafer, undoped'),
('38249080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi aminů z dimerizovaných mastných kyselin,mol.hmotnost 520 až 550', 'Mixture of amines derived from dimerised fatty acids, of an average molecular we'),
('38249085', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '3-(1-ethyl-1-methylpropyl)-5-isoxazolylamin) ve formě toluenového roztoku', '3-"1-Ethyl-1-methylpropyl"isoxazol-5-ylamine, in the form of a solution in tolue'),
('38249087', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi převážně z (5-ethyl-2-methyl-2-oxido-1,3,2-dioxafosfinan-5-yl)methylmethyl-methylfosfonátu a bis[(5-ethyl-2-methyl-2-oxido-1,3,2-dioxafosfinan-5', 'Mixtures consisting mainly of (5-ethyl-2-methyl-2-oxido-1,3,2-dioxaphosphinan-5-'),
('38249091', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Monoalkylestery mastných kyselin obsahující 96,5 % obj. nebo více esterů (FAMAE)', 'Fatty acid mono-alkyl esters, containing by volume  96,5 % or more of esters (FA'),
('38249097', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky a přípravky chemické ostatní, ne:viz sazebník', 'Chemical products and preparations of the chemical or allied industries, incl. t'),
('38251000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad komunální', 'Municipal waste'),
('38252000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kal kanalizační', 'Sewage sludge'),
('38253000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad klinický', 'Clinical waste'),
('38254100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rozpouštědla organická odpadní halogenovaná', 'Waste organic solvents, halogenated'),
('38254900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rozpouštědla organická odpadní ostatní,ne:halogenovaná', 'Waste organic solvents, non-halogenated'),
('38255000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kapaliny odpadní z moření kovu,hydraulické,brzdové,odmrazovací', 'Wastes of metal pickling liquors, of hydraulic fluids, brake fluids and anti-fre'),
('38256100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpady chem.prům.apod.odvětví obsahující hlavně organické složky', 'Wastes from chemical or allied industries, mainly containing organic constituent'),
('38256900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpady chem.prům.apod.odvětví ost.,ne:obsahující hlavně organické složky', 'Wastes from chemical or allied industries (excl. wastes of metal pickling liquor'),
('38259010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Alkalický oxid železa pro čištění plynu', 'Alkaline iron oxide for the purification of gas'),
('38259090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní odpady', 'Residual products of the chemical or allied industries, n.e.s. (excl. waste)'),
('39011010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polyethylen lineární,hustota nižší než 0,94', 'Linear polyethylene with a specific gravity of < 0,94, in primary forms'),
('39011090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polyethylen ostatní,hustota nižší než 0,94', 'Polyethylene with a specific gravity of < 0,94, in primary forms (excl. linear p'),
('39012010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polyethylen ve smyslu pozn.6b,hustota 0,958 a více,obsah prvků viz sazebník', 'Polyethylene in blocks of irregular shape, lumps, powders, granules, flakes and'),
('39012090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polyethylen o hust.0,94 a víc ost.,ne:pro výr.chlorsulfonovaného polyethylenu', 'Polyethylene with a specific gravity of >= 0,94, in primary forms (excl. polyeth'),
('39013000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kopolymery ethylen-vinylacetátové', 'Ethylene-vinyl acetate copolymers, in primary forms'),
('39019030', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ionomerní pryskyřice ze soli termopolymeru ethylenu s isobutylakrylátem a kyselinou metakrylovou; A-B-A blokové kopolymery polystyrenu, ethylenbutylen', 'Ionomer resin consisting of a salt of a terpolymer of ethylene with isobutyl acr'),
('39019090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polymery ethylenu ostatní,ne:viz sazebník', 'Polymers of ethylene, in primary forms (excl. polyethylene, ethylene-vinyl aceta'),
('39021000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polypropylen', 'Polypropylene, in primary forms'),
('39022000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polyisobutylen', 'Polyisobutylene, in primary forms'),
('39023000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kopolymery propylenu', 'Propylene copolymers, in primary forms'),
('39029010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polymery ost.olefinů - A-B-A kopolymery polystyrenu,ethylenbutylenového kopolymeru,obsah.max.35% styrenu', 'A-B-A block copolymer of propylene or of other olefins, of polystyrene, ethylene'),
('39029020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), '1-Polybuten,kopolymer1-butenu s ethylenem,obsahy viz sazebník,viz pozn 6b.', 'Polybut-1-ene, a copolymer of but-1-ene with ethylene containing by weight <= 10'),
('39029090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polymery propylenu a ost.olefínů ostatní,ne:viz sazebník', 'Polymers of propylene or of other olefins, in primary forms (excl. polypropylene'),
('39031100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polystyren lehčený (pěnový)', 'Expansible polystyrene, in primary forms'),
('39031900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polystyren v primárních formách ostatní,ne:lehčený (pěnový)', 'Polystyrene, in primary forms (excl. expansible)'),
('39032000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kopolymery styren-akrylonitrilové (SAN)', 'Styrene-acrylonitrile copolymers "SAN", in primary forms'),
('39033000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kopolymery akrylonitril-butadien-styrenové (ABS)', 'Acrylonitrile-butadiene-styrene copolymers "ABS", in primary forms'),
('39039010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kopolymer výhradně ze starenu a allylalkoholu s acetátovým číslem 175 a vyšším', 'Copolymer solely of styrene with allyl alcohol, of an acetyl value of >= 175, in'),
('39039020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bromovaný polystaren,obsah 58-71% bromu ve smyslu poznámky 6b', 'Brominated polystyrene containing by weight >= 58% but <= 71% of bromine, in blo'),
('39039090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polymery styrenu ost.,ne:polystyren,kopolymer ze starenu,bromovaný polystyren', 'Polymers of styrene, in primary forms (excl. polystyrene, styrene-acrylonitrile'),
('39041000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polyvinylchlorid čistý', 'Poly"vinyl chloride", in primary forms, not mixed with any other substances'),
('39042100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polyvinylchloridy neměkčené,ne:čisté', 'Non-plasticised poly"vinyl chloride", in primary forms, mixed with other substan'),
('39042200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polyvinylchloridy měkčené,ne:čisté', 'Plasticised poly"vinyl chloride", in primary forms, mixed with other substances'),
('39043000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kopolymery vinylchlorid-vinylacetátové', 'Vinyl chloride-vinyl acetate copolymers, in primary forms'),
('39044000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kopolymery vinylchloridové ostatní,ne:vinylchlorid-vinylacetátové', 'Vinyl chloride copolymers, in primary forms (excl. vinyl chloride-vinyl acetate'),
('39045010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kopolymer vinylidenchloridu s akryloitrilem,rozpínavé kuličky 4-20 mikrometrů', 'Copolymer of vinylidene chloride with acrylonitrile, in the form of expansible b'),
('39045090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vinylidenchloridové polymery ostatní,ne:kopolymer vinylidenchloridu s akrylonitrilem', 'Vinylidene chloride polymers, in primary forms (excl. copolymer of vinylidene ch'),
('39046100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polytetrafluorethylen', 'Polytetrafluoroethylene, in primary forms'),
('39046910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polyvinylfluorid ve smyslu pozn.6b', 'Poly"vinyl fluoride" in blocks of irregular shape, lumps, powders, granules, fla'),
('39046990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fluorované polymery ostatní,ne:polytetrafluorethylen,polyvinylfluorid (pozn.6b)', 'Fluoropolymers of vinyl chloride or of other halogenated olefins, in primary for'),
('39049000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polymery halogenolefinů v primárních formách ostatní,ne:viz sazebník', 'Polymers of vinyl chloride or other halogenated olefins, in primary forms (excl.'),
('39051200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polyvinylacetát ve vodné disperzi', 'Poly"vinyl acetate", in aqueous dispersion'),
('39051900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polyvinylacetát ostatní,ne:ve vodné disperzi', 'Poly"vinyl acetate", in primary forms (excl. in aqueous dispersion)'),
('39052100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kopolymery vinylacetátu ve vodné disperzi', 'Vinyl acetate copolymers, in aqueous dispersion'),
('39052900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kopolymery vinylacetátu ostatní,ne:ve vodné disperzi', 'Vinyl acetate copolymers, in primary forms (excl. in aqueous dispersion)'),
('39053000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polyvinylalkoholy obsahující i skupiny acetátové nehydrolyzované', 'Poly"vinyl alcohol", in primary forms, whether or not containing unhydrolyzed ac'),
('39059100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kopolymery vinylu v primárních formách', 'Copolymers of vinyl, in primary forms (excl. vinyl chloride-vinyl acetate copoly'),
('39059910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polyvinyly ve smyslu pozn.6b,složení viz sazebník', 'Poly"vinyl formal" in blocks of irregular shape, lumps, powders, granules, flake'),
('39059990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polymery vinylacetátu ostatní,ne:viz sazebník', 'Polymers of vinyl esters and other vinyl polymers, in primary forms (excl. those'),
('39061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polymethylmetakrylát', 'Poly"methyl methacrylate", in primary forms'),
('39069010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Poly-/N-(3-hydroxyimino-1,1-dimetylbutyl)-akrylamid/', 'Poly[N-"3-hydroxyimino-1,1-dimethylbutyl"acrylamide], in primary forms'),
('39069020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kopolymer 2-diisipropylaminoethylmetakrylát s decylmetakrylátem,obsah.55% a více kopolymeru', 'Copolymer of 2-diisopropylaminoethyl methacrylate with decyl methacrylate in the'),
('39069030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kopolymer kys.akrylové a 2-ethylhexylakrylátu,obsah.10-11% 2-ethylhexylakrylátu', 'Copolymer of acrylic acid with 2-ethylhexyl acrylate containing by weight >= 10%'),
('39069040', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kopolymer akrylonitrilu s methylakrylátem modifik.polubutadien-akrylonitrilem', 'Copolymer of acrylonitrile with methyl acrylate, modified with polybutadiene-acr'),
('39069050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polymerizační produkty kys.akrylové s alkylmetakrylátem pro výr.textil.past', 'Polymerization product of acrylic acid with alkyl methacrylate and small quantit'),
('39069060', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kopolymer methylakrylátu s ethylenem,obsah.50% a více methylakrylátu,též s oxidem křemičitým', 'Copolymer of methyl acrylate with ethylene and a monomer containing a non-termin'),
('39069090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Akrylové polymery v primárních formách ostatní,ne:viz sazebník', 'Acrylic polymers in primary forms (excl. poly"methyl methacrylate", poly[N-"3-hy'),
('39071000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polyacetaly', 'Polyacetals, in primary forms'),
('39072011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polyethylenglykoly', 'Polyethylene glycols, in primary forms'),
('39072020', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polyetheralkoholy ostatní,ne:polyethylenglykoly', 'Polyether alcohols, in primary forms (excl. polyethylene glycols)'),
('39072091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kopolymer 1-chlor-2,3-epoxypropanu s ethylenoxidem', 'Copolymer of 1-chloro-2,3-epoxypropane with ethylene oxide, in primary forms'),
('39072099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polyethery ostatní,ne:polyacetaly,polyetheralkoholy,polyethylenglykoly', 'Polyethers in primary forms (excl. polyether alcohols, polyacetals and copolymer'),
('39073000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pryskyřice epoxidové', 'Epoxide resins, in primary forms'),
('39074000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polykarbonáty', 'Polycarbonates, in primary forms'),
('39075000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pryskyřice alkydové', 'Alkyd resins, in primary forms'),
('39076020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polyethylentereftalát mající viskozní číslo 183ml/g nebo vyšší', 'Poly"ethylene terephthalate", in primary forms, having a viscosity number of >='),
('39076080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polyethylentereftalát ostatní,ne:mající viskozní číslo 183ml/g nebo vyšší', 'Poly"ethylene terephthalate", in primary forms, having a viscosity number of < 7'),
('39077000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Poly(mléčná kyselina)', 'Poly"lactic acid", in primary forms'),
('39079110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polyestery nenasycené kapalné', 'Unsaturated liquid polyesters, in primary forms (excl. polycarbonates, alkyd res'),
('39079190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polyestery ostatní nenasycené,ne:kapalné', 'Unsaturated polyesters, in primary forms (excl. liquid, and polycarbonates, alky'),
('39079910', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Poly(ethylennaftalen-2,6-dikarboxylát)', 'Poly"ethylene naphthalene-2,6-dicarboxylate", saturated, in primary forms'),
('39079990', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polystery nasycené ostatní,ne:viz sazebník', 'Polyesters, saturated, in primary forms (excl. polycarbonates, alkyd resins, pol'),
('39081000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polyamid-6,-11,-12,-6,6,-6,9,-6,10,-6,12', 'Polyamides-6, -11, -12, -6,6, -6,9, -6,10 or -6,12, in primary forms'),
('39089000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polyamidy ost.v primárních formách,ne:polyamid-6,-11,-12,-6,6,-6,9,-6,10,-6,12', 'Polyamides, in primary forms (excl. polyamides-6, -11, -12, -6,6, -6,9, -6,10 an'),
('39091000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pryskyřice močovinové,thiomočovinové', 'Urea resins and thiourea resins, in primary forms'),
('39092000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pryskyřice melaminové', 'Melamine resins, in primary forms'),
('39093000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pryskyřice aminové ostatní,ne:močovinové,thiomočovinové,melaminové', 'Amino-resins, in primary forms (excl. urea resins, thiourea resins and melamine'),
('39094000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pryskyřice fenolové', 'Phenolic resins, in primary forms'),
('39095010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polyurethan 2,2(terc-butylimino)diethanolu s (viz sazebník),50% a více polymeru', 'Polyurethane of 2,2''-"tert-butylimino"diethanol and 4,4''-methylenedicyclohexyl'),
('39095090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polyurethany ost.,ne:2,2-(terc-butylimino)diethanol,50% a více polymeru', 'Polyurethanes in primary forms (excl. polyurethane of 2,2''-"tert-butylimino"die'),
('39100000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Silikony v primárních formách', 'Silicones in primary forms'),
('39111000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pryskyřice ropné,kumaronové,indenové,kumaron-indenové,polyterpeny', 'Petroleum resins, coumarone, indene or coumarone-indene resins and polyterpenes,'),
('39119011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Poly(oxy-1,4-fenylensulfonyl-1,4-fenylen-oxy-1,4-fenilenisopropyliden-1,4fenylen),viz pozn.6b', 'Poly"oxy-1,4-phenylenesulphonyl-1,4-phenyleneoxy-1,4-phenyleneisopropylidene-1,4'),
('39119013', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Poly(thio-1,4-fenylen)', 'Poly"thio-1,4-phenylene", whether or not chemically modified, in primary forms'),
('39119019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polymery kondenzační,přeskupené ostatní,ne:sazeb.pol.39119011,39119013', 'Condensation or rearrangement polymerization products, whether or not chemically'),
('39119092', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kopolymer p-kresolu a divinylbenzenu,roztok obs.>=50% polymeru; hydrogen.kopolymery vinyltoluenu a ?-methylstyrenu', 'Hydrogenated copolymers of vinyltoluene and alfa-methylstyrene, and copolymer of'),
('39119099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polysulfidy,polysulfony a pod.ost.,ne:viz sazebník', 'Polymer and prepolymer plastics produced by chemical synthesis, n.e.s., in prima'),
('39121100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Acetáty (octany) celulózy neměkčené', 'Non-plasticised cellulose acetates, in primary forms'),
('39121200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Acetáty (octany) celulózy měkčené', 'Plasticised cellulose acetates, in primary forms'),
('39122011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kolódia,celuloid neměkčené', 'Non-plasticised collodions and celloidin, in primary forms'),
('39122019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitráty celulózy ostatní neměkčené,ne:kolódia,celuloid', 'Non-plasticised cellulose nitrates, in primary forms (excl. collodions and collo'),
('39122090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitráty celulózy (včetně kolodií) měkčené', 'Plasticised cellulose nitrates, incl. collodions, in primary forms'),
('39123100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Karboxymethylcelulóza,soli', 'Carboxymethylcellulose and its salts, in primary forms'),
('39123920', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hydroxypropylcelulóza', 'Hydroxypropylcellulose in primary forms'),
('39123985', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ethery celulózy ostatní,ne:karboxymethylcelulóza,hydroxypropylcelulóza', 'Cellulose ethers in primary forms (excl. carboxymethylcellulose and its salts an'),
('39129010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Estery celulózy', 'Cellulose esters, in primary forms'),
('39129090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Deriváty celulózy chemické ostatní,ne:viz sazebník', 'Cellulose and chemical derivatives thereof, n.e.s., in primary forms (excl. cell'),
('39131000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kyselina alginová,soli,estery', 'Alginic acid, its salts and esters, in primary forms'),
('39139000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní (i modifikované) přírodní polymery, v primárních formách, j.n.', 'Natural polymers and modified natural polymers, e.g. hardened proteins, chemical'),
('39140000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Menice iontu na bazi polymeru', 'Ion-exchangers based on polymers of heading 3901 to 3913, in primary forms'),
('39151000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpady,úlomky,odřezky z polymerů ethylenu', 'Waste, parings and scrap, of polymers of ethylene'),
('39152000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpady,úlomky,odřezky z polymerů styrenu', 'Waste, parings and scrap, of polymers of styrene'),
('39153000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpady,úlomky,odřezky z polymerů vinylchloridu', 'Waste, parings and scrap, of polymers of vinyl chloride'),
('39159011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpady,úlomky,odřezky z polymerů propylenu', 'Waste, parings and scrap, of polymers of propylene'),
('39159080', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpady, úlomky a odřezky z ostatních plastů,ne:viz sazebník', 'Waste, parings and scrap, of plastics (excl. that of polymers of ethylene, styre'),
('39161000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Monofily z polymerů ethylenu,průměr nad 1mm,tyče,pruty apod. i povrch.upravené', 'Monofilament of which any cross-sectional dimension > 1 mm, rods, sticks and pro'),
('39162000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Monofily z polymerů vinylchloridu,průměr nad 1mm,tyče,pruty apod. i povrch.upravené', 'Monofilament with any cross-sectional dimension of > 1 mm, rods, sticks and prof'),
('39169010', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Monofily z kondenz.,přeskup.polymer.produktů,průměr nad 1mm,tyče,pruty apod. i povrch.upravené', 'Monofilament of which any cross-sectional dimension > 1 mm, rods, sticks and pro'),
('39169050', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Monofily z produktů adiční polymerace,průměr nad 1mm,tyče,pruty apod. i povrch.upravené', 'Monofilament of which any cross-sectional dimension > 1 mm, rods, sticks and pro'),
('39169090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Monofily z plastů ostatních,průměr nad 1mm,tyče,pruty apod.,ne:viz sazebník', 'Monofilament of which any cross-sectional dimension > 1 mm, rods, sticks and pro'),
('39171010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Střeva umělá z tvrzených bílkovin', 'Artificial guts "sausage casings" of hardened protein'),
('39171090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Střeva umělá z plastů celulózových', 'Artificial guts "sausage casings" of cellulose materials'),
('39172110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby aj.neohebné z polymerů ethylenu,bezešvé', 'Rigid tubes, pipes and hoses, of polymers of ethylene, seamless and of a length'),
('39172190', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trubky,hadice neohebné z polymerů ethylenu ostatní,ne:viz sazebník', 'Rigid tubes, pipes and hoses, of polymers of ethylene (excl. seamless and cut to'),
('39172210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby aj.neohebné z polymerů propylenu,bezešvé', 'Rigid tubes, pipes and hoses, of polymers of propylene, seamless and of a length'),
('39172290', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trubky,hadice neohebné z polymerů propylenu ostatní,ne:viz sazebník', 'Rigid tubes, pipes and hoses, of polymers of propylene (excl. seamless and cut t'),
('39172310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby aj.neohebné z polymerů vinylchloridu,bezešvé', 'Rigid tubes, pipes and hoses, of polymers of vinyl chloride, seamless and of a l'),
('39172390', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trubky,hadice neohebné z polymerů vinylchloridu ostatní,ne:viz sazebník', 'Rigid tubes, pipes and hoses, of polymers of vinyl chloride (excl. seamless and'),
('39172900', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby aj.neohebné z plastů jiných,bezešvé,ne:viz sazebník', 'Rigid tubes, pipes and hoses, of plastics (excl. those of polymers of ethylene,'),
('39173100', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trubky,hadice ohebné z plastů,tlak 27,6MPa a více', 'Flexible tubes, pipes and hoses, of plastics, burst pressure >= 27,6 MPa'),
('39173200', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trubky,hadice ohebné z plastů,nezpevněné,nekombinované,bez příslušenství', 'Flexible tubes, pipes and hoses of plastics, not reinforced or otherwise combine'),
('39173300', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trubky,hadice ohebné z plastů nezpevněné,nekombinované,s příslušenstvím', 'Flexible tubes, pipes and hoses of plastics, not reinforced or otherwise combine'),
('39173900', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trubky,hadice ohebné z plastů ost.,ne:viz sazebník', 'Flexible tubes, pipes and hoses, of plastics, reinforced or otherwise combined w'),
('39174000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příslušenství k trubkám,hadicím (např.spojky,kolena,příruby) z plastů', 'Fittings, e.g. joints, elbows, flanges, of plastics, for tubes, pipes and hoses'),
('39181010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Krytiny podlahové i samolepící z polymerů vinylchloridu,tvar rolí,desek apod.', 'Floor coverings, whether or not self-adhesive, in rolls or in the form of tiles,'),
('39181090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Krytiny podlahové,obklady stěn ostatní z polymerů vinylchloridu,ne:viz sazebník', 'Floor coverings of polymers of vinyl chloride, whether or not self-adhesive, in'),
('39189000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Krytiny podlahové,obklady stěn z plastů ostatních,ne:z polymerů vinylchloridu', 'Floor coverings of plastics, whether or not self-adhesive, in rolls or in the fo'),
('39191012', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Samolepící pásky apod.z poly(vinylchloridu),polyethylenu s kaučukem,šíře role do 20cm', 'Plastic strips of poly"vinyl chloride", coated with unvulcanised natural or synt'),
('39191015', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Samolepící pásky apod.z polypropylenu s kaučukem šíře role do 20cm', 'Plastic strips of polypropylene, coated with unvulcanised natural or synthetic r'),
('39191019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Samolep.pásky apod.z plastů ost.s kaučukem šíře role do 20cm,ne:viz sazebník', 'Plastic strips, coated with unvulcanised natural or synthetic rubber, self-adhes'),
('39191080', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Samolepící pásky apod.z plastů ostatních bez kaučuku,šíře role do 20cm', 'Self-adhesive plates, sheets, film, foil, tape, strip and other flat shapes, of'),
('39199000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Samolepící pásky apod.z plastů,šíře role nad 20cm', 'Self-adhesive plates, sheets, film, foil, tape, strip and other flat shapes, of'),
('39201023', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filmy polyethylenové,tl.20-40 mikrometrů pro výr.polovodičů a tišť.spojů', 'Non-cellular polyethylene film of a thickness of >= 20 micrometres but <= 40 mic'),
('39201024', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polyethylenový pružný film,tl.20-40 mikrometrů nepotištěný k výr.polovodičů apod.', 'Stretch film of non-cellular polyethylene, not printed, of a thickness of <= 0,1'),
('39201025', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Folie z polymeru ethylenu ost.,tl.do 0,125,spec.hmotn.do 0,94,ne:viz sazebník', 'Plates, sheets, film, foil and strip, of non-cellular polyethylene, printed, not'),
('39201028', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Folie z polymeru ethylenu,tl.do 0,125,spec.hmotn.0,94 a více', 'Plates, sheets, film, foil and strip, of non-cellular polythene, not reinforced,'),
('39201040', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Folie z polymeru ethylenu ostatní', 'Plates, sheets, film, foil and strip, of non-cellular polymers of ethylene, not'),
('39201081', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filmy,tl.přes 0,125mm,drť v deskách z polyetylen.vláken,do 15% polyvinylalkoholu', 'Synthetic paper pulp in the form of moist sheets made from unconnected finely br'),
('39201089', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filmy z polymerů ethylenu ostatní,tl.přes 0,125mm,ne:do 15% polyvinylalkoholu', 'Plates, sheets, film, foil, tape, strip, of unexpanded polymers of ethylene, not'),
('39202021', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky a podobné tvary z polymerů propylenu, do 0,1 mm, biaxiální', 'Plates, sheets, film, foil and strip, of non-cellular polymers of propylene, not'),
('39202029', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky a podobné tvary z polymerů propylenu do 0,1 mm ostatní,ne:biaxiální', 'Plates, sheets, film, foil and strip, of non-cellular polymers of propylene, not'),
('39202080', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky a podobné tvary z polymerů propylenu nad 0,1 mm', 'Plates, sheets, film, foil and strip, of non-cellular polymers of propylene, not'),
('39203000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky a podobné z polymerů styrenu nevyztužené nekombinované', 'Plates, sheets, foil, film and strip, of non-cellular polymers of styrene, not r'),
('39204310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky apod.z polymerů vinylchloridu,obs.změkčovadel 6% a víc,tl.do 1mm', 'Plates, sheets, film, foil and strip, of non-cellular polymers of vinyl chloride'),
('39204390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky apod.z polymerů vinylchloridu,obs.změkčovadel 6% a víc,tl.nad 1 mm', 'Plates, sheets, film, foil and strip, of non-cellular polymers of vinyl chloride'),
('39204910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky z polymerů styrenu ost,obs.změkčovadel 6% a víc,tl.do 1mm,ne:PVC', 'Plates, sheets, film, foil and strip, of non-cellular polymers of vinyl chloride'),
('39204990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky z polymerů styrenu ost.,obs.změkčovadel 6% a víc,tl.nad 1 mm,ne:PVC', 'Plates, sheets, film, foil and strip, of non-cellular polymers of vinyl chloride'),
('39205100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky a podobné z polymethylmetakrylátu nevyztužené nekombinované', 'Plates, sheets, film, foil and strip, of non-cellular poly"methyl methacrylate",'),
('39205910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky z kopolymerů akrylových a metakrylových esterů,tloušťka do 150 mikrometů', 'Copolymer of non-cellular acrylic and methacrylic esters, in the form of film of'),
('39205990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky z (met-)akrylových kopolymerů ostatní,ne:tloušťka přes 150 mikrometrů', 'Plates, sheets, foil, film and strip of unexpanded acrylic polymers, not reinfor'),
('39206100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky a podobné z polykarbonátů nevyztužené nekombinované', 'Plates, sheets, film, foil and strip, of non-cellular polycarbonates, not reinfo'),
('39206212', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Film poly(ethylentereftalátový),tl.>=72 <=79?m,pruž.mag.disky; tl.>=100 <=150?m,fotopolym.tisk.formy', 'Poly(ethylene terephthalate) film of a thickness ofÂ 72Â micrometres or more but'),
('39206219', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Film polyethylentereftalátový,tl.do 0,35mm,ostatní,ne:tl.72-75,100-150 mikrometrů', 'Plates, sheets, film, foil and strip, of non-cellular poly"ethylene terephthalat'),
('39206290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky a podobné z polyethylentereftalátu nad 0,35 mm', 'Plates, sheets, film, foil and strip, of non-cellular poly"ethylene terephthalat'),
('39206300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky a podobné z polyesterů nenasycených nevyztužené nekombinované', 'Plates, sheets, film, foil and strip, of non-cellular unsaturated polyesters, no'),
('39206900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky a podobné z polyesterů ostatních nevyztužené nekombinované', 'Plates, sheets, film, foil and strip, of non-cellular polyesters, not reinforced'),
('39207100', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,listy,fólie apod. z regenerované celulózy', 'Plates, sheets, film, foil and strip, of non-cellular regenerated cellulose, not'),
('39207310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filmy z celulózy acetátové pro fotografii, kinematografii, role', 'Film backing in rolls or strips for use as carriers for sensitised surfaces in t'),
('39207380', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,listy,fólie apod.z celulózy acetátové ost.,ne:viz sazebník', 'Plates, sheets, film, foil, tape and strip of non-cellular cellulose acetates, n'),
('39207910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky a podobně z vulkánfíbru,nevyztužené,nekombinované', 'Plates, sheets, film, foil and strip of vulcanised fibre, not reinforced, lamina'),
('39207990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky a podobně z derivátů celulózy ostatní,nevyztužené,nekombinované', 'Plates, sheets, film, foil and strip, of non-cellular cellulose derivatives, not'),
('39209100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky a podobně z polyvinylbutyralu nevyztužené nekombinované', 'Plates, sheets, film, foil and strip, of non-cellular poly"vinyl butyral", not r'),
('39209200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky a podobně z polyamidů nevyztužené nekombinované', 'Plates, sheets, film, foil and strip, of non-cellular polyamides, not reinforced'),
('39209300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky a podobně z pryskyřic aminových nevyztužené nekombinované', 'Plates, sheets, film, foil and strip, of non-cellular amino-resins, not reinforc'),
('39209400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky a podobně z pryskyřic fenolických nevyztužené nekombinované', 'Plates, sheets, film, foil and strip, of non-cellular phenolic resins, not reinf'),
('39209921', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filmy,folie a podobně,polyimidové,ne:desky a pásy potažené,nepotažené,kryté plasty', 'Polyimide sheet and strip, non-cellular, uncoated, or coated or covered solely w'),
('39209928', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,listy,folie a podobně z kondenz.nebo přeskup.polymerů ost.,ne:viz sazebník', 'Plates, sheets, film, foil and strip, of non-cellular condensation polymerizatio'),
('39209952', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fólie poly(vinylfluoridové); filmy poly(vinylalkoholové) z >=97%,biax.orient.,nepovrstvené,tl.<=1mm', 'Poly(vinyl fluoride) sheet, and biaxially oriented non-cellular poly"vinyl alcoh'),
('39209953', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Membrány ionto měničové z fluorovaných plast.mater.pro chlor-alkalické články', 'Ion-exchange membranes of fluorinated non-cellular plastic material, for use in'),
('39209959', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,filmy a podobně z adičních polymerů ost.,ne:polyvinylfluoridové,iont.měniče', 'Plates, sheets, film, foil and strip, of non-cellular addition polymerization pr'),
('39209990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,listy a podobně z plastů ostatní,nevyztužené nekombinované,ne:viz sazebník', 'Plates, sheets, film, foil and strip, of non-cellular plastics, n.e.s., not rein'),
('39211100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,listy a podobně z polymerů styrenu lehčené', 'Plates, sheets, film, foil and strip, of cellular polymers of styrene, unworked'),
('39211200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,listy a podobně z polymerů vinylchloridu lehčené', 'Plates, sheets, film, foil and strip, of cellular polymers of vinyl chloride, un'),
('39211310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,listy a podobně z polyurethanů ohebné lehčené', 'Plates, sheets, film, foil and strip, of flexible cellular polyurethane, unworke'),
('39211390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,listy a podobně z polyurethanů ostatní,ne:lehčené,ohebné', 'Plates, sheets, film, foil and strip, of rigid cellular polyurethane, unworked o'),
('39211400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,listy a podobně z celulózy regenerované lehčené', 'Plates, sheets, film, foil and strip, of regenerated cellular cellulose, unworke'),
('39211900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,listy,folie a podobně z ost.plastů lehčené ost.,ne:viz sazebník', 'Plates, sheets, film, foil and strip, of cellular plastic, unworked or merely su'),
('39219010', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,listy a podobně z polyesterů,ne:lehčené', 'Plates, sheets, film, foil and strip, of polyesters, reinforced, laminated, supp'),
('39219030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,listy a podobně z pryskyřic fenolových,ne:lehčené', 'Plates, sheets, film, foil and strip, of phenolic resins, reinforced, laminated,'),
('39219041', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,listy a podobně z laminátů vysokotlakých,dekorativní povrch,ne:lehčené', 'High-pressure laminates of amino-resins, with a decorative surface on one or bot'),
('39219043', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,listy a podobně z pryskyřic aminových ost.laminovaných,ne:vysokotlaké,lehčené', 'Plates, sheets, film, foil and strip, of laminated amino-resins, reinforced, lam'),
('39219049', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,listy a podobně z pryskyřic aminových ost.,ne:laminované,lehčené', 'Plates, sheets, film, foil and strip, of unlaminated amino-resins, reinforced, l'),
('39219055', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,listy,folie a podobně ostatní,ne:viz sazebník', 'Plates, sheets, film, foil and strip, of condensation or rearrangement polymeriz'),
('39219060', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,listy a podobně z polymerů adičních,ne:lehčené', 'Plates, sheets, film, foil and strip, of addition polymerization products, reinf'),
('39219090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,listy,fólie a podobně z plastů ostatních,ne:viz sazebník', 'Plates, sheets, film, foil and strip, of plastics, reinforced, laminated, suppor'),
('39221000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vany koupací,sprchy,umývadla z plastů', 'Baths, shower-baths, sinks and washbasins, of plastics'),
('39222000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sedátka,kryty záchodové z plastů', 'Lavatory seats and covers, of plastics'),
('39229000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zdravotnické,hygienické výrobky z plastů ostatní,ne:viz sazebník', 'Bidets, lavatory pans, flushing cisterns and similar sanitary ware, of plastics'),
('39231000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krabice,bedny,přihrádky a podobné výrobky z plastů', 'Boxes, cases, crates and similar articles for the conveyance or packaging of goo'),
('39232100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pytle,sáčky,kornouty z polymerů ethylenu', 'Sacks and bags, incl. cones, of polymers of ethylene'),
('39232910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pytle,sáčky,kornouty z polyvinylchloridu', 'Sacks and bags, incl. cones, of poly"vinyl chloride"'),
('39232990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pytle,sáčky,kornouty z plastů ostatních,ne:polymery ethylenu,polyvinylchloridu', 'Sacks and bags, incl. cones, of plastics (excl. those of poly"vinyl chloride" an'),
('39233010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Demižony,láhve,flakony a podobně z plastů, obsah do 2l', 'Carboys, bottles, flasks and similar articles for the conveyance or packaging of'),
('39233090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Demižony,láhve,flakony a podobně z plastů, obsah nad 2l', 'Carboys, bottles, flasks and similar articles for the conveyance or packaging of'),
('39234010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cívky a podobně z plastů pro filmy fotografické,kinematograf.,pásky magnetické', 'Spools, reels and similar supports, of plastics, for photographic and cinematogr'),
('39234090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cívky,dutinky,potáče a podobně ostatní z plastů,ne:pro filmy,pásky magnetické', 'Spools, cops, bobbins and similar supports, of plastics (excl. those for photogr'),
('39235010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uzávěry,čepičky z plastů pro láhve', 'Caps and capsules for bottles, of plastics'),
('39235090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zátky,víčka a podobné uzávěry z plastů,ne:pro láhve', 'Stoppers, lids, caps and other closures, of plastics (excl. caps and capsules fo'),
('39239000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky pro balení a podobné zboží z plastů ostatní,ne:viz sazebník', 'Articles for the conveyance or packaging of goods, of plastics (excl. boxes, cas'),
('39241000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nádobí stolní,kuchyňské z plastů', 'Tableware and kitchenware, of plastics'),
('39249000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Potřeby hygienické a podobně z plastů ostatní,ne:nádobí', 'Household articles and toilet articles, of plastics (excl. tableware, kitchenwar'),
('39251000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nádrže,zásobníky,kádě a podobně z plastů, obsah nad 300l', 'Reservoirs, tanks, vats and similar containers, of plastics, with a capacity of'),
('39252000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Dveře,okna,jejich a rámy,zárubně,prahy z plastů', 'Doors, windows and their frames and thresholds for doors, of plastics'),
('39253000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Okenice,rolety (vč.žaluzií) a podobné výrobky,části,příslušenství z plastů', 'Shutters, blinds, incl. Venetian blinds, and similar articles and parts thereof,'),
('39259010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příslušenství,kování na dveře,schodiště,stěny a podobně z plastů', 'Fittings and mountings intended for permanent installation in or on doors, windo'),
('39259020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lávky pro elektrické rozvody,dálkové potrubní,kabelové vedení z plastů', 'Trunking, ducting and cable trays for electrical circuits, of plastics'),
('39259080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stavební výrobky ostatní z plastů,ne:viz sazebník', 'Builders'' ware for the manufacture of flooring, walls, partition walls, ceiling'),
('39261000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Potřeby kancelářské,školní z plastů a podobných materiálů', 'Office or school supplies, of plastics, n.e.s.'),
('39262000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky oděvní,příslušenství včetně rukavic z plastů a podobných materiálů', 'Articles of apparel and clothing accessories produced by the stitching or sticki'),
('39263000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ozdoby a jiné vybavení k nábytku,karoseriím a podobně z plastů', 'Fittings for furniture, coachwork and the like, of plastics (excl. building comp'),
('39264000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sošky a jiné výrobky ozdobné z plastů a podobných materiálů', 'Statuettes and other ornamental articles, of plastics'),
('39269050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Koše perforované apod.k filtraci odtokové vody z plastů', 'Perforated buckets and similar articles used to filter water at the entrance to'),
('39269092', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ost.z fólií z plastů apod.', 'Articles made from plastic sheet, n.e.s.'),
('39269097', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ost.z plastů apod.,ne:viz sazebník', 'Articles of plastics and articles of other materials of heading 3901 to 3914, n.'),
('40011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Latex přírodního kaučuku i předvulkanizovaný', 'Natural rubber latex, whether or not prevulcanised'),
('40012100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kaučuk uzený přírodní', 'Smoked sheets of natural rubber'),
('40012200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kaučuk přírodní technický specifikovaný (TSPK)', 'Technically specified natural rubber "TSNR"'),
('40012900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přírodní kaučuk ostatní,ne:latex,uzený,technicky specifikovaný', 'Natural rubber in primary forms or in plates, sheets or strip (excl. smoked shee'),
('40013000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Balata,gutaperča,guajal,čikl a podobné kaučuky přírodní,ne:viz sazebník', 'Balata, gutta-percha, guayule, chicle and similar natural gums, in primary forms'),
('40021100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kaučuk (karboxylovaný)styren-butadienový-latex syntetický', 'Styrene-butadiene rubber latex "SBR"; carboxylated styrene-butadiene rubber late'),
('40021910', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Styren-butadienový kaučuk vyrobený emulzní polymerací (E-SBR) v balících', 'Styrene-butadiene rubber produced by emulsion polymerisation "E-SBR", in bales'),
('40021920', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Blokové styren-butadien-styrenové kopolymery vyrobené roztokovou polymerací (SBS)-granule apod.', 'Styrene-butadiene-styrene block copolymers produced by solution polymerisation "'),
('40021930', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Styren-butadienový kaučuk vyrobený roztokovou polymerací (S-SBR) v balících', 'Styrene-butadiene rubber produced by solution polymerisation "S-SBR", in bales'),
('40021990', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kaučuk (karboxylovaný) styren-butadienový ostatní,ne:viz sazebník', 'Styrene-butadiene rubber "SBR" and carboxylated styrene-butadiene rubber "XSBR",'),
('40022000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kaučuk butadienový (BR)', 'Butadiene rubber "BR", in primary forms or in plates, sheets or strip'),
('40023100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kaučuk izobuten-izoprenový (butylkaučuk-IIR)', 'Isobutylene isoprene rubber "IIR", in primary forms or in plates, sheets or stri'),
('40023900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kaučuk halogenizobuten-izoprenový (CIIR, BIIR)', 'Halo-isobutene-isoprene rubber "CIIR" or "BIIR", in primary forms or in plates,'),
('40024100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kaučuk chloroprenový (chlorobutadienový) (CR)-latex', 'Chloroprene latex "chlorobutadiene rubber, CR"'),
('40024900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chloroprenový (chlorbutadienový) kaučuk ostatní,ne:latex', 'Chloroprene "chlorobutadiene rubber, CR", in primary forms or in plates, sheets'),
('40025100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kaučuk akrylonytril-butadienový (NBR)-latex', 'Latex of acrylonitrile-butadiene rubber "NBR"'),
('40025900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kaučuk akrylonytril-butadienový (NBR) ostatní,ne:latex', 'Acrylonitrile-butadiene rubber "NBR", in primary forms or in plates, sheets or s'),
('40026000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kaučuk izoprenový (IR)', 'Isoprene rubber "IR", in primary forms or in plates, sheets or strip'),
('40027000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kaučuk dienový ethylenpropylenový nekonjugovaný (EPDM)', 'Ethylene-propylene diene rubber "EPDM", non-conjugated, in primary forms or in p'),
('40028000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi kaučuku syntetického a přírodního', 'Mixtures of natural rubber, balata, gutta-percha, guayule, chicle or similar typ'),
('40029100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Faktis (kaučuk olejový),kaučuky ostatní-latex,ne:viz sazebník', 'Synthetic rubber and factice derived from oils, in primary forms or in plates, s'),
('40029910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Produkty kaučuku modifikované plasty', 'Natural rubber products modified by the incorporation of plastics (excl. depolym'),
('40029990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kaučuky ostatní,ne:latexy,viz sazebník', 'Synthetic rubber and factice derived from oils, in primary forms or plates, shee'),
('40030000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kaučuk regenerovaný v primárních formách,deskách,listech,pásech', 'Reclaimed rubber in primary forms or in plates, sheets or strip'),
('40040000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpady,úlomky,odřezky,prášky,zrna kaučuku,ne:z tvrzené pryže', 'Waste, parings and scrap of soft rubber and powders and granules obtained theref'),
('40051000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kaučuk s plněný sazemi,světlými plnivy nevulkanizovaný', 'Rubber, unvulcanised, compounded with carbon black or silica, in primary forms o'),
('40052000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Roztoky,disperze,ne:kaučuk plněný sazemi,světlými plnivy nevulkanizované', 'Compounded rubber, unvulcanised, in the form of solutions or dispersions (excl.'),
('40059100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,listy,pásy ze směsných kaučuků nevulkanizované', 'Compounded rubber, unvulcanised, in the form of plates, sheets or strip (excl. r'),
('40059900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kaučuky směsné ostatní nevulkanizované,ne:viz sazebník', 'Compounded, unvulcanised rubber in primary forms (excl. solutions and dispersion'),
('40061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Profily k protektorování z kaučuku nevulkanizovaného', '''Camel-back'' strips of unvulcanised rubber, for retreading rubber tyres'),
('40069000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Formy jiné (tyče,trubky apod.),výrobky ost.z kaučuku nevulkaniz.,ne:viz sazebník', 'Rods, bars, tubes, profiles and other forms of unvulcanised rubber, incl. mixed'),
('40070000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlákna,provázky z kaučuku vulkanizovaného', 'Vulcanised rubber thread and cord (excl. ungimped single thread with a diameter'),
('40081100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,listy,pásy z kaučuku vulkanizovaného,ne:z tvrdého kaučuku', 'Plates, sheets and strip of cellular rubber'),
('40081900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,profily a podobně z kaučuku vulkanizovaného,ne:desky,listy,pásy,z tvrdého kaučuku', 'Strip, rods and profile shapes, of cellular rubber'),
('40082110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Podlahoviny,předložky z pryže kompaktní (nelehčené)', 'Floor coverings and mats, uncut or simply cut to rectangular or square shape, of'),
('40082190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,listy,pásy z pryže kompaktní (nelehčené),ne:podlahoviny,předložky', 'Plates, sheets and strip, of non-cellular rubber (excl. floor coverings and mats'),
('40082900', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,profily a podobně z pryže kompaktní ostatní', 'Rods, tubes and profile shapes, of non-cellular rubber'),
('40091100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,hadice z kaučuku vulk. nezpevněné,nekombinované,bez přísluš.', 'Tubes, pipes and hoses, of vulcanised rubber (excl. hard rubber), not reinforced'),
('40091200', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,hadice z kaučuku vulk.nezpevněné,nekombinované,s příslušenstvím', 'Tubes, pipes and hoses, of vulcanised rubber (excl. hard rubber), not reinforced'),
('40092100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,hadice z kaučuku vulk.zpevněné,kombinované pouze s kovy,bez přísl.', 'Tubes, pipes and hoses, of vulcanised rubber (excl. hard rubber), reinforced or'),
('40092200', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,hadice z kaučuku vulk.nezpevněné,nekombinované,s příslušenstvím', 'Tubes, pipes and hoses, of vulcanised rubber (excl. hard rubber), reinforced or'),
('40093100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,hadice z kaučuku vulk.zpevněné,kombinované s textilem,bez přísl.', 'Tubes, pipes and hoses, of vulcanised rubber (excl. hard rubber), reinforced or'),
('40093200', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,hadice z kaučuku vulk.zpevněné,kombinované s textilem,bez příslušenství', 'Tubes, pipes and hoses, of vulcanised rubber (excl. hard rubber), reinforced or'),
('40094100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hadice z kaučuku vulkanizovaného zpevněné, komb.s ost.mater.,bez přísl.', 'Tubes, pipes and hoses, of vulcanised rubber (excl. hard rubber), reinforced or'),
('40094200', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hadice z kaučuku vulk.zpevněné, kombinované s ost.materiály,bez příslušenství', 'Tubes, pipes and hoses, of vulcanised rubber (excl. hard rubber), reinforced or'),
('40101100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pásy dopravníkové,hnací řemeny z vulkaniz.kaučuku zpevněné pouze kovem', 'Conveyor belts or belting, of vulcanised rubber, reinforced only with metal'),
('40101200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pásy dopravníkové,hnací řemeny z vulkaniz.kaučuku zpevněné pouze textil.mater.', 'Conveyor belts or belting, of vulcanised rubber, reinforced only with textile ma'),
('40101900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pásy dopravníkové,hnací řemeny z vulkaniz.kaučuku ostatní,ne:viz sazebník', 'Conveyor belts or belting, of vulcanised rubber (excl. reinforced only with meta'),
('40103100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pásy převod.nekonečné z kaučuku vulk.(V-pásy)žebrované,.obvod nad 60-180cm', 'Endless transmission belts of trapezoidal cross-section "V-belts", of vulcanised'),
('40103200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pásy převod.nekonečné z kaučuku vulk.(V-pásy),.obvod nad 60-180cm,ne:žebr.', 'Endless transmission belts of trapezoidal cross-section "V-belts", of vulcanised'),
('40103300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pásy převod.nekonečné z kaučuku vulk.(V-pásy)žebrované,.obvod nad 180-240cm', 'Endless transmission belts of trapezoidal cross-section "V-belts", of vulcanised'),
('40103400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pásy převod.nekonečné z kaučuku vulk.(V-pásy),.obvod nad 180-240cm,ne:žebr.', 'Endless transmission belts of trapezoidal cross-section "V-belts", of vulcanised'),
('40103500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pásy synchronní nekonečné z kaučuku,obvod nad 60-150cm', 'Endless synchronous belts, of vulcanised rubber, of an outside circumference > 6'),
('40103600', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pásy synchronní nekonečné z kaučuku,obvod nad 150-198cm', 'Endless synchronous belts, of vulcanised rubber, of an outside circumference > 1'),
('40103900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pásy,řemeny hnací z kaučuku vulkanizovaného ostatní,ne:viz sazebník', 'Transmission belts or belting, of vulcanised rubber (excl. endless transmission'),
('40111000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pneumatiky nové pryžové pro osobní motorová vozidla vč.kombinace,závodních', 'New pneumatic tyres, of rubber, of a kind used for motor cars, incl. station wag'),
('40112010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pneumatiky nové pryž.pro autobusy,nákladní autom.,index zatížení nepřesah.121', 'Pneumatic tyres, new, of rubber, of a kind used for buses or lorries, with a loa'),
('40112090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pneumatiky nové pryž.pro autobusy,nákladní autom.,index zatížení převyš.121', 'Pneumatic tyres, new, of rubber, of a kind used for buses or lorries, with a loa'),
('40113000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pneumatiky nové pryžové pro letadla', 'New pneumatic tyres, of rubber, of a kind used for aircraft'),
('40114000', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pneumatiky nové pryžové pro motocykly', 'New pneumatic tyres, of rubber, of a kind used for motorcycles'),
('40115000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pneumatiky nové z kaučuku používané pro jízdní kola', 'New pneumatic tyres, of rubber, of a kind used for bicycles'),
('40116100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pneumatiky nové z kaučuku,běhoun"rybí kost" pro zeměď.,lesnická vozidla', 'Pneumatic tyres, new, of rubber, having a "herring-bone" or similar tread, of a'),
('40116200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pneumat.nové,kaučuk,běhoun"rybí kost"pro prům.manipul.voz.,ráfek do 61cm', 'Pneumatic tyres, new, of rubber, having a "herring-bone" or similar tread, of a'),
('40116300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pneumat.nové,kaučuk,běhoun"rybí kost"pro prům.manipul.voz.,ráfek nad 61cm', 'Pneumatic tyres, new, of rubber, having a "herring-bone" or similar tread, of a'),
('40116900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pneumatiky nové z kaučuku,běhoun"rybí kost" ostatní,ne:viz sazebník', 'Pneumatic tyres, new, of rubber, having a "herring-bone" or similar tread (excl.'),
('40119200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pneumatiky nové z kaučuku, pro zeměď.,lesnická vozidla,ne:běhoun"rybí kost"', 'Pneumatic tyres, of rubber, new, of a kind used on agricultural or forestry vehi'),
('40119300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pneumat.nové,kaučuk,pro prům.manipul.voz.,ráfek do 61cm,ne:běhoun"rybí kost"', 'Pneumatic tyres, new, of rubber, of a kind used on construction or industrial ha'),
('40119400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pneumat.nové,kaučuk,pro prům.manipul.voz.,ráfek nad 61cm,ne:běhoun"rybí kost"', 'Pneumatic tyres, new, of rubber, of a kind used on construction or industrial ha'),
('40119900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pneumatiky nové pryžové ostatní', 'Pneumatic tyres, new, of rubber (excl. having a "herring-bone" or similar tread'),
('40121100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pneumatiky protektorované pro vozy osobní vč.osobní dodávkové,závodní', 'Retreaded pneumatic tyres, of rubber, of a kind used on motor cars "incl. statio'),
('40121200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pneumatiky protektorované pro autobusy,nákladní automobily', 'Retreaded pneumatic tyres, of rubber, of a kind used on buses or lorries'),
('40121300', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pneumatiky protektorované pro letadla', 'Retreaded pneumatic tyres, of rubber, of a kind used on aircraft'),
('40121900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pneumatiky protektorované ostatní,ne:viz sazebník', 'Retreaded pneumatic tyres, of rubber (excl. of a kind used on motor cars, statio'),
('40122000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pneumatiky pryžové použité pro letadla', 'Used pneumatic tyres of rubber'),
('40129020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Komorové (plné) obruče nebo nízkotlaké pláště', 'Solid or cushion tyres, of rubber'),
('40129030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vyměnitelné běhouny pláště pneumatiky', 'Tyre treads, of rubber'),
('40129090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vložky ochranné do ráfků pneumatik pryžové', 'Tyre flaps, of rubber'),
('40131000', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Duše pryžové pro osobní automobily (vč.osobních dodávkových,závodních),pro nákl.automobily,autobusy', 'Inner tubes, of rubber, of a kind used on motor cars, incl. station wagons and r'),
('40132000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Duše pryžové pro kola jízdní', 'Inner tubes, of rubber, of a kind used for bicycles'),
('40139000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Ostatní kaučukové duše,nepouž. pro motorová vozidla, busy, jízdní kola', 'Inner tubes, of rubber (excl. those of a kind used on motor cars, incl. station'),
('40141000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prezervativy z kaučuku vulkanizovaného', 'Sheath contraceptives, of vulcanised rubber (excl. hard rubber)'),
('40149000', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hygien.,farmac.výrobky (vč.dudlíků),z vulkaniz.kaučuku (ne tvrdého),i s přísluš.z tvrdého kaučuku', 'Hygienic or pharmaceutical articles, incl. teats, of vulcanised rubber (excl. ha'),
('40151100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Rukavice chirurgické z kaučuku vulkanizovaného,ne:tvrdého', 'Surgical gloves, of vulcanised rubber (excl. fingerstalls)'),
('40151900', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Rukavice prstové,bez prstů,palčáky,z vulkaniz.kaučuku (ne tvrdého),ne:chirurgické', 'Gloves, mittens and mitts, of vulcanised rubber (excl. surgical gloves)'),
('40159000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky,doplňky oděvní ostatní z kaučuku vulkanizovaného,ne:tvrdého,rukavice', 'Articles of apparel and clothing accessories, for all purposes, of vulcanised ru'),
('40161000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ostatní z pryže pórovité', 'Articles of cellular rubber, n.e.s.'),
('40169100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krytina podlahová,předložky z kaučuku vulkanizovaného,ne:tvrdého', 'Floor coverings and mats, of vulcanised rubber (excl. hard rubber), with chamfer'),
('40169200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pryž mazací', 'Erasers, of vulcanised rubber (excl. hard rubber), conditioned (excl. those simp'),
('40169300', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Těsnění ploché,podložky,kroužky z kaučuku vulkanizovaného', 'Gaskets, washers and other seals, of vulcanised rubber (excl. hard rubber and th'),
('40169400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nárazníky i nafukovací z kaučuku vulkanizovaného pro přistávání lodí', 'Boat or dock fenders, whether or not inflatable, of vulcanised rubber (excl. har'),
('40169500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky nafukovací ost.z kaučuku vulkanizovaného,ne:tvrdého,pro přistávání lodí', 'Inflatable mattresses and cushions and other inflatable articles, of vulcanised'),
('40169952', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Spojovací části z nepórovité pryže spojené s kovem pro vozidla č. 8701-8705', 'Rubber-to-metal bonded parts of vulcanised rubber (excl. hard rubber), of a type'),
('40169957', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z nepórovité pryže ostatní pro motorová vozidla 8701 až 8705,ne:spoj.části spojené s kovem', 'Articles of vulcanised rubber (excl. hard rubber), of a type intended exclusivel'),
('40169991', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Spojovací části z pryže spojené s kovem,pro motorová vozidla čísel 8701 až 8705', 'Rubber-to-metal bonded parts of vulcanised rubber (excl. hard rubber and those o'),
('40169997', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z nepórovité pryže ostatní,ne:viz sazebník', 'Articles of vulcanised rubber, n.e.s. (excl. hard rubber and those of cellular r'),
('40170000', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tvrdá pryž (např.ebonit),v jakékoliv formě vč.odpadů a zbytků,výrobky z tvrdé pryže', 'Hard rubber, e.g. ebonite, in all forms, incl. waste and scrap; articles of hard'),
('41012010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže,kožky hovězího dobytka surové čerstvé,hmotnost viz sazebník', 'Whole raw hides and skins of bovine "incl. buffalo" or equine animals, whether o'),
('41012030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže,kožky hovězího dobytka surové mokrosolené,hmotnost viz sazebník', 'Whole raw hides and skins of bovine "incl. buffalo" or equine animals, whether o'),
('41012050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže,kožky hovězího dobytka surové sušené,suchosolené,hmotnost viz saz', 'Whole raw hides and skins of bovine "incl. buffalo" or equine animals, whether o'),
('41012090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže,kožky hovězího dobytka surové ost.,hmotnost viz sazebník,ne:viz saz', 'Whole raw hides and skins of bovine "incl. buffalo" or equine animals, whether o'),
('41015010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kožky hovězího dobytka surové čerstvé, hmotnost nad 16kg', 'Whole raw hides and skins of bovine "incl. buffalo" or equine animals, whether o'),
('41015030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kožky hovězího dobytka surové mokrosolené, hmotnost nad 16kg', 'Whole raw hides and skins of bovine "incl. buffalo" or equine animals, whether o'),
('41015050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kožky hovězího dobytka surové sušené,suchosolené, hmotnost nad 16kg', 'Whole raw hides and skins of bovine "incl. buffalo" or equine animals, whether o'),
('41015090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže hovězího dobytka surové ostatní, hmotnost nad 16kg,ne:viz sazebník', 'Whole raw hides and skins of bovine "incl. buffalo" or equine animals, whether o'),
('41019000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kůže hovězího dobytka surové ostatní,ne:viz sazebník', 'Butts, bends, bellies and split raw hides and skins of bovine "incl. buffalo" or'),
('41021010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže jehněčí s vlnou surové', 'Raw skins of lambs, with wool on, fresh or salted, dried, limed, pickled or othe'),
('41021090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže ovcí s vlnou surové', 'Raw skins of sheep, with wool on, fresh or salted, dried, limed, pickled or othe'),
('41022100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže ovčí,jehněčí surové bez vlny piklované nevyčiněné', 'Raw skins of sheep or lambs, without wool on, pickled, whether or not split'),
('41022900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže ovčí,jehněčí surové bez vlny nevyčiněné ostatní,ne:piklované', 'Raw skins of sheep or lambs, without wool on, fresh or salted, dried, limed or o'),
('41032000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže plazů surové i konzervované nevyčiněné', 'Raw hides and skins of reptiles, fresh or salted, dried, limed, pickled or other'),
('41033000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže prasat surové i konzervované nevyčiněné', 'Raw hides and skins of swine, fresh, or salted, dried, limed, pickled or otherwi'),
('41039010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže koz,kůzlat,surové,konzervované,nevyčiněné', 'Raw hides and skins of goats or kids, limed, pickled or otherwise preserved, whe'),
('41039090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kůže surové ostatní,konzervované,nevyčiněné', 'Raw hides and skins, fresh, or salted, dried, limed, pickled or otherwise preser'),
('41041110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže hovězího dobytka celé,plný líc,mokrý stav,plocha do 2,6m2', 'Full grains, unsplit and grain splits, in the wet state "incl. wet-blue", of the'),
('41041151', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže hov.dobytka celé, plný líc, mokrý stav, pl.nad 28 čtver.stop(2,6m2)', 'Full grains, unsplit and grain splits, in the wet state "incl. wet-blue", of the'),
('41041159', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže hovězího dobytka,plný líc,mokrý stav,plocha do 2,6m2,ne:celé', 'Full grains, unsplit and grain splits, in the wet state "incl. wet-blue", of hid'),
('41041190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže lichokopytníků ostostatních,plný líc,mokrý stav,ne:hovězí', 'Full grains, unsplit and grain splits, in the wet state "incl. wet-blue", of hid'),
('41041910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže hov.dobytka celé,mokrý stav,pl.do 28 čtver.stop (2,6m2),ne:plný líc', 'Whole hides and skins of bovine "incl. buffalo" animals, with a surface area of'),
('41041951', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže hov.dobytka celé, mokrý stav, pl.nad 28 čtver.stop(2,6m2),ne:plný líc', 'Whole hides and skins of bovine "incl. buffalo" animals, with a surface area of'),
('41041959', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže hovězího dobytka ostatní, mokrý stav,ne:celé, plný líc', 'Hides and skins of bovine "incl. buffalo" animals, in the wet state "incl. wet-b'),
('41041990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže lichokopytníků ostatních, mokrý stav,ne:hovězí, plný líc', 'Hides and skins of equine animals, in the wet state "incl. wet-blue", tanned, wi'),
('41044111', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže východoindické hověz.dobytka celé,suché,plný líc,váha do 4,5kg', 'Full grains leather, unsplit and grain splits leather of East India kip, without'),
('41044119', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže hověz.dobytka celé,suché,plný líc,váha do 4,5kg,ne:východoindický', 'Full grains leather, unsplit and grain splits leather, in the dry state "crust",'),
('41044151', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže hovězího dobytka celé, suché, plný líc, váha do 4, 5kg, pl.nad 2,6m2', 'Full grains leather, unsplit and grain splits leather, in the dry state "crust",'),
('41044159', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže hovězího dobytka, suché, plocha do 2,6m2,ne:celé, plný líc', 'Full grains leather, unsplit and grain splits leather, in the dry state "crust",'),
('41044190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže lichokopytníků ostatních, suché, plný líc,ne:hovězí', 'Full grains leather, unsplit and grain splits leather, in the dry state "crust",'),
('41044911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže hov.dobytka východoind.celé,suché,do 4,5kg, pl.do 2,6m2,ne:plný líc', 'Hides and skins of East India kip, without hair on, whole, whether or not the he'),
('41044919', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže hov.dobytka celé,suché,do 4,5kg, plocha do 2,6m2,ne:východoind.,plný líc', 'Whole hides and skins of bovine "incl. buffalo" animals, with a surface area of'),
('41044951', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže hov.dobytka celé, suché, váha do 4, 5kg, plocha nad 2, 6m2,ne:plný líc', 'Whole hides and skins of bovine "incl. buffalo" animals, with a surface area of'),
('41044959', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže hovězího dobytka, suché, plocha do 2, 6m2,ne:celé, plný líc', 'Hides and skins of bovine "incl. buffalo" animals, with a surface area of > 2,6'),
('41044990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže lichokopytníků ostatních, suché,ne:hovězí, plný líc', 'Hides and skins of equine animals, in the dry state "crust", without hair on, wh'),
('41051010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže ovcí,jehňat,mokrý stav,lícové,vyčiněné,poločiněné,odchlupené', 'Skins of sheep or lambs, in the wet state "incl. wet-blue", tanned, without wool'),
('41051090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže ovcí,jehňat,mokrý stav,štípané,vyčiněné,poločiněné,odchlupené', 'Skins of sheep or lambs, in the wet state "incl. wet-blue", tanned, without wool'),
('41053010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže ovcí indických jemnovlných,suché,vyčiněné tříslem, odchlup.,ne:výr.kož.zboží', 'Indian hair sheep skins, in the dry state "crust", without wool on, vegetable pr'),
('41053091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže ovcí ost.,suché,lícové,odchlupené,ne:indických jemnovlných', 'Skins of sheep or lambs, in the dry state "crust", without wool on, unsplit (exc'),
('41053099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže ovcí ost.,suché,štípané,odchlupené,ne:indických jemnovlných', 'Skins of sheep or lambs, in the dry state "crust", without wool on, split (excl.'),
('41062110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže koz,kůzlat v mokrém stavu,lícové', 'Skins of goats or kids, in the wet state "incl. wet-blue", tanned, without wool'),
('41062190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže koz,kůzlat v mokrém stavu,štípané', 'Skins of goats or kids, in the wet state "incl. wet-blue", tanned, without wool'),
('41062210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže koz,kůzlat indických,suché,vyčiněné tříslem odchlupené,ne:výr.kož.zboží', 'Indian goat or kid skins, in the dry state "crust", without wool on, vegetable p'),
('41062290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže koz,kůzlat ostatní,suché,vyčiněné tříslem odchlupené,ne:z indických', 'Hides and skins of goats or kids, in the dry state "crust", without wool on, whe'),
('41063110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže prasat,mokrý stav,lícové,vyčiněné,odchlupené', 'Hides and skins of swine, in the wet state "incl. wet-blue", tanned, without hai'),
('41063190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže prasat,mokrý stav,štípané,vyčiněné,odchlupené', 'Hides and skins of swine, in the wet state "incl. wet-blue", tanned, without hai'),
('41063210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže prasat,suchý stav,lícové,poločiněné,odchlupené', 'Hides and skins of swine, in the dry state "crust", without wool on, unsplit (ex'),
('41063290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže prasat,suchý stav,štípané,poločiněné,odchlupené', 'Hides and skins of swine, in the dry state "crust", without wool on, split (excl'),
('41064010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže plazů,vyčiněné tříslem', 'Hides and skins of reptiles, vegetable pre-tanned only'),
('41064090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže plazů ostatní,ne:vyčiněné tříslem', 'Tanned or crust hides and skins of reptiles, whether or not split (excl. further'),
('41069100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kůže zvířat ostatních,vyčiněné,odchlupené,suchý stav,ne:viz sazebník', 'Hides and skins of antelopes, deer, elks, elephants and other animals, incl. sea'),
('41069200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kůže zvířat ostatních,vyčiněné,odchlupené,mokrý stav,ne:viz sazebník', 'Hides and skins of antelopes, deer, elks, elephants and other animals, incl. sea'),
('41071111', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Kůže celé hovězího dobytka-telecí box,plocha do 2,6m2,plný líc,jinak upr.', 'Boxcalf full grains leather, unsplit, of whole calfhides and calfskins, with a s'),
('41071119', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Kůže celé hovězího dobytka ost.,plocha do 2,6m2,plný líc,jinak upr.,ne:telecí', 'Full grains leather "incl. parchment-dressed leather", unsplit, of the whole hid'),
('41071190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Kůže celé hovězího dobytka ost.,plný líc,jinak upr.,ne:telecí box,plocha do 2,6m2', 'Full grains leather "incl. parchment-dressed leather", unsplit, of the whole hid'),
('41071211', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Kůže hov.dobytka celé-telecí box, plocha do 2,6m2, líc.štípenka, jinak uprav.', 'Boxcalf grain splits leather, of whole calfhides and calfskins, with a surface a'),
('41071219', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Kůže hov.dobytka celé ost,pl.do 2,6m2, líc.štípenka, jinak upr.,ne:telecí box', 'Grain splits leather "incl. parchment-dressed leather", of the whole hides and s'),
('41071291', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Kůže hov.dobytka celé ost,líc.štípenka, jinak upr.,ne:telecí box, pl.do 2,6m2', 'Grain splits leather "incl. parchment-dressed leather", of the whole hides and s'),
('41071299', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Kůže koní,jiných lichokopytníků celé, jinak upravené', 'Grain splits leather "incl. parchment-dressed leather", of the whole hides and s'),
('41071910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Kůže celé hovězího dobytka,plocha do 2,6m2,jinak upr.,ne:plný líc,líc.štípenka', 'Leather "incl. parchment-dressed leather" of the whole hides and skins of bovine'),
('41071990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Kůže hovězího dobytka,koní,lichokopytníků ostatní,jinak upravené,ne:viz sazeb', 'Leather "incl. parchment-dressed leather" of the whole hides and skins of bovine'),
('41079110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kůže hověz.dobytka,koní,lichokopyt.ost,plný líc,spodkové,,jinak upr.,ne:celé', 'Full grains sole leather "incl. parchment-dressed leather", unsplit, of the port'),
('41079190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Kůže hověz.dobytka,koní,lichokopyt.ost,plný líc,,jinak upr.,ne:celé,spodkové', 'Full grains leather "incl. parchment-dressed leather", unsplit, of the portions,'),
('41079210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Kůže hovězího dobytka ostatní, lícová štípenka, jinak upravené,ne:celé', 'Grain splits leather "incl. parchment-dressed leather", of the portions, strips'),
('41079290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Kůže koní ostatní, lícová štípenka, jinak upravené,ne:celé', 'Grain splits leather "incl. parchment-dressed leather", of the portions, strips'),
('41079910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Kůže hovězího dobytka ostatní,,jinak upr.,ne:celé,lícová štípenka,plný líc', 'Leather "incl. parchment-dressed leather" of the portions, strips or sheets of'),
('41079990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Kůže koní,jiných lichokopytníků ost.,,jinak upr.,ne:celé,lícová štípenka,plný', 'Leather "incl. parchment-dressed leather" of the portions, strips or sheets of'),
('41120000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Usně ovčí,jehněčí,po vyčinění jinak upravené,odchlupené,i zprac.na pergamen', 'Leather further prepared after tanning or crusting "incl. parchment-dressed leat'),
('41131000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Usně kozí,kůzlečí,po vyčinění jinak upravené,odchlupené,i zprac.na pergamen', 'Leather further prepared after tanning or crusting "incl. parchment-dressed leat'),
('41132000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Usně prasat,po vyčinění jinak upravené,odchlupené,i zprac.na pergamen', 'Leather further prepared after tanning or crusting "incl. parchment-dressed leat'),
('41133000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Usně plazů,po vyčinění jinak upravené,odchlupené,i zprac.na pergamen', 'Leather further prepared after tanning or crusting "incl. parchment-dressed leat'),
('41139000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Usně zvířat ostatních,po vyčinění jinak upravené,odchlupené,ne:viz sazebník', 'Leather further prepared after tanning or crusting "incl. parchment-dressed leat'),
('41141010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zámiš (včetně kombinované zámiše) z ovcí,,jehňat', 'Chamois leather, incl. combination chamois leather, of sheep or lambs (excl. gla'),
('41141090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zámiš (včetně kombinované zámiše) ostatní,ne:z ovcí,,jehňat', 'Chamois leather, incl. combination chamois leather (excl. that of sheep or lambs'),
('41142000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Usně lakové, usně lakové laminované,usně metalizované', 'Patent leather and patent laminated leather; metallised leather (excl. lacquered'),
('41151000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Usně kompozitní na zákl.nerozvl.usně,kožených vláken,tvar desek,pruhů apod.', 'Composition leather based on leather or leather fibre, in slabs, sheets or strip'),
('41152000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odřezky,odpady kůží,nepoužitelné k výr.koženého zboží,kořený prach,moučka', 'Parings and other waste of leather or of composition leather, not suitable for t'),
('42010000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky sedlářské,řemenářské pro zvířata z jakéhokoliv materiálu', 'Saddlery and harness for any animal, incl. traces, leads, knee pads, muzzles, sa'),
('42021110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Aktovky,brašny školní apod.vnější povrch z usně přírodní,kompozitní,lakové', 'Executive-cases, briefcases, portfolios, school satchels and similar containers'),
('42021190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kufry,kufříky toaletní a pod.vnější povrch z usně přírodní,kompozitní,lakové', 'Trunks, suitcases, vanity cases and similar containers, with outer surface of le'),
('42021211', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kufry,kufříky toaletní apod.vnější povrch z fólie plastové', 'Executive-cases, briefcases, school satchels and similar containers, with outer'),
('42021219', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kufry,kufříky toaletní apod.vnější povrch z fólie plastové', 'Trunks, suitcases, vanity cases and similar containers of leather, with outer su'),
('42021250', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lodní,cestovní kufry,vč.kufříků pro toal.potř.,aktovky apod.z tvářených plastů', 'Trunks, suitcases, vanity cases, executive-cases, briefcases, school satchels an'),
('42021291', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Aktovky,školní brašny apod.vnější povrch z materiálů ostatních,ne:usně,plastu', 'Executive-cases, briefcases, school satchels and similar containers, with outer'),
('42021299', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kufry,kufříky toaletní apod.vnější povrch z materiálů ostatních,ne:useň,plast', 'Trunks, suitcases, vanity cases and similar cases, with outer surface of plastic'),
('42021910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kufry,brašny,aktovky a podobné schránky z hliníku', 'Trunks, suitcases, vanity cases, executive-cases, briefcases, school satchels an'),
('42021990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kufry,aktovky,brašny a podobné ostatní,ne:z usně,plastu,hliníku', 'Trunks, suitcases, vanity cases, executive-cases, briefcases, school satchels an'),
('42022100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kabelky i se závěsným řemenem vnější povrch z usně přírodní,kompozitní,lakové', 'Handbags, whether or not with shoulder straps, incl. those without handles, with'),
('42022210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kabelky i se závěsným řemenem vnější povrch z plastové fólie', 'Handbags, whether or not with shoulder straps, incl. those without handles, with'),
('42022290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kabelky i se závěsným řemenem vnější povrch z textilních materiálů', 'Handbags, whether or not with shoulder straps, incl. those without handles, with'),
('42022900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kabelky i se závěsným řemenem vnější povrch z ost.materiálů,ne:useň,plast,textil', 'Handbags, whether or not with shoulder strap, incl. those without handle, with o'),
('42023100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky nošené v kapse,kabelce vnější povrch u usně přírodní,kompozitní,lakové', 'Wallets, purses, key-pouches, cigarette-cases, tobacco-pouches and similar artic'),
('42023210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky nošené v kapse,kabelce vnější povrch z fólie plastové', 'Wallets, purses, key-pouches, cigarette-cases, tobacco-pouches and similar artic'),
('42023290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky nošené v kapse,kabelce vnější povrch z textilních materiálů', 'Wallets, purses, key-pouches, cigarette-cases, tobacco-pouches and similar artic'),
('42023900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky nošené v kapse,kabelce vnější povrch z materiálů ost.,ne:viz sazebník', 'Wallets, purses, key-cases, cigarette-cases, tobacco-pouches and similar article'),
('42029110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tašky cestovní,sportovní,ruksaky apod.vnější povrch z usně přír.,kompoz.,lakované', 'Travelling-bags, toilet bags, rucksacks and sports bags with outer surface of le'),
('42029180', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pouzdra na přístroje,hudební nástroje,zbraně apod.vnější povrch z usně', 'Insulated food or beverage bags, shopping bags, map-cases, tool bags, jewellery'),
('42029211', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tašky cestovní,sportovní,ruksaky apod.vnější povrch z fólie plastové', 'Travelling-bags, toilet bags, rucksacks and sports bags, with outer surface of p'),
('42029215', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pouzdra na hudební nástroje vnější povrch z plastové folie', 'Musical instrument cases with outer surface of plastic sheeting'),
('42029219', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pouzdra na přístroje,zbraně apod.vnější povrch z plast.folie,ne:na hudeb.nástroje', 'Insulated food or beverage bags, shopping bags, map-cases, tool bags, jewellery'),
('42029291', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pouzdra na přístroje,zbraně a pod.vnější povrch z textilních materiálů', 'Travelling-bags, toilet bags, rucksacks and sports bags, with outer surface of t'),
('42029298', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pouzdra na přístroje,zbraně a pod.vnější povrch z textilních materiálů', 'Insulated food or beverage bags, shopping bags, map-cases, tool bags, jewellery'),
('42029900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pouzdra,schrány,pytle,tašky apod.vnější povrch z mater.ostatních,ne:viz sazebník', 'Travelling-bags, shopping or tool bags, jewellery boxes, cutlery cases and simil'),
('42031000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy z usně přírodní,kompozitní', 'Articles of apparel, of leather or composition leather (excl. clothing accessori'),
('42032100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Rukavice i bez prstů,palčáky specielně pro sport z usně přírodní,kompozitní', 'Specially designed gloves for use in sport, of leather or composition leather'),
('42032910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Rukavice ochranné pro všechny profese z usně přírodní,kompozitní', 'Protective gloves of leather or composition leather, for all trades'),
('42032991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Rukavice pánské,chlapecké z usně přírodní,kompozitní', 'Men''s and boys'' gloves, mittens and mitts, of leather or composition leather ('),
('42032999', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Rukavice dámské,dívčí z usně přírodní,kompozitní', 'Gloves, mittens and mitts, of leather or composition leather (excl. men''s and b'),
('42033000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pásy,opasky,řemeny závěsné z usně přírodní,kompozitní', 'Belts and bandoliers, of leather or composition leather'),
('42034000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Doplňky oděvní ost.z usně přírodní,kompozitní,ne:rukavice,pásky,řemeny závěsné', 'Clothing accessories of leather or composition leather (excl. gloves, mittens an'),
('42050011', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pásy dopravníkové,transmisní z usně přírodní,kompozitní', 'Conveyor or transmission belts or belting, of leather or composition leather'),
('42050019', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Potřeby technické ost.z usně přírodní,kompozitní,ne:pásy dopravníkové,transmisní', 'Articles for technical use, of leather or composition leather (excl. conveyor or'),
('42050090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ostatní z usně přírodní,kompozitní,ne:viz sazebník', 'Articles of leather or composition leather (excl. saddlery and harness bags; cas'),
('42060000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ze střev,blány zlatotepecké,měchýřů,šlach', 'Articles of gut, goldbeater''s skin, bladders or tendons (excl. silkworm gut, st'),
('43011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kožešiny norkové surové celé i bez hlav,nožek,ohonů', 'Raw furskins of mink, whole, with or without heads, tails or paws'),
('43013000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kožešiny jehněčí (astrachán,karakul,perzián apod.) surové celé i bez hlav,nožek,ohonů', 'Raw furskins of the following types of lamb: Astrakhan, Caracul, Persian, Broadt'),
('43016000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kožešiny liščí surové celé i bez hlav,nožek,ohonů', 'Raw furskins of fox, with or without heads, tails or paws'),
('43018030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kožešiny ze sviště surové celé i bez hlav,nožek,ohonu', 'Raw furskins of marmots, whole, with or without heads, tails or paws'),
('43018050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kožešiny z koček divokých surové celé i bez hlav,nožek,ohonu', 'Raw furskins of wild felines, with or without heads, tails or paws'),
('43018070', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kožešiny surové ostatní,celé,též bez hlav,nožek,ohonů', 'Raw furskins, whole, with or without heads, tails or paws (excl. those of mink,'),
('43019000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hlavy,ohony,nožky a jiné části použitelné v kožešnictví', 'Heads, tails, paws and other pieces or cuttings of furskins suitable for use in'),
('43021100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kožešiny norkové celé vyčiněné upravené nesešité', 'Tanned or dressed furskins of mink, whole, with or without heads, tails or paws,'),
('43021910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kožešiny bobří celé vyčiněné upravené nesešité', 'Tanned or dressed furskins of beaver, whole, with or without heads, tails or paw'),
('43021920', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kožešiny z ondatry pižmové celé vyčiněné upravené nesešité', 'Tanned or dressed furskins of muskrat, whole, with or without heads, tails or pa'),
('43021930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kožešiny liščí celé vyčiněné upravené nesešité', 'Tanned or dressed furskins of fox, whole, with or without heads, tails or paws,'),
('43021935', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kožešiny z králíka,zajíce celé vyčiněné upravené nesešité', 'Tanned or dressed furskins of rabbit or hare, whole, with or without heads, tail'),
('43021941', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kožešiny z mláďat tuleně grónského,kroužkovaného,celé,vyčiněné,upravené,nesešité', 'Tanned or dressed furskins of whitecoat pups of harp seal or blueback pups of ho'),
('43021949', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kožešiny tulení ost.celé vyčiněné,upravené,nesešité,ne:z mláďat tuleně gronského,kroužkovaného', 'Tanned or dressed furskins of seal, whole, with or without heads, tails or paws,'),
('43021950', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kožešiny z kalana (vydra mořská),nutrie celé vyčiněné upravené nesešité', 'Tanned or dressed furskins of sea otters or nutria "coypu", whole, with or witho'),
('43021960', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kožešiny ze svišťě celé vyčiněné upravené nesešité', 'Tanned or dressed furskins of marmots, whole, with or without heads, tails or pa'),
('43021970', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kožešiny z koček divokých celé vyčiněné upravené nesešité', 'Tanned or dressed furskins of wild felines, whole, with or without heads, tails'),
('43021975', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kožešiny jehněčí (astrachán,persián apod.),celé,vyčiněné,upravené,nesešité', 'Tanned or dressed furskins of Astrakhan, Caracul, Persian, Broadtail or similar'),
('43021980', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kožešiny ovčí,jehněčí ost.,celé,vyčiněné,nesešité,ne:viz sazebník', 'Tanned or dressed furskins of sheep or lambs, whole, with or without heads, tail'),
('43021995', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kožešiny ostatní celé vyčiněné nesešité,ne:viz sazebník', 'Furskins, tanned or dressed, whole, with or without heads, tails or paws, not as'),
('43022000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hlavy,ohony,nožky a jiné části,odpad,odřezky vyčiněné nesešité', 'Heads, tails, paws and other pieces or cuttings of tanned or dressed furskins, n'),
('43023010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kožešiny vypouštěné', 'Tanned and dressed ''dropped'' furskins'),
('43023021', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kožešiny norkové celé,části,odřezky vyčiněné spojené', 'Tanned or dressed whole furskins of mink, and pieces or cuttings thereof, assemb'),
('43023025', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kožešiny králičí,zaječí celé,části,odřezky vyčiněné spojené', 'Tanned or dressed whole furskins of rabbit or hare, and pieces or cuttings there'),
('43023031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kožešiny bobří celé,části,odřezky vyčiněné spojené', 'Tanned or dressed whole furskins of Astrakhan, Caracul, Persian, Broadtail or si'),
('43023041', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kožešiny z ondatry pižmové celé,části,odřezky vyčiněné spojené', 'Tanned or dressed whole furskins of muskrat, and pieces or cuttings thereof, ass'),
('43023045', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kožešiny liščí celé,části,odřezky vyčiněné spojené', 'Tanned or dressed whole furskins of fox, and pieces or cuttings thereof, assembl'),
('43023051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kožešiny i části,odřezky,spojené z mláďat tuleně grónského,kroužkovaného', 'Tanned or dressed whole furskins of whitecoat pups of harp seal or blueback pups'),
('43023055', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kožešiny tulení ost.celé,části,odřezky vyčiněné spojené,ne:z mláďat tuleně grónského,kroužkovaného', 'Tanned or dressed whole furskins of seal, and pieces or cuttings thereof, assemb'),
('43023061', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kožešiny z kalana (mořské vydry),nutrie celé,části,odřezky vyčiněné spojené', 'Tanned or dressed whole furskins of sea otters or nutria "coypu", and pieces or'),
('43023071', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kožešiny z koček divokých celé,části,odřezky vyčiněné spojené', 'Tanned or dressed whole furskins of wild felines, and pieces or cuttings thereof'),
('43023095', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní celé vyčiněné kožešiny, jejich kousky nebo odřezky, sešité', 'Tanned or dressed furskins, whole, in pieces or cuttings, assembled, without the'),
('43031010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy,oděvní doplňky z mláďat tuleně grónského,kroužkovaného', 'Articles of apparel and clothing accessories made of the furskin of whitecoat pu'),
('43031090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy,doplňky oděvní z kožešin ostatních,ne:z mláďat tuleně grónského,kroužkovaného', 'Articles of apparel and clothing accessories made of furskin (excl. those of whi'),
('43039000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ostatní z kožešin,ne:oděvy,oděvní doplňky', 'Articles of furskin (excl. articles of apparel, clothing accessories and goods o'),
('43040000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kožešiny umělé,výrobky z kožešin umělých', 'Artificial fur and articles thereof (excl. gloves made of leather and artificial'),
('44011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo palivové (polena,špalky,větve,otepi apod.)', 'Fuel wood, in logs, billets, twigs, faggots or similar forms'),
('44012100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stepky,trisky drevene jehlicnate', 'Coniferous wood in chips or particles (excl. those of a kind used principally fo'),
('44012200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Štěpky,třísky dřevěné ostatní,ne:jehličnaté', 'Wood in chips or particles (excl. those of a kind used principally for dying or'),
('44013020', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Piliny,dřevěné zbytky a dřevěný odpad aglomerované do pelet', 'Sawdust and wood waste and scrap, agglomerated in pellets'),
('44013040', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Piliny ze dřeva,též aglomerované do polen,briket a pod.tvarů,ne:v peletách', 'Sawdust of wood, whether or not agglomerated in logs, briquettes or similar form'),
('44013080', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevěné zbytky a dřevěný odpad,též aglomerované do polen,briket a pod.tvarů,ne:v peletách,piliny', 'Wood waste and scrap, whether or not agglomerated in logs, briquettes or similar'),
('44021000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uhlí dřevěné z bambusu,i aglomerované', 'Bamboo charcoal, incl. shell or nut charcoal, whether or not agglomerated (excl.'),
('44029000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uhlí dřevěné ost.(vč.ze skořápek,ořechů),i aglomerované,ne:z bambusu', 'Wood charcoal, incl. shell or nut charcoal, whether or not agglomerated (excl. b'),
('44031000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo surové i odkorněné natírané nebo mořené kreozotem a pod.ochr.prostředky', 'Wood in the rough, treated with paint, stains, creosote or other preservatives ('),
('44032011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Pilařská kulatina surová ze dřeva smrku,jedle bělokoré (Abies alba Mill.)', 'Sawlogs of spruce of the species "Picea abies Karst." or silver fir "Abies alba'),
('44032019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Surové dřevo ze smrku Picea abies Karst,z jedle Abies alba Mill.,nekonzerv. ost.', 'Spruce of the species "Picea abies Karst." or silver fir "Abies alba Mill.", in'),
('44032031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Pilařská kulatina surová ze dřeva borovice druhu "Pinus sylvestris L."', 'Sawlogs of pine of the species "Pinus sylvestris L.", whether or not stripped of'),
('44032039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Surové dřevo borové druhu Pinus sylvestris L., nekonzervované, ostatní', 'Pine of the species "Pinus sylvestris L." in the rough, whether or not stripped'),
('44032091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Pilařská kulatina surová ze dřeva jehličnatého ostatního,ne:viz sazebník', 'Sawlogs of coniferous wood, whether or not stripped of bark or sapwood, or rough'),
('44032099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Surové dřevo z ostatních jehličnanů, nekonzervované, ostatní', 'Coniferous wood in the rough, whether or not stripped of bark or sapwood, or rou'),
('44034100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo tropické (viz pozn.1) surové meranti tmavo-,světločervené,bakau i odkorněné', 'Dark red meranti, light red meranti and meranti bakau wood in the rough, whether'),
('44034910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo tropické surové africký mahagon,iroko,sapelli,i odkorněné', 'Sapelli, acajou d''Afrique and iroko in the rough, whether or not stripped of ba'),
('44034935', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo tropické surové okoumé,sipo,i odkorněné', 'OkoumĂ© and sipo in the rough, whether or not stripped of bark or sapwood, or ro'),
('44034995', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo surové z druhů tropického dřeva ostatní;ne:viz sazebník', 'Abura, afrormosia, ako, alan, andiroba, aningrĂ©, avodirĂ©, azobĂ©, balau, balsa'),
('44039110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Pilařská kulatina surová ze dřeva dubu (Quercus spp.)', 'Sawlogs of oak "Quercus spp.", whether or not stripped of bark or sapwood, or ro'),
('44039190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Surové dřevo dubové (Quercus spp.), nekonzervované, ostatní', 'Oak "Quercus spp." in the rough, whether or not stripped of bark or sapwood, or'),
('44039210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Pilařská kulatina surová ze dřeva buku (Fagus spp.)', 'Sawlogs of beech "Fagus spp.", whether or not stripped of bark or sapwood, or ro'),
('44039290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Surové dřevo bukové (Fagus spp.), nekonzervované, ostatní', 'Beech "Fagus spp." in the rough, whether or not stripped of bark or sapwood, or'),
('44039910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Drevo surove topolove i odkornene', 'Poplar in the rough, whether or not stripped of bark or sapwood, or roughly squa'),
('44039930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo surové i odkorněné eukalyptové', 'Eucalyptus wood in the rough, whether or not stripped of bark or sapwood, or rou'),
('44039951', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Pilařská kulatina surová ze dřeva břízy', 'Sawlogs of birch, whether or not stripped of bark or sapwood, or roughly squared'),
('44039959', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Surové dřevo březové, nekonzervované, ostatní', 'Birch, in the rough, whether or not stripped of bark or sapwood, or roughly squa'),
('44039995', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Surové dřevo z ostatních stromů, nekonzervované, ne: viz sazebník', 'Wood in the rough, whether or not stripped of bark or sapwood, or roughly square'),
('44041000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo jehličnaté na obruče,tyče,kůly,loubky,hole apod.hrubě opracované', 'Hoopwood; split poles; piles, pickets and stakes of wood, pointed but not sawn l'),
('44042000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo ostatní na obruče,tyče,kůly,loubky apod.hrubě opracované,:ne:jehličnaté', 'Hoopwood; split poles; piles, pickets and stakes of wood, pointed but not sawn l'),
('44050000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlna dřevěná,moučka dřevitá', 'Wood wool; wood flour "wood powder able to pass through a fine", 0,63 mm mesh, s'),
('44061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Pražce dřevěné železniční a podobné neimpregnované', 'Railway or tramway sleepers "cross-ties" of wood, not impregnated'),
('44069000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Pražce dřevěné železniční a podobné impregnované', 'Railway or tramway sleepers "cross-ties" of wood, impregnated'),
('44071015', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané jehličnaté,>6mm,brouš.,spoj.klín.ozuby', 'Coniferous wood sawn or chipped lengthwise, sliced or peeled, of a thickness of'),
('44071031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané smrk (Picea abies Karst),jedle bělokorá,>6mm,hoblované,ne:brouš.,spoj.klín.ozuby', 'Spruce of the species "Picea abies Karst." or silver fir "Abies alba Mill.", saw'),
('44071033', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané borovice (Pinus sylvestrisL.),>6mm,hoblované,ne:brouš.,spoj.klín.ozuby', 'Pine of the species "Pinus sylvestris L.", sawn or chipped lengthwise, sliced or'),
('44071038', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané jehličnaté (ne druhy viz sazebník),>6mm,hoblované,ne:brouš.,spoj.klín.ozuby', 'Coniferous wood sawn or chipped lengthwise, sliced or peeled, of a thickness of'),
('44071091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané smrk (Picea abies Karst),jedle bělokorá,>6mm,ost.,ne:viz sazebník', 'Spruce "Picea abies Karst." or silver fir "Abies alba Mill.", sawn or chipped le'),
('44071093', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané borovice (Pinus sylvestrisL.),>6mm,ost.,ne:viz sazebník', 'Pine of the species "Pinus silvestris L.", sawn or cut lengthwise, sliced or pee'),
('44071098', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané jehličnaté (ne druhy viz sazebník),>6mm,ost.,ne:viz sazebník', 'Coniferous wood sawn or chipped lengthwise, sliced or peeled, of a thickness of'),
('44072110', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo řezané mahagon,>6mm,brouš.,spoj.klín.ozuby', 'Mahogany "Swietenia spp.", sawn or chipped lengthwise, sliced or peeled, of a th'),
('44072191', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané mahagon,>6mm,hoblované,ne:brouš.,spoj.klín.ozuby', 'Mahogany "Swietenia spp.", sawn or chipped lengthwise, sliced or peeled, of a th'),
('44072199', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané mahagon,>6mm,ost.,ne:viz sazebník', 'Mahogany "Swietenia spp.", sawn or chipped lengthwise, sliced or peeled, of a th'),
('44072210', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo řezané virola,imbuia,balsa,>6mm,brouš.,spoj.klín.ozuby', 'Virola, imbuia and balsa, sawn or chipped lengthwise, sliced or peeled, of a thi'),
('44072291', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané virola,imbuia,balsa,>6mm,hoblované,ne:brouš.,spoj.klín.ozuby', 'Virola, imbuia and balsa, sawn or chipped lengthwise, sliced or peeled, of a thi'),
('44072299', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané virola,imbuia,balsa,>6mm,ost.,ne:viz sazebník', 'Virola, imbuia and balsa, sawn or chipped lengthwise, sliced or peeled, of a thi'),
('44072510', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo řezané meranti (druhy viz saz.),>6mm,spoj.klín.ozuby,i hobl.,brouš.', 'Dark red meranti, light red meranti and meranti bakau, sawn or chipped lengthwis'),
('44072530', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané meranti (druhy viz saz.),>6mm,hoblované,ne:spoj.klín.ozuby', 'Dark red meranti, light red meranti and meranti bakau, sawn or chipped lengthwis'),
('44072550', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo řezané meranti (druhy viz saz.),>6mm,brouš.,ne:spoj.klín.ozuby', 'Dark red meranti, light red meranti and meranti bakau, sawn or chipped lengthwis'),
('44072590', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané meranti (druhy viz saz.),>6mm,ost.,ne:viz sazebník', 'Dark red meranti, light red meranti and meranti bakau, sawn or chipped lengthwis'),
('44072610', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo řezané bílý lauan,meranti,seraya,žluté meranti,alan,>6mm,spoj.klín.ozuby,i hobl.,brouš.', 'White lauan, white meranti, white seraya, yellow meranti and alan, sawn or chipp'),
('44072630', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané bílý lauan,meranti,seraya,žluté meranti,alan,>6mm,hoblované,ne:spoj.klín.ozuby', 'White lauan, white meranti, white seraya, yellow meranti and alan, sawn or chipp'),
('44072650', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo řezané bílý lauan,meranti,seraya,žluté meranti,alan,>6mm,brouš.,ne:spoj.klín.ozuby', 'White lauan, white meranti, white seraya, yellow meranti and alan, sawn or chipp'),
('44072690', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané bílý lauan,meranti,seraya,žluté meranti,alan,>6mm,ost.,ne:viz sazebník', 'White lauan, white meranti, white seraya, yellow meranti and alan, sawn or chipp'),
('44072710', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo řezané sapelli,>6mm,brouš.,spoj.klín.ozuby', 'Sapelli, sawn or chipped lengthwise, sliced or peeled, of a thickness of > 6 mm,'),
('44072791', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané sapelli,>6mm,hoblované,ne:brouš.,spoj.klín.ozuby', 'Sapelli, sawn or chipped lengthwise, sliced or peeled, of a thickness of > 6 mm,'),
('44072799', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané sapelli,>6mm,ost.,ne:viz sazebník', 'Sapelli, sawn or chipped lengthwise, sliced or peeled, of a thickness of > 6 mm'),
('44072810', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo řezané iroko,>6mm,brouš.,spoj.klín.ozuby', 'Iroko, sawn or chipped lengthwise, sliced or peeled, of a thickness of > 6 mm, s'),
('44072891', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané iroko,>6mm,hoblované,ne:brouš.,spoj.klín.ozuby', 'Iroko, sawn or chipped lengthwise, sliced or peeled, of a thickness of > 6 mm, p'),
('44072899', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané iroko,>6mm,ost.,ne:viz sazebník', 'Iroko, sawn or chipped lengthwise, sliced or peeled, of a thickness of > 6 mm (e'),
('44072915', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo řezané tropické ost.,>6mm,brouš.,spoj.klín.ozuby', 'Keruing, ramin, kapur, teak, jongkong, merbau, jelutong, kempas, okoumĂ©, obeche'),
('44072920', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané palisandr (de Rio,de para,de rose),>6mm,hoblované,ne:spoj.klín.ozuby', 'Palissandre de Rio, palissandre de Para and palissandre de rose, sawn or chipped'),
('44072925', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané tropické druhy viz saz.,>6mm,hoblované,ne:spoj.klín.ozuby', 'Keruing, ramin, kapur, teak, jongkong, merbau, jelutong, kempas, okoumĂ©, obeche'),
('44072945', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo řezané tropické,druhy viz saz.,>6mm,brouš.,ne:spoj.klín.ozuby', 'Keruing, ramin, kapur, teak, jongkong, merbau, jelutong, kempas, okoumĂ©, obeche'),
('44072961', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané azobé,>6mm,ost.,ne:viz sazebník', 'AzobĂ©, sawn or chipped lengthwise, sliced or peeled, of a thickness of > 6 mm ('),
('44072968', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané tropické,druhy viz saz.,>6mm,ost.,ne:viz sazebník', 'Keruing, ramin, kapur, teak, jongkong, merbau, jelutong, kempas, okoumĂ©, obeche'),
('44072983', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané tropické ost.,>6mm,hoblované,ne:spoj.klín.ozuby,druhy viz sazebník', 'Abura, afrormosia, ako, andiroba, aningrĂ©, avodirĂ©, balau, bossĂ© clair, bossĂ'),
('44072985', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo řezané tropické ost.,>6mm,brouš.,ne:spoj.klín.ozuby, druhy viz sazebník', 'Abura, afrormosia, ako, andiroba, aningrĂ©, avodirĂ©, balau, bossĂ© clair, bossĂ'),
('44072995', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané tropické ost.,>6mm,ost.,ne:viz sazebník', 'Abura, afrormosia, ako, andiroba, aningrĂ©, avodirĂ©, balau, bossĂ© clair, bossĂ'),
('44079115', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo řezané dub,>6mm,brouš.,spoj.klín.ozuby', 'Oak "Quercus spp.", sawn or chipped lengthwise, sliced or peeled, of a thickness'),
('44079131', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Dřevo řezané dub,>6mm,parket.přířezy,hranoly,latě,vlysy apod.,hoblované', 'Blocks, strips and friezes of oak "Quercus spp." for parquet or wood block floor'),
('44079139', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané dub,>6mm,hoblované ost.,ne:parket.přířezy,latě,vlysy apod.,spoj.klín.ozuby', 'Oak "Quercus spp.", sawn or chipped lengthwise, sliced or peeled, of a thickness'),
('44079190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané dub,>6mm,ost.,ne:viz sazebník', 'Oak "Quercus spp.", sawn or chipped lengthwise, sliced or peeled, of a thickness'),
('44079200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané buk,>6mm (brouš.,spoj.klín.ozuby,hoblované)', 'Beech "Fagus spp.", sawn or chipped lengthwise, sliced or peeled, whether or not'),
('44079310', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo řezané javor,>6mm,brouš.,spoj.klín.ozuby', 'Maple "Acer spp.", sawn or chipped lengthwise, sliced or peeled, of a thickness'),
('44079391', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo řezané javor,>6mm,hoblované,ne:brouš.,spoj.klín.ozuby', 'Maple "Acer spp.", sawn or chipped lengthwise, sliced or peeled, of a thickness'),
('44079399', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo řezané javor,>6mm,ost.,ne:viz sazebník', 'Maple "Acer spp.", sawn or chipped lengthwise, sliced or peeled, of a thickness'),
('44079410', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo řezané třešeň,>6mm,brouš.,spoj.klín.ozuby', 'Cherry "Prunus spp.", sawn or chipped lengthwise, sliced or peeled, of a thickne'),
('44079491', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo řezané třešeň,>6mm,hoblované,ne:brouš.,spoj.klín.ozuby', 'Cherry "Prunus spp.", sawn or chipped lengthwise, sliced or peeled, of a thickne'),
('44079499', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo řezané třešeň,>6mm,ost.,ne:viz sazebník', 'Cherry "Prunus spp.", sawn or chipped lengthwise, sliced or peeled, of a thickne'),
('44079510', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo řezané jasan,>6mm,brouš.,spoj.klín.ozuby', 'Ash "Fraxinus spp.", sawn or chipped lengthwise, sliced or peeled, of a thicknes'),
('44079591', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo řezané jasan,>6mm,hoblované,ne:brouš.,spoj.klín.ozuby', 'Ash "Fraxinus spp.", sawn or chipped lengthwise, sliced or peeled, of a thicknes'),
('44079599', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo řezané jasan,>6mm,ost.,ne:viz sazebník', 'Ash "Fraxinus spp.", sawn or chipped lengthwise, sliced or peeled, of a thicknes'),
('44079920', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo řezané ost.,>6mm,brouš.,spoj.klín.ozuby,ne:jehličnaté,tropické', 'Wood sawn or cut lengthwise, sliced or peeled, end-jointed, of a thickness of >'),
('44079925', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané ost.,>6mm,hoblované,ne:brouš.,spoj.klín.ozuby,jehličnaté,tropické', 'Wood sawn or cut lengthwise, sliced or peeled, planed, of a thickness of > 6 mm'),
('44079940', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo řezané ost.,>6mm,brouš.,ne:hoblované,spoj.klín.ozuby,jehličnaté,tropické', 'Wood sawn or cut lengthwise, sliced or peeled, sanded, of a thickness of > 6 mm'),
('44079991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané topol,>6mm,ost.,ne:brouš.,spoj.klín.ozuby,hoblované', 'Poplar, sawn or chipped lengthwise, sliced or peeled, of a thickness of > 6 mm ('),
('44079996', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané tropické,>6mm,ne:viz sazebník', 'Tropical wood, sawn or chipped lengthwise, sliced or peeled, of a thickness of >'),
('44079998', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané ost.,>6mm,ne:viz sazebník', 'Wood, sawn or chipped lengthwise, sliced or peeled, of a thickness of > 6 mm (ex'),
('44081015', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo jehl.řezané,do 6mm brouš.,spoj.klínovými ozuby,i hoblované', 'Sheets for veneering, incl. those obtained by slicing laminated wood, for conife'),
('44081091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tužkárenská prkénka z jehličnanů,tl.do 6mm', 'Small boards for the manufacture of pencils, of coniferous wood, of a thickness'),
('44081093', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo jehličnaté podélně řezané,krájené,loupané,tl.do 1mm', 'Sheets for veneering, incl. those obtained by slicing laminated wood, for conife'),
('44081099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo jehličnaté podélně řezané,krájené,loupané,tl.nad 1-6mm', 'Sheets for veneering, incl. those obtained by slicing laminated wood, for conife'),
('44083111', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dýhy apod.z tmavo-světle červené meranti,bakau,spoj.klín.ozuby,tl.do 6mm', 'Sheets for veneering, incl. those obtained by slicing laminated wood, for plywoo'),
('44083121', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Desky,dýhy,listy z tmavo-světle červeného meranti,bakau,hoblované,tl.do 6mm', 'Sheets for veneering, incl. those obtained by slicing laminated wood, for plywoo'),
('44083125', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,dýhy,listy z tmavo-světle červeného meranti,bakau,brouš.pískem,tl.do 6mm', 'Sheets for veneering, incl. those obtained by slicing laminated wood, for plywoo'),
('44083130', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dýhy,listy z tmavo-světle červen.meranti,bakau,rozřez.,kráj.,loup.,tl.do 6mm', 'Sheets for veneering, incl. those obtained by slicing laminated wood, for plywoo'),
('44083915', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo tropické(druhy viz saz.)řezané,do 6mm brouš.,spoj.klín.ozuby', 'Sheets for veneering, incl. those obtained by slicing laminated wood, for plywoo'),
('44083921', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dýhy apod.z tropického dřeva (viz sazeb.) hoblované,tl.do 6mm', 'Sheets for veneering, incl. those obtained by slicing laminated wood, for plywoo'),
('44083931', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dýhy apod.z tropic.dřeva(viz sazeb.),podél.rozřezané,krájené,loup.,tl.do 1mm', 'Sheets for veneering, incl. those obtained by slicing laminated wood, for plywoo'),
('44083935', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dýhy apod.z tropic.dřeva(viz sazeb.),podél.rozřezané,kráj.,loup.,tl.nad 1-6mm', 'Sheets for veneering, incl. those obtained by slicing laminated wood, for plywoo'),
('44083955', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo tropické(druhy viz saz.)řezané,do 6mm brouš.,spoj.klín.ozuby', 'Sheets for veneering, incl. those obtained by slicing laminated wood, for plywoo'),
('44083970', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tužkárenská prkénka z ostatního dřeva tropického,tl.do 6mm,ne:viz sazebník', 'Small boards for the manufacture of pencils, of a thickness of <= 6 mm, of abura'),
('44083985', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané tropické ostatní, tloušťka do 1mm,ne:viz sazebník', 'Sheets for veneering, incl. those obtained by slicing laminated wood, for plywoo'),
('44083995', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané tropické ostatní, tloušťka 1-6mm,ne:viz sazebník', 'Sheets for veneering, incl. those obtained by slicing laminated wood, for plywoo'),
('44089015', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo řez.,tl.do 6mm,brouš.,hoblov.,spoj.klín.ozuby ost.;ne:viz saz', 'Sheets for veneering, incl. those obtained by slicing laminated wood, for plywoo'),
('44089035', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tužkárenská prkénka z dřeva ostatního,tl.do 6mm,ne:viz sazebník', 'Small boards for the manufacture of pencils, of wood, of a thickness of <= 6 mm'),
('44089085', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané ostatní, tloušťka do 1mm,ne:viz sazebník', 'Sheets for veneering, incl. those obtained by slicing laminated wood, for plywoo'),
('44089095', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo řezané ostatní, tloušťka nad 1-6mm,ne:viz sazebník', 'Sheets for veneering, incl. those obtained by slicing laminated wood, for plywoo'),
('44091011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTR'), 'Lišty z dřeva jehličnanů tvarované pro rámy obrazů,fotografií,zrcadel apod.', 'Mouldings for frames for paintings, photographs, mirrors or similar objects, of'),
('44091018', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo profilované jehličnaté ostatní;ne:viz sazebník', 'Coniferous wood, incl. strips and friezes for parquet flooring, not assembled, c'),
('44092100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo profilované z bambusu', 'Bamboo, incl. strips and friezes for parquet flooring, not assembled, continuous'),
('44092910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTR'), 'Lišty ze dřeva ost.,tvarované pro rámy obrazů,zrcadel apod.,ne:jehličny,bambus', 'Mouldings for frames for paintings, photographs, mirrors or similar objects, of'),
('44092991', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Parketové přířezy,vlysy,kostkové podlahy dřevěné,ne:jehličnany,babus', 'Blocks, strips and friezes for parquet flooring, not assembled,  continuously sh'),
('44092999', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo profilované ostatní;ne:viz sazebník', 'Wood, continuously shaped "tongued, grooved, rebated, chamfered, V-jointed beade'),
('44101110', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Deska třísková dřev.,i broušená pískem,jinak neopracovaná,ne:s orient.třískami', 'Particle board of wood, whether or not agglomerated with resins or other organic'),
('44101130', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Deska třísková dřev.,potaž.papírem impregn.melaminovou pryskyřicí,ne:s orient.třískami,neoprac.,brouš.pískem', 'Particle board of wood, whether or not agglomerated with resins or other organic'),
('44101150', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Deska třísková dřev.,potaž.dekorativním laminátem z plastů,ne:s orient.třískami,neoprac.,brouš.pískem', 'Particle board of wood, whether or not agglomerated with resins or other organic'),
('44101190', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Deska třísková dřev.ostatní,ne:viz sazebník', 'Particle board of wood, whether or not agglomerated with resins or other organic'),
('44101210', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Deska dřev.s orient.třískami (OSB),i broušená pískem,jinak neopracovaná', 'Oriented strand "OSB", of wood, unworked or not further worked than sanded'),
('44101290', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Deska dřev.s orient.třískami (OSB) ost.,ne:neopracovaná jinak než brouš.pískem', 'Oriented strand board "OSB" of wood (excl. unworked or not further worked than s'),
('44101900', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Deska dřevěná ostatní,i aglomerovaná,ne:viz sazebník', 'Waferboard and similar board, of wood, whether or not agglomerated with resins o'),
('44109000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Desky z jiných dřevitých materiálů,ne:dřevěné,dřevotřískové,dřevovláknité', 'Board of bagasse, bamboo or cereal straw particles or other ligneous materials,'),
('44111210', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Deska dřevovlák.polotvrdá (MDF),<=5mm,mechan.neoprac.,nepotažená', 'Medium density fibreboard "MDF" of wood, of a thickness <=Â 5Â mm, not mechanica'),
('44111290', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Deska dřevovlák.polotvrdá (MDF),<=5mm,ost.,ne:mechan.neoprac.,nepotažená', 'Medium density fibreboard "MDF" of wood, of a thickness <=Â 5Â mm, mechanically'),
('44111310', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Deska dřevovlák.polotvrdá (MDF),>5mm,<=9mm,mechan.neoprac.,nepotažená', 'Medium density fibreboard "MDF" of wood, of a thickness >Â 5Â mm but <=Â 9Â mm,'),
('44111390', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Deska dřevovlák.polotvrdá (MDF),>5mm,<=9mm,ost.,ne:mechan.neoprac.,nepotažená', 'Medium density fibreboard "MDF" of wood, of a thickness >Â 5Â mm but <=Â 9Â mm,'),
('44111410', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Deska dřevovlák.polotvrdá (MDF),>9mm,mechan.neoprac.,nepotažená', 'Medium density fibreboard "MDF" of wood, of a thickness >Â 9Â mm, not mechanical'),
('44111490', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Deska dřevovlák.polotvrdá (MDF),>9mm,ost.,ne:mechan.neoprac.,nepotažená', 'Medium density fibreboard "MDF" of wood, of a thickness >Â 9Â mm, mechanically w'),
('44119210', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Deska dřevovlák.ost.,hust.>0,8g/cm3,mechan.neoprac.,nepotažená,ne:MDF', 'Fibreboard of wood or other ligneous materials, whether or not agglomerated with'),
('44119290', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Deska dřevovlák.ost.,hust.>0,8g/cm3,ne:mechan.neoprac.,nepotažená,MDF', 'Fibreboard of wood or other ligneous materials, whether or not agglomerated with'),
('44119310', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Deska dřevovlák.ost.,hust.>0,5g/cm3,<=0,8g/cm3,mechan.neoprac.,nepotažená,ne:MDF', 'Fibreboard of wood or other ligneous materials, whether or not agglomerated with'),
('44119390', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Deska dřevovlák.ost.,hust.>0,5g/cm3,<=0,8g/cm3,ne:mechan.neoprac.,nepotažená,MDF', 'Fibreboard of wood or other ligneous materials, whether or not agglomerated with'),
('44119410', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Deska dřevovlák.ost.,hust.<=0,5g/cm3,mechan.neoprac.,nepotažená,ne:MDF', 'Fibreboard of wood or other ligneous materials, whether or not agglomerated with'),
('44119490', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Deska dřevovlák.ost.,hust.<=0,5g/cm3,ne:mechan.neoprac.,nepotažená,MDF', 'Fibreboard of wood or other ligneous materials, whether or not agglomerated with'),
('44121000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Překližky,desky dýhované apod.z bambusu', 'Plywood, veneered panel and similar laminated wood, of bamboo, not containing pa'),
('44123110', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Překližky,desky dýhov.,min.1 vnější vrstva z trop.dřeva,druhy viz sazebník', 'Plywood consisting solely of sheets of wood <= 6 mm thick, with at least one out'),
('44123190', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Překližky,desky dýhov.,min.1 vnější vrstva z trop.dřeva,ne:druhy viz sazebník', 'Plywood consisting solely of sheets of wood <= 6 mm thick, with at least one out'),
('44123210', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Překližky,desky dýhov.,min.1 vnější vrstva z list.dřeva,druhy viz sazebník,ne:tropické dřevo', 'Plywood consisting solely of sheets of wood <= 6 mm thick, with at least one out'),
('44123290', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Překližky,desky dýhov.,min.1 vnější vrstva z list.dřeva,ne:druhy viz sazebník,ne:tropické dřevo', 'Plywood consisting solely of sheets of wood <= 6 mm thick, with at least one out'),
('44123900', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Překližky,desky dýhov.,obě vnější vrstvy z jehlič.dřeva', 'Plywood consisting solely of sheets of wood <= 6 mm thick (excl. of bamboo, plyw'),
('44129410', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Laťovky (i podlahové),desky vrstvené,min.1 vnější vrstva jiná než z jehlič.dřeva', 'Laminated wood with at least one outer ply of non-coniferous wood, and containin'),
('44129490', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Laťovky (i podlahové),desky vrstvené,obě vnější vrstvy z jehlič.dřeva', 'Laminated wood as blockboard, laminboard or battenboard (excl. of bamboo, such w'),
('44129930', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo vrstvené ostatní,min.1 vnější vrstva z desky třískové', 'Veneered panels and similar laminated wood with at least one layer of particle b'),
('44129940', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo vrstvené ostatní,min.1 vnější vrstva z list.dřeva,druhy viz sazebník', 'Veneered panels and similar laminated wood with at least one outer ply of alder,'),
('44129950', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo vrstvené ostatní,min.1 vnější vrstva z list.dřeva,ne:druhy viz sazebník', 'Veneered panels and similar laminated wood with at least one outer ply of non-co'),
('44129985', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo vrstvené ostatní,ne:viz sazebník', 'Veneered panels and similar laminated wood not containing layers of particle boa'),
('44130000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Dřevo tzv zhutněné ve tvaru špalků,prken,destiček,profilů', 'Metallised wood and other densified wood in blocks, plates, strips or profile sh'),
('44140010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rámy dřevěné na obrazy,zrcadla a podobně z tropického dřeva(viz pozn.2 kapit.)', 'Wooden frames for paintings, photographs, mirrors or similar objects, of tropica'),
('44140090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rámy dřevěné na obrazy,zrcadla a podobně z dřeva ostatního,ne:tropického', 'Wooden frames for paintings, photographs, mirrors or similar objects (excl. of t'),
('44151010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bedny,bedničky,klece,bubny a podobné obaly dřevěné,ne:bubny kabelové', 'Cases, boxes, crates, drums and similar packings, of wood'),
('44151090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bubny kabelové dřevěné', 'Cable drums of wood'),
('44152020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Ploché palety,nástavné rámy palet dřevěné', 'Pallets and pallet collars, of wood'),
('44152090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Palety skříňové a jiné nakládací plošiny dřevěné', 'Box pallets and other load boards, of wood (excl. containers specially designed'),
('44160000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sudy,kádě,škopky a pod.bednářské výrobky,jejich části ze dřeva vč.dužin', 'Casks, barrels, vats, tubs and other coopers'' products parts thereof, of wood,'),
('44170000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevěné nástroje,násady,rukojeti,formy,kopyta,napínáky obuvi', 'Tools, tool bodies, tool handles, broom or brush bodies and handles, of wood; bo'),
('44181010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Okna,balkonové dveře,jejich rámy,zárubně ze dřeva tropického', 'Windows and French windows and their frames, of okoumĂ©, obeche, sapelli, sipo,'),
('44181050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Okna,balkonové dveře,jejich rámy,zárubně ze dřeva jehličnanů', 'Windows and French windows and their frames, of coniferous wood'),
('44181090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Okna,balkonové dveře,jejich rámy,zárubně ze dřeva ost.,ne:tropického,jehličnanů', 'Windows and French windows and their frames, of wood (excl. okoumĂ©, obeche, sap'),
('44182010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Dveře,jejich rámy,zárubně,prahy z tropického dřeva', 'Doors and their frames and thresholds, of okoumĂ©, obeche, sapelli, sipo, acajou'),
('44182050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Dveře,jejich rámy,zárubně,prahy ze dřeva jehličnanů', 'Doors and their frames and thresholds, of coniferous wood'),
('44182080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Dveře,jejich rámy,zárubně,prahy ze dřeva ostatního,ne:tropického,jehličnanů', 'Doors and their frames and thresholds, of wood (excl. okoumĂ©, obeche, sapelli,'),
('44184000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bednění pro betonování ze dřeva', 'Wooden shuttering for concrete constructional work (excl. plywood boarding)'),
('44185000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šindele', 'Shingles and shakes, of wood'),
('44186000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sloupy a trámy', 'Posts and beams, of wood'),
('44187100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Desky podlahové sestavené,pro mozaikové podlahy', 'Flooring panels for mosaic floors, assembled, of wood'),
('44187200', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Desky podlahové sestavené,ost.,vícevrstvé,ne:pro mozaikové podlahy', 'Flooring panels, multilayer, assembled, of wood (excl. for mosaic floors)'),
('44187900', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Desky podlahové sestavené,ost.,ne:pro mozaikové podlahy,vícevrstvé', 'Flooring panels, assembled, of wood (excl. multilayer panels and flooring panels'),
('44189010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dřevo stavebního truhlářství a tesařství ostatní provrstvené klihem,ne:viz sazebník', 'Builders'' joinery and carpentry, of glue-laminated timber (excl. windows and Fr'),
('44189080', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky stavebního truhlářství,tesařství ostatní ze dřeva,ne:viz sazebník', 'Builders'' joinery and carpentry, of wood, incl. cellular wood panels (excl. of'),
('44190010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Náčiní stolní,kuchyňské z tropického dřeva', 'Tableware and kitchenware, of okoumĂ©, obeche, sapelli, sipo, acajou d''Afrique,'),
('44190090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Náčiní stolní,kuchyňské ze dřeva ostatní,ne:dřeva tropického', 'Tableware and kitchenware, of wood (excl. okoumĂ©, obeche, sapelli, sipo, acajou'),
('44201011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sošky a jiné předměty ozdobné ze dřeva ostatního,ne:tropického', 'Statuettes and other ornaments, of okoumĂ©, obeche, sapelli, sipo, acajou d''Afr'),
('44201019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sošky a jiné předměty ozdobné ze dřeva ostatního,ne:tropického', 'Statuettes and other ornaments, of wood (excl. okoumĂ©, obeche, sapelli, sipo, a'),
('44209010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTQ'), 'Intarzované a inkrustované dřevo', 'Wood marquetry and inlaid wood (excl. statuettes and other ornaments, articles o'),
('44209091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skříňky,pouzdra,nábytek a podobně z tropického dřeva', 'Caskets and cases for jewellery or cutlery, and similar articles and articles of'),
('44209099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skříňky,pouzdra,nábytek a podobně ze dřeva ostatního,ne:tropického', 'Caskets and cases for jewellery or cutlery, and similar articles and articles of'),
('44211000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Ramínka na šaty ze dřeva', 'Clothes hangers of wood'),
('44219091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z dřevovláknitých desek ostatní;ne:viz sazebník', 'Articles of fibreboard, n.e.s.'),
('44219098', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ze dřeva ostatní;ne:viz sazebník', 'Articles of wood, n.e.s.'),
('45011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Korek přírodní,surový i jednoduše upravený', 'Natural cork, raw or simply prepared "merely surface-worked or otherwise cleaned'),
('45019000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad korkový,korek drcený,granulovaný,mletý', 'Cork waste; crushed, powdered or ground cork'),
('45020000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Korek přírodní odkorněný otesaný,v kostkách,deskách,listech,pásech', 'Natural cork, debacked or roughly squared, or in square or rectangular blocks, p'),
('45031010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zátky válcovité z přírodního korku', 'Corks and stoppers, cylindrical, of natural cork'),
('45031090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zátky ostatní z přírodního korku,ne:válcovité', 'Corks and stoppers of all types, incl. round-edged blanks (excl. cylindrical)'),
('45039000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ostatní z korku přírodního,ne:zátky', 'Articles of natural cork (excl. cork in square or rectangular blocks, plates, sh'),
('45041011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zátky pro šumivá vína válcovité z aglomerovaného korku,vč.s kotoučem z přír.korku', 'Corks and stoppers, cylindrical, for sparkling wine, of agglomerated cork, incl.'),
('45041019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zátky ostatní válcovité z aglomerovaného korku,ne:pro šumivá vína', 'Corks and stoppers, cylindrical, of agglomerated cork (excl. such products for s'),
('45041091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kostky,cihly,desky,dlaždice,válce apod.z aglomerovaného korku s pojidlem', 'Tiles of any shape, blocks, plates, sheets and strip, solid cylinders, incl. dis'),
('45041099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kostky,cihly,desky,dlaždice,válce apod.z aglomerovaného korku ostatní,ne:s pojidlem', 'Tiles of any shape, blocks, plates, sheets and strip, solid cylinders, incl. dis'),
('45049020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zátky ostatní z korku aglomerovaného,ne:válcovité', 'Corks and stoppers, of agglomerated cork (excl. cylindrical)'),
('45049080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Aglomerovaný korek,výrobky ostatní,ne:viz sazebník', 'Agglomerated cork, with or without a binding substance, and articles of agglomer'),
('46012110', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rohože,rohožky,košatiny,z bambusových pletenců', 'Mats, matting and screens, flat-woven or bound together in parallel, of plaits o'),
('46012190', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rohože,rohožky,košatiny,z bambusu ost.,ne:z pletenců', 'Mats, matting and screens, of bamboo plaiting materials, flat-woven or bound tog'),
('46012210', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rohože,rohožky,košatiny,z ratanových pletenců', 'Mats, matting and screens, flat-woven or bound together in parallel, of plaits o'),
('46012290', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rohože,rohožky,košatiny,z ratanu ost.,ne:z pletenců', 'Mats, matting and screens, of rattan plaiting materials, flat-woven or bound tog'),
('46012910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rohože,rohožky,košatiny,z rostl.mat.,z pletenců,ne:z bambusu,ratanu', 'Mats, matting and screens, of vegetable plaiting materials, flat-woven or bound'),
('46012990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rohože,rohožky,košatiny,z rostl.mat.,ost.,ne:z pletenců,z bambusu,ratanu', 'Mats, matting and screens, of vegetable plaiting materials, flat-woven or bound'),
('46019205', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pletence a podobné výr.z pletacích mat.,též spojené do pásů,z bambusu', 'Plaits and similar products of bamboo plaiting materials worked lengthwise, whet'),
('46019210', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ost.z pletenců apod.,z bambusu', 'Plaiting materials, plaits and similar products of bamboo plaiting materials, fl'),
('46019290', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ost.z pletacích materiálů,z bambusu,ne:viz sazebník', 'Plaiting materials, plaits and similar products of bamboo plaiting materials, fl'),
('46019305', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pletence a podobné výr.z pletacích mat.,též spojené do pásů,z ratanu', 'Plaits and similar products of rattan plaiting materials worked lengthwise, whet'),
('46019310', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ost.z pletenců apod.,z ratanu', 'Plaiting materials, plaits and similar products of rattan materials, flat-woven'),
('46019390', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ost.z pletacích materiálů,z ratanu,ne:viz sazebník', 'Plaiting materials, plaits and similar products of rattan plaiting materials, fl'),
('46019405', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pletence a podobné výr.z rost.pletacích mat.,též spojené do pásů,ne:bambus,ratan', 'Plaits and similar products of vegetable plaiting materials worked lengthwise, w'),
('46019410', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ost.z pletenců apod.,z rostl.mat.,ne:bambus,ratan', 'Plaiting materials, plaits and similar products of vegetable materials, flat-wov'),
('46019490', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ost.z rostl.pletacích materiálů,ne:bambus,ratan,viz sazebník', 'Plaiting materials, plaits and similar products of vegetable plaiting materials,'),
('46019905', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pletence z materiálů ostatních,ne:viz sazebník', 'Plaits and similar products of non-vegetable plaiting materials worked lengthwis'),
('46019910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky,úplety ostatní z materiálů ostatních,ne:viz sazebník', 'Plaiting materials, plaits and similar products of non-vegetable plaiting materi'),
('46019990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky,úplety ostatní z materiálů ostatních,ne:viz sazebník', 'Plaiting materials, plaits and similar products of non-vegetable materials, flat'),
('46021100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky košíkářské apod,z bambusu', 'Basketwork, wickerwork and other articles, made directly to shape from bamboo pl'),
('46021200', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky košíkářské apod,z ratanu', 'Basketwork, wickerwork and other articles, made directly to shape from rattan pl'),
('46021910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slaměné obaly na láhve', 'Bottle envelopes made directly from straw or from vegetable plaiting materials o'),
('46021991', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky košíkářské apod,z rostl.materiálů,vyr.přímo do koneč.tvaru,ne:bambus,ratan', 'Basketwork, wickerwork and other articles, made directly to shape from vegetable'),
('46021999', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky košíkářské apod,z rostl.materiálů ost.,ne:viz sazebník', 'Basketwork, wickerwork and other articles, made up from goods of vegetable mater'),
('46029000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky košíkářské ostatní,ne:z rostl.materiálů', 'Basketwork, wickerwork and other articles, made directly to shape from non-veget'),
('47010010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KSD'), 'Vláknina (dřevovina) termomechanická', 'Thermo-mechanical wood pulp, not chemically treated'),
('47010090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KSD'), 'Vláknina (dřevovina) ostatní,ne:termomechanická', 'Mechanical wood pulp, not chemically treated (excl. thermo-mechanical wood pulp)'),
('47020000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KSD'), 'Buničina dřevná pro chemické zpracování (viz pozn.1 ke kapitole)', 'Chemical wood pulp, dissolving grades'),
('47031100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KSD'), 'Buničina dřevná nátronová,sulfátová nebělená jehličnanová,ne:pro chem.zpracování', 'Unbleached coniferous chemical wood pulp, soda or sulphate (excl. dissolving gra'),
('47031900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KSD'), 'Buničina dřevná nátronová,sulfátová nebělená ost.,ne:jehličnanová,pro chem.zpracování', 'Unbleached non-coniferous chemical wood pulp, soda or sulphate (excl. dissolving'),
('47032100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KSD'), 'Buničina dřevná nátronová,sulfátová bělená,polobělená jehličnanová,ne:pro chem.zpracování', 'Semi-bleached or bleached coniferous chemical wood pulp, soda or sulphate (excl.'),
('47032900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KSD'), 'Buničina dřevná nátronová,sulfátová bělená,polobělená ostatní,ne:viz sazebník', 'Semi-bleached or bleached non-coniferous chemical wood pulp, soda or sulphate (e'),
('47041100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KSD'), 'Buničina dřevná sulfitová nebělená jehličnanová,ne:pro chem.zpracování', 'Unbleached coniferous chemical wood pulp, sulphite (excl. dissolving grades)'),
('47041900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KSD'), 'Buničina dřevná sulfitová nebělená ostatní,ne:jehličnanová,pro chem.zpracování', 'Unbleached non-coniferous chemical wood pulp, sulphite (excl. dissolving grades)'),
('47042100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KSD'), 'Buničina dřevná sulfitová bělená,polobělená jehličnanová,ne:pro chem.zpracování', 'Semi-bleached or bleached coniferous chemical wood pulp, sulphite (excl. dissolv'),
('47042900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KSD'), 'Buničina dřevná sulfitová bělená,polobělená ostatní,ne:jehličnanová,pro chem.zpracování', 'Semi-bleached or bleached non-coniferous chemical wood pulp, sulphite (excl. dis'),
('47050000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KSD'), 'Buničina dřevná polochemická', 'Wood pulp obtained by a combination of mechanical and chemical pulping processes'),
('47061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Buničina z lintru bavlněného', 'Pulp of cotton linters'),
('47062000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KSD'), 'Buničina z vláken získaných ze sběrového papíru, odpadu', 'Pulps of fibres derived from recovered "waste and scrap" paper or paperboard'),
('47063000', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'KSD'), 'Buničina z vláken bambusu', 'Pulps of fibrous cellulosic bamboo material'),
('47069100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KSD'), 'Buničina z ost.celulózových vláknovin,mechanická,ne:viz sazebník', 'Mechanical pulp of fibrous cellulosic material (excl. that of bamboo, wood, cott'),
('47069200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KSD'), 'Buničina z ost.celulózových vláknovin,chemická,ne:viz sazebník', 'Chemical pulp of fibrous cellulosic material (excl. that of bamboo, wood, cotton'),
('47069300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'KSD'), 'Buničina z ost.celulózových vláknovin,polochemická,ne:viz sazebník', 'Semi-chemical pulp of fibrous cellulosic material (excl. that of bamboo, wood, c'),
('47071000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sulfátový papír,kartón,lepenka,vlnitý papír-sběr,odpad nebělený', 'Recovered "waste and scrap" paper or paperboard of unbleached kraft paper, corru'),
('47072000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír,kartón,lepenka-sběr,odpad vyrobený hlavně z bělené buničiny,nebarvený', 'Recovered "waste and scrap" paper or paperboard made mainly of bleached chemical'),
('47073010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Staré noviny,časopisy,telefonní seznamy,letáky,brožury,reklamní materiál', 'Old and unsold newspapers and magazines, telephone directories, brochures and pr'),
('47073090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad papíru,výmět apod.ostatní z mechanické vlákniny,ne:viz sazebník', '"Waste and scrap" of paper or paperboard made mainly of mechanical pulp (excl. o'),
('47079010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,výmět ostatní,papír sběrový netříděný,ne:viz sazebník', 'Unsorted, recovered "waste and scrap" paper or paperboard (excl. paper wool)'),
('47079090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,výmět ostatní,papír sběrový tříděný,ne:viz sazebník', 'Sorted, recovered "waste and scrap" paper or paperboard (excl. waste and scrap o'),
('48010000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Novinový papír, v kotoučích nebo listech (arších)', 'Newsprint as specified in Note 4 to chapter 48, in rolls of a width > 36 cm or i'),
('48021000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ruční papír, kartón', 'Handmade paper and paperboard of any size or shape'),
('48022000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír, kartón, lepenka-podklad pro světlo-,teplo-,elektrocitlivý papír', 'Paper and paperboard of a kind used as a base for photosensitive, heat-sensitive'),
('48024010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír tapetový surový, do 10% vlákna získaná mechnicky', 'Wallpaper base, uncoated, not containing fibres obtained by a mechanical process'),
('48024090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír tapetový surový', 'Wallpaper base, uncoated, of which > 10% by weight of the total fibre content co'),
('48025400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.papír,kartón,lepenka,hmot.<40g/m2,obs.vláken získaných mech.0-10%', 'Uncoated paper and paperboard, of a kind used for writing, printing or other gra'),
('48025515', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír v kotoučích,hmotnost 40-60g/m2,obsah vláken získaných mech.0-10%', 'Uncoated paper and paperboard, of a kind used for writing, printing or other gra'),
('48025525', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír v kotoučích,hmotnost 60-75g/m2,obsah vláken získaných mech.0-10%', 'Uncoated paper and paperboard, of a kind used for writing, printing or other gra'),
('48025530', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír v kotoučích,hmotnost 75-80g/m2,obsah vláken získaných mech.0-10%', 'Uncoated paper and paperboard, of a kind used for writing, printing or other gra'),
('48025590', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír v kotoučích,hmotnost 80-150g/m2,obs.vláken získaných mech.0-10%', 'Uncoated paper and paperboard, of a kind used for writing, printing or other gra'),
('48025620', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír v listech (arších),hmotnost 40-150g/m2,formát A4 (297x210mm)', 'Uncoated paper and paperboard, of a kind used for writing, printing or other gra'),
('48025680', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír v listech (arších) ost.,hmotnost 40-150g/m2,formát <(435x297mm),ne:A4', 'Uncoated paper and paperboard, of a kind used for writing, printing or other gra'),
('48025700', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.papír,kartón,lepenka,hmot.40-150g/m2,obs.vláken získan. mech.0-10%', 'Uncoated paper and paperboard, of a kind used for writing, printing or other gra'),
('48025810', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.papír,kartón,hmot.>150g/m2,obs.vláken získan. mech.0-10%,v kotouč.', 'Uncoated paper and paperboard, of a kind used for writing, printing or other gra'),
('48025890', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.papír,kartón,lepenka,hmot.>150g/m2,obs.vláken získan. mech.0-10%', 'Uncoated paper and paperboard, of a kind used for writing, printing or other gra'),
('48026115', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní papír v kotoučích,hmotnost <72g/m2, obs.vláken získ.mech.>50%', 'Uncoated paper and paperboard, of a kind used for writing, printing or other gra'),
('48026180', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní papír v kotoučích, obsah vláken získaných mechanicky >10%', 'Uncoated paper and paperboard, of a kind used for writing, printing or other gra'),
('48026200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní papír v listech,max. 435x297mm,obs.vláken získaných mech.>10%', 'Uncoated paper and paperboard, of a kind used for writing, printing or other gra'),
('48026900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní papír,obsah vláken získaných mech.>10%, ne:v kotoučích,listech', 'Uncoated paper and paperboard, of a kind used for writing, printing or other gra'),
('48030010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vata buničitá', 'Cellulose wadding in rolls of a width > 36 cm or in square or rectangular sheets'),
('48030031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír krepový,pásy celulózových vláken,každá vrstva hmotn. do 25 g.m-2', 'Creped paper for household or sanitary purposes and webs of cellulose fibres "ti'),
('48030039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír krepový,pásy celulózových vláken,každá vrstva hmotnost nad 25 g.m-2', 'Creped paper for household or sanitary purposes and webs of cellulose fibres "ti'),
('48030090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír toaletní a podobné hygienické výrobky', 'Toilet or facial tissue stock, towel or napkin stock and similar paper for house'),
('48041111', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kartón sulfátový krycí neběl.,nad 80% vlákna jehličnan.,hmotn.méně než 150g/m2', 'Unbleached kraftliner, uncoated, in rolls of a width > 36 cm, containing >= 80%'),
('48041115', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kartón sulfátový krycí neběl.,nad 80% vlákna jehličnan.,hmotn.150-méně 175g/m2', 'Unbleached kraftliner, uncoated, in rolls of a width > 36 cm, containing >= 80%'),
('48041119', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kartón sulfátový krycí neběl.,nad 80% vlákna jehličnan.,hmotn.175g/m2 a víc', 'Unbleached kraftliner, uncoated, in rolls of a width > 36 cm, containing >= 80%'),
('48041190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kartón sulfátový krycí neběl.,do 80% vlákna jehličnanová', 'Unbleached kraftliner, uncoated, in rolls of a width > 36 cm (excl. that contain'),
('48041912', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kartón sulfát.krycí 1 vrstva bělená,nad 80% vlákna jehličn.,hmotn.méně 175g/m2', 'Kraftliner, uncoated, in rolls of a width > 36 cm, containing >= 80% coniferous'),
('48041919', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kartón sulfát.krycí 1 vrstva bělená,nad 80% vlákna jehličn.,hmotn.175g/m2 a více', 'Kraftliner, uncoated, in rolls of a width > 36 cm, containing >= 80% coniferous'),
('48041930', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kartón sulfát.krycí bělený,nad 80% vlákna jehličnanová', 'Kraftliner, uncoated, in rolls of a width > 36 cm, containing >= 80% coniferous'),
('48041990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kartón sulfát.krycí bělený,do 80% vlákna jehličnanová', 'Kraftliner, uncoated, in rolls of a width > 36 cm (excl. unbleached, kraftliner'),
('48042110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír kraft pytlový nebělený,nad 80% vlákna jehličnanová', 'Unbleached sack kraft paper, uncoated, in rolls of a width > 36 cm, containing >'),
('48042190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír kraft pytlový nebělený,do 80% vlákna jehličnanová', 'Unbleached sack kraft paper, uncoated, in rolls of a width > 36 cm (excl. kraft'),
('48042910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír kraft pytlový bělený,nad 80% vlákna jehličnanová', 'Sack kraft paper, uncoated, in rolls of a width > 36 cm, containing >= 80% conif'),
('48042990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír kraft pytlový bělený,do 80% vlákna jehličnanová', 'Sack kraft paper, uncoated, in rolls of a width > 36 cm (excl. unbleached, kraft'),
('48043151', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír elektrotech.izolační kraft nebělený,nad 80% vlákna jehličnan,do 150g/m2', 'Unbleached kraft insulating paper for electro-technical purposes, uncoated, in r'),
('48043158', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.nebělený papír,<150g/m2,jehličnan.vláken získ.sulfát.postupem>80%', 'Unbleached kraft paper and paperboard, uncoated, in rolls of a width > 36 cm or'),
('48043180', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní nebělený papír, kartón, lepenka, hmotnost <150g/m2', 'Unbleached kraft paper and paperboard, uncoated, in rolls of a width > 36 cm or'),
('48043951', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír kraft stejnoměrně bělený,nad 80% vlákna jehličnanová,hmotn.do 150g/m2', 'Kraft paper and paperboard, uncoated, in rolls of a width > 36 cm or in square o'),
('48043958', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.bělený papír,<150g/m2,jehličnan.vláken získ.sulfát.postupem>80%', 'Kraft paper and paperboard, uncoated, in rolls of a width > 36 cm or in square o'),
('48043980', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní bělený papír, kartón, lepenka, hmotnost <150g/m2', 'Kraft paper and paperboard, uncoated, in rolls of a width > 36 cm or in square o'),
('48044191', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír na tvrzené lamináty "saturating craft",nebělený,hmotn.>150 <225g/m2', 'Unbleached saturating kraft paper and paperboard, uncoated, in rolls of a width'),
('48044198', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kartón nebělený ostatní,hmotn.>150 <225g/m2,ne:viz sazebník', 'Unbleached kraft paper and paperboard, uncoated, in rolls of a width > 36 cm or'),
('48044200', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír,kartón stejnoměrně bělený,hmotn.>150 <225g/m2,>95% dřev.vláken získáno chem.postupy', 'Kraft paper and paperboard, uncoated, in rolls of a width > 36 cm or in square o'),
('48044900', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír,kartón bělený ostatní,hmotn.>150 <225g/m2,ne:viz sazebník', 'Kraft paper and paperboard, uncoated, in rolls of a width > 36 cm or in square o'),
('48045100', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír,kartón nebělený,hmotn.>=225g/m2', 'Unbleached kraft paper and paperboard, uncoated, in rolls of a width > 36 cm or'),
('48045200', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír,kartón stejnoměrně bělený,hmotn.>=225g/m2,>95% dřev.vláken získáno chem.postupy', 'Kraft paper and paperboard, uncoated, in rolls of a width > 36 cm or in square o'),
('48045910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kartón bělený ost.,>=80% vlákna jehlič.,hmotn.>=225g/m2,ne:viz sazebník', 'Kraft paper and paperboard, uncoated, in rolls of a width > 36 cm or in square o'),
('48045990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kartón bělený ost.,<80% vlákna jehlič.,hmotn.>=225g/m2,ne:viz sazebník', 'Kraft paper and paperboard, uncoated, in rolls of a width > 36 cm or in square o'),
('48051100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nenatíraný polochemický papír na zvlněnou vrstvu (fluting)', 'Semi-chemical fluting paper, uncoated, in rolls of a width > 36 cm'),
('48051200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nenatíraný slámový papír na zvlněnou vrstvu (fluting)', 'Straw fluting paper, in rolls of a width > 36 cm, weighing >= 130 g/m2'),
('48051910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní nenatíraný papír na zvlněnou vrstvu (fluting) - wellenstoff', 'Wellenstoff, uncoated, in rolls of a width > 36 cm or in square or rectangular s'),
('48051990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.nenatír.papír na zvlněnou vrstvu(fluting),ne slámový,ne polochem.', 'Fluting paper, uncoated, in rolls of a width > 36 cm or in square or rectangular'),
('48052400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Testliner (recyklovaný krycí kartón), s plošnou hmotností <150g/m2', 'Testliner "recycled liner board", uncoated, in rolls of a width > 36 cm or in sq'),
('48052500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Testliner (recyklovaný krycí kartón), s plošnou hmotností >150g/m2', 'Testliner "recycled liner board", uncoated, in rolls of a width > 36 cm or in sq'),
('48053010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír balicí sulfitový, hmotnost do 30 g/m2', 'Sulphite wrapping paper, uncoated, in rolls of a width > 36 cm or in square or r'),
('48053090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír balicí sulfitový, hmotnost nad 30 g/m2', 'Sulphite wrapping paper, uncoated, in rolls of a width > 36 cm or in square or r'),
('48054000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír filtrační, kartón', 'Filter paper and paperboard, in rolls of a width > 36 cm or in square or rectang'),
('48055000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír savý napouštěcí, kartón, lepenka', 'Felt paper and paperboard, in rolls of a width > 36 cm or in square or rectangul'),
('48059100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní nenatíraný papír,kartón,lepenka,dále nezprac.,hmot.<150g/m2', 'Paper and paperboard, uncoated, in rolls of a width > 36 cm or in square or rect'),
('48059200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní nenatíraný papír,kartón,lepenka,dále nezprac.,hmot.150-225g/m2', 'Paper and paperboard, uncoated, in rolls of a width > 36 cm or in square or rect'),
('48059320', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.nenatíraný papír,kartón,lepenka,>225g/m2, vyr.z odpadového papíru', 'Paper and paperboard made from recovered paper, uncoated, in rolls of a width >'),
('48059380', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní nenatíraný papír,kartón,lepenka,dále nezprac.,hmot.>225g/m2', 'Paper and paperboard, uncoated, in rolls of a width > 36 cm or in square or rect'),
('48061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír pergamenový (rostlinný)', 'Vegetable parchment, in rolls of a width > 36 cm or in square or rectangular she'),
('48062000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír nepromastitelný', 'Greaseproof papers, in rolls of a width > 36 cm or in square or rectangular shee'),
('48063000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír pauzovací', 'Tracing papers, in rolls of a width > 36 cm or in square or rectangular sheets w'),
('48064010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pergamin', 'Glassine papers in rolls of a width > 36 cm or in square or rectangular sheets w'),
('48064090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír hlazený průhledný, průsvitný, ne pergamin', 'Transparent or translucent papers, in rolls of a width > 36 cm or in square or r'),
('48070030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vrstvený nenatíraný papír,kartón,lepenka,vyrobené z odpadového papíru', 'Composite paper and paperboard made from recovered paper, whether or not covered'),
('48070080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní vrstvený nenatíraný papír, kartón, lepenka', 'Composite paper and paperboard, not surface-coated or impregnated, whether or no'),
('48081000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír vlnitý, kartón, lepenka, též perforované', 'Corrugated paper and paperboard "with or without glued flat surface sheets", whe'),
('48082000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír pytlový kraft, krepovaný, plisovaný, ražený, perforovaný', 'Sack kraft paper, creped or crinkled, whether or not embossed or perforated, in'),
('48083000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír kraft jiný, krepovaný, plisovaný, ražený, perforovaný', 'Kraft paper, creped or crinkled, whether or not embossed or perforated, in rolls'),
('48089000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír a podobně ostatní, krepovaný, plisovaný, ražený, perforovaný', 'Paper and paperboard, creped, crinkled, embossed or perforated, in rolls of a wi'),
('48092010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír samokopírovací (přímokopírovací) v kotoučích', 'Self-copy paper, whether or not printed, in rolls of a width > 36 cm (excl. carb'),
('48092090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír samokopírovací (přímokopírovací) v listech', 'Self-copy paper, whether or not printed, in square or rectangular sheets with on'),
('48099010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír kopírovací karbonový apod.', 'Carbon and similar copying papers, whether or not printed, in rolls of a width >'),
('48099090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papíry kopírovací,přetiskovací ostatní', 'Transfer papers, incl. coated or impregnated paper for duplicator stencils or of'),
('48101320', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Natír.papír v kotouč.,podkl.pro foto/teplo/elektrocitl.papír,<150g/m2', 'Paper and paperboard used as a base for photosensitive, heat-sensitive or electr'),
('48101380', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.natíraný papír v kotoučích,určený k psaní,tisk aj.grafické účely', 'Paper and paperboard used for writing, printing or other graphic purposes, not c'),
('48101420', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Natír.papír v listech,podkl.pro foto/teplo/elektrocitl.papír,<150g/m2', 'Paper and paperboard used as a base for photosensitive, heat-sensitive or electr'),
('48101480', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní natíraný papír v listech,určený k psaní,tisk aj.grafické účely', 'Paper and paperboard used for writing, printing or other graphic purposes, not c'),
('48101910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír,kartón,lep. jako podkl.pro foto/teplo/elektrocitl.papír,<150g/m2', 'Paper and paperboard used as a base for photosensitive, heat-sensitive or electr'),
('48101990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.papír,kartón jako podkl.pro foto/teplo/elektrocitl.papír,<150g/m2', 'Paper and paperboard used for writing, printing or other graphic purposes, not c'),
('48102210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tenký nat.papír v kotouč.(š.>15cm),v list.>36x15cm,obs.vl.z.mech.>10%', 'Lightweight coated paper used for writing, printing or other graphic purposes, t'),
('48102290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní  tenký natíraný papír,určený k psaní,tisku aj.grafickým účelům', 'Lightweight coated paper used for writing, printing or other graphic purposes, t'),
('48102930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír,kartón,lepenka,v kotoučích,pro psaní,tisk aj.grafické účely', 'Paper and paperboard used for writing, printing or other graphic purposes, of wh'),
('48102980', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní papír,kartón,lepenka,určené pro psaní,tisk aj.grafické účely', 'Paper and paperboard used for writing, printing or other graphic purposes, of wh'),
('48103100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír sulfátový a jiné, ne grafické účely, bělený, do 150 g.m-2', 'Kraft paper and paperboard, bleached uniformly throughout the mass and containin'),
('48103210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír sulfátový a jiné, ne grafické účely, bělený nad 150 g.m-2', 'Kraft paper and paperboard, bleached uniformly throughout the mass and containin'),
('48103290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír sulfátový a jiné, ne grafické účely, bělený nad 150 g.m-2', 'Kraft paper and paperboard, bleached uniformly throughout the mass and containin'),
('48103900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír sulfátový a jiné, ne grafické účely, ostatní', 'Kraft paper and paperboard, coated on one or both sides with kaolin or other ino'),
('48109210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní papír,kartón,lepenka,vícevrstvé, každá vrstva bělená', 'Multi-ply paper and paperboard, each layer bleached, coated on one or both sides'),
('48109230', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost. papír,kartón,lepenka,vícevrstvé,bělená pouze jedna vnější vrstva', 'Multi-ply paper and paperboard, with only one outer layer bleached, coated on on'),
('48109290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost. papír,kartón,lepenka,vícevrstvé,ne k psaní,tisku,graf.účelům', 'Multi-ply paper and paperboard, coated on one or both sides with kaolin or other'),
('48109910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír, lepenka bělené, natírané kaolinem', 'Bleached paper and paperboard, coated on one or both sides with kaolin, in rolls'),
('48109930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír,lepenka natírané slídovým práškem', 'Paper and paperboard, coated on one or both sides with mica powder, in rolls or'),
('48109990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír, kartón, lepenka jiné, ostatní', 'Paper and paperboard, coated on one or both sides with inorganic substances, in'),
('48111000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír, kartón, lepenka dehtované, bitumen, asfalt', 'Tarred, bituminised or asphalted paper and paperboard, in rolls or in square or'),
('48114120', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Samolepicí gumovaný n.lepicí papír,kartón,lepenka,š.<10cm,kaučuk.nátěr', 'Self-adhesive paper and paperboard, surface-coloured, surface-decorated or print'),
('48114190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní samolepicí gumovaný n.lepicí papír, kartón a lepenka, natírané', 'Self-adhesive paper and paperboard, surface-coloured, surface-decorated or print'),
('48114900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní gumovaný nebo lepicí papír, kartón a lepenka, natírané', 'Gummed or adhesive paper and paperboard, surface-coloured, surface-decorated or'),
('48115100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír,kartón,lepnka,bělené,s plošnou hmotn.>150g/m2', 'Paper and paperboard, surface-coloured, surface-decorated or printed, coated, im'),
('48115900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní papír,kartón,lepenka,natřené,impregnované,potažené plasty', 'Paper and paperboard, surface-coloured, surface-decorated or printed, coated, im'),
('48116000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír,kartón,lep.,natír.,impregn.,potaž.voskem,paraf.,stearinem,olej.', 'Paper and paperboard, coated, impregnated or covered with wax, paraffin wax, ste'),
('48119000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost. papír,kartón,lepenka,buničitá vata a pásy zplstěných bunič.vláken', 'Paper, paperboard, cellulose wadding and webs of soft cellulose, coated, impregn'),
('48120000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filtrační bloky,desky z papíroviny', 'Filter blocks, slabs and plates, of paper pulp'),
('48131000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír cigaretový ve tvaru složek (sešitů),trubek (dutinek)', 'Cigarette paper in the form of booklets or tubes'),
('48132000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír cigaretový v kotoučcích,šířka <=5cm', 'Cigarette paper in rolls of a width of <= 5 cm'),
('48139010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír cigaretový v kotoučcích,šířka >5cm,<=15cm', 'Cigarette paper in rolls of a width >Â 5Â cm but <= 15Â cm'),
('48139090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír cigaretový ostatní,ne:viz sazebník', 'Cigarette paper, whether or not cut to size (excl. in the form of booklets or tu'),
('48141000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír zvaný "Ingrain" (drsně vzorovaný papír)', '''Ingrain'' paper'),
('48142000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír tapetový a podobný na stěny, líc - vrstva z plastů', 'Wallpaper and similar wallcoverings of paper, consisting of paper coated or cove'),
('48149010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír tapetový a podobný na stěny, potažený a podobně plasty', 'Wallpaper and similar wallcoverings of paper, consisting of grained, embossed, s'),
('48149080', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír tapetový,okenní transparentní apod.,ostatní,ne:viz sazebník', 'Wallpaper and similar wallcoverings of paper, and window transparencies of paper'),
('48162000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír samokopírovací,ne:výrobky č.4809', 'Self-copy paper, in rolls of a width of <= 36 cm or in rectangular or square she'),
('48169000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Matrice ofsetové z papíru,ne:výrobky č.4809', 'Copying or transfer papers, in rolls of a width of <= 36 cm or in rectangular or'),
('48171000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Obálky z papíru, kartónu, lepenky', 'Envelopes of paper or paperboard (excl. letter cards)'),
('48172000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zálepky, neilustrované dopisnice, lístky pro korespondenci', 'Letter cards, plain postcards and correspondence cards, of paper or paperboard ('),
('48173000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krabice a podobně obsahující potřeby pro korespondenci, z papíru apod.', 'Boxes, pouches, wallets and writing compendiums, of paper or paperboard, contain'),
('48181010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír toaletní, každá vrstva do 25 g.m-2', 'Toilet paper in rolls of a width of <= 36 cm, weighing per ply <= 25 g/m2'),
('48181090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír toaletní, každá vrstva nad 25 g.m-2', 'Toilet paper in rolls of a width of <= 36 cm, weighing per ply > 25 g/m2'),
('48182010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kapesníky, čisticí a odličovací ubrousky, z papíru a podobně', 'Handkerchiefs, cleansing or facial tissues and towels, of paper pulp, paper, cel'),
('48182091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ručníky v kotoučích, z papíru a podobně', 'Hand towels of paper pulp, paper, cellulose wadding or webs of cellulose fibres,'),
('48182099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ručníky ostatní, z papíru a podobně', 'Hand towels of paper pulp, paper, cellulose wadding or webs of cellulose fibres'),
('48183000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ubrusy, ubrousky z papíru a podobně', 'Tablecloths and serviettes of paper pulp, paper, cellulose wadding or webs of ce'),
('48184011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vložky hygienické z papíru,papíroviny,bunič.vaty,ze zplsť.bunič.vláken', 'Sanitary towels of paper pulp, paper, cellulose wadding or webs of cellulose fib'),
('48184013', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tampony hygienické z papíru,papíroviny,bunič.vaty,ze zplsť.bunič.vláken', 'Tampons of paper pulp, paper, cellulose wadding or webs of cellulose fibres'),
('48184019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky hygienické ostatní z papíru,bunič.vaty apod.,ne:viz sazebník', 'Feminine hygiene products of paper pulp, paper, cellulose wadding or webs of cel'),
('48184091', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dětské pleny', 'Napkins and napkin liners for babies, of paper pulp, paper, cellulose wadding or'),
('48184099', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hygienické výrobky ost.(např.pro inkontinenci),ne:dětské pleny', 'Sanitary articles, of paper pulp, paper, cellulose wadding or webs of cellulose'),
('48185000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy a oděvní doplňky z papíru a podobně', 'Articles of apparel and clothing accessories, of paper pulp, paper, cellulose wa'),
('48189010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papírové apod.výrobky pro lékařské účely neupravené pro maloobchod', 'Articles of paper pulp, paper, cellulose wadding or webs of cellulose fibre of a'),
('48189090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky k toaletním, hygienickým a podobným účelům ostatní,z papíru apod.', 'Paper, cellulose wadding or webs of cellulose fibres, of a kind used for househo'),
('48191000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krabice, bedny z vlnitého papíru, vlnité lepenky', 'Cartons, boxes and cases, of corrugated paper or paperboard'),
('48192000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skládací kartóny, bedny a krabice z nezvlněného papíru, kartónu, lepenky', 'Folding cartons, boxes and cases, of non-corrugated paper or paperboard'),
('48193000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pytle, spodní část šířka  nad 40 cm, z papíru a podobně', 'Sacks and bags, of paper, paperboard, cellulose wadding or webs of cellulose fib'),
('48194000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pytle jiné, sáčky, kapsy, tašky, kornouty, z papíru a podobně', 'Sacks and bags, incl. cones, of paper, paperboard, cellulose wadding or webs of'),
('48195000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Obaly jiné, včetně obalů na gramofonové desky, z papíru a podobně', 'Packing containers, incl. record sleeves, of paper, paperboard, cellulose waddin'),
('48196000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pořadače a podobně pro kanceláře, obchody a podobně, z papíru a podobně', 'Box files, letter trays, storage boxes and similar articles, of paperboard, of a'),
('48201010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rejstříky, účetní knihy, bloky objednávek, stvrzenek, z papíru apod.', 'Registers, account books, order books and receipt books, of paper or paperboard'),
('48201030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Poznámkové bloky, složky dopis.papírů, poznámkové notesy, z papíru apod.', 'Notebooks, letter pads and memorandum pads, without calendars, of paper or paper'),
('48201050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Diáře, z papíru a podobně', 'Diaries with calendars, of paper or paperboard'),
('48201090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rejstříky, bloky a podobně ostatní, z papíru a podobně', 'Writing pads and the like, of paper or paperboard'),
('48202000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sešity z papíru a podobně', 'Exercise books of paper or paperboard'),
('48203000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rychlovazače(ne knižní desky), desky, spisové mapy z papíru a podobně', 'Binders (other than book covers), folders and file covers, of paper or paperboar'),
('48204000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tiskopisy obchodní, sady papírů proložené karbonovými papíry', 'Manifold business forms and interleaved carbon sets, of paper or paperboard'),
('48205000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Alba na vzorky nebo sbírky, z papíru a podobně', 'Albums for samples or collections, of paper or paperboard'),
('48209000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Školní, kancelářské, papírnické výrobky ostatní z papíru a podobně', 'Blotting pads and similar articles of stationery, of paper and paperboard, and b'),
('48211010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nálepky papírové, kartónové, lepenkové potištěné, samolepicí', 'Self-adhesive paper or paperboard labels of all kinds, printed'),
('48211090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nálepky papírové, kartónové, lepenkové potištěné ostatní', 'Paper or paperboard labels of all kinds, printed (excl. self-adhesive)'),
('48219010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nálepky papírové, kartónové, lepenkové ostatní samolepicí', 'Self-adhesive paper or paperboard labels of all kinds, non-printed'),
('48219090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nálepky papírové, kartónové, lepenkové ostatní', 'Paper or paperboard labels of all kinds, non-printed (excl. self-adhesive)'),
('48221000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dutinky a podobné výztuže z papíru a podobně, k navíjení text. příze', 'Bobbins, spools, cops and similar supports of paper pulp, paper or paperboard, w'),
('48229000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dutinky a podobné výztuže z papíru a podobně, ostatní', 'Bobbins, spools, cops and similar supports of paper pulp, paper or paperboard, w'),
('48232000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír filtrační, kartón, lepenka', 'Filter paper and paperboard, in strips or rolls of a width <= 36 cm, in rectangu'),
('48234000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír diagramový pro registrační přístroje, kotouče, listy, disky', 'Rolls, sheets and dials, printed for self-recording apparatus, in rolls of a wid'),
('48236100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Podnosy,tácky,misky,talíře,šálky apod.,z bambusu', 'Trays, dishes, plates, cups and the like, of bamboo paper or bamboo paperboard'),
('48236910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Podnosy,tácky,misky,talíře,z papíru,kartónu,lepenky', 'Trays, dishes and plates, of paper or paperboard (excl. of bamboo paper or bambo'),
('48236990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šálky apod.,z papíru,kartónu,lepenky,ne:viz sazebník', 'Cups and the like, of paper or paperboard (excl. of bamboo paper or bamboo paper'),
('48237010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Proložky nasávané, krabice pro balení vajec, z papíroviny', 'Trays and boxes for packing eggs, of moulded paper pulp'),
('48237090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky tvarované z papíroviny lisované', 'Moulded or pressed articles of paper pulp, n.e.s.'),
('48239040', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostat.nařezaný papír,kartón a lepenka,pro psaní,tisk aj.grafické účely', 'Paper and paperboard used for writing, printing or other graphic purposes, n.e.s'),
('48239085', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.nařezaný papír,kartón,lepenka a buničitá vata,ost.výrobky z nich,ne:viz sazebník', 'Paper, paperboard, cellulose wadding and webs of cellulose fibres, in strips or'),
('49011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Knihy,brožury,letáky a podobně v jednotlivých listech (arších) i skládané', 'Printed books, brochures and similar printed matter, in single sheets, whether o'),
('49019100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slovníky,encyklopedie i v pořadačové úpravě', 'Dictionaries and encyclopaedias, and serial instalments thereof'),
('49019900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Knihy,brožury a podobné výrobky tiskařské ostatní,ne:viz sazebník', 'Printed books, brochures and similar printed matter (excl. those in single sheet'),
('49021000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Noviny,časopisy a podobně vycházející minimálně 4x týdně i ilustrované', 'Newspapers, journals and periodicals, whether or not illustrated or containing a'),
('49029000', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Noviny,časopisy a podobně vycházející méně než 4x týdně i ilustrované', 'Newspapers, journals and periodicals, whether or not illustrated or containing a'),
('49030000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Alba,knihy obrázkové,předlohy ke kreslení,omalovánky pro děti', 'Children''s picture, drawing or colouring books'),
('49040000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hudebniny (noty) ručně psané,tištěné i vázané i ilustrované', 'Music, printed or in manuscript, whether or not bound or illustrated'),
('49051000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Glóbusy tištěné', 'Globes, printed (excl. relief globes)'),
('49059100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky kartografické tištěné ostatní v knižní formě,ne:glóbusy', 'Maps and hydrographic or similar charts of all kinds, incl. atlases and topograp'),
('49059900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky kartografické tištěné ostatní,ne:glóbusy,v knižní formě', 'Maps and hydrographic or similar charts of all kinds, incl. atlases, wall maps a'),
('49060000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plány,výkresy pro účely stavební,strojnické,průmyslové apod.-viz sazebník', 'Plans and drawings for architectural, engineering, industrial, commercial, topog'),
('49070010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Známky poštovní,kolkové a podobné nepoužité', 'Unused postage, revenue or similar stamps of current or new issue in the country'),
('49070030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bankovky', 'Banknotes'),
('49070090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šekové tiskopisy,akcie,obligace a pod. cenné papíry', 'Stamp-impressed paper; cheque forms; stock, share or bond certificates and simil'),
('49081000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Obtisky zeskelnitelné', 'Transfers "decalcomanias", vitrifiable'),
('49089000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Obtisky ostatní,ne:zeskelnitelné', 'Transfers "decalcomanias" (excl. vitrifiable)'),
('49090000', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dopisnice,pohlednice,přání,oznámení,tištěné nebo ilustrované,též s obálkami,ozdobami', 'Printed or illustrated postcards; printed cards bearing personal greetings, mess'),
('49100000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kalendáře všech druhů tištěné vč.trhacích', 'Calendars of any kinds, printed, incl. calendars blocks'),
('49111010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Obchodní katalogy', 'Commercial catalogues'),
('49111090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tiskoviny reklamní,propagační apod.', 'Trade advertising material and the like (other than commercial catalogues)'),
('49119100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Obrazy, rytiny a fotografie', 'Pictures, prints and photographs, n.e.s.'),
('49119900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky tiskařské ostatní,ne:viz sazebník', 'Printed matter, n.e.s.'),
('50010000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zámotky bource morušového vhodné k smotávání', 'Silkworm cocoons suitable for reeling'),
('50020000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hedvábí přírodní surové (neskané)', 'Raw silk "non-thrown"'),
('50030000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad hedvábný,vč.zámotků nevhodných ke smotávání,apod.', 'Silk waste, incl. cocoons unsuitable for reeling, yarn waste and garnetted stock'),
('50040010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze hedvábná nebělená,praná,bělená neupravená pro drobný prodej', 'Silk yarn, unbleached, scoured or bleached (excl. that spun from silk waste and'),
('50040090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze hedvábná neupravená pro drobný prodej ostatní,ne:nebělená,praná,bělená', 'Silk yarn (excl. unbleached, scoured or bleached, that spun from silk waste and'),
('50050010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze spředené z hedvábného odp.nebělené,degumované,bělené,ne:pro drobný prodej', 'Yarn spun from silk waste, unbleached, scoured or bleached (excl. that put up fo'),
('50050090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze spředená z odpadu hedvábného ostatní,ne:nebělená,praná,bělená,pro drobný prodej', 'Yarn spun from silk waste (excl. unbleached, scoured or bleached, or put up for'),
('50060010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze hedvábná upravená pro drobný prodej', 'Silk yarn, put up for retail sale (excl. yarn spun from silk waste)'),
('50060090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze z odpadu hedvábného,vlas messinský upravená pro drobný prodej', 'Yarn spun from noil or other silk waste, put up for retail sale; silkworm gut'),
('50071000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z hedvábí buretového', 'Woven fabrics of noil silk'),
('50072011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Krepy nebělené,prané,bělené,obsah.85% a víc hedvábí i odpadu,ne:buretového', 'Crepes, containing >= 85% silk or silk waste by weight, unbleached, scoured or b'),
('50072019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Krepy ostatní,obsah 85% hedvábí i odpadu,ne:buretového,nebělené,prané,bělené', 'Crepes, containing >= 85% silk or silk waste by weight (excl. unbleached, scoure'),
('50072021', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z hedvábí přír.(85% a víc hedvábí),vazba plátnová,ne(bělené),prané', 'Pongee, habutai, honan, shantung, corah and similar far eastern fabrics, wholly'),
('50072031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z hedvábí přír.(obsah.85% a víc hedvábí),vazba plátnová,upravené', 'Pongee, habutai, honan, shantung, corah and similar far eastern fabrics, wholly'),
('50072039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z hedvábí přírodního oststní,ne:vazba plátnová', 'Pongee, habutai, honan, shantung, corah and similar far eastern fabrics, wholly'),
('50072041', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny průsvitné hedvábné (obsah 85% a víc hedvábí),vazba volná', 'Diaphanous fabrics "open weave" containing >= 85% silk or silk waste by weight'),
('50072051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z hedvábí (obsah 85% a víc hedvábí) nebělené,prané,bělené,ne:sazebník', 'Densely-woven fabrics containing >= 85% silk or silk waste by weight, unbleached'),
('50072059', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z hedvábí (obsah 85% a víc hedvábí) barvené,ne:viz sazebník', 'Densely-woven fabrics containing >= 85% silk or silk waste by weight, dyed (excl'),
('50072061', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z hedvábí (obsah 85% a víc hedvábí),různobarev.příze,šíře nad 57-75cm', 'Densely-woven fabrics made from yarn of different colours, containing >= 85% sil'),
('50072069', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z hedvábí (obsah.85% a víc hedvábí),různobarev.příze ost.,ne:viz sazebník', 'Densely-woven fabrics made from yarn of different colours, containing >= 85% sil'),
('50072071', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z hedvábí (obsah.85% a víc hedvábí),potisknuté', 'Densely-woven fabrics, containing >= 85% silk or silk waste by weight, printed ('),
('50079010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z hedvábí (obsah do 85% hedvábí),nebělené,prané,bělené', 'Woven fabrics containing predominantly, but < 85% silk or silk waste by weight,'),
('50079030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z hedvábí (obsah do 85% hedvábí),barvené', 'Dyed woven fabrics containing predominantly, but < 85% silk or silk waste by wei'),
('50079050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z hedvábí (obsah do 85% hedvábí),z různobarevných přízí', 'Fabrics woven from yarns of different colours, containing predominantly, but < 8'),
('50079090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z hedvábí (obsah do 85% hedvábí),potisknuté', 'Printed woven fabrics containing predominantly, but < 85% silk or silk waste by'),
('51011100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlna potní střižní nemykaná,nečesaná včetně prané na hřbetě', 'Greasy shorn wool, incl. fleece-washed wool, neither carded nor combed'),
('51011900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlna potní ostatní nemykaná,nečesaná včetně pranéna hřbetě,ne:střižní', 'Greasy wool, incl. fleece-washed wool, neither carded nor combed (excl. shorn wo'),
('51012100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlna střižní odtučněná,nekarbonizovaná nemykaná,nečesaná', 'Shorn wool, degreased, non-carbonised, neither carded nor combed'),
('51012900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlna ostatní odtučněná nekarbonizovaná nemykaná,nečesaná,ne:střižní', 'Degreased wool, non-carbonised, neither carded nor combed (excl. shorn wool)'),
('51013000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlna karbonizovaná nemykaná,nečesaná', 'Carbonised wool, neither carded nor combed'),
('51021100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlupy jemné z kozy kašmírské nemykané,nečesané', 'Hair of Kashmir "cashmere" goats, neither carded nor combed'),
('51021910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlupy jemné z králíka angorského nemykané, nečesané', 'Hair of angora rabbit, neither carded nor combed'),
('51021930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlupy jemné z alpaky, lamy, vikuně nemykané, nečesané', 'Hair of alpaca, llama or vicuna, neither carded nor combed'),
('51021940', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlupy jemné z velblouda (vč.dromedára),jaka,kozy angorské,tibetské apod.nemyk.,nečesané', 'Hair of camel or yak, or of angora goats, Tibetan goats or similar goats, neithe'),
('51021990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlupy jemné z králíka,zajíce,bobra,nutrie,ondatry pižmové nemyk., nečes.', 'Hair of rabbit, hare, beaver, nutria "coypu" or muskrat, neither carded nor comb'),
('51022000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlupy zvířecí hrubé nemykané,nečesané', 'Coarse animal hair, neither carded nor combed (excl. wool, hair and bristles use'),
('51031010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výčesky z vlny,chlupů zvířecích jemných nekarbonizované', 'Noils of wool or of fine animal hair, non-carbonised (excl. garnetted stock)'),
('51031090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výčesky z vlny,chlupů zvířecích jemných karbonizované', 'Noils of wool or of fine animal hair, carbonised (excl. garnetted stock)'),
('51032000', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad z vlny,chlupů zvířecích jemných jiný než výčesky', 'Waste of wool or of fine animal hair, incl. yarn waste (excl. noils and garnette'),
('51033000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad z chlupů zvířecích hrubých', 'Waste of coarse animal hair, incl. yarn waste (excl. garnetted stock, waste of h'),
('51040000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Materiál trhaný z vlny,chlupů zvířecích jemných,hrubých', 'Garnetted stock of wool or of fine or coarse animal hair, neither carded nor com'),
('51051000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlna mykaná', 'Wool, carded'),
('51052100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Útržky vlny česané', 'Wool, combed, in fragments "open tops"'),
('51052900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Česance vlněné,vlna česaná,ne:útržky', 'Wool, combed (excl. that in fragments "open tops")'),
('51053100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlupy jemné z kozy kašmírské mykané,česané', 'Hair of Kashmir "cashmere" goats, carded or combed'),
('51053900', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlupy zvířecí jemné ostatní mykané,česané,ne:z kozy kašmírské', 'Fine animal hair, carded or combed (excl. wool and hair of Kashmir "cashmere" go'),
('51054000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chlupy zvířecí hrubé mykané,česané', 'Coarse animal hair, carded or combed'),
('51061010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze vlněná mykaná nebělená,obsah.85% a víc vlny,neuprav.pro drobný prodej', 'Carded wool yarn containing >= 85% wool by weight, unbleached (excl. that put up'),
('51061090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze vlněná mykaná ost.,obsah.85% a víc vlny,neuprav.pro dr.prodej,ne:nebělená', 'Carded wool yarn containing >= 85% wool by weight (excl. unbleached and that put'),
('51062010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze vlněná mykaná,vlna pod 85%,vlna a jemných zvíř.chlupů 85% a víc,nebělená', 'Carded wool yarn containing predominantly, but < 85% wool by weight, with a wool'),
('51062091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze vlněná mykaná nebělená ost,obsah.nad 85% vlna,chlupy,neupr.pro dr.prodej', 'Carded wool yarn containing predominantly, but < 85% wool by weight, unbleached'),
('51062099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze vlněná mykaná ost.,obs.nad 85% vlna,chlupy,neupr.pro dr.prodej,ne:neběle', 'Carded wool yarn containing predominantly, but < 85% wool by weight (excl. unble'),
('51071010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze vlněná česaná nebělená,obsah.85% a víc vlny,neupravená pro drobný prodej', 'Yarn of combed wool containing >= 85% wool by weight, unbleached (excl. that put'),
('51071090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze vlněná česaná ost.,obsah.85% a víc vlny,neuprav.pro dr.prodej,ne:bělená', 'Yarn of combed wool containing >= 85% wool by weight (excl. unbleached and that'),
('51072010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze vlněná česaná nebělená,obsah.do 85% vlny,chlupů neuprav.pro dr.prodej', 'Yarn of combed wool containing predominantly, but < 85% wool by weight, with a w'),
('51072030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze vlněná česaná ost.,obs.do 85% vlny,chlupů,neupr.pro dr.prodej,ne:nebělená', 'Yarn of combed wool containing predominantly, but < 85% wool by weight, with a w'),
('51072051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze vlněná česaná směsovaná se syntetickými vlákny,nebělená', 'Yarn of combed wool containing predominantly, but < 85% wool by weight, mixed pr'),
('51072059', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze vlněná česaná směsovaná se syntet.vlákny ost.,ne:pro dr.prodej,nebělená', 'Yarn of combed wool containing predominantly, but < 85% wool by weight, mixed pr'),
('51072091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze vlněná česaná jinak směsovaná nebělená upr.pro dr.prod.,ne:se syntet.vlákny', 'Yarn of combed wool containing predominantly, but < 85% wool by weight, unbleach'),
('51072099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze vlněná česaná jinak směsovaná bělená ost.neupr.pro dr.prodej,ne:viz sazebník', 'Yarn of combed wool containing predominantly, but < 85% wool by weight (excl. un'),
('51081010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze z chlupů zvířecích jemných mykaná nebělená,neuprav.pro drobný prodej', 'Carded yarn of fine animal hair, unbleached (excl. that of wool or that put up f'),
('51081090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze z chlupů zvířecích jemných mykaná ost.neuprav.pro dr.prodej,ne:nebělená', 'Carded yarn of fine animal hair (excl. unbleached yarn, yarn of wool and yarn pu'),
('51082010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze z chlupů zvířecích jemných česaná nebělená,neuprav.pro drobný prodej', 'Combed yarn of fine animal hair, unbleached (excl. that of wool and that put up'),
('51082090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze z chlupů zvířecích jemných česaná ost.neuprav.pro dr.prodej,ne:nebělená', 'Combed yarn of fine animal hair (excl. unbleached yarn, yarn of wool and yarn pu'),
('51091010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze obsah.85% a víc vlny,chlupy,klubíčka,přadena,hmotnost nad 125-500g', 'Yarn containing >= 85% wool or fine animal hair by weight, put up for retail sal'),
('51091090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze obsah.85% a víc vlny,chlupy,klubíčka,přadena,ne:hmotnost viz sazebník', 'Yarn containing >= 85% wool or fine animal hair by weight, put up for retail sal'),
('51099000', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze obsah.do 85% vlny,chlupů zvířecích jemných,upravená pro drobný prodej', 'Yarn containing predominantly, but < 85% wool or fine animal hair by weight, put'),
('51100000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze z hrubých zvířecích chlupů,žíní i upravená pro drobný prodej', 'Yarn of coarse animal hair or of horsehair, incl. gimped horsehair yarn, whether'),
('51111100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z mykané vlněné příze, obsah vlny od 85%, hmotnost do 300 g/m2', 'Woven fabrics containing >= 85% carded wool or carded fine animal hair by weight'),
('51111910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z mykané vlněné příze, obsah vlny od 85%, hmotnost 300-450g/m2', 'Woven fabrics, containing >= 85% by weight of carded wool or of carded fine anim'),
('51111990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z mykané vlněné příze, obsah vlny od 85%, hmotnost nad 450g/m2', 'Woven fabrics, containing >= 85% by weight of carded wool or of carded fine anim'),
('51112000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z příze mykané vlněné,jemných zvíř.chlupů hlavně s hedvábím chemickým', 'Woven fabrics containing predominantly, but < 85% carded wool or carded fine ani'),
('51113010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z příze mykané vlněné se střižovými vlákny chemickými,hm.do 300g/m2', 'Woven fabrics containing predominantly, but < 85% carded wool or carded fine ani'),
('51113030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z příze mykané vlněné se střiž.vlákny chemickými,hm.nad 300-pod 450g/m2', 'Woven fabrics containing predominantly, but < 85% carded wool or carded fine ani'),
('51113090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z příze mykané vlněné se střiž.vlákny chemickými,hm.nad 450g/m2', 'Woven fabrics containing predominantly, but < 85% carded wool or carded fine ani'),
('51119010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z příze mykané vlněné,jemných zvíř.chlupů,obsah nad 10% hedvábí', 'Woven fabrics containing predominantly, but < 85% carded wool or carded fine ani'),
('51119091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z příze mykané vlněné,do 85% vlna,chlupy,hm.do 300g/m2', 'Woven fabrics containing predominantly, but < 85% carded wool or carded fine ani'),
('51119093', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z příze mykané vlněné,do 85% vlna,chlupy,hm.nad 300-pod 450g/m2', 'Woven fabrics containing predominantly, but < 85% carded wool or carded fine ani'),
('51119099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z příze mykané vlněné,do 85% vlna,chlupy,hm.nad 450g/m2', 'Woven fabrics containing predominantly, but < 85% carded wool or carded fine ani'),
('51121100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z česané vlny, obsah vlny od 85%, hmotnost do 200 g/m2', 'Woven fabrics containing >= 85% combed wool or combed fine animal hair by weight'),
('51121910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z česané vlny, obsah vlny od 85%, hmotnost 200-375 g/m2', 'Woven fabrics containing >= 85% by weight of carded wool or of carded fine anima'),
('51121990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z česané vlny, obsah vlny od 85%, hmotnost nad 375 g/m2', 'Woven fabrics containing >= 85% by weight of carded wool or of carded fine anima'),
('51122000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z příze česané vlněné,z jemných zvíř.chlupů hlavně s hedvábím chemickým', 'Woven fabrics containing predominantly, but < 85% combed wool or combed fine ani'),
('51123010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z příze česané vlněné s vlákny střiž.chemickými,hmotnost do 200g/m2', 'Woven fabrics containing predominantly, but < 85% combed wool or combed fine ani'),
('51123030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z příze česané vlněné s vlákny střiž.chemickými,hm.nad 200-375g/m2', 'Woven fabrics containing predominantly, but < 85% combed wool or combed fine ani'),
('51123090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z příze česané vlněné s vlákny střiž.chemickými,hm.nad 375g/m2', 'Woven fabrics containing predominantly, but < 85% combed wool or combed fine ani'),
('51129010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z příze česané vlněné,jemných zvíř.chlupů,obs.nad 10% hedvábí', 'Woven fabrics containing predominantly, but < 85% combed wool or combed fine ani'),
('51129091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z příze česané vlněné,zvíř.chlupů ostatní,hm.do 200g/m2,ne:viz sazebník', 'Woven fabrics containing predominantly, but < 85% combed wool or combed fine ani'),
('51129093', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z příze česané vlněné,chlupů ostatní,hm.nad 200-375g/m2,ne:viz sazebník', 'Woven fabrics containing predominantly, but < 85% combed wool or combed fine ani'),
('51129099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z příze česané vlněné,chlupů ostatní,hm.nad 375g/m2,ne:viz sazebník', 'Woven fabrics containing predominantly, but < 85% combed wool or combed fine ani'),
('51130000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z hrubých zvířecích chlupů a z žíní', 'Woven fabrics of coarse animal hair or of horsehair (excl. fabrics for technical'),
('52010010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bavlna nemykaná,nečesaná bělená,upravená na absorbovatelnost', 'Cotton, neither carded nor combed, rendered absorbent or bleached'),
('52010090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bavlna nemykaná,nečesaná nebělená,neupravená na absorbovatelnost', 'Cotton, neither carded nor combed (excl. rendered absorbent or bleached)'),
('52021000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad bavlněný přízový (včetně níťového)', 'Cotton yarn waste, incl. thread waste'),
('52029100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Materiál bavlněný trhaný', 'Garnetted stock of cotton'),
('52029900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad bavlněný ostatní,ne:odpad bavlněný přízový,materiál trhaný', 'Cotton waste (excl. yarn waste, thread waste and garnetted stock)'),
('52030000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bavlna mykaná,česaná', 'Cotton, carded or combed'),
('52041100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nítě bavlněné šicí,obsah nad 85% bavlna neupravené pro drobný prodej', 'Sewing thread, containing >= 85% cotton by weight (excl. that put up for retail'),
('52041900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nítě bavlněné šicí,obsah do 85% bavlna neupravené pro drobný prodej', 'Sewing thread, containing predominantly, but < 85% cotton by weight (excl. that'),
('52042000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nítě bavlněné šicí upravené pro drobný prodej', 'Cotton sewing thread, put up for retail sale'),
('52051100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná jednoduchá nečesaná,nad 85% bavlny,délk.hm.714,29 decitex a více', 'Single cotton yarn, of uncombed fibres, containing >= 85% cotton by weight and w'),
('52051200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná jednoduchá nečesaná,nad 85% bavlny,hm.232,56-pod 714,29 decitex', 'Single cotton yarn, of uncombed fibres, containing >= 85% cotton by weight and w'),
('52051300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná jednoduchá nečesaná,nad 85% bavlny,hm.192,31-pod 232,56 decitex', 'Single cotton yarn, of uncombed fibres, containing >= 85% cotton by weight and w'),
('52051400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná jednoduchá nečesaná,nad 85% bavlny,hm.125-pod 192,31 decitex', 'Single cotton yarn, of uncombed fibres, containing >= 85% cotton by weight and w'),
('52051510', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná jednoduchá nečesaná,nad 85% bavlna,hm.83,33-pod 125 decitex', 'Single cotton yarn, of uncombed fibres, containing >= 85% cotton by weight and w'),
('52051590', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná jednoduchá nečesaná,nad 85% bavlna,hm.pod 83,33 decitex', 'Single cotton yarn, of uncombed fibres, containing >= 85% cotton by weight and w'),
('52052100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná jednoduchá česaná,nad 85% bavlna,hm.nad 714,29 decitex', 'Single cotton yarn, of combed fibres, containing >= 85% cotton by weight and wit'),
('52052200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná jednoduchá česaná,nad 85% bavlna,hm.232,56-pod 714,29 decitex', 'Single cotton yarn, of combed fibres, containing >= 85% cotton by weight and wit'),
('52052300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná jednoduchá česaná,nad 85% bavlna,hm.192,31-pod 232,56 decitex', 'Single cotton yarn, of combed fibres, containing >= 85% cotton by weight and wit'),
('52052400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná jednoduchá česaná,nad 85% bavlna,hm.125-pod 192,31 decitex', 'Single cotton yarn, of combed fibres, containing >= 85% cotton by weight and wit'),
('52052600', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná jednoduchá česaná,nad 85% bavlna,hm.106,38-pod 125 decitex', 'Single cotton yarn, of combed fibres, containing >= 85% cotton by weight and wit'),
('52052700', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná jednoduchá česaná,nad 85% bavlna,hm.83,33-pod 106,38 decitex', 'Single cotton yarn, of combed fibres, containing >= 85% cotton by weight and wit'),
('52052800', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná jednoduchá česaná,nad 85% bavlna,hm.pod 83,33 decitex', 'Single cotton yarn, of combed fibres, containing >= 85% cotton by weight and wit'),
('52053100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná skaná,kablová nečesaná,nad 85% bavlna,hm.nad 714,29 decitex', 'Multiple "folded" or cabled cotton yarn, of uncombed fibres, containing >= 85% c'),
('52053200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná skaná,kablová nečes,nad 85% bavlna,hm.232,56-pod 714,29 decitex', 'Multiple "folded" or cabled cotton yarn, of uncombed fibres, containing >= 85% c'),
('52053300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná skaná,kablová nečes,nad 85% bavlna,hm.192,31-pod 232,56 decitex', 'Multiple "folded" or cabled cotton yarn, of uncombed fibres, containing >= 85% c'),
('52053400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná skaná,kablová nečesaná,nad 85% bavlna,hm.125-pod 192,31 decitex', 'Multiple "folded" or cabled cotton yarn, of uncombed fibres, containing >= 85% c'),
('52053500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná jednoduchá skaná,kablová,nečesaná,délková hmotn.pod 125 decitex', 'Multiple "folded" or cabled cotton yarn, of uncombed fibres, containing >= 85% c'),
('52054100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná skaná,kablová česaná,nad 85% bavlna,hm.nad 714,29 decitex', 'Multiple "folded" or cabled cotton yarn, of combed fibres, containing >= 85% cot'),
('52054200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná skaná,kablová česaná,nad 85% bavlna,hm.232,56-pod 714,29 decitex', 'Multiple "folded" or cabled cotton yarn, of combed fibres, containing >= 85% cot'),
('52054300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná skaná,kablová česaná,nad 85% bavlna,hm.192,31-pod 232,56 decitex', 'Multiple "folded" or cabled cotton yarn, of combed fibres, containing >= 85% cot'),
('52054400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná skaná,kablová česaná,nad 85% bavlna,hm.125-pod 192,31 decitex', 'Multiple "folded" or cabled cotton yarn, of combed fibres, containing >= 85% cot'),
('52054600', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná skaná,kablová česaná,nad 85% bavlna,hm.106,38-pod 125 decitex', 'Multiple "folded" or cabled cotton yarn, of combed fibres, containing >= 85% cot'),
('52054700', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná skaná,kablová česaná,nad 85% bavlna,hm.83,33-pod 106,38decitex', 'Multiple "folded" or cabled cotton yarn, of combed fibres, containing >= 85% cot'),
('52054800', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná skaná,kablová česaná,nad 85% bavlna,hm.pod 83,33 decitex', 'Multiple "folded" or cabled cotton yarn, of combed fibres, containing >= 85% cot'),
('52061100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná jednoduchá nečesaná,do 85% bavlny,714,29 a víc decitex', 'Single cotton yarn containing predominantly, but < 85% cotton by weight, of unco'),
('52061200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná jednoduchá nečesaná,do 85% bavlny,232,56-méně než 714,29 decitex', 'Single cotton yarn containing predominantly, but < 85% cotton by weight, of unco'),
('52061300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná jednoduchá nečesaná,do 85% bavlny,192,31-méně než 232,56 decitex', 'Single cotton yarn containing predominantly, but < 85% cotton by weight, of unco'),
('52061400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná jednoduchá nečesaná,do 85% bavlny,125-méně než 192,31 decitex', 'Single cotton yarn containing predominantly, but < 85% cotton by weight, of unco'),
('52061500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná jednoduchá nečesaná,do 85% bavlny,83,méně než 125 decitex', 'Single cotton yarn containing predominantly, but < 85% cotton by weight, of unco'),
('52062100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná jednoduchá česaná,do 85% bavlny,714,29 a víc decitex', 'Single cotton yarn containing predominantly, but < 85% cotton by weight, of comb'),
('52062200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná jednoduchá česaná,do 85% bavlny,232,56-méně než 714,29 decitex', 'Single cotton yarn containing predominantly, but < 85% cotton by weight, of comb'),
('52062300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná jednoduchá česaná,do 85% bavlny,192,31-méně než 232,56 decitex', 'Single cotton yarn containing predominantly, but < 85% cotton by weight, of comb'),
('52062400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná jednoduchá česaná,do 85% bavlny,125-méně než 192,31 decitex', 'Single cotton yarn containing predominantly, but < 85% cotton by weight, of comb'),
('52062500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná jednoduchá česaná,do 85% bavlny,méně než 125 decitex', 'Single cotton yarn containing predominantly, but < 85% cotton by weight, of comb'),
('52063100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná skaná,kablová nečesaná,do 85% bavlny,714,29 a víc decitex', 'Multiple "folded" or cabled cotton yarn containing predominantly, but < 85% cott'),
('52063200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná skaná,kablová nečes.,do 85% bavlny,232,56-méně než 714,29 decitex', 'Multiple "folded" or cabled cotton yarn containing predominantly, but < 85% cott'),
('52063300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná skaná,kablová nečes.,do 85% bavlny,192,31-méně než 232,56 decitex', 'Multiple "folded" or cabled cotton yarn containing predominantly, but < 85% cott'),
('52063400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná skaná,kablová nečes.,do 85% bavlny,125-méně než 192,31 decitex', 'Multiple "folded" or cabled cotton yarn containing predominantly, but < 85% cott'),
('52063500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná jednoduchá,do 85% bavlny,délk.hmotn.pod 125 decitex,ne:pro drobný prodej', 'Multiple "folded" or cabled cotton yarn containing predominantly, but < 85% cott'),
('52064100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná skaná,kablová česaná,do 85% bavlny,714,29 a víc decitex', 'Multiple "folded" or cabled cotton yarn containing predominantly, but < 85% cott'),
('52064200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná skaná,kablová česaná,do 85% bavlny,232,56-méně než 714,29 decitex', 'Multiple "folded" or cabled cotton yarn containing predominantly, but < 85% cott'),
('52064300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná skaná,kablová česaná,do 85% bavlny,192,31-méně než 232,56 decitex', 'Multiple "folded" or cabled cotton yarn containing predominantly, but < 85% cott'),
('52064400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná skaná,kablová česaná,do 85% bavlny,125-méně než 192,31 decitex', 'Multiple "folded" or cabled cotton yarn containing predominantly, but < 85% cott'),
('52064500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná jednoduchá skaná,kablová,česaná,délková hmotn.pod 125 decitex', 'Multiple "folded" or cabled cotton yarn containing predominantly, but < 85% cott'),
('52071000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná pro drobný prodej,85% a víc bavlny,ne:šicí nit', 'Cotton yarn containing >= 85% cotton by weight, put up for retail sale (excl. se'),
('52079000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze bavlněná pro drobný prodej,do 85% bavlny,ne:šicí nit', 'Cotton yarn containing predominantly, but < 85% cotton by weight, put up for ret'),
('52081110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné nebělené,nad 85% bavlny,výr.obvazů,mulů apod.,hm.do 100g/m2', 'Plain woven fabrics of cotton for the manufacture of bandages, dressings and med'),
('52081190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné neběl.ost.,nad 85% bavlny,plátnová vazba,hm.do 100g/m2,ne:sazebník', 'Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing <'),
('52081216', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkanina bavlněná,bavlna 85% a víc,neběl.,hmotn.nad100-130g/m2,šíře do 165cm', 'Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing >'),
('52081219', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné neběl.,nad 85% bavlny,plátn.vazba,100-130g/m2,šíře nad 165cm', 'Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing >'),
('52081296', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkanina bavlněná,bavlna 85% a víc,neběl.,hmotn.nad 130g/m2,šíře do 165cm', 'Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing >'),
('52081299', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné neběl.,nad 85% bavlny,plátn.vazba,130-200g/m2,šíře nad 165cm', 'Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing >'),
('52081300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné nebělené,nad 85% bavlny,vazba kepr,hmotnost do 200g/m2', 'Woven fabrics of cotton, containing >= 85% cotton by weight and weighing <= 200'),
('52081900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné nebělené ostatní,nad 85% bavlny,hmotnost do 200g/m2,ne:sazebník', 'Woven fabrics of cotton, containing >= 85% cotton by weight and weighing <= 200'),
('52082110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné bělené,nad 85% bavlny,výr.obvazů,mulů apod.,do 100g/m2', 'Plain woven fabrics of cotton for the manufacture of bandages, dressings and med'),
('52082190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné bělené ost.,nad 85% bavlny,do 100g/m2,ne:výr.obvazů,mulů apod.', 'Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing <'),
('52082216', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkanina bavlněná,bavlna 85% a víc,běl.,hmotn.nad 100-130g/m2,šíře do 165cm', 'Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing >'),
('52082219', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné bělené,nad 85% bavlny,plátn.vazba,100-130g/m2,šíře nad 165 cm', 'Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing >'),
('52082296', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkanina bavlněná,bavlna 85% a víc,bělená,hmotn.nad 130g/m2,šíře do 165cm', 'Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing >'),
('52082299', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné běl.,nad 85% bavlny,plátn.vazba,130-200g/m2,šíře nad 165cm', 'Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing >'),
('52082300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné bělené,nad 85% bavlny,vazba kepr,hmotnost do 200g/m2', 'Woven fabrics of cotton, containing >= 85% cotton by weight and weighing <= 200'),
('52082900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné bělené ostatní,nad 85% bavlny,hmotnost do 200g/m2,ne:viz sazebník', 'Woven fabrics of cotton, containing >= 85% cotton by weight and weighing <= 200'),
('52083100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné barvené,nad 85% bavlny,plátnová vazba,hmotnost do 100g/m2', 'Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing <'),
('52083216', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkanina bavlněná,bavlna 85% a víc,barvená,hmotn.nad100-130g/m2,šíře do 165cm', 'Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing >'),
('52083219', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné barvené,nad 85% bavlny,plátn.vazba,100-130g/m2,šíře nad 165cm', 'Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing >'),
('52083296', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkanina bavlněná,bavlna 85% a víc,barvená,hmotn.nad 130g/m2,šíře do 165cm', 'Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing >'),
('52083299', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné barvené,nad 85% bavlny,plátn.vazba,130-200g/m2,šíře nad 165cm', 'Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing >'),
('52083300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné barvené,nad 85% bavlny,vazba kepr,hmotnost do 200g/m2', 'Woven fabrics of cotton, containing >= 85% cotton by weight and weighing <= 200'),
('52083900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné barvené ostatní,nad 85% bavlny,hmotnost do 200g/m2,ne:sazebník', 'Woven fabrics of cotton, containing >= 85% cotton by weight and weighing <= 200'),
('52084100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné různobarevné,nad 85% bavlny,plátnová vazba,hmotn.do 100g/m2', 'Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing <'),
('52084200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné různobarevné,nad 85% bavlny,plátnová vazba,hmotn.100-200g/m2', 'Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing >'),
('52084300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné různobarevné,nad 85% bavlny,vazba kepr,hmotnost do 200g/m2', 'Woven fabrics of cotton, containing >= 85% cotton by weight and weighing <= 200'),
('52084900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné různobarevné ostatní,nad 85% bavlny,hm.do 200g/m2,ne:viz sazebník', 'Woven fabrics of cotton, containing >= 85% cotton by weight and weighing <= 200'),
('52085100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné potisknuté,nad 85% bavlny,plátnová vazba,hmotn.do 100g/m2', 'Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing <'),
('52085200', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné potisknuté,nad 85% bavlny,plátnová vazba,hmotn.nad 100g/m2', 'Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing >'),
('52085910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné potisknuté,nad 85% bavlny,vazba kepr,hmotn.do 200g/m2', 'Woven fabrics of cotton, containing >= 85% cotton by weight and weighing <= 200'),
('52085990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné potisknuté ostatní,nad 85% bavlny,hmotn.do 200g/m2,ne:sazebník', 'Woven fabrics of cotton, containing >= 85% cotton by weight and weighing <= 200'),
('52091100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné nebělené,nad 85% bavlny,plátnová vazba,hmotnost nad 200g/m2', 'Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing >'),
('52091200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné nebělené,nad 85% bavlny,vazba kepr,hmotnost nad 200g/m2', 'Woven fabrics of cotton, containing >= 85% cotton by weight and weighing > 200 g'),
('52091900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné nebělené ostatní,nad 85% bavlny,hmotn.nad 200g/m2,ne:viz sazebník', 'Woven fabrics of cotton, containing >= 85% cotton by weight and weighing > 200 g'),
('52092100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné bělené,nad 85% bavlny,plátnová vazba,hmotnost nad 200g/m2', 'Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing >'),
('52092200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné bělené,nad 85% bavlny,vazba kepr,hmotnost nad 200g/m2', 'Woven fabrics of cotton, containing >= 85% cotton by weight and weighing > 200 g'),
('52092900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné bělené ostatní,nad 85% bavlny,hmotnost nad 200g/m2,ne:viz sazebník', 'Woven fabrics of cotton, containing >= 85% cotton by weight and weighing > 200 g'),
('52093100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné barvené,nad 85% bavlny,plátnová vazba,hmotnost nad 200g/m2', 'Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing >'),
('52093200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné barvené,nad 85% bavlny,vazba kepr,hmotnost nad 200g/m2', 'Woven fabrics of cotton, containing >= 85% cotton by weight and weighing > 200 g'),
('52093900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné barvené ostatní,nad 85% bavlny,hmotn.nad 200g/m2,ne:viz sazebník', 'Woven fabrics of cotton, containing >= 85% cotton by weight and weighing > 200 g'),
('52094100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné různobarevné,nad 85% bavlny,plátnová vazba,hmotn.nad 200g/m2', 'Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing >'),
('52094200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné různobarevné zvané denim,nad 85% bavlny,hmotn.nad 200g/m2', 'Denim, containing >= 85% cotton by weight and weighing > 200 g/m2, made of yarn'),
('52094300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné různobarevné,nad 85% bavlny,vazba kepr,hmotn.nad 200g/m2', 'Woven fabrics of cotton, containing >= 85% cotton by weight and weighing > 200 g'),
('52094900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné různobarevné ostatní,nad 85% bavlny,hm.nad 200g/m2,ne:viz sazebník', 'Woven fabrics of cotton, containing >= 85% cotton by weight and weighing > 200 g'),
('52095100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné potisknuté,nad 85% bavlny,plátnová vazba,hmotnost nad 200g/m2', 'Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing >'),
('52095200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné potisknuté,nad 85% bavlny,vazba kepr,hmotnost nad 200g/m2', 'Woven fabrics of cotton, containing >= 85% cotton by weight and weighing > 200 g'),
('52095900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné potisknuté ostatní,nad 85% bavlny,hmotn.nad 200g/m2,ne:viz sazebník', 'Woven fabrics of cotton, containing >= 85% cotton by weight and weighing > 200 g'),
('52101100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné neběl.do 85% bavlny,chem.vlákna,pl.vazba,do 200g/m2', 'Plain woven fabrics of cotton, containing predominantly, but < 85% cotton by wei'),
('52101900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné neběl.ostatní,do 85% bavlna,chem.vlákna,do 200g/m2,ne:sazebník', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, m'),
('52102100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné běl.,do 85% bavlny,chem.vlákna,pl.vazba,do 200g/m2', 'Plain woven fabrics of cotton, containing predominantly, but < 85% cotton by wei'),
('52102900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné běl.ostatní,do 85% bavlny,chem.vlákno,do 200g/m2,ne:viz sazebník', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, m'),
('52103100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné barvené,do 85% bavln,chem.vlákna,pl.vazba,do 200g/m2', 'Plain woven fabrics of cotton, containing predominantly, but < 85% cotton by wei'),
('52103200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné barvené,do 85% bavlny,chemická vlákna,vazba kepr,do 200g/m2', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, m'),
('52103900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné barvené ost.,do 85% bavlny,chem.vlákno,do 200g/m2,ne:viz sazebník', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, m'),
('52104100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné různobarevné,do 85% bavlny,chem.vlákna,plát.vazba,do 200g/m2', 'Plain woven fabrics of cotton, containing predominantly, but < 85% cotton by wei'),
('52104900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavln.různobarevné ost.,do 85% bavlna,chem.vlákno,do 200g/m2,ne:sazebník', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, m'),
('52105100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné potisknuté,do 85% bavlny,chem.vlákna,plát.vazba,do 200g/m2', 'Plain woven fabrics of cotton, containing predominantly, but < 85% cotton by wei'),
('52105900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné potisknuté ost.,do 85% bavlna,chem.vlákno,do 200g/m2,ne:sazebník', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, m'),
('52111100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné nebělené,do 85% bavlny,chem.vlákna,plátnová vazba,nad 200g/m2', 'Plain woven fabrics of cotton, containing predominantly, but < 85% cotton by wei'),
('52111200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné nebělené,do 85% bavlny,chem.vlákna,vazba kepr,nad 200g/m2', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, m'),
('52111900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné nebělené ost.,do 85% bavlny,chem.vlákno,nad 200g/m2,ne:sazebník', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, m'),
('52112000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné bělené,do 85% bavlny,chem.vlákno,nad 200g/m2', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, m'),
('52113100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné barvené,do 85% bavlny,chem.vlákno,plátnová vazba,nad 200g/m2', 'Plain woven fabrics of cotton, containing predominantly, but < 85% cotton by wei'),
('52113200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné barvené,do 85% bavlny,chem.vlákna,vazba kepr,nad 200g/m2', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, m'),
('52113900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné barvené ost.,do 85% bavlny,chem.vlákno,nad 200g/m2,ne:sazebník', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, m'),
('52114100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné různobar.,do 85% bavlny,chem.vlákna,plátn.vazba,nad 200g/m2', 'Plain woven fabrics of cotton, containing predominantly, but < 85% cotton by wei'),
('52114200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné (denim) různobar.,do 85% bavlny,chem.vlákna,nad 200g/m2', 'Denim, containing predominantly, but < 85% cotton by weight, mixed principally o'),
('52114300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné různobar.,do 85% bavlny,chem.vlákna,vazba kepr,nad 200g/m2', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, m'),
('52114910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné žakárové,do 85%bavlny,chemická vlákna,nad 200 g/m2', 'Woven jacquard fabrics containing predominantly, but < 85% cotton by weight, mix'),
('52114990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné různobar.ost.,do 85% bavlny,chem.vlákna,nad 200g/m2,ne:sazebník', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, m'),
('52115100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné potisknuté,do 85% bavlny,chem.vlákna,plátn.vazba,nad 200g/m2', 'Plain woven fabrics of cotton, containing predominantly, but < 85% cotton by wei'),
('52115200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné potisknuté,do 85% bavlny,chem.vlákna,vazba kepr,nad 200g/m2', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, m'),
('52115900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné potisk.ost.,do 85% bavlny,chem.vlákna,nad 200g/m2,ne:viz sazebník', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, m'),
('52121110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny směsové bavlna-len nebělené,hmotnost do 200g/m2', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, m'),
('52121190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné směsové nebělené ostatní,hmotnost do 200g/m2,ne:bavlna-len', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, o'),
('52121210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny směsové bavlna-len bělené,hmotnost do 200g/m2', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, m'),
('52121290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné směsové bělené ostatní,hmotnost do 200g/m2,ne:bavlna-len', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, o'),
('52121310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny směsové bavlna-len barvené,hmotnost do 200g/m2', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, m'),
('52121390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné směsové barvené ostatní,hmotnost do 200g/m2,ne:bavlna-len', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, o'),
('52121410', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny směsové bavlna-len z různobarevných přízí,hmotnost do 200g/m2', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, m'),
('52121490', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné směsové ostatní z různobarevných přízí,do 200g/m2,ne:se lnem', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, o'),
('52121510', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny směsové bavlna-len potisknuté,hmotnost do 200g/m2', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, m'),
('52121590', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné směsové potisknuté ostatní,do 200g/m2,ne:bavlna-len', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, o'),
('52122110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny směsové bavlna-len nebělené,hmotnost nad 200g/m2', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, m'),
('52122190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné směsové nebělené ostatní,hmotnost nad 200g/m2,ne:bavlna-len', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, o'),
('52122210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny směsové bavlna-len bělené,hmotnost nad 200g/m2', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, m'),
('52122290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné směsové bělené ostatní,hmotnost nad 200g/m2,ne:bavlna-len', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, o'),
('52122310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny směsové bavlna-len barvené,hmotnost nad 200g/m2', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, o'),
('52122390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné směsové barvené ostatní,hmotnost nad 200g/m2,ne:bavlna-len', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, o'),
('52122410', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny směsové bavlna-len z různobarevných přízí,hmotnost nad 200g/m2', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, m'),
('52122490', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné směsové z různobarevných přízí ost.,nad 200g/m2,ne:bavlna-len', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, o'),
('52122510', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny směsové bavlna-len potisknuté,hmotnost nad 200g/m2', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, m'),
('52122590', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny bavlněné směsové potisknuté ostatní,nad 200g/m2,ne:bavlna-len', 'Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, o'),
('53011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Len surový nebo rosený', 'Flax, raw or retted'),
('53012100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Len lámaný,třený nespředený', 'Flax, broken or scutched'),
('53012900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Len vochlovaný a jinak zpracovaný nespředený,ne:lámaný,třený', 'Flax, hackled or otherwise processed, but not spun (excl. broken, scutched and r'),
('53013000', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Koudel a lněný odpad', 'Flax tow and waste, incl. yarn waste and garnetted stock'),
('53021000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Konopí pravé surové,máčené nespředené', 'True hemp "Cannabis sativa L.", raw or retted'),
('53029000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Koudel,odpad z konopí pravého (vč.přízového odpadu a trhaného materiálu)', 'True hemp "Cannabis sativa L.", processed but not spun; tow and waste of hemp, i'),
('53031000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Juta a jiná textilní lýková vlákna surová,máčená nespředená', 'Jute and other textile bast fibres, raw or retted (excl. flax, true hemp and ram'),
('53039000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Koudel,odpad z juty a jiných textilních lýkových vláken (vč.přízového odpadu)', 'Jute and other textile bast fibres, processed but not spun; tow and waste of suc'),
('53050000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlákna rostlinná textilní ost.nespředená,koudel,odpad apod.,ne:viz sazebník', 'Coconut, abaca "Manila hemp or Musa textilis Nee", ramie, agave and other vegeta'),
('53061010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě lněné jednoduché,délková hmotn.833,3 a víc decitex,ne:pro drobný prodej', 'Single flax yarn, with a linear density of >= 833,3 decitex "<= metric number 12'),
('53061030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě lněné jednoduché,délk.hmotn.pod 833,3-277,8 decitex,ne:pro drobný prodej', 'Single flax yarn, with a linear density of 277,8 decitex to < 833,3 decitex "> M'),
('53061050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze lněná jednoduchá,do 277,8 decitex', 'Single flax yarn, with a linear density of < 277,8 decitex "> MN 36" (excl. that'),
('53061090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze lněná jednoduchá,upravená pro maloobchodní prodej', 'Single flax yarn, put up for retail sale'),
('53062010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě lněné skané nebo kablové,neupravené pro drobný prodej', 'Multiple "folded" or cabled flax yarn (excl. for retail sale)'),
('53062090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze lněná násobná (skaná),kablová upravená pro maloobchodní prodej', 'Multiple "folded" or cabled flax yarn, put up for retail sale'),
('53071000', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze z juty a podobných vláken textilních lýkových jednoduchá', 'Single yarn of jute or of other textile bast fibres of heading 5303'),
('53072000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze z juty a podobných vláken textilních lýkových skaná,kablová', 'Multiple "folded" or cabled yarn of jute or of other textile bast fibres of head'),
('53081000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze kokosová', 'Coconut "coir" yarn'),
('53082010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze z pravého konopí,ne:pro maloobchodní prodej', 'Hemp yarn (excl. that put up for retail sale)'),
('53082090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze z pravého konopí upravená pro maloobchodní prodej', 'Hemp yarn put up for retail sale'),
('53089012', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě ramiové,délková hmotnost 277,8 a víc decitex', 'Ramie yarn, with a linear density of >= 277,8 decitex "<= MN 36"'),
('53089019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze ramiová,do 277,8 decitex', 'Ramie yarn, with a linear density of < 277,8 decitex "> MN 36"'),
('53089050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě papírové', 'Paper yarn'),
('53089090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze z vláken rostlinných textilních ostatní,ne:viz sazebník', 'Yarn of vegetable textile fibres (excl. flax yarn, yarn of jute or of other text'),
('53091110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny lněné,obsah lnu >= 85 %,nebělené', 'Woven fabrics of flax, containing >= 85% flax by weight, unbleached'),
('53091190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny lněné,obsah lnu >= 85 %,bělené', 'Woven fabrics of flax, containing >= 85% flax by weight, bleached'),
('53091900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny lněné,obsah lnu >= 85 %,ostatní,ne:bělené,nebělené', 'Woven fabrics of flax, containing >= 85% flax by weight, dyed, made of yarn of d'),
('53092100', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny lněné,obsah lnu < 85 %,nebělené i bělené', 'Woven fabrics of flax, containing predominantly, but < 85% flax by weight, unble'),
('53092900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny lněné,obsah lnu < 85 %,ostatní,ne:bělené,nebělené', 'Woven fabrics of flax, containing predominantly, but < 85% flax by weight, dyed,'),
('53101010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z vláken jutových,jiných textilních lýkových nebělené,šíře do 150cm', 'Woven fabrics of jute or of other textile bast fibres of heading 5303, unbleache'),
('53101090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z vláken jutových,jiných textilních lýkových nebělené,šíře nad 150cm', 'Woven fabrics of jute or of other textile bast fibres of heading 5303, unbleache'),
('53109000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z vláken jutových a podobných rostlinných lýkových ostatní,ne:nebělen', 'Woven fabrics of jute or of other textile bast fibres of heading 5303, bleached,'),
('53110010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z vláken ramie', 'Woven fabrics of ramie'),
('53110090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z papírové příze,vláken rostlinných ostatní,ne:viz sazebník', 'Woven fabrics of other vegetable textile fibres; woven fabrics of paper yarn (ex'),
('54011012', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě šicí,synt.,neupr.pro maloobch.prodej,jádrové,vlákno z polyesterů ovinuté bavln.vlákny', 'Sewing thread ''core yarn'' of polyester filament surrounded by cotton fibres (e'),
('54011014', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě šicí,synt.,neupr.pro maloobch.prodej,jádrové ost.,ne:vlákno z polyesterů ovinuté bavln.vlákny', 'Core yarn of synthetic filaments (excl. that put up for retail sale and polyeste'),
('54011016', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě šicí,synt.,tvarované,neupr.pro maloobch.prodej,ne:jádrové', 'Textured sewing yarn of synthetic filaments (excl. core yarn and yarn put up for'),
('54011018', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě šicí,synt.,ost.,neupr.pro maloobch.prodej,ne:tvarované,jádrové', 'Sewing thread of synthetic filaments (excl. core yarn, textured yarn and yarn pu'),
('54011090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě šicí,synt.,upr.pro maloobch.prodej', 'Sewing thread of synthetic filaments, put up for retail sale'),
('54012010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě šicí,umělé,neupr.pro maloobch.prodej', 'Sewing thread of artificial filaments (excl. that put up for retail sale)'),
('54012090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě šicí,umělé,upr.pro maloobch.prodej', 'Sewing thread of artificial filaments, put up for retail sale'),
('54021100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě synt.,vysokopevnostní,z polyamidů aromatických', 'High-tenacity filament yarn of aramids (excl. sewing thread and yarn put up for'),
('54021900', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě synt.,vysokopevnostní,z nylonu,polyamidů,ne:z polyamidů aromatických', 'High-tenacity filament yarn of nylon or other polyamides (excl. sewing thread, y'),
('54022000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě synt.,vysokopevnostní,z polyesterů', 'High-tenacity filament yarn of polyesters (excl. that put up for retail sale)'),
('54023100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě synt.,tvarované,z nylonu aj.polyamidů,délk.hm.jednoduché nitě <= 50 tex', 'Textured filament yarn of nylon or other polyamides, with a linear density of <='),
('54023200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě synt.,tvarované,z nylonu aj.polyamidů,délk.hm.jednoduché nitě > 50 tex', 'Textured filament yarn of nylon or other polyamides, with a linear density of >'),
('54023300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě synt.,tvarované,z polyesterů', 'Textured filament yarn of polyester (excl. that put up for retail sale)'),
('54023400', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě synt.,tvarované,z polypropylenu', 'Textured synthetic filament yarn of polypropylene (excl. sewing thread and yarn'),
('54023900', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě synt.,tvarované,ostatní,ne:viz sazebník', 'Textured synthetic filament yarn (excl. sewing thread, yarn put up for retail sa'),
('54024400', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě synt.ost.,jednod.,nekrouc.,krouc.s max.50 zákr./m,elastomerové', 'Synthetic filament elastomeric yarn, single, untwisted or with a twist of <= 50'),
('54024500', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě synt.ost.,jednod.,nekrouc.,krouc.s max.50 zákr./m,z nylonu aj.polyamidů', 'Filament yarn of nylon or other polyamides, incl. monofilament of < 67 decitex,'),
('54024600', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě synt.ost.,jednod.,nekrouc.,krouc.s max.50 zákr./m,z polyesterů,část.orient.', 'Filament yarn of polyester, incl. monofilament of < 67 decitex, single, untwiste'),
('54024700', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě synt.ost.,jednod.,nekrouc.,krouc.s max.50 zákr./m,z polyesterů,ne:část.orient.', 'Filament yarn of polyester, incl. monofilament of < 67 decitex, single, untwiste'),
('54024800', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě synt.ost.,jednod.,nekrouc.,krouc.s max.50 zákr./m,z polypropylenu', 'Filament yarn of polypropylene, incl. monofilament of < 67 decitex, single, untw'),
('54024900', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě synt.ost.,jednod.,nekrouc.,krouc.s max.50 zákr./m,ostatní,ne:viz sazebník', 'Synthetic filament yarn, incl. synthetic monofilament of < 67 decitex, single, u'),
('54025100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě synt.ost.,jednod.,krouc.s více než 50 zákr./m,z nylonu aj.polyamidů', 'Filament yarn of nylon or other polyamides, incl. monofilament of < 67 decitex,'),
('54025200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě synt.ost.,jednod.,krouc.s více než 50 zákr./m,z polyesterů', 'Filament yarn of polyester, incl. monofilament of < 67 decitex, single, with a t'),
('54025910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě synt.ost.,jednod.,krouc.s více než 50 zákr./m,z polypropylenu', 'Filament yarn of polypropylene, incl. monofilament of < 67 decitex, single, with'),
('54025990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě synt.ost.,jednod.,krouc.s více než 50 zákr./m,ostatní,ne:viz sazebník', 'Synthetic filament yarn, incl. synthetic monofilament of < 67 decitex, single, w'),
('54026100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě synt.ost.,skané či kablové,z nylonu aj.polyamidů', 'Multiple "folded" or cabled filament yarn of nylon or other polyamides, incl. mo'),
('54026200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě synt.ost.,skané či kablové,z polyesterů', 'Multiple "folded" or cabled filament yarn of polyester, incl. monofilament of <'),
('54026910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě synt.ost.,skané či kablové,z polypropylenu', 'Multiple "folded" or cabled synthetic filament yarn of polypropylene, incl. mono'),
('54026990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě synt.ost.,skané či kablové,ostatní,ne:viz sazebník', 'Multiple "folded" or cabled synthetic filament yarn, incl. synthetic monofilamen'),
('54031000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě umělé,vysokopevnostní,z viskózového hedvábí', 'High-tenacity yarn of viscose rayon filament (excl. sewing thread and yarn put u'),
('54033100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě umělé,jednod.,nekrouc.,krouc.s max.120 zákr./m,z viskózového hedvábí', 'Yarn of viscose rayon filament, incl. monofilament of < 67 decitex, single, untw'),
('54033200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě umělé,jednod.,krouc.s více než 120 zákr./m,z viskózového hedvábí', 'Yarn of viscose rayon filament, incl. monofilament of < 67 decitex, single, with'),
('54033300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě umělé,jednod.,z acetátu celulózy', 'Filament yarn of cellulose acetate, incl. monofilament of < 67 decitex, single ('),
('54033900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě umělé,jednod.,ostatní,ne:viz sazebník', 'Artificial filament yarn, incl. artificial monofilament of < 67 decitex, single'),
('54034100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě umělé ost.,skané či kablové,z viskózového hedvábí', 'Multiple "folded" or cabled filament yarn of viscose rayon, incl. monofilament o'),
('54034200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě umělé ost.,skané či kablové,z acetátu celulózy', 'Multiple "folded" or cabled filament yarn of cellulose acetate, incl. monofilame'),
('54034900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě umělé ost.,skané či kablové,ostatní,ne:viz sazebník', 'Multiple "folded" or cabled artificial filament yarn, incl. artificial monofilam'),
('54041100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě ze synt.monofilamentu,>=67decitex,průřez <1mm,elastomerové', 'Elastomeric monofilament of >= 67 decitex and with a cross sectional dimension o'),
('54041200', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě ze synt.monofilamentu,>=67decitex,průřez <1mm,z polypropylenu', 'Polypropylene monofilament of >= 67 decitex and with a cross sectional dimension'),
('54041900', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě ze synt.monofilamentu ost.,>=67decitex,průřez <1mm,ne:viz sazebník', 'Synthetic monofilament of >= 67 decitex and with a cross sectional dimension of'),
('54049010', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pásky a podobné tvary (např.umělá sláma) z polypropylenu,šíře <= 5 mm', 'Strip and the like, e.g. artificial straw, of polypropylene, with an apparent wi'),
('54049090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pásky a pod.z materiálů textilních syntet.,šíře <= 5mm,ne:polypropylen', 'Synthetic strip and the like, e.g. artificial straw, of synthetic textile materi'),
('54050000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě z umělého monofilamentu,>=67 decitex,pásky z mater.textilních umělých,šíře <= 5mm', 'Artificial monofilament of >= 67 decitex and with a cross sectional dimension of'),
('54060000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě z vláken nekonečných chemických,pro drobný prodej,ne:šicí nit', 'Man-made filament yarn, put up for retail sale (excl. sewing thread)'),
('54071000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z vysokopevnostní příze z nylonu nebo jiných polyamidů,polyesterů', 'Woven fabrics of high-tenacity yarn, nylon, other polyamides or polyesters, incl'),
('54072011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z pásků z polyethylenu,polypropylenu,šíře do 3m', 'Woven fabrics of strip or the like, of polyethylene or polypropylene, incl. mono'),
('54072019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z pásků z polyethylenu,polypropylenu,šíře nad 3m', 'Woven fabrics of strip or the like, of polyethylene or polypropylene, incl. mono'),
('54072090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z pásků a pod.tvarů ostatní,ne:polyethylen,polypropylen', 'Woven fabrics of strip or the like, of synthetic filament, incl. monofilament of'),
('54073000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z vrstev paralelních nití z hedvábí syntetického (pozn.9 ke třídě XI)', 'Woven fabrics of synthetic filament yarn, incl. monofilament of >= 67 decitex an'),
('54074100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny ostatní,85% a víc hedvábí z nylonu a jiných polyamidů,nebělené,bělené', 'Woven fabrics of yarn containing >= 85% by weight of filaments of nylon or other'),
('54074200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny ostatní,85% a víc hedvábí z nylonu a jiných plyamidů,barvené', 'Woven fabrics of filament yarn containing >= 85% nylon or other polyamides by we'),
('54074300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny ost.,85% a víc hedvábí z nylonu a jiných polyamidů,různobarevné příze', 'Woven fabrics of yarn containing >= 85% by weight of filaments of nylon or other'),
('54074400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny ostatní,85% a víc hedvábí z nylonu a jiných polyamidů,potisknuté', 'Woven fabrics of yarn containing >= 85% by weight of filaments of nylon or other'),
('54075100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny ostatní,85% a víc hedvábí tvarované polyesterové,bělené,nebělené', 'Woven fabrics of yarn containing >= 85% by weight of textured polyester filament'),
('54075200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny ostatní,85% a víc hedvábí tvarované polyesterové,barvené', 'Woven fabrics of yarn containing >= 85% by weight of textured polyester filament'),
('54075300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny ostatní,85% a víc hedvábí tvarované polyesterové,z různobarev.přízí', 'Woven fabrics of yarn containing >= 85% by weight of textured polyester filament'),
('54075400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny ostatní,85% a víc hedvábí tvarované polyesterové,potisknuté', 'Woven fabrics of yarn containing >= 85% by weight of textured polyester filament'),
('54076110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny ostatní,85% a víc hedvábí netvarované polyesterové,bělené,nebělené', 'Woven fabrics of yarn containing >= 85% by weight of non-textured polyester fila'),
('54076130', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny ostatní,85% a víc hedvábí netvarované polyesterové,barvené', 'Woven fabrics of yarn containing >= 85% by weight of non-textured polyester fila'),
('54076150', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny ostatní,85% a víc hedvábí netvarované polyesterové,různobarevné příze', 'Woven fabrics of yarn containing >= 85% by weight of non-textured polyester fila'),
('54076190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny ostatní,85% a víc hedvábí netvarované polyesterové,potisknuté', 'Woven fabrics of yarn containing >= 85% by weight of non-textured polyester fila'),
('54076910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny ostatní,85% a víc hedvábí polyesterové,nebělené,bělené,ne:viz sazebník', 'Woven fabrics of yarn containing >= 85% by weight of mixtures of textured and no'),
('54076990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny ostatní,85% a víc hedvábí polyesterové,barvené,ne:viz sazebník', 'Woven fabrics of yarn containing >= 85% by weight of mixtures of textured and no'),
('54077100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny ostatní,85% a víc hedvábí syntetické,nebělené,bělené,ne:viz sazebník', 'Woven fabrics of yarn containing >= 85% synthetic filament by weight, incl. mono'),
('54077200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny ostatní,85% a víc hedvábí syntetické,barvené,ne:viz sazebník', 'Woven fabrics of yarn containing >= 85% synthetic filament by weight, incl. mono'),
('54077300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny ostatní,85% a víc hedvábí syntetické,z různobarevných přízí,ne:viz sazebník', 'Woven fabrics of yarn containing >= 85% synthetic filament by weight, incl. mono'),
('54077400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny ostatní,85% a víc hedvábí syntetické,potisknuté,ne:viz sazebník', 'Woven fabrics of yarn containing >= 85% synthetic filament by weight, incl. mono'),
('54078100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny ostatní,pod 85% hedvábí syntetické,s bavlnou,nebělené,bělené,ne:viz sazebník', 'Woven fabrics of yarn containing predominantly, but < 85% synthetic filament by'),
('54078200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny ostatní,pod 85% hedvábí syntetické,s bavlnou,barvené,ne:viz sazebník', 'Woven fabrics of yarn containing predominantly, but < 85% synthetic filament by'),
('54078300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny ostatní,pod 85% hedvábí syntetické,s bavlnou,z různobarevných přízí', 'Woven fabrics of yarn containing predominantly, but < 85% synthetic filament by'),
('54078400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny ostatní,pod 85% hedvábí syntetické,s bavlnou,potisknuté,ne:sazebník', 'Woven fabrics of yarn containing predominantly, but < 85% synthetic filament by'),
('54079100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny ostatní,pod 85% hedvábí syntetické,nebělené,bělené,ne:viz sazebník', 'Woven fabrics of yarn containing predominantly, but < 85% synthetic filament by'),
('54079200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny ostatní,pod 85% hedvábí syntetické,barvené,ne:viz sazebník', 'Woven fabrics of yarn containing predominantly, but < 85% synthetic filament by'),
('54079300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny ostatní,pod 85% hedvábí syntetické,z různobarevných přízí,ne:sazebník', 'Woven fabrics of yarn containing predominantly, but < 85% synthetic filament by'),
('54079400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny ostatní,pod 85% hedvábí syntetické,potisknuté,ne:viz sazebník', 'Woven fabrics of yarn containing predominantly, but < 85% synthetic filament by'),
('54081000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z příze vysokopevnostní z viskózových vláken', 'Woven fabrics of high-tenacity viscose yarn, incl. monofilament of >= 67 decitex'),
('54082100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny nad 85% hedvábí umělé nebělené,bělené', 'Woven fabrics of yarn containing >= 85% artificial filament by weight, incl. mon'),
('54082210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny nad 85% hedvábí umělé barvené,šíře 135-155cm,kepr,vazba plátn.,atlas.', 'Woven fabrics of yarn containing >= 85% artificial filament by weight, incl. mon'),
('54082290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny nad 85% hedvábí umělé barvené ostatní,ne:viz sazebník', 'Woven fabrics of yarn containing >= 85% artificial filament by weight, incl. mon'),
('54082300', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny nad 85 % hedvábí umělé z různobarevných přízí,ne:viz sazebník', 'Woven fabrics of yarn containing >= 85% artificial filament by weight, incl. mon'),
('54082400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny nad 85% hedvábí umělé potisknuté', 'Woven fabrics of yarn containing >= 85% artificial filament by weight, incl. mon'),
('54083100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny ostatní do 85% hedvábí umělé nebělené,bělené,ne:viz sazebník', 'Woven fabrics of yarn containing predominantly, but < 85% artificial filament by'),
('54083200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny ostatní do 85% hedvábí umělé barvené,ne:viz sazebník', 'Woven fabrics of yarn containing predominantly, but < 85% artificial filament by'),
('54083300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny ostatní do 85% hedvábí umělé z různobarevných přízí,ne:viz sazebník', 'Woven fabrics of yarn containing predominantly, but < 85% artificial filament by'),
('54083400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny ostatní do 85% hedvábí umělé potisknuté,ne:viz sazebník', 'Woven fabrics of yarn containing predominantly, but < 85% artificial filament by'),
('55011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kabel z nylonu a jiných polyamidů', 'Filament tow as specified in Note 1 to chapter 55, of nylon or other polyamides'),
('55012000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kabel z polyesterů', 'Filament tow as specified in Note 1 to chapter 55, of polyesters'),
('55013000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kabel akrylový,modakrylový', 'Filament tow as specified in Note 1 to chapter 55, acrylic or modacrylic'),
('55014000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kabely ze syntetických nekonečných vláken z polypropylenu', 'Synthetic filament tow as specified in Note 1 to chapter 55, of polypropylene'),
('55019000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kabely ze syntetických nekonečných vláken ostatní,ne:viz sazebník', 'Synthetic filament tow as specified in Note 1 to chapter 55 (excl. that of acryl'),
('55020010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kabel z viskózového vlákna', 'Artificial filament tow as specified in Note 1 to chapter 55, of viscose rayon'),
('55020040', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kabely z umělých nekonečných vláken z acetátu', 'Artificial filament tow as specified in Note 1 to chapter 55, of acetate'),
('55020080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kabely z umělých nekonečných vláken ostatní,ne:viz sazebník', 'Artificial filament tow, as specified in Note 1 to chapter 55 (excl. of viscose'),
('55031100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlákna střižová z aromat.polyamidů,nezprac.pro spřádání', 'Staple fibres of aramids, not carded, combed or otherwise processed for spinning'),
('55031900', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlákna střižová z nylonu aj.polyamidů ost.,nezprac.pro spřádání,ne:viz sazebník', 'Staple fibres of nylon or other polyamides, not carded, combed or otherwise proc'),
('55032000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlákna střižová z polyesterů nemykaná,nečesaná', 'Staple fibres of polyesters, not carded, combed or otherwise processed for spinn'),
('55033000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlákna střižová akrylová,modakrylová nemykaná,nečesaná', 'Acrylic or modacrylic staple fibres, not carded, combed or otherwise processed f'),
('55034000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlákna střižová z polypropylenu nemykaná,nečesaná', 'Staple fibres of polypropylene, not carded, combed or otherwise processed for sp'),
('55039000', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlákna střižová syntetická ostatní,nemykaná,nečesaná,ne:viz sazebník', 'Synthetic staple fibres, not carded, combed or otherwise processed for spinning'),
('55041000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlákna střižová viskózová nemykaná,nečesaná', 'Staple fibres of viscose rayon, not carded, combed or otherwise processed for sp'),
('55049000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlákna střižová umělá ostatní nemykaná,nečesaná,ne:viskózová', 'Artificial staple fibres, not carded, combed or otherwise processed for spinning'),
('55051010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad z nylonu a jiných polyamidů včetně výčesků,přízového odpadu,trhaného materiálu', 'Waste of staple fibres of nylon or other polyamides, incl. noils, yarn waste and'),
('55051030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad z polyesterů včetně výčesků,přízového odpadu,trhaného materiálu', 'Waste of staple fibres of polyesters, incl. noils, yarn waste and garnetted stoc'),
('55051050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad z vláken akrylnitrilových,modakrylových vč.výčesků,trhaného materiálu', 'Waste of acrylic or modacrylic staple fibres, incl. noils, yarn waste and garnet'),
('55051070', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad z polypropylenu včetně výčesků,přízového odpadu,trhaného materiálu', 'Waste of polypropylene staple fibres, incl. noils, yarn waste and garnetted stoc'),
('55051090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad z vláken syntetických ostatní včetně výčesků,trhaného mater.,ne:viz sazebník', 'Waste of synthetic staple fibres, incl. noils, yarn waste and garnetted stock (e'),
('55052000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad z vláken umělých včetně výčesků,přízového odpadu,trhaného materiálu', 'Waste of artificial staple fibres, incl. noils, yarn waste and garnetted stock'),
('55061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlákna střižová z nylonu a jiných polyamidů mykaná,česaná', 'Staple fibres of nylon or other polyamides, carded, combed or otherwise processe'),
('55062000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlákna střižová z polyesterů mykaná,česaná', 'Staple fibres of polyesters, carded, combed or otherwise processed for spinning'),
('55063000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlákna střižová akrylová,modakrylová mykaná,česaná', 'Acrylic or modacrylic staple fibres, carded, combed or otherwise processed for s'),
('55069000', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlákna střižová syntetická ostatní mykaná,česaná a jinak zprac.pro spřádání,ne:viz sazebník', 'Synthetic staple fibres carded, combed or otherwise processed for spinning (excl'),
('55070000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlákna střižová umělá mykaná,česaná', 'Artificial staple fibres, carded, combed or otherwise processed for spinning'),
('55081010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nit šicí z vláken střižových polyesterových,neupravená pro drobný prodej', 'Sewing thread of synthetic staple fibres (excl. that put up for retail sale)'),
('55081090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nit šicí z vláken střižových syntetických pro maloobchodní prodej', 'Sewing thread of synthetic staple fibres, put up for retail sale'),
('55082010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nit šicí z vláken střižových umělých,ne:pro drobný prodej', 'Sewing thread of artificial staple fibres (excl. that put up for retail sale)'),
('55082090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nit šicí z vláken střižových umělých pro drobný prodej', 'Sewing thread of artificial staple fibres, put up for retail sale'),
('55091100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze jednoduchá,nad 85% vlákna střižová z nylonu a jiných polyamidů', 'Single yarn containing >= 85% nylon or other polyamide staple fibres by weight ('),
('55091200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze skaná,kablová,nad 85% vlákna střižová z nylonu a jiných polyamidů', 'Multiple "folded" or cabled yarn containing >= 85% nylon or other polyamide stap'),
('55092100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze jednoduchá,nad 85% vlákna střižová polyesterová', 'Single yarn containing >= 85% polyester staple fibres by weight (excl. sewing th'),
('55092200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze skaná,kablová,nad 85% vlákna střižová polyesterová', 'Multiple "folded" or cabled yarn containing >= 85% polyester staple fibres by we'),
('55093100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze jednoduchá,nad 85% vlákna střižová (mod)akrylová', 'Single yarn containing >= 85% acrylic or modacrylic staple fibres by weight (exc'),
('55093200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze skaná,kablová,nad 85% vlákna střižová (mod)akrylová', 'Multiple "folded" or cabled yarn containing >= 85% acrylic or modacrylic staple'),
('55094100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze jednoduchá,nad 85% vlákna střižová syntetická ostatní', 'Single yarn containing >= 85% synthetic staple fibres by weight (excl. sewing th'),
('55094200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze skaná,kablová,nad 85% vlákna střižová syntetická ostatní', 'Multiple "folded" or cabled yarn containing >= 85% synthetic staple fibres by we'),
('55095100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze z vláken střižových polyesterových s vlákny střižovými umělými', 'Yarn containing predominantly, but < 85% polyester staple fibres by weight, mixe'),
('55095200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze z vláken střižových polyesterových s vlnou apod.', 'Yarn containing > 50% to < 85% polyester staple fibres by weight, mixed principa'),
('55095300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze z vlákna střižového polyesterového s bavlnou', 'Yarn containing predominantly, but < 85% polyester staple fibres by weight, mixe'),
('55095900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze z vlákna střižového polyesterového ostatní,ne:viz sazebník', 'Yarn containing predominantly, but < 85% polyester staple fibres by weight, othe'),
('55096100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze z vlákna střižového akrylového,modakrylového s vlnou', 'Yarn containing predominantly, but < 85% acrylic or modacrylic staple fibres by'),
('55096200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze z vlákna střižového akrylového,modakrylového s bavlnou', 'Yarn containing predominantly, but < 85% acrylic or modacrylic staple fibres by'),
('55096900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze z vlákna střižového akrylového,modakrylového ostatní,ne:viz sazebník', 'Yarn containing predominantly, but < 85% acrylic or modacrylic staple fibres by'),
('55099100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze z vlákna střižového syntetického ost.s vlnou,ne:sazebník', 'Yarn containing predominantly, but < 85% synthetic staple fibres by weight, mixe'),
('55099200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze z vlákna střižového syntetického ostatní s bavlnou,ne:viz sazebník', 'Yarn containing predominantly, but < 85% synthetic staple fibres by weight, mixe'),
('55099900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze z vlákna střižového syntetického ostatní,ne:viz sazebník', 'Yarn containing predominantly, but < 85% synthetic staple fibres by weight, othe'),
('55101100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze jednoduchá,nad 85% vlákna střižová umělá', 'Single yarn, containing >= 85% artificial staple fibres by weight (excl. sewing'),
('55101200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze skaná,kablová,nad 85% vlákna střižová umělá', 'Multiple "folded" or cabled yarn containing >= 85% artificial staple fibres by w'),
('55102000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze z vlákna střižového umělého s vlnou,jemnými zvířecími chlupy', 'Yarn containing predominantly, but < 85% artificial staple fibres by weight, mix'),
('55103000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze z vlákna střižového umělého s bavlnou', 'Yarn containing predominantly, but < 85% artificial staple fibres by weight, mix'),
('55109000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze z vlákna střižového umělého ostatní,ne:viz sazebník', 'Yarn containing predominantly, but < 85% artificial staple fibres by weight, oth'),
('55111000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze,85% a víc vlákna střižová syntetická upravená pro drobný prodej', 'Yarn containing >= 85% synthetic staple fibres by weight, put up for retail sale'),
('55112000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze,pod 85% vlákna střižová syntetická upravená pro drobný prodej', 'Yarn containing predominantly, but < 85% synthetic staple fibres by weight, put'),
('55113000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze z vláken střižových umělých upravená pro drobný prodej', 'Yarn of artificial staple fibres, put up for retail sale (excl. sewing thread)'),
('55121100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,85% a víc vlákna střižová polyesterová nebělené,bělené', 'Woven fabrics containing >= 85% polyester staple fibres by weight, unbleached or'),
('55121910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,85% a víc vlákna střižová polyesterová potisknuté', 'Woven fabrics containing >= 85% polyester staple fibres by weight, printed'),
('55121990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,85% a víc vlákna střižová polyester.ost.,ne:bělené,nebělené,potisknuté', 'Woven fabrics containing >= 85% polyester staple fibres by weight, dyed or made'),
('55122100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,85% a víc vlákna střižová akrylová,modakrylová nebělené,bělené', 'Woven fabrics containing >= 85% acrylic or modacrylic staple fibres by weight, u'),
('55122910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,85% a víc vlákna střižová akrylová,modakrylová potisknuté', 'Woven fabrics containing >= 85% acrylic or modacrylic staple fibres by weight, p'),
('55122990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,85% a víc vlákna střižová (mod)akrylová ost.,ne:potisknuté,(ne)bělené', 'Woven fabrics containing >= 85% acrylic or modacrylic staple fibres by weight, d'),
('55129100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,85% a víc vlákna střižová syntetická ostatní,ne:viz sazebník', 'Woven fabrics containing >= 85% synthetic staple fibres by weight, unbleached or'),
('55129910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,85% a víc vlákna střižová syntetická ostatní potisknuté,ne:viz sazebník', 'Woven fabrics containing >= 85% synthetic staple fibres by weight, printed (excl'),
('55129990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,85% a víc vlákna střižová syntetická ostatní,ne:viz sazebník', 'Woven fabrics containing >= 85% synthetic staple fibres by weight, dyed or made'),
('55131120', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z polyester.střiž.vl.(pod 85%)+bavlna,hmotn.do 170g/m2,šíře do 165 cm', 'Plain woven fabrics containing predominantly, but < 85% polyester staple fibres'),
('55131190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% polyester.střiž.vl.+bavlna,(ne)bělené,do 170g/m2,šíře nad 165cm', 'Plain woven fabrics containing predominantly, but < 85% polyester staple fibres'),
('55131200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% polyester.střiž.vl.+bavlna,vazba kepr,(ne)bělené,do 170g/m2', 'Woven fabrics containing predominantly, but < 85% polyester staple fibres by wei'),
('55131300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% polyester.střiž.vl.ostatní (ne)bělené,do 170g/m2,ne:viz sazebník', 'Woven fabrics containing predominantly, but < 85% polyester staple fibres by wei'),
('55131900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% vlákna syntetická ostatní nebělené,bělené,do 170g/m2,ne:viz sazebník', 'Woven fabrics containing predominantly, but < 85% synthetic staple fibres by wei'),
('55132100', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% polyester.střiž.vl.+bavlna,v plátnové vazbě,barvené', 'Plain woven fabrics containing predominantly, but < 85% polyester staple fibres'),
('55132310', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% polyester.střiž.vl.+bavlna,vazba kepr,barvené,do 170g/m2', 'Woven fabrics containing predominantly, but < 85% polyester staple fibres by wei'),
('55132390', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% polyester.střiž.vl.+bavlna ostatní barvené,do 170g/m2', 'Woven fabrics containing predominantly, but < 85% polyester staple fibres by wei'),
('55132900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% vlákna syntetická ostatní+bavlna barvené,do 170g/m2', 'Woven fabrics containing predominantly, but < 85% synthetic staple fibres by wei'),
('55133100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% polyester.střiž.vl.+bavlna,plátn.vazba,různobarevné,do 170g/m2', 'Plain woven fabrics containing predominantly, but < 85% polyester staple fibres'),
('55133900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% vlákna syntetická+bavlna ost.,různobarevné,do 170g/m2', 'Woven fabrics containing predominantly, but < 85% synthetic staple fibres by wei'),
('55134100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% polyester.střiž.vl.+bavlna,plátnová vazba,potisk.,do 170g/m2', 'Plain woven fabrics containing predominantly, but < 85% polyester staple fibres'),
('55134900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% vlákna syntetická ostatní+bavlna,potisknuté,do 170g/m2', 'Woven fabrics containing predominantly, but < 85% synthetic staple fibres by wei'),
('55141100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% polyester.střiž.vl.+bavlna,plátn.vazba,(ne)bělené,nad 170g/m2', 'Plain woven fabrics containing predominantly, but < 85% polyester staple fibres'),
('55141200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% polyester.střiž.vl.+bavlna,vazba kepr,(ne)bělené,nad 170g/m2', 'Woven fabrics containing predominantly, but < 85% polyester staple fibres by wei'),
('55141910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% polyester.střiž.vl.+bavlna,nebělené,bělené ostatní,nad 170g/m2', 'Woven fabrics containing predominantly, but < 85% polyester staple fibres by wei'),
('55141990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% vlákna syntet.ost.+bavlna,(ne)bělené,nad 170g/m2,ne:sazebník', 'Woven fabrics containing predominantly, but < 85% synthetic staple fibres by wei'),
('55142100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% polyester.střiž.vl.+bavlna,plátnová vazba,barvené,nad 170g/m2', 'Plain woven fabrics containing predominantly, but < 85% polyester staple fibres'),
('55142200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% polyester.střiž.vl.+bavlna,vazba kepr,barvené,nad 170g/m2', 'Woven fabrics containing predominantly, but < 85% polyester staple fibres by wei'),
('55142300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% polyester.střiž.vl.+bavlna ost.,barvené,nad 170g/m2,ne:viz sazebník', 'Woven fabrics containing predominantly, but < 85% polyester staple fibres by wei'),
('55142900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% vlákna syntetická ost.+bavlna,barvené,nad 170g/m2,ne:viz sazebník', 'Woven fabrics containing predominantly, but < 85% synthetic staple fibres by wei'),
('55143010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85%polyester.střiž.vl.+bavlna,plátn.vazba,různobarevné,nad 170g/m2', 'Plain woven fabrics containing predominantly, but < 85% polyester staple fibres'),
('55143030', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% polyester.střiž.vl.+bavlna,vazba kepr,různobarevné,nad 170g/m2', 'Woven fabrics containing predominantly, but < 85% polyester staple fibres by wei'),
('55143050', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% polyester.střiž.vl.+bavlna ost.,různobar.,nad 170g/m2,ne:sazeb', 'Woven fabrics containing predominantly, but < 85% polyester staple fibres by wei'),
('55143090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% vlákna syntetická+bavlna ost.,různobar.,nad 170g/m2,ne:sazební', 'Woven fabrics containing predominantly, but < 85% synthetic staple fibres by wei'),
('55144100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% polyester.střiž.vl.+bavlna,plátn.vazba,potisknuté,nad 170g/m2', 'Plain woven fabrics containing predominantly, but < 85% polyester staple fibres'),
('55144200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% polyester.střiž.vl.+bavlna,vazba kepr,potisknuté,nad 170g/m2', 'Woven fabrics containing predominantly, but < 85% polyester staple fibres by wei'),
('55144300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% polyester.střiž.vl.+bavlna,potisknuté,nad 170g/m2', 'Woven fabrics containing predominantly, but < 85% polyester staple fibres by wei'),
('55144900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% vlákna syntetická ost.+bavlna,potisknuté,nad 170g/m2,ne:viz sazebník', 'Woven fabrics containing predominantly, but < 85% synthetic staple fibres by wei'),
('55151110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z polyester.střiž.vl.s vláknem viskózovým střižovým bělené,nebělené', 'Woven fabrics containing predominantly, but < 85% polyester staple fibres by wei'),
('55151130', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z polyester.střiž.vl.s vláknem viskózovým střižovým potisknuté', 'Woven fabrics containing predominantly, but < 85% polyester staple fibres by wei'),
('55151190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z polyester.střiž.vl.s vláknem viskózovým střižovým,ne:viz sazebník', 'Woven fabrics containing predominantly, but < 85% polyester staple fibres by wei'),
('55151210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z polyester.střiž.vl.s chemickým hedvábím bělené,nebělené', 'Woven fabrics containing predominantly, but < 85% polyester staple fibres by wei'),
('55151230', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z polyester.střiž.vl.s chemickým hedvábím potisknuté', 'Woven fabrics containing predominantly, but < 85% polyester staple fibres by wei'),
('55151290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z polyester.střiž.vl.s chemickým hedvábím ostatní,ne:viz sazebník', 'Woven fabrics containing predominantly, but < 85% polyester staple fibres by wei'),
('55151311', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny polyesterové s mykanou vlnou, ne bělené, nebělené', 'Woven fabrics containing predominantly, but < 85% polyester staple fibres by wei'),
('55151319', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny polyesterové s mykanou vlnou, ne bělené, nebělené', 'Woven fabrics containing predominantly, but < 85% polyester staple fibres by wei'),
('55151391', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny polyesterové s česanou vlnou bělené, nebělené', 'Woven fabrics containing predominantly, but < 85% polyester staple fibres by wei'),
('55151399', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny polyesterové s česanou vlnou, ne bělené, nebělené', 'Woven fabrics containing predominantly, but < 85% polyester staple fibres by wei'),
('55151910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny polyesterové ostatní bělené, nebělené', 'Woven fabrics containing predominantly, but < 85% polyester staple fibres by wei'),
('55151930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny polyesterové ostatní potisknuté', 'Woven fabrics containing predominantly, but < 85% polyester staple fibres by wei'),
('55151990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny polyesterové ostatní, ne bělené, nebělené, potisknuté', 'Woven fabrics containing predominantly, but < 85% polyester staple fibres by wei'),
('55152110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z (mod)akrylových střiž.vl.s hedvábím chemickým bělené,nebělené', 'Woven fabrics containing predominantly, but < 85% acrylic or modacrylic staple f'),
('55152130', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z (mod)akrylových střiž.vl.s hedvábím chemickým potisknuté', 'Woven fabrics containing predominantly, but < 85% acrylic or modacrylic staple f'),
('55152190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z (mod)akrylových střiž.vl.s hedvábím chemickým ostatní,ne:viz sazebník', 'Woven fabrics containing predominantly, but < 85% acrylic or modacrylic staple f'),
('55152211', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny akrylové, modakrylové s mykanou vlnou bělené, nebělené', 'Woven fabrics containing predominantly, but < 85% acrylic or modacrylic staple f'),
('55152219', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny akrylové, modakrylové s mykanou vlnou potisknuté', 'Woven fabrics containing predominantly, but < 85% acrylic or modacrylic staple f'),
('55152291', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny akrylové, modakrylové s česanou vlnou bělené, nebělené', 'Woven fabrics containing predominantly, but < 85% acrylic or modacrylic staple f'),
('55152299', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny akrylové, modakrylové s česanou vlnou, ne bělené, nebělené', 'Woven fabrics containing predominantly, but < 85% acrylic or modacrylic staple f'),
('55152900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z (mod)akrylových střiž.vl.ostatní,ne:viz sazebník', 'Woven fabrics containing predominantly, but < 85% acrylic or modacrylic staple f'),
('55159110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z vláken syntet.ostatní s hedvábím chemickým (ne)bělené,ne:viz sazebník', 'Woven fabrics containing predominantly, but < 85% synthetic staple fibres, mixed'),
('55159130', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z vláken syntet.ostatní s hedvábím chemickým potisknuté,ne:viz sazebník', 'Woven fabrics containing predominantly, but < 85% synthetic staple fibres, mixed'),
('55159190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z vláken syntet.ostatní s hedvábím chemickým,ne:viz sazebník', 'Woven fabrics containing predominantly, but < 85% synthetic staple fibres, mixed'),
('55159920', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z vláken syntetických ostatní bělené,nebělené,ne:viz sazebník', 'Woven fabrics containing predominantly, but < 85% synthetic staple fibres, other'),
('55159940', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z vláken syntetických ostatní potisknuté,ne:viz sazebník', 'Woven fabrics containing predominantly, but < 85% synthetic staple fibres, other'),
('55159980', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z vláken syntetických ostatní,ne:viz sazebník', 'Woven fabrics containing predominantly, but < 85% synthetic staple fibres, other'),
('55161100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,85% a víc vlákna střižová umělá,nebělené,bělené', 'Woven fabrics containing >= 85% artificial staple fibres by weight, unbleached o'),
('55161200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,85% a víc vlákna střižová umělá,barvené', 'Woven fabrics containing >= 85% artificial staple fibres by weight, dyed'),
('55161300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,85% a víc vlákna střižová umělá,z různobarevných přízí', 'Woven fabrics containing >= 85% artificial staple fibres by weight, made of yarn'),
('55161400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,85% a víc vlákna střižová umělá,potisknuté', 'Woven fabrics containing >= 85% artificial staple fibres by weight, printed'),
('55162100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% vlákna střižová umělá s chemickým hedvábím,nebělené,bělené', 'Woven fabrics containing predominantly, but < 85% artificial staple fibres, mixe'),
('55162200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% vlákna střižová umělá s chemickým hedvábím,barvené', 'Woven fabrics containing predominantly, but < 85% artificial staple fibres, mixe'),
('55162310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% vlákna střižová umělá s chem.hedvábím,žakárové,šíře 140cm a více', 'Woven jacquard fabrics containing predominantly, but < 85% artificial staple fib'),
('55162390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% vlákna střižová umělá s chem.hedvábím,různobarevné,ne:žakárové', 'Woven fabrics containing predominantly, but < 85% artificial staple fibres by we'),
('55162400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% vlákna střižová umělá s chem. hedvábím,potisknuté', 'Woven fabrics containing predominantly, but < 85% artificial staple fibres by we'),
('55163100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% vlákna střižová umělá s vlnou,nebělené,bělené', 'Woven fabrics containing predominantly, but < 85% artificial staple fibres by we'),
('55163200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% vlákna střižová umělá s vlnou,barvené', 'Woven fabrics containing predominantly, but < 85% artificial staple fibres by we'),
('55163300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% vlákna střižová umělá s vlnou,z různobarevných přízí', 'Woven fabrics containing predominantly, but < 85% artificial staple fibres by we'),
('55163400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% vlákna střižová umělá s vlnou,potisknuté', 'Woven fabrics containing predominantly, but < 85% artificial staple fibres by we'),
('55164100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% vlákna střižová umělá s bavlnou,nebělené,bělené', 'Woven fabrics containing predominantly, but < 85% artificial staple fibres by we'),
('55164200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% vlákna střižová umělá s bavlnou,barvené', 'Woven fabrics containing predominantly, but < 85% artificial staple fibres by we'),
('55164300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% vlákna střižová umělá s bavlnou,z různobarevných přízí', 'Woven fabrics containing predominantly, but < 85% artificial staple fibres by we'),
('55164400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny,pod 85% vlákna střižová umělá s bavlnou,potisknuté', 'Woven fabrics containing predominantly, but < 85% artificial staple fibres by we'),
('55169100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z vláken střižových umělých ostatní nebělené,bělené,ne:viz sazebník', 'Woven fabrics containing predominantly, but < 85% artificial staple fibres by we'),
('55169200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z vláken střižových umělých ostatní barvené,ne:viz sazebník', 'Woven fabrics containing predominantly, but < 85% artificial staple fibres by we'),
('55169300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z vláken střižových umělých ostatní z různobarevných přízí,ne:viz sazebník', 'Woven fabrics containing predominantly, but < 85% artificial staple fibres by we'),
('55169400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z vláken střižových umělých ostatní potisknuté,ne:viz sazebník', 'Woven fabrics containing predominantly, but < 85% artificial staple fibres by we'),
('56011010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vložky,tampóny hygienické,pleny apod.z vaty z vláken chemických', 'Sanitary towels and tampons, napkins and napkin liners for babies and similar sa'),
('56011090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vložky,tampóny hygienické,pleny apod.z vaty z mat.textil.ost.,ne:chem.vlákna', 'Sanitary towels and tampons, napkins and napkin liners for babies and similar sa'),
('56012110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vata bavlněná absorpční,výrobky z vaty', 'Absorbent cotton wadding and articles thereof (excl. sanitary towels and tampons'),
('56012190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vata bavlněná ostatní,výrobky z vaty,ne:absorpční', 'Wadding of non-absorbent cotton and articles thereof (excl. sanitary towels and'),
('56012210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Náviny z vaty z vláken chemických,průměr <= 8mm', 'Rolls of wadding of man-made fibres, of a diameter of <= 8 mm (excl. those cover'),
('56012290', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vata z vláken chemických,výrobky z vaty,ne:náviny o průměru <= 8mm', 'Wadding of man-made fibres and articles thereof (excl. rolls of wadding of a dia'),
('56012900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vata z materiálů textilních ostatní,výrobky z vaty', 'Wadding of textile materials and articles thereof (excl. of cotton or man-made f'),
('56013000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilní vločky (vlákno do 5 mm),prach,nopky', 'Textile flock and dust and mill neps'),
('56021011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plsť vpichovaná z juty,jiných vláken lýkových neimpregnovaná,nepovlečená apod.', 'Needleloom felt of jute or of other textile bast fibres of heading 5303, not imp'),
('56021019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plsť vpichovaná z materiálů textilních ost.,ne:z juty a pod.,neimpregnovaná', 'Needleloom felt, not impregnated, coated, covered or laminated, n.e.s.(excl. tha'),
('56021031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Proplety provázané vlastními vlákny z vlny nebo jemných zvířecích chlupů', 'Felt in the form of stitch-bonded fibre fabrics, not impregnated, coated, covere'),
('56021038', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Proplety provázané vlastními vlákny z ost.materiálů textilních,ne:vlna,jemné zvířecí chlupy', 'Felt in the form of stitch-bonded fibre fabrics, not impregnated, coated, covere'),
('56021090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plsť vpichovaná,proplety impregnované,povrstvené,povlečené,laminované', 'Needleloom felt and stitch-bonded fibre fabrics, impregnated, coated, covered or'),
('56022100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plsť nevpichovaná z vlny,jemných zvíř.chlupů neimpregnovanánepovlečená apod.', 'Felt, not impregnated, coated, covered or laminated, of wool or fine animal hair'),
('56022900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plsť nevpichovaná z ost.mater.textilních,ne:z vlny,jemných zvířecích chlupů', 'Felt, not impregnated, coated, covered or laminated (excl. that of wool or fine'),
('56029000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plsť ostatní,ne:viz sazebník', 'Felt, impregnated, coated, covered or laminated (excl. needleloom felt and stitc'),
('56031110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie netkané z chem.vláken,povrstvené,povlečené,do 25g/m2', 'Nonwovens, coated or covered, n.e.s., of man-made filaments, weighing <= 25 g/m2'),
('56031190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie netkané z chem.vláken ostatní,do 25g/m2,ne:viz sazebník', 'Nonwovens, whether or not impregnated or laminated, n.e.s., of man-made filament'),
('56031210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie netkané z chem.vláken,povrstvené,povlečené,nad 25-70g/m2', 'Nonwovens, coated or covered, n.e.s., of man-made filaments, weighing > 25 g/m2'),
('56031290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie netkané z chem.vláken ostatní,nad 25-70g/m2,ne:viz sazebník', 'Nonwovens, whether or not impregnated or laminated, n.e.s., of man-made filament'),
('56031310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie netkané z chem.vláken,povrstvené,povlečené,nad 70-150g/m2', 'Nonwovens, coated or covered, n.e.s., of man-made filaments, weighing > 70 g/m2'),
('56031390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie netkané z chem.vláken ostatní,nad 70-150g/m2,ne:viz sazebník', 'Nonwovens, whether or not impregnated or laminated, n.e.s., of man-made filament'),
('56031410', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie netkané z chem.vláken povrstvené,povlečené,nad 150g/m2', 'Nonwovens, coated or covered, n.e.s., of man-made filaments, weighing > 150 g/m2'),
('56031490', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie netkané z chem.vláken ostatní,nad 150g/m2,ne:viz sazebník', 'Nonwovens, whether or not impregnated or laminated, n.e.s., of man-made filament'),
('56039110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie netkané ostatní,povrstvené,povlečené,do 25g/m2,ne:z chem.vláken', 'Nonwovens, coated or covered, n.e.s., weighing <= 25 g/m2 (excl. of man-made fil'),
('56039190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie netkané ostatní,do 25g/m2,ne:povrstvené,povlečené,z chem.vláken', 'Nonwovens, whether or not impregnated or laminated, n.e.s., weighing <= 25 g/m2'),
('56039210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie netkané ostatní povrstvené,povlečené,nad 25-70g/m2,ne:z chem.vláken', 'Nonwovens, coated or covered, n.e.s., weighing > 25 g/m2 but <= 70 g/m2 (excl. o'),
('56039290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie netkané ostatní,nad 25-70g/m2,ne:povrstvené,povlečené,z chem.vláken', 'Nonwovens, whether or not impregnated or laminated, n.e.s., weighing > 25 g/m2 b'),
('56039310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie netkané ostatní povrstvené,povlečené,nad 70-150g/m2,ne:z chem.vláken', 'Nonwovens, coated or covered, n.e.s., weighing > 70 g/m2 but <= 150 g/m2 (excl.'),
('56039390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie netkané ostatní,nad 70-150g/m2,ne:povrstvené,povlečené,z chem.vláken', 'Nonwovens, whether or not impregnated or laminated, n.e.s., weighing > 70 g/m2 b'),
('56039410', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie netkané ostatní povrstvené,povlečené,nad 150g/m2,ne:z chem.vláken', 'Nonwovens, coated or covered, n.e.s., weighing > than 150 g/m2 (excl. of man-mad'),
('56039490', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie netkané ostatní,nad 150g/m2,ne:povrstvené,povlečené,z che.vláken', 'Nonwovens, whether or not impregnated or laminated, n.e.s., weighing > than 150'),
('56041000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nitě kaučukové,kordové pokryté textilem', 'Textile-covered rubber thread and cord'),
('56049010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze vysokopevnostní z polyesterů,nylonu,polyamidů,viskóz.vláken impregnované', 'High-tenacity yarn of polyesters, nylon, other polyamides or viscose rayon, impr'),
('56049090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze,pásky a podobné tvary textilní ostatní impregnované apod.,ne:viz sazební', 'Textile yarn, strip and the like of heading 5404 and 5405, impregnated, coated,'),
('56050000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze metalizovaná i opředená kombinovaná s kovem', 'Metallised yarn, whether or not gimped, being textile yarn, or strip or the like'),
('56060010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Smyčková pletená nit', 'Loop wale-yarn (excl. metal yarn and metallised yarn of heading 5605; gimped hor'),
('56060091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nit opředená', 'Gimped yarn (excl. metal yarn and metallised yarn of heading 5605; gimped horseh'),
('56060099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příze žinylková,pásky a podobné tvary opředené', 'Chenille yarn, incl. flock chenille yarn; gimped strip and the like of heading 5'),
('56072100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Motouz vázací,balící z vláken sisalových a jiných rodu Agave', 'Binder or baler twine, of sisal or other textile fibres of the genus Agave'),
('56072900', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Provazy apod.z vláken sisalových a jiných rodu Agave,ne:vázací,balicí', 'Twine, cordage, ropes and cables, of sisal or other textile fibres of the genus'),
('56074100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Motouz vázací,balící z polyethylenu,polypropylenu', 'Binder or baler twine, of polyethylene or polypropylene'),
('56074911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Provazy splétané z polyethylenu,polypropylenu nad 50 000 decit,ne:balicí,vázací', 'Twine, cordage, ropes and cables, of polyethylene or polypropylene, plaited or b'),
('56074919', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Provazy z polyethylenu,polypropylenu ost.,nad 50 000 decitexne:viz sazebník', 'Twine, cordage, ropes and cables, of polyethylene or polypropylene, not plaited'),
('56074990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Provazy a pod.z polyethylenu,polypropylenu ostatní,50 000 decitex,ne:sazebník', 'Twine, cordage, ropes and cables, of polyethylene or polypropylene, whether or n'),
('56075011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Provazy apod.z nylonu,jiných polyamidů,polyesterů splétané,nad 50 000 decitex', 'Twine, cordage, ropes and cables of nylon, other polyamides or polyesters, plait'),
('56075019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Provazy apod.z nylonu,jiných polyamidů,polyesterů,nad 50 000 decitex,ne:splétané', 'Twine, cordage, ropes and cables, of nylon, other polyamides or polyesters, not'),
('56075030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Provazy apod.z nylonu,jiných polyamidů,polyesterů,do 50 000 decitex', 'Twine, cordage, ropes and cables, of nylon, other polyamides or polyester, wheth'),
('56075090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Provazy,lana,šňůry apod.z vláken syntetických ostatní,ne:viz sazebník', 'Twine, cordage, ropes and cables, of synthetic fibres, whether or not plaited or'),
('56079020', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Provazy,lana,šňůry,motouzy apod.z abakových ap.vláken,ne:viz sazebník', 'Twine, cordage, ropes and cables, of abaca "Manila hemp or Musa textilis Nee" or'),
('56079090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Provazy,lana,šňůry,motouzy apod.ostatní,ne:viz sazebník', 'Twine, cordage, ropes and cables, whether or not plaited or braided and whether'),
('56081120', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sítě rybářské z materiálů textilních chemických z motouzů,šňůr,provazů,lan,ne:viz sazebník', 'Made-up knotted fishing nets of twine, cordage, ropes or cables, of man-made tex'),
('56081180', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sítě rybářské z nylonu a jiných polyamidů,ne:z motouzů,šňůr,provazů,lan,ne:viz sazebník', 'Made-up knotted fishing nets of yarn, of man-made textile materials (excl. those'),
('56081911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sítě z motouzů,šňůr,provazů,lan z nylonu a jiných polyamidů,ne:rybářské', 'Made-up knotted nets of twine, cordage, ropes or cables, of nylon or other polya'),
('56081919', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sítě ostatní z nylonu a jiných polyamidů,ne:rybářské,z motouzů,šňůr,lan,provazů', 'Made-up knotted nets of nylon or other polyamides (excl. those of twine, cordage'),
('56081930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sítě zhotovené ost.,ne:rybářské;z nylonu nebo jiných polyamidů', 'Made-up knotted nets of man-made textile materials (excl. those of nylon or othe'),
('56081990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Síťoviny vázané ze syntetických nebo umělých materiálů ost.,ne:viz sazebník', 'Knotted netting of twine, cordage, ropes or cables, by the piece or metre, of ma'),
('56089000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Síťoviny vázané z motouzů,šňůr,provazů', 'Knotted netting of twine, cordage, ropes or cables, by the piece or metre; made-'),
('56090000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z nití,pásků a podobných tvatů ostatní,ne:viz sazebník', 'Articles of yarn, strip or the like of heading 5404 or 5405, or of twine, cordag'),
('57011010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné podlahové krytiny vázané z vlny,zvíř.chlupů,nad 10% hedvábí', 'Carpets and other textile floor coverings, of wool or fine animal hair, knotted,'),
('57011090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné podlahové krytiny vázané z vlny apod. ostatní,ne:sazebník', 'Carpets and other textile floor coverings, of wool or fine animal hair, knotted,'),
('57019010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce apod.vázané z hedvábí,vláken syntetických textilních,příze metalizované', 'Carpets and other textile floor coverings, of silk, waste silk other than noil,'),
('57019090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné podlah.krytiny vázané z materiálů textilních ostatní,ne:viz sazebník', 'Carpets and other textile floor coverings, of textile materials, knotted, whethe'),
('57021000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce Kelim,Schumacks,Karamanie a podobné ručně tkané', 'Kelem, Schumacks, Karamanie and similar hand-woven rugs, whether or not made up'),
('57022000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Krytiny podlahové z vláken kokosových tkané', 'Floor coverings of coconut fibres "coir", woven, whether or not made up'),
('57023110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce Axminsterské,nezhot.ost.z vlny,zvíř.chlupů,ne:viz sazebník', 'Axminster carpets of wool or fine animal hair, woven, not tufted or flocked, of'),
('57023180', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné podlah.krytiny nevšív.,nezhot.ost.z vlny,zvíř.chlupů,ne:viz sazebník', 'Carpets and other floor coverings, of wool or fine animal hair, woven, not tufte'),
('57023210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce Axminsterské,nezhot.ost.ze synt,umělých vl.,ne:viz saz', 'Axminster carpets of man-made textile materials, woven, not tufted or flocked, o'),
('57023290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné podlah.krytiny nevšív.,nezhot.ost.ze synt,umělých vl.,ne:viz saz', 'Carpets and other floor coverings, of man-made textile materials, woven, not tuf'),
('57023900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné ost.s vlasem z materiálů textilních ost.,ne:viz sazebník', 'Carpets and other floor coverings, of vegetable textile materials or coarse anim'),
('57024110', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné podlah.krytiny nevšív.,zhotov.,z vlny,zvíř.chlupů,Axminsterské', 'Axminster carpets of wool or fine animal hair, woven, not tufted or flocked, of'),
('57024190', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné podlah.krytiny nevšív.,zhotov.,ost.,z vlny,zvíř.chlupů,ne:viz sazebník', 'Carpets and other floor coverings, of wool or fine animal hair, woven, not tufte'),
('57024210', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné podlah.krytiny nevšív.,zhotov.,z chem.textil.mat.,Axminsterské', 'Axminster carpets of man-made textile materials, woven, not tufted or flocked, o'),
('57024290', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné podlah.krytiny nevšív.,zhotov.,ost.,z chem.textil.mat.,ne:viz sazebník', 'Carpets and other floor coverings, of man-made textile materials, woven, not tuf'),
('57024900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce s vlasem z materiálů textilních ostatních tkané hotové,ne:viz sazebník', 'Carpets and other floor coverings, of vegetable textile materials or coarse anim'),
('57025010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné bez vlasu z vlny,jemných zvířecích chlupů tkané nehotové', 'Carpets and other floor coverings, of wool or fine animal hair, woven, not tufte'),
('57025031', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné bez vlasu z polypropylenu tkané nehotové', 'Carpets and other floor coverings, of polypropylene, woven, not tufted or flocke'),
('57025039', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné bez vlasu z materiálů textilních chemických tkané nehotové,ne:sazebník', 'Carpets and other floor coverings, of man-made textile materials, woven, not tuf'),
('57025090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné bez vlasu z materiálů textilních ost.tkané nehotové,ne:sazebník', 'Carpets and other floor coverings, of vegetable textile materials or coarse anim'),
('57029100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné bez vlasu z vlny,jemných zvířecích chlupů tkané hotové', 'Carpets and other floor coverings, of wool or fine animal hair, woven, not tufte'),
('57029210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné bez vlasu z polypropylenu tkané hotové', 'Carpets and other floor coverings, of polypropylene, woven, not tufted or flocke'),
('57029290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné bez vlasu z materiálů textilních chemických tkané hotové,ne:viz sazebník', 'Carpets and other floor coverings, of man-made textile materials, woven, not tuf'),
('57029900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné bez vlasu z materiálů textilních ost.tkané hotové,ne:sazebník', 'Carpets and other floor coverings, of vegetable textile materials or coarse anim'),
('57031000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné podlah.krytiny všívané z vlny nebo jemných zvířecích chlupů', 'Carpets and other floor coverings, of wool or fine animal hair, tufted "needle p'),
('57032012', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné podlah.krytiny všívané,potisknuté,z nylonu a jiných polyamidů,plocha <= 1m2 (dlaždice)', 'Tiles, of nylon or other polyamides, tufted "needle punched", whether or not mad'),
('57032018', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné podlah.krytiny všívané,potisknuté,z nylonu a jiných polyamidů,plocha > 1m2', 'Carpets and other floor coverings, of nylon or other polyamides, tufted "needle'),
('57032092', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné podlah.krytiny všívané,nepotisknuté,z nylonu a jiných polyamidů,plocha <= 1m2 (dlaždice)', 'Tiles, of nylon or other polyamides, tufted "needle punched", whether or not mad'),
('57032098', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné podlah.krytiny všívané,nepotisknuté,z nylonu a jiných polyamidů,plocha > 1m2', 'Carpets and other textile floor coverings, of nylon or other polyamides, tufted'),
('57033012', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné podlah.krytiny všívané,z polypropylenu,plocha <= 1m2', 'Tiles, of polypropylene, tufted "needle punched", whether or not made up (excl.'),
('57033018', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné podlah.krytiny všívané,z polypropylenu,plocha > 1m2', 'Carpets and other floor coverings, of polypropylene, tufted "needle punched", wh'),
('57033082', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné podlah.krytiny všívané,z mater.textil.chem.ost,plocha <= 1m2,ne:viz sazebník', 'Tiles, of man-made textile materials, tufted "needle punched", whether or not ma'),
('57033088', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné podlah.krytiny všívané,z mater.textil.chem.ost,plocha > 1m2,ne:viz sazebník', 'Carpets and other floor coverings, of man-made textile materials, tufted "needle'),
('57039020', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné podlah.krytiny všívané,z mater.textil.ost,plocha <= 1m2,ne:viz sazebník', 'Tiles, of vegetable textile materials or coarse animal hair, tufted "needle punc'),
('57039080', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné podlah.krytiny všívané,z mater.textil.ost,plocha > 1m2,ne:viz sazebník', 'Carpet and other floor coverings, of vegetable textile materials or coarse anima'),
('57041000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Dlaždice z plsti nevšívané,nopovločkované i hotové,plocha do 0,3m2', 'Floor tiles, of felt, not tufted or flocked, with an area of <= 0,3 m2'),
('57049000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné textil.podlah.krytiny z plsti ost.nevšívané i hotové,ne:viz sazebník', 'Carpets and other floor coverings, of felt, not tufted or flocked, whether or no'),
('57050010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce,krytiny podlahové ostatní z vlny,jemných zvířecích chlupů,ne:viz sazebník', 'Carpets and other floor coverings, of wool or fine animal hair, whether or not m'),
('57050030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné podlah.krytiny ostatní,ne:viz sazebník', 'Carpets and other floor coverings, of man-made textile materials, whether or not'),
('57050090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Koberce a jiné ost.z materiálů textilních ost.,ne:viz sazebník', 'Carpets and other floor coverings, of vegetable textile materials or coarse anim'),
('58011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny vlasové,žinylkové z vlny,jemných zvířecích chlupů', 'Woven pile fabrics and chenille fabrics, of wool or fine animal hair (excl. terr'),
('58012100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny z bavlny neřezané útkové vlasové', 'Uncut weft pile fabrics, of cotton (excl. terry towelling and similar woven terr'),
('58012200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Manšestr řezaný z bavlny', 'Cut corduroy, of cotton (excl. terry towelling and similar woven terry fabrics,'),
('58012300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny jiné útkové vlasové z bavlny,ne:neřezané útkové vlasové,řezaný manšestr', 'Cut weft pile fabrics, of cotton (excl. terry towelling and similar woven terry'),
('58012400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny vlasové osnovní,epingl (neřezané) z bavlny', 'Uncut warp pile fabrics "Ă©pinglĂ©", of cotton (excl. terry towelling and simila'),
('58012500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny vlasové osnovní,řezané z bavlny', 'Cut warp pile fabrics, of cotton (excl. terry towelling and similar woven terry'),
('58012600', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny žinylkové z bavlny', 'Chenille fabrics, of cotton (excl. terry towelling and similar woven terry fabri'),
('58013100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny vlasové útkové neřezané z vláken chemických', 'Uncut weft pile fabrics, of man-made fibres (excl. terry towelling and similar w'),
('58013200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Manšestr řezaný z vláken chemických', 'Cut corduroy, of man-made fibres (excl. terry towelling and similar woven terry'),
('58013300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny vlasové útkové jiné z vláken chemických', 'Cut weft pile fabrics, of man-made fibres (excl. terry towelling and similar wov'),
('58013400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny vlasové osnovní,epingl z vláken chemických', 'Uncut warp pile fabrics "Ă©pinglĂ©", of man-made fibres (excl. terry towelling a'),
('58013500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny vlasové osnovní řezané z vláken chemických', 'Cut warp pile fabrics, of man-made fibres (excl. terry towelling and similar wov'),
('58013600', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny žinylkové z vláken chemických', 'Chenille fabrics, of man-made fibres (excl. terry towelling and similar woven te'),
('58019010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny vlasové,žinylkové ze lnu', 'Woven pile fabrics and chenille fabrics, of flax (excl. terry towelling and simi'),
('58019090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny vlasové,žinylkové z materiálů textilních ostatních,ne:viz sazebník', 'Woven pile fabrics and chenille fabrics (excl. those of flax, man-made fibres, w'),
('58021100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Smyčkové ručníkoviny a podobné tkaniny smyčkové z bavlny nebělené', 'Terry towelling and similar woven terry fabrics, of cotton, unbleached (excl. na'),
('58021900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Smyčkové ručníkoviny a podobné tkaniny smyčkové z bavlny ost.,ne:nebělené', 'Terry towelling and similar woven terry fabrics, of cotton (excl. unbleached, na'),
('58022000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Smyčkové ručníkoviny a podobné tkaniny smyčkové z materiálů ost.,ne:z bavlny', 'Terry towelling and similar woven terry fabrics (excl. those of cotton, narrow w'),
('58023000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Textilie všívané,ne:koberce a podobné podlahové krytiny', 'Tufted textile fabrics (excl. carpets and other floor coverings)'),
('58030010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny perlinkové z bavlny,ne:stuhy', 'Cotton gauze (excl. narrow woven fabrics of heading 5806)'),
('58030030', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny perlinkové z hedvábí pravého,hedvábného odpadu,ne:stuhy', 'Gauze of silk or silk waste (excl. narrow woven fabrics of heading 5806)'),
('58030090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny perlinkové z materiálů textilních ostatních,ne:viz sazebník', 'Gauze (excl. that of silk, silk waste or cotton, and narrow woven fabrics of hea'),
('58041010', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyly a jiné textilie síťové hladké,ne:textilie síťové vázané', 'Tulles and other net fabrics, plain (excl. knotted net fabrics, and woven, knitt'),
('58041090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyly a jiné textilie síťové ostatní,ne:hladké,textilie síťové vázané', 'Tulles and other net fabrics, patterned (excl. woven, knitted or crocheted fabri'),
('58042110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krajky vyrobené na krajkových paličkovacích strojích z vláken chemických', 'Lace of man-made fibres in the piece, in strips or in motifs, made on mechanical'),
('58042190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krajky strojní z vláken chemických ost.,ne:vyrobené na krajkových paličkovacích strojích', 'Mechanically made lace of man-made fibres in the piece, in strips or in motifs ('),
('58042910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krajky strojní vyrobené na strojích paličkovacích z mater.textil.ost.,ne:viz sazebník', 'Lace in the piece, in strips or in motifs, made on mechanical bobbin machines (e'),
('58042990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krajky strojní z materiálů textilních ostatní,ne:viz sazebník', 'Mechanically made lace in the piece, in strips or in motifs (excl. that of man-m'),
('58043000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krajky vyrobené ručně', 'Handmade lace in the piece, in strips or in motifs (excl. fabrics of heading 600'),
('58050000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tapiserie ručně tkané typu goblén,pracované jehlou', 'Hand-woven tapestries of the type Gobelin, Flanders, Aubusson, Beauvais and the'),
('58061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stuhy vlasové,žinilkové předdílo,smyčkové tkaniny savé', 'Narrow woven pile fabrics, incl. terry towelling and similar terry fabrics, and'),
('58062000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stuhy-tkaniny jiné,nad 5% nitě elastomerové,pryžové,ne:vlasové,žinylkové', 'Narrow woven fabrics of textile materials, containing >= 5% elastomeric yarn or'),
('58063100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stuhy ostatní z bavlny,ne:viz sazebník', 'Narrow woven fabrics of cotton, with a width of <= 30 cm, n.e.s.'),
('58063210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stuhy-tkaniny ostatní z vláken chemických s pravými okraji', 'Narrow woven fabrics of man-made fibres, with real selvedges, with a width of <='),
('58063290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stuhy-tkaniny ostatní z vláken chemických,ne:s pravými okraji', 'Narrow woven fabrics of man-made fibres, without real selvedges, with a width of'),
('58063900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stuhy-tkaniny ostatní z materiálů textilních ostatních,ne:viz sazebník', 'Narrow woven fabrics of textile materials other than cotton or man-made fibres,'),
('58064000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie bez útku zhotovené z osnovních nití spojených pojivem (bolduky)', 'Narrow fabrics consisting of warp without weft assembled by means of an adhesive'),
('58071010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Štítky,odznaky apod.z materiálů textilních s vetkaným nápisem', 'Labels, badges and similar articles, of textile materials, in the piece, in stri'),
('58071090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Štítky,odznaky apod.z materiálů textilních tkané ost.,ne:s vetkaným nápisem', 'Labels, badges and similar articles, of textile materials, in the piece, in stri'),
('58079010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Štítky,odznaky apod.z plsti,textilií netkaných nevyšívané', 'Labels, badges and similar articles, of felt or nonwovens, in the piece, in stri'),
('58079090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Štítky,odznaky apod.z materiálů textilních nevyšívané ost.,ne:viz sazebník', 'Labels, badges and similar articles, of textile materials, in the piece, in stri'),
('58081000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prýmky v metráži', 'Braids in the piece'),
('58089000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ozdobné lemovky,střapce,bambule a podobné výrobky,ne:pletené,háčkované', 'Ornamental trimmings of textile materials, in the piece, not embroidered, other'),
('58090000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tkaniny z nití kovových,příze pokovené jinde neuvedené,ne:viz sazebník', 'Woven fabrics of metal thread and woven fabrics of metallised yarn of heading 56'),
('58101010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výšivky bez viditelného podkladu,hodnota nad 35 Euro/1kg netto hmotnosti', 'Embroidery on a textile fabric ground without visible ground, in the piece, in s'),
('58101090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výšivky bez viditelného podkladu,hodnota do 35 ECU/kg', 'Embroidery on a textile fabric ground without visible ground, in the piece, in s'),
('58109110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výšivky ostatní z bavlny,hodnota nad 17,50 Euro/1kg netto hmotnosti,ne:viz sazebník', 'Embroidery of cotton on a textile fabric ground, in the piece, in strips or in m'),
('58109190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výšivky z bavlny v metráži,hodnota do 17,5 ECU/kg,ne:bez viditelného podkladu', 'Embroidery of cotton on a textile fabric ground, in the piece, in strips or in m'),
('58109210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výšivky ost.ze syntet.,umělých vl.,hodn.nad 17,50 Euro/kg netto,ne:viz sazebník', 'Embroidery of man-made fibres on a textile fabric base, in the piece, in strips'),
('58109290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výšivky z vláken chemických v metráži,hodnota do 17,5 ECU/kg', 'Embroidery of man-made fibres on a textile fabric base, in the piece, in strips'),
('58109910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výšivky ost.z ost.textil.mat.,hodn.nad 17,50 Euro/kg netto,ne:viz sazebník', 'Embroidery of materials other than cotton or man-made fibres, on a textile fabri'),
('58109990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výšivky z materiálů textilních ostatních,hodnota do 17,5 ECU/kg,ne:viz sazebník', 'Embroidery of materials other than cotton or man-made fibres, on a textile fabri'),
('58110000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Výrobky textilní prošívané z vrstev v metráži,spojené s výplňkovým materiálem', 'Quilted textile products in the piece, composed of one or more layers of textile'),
('59011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Textilie na vnější obaly knih povrstvené lepidlem,škrobovými látkami', 'Textile fabrics coated with gum or amylaceous substances, of a kind used for the'),
('59019000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Plátno kopírovací,malířské,ztužené pro kloboučnické podložky', 'Tracing cloth; prepared painting canvas; buckram and similar stiffened textile f'),
('59021010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Textilie pneumatikové kordové z nylonu,jiných polyamidů impregnované kaučukem', 'Tyre cord fabric of high-tenacity yarn of nylon or other polyamides, impregnated'),
('59021090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Textilie pneumatikové kordové z nylonu,jiných polyamidů,ne:impregn.kaučukem', 'Tyre cord fabric of high-tenacity of nylon or other polyamides, whether or not d'),
('59022010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Textilie pneumatikové kordové z polyesterů impregnované kaučukem', 'Tyre cord fabric of high-tenacity polyester yarn, impregnated with rubber'),
('59022090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Textilie pneumatikové kordové z polyesterů ne:impregnované kaučukem', 'Tyre cord fabric of high-tenacity polyester yarn, whether or not dipped or impre'),
('59029010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Textilie pneumatikové kordové z hedvábí viskózového impregnované kaučukem', 'Tyre cord fabric of high-tenacity viscose rayon yarn, impregnated with rubber'),
('59029090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Textilie pneumatikové kordové z hedvábí viskózového,ne:impregnované kaučukem', 'Tyre cord fabric of high-tenacity viscose rayon yarn, whether or not dipped in p'),
('59031010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Textilie impregnované polyvinylchloridem', 'Textile fabrics impregnated with poly"vinyl chloride" (excl. wallcoverings of te'),
('59031090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Textilie povrstvené,povlečené,laminované polyvinylchloridem,ne:impregnované', 'Textile fabrics coated, covered or laminated with poly"vinyl chloride" (excl. wa'),
('59032010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Textilie impregnované polyurethanem', 'Textile fabrics impregnated with polyurethane (excl. wallcoverings of textile ma'),
('59032090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Textilie povrstvené,povlečené,laminované polyurethanem,ne:imregnované', 'Textile fabrics coated, covered or laminated with polyurethane (excl. wallcoveri'),
('59039010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Textilie impregnované plasty ostatními,ne:PVC,polyurethanem', 'Textile fabrics impregnated with plastics other than poly"vinyl chloride" or pol'),
('59039091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Textilie ost.,rub povrstvený,povlečený,laminovaný deriváty celulózy', 'Textile fabrics coated, covered or laminated with cellulose derivatives or plast'),
('59039099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Textilie ost.,povrstvené,povlečené,laminované plasty ost.,ne:viz sazebník', 'Textile fabrics coated, covered or laminated with plastics other than poly"vinyl'),
('59041000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Linoleum i přiříznuté do tvaru', 'Linoleum, whether or not cut to shape'),
('59049000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Krytina podlahová na textilním podkladu ost, i přiříznutá do tvaru,ne:linoleum', 'Floor coverings consisting of a coating or covering applied on a textile backing'),
('59050010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tapety textilní-rovnoběžně uložená příze na podkladu', 'Textile wallcoverings consisting of parallel yarns, fixed on a backing of any ma'),
('59050030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tapety ze lnu ostatní,ne:z nití rovnoběžně uložených na podklad', 'Wallcoverings of flax (excl. consisting of parallel yarns, fixed on a backing of'),
('59050050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tapety textilní z juty,ne:rovnoběžně uložená příze na podkladu', 'Wallcoverings of jute (excl. those consisting of parallel yarns, fixed on a back'),
('59050070', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tapety textilní z vláken chemických,ne:rovnoběžně uložená příze napodkladu', 'Wallcoverings of man-made fibres (excl. those consisting of parallel yarns, fixe'),
('59050090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tapety textilní ostatní,ne:len,juta,vlákna chemická,rovnoběžně uložená příze', 'Textile wallcoverings (excl. those of flax, jute or man-made fibres, and those c'),
('59061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lepící páska pogumovaná,šíře do 20cm,ne:textilie čísla 5902', 'Adhesive tape of rubberised textile fabrics, of a width of <= 20 cm (excl. that'),
('59069100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie pogumované pletené,háčkované', 'Knitted or crocheted textile fabrics, rubberised, n.e.s.'),
('59069910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie pogumované-paralelně uložené textilní příze spojené kaučukem', 'Textile fabrics composed of parallel textile yarns agglomerated with rubber'),
('59069990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie pogumované ostatní,ne:pletené,háčkované,rovnoběžné textilní příze', 'Rubberised textile fabrics (excl. knitted or crocheted textile fabrics, fabrics'),
('59070000', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Textilie impregnované,povrstvené,potažené,plátno malované pro divadelní scénu apod.,ne:pogumované', 'Impregnated, coated or covered textile fabrics; painted canvas being theatrical'),
('59080000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Knoty textilní tkané apod.pro lampy,vařiče apod.,žárové punčošky apod.', 'Textile wicks, woven, plaited or knitted, for lamps, stoves, lighters, candles o'),
('59090010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hadice apod.textilie trubkové z vláken syntetických i s vyložením,příslušenstvím', 'Hosepiping and similar tubing of synthetic fibres, whether or not impregnated or'),
('59090090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hadice apod.textilie trubkové z mater.textil.ost.,ne:z vláken syntetických', 'Textile hosepiping and similar textile tubing, whether or not impregnated or coa'),
('59100000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pásy,řemeny dopravníkové,hnací z materiálů textilních i spojené s jiným materiálem', 'Transmission or conveyor belts or belting, of textile material, whether or not i'),
('59111000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textil,plsti s kaučukem,usní apod.pro technické účely', 'Textile fabrics, felt and felt-lined woven fabrics, coated, covered or laminated'),
('59112000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plátno mlynářské i zcela zhotovené', 'Bolting cloth, whether or not made up'),
('59113111', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Textilie z hedvábí přír.,chem.vláken na papírenské apod.stroje,pod 650g/m2', 'Woven textile fabrics, whether or not felted, of synthetic fibres, endless or fi'),
('59113119', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z hedvábí přír.,chem.vláken na papírenské apod.stroje,pod 650g/m2', 'Woven textile fabrics and felts, of silk or artificial fibres, endless or fitted'),
('59113190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z materiálů textilních ost.na papír.apod.stroje,pod 650g/m2,ne:viz sazebník', 'Textile fabrics and felts, endless or fitted with linking devices, of a kind use'),
('59113211', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Tkaniny s vpich.plstěnou vrstvou,z hedvábí přír.,vláken chem.na papírenské apod.stroje,>=650g/m2,', 'Woven textile fabrics having a batt layer needled on them, of silk or man-made f'),
('59113219', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Textilie z hedvábí přír.,vláken chem.na papírenské apod.stroje,>=650g/m2,ost.,ne:viz sazebník', 'Textile fabrics and felts, of silk or man-made fibres, endless or fitted with li'),
('59113290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z materiálů textil.ost.na papír.apod.stroje,650g/m2 a víc,ne:viz sazebník', 'Textile fabrics and felts, endless or fitted with linking devices, of a kind use'),
('59114000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plachetky filtrační pro olejové lisy a podobná zařízení,vč.z lidských vlasů', 'Straining cloth of a kind used in oil-presses or for similar technical purposes,'),
('59119010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky textilní z plsti pro technické účely ostatní,ne:viz sazebník', 'Felt products and articles, for technical purposes, specified in Note 7 to chapt'),
('59119090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky textilní ostatní pro technické účely,ne:viz sazebník', 'Textile products and articles, for technical purposes, specified in Note 7 to ch'),
('60011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie s dlouhým vlasem pletené,háčkované', '"Long pile" fabrics, knitted or crocheted'),
('60012100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie smyčkové z bavlny pletené,háčkované', 'Looped pile fabrics of cotton, knitted or crocheted'),
('60012200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie smyčkové z vláken chemických pletené,háčkované', 'Looped pile fabrics of man-made fibres, knitted or crocheted'),
('60012900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie smyčkové ostatní pletené,háčkované,ne:bavlna,chem.vlákna', 'Looped pile fabrics, knitted or crocheted (excl. of cotton or man-made fibres)'),
('60019100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie vlasové z bavlny pletené,háčkované', 'Pile fabrics of cotton, knitted or crocheted (excl. "long pile" fabrics)'),
('60019200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie vlasové z vláken chemických pletené,háčkované', 'Pile fabrics of man-made fibres, knitted or crocheted (excl. "long pile" fabrics'),
('60019900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie vlasové z materiálů textilních ostatních pletené,háčkované,ne:viz sazebník', 'Pile fabrics, knitted or crocheted (excl. cotton or man-made fibres and "long pi'),
('60024000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie pletené,háčkované,5%a víc nitě elastomerní,šíře do 30cm,ne:s pryž.vlákny', 'Knitted or crocheted fabrics, of a width of <= 30 cm, containing >= 5% by weight'),
('60029000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie pletené,háčkované,5%a víc nitě elastomerní,šíře do 30cm,s pryž.vlákny', 'Knitted or crocheted fabrics, of a width of <= 30 cm, containing >= 5% by weight'),
('60031000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie pletené,háčkované z bavlny,šíře do 30cm,ne:viz sazebník', 'Knitted or crocheted fabrics of wool or fine animal hair, of a width of <= 30 cm'),
('60032000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie pletené,háčkované z vlny,zvíř.chlupů,šíře do 30cm,ne:viz sazebník', 'Knitted or crocheted fabrics of cotton, of a width of <= 30 cm (excl. those cont'),
('60033010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krajka rašlová ze syntetických vláken,šíře do 30 cm', 'Raschel lace of synthetic fibres, of a width of <= 30 cm (excl. those containing'),
('60033090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie pletené,háčkované ze synt.vláken,šíře do 30cm,ne:viz sazebník', 'Knitted or crocheted fabrics of synthetic fibres, of a width of <= 30 cm (excl.'),
('60034000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie pletené,háčkované z umělých vláken,šíře do 30cm,ne:viz sazebník', 'Knitted or crocheted fabrics of artificial fibres, of a width of <= 30 cm (excl.'),
('60039000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie pletené,háčkované ostatní,šíře do 30cm,ne:viz sazebník', 'Knitted or crocheted fabrics of a width of <= 30 cm (excl. of cotton, man-made f'),
('60041000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie,5% a víc nitě elastomerní plet.,háčkov., šíře nad 30cm,ne:s pryž.vlákny', 'Knitted or crocheted fabrics, of a width of > 30 cm, containing >= 5% by weight'),
('60049000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie pletené,háčkované,5%a víc nitě elastomerní,šíře nad 30cm,s pryž.vlákny', 'Knitted or crocheted fabrics, of a width of > 30 cm, containing >= 5% by weight'),
('60052100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z osnovních pletenin z bavlny bělené,nebělené', 'Unbleached or bleached cotton warp knit fabrics "incl. those made on galloon kni'),
('60052200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z osnovních pletenin z bavlny barvené', 'Dyed cotton warp knit fabrics "incl. those made on galloon knitting machines", o'),
('60052300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z osnovních pletenin z bavlny z různobarevných nití', 'Cotton warp knit fabrics of yarns of different colours "incl. those made on gall'),
('60052400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z osnovních pletenin z bavlny potisknuté', 'Printed cotton warp knit fabrics "incl. those made on galloon knitting machines"'),
('60053110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z osnovních pletenin z vláken syntetických na záclony a vitrážky', 'Unbleached or bleached warp knit fabrics of synthetic fibres "incl. those made o'),
('60053150', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krajka rašlová z osnovních pletenin z vláken syntetických,šíře nad 30cm', 'Unbleached or bleached Raschel lace, warp knit, of synthetic fibres "incl. those'),
('60053190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z osnovních pletenin z vláken syntet.ost.,bělené,nebělené,ne:viz sazebník', 'Unbleached or bleached warp knit fabrics of synthetic fibres "incl. those made o'),
('60053210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z osnovních pletenin z vláken syntet.barvené na záclony a vitrážky', 'Dyed warp knit fabrics of synthetic fibres "incl. those made on galloon knitting'),
('60053250', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krajka rašlová z osnovních pletenin z vláken syntetických barvená', 'Dyed Raschel lace, warp knit, of synthetic fibres "incl. those made on galloon k'),
('60053290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z osnovních pletenin z vláken syntetických ostatní, barvená', 'Dyed warp knit fabrics of synthetic fibres "incl. those made on galloon knitting'),
('60053310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z osnovních pletenin z vl.syntet.z různobarevných nití na záclony, vitrážky', 'Warp knit fabrics of synthetic fibres, of yarns of different colours "incl. thos'),
('60053350', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krajka rašlová z osnovních pletenin z vláken syntet.z různobarevných nití', 'Raschel lace, warp knit, of synthetic fibres, of yarns of different colours "inc'),
('60053390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z osnovních pletenin z vláken syntet.ostatní, z různobarevných nití', 'Warp knit fabrics of synthetic fibres, of yarns of different colours "incl. thos'),
('60053410', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z osnovních pletenin z vláken syntet.potisknutá na záclony, vitrážky', 'Printed warp knit fabrics of synthetic fibres "incl. those made on galloon knitt'),
('60053450', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krajka rašlová z osnovních pletenin z vláken syntetických potisknutá', 'Printed Raschel lace, warp knit, of synthetic fibres "incl. those made on galloo'),
('60053490', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z osnovních pletenin z vláken syntetických ostatní, potisknuté', 'Printed warp knit fabrics of synthetic fibres "incl. those made on galloon knitt'),
('60054100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z osnovních pletenin z vláken umělých bělené,nebělené', 'Unbleached or bleached warp knit fabrics of artificial fibres "incl. those made'),
('60054200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z osnovních pletenin z vláken umělých barvené', 'Dyed warp knit fabrics of artificial fibres "incl. those made on galloon knittin'),
('60054300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z osnovních pletenin z vláken umělých z různobarevných nití', 'Warp knit fabrics of artificial fibres, of yarns of different colours "incl. tho'),
('60054400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z osnovních pletenin z vláken umělých potisknuté', 'Printed warp knit fabrics of artificial fibres "incl. those made on galloon knit'),
('60059010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z osnovních pletenin z vlny nebo ,jemných zvířecích chlupů', 'Warp knit fabrics "incl. those made on galloon knitting machines", of a width of'),
('60059090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z osnovních pletenin ostatní,ne:viz sazebník', 'Warp knit fabrics "incl. those made on galloon knitting machines", of a width of'),
('60061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie pletené,háčkované ostatní z vlny,jemných zvířecích chlupů,ne:viz sazebník', 'Fabrics, knitted or crocheted, of a width of > 30 cm, of wool or fine animal hai'),
('60062100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie pletené,háčkované ostatní z bavlny bělené,nebělené,ne:viz sazebník', 'Unbleached or bleached cotton fabrics, knitted or crocheted, of a width of > 30'),
('60062200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie pletené,háčkované ostatní z bavlny barvené,ne:viz sazebník', 'Dyed cotton fabrics, knitted or crocheted, of a width of > 30 cm (excl. warp kni'),
('60062300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie pletené,háčkované ostatní z bavlny z různobarevných přízí,ne:viz sazebník', 'Cotton fabrics, knitted or crocheted, of yarns of different colours, of a width'),
('60062400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie pletené,háčkované ostatní z bavlny potisknuté,ne:viz sazebník', 'Printed cotton fabrics, knitted or crocheted, of a width of > 30 cm (excl. warp'),
('60063110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie plet.,háčk.ost.z vláken syntet.(ne)bělené na záclony,ne:viz sazebník', 'Unbleached or bleached fabrics, knitted or crocheted, of synthetic fibres, of a'),
('60063190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie plet.,háčk.ost.z vláken syntet.(ne)bělené,ne:viz sazebník', 'Unbleached or bleached fabrics, knitted or crocheted, of synthetic fibres, of a'),
('60063210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z vláken syntet.ost,pletené,háčkované,barvené na záclony,ne:viz sazebník', 'Dyed fabrics, knitted or crocheted, of synthetic fibres, of a width of > 30 cm,'),
('60063290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z vláken syntet.ost,pletené,háčkované,barvené,ne:viz sazebník', 'Dyed fabrics, knitted or crocheted, of synthetic fibres, of a width of > 30 cm ('),
('60063310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z vláken syntet.ost,pletené,háčkované,z různobar.nití na záclony,ne:viz sazebník', 'Fabrics, knitted or crocheted, of synthetic fibres, of yarns of different colour'),
('60063390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z vláken syntet.ost,pletené,háčkované,z různobar.nití,ne:viz sazebník', 'Fabrics, knitted or crocheted, of synthetic fibres, of yarns of different colour'),
('60063410', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z vláken syntet.ost,pletené,háčkované,potisknuté na záclony,ne:viz sazebník', 'Printed fabrics, knitted or crocheted, of synthetic fibres, of a width of > 30 c'),
('60063490', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z vláken syntet.ost,pletené,háčkované,potisknuté,ne:viz sazebník', 'Printed fabrics, knitted or crocheted, of synthetic fibres, of a width of > 30 c'),
('60064100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z osnovních pletenin ost.z vláken umělých bělené,nebělené,ne:viz sazebník', 'Unbleached or bleached fabrics, knitted or crocheted, of artificial fibres, of a'),
('60064200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z osnovních pletenin ost.z vláken umělých barvené,ne:viz sazebník', 'Dyed fabrics, knitted or crocheted, of artificial fibres, of a width of > 30 cm'),
('60064300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z osnovních pletenin ost.z vláken umělých z různobar.nití,ne:viz sazebník', 'Fabrics, knitted or crocheted, of artificial fibres, of yarns of different colou'),
('60064400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z osnovních pletenin ost.z vláken umělých potisknuté,ne:viz sazebník', 'Printed fabrics, knitted or crocheted, of artificial fibres, of a width of > 30'),
('60069000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie z osnovních pletenin ostatní,ne:viz sazebník', 'Fabrics, knitted or crocheted, of a width of > 30 cm (excl. of man-made fibres,'),
('61012010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Svrchníky,pláště apod.pánské,chlapecké z bavlny pletené,háčkované', 'Men''s or boys'' overcoats, car coats, capes, cloaks and similar articles of cot'),
('61012090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Bundy,větrovky apod.pánské,chlapecké z bavlny pletené,háčkované', 'Men''s or boys'' anoraks, incl. ski jackets, windcheaters, wind-jackets and simi'),
('61013010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Svrchníky,pláště apod.pánské,chlapecké z vláken chemických pletené,háčkované', 'Men''s or boys'' overcoats, car coats, capes, cloaks and similar articles of man'),
('61013090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Bundy,větrovky apod.pánské,chlapecké z vláken chemických pletené,háčkované', 'Men''s or boys'' anoraks, incl. ski jackets, windcheaters, wind-jackets and simi'),
('61019020', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Svrchníky,pláště apod.pánské,chlapec.z mater.textil.ost.pletené,háčkov,ne:sazebník', 'Men''s or boys'' overcoats, car coats, capes, cloaks and similar articles of tex'),
('61019080', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Bundy,větrovky apod.pánské,chlapecké z mater.textil.ost.pletené,háčkov,ne:sazebník', 'Men''s or boys'' anoraks, incl. ski jackets, windcheaters, wind-jackets and simi'),
('61021010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Svrchníky,pláště apod.dámské,dívčí z vlny,zvířecích chlupů pletené,háčkované', 'Women''s or girls'' overcoats, car coats, capes, cloaks and similar articles of'),
('61021090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Bundy,větrovky apod.dámské,dívčí z vlny,zvířecích chlupů pletené,háčkované', 'Women''s or girls'' anoraks, incl. ski jackets, windcheaters, wind-jackets and s'),
('61022010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Svrchníky,pláště apod.dámské,dívčí z bavlny pletené,háčkované', 'Women''s or girls'' overcoats, car coats, capes, cloaks and similar articles of'),
('61022090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Bundy,větrovky apod.dámské,dívčí z bavlny pletené,háčkované', 'Women''s or girls'' anoraks, incl. ski jackets, windcheaters, wind-jackets and s'),
('61023010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Svrchníky,pláště apod.dámské,dívčí z vláken chemických pletené,háčkované', 'Women''s or girls'' overcoats, car coats, capes, cloaks and similar articles of'),
('61023090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Bundy,větrovky apod.dámské,dívčí z vláken chemických pletené,háčkované', 'Women''s or girls'' anoraks, incl. ski jackets, windcheaters, wind-jackets and s'),
('61029010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Svrchníky,pláště apod.dámské,dívčí z mater.textil.ost.pletené,háčkov.,ne:sazebník', 'Women''s or girls'' overcoats, car coats, capes, cloaks and similar articles, of'),
('61029090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Bundy,větrovky apod.dámské,dívčí z mater.textil.ost.pletené,háčkov.,ne:sazebník', 'Women''s or girls'' anoraks, incl. ski jackets, windcheaters, wind-jackets and s'),
('61031010', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Obleky pánské,chlapecké z vlny,zvířecích chlupů pletené,háčkované', 'Mens or boys suits of textile materials, knitted or crocheted, of wool or fine a'),
('61031090', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Obleky pánské,chlapecké z mater.textil.ost.pletené,háčkované,ne:z vlny,zvířecích chlupů', 'Mens or boys suits of textile materials, knitted or crocheted (excl. of wool or'),
('61032200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Komplety pánské,chlapecké z bavlny pletené,háčkované', 'Men''s or boys'' ensembles of cotton, knitted or crocheted (excl. ski ensembles'),
('61032300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Komplety pánské,chlapecké z vláken syntetických pletené,háčkované', 'Men''s or boys'' ensembles of synthetic fibres, knitted or crocheted (excl. ski'),
('61032900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Komplety pánské,chlapecké z mater.textil.ost.pletené,háčkované,ne:viz sazebník', 'Men''s or boys'' ensembles of textile materials (excl. wool, fine animal hair, c'),
('61033100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Saka,blejzry pánské,chlapecké z vlny,zvířecích chlupů pletené,háčkované', 'Men''s or boys'' jackets and blazers of wool or fine animal hair, knitted or cro'),
('61033200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Saka,blejzry pánské,chlapecké z bavlny pletené,háčkované', 'Men''s or boys'' jackets and blazers of cotton, knitted or crocheted (excl. wind'),
('61033300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Saka,blejzry pánské,chlapecké z vláken syntetických pletené,háčkované', 'Men''s or boys'' jackets and blazers of synthetic fibres, knitted or crocheted ('),
('61033900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Saka,blejzry pánské,chlapecké z mater.textil.ost.pletené,háčkované,ne:viz sazebník', 'Men''s or boys'' jackets and blazers of textile materials (excl. of wool, fine a'),
('61034100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty pánské,chlapecké z vlny,zvířecích chlupů pletené,háčkované', 'Men''s or boys'' trousers, bib and brace overalls, breeches and shorts of wool o'),
('61034200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty pánské,chlapecké z bavlny pletené,háčkované', 'Men''s or boys'' trousers, bib and brace overalls, breeches and shorts of cotton'),
('61034300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty pánské,chlapecké z vláken syntetických pletené,háčkované', 'Men''s or boys'' trousers, bib and brace overalls, breeches and shorts of synthe'),
('61034900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty pánské,chlapecké z mater.textil.ost.pletené,háčkov,ne:sazebník', 'Men''s or boys'' trousers, bib and brace overalls, breeches and shorts of textil'),
('61041300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kostýmy dámské,dívčí z vláken syntetických pletené,háčkované', 'Women''s or girls'' suits of synthetic fibres, knitted or crocheted (excl. ski o'),
('61041920', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kostýmy dámské,dívčí z bavlny pletené,háčkované', 'Womens or girls suits of textile materials, knitted or crocheted, of cotton (exc'),
('61041990', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kostýmy dámské,dívčí z mater.textil.ost.pletené,háčkované,ne:viz sazebník', 'Womens or girls suits of textile materials, knitted or crocheted (excl. of synth'),
('61042200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Komplety dámské,dívčí z bavlny pletené,háčkované', 'Women''s or girls'' ensembles of cotton, knitted or crocheted (excl. ski ensembl'),
('61042300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Komplety dámské,dívčí z vláken syntetických pletené,háčkované', 'Women''s or girls'' ensembles of synthetic fibres, knitted or crocheted (excl. s'),
('61042910', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Komplety dámské,dívčí z vlny,zvířecích chlupů pletené,háčkované', 'Womens or girls ensembles of textile materials (excl. of cotton or synthetic fib'),
('61042990', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Komplety dámské,dívčí z mater.textil.ost.pletené,háčkované,ne:viz sazebník', 'Womens or girls ensembles of textile materials (excl. of cotton or synthetic fib'),
('61043100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kabátky,blejzry dámské,dívčí z vlny,zvířecích chlupů pletené,háčkované', 'Women''s or girls'' jackets and blazers of wool or fine animal hair, knitted or'),
('61043200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kabátky,blejzry dámské,dívčí z bavlny pletené,háčkované', 'Women''s or girls'' jackets and blazers of cotton, knitted or crocheted (excl. w'),
('61043300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kabátky,blejzry dámské,dívčí z vláken syntetických pletené,háčkované', 'Women''s or girls'' jackets and blazers of synthetic fibres, knitted or crochete'),
('61043900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kabátky,blejzry dámské,dívčí z mater.textil.ost.pletené,háčkované,ne:viz sazebník', 'Women''s or girls'' jackets and blazers of textile materials, knitted or crochet'),
('61044100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Šaty dámské,dívčí z vlny,zvířecích chlupů pletené,háčkované', 'Women''s or girls'' dresses of wool or fine animal hair, knitted or crocheted (e'),
('61044200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Šaty dámské,dívčí z bavlny pletené,háčkované', 'Women''s or girls'' dresses of cotton, knitted or crocheted (excl. petticoats)'),
('61044300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Šaty dámské,dívčí z vláken syntetických pletené,háčkované', 'Women''s or girls'' dresses of synthetic fibres, knitted or crocheted (excl. pet'),
('61044400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Šaty dámské,dívčí z vláken umělých pletené,háčkované', 'Women''s or girls'' dresses of artificial fibres, knitted or crocheted (excl. pe'),
('61044900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Šaty dámské,dívčí z materiálů textilních ostatních pletené,háčkované,ne:sazebník', 'Women''s or girls'' dresses of textile materials, knitted or crocheted (excl. of'),
('61045100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sukně i kalhotové dámské,dívčí z vlny,zvířecích chlupů pletené,háčkované', 'Women''s or girls'' skirts and divided skirts of wool or fine animal hair, knitt'),
('61045200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sukně i kalhotové dámské,dívčí z bavlny pletené,háčkované', 'Women''s or girls'' skirts and divided skirts of cotton, knitted or crocheted (e'),
('61045300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sukně i kalhotové dámské,dívčí z vláken syntetických pletené,háčkované', 'Women''s or girls'' skirts and divided skirts of synthetic fibres, knitted or cr'),
('61045900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sukně i kalhotové dámské,dívčí z mater.textil.ost.pletené,háčkované,ne:sazebník', 'Women''s or girls'' skirts and divided skirts of textile materials, knitted or c'),
('61046100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty dámské,dívčí z vlny,zvířecích chlupů pletené,háčkované', 'Women''s or girls'' trousers, bib and brace overalls, breeches and shorts of woo'),
('61046200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty dámské,dívčí z bavlny pletené,háčkované', 'Women''s or girls'' trousers, bib and brace overalls, breeches and shorts of cot'),
('61046300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty dámské,dívčí z vláken syntetických pletené,háčkované', 'Women''s or girls'' trousers, bib and brace overalls, breeches and shorts of syn'),
('61046900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty dámské,dívčí z mater.textil.ost.pletené,háčkov,ne:viz sazebník', 'Women''s or girls'' trousers, bib and brace overalls, breeches and shorts of tex'),
('61051000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Košile pánské,chlapecké z bavlny pletené,háčkované', 'Men''s or boys'' shirts of cotton, knitted or crocheted (excl. nightshirts, T-sh'),
('61052010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Košile pánské,chlapecké z vláken syntetických pletené,háčkované', 'Men''s or boys'' shirts of synthetic fibres, knitted or crocheted (excl. nightsh'),
('61052090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Košile pánské,chlapecké z vláken umělých pletené,háčkované', 'Men''s or boys'' shirts of artificial fibres, knitted or crocheted (excl. nights'),
('61059010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Košile pánské,chlapecké z vlny,zvířecích chlupů pletené,háčkované', 'Men''s or boys'' shirts of wool or fine animal hair, knitted or crocheted (excl.'),
('61059090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Košile pánské,chlapecké z mater.textil.ostatních pletené,háčkované,ne:viz sazebník', 'Men''s or boys'' shirts of textile materials, knitted or crocheted (excl. of cot'),
('61061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Halenky,košile dámské,dívčí z bavlny pletené,háčkované', 'Women''s or girls'' blouses, shirts and shirt-blouses of cotton, knitted or croc'),
('61062000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Halenky,košile dámské,dívčí z vláken chemických pletené,háčkované', 'Women''s or girls'' blouses, shirts and shirt-blouses of man-made fibres, knitte'),
('61069010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Halenky,košile dámské,dívčí z vlny,zvířecích chlupů pletené,háčkované', 'Women''s or girls'' blouses, shirts and shirt-blouses of wool or fine animal hai'),
('61069030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Halenky,košile dámské,dívčí z hedvábí přírodního,odpadu pletené,háčkované', 'Women''s or girls'' blouses, shirts and shirt-blouses of silk or silk waste, kni'),
('61069050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Halenky,košile dámské,dívčí ze lnu,ramie pletené,háčkované', 'Women''s or girls'' blouses, shirts and shirt-blouses of flax or ramie, knitted'),
('61069090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Halenky,košile dámské,dívčí z mater.textil.ost.pletené,háčkované,ne:viz sazebník', 'Women''s or girls'' blouses, shirts and shirt-blouses of textile materials, knit'),
('61071100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Spodky krátké,dlouhé pánské,chlapecké z bavlny pletené,háčkované', 'Men''s or boys'' underpants and briefs of cotton, knitted or crocheted'),
('61071200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Spodky krátké,dlouhé pánské,chlapecké z vláken chem.pletené,háčkované,ne:sazebník', 'Men''s or boys'' underpants and briefs of man-made fibres, knitted or crocheted'),
('61071900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Spodky krátké,dlouhé pánské,chlapecké z mater.textil.ost.pletené,háčkované', 'Men''s or boys'' underpants and briefs of other textile materials, knitted or cr'),
('61072100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Košile noční,pyžama pánské,chlapecké z bavlny pletené,háčkované', 'Men''s or boys'' nightshirts and pyjamas of cotton, knitted or crocheted (excl.'),
('61072200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Košile noční,pyžama pánské,chlapecké z vláken chemických pletené,háčkované', 'Men''s or boys'' nightshirts and pyjamas of man-made fibres, knitted or crochete'),
('61072900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Košile noční,pyžama pánské,chlap.z mater.textil.ost.pletené,háčkované,ne:sazebník', 'Men''s or boys'' nightshirts and pyjamas of textile materials, knitted or croche'),
('61079100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Župany,pláště koupací apod.pánské,chlapecké z bavlny pletené,háčkované', 'Men''s or boys'' bathrobes, dressing gowns and similar articles of cotton, knitt'),
('61079900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Župany,pláště koupací apod.pánské,chlapecké z mater.textil.ost.,pletené,ne:sazebník', 'Men''s or boys'' bathrobes, dressing gowns and similar articles of textile mater'),
('61081100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kombiné a spodničky ze syntetických nebo umělých vláken', 'Women''s or girls'' slips and petticoats of man-made fibres, knitted or crochete'),
('61081900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kombiné a spodničky z ost.textil.mater.,ne:ze syntetických nebo umělých vláken', 'Women''s or girls'' slips and petticoats of textile materials, knitted or croche'),
('61082100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhotky dámské,dívčí z bavlny pletené,háčkované', 'Women''s or girls'' briefs and panties of cotton, knitted or crocheted'),
('61082200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhotky dámské,dívčí z vláken chemických pletené,háčkované', 'Women''s or girls'' briefs and panties of man-made fibres, knitted or crocheted'),
('61082900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhotky dámské,dívčí z mater.textilních ostatních pletené,háčkované,ne:viz sazebník', 'Women''s or girls'' briefs and panties of textile materials, knitted or crochete'),
('61083100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Košile noční,pyžama dámská,dívčí z bavlny pletená,háčkovaná', 'Women''s or girls'' nightdresses and pyjamas of cotton, knitted or crocheted (ex'),
('61083200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Košile noční,pyžama dámská,dívčí z vláken syntetických pletená,háčkovaná', 'Women''s or girls'' nightdresses and pyjamas of man-made fibres, knitted or croc'),
('61083900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Košile noční,pyžama dámské,dívčí z mater.textil.ost.pletené,háčkov.,ne:sazebník', 'Women''s or girls'' nightdresses and pyjamas of textile materials, knitted or cr'),
('61089100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Župany,pláště koupací apod.dámské,dívčí z bavlny pletené,háčkované', 'Women''s or girls'' nĂ©gligĂ©s, bathrobes, dressing gowns, housejackets and simi'),
('61089200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Župany,pláště koupací apod.dámské,dívčí z vláken chemických pletené,háčkované', 'Women''s or girls'' nĂ©gligĂ©s, bathrobes, dressing gowns, housejackets and simi'),
('61089900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Župany,pláště koupací apod.dámské,dívčí z mater.textil.ost.,pletené,ne:sazebník', 'Women''s or girls'' nĂ©gligĂ©s, bathrobes, dressing gowns, housejackets and simi'),
('61091000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Trička vrchní,tílka a jiné nátělníky z bavlny pletené,háčkované', 'T-shirts, singlets and other vests of cotton, knitted or crocheted'),
('61099020', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Trička vrchní,tílka a jiné nátělníky z vlny,zvířecích chlupů,vláken chemických pletené,háčkované', 'T-shirts, singlets and other vests of wool or fine animal hair or man-made fibre'),
('61099090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Trička vrchní,tílka apod.z mater.textil.ost.pletené,háčkov.,ne:viz sazebník', 'T-shirts, singlets and other vests of textile materials, knitted or crocheted (e'),
('61101110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pulovry,svetry,50% a víc vlna,zvíř.chlupy,váha 600g/ks a víc,pletené,háčkované', 'Jerseys and pullovers containing >= 50% by weight of wool and weighing >= 600 g/'),
('61101130', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pulovry,svetry apod.pánské,chlapecké z vlny ost.pletené,háčkované,ne:sazebník', 'Men''s or boys'' jerseys, pullovers, cardigans, waistcoats and similar articles,'),
('61101190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pulovry,svetry apod.dámské,dívčí z vlny ost.pletené,háčkované,ne:sazebník', 'Women''s or girls'' jerseys, pullovers, cardigans, waistcoats and similar articl'),
('61101210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pulovry,svetry pánské,chlap.z vlny,vlna z kašmír.koz 50% a víc,pletené,háčkované', 'Jerseys, pullovers, cardigans, waistcoats and similar articles, of hair of Kashm'),
('61101290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pulovry,svetry dámské,dívčí z vlny,vlna z kašmír.koz 50% a víc,pletené,háčkované', 'Jerseys, pullovers, cardigans, waistcoats and similar articles, of hair of Kashm'),
('61101910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pulovry,svetry pánské,chlapec.z vlny ost, pletené, háčkované,ne:viz sazebník', 'Jerseys, pullovers, cardigans, waistcoats and similar articles, of fine animal h'),
('61101990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pulovry,svetry dámské,dívčí z vlny ostatní, pletené, háčkované,ne:viz sazebník', 'Jerseys, pullovers, cardigans, waistcoats and similar articles, of fine animal h'),
('61102010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Svetry lehké (roláky),pulovry z bavlny pletené,háčkované', 'Lightweight fine knit roll, polo or turtleneck jumpers and pullovers of cotton,'),
('61102091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Svetry,vesty apod.pánské,chlapecké z bavlny pletené,háčkované', 'Men''s or boys'' jerseys, pullovers, cardigans, waistcoats and similar articles,'),
('61102099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Svetry,vesty apod.dámské,dívčí z bavlny pletené,háčkované', 'Women''s or girls'' jerseys, pullovers, cardigans, waistcoats and similar articl'),
('61103010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Svetry lehké (roláky),pulovry z vláken chemických pletené,háčkované', 'Lightweight fine knit roll, polo or turtleneck jumpers and pullovers of man-made'),
('61103091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Svetry,vesty apod.pánské,chlapecké z vláken chemických pletené,háčkované', 'Men''s or boys'' jerseys, pullovers, cardigans, waistcoats and similar articles,'),
('61103099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Svetry,vesty apod.dámské,dívčí z vláken chemických pletené,háčkované', 'Women''s or girls'' jerseys, pullovers, cardigans, waistcoats and similar articl'),
('61109010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pulovry,svetry,vesty apod.ze lnu,ramie pletené,háčkované', 'Jerseys, pullovers, cardigans, waistcoats and similar articles, of flax or ramie'),
('61109090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pulovry,svetry apod.z mater.textilních ostatních pletené,háčkované,ne:viz sazebník', 'Jerseys, pullovers, cardigans, waistcoats and similar articles, of textile mater'),
('61112010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Rukavice kojenecké z bavlny pletené,háčkované', 'Babies'' gloves, mittens and mitts, of cotton, knitted or crocheted'),
('61112090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy kojenecké, ne rukavice, z bavlny pletené, háčkované', 'Babies'' garments and clothing accessories, of cotton, knitted or crocheted (exc'),
('61113010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Rukavice kojenecké z vláken syntetických pletené,háčkované', 'Babies'' gloves, mittens and mitts for babies, of synthetic fibres, knitted or c'),
('61113090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy kojenecké,oděvní doplňky z vláken syntetických pletené,háčkov.,ne:sazebník', 'Babies'' garments and clothing accessories, of synthetic fibres, knitted or croc'),
('61119011', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Rukavice kojenecké,z vlny,zvířecích chlupů,pletené,háčkované', 'Babies'' gloves, mittens and mitts, of wool or fine animal hair, knitted or croc'),
('61119019', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy kojenecké,oděvní doplňky,z vlny,zvířecích chlupů,pletené,háčkov.,ne:sazebník', 'Babies'' garments and clothing accessories, of wool or fine animal hair, knitted'),
('61119090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy kojenecké,doplňky,z mater.textil.ost.,pletené,háčkované,ne:viz sazebník', 'Babies'' garments and clothing accessories of textile materials, knitted or croc'),
('61121100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Tepláky z bavlny pletené,háčkované', 'Track-suits of cotton, knitted or crocheted'),
('61121200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Tepláky z vláken syntetických pletené,háčkované', 'Track-suits of synthetic fibres, knitted or crocheted'),
('61121900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Tepláky z materiálů textilních ostatních pletené,háčkované,ne:viz sazebník', 'Track-suits of textile materials, knitted or crocheted (excl. cotton or syntheti'),
('61122000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy lyžařské pletené,háčkované', 'Ski-suits, knitted or crocheted'),
('61123110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Plavky pánské,chlapecké z vláken syntet.,nad 5% nitě pryžové,pletené,háčkované', 'Men''s or boys'' swimwear of synthetic fibres, knitted or crocheted, containing'),
('61123190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Plavky pánské,chlapecké z vláken syntet.,do 5% nitě pryžové,pletené,háčkované', 'Men''s or boys'' swimwear of synthetic fibres, knitted or crocheted (excl. conta'),
('61123910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Plavky pánské,chlapecké z mater.textil.ost.,nad 5% nitě pryžové,pletené,ne:sazebník', 'Men''s or boys'' swimwear of textile materials, knitted or crocheted, containing'),
('61123990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Plavky pánské,chlapecké z mater.textil.ost.,do 5% nitě pryžové,pletené,ne:sazebník', 'Men''s or boys'' swimwear of textile materials, knitted or crocheted (excl. synt'),
('61124110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Plavky dámské,dívčí z vláken syntetických,nad 5% nitě pryžové,pletené,háčkované', 'Women''s or girls'' swimwear of synthetic fibres, knitted or crocheted, containi'),
('61124190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Plavky dámské,dívčí z vláken syntetických,do 5% nitě pryžové,pletené,háčkované', 'Women''s or girls'' swimwear of synthetic fibres, knitted or crocheted (excl. co'),
('61124910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Plavky dámské,dívčí z mater.textil.ost.,nad 5% nitě pryžové,pletené,ne:sazebník', 'Women''s or girls'' swimwear of textile materials, knitted or crocheted, contain'),
('61124990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Plavky dámské,dívčí z mater.textil.ost.,do 5% nitě pryžové,pletené,ne:viz sazebník', 'Women''s or girls'' swimwear of textile materials, knitted or crocheted (excl. s'),
('61130010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy zcela zhotovené z textilií pletených,háčkovaných pogumovaných', 'Garments, knitted or crocheted, rubberised (excl. babies'' garments and clothing'),
('61130090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy zcela zhotovené z textilií pletených,háčkov.,impregnovaných,potažených', 'Garments, knitted or crocheted, impregnated, coated or covered with plastics or'),
('61142000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy ostatní z bavlny pletené,háčkované,ne:viz sazebník', 'Special garments for professional, sporting or other purposes, n.e.s., of cotton'),
('61143000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy ostatní z vláken chemických pletené,háčkované,ne:viz sazebník', 'Special garments for professional, sporting or other purposes, n.e.s., of man-ma'),
('61149000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy ostatní z materiálů textilních ostatních pletené,háčkované,ne:viz sazebník', 'Special garments for professional, sporting or other purposes, n.e.s., of textil'),
('61151010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Punčochy na křečové žíly z vláken syntetických pletené,háčkované', 'Stockings for varicose veins of synthetic fibres, knitted or crocheted'),
('61151090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Punčochové zboží s postupným stlačením ost.,pletené,háčkované,ne:viz sazebník', 'Graduated compression hosiery of textile materials, knitted or crocheted (excl.'),
('61152100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty punčochové z vláken syntetických,pod 67 decitex,pletené,háčkované,ne:viz sazebník', 'Pantyhose and tights of synthetic fibres, knitted or crocheted, measuring per si'),
('61152200', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty punčochové z vláken syntetických,67 a víc decitex,pletené,háčkované,ne:viz sazebník', 'Pantyhose and tights of synthetic fibres, knitted or crocheted, measuring per si'),
('61152900', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Punčochové kalhoty z ost.textil.mater.,ne:viz sazebník', 'Pantyhose and tights of textile materials, knitted or crocheted (excl. graduated'),
('61153011', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Podkolenky z vláken syntetických,pod 67 decitex,pletené,háčkované,ne:viz sazebník', 'Women''s knee-length stockings of synthetic fibres, knitted or crocheted, measur'),
('61153019', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Punčochy dlouhé z vláken syntetických,pod 67 decitex,pletené,háčkované,ne:viz sazebník', 'Women''s full-length hosiery of synthetic fibres, knitted or crocheted, measurin'),
('61153090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Punčochy dlouhé apod.z mat.textil.ost.,pod 67 decitex,pletené,háčkov.ne:viz sazebník', 'Women''s full-length and knee-length hosiery, knitted or crocheted, measuring pe'),
('61159400', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Ponožky apod.výrobky z vlny,zvířecích chlupů,pletené,háčkované,ne:viz sazebník', 'Full-length or knee-length stockings, socks and other hosiery, incl. footwear wi'),
('61159500', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Ponožky apod.výrobky z bavlny,pletené,háčkované,ne:viz sazebník', 'Full-length or knee-length stockings, socks and other hosiery, incl. footwear wi'),
('61159610', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Podkolenky z vláken syntetických pletené,háčkované,ne:viz sazebník', 'Knee-length stockings of synthetic fibres, knitted or crocheted (excl. graduated'),
('61159691', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Punčochy dámské z vláken syntetických pletené,háčkované,ne:viz sazebník', 'Women''s stockings of synthetic fibres, knitted or crocheted (excl. graduated co'),
('61159699', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Ponožky apod.výrobky z vláken syntetických ost.,pletené,háčkované,ne:viz sazebník', 'Full-length stockings, socks and other hosiery, incl. footwear without applied s'),
('61159900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Ponožky apod.výrobky z mater.textil.ostatních pletené,háčkované,ne:viz sazebník', 'Full-length or knee-length stockings, socks and other hosiery, incl. footwear wi'),
('61161020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Rukavice impregnované,povrstvené,povlečené kaučukem,pletené,háčkované', 'Gloves, impregnated, coated or covered with rubber, knitted or crocheted'),
('61161080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Rukavice impregnované,povrstvené,povlečené plasty,pletené,háčkované', 'Mittens and mitts, impregnated, coated or covered with plastics or rubber, knitt'),
('61169100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Rukavice z vlny,chlupů zvířecích pletené,háčkované', 'Gloves, mittens and mitts, of wool or fine animal hair, knitted or crocheted (ex'),
('61169200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Rukavice z bavlny pletené,háčkované', 'Gloves, mittens and mitts, of cotton, knitted or crocheted (excl. impregnated, c'),
('61169300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Rukavice z vláken syntetických pletené,háčkované', 'Gloves, mittens and mitts, of synthetic fibres, knitted or crocheted (excl. impr'),
('61169900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Rukavice z materiálů textilních ostatních pletené,háčkované,ne:viz sazebník', 'Gloves, mittens and mitts, of textile materials, knitted or crocheted (excl. of'),
('61171000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přehozy,šátky,šály,mantily,závoje apod.výrobky pletené,háčkované', 'Shawls, scarves, mufflers, mantillas, veils and the like, knitted or crocheted'),
('61178010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Doplňky oděvní pletené,háčkované elastické,povrstvené kaučukem', 'Made-up clothing accessories, knitted or crocheted, elasticated or rubberised, n'),
('61178080', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Doplňky oděvní ostatní pletené,háčkované,ne:elastické,povrstvené kaučukem', 'Ties, bow ties, cravats and other made-up clothing accessories, knitted or croch'),
('61179000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části oděvů,doplnků oděvních pletené,háčkované', 'Parts of garments or clothing accessories, knitted or crocheted, n.e.s.'),
('62011100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Svrchníky,kabáty,pláště apod.pánské,chlapecké z vlny,zvířecích chlupů', 'Men''s or boys'' overcoats, raincoats, car coats, capes, cloaks and similar arti'),
('62011210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Svrchníky,kabáty,pláště apod.pánské,chlapecké z bavlny,hmotnost do 1kg/ks', 'Men''s or boys'' overcoats, raincoats, car coats, capes, cloaks and similar arti'),
('62011290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Svrchníky,kabáty,pláště apod.pánské,chlapecké z bavlny,hmotnost nad 1kg/ks', 'Men''s or boys'' overcoats, raincoats, car coats, capes, cloaks and similar arti'),
('62011310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Svrchníky,kabáty,pláště apod.panské,chlapecké z vláken chemických,do 1kg/ks', 'Men''s or boys'' overcoats, raincoats, car coats, capes, cloaks and similar arti'),
('62011390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Svrchníky,kabáty,pláště apod.pánské,chlapecké z vláken chemických,nad 1kg/ks', 'Men''s or boys'' overcoats, raincoats, car coats, capes, cloaks and similar arti'),
('62011900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Svrchníky,kabáty,pláště apod.pánské,chlapecké z mater.textil.ost.,ne:viz sazebník', 'Men''s or boys'' overcoats, raincoats, car coats, capes, cloaks and similar arti'),
('62019100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Bundy,větrovky apod.pánské,chlapecké z vlny,zvířecích chlupů', 'Men''s or boys'' anoraks, incl. ski jackets, windcheaters, wind-jackets and simi'),
('62019200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Bundy,větrovky apod.pánské,chlapecké z bavlny', 'Men''s or boys'' anoraks, windcheaters, wind jackets and similar articles, of co'),
('62019300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Bundy,větrovky apod.pánské,chlapecké z vláken chemických', 'Men''s or boys'' anoraks, windcheaters, wind jackets and similar articles, of ma'),
('62019900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Bundy,větrovky apod.pánské,chlapecké z mater.textilních ostatních,ne:viz sazebník', 'Men''s or boys'' anoraks, incl. ski jackets, windcheaters, wind-jackets and simi'),
('62021100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Svrchníky,kabáty,pláště apod.dámské,dívčí z vlny,zvířecích chlupů', 'Women''s or girls'' overcoats, raincoats, car coats, capes, cloaks and similar a'),
('62021210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Svrchníky,kabáty,pláště apod.dámské,dívčí z bavlny,do 1kg/ks', 'Women''s or girls'' overcoats, raincoats, car coats, capes, cloaks and similar a'),
('62021290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Svrchníky,kabáty,pláště apod.dámské,dívčí z bavlny,nad 1kg/ks', 'Women''s or girls'' overcoats, raincoats, car coats, capes, cloaks and similar a'),
('62021310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Svrchníky,kabáty,pláště apod.dámské,dívčí z vláken chemických,do 1kg/ks', 'Women''s or girls'' overcoats, raincoats, car coats, capes, cloaks and similar a'),
('62021390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Svrchníky,kabáty,pláště apod.dámské,dívčí z vláken chemických,nad 1kg/ks', 'Women''s or girls'' overcoats, raincoats, car coats, capes, cloaks and similar a'),
('62021900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Svrchníky,kabáty,pláště apod.dámské,dívčí z mater.textil.ost.,ne:viz sazebník', 'Women''s or girls'' overcoats, raincoats, car coats, capes, cloaks and similar a'),
('62029100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Bundy,větrovky apod.dámské,dívčí z vlny,zvířecích chlupů', 'Women''s or girls'' anoraks, incl. ski jackets, windcheaters, wind-jackets and s'),
('62029200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Bundy,větrovky apod.dámské,dívčí z bavlny', 'Women''s or girls'' anoraks, windcheaters, wind jackets and similar articles, of'),
('62029300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Bundy,větrovky apod.dámské,dívčí z vláken chemických', 'Women''s or girls'' anoraks, windcheaters, wind jackets and similar articles, of'),
('62029900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Bundy,větrovky apod.dámské,dívčí z materiálů textilních ostatních,ne:viz sazebník', 'Women''s or girls'' anoraks, incl. ski jackets, windcheaters, wind-jackets and s'),
('62031100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Obleky pánské,chlapecké z vlny,zvířecích chlupů', 'Men''s or boys'' suits of wool or fine animal hair (excl. knitted or crocheted,'),
('62031200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Obleky pánské,chlapecké z vláken syntetických', 'Men''s or boys'' suits of synthetic fibres (excl. knitted or crocheted, tracksui'),
('62031910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Obleky pánské,chlapecké z bavlny', 'Men''s or boys'' suits of cotton (excl. knitted or crocheted, tracksuits, ski su'),
('62031930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Obleky pánské,chlapecké z vláken umělých', 'Men''s or boys'' suits of artificial fibres (excl. knitted or crocheted, tracksu'),
('62031990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Obleky pánské, chlapecké z materiálů textilních, ne bavlna, vlákna umělá', 'Men''s or boys'' suits of textile materials (excl. of wool or fine animal hair,'),
('62032210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Komplety pracovní pánské,chlapecké z bavlny', 'Men''s or boys'' industrial and occupational ensembles of cotton (excl. knitted'),
('62032280', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Komplety ostatní pánské,chlapecké z bavlny,ne:pracovní', 'Men''s or boys'' ensembles, of cotton (not knitted or crocheted and excl. indust'),
('62032310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Komplety pracovní pánské,chlapecké z vláken syntetických', 'Men''s or boys'' industrial and occupational ensembles of synthetic fibres (excl'),
('62032380', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Komplety ostatní pánské,chlapecké z vláken syntetických,ne:pracovní', 'Men''s or boys'' ensembles, of synthetic fibres (not knitted or crocheted and ex'),
('62032911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Komplety pracovní pánské,chlapecké z vláken umělých', 'Men''s or boys'' industrial and occupational ensembles of artificial fibres (exc'),
('62032918', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Komplety ostatní pánské,chlapecké z vláken umělých,ne:pracovní', 'Men''s or boys'' ensembles, of artificial fibres (not knitted or crocheted and e'),
('62032930', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Komplety pánské,chlapecké z vlny,zvířecích chlupů', 'Men''s or boys'' ensembles of wool or fine animal hair (excl. knitted or crochet'),
('62032990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Komplety pánské,chlapecké z materiálů textilních ostatních,ne:viz sazebník', 'Men''s or boys'' ensembles of textile materials (excl. of wool, fine animal hair'),
('62033100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Saka,blejzry pánské,chlapecké z vlny,zvířecích chlupů', 'Men''s or boys'' jackets and blazers of wool or fine animal hair (excl. knitted'),
('62033210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Saka,blejzry pracovní pánské,chlapecké z bavlny', 'Men''s or boys'' jackets and blazers of cotton, industrial and occupational (exc'),
('62033290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Saka,blejzry ostatní pánské,chlapecké z bavlny,ne:pracovní', 'Men''s or boys'' jackets and blazers of cotton (excl. knitted or crocheted, indu'),
('62033310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Saka,blejzry pracovní pánské,chlapecké z vláken syntetických', 'Men''s or boys'' jackets and blazers of synthetic fibres, industrial and occupat'),
('62033390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Saka,blejzry ostatní pánské,chlapecké z vláken syntetických,ne:pracovní', 'Men''s or boys'' jackets and blazers of synthetic fibres (excl. knitted or croch'),
('62033911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Saka,blejzry pracovní pánské,chlapecké z vláken umělých', 'Men''s or boys'' jackets and blazers of artificial fibres, industrial and occupa'),
('62033919', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Saka,blejzry ostatní pánské,chlapecké z vláken umělých,ne:pracovní', 'Men''s or boys'' jackets and blazers of artificial fibres (excl. knitted or croc'),
('62033990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Saka, blejzry pánské a podobně z materiálů textilních, ne vlákna umělá', 'Men''s or boys'' jackets and blazers of textile materials (excl. of wool, fine a'),
('62034110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty,krátké kalhoty pánské,chlapecké z vlny nebo jemných chlupů', 'Men''s or boys'' trousers and breeches of wool or fine animal hair (excl. knitte'),
('62034130', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty s laclem se šlemi pánské,chlapecké z vlny nebo jemných chlupů', 'Men''s or boys'' bib and brace overalls of wool or fine animal hair (excl. knitt'),
('62034190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty ostatní pánské,chlapecké z vlny nebo jemných chlupů,ne:viz sazebník', 'Men''s or boys'' shorts of wool or fine animal hair (excl. knitted or crocheted,'),
('62034211', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty,krátké kalhoty pracovní pánské,chlapecké z bavlny', 'Men''s or boys'' industrial and occupational trousers and breeches of cotton (ex'),
('62034231', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty,krátké kalhoty pánské,chlapecké z denimu (džínsoviny),ne:pracovní', 'Men''s or boys'' trousers and breeches of cotton denim (excl. knitted or crochet'),
('62034233', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty,krátké kalhoty pánské,chlapecké z vlasového manšestru,ne:pracovní', 'Men''s or boys'' trousers and breeches of cotton cut corduroy (excl. knitted or'),
('62034235', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty,krátké kalhoty pánské,chlapecké z bavlny ostatní,ne:viz sazebník', 'Men''s or boys'' trousers and breeches of cotton (excl. denim, cut corduroy, kni'),
('62034251', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty s laclem se šlemi pracovní pánské,chlapecké z bavlny', 'Men''s or boys'' bib and brace overalls, of cotton, industrial and occupational'),
('62034259', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty s laclem se šlemi pánské,chlapecké z bavlny ostatní,ne:pracovní', 'Men''s or boys'' bib and brace overalls, of cotton (excl. knitted or crocheted,'),
('62034290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty pánské,chlapecké z bavlny ostatní,ne:viz sazebník', 'Men''s or boys'' shorts of cotton (excl. knitted or crocheted, swimwear and unde'),
('62034311', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty,krátké kalhoty pracovní pánské,chlapecké ze syntetických vláken', 'Men''s or boys'' trousers and breeches of synthetic fibres, industrial and occup'),
('62034319', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty,krátké kalhoty pánské,chlapecké ze syntetických vláken ost.,ne:pracovní', 'Men''s or boys'' trousers and breeches of synthetic fibres (excl. knitted or cro'),
('62034331', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty s laclem se šlemi pracovní pánské,chlapecké ze syntetických vláken', 'Men''s or boys'' bib and brace overalls of synthetic fibres, industrial and occu'),
('62034339', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty s laclem se šlemi pánské,chlapecké ze syntetických vláken ost.,ne:pracovní', 'Men''s or boys'' bib and brace overalls of synthetic fibres (excl. knitted or cr'),
('62034390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty pánské,chlapecké ze syntetických vláken ostatní,ne:viz sazebník', 'Men''s or boys'' shorts of synthetic fibres (excl. knitted or crocheted, underpa'),
('62034911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty,krátké kalhoty pracovní pánské,chlapecké z umělých vláken', 'Men''s or boys'' trousers and breeches of artificial fibres, industrial and occu'),
('62034919', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty,krátké kalhoty pánské,chlapecké z umělých vláken ostatní,ne:pracovní', 'Men''s or boys'' trousers and breeches of artificial fibres (excl. knitted or cr'),
('62034931', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty s laclem se šlemi pánské,chlapecké z umělých vláken ost.,ne:pracovní', 'Men''s or boys'' bib and brace overalls of artificial fibres, industrial and occ'),
('62034939', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty s laclem se šlemi pánské,chlapecké z umělých vláken ost.,ne:pracovní', 'Men''s or boys'' bib and brace overalls of artificial fibres (excl. knitted or c'),
('62034950', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty pánské,chlapecké z umělých vláken ostatní,ne:viz sazebník', 'Men''s or boys'' shorts of artificial fibres (excl. knitted or crocheted, underp'),
('62034990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty pánské,chlapecké z jiných textilních materiálů ost.,ne:viz sazebník', 'Men''s or boys'' trousers, bib and brace overalls, breeches and shorts of textil'),
('62041100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kostýmy dámské,dívčí z vlny,zvířecích chlupů', 'Women''s or girls'' suits of wool or fine animal hair (excl. knitted or crochete'),
('62041200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kostýmy dámské,dívčí z bavlny', 'Women''s or girls'' suits of cotton (excl. knitted or crocheted, ski overalls an'),
('62041300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kostýmy dámské,dívčí z vláken syntetických', 'Women''s or girls'' suits of synthetic fibres (excl. knitted or crocheted, ski o'),
('62041910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kostýmy dámské,dívčí z vláken umělých', 'Women''s or girls'' suits of artificial fibres (excl. knitted or crocheted, ski'),
('62041990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kostýmy dámské,dívčí z materiálů textilních ostatních,ne:viz sazebník', 'Women''s or girls'' suits of textile materials (excl. of wool, fine animal hair,'),
('62042100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Komplety dámské,dívčí z vlny,zvířecích chlupů', 'Women''s or girls'' ensembles of wool or fine animal hair (excl. knitted or croc'),
('62042210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Komplety pracovní dámské,dívčí z bavlny', 'Women''s or girls'' ensembles of cotton, industrial and occupational (excl. knit'),
('62042280', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Komplety dámské,dívčí ostatní z bavlny,ne:pracovní', 'Women''s or girls'' ensembles, of cotton (not knitted or crocheted and excl. ind'),
('62042310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Komplety pracovní dámské,dívčí z vláken syntetických', 'Women''s or girls'' ensembles of synthetic fibres, industrial and occupational ('),
('62042380', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Komplety dámské,dívčí ostatní z vláken syntetických,ne:pracovní', 'Women''s or girls'' ensembles, of synthetic fibres (not knitted or crocheted and'),
('62042911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Komplety pracovní dámské,dívčí z vláken umělých', 'Women''s or girls'' ensembles, of artificial fibres, industrial and occupational'),
('62042918', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Komplety dámské,dívčí ostatní z vláken umělých,ne:pracovní', 'Women''s or girls'' ensembles, of artificial fibres (not knitted or crocheted an'),
('62042990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Komplety dámské,dívčí z materiálů textilních ostatních,ne:viz sazebník', 'Women''s or girls'' ensembles of textile materials (excl. of wool, fine animal h'),
('62043100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kabátky,blejzry dámské,dívčí z vlny,zvířecích chlupů', 'Women''s or girls'' jackets and blazers of wool or fine animal hair (excl. knitt'),
('62043210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kabátky,blejzry pracovní dámské,dívčí z bavlny', 'Women''s or girls'' jackets and blazers of cotton, industrial and occupational ('),
('62043290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kabátky,blejzry dámské,dívčí ostatní z bavlny,ne:pracovní', 'Women''s or girls'' jackets and blazers of cotton (excl. knitted or crocheted, i'),
('62043310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kabátky,blejzry pracovní dámské,dívčí z vláken syntetických', 'Women''s or girls'' jackets and blazers of synthetic fibres, industrial and occu'),
('62043390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kabátky,blejzry dámské,dívčí ostatní z vláken syntetických,ne:pracovní', 'Women''s or girls'' jackets and blazers of synthetic fibres (excl. knitted or cr'),
('62043911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kabátky,blejzry pracovní dámské,dívčí z vláken umělých', 'Women''s or girls'' jackets and blazers of artificial fibres, industrial and occ'),
('62043919', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kabátky,blejzry dámské,dívčí ostatní z vláken umělých,ne:pracovní', 'Women''s or girls'' jackets and blazers of artificial fibres (excl. knitted or c'),
('62043990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kabátky,blejzry dámské,dívčí z materiálů textilních ostatních,ne:viz sazebník', 'Women''s or girls'' jackets and blazers of textile materials (excl. of wool, fin'),
('62044100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Šaty dámské,dívčí z vlny,zvířecích chlupů', 'Women''s or girls'' dresses of wool or fine animal hair (excl. knitted or croche'),
('62044200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Šaty dámské,dívčí z bavlny', 'Women''s or girls'' dresses of cotton (excl. knitted or crocheted and petticoats'),
('62044300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Šaty dámské,dívčí z vláken syntetických', 'Women''s or girls'' dresses of synthetic fibres (excl. knitted or crocheted and'),
('62044400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Šaty dámské,dívčí z vláken umělých', 'Women''s or girls'' dresses of artificial fibres (excl. knitted or crocheted and'),
('62044910', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Šaty dámské,dívčí z hedvábí,hedvábného odpadu', 'Womens or girls dresses of textile materials, of silk or silk waste (excl. knitt'),
('62044990', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Šaty dámské,dívčí z materiálů textilních ostatních,ne:viz sazebník', 'Womens or girls dresses of textile materials (excl. of silk or silk waste, wool,'),
('62045100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sukně i kalhotové dámské,dívčí z vlny,zvířecích chlupů', 'Women''s or girls'' skirts and divided skirts of wool or fine animal hair (excl.'),
('62045200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sukně i kalhotové dámské,dívčí z bavlny', 'Women''s or girls'' skirts and divided skirts of cotton (excl. knitted or croche'),
('62045300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sukně i kalhotové dámské,dívčí z vláken syntetických', 'Women''s or girls'' skirts and divided skirts of synthetic fibres (excl. knitted'),
('62045910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sukně i kalhotové dámské,dívčí z vláken umělých', 'Women''s or girls'' skirts and divided skirts of artificial fibres (excl. knitte'),
('62045990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sukně i kalhotové dámské,dívčí z materiálů textilních ostatních,ne:viz sazebník', 'Women''s or girls'' skirts and divided skirts of textile materials (excl. of woo'),
('62046110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty,krátké kalhoty dámské,dívčí z vlny nebo jemných chlupů', 'Women''s or girls'' trousers and breeches of wool or fine animal hair (excl. kni'),
('62046185', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty ostatní dámské,dívčí z vlny nebo jemných chlupů,ne:viz sazebník', 'Women''s or girls'' bib and brace overalls and shorts, of wool or fine animal ha'),
('62046211', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty,krátké kalhoty pracovní dámské,dívčí z bavlny', 'Women''s or girls'' trousers and breeches of cotton, industrial and occupational'),
('62046231', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty,krátké kalhoty dámské,dívčí z denimu (džínsoviny)', 'Women''s or girls'' cotton denim trousers and breeches (excl. industrial and occ'),
('62046233', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty,krátké kalhoty dámské,dívčí z vlasového manšestru', 'Women''s or girls'' trousers and breeches of cotton cut corduroy (excl. industri'),
('62046239', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty,krátké kalhoty dámské,dívčí ostatní,ne:viz sazebník', 'Women''s or girls'' trousers and breeches, of cotton (not of cut corduroy, of de'),
('62046251', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty s laclem se šlemi pracovní dámské,dívčí z bavlny', 'Women''s or girls'' bib and brace overalls, of cotton, industrial and occupation'),
('62046259', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty s laclem se šlemi dámské,dívčí z bavlny ostatní,ne:pracovní', 'Women''s or girls'' cotton bib and brace overalls (excl. knitted or crocheted, i'),
('62046290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty dámské,dívčí z bavlny ostatní,ne:viz sazebník', 'Women''s or girls'' cotton shorts (excl. knitted or crocheted, panties and swimw'),
('62046311', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty,krátké kalhoty pracovní dámské,dívčí ze syntetických vláken', 'Women''s or girls'' trousers and breeches, of synthetic fibres, industrial and o'),
('62046318', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty,krátké kalhoty dámské,dívčí ze syntetických vláken ost.,ne:pracovní', 'Women''s or girls'' trousers and breeches, of synthetic fibres (not of cut cordu'),
('62046331', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty s laclem se šlemi pracovní dámské,dívčí ze syntetických vláken', 'Women''s or girls'' bib and brace overalls, of synthetic fibres, industrial and'),
('62046339', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty s laclem se šlemi dámské,dívčí ze syntetických vláken ost.,ne:pracovní', 'Women''s or girls'' bib and brace overalls, of synthetic fibres (excl. knitted o'),
('62046390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty dámské,dívčí ze syntetických vláken ostatní,ne:viz sazebník', 'Women''s or girls'' shorts of synthetic fibres (excl. knitted or crocheted, pant'),
('62046911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty,krátké kalhoty pracovní dámské,dívčí z umělých vláken', 'Women''s or girls'' trousers and breeches, of artificial fibres, industrial and'),
('62046918', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty,krátké kalhoty dámské,dívčí z umělých vláken ostatní,ne:pracovní', 'Women''s or girls'' trousers and breeches, of artificial fibres (not of cut cord'),
('62046931', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty s laclem se šlemi pracovní dámské,dívčí z umělých vláken', 'Women''s or girls'' bib and brace overalls, of artificial fibres, industrial and'),
('62046939', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty s laclem se šlemi dámské,dívčí z umělých vláken ostatní,ne:pracovní', 'Women''s or girls'' bib and brace overalls of artificial fibres (excl. knitted o'),
('62046950', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty dámské,dívčí z umělých vláken ostatní,ne:viz sazebník', 'Women''s or girls'' shorts of artificial fibres (excl. knitted or crocheted, pan'),
('62046990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalhoty dámské,dívčí ostatní z jiných textilních materiálů,ne:viz sazebník', 'Women''s or girls'' trousers, bib and brace overalls, breeches and shorts of tex'),
('62052000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Košile pánské,chlapecké z bavlny', 'Men''s or boys'' shirts of cotton (excl. knitted or crocheted, nightshirts, sing'),
('62053000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Košile pánské,chlapecké z vláken chemických', 'Men''s or boys'' shirts of man-made fibres (excl. knitted or crocheted, nightshi'),
('62059010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Košile pánské,chlapecké ze lnu,ramie', 'Men''s or boys'' shirts of flax or ramie (excl. knitted or crocheted, nightshirt'),
('62059080', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Košile pánské,chlapecké z materiálů textilních ostatních,ne:viz sazebník', 'Men''s or boys'' shirts of textile materials (excl. of cotton or man-made fibres'),
('62061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Halenky,košile dámské,dívčí z hedvábí přírodního,hedvábného odpadu', 'Women''s or girls'' blouses, shirts and shirt-blouses of silk or silk waste (exc'),
('62062000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Halenky,košile dámské,dívčí z vlny,zvířecích chlupů', 'Women''s or girls'' blouses, shirts and shirt-blouses of wool or fine animal hai'),
('62063000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Halenky,košile dámské,dívčí z bavlny', 'Women''s or girls'' blouses, shirts and shirt-blouses of cotton (excl. knitted o'),
('62064000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Halenky,košile dámské,dívčí z vláken chemických', 'Women''s or girls'' blouses, shirts and shirt-blouses of man-made fibres (excl.'),
('62069010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Halenky,košile dámské,dívčí ze lnu,ramie', 'Women''s or girls'' blouses, shirts and shirt-blouses of flax or ramie (excl. kn'),
('62069090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Halenky,košile dámské,dívčí z materiálů textilních ostatních,ne:viz sazebník', 'Women''s or girls'' blouses, shirts and shirt-blouses of textile materials (excl'),
('62071100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Spodky krátké,dlouhé pánské,chlapecké z bavlny', 'Men''s or boys'' underpants and briefs of cotton (excl. knitted or crocheted)'),
('62071900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Spodky krátké,dlouhé pánské,chlapecké z materiálů textil.ostatních,ne:bavlna', 'Men''s or boys'' underpants and briefs of textile materials (excl. cotton and kn'),
('62072100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Košile noční,pyžama pánské,chlapecké z bavlny', 'Men''s or boys'' nightshirts and pyjamas of cotton (excl. knitted or crocheted,'),
('62072200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Košile noční,pyžama pánské,chlapecké z vláken chemických', 'Men''s or boys'' nightshirts and pyjamas of man-made fibres (excl. knitted or cr'),
('62072900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Košile noční,pyžama pánské,chlapecké z materiálů textil.ostatních,ne:viz sazebník', 'Men''s or boys'' nightshirts and pyjamas of textile materials (excl. of cotton o'),
('62079100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tílka,župany,pláště koupací apod.pánské,chlapecké z bavlny', 'Men''s or boys'' singlets and other vests, bathrobes, dressing gowns and similar'),
('62079910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tílka,župany,pláště koupací apod.pánské,chlapecké z vláken chemických', 'Men''s or boys'' singlets and other vests, bathrobes, dressing gowns and similar'),
('62079990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tílka,župany,pláště koupací apod.pánské,chlapecké z mater.textil.ost.,ne:sazebník', 'Men''s or boys'' singlets and other vests, bathrobes and dressing gowns of texti'),
('62081100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kombiné,spodničky dámské,dívčí z vláken chemických', 'Women''s or girls'' slips and petticoats of man-made fibres (excl. knitted or cr'),
('62081900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kombiné,spodničky dámské,dívčí z mater.textil.ostatních,ne:chemická vlákna', 'Women''s or girls'' slips and petticoats of textile materials (excl. man-made fi'),
('62082100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Košile noční,pyžama dámské,díví z bavlny', 'Women''s or girls'' nightdresses and pyjamas of cotton (excl. knitted or crochet'),
('62082200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Košile noční,pyžama dámské,dívčí z vláken chemických', 'Women''s or girls'' nightdresses and pyjamas of man-made fibres (excl. knitted o'),
('62082900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Košile noční,pyžama dámské,dívčí z mater.textil.ost.,ne:bavlna,chemická vlákna', 'Women''s or girls'' nightdresses and pyjamas of textile materials (excl. cotton'),
('62089100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tílka,kalhotky,nedbalky,župany,pláště koupací apod.dámské,dívčí z bavlny', 'Women''s or girls'' singlets and other vests, briefs, panties, nĂ©gligĂ©s, bathr'),
('62089200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nedbalky,koupací pláště,župany a pod.ost.ze syntet.,umělých vl.,ne:viz sazebník', 'Women''s or girls'' singlets and other vests, briefs, panties, nĂ©gligĂ©s, bathr'),
('62089900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tílka,kalhotky,župany apod.dámské,dívčí z mater.textil.ostatních,ne:viz sazebník', 'Women''s or girls'' singlets and other vests, briefs, panties, nĂ©gligĂ©s, bathr'),
('62092000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy kojenecké, doplňky z bavlny', 'Babies'' garments and clothing accessories of cotton (excl. knitted or crocheted'),
('62093000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy kojenecké,doplňky z vláken syntetických', 'Babies'' garments and clothing accessories of synthetic fibres (excl. knitted or'),
('62099010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy kojenecké,doplňky z vlny,zvířecích chlupů', 'Babies'' garments and clothing accessories of wool or fine animal hair (excl. kn'),
('62099090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy kojenecké,doplňky z materiálů textil.ost.,ne:viz sazebník', 'Babies'' garments and clothing accessories of textile materials (excl. of wool o'),
('62101010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy zcela zhotovené z plsti', 'Garments made up of felt, whether or not impregnated, coated, covered or laminat'),
('62101090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy zcela zhotovené z textilií netkaných', 'Garments made up of nonwovens, whether or not impregnated, coated, covered or la'),
('62102000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Svrchníky,kabáty,pláště apod.pánské,chlapec.z textilií impregnovaných,pogumovaných', 'Garments of the type described in subheading 6201,11 to 6201,19, rubberised or i'),
('62103000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Svrchníky,kabáty,pláště apod.dámské,dívčí z textilií impregnovaných,pogumovaných', 'Garments of the type described in subheading 6202,11 to 6202,19, rubberised or i'),
('62104000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy ost.pánské,chlapecké z plsti,textilií netkaných impregnovaných,ne:viz sazebník', 'Men''s or boys'' garments of textile fabrics, rubberised or impregnated, coated,'),
('62105000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy ost.dámské,dívčí z plsti,textilií netkaných impregnovaných,ne:viz sazebník', 'Women''s or girls'' garments of textile fabrics, rubberised or impregnated, coat'),
('62111100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Plavky pánské,chlapecké', 'Men''s or boys'' swimwear (excl. knitted or crocheted)'),
('62111200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Plavky dámské,dívčí', 'Women''s or girls'' swimwear (excl. knitted or crocheted)'),
('62112000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Oděvy lyžařské', 'Ski suits (excl. knitted or crocheted)'),
('62113210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy pracovní ostatní pánské,chlapecké z bavlny,ne:viz sazebník', 'Men''s or boys'' industrial and occupational clothing of cotton (excl. knitted o'),
('62113231', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Tepláky+podšívka pánské,chlapecké z bavlny,jediná vnější textilie,ne:pracovní', 'Men''s or boys'' lined tracksuits, of cotton, with an outer shell of a single id'),
('62113241', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Tepláky+podšívka-horní části pánské,chlapecké z bavlny,růz.vněj.text.,ne:pracovní', 'Men''s or boys'' lined tracksuit tops "upper parts", of cotton (not knitted or c'),
('62113242', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Tepláky+podšívka-dolní části pánské,chlapecké z bavlny,růz.vněj.text.,ne:pracovní', 'Men''s or boy''s lined tracksuit bottoms "lower parts", of cotton (not knitted o'),
('62113290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy ostatní pánské,chlapecké z bavlny,ne:viz sazebník', 'Men''s or boys'' garments, of cotton, n.e.s. (not knitted or crocheted)'),
('62113310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy pracovní ostatní pánské,chlapecké z vláken chemických,ne:viz sazebník', 'Men''s or boys'' industrial and occupational clothing of man-made fibres (excl.'),
('62113331', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Tepláky+podš.pánské,chlapecké,z chem.vláken,jediná vnější textil.,ne:pracovní', 'Men''s or boys'' lined tracksuits, of man-made fibres, with an outer shell of a'),
('62113341', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Tepláky+podšívka-horní části pánské,chlapecké,z chem.vláken,růz.vněj.textilie', 'Men''s or boys'' lined tracksuit tops "upper parts", of man-made fibres (not kni'),
('62113342', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Tepláky+podšívka-dolní části pánské,chlapecké,z chem.vláken,růz.vněj.textilie', 'Men''s or boys'' lined tracksuit bottoms "lower parts", of man-made fibres (not'),
('62113390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy ostatní pánské,chlapecké z vláken chemických,ne:viz sazebník', 'Men''s or boys'' garments, of man-made fibres, n.e.s. (not knitted or crocheted)'),
('62113900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy ostatní pánské,chlapecké z materiálů textilních ostatních,ne:viz sazebník', 'Men''s or boys'' tracksuits and other garments, n.e.s. of textile materials (exc'),
('62114100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy ostatní dámské,dívčí z vlny,zvířecích chlupů', 'Women''s or girls'' tracksuits and other garments, n.e.s. of wool or fine animal'),
('62114210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zástěry,kombinézy a jiné pracovní oděvy dámské,dívčí z bavlny,ne:viz sazebník', 'Women''s or girls'' aprons, overalls, smock-overalls and other industrial and oc'),
('62114231', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Tepláky+podšívka dámské,dívčí,z bavlny,jediná vnější textilie', 'Women''s or girls'' lined tracksuits, of cotton, with an outer shell of a single'),
('62114241', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Tepláky+podšívka-horní část dámské,dívčí z bavlny,různá horní textilie', 'Women''s or girls'' lined tracksuit tops "upper parts", of cotton (not knitted o'),
('62114242', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Tepláky+podšívka-dolní část dámské,dívčí z bavlnz,různá horní textilie', 'Women''s or girls'' lined tracksuit bottoms "lower parts", of cotton (not knitte'),
('62114290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy ostatní dámské,dívčí z bavlny,ne:viz sazebník', 'Women''s or girls'' garments, of cotton, n.e.s. (not knitted or crocheted)'),
('62114310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zástěry,kombinézy a jiné pracovní oděvy dámské,dívčí z vláken chemických', 'Women''s or girls'' aprons, overalls, smock-overalls and other industrial and oc'),
('62114331', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Tepláky+podšívka dámské,dívčí z chemických vláken,jediná vnější textilie', 'Women''s or girls'' lined tracksuits, of man-made fibres, with an outer shell of'),
('62114341', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Tepláky+podšívka-horní části dámské,dívčí z chem.vláken,různá horní textilie', 'Women''s or girls'' lined tracksuit tops "upper parts", of man-made fibres (not'),
('62114342', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Tepláky+podšívka-dolní části dámské,dívčí z chem.vláken,různá horní textilie', 'Women''s or girls'' lined tracksuit bottoms "lower parts", of man-made fibres (n'),
('62114390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy ostatní dámské,dívčí z vláken chemických,ne:viz sazebník', 'Women''s or girls'' garments, of man-made fibres, n.e.s. (not knitted or crochet'),
('62114900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy ostatní dámské,dívčí z materiálů textilních ostatních,ne:viz sazebník', 'Women''s or girls'' tracksuits and other garments, n.e.s. of textile materials ('),
('62121010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Podprsenky a polokorsety v sadě obsah.podprsenky nebo polokorset a kalhotky', 'Brassieres of all types of textile materials, whether or not elasticated, incl.'),
('62121090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Podprsenky a polokorsety ost.,ne:sada obsah.podprs.nebo polokorset a kalhotky', 'Brassieres of all types of textile materials, whether or not elasticated, incl.'),
('62122000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Podvazkové pásy,kalhotky i pletené,háčkované', 'Girdles and panty girdles of all types of textile materials, whether or not elas'),
('62123000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Korzety i pletené,háčkované', 'Corselettes of all types of textile materials, whether or not elasticated, incl.'),
('62129000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šle,podvazky a podobné výrobky a jejich části i pletené,háčkované', 'Corsets, braces, garters, suspenders and similar articles and parts thereof, inc'),
('62132000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kapesníky z bavlny', 'Handkerchiefs of cotton, of which no side exceeds 60 cm (excl. knitted or croche'),
('62139000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kapesníky z materiálu textil.ostatního,ne:bavlna', 'Handkerchiefs of textile materials, of which no side exceeds 60 cm (excl. of cot'),
('62141000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přehozy,šátky,šály,mantily,závoje a podobné výrobky z hedvábí přírod.,odpadu', 'Shawls, scarves, mufflers, mantillas, veils and similar articles of silk or silk'),
('62142000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přehozy,šátky,šály,mantily,závoje a podobné výrobky z vlny,zvířecích chlupů', 'Shawls, scarves, mufflers, mantillas, veils and similar articles of wool or fine'),
('62143000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přehozy,šátky,šály,mantily,závoje a podobné výrobky z vláken syntetických', 'Shawls, scarves, mufflers, mantillas, veils and similar articles of synthetic fi'),
('62144000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přehozy,šátky,šály,mantily,závoje a podobné výrobky z vláken umělých', 'Shawls, scarves, mufflers, mantillas, veils and similar articles of artificial f'),
('62149000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přehozy,šátky,šály a podobné výrobky z materiálů textilních ost.,ne:viz sazebník', 'Shawls, scarves, mufflers, mantillas, veils and similar articles of textile mate'),
('62151000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vázanky,motýlky,kravaty z hedvábí přírodního,hedvábného odpadu', 'Ties, bow ties and cravats of silk or silk waste (excl. knitted or crocheted)'),
('62152000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vázanky,motýlky,kravaty z vláken chemických', 'Ties, bow ties and cravats of man-made fibres (excl. knitted or crocheted)'),
('62159000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vázanky,motýlky,kravaty z materiálů textilních ostatních,ne:viz sazebník', 'Ties, bow ties and cravats of textile materials (excl. of silk, silk waste or ma'),
('62160000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Rukavice prstové,palcové,bez prstů', 'Gloves, mittens and mitts, of all types of textile materials (excl. knitted or c'),
('62171000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Doplňky oděvní zcela zhotovené ostatní,ne:viz sazebník', 'Made-up clothing accessories, of all types of textile materials, n.e.s. (excl. k'),
('62179000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části oděvů,doplňků oděvních ostatní,ne:viz sazebník', 'Parts of garments or clothing accessories, of all types of textile materials, n.'),
('63011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přikrývky elektricky vyhřívané', 'Electric blankets of all types of textile materials'),
('63012010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přikrývky,koberečky cestovní z vlny,zvířecích chlupů pletené,háčkované', 'Blankets and travelling rugs of wool or fine animal hair, knitted or crocheted ('),
('63012090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přikrývky,koberečky cestovní z vlny,zvířecích chlupů,ne:pletené,háčkované', 'Blankets and travelling rugs, of wool or fine animal hair (excl. knitted or croc'),
('63013010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přikrývky,koberečky cestovní z bavlny pletené,háčkované', 'Blankets and travelling rugs of cotton, knitted or crocheted (excl. electric, ta'),
('63013090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přikrývky,koberečky cestovní z bavlny,ne:pletené,háčkované', 'Blankets and travelling rugs of cotton (excl. knitted or crocheted, electric, ta'),
('63014010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přikrývky,koberečky cestovní z vláken syntetických pletené,háčkované', 'Blankets and travelling rugs of synthetic fibres, knitted or crocheted (excl. el'),
('63014090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přikrývky,koberečky cestovní z vláken syntetických,ne:pletené,háčkované', 'Blankets and travelling rugs of synthetic fibres (excl. knitted or crocheted, el'),
('63019010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přikrývky,koberečky cestovní z mater.textil.ost.pletené,háčkované,ne:viz sazebník', 'Blankets and travelling rugs, knitted or crocheted (excl. of wool or fine animal'),
('63019090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přikrývky,koberečky cestovní ostatní z mater.textil.ostatních,ne:viz sazebník', 'Blankets and travelling rugs of textile materials (excl. of wool or fine animal'),
('63021000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prádlo ložní pletené,háčkované', 'Bedlinen, knitted or crocheted'),
('63022100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prádlo ložní potisknuté z bavlny', 'Printed bedlinen of cotton (excl. knitted or crocheted)'),
('63022210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prádlo ložní potisknuté z textilíí netkaných z vláken chemických', 'Printed bedlinen of nonwovens of man-made fibres'),
('63022290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prádlo ložní potisknuté z vláken chemických ostatní,ne:z netkaných textilií', 'Printed bedlinen of man-made fibres (excl. nonwovens and knitted or crocheted)'),
('63022910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prádlo ložní potisknuté ze lnu,ramie', 'Printed bedlinen of flax or ramie (excl. knitted or crocheted)'),
('63022990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prádlo ložní potisknuté z materiálů textilních ostatních,ne:viz sazebník', 'Printed bedlinen of textile materials (excl. of cotton and man-made fibres, flax'),
('63023100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prádlo ložní nepotisknuté z bavlny', 'Bedlinen of cotton (excl. printed, knitted or crocheted)'),
('63023210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prádlo ložní nepotisknuté z textilie netkané z vláken chemických', 'Bedlinen of nonwovens of man-made fibres (excl. printed)'),
('63023290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prádlo ložní nepotisknuté z vláken chemických ostatní,ne:z netkané textilie', 'Bedlinen of man-made fibres (excl. nonwovens, printed, knitted or crocheted)'),
('63023920', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prádlo ložní nepotisknuté ze lnu,ramie', 'Bedlinen of flax or ramie (excl. printed, knitted or crocheted)'),
('63023990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prádlo ložní nepotisknuté z materiálů textilních ostatních,ne:viz sazebník', 'Bedlinen of textile materials (excl. of cotton, man-made fibres, flax or ramie,'),
('63024000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prádlo stolní pletené,háčkované', 'Table linen, knitted or crocheted'),
('63025100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prádlo stolní z bavlny,ne:pletené,háčkované', 'Table linen of cotton (excl. knitted or crocheted)'),
('63025310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prádlo stolní z textilie netkané z vláken chemických', 'Table linen of nonwovens of man-made fibres'),
('63025390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prádlo stolní z vláken chemických ostatní,ne:z netkané textilie,pletené,háčkované', 'Table linen of man-made fibres (excl. nonwovens, knitted or crocheted)'),
('63025910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prádlo stolní ze lnu', 'Table linen of flax (excl. knitted or crocheted)'),
('63025990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prádlo stolní z materiálů textilních ostatních,ne:viz sazebník', 'Table linen of textile materials (excl. of cotton, flax or man-made fibres, knit'),
('63026000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prádlo toaletní,kuchyňské z bavlny z froté apod.', 'Toilet linen and kitchen linen, of terry towelling or similar terry fabrics of c'),
('63029100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prádlo toaletní,kuchyňské z bavlny,ne:froté', 'Toilet linen and kitchen linen of cotton (excl. of terry fabrics, floorcloths, p'),
('63029310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prádlo toaletní,kuchyňské z textilií netkaných z vláken chemických', 'Toilet linen and kitchen linen of nonwovens of man-made fibres (excl. floorcloth'),
('63029390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prádlo toaletní,kuchyňské z vláken chemických ostatní,ne:netkané textilie', 'Toilet linen and kitchen linen of man-made fibres (excl. nonwovens, floorcloths,'),
('63029910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prádlo toaletní,kuchyňské ze lnu', 'Toilet linen and kitchen linen of flax (excl. floorcloths, polishing cloths, dis'),
('63029990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prádlo toaletní,kuchyňské z materiálů textilních ostatních,ne:viz sazebník', 'Toilet linen and kitchen linen of textile materials (excl. of cotton, flax or ma'),
('63031200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Záclony,závěsy,rolety,draperie apod.z vláken syntetických pletené,háčkované', 'Curtains, incl. drapes, and interior blinds, curtain or bed valances of syntheti'),
('63031900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Záclony,závěsy,rolety apod.z mater.textil.ost.pletené,háčkované,ne:viz sazebník', 'Curtains, incl. drapes, and interior blinds, curtain or bed valances, knitted or'),
('63039100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Záclony,závěsy,rolety,draperie z bavlny,ne:pletené,háčkované', 'Curtains, incl. drapes, and interior blinds, curtain or bed valances of cotton ('),
('63039210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Záclony,rolety apod.z textilií netkaných z vláken syntet.,ne:pletené,háčkované', 'Curtains, incl. drapes, and interior blinds, curtain or bed valances of nonwoven'),
('63039290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Záclony,rolety apod.z vláken syntet.ost.,ne:netkaný textil,pletené,háčkované', 'Curtains, incl. drapes, and interior blinds, curtain or bed valances of syntheti'),
('63039910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Záclony,rolety apod.z textilií netkaných z mater.textil.ostatních,ne:viz sazebník', 'Curtains, incl. drapes, and interior blinds, curtain or bed valances of nonwoven'),
('63039990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Záclony,rolety apod.ostatní z materiálů textilních ostatních,ne:viz sazebník', 'Curtains, incl. drapes, and interior blinds, curtain or bed valances of textile'),
('63041100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přehozy lůžkové pletené,háčkované', 'Knitted or crocheted bedspreads (excl. bedlinen, quilts and eiderdowns)'),
('63041910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přehozy lůžkové z bavlny,ne:pletené,háčkované', 'Bedspreads of cotton (excl. knitted or crocheted, bedlinen, quilts and eiderdown'),
('63041930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přehozy lůžkové ze lnu,ramie,ne:pletené,háčkované', 'Bedspreads of flax or ramie (excl. knitted or crocheted, bedlinen, quilts and ei'),
('63041990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přehozy lůžkové z mater.textil.ostatních,ne:bavlna,len,ramie,pletené,háčkované', 'Bedspreads of textile materials (excl. of cotton, flax or ramie, knitted or croc'),
('63049100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie bytové ostatní pletené,háčkované,ne:lůžkové přehozy', 'Articles for interior furnishing, knitted or crocheted (excl. blankets and trave'),
('63049200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie bytové ostatní bavlněné,ne:pletené,háčkované,lůžkové přehozy', 'Articles for interior furnishing, of cotton (excl. knitted or crocheted, blanket'),
('63049300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie bytové ostatní z vláken syntet.,ne:pletené,háčkované,lůžkové přehozy', 'Articles for interior furnishing, of synthetic fibres (excl. knitted or crochete'),
('63049900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Textilie bytové ostatní z materiálů textilních ostatních,ne:viz sazebník', 'Articles for interior furnishing, of textile materials (excl. of cotton or synth'),
('63051010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pytle,pytlíky k balení zboží z juty,jiných textilních lýkových vláken použité', 'Used sacks and bags, for the packing of goods, of jute or other textile bast fib'),
('63051090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pytle,pytlíky k balení zboží z juty,jiných textil.lýkových vláken nepoužité', 'Sacks and bags, for the packing of goods, of jute or other textile bast fibres o'),
('63052000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pytle,pytlíky k balení zboží z bavlny', 'Sacks and bags, for the packing of goods, of cotton'),
('63053211', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pytle,pytlíky z pásků polyethylen.,polypropylen.pružné pletené,háčkované', 'Flexible intermediate bulk containers, for the packing of goods, of polyethylene'),
('63053219', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pytle,pytlíky z pásků polyethylen.,polypropylen.pružné ostatní,ne:pletené,háčkované', 'Flexible intermediate bulk containers, for the packing of goods, of polyethylene'),
('63053290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pytle,pytlíky z pásků z mater.textil.chem.ostatních pružné,ne:viz sazebník', 'Flexible intermediate bulk containers, for the packing of goods, of man-made tex'),
('63053310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pytle,pytlíky z pásků polyethylen.,polypropylen.nepružné,pletené,háčkované', 'Sacks and bags, for the packing of goods, of polyethylene or polypropylene strip'),
('63053390', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pytle,pytlíky z pásků polyethylen.,polypropylen.nepružné ostatní,ne:pletené,háčkované', 'Sacks and bags, for the packing of goods, of polyethylene or polypropylene strip'),
('63053900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pytle,pytlíky z materiálů textilních chemických ostatních,ne:viz sazebník', 'Sacks and bags, for the packing of goods, of man-made textile materials (excl. o'),
('63059000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pytle,pytlíky z pásků z materiálů textilních ostatních,ne:viz sazebník', 'Sacks and bags, for the packing of goods, of textile materials (excl. man-made,'),
('63061200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plachty nepromokavé,ochranné,stínící z vláken syntetických', 'Tarpaulins, awnings and sunblinds of synthetic fibres (excl. flat covers of ligh'),
('63061900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plachty nepromokavé,ochranné,stínící z mater.textil.ost.,ne:vlákna syntetická', 'Tarpaulins, awnings and sunblinds of textile materials (excl. of synthetic fibre'),
('63062200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stany z vláken syntetických', 'Tents of synthetic fibres (excl. umbrella and play tents)'),
('63062900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stany z materiálů textilních ostatních,ne:vlákna syntetická', 'Tents of textile materials (excl. of synthetic fibres, and umbrella and play ten'),
('63063000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plachty lodní', 'Sails for boats, sailboards or landcraft, of textile materials'),
('63064000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Matrace nafukovací', 'Pneumatic mattresses of textile materials'),
('63069100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky kempingové ostatní z bavlny', 'Camping goods of cotton (excl. tents, awnings and sunblinds, sails, pneumatic ma'),
('63069900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky kempingové ostatní z materiálů textilních ostatních,ne:bavlna', 'Camping goods of textile materials (excl. of cotton, tents, awnings and sunblind'),
('63071010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hadry na podlahu,utěrky,prachovky apod.pletené,háčkované', 'Floorcloths, dishcloths, dusters and similar cleaning cloths, knitted or crochet'),
('63071030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hadry na podlahu,utěrky,prachovky apod.z textilie netkané', 'Floorcloths, dishcloths, dusters and similar cleaning cloths, of nonwovens'),
('63071090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hadry na podlahu,utěrky,prachovky apod.ost.,ne:textilie netkané,pletené,háčkov', 'Floorcloths, dishcloths, dusters and similar cleaning cloths, of all types of te'),
('63072000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vesty,pásy záchranné', 'Life jackets and life belts, of all types of textile materials'),
('63079010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky zcela zhotovené ostatní pletené,háčkované,ne:viz sazebník', 'Made-up articles of textile materials, incl. dress patterns, knitted or crochete'),
('63079091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky zcela zhotovené ostatní z plsti,ne:viz sazebník', 'Made-up articles of felt, incl. dress patterns, n.e.s.'),
('63079099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky zcela zhotovené ostatní,ne:viz sazebník', 'Made-up articles of textile materials, incl. dress patterns, n.e.s. (excl. of fe'),
('63080000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Soupravy z tkanin,přízí k výrobě koberečků,ubrusů apod.v balení pro dr.prodej', 'Sets consisting of woven fabric and yarn, whether or not with accessories, for m'),
('63090000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy obnošené a jiné výrobky textilní opotřebené', 'Worn clothing and clothing accessories, blankets and travelling rugs, household'),
('63101000', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hadry použité,nové,odpady lan,provazů a podobně tříděné', 'Used or new rags, scrap twine, cordage, rope and cables and worn-out articles th'),
('63109000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hadry použité,nové,odpady lan,provazů a podobně netříděné', 'Used or new rags, scrap twine, cordage, rope and cables and worn-out articles th'),
('64011000', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv nepromokavá,svršek pryžový nebo plastový,kovová ochranná špička', 'Waterproof footwear incorporating a protective metal toecap, with outer soles an'),
('64019210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv nepromokavá kryjící kotník,svršek pryžový,ne:kovová ochranná špička', 'Waterproof footwear with uppers of rubber and outer soles of rubber or of plasti'),
('64019290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv nepromokavá kryjící kotník,svršek plasty,ne:kovová ochranná špička', 'Waterproof footwear with uppers of plastic and outer soles of rubber or of plast'),
('64019900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv nepromokavá ostatní,svršek z kaučuku nebo plastu,ne:viz sazebník', 'Waterproof footwear covering neither the ankle nor the knee, with outer soles an'),
('64021210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv lyžařská,běžkařská,podešev i svršek z kaučuku,plastů', 'Ski-boots and cross-country ski footwear, with outer soles and uppers of rubber'),
('64021290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv pro snowboard,podešev i svršek z kaučuku,plastů', 'Snowboard boots with outer soles and uppers of rubber or plastics (excl. waterpr'),
('64021900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv sportovní ostatní,podešev z kaučuku,plastů,ne:lyžařská,běžky,snowboard', 'Sports footwear with outer soles and uppers of rubber or plastics (excl. waterpr'),
('64022000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv z kaučuku,plastů,svršek z řemínků,pásků připevněný k podešvi čepy', 'Footwear with outer soles and uppers of rubber or plastics, with upper straps or'),
('64029110', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv pokrývající kotník,podešev i svršek pryžový,z plastu,kovová ochr.špička', 'Footwear covering the ankle, incorporating a protective metal toecap, with outer'),
('64029190', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv pokrývající kotník,podešev i svršek pryžový,z plastu,ost.,ne:kovová ochr.špička', 'Footwear covering the ankle, with outer soles and uppers of rubber or plastics ('),
('64029905', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv nekryjící kotník,podešev i svršek pryžový,z plastu,kovová ochr.špička', 'Footwear incorporating a protective metal toecap, with outer soles and uppers of'),
('64029910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv nekryjící kotník,svršek pryžový,ne:kovová ochr.špička', 'Footwear with uppers of rubber and outer soles of rubber or plastics (excl. cove'),
('64029931', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv nekryjící kotník,svršek plasty-řemínky,výřezy,podpatek nad 3cm,ne:kovová ochr.špička', 'Footwear with uppers of plastic and outer soles of rubber or plastics, with a va'),
('64029939', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv nekryjící kotník,svršek plasty-řemínky,výřezy,podpatek do 3cm,ne:kovová ochr.špička', 'Footwear with uppers of plastic and outer soles of rubber or plastics, with a va'),
('64029950', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Trepky a jiná obuv domácí,svršek plasty,ne:kovová ochr.špička', 'Slippers and other indoor footwear, with outer sole and upper of rubber or plast'),
('64029991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv ostatní,svršek plasty,stélka pod 24cm,ne:viz sazebník', 'Footwear with uppers of plastics and outer soles of rubber or plastics, with in-'),
('64029993', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv ostatní,svršek plasty,stélka 24cm a víc,ne:viz sazebník', 'Footwear non-identifiable as men''s or women''s footwear, with uppers of plastic'),
('64029996', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv ostatní pánská,svršek plasty,stélka 24cm a víc,ne:viz sazebník', 'Footwear with outer soles of rubber or plastics and uppers of plastics, with in-'),
('64029998', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv ostatní dámská,svršek plasty,stélka 24cm a víc,ne:viz sazebník', 'Footwear with outer soles of rubber or of plastics and uppers of plastics, with'),
('64031200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv lyžař.běžec.snowboard,podešev z kaučuku,plastu,usně,svršek z usně', 'Ski-boots, cross-country ski footwear and snowboard boots, with outer soles of r'),
('64031900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv sportovní ostatní,svršek z usně,podešev kaučuk,plasty,useň,ne:viz sazebník', 'Sports footwear, with outer soles of rubber, plastics, leather or composition le'),
('64032000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv,svršek z řemínků z usně přes nárt a kolem palce,podešev useň', 'Footwear with outer soles of leather, and uppers which consist of leather straps'),
('64034000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv,svršek z usně,podešev kaučuk,plast,useň s kovovou ochrannou špičkou', 'Footwear, incorporating a protective metal toecap, with outer soles of rubber, p'),
('64035105', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv pokrývající kotník,z usně,základní díl dřevo,bez stélky,bez kovové ochr.špičky', 'Footwear with outer soles and uppers of leather, made on a base or platform of w'),
('64035111', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv ostatní,podešev z usně kryjící kotník,stélka pod 24cm,ne:viz sazebník', 'Footwear with outer soles and uppers of leather, covering the ankle but not the'),
('64035115', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv ostatní,podešev z usně kryjící kotník pánská,stélka 24cm a víc,ne:sazebník', 'Men''s footwear with outer soles and uppers of leather, covering the ankle but n'),
('64035119', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv ostatní,podešev z usně kryjící kotník dámská,stélka 24cm a víc,ne:viz sazebník', 'Women''s footwear with outer soles and uppers of leather, covering the ankle but'),
('64035191', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv ostatní,podešev z usně kryjící kotník i část lýtka,stélka pod 24cm,ne:viz sazebník', 'Footwear with outer soles and uppers of leather, covering the ankle and calf, wi'),
('64035195', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv ostatní,podešev z usně kryjící kotník i část lýtka pánská,stélka nad 24cm', 'Men''s footwear with outer soles and uppers of leather, covering the ankle and c'),
('64035199', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv ostatní,podešev z usně kryjící kotník i část lýtka dámská,stélka nad 24cm', 'Women''s footwear with outer soles and uppers of leather, covering the ankle and'),
('64035905', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv nekryjící kotník,z usně,základní díl dřevo,bez stélky,bez kovové ochr.špičky', 'Footwear with outer soles and uppers of leather, made on a base or platform of w'),
('64035911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv dám.,svršek useň-řemínky,výřezy,kombinovaná podešev useň,podpatek nad 3cm', 'Footwear with outer soles and uppers of leather, with a vamp made of straps or w'),
('64035931', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv dám.,svršek useň-řemínky,výřezy,podešev useň,stélka do 24cm,podpat.do 3cm', 'Footwear with outer soles and uppers of leather, with a vamp made of straps or w'),
('64035935', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv pán.,svršek useň-řemínky,výřezy,podešev useň,podp.do 3cm,stélka 24cm a více', 'Men''s footwear with outer soles and uppers of leather, with a vamp made of stra'),
('64035939', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv dám.,svršek useň-řemínky,výřezy,podešev useň,podp.do 3cm,stélka 24cm a více', 'Women''s footwear with outer soles and uppers of leather, with a vamp made of st'),
('64035950', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Trepky a jiná obuv domácí z usně,podešev useň', 'Slippers and other indoor footwear, with outer soles and uppers of leather (excl'),
('64035991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv ostatní,podešev i svršek z usně,stélka do 24cm,ne:viz sazebník', 'Footwear with outer soles and uppers of leather, with in-soles of < 24 cm in len'),
('64035995', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv ostatní,podešev i svršek z usně pánská,stélka 24cm a víc,ne:viz sazebník', 'Men''s footwear with outer soles and uppers of leather, with in-soles of >= 24 c'),
('64035999', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv ostatní,podešev i svršek z usně dámská,stélka 24cm a víc,ne:viz sazebník', 'Women''s footwear with outer soles and uppers of leather, with in-soles of >= 24'),
('64039105', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv pokrývající kotník,základní díl dřevo,bez stélky,bez kovové ochr.,ne:z usně', 'Footwear with outer soles of rubber, plastics or composition leather, with upper'),
('64039111', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv kryjící kotník(ne lýtko),podešev kaučuk,plast,svršek useň,stélka pod 24cm', 'Footwear with outer soles of rubber, plastics or composition leather, with upper'),
('64039113', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv kryjící kotník(ne lýtko),podešev kaučuk,plast,svršek useň,stélka 24cm a více', 'Footwear non-identifiable as men''s or women''s footwear, with outer soles of ru'),
('64039116', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv kryjící kotník pánská,podešev kaučuk,plast,svršek useň,stélka 24cm a více', 'Men''s footwear with outer soles of rubber, plastics or composition leather, wit'),
('64039118', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv kryjící kotník dámská,podešev kaučuk,plast,svršek useň,stélka 24cm a více', 'Women''s footwear with outer soles of rubber, plastics or composition leather, w'),
('64039191', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv kryjící lýtko,podešev kaučuk,plast,svršek useň,stélka pod 24cm', 'Footwear with outer soles of rubber, plastics or composition leather, with upper'),
('64039193', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv kryjící lýtko,podešev kaučuk,plast,svršek useň,stélka 24cm a více', 'Footwear non-identifiable as men''s or women''s footwear, with outer soles of ru'),
('64039196', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv kryjící lýtko pánská,podešev kaučuk,plast,svršek useň,stélka 24cm a víc', 'Men''s footwear with outer soles of rubber, plastics or composition leather, wit'),
('64039198', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv kryjící lýtko dámská,podešev kaučuk,plast,svršek useň,stélka 24cm a více', 'Women''s footwear with outer soles of rubber, plastics or composition leather, w'),
('64039905', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv nekryjící kotník,základní díl dřevo,bez stélky,bez kovové ochr.špičky,ne:z usně', 'Footwear with outer soles of rubber, plastics or composition leather, with upper'),
('64039911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv, svršek useň - řemínky, výřezy, podešev kaučuk, useň, podpatek nad 3 cm', 'Footwear with outer soles of rubber, plastics or composition leather, with upper'),
('64039931', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv, svršek useň - řemínky, výřezy, podešev kaučuk, useň, do 24 cm', 'Footwear with outer soles of rubber, plastics or composition leather, with upper'),
('64039933', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv, svršek useň - řemínky, výřezy, podešev kaučuk, useň, nad 24 cm', 'Footwear non-identifiable as men''s or women''s footwear, with outer soles of ru'),
('64039936', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv, svršek useň - řemínky, výřezy, pánská,podešev kaučuk, useň, nad 24 cm', 'Men''s footwear with outer soles of rubber, plastics or composition leather, wit'),
('64039938', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv, svršek useň-řemínky dámská, podešev kaučuk aj., podpatek do 3cm,nad 24cm', 'Women''s footwear with outer soles of rubber, plastics or composition leather, w'),
('64039950', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Trepky a jiná obuv domácí z usně, podešev kaučuk a podobně, useň', 'Slippers and other indoor footwear, with outer soles of rubber, plastics, or com'),
('64039991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv z usně dámská, podešev kaučuk, plasty, useň, nad 24 cm', 'Footwear with outer soles of rubber, plastics or composition leather, with upper'),
('64039993', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv z usně, podešev kaučuk, plasty, useň, nad 24 cm', 'Footwear non-identifiable as men''s or women''s footwear, with outer soles of ru'),
('64039996', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv z usně pánská, podešev kaučuk, plasty, useň, nad 24 cm', 'Men''s footwear with outer soles of rubber, plastics or composition leather, wit'),
('64039998', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv z usně dámská, podešev kaučuk, plasty, useň, nad 24 cm', 'Footwear with outer soles of rubber, plastics or composition leather and uppers'),
('64041100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv sportovní,svršek materiál textiln,podešev kaučuk,plast', 'Sports footwear, incl. tennis shoes, basketball shoes, gym shoes, training shoes'),
('64041910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Trepky a jiná obuv domácí,svršek materiál textilní,podešev kaučuk,plast', 'Slippers and other indoor footwear, with outer soles of rubber or plastics and u'),
('64041990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv ost.,svršek materiál textilní,podešev kaučuk,plast,ne:sportovní,domácí', 'Footwear with outer soles of rubber or plastics and uppers of textile materials'),
('64042010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Trepky a jiná obuv domácí,svršek materiál textiln,podešev useň i kompozitní', 'Slippers and other indoor footwear with outer soles of leather or composition le'),
('64042090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv ostatní,svršek materiál textilní,podešev useň i kompozitní,ne:domácí', 'Footwear with outer soles of leather or composition leather and uppers of textil'),
('64051000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Ostatní obuv se svrškem z usně nebo kompozitní usně', 'Footwear with uppers of leather or composition leather (excl. with outer soles o'),
('64052010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv,svršek materiál textilní,podešev dřevo,korek', 'Footwear with uppers of textile materials and outer soles of wood or cork (excl.'),
('64052091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Trepky a jiná obuv domácí,svršek mater.textil.,podešev z ost.mater.,ne:sazebník', 'Slippers and other indoor footwear with uppers of textile materials (excl. with'),
('64052099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv ost.,svršek materiál textilní,podešev z ost.materiálů,ne:viz sazebník', 'Footwear with uppers of textile materials (excl. with outer soles of rubber, pla'),
('64059010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv ostatní,podešev pryž,plast,useň,ne:viz sazebník', 'Footwear with outer soles of rubber, plastics, leather or composition leather an'),
('64059090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Obuv ostatní,ne:viz sazebník', 'Footwear with outer soles of wood, cork, twine, paperboard, furskin, woven fabri'),
('64061010', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Svršky obuvi a jejich části z usně,ne:opatky a výztuže', 'Uppers and parts thereof, of leather (excl. stiffeners)'),
('64061090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Svršky obuvi a jejich části z ost. materiálů,ne:opatky a výztuže,z usně', 'Uppers, whether or not attached to soles other than outer soles, and parts there'),
('64062010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Podešve,podpatky z kaučuku', 'Outer soles and heels of rubber'),
('64062090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Podešve,podpatky z plastů', 'Outer soles and heels of plastics'),
('64069100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části obuvi ostatní ze dřeva', 'Parts of footwear, of wood'),
('64069930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Svršky spojené se stélkou a jinou  částí spodku obuvi,ale bez podešve', 'Assemblies of uppers affixed to inner soles or to other sole components (excl. o'),
('64069950', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stélky a jiné odstranitelné příslušenství', 'Removable in-soles, heel cushions and other removable accessories'),
('64069960', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Podešve z usně nebo kompozitní usně', 'Outer soles of shoes, of leather or composition leather,'),
('64069985', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní části obuvi,ne:viz sazebník', 'Parts of footwear and gaiters, leggings and similar articles, and parts thereof'),
('65010000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kloboukové šišáky,formy kloboukové nezformované,bez střechy z plsti', 'Hat-forms, hat bodies and hoods of felt, neither blocked to shape nor with made'),
('65020000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'kloboukové šišáky,formy kloboukové splétané,spojením pásků nezformované', 'Hat-shapes, plaited or made by assembling strips of any material (excl. blocked'),
('65040000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Klobouky a jiné pokrývky hlavy splétané,z pásků i podšité,zdobené', 'Hats and other headgear, plaited or made by assembling strips of any material, w'),
('65051000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Síťky na vlasy pletené,háčkované (jakýkoli materiál) i podšité,zdobené', 'Hairnets of any material, whether or not lined or trimmed'),
('65059005', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Klobouky a jiné pokrývky hlavy ze šišáků z plsti z chlupů,z vlny a chlupů', 'Hats and other headgear, knitted or crocheted, or made up from lace, of fur felt'),
('65059010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Barety,čepice,čapky,fezy,turbany a podobné pokrývky hlavy', 'Berets, bonnets, skull-caps, fezzes, tarbooshes and the like, knitted or crochet'),
('65059030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čepice se štítkem', 'Peaked caps and the like, knitted or crocheted, or made up from lace, felt or ot'),
('65059080', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Klobouky a jiné pokrývky hlavy,ne:viz sazebník', 'Hats and other headgear, knitted or crocheted, or made up from lace, felt or oth'),
('65061010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pokrývky hlavy ost.,ochranné,z plastů,i podšívané,zdobené', 'Safety headgear of plastics, whether or not lined or trimmed'),
('65061080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pokrývky hlavy ost.,ochranné,z jiných mat.,i podšívané,zdobené,ne:z plastů', 'Safety headgear, whether or not lined or trimmed (other than of plastics)'),
('65069100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pokrývky hlavy ost.,z kaučuku,plastů,ne:ochranné', 'Bathing caps, hoods and other headgear, whether or not lined or trimmed, of rubb'),
('65069910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pokrývky hlavy ost.,ze šišáků z plsti z chlupů,z vlny a chlupů,ne:viz sazebník', 'Hats and other headgear, of fur felt or of felt of wool and fur, made from the h'),
('65069990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pokrývky hlavy ost.,z jiných mat.,ne:viz sazebník', 'Headgear, whether or not lined or trimmed, n.e.s.'),
('65070000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pásky pro vnitřní vybavení,podšívky,povlaky,kostry apod.pro pokrývky hlavy', 'Headbands, linings, covers, hat foundations, hat frames, peaks and chinstraps, f'),
('66011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Slunečníky zahradní a podobné', 'Garden or similar umbrellas (excl. beach tents)'),
('66019100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Deštníky,slunečníky se zásuvnou rukojetí,ne:zahradní slunečníky', 'Umbrellas having a telescopic shaft (excl. toy umbrellas)'),
('66019911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Deštníky,slunečníky ost.se zásuvnou rukojetí,potah z chem.vláken,ne:viz sazebník', 'Umbrellas and sun umbrellas, incl. walking-stick umbrellas, with a cover of wove'),
('66019919', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Deštníky,slunečníky ost.se zás.rukojetí,potah z jiných textil.mater.,ne:viz sazebník', 'Umbrellas and sun umbrellas, incl. walking-stick umbrellas, with a cover of wove'),
('66019990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Deštníky,slunečníky ostatní,ne:potah z mater.textil.,zásuv.rukojeť,zahradní', 'Umbrellas and sun umbrellas, incl. walking-stick umbrellas (excl. umbrellas with'),
('66020000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hole,i sedaci,bice,biciky jezdecke ap vyrobky', 'Walking sticks, seat-sticks, whips, riding-crops and the like (excl. measure wal'),
('66032000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kostry deštníkové i nasazené na holích', 'Umbrella frames, incl. frames mounted on shafts "sticks", for umbrellas and sun'),
('66039010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rukojeti,knoflíky pro deštníky,slunečníky,hole,biče a podobné výrobky', 'Handles and knobs for umbrellas and sun umbrellas of heading 6601 or for walking'),
('66039090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Součásti,příslušenství ost.pro deštníky,slunečníky,hole,biče apod.,ne:viz sazebník', 'Parts, trimmings and accessories for umbrellas and sun umbrellas of heading 6601'),
('67010000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kůže a jiné části ptáků s peřím,péra (i části),peří,výrobky z nich', 'Skins and other parts of birds with their feathers or down, feathers, parts of f'),
('67021000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Květiny,listoví,ovoce a jejich součásti umělé z plastů,výrobky z nich', 'Artificial flowers, foliage and fruit and parts thereof, and articles made of ar'),
('67029000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Květiny,listoví,ovoce a jejich součásti,výrobky umělé z mater.ost.,ne:plast', 'Artificial flowers, foliage and fruit and parts thereof, and articles made of ar'),
('67030000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlasy lidské,vlna ovcí,chlupy zvířecí upravené pro výrobu paruk', 'Human hair, dressed, thinned, bleached or otherwise worked; wool, other animal h'),
('67041100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Paruky celé z materialů textilních syntetických', 'Complete wigs of synthetic textile materials'),
('67041900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vousy nepravé,příčesky,obočí,řasy apod.výr.z materiálů textilních syntetických', 'False beards, eyebrows and eyelashes, switches and the like, of synthetic textil'),
('67042000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Paruky,vousy nepravé,příčesky,obočí,řasy apod.výr.z lidských vlasů', 'Wigs, false beards, eyebrows and eyelashes, switches and the like, of human hair'),
('67049000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Paruky,vousy nepravé,příčesky,řasy apod.výr.z mater.ostatních,ne:viz sazebník', 'Wigs, false beards, eyebrows and eyelashes, switches and the like, of animal hai'),
('68010000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dlažební kostky,obrubníky,desky dlažební z přírodního kamene,ne:z břidlice', 'Setts, curbstones and flagstones, of natural stone (excl. slate)'),
('68021000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dlaždice,kostky apod.(plocha do čtverce do 7cm),prach,granule barvené,ne:břidlice', 'Tiles, cubes and other processed articles of natural stone, incl. slate, for mos'),
('68022100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mramor,travertin,alabastr jednoduše řezané,broušené,pro staveb.,výtvarné účely', 'Marble, travertine and alabaster articles thereof, simply cut or sawn, with a fl'),
('68022300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Žula jednoduše broušená,řezaná k stavebním,výtvarným účelům', 'Granite and articles thereof, simply cut or sawn, with a flat or even surface (e'),
('68022900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kameny ost.jednoduše broušené,řezané k stavebním,výtvarným účelům,ne:sazebník', 'Monumental or building stone and articles thereof, simply cut or sawn, with a fl'),
('68029110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Alabastr leštěný zdobený,jinak opracovaný,ne:vyřezávaný', 'Polished alabaster, in any form, decorated or otherwise worked, but not carved ('),
('68029190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mramor,travertin leštěný,opracovaný,ne:vyřezávaný', 'Marble, travertine and alabaster, in any form, polished, decorated or otherwise'),
('68029210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kameny ost.vápenaté,leštěné,opracované,ne:vyřezávané,mramor,alabastr,travertin', 'Calcareous stone other than marble, travertine and alabaster, in any form, polis'),
('68029290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kameny ostatní vápenaté vyřezávané,ne:viz sazebník', 'Calcareous stone other than marble, travertine and alabaster, in any form, polis'),
('68029310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Žula leštěná,zdobená,opracovaná,hmotnost 10 kg a víc,ne:vyřezávaná', 'Granite, in any form, polished, decorated or otherwise worked, but not carved, o'),
('68029390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Žula leštěná,zdobená,opracovaná,hmotnost pod 10 kg', 'Granite, in any form, polished, decorated or otherwise worked, of a net weight o'),
('68029910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kameny ostatní leštěné,zdobené,opracované,hmotnost 10kg a víc,ne:viz sazebník', 'Monumental or building stone, in any form, polished, decorated or otherwise work'),
('68029990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kameny ostatní leštěné,zdobené,opracované,hmotnost pod 10kg,ne:viz sazebník', 'Monumental or building stone, natural (excl. calcareous stone, granite and slate'),
('68030010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Břidlice střešní,nástěnná opracovaná', 'Roofing and wall slates, worked'),
('68030090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Břidlice opracovaná ostatní,výrobky z břidlice,ne:střešní,nástěnná', 'Worked slate and articles of slate or of agglomerated slate (excl. slate granule'),
('68041000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kameny mlýnské,brusné používané k mletí,drcení,rozvlákňování', 'Millstones and grindstones, without frameworks, for milling, grinding or pulping'),
('68042100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kameny mlýnské,brusy,brus.kotouče z diamantu přírod.vč.syntet.aglomerovaného', 'Millstones, grindstones, grinding wheels and the like, without frameworks, for s'),
('68042212', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kameny mlýnské,brusy z umělých brusiv,z pryskyřic umělých,syntet.,nevyztužené', 'Millstones, grindstones, grinding wheels and the like, without frameworks, for s'),
('68042218', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kameny mlýnské,brusy,z umělých brusiv z pryskyřic umělých,syntet.,vyztužené', 'Millstones, grindstones, grinding wheels and the like, without frameworks, for s'),
('68042230', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kameny mlýnské,brusy,brusné kotouče z keramiky,silikátu', 'Millstones, grindstones, grinding wheels and the like, without frameworks, for s'),
('68042250', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kameny mlýnské,brusy,brusné kotouče z brusiv umělých ostatních,ne:viz sazebník', 'Millstones, grindstones, grinding wheels and the like, without frameworks, for s'),
('68042290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kameny mlýnské,brusy,brusné kotouče z brusiv aglomerovaných ost.,ne:umělých', 'Millstones, grindstones, grinding wheels and the like, without frameworks, for s'),
('68042300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kameny mlýnské,brusy,brusné kotouče z kamenů přírodních', 'Millstones, grindstones, grinding wheels and the like, without frameworks, for s'),
('68043000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brousky,kameny lešticí ruční', 'Hand sharpening or polishing stones'),
('68051000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brusiva přírodní,umělá na podložce z textilu,i sešité', 'Natural or artificial abrasive powder or grain, on a base of woven textile fabri'),
('68052000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brusiva přírodní,umělá na podložce z papíru,kartonu nebo lepenky,i sešité', 'Natural or artificial abrasive powder or grain, on a base of paper or paperboard'),
('68053010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brusiva přírodní,umělá podložka tkané textil.pletivo kombin.s papírem,lepenkou', 'Natural or artificial abrasive powder or grain, on a base of woven textile fabri'),
('68053020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brusiva přírodní,umělá na podložce na bázi vulkanfíbru', 'Natural or artificial abrasive powder or grain, on a base of vulcanised fibre, w'),
('68053080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brusiva přírodní,umělá na jiné podložce,ne:papír,textil,vulkánfíbr', 'Natural or artificial abrasive powder or grain, on a base other than of merely w'),
('68061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlna strusková,horninová apod.minerální vlny vč.směsí,volně ložená,listy apod.', 'Slag-wool, rock-wool and similar mineral wools, incl. intermixtures thereof, in'),
('68062010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Expandované jíly', 'Expanded clays'),
('68062090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Expandovaný vermikulit,hlíny expandované,struska pěnová,i směsi,ne:jíl rozválcovaný', 'Exfoliated vermiculite, foamed slag and similar expanded mineral materials, incl'),
('68069000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Směsi,výrobky z materiálů nerostných pro izolaci tepelnou apod.ost.,ne:viz sazebník', 'Mixtures and articles of heat-insulating, sound-insulating or sound absorbing mi'),
('68071010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Výrobky z asfaltu střešní a nástěnné ve svitcích', 'Roofing and facing products, of asphalt or of similar materials, in rolls'),
('68071090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z asfaltu ve svitcích ostatní,ne:střešní a nástěnné ve svitcích', 'Articles of asphalt or of similar materials e.g. petroleum pitch or coal-tar pit'),
('68079000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z asfaltu a podobného materiálu ostatní,ne:ve svitku', 'Articles of asphalt or of similar materials, e.g. petroleum bitumen or coal tar'),
('68080000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky, bloky a podobně z vláken rostlinných, hoblin s mineral. pojivy', 'Panels, boards, tiles, blocks and similar articles of vegetable fibre, of straw'),
('68091100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Desky,tabule,panely,apod.ze sádry nezdobené vyztuž.papírem,lepenkou,kartonem', 'Boards, sheets, panels, tiles and similar articles, of plaster or compositions b'),
('68091900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Desky,tabule,panely apod.ze sádry nezdobené,ne:vyztuž.papírem,lepenkou,kartonem', 'Boards, sheets, panels, tiles and similar articles, of plaster or compositions b'),
('68099000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ostatní ze sádry,směsí na podkladě sádry,ne:desky,tabule,panely apod.', 'Articles of plaster or of compositions based on plaster (excl. plaster bandages'),
('68101110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tvárnice,cihly z betonu lehkého i vyztužené', 'Building blocks and bricks, of light concrete with a basis of crushed pumice, gr'),
('68101190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tvárnice,cihly z cementu,betonu ostatní i vyztužené,ne:z lehkého betonu', 'Building blocks and bricks of cement, concrete or artificial stone, whether or n'),
('68101910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tašky střešní z cementu,betonu apod.i vyztužené', 'Roofing tiles of cement, concrete or artificial stone'),
('68101931', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Obkladačky,dlaždice ostatní z betonu,ne:střešní tašky', 'Tiles and paving of concrete, whether or not reinforced'),
('68101939', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Oobkladačky,dlaždice ostatní z cementu,ne:z betonu,střešní tašky', 'Wall tiles and paving of cement, concrete or artificial stone, whether or not re'),
('68101990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Obkladové desky a podobné výrobky ostatní z cementu,betonu,ne:viz sazebník', 'Flagstones and similar articles of cement, concrete or artificial stone (excl. b'),
('68109110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prefabrikované části podlah z cementu,betonu,umělého kamene', 'Floor components and ceiling components, prefabricated, of cement, concrete or a'),
('68109190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prefabrikované stavební dílce z cementu,betonu,umělého kamene,ne:části podlah', 'Structural components for building or civil engineering, prefabricated, of cemen'),
('68109900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ostatní z cementu,betonu,kamene umělého,i vyztužené,ne:viz sazebník', 'Articles of cement, concrete or artificial stone, whether or not reinforced (exc'),
('68114000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z osinko-,buničitocementu obs.osinek (azbest)', 'Articles of asbestos-cement, cellulose fibre-cement or the like, containing asbe'),
('68118100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky vlnité z osinko-,buničitocementu neobs.osinek (azbest)', 'Corrugated sheets of cellulose fibre-cement or the like, not containing asbestos'),
('68118210', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Desky pro střechy,max.40x60cm,z osinko-,buničitocementu neobs.osinek (azbest)', 'Sheets of cellulose fibre-cement or the like, for roofing or wall cladding, of <'),
('68118290', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky ost.,dlaždice aj.z osinko-,buničitocementu neobs.osinek (azbest),ne:pro střechy', 'Sheets, panels, tiles and similar articles, of cellulose-fibre cement or the lik'),
('68118300', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,armatury potrub.z osinko-,buničitocementu neobs.osinek (azbest)', 'Tubes, pipes and tube or pipe fittings of cellulose fibre-cement or the like, no'),
('68118900', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z osinko-,buničitocementu neobs.osinek (azbest),ost.,ne:viz sazebník', 'Articles of cellulose fibre-cement or the like, not containing asbestos (excl. t'),
('68128010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlákna osinková zpracovaná,směsi,z krokydolitu', 'Fabricated crocidolite asbestos fibres; mixtures with a basis of crocidolite asb'),
('68128090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z osinku,směsí osinku a uhl.hořečnatého,z krokydolitu', 'Articles of crocidolite asbestos or of mixtures based on crocidolite asbestos or'),
('68129100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oděvy,doplňky,obuv,pokr.hlavy,z osinku,směsí,ne:krokydolit', 'Clothing, clothing accessories, footwear and headgear of asbestos or of mixtures'),
('68129200', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Papír,lepenka,plsť,z osinku,směsí,ne:krokydolit', 'Paper, millboard and felt of asbestos or of mixtures with a basis of asbestos or'),
('68129300', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Těsnění lisované z osink.vláken,v listech,kotoučích,ne:krokydolit', 'Compressed asbestos fibre jointing, in sheets or rolls (excl. of crocidolite asb'),
('68129910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlákna osinková zpracovaná,směsi,ost.,ne:viz sazebník', 'Fabricated asbestos fibres; mixtures with a basis of asbestos or with a basis of'),
('68129990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z osinku,směsí osinku a uhl.hořečnatého,ost.,ne:viz sazebník', 'Articles of asbestos or of mixtures based on asbestos or asbestos and magnesium'),
('68132000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Materiál třecí,výrobky z něho,obs.osinek (azbest)', 'Friction material and articles thereof, e.g. sheets, rolls, strips, segments, di'),
('68138100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Obložení a podložky brzdové,neobs.osinek (azbest)', 'Brake linings and pads, with a basis of mineral substances or cellulose, whether'),
('68138900', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Materiál třecí,výrobky z něho,neobs.osinek (azbest),ost.,ne:viz sazebník', 'Friction material and articles thereof, e.g. sheets, rolls, strips, segments, di'),
('68141000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,tabule,pásy ze slídy lisované i rekonstituované též na podložce', 'Plates, sheets and strips of agglomerated or reconstituted mica, whether or not'),
('68149000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní zpracovaná slída a výrobky ze slídy, též na podložce', 'Worked mica and articles of mica (excl. electrical insulators, insulating fittin'),
('68151010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uhlíková vlákna a výrobky z nich,ne:pro elektrotechnické účely', 'Carbon fibres and articles of carbon fibres, for non-electrical purposes'),
('68151090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z grafitu,jiných druhů uhlíku,ne:pro elektrotechnické úč.,uhlík.vlákna', 'Articles of graphite or other carbon, for non-electrical purposes (excl. carbon'),
('68152000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z rašeliny', 'Articles of peat (excl. textile products from peat fibres)'),
('68159100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky obsahující magnezit,dolomit,chromit', 'Articles of stone or other mineral substances, n.e.s. containing magnesite, dolo'),
('68159910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z materiálů žáruvzdorných chemicky vázaných', 'Articles of refractory mineral substances, chemically bonded, not calcined, n.e.'),
('68159990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jiné výrobky z kamene a jiných minerálních látek,ne:viz sazebník', 'Articles of stone or other mineral substances, n.e.s. (excl. containing magnesit'),
('69010000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cihly, dlaždice aj. z křemičitých fosilních mouček, křemičitých zemin', 'Bricks, blocks, tiles and other ceramic goods of siliceous fossil meals, e.g. ki'),
('69021000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cihly,desky apod.stavebniny keramické žáruvzdorné,nad 50%Mg,Ca,Cr', 'Refractory bricks, blocks, tiles and similar refractory ceramic constructional g'),
('69022010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cihly,desky apod.stavebniny keramické žáruvzdorné,obsah.93% a víc oxidy Si', 'Refractory bricks, blocks, tiles and similar refractory ceramic constructional g'),
('69022091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cihly,desky apod.stavebniny keramické žáruvzdorné,obsah.nad 7-pod 45% oxid Al', 'Refractory bricks, blocks, tiles and similar refractory ceramic constructional g'),
('69022099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cihly,desky apod.staveb.keramické žáruvzdorné ost.,nad 50% oxid Si,Al,ne:viz sazebník', 'Refractory bricks, blocks, tiles and similar refractory ceramic constructional g'),
('69029000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stavebniny keramické žáruvzdorné ostatní,ne:viz sazebník', 'Refractory bricks, blocks, tiles and similar refractory ceramic constructional g'),
('69031000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky žáruvzdorné keramické,nad 50% grafit a jiný uhlík', 'Retorts, crucibles, mufflers, nozzles, plugs, supports, cupels, tubes, pipes, sh'),
('69032010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky žáruvzdorné keramické ostatní,pod 45% oxid hlinitý', 'Retorts, crucibles, mufflers, nozzles, plugs, supports, cupels, tubes, pipes, sh'),
('69032090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky žáruvzdorné keramické ostatní,45% a víc oxid hlinitý', 'Retorts, crucibles, mufflers, nozzles, plugs, supports, cupels, tubes, pipes, sh'),
('69039010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky žáruvzdorné keramické,nad 25-50% grafit nebo jiné formy uhlíku', 'Retorts, crucibles, mufflers, nozzles, plugs, supports, cupels, tubes, pipes, sh'),
('69039090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní žáruvzdorné keramické výrobky, jiné než z křemičitých zemin', 'Retorts, crucibles, mufflers, nozzles, plugs, supports, cupels, tubes, pipes, sh'),
('69041000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Cihly', 'Building bricks (excl. those of siliceous fossil meals or similar siliceous eart'),
('69049000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kameny podlahové,tvarovky nosné,výplňové,vložky stropní a podobné výrobky', 'Ceramic flooring blocks, support or filler tiles and the like (excl. those of si'),
('69051000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Krytina střešní keramická', 'Roofing tiles'),
('69059000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Komínové vyzdívky,nástavce a jiná keramika stavební,ozdobná,ne:krytina střešní', 'Ceramic chimney pots, cowls, chimney liners, architectural ornaments and other c'),
('69060000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,trubky,žlábky,spojky trub a příslušenství z keramiky', 'Ceramic pipes, conduits, guttering and pipe fittings (excl. of siliceous fossil'),
('69071000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Obkládačky,dlaždice apod.keramické výrobky neglazované,strana pod 7cm', 'Unglazed ceramic tiles, cubes and similar articles, for mosaics, whether or not'),
('69079010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Obkladačky keramické dvojité neglazované typu Spaltplatten', 'Unglazed ceramic double tiles of the ''Spaltplatten'' type'),
('69079091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Obkládačky,dlaždice, apod.zboží kameninové neglazované', 'Unglazed flags and paving, hearth or wall tiles of stoneware (excl.  double tile'),
('69079093', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Pórovina,jemné keramické zboží neglazované', 'Unglazed flags and paving, hearth or wall tiles of earthenware or fine pottery ('),
('69079099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Mozaika keramická neglazovaná a pod.výrobky i na podkladu', 'Unglazed ceramic flags and paving, hearth or wall tiles (excl. of siliceous foss'),
('69081010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Obkladačky,dlaždice,kostky apod.keram.výr.glazované,strana pod 7cm běžné zboží', 'Ceramic mosaic tiles, cubes and similar articles, of common pottery, glazed, whe'),
('69081090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Obkladačky,dlaždice,kostky apod.výr.glazované,strana po 7cm,ne:běžné výrobky', 'Ceramic mosaic tiles, cubes and similar articles, glazed, whether or not square'),
('69089011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Obkladačky keramické dvojité glazované typu Spaltplatten', 'Glazed double tiles of the ''Spaltplatten'' type, of common pottery'),
('69089021', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Obkladačky,dlaždice apod.keramické glazované,str.7cm a víc,tloušťka do 15mm', 'Ceramic flags and paving, hearth or wall tiles, of common pottery, glazed, of a'),
('69089029', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Obkladačky,dlaždice apod.keramické glazované,str.7cm a víc,tloušťka nad 15mm', 'Ceramic flags and paving, hearth or wall tiles, of common pottery, glazed, of a'),
('69089031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Obkladačky keramické dvojité glazované ost.typu Spaltplatten,ne:viz sazebník', 'Glazed ceramic double tiles of the ''Spaltplatten'' type (excl. of common potter'),
('69089051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Mozaika keramická glazovaná,líc do 90 cm2', 'Glazed ceramic flags and paving, hearth or wall tiles with a face of <= 90 cm2 ('),
('69089091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Kameninové zboží glazované', 'Glazed flags and paving, hearth or wall tiles of stoneware with a face of > 90 c'),
('69089093', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Pórovina,jemné keramické zboží glazované', 'Glazed flags and paving, hearth or wall tiles of earthenware or fine pottery wit'),
('69089099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Výrobky keramické glazované ostatní,ne:viz sazebník', 'Glazed ceramic flags and paving, hearth or wall tiles with a face of > 90 cm2 (e'),
('69091100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Keramika laboratorní,chemická,technická z porcelánu', 'Ceramic wares for laboratory, chemical or other technical uses, of porcelain or'),
('69091200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Keramika laboratorní,chemická,technická ost.,tvrdost 9 a víc Mohsovy stupnice', 'Ceramic articles having a hardness equivalent to >= 9 on the Mohs scale, for che'),
('69091900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Keramika laboratorní,chemická,technická ostatní,ne:viz sazebník', 'Ceramic wares for chemical or other technical uses (excl. of porcelain or china,'),
('69099000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky keramické pro zemědělství,dopravu,balení zboží', 'Ceramic troughs, tubs and similar receptacles of a kind used in agriculture; cer'),
('69101000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Umývadla,vany,mísy záchodové a jiné hygienické a sanitární výrobky z porcelánu', 'Ceramic sinks, washbasins, washbasin pedestals, baths, bidets, water closet pans'),
('69109000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Umývadla,vany,mísy a jiné hygienické,sanitární výrobky keramické,ne:porcelán', 'Ceramic sinks, washbasins, washbasin pedestals, baths, bidets, water closet pans'),
('69111000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nádobí kuchyňské,stolní z porcelánu', 'Tableware and kitchenware, of porcelain or china (excl. ornamental articles, pot'),
('69119000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Předměty pro domácnost ostatní,toaletní z porcelánu,ne:nádobí kuchyňské,stolní', 'Household and toilet articles, of porcelain or china (excl. tableware and kitche'),
('69120010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zboží hrnčířské běžné kuchyňské,stolní apod.pro domácnost,toaletu,ne:porcelán', 'Tableware, kitchenware, other household articles and toilet articles, of common'),
('69120030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zboží kameninové kuchyňské,stolní apod.pro domácnost,toaletu', 'Tableware, kitchenware, other household articles and toilet articles, of stonewa'),
('69120050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pórovina,jemné keramické zboží pro domácnost,toaletu,ne:porcelán', 'Tableware, kitchenware, other household articles and toilet articles, of earthen'),
('69120090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zboží keramické ostatní pro domácnost,toaletu,ne:viz sazebník', 'Ceramic tableware, kitchenware, other household articles and toilet articles (ex'),
('69131000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sošky a jiné předměty ozdobné z porcelánu', 'Statuettes and other ornamental articles of porcelain or china, n.e.s.'),
('69139010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sošky a jiné ozdobné předměty-běžné keramické zboží,ne:porcelán', 'Statuettes and other ornamental articles of common pottery, n.e.s.'),
('69139091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sošky a jiné ozdobné předměty z kameniny', 'Statuettes and other ornamental articles of stoneware, n.e.s.'),
('69139093', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sošky a jiné ozdobné předměty-pórovina nebo jemné keramické zboží,ne:porcelán', 'Statuettes and other ornamental articles of earthenware or fine pottery, n.e.s.'),
('69139099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sošky a jiné ozdobné předměty z materiálů keramických oistatních,ne:viz sazebník', 'Statuettes and other ornamental ceramic articles, n.e.s. (excl. of porcelain or'),
('69141000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ostatní z porcelánu,ne:viz sazebník', 'Ceramic articles of porcelain or china, n.e.s.'),
('69149010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zboží hrnčířské běžné ostatní,ne:viz sazebník', 'Ceramic articles of common pottery, n.e.s.'),
('69149090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ostatní keramické,ne:viz sazebník', 'Ceramic articles, n.e.s. (excl. of porcelain or china and common pottery)'),
('70010010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Střepy a jiné odpady skleněné', 'Cullet and other waste and scrap of glass (excl. glass in the form of powder, gr'),
('70010091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sklo optické masivní v kusech', 'Optical glass in the mass'),
('70010099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sklo masivní ostatní v kusech,ne:optické', 'Glass in the mass (excl. optical glass)'),
('70021000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sklo ve tvaru kuliček,ne:mikrokuličky čísla 7018', 'Glass in balls, unworked (excl. glass microspheres <= 1 mm in diameter, glass ba'),
('70022010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sklo ve tvaru tyčí optické nezpracované', 'Rods of optical glass, unworked'),
('70022090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sklo ve tvaru tyčí nezpracované ostatní,ne:optické', 'Rods of glass, unworked (excl. optical glass)'),
('70023100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trubice ze skla křemenného průhledného i neprůhledného nezpracované', 'Tubes of fused quartz or other fused silica, unworked'),
('70023200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trubice ze skla,koefic.teplot.roztaž.do 5x10na minus6 Kna minus1,od 0-300st.C', 'Tubes of glass having a linear coefficient of expansion <= 5 x 10-6 per kelvin w'),
('70023900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trubice ze skla ostatní nezpracované,ne:viz sazebník', 'Tubes of glass, unworked (excl. tubes of glass having a linear coefficient of ex'),
('70031210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Sklo optické ploché lité apod.bez drátěné vložky barvené,kalené,s vrstvou apod.', 'Cast glass and rolled glass, optical, in non-wired sheets, coloured throughout t'),
('70031291', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Sklo ploché nezpracované,s nereflexní vrstvou bez drátěné vložky', 'Cast glass and rolled glass, in non-wired sheets, having a non-reflecting layer,'),
('70031299', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Sklo ploché nezprac.bez drátěné vložky barvené apod.,ne:s nereflexní vrstvou', 'Cast glass and rolled glass, in non-wired sheets, coloured throughout the mass "'),
('70031910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Sklo optické ploché bez drátěné vložky ost.,ne:barvené,kalené,s vrstvou apod.', 'Cast glass and rolled glass, optical, in non-wired sheets, not otherwise worked'),
('70031990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Sklo ploché nezpracované lité,válcované bez drátěné vložky ostatní,ne:viz sazebník', 'Cast glass and rolled glass, in non-wired sheets, not otherwise worked (excl. gl'),
('70032000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Sklo s drátěnou vložkou nezpracované', 'Cast glass and rolled glass, in wired sheets, whether or not with absorbent, ref'),
('70033000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sklo profilové lité,válcované nezpracované', 'Profiles of glass, whether or not having an absorbent, reflecting or non-reflect'),
('70042010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Sklo optické ploché tažené,foukané barvené,kalené,s vrstvou apod.nezpracované', 'Sheets of optical glass, drawn or blown, coloured throughout the mass "body tint'),
('70042091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Sklo v tabulích tažené,foukané barvené,kalené s nereflexní vrstvou nezpracov.', 'Sheets of glass, drawn or blown, having a non-reflecting layer, but not otherwis'),
('70042099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Sklo v tabulích tažené,foukané barvené,kalené nezpracov.ost.,ne:viz sazebník', 'Sheets of glass, drawn or blown, coloured throughout the mass "body tinted", fla'),
('70049010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Sklo optické v tabulích tažené,foukané,ne:barvené apod.', 'Sheets of optical glass, drawn or blown, but not otherwise worked (excl. glass c'),
('70049080', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Sklo v tabulích tažené,foukané ostatní,ne:viz sazebník', 'Sheets of glass, drawn or blown, otherwise unworked (other than coloured through'),
('70051005', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Sklo tabulové plavené,broušené,leštěné bez drát.vložky,s nereflexní vrstvou', 'Float glass and surface ground or polished glass, in sheets, having a non-reflec'),
('70051025', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Sklo tabulové plavené,broušené,leštěné bez drát.vložky,reflex.vrstva,do 3,5mm', 'Float glass and surface ground or polished glass, in sheets, having an absorbent'),
('70051030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Sklo tabul.plavené,brouš.,leštěné bez drát.vložky,reflex.vrstva,nad 3,5-4,5mm', 'Float glass and surface ground or polished glass, in sheets, having an absorbent'),
('70051080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Sklo tabul.plavené,brouš.,leštěné bez drát.vložky,reflex.vrstva,nad 4,5mm', 'Float glass and surface ground or polished glass, in sheets, having an absorbent'),
('70052125', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Sklo tabul.plavené bez drátěné vložky,barvené,kalené apod.,síla do 3,5mm', 'Float glass and surface ground glass, in sheets, coloured throughout the mass "b'),
('70052130', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Sklo tabul.plavené bez drátěné vložky,barvené,kalené apod.,síla nad 3,5-4,5mm', 'Float glass and surface ground glass, in sheets, coloured throughout the mass "b'),
('70052180', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Sklo tabul.plavené bez drátěné vložky,barvené,kalené apod.,síla nad 4,5mm', 'Float glass and surface ground glass, in sheets, coloured throughout the mass "b'),
('70052925', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Sklo tabul.plavené bez drátěné vložky ostatní,síla do 3,5mm,ne:viz sazebník', 'Float glass and surface ground and polished glass, in sheets, but not otherwise'),
('70052935', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Sklo tabul.plavené bez drátěné vložky ostatní,síla nad 3,5-4,5mm,ne:sazebník', 'Float glass and surface ground and polished glass, in sheets, but not otherwise'),
('70052980', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Sklo tabul.plavené bez drátěné vložky,ostatní,síla nad 4,5mm,ne:viz sazebník', 'Float glass and surface ground and polished glass, in sheets, but not otherwise'),
('70053000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Sklo tabulové plavené s drátěnou vložkou i broušené,leštěné,s vrstvou', 'Float glass and surface ground and polished glass, in sheets, whether or not hav'),
('70060010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sklo optické ploché,profilové,tabulové ohýbané,broušebé,ryté,vrtané apod.', 'Sheets or profiles of optical glass, whether or not having an absorbent or refle'),
('70060090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sklo ploché,profilové,tabulové ostatní ohýbané,broušené,ryté apod.,ne:optické', 'Sheets or profiles of glass, whether or not having an absorbent, reflecting or n'),
('70071110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sklo bezpečnostní tvrzené pro motorová vozidla', 'Toughened "tempered" safety glass, of size and shape suitable for incorporation'),
('70071190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sklo bezpečnostní tvrzené pro letadla,lodě,kosmické lodě', 'Toughened "tempered" safety glass, of size and shape suitable for incorporation'),
('70071910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Sklo bezpečnostní tvrzené ostatní smaltované,ne:pro dopravní prostředky', 'Toughened "tempered" safety glass, enamelled'),
('70071920', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Sklo bezpečnostní tvrzené barvené,kalené,s vrstvou ostatní,ne:pro dopr.prostředky', 'Toughened "tempered" safety glass, coloured throughout the mass "body tinted", o'),
('70071980', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Sklo bezpečnostní tvrzené ostatní,ne:viz sazebník', 'Toughened "tempered" safety glass (excl. enamelled, coloured throughout the mass'),
('70072120', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sklo bezpečnostní vrstvené pro motorová vozidla', 'Laminated safety glass of size and shape suitable for incorporation in motor veh'),
('70072180', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sklo bezpečnostní vrstvené ost.(pro vozidla,letadla,kosmic.lodi,plavidla),ne:pro motorová vozidla', 'Laminated safety glass of size and shape suitable for incorporation in aircraft,'),
('70072900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Sklo bezpečnostní vrstvené ostatní,ne:dopravní prostředky,lodě,letadla apod.', 'Laminated safety glass (excl. glass of size and shape suitable for incorporation'),
('70080020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Jednotky izolační z několika skleněn.tabulí barvené ve hmotě,kalené,s vrstvou', 'Multiple-walled insulating units of glass, coloured throughout the mass, opacifi'),
('70080081', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Jednotky izolační,2 tabule vzduchotěsné', 'Insulating units consisting of two panels of glass sealed around the edges by an'),
('70080089', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Jednotky izolační ostatní,ne:viz sazebník', 'Multiple-walled insulating glass consisting of two panels of glass with an inter'),
('70091000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zrcátka zpětná pro motorová vozidla', 'Rear-view mirrors, whether or not framed, for vehicles'),
('70099100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrcadla skleněná nezarámovaná', 'Glass mirrors, unframed (excl. rear-view mirrors for vehicles, optical mirrors,'),
('70099200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zrcadla skleněná zarámovaná,ne:zpětná zrcátka pro motorová vozidla', 'Glass mirrors, framed (excl. rear-view mirrors for vehicles, optical mirrors, op'),
('70101000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Ampulky skleněné', 'Glass ampoules'),
('70102000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zátky,víčka a jiné uzávěry ze skla', 'Stoppers, lids and other closures, of glass'),
('70109010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sklenice na konzervování, sterilování', 'Household preserving jars "sterilising jars", of glass'),
('70109021', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kontejnery k dopravě zboží z trubek skleněných do 1 mm', 'Phials and other containers made from tubing of glass, of a kind used for the co'),
('70109031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kontejnery k dopravě zboží ze skla nad 2,5 l', 'Carboys, bottles, flasks, jars, pots, phials and other containers, of glass, of'),
('70109041', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Láhve ze skla bezbarvého pro nápoje, potraviny 1 - 2,5 l', 'Bottles of colourless glass, of a kind used for the commercial conveyance or pac'),
('70109043', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Láhve ze skla bezbarvého pro nápoje, potraviny 0,33 - 1 l', 'Bottles of colourless glass, of a kind used for the commercial conveyance or pac'),
('70109045', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Láhve ze skla bezbarvého pro nápoje a podobně 0,15 -0,33 l', 'Bottles of colourless glass, of a kind used for the commercial conveyance or pac'),
('70109047', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Láhve ze skla bezbarvého pro nápoje, potraviny do 0,15 l', 'Bottles of colourless glass, of a kind used for the commercial conveyance or pac'),
('70109051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Láhve ze skla barveného pro nápoje, potraviny 1 - 2,5 l', 'Bottles of coloured glass, of a kind used for the commercial conveyance or packi'),
('70109053', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Láhve ze skla barveného pro nápoje, potraviny 0,33 - 1 l', 'Bottles of coloured glass, of a kind used for the commercial conveyance or packi'),
('70109055', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Lahve ze skla barveného pro nápoje, potraviny 0,15 - 0,33 l', 'Bottles of coloured glass, of a kind used for the commercial conveyance or packi'),
('70109057', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Láhve ze skla barveného pro nápoje, potraviny do 0,15 l', 'Bottles of coloured glass, of a kind used for the commercial conveyance or packi'),
('70109061', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Obaly skleněné ostatní pro nápoje, potraviny O,25 - 2,5 l', 'Carboys, flasks, jars, pots, phials and other containers, of glass, of a kind us'),
('70109067', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Obaly skleněné ostatní pro nápoje, potraviny do 0,25 l', 'Carboys, flasks, jars, pots, phials and other containers, of glass, of a kind us'),
('70109071', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Lékovky a jiné skleněné pro výrobky farmaceutické do 0,055 l', 'Bottles, flasks, phials and other containers, of glass, of a kind used for the c'),
('70109079', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Nádoby ze skla pro farmaceutické výrobky ost.objem do 0,055 l, ne:viz sazebník', 'Bottles, flasks, phials and other containers, of glass, of a kind used for the c'),
('70109091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Nádoby ze skla bezbarvého ostatní,ne:viz sazebník', 'Carboys, bottles, flasks, jars, pots, phials and other containers, of colourless'),
('70109099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Skleněné obaly/flakony pro jiné použití z barevného skla', 'Carboys, bottles, flasks, jars, pots, phials and other containers, of coloured g'),
('70111000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skleněné baňky,trubice otevřené,nedohotovené pro elektrické osvětlení', 'Glass envelopes, incl. bulbs and tubes, open, and glass parts thereof, without f'),
('70112000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Baňky,trubice skleněné pro obrazovky nedohotovené', 'Glass envelopes, incl. bulbs and tubes, open, and glass parts thereof, without f'),
('70119000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Baňky,trubice skleněné ostatní nedohotovené,ne:pro el.osvětlení,obrazovky', 'Glass envelopes, incl. bulbs and tubes, open, and glass parts thereof, without f'),
('70131000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sklo domácenské,stolní,kancelářské,toaletní a podobné ze sklokeramiky', 'Glassware of glass ceramics, of a kind used for table, kitchen, toilet, office,'),
('70132210', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sklo nápojové kalíškové na nožce,z křišťálu olovnatého,ručně nabírané', 'Drinking glasses, stemware, of lead crystal, gathered by hand'),
('70132290', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sklo nápojové kalíškové na nožce,z křišťálu olovnatého,mechanicky nabírané', 'Drinking glasses of lead crystal, stemware, gathered mechanically'),
('70132810', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sklo nápojové kalíškové na nožce,ne ze sklokeramiky,ost.,ručně nabírané', 'Drinking glasses, stemware, gathered by hand (excl. of glass ceramics or of lead'),
('70132890', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sklo nápojové kalíškové na nožce,ne ze sklokeramiky,ost.,mechanicky nabírané', 'Drinking glasses, stemware, gathered mechanically (excl. of glass ceramics or of'),
('70133311', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sklo nápojové,z křišťálu olovnatého,ost.,ručně nabírané,broušené,zdobené', 'Drinking glasses of lead crystal, gathered by hand, cut or otherwise decorated ('),
('70133319', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sklo nápojové,z křišťálu olovnatého,ost.,ručně nabírané,ne:broušené,zdobené', 'Drinking glasses of lead crystal, gathered by hand (excl. cut or otherwise decor'),
('70133391', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sklo nápojové,z křišťálu olovnatého,ost.,mechanicky nabírané,broušené,zdobené', 'Drinking glasses of lead crystal, gathered mechanically, cut or otherwise decora'),
('70133399', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sklo nápojové,z křišťálu olovnatého,ost.,mechanicky nabírané,ne:broušené,zdobené', 'Drinking glasses of lead crystal, gathered mechanically (excl. cut or otherwise'),
('70133710', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sklo nápojové,ne ze sklokeramiky,ost.,tvrzené', 'Drinking glasses of toughened glass (excl. stemware)'),
('70133751', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sklo nápojové,ne ze sklokeramiky,ost.,ručně nabírané,broušené,zdobené,ne:tvrzené', 'Drinking glasses, gathered by hand, cut or otherwise decorated (excl. glasses of'),
('70133759', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sklo nápojové,ne ze sklokeramiky,ost.,ručně nabírané,ne:broušené,zdobené,tvrzené', 'Drinking glasses, gathered by hand (excl. glasses cut or otherwise decorated, or'),
('70133791', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sklo nápojové,ne ze sklokeramiky,ost.,mechanicky nabírané,broušené,zdobené,ne:tvrzené', 'Drinking glasses, gathered mechanically, cut or otherwise decorated (excl. glass'),
('70133799', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sklo nápojové,ne ze sklokeramiky,ost.,mechanicky nabírané,ne:broušené,zdobené,tvrzené', 'Drinking glasses, gathered mechanically (excl. glasses cut or otherwise decorate'),
('70134110', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sklo stolní,kuchyňské,z křišťálu olovnatého,ručně nabírané,ne:nápojové', 'Glassware of lead crystal, of a kind used for table or kitchen purposes, gathere'),
('70134190', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sklo stolní,kuchyňské,z křišťálu olovnatého,mechanicky nabírané,ne:nápojové', 'Glassware of lead crystal, of a kind used for table or kitchen purposes, gathere'),
('70134200', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sklo stolní,kuchyňské,sklo koef.<5x10-6K-1,ne:nápojové', 'Glassware for table or kitchen purposes of glass having a linear coefficient of'),
('70134910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sklo stolní,kuchyňské ost.,ručně nabírané,ne:nápojové', 'Glassware for table or kitchen purposes, of toughened glass (excl. glass having'),
('70134991', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sklo stolní,kuchyňské ost.,mechanicky nabírané,ne:nápojové', 'Glassware of a kind used for table or kitchen purposes, gathered by hand (excl.'),
('70134999', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Výrobky skleněné ostatní,ne:viz sazebník', 'Glassware of a kind used for table or kitchen purposes, gathered mechanically (e'),
('70139110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zboží skleněné ostatní ručně nabírané z křišťálu olovnatého,ne:viz sazebník', 'Glassware of lead crystal, of a kind used for toilet, office, indoor decoration'),
('70139190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zboží skleněné ostatní mechanicky nabírané z křišťálu olovnatého,ne:viz sazebník', 'Glassware of lead crystal, of a kind used for toilet, office, indoor decoration'),
('70139900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sklo,skleněné zboží ostatní,ne:viz sazebník', 'Glassware of a kind used for toilet, office, indoor decoration or similar purpos'),
('70140000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sklo signální,prvky optické ze skla,opticky neopracované', 'Signalling glassware and optical elements of glass, not optically worked (excl.'),
('70151000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skla brýlová korekční opticky neopracovaná', 'Glasses for corrective spectacles, curved, bent, hollowed or the like, but not o'),
('70159000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skla hodinová,brýlová i nekorekční opticky neopracovaná,koule duté', 'Clock or watch glasses and similar glasses, glasses for non-corrective spectacle'),
('70161000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kostičky apod.ze skla pro mozaiky a podobné dekorativní účely i na podložce', 'Glass cubes and other glass smallwares, whether or not on a backing, for mosaics'),
('70169010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTK'), 'Vitráže skleněné k stavebním,konstrukčním účelům', 'Leaded lights and the like (excl. such articles > 100 years old)'),
('70169040', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skleněné kostky a cihly používané pro stavební nebo konstrukční účely', 'Blocks and bricks, of a kind used for building or construction purposes'),
('70169070', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skleněné dlaždice,desky a ost.drobné skleněné zboží,pro mozaiky a pod.dekor.účely,ne:viz sazebník', 'Slabs, squares, tiles and other articles of pressed or moulded glass, whether or'),
('70171000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sklo laboratorní,zdravotnické,farmaceutické ze skla křemenného i neprůhledného', 'Laboratory, hygienic or pharmaceutical glassware, whether or not graduated or ca'),
('70172000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sklo laborator.,zdravot.,farmaceut.,koef.rozt.do 5x10na minus6 Kna minus 1', 'Laboratory, hygienic or pharmaceutical glassware, whether or not graduated or ca'),
('70179000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sklo laboratorní,zdravotnické,farmaceutické ze skla ostatního,ne:viz sazebník', 'Laboratory, hygienic or pharmaceutical glassware, whether or not graduated or ca'),
('70181011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Perly skleněné broušené,mechanicky leštěné', 'Glass beads, cut and mechanically polished (excl. articles thereof)'),
('70181019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Perly skleněné ostatní,ne:broušené,mechanicky leštěné', 'Glass beads (excl. beads, cut and mechanically polished, and articles thereof)'),
('70181030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Imitace perel skleněné', 'Imitation pearls of glass (excl. articles thereof)'),
('70181051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Imitace drahokamů,polodrahokamů skleněné broušené,mechanicky leštěné', 'Imitation precious and semi-precious stones of glass, cut and mechanically polis'),
('70181059', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Imitace drahokamů,polodrahokamů skleněné ostatní,ne:broušené,mechanicky leštěné', 'Imitation precious and semi-precious stones of glass (excl. beads, cut and mecha'),
('70181090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zboží skleněné drobné ostatní,ne:viz sazebník', 'Imitation coral and similar glass smallwares (excl. articles thereof and imitati'),
('70182000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mikrokuličky skleněné,průměr do 1mm (balotina)', 'Glass microspheres <= 1 mm in diameter'),
('70189010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oči skleněné a podobné drobné zboží skleněné,ne:viz sazebník', 'Glass eyes, articles of glass beads, or of imitation pearls, imitation precious'),
('70189090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Figurky a podobné předměty ozdobné skleněné tvarované na kahanu,ne:viz sazebník', 'Statuettes and other ornaments of lamp-worked glass (excl. imitation jewellery)'),
('70191100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skleněná střiž o délce nepřesahující 50mm', 'Glass fibre threads "chopped strands", cut into lengths <= 50 mm'),
('70191200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skleněné pramence', 'Rovings of glass fibres'),
('70191910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skleněná lunta,příze,skleněná střiž o délce nad 50mm', 'Slivers and yarn of glass filaments (excl. glass filaments in chopped strands of'),
('70191990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skleněná střiž,lunta,příze z vláken skleněných střižových', 'Slivers and yarn of glass staple fibres'),
('70193100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rohože skleněné', 'Mats of irregularly laminated glass fibres'),
('70193200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rohože tenké (závojové) skleněné', 'Thin sheets "voiles" of irregularly laminated glass fibres'),
('70193900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skleněné rouno,matrace apod.tenké(závojové)ostatní;ne:rohože', 'Webs, mattresses, boards and similar nonwoven products, of glass fibres (excl. m'),
('70194000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tkaniny ze skleněných pramenců', 'Woven fabrics of glass fibres made from rovings'),
('70195100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skleněné tkaniny ostatní o šířce nepřesahující 30 cm,ne:viz sazebník', 'Woven fabrics, incl. narrow fabrics, of glass, of a width of <= 30 cm (excl. rov'),
('70195200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tkaniny skleněné,šíře nad 30cm,plátn.vazba,z příze do 136tex,hmotn.do 250g/cm2', 'Woven fabrics, incl. narrow fabrics, of glass filaments, of width of > 30 cm, pl'),
('70195900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skleněné tkaniny ostatní,ne:viz sazebník', 'Woven fabrics, incl. narrow fabrics, of glass fibres, of a width of > 30 cm (exc'),
('70199010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlna skleněná volně ložená,vločky', 'Glass fibres in bulk or flocks (excl. textile glass fibres and mineral wool)'),
('70199030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Podušky,pouzdra skleněné k izolaci trubek a trubic', 'Pads and casings for insulating tubes and pipes, of glass fibres'),
('70199091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z vláken skleněných textilních,ne:viz sazebník', 'Articles of textile glass fibres (excl. yarn, woven fabrics, incl. narrow fabric'),
('70199099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ostatní z vláken skleněných,ne:viz sazebník', 'Articles of non-textile glass fibres (excl. electrical insulators or parts there'),
('70200005', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Křemenné reaktor.trubky,držáky pro difus.,oxid.pece na výr.polovodič.destiček', 'Quartz reactor tubes and holders designed for insertion into diffusion and oxida'),
('70200007', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vložky skleněné do termosek apod.,nedokončené', 'Unfinished glass inners, for vacuum flasks or for other vacuum vessels, unfinish'),
('70200008', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vložky skleněné do termosek apod.,dokončené', 'Finished glass inners, for vacuum flasks or for other vacuum vessels, finished'),
('70200010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zboží skleněné ostatní z krystalu křemenného,jiného taveného křemene,ne:viz sazebník', 'Glassware of fused quartz or other fused silica, n.e.s.'),
('70200030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zboží ze skla ost.,koef.roztaž.do 5x10na minus6 Kna minus1,ne:viz sazebník', 'Articles of glass having a linear coefficient of expansion <= 5 x 10 -6 per kelv'),
('70200080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skleněné zboží ostatní,ne:viz sazebník', 'Articles of glass, n.e.s.'),
('71011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Perly přírodní pravé nenavlečené,nezasazené', 'Pearls, natural, whether or not worked or graded, but not strung, mounted or set'),
('71012100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Perly uměle pěstované neopracované,nenavlečené,nezasazené', 'Cultured pearls, unworked, whether or not graded'),
('71012200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Perly uměle pěstované opracované,nenavlečené,nezasazené', 'Cultured pearls, worked, whether or not graded, but not strung, mounted or set,'),
('71021000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'CTM'), 'Diamanty netříděné,nezasazené', 'Diamonds, unsorted'),
('71022100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'CTM'), 'Diamanty průmyslové neopracované nebo jednoduše řezané,štípané,nezasazené', 'Industrial diamonds unworked or simply sawn, cleaved or bruted'),
('71022900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'CTM'), 'Diamanty průmyslové ostatní nezasazené,ne:viz sazebník', 'Industrial diamonds, worked, but not mounted or set (excl. unmounted stones for'),
('71023100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'CTM'), 'Diamanty jiné než průmysl.neopracované nebo jednoduše řezané,štípané,nezasazené', 'Non-industrial diamonds unworked or simply sawn, cleaved or bruted (excl. indust'),
('71023900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'CTM'), 'Diamanty jiné než průmyslové ostatní,nezasazené,ne:viz sazebník', 'Diamonds, worked, but not mounted or set (excl. industrial diamonds)'),
('71031000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Drahokamy,polodrahokamy neoprac.,i jednoduše řezané,tvarované,nezasaz.ne:diamanty', 'Precious stones and semi-precious stones, unworked or simply sawn or roughly sha'),
('71039100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Rubíny,safíry,smaragdy opracované,nezasazené', 'Rubies, sapphires and emeralds, worked, whether or not graded, but not strung, m'),
('71039900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Drahokamy,polodrahokamy ost.oprac.,nezasazené,ne:diamanty,rubíny,safíry,smaragdy', 'Precious and semi-precious stones, worked, whether or not graded, but not strung'),
('71041000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Křemen piezoelektrický,nenamontovaný,nezasazený', 'Quartz, piezoelectric, of synthetic or reconstructed stone whether or not worked'),
('71042000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Drahokamy,polodrahokamy umělé,rekonstituované neopracované,nezasaz.,nenamont.', 'Precious and semi-precious stones, synthetic or reconstructed, unworked or simpl'),
('71049000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Drahokamy,polodrahokamy umělé,rekonstituované opracované,nezasazené,nenamont.', 'Precious and semi-precious stones, synthetic or reconstructed, worked, whether o'),
('71051000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Drť,prach z diamantů', 'Dust and powder of diamonds, incl. synthetic diamonds'),
('71059000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Drť,prach z drahokamů,polodrahokamů pravých,umělých,ne:z diamantu', 'Dust and powder of natural or synthetic precious or semi-precious stones (excl.'),
('71061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Prach stříbrný', 'Powder of silver, incl. silver plated with gold or platinum'),
('71069110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Stříbro surové,ryzost 999/1000 a víc', 'Silver, incl. silver plated with gold or platinum, unwrought, of a fineness of >'),
('71069190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Stříbro surové,ryzost pod 999/1000', 'Silver, incl. silver plated with gold or platinum, unwrought, of a fineness of <'),
('71069220', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Polotovary ze stříbra o ryzosti 750 dílů na 1000 nebo větší;ne:prach', 'Semi-manufactured silver, incl. silver plated with gold or platinum, of a finene'),
('71069280', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Polotovary ze stříbra o ryzosti menší než 750 dílů na 1000;ne:prach', 'Semi-manufactured silver, incl. silver plated with gold or platinum, of a finene'),
('71070000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kovy obecné plátované stříbrem,surové,opracované pouze do formy polotovarů', 'Base metals clad with silver, not further worked than semi-manufactured'),
('71081100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Prach zlatý,ne:mincovní', 'Gold, incl. gold plated with platinum, for non-monetary purposes'),
('71081200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Zlato surové ostatní-neopracované formy,ne:prach,mincovní zlato', 'Gold, incl. gold plated with platinum, unwrought, for non-monetary purposes (exc'),
('71081310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Tyče,pruty,dráty,profily,desky,plechy,pásy zlaté,síla nad 0,15mm', 'Bars, rods, wire and sections, plates, sheets and strips of a thickness, excl. a'),
('71081380', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Polotovary ze zlata ostatní;ne:viz sazebník', 'Gold, incl. gold plated with platinum, in semi-manufactured forms, for non-monet'),
('71082000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Zlato mincovní', 'Monetary gold'),
('71090000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kovy obecné,stříbro plátované zlatem,surové,oprac.pouze do formy polotovaru', 'Base metals or silver, clad with gold, not further worked than semi-manufactured'),
('71101100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Platina surová nebo ve formě prachu', 'Platinum, unwrought or in powder form'),
('71101910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Tyče,pruty,dráty,profily,pláty,plechy,pásy,síla nad 0,15mm platinové', 'Bars, rods, wire and sections; plates; sheets and strips of a thickness, excl. a'),
('71101980', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Polotovary z platiny ostatní;ne:viz sazebník', 'Platinum in semi-manufactured forms (excl. sheets and strips of a thickness, exc'),
('71102100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Palladium surové nebo ve formě prachu', 'Palladium, unwrought or in powder form'),
('71102900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Palladium ve formě polotovaru ostatní,ne:surové,prach', 'Palladium in semi-manufactured forms'),
('71103100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Rhodium surové nebo ve formě prachu', 'Rhodium, unwrought or in powder form'),
('71103900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Rhodium ve formě polotovaru ostatní,ne:surové,prach', 'Rhodium in semi-manufactured forms'),
('71104100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Iridium,osmium,ruthenium surové,prach', 'Iridium, osmium and ruthenium, unwrought or in powder form'),
('71104900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Iridium,osmium,ruthenium ve formě polotovaru ostatní,ne:surové,prach', 'Iridium, osmium and ruthenium, in semi-manufactured forms'),
('71110000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kovy obecné,stříbro,zlato plátované platinou,surové,oprac.pouze do polotovaru', 'Base metals, silver or gold, clad with platinum, not further worked than semi-ma'),
('71123000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prach obsahující drahé kovy nebo sloučeniny drahých kovů', 'Ash containing precious metal or precious-metal compounds'),
('71129100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad a šrot ze zlata,vč.kovu plátovaného Au,ne:smetky s obs.jiných dr.kovů', 'Waste and scrap of gold, incl. metal clad with gold, and other waste and scrap c'),
('71129200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šrot z platiny,vč.kovu plátovaného Pt,ne:smetky s obs.jiných drahých kovů', 'Waste and scrap of platinum, incl. metal clad with platinum, and other waste and'),
('71129900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šrot z drahých kovů ostatní,ne:viz sazebník', 'Waste and scrap of silver, incl. metal clad with silver, and other waste and scr'),
('71131100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Šperky,klenoty ze stříbra i plátované,jinak pokovené ostatními drahými kovy', 'Articles of jewellery and parts thereof, of silver, whether or not plated or cla'),
('71131900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Šperky,klenoty z ost.drahých kovů i plátované,pokovené drahými kovy,ne:stříbro', 'Articles of jewellery and parts thereof, of precious metal other than silver, wh'),
('71132000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šperky,klenoty z obecných kovů plátovaných drahými kovy', 'Articles of jewellery and parts thereof, of base metal clad with precious metal'),
('71141100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Výrobky zlatnické ost.ze stříbra i plátované drahými kovy,ne:šperky,klenoty', 'Articles of goldsmiths'' or silversmiths'' wares or parts thereof, of silver, wh'),
('71141900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Výrobky zlatnické ost.z drahých kovů ost.i plátovaných drahými kovy,ne:viz sazebník', 'Articles of goldsmiths'' or silversmiths'' wares or parts thereof, of precious m'),
('71142000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky zlatnické z obecných kovů plátovaných drahými kovy,ne:šperky,klenoty', 'Articles of goldsmiths'' or silversmiths'' wares and parts thereof, of base meta'),
('71151000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Katalyzátory ve formě drátěného síta,mřížky z platiny', 'Catalysts in the form of wire cloth or grill, of platinum'),
('71159010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ostatní z drahých kovů,ne:viz sazebník', 'Articles of precious metal, n.e.s.'),
('71159090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ostatní z kovů plátovaných drahým kovem,ne:viz sazebník', 'Articles of metal clad with precious metal, n.e.s.'),
('71161000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Výrobky z pravých perel přírodních,uměle pěstovaných', 'Articles of natural or cultured pearls, n.e.s.'),
('71162011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Náhrdelníky,náramky apod.z (polo)drahokamů přírodních bez závěru a pod.', 'Necklaces, bracelets and other articles, wholly of natural precious or semi-prec'),
('71162019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Výrobky ost.z (polo)drahokamů přírodních,ne:náhrdelníky,náramky bez závěru', 'Articles made wholly of natural precious or semi-precious stones, n.e.s.'),
('71162090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Výrobky z drahokamů,polodrahokamů umělých,rekonstituovaných', 'Articles of precious or semi-precious stones "natural, synthetic or reconstructe'),
('71171100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Knoflíky manžetové,ozdobné z obecných kovů i potažených drahými kovy', 'Cuff links and studs, of base metal, whether or not clad with silver, gold or pl'),
('71171910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bižuterie umělá z obecných kovů s díly ze skla', 'Imitation jewellery, of base metal, whether or not clad with silver, gold or pla'),
('71171991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bižuterie umělá z obecných kovů zlacená,stříbřená,platinovaná bez dílů ze skla', 'Imitation jewellery, of base metal, whether or not clad with silver, gold or pla'),
('71171999', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bižuterie umělá z obecných kovů bez dílů ze skla,ne:zlacená,stříbřená,platinovaná', 'Imitation jewellery, of base metal (excl. jewellery clad with silver, gold or pl'),
('71179000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bižuterie umělá ostatní,ne:viz sazebník', 'Imitation jewellery (excl. jewellery, of base metal, whether or not clad with si'),
('71181010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Mince,které nejsou zákonným platidlem ze stříbra', 'Silver coin (excl. coin being legal tender, medals, jewellery of coins, collecto'),
('71181090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mince,které nejsou zákonným platidlem ostatní,ne:ze stříbra', 'Coin (excl. coin being legal tender, gold and silver coin, medals, jewellery of'),
('71189000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GRM'), 'Mince ostatní,ne:viz sazebník', 'Coin of legal tender'),
('72011011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Železo surové nelegované,do 0,5% fosfor,0,4% a víc mangan,do 1% křemík', 'Non-alloy pig iron in pigs, blocks or other primary forms, containing by weight'),
('72011019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Železo surové nelegované,do 0,5% fosfor,0,4% a víc mangan,nad 1% křemík', 'Non-alloy pig iron in pigs, blocks or other primary forms, containing by weight'),
('72011030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Železo surové nelegované,do 0,5% fosfor,0,1-pod 0,4% mangan', 'Non-alloy pig iron in pigs, blocks or other primary forms, containing by weight'),
('72011090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Železo surové nelegované,do 0,5% fosfor,pod 0,1% mangan', 'Non-alloy pig iron in pigs, blocks or other primary forms, containing by weight'),
('72012000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Železo surové nelegované,nad 0,5% fosfor', 'Non-alloy pig iron in pigs, blocks or other primary forms, containing by weight'),
('72015010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Železo surové legované,0,3-1% titan,0,5-1% vanad', 'Alloy pig iron in pigs, blocks or other primary forms, containing by weight >= 0'),
('72015090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Železo surové legované ostatní,vysokopecní zrcadlovina,ne:viz sazebník', 'Alloy pig iron and spiegeleisen, in pigs, blocks or other primary forms (excl. a'),
('72021120', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Feromangan,granule do 5mm,nad 2% uhlíku,nad 65% mangan', 'Ferro-manganese, containing by weight > 2% carbon, with a granulometry <= 5 mm a'),
('72021180', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Feromangan ostatní,nad 2% uhlík,do 65% mangan', 'Ferro-manganese, containing by weight > 2% carbon (excl. ferro-manganese with a'),
('72021900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Feromangan,do 2% uhlík', 'Ferro-manganese, containing by weight <= 2% carbon'),
('72022100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ferosilicium, obsah křemíku nad 55%', 'Ferro-silicon, containing by weight > 55% of silicon'),
('72022910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ferosilicium,do 55% křemík,4-10% hořčík', 'Ferro-silicon, containing by weight <= 55% silicon and >= 4% but <= 10% of magne'),
('72022990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ferosilicium ostatní,do 55% křemík,ne:4-10% hořčík', 'Ferro-silicon, containing by weight <= 55% silicon (excl. that containing by wei'),
('72023000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ferosilikomangan', 'Ferro-silico-manganese'),
('72024110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ferochrom,nad 4-6% uhlík', 'Ferro-chromium, containing by weight > 4% but <= 6% carbon'),
('72024190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ferochrom, obsah uhlíku nad 6%', 'Ferro-chromium, containing by weight > 6% carbon'),
('72024910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ferochrom,do 0,05% uhlík', 'Ferro-chromium, containing by weight <= 0,05% carbon'),
('72024950', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ferochrom,nad 0,05-0,5% uhlík', 'Ferro-chromium, containing by weight > 0,05% but <= 0,5% carbon'),
('72024990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ferochrom,nad 0,5-4% uhlík', 'Ferro-chromium, containing by weight > 0,5% but <= 4% carbon'),
('72025000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ferosilikochrom (ferosiliciumchrom)', 'Ferro-silico-chromium'),
('72026000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Feronikl', 'Ferro-nickel'),
('72027000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Feromolybden', 'Ferro-molybdenum'),
('72028000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ferowolfram,ferosilikowolfram (ferosiliciumwolfram)', 'Ferro-tungsten and ferro-silico-tungsten'),
('72029100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ferotitan,ferotitansilicum', 'Ferro-titanium and ferro-silico-titanium'),
('72029200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ferovanad', 'Ferro-vanadium'),
('72029300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Feroniob', 'Ferro-niobium'),
('72029910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ferofosfor', 'Ferro-phosphorus'),
('72029930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ferro-silikomagnezium', 'Ferro-silico-magnesium'),
('72029980', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Feroslitiny ostatní,ne:viz sazebník', 'Ferro-alloys (excl. ferro-manganese, ferro-silicon, ferro-silico-manganese, ferr'),
('72031000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Produkty získané přímou redukcí železné rudy', 'Ferrous products obtained by direct reduction of iron ore, in lumps, pellets or'),
('72039000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Železo houbovité ostatní,železo o ryzosti 99,94% a víc,ne:získ.přímou redukcí', 'Spongy ferrous products, obtained from molten pig iron by atomisation, iron of a'),
('72041000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,šrot litinový', 'Waste and scrap, of cast iron (excl. radioactive)'),
('72042110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,šrot z nerezavějící oceli obsah 8% a víc niklu', 'Waste and scrap of stainless steel, containing by weight >= 8% nickel (excl. rad'),
('72042190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,šrot z nerezavějící oceli obsah pod 8% niklu', 'Waste and scrap of stainless steel (not containing >= 8% nickel, radioactive, or'),
('72042900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,šrot z oceli legované ostatní,ne:nerezavějící', 'Waste and scrap of alloy steel (excl. stainless steel, and waste and scrap, radi'),
('72043000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,šrot ze železa,oceli pocínované', 'Waste and scrap of tinned iron or steel (excl. radioactive, and waste and scrap'),
('72044110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpady železa,oceli neleg.ze soustružení,hoblování,frézování,řezání,pilování', 'Turnings, shavings, chips, milling waste, sawdust and filings, of iron or steel,'),
('72044191', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zbytky z ražení,odstřižky ze železa,oceli nelegované paketované', 'Trimmings and stampings, of iron or steel, in bundles (excl. such items of cast'),
('72044199', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zbytky z ražení,odstřižky ze železa,oceli nelegované ostatní,ne:paketované', 'Trimmings and stampings, of iron or steel, not in bundles (excl. such items of c'),
('72044910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,šrot ze železa,oceli nelegované ostatní drcený (rozstříhaný),ne:viz sazebník', 'Waste and scrap of iron or steel, fragmentised "shredded" (excl. slag, scale and'),
('72044930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,šrot ze železa,oceli nelegované ostatní paketovaný,ne:viz sazebník', 'Waste and scrap of iron or steel, not fragmentised "shredded", in bundles (excl.'),
('72044990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní železný odpad a šrot', 'Waste and scrap of iron or steel, not fragmentised "shredded", not in bundles (e'),
('72045000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přetavený odpad železa nebo oceli v ingotech', 'Remelting scrap ingots of iron or steel (excl. products whose chemical compositi'),
('72051000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Granuly ze surového železa,železa,oceli,zrcadloviny vysokopecní,ne:feroslitin', 'Granules, of pig iron, spiegeleisen, iron or steel (excl. granules of ferro-allo'),
('72052100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prášek z oceli legované', 'Powders, of alloy steel (excl. powders of ferro-alloys and radioactive iron powd'),
('72052900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prášek ze železa i surového,oceli nelegované,zrcadl.vysokopecní,ne:feroslitin', 'Powders, of pig iron, spiegeleisen, iron or non-alloy steel (excl. powders of fe'),
('72061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ingoty ze železa,oceli nelegované', 'Ingots, of iron and non-alloy steel (excl. remelted scrap ingots, continuous cas'),
('72069000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tvary základní ostatní ze železa,oceli nelegované,ne:ingoty', 'Iron and non-alloy steel, in puddled bars or other primary forms (excl. ingots,'),
('72071111', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polotovary válc.,kontin.lité z dobře obrobitelné oceli,do 0,25% C,pravoúhlé', 'Semi-finished products, of non-alloy free-cutting steel, containing by weight <'),
('72071114', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polotovary válc.,kontin.lité,do 0,25% C,pravoúhlé,tl. do 130mm,ne:dobře obrobitelná ocel', 'Semi-finished products, of iron or non-alloy steel, containing by weight < 0,25%'),
('72071116', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polotovary válc.,kontin.lité,do 0,25% C,pravoúhlé,tl. nad 130mm,ne:dobře obrobitelná ocel', 'Semi-finished products, of iron or non-alloy steel, containing by weight < 0,25%'),
('72071190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polotovary kované ze železa,oceli neleg.,do 0,25% C,pravoúhlé', 'Semi-finished products of iron or non-alloy steel, containing by weight < 0,25%'),
('72071210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polotovary válc.,kont.lité ze železa,oceli,neleg.,Cdo 0.25%,pravoúhlé', 'Semi-finished products of iron or non-alloy steel, containing by weight < 0,25 o'),
('72071290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polotovary kované ze železa,oceli neleg.,do 0,25% C,pravoúhlé', 'Semi-finished products of iron or non-alloy steel, containing by weight < 0,25%'),
('72071912', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polotovary z neleg.oceli,Fe,válc.,lité,C<0,25%,průřez:kruh.,polygonál.', 'Semi-finished products, of iron or non-alloy steel, containing by weight < 0,25%'),
('72071919', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polotovary kované ze železa,oceli neleg.,do 0,25% C,kruhové,mnohoúhelníkové', 'Semi-finished products of iron or non-alloy steel, containing by weight < 0,25%'),
('72071980', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní polotovary z nelegované oceli nebo z Fe,obsah C do 0,25%', 'Semi-finished products of iron or non-alloy steel, containing by weight < 0,25%'),
('72072011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polotovary válc.,kont.lité z dobře obrobitelné oceli,0,25% a víc C,pravoúhlé', 'Semi-finished products, of non-alloy free-cutting steel, containing by weight >='),
('72072015', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polotovary válcované,kont.lité ze železa,neleg.oceli,0,25-pod 0,6% C,pravoúhlé', 'Semi-finished products of iron or non-alloy steel, containing by weight >= 0,25%'),
('72072017', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polotovary válcované,kont.lité ze železa,neleg.oceli,0,6% a víc C,pravoúhlé', 'Semi-finished products of iron or non-alloy steel, containing by weight >= 0,6%'),
('72072019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polotovary kované ze železa,neleg.oceli,0,25% a víc C,pravoúhlé', 'Semi-finished products of iron or non-alloy steel, containing by weight >= 0,25%'),
('72072032', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polotovary válcované,kont.lité ze železa,neleg.oceli,0.25% a víc C,pravoúhlé', 'Semi-finished products of iron or non-alloy steel, containing by weight >= 0,25'),
('72072039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polotovary kované ze železa,neleg.oceli,0,25% a víc C,pravoúhlé', 'Semi-finished products of iron or non-alloy steel, containing by weight >= 0,25%'),
('72072052', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polotovary z neleg.oceli,Fe,válc.,lité,C>0,25%,průřez:kruh.,polygonál.', 'Semi-finished products of iron or non-alloy steel, containing by weight >= 0,25%'),
('72072059', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polotovary kované ze železa,neleg.oceli,0,25% a víc C,kruh,mnohoúhelník', 'Semi-finished products of iron or non-alloy steel, containing by weight >= 0,6%'),
('72072080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní polotovary z nelegované oceli nebe z Fe, obsah C od 0,25%', 'Semi-finished products of iron or non-alloy steel, containing by weight >= 0,25%'),
('72081000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.ploché,za tepla,šíře 600mm a víc,svitky,neoprac.,vzor v reliéfu', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, in coi'),
('72082500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.ploché,za tepla,šíře 600mm a víc,svitky,tl.4,75mm a víc,mořené,neopracované', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, in coi'),
('72082600', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.za tepla,šíře 600mm a víc,svitky,tl.3-pod 4,75mm,mořené,neopracované', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, in coi'),
('72082700', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.za tepla,šíře 600mm a víc,svitky,tl.pod 3mm,mořené,neopracované', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, in coi'),
('72083600', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pl.válc.výr.šíře 600mm a víc,za tepla,svitek ost.,tl.nad 10mm,ne:viz sazebník', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, in coi'),
('72083700', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché výr.válc.za tepla,z neleg.oceli,Fe,š.>600mm,svitky,tl.4,75-10mm', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, in coi'),
('72083800', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché výr. válc.za tepla,z neleg.oceli,Fe,š.>600mm,svitky,tl.3-4,75mm', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, in coi'),
('72083900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché výrobky válc.za tepla,z neleg.oceli,Fe,š.>600mm,svitky,tl.<3mm', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, in coi'),
('72084000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché výrobky válc.za tepla,z neleg.oceli,Fe,š>600mm,vzor v reliéfu', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, not in'),
('72085120', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché výrobky válc.za tepla,z neleg.oceli,Fe,šíře >600mm,tl.>15mm', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, not in'),
('72085191', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.za tepla,šíře 2050mm a víc,(ne svitky),tl.nad 10-15mm,neopracované', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 2.050 mm, not'),
('72085198', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché výrobky válc.za tepla,z neleg.oceli,Fe,š.600-2050mm,tl.10-15mm', 'Flat-rolled products of iron or non-alloy steel, of a width of < 2.050 mm but >='),
('72085210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché výrob. válc.za tepla ze 4 stran,v uzavř.kalibru,z neleg.oceli,Fe,šíře 600-1250mm,tl.4,75-10mm', 'Flat-rolled products of iron or non-alloy steel, of a width of <= 1.250 mm, not'),
('72085291', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché výrob. válc.za tepla,z neleg.oceli,Fe,ost.,šíře>2050mm,tl.4,75-10mm,ne:válc.ze 4 stran,v uzavř.kalibru', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 2.050 mm, not'),
('72085299', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché výrob.válc.za tepla,z neleg.oceli,Fe,ost.,šíře 600-2050mm,tl.4,75-10mm,ne:válc.ze 4 stran,v uzavř.kalibru', 'Flat-rolled products of iron or non-alloy steel, of a width of < 2.050 mm but >='),
('72085310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché výrob. válc.za tepla ze 4 stran,v uzavř.kalibru,z neleg.oceli,Fe,šíře 600-1250mm,tl.4-4,75mm', 'Flat-rolled products of iron or non-alloy steel, of a width of <= 1.250 mm, not'),
('72085390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché výrob.válc.za tepla,z neleg.oceli,Fe,ost.,šíře>600mm,tl.3-4,75mm,ne:válc.ze 4 stran,v uzavř.kalibru', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, not in'),
('72085400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché výrob.válc.za tepla,z neleg.oceli,Fe,šíře >600mm,tloušťka <3mm', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, not in'),
('72089020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní ploché výrobky válcované za tepla,z neleg.oceli,Fe,šíře >600mm,perforované', 'Flat-rolled products of iron or steel, of a width >= 600 mm, hot-rolled and furt'),
('72089080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní ploché výrobky válcované za tepla,z neleg.oceli,Fe,šíře >600mm,ne:perforované', 'Flat-rolled products of iron or steel, of a width >= 600 mm, hot-rolled and furt'),
('72091500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.za stud.,šíře 600mm a víc,svitky,tl.3mm a víc,neopracované', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, in coi'),
('72091610', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.za stud.elektrické,šíře 600mm a víc,svitky,tl.nad 1-pod 3mm', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, in coi'),
('72091690', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.za stud.,šíře 600mm a víc,svitky,tl.nad 1-pod 3mm,neoprac.,ne:elektrické', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, in coi'),
('72091710', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.za stud.elektrické,šíře 600mm a víc,svitky,tl.0,5-1mm', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, in coi'),
('72091790', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.za stud.,šíře 600mm a víc,svitky,tl.0,5-1mm,neoprac.,ne:elektrické', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, in coi'),
('72091810', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.za stud.elektrické,šíře 600mm a víc,svitky,tl.pod 0,5mm', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, in coi'),
('72091891', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.za stud.,šíře 600mm a víc,svitky,tl.0,35-pod 0,5mm,neoprac.,ne:elektrické', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, in coi'),
('72091899', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.za stud.,šíře 600mm a víc,svitky,tl.pod 0,35mm,neoprac.,ne:elektrické', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, in coi'),
('72092500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.za stud.,šíře 600mm a víc,(ne svitky),tl.3mm a víc,neopracované', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, not in'),
('72092610', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.za stud.elektrické,šíře 600mm a víc,(ne svitky),tl.nad 1-pod 3mm', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, not in'),
('72092690', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.za stud.,šíře 600mm a víc,(ne svitky),tl.nad 1-pod 3mm,ne:elektrické', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, not in'),
('72092710', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.za stud.elektrické,šíře 600mm a víc,(ne svitky),tl.0,5-1mm', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, not in'),
('72092790', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.za stud.,šíře 600mm a víc,(ne svitky),tl.0,5- 1mm,ne:elektrické', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, not in'),
('72092810', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.za stud.,elektrické,šíře 600mm a víc,(ne svitky),tl.pod 0,5mm', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, not in'),
('72092890', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.za stud.,šíře 600mm a víc,(ne svitky),tl.pod 0,5mm,ne:elektrické', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, not in'),
('72099020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní ploché výrobky válcované za studena,z neleg.oceli,Fe,š.>600mm,perforované', 'Flat-rolled products of iron or steel, of a width of >= 600 mm, cold-rolled "col'),
('72099080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní ploché výrobky válcované za studena,z neleg.oceli,Fe,š.>600mm,ne:perforované', 'Flat-rolled products of iron or steel, of a width of >= 600 mm, cold-rolled "col'),
('72101100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válc. výrobky,z neleg.oceli,Fe,pocínované,šíře >600mm,tl.>0,5mm', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, hot-ro'),
('72101220', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pocínovaný plech, z neleg.oceli, Fe, šíře >600mm,tloušťka <0,5mm', 'Tinplate of iron or non-alloy steel, of a width of >= 600 mm and of a thickness'),
('72101280', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.ploché válcované výrobky,z neleg.oceli,Fe,pocín.,š>600mm,tl<0,5mm', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, hot-ro'),
('72102000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válcované výrobky,z neleg.oceli,Fe,pokovené olovem,šíře >600mm', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, hot-ro'),
('72103000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válc.výrob.,z neleg.oceli,Fe,elektrolyticky pozinkované,š>600mm', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, hot-ro'),
('72104100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válc.výrobky,z neleg.oceli,Fe,jinak pozinkované,vlnité,š>600mm', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, hot-ro'),
('72104900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní ploché válc.výrobky,z neleg.oceli,Fe,jinak pozinkované,š>600mm', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, hot-ro'),
('72105000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válc.výrob.,z neleg.oceli,Fe,pokovené chromem,oxidy Cr,š.>600mm', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, hot-ro'),
('72106100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válc. výrobky,z neleg.oceli,Fe,pokovené slitinou Al-Zn,š.>600mm', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, hot-ro'),
('72106900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válcované výrobky,z neleg.oceli,Fe,pokovené hliníkem,šíře>600mm', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, hot-ro'),
('72107010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pocín.plech a ploché válc.výrob. pokov. Cr, oxidy Cr, lakované,š>600mm', 'Tinplate of a width of >= 600 mm and of a thickness of < 0,5 mm, tinned [coated'),
('72107080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.ploché válc.výrobky,z neleg.oceli,Fe,lakované,potaž.plasty,š>600mm', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, hot-ro'),
('72109030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válcované výrobky, z neleg.oceli, Fe, plátované, šíře >600mm', 'Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, hot-ro'),
('72109040', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válc.výrobky,z neleg.oceli,Fe,cínované,potištěné,šíře >600mm', 'Flat-rolled products of iron or non-alloy steel, tinned and printed, of a width'),
('72109080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní ploché válc.výrobky,z neleg.oceli,Fe,potažené,pokovené,š>600mm', 'Flat-rolled products of iron or non-alloy steel, hot-rolled or cold-rolled "cold'),
('72111300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.,za tepla,šíře nad 150-pod 600mm,tl.4mm a víc,bez vzorku,ne:svitek', 'Flat-rolled products of iron or non-alloy steel, simply hot-rolled on four faces'),
('72111400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché výr. válc. za tepla,z neleg.oceli,neoprac.,š.<600mm,tl.>4,75mm', 'Flat-rolled products of iron or non-alloy steel, of a width < 600 mm, not furthe'),
('72111900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché výr. válc. za tepla,z neleg.oceli,neoprac.,š.<600mm,tl.<4,75mm', 'Flat-rolled products of iron or non-alloy steel, of a width < 600 mm, simply hot'),
('72112320', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché výr. válc.za studena,neleg.ocel,š.<600mm,C<0,25%,el.tech.účely', 'Flat-rolled products of iron or non-alloy steel, of a width of < 600 mm, simply'),
('72112330', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché výr. válc.za studena,neleg.ocel,Fe,š.<600mm,tl.>0,35mm,C<0,25%', 'Flat-rolled products of iron or non-alloy steel, of a width of < 600 mm and of a'),
('72112380', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché výr. válc.za studena,neleg.ocel,Fe,š.<600mm,tl.<0,35mm,C<0,25%', 'Flat-rolled products of iron or non-alloy steel, of a width of < 600 mm and of a'),
('72112900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché výrobky válcované za studena,z neleg.oceli,Fe,š.<600mm,C>0,25%', 'Flat-rolled products of iron or non-alloy steel, of a width of < 600 mm, simply'),
('72119020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.ploché válc.výrobky,z neleg.oceli,Fe,nepokov.,neplátované,š<600mm,perforované', 'Flat-rolled products of iron or non-alloy steel, of a width of < 600 mm, hot-rol'),
('72119080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.ploché válc.výrobky,z neleg.oceli,Fe,nepokov.,neplátované,š<600mm,ne:perforované', 'Flat-rolled products of iron or non-alloy steel, of a width of < 600 mm, hot-rol'),
('72121010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.,šíře pod 600mm,ze železa,neleg.oceli,pocínované,dále neopracované', 'Tinplate of iron or non-alloy steel, of a width of < 600 mm and of a thickness o'),
('72121090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.ploché válcované výrobky,z neleg.oceli,Fe,pocínované,šíře <600mm', 'Flat-rolled products of iron or non-alloy steel, hot-rolled or cold-rolled "cold'),
('72122000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válc.výrob.,z neleg.oceli,Fe,elektrolyticky pozinkované,š<600mm', 'Flat-rolled products of iron or non-alloy steel, of a width of < 600 mm, hot-rol'),
('72123000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní ploché válc.výrobky,z neleg.oceli,Fe,jinak pozinkované,š<600mm', 'Flat-rolled products of iron or non-alloy steel, of a width of < 600 mm, hot-rol'),
('72124020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pocín.plech a ploché válc.výrob. pokov. Cr, oxidy Cr, lakované,š<600mm', 'Tinplate of a width of < 600 mm and of a thickness of < 0,5 mm, tinned [coated w'),
('72124080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.ploché válc.výrobky,z neleg.oceli,Fe,lakované,potaž.plasty,š<600mm', 'Flat-rolled products of iron or non-alloy steel, of a width of < 600 mm, hot-rol'),
('72125020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válc.výrob.,z neleg.oceli,Fe,pokovené chromem,oxidy Cr,š.<600mm', 'Flat-rolled products of iron or non-alloy steel, of a width of < 600 mm, hot-rol'),
('72125030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válc.výrob.,z neleg.oceli,Fe,pokovené chromem n. niklem,š<600mm', 'Flat-rolled products of iron or non-alloy steel, of a width of < 600 mm, hot-rol'),
('72125040', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válc.výrob.,z neleg.oceli,Fe,pokovené mědí,šíře <600mm', 'Flat-rolled products of iron or non-alloy steel, of a width of < 600 mm, hot-rol'),
('72125061', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válc. výrobky,z neleg.oceli,Fe,pokovené slitinou Al-Zn,š.<600mm', 'Flat-rolled products of iron or non-alloy steel, of a width of < 600 mm, hot-rol'),
('72125069', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válcované výrobky,z neleg.oceli,Fe,pokovené hliníkem,šíře<600mm', 'Flat-rolled products of iron or non-alloy steel, of a width of < 600 mm, hot-rol'),
('72125090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní ploché válc.výrobky,z neleg.oceli,Fe,potažené,pokovené,š<600mm', 'Flat-rolled products of iron or non-alloy steel, of a width of < 600 mm, hot-rol'),
('72126000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válcované výrobky, z neleg.oceli, Fe, plátované, šíře <600mm', 'Flat-rolled products of iron or non-alloy steel, of a width of < 600 mm, hot-rol'),
('72131000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty válc.za tepla,svitek,ze železa,neleg.oceli s vroubkováním apod', 'Bars and rods, hot-rolled, in irregularly wound coils of iron or non-alloy steel'),
('72132000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty válc.za tepla,svitek,z oceli automatové', 'Bars and rods, hot-rolled, in irregularly wound coils, of non-alloy free-cutting'),
('72139110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty válc.za tepla,svitek,do 14mm,kruhové,pro betonové výztuže', 'Bars and rods, hot-rolled, of the type used for concrete reinforcement, smooth,'),
('72139120', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty válc.za tepla,svitek,do 14mm,kruhové,použ.pro kordové pneumatiky', 'Bars and rods, hot-rolled, of the type used for tyre cord, smooth, of iron or no'),
('72139141', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty válc.za tepla,svitek,do 14mm,kruhové,obsah do 0,06% C', 'Bars and rods, hot-rolled, of iron or non-alloy steel, in irregularly wound coil'),
('72139149', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty válc.za tepla,svitek,do 14mm,kruhové,obsah nad 0,06-pod 0,25% C', 'Bars and rods, hot-rolled, of iron or non-alloy steel, in irregularly wound coil'),
('72139170', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty za tepla,svitek,kruh.průřez pod 14mm,uhlík 0,25-0,75%,ne:viz sazebník', 'Bars and rods, hot-rolled, in irregularly wound coils, of iron or non-alloy stee'),
('72139190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty válc.za tepla,svitek,do 14mm,kruhové,obsah 0,75% a víc C', 'Bars and rods, hot-rolled, of iron or non-alloy steel, in irregularly wound coil'),
('72139910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty válc.za tepla,svitek,pod 0,25% C,ne:automatová,kruhová do 14mm', 'Bars and rods, of iron or non-alloy steel, hot-rolled, in irregularly wound coil'),
('72139990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty válc.za tepla,svitek,0,25% a víc C,ne:automatová,kruhová do 14mm', 'Bars and rods, hot-rolled, in irregularly wound coils, of iron or non-alloy stee'),
('72141000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty jiné za tepla,(ne svitek),ze železa,neleg.oceli kované', 'Bars and rods, of iron or non-alloy steel, not further worked than forged (excl.'),
('72142000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty jiné za tepla,(ne svitek),ze železa,neleg.oceli s vroubkováním', 'Bars and rods, of iron or non-alloy steel, with indentations, ribs, groves or ot'),
('72143000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty jiné za tepla,(ne svitek),z oceli automatové', 'Bars and rods, of non-alloy free-cutting steel, not further worked than hot-roll'),
('72149110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty jiné za tepla,(ne svitek),pod 0,25% C,pravoúhlé,ne:čtvercové', 'Bars and rods of iron or non-alloy steel, not further worked than hot-rolled, ho'),
('72149190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty jiné za tepla,(ne svitek),0,25% a víc C,pravoúhlé,ne:čtvercové', 'Other bars and rods of iron or non-alloy steel, only hot-rolled, only hot-drawn'),
('72149910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty jiné za tepla,(ne svitek),pod 0,25% C,pro betonové výztuže', 'Bars and rods of the type used for concrete reinforcement, smooth, of iron or no'),
('72149931', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty jiné za tepla,(ne svitek),pod 0,25% C,kruhové,průměr 80mm a více', 'Bars and rods of iron or non-alloy steel, only hot-rolled, hot-drawn or hot-extr'),
('72149939', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty jiné za tepla,(ne svitek),pod 0,25% C,kruhové,průměr pod 80mm', 'Bars and rods of iron or non-alloy steel, only hot-rolled, hot-drawn or hot-extr'),
('72149950', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty jiné za tepla,(ne svitek),pod 0,25% C,ne:pro výztuže,kruhové', 'Bars and rods of iron or non-alloy steel, only hot-rolled, hot-drawn or hot-extr'),
('72149971', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.tyče,pruty,z neleg.oceli,válc.za tepla,C>0,25%,kruh.průřez-d>80mm', 'Bars and rods of iron or non-alloy steel, only hot-rolled, only hot-drawn or onl'),
('72149979', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.tyče,pruty,z neleg.oceli,válc.za tepla,C>0,25%,kruh.průřez-d<80mm', 'Bars and rods of iron or non-alloy steel, only hot-rolled, only hot-drawn or onl'),
('72149995', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.tyče a pruty,z neleg.oceli,Fe,válc.za tepla,C>0,25%,nekruh.průřez', 'Bars and rods of iron or non-alloy steel, only hot-rolled, only hot-drawn or onl'),
('72151000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ostatní za studena,z automatové oceli,neopracované', 'Bars and rods, of non-alloy free-cutting steel, not further worked than cold-for'),
('72155011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ostatní za studena,pod 0,25% C,pravoúhlé,neopracované,ne:čtvercové', 'Other bars and rods of iron or non-alloy steel, not further worked than cold-for'),
('72155019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ostatní za studena,pod 0,25% C,neopracované,ne:pravoúhlé', 'Other bars and rods of iron or non-alloy steel, not further worked than cold-for'),
('72155080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní tyče a pruty, z neleg.oceli, Fe, tvářené za studena, C>0,25%', 'Other bars and rods of iron or non-alloy steel, not further worked than cold-for'),
('72159000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní tyče a pruty, z neleg.oceli, Fe, tvářené za studena', 'Bars or rods, of iron or non-alloy steel, cold-formed or cold-finished and furth'),
('72161000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Profily U,I,H za tepla,ze železa,neleg.oceli,výška pod 80mm', 'U, I or H sections of iron or non-alloy steel, not further worked than hot-rolle'),
('72162100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Profily L za tepla,ze železa,neleg.oceli,výška pod 80mm', 'L sections of iron or non-alloy steel, not further worked than hot-rolled, hot-d'),
('72162200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Profily T za tepla,ze železa,neleg.oceli,výška pod 80mm', 'T sections of iron or non-alloy steel, not further worked than hot-rolled, hot-d'),
('72163110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Profily ve tvaru U,z neleg. oceli,Fe,válc.za tepla,o výšce 80-220 mm', 'U sections of iron or non-alloy steel, simply hot-rolled, hot-drawn or extruded,'),
('72163190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Profily ve tvaru U,z neleg. oceli,Fe,válc.za tepla,o výšce >220 mm', 'U sections of iron or non-alloy steel, simply hot-rolled, hot-drawn or extruded,'),
('72163211', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Profily I za tepla,ze železa,neleg.oceli,výška 80-220mm,příruby s paralel.str.', 'I sections with parallel flange faces, of iron or non-alloy steel, simply hot-ro'),
('72163219', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Profily I za tepla,ze železa,neleg.oceli,výška 80-220mm,ne:přír.s paralel.str.', 'I sections of iron or non-alloy steel, simply hot-rolled, hot-drawn or extruded,'),
('72163291', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Profily I za tepla,ze železa,neleg.oceli,výška nad 220mm,příruby s paralel.str.', 'I sections with parallel flange faces, of iron or non-alloy steel, simply hot-ro'),
('72163299', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Profily I za tepla,ze železa,neleg.oceli,výška nad 220mm,ne:přír.s paralel.str.', 'I sections of iron or non-alloy steel, simply hot-rolled, hot-drawn or extruded,'),
('72163310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Profily H za tepla,ze železa,neleg.oceli,výška 80-180mm', 'H sections of iron or non-alloy steel, simply hot-rolled, hot-drawn or extruded,'),
('72163390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Profily H za tepla,ze železa,neleg.oceli,výška nad 180mm', 'H sections of iron or non-alloy steel, simply hot-rolled, hot-drawn or extruded,'),
('72164010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Profily L za tepla,ze železa,neleg.oceli,výška 80mm a víc', 'L sections of iron or non-alloy steel, not further worked than hot-rolled, hot-d'),
('72164090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Profily T za tepla,ze železa,neleg.oceli,výška nad 80mm', 'T sections of iron or non-alloy steel, not further worked than hot-rolled, hot-d'),
('72165010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Profily,úhelníky,tvarovky ost.za tepla,ze železa,neleg.ocel,průřez max.do 80mm', 'Sections of iron or non-alloy steel, not further worked than hot-rolled, hot-dra'),
('72165091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Profily,úhelníky,tvarovky za tepla,průřez nad 80mm,hlavičkové ploché', 'Bulb sections "bulb flat", only hot-rolled, hot-drawn or hot-extruded'),
('72165099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Profily,úhelníky,tvarovky za tepla,průřez nad 80mm,ne:viz sazebník', 'Profile of iron or non-alloy steel, only hot-rolled, hot-drawn or hot-extruded ('),
('72166110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Profily C,L,U,Z,omega za studena,z výrobků válcovaných plochých,neopracované', 'c, l, u, z, omega or open-ended sections of iron or non-alloy steel, simply cold'),
('72166190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Profily ostatní za studena,neoprac.,z výrobků válcovaných plochých,ne:viz sazebník', 'Angles, shapes and sections (other than c, l, u, z, omega or open-ended sections'),
('72166900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Profily ost.za studena,neopracované,ne:z výrobků válcovaných plochých', 'Angles, shapes and sections, of iron or non-alloy steel, not further worked than'),
('72169110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plechy žebrované za studena,ze železa,neleg.oceli', 'Sheets sheets of iron or non-alloy steel, cold-formed or cold finished, profiled'),
('72169180', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.úhelníky,tvarovky,profily,tvář.za studena,uprav.z ploch.válc.výr.', 'Angles, shapes and sections, of iron or non-alloy steel, cold-formed or cold-fin'),
('72169900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní úhelníky, tvarovky a profily z neleg. oceli n. železa', 'Angles, shapes and sections, of iron or non-alloy steel, cold-formed or cold-fin'),
('72171010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Drát ze železa,neleg.ocel,nepokov.nepotaž.,pod 0,25% C,řez pod 0,8mm', 'Wire of iron or non-alloy steel, in coils, containing by weight < 0,25% carbon,'),
('72171031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Drát ze železa,neleg.ocel,nepokov.nepotaž.,pod 0,25% C,řez od 0,8mm,vroubkovan', 'Wire of iron or non-alloy steel, in coils, containing by weight < 0,25% carbon,'),
('72171039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Drát ze železa,neleg.ocel,nepokov.nepotaž.,pod 0,25% C,řez od 0,8mm,ne:vroubkované', 'Wire of iron or non-alloy steel, in coils, containing by weight < 0,25% carbon,'),
('72171050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Drát ze železa,neleg.ocel,nepokov.nepotaž.,0,25-pod 0,6% C', 'Wire of iron or non-alloy steel, in coils, containing by weight >= 0,25% but < 0'),
('72171090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Drát ze železa,neleg.ocel,nepokov.nepotaž.,nad 0,6% C', 'Wire of iron or non-alloy steel, in coils, containing by weight >= 0,6% carbon,'),
('72172010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Drát ze železa,neleg.ocel,pozinkovaný,pod 0,25% C,řez pod 0,8mm', 'Wire of iron or non-alloy steel, in coils, containing by weight < 0,25% carbon,'),
('72172030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Drát ze železa,neleg.ocel,pozinkovaný,pod 0,25% C,řez 0,8mm a víc', 'Wire of iron or non-alloy steel, in coils, containing by weight < 0,25% carbon,'),
('72172050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Drát ze železa,neleg.ocel,pozinkovaný,0,25-pod 0,6% C', 'Wire of iron or non-alloy steel, in coils, containing by weight >= 0,25% but < 0'),
('72172090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Drát ze železa,neleg.ocel,pozinkovaný,0,6% a víc C', 'Wire of iron or non-alloy steel, in coils, containing by weight >= 0,6% carbon,'),
('72173041', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dráty z neleg. oceli, Fe, pokovené mědí, obsah. méně než 0,25% uhlíku', 'Wire of iron or non-alloy steel, in coils, containing by weight < 0,25% carbon,'),
('72173049', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dráty z neleg. oceli, Fe, pokovené ostatními obecnými kovy, C<0,25%', 'Wire of iron or non-alloy steel, in coils, containing by weight < 0,25% carbon,'),
('72173050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Drát ze železa,neleg.ocel,pokovený,plátovaný obecnými kovy,0,25-pod 0,6% C', 'Wire of iron or non-alloy steel, in coils, containing by weight >= 0,25% but < 0'),
('72173090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Drát ze železa,neleg.ocel,pokovený,plátovaný obecnými kovy,0,6% a víc C', 'Wire of iron or non-alloy steel, in coils, containing by weight >= 0,6% carbon,'),
('72179020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní dráty z neleg. oceli, Fe, obsahující měně než 0,25% uhlíku', 'Wire of iron or non-alloy steel, in coils, containing by weight < 0,25% carbon,'),
('72179050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Drát ze železa,neleg.ocel ostatní,0,25-pod 0,6% C,ne:viz sazebník', 'Wire of iron or non-alloy steel, in coils, containing by weight >= 0,25% but < 0'),
('72179090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Drát ze železa,neleg.ocel ostatní,0,6% a víc C,ne:viz sazebník', 'Wire of iron or non-alloy steel, in coils, containing by weight >= 0,6% carbon,'),
('72181000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ingoty a jiné tvary základní z oceli nerezavějící', 'Steel, stainless, in ingots and other primary forms (excl. waste and scrap in in'),
('72189110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polotovary z nerez.oceli,pravoúhlý průřez (ne čtverc.), nikl >2,5%', 'Semi-finished products of stainless steel, of rectangular "other than square" cr'),
('72189180', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polotovary z nerez.oceli,pravoúhlý průřez (ne čtverc.), nikl <2,5%', 'Semi-finished products of stainless steel, of rectangular "other than square" cr'),
('72189911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polotovary z oceli nerezavějící válcované,kont.lité,čtvercového průřezu', 'Semi-finished products of stainless steel, of square cross-section, rolled or ob'),
('72189919', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polotovary z oceli nerezavějící kované,čtvercového průřezu', 'Semi-finished products of stainless steel, of square cross-section, forged'),
('72189920', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polotovary z oceli nerezavějící válcované,kontinuálně lité ost.,ne:pravoúhlé', 'Semi-finished products of stainless steel, of circular cross-section or of cross'),
('72189980', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní polotovary z nerezavějící oceli, kované', 'Semi-finished products of stainless steel, forged (excl. products of square or r'),
('72191100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.nerez.za tepla,svitky,šíře 600mm a víc,tl.nad 10mm,neopracov.', 'Flat-rolled products of stainless steel, of a width of >= 600 mm, not further wo'),
('72191210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.nerez.za tepla,svitky,šíře 600mm a víc,tl.4,75-10mm,2,5% a víc Ni', 'Flat-rolled products of stainless steel, of a width of >= 600 mm, not further wo'),
('72191290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.nerez.za tepla,svitky,šíře 600mm a víc,tl.4,75-10mm,pod 2,5% Ni', 'Flat-rolled products of stainless steel, of a width of >= 600 mm, not further wo'),
('72191310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.nerez.za tepla,svitky,šíře 600mm a víc,tl.3-4,75mm,2,5% a víc Ni', 'Flat-rolled products of stainless steel, of a width of >= 600 mm, not further wo'),
('72191390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.nerez.za tepla,svitky,šíře 600mm a víc,tl.3-4,75mm,pod 2,5% Ni', 'Flat-rolled products of stainless steel, of a width of >= 600 mm, not further wo'),
('72191410', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.nerez.za tepla,svitky,šíře 600mm a víc,tl.pod 3mm,2,5% a víc Ni', 'Flat-rolled products of stainless steel, of a width of >= 600 mm, not further wo'),
('72191490', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.nerez.za tepla,svitky,šíře 600mm a víc,tl.pod 3mm,pod 2,5% Ni', 'Flat-rolled products of stainless steel, of a width of >= 600 mm, not further wo'),
('72192110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.nerez.za tepla,(ne svitky),š.600mm a víc,tl.nad 10mm,2,5% a víc Ni', 'Flat-rolled products of stainless steel, of a width of >= 600 mm, not further wo'),
('72192190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.nerez.za tepla,(ne svitky),š.600mm a víc,tl.nad 10mm,pod 2,5% Ni', 'Flat-rolled products of stainless steel, of a width of >= 600 mm, not further wo'),
('72192210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.nerez.za tepla,(ne svitky),š.600mm a víc,tl.4,75-10mm,2,5% a víc Ni', 'Flat-rolled products of stainless steel, of a width of >= 600 mm, not further wo'),
('72192290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.nerez.za tepla,(ne svitky),š.600mm a víc,tl.4,75-10mm,pod 2,5% Ni', 'Flat-rolled products of stainless steel, of a width of >= 600 mm, not further wo'),
('72192300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pl.válc.výr.nerez.šíře 600mm a víc,za tepla,ost.,tl.3-pod 4,75mm,ne:viz sazebník', 'Flat-rolled products of stainless steel, of a width of >= 600 mm, not further wo'),
('72192400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.nerez.za tepla,(ne svitky),š.600mm a víc,tl.do 3mm', 'Flat-rolled products of stainless steel, of a width of >= 600 mm, not further wo'),
('72193100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pl.válc.výr.nerez.šíře 600mm a víc,za stud.,ost.,4,75mm a víc,ne:viz sazebník', 'Flat-rolled products of stainless steel, of a width of >= 600 mm, not further wo'),
('72193210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.nerez.za studena,šíře 600mm a víc,tl.3-4,75mm,2,5% a víc Ni', 'Flat-rolled products of stainless steel, of a width of >= 600 mm, not further wo'),
('72193290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.nerez.za studena,šíře 600mm a víc,tl.3-4,75mm,do 2,5% Ni', 'Flat-rolled products of stainless steel, of a width of >= 600 mm, not further wo'),
('72193310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.nerez.za studena,šíře 600mm a víc,tl.nad 1-pod 3mm,2,5% a víc Ni', 'Flat-rolled products of stainless steel, of a width of >= 600 mm, not further wo'),
('72193390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.nerez.za studena,šíře 600mm a víc,tl.nad 1-pod 3mm,do 2,5% Ni', 'Flat-rolled products of stainless steel, of a width of >= 600 mm, not further wo'),
('72193410', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.nerez.za studena,šíře 600mm a víc,tl.0,5-1mm,2,5% a víc Ni', 'Flat-rolled products of stainless steel, of a width of >= 600 mm, not further wo'),
('72193490', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.nerez.za studena,šíře 600mm a víc,tl.0,5-1mm,do 2,5% Ni', 'Flat-rolled products of stainless steel, of a width of >= 600 mm, not further wo'),
('72193510', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.nerez.za studena,šíře 600mm a víc,tl.pod 0,5mm,2,5% a víc Ni', 'Flat-rolled products of stainless steel, of a width of >= 600 mm, not further wo'),
('72193590', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.nerez.za studena,šíře 600mm a víc,tl.pod 0,5mm,do 2,5% Ni', 'Flat-rolled products of stainless steel, of a width of >= 600 mm, not further wo'),
('72199020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.ploché válcované výrobky z nerezavějící oceli, šířka 600 mm a více,perforované', 'Flat-rolled products of stainless steel, of a width of >= 600 mm, hot-rolled or'),
('72199080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.ploché válcované výrobky z nerezavějící oceli, šířka 600 mm a více,ne:perforované', 'Flat-rolled products of stainless steel, of a width of >= 600 mm, hot-rolled or'),
('72201100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.nerez.za tepla,pod 600mm,šíře 4,75mm a víc,neopracované', 'Flat-rolled products of stainless steel, of a width of < 600 mm, not further wor'),
('72201200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.nerez.za tepla,pod 600mm,šíře pod 4,75mm,neopracované', 'Flat-rolled products of stainless steel, of a width of < 600 mm, not further wor'),
('72202021', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válc.výrobky z nerez.oceli,za studena,š.<600mm,tl.>3mm,Ni>2,5%', 'Flat-rolled products of stainless steel, of a width of < 600 mm, not further wor'),
('72202029', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válc.výrobky z nerez.oceli,za studena,š.<600mm,tl.>3mm,Ni<2,5%', 'Flat-rolled products of stainless steel, of a width of < 600 mm, not further wor'),
('72202041', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válc.výr.z nerez.oceli,za studena,š.<600mm,tl.0,35-3mm,Ni>2,5%', 'Flat-rolled products of stainless steel, of a width of < 600 mm, not further wor'),
('72202049', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válc.výr.z nerez.oceli,za studena,š.<600mm,tl.0,35-3mm,Ni<2,5%', 'Flat-rolled products of stainless steel, of a width of < 600 mm, not further wor'),
('72202081', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válc.výrobky z nerez.oceli,za studena,š<600mm,tl<0,35mm,Ni>2,5%', 'Flat-rolled products of stainless steel, of a width of < 600 mm, not further wor'),
('72202089', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válc.výrobky z nerez.oceli,za studena,š<600mm,tl<0,35mm,Ni<2,5%', 'Flat-rolled products of stainless steel, of a width of < 600 mm, not further wor'),
('72209020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní ploché válc.výrobky z nerezavějící oceli, za studena, š.<600mm,perforované', 'Flat-rolled products of stainless steel, of a width of < 600 mm, hot-rolled or c'),
('72209080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní ploché válc.výrobky z nerezavějící oceli, za studena, š.<600mm,ne:perforované', 'Flat-rolled products of stainless steel, of a width of < 600 mm, hot-rolled or c'),
('72210010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty z oceli nerezavějící,za tepla,svitky,2,5% a víc Ni', 'Bars and rods of stainless steel, hot-rolled, in irregularly wound coils, contai'),
('72210090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty z oceli nerezavějící,za tepla,svitky,do 2,5% Ni', 'Bars and rods of stainless steel, hot-rolled, in irregularly wound coils, contai'),
('72221111', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ost.nerez,za tepla,(ne svitky),2,5% a víc Ni,kruh,průměr 80mm a víc', 'Bars and rods of stainless steel, not further worked than hot-rolled, hot-drawn'),
('72221119', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ost.nerez,za tepla,(ne svitky),do 2,5% Ni,kruhové,průměr 80mm a víc', 'Bars and rods of stainless steel, not further worked than hot-rolled, hot-drawn'),
('72221181', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče a pruty z nerez.oceli,válc.za tepla,Ni>2,5%,kruh.průřez-d<80mm', 'Bars and rods of stainless steel, not further worked than hot-rolled, hot-drawn'),
('72221189', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče a pruty z nerez.oceli,válc.za tepla,Ni<2,5%,kruh.průřez-d<80mm', 'Bars and rods of stainless steel, not further worked than hot-rolled, hot-drawn'),
('72221910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ost.nerez.za tepla,(ne svitek),2,5% a víc Ni,ne:kruhové', 'Bars and rods of stainless steel, not further worked than hot-rolled, hot-drawn'),
('72221990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ost.nerez.za tepla,(ne svitek),do 2,5% Ni,ne:kruhové', 'Bars and rods of stainless steel, not further worked than hot-rolled, hot-drawn'),
('72222011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ost.nerez.za stud.,(ne svitek),2,5% a víc Ni,kruh,průměr 80mm a víc', 'Bars and rods of stainless steel, of circular cross-section of a diameter >= 80'),
('72222019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ost.nerez.za stud.,(ne svitek),do 2,5% Ni,kruh,průměr 80mm a víc', 'Bars and rods of stainless steel, of circular cross-section of a diameter >= 80'),
('72222021', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ost.nerez.za stud.,(ne svitek),2,5% avíc Ni,kruh,průměr 25-pod 80mm', 'Bars and rods of stainless steel, not further worked than cold-formed or cold-fi'),
('72222029', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ost.nerez.za stud.,(ne svitek),do 2,5% Ni,kruh,průměr 25-pod 80mm', 'Bars and rods of stainless steel, not further worked than cold-formed or cold-fi'),
('72222031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ost.nerez.za stud.,(ne svitek),do 2,5% Ni,kruh,průměr pod 25mm', 'Bars and rods of stainless steel, not further worked than cold-formed or cold-fi'),
('72222039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ost.nerez.za stud.,(ne svitek),do 2,5% Ni,kruh,průměr pod 25mm', 'Bars and rods of stainless steel, not further worked than cold-formed or cold-fi'),
('72222081', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ost.nerez.za stud.,(ne svitek),2,5% a víc Ni,ne:kruhové', 'Bars and rods of stainless steel, not further worked than cold-formed or cold-fi'),
('72222089', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ost.nerez.za stud.,(ne svitek),do 2,5% Ni,ne:kruhové', 'Bars and rods of stainless steel, not further worked than cold-formed or cold-fi'),
('72223051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ost.nerez.kované,(ne svitek),2,5% a víc Ni', 'Other bars and rods of stainless steel, containing by weight >= 2,5% of nickel,'),
('72223091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ost.nerez.kované,(ne svitky),do 2,5% Ni', 'Other bars and rods of stainless steel, containing by weight < 2,5% of nickel, f'),
('72223097', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní tyče a pruty z nerezavějící oceli', 'Bars and rods of stainless steel, cold-formed or cold-finished and further worke'),
('72224010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Úhelníky,tvarovky,profily z oceli nerezavějící,za tepla,neopracované', 'Angles, shapes and sections of stainless steel, only hot-rolled, only hot-drawn'),
('72224050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Úhelníky, tvarovky a profily z nerez.oceli, tvářené za studena', 'Angles, shapes and sections of stainless steel, not further worked than cold-for'),
('72224090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní úhelníky, tvarovky a profily z nerez.oceli', 'Angles, shapes and sections of stainless steel, cold-formed or cold-finished and'),
('72230011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Drát z nerezavějící oceli,28-31% niklu,10,5-22% chromu', 'Wire of stainless steel, in coils, containing by weight 28% to 31% nickel and 20'),
('72230019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Drát z nerezavějící oceli,2,5-pod 28% Ni,nad 22% Cr', 'Wire of stainless steel, in coils, containing by weight >= 2,5% nickel (excl. su'),
('72230091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Drát z nerezavějící oceli,do 2,5% niklu,13-25% chromu,3,5-6% hliník', 'Wire of stainless steel, in coils, containing by weight < 2,5% nickel, 13% to 25'),
('72230099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'drát z nerezavějící oceli ostatní,ne:viz sazebník', 'Wire of stainless steel, in coils, containing by weight < 2,5% nickel (excl. suc'),
('72241010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ingoty a jiné základní tvary z nástrojové oceli', 'Ingots and other primary forms, of tool steel'),
('72241090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní ingoty a jiné základní tvary z legované oceli', 'Steel, alloy, other than stainless, in ingots or other primary forms (excl. of t'),
('72249002', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polotovary z nástrojové oceli', 'Semi-finished products of tool steel'),
('72249003', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polotovary z rychlořez.oceli,válc.za tepla,lité,pravoúhlý průřez,š<2tl', 'Semi-finished products of high-speed steel, of square or rectangular cross-secti'),
('72249005', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polotovary z leg.oceli,válcov,kont.lité za tepla,pravoúhlé,složení viz sazebník', 'Semi-finished products of steel containing by weight <= 0,7% of carbon, 0,5% to'),
('72249007', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.polotovary z leg.oceli,válc.za tepla,lité,pravoúhlý průřez,š<2tl', 'Semi-finished products of alloy steel other than stainless steel, of square or r'),
('72249014', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polotovary z legované oceli,válc.za tepla,lité,pravoúhlý průřez,š>2tl', 'Semi-finished products of alloy steel other than stainless steel, of square or r'),
('72249018', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polotovary z legované oceli, kované, pravoúhlý průřez', 'Semi-finished products of alloy steel other than stainless steel, of square or r'),
('72249031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polotovary z leg.oceli,válc,kont.lité,za tepla,složení viz sazeb,ne:pravoúhlé', 'Semi-finished products of steel containing by weight 0,9% to 1,15% carbon, 0,5%'),
('72249038', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.polotovary z leg.oceli,válcované za tepla,lité,nepravoúhl.průřez', 'Semi-finished products of alloy steel, other than stainless steel, cut into shap'),
('72249090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní polotovary z legované oceli, kované, ne pravoúhlý průřez', 'Semi-finished products of alloy steel, other than stainless steel, forged (excl.'),
('72251100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.,šíře 600mm a víc,z elektrooceli křemíkové orientované', 'Flat-rolled products of silicon-electrical steel, of a width of >= 600 mm, grain'),
('72251910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.,za tepla,šíře 600mm a víc,elektroocel křemíková,ne:orientované', 'Flat-rolled products of silicon-electrical steel, of a width of >= 600 mm, hot-r'),
('72251990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.,za studena,šíře 600mm a víc,elektroocel křemíková,ne:orientované', 'Flat-rolled products of silicon-electrical steel, of a width of >= 600 mm, cold-'),
('72253010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válc.výrobky z nástrojové oceli,za tepla,ve svitcích,š.>600mm', 'Flat-rolled products of tool steel, of a width of >= 600 mm, not further worked'),
('72253030', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válc.výrobky z rychlořezné oceli,za tepla,ve svitcích,š.>600mm', 'Flat-rolled products of high-speed steel, of a width of >= 600 mm, not further w'),
('72253090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní ploché válc.výrobky z leg.oceli,za tepla,ve svitcích,š.>600mm', 'Flat-rolled products of alloy steel other than stainless, of a width of >= 600 m'),
('72254012', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válcované výrobky z nástrojové oceli, za tepla, š.>600mm', 'Flat-rolled products of tool steel, of a width of >= 600 mm, not further worked'),
('72254015', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válcované výrobky z rychlořezné oceli,za tepla,š.>600mm', 'Flat-rolled products of high-speed steel, of a width of >= 600 mm, not further w'),
('72254040', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní ploché válc.výrobky z leg.oceli,za tepla,š.>600mm,tl.>10mm', 'Flat-rolled products of alloy steel other than stainless, of a width of >= 600 m'),
('72254060', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.ploché válc.výrobky z leg.oceli,za tepla,š.>600mm,tl.4,75-10mm', 'Flat-rolled products of alloy steel other than stainless, of a width of >= 600 m'),
('72254090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní ploché válc.výrobky z leg.oceli,za tepla,š.>600mm,tl.<4,75mm', 'Flat-rolled products of alloy steel other than stainless, of a width of >= 600 m'),
('72255020', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.,za studena,šíře 600mm a víc,rychlořená ocel,neopracované', 'Flat-rolled products of high-speed steel, of a width of >= 600 mm, not further w'),
('72255080', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.,za studena,šíře 600mm a víc,ocel leg.,neopracované', 'Flat-rolled products of alloy steel other than stainless, of a width of >= 600 m'),
('72259100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válc.výrobky z leg.oceli, elektroliticky pozinkované, š.>600mm', 'Flat-rolled products of alloy steel other than stainless, of a width of >= 600 m'),
('72259200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válc.výrobky z legované oceli, jinak pozinkované, š.>600mm', 'Flat-rolled products of alloy steel other than stainless, of a width of >= 600 m'),
('72259900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní ploché válcované výrobky z legované oceli, šíře 600 mm a více', 'Flat-rolled products of alloy steel other than stainless, of a width of >= 600 m'),
('72261100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válc.výr.z křemíkové elektrooceli,š<600mm,orientovaná struktura', 'Flat-rolled products of silicon-electrical steel, of a width of < 600 mm, hot-ro'),
('72261910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výr.válc.pl.,za tepla,šíře pod 600mm,elektroocel křemíková,neopracovaný', 'Flat-rolled products of silicon-electrical steel, of a width of < 600 mm, not fu'),
('72261980', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní ploché válc.výrobky z křemíkové elektrooceli,š<600mm', 'Flat-rolled products of silicon-electrical steel, of a width of < 600 mm, cold-r'),
('72262000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válcované výrobky z rychlořezné oceli, šíře menší než 600mm', 'Flat-rolled products of high-speed steel, of a width of <= 600 mm, hot-rolled or'),
('72269120', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válcované výrobky z nástrojové oceli,za tepla, šíře <600mm', 'Flat-rolled products of tool steel, of a width of < 600 mm, simply hot-rolled'),
('72269191', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válc.výrobky z ost.legované oceli,za tepla,š.<600mm,tl.>4,75mm', 'Flat-rolled products of alloy steel other than stainless steel, simply hot-rolle'),
('72269199', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válc.výrobky z ost.legované oceli,za tepla,š.<600mm,tl.<4,75mm', 'Flat-rolled products of alloy steel other than stainless steel, simply hot-rolle'),
('72269200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válcované výrobky z ost. legované oceli,za studena, šíře <600mm', 'Flat-rolled products of alloy steel other than stainless, of a width of < 600 mm'),
('72269910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válc.výrobky z ost.leg.oceli,elektrolyticky pozinkované,š<600mm', 'Flat-rolled products of alloy steel other than stainless, of a width of < 600 mm'),
('72269930', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ploché válc.výrobky z ost.legované oceli,jinak pozinkované,š<600mm', 'Flat-rolled products of alloy steel other than stainless, of a width of < 600 mm'),
('72269970', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní ploché válcované výrobky z ost. legované oceli, šíře <600mm', 'Flat-rolled products of alloy steel other than stainless, of a width of < 600 mm'),
('72271000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty,za tepla,svitek,z oceli rychlořezné', 'Bars and rods of high-speed steel, hot-rolled, in irregularly wound coils'),
('72272000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty,za tepla,svitek z oceli křemíkomanganové', 'Bars and rods of silico-manganese steel, hot-rolled, in irregularly wound coils'),
('72279010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty,za tepla,svitek,ocel leg.,nad 0,0008% bóru', 'Bars and rods, hot-rolled, of steel containing by weight >= 0,0008% of boron wit'),
('72279050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty,za tepla,svitek,ocel leg.,0,9-1,15% C,0,5-2% Cr,je-li Mo-do 0,5%', 'Bars and rods, hot-rolled, of steel containing by weight 0,9% to 1,15% carbon, 0'),
('72279095', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty,za tepla,svitek,ocel leg.,ostatní,ne:viz sazebník', 'Bars and rods, hot-rolled, in irregularly wound coils of alloy steel other than'),
('72281020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče a pruty z ostatní legované oceli,válcované za tepla, i plátované', 'Bars and rods of high-speed steel, not further worked than hot-rolled, hot-drawn'),
('72281050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ost.,kované,(ne svitek),ocel rychlořezná', 'Bars and rods of high-speed steel, forged (excl. semi-finished products, flat-ro'),
('72281090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ost.,(ne svitek),ocel rychlořezná ostatní,ne:viz sazebník', 'Bars and rods of high-speed steel, not further worked than cold-formed or cold-f'),
('72282010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče a pruty z Si-Mn oceli,válc.za tepla,provoúhlý průřez (ne čtverc.)', 'Bars and rods of silico-manganese steel, of rectangular "other than square" cros'),
('72282091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní tyče a pruty z Si-Mn oceli,po válcování za tepla dále neoprac.', 'Bars and rods of silico-manganese steel, of square or other than rectangular cro'),
('72282099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní tyče a pruty z křemíkomanganové oceli,válcované za tepla', 'Bars and rods of silico-manganese stee, of square or other than rectangular cros'),
('72283020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ost.,za tepla,(ne svitek),ocel nástrojová', 'Bars and rods of tool steel, only hot-rolled, only hot-drawn or only extruded (e'),
('72283041', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ost.,za tepla,(ne svitek),ocel leg.,kruh.80mm a víc,slož.viz sazebník', 'Bars and rods of steel containing by weight 0,9 to 1,15% of carbon and 0,5 to 2%'),
('72283049', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ost.,za tepla,(ne svitek),ocel leg.ost.ne:viz sazebník', 'Bars and rods of steel containing by weight 0,9 to 1,15% of carbon and 0,5 to 2%'),
('72283061', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ost.,za tepla,(ne svitek),ocel leg.,kruh. 80mm a víc,ne:viz sazebník', 'Bars and rods of alloy steel other than stainless steel, only hot-rolled, hot-dr'),
('72283069', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ost.,za tepla,(ne svitek),ocel leg.,kruh do 80mm,ne:viz sazebník', 'Bars and rods or alloy steel other than stainless steel, only hot-rolled, hot-dr'),
('72283070', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ost.,za tepla,(ne svitek),ocel leg.,pravoúhlé,ne:čtverec', 'Bars and rods of alloy steel other than stainless steel, of rectangular "other t'),
('72283089', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ost.,za tepla,(ne svitek),ocel leg.,ost.i čtvercové,ne:pravoúhlé', 'Bars and rods of alloy steel other than stainless steel, only hot-rolled, hot-dr'),
('72284010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ost.,kované,(ne svitek),ocel leg.,nástrojová', 'Bars and rods of tool steel, only forged (excl. semi-finished products, flat-rol'),
('72284090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ost.,kované,(ne svitek),ocel leg.ostatní,ne:nástrojová', 'Bars and rods of alloy steel, other than stainless steel, only forged (excl. of'),
('72285020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ost.,za studena,(ne svitek),ocel leg.,nástrojová', 'Bars and rods of tool steel, only cold-formed or cold-finished (excl. semi-finis'),
('72285040', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ost.,za studena,(ne svitek),ocel leg.,složení viz sazebník', 'Bars and rods of steel containing 0,9% to 1,15% of carbon, 0,5% to 2% of chromiu'),
('72285061', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ost.,za studena,(ne svitek),ocel leg.,kruh.80mm a víc,slož.viz sazebník', 'Bars and rods of alloy steel, other than stainless steel, not further worked tha'),
('72285069', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ost.,za studena,(ne svitek),ocel leg.,kruh.pod 80mm,slož.viz sazebník', 'Bars and rods of alloy steel, other than stainless steel, not further worked tha'),
('72285080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.tyče a pruty z ost.leg. oceli,tvarované za studena,nekruh.průřez', 'Bars and rods of alloy steel, other than stainless steel, not further worked tha'),
('72286020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní tyče a pruty z nástrojové oceli', 'Bars and rods of tool steel, cold-formed or cold-finished and further worked or'),
('72286080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní tyče a pruty z ostatní legované oceli', 'Bars and rods of alloy steel, other than stainless steel, cold-formed or cold-fi'),
('72287010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Úhelníky,tvarovky,profily,za tepla,ocel leg.,neopracované', 'Angles, shapes and sections of alloy steel other than stainless, not further wor'),
('72287090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní úhelníky, tvarovky a profily z ostatní legované oceli', 'Angles, shapes and sections of alloy steel other than stainless, n.e.s. (excl. p'),
('72288000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Duté vrtné tyče a pruty z legované nebo nelegované oceli', 'Hollow drill bars and rods, of alloy or non-alloy steel'),
('72292000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dráty z oceli křemíkomanganové', 'Wire of silico-manganese steel, in coils (excl. bars and rods)'),
('72299020', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dráty z oceli rychlořezné', 'Wire of high-speed steel, in coils (excl. bars and rods)'),
('72299050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dráty z ostatní legované oceli,0,9-1,15% C,0,5-2% Cr,je-li Mo-do 0,5%', 'Wire of steel containing by weight 0,9% to 1,1% of carbon, 0,5% to 2% of chromiu'),
('72299090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dráty z ostatní legované oceli ostatní,ne:viz sazebník', 'Wire of alloy steel other than stainless, in coils (excl. rolled bars and rods,'),
('73011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Štětovnice z železa,oceli i vrtané,ražené a podobně', 'Sheet piling of iron or steel, whether or not drilled, punched or made from asse'),
('73012000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Úhelníky,tvarovky,profily ze železa,oceli svařované', 'Angles, shapes and sections, of iron or steel, welded'),
('73021010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kolejnice napájecí-vodič elektrického proudu z neželezného kovu', 'Current-conducting rails of iron or steel, with parts of non-ferrous metal, for'),
('73021021', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nové Vignolovy (širokopatní) kolejnice,hmotnost na metr větší než 46kg', 'Vignole rails of iron or steel, for railway or tramway track, new, of a weight o'),
('73021023', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nové Vignolovy (širokopatní) kolejnice, o hmotnosti na metr 27-46 kg', 'Vignole rails of iron or steel, for railway or tramway track, new, of a weight o'),
('73021029', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nové Vignolovy (širokopatní) kolejnice,hmot.na metr menší než 27 kg', 'Vignole rails of iron or steel, for railway or tramway track, new, of a weight o'),
('73021040', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nové žlábkové kolejnice', 'Grooved rails of iron or steel, for railway or tramway track, new'),
('73021050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní nové kolejnice', 'Rails of iron or steel, for railway or tramway track, new, of a weight of < 20 k'),
('73021090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kolejnice železné,ocelové použité', 'Rails of iron or steel, for railway or tramway track, used (excl. check-rails an'),
('73023000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hrotnice,výhybky,přestav.tyče výměny a jiná zařízení přejezdová železné,ocel.', 'Switch blades, crossing frogs, point rods and other crossing pieces, for railway'),
('73024000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kolejnicové spojky a podkladnice', 'Fish-plates and sole plates of iron or steel, for railways or tramways'),
('73029000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.materiál pro stavbu železničních a tramvajových tratí, z Fe, oceli', 'Sleepers "cross-ties", check-rails, rack rails, chairs, chair wedges, rail clips'),
('73030010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,trubky pro tlaková zatížení z litiny', 'Tubes and pipes of a kind used in pressure systems, of cast iron'),
('73030090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,trubky,duté profily ostatní z litiny,ne:pro tlaková zatížení', 'Tubes, pipes and hollow profiles, of cast iron (excl. products of a kind used in'),
('73041100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,duté profily ap,bezešvé,z nerez.oceli', 'Line pipe of a kind used for oil or gas pipelines, seamless, of stainless steel'),
('73041910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,duté profily ap,bezešvé,ze železa,oceli,průměr <=168,3mm,ne:nerez.ocel', 'Line pipe of a kind used for oil or gas pipelines, seamless, of iron or steel, o'),
('73041930', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,duté profily ap,bezešvé,ze železa,oceli,průměr >168,3mm,<=406,4mm,ne:nerez.ocel', 'Line pipe of a kind used for oil or gas pipelines, seamless, of iron or steel, o'),
('73041990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,duté profily ap,bezešvé,ze železa,oceli,průměr >406,4mm,ne:nerez.ocel', 'Line pipe of a kind used for oil or gas pipelines, seamless, of iron or steel, o'),
('73042200', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trubky vrtné,bezešvé,z nerez.oceli,pro vrt.těžbu ropy', 'Drill pipe, seamless, of stainless steel, of a kind used in drilling for oil or'),
('73042300', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trubky vrtné,bezešvé,ze železa,oceli,ost,pro vrt.těžbu ropy', 'Drill pipe, seamless, of a kind used in drilling for oil or gas, of iron or stee'),
('73042400', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pažnice,trubky čerpací,bezešvé,z nerez.oceli,pro vrt.těžbu ropy', 'Casing and tubing, seamless, of a kind used for drilling for oil or gas, of stai'),
('73042910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pažnice,trubky čerpací,bezešvé,ze železa,oceli,ost,pro vrt.těžbu ropy,průměr <=168,3mm', 'Casing and tubing of a kind used for drilling for oil or gas, seamless, of iron'),
('73042930', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pažnice,trubky čerpací,bezešvé,ze železa,oceli,ost,pro vrt.těžbu ropy,průměr >168,3mm,<=406,4mm', 'Casing and tubing of a kind used for drilling for oil or gas, seamless, of iron'),
('73042990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pažnice,trubky čerpací,bezešvé,ze železa,oceli,ost,pro vrt.těžbu ropy,průměr >406,4mm', 'Casing and tubing of a kind used for drilling for oil or gas, seamless, of iron'),
('73043120', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby apod.přesné železné,ocelové neleg.bezešvé kruh.,za studena', 'Precision tubes, seamless, of circular cross-section, of iron or non-alloy steel'),
('73043180', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby apod.železné,ocelové neleg.bezešvé kruh.za studena ost.,ne:přesné', 'Tubes, pipes and hollow profiles, seamless, of circular cross-section, of iron o'),
('73043910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby apod.železné,ocel.neleg.bezešvé kruh.rovné neoprac.k výrobě jiných trub', 'Tubes, pipes and hollow profiles, seamless, of circular cross-section, of iron o'),
('73043952', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trubky plynové železné,ocel.neleg.bezešvé kruhovité pokovené,pozinkované', 'Threaded or threadable tubes "gas pipe", seamless, of iron or non-alloy steel, p'),
('73043958', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trubky plynové železné,ocel.neleg.bezešvé kruhovité ost.,ne:pokovené,pozinkované', 'Threaded or threadable tubes "gas pipe", seamless, of iron or non-alloy steel (e'),
('73043992', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby apod.železné,ocel.neleg.bezešvé kruh.ost.,průměr <=168,3mm,ne:viz sazebník', 'Tubes, pipes and hollow profiles, seamless, of circular cross-section, of iron o'),
('73043993', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby apod.železné,ocel.neleg.bezešvé kruh.ost.,průměr >168,3,<=406,4mm,ne:viz sazebník', 'Tubes, pipes and hollow profiles, seamless, of circular cross-section, of iron o'),
('73043998', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby apod.železné,ocel.neleg.bezešvé kruh.ost.,průměr >406,4mm,ne:viz sazebník', 'Tubes, pipes and hollow profiles, seamless, of circular cross-section, of iron o'),
('73044100', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby apod.nerez.bezešvé za studena,kruhovité', 'Tubes, pipes and hollow profiles, seamless, of circular cross-section, of stainl'),
('73044910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby apod.nerez.bezešvé kruhovité rovné neopracované k výrobě jiných trub', 'Tubes, pipes and hollow profiles, seamless, of circular cross-section, of stainl'),
('73044993', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,trubky apod.nerez.bezešvé kruhovité ostatní,průměr <=168,3mm,ne:viz sazebník', 'Tubes, pipes and hollow profiles, seamless, of circular cross-section, of stainl'),
('73044995', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,trubky apod.nerez.bezešvé kruhovité ostatní,průměr >168,3, <=406,4mm,ne:viz sazebník', 'Tubes, pipes and hollow profiles, seamless, of circular cross-section, of stainl'),
('73044999', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,trubky apod.nerez.bezešvé kruhovité ostatní,průměr >406,4mm a víc', 'Tubes, pipes and hollow profiles, seamless, of circular cross-section, of stainl'),
('73045112', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby bezešvé,z leg.oceli,kruh.průřez,tažené za studena,délka <0,5m', 'Tubes, pipes and hollow profiles, seamless, of circular cross-section, of alloy'),
('73045118', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby bezešvé,z leg.oceli,kruh.průřez,tažené za studena,délka >0,5m', 'Tubes, pipes and hollow profiles, seamless, of circular cross-section, of alloy'),
('73045181', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trubky apod.leg.ocel,za studena,bezešvé kruhové přesné', 'Precision tubes, seamless, of circular cross-section, of alloy steel other than'),
('73045189', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trubky apod.leg.ocel,za studena,bezešvé kruhové,ne:přesné', 'Tubes, pipes and hollow profiles, seamless, of circular cross-section, of alloy'),
('73045910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby apod.leg.ocel,bezešvé kruhovité neopracované k výrobě jiných trub', 'Tubes, pipes and hollow profiles, seamless, of circular cross-section, of alloy'),
('73045932', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.trouby,trubky,duté profily,bezešvé,z leg.oceli,kruh.průřez,d.<0,5m', 'Tubes, pipes and hollow profiles of alloy steel (excl. stainless), seamless, of'),
('73045938', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost.trouby,trubky,duté profily,bezešvé,z leg.oceli,kruh.průřez,d.>0,5m', 'Tubes, pipes and hollow profiles, seamless, of circular cross-section, of alloy'),
('73045992', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby apod.ocel leg.bezešvé kruhovité ost.,průměr do 168,3mm', 'Tubes, pipes and hollow profiles, seamless, of circular cross-section, of alloy'),
('73045993', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby apod.ocel leg.bezešvé kruhovité ost.průměr nad 168,3-406,4mm,ne:viz sazebník', 'Tubes, pipes and hollow profiles, seamless, of circular cross-section, of alloy'),
('73045999', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby apod.ocel leg.bezešvé kruhovité ost.průměr nad 406,4mm,ne:viz sazebník', 'Tubes, pipes and hollow profiles, seamless, of circular cross-section, of alloy'),
('73049000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby apod.ostatní železné,ocelové bezešvé,ne:viz sazebník', 'Tubes, pipes and hollow profiles, seamless, of non-circular cross-section, of ir'),
('73051100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby apod.kruhovité nad 406,4mm,podélně obloukově svař.pro ropovody,plynovody', 'Line pipe of a kind used for oil or gas pipelines, having circular cross-section'),
('73051200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby apod.kruhovité nad 406,4mm,podélně svařované pro ropovody,plynovody', 'Line pipe of a kind used for oil or gas pipelines, having circular cross-section'),
('73051900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby apod.kruhovité nad 406,4mm ostatní pro ropovody,plynovody,ne:sazebník', 'Line pipe of a kind used for oil or gas pipelines, having circular cross-section'),
('73052000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pažnice používané při vrtné těžbě ropy nebo plynu', 'Casing of a kind used in drilling for oil or gas, having circular cross-sections'),
('73053100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby apod.kruhovité nad 406,4mm ostatní podélně svařované', 'Tubes and pipes having circular cross-sections and an external diameter of > 406'),
('73053900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby apod.kruhovité nad 406,4 mm ostatní svařované,ne:podélně', 'Tubes and pipes having circular cross-sections and an external diameter of > 406'),
('73059000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,trubky kruhovité nad 406,4mm ostatní,ne:viz sazebník', 'Tubes and pipes having circular cross-sections and an external diameter of > 406'),
('73061110', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,duté profily ap,ost,pro ropovody,plynovody,podélně svař.,z nerez.oceli', 'Line pipe of a kind used for oil or gas pipelines, longitudinally welded, of fla'),
('73061190', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,duté profily ap,ost,pro ropovody,plynovody,spirálovitě svař.,z nerez.oceli', 'Line pipe of a kind used for oil or gas pipelines, spirally welded, of flat-roll'),
('73061910', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,duté profily ap,ost,pro ropovody,plynovody,podélně svař.,ze železa,oceli,ne:nerez.ocel', 'Line pipe of a kind used for oil or gas pipelines, longitudinally welded, of fla'),
('73061990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,duté profily ap,ost,pro ropovody,plynovody,spirálovitě svař.,ze železa,oceli,ne:nerez.ocel', 'Line pipe of a kind used for oil or gas pipelines, spirally welded, of flat-roll'),
('73062100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pažnice,trubky,ost,pro vrt.těžbu ropy,plynu,svař.,z nerez.oceli', 'Casing and tubing of a kind used in drilling for oil or gas, welded, of flat-rol'),
('73062900', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pažnice,trubky,ost,pro vrt.těžbu ropy,plynu,ost.,ne:viz sazebník', 'Casing and tubing of a kind used in drilling for oil or gas, welded, of flat-rol'),
('73063011', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trubky apod.ost.přesné železné,neleg.ocel,kruhovité,svařované,stěna do 2mm', 'Precision tubes, welded, of circular cross-section, of iron or non-alloy steel,'),
('73063019', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trubky apod.ost.přesné železné,neleg.ocel,kruhovité,svařované,stěna nad 2mm', 'Precision tubes, welded, of circular cross-section, of iron or non-alloy steel,'),
('73063041', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trubky apod.ost.plynové železné,neleg.ocel,kruhovité,svařované,pokovené,pozinkované', 'Threaded or threadable tubes "gas pipe", welded, of circular cross-section, of i'),
('73063049', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trubky apod.ost.plynové železné,neleg.ocel,kruhovité,svařované,ne:pokovené,pozinkované', 'Threaded or threadable tubes "gas pipe", welded, of circular cross-section, of i'),
('73063072', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby apod.ost.železné,neleg.ocel,kruh.,svař.,průměr do 168,3mm,pokovené,pozinkované', 'Other tubes, pipes and hollow profiles, welded, of circular cross-section, of ir'),
('73063077', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby apod.ost.železné,neleg.ocel,kruh.,svař.,průměr do 168,3mm,ne:pokovené,pozinkované', 'Other tubes, pipes and hollow profiles, welded, of circular cross-section, of ir'),
('73063080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby apod.ost.železné,neleg.ocel,kruh.,svař.,průměr nad 168,3-406,4mm', 'Tubes, pipes and hollow profiles, welded, having a circular cross-section, of ir'),
('73064020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby apod.nerez.ocel,za studena,kruhovité,svařované', 'Tubes, pipes and hollow profiles, welded, of circular cross-section, of stainles'),
('73064080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby apod.nerez.ocel,kruhovité,svařované,ne:za studena', 'Tubes, pipes and hollow profiles, welded, of circular cross-section, of stainles'),
('73065020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby apod.přesné,ocel legovaná,kruhovité,svařované', 'Precision steel tubes, welded, of circular cross-section of an external diameter'),
('73065080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby apod.ost.,ocel legovaná,kruhovité,svařované,ne:přesné', 'Tubes, pipes and hollow profiles, welded, of circular cross-section, of alloy st'),
('73066110', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,duté profily ap,ost,svař,průřez čtverec/obdélník,z nerez.oceli', 'Tubes and pipes and hollow profiles, welded, of square or rectangular cross-sect'),
('73066192', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,duté profily ap,ost,svař,průřez čtverec/obdélník,tl.<=2mm,ne:z nerez.oceli', 'Tubes and pipes and hollow profiles, welded, of square or rectangular cross-sect'),
('73066199', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,duté profily ap,ost,svař,průřez čtverec/obdélník,z nerez.oceli', 'Tubes and pipes and hollow profiles, welded, of square or rectangular cross-sect'),
('73066910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,duté profily ap,ost,svař.,z nerez oceli,ne:průřez kruh/čtverec/obdélník', 'Tubes, pipes and hollow profiles, welded, of non-circular cross-section, of stai'),
('73066990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,duté profily ap,ost,svař.,ne:z nerez oceli,průřez kruh/čtverec/obdélník', 'Tubes, pipes and hollow profiles, welded, of non-circular cross-section, of iron'),
('73069000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,trubky,profily duté ostatní ze železa,oceli,ne:viz sazebník', 'Tubes, pipes and hollow profiles "e.g., open seam, riveted or similarly closed",'),
('73071110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příslušenství pro trouby,trubky lité z litiny nekujné pro systémy tlakové', 'Tube or pipe fittings of non-malleable cast iron, of a kind used in pressure sys'),
('73071190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příslušenství pro trouby,trubky lité z litiny nekujné ost.,ne:systémy tlakové', 'Tube or pipe fittings of non-malleable cast iron (excl. products of a kind used'),
('73071910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příslušenství pro trouby,trubky lité z litiny kujné', 'Tube or pipe fittings of malleable cast iron'),
('73071990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příslušenství pro trouby,trubky lité ostatní,ne:z litiny kujné,nekujné', 'Cast tube or pipe fittings of steel'),
('73072100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příruby z oceli nerezavějící', 'Flanges of stainless steel (excl. cast products)'),
('73072210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nátrubky se závitem z oceli nerezavějící', 'Sleeves, of stainless steel, threaded (excl. cast products)'),
('73072290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kolena,ohyby se závitem z oceli nerezavějící', 'Elbows and bends, of stainless steel, threaded (excl. cast products)'),
('73072310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kolena,ohyby pro svařování na tupo z oceli nerezavějící', 'Butt welding elbows and bends of stainless steel (excl. cast products)'),
('73072390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příslušenství ost.,pro svařování na tupo z oceli nerezavějící,ne:kolena,ohyby', 'Butt welding tube or pipe fittings of stainless steel (excl. cast products and e'),
('73072910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příslušenství ost.se závitem pro trouby z oceli nerez.,ne:nátrubky,kolena,ohyby', 'Threaded tube or pipe fittings of stainless steel (excl. cast products, flanges,'),
('73072930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příslušenství ost.pro svařování z oceli nerezavějící,ne:pro svařování na tupo', 'Tube or pipe fittings of stainless steel, for welding (excl. cast products and f'),
('73072990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příslušenství ostatní pro trouby z oceli nerezavějící,ne:viz sazebník', 'Tube or pipe fittings of stainless steel (excl. cast products, threaded products'),
('73079100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příruby ze železa,oceli,ne:nerez,litina', 'Flanges of iron or steel (excl. cast or stainless products)'),
('73079210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nátrubky se závitem ze železa,oceli,ne:nerez,litina', 'Sleeves of iron or steel, threaded (excl. cast or of stainless steel)'),
('73079290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kolena,ohyby se závitem ze železa,oceli,ne:nerez,litina', 'Elbows and bends, of iron or steel, threaded (excl. cast or of stainless steel)'),
('73079311', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kolena,ohyby pro svařování na tupo ze železa,oceli do 609,6mm,ne:nerez,litina', 'Butt welding elbows and bends, of iron or steel, with greatest external diameter'),
('73079319', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příslušenství ost.pro svařování na tupo ze železa,oceli do 609,6mm,ne:viz sazebník', 'Butt welding fittings of iron or steel, with greatest external diameter <= 609,6'),
('73079391', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kolena,ohyby pro svařování na tupo ze železa,oceli nad 609,6mm,ne:nerez,litina', 'Butt welding elbows and bends, of iron or steel, with greatest external diameter'),
('73079399', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příslušenství ost.pro svařování na tupo ze železa,oceli nad 609,6mm,ne:viz sazebník', 'Butt welding fittings of iron or steel, with greatest external diameter > 609,6'),
('73079910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příslušenství ost.se závitem pro trouby,trubky ze železa,oceli,ne:nerez,litina', 'Threaded tube or pipe fittings, of iron or steel (excl. cast iron or stainless s'),
('73079930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příslušenství ost.pro svařování ze železa,oceli,ne:nerez,litina,svař.na tupo', 'Tube or pipe fittings, of iron or steel, for welding (excl. cast iron or stainle'),
('73079990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příslušenství ost.ze železa,oceli,ne:viz sazebník', 'Tube or pipe fittings, of iron or steel (excl. products of cast iron or stainles'),
('73081000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mosty,části mostů ze železa,oceli', 'Bridges and bridge-sections, of iron or steel'),
('73082000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Věže,stožáry,sloupy,pilíře ze železa,oceli', 'Towers and lattice masts, of iron or steel'),
('73083000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Dveře,okna,jejich rámy,dveřní prahy ze železa,oceli', 'Doors, windows and their frames and thresholds for doors, of iron or steel'),
('73084010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Důlní výztuže', 'Mine supports, of iron or steel'),
('73084090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zařízení pro lešení,bednění,vzpěry,ne:důlní výztuže', 'Equipment for scaffolding, shuttering, propping or pit-propping, of iron or stee'),
('73089010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Konstrukce pro cesty vodní,námořní ze železa,oceli', 'Weirs, sluices, lock-gates, landing stages, fixed docks and other maritime and w'),
('73089051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Panely-dvoustěny z profilovaného plechu s izolací', 'Panels comprising two walls of profiled "ribbed" sheet, of iron or steel, with a'),
('73089059', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky konstrukční z plechu ze železa,oceli', 'Structures and parts of structures, of iron or steel, solely or principally of s'),
('73089099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Konstrukce,konstrukční prvky a části ostatní ze železa,oceli,ne:z plechu', 'Structures and parts of structures of iron or steel, n.e.s. (excl. bridges and b'),
('73090010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nádrže apod.ze železa,oceli na plyny,objem nad 300 l,ne:stlačené,zkapalněné', 'Reservoirs, tanks, vats and similar containers, of iron or steel, for gases othe'),
('73090030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nádrže apod.na kapaliny izolované ze železa,oceli,objem nad 300 l', 'Reservoirs, tanks, vats and similar containers, of iron or steel, for liquids, l'),
('73090051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nádrže apod.ze železa,oceli na kapaliny,objem nad 100 000 l', 'Reservoirs, tanks, vats and similar containers, of iron or steel, for liquids, o'),
('73090059', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nádrže apod.ze železa,oceli na kapaliny,objem nad 300-100 000 l', 'Reservoirs, tanks, vats and similar containers, of iron or steel, for liquids, o'),
('73090090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nádrže apod.ze železa,oceli na látky pevné,objem nad 300 l', 'Reservoirs, tanks, vats and similar containers, of iron or steel, for solids, of'),
('73101000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cisterny,kádě,sudy apod.ze železa,oceli,objem 50-300 l', 'Tanks, casks, drums, cans, boxes and similar containers, of iron or steel, for a'),
('73102111', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plechovky o objemu menším než 50 l,určené ke konzervování potravin', 'Cans of iron or steel, of a capacity of < 50 l, which are to be closed by solder'),
('73102119', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plechovky o objemu menším než 50 l,určené ke konzervování nápojů', 'Cans of iron or steel, of a capacity of < 50 l, which are to be closed by solder'),
('73102191', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plechovky ze železa,oceli,plech do 0,5mm,objem do 50 l,ne:na potraviny,nápoje', 'Cans of iron or steel, of a capacity of < 50 l, which are to be closed by solder'),
('73102199', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plechovky ze železa,oceli,plech 0,5mm a víc,objem do 50 l,ne:potraviny,nápoje', 'Cans of iron or steel, of a capacity of < 50 l, which are to be closed by solder'),
('73102910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nádoby,obaly ze železa,oceli,plech do 0,5mm,objem do 50 l,ne:plechovky', 'Tanks, casks, drums, cans, boxes and similar containers, of iron or steel, for a'),
('73102990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nádoby,obaly ze železa,oceli,plech 0,5mm a víc,objem do 50 l,ne:plechovky', 'Tanks, casks, drums, cans, boxes and similar containers, of iron or steel, for a'),
('73110011', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Nádoby tlakové bezešvé ze železa,oceli na plyn stlačený,zkapalněný,tlak >=165 bar,objem <20 l', 'Containers of iron or steel, seamless, for compressed or liquefied gas, for a pr'),
('73110013', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Nádoby tlakové bezešvé ze železa,oceli na plyn stlačený,zkapalněný,tlak >=165 bar,objem >=20, <=50 l', 'Containers of iron or steel, seamless, for compressed or liquefied gas, for a pr'),
('73110019', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Nádoby tlakové bezešvé ze železa,oceli na plyn stlačený,zkapalněný,tlak >=165 bar,objem >50 l', 'Containers of iron or steel, seamless, for compressed or liquefied gas, for a pr'),
('73110030', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Nádoby tlakové bezešvé ze železa,oceli na plyn stlačený,zkapalněný,tlak <165 bar', 'Containers of iron or steel, seamless, for compressed or liquefied gas, for a pr'),
('73110091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nádoby tlak.ost.ze železa,oceli na plyn stlačený,zkapal.,pod 1000 l,ne:bezešvé', 'Containers of iron or steel, seamless, for compressed or liquefied gas, of a cap'),
('73110099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nádoby tlak.ost.ze železa,oceli na plyn stlačený,zkapal.1 000 l a víc,ne:bezešvé', 'Containers of iron or steel, seamless, for compressed or liquefied gas, of a cap'),
('73121020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lanka,lana,kabely splétané,z nerez.oceli,ne:elektricky izolované', 'Stranded wire, ropes and cables, of stainless steel (excl. electrically insulate'),
('73121041', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lanka,lana,kabely splétané ost.,do 3mm,potaž.mosazí,ne:el.izolované,nerez.ocel', 'Stranded wire, ropes and cables, of iron or steel other than stainless steel, wi'),
('73121049', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lanka,lana,kabely splétané ost.,do 3mm,ne:el.izolované,nerez.ocel,potaž.mosazí', 'Stranded wire, ropes and cables, of iron or steel other than stainless steel, wi'),
('73121061', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lanka splétaná ost.,nad 3mm,nepotažená,ne:el.izolovaná,nerez.ocel', 'Stranded wire, of iron or steel other than stainless, uncoated, with a maximum c'),
('73121065', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lanka splétaná ost.,nad 3mm,pozink.,ne:el.izolovaná,nerez.ocel', 'Stranded wire, of iron or steel other than stainless, with a maximum cross-secti'),
('73121069', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lanka splétaná ost.,nad 3mm,potaž.ost.,ne:el.izolovaná,nerez.ocel,pozink.', 'Stranded wire, of iron or steel other than stainless, with a maximum cross-secti'),
('73121081', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lana,kabely splétané ost.,3-12mm,nepotaž.či pozink.,ne:el.izolované,nerez.ocel', 'Ropes and cables, incl. locked-coil ropes, of iron or steel other than stainless'),
('73121083', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lana,kabely splétané ost.,12-24mm,nepotaž.či pozink.,ne:el.izolované,nerez.ocel', 'Ropes and cables, incl. locked-coil ropes, of iron or steel other than stainless'),
('73121085', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lana,kabely splétané ost.,24-48mm,nepotaž.či pozink.,ne:el.izolované,nerez.ocel', 'Ropes and cables, incl. locked-coil ropes, of iron or steel other than stainless'),
('73121089', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lana,kabely splétané ost.,nad 48mm,nepotaž.či pozink.,ne:el.izolované,nerez.ocel', 'Ropes and cables, incl. locked-coil ropes, of iron or steel other than stainless'),
('73121098', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lana,kabely splétané ost.,nad 3mm,povrch.upravené,ne:el.izolované,nerez.ocel,pozink.', 'Ropes and cables, incl. locked-coil ropes, of iron or steel other than stainless'),
('73129000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pásy splétané,smyčky apod.ze železa,oceli,ne:el.izolované', 'Plaited bands, slings and the like, of iron or steel (excl. electrically insulat'),
('73130000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Drát ostnatý,kroucený a podobně železný,ocelový na ploty', 'Barbed wire of iron or steel; twisted hoop or single flat wire, barbed or not, a'),
('73141200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pásy tkané nekonečné z oceli nerezavějící pro stroje', 'Endless bands of stainless steel wire, for machinery'),
('73141400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky tkané ostatní z oceli nerezavějící,ne:pásy nekonečné', 'Woven cloth, incl. endless bands, of stainless steel wire (excl. woven products'),
('73141900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky tkané ze železa,oceli ostatní,ne:viz sazebník', 'Woven cloth, incl. endless bands, of iron or steel wire (excl. stainless and wov'),
('73142010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pletiva,rošty,sítě svařované,drát 3mm a víc,oka 100 cm2 a víc z vroubk.drátu', 'Grill, netting and fencing, welded at the intersection, having a mesh size of >='),
('73142090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pletiva,rošty,sítě svařované,drát 3mm a víc,oka 100 cm2 a víc,ne:vroubk.drát', 'Grill, netting and fencing, welded at the intersection, having a mesh size of >='),
('73143100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pletiva,rošty sítě svařované z drátu ze železa,oceli pozinkované,ne:sazebník', 'Grill, netting and fencing, of iron or steel wire, welded at the intersection, p'),
('73143900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pletiva,rošty,sítě svařované z drátu ze železa,oceli ost.,ne:viz sazebník', 'Grill, netting and fencing, of iron or steel wire, welded at the intersection (e'),
('73144110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pletiva,rošty apod.z drátu ze železa pozink.,hexagonální zesítění,ne:sazebník', 'Hexagonal netting, of iron or steel wire, not welded at the intersection, plated'),
('73144190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pletiva,rošty apod.z drátu ze železa pozink.ostatní,ne:viz sazebník', 'Grill, netting and fencing, of iron or steel wire, not welded at the intersectio'),
('73144210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pletiva,rošty apod.z drátu ze železa plastov.,hexagonální zesítění,ne:svařované', 'Hexagonal netting, of iron or steel wire, not welded at the intersection, coated'),
('73144290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pletiva,rošty apod.z drátu ze železa plastov.,ne:hexagonální zesítění,svařované', 'Grill, netting and fencing, of iron or steel wire, not welded at the intersectio'),
('73144900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pletiva,rošty apod.z drátu ze železa,oceli ostatní,ne:viz sazebník', 'Grill, netting and fencing, of iron or steel wire, not welded at the intersectio'),
('73145000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mřížovina plechová ze železa,oceli', 'Expanded metal, of iron or steel'),
('73151110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Řetězy kloubové válečkové ze železa,oceli pro jízdní kola,motocykly', 'Roller chain of iron or steel, of a kind used for cycles and motorcycles'),
('73151190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Řetězy kloubové válečkové ze železa,oceli ostatní,ne:pro jízdní kola,motocykly', 'Roller chain of iron or steel (excl. roller chain of a kind used for cycles and'),
('73151200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Řetězy,řetízky kloubové ze železa,oceli,ne:válečkové', 'Articulated link chain of iron or steel (excl. roller chain)'),
('73151900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části a součásti řetězů,řetízků kloubových ze železa,oceli', 'Parts of articulated link chain, of iron or steel'),
('73152000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Řetězy protismykové ze železa,oceli', 'Skid chain for motor vehicles, of iron or steel'),
('73158100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Řetězy,řetízky článkové s můstkem ze železa,oceli', 'Stud-link of iron or steel'),
('73158210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Řetězy,řetízky s články svařovanými ze železa,oceli,příčný řez do 16mm', 'Welded link chain of iron or steel, the constituent material of which has a maxi'),
('73158290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Řetězy,řetízky s články svařovanými ze železa,oceli,příčný řez nad 16mm', 'Chains of iron or steel, welded at the intersection, the constituent material of'),
('73158900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Řetězy,řetízky ostatní ze železa,oceli,ne:články svařované', 'Chain of iron or steel (excl. articulated link chain, skid chain, stud-link chai'),
('73159000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti řetězů,řetízků ostatních ze železa,oceli,ne:kloubových řetězů', 'Parts of skid chain, stud-link chain and other chains of heading 7315 (excl. art'),
('73160000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kotvy,kotvice,jejich části,součásti ze železa,oceli', 'Anchors, grapnels and parts thereof, of iron or steel'),
('73170010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Připínáčky ze železa,oceli', 'Drawing pins of iron or steel'),
('73170020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hřebíky lisované z drátu za studena v pruzích,svitcích ze železa,oceli', 'Nails of iron or steel wire, in strips or coils'),
('73170040', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hřebíky lisované z drátu za studena ze železa,oceli tvrzené,0,5% a víc C', 'Nails of steel wire containing by weight >= 0,5% of carbon, hardened (excl. nail'),
('73170061', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hřebíky,cvočky,sponky,svorky,apod.lisov.z drátu za studena pozinkované', 'Nails, tacks, corrugated nails, staples and similar articles, of iron or steel w'),
('73170069', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hřebíky,cvočky,sponky,svorky apod.ost.lisované z drátu za studena,ne:sazebník', 'Nails, tacks, corrugated nails, staples and similar articles, of iron or steel w'),
('73170090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hřebíky,cvočky,sponky,svorky apod.ostatní,ne:lisované z drátu za studena', 'Nails, tacks, corrugated nails, staples and similar articles, of iron or steel ('),
('73181100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vrtule do pražců se závity ze železa,oceli', 'Coach screws of iron or steel'),
('73181210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vruty do dřeva z oceli nerezavějící,ne:vrtule do pražců', 'Wood screws of stainless steel (excl. coach screws)'),
('73181290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vruty do dřeva ze železa,oceli,ne:nerezavějící,vrtule do pražců', 'Wood screws of iron or steel other than stainless (excl. coach screws)'),
('73181300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šrouby s hákem,s okem ze železa,oceli', 'Screw hooks and screw rings, of iron or steel'),
('73181410', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šrouby závitořezné z oceli nerezavějící', 'Self-tapping screws, of iron or steel other than stainless (excl. wook screws)'),
('73181491', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šrouby závitořezné s prostorovým závitem ze železa,oceli,ne:nerezavějící', 'Spaced-thread screws of iron or steel other than stainless'),
('73181499', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šrouby závitořezné ze železa,oceli,ne:nerezavějící,s prostorovým závitem', 'Self-tapping screws of iron or steel other than stainless (excl. spaced-thread s'),
('73181510', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šrouby ze železa,oceli,dřík do 6mm,soustružené z tyčí,prutů,profilů,drátů', 'Screws of iron or steel, turned from bars, rods, profiles, or wire, of solid sec'),
('73181520', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šrouby ze železa,oceli k upevňování konstrukčních materiálů železničních tratí', 'Screws and bolts, of iron or steel "whether or not with their nuts and washers",'),
('73181530', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šrouby bezhlavé z oceli nerezavějící', 'Screws and bolts, of stainless steel "whether or not with their nuts and washers'),
('73181541', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šrouby bezhlavé ze železa,oceli,pevnost tahu 800 MPa a víc,ne:nerezavějící', 'Screws and bolts, of iron or steel other than stainless "whether or not with the'),
('73181549', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šrouby bezhlavé ze železa,oceli,pevnost tahu 800 MPa a víc,ne:nerezavějící', 'Screws and bolts, of iron or steel other than stainless "whether or not with the'),
('73181551', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šrouby s hlavou se zářezem a příčným vybráním nerezavějící', 'Slotted and cross-recessed screws and bolts, of stainless steel "whether or not'),
('73181559', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šrouby s hlavou se zářezem a příčným vybráním ze železa,oceli,ne:nerezavějící', 'Slotted and cross-recessed screws and bolts, of iron or steel other than stainle'),
('73181561', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šrouby s hlavou šestihrannou z oceli nerezavějící', 'Hexagon socket head screws and bolts, of stainless steel "whether or not with th'),
('73181569', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šrouby s hlavou šestihrannou ze železa,oceli,ne:nerezavějící', 'Hexagon socket head screws and bolts, of iron or steel other than stainless "whe'),
('73181570', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šrouby šestihranné z oceli nerezavějící', 'Hexagon screws and bolts, of stainless steel "whether or not with their nuts and'),
('73181581', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šrouby šestihranné ze železa,oceli,pevnost tahu pod 800 MPa,ne:nerezavějící', 'Hexagon screws and bolts, of iron or steel other than stainless "whether or not'),
('73181589', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šrouby šestihranné ze železa,oceli,pevnost tahu 800 MPa a víc,ne:nerezavějící', 'Hexagon screws and bolts, of iron or steel other than stainless "whether or not'),
('73181590', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šrouby ostatní ze železa,oceli,ne:viz sazebník', 'Screws and bolts, of iron or steel "whether or not with their nuts and washers",'),
('73181610', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Matice ze železa,oceli,otvor pod 6mm,soustružené z tyčí,prutů,profilů,drátů', 'Nuts of iron or steel, turned from bars, rods, profiles, or wire, of solid secti'),
('73181630', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Matice z oceli nerezavějící', 'Nuts of stainless steel (excl. nuts turned from bars, rods, profiles, or wire, o'),
('73181650', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Matice samosvorné ze železa,oceli,ne:nerezavějící', 'Self-locking nuts of iron or steel other than stainless (excl. such articles tur'),
('73181691', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Matice ze železa,oceli,vnitřní průměr do 12mm', 'Nuts of iron or steel other than stainless, with an inside diameter of <= 12 mm'),
('73181699', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Matice ze železa,oceli,vnitřní průměr nad 12mm', 'Nuts of iron or steel other than stainless, with an inside diameter of > 12 mm ('),
('73181900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky se závity ostatní ze železa,oceli,ne:šrouby,matice', 'Threaded articles, of iron or steel, n.e.s.'),
('73182100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Podložky pružné a jiné pojistné podložky ze železa,oceli', 'Spring washers and other lock washers, of iron or steel'),
('73182200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Podložky ostatní ze železa,oceli,ne:pružné a jiné pojistné', 'Washers of iron or steel (excl. spring washers and other lock washers)'),
('73182300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nýty ze železa,oceli,ne:duté,s rozštěpeným dříkem', 'Rivets of iron or steel (excl. tubular and bifurcated rivets for particular uses'),
('73182400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Závlačky,klíny příčné ze železa,oceli', 'Cotters and cotter pins, of iron or steel'),
('73182900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky bez závitů ost.ze železa,oceli,ne:nýty,podložky,závlačky,příčné klíny', 'Non-threaded articles, of iron or steel'),
('73192000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Špendlíky zavírací ze železa,oceli', 'Safety pins of iron or steel'),
('73193000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Špendlíky ostatní ze železa,oceli,ne:zavírací', 'Pins of iron or steel, n.e.s.'),
('73199010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jehly šicí,látací,vyšívací,ze železa,oceli,ne:strojní', 'Sewing, darning or embroidery needles, for use in the hand, of iron or steel'),
('73199090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jehlice pletací a jiné,pro práce ruční,ze železa,oceli', 'Knitting needles, bodkins, crochet hooks, embroidery stilettos and similar artic'),
('73201011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pružiny listové,listy ze železa,oceli,zpracované za tepla', 'Laminated leaf-springs and leaves therefor, of iron or steel'),
('73201019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pružiny listové,listy ze železa,oceli,ostatní,ne:viz sazebník', 'Leaf-springs and leaves therefor, of iron or steel, hot-worked (excl. laminated)'),
('73201090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pružiny listové,listy ze železa,oceli ostatní,ne:zpracované za tepla', 'Leaf-springs and leaves therefor, of iron or steel (excl. hot-worked)'),
('73202020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pružiny šroubové (spirálové) ze železa,oceli zpracované za tepla', 'Helical springs, of iron or steel, hot-worked (excl. flat spiral springs, clock'),
('73202081', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pružiny spirálové tlačné ze železa,oceli,ne:zpracované za tepla', 'Coil compression springs, of iron or steel'),
('73202085', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pružiny spirálové tažné ze železa,oceli,ne:zpracované za tepla', 'Coil tension springs, of iron or steel'),
('73202089', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pružiny spirálové ostatní ze železa,oceli,ne:zpracované za tepla,tahové,tlakové', 'Helical springs, of iron or steel (excl. hot-worked, coil compression and coil t'),
('73209010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pružiny ploché spirálové ze železa,oceli', 'Flat spiral springs, of iron or steel'),
('73209030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pružiny diskové ze železa,oceli', 'Discs springs, of iron or steel'),
('73209090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pružiny ze železa,oceli ostatní,ne:spirálové,diskové,ploché spirálové', 'Springs and leaves for springs, of iron or steel (excl. discs springs, flat spir'),
('73211110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení na vaření,ohřev talířů na plyn s topeništěm ze železa,oceli', 'Appliances for baking, frying, grilling and cooking with oven, incl. separate ov'),
('73211190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení na vaření,ohřev talířů na plyn ost.ze železa,oceli,ne:topeniště', 'Appliances for baking, frying, grilling and cooking and plate warmers, for domes'),
('73211200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení na vaření,ohřev talířů na paliva kapalná ze železa,oceli', 'Appliances for baking, frying, grilling and cooking and plate warmers, for domes'),
('73211900', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení na vaření,ohřev talířů,ze železa,oceli,ostatní,vč.na pevná paliva', 'Appliances for baking, frying, grilling and cooking and plate warmers, for domes'),
('73218110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení na topení pro domácnost na plyn s výfukem ze železa,oceli', 'Stoves, heaters, grates, fires, wash boilers, braziers and similar appliances, o'),
('73218190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení na topení pro domácnost na plyn bez výfuku ze železa,oceli', 'Stoves, heaters, grates, fires, wash boilers, braziers and similar appliances, o'),
('73218210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení na topení pro domácnost na paliva kapalná s výfukem ze železa,oceli', 'Stoves, heaters, grates, fires, wash boilers, braziers and similar appliances, o'),
('73218290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení na topení pro domácnost na paliva kapalná bez výfuku ze železa,oceli', 'Stoves, heaters, grates, fires, wash boilers, braziers and similar appliances, o'),
('73218900', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kotle,krby,kamna apod.pro dom.,ze železa,oceli,ostatní,vč.na pevná paliva', 'Stoves, heaters, grates, fires, wash boilers, braziers and similar domestic appl'),
('73219000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti zařízení varných,topných apod.pro domácnost ze železa,oceli', 'Parts of domestic appliances non-electrically heated of heading 7321, n.e.s.'),
('73221100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Radiátory ústřed.topení neelektrické,jejich části,součásti z litiny', 'Radiators for central heating, non-electrically heated, and parts thereof, of ir'),
('73221900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Radiátory ústřed.topení neelektrické,části,součásti ze železa,oceli,ne:z litiny', 'Radiators for central heating, non-electrically heated, and parts thereof, of ir'),
('73229000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ohřívače,rozváděče vzduchu neelektrické ze železa,oceli ostatní', 'Air heaters and hot-air distributors, incl. distributors which can also distribu'),
('73231000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlna železná,ocelová,drátěnky na nádobí,drátkovací polštářky,rukavice ze železa', 'Iron or steel wool; pot scourers and scouring or polishing pads, gloves and the'),
('73239100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky stolní,kuchyňské apod.pro domácnost z litiny nesmaltované', 'Table, kitchen or other household articles, and parts thereof, of cast iron, not'),
('73239200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky stolní,kuchyňské apod.pro domácnost z litiny smaltované', 'Table, kitchen or other household articles, and parts thereof, of cast iron, ena'),
('73239310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky pro stolování pro domácnost z oceli nerezavějící', 'Household articles for table use, of stainless steel (excl. cans, boxes and simi'),
('73239390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky kuchyňské apod.pro domácnost z oceli nerezavějící,ne:pro stolování', 'Kitchen or other household articles, and parts thereof, of stainless steel (excl'),
('73239410', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky pro stolování pro domácnost ze železa,oceli smaltované,ne:litina,nerez', 'Articles for table use, of iron other than cast iron or steel other than stainle'),
('73239490', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky kuchyňské apod.pro domácnost ze železa,oceli smaltované,ne:nerez,pro stolování', 'Kitchen or other household articles, and parts thereof, of iron other than cast'),
('73239910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky pro stolování pro domácnost ze železa,oceli nesmaltované,ne:nerez', 'Articles for table use, of iron other than cast iron or steel other than stainle'),
('73239991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky kuchyňské apod.pro domácnost ze železa,oceli ost,ne:lakov.,barv.,nerez', 'Kitchen or other household articles, and parts thereof, of iron other than cast'),
('73239999', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky kuchyňské apod.pro domácnost ze železa,oceli ost,ne:lakov.,barv.,nerez', 'Table, kitchen or other household articles and parts thereof, of iron other than'),
('73241000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výlevky,umyvadla,dřezy z nerez.oceli', 'Sinks and washbasins, of stainless steel'),
('73242100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vany z litiny i smaltované', 'Baths of cast iron, whether or not enamelled'),
('73242900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vany ze železa,oceli ostatní,ne:litinové', 'Baths of steel sheet'),
('73249000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky sanitární a jejich části,součásti ze železa,oceli', 'Sanitary ware, incl. parts thereof (excl. cans, boxes and similar containers of'),
('73251050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Poklopy padací,tělesa ventilů lité z litiny nekujné', 'Surface and valve boxes, of non-malleable cast iron'),
('73251092', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky pro splaškové,vodní apod.systémy lité z nekujné litiny', 'Articles of non-malleable cast iron, for sewage, water, etc., systems (excl. sur'),
('73251099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ostatní lité z litiny nekujné,ne:viz sazebník', 'Articles of non-malleable cast iron, n.e.s. (excl. surface and valve boxes and a'),
('73259100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Koule mlecí apod.pro drtiče,mlýny lité ze železa,oceli,ne:nekujné litiny', 'Grinding balls and similar articles for mills, cast (excl. such articles of non-'),
('73259910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky lité z litiny kujné', 'Articles of malleable cast iron, n.e.s. (excl. grinding balls and similar articl'),
('73259990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky lité ostatní ze železa,oceli,ne:viz sazebník', 'Articles of iron or steel, cast, n.e.s. (excl. of malleable or non-malleable cas'),
('73261100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Koule mlecí apod.pro drtiče,mlýny kované,ražené ze železa,oceli', 'Grinding balls and similar articles for mills, of iron or steel, forged or stamp'),
('73261910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky kované v otevřené zápustce ze železa,oceli dále neupravené', 'Articles of iron or steel, open-die forged, but not further worked, n.e.s. (excl'),
('73261990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ost.kované,ražené ze železa,oceli,ne:mlecí koule,výr.kované v zápustce', 'Articles of iron or steel, closed-die forged or stamped, but not further worked,'),
('73262030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Klece malé,voliéry z drátu železného,ocelového', 'Small cages and aviaries, of iron or steel wire'),
('73262050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Koše drátěné z drátu železného,ocelového', 'Baskets of iron or steel wire'),
('73262080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ostatní z drátu železného,ocelového,ne:klece,koše', 'Articles of iron or steel wire, n.e.s. (excl. small cages and aviaries, and bask'),
('73269010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tabatěrky,pudřenky,pouzdra na kosmetiku apod.kapesní předměty ze železa,oceli', 'Snuffboxes, cigarette cases, cosmetic and powder boxes and cases, and similar po'),
('73269030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Žebříky,schody ze železa,oceli', 'Ladders and steps, of iron or steel'),
('73269040', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Palety apod.plošiny pro manipulaci se zbožím ze železa,oceli', 'Pallets and similar platforms for handling goods, of iron or steel'),
('73269050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bubny,cívky na kabely,hadice apod.ze železa,oceli', 'Reels for cables, piping and the like, of iron or steel'),
('73269060', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Větráky,žlaby,háky apod.pro stavebmí účely ze železa,oceli', 'Ventilators, non-mechanical, guttering, hooks and like articles used in the buil'),
('73269070', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Koše apod.k filtrování vody do odpadu z plechu železného,ocelového', 'Perforated buckets and similar articles of steel sheet, used to filter water at'),
('73269091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky kované v otevřené zápustce ze železa,oceli upravené', 'Articles of iron or steel, open-die forged, n.e.s.'),
('73269093', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky kované v uzavřené zápustce ze železa,oceli', 'Articles of iron or steel, closed-die forged, n.e.s.'),
('73269095', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ostatní ze železa,oceli sintrované', 'Sintered articles of iron or steel, n.e.s.'),
('73269098', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní výrobky ze železa nebo oceli', 'Articles of iron or steel, n.e.s.'),
('74010000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kamínek měděný (lech);měď cementová (měď srážená)', 'Copper mattes; cement copper "precipitated copper"'),
('74020000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Měď nerafinovaná,anody měděné pro elektrolytickou rafinaci', 'Copper, unrefined; copper anodes for electrolytic refining'),
('74031100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Katody,části katod z mědi rafinované', 'Copper, refined, in the form of cathodes and sections of cathodes'),
('74031200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Předlitky pro válcování drátu z mědi rafinované', 'Copper, refined, in the form of wire-bars'),
('74031300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Předvalky (sochory) z mědi rafinované', 'Copper, refined, in the form of billets'),
('74031900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Měď rafinovaná ostatní netvářená,ne:katody,předlitky,předvalky', 'Copper, refined, unwrought (excl. copper in the form of billets, wire-bars, cath'),
('74032100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slitiny na bázi měď-zinek (mosaz),netvářené', 'Copper-zinc base alloys "brass" unwrought'),
('74032200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slitiny na bázi měď-cín (bronz),netvářené', 'Copper-tin base alloys "bronze" unwrought'),
('74032900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slitiny mědi ostatní,ne:viz sazebník', 'Copper alloys unwrought (excl. copper-zinc base alloys "brass", copper-zinc base'),
('74040010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,šrot z mědi rafinované', 'Waste and scrap, of refined copper (excl. ingots or other similar unwrought shap'),
('74040091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,šrot ze slitin měď-zinek (mosazi)', 'Waste and scrap, of copper-zinc base alloys "brass" (excl. ingots or other simil'),
('74040099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,šrot ze slitin mědi ostatních,ne:měď-zinek (mosaz)', 'Waste and scrap, of copper alloys (excl. of copper-zinc alloys, ingots or other'),
('74050000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Předslitiny mědi', 'Master alloys of copper (excl. phosphorus-copper compounds "copper phosphide" co'),
('74061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prášek měděný s nelamelární strukturou', 'Copper powders, of non-lamellar structure (excl. grains of copper)'),
('74062000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prášek měděný s lamelární strukturou,šupiny (vločky)', 'Copper powders, of lamellar structure, and flakes of copper (excl. grains of cop'),
('74071000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty,profily z mědi rafinované', 'Bars, rods and profiles, of refined copper, n.e.s.'),
('74072110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ze slitin měď-zinek (mosaz)', 'Bars and rods, of copper-zinc base alloys "brass", n.e.s.'),
('74072190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Profily ze slitin měď-zinek (mosaz)', 'Profiles of copper-zinc base alloys "brass", n.e.s.'),
('74072910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty,profily ze slitin Cu-Ni (kupronikl),Cu-Ni-Zn (alpaka,niklová mosaz)', 'Bars, rods and profiles of copper-nickel base alloys "cupro-nickel" or copper-ni'),
('74072990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty,profily ze slitin mědi ostatních,ne:viz sazebník', 'Bars, rods and profiles of copper alloys, n.e.s. (excl. such articles of copper-'),
('74081100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Drát z mědi rafinované,průměr nad 6mm', 'Wire of refined copper, with a maximum cross-sectional dimension of > 6 mm'),
('74081910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Drát z mědi rafinované nad 0,5-6mm', 'Wire of refined copper, with a maximum cross-sectional dimension of > 0,5 mm but'),
('74081990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Drát z mědi rafinované do 0,5mm', 'Wire of refined copper, with a maximum cross-sectional dimension of <= 0,5 mm'),
('74082100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Drát ze slitin měď-zinek (mosaz)', 'Wire of copper-zinc base alloys "brass"'),
('74082200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Drát ze slitin Cu-Ni (kupronikl),Cu-Ni-Zn (alpaka,niklová mosaz)', 'Wire of copper-nickel alloys "cupro-nickel" or copper-nickel-zinc alloys "nickel'),
('74082900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Drát ze slitin mědi ostatních,ne:viz sazebník', 'Wire of copper alloys (other than copper-zinc alloys [brass], copper-nickel allo'),
('74091100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,plechy,pásy z mědi rafinované,svitky,síla nad 0,15mm', 'Plates, sheets and strip, of refined copper, in coils, of a thickness of > 0,15'),
('74091900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,plechy,pásy z mědi rafinované,(ne svitek),síla nad 0,15mm', 'Plates, sheets and strip, of refined copper, not in coils, of a thickness of > 0'),
('74092100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,plechy,pásy ve svitku ze slitin na bázi Cu-Zn (mosaz),síla nad 0,15mm', 'Plates, sheets and strip, of copper-zinc base alloys "brass", of a thickness of'),
('74092900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,plechy,pásy (ne svitek) ze slitin na bázi Cu-Zn (mosaz),síla nad 0,15mm', 'Plates, sheets and strip, of copper-zinc base alloys "brass", of a thickness of'),
('74093100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,plechy,pásy ve svitku ze slitin na bázi Cu-Sn (bronz),síla nad 0,15mm', 'Plates, sheets and strip, of copper-tin base alloys "bronze", of a thickness of'),
('74093900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,plechy,pásy (ne svitek) ze na bázi slitin Cu-Sn (bronz),síla nad 0,15mm', 'Plates, sheets and strip, of copper-tin base alloys "bronze", of a thickness of'),
('74094010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,plechy,pásy ze slitin na bázi Cu-Ni (kupronikl),síla nad 0,15mm', 'Plates, sheets and strip, of copper-nickel alloys "cupro-nickel", having a thick'),
('74094090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,plechy,pásy ze slitin na bázi Cu-Ni-Zn,síla nad 0,15mm', 'Plates, sheets and strip, of copper-nickel-zinc alloys "nickel silver", having a'),
('74099000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,plechy apod.,tl.nad 0,15mm z ostatních slitin mědi;ne:viz sazeb', 'Plates, sheets and strip, of copper alloys, of a thickness of > 0,15 mm (excl. c'),
('74101100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fólie z mědi rafinované bez podložky,síla do 0,15mm', 'Refined copper foil, not backed, of a thickness of <= 0,15 mm (excl. stamping fo'),
('74101200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fólie ze slitin mědi bez podložky,síla do 0,15mm', 'Copper alloy foil, not backed, of a thickness of <= 0,15 mm (excl. stamping foil'),
('74102100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fólie z mědi rafinované na podložce,síla bez podložky do 0,15mm', 'Refined copper foil, backed, of a thickness "excl. any backing" of <= 0,15 mm (e'),
('74102200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fólie ze slitin mědi na podložce,síla bez podložky do 0,15mm', 'Copper alloy foil, backed, of a thickness "excl. any backing" of <= 0,15 mm (exc'),
('74111011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,trubky rovné z mědi rafinované,síla stěny nad 0,6mm', 'Tubes and pipes of refined copper, straight, of a wall thickness of > 0,6 mm'),
('74111019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,trubky rovné z mědi rafinované,síla stěny do 0,6mm', 'Tubes and pipes of refined copper, straight, of a wall thickness of <= 0,6 mm'),
('74111090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,trubky ostatní z mědi rafinované,ne:rovné', 'Tubes and pipes of refined copper, in coils or otherwise bent'),
('74112110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,trubky rovné ze slitin na bázi měď-zinek', 'Tubes and pipes of copper-zinc base alloys "brass", straight'),
('74112190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,trubky ostatní ze slitin na bázi měď-zinek,ne:rovné', 'Tubes and pipes of copper-zinc base alloys "brass", in coils or otherwise bent'),
('74112200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,trubky ze slitin na bázi Cu-Ni-Zn (alpaka) nebo Cu-Ni (kupronikl)', 'Tubes and pipes of copper-nickel base alloys "cupro-nickel" or copper-nickel-zin'),
('74112900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,trubky ze slitin mědi ostatní;ne:viz sazebník', 'Tubes and pipes of copper alloys (excl. copper-zinc base alloys "brass", copper-'),
('74121000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příslušenství z mědi rafinované pro trouby,trubky', 'Refined copper tube or pipe fittings "e.g., couplings, elbows, sleeves"'),
('74122000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příslušenství ze slitin mědi pro trouby,trubky', 'Copper alloy tube or pipe fittings "e.g., couplings, elbows, sleeves"'),
('74130020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lanka,lana,kabely apod.z rafinované mědi splétané,ne:el.izolované', 'Stranded wire, cables, plaited bands and the like, of refined copper (excl. elec'),
('74130080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lanka,lana,kabely apod.ze slitin mědi splétané,ne:el.izolované', 'Stranded wire, cables, plaited bands and the like, of copper alloys (excl. elect'),
('74151000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hřebíky,cvočky,napínáčky,skoby apod.z mědi', 'Nails, tacks, drawing pins, staples and similar articles, of copper or with shaf'),
('74152100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Podložky včetně pružných z mědi', 'Washers, "incl. spring washers and spring lock washers", of copper'),
('74152900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ostatní bez závitu z mědi', 'Rivets, cotters, cotter pins and the like, not threaded, of copper (excl. spring'),
('74153300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vruty a šrouby,svorníky (maticové šrouby) a matice z mědi', 'Screws, bolts, nuts and similar articles, threaded, of copper (other than screw'),
('74153900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ostatní se závitem z mědi,ne:šrouby,matice,svorníky,vruty', 'Screw hooks, screw rings and the like, threaded, of copper (excl. standard screw'),
('74181100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Drátěnky na nádobí,drátkovací polštářky,rukavice apod.z mědi', 'Pot scourers and scouring or polishing pads, gloves and the like, of copper (exc'),
('74181910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje na vaření,topení pro domácnosti,z mědi,ne:elektrické', 'Cooking or heating apparatus of a kind used for domestic purposes, non-electric,'),
('74181990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky stolní,kuchyňské a jiné pro domácnost,části,součásti,z mědi,ne:viz sazebník', 'Table, kitchen or other household articles, parts thereof, of copper (excl. pot'),
('74182000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky sanitární (hygienické),části,součásti z mědi', 'Sanitary ware and parts thereof, of copper (excl. cooking and heating appliances'),
('74191000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Řetězy,řetízky,části,součásti z mědi', 'Chain and parts thereof, of copper (excl. watch chains, necklace chains and the'),
('74199100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z mědi lité,tvarované,ražené,kované dále neopracované', 'Articles of copper, cast, moulded, stamped or forged, but not further worked, n.'),
('74199910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Látky (i nekoneč.pásy),mřížovina,síťovina,z drátu měděného,tl.<=6mm,mřížovina plechová', 'Cloth "incl. endless bands", grill and netting, of copper wire of which the larg'),
('74199930', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pružiny měděné', 'Copper springs (excl. clock and watch springs, spring washers and other lock was'),
('74199990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z mědi ostatní,ne:viz sazebník', 'Articles of copper, n.e.s.'),
('75011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kamínek niklový (lech)', 'Nickel mattes'),
('75012000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky oxidu niklelnatého slinuté,jiné meziprodukty metalurgie niklu', 'Nickel oxide sinters and other intermediate products of nickel metallurgy (excl.'),
('75021000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nikl nelegovaný', 'Nickel, not alloyed, unwrought'),
('75022000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slitiny niklu', 'Unwrought nickel alloys'),
('75030010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,šrot z niklu nelegovaného', 'Waste and scrap, of non-alloy nickel (excl. ingots or other similar unwrought sh'),
('75030090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,šrot ze slitin niklu', 'Waste and scrap, of nickel alloys (excl. ingots or other similar unwrought shape'),
('75040000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prášek,šupiny (vločky) niklové', 'Powders and flakes, of nickel (excl. nickel oxide sinters)'),
('75051100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty,profily z niklu nelegovaného', 'Bars, rods, profiles and wire, of non-alloy nickel, n.e.s. (excl. electrically i'),
('75051200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty,profily ze slitin niklu', 'Bars, rods, profiles and wire, of nickel alloys, n.e.s. (excl. electrically insu'),
('75052100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dráty z niklu nelegovaného', 'Wire of non-alloy nickel (excl. electrically insulated products)'),
('75052200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dráty ze slitin niklu', 'Wire of nickel alloys (excl. electrically insulated products)'),
('75061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,plechy,pásy,fólie z niklu nelegovaného', 'Plates, sheets, strip and foil, of non-alloy nickel (excl. expanded plates, shee'),
('75062000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,plechy,pásy,fólie ze slitin niklu', 'Plates, sheets, strip and foil, of nickel alloys (excl. expanded plates, sheets'),
('75071100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,trubky z niklu nelegovaného', 'Tubes and pipes of non-alloy nickel'),
('75071200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,trubky ze slitin niklu', 'Tubes and pipes of nickel alloys'),
('75072000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příslušenství z niklu pro trouby,trubky', 'Tube or pipe fittings, of nickel'),
('75081000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tkaniny,mřížky,síťoviny z drátu niklového', 'Cloth, grill, netting and fencing, of nickel wire'),
('75089000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ostatní z niklu,ne:viz sazebník', 'Articles of nickel, n.e.s.'),
('76011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hliník nelegovaný', 'Aluminium, not alloyed, unwrought'),
('76012010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slitiny hliníku primární', 'Unwrought primary aluminium alloys'),
('76012091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slitiny hliníku sekundární v ingotech nebo v kapalném stavu', 'Unwrought secondary aluminium alloys, in ingots or in liquid state'),
('76012099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slitiny hliníku sekundární ostatní,ne:ingot,kapalný stav', 'Unwrought secondary aluminium alloys (excl. in ingots or in liquid state)'),
('76020011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad hliníkový ze soustružení,vystřihování apod.,z plechů do 0,2mm', 'Turnings, shavings, chips, milling waste, sawdust and filings, of aluminium; was'),
('76020019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad hliníkový ostatní vč.průmyslového odpadu,ne:viz sazebník', 'Waste of aluminium, incl. faulty workpieces and workpieces which have become unu'),
('76020090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šrot hliníkový', 'Scrap of aluminium (excl. slags, scale and the like from iron and steel producti'),
('76031000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prášek hliníkový nelamelární struktury', 'Powders of aluminium, of non-lamellar structure (excl. pellets of aluminium)'),
('76032000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prášek hliníkový lamelární struktury,šupiny', 'Powders of aluminium, of lamellar structure, and flakes of aluminium (excl. pell'),
('76041010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty z hliníku nelegovaného', 'Bars, rods and profiles, of non-alloy aluminium'),
('76041090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Profily z hliníku nelegovaného', 'Profiles of non-alloy aluminium, n.e.s.'),
('76042100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Profily duté ze slitin hliníku', 'Hollow profiles of aluminium alloys, n.e.s.'),
('76042910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty ze slitin hliníku', 'Bars and rods of aluminium alloys'),
('76042990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Profily ze slitin hliníku,ne:duté', 'Solid profiles, of aluminium alloys, n.e.s.'),
('76051100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dráty z hliníku nelegovaného,průměr nad 7mm', 'Wire of non-alloy aluminium, with a maximum cross-sectional dimension of > 7 mm'),
('76051900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dráty z nelegovaného hliníku,průměr do 7mm', 'Wire of non-alloy aluminium, with a maximum cross-sectional dimension of <= 7 mm'),
('76052100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dráty ze slitin hliníku nad 7mm', 'Wire of aluminium alloys, with a maximum cross-sectional dimension of > 7 mm (ex'),
('76052900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dráty ze slitin hliníku,průměr do 7mm', 'Wire, of aluminium alloys, having a maximum cross-sectional dimension of <= 7 mm'),
('76061110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,plechy,pásy pravoúhlé z hliníku nelegovaného barvené apod.,nad 0,2mm', 'Plates, sheets and strip, of non-alloy aluminium, of a thickness of > 0,2 mm, sq'),
('76061191', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,plechy,pásy z hliníku nelegovaného,nad 0,2-pod 3mm pravoúhlé', 'Plates, sheets and strip, of non-alloy aluminium, of a thickness of > 0,2 mm but'),
('76061193', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,plechy,pásy z hliníku nelegovaného,3-pod 6mm pravoúhlé', 'Plates, sheets and strip, of non-alloy aluminium, of a thickness of >= 3 mm but'),
('76061199', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,plechy,pásy z hliníku nelegovaného,síla 6mm a víc,pravoúhlé', 'Plates, sheets and strip, of non-alloy aluminium, of a thickness of >= 6 mm, squ'),
('76061210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pásy pro žaluzie ze slitin hliníku nad 0,2mm', 'Strip of aluminium alloys, for venetian blinds'),
('76061250', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,plechy,pásy ze slitin hliníku barvené apod.,nad 0,2mm pravoúhlé', 'Plates, sheets and strip, of aluminium alloys, of a thickness of > 0,2 mm, squar'),
('76061291', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,plechy,pásy ze slitin hliníku,nad 0,2-pod 3mm pravoúhlé', 'Plates, sheets and strip, of aluminium alloys, of a thickness of > 0,2 mm but <'),
('76061293', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,plechy,pásy ze slitin hliníku,3-pod 6mm pravoúhlé', 'Plates, sheets and strip, of aluminium alloys, of a thickness of >= 3 mm but < 6'),
('76061299', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,plechy,pásy ze slitin hliníku,šíře 6mm a víc pravoúhlé', 'Plates, sheets and strip, of aluminium alloys, of a thickness of >= 6 mm, square'),
('76069100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,plechy,pásy z hliníku nelegovaného ost.,nad 0,2mm,ne:pravoúhlé', 'Plates, sheets and strip, of non-alloy aluminium, of a thickness of > 0,2 mm (ot'),
('76069200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,plechy,pásy ze slitin hliníku ost.,nad 0,2 mm,ne:pravoúhlé', 'Plates, sheets and strip, of aluminium alloys, of a thickness of > 0,2 mm (other'),
('76071111', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fólie hliníkové bez podložky,tloušťka <0,021mm,hmotnost <=10kg,válcované dále neupravené', 'Aluminium foil, not backed, rolled but not further worked, of a thickness of <Â '),
('76071119', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fólie hliníkové bez podložky,tloušťka <0,021mm,hmotnost >10kg,válcované dále neupravené', 'Aluminium foil, not backed, rolled but not further worked, of a thickness of < 0'),
('76071190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fólie hliníkové bez podložky,tloušťka >=0,021, <=0,2mm,válcované dále neupravené', 'Aluminium foil, not backed, rolled but not further worked, of a thickness of >='),
('76071910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fólie hliníkové bez podložky,tloušťka <0,021mm ost.,ne:válcované dále neupravené', 'Aluminium foil, not backed, rolled and further worked, of a thickness of <= 0,02'),
('76071991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fólie hliníkové bez podložky,tloušťka >=0,021, <=0,2mm ost.,samolepicí,ne:válcované dále neupravené', 'Aluminium foil, not backed, rolled and worked, of a thickness of >= 0,021 mm but'),
('76071999', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fólie hliníkové bez podložky,tloušťka >=0,021, <=0,2mm ost.,ne:samolepicí,válcované dále neupravené', 'Aluminium foil, not backed, rolled and worked, of a thickness (excl. any backing'),
('76072010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fólie hliníkové s podložkou,tloušťka <0,021mm měřeno bez podložky', 'Aluminium foil, backed, of a thickness "excl. any backing" of < 0,021 mm (excl.'),
('76072091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fólie hliníkové s podložkou,tloušťka >=0,021, <=0,2mm měřeno bez podložky,samolepicí', 'Aluminium foil, backed, rolled and worked, of a thickness (excl. any backing) of'),
('76072099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fólie hliníkové s podložkou,tloušťka >=0,021, <=0,2mm měřeno bez podložky ost.,ne:samolepicí', 'Aluminium foil, backed, of a thickness (excl. any backing) of >= 0,021 mm but <='),
('76081000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,trubky z hliníku nelegovaného', 'Tubes and pipes of non-alloy aluminium (excl. hollow profiles)'),
('76082020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,trubky ze slitin hliníku svařované', 'Tubes and pipes of aluminium alloys, welded (excl. hollow profiles)'),
('76082081', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,trubky ze slitin hliníku,po protlačování dále neoprac.,ne:svařované', 'Tubes and pipes of aluminium alloys, not further worked than extruded (excl. hol'),
('76082089', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,trubky ze slitin hliníku ost.,ne:svařované,po protlačování dále neoprac.', 'Tubes and pipes of aluminium alloys (excl. such products welded or not further w'),
('76090000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příslušenství z hliníku pro trouby,trubky', 'Aluminium tube or pipe fittings "e.g., couplings, elbows, sleeves"'),
('76101000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Dveře,okna,jejich rámy,zárubně,prahy dveřní z hliníku', 'Doors, windows and their frames and thresholds for door, of aluminium (excl. doo'),
('76109010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mosty a jejich části,věže,stožáry z hliníku', 'Bridges and bridge-sections, towers and lattice masts, of aluminium'),
('76109090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Konstrukce ostatní z hliníku,ne:viz sazebník', 'Structures and parts of structures, of aluminium, n.e.s., and plates, rods, prof'),
('76110000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nádrže,cisterny,kádě a podobné zásobníky z hliníku,obsah nad 300 l', 'Reservoirs, tanks, vats and similar containers, of aluminium, for any material ('),
('76121000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zásobníky stlačitelné válcovité (trubkovité) z hliníku do 300 l', 'Collapsible tubular containers, of aluminium'),
('76129010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zásobníky pevné válcovité z hliníku do 300 l', 'Rigid tubular containers, of aluminium'),
('76129020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zásobníky používané pro aerosoly', 'Containers of a kind used for aerosols, of aluminium'),
('76129091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sudy,barely,plechovky apod.zásobníky z hliníku,obsah 50-300 l', 'Casks, drums, cans, boxes and similar containers, of aluminium, for any material'),
('76129098', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plechovky,krabice apod.obaly z hliníku,obsah pod 50 l', 'Casks, drums, cans, boxes and similar containers, of aluminium, for any material'),
('76130000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nádoby hliníkové na plyn stlačený,zkapalněný', 'Aluminium containers for compressed or liquefied gas'),
('76141000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lanka,lana,kabely apod.z hliníku s ocelovým jádrem,ne:elektricky izolované', 'Stranded wire, cables, plaited bands and the like, of aluminium, with steel core'),
('76149000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lanka,lana,kabely apod.z hliníku ost.,ne:elektricky izolované,s ocel.jádrem', 'Stranded wires, cables, ropes and similar articles, of aluminium (other than wit'),
('76151100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Drátěnky na nádobí,drátkovací,čistící polštářky,rukavice apod.z hliníku', 'Pot scourers and scouring or polishing pads, gloves and the like, of aluminium ('),
('76151910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky stolní,kuchyňské apod.pro domácnost z hliníku odlévané', 'Table, kitchen or other household articles, parts thereof, of aluminium, cast (e'),
('76151990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky stolní,kuchyňské apod.pro domácnost z hliníku ostatní,ne:odlévané', 'Table, kitchen or other household articles, parts thereof, of aluminium, uncast'),
('76152000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky sanitární (hygienické),jejich části z hliníku', 'Sanitary ware and parts thereof, of aluminium (excl. cans, boxes and similar con'),
('76161000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hřebíky,napínáčky,skoby,šrouby,háky,matice,nýty apod.z hliníku', 'Nails, tacks, staples, screws, bolts, nuts, screw hooks, rivets, cotters, cotter'),
('76169100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tkaniny,mřížkoviny,síťoviny,pletiva z hliníkového drátu', 'Cloth, grill, netting and fencing, of aluminium wire (excl. cloth of metal fibre'),
('76169910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z hliníku ostatní odlévané,ne:viz sazebník', 'Articles of aluminium, cast, n.e.s.'),
('76169990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z hliníku ostatní,ne:viz sazebník', 'Articles of aluminium, uncast, n.e.s.'),
('78011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olovo rafinované', 'Unwrought lead, refined'),
('78019100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olovo surové (neopracované) s obsahem antimonu-hmotn.převaž.nad každým prvkem', 'Unwrought lead, containing by weight antimony as the principal other element'),
('78019910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olovo surové k rafinaci,0,2% a víc stříbra', 'Unwrought lead, containing by weight >= 0,02% of silver, for refining "bullion l'),
('78019991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slitiny olova', 'Unwrought lead alloys (excl. lead containing by weight antimony as the principal'),
('78019999', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Olovo surové ostatní,ne:viz sazebník', 'Unwrought lead (excl. lead containing by weight antimony as the principal other'),
('78020000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,šrot olověný ostatní,ne:z akumulátorů', 'Lead waste and scrap (excl. ashes and residues from lead production "heading No'),
('78041100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plechy,pásy,folie olověné,síla do 0,2mm', 'Lead sheets, strip and foil, of a thickness "excl. any backing" of <= 0,2 mm'),
('78041900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,plechy,pásy,fólie olověné,síla nad 0,2mm', 'Lead plates; lead sheets, strip and foil, of a thickness "excl. any backing" of'),
('78042000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prášek,šupiny (vločky) olověné', 'Lead powders and flakes (excl. grains of lead, and spangles of heading 8308)'),
('78060010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kontejnery na materiál radioaktivní s olověnou ochrannou vrstvou', 'Containers with an anti-radiation lead covering, for the transport or storage of'),
('78060030', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty,profily,dráty z olova', 'Lead bars, rods, profiles and wire, n.e.s.'),
('78060050', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,trubky,příslušenství olověné', 'Lead tubes, pipes and tube or pipe fittings "e.g., couplings, elbows, sleeves"'),
('78060090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z olova ostatní,ne:viz sazebník', 'Articles of lead, n.e.s.'),
('79011100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zinek surový nelegovaný,obsah 99,99% a víc zinku', 'Unwrought zinc, not alloyed, containing by weight >= 99,99% of zinc'),
('79011210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zinek surový nelegovaný,obsah 99,95-pod 99,99% zinku', 'Unwrought zinc, not alloyed, containing by weight >= 99,95% but < 99,99% of zinc'),
('79011230', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zinek surový nelegovaný,obsah 98,5-pod 99,95% zinku', 'Unwrought zinc, not alloyed, containing by weight >= 98,5% but < 99,95% of zinc'),
('79011290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zinek surový nelegovaný,obsah 97,5-pod 98,5% zinku', 'Unwrought zinc, not alloyed, containing by weight >= 97,5% but < 98,95% of zinc'),
('79012000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slitiny zinku neopracované', 'Unwrought zinc alloys'),
('79020000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,šrot zinkový', 'Zinc waste and scrap (excl. ash and residues from zinc production "heading 2620"'),
('79031000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prach ze zinku', 'Zinc dust'),
('79039000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šupiny (vločky) zinkové', 'Zinc powders and flakes (excl. grains of zinc, and spangles of heading 8308, and'),
('79040000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty,profily,dráty zinkové', 'Zinc bars, rods, profiles and wire, n.e.s.'),
('79050000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,plechy,pásy,folie zinkové', 'Zinc plates, sheets, strip and foil'),
('79070010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,trubky,příslušenství zinkové', 'Zinc tubes, pipes and tube or pipe fittings "e.g., couplings, elbows, sleeves"'),
('79070090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ostatní zinkové,ne:viz sazebník', 'Articles of zinc, n.e.s.'),
('80011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cín nelegovaný neopracovaný', 'Unwrought tin, not alloyed'),
('80012000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slitiny cínu neopracované', 'Unwrought tin alloys'),
('80020000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,šrot cínový', 'Tin waste and scrap (excl. ash and residues from the manufacture of tin of headi'),
('80030000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty,profily,dráty cínové', 'Tin bars, rods, profiles and wire, n.e.s.'),
('80070010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,plechy,pásy cínové,tl.>0,2mm', 'Tin plates, sheets and strip, of a thickness of > 0,2 mm'),
('80070030', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fólie cínové,tl.<=0,2mm (též potištěné,podložené),cínový prášek,vločky', 'Tin foil of a thickness "without any backing" <= 0,2 mm, whether or not printed'),
('80070050', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,trubky,příslušenství cínové', 'Tin tubes, pipes and tube or pipe fittings "e.g., couplings, elbows, sleeves"'),
('80070090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ostatní z cínu,ne:viz sazebník', 'Articles of tin, n.e.s.'),
('81011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prášek wolframový', 'Tungsten powders'),
('81019400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Wolfram surový (netvářený),vč.tyčí,prutů získaných prostým slinováním', 'Unwrought tungsten, incl. bars and rods of tungsten obtained simply by sintering'),
('81019600', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dráty z wolframu', 'Tungsten wire'),
('81019700', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,šrot z wolframu', 'Tungsten waste and scrap (excl. ash and residues containing tungsten)'),
('81019910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty,profily,desky,plechy,pásy,fólie z wolframu,ne:tyče,pruty slinované', 'Tungsten bars and rods (other than those obtained simply by sintering), profiles'),
('81019990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ostatní z wolframu,ne:viz sazebník', 'Articles of tungsten, n.e.s.'),
('81021000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prášek molybdenový', 'Molybdenum powders'),
('81029400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Molybden surový (netvářený), vč.tyčí, prutů získaných prostým slinováním', 'Unwrought molybdenum, incl. bars and rods obtained simply by sintering'),
('81029500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče a pruty,profily,desky,plechy,pásy z molybdenu', 'Molybdenum bars and rods (other than those obtained simply by sintering), profil'),
('81029600', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Drát z molybdenu', 'Molybdenum wire'),
('81029700', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad, šrot z molybdenu', 'Molybdenum waste and scrap (excl. ash and residues containing molybdenum)'),
('81029900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ostatní z molybdenu,ne:viz sazebník', 'Articles of molybdenum, n.e.s.'),
('81032000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tantal surový (netvářený),vč.tyčí,prutů získaných prostým slinováním', 'Unwrought tantalum, incl. bars and rods of tantalum obtained simply by sintering'),
('81033000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,šrot z tantalu', 'Tantalum waste and scrap (excl. ash and residues containing tantalum)'),
('81039010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty,profily,dráty,desky,plechy,pásy,folie tantalové,ne:tyče,pruty slinované', 'Tantalum bars and rods (other than those obtained simply by sintering), profiles'),
('81039090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ostatní z tantalu,ne:viz sazebník', 'Articles of tantalum, n.e.s.'),
('81041100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hořčík surový (neopracovaný),obsah  99,8% a víc hořčíku', 'Unwrought magnesium, containing >= 99,8% by weight of magnesium'),
('81041900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hořčík surový (neopracovaný),obsah pod 99,8% hořčíku', 'Unwrought magnesium, containing < 99,8% by weight of magnesium'),
('81042000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,šrot z hořčíku', 'Magnesium waste and scrap (excl. ash and residues containing magnesium, and rasp'),
('81043000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Třísky,granule tříděné podle velikosti,prášek z hořčíku', 'Magnesium raspings, turnings and granules, graded according to size; magnesium p'),
('81049000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ostatní z hořčíku,ne:viz sazebník', 'Articles of magnesium, n.e.s.'),
('81052000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lech kobaltový a ost.meziprodukty metalurgie kobaltu,kobalt surový,prášek', 'Cobalt mattes and other intermediate products of cobalt metallurgy; unwrought co'),
('81053000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,šrot z kobaltu', 'Cobalt waste and scrap (excl. ash and residues containing cobalt)'),
('81059000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z kobaltu ostatní,ne:viz sazebník', 'Articles of cobalt, n.e.s.'),
('81060010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vizmut surový,odpad,šrot,prášek', 'Unwrought bismuth; bismuth powders; bismuth waste and scrap (excl. ash and resid'),
('81060090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z vizmutu,ne:vizmut surový,odpad,šrot,prášek', 'Articles of bismuth, n.e.s.'),
('81072000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kadmium surové (netvářené),prášek', 'Unwrought cadmium; cadmium powders'),
('81073000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,šrot z kadmia', 'Cadmium waste and scrap (excl. ashes and residues containing cadmium)'),
('81079000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z kadmia,ne:kadmium surové,prášek,odpad,šrot', 'Articles of cadmium, n.e.s.'),
('81082000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Titan surový (netvářený),prášek', 'Unwrought titanium; titanium powders'),
('81083000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,šrot z titanu', 'Titanium waste and scrap (excl. ash and residues containing titanium)'),
('81089030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,pruty,profily,dráty z titanu', 'Titanium bars, rods, profiles and wire, n.e.s.'),
('81089050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,plechy,pásy,fólie z titanu', 'Titanium plates, sheets, strip and foil'),
('81089060', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Trouby,trubky z titanu', 'Tubes and pipes, of titanium'),
('81089090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ostatní z titanu,ne:viz sazebník', 'Articles of titanium, n.e.s.'),
('81092000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zirkonium surové (netvářené),prášek', 'Unwrought zirconium; zirconium powders'),
('81093000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,šrot ze zirkonia', 'Zirconium waste and scrap (excl. ash and residues containing zirconium)'),
('81099000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ze zirkonia ostatní,ne:prášek,odpad,šrot', 'Articles of zirconium, n.e.s.'),
('81101000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Antimon surový (netvářený),prášek', 'Unwrought antimony; antimony powders'),
('81102000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,šrot z antimonu', 'Antimony waste and scrap (excl. ash and residues containing antimony)'),
('81109000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z antimonu,ne:prášek,odpad,šrot', 'Articles of antimony, n.e.s.'),
('81110011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mangan surový (neopracovaný),prášek', 'Unwrought manganese; manganese powders'),
('81110019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,šrot manganový', 'Manganese waste and scrap (excl. ash and residues containing manganese)'),
('81110090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z manganu,ne:prášek,odpad,šrot', 'Articles of manganese, n.e.s.'),
('81121200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Berrylium surové (netvářené),prášek', 'Unwrought beryllium; beryllium powders'),
('81121300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,šrot z berrylia', 'Beryllium waste and scrap (excl. ashes and residues containing beryllium)'),
('81121900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z beryllia,ne:prášek,odpad,šrot', 'Articles of beryllium, n.e.s.'),
('81122110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slitiny chromu surové (netvářené),prášek ostatní,ne:obsah niklu nad 10%', 'Chromium alloys containing > 10% by weight of nickel, unwrought; powders of thes'),
('81122190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slitiny chromu surové (netvářené),prášek,obsah niklu nad 10%', 'Unwrought chromium; chromium powders (excl. chromium alloys containing > 10% by'),
('81122200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,šrot z chromu', 'Chromium waste and scrap (excl. ash and residues containing chromium and chromiu'),
('81122900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z chromu,ne:slitiny nad 10% nikl,prášek,odpad,šrot', 'Articles of chromium, n.e.s.'),
('81125100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Thalium surové (netvářené),prášek', 'Unwrought thallium; thallium powders'),
('81125200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,šrot z thalia', 'Thallium waste and scrap (excl. ashes and residues containing thallium)'),
('81125900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z thalia ostatní,ne:prášek,odpad,šrot', 'Articles of thallium, n.e.s.'),
('81129210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hafnium (celtium) surové (netvářené),odpad,šrot,prášek', 'Unwrought hafnium "celtium"; hafnium powders; hafnium waste and scrap (excl. ash'),
('81129221', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Niob (columbium),rhenium,gallium,indium,vanad,germanium,odpad,šrot', 'Niobium "columbium", rhenium, gallium, indium, vanadium and germanium waste and'),
('81129231', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Niob (columbium),rhenium surové,prášek,ne:odpad,šrot', 'Unwrought niobium "columbium" and rhenium; niobium "columbium" or rhenium powder'),
('81129281', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Indium surové (netvářené),prášek,ne:odpad,šrot', 'Unwrought indium; indium powders'),
('81129289', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Galium surové (netvářené),prášek,ne:odpad,šrot', 'Unwrought gallium; gallium powders'),
('81129291', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vanad surový (netvářený),prášek,ne:odpad,šrot', 'Unwrought vanadium; vanadium powders (excl. ash and residues containing vanadium'),
('81129295', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Germanium surové (neopracované),prášek,ne:odpad,šrot', 'Unwrought germanium; germanium powders'),
('81129920', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z hafnia (celtium),germania,ne:surové,prášek,odpad,šrot', 'Articles of hafnium "celtium" and germanium, n.e.s.'),
('81129930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z niobu (columbium),rhenia,ne:surové,prášek,odpad,šrot', 'Articles of niobium "columbium" or rhenium, n.e.s.'),
('81129970', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z gallia,india,vanadu,ne:surové,prášek,odpad,šrot', 'Articles of gallium, indium and vanadium, n.e.s.'),
('81130020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cermety surové (neopracované)', 'Unwrought cermets'),
('81130040', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,šrot z cermetů', 'Waste and scrap of cermets (excl. ashes and residues containing cermets)'),
('81130090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky z cermetu,ne:odpad,šrot', 'Articles of cermets, n.e.s.'),
('82011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Rýče,lopaty', 'Spades and shovels, with working parts of base metal'),
('82012000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vidle', 'Forks, incl. pitchforks, with working parts of base metal'),
('82013000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krumpáče,škrabky,motyky,hrábě', 'Mattocks, picks, hoes and rakes, with working parts of base metal (excl. ice axe'),
('82014000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sekery,sekáčky na větve,žabky zahradnické a podobné nástroje sekací,mačety', 'Axes, billhooks and similar hewing tools, with working parts of base metal (excl'),
('82015000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Nůžky zahradnické ovládané jednou rukou (i nůžky na drůbež)', 'Secateurs and similar one-handed pruners and shears, incl. poultry shears, with'),
('82016000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nůžky zahradnické,na stříhání keřů a podobně ovládané oběma rukama', 'Hedge shears, two-handed pruning shears and similar two-handed shears, with work'),
('82019000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje ruční ostatní pro zemědělství,zahradnictví,lesnictví,ne:viz sazebník', 'Scythes, sickles, hay knives, timber wedges and other hand tools of a kind used'),
('82021000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pily ruční', 'Handsaws, with working parts of base metal (excl. power-operated saws)'),
('82022000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Listy pilové', 'Bandsaw blades of base metal'),
('82023100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Listy do pil kotoučových se vsazenými zuby,pracovní část ocelová', 'Circular saw blades, incl. slitting or slotting saw blades, of base metal, with'),
('82023900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Listy do pil kotoučových se vsazenými zuby ost.,ne:pracovní část ocelová', 'Circular saw blades, incl. slitting or slotting saw blades, and parts thereof, o'),
('82024000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Listy do pil řetězových', 'Chainsaw blades of base metal'),
('82029100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Listy rovné řezací pro řezání kovů', 'Straight saw blades, of base metal, for working metal'),
('82029911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Listy řezací ostatní,pracovní část ocelová,ne:rovné,na kov', 'Saw blades, incl. toothless saw blades, of base metal, with working parts of ste'),
('82029919', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Listy řezací ostatní,pracovní část ocelová,ne:rovné,na kov', 'Saw blades, incl. toothless saw blades, of base metal, with working parts of ste'),
('82029990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Listy řezací ostatní,ne:pracovní část ocelová,rovné na kov,do kotoučových pil', 'Saw blades, incl. toothless saw blades, of base metal, with working parts of mat'),
('82031000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pilníky,rašple a podobné nástroje', 'Files, rasps and similar hand tools of base metal'),
('82032010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pinzety,kleštičky depilační', 'Tweezers for non-medical use, of base metal'),
('82032090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kleště všech druhů,ne:pinzety,kleštičky depilační', 'Pliers, incl. cutting pliers, pincers and similar hand tools of base metal (excl'),
('82033000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nůžky na plech a podobné nástroje', 'Metal-cutting shears and similar hand tools, of base metal'),
('82034000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Řezače trub,čepů,děrovače,průbojníky a podobné nástroje', 'Pipe-cutters, bolt croppers, perforating punches and similar hand tools, of base'),
('82041100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Klíče ruční šroubové,napínací nenastavitelné', 'Hand-operated spanners and wrenches, incl. torque meter wrenches, of base metal,'),
('82041200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Klíče ruční šroubové,napínací nastavitelné', 'Hand-operated spanners and wrenches, incl. torque meter wrenches, of base metal,'),
('82042000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástavce klíčové výměnné i s rukojetí', 'Interchangeable spanner sockets, with or without handles, of base metal'),
('82051000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje ruční na vrtání,řezání vnějších,vnitřních závitů', 'Hand-operated drilling, threading or tapping hand tools'),
('82052000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kladiva,palice', 'Hammers and sledge hammers with working parts of base metal'),
('82053000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hoblíky,dláta i žlábková (dutá) a podobně k opracovávání dřeva', 'Planes, chisels, gouges and similar cutting tools for working wood'),
('82054000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šroubováky', 'Hand-operated screwdrivers'),
('82055100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje ruční používané v domácnosti', 'Household hand tools, non-mechanical, with working parts of base metal, n.e.s.'),
('82055910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nářadí ruční pro zedníky,formíře,cementáře,štukatéry,malíře', 'Hand tools for masons, moulders, cement workers, plasterers and painters, of bas'),
('82055930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pistole nýtovací,nastřelovací a podobné pracující s výbušnou nábojnicí', 'Cartridge-operated riveting, wallplugging, etc., hand tools'),
('82055990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Diamanty sklenářské zasazené,nástroje ruční ostatní,ne:viz sazebník', 'Hand tools, incl. glaziers'' diamonds, of base metal, n.e.s.'),
('82056000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lampy pájecí', 'Blowlamps and the like (excl. gas-powered blowlamps)'),
('82057000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Svěráky,upínáky a podobné nástroje', 'Vices, clamps and the like (excl. accessories for and parts of machine tools)'),
('82058000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kovadliny,výhně přenosné,kotouče brusné ruční nebo s pedály s konstrukcí', 'Anvils; portable forges; hand-operated or pedal-operated grinding wheels with fr'),
('82059000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Soubory dvou a více nástrojů ručních čísla 8205', 'Sets of two or more tools of the subheading of heading 8205'),
('82060000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Soubory nástrojů (pily,pilníky,klíče,kladiva,ruční nástroje) čísel 8202-8205', 'Sets of two or more tools of heading 8202 to 8205, put up in sets for retail sal'),
('82071300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje na vrtání pro zemní práce s pracovní částí z cermetů,karbidů kovů', 'Rock-drilling or earth-boring tools, interchangeable, with working parts of sint'),
('82071910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje na zemní vrtání,sondy,pracovní část z diamantu i aglomerovaného', 'Rock-drilling or earth-boring tools, interchangeable, with working parts of diam'),
('82071990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje na vrtání pro zemní práce s prac.částí ost.,ne:cermet,karbid,diamant', 'Rock-drilling or earth-boring tools, interchangeable, with working parts of mate'),
('82072010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zápustky na tažení,vytlačování kovů,pracovní část z diamantu i aglomerovaného', 'Interchangeable dies for drawing or extruding metal, with working parts of diamo'),
('82072090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zápustky na tažení,vytlačování kovů,pracovní část z ost.mater.,ne:diamant', 'Interchangeable dies for drawing or extruding metal, with working parts of mater'),
('82073010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje na lisování,ražení,děrování kovů', 'Interchangeable tools for pressing, stamping or punching, for working metal'),
('82073090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje na lisování,ražení,děrování ostatních materiálů,ne:kovů', 'Interchangeable tools for pressing, stamping or punching, for working materials'),
('82074010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje na řezání vnitřních závitů-pro obrábění kovů', 'Tools for tapping metal, interchangeable'),
('82074030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje na řezání vnějších závitů-pro obrábění kovů', 'Tools for threading metal, interchangeable'),
('82074090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje na řezání vnějších,vnitřních závitů ostatních materiálů,ne:kovů', 'Tools for tapping or threading materials other than metal, interchangeable'),
('82075010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje na vrtání,pracovní část z diamantu i aglomerovaného,ne:pro zemní práce', 'Tools for drilling, interchangeable, with working parts of diamond or agglomerat'),
('82075030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vrtáky do zdiva,ne:pracovní část z diamantu', 'Interchangeable masonry drills, with working parts of materials other than diamo'),
('82075050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje na vrtání na kovy,pracovní část z cermetů,karbidů kovů', 'Tools for drilling metal, interchangeable, with working parts of sintered metal'),
('82075060', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje na vrtání na kovy,pracovní část z oceli rychlořezné', 'Tools for drilling, interchangeable, for working metal, with working parts of hi'),
('82075070', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje na vrtání na kovy,pracovní část ostatní,ne:viz sazebník', 'Tools for drilling metal, interchangeable, with working parts of materials other'),
('82075090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje na vrtání ostatních materiálů,ne:zemní práce,kovů', 'Tools for drilling, interchangeable, for working materials other than metal, wit'),
('82076010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje na vyvrtávání,protahování,pracovní část z diamantu i aglomerovaného', 'Interchangeable tools for boring or broaching, with working parts of diamond or'),
('82076030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje na vyvrtávání kovů,pracovní část z jiných materiálů,ne:diamantu', 'Interchangeable tools for boring or drilling metal'),
('82076050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje na vyvrtávání materiálů ostatních,prac.část z mater.ost.,ne:viz sazebník', 'Interchangeable tools for boring materials other than metal, with working parts'),
('82076070', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje na protahování kovů z materiálů ostatních,ne:z diamantu', 'Interchangeable tools for broaching metal'),
('82076090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje na protahování materiálů ostatních,prac.část z mater.ost.,ne:viz sazebník', 'Interchangeable tools for broaching materials other than metal, with working par'),
('82077010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje na frézování kovů,pracovní část z cermetů,karbidů kovů', 'Interchangeable tools for milling metal, with working parts of sintered metal ca'),
('82077031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje na frézování kovů se stopkou,prac.část z ost.mater.,ne:karbid,cermet', 'Interchangeable shank type tools for milling metal, with working parts of materi'),
('82077035', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Válcové frézy pro obrábění kovů,pracovní část z ost.mater.,ne:cermet,karbid', 'Hobs, interchangeable, for working metal, with working part of materials other t'),
('82077038', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje na frézování kovů ostatní,pracovní část z ost.mater.,ne:viz sazebník', 'Tools for milling, interchangeable, for working metal, with working part of mate'),
('82077090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje na frézování materiálů ostatních,ne:kovů', 'Interchangeable tools for milling materials other than metal'),
('82078011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje na soustružení pro obrábění kovů,prac.část mater.ost.z cermetů,ne:karbid', 'Tools, interchangeable, for turning metal, with working parts of sintered metal'),
('82078019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje na soustružení pro obrábění kovů,prac.část mater.ost.,ne:cermet,karbid', 'Tools for turning, interchangeable, for working metal, with working part of mate'),
('82078090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje na soustružení materialů ostatních,ne:kovů', 'Interchangeable tools for turning materials other than metal'),
('82079010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje výměnné ostatní,pracovní část z diamantu i aglomerovaného,ne:viz sazebník', 'Interchangeable tools for hand tools, whether or not power-operated, or for mach'),
('82079030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šroubováky výměnné,ne:pracovní část z diamantu', 'Screwdriver bits of base metal'),
('82079050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje výměnné na řezání ozubení,ne:pracovní část z diamantu', 'Interchangeable gear-cutting tools (excl. milling tools for gear-cutting)'),
('82079071', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje výměnné ost.na obrábění kovů,prac.část z cermetů,karbidů kovů,ne:viz sazebník', 'Interchangeable tools for hand tools, whether or not power-operated, or for mach'),
('82079078', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje výměnné ost.na obrábění mater.ost.z cermetů,karbidů kovů,ne:viz sazebník', 'Tools, interchangeable, for use in mechanical or non-mechanical hand-held applia'),
('82079091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje výměnné ostatní na obrábění mater.ost.,ne:viz sazebník', 'Tools, interchangeable, for use in mechanical or non-mechanical hand-held applia'),
('82079099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje výměnné ostatní na obrábění mater.ost.,ne:viz sazebník', 'Tools, interchangeable, for use in mechanical or non-mechanical hand-held applia'),
('82081000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nože,destičky břitové pro stroje,mech.zařízení pro opracování kovů', 'Knives and cutting blades, of base metal, for machines or for mechanical applian'),
('82082000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nože,destičky břitové pro stroje,mech.zařízení pro opracování dřeva', 'Knives and cutting blades, of base metal, for machines or for mechanical applian'),
('82083010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nože kotoučové (kráječe kruhové) pro přístroje kuchyňské,potravinářské', 'Circular knives of base metal, for kitchen appliances or for machines used by th'),
('82083090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nože ostatní pro přístroje kuchyňské,potravinářské,ne:kotoučové (kruhové)', 'Knives and cutting blades, of base metal, for kitchen appliances or for machines'),
('82084000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nože,destičky břitové výměnné pro stroje zemědělské,zahradnické,lesnické', 'Knives and cutting blades, of base metal, for agricultural, horticultural or for'),
('82089000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nože,destičky břitové výměnné ostatní,ne:viz sazebník', 'Knives and cutting blades, of base metal, for machines or for mechanical applian'),
('82090020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Otočné břitové destičky z cermetů,slinutých karbidů kovů', 'Inserts, indexable, for tools, unmounted, of sintered metal carbide or cermets'),
('82090080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Destičky,tyčinky,hroty apod.vyměnitelné nenamontované ostatní,ne:otočné', 'Plates, sticks, tips and the like for tools, unmounted, of sintered metal carbid'),
('82100000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mechanizované ruční zařízení pro potraviny,nápoje,hmotnost do 10 kg', 'Hand-operated mechanical devices, of base metal, weighing <= 10 kg, used in the'),
('82111000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Soubory  nožů', 'Sets of assorted articles of knives of heading 8211; sets in which there is a hi'),
('82119130', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nože jídelní,rukojeť a pevná čepel z nerezavějící oceli', 'Table knives with handle and fixed blade of stainless steel'),
('82119180', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nože jídelní,pevná čepel,ne:rukojeť a čepel z nerezavějící oceli', 'Table knives with fixed blades of base metal (not with handle and blade of stain'),
('82119200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nože s pevnou čepelí pevnou ostatní,ne:jídelní,rukojeť  čepel z nerez.oceli', 'Knives with fixed blades of base metal (excl. straw knives, machetes, knives and'),
('82119300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nože bez pevné čepele', 'Knives having other than fixed blades, incl. pruning knives, of base metal (excl'),
('82119400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Čepele nožů,ne:nástroje vyměnitelné', 'Blades of base metal for table knives, pocket knives and other knives of heading'),
('82119500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rukojeti z obecných kovů', 'Handles of base metal for table knives, pocket knives and other knives of headin'),
('82121010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Strojky holící bezpečné s pevnými čepelkami', 'Safety razors with non-replaceable blades of base metal'),
('82121090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Břitvy,strojky holící,ne:holící strojky s pevnými (nevyměnitelnými) čepelkami', 'Non-electric razors of base metal (excl. safety razors with non-replaceable blad'),
('82122000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MIL'), 'Čepelky do strojků holících,polotovary čepelek v pásech', 'Safety razor blades of base metal, incl. razor blade blanks in strips'),
('82129000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti ostatní břitev,strojků holících,ne:čepelky', 'Parts of non-electric razors of base metal (excl. safety razor blades and razor'),
('82130000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nůžky (krejčovské a podobně),čelisti nůžek', 'Scissors, tailors'' shears and similar shears, and blades therefor, of base meta'),
('82141000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nože na papír,obálky,nožíky vyškrabovací,ořezávátka na tužky vč.čepelí', 'Paperknives, letter openers, erasing knives, pencil sharpeners and blades theref'),
('82142000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Soupravy,náčiní na manikúru,pedikúru', 'Manicure or pedicure sets and instruments, incl. nail files, of base metal (excl'),
('82149000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sekáčky,sekery,strojky na vlasy a podobné zboží nožířské ostatní,ne:viz sazebník', 'Hair clippers, butchers'' or kitchen cleavers and other articles of cutlery of b'),
('82151020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Soubory příborů obsahující pouze výrobky stříbřené,zlacené,platinované', 'Sets consisting of one or more knives of heading 8211 and at least an equal numb'),
('82151030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Soubory příborů z nerez.oceli,obsah.alespoň 1 výr.stříbřený,zlacený,platinované', 'Sets consisting of one or more knives of heading 8211 and at least an equal numb'),
('82151080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Soubory příborů ostatní,obsah.min.1 výrobek stříbřený,zlacený,platin.,ne:nerez', 'Sets consisting of one or more knives of heading 8211 and at least an equal numb'),
('82152010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Soubory příborů z nerezavějící oceli', 'Sets consisting of one or more knives of heading 8211 and at least an equal numb'),
('82152090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Soubory příborů ostatní,ne:z nerezavějící oceli', 'Sets consisting of one or more knives of heading 8211 and at least an equal numb'),
('82159100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lžíce,vidličky,naběračky apod.kuchyňské,jídelní stříbřené,zlacené,platinované', 'Spoons, forks, ladles, skimmers, cake-servers, fish-knives, butter-knives, sugar'),
('82159910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lžíce,vidličky,naběračky apod.kuchyňské,jídelní z oceli nerezavějící', 'Spoons, forks, ladles, skimmers, cake-servers, fish-knives, butter-knives, sugar'),
('82159990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lžíce,vidličky,naběračky apod.kuchyňské,jídelní ostat.,ne:viz sazebník', 'Spoons, forks, ladles, skimmers, cake-servers, fish-knives, butter-knives, sugar'),
('83011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zámky visací z kovů obecných', 'Padlocks of base metal'),
('83012000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zámky do vozidel motorových z kovů obecných', 'Locks used for motor vehicles, of base metal'),
('83013000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zámky pro nábytek z kovů obecných', 'Locks used for furniture, of base metal'),
('83014011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zámky válcové do domovních dveří z obecných kovů', 'Cylinder locks of a kind used for doors of buildings, of base metal'),
('83014019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zámky do domovních dveří z obecných kovů ostatní i elektrické,ne:válcové', 'Locks of a kind used for doors of buildings, of base metal (excl. cylinder locks'),
('83014090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zámky ostatní z obecných kovů,ne:visací,pro motor.voz.,nábytek,domovní dveře', 'Locks of base metal (excl. padlocks and locks of a kind used for motor vehicles,'),
('83015000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Závěry,rámy závěrové s vestavěnými zámky z kovů obecných', 'Clasps and frames with clasps, incorporating locks, of base metal'),
('83016000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti zámků,závěrů,rámů závěrových z kovů obecných', 'Parts of padlocks, locks, clasps and frames with clasps, incorporating locks, of'),
('83017000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Klíče (samostatné) z kovů obecných', 'Keys presented separately for padlocks, locks, clasps and frames with clasps inc'),
('83021000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Závěsy z kovů obecných', 'Hinges of all kinds, of base metal'),
('83022000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kolečka rejdovací z kovů obecných', 'Castors with mountings of base metal'),
('83023000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Úchytky,kování a podobné z kovů obecných pro vozidla motorová', 'Base metal mountings, fittings and similar articles suitable for motor vehicles'),
('83024110', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Úchytky,kování a podobné výrobky z kovů obecných ke dveřím,ne:zámky s klíči,panty', 'Base metal mountings and fittings suitable for doors (excl. locks with keys and'),
('83024150', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Úchytky,kování a podobné z kovů obecných k oknům (vč.francouzských),ne:zámky s klíči,panty', 'Base metal mountings and fittings suitable for windows and French windows (excl.'),
('83024190', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Úchytky,kování a podobné z kovů obecných pro stavby,ne:viz sazebník', 'Base metal mountings and fittings suitable for buildings (excl. for doors, windo'),
('83024200', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Úchytky,kování apod.z kovů obecných pro nábytek', 'Base metal mountings, fittings and similar articles suitable for furniture (excl'),
('83024900', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Úchytky,kování apod.ost.z kovů obecných,ne:pro stavby,nábytek', 'Base metal mountings, fittings and similar articles (excl. locks with keys, clas'),
('83025000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Věšáky,háčky na šaty,klobouky,konzoly a podobně z kovů obecných', 'Hat-racks, hat-pegs, brackets and similar fixtures of base metal'),
('83026000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zařízení pro automatické zavírání dveří z obecných kovů', 'Automatic door closers of base metal'),
('83030010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Skříně pancéřové,zpevněné z kovů obecných', 'Armoured or reinforced safes and strongboxes, of base metal'),
('83030030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dveře pancéřové a podobně i se zámky bezpečnostními pro trezory z obecných kovů', 'Armoured or reinforced doors and safe deposit lockers for strongrooms, of base m'),
('83030090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pokladny příruční,kufry bezpečnostní a podobně z kovů obecných', 'Cash or deed boxes and the like, of base metal (excl. armoured or reinforced saf'),
('83040000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skříně kartoték,pořadače spisů,schránky na papíry apod.z kovů obecných', 'Filing cabinets, card-index cabinets, paper trays, paper rests, pen trays, offic'),
('83051000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mechaniky pro pořadače,rychlovazače a jiné z kovů obecných', 'Fittings for loose-leaf binders or files, of base metal (excl. drawing pins and'),
('83052000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Spony sešívací v pásech z kovů obecných', 'Staples in strips, of base metal'),
('83059000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zboží kancelářské ostatní z kovů obecných,ne:viz sazebník', 'Office articles such as letter clips, letter corners, paper clips and indexing t'),
('83061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zvony,gongy a podobné výrobky z kovů obecných', 'Bells, gongs and the like, non-electric, of base metal (excl. musical instrument'),
('83062100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sošky apod.dekorační předměty z obecných kovů pokovené drahými kovy,ne:plátované', 'Statuettes and other ornaments, of base metal, plated with precious metal (excl.'),
('83062910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sošky a podobné dekorační předměty z mědi', 'Statuettes and other ornaments, of copper, not plated with precious metal (excl.'),
('83062990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sošky a podobné dekorační předměty z kovů obecných,ne:z mědi', 'Statuettes and other ornaments, of base metal other than copper, not plated with'),
('83063000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rámečky k fotografiím,obrazům a podobné,zrcadla z kovů obecných', 'Photograph, picture or similar frames, of base metal; mirrors of base metal (exc'),
('83071000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hadice ze železa,oceli i s příslušenstvím (fitinky)', 'Flexible tubing of iron or steel, with or without fittings'),
('83079000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hadice z kovů obecných i s příslušenstvím (fitinky),ne:ze železa,oceli', 'Flexible tubing of base metal other than iron or steel, with or without fittings'),
('83081000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Svorky,háčky,očka z kovů obecných pro oděvy,obuv,brašnářské zboží apod.', 'Hooks, eyes and eyelets, of base metal, of a kind used for clothing, footwear, a'),
('83082000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nýty duté,s dříkem rozštěpeným z kovů obecných', 'Tubular or bifurcated rivets, of base metal'),
('83089000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky (kování) ost.z kovů obecných pro oděvy,obuv apod.,perly apod.,ne:viz sazebník', 'Clasps, frames with clasps without locks, buckles and buckle-clasps, of base met'),
('83091000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uzávěry korunkové z kovů obecných', 'Crown corks of base metal'),
('83099010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kapsle z olova,hliníku,průměr nad 21mm', 'Capsules of lead; capsules of aluminium of a diameter > 21 mm (excl. crown corks'),
('83099090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zátky,víka,plomby uzávěry apod. ostatní z kovů obecných,ne:korunkové,kapsle', 'Stoppers, caps and lids, incl. screw caps and pouring stoppers, capsules for bot'),
('83100000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,štíty s nápisy a podobně,číslice,písmena a jiné z obecných kovů', 'Sign-plates, nameplates, address-plates and similar plates, numbers, letters and'),
('83111010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Elektrody svařovací,jádro železo,ocel,povlak materiál žáruvzdorný', 'Welding electrodes cored with iron or steel and coated with refractory material,'),
('83111090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Elektrody povlečené pro svařování z kovů obecných ostatní,ne:jádro železo,ocel', 'Coated electrodes of base metal, for electric arc-welding (excl. those cored wit'),
('83112000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyčky,dráty a podobně plněné pro svařování elektrickým obloukem z obec.kovů', 'Cored wire of base metal, for electric arc-welding'),
('83113000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče,dráty a podobně plněné pro pájení,svařování plamenem z obecných kovů', 'Coated rods and cored wire, of base metal, for soldering, brazing or welding by'),
('83119000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky ostatní pro svařování,pájení z kovů,pro metalizaci apod.,ne:viz sazebník', 'Wire, rods, tubes, plates, electrodes and the like, of base metal or of metal ca'),
('84011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Reaktory jaderné', 'Nuclear reactors [Euratom]'),
('84012000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje pro oddělování izotopů,jejich části,součásti', 'Machinery and apparatus for isotopic separation and parts thereof, n.e.s. [Eurat'),
('84013000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GFI'), 'Články (kazety) palivové neozářené pro reaktory', 'Fuel elements "cartridges", non-irradiated, in casing with handling fixtures, fo'),
('84014000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části reaktorů jaderných,ne:stroje pro dělení izotopů,neozářené palivové články', 'Parts of nuclear reactors, n.e.s. [Euratom]'),
('84021100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kotle parní vodotrubné,výroba nad 45t páry/hod.', 'Watertube boilers with a steam production > 45 t/hour'),
('84021200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kotle parní vodotrubné,výroba do 45t páry/hod.', 'Watertube boilers with a steam production <= 45 t/hour (excl. central heating ho'),
('84021910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kotle parní ostatní včetně hybridních s trubkami ohnivzdornými,ne:vodotrubné', 'Firetube boilers (excl. central heating hot water boilers capable also of produc'),
('84021990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kotle parní ostatní včetně hybridních,ne:s trubkami ohnivzdornými,vodotrubné', 'Vapour generating boilers, incl. hybrid boilers (excl. watertube boilers, firetu'),
('84022000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kotle zvané na přehřátou vodu', 'Superheated water boilers'),
('84029000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti parních kotlů,kotlů zvaných na přehřátou vodu', 'Parts of vapour generating boilers and superheated water boilers, n.e.s.'),
('84031010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kotle k ústřednímu topení z litiny,ne:čísla 8402', 'Central heating boilers of cast iron (excl. vapour generating boilers and superh'),
('84031090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kotle k ústřednímu topení ostatní,ne:z litiny,čísla 8402', 'Central heating boilers, non-electric, of materials other than cast iron (excl.'),
('84039010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti kotlů k ústřednímu topení z litiny', 'Parts of central heating boilers of cast iron, n.e.s.'),
('84039090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části součásti kotlů k ústřednímu topení ostatní,ne:z litiny', 'Parts of central heating boilers, n.e.s.'),
('84041000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje,zařízení pomocné ke kotlům parním,ústředního topení', 'Auxiliary plant for use with boilers of heading 8402 or 8403, e.g. economizers,'),
('84042000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kondenzátory pro parní stroje', 'Condensers for steam or other vapour power units'),
('84049000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti přístrojů pomocných ke kotlům parním,ústředního topení,kondenzátorům', 'Parts of auxiliary plant of heading 8402 or 8403 and condensers for steam or oth'),
('84051000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Generátory na výr.generátorového,vodního plynu,vyvíječe acetylénu apod.', 'Producer gas or water gas generators, with or without their purifiers; acetylene'),
('84059000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti generátorů plynových,vyvíječů acetylénu', 'Parts of producer gas or water gas generators and acetylene gas generators or si'),
('84061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Turbíny parní pro pohon lodí', 'Steam and other vapour turbines for marine propulsion'),
('84068100', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Turbíny parní ostatní,výkon >40MW,ne:pro pohon lodí', 'Steam and other vapour turbines, of an output > 40 MW (excl. those for marine pr'),
('84068200', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Turbíny parní ostatní,výkon <=40MW,ne:pro pohon lodí', 'Steam and other vapour turbines, of an output <= 40 MW (excl. those for marine p'),
('84069010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lopatky statorů,rotory a jejich lopatky', 'Stator blades, rotors and their blades, of turbines'),
('84069090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti parních turbin', 'Parts of steam turbines and other vapour turbines, n.e.s. (excl. stator blades,'),
('84071000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory letecké zážehové', 'Spark-ignition reciprocating or rotary internal combustion piston engine, for ai'),
('84072110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory zážehové závěsné pro pohon lodí,obsah válců do 325cm3', 'Spark-ignition outboard motors for marine propulsion, of a cylinder capacity <='),
('84072191', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory zážehové závěsné pro pohon lodí,obsah válců nad 325cm3,výkon do 30kW', 'Spark-ignition outboard motors for marine propulsion, of a cylinder capacity > 3'),
('84072199', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory zážehové závěsné pro pohon lodí,obsah válců nad 325cm3,výkon nad 30kW', 'Spark-ignition outboard motors for marine propulsion, of a cylinder capacity > 3'),
('84072900', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory zážehové ost.pro pohon lodí,ne:závěsné', 'Spark-ignition reciprocating or rotary engines, for marine propulsion (excl. out'),
('84073100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory zážehové vratné pro motorová vozidla silniční,obsah válců do 50cm3', 'Spark-ignition reciprocating piston engine, of a kind used for the propulsion of'),
('84073210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory zážehové vratné pro motorová vozidla silniční,obsah válců nad 50-125cm3', 'Spark-ignition reciprocating piston engine, of a kind used for the propulsion of'),
('84073290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory zážehové vratné pro motorová vozidla silniční,obs.válců nad 125-250cm3', 'Spark-ignition reciprocating piston engine, of a kind used for the propulsion of'),
('84073300', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory zážehové vratné pro motorová vozidla silniční,obs.válců nad 250-1000cm3', 'Spark-ignition reciprocating piston engine, of a kind used for vehicles of chapt'),
('84073410', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory zážehové vratné k průmyslové montáži sil.vozidel,obs.válců nad 1000cm3', 'Spark ignition reciprocating piston engine of a cylinder capacity > 1.000 cm3, f'),
('84073430', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory zážehové vratné nad 1 000 cm3 použité', 'Spark-ignition reciprocating piston engine, of a kind used for vehicles of chapt'),
('84073491', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory zážehové vratné ost.,obs.válců nad 1000-1500cm3 nové,ne:k prům.montáži', 'Spark-ignition reciprocating piston engine, of a kind used for vehicles of chapt'),
('84073499', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory zážehové vratné ost.,obs.válců nad 1500cm3 nové,ne:k prům.montáži', 'Spark-ignition reciprocating piston engine, of a kind used for vehicles of chapt'),
('84079010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory zážehové rotační do 250cm3', 'Spark-ignition reciprocating or rotary internal combustion piston engine, of a c'),
('84079050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory zážehové rotační,nad 250cm3 k prům.montáži malotraktorů a silnič.vozidel', 'Spark-ignition rotary internal combustion piston engine of a cylinder capacity >'),
('84079080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory zážehové rotační,nad 250cm3,výkon do 10KW,ne:k prům.montáži', 'Spark-ignition reciprocating or rotary piston engine, of a cylinder capacity > 2'),
('84079090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory zážehové rotační,nad 250cm3,výkon nad 10KW,ne:k prům.montáži', 'Spark-ignition reciprocating or rotary piston engine, of a cylinder capacity > 2'),
('84081011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové lodní použité pro námořní lodě-typy viz sazebník', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84081019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové lodní použité pro plavidla ostatní,ne:viz sazebník', 'Compression-ignition combustion piston engine, for vessels (other than for seago'),
('84081023', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové lodní nové pro námořní lodě-typy viz sazebník,výkon do 50KW', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84081027', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové lodní nové pro plavidla ost.,výkon do 50KW,ne:viz sazebník', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84081031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové lodní nové pro nám.lodě-typy viz sazebník,výkon nad 50-100KW', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84081039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové lodní nové pro plavidla ost.,výkon nad 51-100kW,ne:viz sazebník', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84081041', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové lodní nové pro nám.lodě-typy viz sazebník,výkon nad 100-200kW', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84081049', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové lodní nové pro plavidla ost.,výkon nad 100-200kW,ne:viz sazebník', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84081051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové lodní nové pro nám.lodě-typy viz sazebník,výkon nad 200-300kW', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84081059', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové lodní nové pro plavidla ost.,výkon nad 200-300kW,ne:viz sazebník', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84081061', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové lodní nové pro plavidla ost.,výkon nad 300-500kW,ne:viz sazebník', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84081069', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové lodní nové pro plavidla ost.,výkon nad 300-500kW,ne:viz sazebník', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84081071', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové lodní nové pro nám.lodě-typy viz sazebník,výkon nad 500-1000kW', 'Compression-engine internal combustion piston engine "diesel or semi-diesel engi'),
('84081079', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové lodní nové pro plavidla ost.,výkon nad 500-1000kW,ne:viz sazebník', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84081081', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové lodní nové pro nám.lodě-typy viz sazeb.,výkon nad 1000-5000kW', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84081089', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové lodní nové pro plavidla ost.,výkon nad 1000-5000kW,ne:viz sazebník', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84081091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové lodní nové pro nám.lodě-typy viz sazebník,výkon nad 5000kW', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84081099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové lodní nové pro plavidla ost.,výkon nad 5000kW,ne:viz sazebník', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84082010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové k průmysl.mont.pro malotraktory,motor.vozidla,obsah pod2500cm3', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84082031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové pro traktory kolové zemědělské,lesnické,výkon nad 100kW', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84082035', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové pro traktory kolové zemědělské,lesnické,výkon nad 50-100kW', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84082037', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové pro traktory kolové zemědělské,lesnické,výkon nad 100kW', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84082051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové pro motorová vozidla ostatní,výkon do 50kW,ne:traktory', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84082055', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové pro motorová vozidla ostatní,výkon nad 50-100kW,ne:traktory', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84082057', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové pro motorová vozidla ostatní,výkon nad 100-200kW,ne:traktory', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84082099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové pro motorová vozidla ostatní,výkon nad 200kW,ne:traktory', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84089021', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové pro trakce kolejové', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84089027', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové ostatní použité,ne:viz sazebník', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84089041', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové nové ostatní,výkon do 15kW,ne:viz sazebník', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84089043', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové nové ostatní,výkon nad 15-30kW,ne:viz sazebník', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84089045', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové nové ostatní,výkon nad 30-50kW,ne:viz sazebník', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84089047', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové nové ostatní,výkon nad 50-100kW,ne:viz sazebník', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84089061', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové nové ostatní,výkon nad 100-200kW,ne:viz sazebník', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84089065', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové nové ostatní,výkon nad 200-300kW,ne:viz sazebník', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84089067', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové nové ostatní,výkon nad 300-500kW,ne:viz sazebník', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84089081', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové nové ostatní,výkon nad 500-1000kW,ne:viz sazebník', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84089085', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové nové ostatní,výkon nad 1000-5000kW,ne:viz sazebník', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84089089', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory vznětové nové ostatní,výkon nad 5000kW', 'Compression-ignition internal combustion piston engine "diesel or semi-diesel en'),
('84091000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti pro motory letecké', 'Parts suitable for use solely or principally with internal combustion piston eng'),
('84099100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti motorů zážehových s vnitřním spalováním', 'Parts suitable for use solely or principally with spark-ignition internal combus'),
('84099900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti motorů vznětových s vnitřním spalováním', 'Parts suitable for use solely or principally with compression-ignition internal'),
('84101100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Turbiny,kola vodni do 1000kW', 'Hydraulic turbines and water wheels, of a power <= 1.000 kW (excl. hydraulic pow'),
('84101200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vodní turbiny,vodní kola,výkon nad 1000-10000kW', 'Hydraulic turbines and water wheels, of a power > 1.000 kW but <= 10.000 kW (exc'),
('84101300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vodní turbiny,vodní kola,výkon nad 10000kW', 'Hydraulic turbines and water wheels, of a power > 10.000 kW (excl. hydraulic pow'),
('84109000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti vodních turbin,vodních kol vč.regulátorů', 'Parts of hydraulic turbines and water wheels incl. regulators'),
('84111100', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory proudové,tah do 25 kN', 'Turbojets of a thrust <= 25 kN'),
('84111210', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory proudové,tah nad 25-44 kN', 'Turbojets of a thrust > 25 kN but <= 44 kN'),
('84111230', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory proudové,tah nad 44-132 kN', 'Turbojets of a thrust > 44 kN but <= 132 kN'),
('84111280', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory proudové,tah nad 132 kN', 'Turbojets of a thrust > 132 kN'),
('84112100', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pohony turbovrtulové,výkon do 1.100 kW', 'Turbopropellers of a power <= 1.100 kW'),
('84112220', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pohony turbovrtulové,výkon nad 1.100-3.730 kW', 'Turbopropellers of a power > 1.100 kW but <= 3.730 kW'),
('84112280', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pohony turbovrtulové,výkon nad 3.730 kW', 'Turbopropellers of a power > 3.730 kW'),
('84118100', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Turbíny plynové ostatní,výkon do 5.000 kW,ne:viz sazebník', 'Gas turbines of a power <= 5.000 kW (excl. turbojets and turbopropellers)'),
('84118220', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Turbíny plynové ostatní,výkon nad 5.000-20.000 kW,ne:viz sazebník', 'Gas turbines of a power > 5.000 kW but <= 20.000 kW (excl. turbojets and turbopr'),
('84118260', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Turbíny plynové ostatní,výkon nad 20.000-50.000 kW,ne:viz sazebník', 'Gas turbines of a power > 20.000 kW but <= 50.000 kW (excl. turbojets and turbop'),
('84118280', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Turbíny plynové ostatní,výkon nad 50.000 kW,ne:viz sazebník', 'Gas turbines of a power > 50.000 kW (excl. turbojets and turbopropellers)'),
('84119100', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti motorů proudových,pohonů turbovrtulových', 'Parts of turbojets or turbopropellers, n.e.s.'),
('84119900', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti turbín plynových', 'Parts of gas turbines, n.e.s.'),
('84121000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory reaktivní,ne:proudové', 'Reaction engines other than turbojets'),
('84122120', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hydraulické systémy s lineárním pohybem (válců)', 'Hydraulic systems, linear acting "cylinders"'),
('84122180', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Motory,pohony hydraul.s lineárním pohybem (válců) ost.,ne:hydraulické systémy', 'Hydraulic power engines and motors, linear acting "cylinders" (excl. hydraulic s'),
('84122920', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hydraulické systémy ost.,ne:s lineárním pohybem (válců)', 'Hydraulic systems powered using hydraulic fluid power motors (excl. hydraulic po'),
('84122981', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Motory,pohony hydraulické kapalinové,ne:s lineárním pohybem (válců)', 'Hydraulic fluid power motors (excl. linear acting [cylinders] and hydraulic syst'),
('84122989', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Motory,pohony hydraulické ostatní,ne:viz sazebník', 'Hydraulic power engines and motors (excl. linear acting [cylinders], hydraulic s'),
('84123100', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Motory,pohony pneumatické s lineárním pohybem', 'Pneumatic power engines and motors, linear-acting, "cylinders"'),
('84123900', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Motory,pohony pneumatické ostatní,ne:s lineárním pohybem (válců)', 'Pneumatic power engines and motors (excl. linear acting)'),
('84128010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje parní poháněné vodní a jinou párou', 'Steam or other vapour power engines (excl. steam or other vapour generating boil'),
('84128080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Motory,pohony ostatní,ne:viz sazebník', 'Engines and motors, non-electrical (excl. steam turbines, internal combustion pi'),
('84129020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti motorů reaktivních,ne:proudových', 'Parts of reaction engines, n.e.s. (excl. of turbojets)'),
('84129040', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti hydraulicky poháněných motorů,pohonů', 'Parts of hydraulic power engines and motors, n.e.s.'),
('84129080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti motorů,pohonů ostatních,ne:viz sazebník', 'Parts of non-electrical engines and motors, n.e.s.'),
('84131100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čerpadla pohonných hmot,mazadel s meřícím zařízením pro čerpací stanice,garáže', 'Pumps fitted or designed to be fitted with a measuring device, for dispensing fu'),
('84131900', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čerpadla pohonných hmot,mazadel s měřícím zařízením', 'Pumps for liquids, fitted or designed to be fitted with a measuring device (excl'),
('84132000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čerpadla ruční bez meřícího zařízení', 'Hand pumps for liquids (excl. those of subheading 8413.11 and 8413.19)'),
('84133020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čerpadla pohon.hmot,mazadel,chlad.kapalin vstřikovací,pro pístové spal.motory', 'Injection pumps for internal combustion piston engine'),
('84133080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čerpadla pohon.hmot,mazadel,chlad.kapalin ost.,pro pístové spal.motory,ne:vstřikovací', 'Fuel, lubricating or cooling medium pumps for internal combustion piston engine'),
('84134000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čerpadla na beton', 'Concrete pumps'),
('84135020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jednotky hydraulické s kmitavým pohybem', 'Reciprocating positive displacement hydraulic units, with pumps'),
('84135040', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čerpadla dávkovací s kmitavým pohybem,různé typy,ne:hydraulická', 'Dosing and proportioning reciprocating positive displacement pumps, power-driven'),
('84135061', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čerpadla pístová s kmitavým pohybem,pohon hydraulický kapalinový', 'Hydraulic fluid power piston pumps (excl. hydraulic units)'),
('84135069', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čerpadla pístová s kmitavým pohybem ostatní,ne:pohon hydraulický kapalinový', 'Piston pumps, power-driven (excl. pumps of subheading 8413.11 and 8413.19, fuel,'),
('84135080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čerpadla s kmitavým pohybem ostatní,ne:viz sazebník', 'Reciprocating positive displacement pumps, power-driven (excl. pumps of subheadi'),
('84136020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jednotky hydraulické rotační', 'Rotory positive displacement hydraulic units, with pumps'),
('84136031', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čerpadla zubová,pohon hydraulický kapalinový', 'Hydraulic fluid power gear pumps (excl. hydraulic units)'),
('84136039', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čerpadla zubová ostatní,ne:pohon hydraulický kapalinový', 'Gear pumps, power-driven (excl. pumps of subheading 8413.11 and 8413.19, fuel, l'),
('84136061', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čerpadla křídlová,pohon hydraulický kapalinový', 'Hydraulic fluid power vane pumps (excl. hydraulic units)'),
('84136069', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čerpadla křídlová ostatní,ne:pohon hydraulický kapalinový', 'Vane pumps, power-driven (excl. pumps of subheading 8413.11 and 8413.19, fuel, l'),
('84136070', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čerpadla vřetenová rotační', 'Screw pumps, power-driven (excl. pumps of subheading 8413.11 and 8413.19, fuel,'),
('84136080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čerpadla rotační objemová ostatní,ne:hydraul.jednotky,zubová,křídlová,vřetenová', 'Rotary positive displacement pumps, power-driven (excl. pumps of subheading 8413'),
('84137021', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čerpadla odstředivá ponorná jednostupňová,ne:pro letadla civilní', 'Submersible pumps, single-stage'),
('84137029', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čerpadla odstředivá ponorná vícestupňová,ne:pro letadla civilní', 'Submersible pumps, multi-stage'),
('84137030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čerpadla odstředivá bezucpávková pro topné systémy a dodávku teplé vody', 'Glandless impeller pumps for heating systems and warm water supply'),
('84137035', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čerpadla odstředivá ostatní,výstupní potrubí do 15mm,ne:viz sazebník', 'Pumps, power-driven, with a discharge outlet diameter <= 15 mm (excl. pumps of s'),
('84137045', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čerpadla odstředivá ostatní,přímá,boční vtok,výstup potrubí nad 15mm,ne:viz sazebník', 'Channel impeller and side channel pumps'),
('84137051', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čerpadla odstředivá radiální průtok.jednostupňová,jednoduch.vstup-monobloky', 'Radial flow centrifugal pumps with a discharge outlet diameter > 15 mm, single-s'),
('84137059', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čerpadla odstředivá radiální průtok.jednostupňová,jednoduch.vstup:ne:monobloky', 'Radial flow centrifugal pumps with a discharge outlet diameter > 15 mm, single-s'),
('84137065', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čerpadla odstředivá radiální průtoková jednostupňová,více vstupů', 'Radial flow centrifugal pumps with a discharge outlet diameter > 15 mm, single-s'),
('84137075', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čerpadla radiální průtoková vícestupňová', 'Radial flow centrifugal pumps with a discharge outlet diameter > 15 mm, multi-st'),
('84137081', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čerpadla odstředivá ostatní jednostupňová,ne:viz sazebník', 'Single-stage centrifugal pumps, power-driven, with a discharge outlet diameter >'),
('84137089', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čerpadla odstředivá ostatní vícestupňová,ne:viz sazebník', 'Multi-stage centrifugal pumps, power-driven, with a discharge outlet diameter >'),
('84138100', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čerpadla ostatní i s měřicím zařízením,ne:viz sazebník', 'Pumps for liquids, power-driven (excl. those of subheading 8413.11 and 8413.19,'),
('84138200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zdviže na kapaliny', 'Liquid elevators (excl. pumps)'),
('84139100', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti čerpadel', 'Parts of pumps for liquids, n.e.s.'),
('84139200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti zdviží na kapaliny', 'Parts of liquid elevators, n.e.s.'),
('84141020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vývěvy pro použití při výrobě polovodičů', 'Vacuum pumps for use in semiconductor production'),
('84141025', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vývěvy molekulární,čerpadla rotační,Rootsova', 'Rotary piston vacuum pumps, sliding vane rotary pumps, molecular drag pumps and'),
('84141081', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vývěvy kryogenní,absorbční,čerpadla difusní', 'Diffusion pumps, cryopumps and adsorption pumps'),
('84141089', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vývěvy ostatní,ne:viz sazebník', 'Vacuum pumps (excl. vacuum pumps for use in semiconductor production, rotary pis'),
('84142020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pumpičky ruční pro jízdní kola', 'Handpumps for cycles'),
('84142080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čerpadla vzduchová s obsluhou ruční,nožní ostatní,ne:viz sazebník', 'Hand-operated or foot-operated air pumps (excl. handpumps for cycles)'),
('84143020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kompresory pro zařízení chladicí,výkon do 0,4kW', 'Compressors for refrigerating equipment, of a power <= 0,4 kW'),
('84143081', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kompresory pro zařízení chladicí,výkon nad 0,4kW,(polo)hermetické', 'Compressors for refrigerating equipment, of a power > 0,4 kW, hermetic or semi-h'),
('84143089', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kompresory pro zařízení chladicí ost.,výkon nad 0,4kW,ne:(polo)hermetické', 'Compressors for refrigerating equipment, of a power > 0,4 kW (excl. hermetic or'),
('84144010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kompresory vzduchové na podvozku s koly,průtok do 2 m3/min', 'Air compressors mounted on a wheeled chassis for towing, giving a flow per minut'),
('84144090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kompresory vzduchové na podvozku s koly,průtok nad 2 m3/min', 'Air compressors mounted on a wheeled chassis for towing, giving a flow per minut'),
('84145100', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Ventilátory stolní,nástěnné apod.,elektrické do 125 W', 'Table, floor, wall, window, ceiling or roof fans, with a self-contained electric'),
('84145920', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Ventilátory axiální', 'Axial fans (excl. table, floor, wall, window, ceiling or roof fans, with a self-'),
('84145940', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Ventilátory odstředivé', 'Centrifugal fans (excl. table, floor, wall, window, ceiling or roof fans, with a'),
('84145980', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Ventilátory ostatní,ne:viz sazebník', 'Fans (excl. table, floor, wall, window, ceiling or roof fans, with a self-contai'),
('84146000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Odsavače s vodorovnou hranou do 120cm', 'Hoods incorporating a fan, whether or not fitted with filters, having a maximum'),
('84148011', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Turbokompresory jednostupňové', 'Turbocompressors, single-stage (excl. compressors for refrigerating equipment an'),
('84148019', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Turbokompresory vícestupňové', 'Turbocompressors, multi-stage (excl. compressors for refrigerating equipment and'),
('84148022', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kompresory pístové odsávací,přetlak do 1,5MPa (15 barů),průtok do 60m3/hod', 'Reciprocating displacement compressors, having a gauge pressure capacity <= 15 b'),
('84148028', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kompresory pístové odsávací,přetlak do 1,5MPa (15 barů),průtok nad 60m3/hod', 'Reciprocating displacement compressors, having a gauge pressure capacity <= 15 b'),
('84148051', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kompresory pístové odsávací,přetlak nad 1,5MPa (15 barů),průtok do 120m3/hod', 'Reciprocating displacement compressors, having a gauge pressure capacity > 15 ba'),
('84148059', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kompresory pístové odsávací,přetlak nad 1,5MPa (15 barů),průtok nad 120m3/hod', 'Reciprocating displacement compressors, having a gauge pressure capacity > 15 ba'),
('84148073', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kompresory rotační odsávací s jednou hřídělí', 'Rotary displacement compressors, single-shaft (excl. compressors for refrigerati'),
('84148075', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kompresory rotační odsávací s více hřídelemi šroubové', 'Screw compressors, multi-shaft (excl. compressors for refrigerating equipment an'),
('84148078', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kompresory rotační odsávací ostatní s více hřídelemi,ne:šroubové', 'Rotary displacement compressors, multi-shaft (excl. compressors for refrigeratin'),
('84148080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kompresory ostatní,ne:viz sazebník', 'Air pumps and ventilating or recycling hoods incorporating a fan, whether or not'),
('84149000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části vývěv,kompresorů,ventilátorů apod.', 'Parts of : air or vacuum pumps, air or other gas compressors, fans and ventilati'),
('84151010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Klimatiz.zaříz.okenního,nástěnného typu s vlastním pohonem', 'Window or wall air conditioning machines, self-contained'),
('84151090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Klimatiz.zaříz.okenního,nástěnného typu ve formě "děleného systému"', 'Window or wall air conditioning machines "split-system"'),
('84152000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Klimatizační zařízení pro motorová vozidla,používaná v prostorech a osobami', 'Air conditioning machines of a kind used for persons, in motor vehicles'),
('84158100', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Klimatiz.zaříz.s chlazením a ventilem pro střídání cyklů', 'Air conditioning machines incorporating a refrigerating unit and a valve for rev'),
('84158200', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Klimatiz.zaříz.s chlazením bez ventilu pro střídání cyklů', 'Air conditioning machines incorporating a refrigerating unit but without a valve'),
('84158300', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Klimatiz.zaříz.bez vestavěné chladicí jednotky', 'Air conditioning machines comprising a motor-driven fan, not incorporating a ref'),
('84159000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti strojů,přístrojů klimatizačních', 'Parts of air conditioning machines, comprising a motor-driven fan and elements f'),
('84161010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Hořáky pro topeniště na paliva kapalná,vestavěné automatické ovládání', 'Furnace burners for liquid fuel, incorporating an automatic control device'),
('84161090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Hořáky pro topeniště na paliva kapalná ost.,ne:vestavěné automatické ovládání', 'Furnace burners for liquid fuel (excl. those incorporating an automatic control'),
('84162010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Hořáky ostatní plynové,monobloky,s vestavěným ventilátorem a ovládacím zařízením', 'Furnace burners, only for gas, monobloc, incorporating a ventilator and a contro'),
('84162020', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Hořáky ostatní kombinované,na prášková nebo plynná paliva', 'Combination furnace burners for pulverised solid fuel or for gas'),
('84162080', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hořáky ostatní,ne:viz sazebník', 'Furnace burners for pulverised solid fuel or gas (excl. such products only for g'),
('84163000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zařízení mechanická přikládací,k odstraňování popela,vč.mech.roštů apod.', 'Mechanical stokers, incl. their mechanical grates, mechanical ash dischargers an'),
('84169000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti hořáků,zařízení mechanických přikládacích,roštů apod.', 'Parts of furnace burners such as mechanical stokers, incl. their mechanical grat'),
('84171000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pece na tepelné zpracování rud,pyritu,kovů,ne:elektrické', 'Industrial or laboratory furnaces and ovens, non-electric, for the roasting, mel'),
('84172010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pece pekárenské tunelové ne:elektrické', 'Tunnel bakery ovens, incl. biscuit ovens, non-electric'),
('84172090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pece pekárenské ostatní,ne:tunelové,elektrické', 'Bakery ovens, incl. biscuit ovens, non-electric (excl. tunnel ovens)'),
('84178030', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pece na vypalování keramických výrobků', 'Ovens and furnaces for firing ceramic products'),
('84178050', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pece na vypalování  cementu,skla nebo chemických výrobků', 'Ovens and furnaces for firing cement, glass or chemical products'),
('84178070', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pece neelektrické průmyslové a laboratorní ostatní,ne:viz sazebník', 'Industrial or laboratory furnaces, incl. incinerators, non-electric (excl. for t'),
('84179000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti pecí průmyslových,laboratorních,ne:elektrických', 'Parts of industrial or laboratory furnaces, non-electric, incl. incinerators, n.'),
('84181020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení chladicí,mrazicí kombinovaná,samostatné dveře,nad 340l', 'Combined refrigerator-freezers, of a capacity > 340 l, fitted with separate exte'),
('84181080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení chladicí,mrazicí kombinovaná,samostatné dveře,do 340l', 'Combined refrigerator-freezers, of a capacity <= 340 l, fitted with separate ext'),
('84182110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Chladničky pro domácnost kompresorové,obsah nad 340 l', 'Household refrigerators, compression-type, of a capacity > 340 l'),
('84182151', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Chladničky pro domácnost kompresorové stolní,obsah do 340 l', 'Household refrigerators, compression-type, table model'),
('84182159', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Chladničky pro domácnost kompresorové vestavěné,obsah do 340 l', 'Household refrigerators, compression-type, building-in type'),
('84182191', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Chladničky pro domácnost kompresor.ostatní,do 250 l,ne:deskové,vestavěné', 'Household refrigerators compression-type, of a capacity <= 250 l (excl. table mo'),
('84182199', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Chladničky pro domácnost kompresor.ost.,nad 250-340 l,ne:deskové,vestavěné', 'Household refrigerators, compression-type, of a capacity > 250 l but <= 340 l (e'),
('84182900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Chladničky pro domácnost ostatní,ne:kompresorové', 'Household refrigerators, absorption-type'),
('84183020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Mrazničky pultového typu,objem do 400 l', 'Freezers of the chest type, of a capacity <= 400 l'),
('84183080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Mrazničky pultového typu,objem nad 400-800 l', 'Freezers of the chest type, of a capacity > 400 l but <= 800 l'),
('84184020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Mrazničky skříňového typu,objem do 250 l', 'Freezers of the upright type, of a capacity <= 250 l'),
('84184080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Mrazničky skříňového typu,objem nad 250-900 l', 'Freezers of the upright type, of a capacity > 250 l but <= 900 l'),
('84185011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vitriny,pulty chladicí ostatní,pro skladování potravin zmrazených', 'Refrigerated show-cases and counters, with a refrigerating unit or evaporator, f'),
('84185019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vitriny,pulty chladicí ostatní,ne:pro skladování potravin zmrazených', 'Refrigerated show-cases and counters, with a refrigerating unit or evaporator, f'),
('84185090', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Nábytek chladicí,mrazicí ostatní,ne:viz sazebník', 'Refrigerating furniture with a refrigerating unit or evaporator (excl. combined'),
('84186100', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Čerpadla tepelná jiná než klimatizační zařízení čísla 8415', 'Heat pumps (excl. air conditioning machines of heading 8415)'),
('84186900', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zařízení chladicí,mrazicí ostatní,ne:viz sazebník', 'Refrigerating or freezing equipment (excl. refrigerating and freezing furniture)'),
('84189100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nábytek upravený pro vestavění zařízení chladicích,mrazicích', 'Furniture designed to receive refrigerating or freezing equipment'),
('84189910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zařízení odpařovací,kondenzátory,ne:pro chladničky pro domácnost', 'Evaporators and condensers for refrigerating equipment (excl. for household refr'),
('84189990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zařízení chladicí,mrazicí ostatní,ne:viz sazebník', 'Parts of refrigerating or freezing equipment and heat pumps, n.e.s.'),
('84191100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ohřívače průtokové plynové', 'Instantaneous gas water heaters (excl. boilers or water heaters for central heat'),
('84191900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ohrivace vody prutokove,zasobnikove neel.ost.', 'Instantaneous or storage water heaters, non-electric (excl. instantaneous gas wa'),
('84192000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje sterilizační pro lékařské,chirurgické,laboratorní účely', 'Medical, surgical or laboratory sterilizers'),
('84193100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje sušicí pro sušení výrobků zemědělských', 'Dryers for agricultural products'),
('84193200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje sušicí pro sušení dřeva,buničiny,papíru,lepenky,kartonu', 'Dryers for wood, paper pulp, paper or paperboard'),
('84193900', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje sušicí ostatní,ne:pro výr.zemědělské,dřevo,buničinu,papír,lepenku,karton', 'Dryers (excl. dryers for agricultural products, for wood, paper pulp, paper or p'),
('84194000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje destilační,rektifikační', 'Distilling or rectifying plant'),
('84195000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výměníky tepla', 'Heat-exchange units (excl. instantaneous heaters, storage water heaters, boilers'),
('84196000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje a zařízení pro zkapalňování vzduchu a jiných plynů', 'Machinery for liquefying air or other gases'),
('84198120', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Perkolátory a jiná zařízení k výrobě kávy a jiných teplých nápojů', 'Percolators and other appliances for making coffee and other hot drinks (excl. d'),
('84198180', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje pro vaření a ohřívání jídel,ne:perkolátory apod.pro výrobu teplých nápojů', 'Machinery, plant and equipment for cooking or heating food (excl. percolators an'),
('84198910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Věže chladicí apod.zař. pro přímé chlazení recirkulací vody', 'Cooling towers and similar plant for direct cooling (without a separating wall)'),
('84198930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zařízení k nanášení kovů srážením par ve vakuu', 'Vacuum-vapour plant for the deposition of metal'),
('84198998', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje ke zprac.materiálu na základě změny teploty ostatní,ne:viz sazebník', 'Machinery, plant or laboratory equipment, whether or not electrically heated, fo'),
('84199015', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti přístrojů sterilizačních podpoložky 8419 20 00', 'Parts of medical, surgical or laboratory sterilizers, n.e.s.'),
('84199085', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti ostatní,ne:viz sazebník', 'Parts of machinery, plant and laboratory equipment, whether or not electrically'),
('84201010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kalandry nebo jiné valcovací stroje pro textilní průmysl', 'Calendering or other rolling machines, of a kind used in the textile industry'),
('84201030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kalandry nebo jiné valcovací stroje pro papírenský průmysl', 'Calendering or other rolling machines, of a kind used in the paper industry'),
('84201080', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kalandry nebo jiné válcovací stroje ostatní,ne:pro textil.,papír.prům.', 'Calendering or other rolling machines (excl. such machines of a kind used in the'),
('84209110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Válce pro kalandry a jiné stroje válcovací z litiny', 'Cylinders for calendering or other rolling machines, of cast iron (other than fo'),
('84209180', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Válce pro kalandry a podobné válcovací stroje ostatní,ne:z litiny', 'Cylinders for calendering or other rolling machines (excl. of cast iron and thos'),
('84209900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti ostatní kalandrů a jiných strojů válcovacích,ne:válce', 'Parts for calendering or rolling machines, n.e.s. (other than for metals or glas'),
('84211100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odstředivky mléka', 'Centrifugal cream separators'),
('84211200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Ždímačky prádla', 'Centrifugal clothes-dryers'),
('84211920', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odstředivky pro laboratoře (ke zpracování krve a krevních derivátů)', 'Centrifuges of a kind used in laboratories'),
('84211970', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odstředivky,včetně odstředivých ždímaček ostatní,ne:viz sazebník', 'Centrifuges, incl. centrifugal dryers (excl. apparatus for isotope separation, c'),
('84212100', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje k filtrování,čištění vody', 'Machinery and apparatus for filtering or purifying water'),
('84212200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje k filtrování,čištění kapalin ostatních,ne:vody', 'Machinery and apparatus for filtering or purifying beverages (excl.water)'),
('84212300', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filtry olejové,benzinové pro spalovací motory', 'Oil or petrol-filters for internal combustion engines'),
('84212900', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje k filtrování,čištění kapalin ostatní,ne:viz sazebník', 'Machinery and apparatus for filtering or purifying liquids (excl. such machinery'),
('84213100', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filtry vzduchové sací pro spalovací motory', 'Intake air filters for internal combustion engines'),
('84213920', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje k filtrování,čištění vzduchu', 'Machinery and apparatus for filtering or purifying air (excl. isotope separators'),
('84213960', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje k filtrování,čištění plynů katalytickým procesem,ne:vzduchu', 'Machinery and apparatus for filtering or purifying gases (other than air), by a'),
('84213980', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje k filtrování,čištění plynů ostatní,ne:katalytickým procesem,vzduchu', 'Machinery and apparatus for filtering and purifying gases (other than air and ex'),
('84219100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti odstředivek,vč.odstředivých ždímaček', 'Parts of centrifuges, incl. centrifugal dryers, n.e.s.'),
('84219900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Casti pristroju k filtrovani ap tekutin,plynu', 'Parts of machinery and apparatus for filtering or purifying liquids or gases, n.'),
('84221100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Myčky nádobí pro domácnost', 'Dishwashing machines of the household type'),
('84221900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Myčky nádobí ostatní,ne:pro domácnost', 'Dishwashing machines (excl. those of the household type)'),
('84222000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje k čištění,sušení lahví a jiných obalů', 'Machinery for cleaning or drying bottles or other containers (excl. dishwashing'),
('84223000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje k plnění,uzavírání apod.lahví,krabic a jiných obalů,k sycení CO2', 'Machinery for filling, closing, sealing or labelling bottles, cans, boxes, bags'),
('84224000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje balicí ostatní,ne:viz sazebník', 'Packing or wrapping machinery, incl. heat-shrink wrapping machinery (excl. machi'),
('84229010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části myček nádobí', 'Parts of dishwashing machines, n.e.s.'),
('84229090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti strojů k mytí,plnění,značení apod.obalů,ne:pro myčky nádobí', 'Parts of packing or wrapping machinery and of other machinery of heading 8422, n'),
('84231010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vahy pro domacnost osobni,kuchynske', 'Household scales (excl. personal weighing machines and baby scales)'),
('84231090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Váhy osobní včetně dětských', 'Personal weighing machines, incl. baby scales'),
('84232000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Váhy pro průběžné vážení zboží na dopravnících', 'Scales for continuous weighing of goods on conveyors'),
('84233000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Váhy pro konstantní odvažování,zařízení odvažovací pro plnění stanov.množství', 'Constant weight scales and scales for discharging a pre-determined weight of mat'),
('84238110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Váhy kontrolní apod.zařízení,zatížení do 30kg,k porovnání váhy s urč.hmotností', 'Check weighers and automatic control machines operating by reference to a pre-de'),
('84238130', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení k vážení,označování předem zabaleného zboží,zatížení do 30kg', 'Machinery for weighing and labelling pre-packaged goods, of a maximum weighing c'),
('84238150', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Váhy používané v prodejnách,zatížení do 30kg', 'Shop-scales of a maximum weighing capacity <= 30 kg (excl. machinery for weighin'),
('84238190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje,zařízení k vážení ostatní,zatížení do 30kg,ne:viz sazebník', 'Weighing machinery of a maximum capacity <= 30 kg (excl. of a sensitivity <= 50'),
('84238210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Váhy kontrolní apod.zař.,zatížení nad 30-5000kg,k porov.váhy s urč.hmotností', 'Check weighers and automatic control machines operating by reference to a pre-de'),
('84238290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje a zařízení k vážení ostatní,zatížení nad 30-5000kg,ne:viz sazebník', 'Weighing machinery having a maximum weighing capacity of > 30 kg but <= 5.000 kg'),
('84238900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Ostatní přístroje a zařízení k určování hmotnosti,max.zatížení >5000kg', 'Weighing machinery of a maximum weighing capacity > 5.000 kg'),
('84239000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Závaží pro váhy všech druhů,části,součásti přístrojů a zařízení k vážení', 'Weighing machine weights of all kinds; parts of weighing machinery, n.e.s.'),
('84241000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje hasicí i s náplní', 'Fire extinguishers, whether or not charged'),
('84242000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stříkací pistole a podobné přístroje', 'Spray guns and similar appliances (other than electrical machines, appliances an'),
('84243001', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení mycí vodní s motorem a vyhřívačem', 'Water cleaning appliances with built-in motor, with heating device'),
('84243008', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení mycí vodní s motorem bez vyhřívače', 'Water cleaning appliances with built-in motor, without heating device'),
('84243010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dmychadla k vrhání písku apod.tryskací přístroje na stlačený vzduch', 'Steam or sand blasting machines and similar jet projecting machines, compressed'),
('84243090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dmychadla k vrhání písku apod.tryskací přístroje ost.,ne:na stlačený vzduch', 'Steam or sand blasting machines and similar jet projecting machines (excl. compr'),
('84248110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zařízení zavlažovací mechanické pro zemědělství,zahradnictví', 'Agricultural or horticultural watering appliances, whether or not hand-operated'),
('84248130', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Mech.přístr.ke stříkání,rozstřik.,rozprašování apod.přenosné ost.,ne:viz sazebník', 'Portable agricultural or horticultural appliances, whether or not hand-operated,'),
('84248191', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Rozstřikovače,rozprašovače na zemědělských traktorech,tažené zeměď.traktory', 'Agricultural or horticultural sprayers and powder distributors, designed to be m'),
('84248199', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje mech.rozprašovací apod.ost.pro zemědělství,zahradnictví,ne:viz sazebník', 'Agricultural or horticultural mechanical appliances, whether or not hand-operate'),
('84248900', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje mech.rozprašovací,rozstřikovací,rozmetávací apod.ost.,ne:viz sazebník', 'Mechanical appliances, whether or not hand-operated, for projecting, dispersing'),
('84249000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součástí přístrojů čísla 8424', 'Parts of fire extinguishers, spray guns and similar appliances, steam or sand bl'),
('84251100', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kladkostroje,zařízení zdvihací apod.s elektrickým motorem', 'Pulley tackle and hoists, powered by electric motor (other than skip hoists or h'),
('84251900', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kladkostroje,zařízení zdvihací apod.bez elektrického motoru', 'Pulley tackle and hoists (other than skip hoists or hoists of a kind used for ra'),
('84253100', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vrátky,navijáky s elektrickým motorem', 'Winches and capstans powered by electric motor'),
('84253900', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vrátky,navijáky bez elektrického motoru', 'Winches and capstans, non-powered by electric motor'),
('84254100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zdvihací zařízení fixní používané v  garážích', 'Built-in jacking systems of a type used in garages'),
('84254200', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení zdvihací,zdviháky hydraulické', 'Jacks and hoists, hydraulic (excl. built-in jacking systems used in garages)'),
('84254900', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení zdvihací,zdviháky ostatní,ne:hydraulické', 'Jacks and hoists of a kind used for raising vehicles, not hydraulic'),
('84261100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jeřáby pojízdné s pevnou podpěrou', 'Overhead travelling cranes on fixed support'),
('84261200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rámy zdvihací mobilní na pneu.,vozíky zdvižné obkročné,portálové nízkozdvižné', 'Mobile lifting frames on tyres and straddle carriers'),
('84261900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jeřáby přepravní,portálové', 'Overhead travelling cranes, transporter cranes, gantry cranes, bridge cranes and'),
('84262000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jeřáby věžové', 'Tower cranes'),
('84263000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jeřáby sloupové otočné,portálové', 'Portal or pedestal jib cranes'),
('84264100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje zvedací ostatní s vlastním pohonem na pneumatikách,ne:sazebník', 'Mobile cranes and works trucks fitted with a crane, self-propelled, on tyres (ex'),
('84264900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje zvedací ostatní s vlastním pohonem,ne:viz sazebník', 'Mobile cranes and works trucks fitted with a crane, self-propelled (excl. those'),
('84269110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Jeřáby hydraulické-připevnění na vozidla silniční,k nakládání,vykládání vozidla', 'Hydraulic cranes designed for the loading and unloading of the vehicle'),
('84269190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje zvedací-připevnění na vozidla silniční ost.,ne:viz sazebník', 'Cranes designed for mounting on road vehicles (excl. hydraulic cranes designed f'),
('84269900', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje zvedací ostatní,ne:viz sazebník', 'Ships'' derricks; cranes, incl. cable cranes (excl. overhead travelling cranes,'),
('84271010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozíky vidlicové stohovací samohybné s elektrickým motorem,zdvih 1m a víc', 'Self-propelled works trucks powered by an electric motor, with a lifting height'),
('84271090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozíky vidlicové stohovací samohybné s elektrickým motorem,zdvih do 1m', 'Self-propelled works trucks powered by an electric motor, with a lifting height'),
('84272011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozíky vidlicové zdvihací terénní apod.stohovací,zdvih 1m a víc,ne:s el.motorem', 'Rough terrain fork-lift and other stacking trucks, self-propelled, with a liftin'),
('84272019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozíky zdvihací samohybné ostatní,zdvih 1m a víc,ne:viz sazebník', 'Works trucks, self-propelled, with a lifting height >= 1 m, non- powered with an'),
('84272090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozíky zdvihací samohybné ostatní,zdvih do 1m,ne:s elektrickým motorem', 'Works trucks, self-propelled, with a lifting height < 1 m, non-powered with an e'),
('84279000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozíky ostatní se zařízením zdvihacím,manipulačním,ne:viz sazebník', 'Works trucks fitted with lifting or handling equipment, not self-propelled'),
('84281020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Osobní,nákladní výtahy i skipové s elektrickým motorem', 'Lifts and skip hoists, electrically operated'),
('84281080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Osobní,nákladní výtahy i skipové,ne:s elektrickým motorem', 'Lifts and skip hoists, non-electrically operated'),
('84282020', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Elevátory,dopravníky pneumatické pro sypké materiály', 'Pneumatic elevators and conveyors, for bulk materials'),
('84282080', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Elevátory,dopravníky pneumatické ostatní,ne:pro sypké materiály', 'Pneumatic elevators and conveyors (excl. those for bulk materials)'),
('84283100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Elevátory,dopravníky ostatní používané pod zemí,ne:pneumatické', 'Continuous-action elevators and conveyors for goods or materials, for undergroun'),
('84283200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Elevátory,dopravníky korečkové', 'Continuous-action elevators and conveyors for goods or materials, bucket type (e'),
('84283300', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Elevátory,dopravníky pásové,ne:pneumatické', 'Continuous-action elevators and conveyors for goods or materials, belt type (exc'),
('84283920', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dopravníky válečkové', 'Roller conveyors'),
('84283990', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Elevátory ostatní,ne:viz sazebník', 'Continuous-action conveyors for goods or materials (excl. specially designed for'),
('84284000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Eskalátory,chodníky pohyblivé', 'Escalators and moving walkways'),
('84286000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lanovky,výtahy sedačkové,vleky lyžařské,trakční zařízení pro pozemní lanovky', 'Teleferics, chairlifts, ski-draglines; traction mechanisms for funiculars'),
('84289071', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nakládače pro zemědělství k připojení za traktor', 'Loaders specially designed for attachment to agricultural tractors'),
('84289079', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nakladače pro zemědělství ostatní,ne:k připojení za traktor', 'Loaders for use in agriculture (excl. those specially designed for attachment to'),
('84289090', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zařízení zdvihací ostatní,ne:viz sazebník', 'Lifting, handling, loading or unloading machinery, n.e.s.'),
('84291100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Buldozery,angldozery na pásech', 'Self-propelled bulldozers and angledozers, track laying'),
('84291900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Buldozery,angldozery ostatní,ne:na pásech', 'Self-propelled bulldozers and angledozers, on wheels'),
('84292000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje k vyrovnávání,srovnávání terénu (grejdr,nivelátor)', 'Self-propelled graders and levellers'),
('84293000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Škrabače (skrejpry)', 'Self-propelled scrapers'),
('84294010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Válce silniční vibrační s vlastním pohonem', 'Self-propelled roadrollers, vibratory'),
('84294030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Válce silniční s vlastním pohonem ostatní,ne:vibrační', 'Self-propelled roadrollers (other than vibratory)'),
('84294090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Dusadla s vlastním pohonem', 'Self-propelled tamping machines (excl. roadrollers)'),
('84295110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Nakladače lopatové čelní k práci pod zemí s vlastním pohonem', 'Self-propelled front-end shovel loaders specially designed for underground use'),
('84295191', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pásové lopatové nakladače,ne:k práci pod zemí', 'Self-propelled front-end crawler shovel loaders (other than specially designed f'),
('84295199', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čelní lopatové nakladače ostatní,ne:pásové,k práci pod zemí', 'Self-propelled front-end shovel loaders (other than specially designed for under'),
('84295210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pásová rypadla s nástavbou otočnou o 360 stupňů', 'Self-propelled track-laying excavators, with a 360Â° revolving superstructure'),
('84295290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zař.nakládací strojní s nástavbou otočnou o 360 stupňů ost.,ne:pásová rypadla', 'Self-propelling mechanical shovels with a 360Â° revolving superstructure (other'),
('84295900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Lopaty,rydla mechanické ostatní s vlastním pohonem,ne:viz sazebník', 'Self-propelled mechanical shovels, excavators and shovel loaders (excl. self-pro'),
('84301000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Beranidla,vytahovače pilot', 'Pile-drivers and pile-extractors (excl. those mounted on railway wagons, motor v'),
('84302000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pluhy,frézy sněhové', 'Snowploughs and snowblowers (excl. those mounted on railway wagons, motor vehicl'),
('84303100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje brázdicí,zásekové,razící s vlastním pohonem', 'Self-propelled coal or rock cutters and tunnelling machinery (excl. hydraulicall'),
('84303900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje brázdicí,zásekové,razící ostatní,ne:s vlastním pohonem', 'Coal or rock cutters and tunnelling machinery, not self-propelled (excl. hand-op'),
('84304100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje hloubící,vrtací s vlastním pohonem', 'Self-propelled boring or sinking machinery for boring earth or extracting minera'),
('84304900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje hloubící,vrtací ostaní,ne:s vlastním pohonem', 'Boring or sinking machinery for boring earth or extracting minerals or ores, not'),
('84305000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje zemní ostatní s vlastním pohonem', 'Self-propelled earth-moving machinery, n.e.s.'),
('84306100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje dusací,pěchovací,zhutňovací ostatní,ne:s vlastním pohonem', 'Tamping or compacting machinery, not self-propelled (excl. hand-operated tools)'),
('84306900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje zemní ostatní bez vlastního pohonu,ne:viz sazebník', 'Earth moving machinery, not self-propelled, n.e.s.'),
('84311000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti kladkostrojů,zařízení zdvihacích,navijáků,vrátků,zdviháků', 'Parts of pulley tackles and hoists (other than skip hoists), winches, capstans a'),
('84312000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části vozíků vidlicových stohovacích apod.se zařízením zdvihacím,manipulačním', 'Parts of fork-lift trucks and other works trucks fitted with lifting or handling'),
('84313100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti výtahů i skipových,eskalátorů,elevátorů', 'Parts of lifts, skip hoists or escalators, n.e.s.'),
('84313910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti dopravníků ve válcovnách,zař.manipulačních pro ingoty,tyče apod.', 'Parts of rolling-mill machinery of subheading 8428.90.30, n.e.s.'),
('84313970', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti strojů a přístrojů čísel 8428 ostatní,ne:viz sazebník', 'Parts of  lifting, handling, loading or unloading machinery "e.g. conveyors, tel'),
('84314100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti-korečky,lopatky,drapáky,upínadla rypadel apod.', 'Buckets, shovels, grabs and grips for machinery of heading 8426, 8429 and 8430'),
('84314200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Radlice buldozerů,angldozerů', 'Bulldozer or angledozer blades, n.e.s.'),
('84314300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti strojů hloubicích,vrtacích', 'Parts for boring or sinking machinery of subheading 8430.41 or 8430.49, n.e.s.'),
('84314920', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti jeřábů,strojů zemních apod.z litiny,oceli lité ost.,ne:viz sazebník', 'Parts of machinery of heading 8426, 8429 and 8430 of cast iron or cast steel, n.'),
('84314980', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti jeřábů,strojů zemních apod.ostatní,ne:viz sazebník', 'Parts of machinery of heading 8426, 8429 and 8430, n.e.s.'),
('84321000', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pluhy (vč.odhrnovaček) pro zemědělství, zahradnictví nebo lesnictví', 'Ploughs for use in agriculture, horticulture or forestry'),
('84322100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Brány talířové', 'Disc harrows for use in agriculture, horticulture or forestry'),
('84322910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Rozrývače (skarifikátory),kultivátory', 'Scarifiers and cultivators for use in agriculture, horticulture and forestry'),
('84322930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Brány ostatní,ne:talířové,rozrývače,kultivátory,rotavátory', 'Harrows for use in agriculture, horticulture and forestry (excl. disc harrows)'),
('84322950', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Frézy půdní (rotavátory)', 'Rotovators for use in agriculture, horticulture and forestry'),
('84322990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Plečky', 'Weeders and hoes for use in agriculture, horticulture and forestry (excl. rotova'),
('84323011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje secí přesně nastavitelné s centrálním pohonem', 'Central driven precision spacing seeders for use in agriculture, horticulture an'),
('84323019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje secí ostatní,ne:přesně nastavitelné s centrálním pohonem', 'Seeders for use in agriculture, horticulture and forestry (excl. central driven'),
('84323090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje sázecí,jednotící', 'Planters and transplanters for use in agriculture, horticulture and forestry'),
('84324010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Rozmetadla hnojiv minerálních,chemických', 'Mineral or chemical fertiliser distributors for use in agriculture, horticulture'),
('84324090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Rozmetadla mrvy', 'Farmyard manure or compost spreaders for use in agriculture, horticulture and fo'),
('84328000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje ost.k přípr.,obdělávání půdy v zeměď.,lesnictví,válce na trávu,ne:sazebník', 'Agricultural, horticultural or forestry machinery for soil preparation or cultiv'),
('84329000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti strojů a pod.pro zemědělství,zahradnictví,lesnictví', 'Parts of agricultural, horticultural or forestry machinery for soil preparation'),
('84331110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sekačky na trávu,úpravu trávníků apod.,horizontální s elektrickým motorem', 'Electric motor mowers for lawns, parks or sports grounds, with the cutting devic'),
('84331151', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sekačky na trávu horizontální samohybné,s motorem a sedadlem,ne:elektrické', 'Self-propelled mowers for lawns, parks or sports grounds, powered non-electrical'),
('84331159', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sekačky na trávu horizontální samohybné,s motorem,ne:se sedadlem,elektrické', 'Self-propelled mowers for lawns, parks or sports grounds, powered non-electrical'),
('84331190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sekačky na trávu horizontální ostatní,ne:elektrické,samohybné', 'Mowers for lawns, parks or sports grounds, powered non-electrically, with the cu'),
('84331910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sekačky na trávu ostatní s elektrickým motorem,ne:horizontální', 'Electric motor mowers for lawns, parks or sports grounds, with the cutting devic'),
('84331951', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sekačky na trávu ostatní samohybné se sedadlem,ne:elektrické,horizontální', 'Self-propelled motor mowers for lawns, parks or sports grounds, powered non-elec'),
('84331959', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sekačky na trávu ostatní samohybné,ne:elektrické,horizontální,se sedadlem', 'Self-propelled motor mowers for lawns, parks or sports grounds, powered non-elec'),
('84331970', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sekačky na trávu ostatní s motorem,ne:horizontální,samohybné,elektrické', 'Motor mowers for lawns, parks or sports grounds, powered non-electrically, with'),
('84331990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sekačky na trávu bez motoru', 'Mowers for lawns, parks or sports grounds, without motor'),
('84332010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje žací včetně žacích lišt s motorem,k připevnění na traktory', 'Motor mowers (excl. mowers for lawns, parks or sports grounds)'),
('84332050', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje žací bez motoru,pro tažení,vezení traktory', 'Mowers without motor, incl. cutter bars, designed to be carried on or hauled by'),
('84332090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje žací včetně žacích lišt bez motoru ost.,ne:pro tažení,vezení traktory', 'Mowers (excl. mowers designed to be carried on or hauled by a tractor, mowers fo'),
('84333000', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje a přístroje na zpracování sena a píce,ostatní,ne:žací stroje', 'Haymaking machinery (excl. mowers)'),
('84334000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Lisy balicí (vč.sběracích) na píci,slámu', 'Straw or fodder balers, incl. pick-up balers'),
('84335100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kombajny pro sklízení a výmlat', 'Combine harvester-threshers'),
('84335200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje,přístroje ostatní pro výmlat,ne:kombajny', 'Threshing machinery (excl. combine harvester-threshers)'),
('84335310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vyorávače brambor,kombajny bramborové', 'Potato-diggers and potato harvesters'),
('84335330', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje na ořezávání cukrové řepy,kombajny na cukrovou řepu', 'Beet-topping machines and beet harvesters'),
('84335390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje na sklízení kořenů,hlíz ostatní,ne:na brambory,cukrovku', 'Root or tuber harvesting machines (excl. potato-diggers and potato harvesters an'),
('84335911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kombajny na píci s vlastním pohonem', 'Forage harvesters, self-propelled'),
('84335919', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kombajny na píci ostatní,ne:s vlastním pohonem', 'Forage harvesters, not self-propelled'),
('84335985', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje,přístroje pro sklizňové práce ostatní,ne:viz sazebník', 'Harvesting machinery for agricultural produce (excl. mowers, haymaking machinery'),
('84336000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje na čištění nebo třídění vajec,ovoce nebo jiných zeměďělských výrobků', 'Machines for cleaning, sorting or grading eggs, fruit or other agricultural prod'),
('84339000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti strojů žacích,sklizňových,třídících,sekaček trávy apod.', 'Parts of harvesting machinery, threshing machinery, mowers and machines for clea'),
('84341000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje dojící', 'Milking machines'),
('84342000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje mlékárenské', 'Dairy machinery (excl. refrigerating or heat treatment equipment, cream separato'),
('84349000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti strojů,přístrojů dojících,mlékárenských', 'Parts of milking machines and dairy machinery, n.e.s.'),
('84351000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lisy,drtiče apod.pro výrobu vína,moštů,šťáv a pod.nápojů', 'Presses, crushers and similar machinery used in the manufacture of wine, cider,'),
('84359000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti strojů k výrobě vína,moštů,šťáv apod.', 'Parts of presses, crushers and similar machinery used in the manufacture of wine'),
('84361000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje a přístroje pro přípravu krmiv pro zvířata', 'Machinery for preparing animal feedingstuffs in agricultural holdings and simila'),
('84362100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Líhně,kvočny umělé', 'Poultry incubators and brooders'),
('84362900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje pro drůbežnictví ostatní,ne:líhně,kvočny', 'Poultry-keeping machinery (excl. machines for sorting or grading eggs, poultry p'),
('84368010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Lesnické stroje', 'Forestry machinery, n.e.s.'),
('84368090', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,zařízení ost.pro zemědělství,zahradnictví,včelař.,klíčení rostl.,ne:viz sazebník', 'Agricultural, horticultural, forestry, poultry-keeping or bee-keeping machinery,'),
('84369100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti strojů pro drůbežnictví,umělé líhně,kvočny', 'Parts of poultry-keeping machinery or poultry incubators and brooders, n.e.s.'),
('84369900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části strojů ost.pro zemědělství,zahradnictví,lesnictví,včelař.apod.,ne:viz sazebník', 'Parts of agricultural, horticultural, forestry or bee-keeping machinery, n.e.s.'),
('84371000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje k čištění,třídění,prosévání semen,zrní,suchých luštěnin', 'Machines for cleaning, sorting or grading seed, grain or dried leguminous vegeta'),
('84378000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje mlynářské,pro zpracování semen,zrní,luštěnin ostatní,ne:čištění', 'Machinery used in the milling industry or for the working of cereals or dried le'),
('84379000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti strojů k třídění,čištění apod.semen,zrní,strojů mlynářských', 'Parts of machinery used in the milling industry or for the working of cereals or'),
('84381010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,zařízení pekařské,ne:pece', 'Bakery machinery (excl. ovens and dough rollers)'),
('84381090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,zařízení k výrobě makaronů,špaget apod.výrobků,ne:pece', 'Machinery for the industrial preparation or manufacture of macaroni, spaghetti o'),
('84382000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,zařízení k výrobě cukrovinek,kakaa,čokolády', 'Machinery for the industrial preparation or manufacture of confectionery, cocoa'),
('84383000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje pro cukrovary', 'Machinery for sugar manufacture (excl. centrifuges and filtering, heating or ref'),
('84384000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje pro pivovary', 'Brewery machinery (excl. centrifuges and filtering, heating or refrigerating equ'),
('84385000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje k zpracování masa,drůbeže', 'Machinery for the industrial preparation of meat or poultry (excl. cooking and o'),
('84386000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje k zpracování ovoce,ořechů,zeleniny', 'Machinery for the industrial preparation of fruits, nuts or vegetables (excl. co'),
('84388010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,zařízení k přípravě kávy,čaje', 'Machinery for the industrial preparation of tea or coffee (excl. centrifuges, fi'),
('84388091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,zařízení k přípravě,výrobě nápojů ostatní,ne:kávy,čaje,pro pivovary', 'Machinery for the industrial preparation or manufacture of drink (excl. centrifu'),
('84388099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,zařízení ostatní k průmyslové výrobě potravin,tuků,ne:viz sazebník', 'Machinery for the industrial preparation or manufacture of food or drink, n.e.s.'),
('84389000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti strojů,zařízení k průmysl.výrobě,přípravě potravin,nápojů,tuků', 'Parts of machinery for the industrial preparation or manufacture of food or drin'),
('84391000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje k výrobě buničiny (papíroviny)', 'Machinery for making pulp of fibrous cellulosic material (excl. autoclaves, boil'),
('84392000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje k výrobě papíru,kartónu,lepenky', 'Machinery for making paper or paperboard (excl. dryers and other heating applian'),
('84393000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje ke konečné úpravě papíru,kartónu,lepenky', 'Machinery for finishing paper or paperboard (excl. calenders)'),
('84399110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti strojů,přístrojů k výrobě buničiny z litiny,oceli lité', 'Parts of machinery for making pulp of fibrous cellulosic material, of cast iron'),
('84399190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti strojů,přístrojů k výrobě buničiny ost.,ne:z litiny,oceli lité', 'Parts of machinery for making pulp of fibrous cellulosic material, n.e.s. (excl.'),
('84399910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části strojů,přístr.k výr.,úpravě papíru apod.z litiny,oceli lité,ne:buničiny', 'Parts of machinery for making or finishing paper or paperboard, n.e.s., of cast'),
('84399990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části strojů k výr.,úpravě papíru apod.ost.,ne:buničiny,z litiny,oceli lité', 'Parts of machinery for making or finishing paper or paperboard, n.e.s. (excl. of'),
('84401010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Knihařské stroje skládací', 'Folding machines for bookbinding'),
('84401020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Knihařské stroje snášecí a kompletovací', 'Collating machines and gathering machines for bookbinding'),
('84401030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Knihařské stroje sešívací,drátovky (stroje na šití drátem)', 'Sewing, wire stitching and stapling machines, incl. book-sewing machines, for bo'),
('84401040', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje na vazbu knih lepením (ne šitím)', 'Unsewn "perfect" binding machines'),
('84401090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Knihař.stroje ost.,ne:skládací,snášecí,kompletovací,sešívací,drátovky,na vazbu', 'Bookbinding machinery (excl. machinery of heading 8441, general-purpose presses,'),
('84409000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti knihařských strojů', 'Parts of bookbinding machinery, n.e.s.'),
('84411010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Řezačky na papír,buničinu apod. kombinované se stroji pro odvíjení,převíjení', 'Combined reel slitting and re-reeling machines, for making up paper pulp, paper'),
('84411020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Řezačky ostatní podélné a příčné na papír,buničinu apod.,ne:viz sazebník', 'Slitting and cross cutting machines, for making up paper pulp, paper or paperboa'),
('84411030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Řezačky knihařské', 'Guillotines for paper or paperboard'),
('84411070', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Řezačky ostatní na buničinu,papír apod.,ne:viz sazebník', 'Cutting machines for paper or paperboard (other than bookbinding machinery of he'),
('84412000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje k výrobě pytlů,sáčků,obálek', 'Machines for making bags, sacks or envelopes out of paper pulp, paper or paperbo'),
('84413000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje k výrobě krabic,beden,pouzdertub,beček apod.,ne:tvarováním', 'Machines for making cartons, boxes, cases, tubes, drums or similar containers (o'),
('84414000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje k výrobě předmětů z papíroviny,papíru,lepenky,kartónu tvarováním', 'Machines for moulding articles in paper pulp, paper or paperboard (excl. drying'),
('84418000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje ostatní ke zpracování buničiny,papíru,lepenky,kartónu ostatní,ne:viz sazebník', 'Machinery for making up paper pulp, paper or paperboard, n.e.s.'),
('84419010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti řezaček na buničinu,papír,kartón apod.', 'Parts of cutting machines for making up paper pulp, paper or paperboard, n.e.s.'),
('84419090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti strojů ostatních k zpracování buničiny,papíru apod.,ne:řezaček', 'Parts of machinery for making up paper pulp, paper or paperboard, n.e.s.'),
('84423010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje fotosázecí', 'Phototypesetting and composing machines (excl. general purpose automatic data-pr'),
('84423091', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje,přístr.pro lití a sázení písma (např.lino-,mono-,intertypů),i se zař.pro odlévání', 'Machinery for type founding and typesetting "combined", e.g. linotypes, monotype'),
('84423099', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,příst.pro zhotovování desek,válců aj.tisk.pomůcek,ostatní,ne:viz sazebník', 'Machinery, apparatus and equipment for preparing or making plates, cylinders or'),
('84424000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti strojů pro sázení,lití písma,zhotovování tisk.pomůcek apod.', 'Parts of machinery, apparatus and equipment for preparing or making printing blo'),
('84425020', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,válce aj.tisk.pomůcky,s graf.znaky', 'Plates, cylinders and other printing components, with printing image "e.g. for g'),
('84425080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky,válce aj.tisk.pomůcky ostatní,ne:s graf.znaky', 'Lithographic stones, plates and cylinders, without printing image, but prepared'),
('84431100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje,přístr.tisk.ofsetové,kotoučové', 'Offset printing machinery, reel fed'),
('84431200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje,přístr.tisk.ofsetové,archový (plochý) tisk,archy <=22x36cm (kancelářského typu)', 'Offset printing machinery, sheet fed [office type], using sheets of a side <= 22'),
('84431310', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje,přístr.tisk.ofsetové,archový (plochý) tisk,použité', 'Offset printing machinery, sheet fed, used, taking sheets of a size > 22 x 36 cm'),
('84431331', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje,přístr.tisk.ofsetové,archový (plochý) tisk,archy >22x36cm,<=52x74cm', 'Offset printing machinery, sheet fed, new, taking sheets of a size <= 52 x 74 cm'),
('84431335', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje,přístr.tisk.ofsetové,archový (plochý) tisk,archy >52x74cm,<=74x107cm', 'Offset printing machinery, sheet fed, new, taking sheets of a size > 52 x 74 cm'),
('84431339', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje,přístr.tisk.ofsetové,archový (plochý) tisk,archy >74x107cm', 'Offset printing machinery, sheet fed, new, taking sheets of a size > 74 x 107 cm'),
('84431390', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje,přístr.tisk.ofsetové,ost.,ne:archový (plochý) tisk', 'Offset printing machinery (excl. reel feed and sheet feed)'),
('84431400', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje,přístr.tisk.typograf,kotoučové,ne:flexograf.', 'Letterpress printing machinery, reel fed (excl. flexographic printing machinery)'),
('84431500', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje,přístr.tisk.typograf,ne:kotoučové,flexograf.', 'Letterpress printing machinery (excl. flexographic printing and reel fed machine'),
('84431600', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje,přístr.tisk.flexograf.', 'Flexographic printing machinery'),
('84431700', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje,přístr.hlubokotiskové', 'Gravure printing machinery'),
('84431920', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje,přístr.pro tisk s pomůckami HS 8442,pro potisk textil.materiálů', 'Printing machinery for printing textile materials (excl. offset, flexographic, l'),
('84431940', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje,přístr.pro tisk s pomůckami HS 8442,pro použití při výr.polovodičů', 'Printing machinery for use in the production of semiconductors'),
('84431970', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje,přístr.pro tisk s pomůckami HS 8442,ostatní,ne:viz sazebník', 'Printing machinery used for printing by means of plates, cylinders and other pri'),
('84433110', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje s funkcemi kopírování max.12 monochr.str./min,fax.přenosu (vč.tisku),připojitelné k PC', 'Machines performing the functions of copying and facsimile transmission, whether'),
('84433191', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje kombin.,kopírující snímáním originálu a tiskem elektrostat.tisk.ústrojím,připojitelné k PC', 'Machines which perform at least one of the functions of printing or facsimile tr'),
('84433199', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje kombin.min.2 z funkcí tisku,kopír,fax.přenosu,připojitelné k PC,ostatní,ne:viz sazebník', 'Machines which perform two or more of the functions of printing, copying or facs'),
('84433210', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Tiskárny,připojitelné k PC,ne:kombinované', 'Printers capable of connecting to an automatic data processing machine or to a n'),
('84433230', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje telefaxové,připojitelné k PC,ne:kombinované', 'Facsimile machines capable of connecting to an automatic data processing machine'),
('84433291', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje kopírující snímáním originálu a tiskem elektrostat.tisk.ústrojím,připojitelné k PC,ne:kombinované', 'Machines only performing a copying function by scanning the original and printin'),
('84433293', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje kopírovací,s optickým systémem,připojitelné k PC,ne:kombinované', 'Machines only performing a copying function incorporating an optical system capa'),
('84433299', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje kopírovací,připojitelné k PC,ostatní,ne:kombinované,s optickým systémem', 'Machines only performing a copying function incorporating a non-optical system c'),
('84433910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje kopírující snímáním originálu a tiskem elektrostat.tisk.ústrojím,ne:kombinované,připojitelné k PC', 'Machines performing a copying function by scanning the original and printing the'),
('84433931', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje kopírovací,s optickým systémem,ne:kombinované,připojitelné k PC', 'Machines performing a copying function incorporating an optical system (excl. ca'),
('84433939', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje kopírovací,ostatní,ne:kombinované,s optickým systémem,připojitelné k PC', 'Machines only performing a copying function incorporating a non-optical system ('),
('84433990', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Tiskárny,telefaxové přístroje,ostatní,ne:kombinované,připojitelné k PC', 'Printers and facsimile machines (excl. those capable of connecting to an automat'),
('84439110', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,souč,přísluš.strojů,přístrojů podpoložky 8443 19 40', 'Parts and accessories of printing machinery for use in the production of semicon'),
('84439191', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,souč,přísluš.strojů,přístrojů pro tisk s pomůckami HS 8442,z litiny,lité oceli', 'Parts and accessories of printing machinery used for printing by means of plates'),
('84439199', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,souč,přísluš.strojů,přístrojů pro tisk s pomůckami HS 8442,ost.,ne:viz sazebník', 'Parts and accessories of printing machinery used for printing by means of plates'),
('84439910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sestavy elektronické pro stroje,přístroje pro tisk', 'Electronic assemblies of printers, copying machines and facsimile machines (excl'),
('84439990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,souč,přísluš.strojů,přístrojů pro tisk,ostatní,ne:viz sazebník', 'Parts and accessories of printers, copying machines and facsimile machines, n.e.'),
('84440010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje k vytlačování materiálů textilních syntetických,umělých', 'Machines for extruding filaments of man-made textile materials'),
('84440090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje k protahování,tvarování,stříhání,materiálů textil.syntetických,umělých', 'Machines for drawing, texturing or cutting filaments of man-made textile materia'),
('84451100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje mykací', 'Carding machines for preparing textile fibres'),
('84451200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje česací', 'Combing machines for preparing textile fibres'),
('84451300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje protahovací,předpřádací', 'Drawing or roving machines'),
('84451900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje pro přípravu vláken textil.ost.,ne:mykací,česací,protahovací,předpřádací', 'Machines for preparing textile fibres (excl. carding, combing, drawing or roving'),
('84452000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje textilní spřádací,dopřádací', 'Textile spinning machines (excl. extruding and drawing or roving machines)'),
('84453010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje textilní na zdvojování vláken', 'Textile doubling machines'),
('84453090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje textilní na splétání vláken', 'Textile twisting machines'),
('84454000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje textilní soukací (včetně útkových soukacích),navíjecí', 'Textile winding, incl. weft-winding, or reeling machines'),
('84459000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje textilní ostatní pro výrobu přízí,přípravu vláken apod.,ne:viz sazebník', 'Machines for producing textile yarns and machines for preparing textile yarns fo'),
('84461000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stavy tkalcovské pro tkaní textilií do šířky 30cm', 'Weaving machines for weaving fabrics of a width <= 30 cm'),
('84462100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stavy člunkové mechanické pro tkaní textilií šířky nad 30cm', 'Power looms for weaving fabrics of a width > 30 cm, shuttle type'),
('84462900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stavy člunkové ostatní pro tkaní textilií šířky nad 30cm,ne:mechanické', 'Hand looms for weaving fabrics of a width > 30 cm, shuttle type'),
('84463000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stavy tkalcovské bezčlunkové pro tkaní textilií šířky nad 30cm', 'Weaving machines for weaving fabrics of a width > 30 cm, shuttleless type'),
('84471100', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stavy kruhové pletací,průměr válce <=165cm', 'Circular knitting machines, with cylinder diameter <= 165 mm'),
('84471200', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stavy kruhové pletací,průměr válce >165cm', 'Circular knitting machines, with cylinder diameter > 165 mm'),
('84472020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Osnovní pletací stroje (vč.rašlových); stroje na zpevnění prošitím', 'Warp knitting machines, incl. Raschel type, and stitch-bonding machines'),
('84472080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Ostatní ploché pletací stroje', 'Flat knitting machines (excl. warp knitting machines, incl. Raschel type)'),
('84479000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje na výrobu tylu,krajek,výšivek,síťovin,střapců apod.,opřádací', 'Machines for making gimped yarn, tulle, lace, embroidery, trimmings, braid or ne'),
('84481100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Listovky,stroje žakárové a jiná pomoc.zaříz.textil.str.čís.8444,8445,8446,8447', 'Doobies and jacquards; card reducing, copying, punching or assembling machines f'),
('84481900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zařízení pomocná ostatní pro stavy tkalcovské,stroje pletací apod.,ne:viz sazebník', 'Auxiliary machinery for machines of heading 8444, 8445, 8446 or 8447 (excl. doob'),
('84482000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti strojů k vytlačování,tvarování ap.chem.textil.materiálů', 'Parts and accessories of machines for extruding, drawing, texturing or cutting m'),
('84483100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Povlaky mykací strojů pro přípravu textil.vláken,pro spřádání,navíjení apod.', 'Card clothing for machines for preparing textile fibres'),
('84483200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části strojů pro přípravu textilních vláken,ne:mykací povlaky', 'Parts and accessories of machines for preparing textile fibres, n.e.s. (other th'),
('84483300', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vřetena,křídla,dopřádací prstence,běžce,pro stroje spřádací prstencové', 'Spindles, spindle flyers, spinning rings and ring travellers, for machines of he'),
('84483900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části ostatní strojů pro přípravu vláken textilních,zařízení pomocná,ne:sazebník', 'Parts and accessories of machines of heading 8445, n.e.s.'),
('84484200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dostavy pro stavy tkalcovské,nitěnky,listy brdové', 'Reeds for looms, healds and heald-frames'),
('84484900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti,příslušenství ostatní stavů tkalcovských,ne:viz sazebník', 'Parts and accessories of weaving machines "looms" and their auxiliary machinery,'),
('84485110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Platiny k pletacím strojům,stavům', 'Sinkers used in forming stitches, for machines of heading 8447'),
('84485190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jehly a ost.výrobky pro vytváření ok k pletacím strojům,stavům', 'Needles and other articles used in forming stitches, for machines of heading 844'),
('84485900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,příslušenství ost.pletacích strojů,stavů,ne:platiny,jehly,k vytváření ok', 'Parts and accessories of machines of heading 8447, n.e.s.'),
('84490000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje k výrobě,konečné úpravě plsti,textilu netkaného,fdormy na výr.klobouků', 'Machinery for the manufacture or finishing of felt or nonwovens in the piece or'),
('84501111', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Plně automat.pračky,suché prádlo do 6kg,plnění shora,pro domácnost,prádelny', 'Fully-automatic household or laundry-type front-loading washing machines, of a d'),
('84501119', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Plně automat.pračky,suché prádlo do 6kg,plnění shora,pro domácnost,prádelny', 'Fully-automatic household or laundry-type top-loading washing machines, of a dry'),
('84501190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Plně automat.pračky,suché prádlo nad 6-10 kg,pro domácnost,prádelny', 'Fully-automatic household or laundry-type washing machines, of a dry linen capac'),
('84501200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pračky ost.s odstředivkami,suché prádlo do 10kg,pro domácnost,ne:plně automat.', 'Household or laundry-type washing machines, with built-in centrifugal drier (exc'),
('84501900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pračky ost.,suché prádlo do 10kg,pro domácnost,ne:s odstředivkou,plně automat.', 'Household or laundry-type washing machines, of a dry linen capacity <= 6 kg (exc'),
('84502000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pračky,suché prádlo nad 10kg,pro domácnost,prádelny', 'Laundry-type washing machines, of a dry linen capacity > 10 kg'),
('84509000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti praček pro domácnost,prádelny', 'Parts of household or laundry-type washing machines, n.e.s.'),
('84511000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje pro chemické čištění textilních materiálů', 'Dry-cleaning machines for made-up textile articles'),
('84512100', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sušičky,suché prádlo do 10kg', 'Drying machines, of a dry linen capacity <= 10 kg (excl. centrifugal driers)'),
('84512900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sušičky,suché prádlo nad 10kg', 'Drying machines for textile yarns, fabrics or made-up textile articles (excl. ma'),
('84513010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Žehlící stroje včetně mandlů elektricky vyhřívané,příkon do 2 500 W', 'Ironing machines and presses, electrically heated, of a power <= 2.500 W'),
('84513030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Žehlící stroje včetně mandlů elektricky vyhřívané,příkon nad 2 500 W', 'Ironing machines and presses, electrically heated, of a power > 2.500 W'),
('84513080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Žehlící stroje vč.mandlů ostatní,ne:elektricky vyhřívané', 'Ironing machines and presses (excl. such machines electrically heated and calend'),
('84514000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pračky průmyslové,stroje na bělení,barvení textilních materiálů', 'Machines for washing, bleaching or dyeing textile yarns, fabrics or made-up text'),
('84515000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje k navíjení,odvíjení,skládání,střihání,zoubkování,vykrajování textilií', 'Machines for reeling, unreeling, folding, cutting or pinking textile fabrics'),
('84518010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje k potahování podkladů při výrobě linolea,jiných podlahových krytin', 'Machines used in the manufacture of linoleum or other floor coverings for applyi'),
('84518030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje pro apretaci textilních materiálů a ostatní konečné úpravy', 'Machinery for dressing or finishing textile yarns, fabrics or other made-up text'),
('84518080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje propařovací na zvlhčování textilního materiálu', 'Machinery for coating or impregnating textile yarns, fabrics or other made-up te'),
('84519000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části sušiček,strojů žehlících,barvících,k potahování podkladů na lino apod.', 'Parts of machines for washing, cleaning, wringing, drying, ironing, pressing, bl'),
('84521011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Šicí stroje pro domácnost(bez rámu,stolku apod.),hodnota nad 65 Euro', 'Sewing machines "lock-stitch only" of the household type, with heads weighing <='),
('84521019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Šicí stroje pro domácnost bez rámu apod.,do 17kg,hodnota do 65 ECU', 'Sewing machines "lock-stitch only" of the household type, with heads weighing <='),
('84521090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Šicí stroje pro domácnost ostatní,hlavy jiných strojů šicích,ne:viz sazebník', 'Sewing machines and heads, of the household type (excl. lock-stitch sewing machi'),
('84522100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Šicí stroje automatické,ne:pro domácnost', 'Automatic sewing machines, industrial type'),
('84522900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Šicí stroje ostatní,ne:automatické,pro domácnost', 'Sewing machines, industrial type (excl. automatic units)'),
('84523010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MIL'), 'Jehly do šicích strojů s jedním plochým držákem', 'Sewing machine needles with single flat shank'),
('84523090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MIL'), 'Jehly do šicích strojů ostatní,ne:s jedním plochým držákem', 'Sewing machine needles (other than with single flat shank)'),
('84524000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nábytek,podstavce,kryty zvlášť upravené pro šicí stroje,jejich části,součásti', 'Furniture, bases and covers for sewing machines and parts thereof'),
('84529000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti ostatní strojů šicích,ne:viz sazebník', 'Parts of sewing machines, n.e.s.'),
('84531000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje k přípravě,vyčiňování,zpracování kůží,usní', 'Machinery for preparing, tanning or working hides, skins or leather (excl. dryin'),
('84532000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje pro výrobu,opravy obuvi', 'Machinery for making or repairing footwear of hides, skins or leather (excl. sew'),
('84538000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje ostatní pro výrobu,opravy výrobků z kůží,usní,ne:viz sazebník', 'Machinery for making or repairing articles of hides, skins or leather (excl. foo'),
('84539000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti strojů k zpracování kůží,usní,výrobků z nich', 'Parts of machinery for preparing, tanning or working hides, skins or leather or'),
('84541000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Konvertory', 'Converters of a kind used in metallurgy or in metal foundries'),
('84542000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kokily ingotové,licí pánve', 'Ingot moulds and ladles, of a kind used in metallurgy or in metal foundries'),
('84543010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje licí pro odlévání pod tlakem', 'Machines for casting under pressure of a kind used in metallurgy or in metal fou'),
('84543090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje licí ostatní,ne:pro odlévání pod tlakem', 'Casting machines of a kind used in metallurgy or in metal foundries (excl. machi'),
('84549000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti konvertorů,kokil,licích pánví,licích strojů pro metalurgii', 'Parts of converters, ladles, ingot moulds and casting machines of a kind used in'),
('84551000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Válcovací stolice,tratě na trubky', 'Mills for rolling metal tubes'),
('84552100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Válcovací stolice,tratě za tepla,kombinované za tepla a studena,ne:na trubky', 'Hot or combination hot and cold metal-rolling mills (excl. tubes mills)'),
('84552200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Válcovací stolice,tratě pracující za studena,ne:na trubky', 'Cold-rolling mills for metal (excl. tube mills)'),
('84553010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Válce pro stolice válcovací z litiny', 'Rolls for metal-rolling mills, of cast iron'),
('84553031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Válce pro stolice válc.za tepla i v konb.za studena z oceli zápustkové kované', 'Hot-rolling work-rolls; hot-rolling and cold-rolling back-up rolls, of open-die'),
('84553039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Válce pro stolice válcovací pracující za studena z oceli zápustkové kované', 'Cold-rolling work-rolls, for metal, of open-die forged steel'),
('84553090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Válce pro stolice válcovací z oceli tvářené,lité', 'Rolls for metal-rolling mills, of cast or wrought steel'),
('84559000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti ostatní pro válcovací stolice,tratě,ne:válce', 'Parts of metal-rolling mills, n.e.s.'),
('84561000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje obráběcí pracující pomocí laserů nebo jiných světelných,fotonových svazků', 'Machine tools for working any material by removal of material, operated by laser'),
('84562000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje obráběcí ultrazvukové', 'Machine tools for working any material by removal of material, operated by ultra'),
('84563011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje obráběcí elektroerozivní číslicově řízené pro dělení materiálu', 'Machine tools for working any material by removal of material, operated by elect'),
('84563019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje obráběcí elektroerozivní číslicově řízené ost.,ne:pro dělení materiálu', 'Machine tools for working any material by removal of material, operated by elect'),
('84563090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje obráběcí elektroerozivní ostatní,ne:číslicově řízené', 'Machine tools for working any material by removal of material, operated by elect'),
('84569000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje obráběcí pomocí el-chem.reakcí,el.svazků,ion.záření,oblouk.výbojů v plazmatu', 'Machine tools for working any material by removal of material, operated by elect'),
('84571010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Obráběcí centra horizontální', 'Horizontal machining centres for working metal'),
('84571090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Obráběcí centra ostatní,ne:horizontální', 'Machining centres for working metal (excl. horizontal machining centres)'),
('84572000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stavebnicové stroje jednopolohové', 'Unit construction machines "single station", for working metal'),
('84573010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje stavebnicové vícepolohové číslicově řízené', 'Multi-station transfer machines for working metal, numerically controlled'),
('84573090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje stavebnicové vícepolohové ostatní,ne:číslicově řízené', 'Multi-station transfer machines for working metal, not numerically controlled'),
('84581120', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Soustruhy horizontální-soustružnická obráběcí centra číslicově řízená', 'Horizontal turning centres for removing metal, numerically controlled'),
('84581141', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Soustruhy horizontální-jednovřetenové automatické číslicově řízené', 'Horizontal single spindle automatic lathes for removing metal, numerically contr'),
('84581149', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Soustruhy horizontální-vícevřetenové automatické číslicově řízené', 'Horizontal multi-spindle automatic lathes for removing metal, numerically contro'),
('84581180', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Soustruhy horizontální ostatní číslicově řízené,ne:viz sazebník', 'Horizontal lathes for removing metal, numerically controlled (excl. turning cent'),
('84581900', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Soustruhy horizontální,ne:číslicové řízené', 'Horizontal lathes, incl. turning centres, for removing metal, not numerically co'),
('84589120', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Soustruhy ost.-soustružnická obráběcí centra číslicově řízená,ne:horizontální', 'Turning centres for removing metal, numerically controlled (excl. horizontal tur'),
('84589180', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Soustruhy ost.číslicově řízené,ne:horizontální,obráběcí centra', 'Lathes for removing metal, numerically controlled (excl. horizontal lathes and t'),
('84589900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Soustruhy ostatní,ne: horizontální,číslicově řízené', 'Lathes, incl. turning centres, for removing metal, not numerically controlled (e'),
('84591000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje obráběcí s hlavou pohyblivou pro vrtání,vyvrtávání,frézování,závity', 'Way-type unit head machines for drilling, boring, milling, threading or tapping'),
('84592100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje vrtací ostatní číslicově řízené,ne:s pohyblivou hlavou,soustruhy', 'Drilling machines for working metal, numerically controlled (excl. way-type unit'),
('84592900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje vrtací ostatní,ne:číslicově řízené,s pohyblivou hlavou,soustruhy', 'Drilling machines for working metal, not numerically controlled (excl. way-type'),
('84593100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje kombinované vyvrtávací-frézovací číslicově řízené', 'Boring-milling machines for metals, numerically controlled (excl. way-type unit'),
('84593900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje kombinované vyvrtávací-frézovací ostatní,ne:číslicově řízené', 'Boring-milling machines for metals, not numerically controlled (excl. way-type u'),
('84594010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje vyvrtávací ostatní číslicově řízené,ne:vyvrtávací-frézovací', 'Boring machines for metals, numerically controlled (excl. way-type unit head mac'),
('84594090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje vyvrtávací ostatní,ne:číslicově řízené,vyvrtávací-frézovací', 'Boring machines for metals, not numerically controlled (excl. way-type unit head'),
('84595100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Frézky konzolové číslicově řízené', 'Milling machines for metals, knee-type, numerically controlled'),
('84595900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Frézky konzolové ostatní,ne:číslicově řízené', 'Milling machines for metals, knee-type, not numerically controlled'),
('84596110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Frézky nástrojové číslicově řízené', 'Tool milling machines for metals, numerically controlled'),
('84596190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Frézky ostatní číslicově řízené,ne:viz sazebník', 'Milling machines for metals, numerically controlled (excl. way-type unit head ma'),
('84596910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Frézky nástrojové ostatní,ne:číslicově řízené', 'Tool milling machines for metals, not numerically controlled'),
('84596990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Frézky ostatní,ne:viz sazebník', 'Milling machines for metals, not numerically controlled (excl. way-type unit hea'),
('84597000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje obráběcí ostatní k řezání závitů vnitřních,vnějších,ne:viz sazebník', 'Threading or tapping machines for metals (excl. way-type unit head machines)'),
('84601100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Brusky na plocho s přesností nejméně 0,01 mm číslicově řízené', 'Flat-surface grinding machines, for working metal, in which the positioning in a'),
('84601900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Brusky na plocho s přesností nejméně 0,01 mm ostatní,ne:číslicově řízené', 'Flat-surface grinding machines, for working metal, in which the positioning in a'),
('84602111', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Brusky hrotové číslic.řízené pro válcové povrchy-vnitřní broušení', 'Internal cylindrical grinding machines for finishing metals, metal carbides or c'),
('84602115', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Brusky s přesností nejméně 0,01 mm pro válc. povrchy bezhroté pro vnitřní broušení číslicově řízené', 'Centreless grinding machines, for finishing metals, metal carbides or cermets, i'),
('84602119', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Brusky s přesností nejméně 0,01 mm pro válc. povrchy ostatní pro vnitřní broušení číslicově řízené', 'Grinding machines for cylindrical surfaces, for finishing metals, metal carbides'),
('84602190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Brusky s přesností nejméně 0,01 mm číslicově řízené,ne:pro válcové povrchy', 'Grinding machines, for working metals, metal carbides or cermets, in which the p'),
('84602910', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Brusky s přesností nejméně 0,01 mm pro válcové povrchy,ne:číslicově řízené', 'Grinding machines for cylindrical surfaces, for finishing metals, metal carbides'),
('84602990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Brusky ostatní s přesností nejméně 0,01 mm,ne:číslicově řízené,pro válcové povrchy', 'Grinding machines for working metals, metal carbides or cermets, in which the po'),
('84603100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje k ostření (brusky nástrojů,obráběcích nožů) číslicově řízené', 'Sharpening "tool or cutter grinding" machines, numerically controlled'),
('84603900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje k ostření ostatní (brusky nástrojů,obráběcích nožů),ne:číslicově řízené', 'Sharpening "tool or cutter grinding" machines, not numerically controlled'),
('84604010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje honovací a lapovací číslicově řízené', 'Honing or lapping machines, for finishing metals, metal carbides or cermets, num'),
('84604090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje honovací a lapovací ostatní,ne:číslicově řízené', 'Honing or lapping machines, for finishing metals, metal carbides or cermets, not'),
('84609010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje brousící apod.ost.,přesnost do 0,01mm,mikrometrický nastavovací system', 'Machines for deburring or polishing metals, metal carbides or cermets, in which'),
('84609090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje brousící apod.ostatní,ne:viz sazebník', 'Machines for deburring, grinding, or polishing metals, metal carbides or cermets'),
('84612000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Obrážečky vodorovné,svislé na kovy', 'Shaping or slotting machines, for working metals, metal carbides or cermets'),
('84613010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje protahovací,protlačovací číslicově řízené', 'Broaching machines for working metal, metal carbides or cermets, numerically con'),
('84613090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje protahovací,protlačování ostatní,ne:číslicově řízené', 'Broaching machines for working metal, metal carbides or cermets, not numerically'),
('84614011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje k zhotovování ozubených čelních kol číslicově řízené', 'Gear cutting machines, incl. abrasive gear cutting machines, for cutting cylindr'),
('84614019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje k zhotovování ozubených čelních kol ostatní,ne:číslicově řízené', 'Gear cutting machines, incl. abrasive gear cutting machines, for cutting cylindr'),
('84614031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje k zhotovování ozubených kol ost.číslicově řízené,ne:ozub.kol čelních', 'Gear cutting machines, incl. abrasive gear cutting machines, not for cylindrical'),
('84614039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje k zhotovování ozubených kol ost.,ne:číslicově řízené,ozub.kol čelních', 'Gear cutting machines, incl. abrasive gear cutting machines, not for cylindrical'),
('84614071', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje k dokončování ozubených kol,mikrometrický systém do 0,01mm číslicově řízené', 'Gear finishing machines, incl. abrasive gear cutting machines, in which the posi'),
('84614079', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje k dokončování ozubených kol ost.,mikrometr.syst.do 0,01mm,ne:číslicově řízené', 'Gear finishing machines, incl. abrasive gear cutting machines, in which the posi'),
('84614090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje k dokončování ozubených kol ost.,ne:mikrometrický systém,číslicově řízené', 'Gear finishing machines for working metals, metal carbides or cermets (excl. tho'),
('84615011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pily strojní kotoučové', 'Circular saws for working metals, metal carbides or cermets (excl. machines for'),
('84615019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pily strojní ostatní,ne:kotoučové', 'Sawing machines for working metals, metal carbides or cermets (excl. machines fo'),
('84615090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje odřezávací', 'Cutting-off machines for working metals, metal carbides or cermets (excl. machin'),
('84619000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje obráběcí ostatní pracující metodou úběru,ne:viz sazebník', 'Planing machines and other machine tools for working metals, metal carbides or c'),
('84621010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje ke kování,lisování v zápustce,buchary číslicově řízené', 'Forging or die-stamping machines, incl. presses, and hammers, numerically contro'),
('84621090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje ke kování,lisování v zápustce,buchary ostatní,ne:číslicově řízené', 'Forging or die-stamping machines, incl. presses, and hammers, not numerically co'),
('84622110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje k tváření plochých kovových výrobků číslicově řízené', 'Bending, folding, straightening or flattening machines, incl. presses, numerical'),
('84622180', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje k tváření kovových výrobků číslicově řízené ost.,ne:k tváření plochých výr.', 'Bending, folding, straightening or flattening machines, incl. presses, numerical'),
('84622910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje k tváření plochých výrobků ostatní,ne:číslicově řízené', 'Bending, folding, straightening or flattening machines, incl. presses, not numer'),
('84622991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje k tváření kovů hydraulické,ne:číslicově řízené,k tváření plochých výr.', 'Bending, folding, straightening or flattening machines, incl. presses, hydraulic'),
('84622998', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje k tváření kovů ohýbáním,drážkováním apod.ostatní,ne:viz sazebník', 'Bending, folding, straightening or flattening machines, incl. presses, not hydra'),
('84623100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje střihací vč.lisů číslicově řízené', 'Shearing machines, incl. presses, numerically controlled, for working metal (oth'),
('84623910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje střihací na výrobky ploché,ne:číslicově řízené', 'Shearing machines, incl. presses, not numerically controlled, for working flat m'),
('84623991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje střihací ostatní,ne:číslicově řízené,hydraulické,na ploché výrobky', 'Shearing machines, incl. presses, hydraulic, not numerically controlled, for wor'),
('84623999', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje střihací ostatní,ne:číslicově řízené,hydraulické,na ploché výrobky', 'Shearing machines, incl. presses, not hydraulic, not numerically controlled, for'),
('84624110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje děrovací,probíjecí,nařezávací apod.na výrobky ploché číslicově řízené', 'Punching or notching machines, incl. presses, and combined punching and shearing'),
('84624190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje děrovací,probíjecí apod.číslicově řízené ost.,ne:na výrobky ploché', 'Punching or notching machines, incl. presses, and combined punching and shearing'),
('84624910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje děrovací,probíjecí,nařezávací apod.na výrobky ploché,ne:číslicově řízené', 'Punching or notching machines, incl. presses, and combined punching and shearing'),
('84624990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje děrovací,probíjecí apod.,ost.,ne:číslicově řízené,na výrobky ploché', 'Punching or notching machines, incl. presses, and combined punching and shearing'),
('84629120', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Lisy hydraulické číslicově řízené,na tvarování kovů,ne:viz sazebník', 'Hydraulic presses, numerically controlled, for working metals (excl. forging, be'),
('84629180', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Lisy hydraulické jiné než číslicově řízené,na tvarování kovů,ne:viz sazebník', 'Hydraulic presses, not numerically controlled, for working metal (excl. forging,'),
('84629920', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Lisy nehydraulické číslicově řízené,na tvarování kovů,ne:viz sazebník', 'Presses, not hydraulic, numerically controlled, for working metals (excl. forgin'),
('84629980', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Lisy nehydraulické jiné než číslicově řízené,na tvarování kovů,ne:viz sazebník', 'Presses, not hydraulic, not numerically controlled, for working metals (excl. fo'),
('84631010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stolice tažné k výrobě drátů', 'Draw-benches for metal wire'),
('84631090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stolice tažné k výrobě tyčí,trubek,profilů apod.výrobků', 'Draw-benches for metal bars, tubes, profiles, or the like (excl. draw-benches fo'),
('84632000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Válcovačky na závity', 'Thread rolling machines, for working metal'),
('84633000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje k tažení drátů,ne:tažné stolice', 'Machine tools for working metal wire, without removing material (excl. wire bend'),
('84639000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Tvářecí stroje pro opracování kovů (ne na principu úběru) ostatní,ne:viz sazebník', 'Machine tools for working metal, sintered metal carbides or cermets, without rem'),
('84641000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pily strojní na řezání kamene,keramiky,betonu,osinkocementu,skla za studena', 'Sawing machines for working stone, ceramics, concrete, asbestos-cement or like m'),
('84642011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje brousicí,lešticí na opracování optického skla', 'Grinding or polishing machines, for cold-working optical glass'),
('84642019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje brousicí,lešticí na opracování skla ostatní,ne:na optické sklo', 'Grinding or polishing machines, for cold-working glass (other than optical glass'),
('84642080', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje brousicí,lešticí ostatní,ne:pro opracování skla', 'Grinding or polishing machines, for working stones, concrete, asbestos cement or'),
('84649000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje obráběcí na kámen,keramické hmoty,beton apod.ostatní,ne:viz sazebník', 'Machine tools for working stones, concrete, asbestos cement or similar mineral s'),
('84651010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje obráběcí na dřevo,korek,plast apod.hmoty,ruční přenos obrobku', 'Machines for working wood, cork, bone, hard rubber, hard plastics or similar har'),
('84651090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje obráběcí na dřevo,korek,plast apod.hmoty,automatický přenos obrobku', 'Machines for working wood, cork, bone, hard rubber, hard plastics or similar har'),
('84659110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Strojní pily pásové na dřevo,korek,plast a pod.materiály', 'Bandsaws for working wood, cork, bone, hard rubber, hard plastics or similar har'),
('84659120', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Strojní pily kotoučové na dřevo,korek,plast apod.materiály', 'Circular saws for working wood, cork, bone, hard rubber, hard plastics or simila'),
('84659190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Strojní pily ostatní na dřevo,korek,plast apod.materiály,ne:kotoučové,pásové', 'Sawing machines for working wood, cork, bone, hard rubber, hard plastics or simi'),
('84659200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje na hoblování,frézování,tvarování(řezáním) dřeva,korku,plastu apod.materiálů', 'Planing, milling or moulding -by cutting- machines, for working wood, cork, bone'),
('84659300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje k broušení,hlazení,leštění dřeva,korku,plastu apod.materiálů', 'Grinding, sanding or polishing machines for working wood, cork, bone, hard rubbe'),
('84659400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje ohýbací,spojovací na dřevo,korek,plast apod.materiály', 'Bending or assembling machines for working wood, cork, bone, hard rubber, hard p'),
('84659500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vrtačky,obrážečky na dřevo,korek,ebonit,plast apod.materiály', 'Drilling or mortising machines for working wood, cork, bone, hard rubber, hard p'),
('84659600', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje k štípání,krájení (dýhy),loupání (dřeva)', 'Splitting, slicing or paring machines, for working wood'),
('84659900', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje obráběcí ostatní na dřevo,korek,plasty apod.materiály,ne:viz sazebník', 'Machine tools for working wood, cork, bone, hard rubber, hard plastics or simila'),
('84661020', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástrojové držáky-upínací trny,upínací pouzdra,objímky', 'Arbors, collets and sleeves for use as tool holders in machine tools, incl. tool'),
('84661031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástrojové držáky pro soustruhy ost.,ne:upínací trny,upínací pouzdra,objímky', 'Tool holders for lathes (excl. arbors, collets and sleeves)'),
('84661038', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástrojové držáky ostatní,ne:upínací trny,upínací pouzdra,objímky,držáky pro soustruhy', 'Tool holders for machine tools, incl. tool holders for any type of tool for work'),
('84661080', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hlavy závitořezné samočinné', 'Self-opening dieheads for machine tools'),
('84662020', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Upínací zařízení-pro specifické použití,sady upínacích zařízení a jejich části', 'Work holders for machine tools in the form of jigs and fixtures for specific app'),
('84662091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Upínací zařízení ostatní pro soustruhy,ne:sady,specifické použití', 'Work holders for lathes (excl. work holders in the form of jigs and fixtures for'),
('84662098', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Upínací zařízení pro stroje obráběcí ost.,ne:pro soustruh,sady,specifické použití', 'Work holders for machine tools (excl. work holders for lathes and in the form of'),
('84663000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přídavná speciální zařízení k obráběcím strojům,dělící hlavy', 'Dividing heads and other special attachments for machine tools, n.e.s.'),
('84669120', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti,přísluš.strojů čísla 8464 z litiny,lité oceli', 'Parts and accessories for machine tools for working stone, ceramics, concrete, a'),
('84669195', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti,přísluš.strojů čísla 8464 ostatní,ne:z litiny,lité oceli', 'Parts and accessories for machine tools for working stone, ceramics, concrete, a'),
('84669220', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti,přísluš.strojů čísla 8465 z litiny,lité oceli', 'Parts and accessories for machine tools for working wood, cork, bone, hard rubbe'),
('84669280', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti,přísluš.strojů čísla 8465 ostatní,ne:z litiny,lité oceli', 'Parts and accessories for machine tools for working wood, cork, bone, hard rubbe'),
('84669300', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti,přísluš.strojů čísel 8456 až 8461', 'Parts and accessories for machine tools for working metal by removing material,'),
('84669400', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti,přísluš.strojů čísel 8462 nebo 8463', 'Parts and accessories for machine tools for working metal without removing mater'),
('84671110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nářadí ruční pneumatické rotační i rotačně-nárazové na kovy', 'Tools for working in the hand, pneumatic, rotary type, for working metal'),
('84671190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nářadí ruční pneumatické rotační i rotačně-nárazové ostatní,ne:na kovy', 'Tools for working in the hand, pneumatic, rotary type (other than for working me'),
('84671900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nářadí ruční pneumatické ostatní,ne:rotační,rotačně-nárazové', 'Pneumatic tools for working in the hand, non-rotary type'),
('84672110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vrtačky ruční s vestavěným el. motorem bez vnějšího zdroje napájení', 'Drills of all kinds for working in the hand, with self-contained electric motor'),
('84672191', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vrtačky ruční s vestavěným el. motorem elektropneumatické', 'Electropneumatic drills of all kinds for working in the hand'),
('84672199', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vrtačky ruční s vestavěným el. motorem ost.,ne:bez vnějšího zdr.napáj.,elektropneumatické', 'Drills of all kinds for working in the hand, with self-contained electric motor'),
('84672210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pily ruční řetězové s vestavěným el. motorem', 'Chainsaws for working in the hand, with self-contained electric motor'),
('84672230', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pily ruční okružní s vestavěným el. motorem', 'Circular saws for working in the hand, with self-contained electric motor'),
('84672290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pily ruční s vestavěným el. motorem ostatní,ne:řetězové,okružní', 'Saws for working in the hand, with self-contained electric motor (excl. chainsaw'),
('84672910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje ruční s vestavěným el. motorem pro opracování textilních materiálů', 'Electromechanical tools for working in the hand, with self-contained electric mo'),
('84672930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Nástroje ruční s vestavěným el.motorem bez vnějšího zdroje napájení', 'Electromechanical tools for working in the hand, with self-contained electric mo'),
('84672951', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Brusky ruční úhlové s vestavěným el.motorem', 'Angle grinders for working in the hand, with self-contained electric motor, oper'),
('84672953', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Brusky ruční pásové s pískovým papírem s vestavěným el. motorem', 'Belt sanders for working in the hand, with self-contained electric motor, operat'),
('84672959', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Brusky ruční ostatní s vestavěným el.motorem,ne:úhlové,pásové', 'Grinders and sanders, for working in the hand, with self-contained electric moto'),
('84672970', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Srovnávačky (hoblíky) ruční s vestavěným el.motorem', 'Planers for working in the hand, with self-contained electric motor, operating w'),
('84672980', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Střihače živých plotů a trávníků ruční s vestavěným el.motorem', 'Hedge trimmers and lawn edge cutters, for working in the hand, with self-contain'),
('84672990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Nástroje ruční s vestavěným el.motorem ostatní,ne:viz sazebník', 'Electromechanical tools for working in the hand, with self-contained electric mo'),
('84678100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pily řetězové s motorem neelektrickým', 'Chainsaws for working in the hand, with self-contained non-electric motor'),
('84678900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nářadí ruční ostatní s motorem neelektrickým', 'Tools for working in the hand, hydraulic or with self-contained non-electric mot'),
('84679100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti pil řetězových s motorem neelektrickým', 'Parts of chainsaws, for working in the hand, with self-contained electric or non'),
('84679200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti nářadí pneumatického', 'Parts of pneumatic tools for working in the hand, n.e.s.'),
('84679900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti nářadí ručního ostatní,ne:viz sazebník', 'Parts of pneumatic tools for working in the hand, hydraulic or with self-contain'),
('84681000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hořáky pájecí ruční', 'Hand-held blow pipes, gas-operated, for soldering, brazing or welding'),
('84682000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje plynové ostatní k pájení,řezání,povrch.kalení apod.,ne:hořáky', 'Gas-operated machinery and apparatus for soldering, brazing, welding or surface'),
('84688000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje ostatní k pájení,svařování,řezání,ne:laserové', 'Machinery and apparatus for welding, not gas-operated (excl. electric machines a'),
('84689000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části strojů k pájení,svařování,řezání,povrchovému kalení', 'Parts of machinery and apparatus for soldering, brazing, welding or surface temp'),
('84690010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje na zpracování textu', 'Word-processing machines (excl. automatic data-processing machines and units the'),
('84690091', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Psací stroje elektrické,ne:tiskárny čísla 8443', 'Typewriters, electric (excl. units for automatic data-processing machines of hea'),
('84690099', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Psací stroje ostatní,ne:elektrické,tiskárny čísla 8443', 'Typewriters, non-electric'),
('84701000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalkulacky elektronicke bez vn.zdroje energie', 'Electronic calculators capable of operation without an external source of electr'),
('84702100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje pocitaci elektronicke s tiskarnou', 'Electronic calculating machines incorporating a printing device, with mains conn'),
('84702900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje pocitaci elektronicke bez tiskarny', 'Electronic calculating machines not incorporating a printing device, with mains'),
('84703000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje počítací ostatní,ne:elektronické', 'Calculating machines, non-electronic'),
('84705000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pokladny registrační', 'Cash registers incorporating a calculating device'),
('84709000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje frankovací,navydávání lístků apod.se zařízením počítacím,ne:viz sazebník', 'Accounting machines, postage-franking machines, ticket-issuing machines and simi'),
('84713000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení pro autom.zprac.dat přenosná,<10kg,obsah.min.CPU+kláv+displej', 'Data-processing machines, automatic, portable, weighing <= 10 kg, consisting of'),
('84714100', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení pro autom.zprac.dat,obsah.CPU+vstup/výstup jednotku,i kombinované', 'Data-processing machines, automatic, comprising in the same housing at least a c'),
('84714900', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení pro autom.zprac.dat,ve formě systémů', 'Data-processing machines, automatic, presented in the form of systems "comprisin'),
('84715000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zpracovatelské jednotky jiné než položek 8471.41 nebo 8471.49', 'Processing units for automatic data-processing machines, whether or not containi'),
('84716060', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Klávesnice', 'Keyboards for automatic data-processing machines, whether or not containing stor'),
('84716070', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Jednotky vstupní,výstupní pro zařízení pro autom.zprac.dat ost.,ne:klávesnice', 'Input or output units for automatic data-processing machines, whether or not con'),
('84717020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Jednotky paměťové základní pro zařízení na zprac.dat', 'Central storage units for automatic data-processing machines'),
('84717030', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Jednotky paměťové diskové optické,vč.magnetooptických,pro zařízení pro autom.zprac.dat', 'Disk storage units for automatic data-processing machines, optical, incl. magnet'),
('84717050', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Jednotky paměťové diskové s pevným diskem pro zařízení pro autom.zprac.dat', 'Hard disk storage drives for automatic data-processing machines, neither optical'),
('84717070', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Jednotky paměťové diskové ostatní pro zařízení pro autom.zprac.dat,ne:viz sazebník', 'Disk storage units for automatic data-processing machines, neither optical nor m'),
('84717080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Jednotky paměťové páskové magnetické', 'Magnetic tape storage units for automatic data-processing machines (excl. centra'),
('84717098', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Jednotky paměťové ostatní,ne:viz sazebník', 'Storage units for automatic data-processing machines (excl. disk, magnetic tape'),
('84718000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Jednotky zařízení pro autom.zprac.dat ostatní,ne:viz sazebník', 'Units for automatic data-processing machines (excl. processing units, input or o'),
('84719000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení pro autom.zprac.dat ostatní,ne:viz sazebník', 'Magnetic or optical readers, machines for transcribing data onto data media in c'),
('84721000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje rozmnožovací kancelářské', 'Duplicating machines "hectograph or stencil" (excl. printing machines and photoc'),
('84723000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje pro práci s korespondencí (třídění,zavírání apod.),známkování', 'Machines for sorting or folding mail or for inserting mail in envelopes or bands'),
('84729010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje pro třídění,počítání,balení mincí', 'Coin-sorting, coin-counting or coin-wrapping machines'),
('84729030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Automatické bankovní stroje (bankomaty)', 'Automatic teller machines'),
('84729070', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jiné kancelářské stroje ostatní,ne:viz sazebník', 'Office machines, n.e.s.'),
('84731011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sestavy tištěných obvodů pro výrobky položky 8469 00 10', 'Electronic assemblies of word-processing machines of heading 8469, n.e.s.'),
('84731019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,souč.strojů čísla 8469 ost.,ne:sestavy tišť.obvodů pro výr.pol.8469 00 10', 'Electronic assemblies of typewriters of heading 8469, n.e.s.'),
('84731090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti,příslušenství strojů psacích,strojů k zpracování textu', 'Parts and accessories of typewriters or word-processing machines of heading 8469'),
('84732110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Elektronické sestavy k elektronickým kalkulačkám,počítacím strojům', 'Electronic assemblies of electronic calculators of subheading 8470.10, 8470.21 o'),
('84732190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti k pol.847010,847021,847029 hlasovým výstupem pro nevidomé', 'Parts and accessories of electronic calculators of subheading 8470.10, 8470.21 o'),
('84732910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Elektronické sestavy k ostatním strojům čísla 8470,ne:viz sazebník', 'Electronic assemblies of accounting machines, cash registers or other machines,'),
('84732990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti ost.strojů počítacích,účtovacích,reg.pokladen apod.,ne:viz sazebník', 'Parts and accessories of non-electronic calculators, for accounting machines, ca'),
('84733020', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Elektronické sestavy k zařízení čísla 8471', 'Electronic assemblies of automatic data-processing machines or for other machine'),
('84733080', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti k zařízení čísla 8471,ne:elektronické sestavy', 'Parts and accessories of automatic data-processing machines or for other machine'),
('84734011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Elektronické sestavy ke strojům podpoložky 8472 90 30', 'Electronic assemblies of automatic teller machines of subheading 8472.90.30, n.e'),
('84734018', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Elektronické sestavy ke strojům čísla 8472 ost.,ne:ke strojům podpoložky 8472 90 30', 'Electronic assemblies of other office machines of heading 8472, n.e.s. (excl. of'),
('84734080', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti ke strojům čísla 8472,ne:elektronické sestavy', 'Parts and accessories of other office machines of heading 8472, n.e.s. (excl. el'),
('84735020', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Elektronické sestavy ke dvěma či více strojům čísel 8469 až 8472', 'Electronic assemblies equally suitable for use with two or more electronic typew'),
('84735080', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti ke dvěma či více strojům čísel 8469 až 8472,ne:elektronické sestavy', 'Parts and accessories equally suitable for use with two or more typewriters, wor'),
('84741000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístr.k třídění,prosévání,oddělování,praní zemin,nerostných hmot apod.', 'Sorting, screening, separating or washing machines for solid mineral substances,'),
('84742000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje k drcení,mletí', 'Crushing or grinding machines for solid mineral substances'),
('84743100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Míchačky malty,betonu', 'Concrete or mortar mixers (excl. those mounted on railway wagons or lorry chassi'),
('84743200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Míchačky živičných minerálních hmot', 'Machines for mixing mineral substances with bitumen'),
('84743900', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje k míchání,hnětení ostatní,ne:malty,betonu,živičných minerálních hmot', 'Machinery for mixing or kneading solid mineral substances, incl. those in powder'),
('84748010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje k aglomeraci,lisování nebo tváření keramických hmot', 'Machinery for agglomerating, shaping or moulding ceramic paste'),
('84748090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje na tvarování hmot ostatní,ne:viz sazebník', 'Machinery for agglomerating, shaping or moulding solid mineral fuels, unhardened'),
('84749010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části strojů k třídění,drcení,tváření apod.hmot nerostných z litiny,lité oceli', 'Parts of machinery of heading 8474, of cast iron or cast steel'),
('84749090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části strojů k třídění,drcení apod.hmot nerostných ost.,ne:z litiny,lité oceli', 'Parts of machinery of heading 8474 (excl. of cast iron or cast steel)'),
('84751000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje k montáži žárovek,elektronových lamp,trubic,elektronek apod.výrobků', 'Machines for assembling electric or electronic lamps, tubes or valves or flashbu'),
('84752100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje na výrobu optických vláken a jejich předlisků za tepla', 'Machines for making optical fibres and preforms thereof'),
('84752900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje ostatní k výrobě,opracování skla,skleněných výrobků za tepla,ne:sazebník', 'Machines for manufacturing or hot working glass or glassware (excl. machines for'),
('84759000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části strojů k mont.žárovek,elektronek apod.výr.,výrobu a oprac.skla za tepla', 'Parts of machines for assembling electric or electronic lamps, tubes or valves o'),
('84762100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Automaty pro prodej nápojů se zabudovaným chladícím nebo ohřívacím zařízením', 'Automatic beverage-vending machines incorporating heating or refrigerating devic'),
('84762900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Automaty pro prodej nápojů ostatní,ne:se zabudovaným chlazením,ohřevem', 'Automatic beverage-vending machines, without heating or refrigerating devices'),
('84768100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Automaty prodejní ost.obsahující zabudované ohřívací,chladící zař.,ne:na nápoje', 'Automatic goods-vending machines incorporating heating or refrigerating devices'),
('84768900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Automaty prodejní ost,ne:na nápoje,zabudované chlazení,ohřev', 'Automatic goods-vending machines, without heating or refrigerating devices; mone'),
('84769000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti automatů prodejních', 'Parts of automatic goods-vending machines, incl. money changing machines, n.e.s.'),
('84771000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lisy vstřikovací pro zpracování kaučuku,plastů', 'Injection-moulding machines for working rubber or plastics'),
('84772000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lisy vytlačovací pro zpracování kaučuku,plastů', 'Extruders for working rubber or plastics'),
('84773000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje k tvarování kaučuku,plastů vyfukováním', 'Blow-moulding machines for working rubber or plastics'),
('84774000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje k tvarování kaučuku,plastů podtlakem,stroje na tvarování za tepla', 'Vacuum-moulding machines and other thermoforming machines for working rubber or'),
('84775100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje k lisování,obnovování(protektorování) pneumatik,lisování,tvarování duší', 'Machinery for moulding or retreading pneumatic tyres or for moulding or otherwis'),
('84775910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lisy ostatní na kaučuk,plasty,ne:vstřikovací,vytlačovací', 'Presses for moulding or otherwise forming products from rubber or plastics (excl'),
('84775980', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje na zpracování kaučuku,plastů ostatní,ne:viz sazebník', 'Machinery for moulding or otherwise forming products from rubber or plastics (ex'),
('84778011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje a přístroje pro zpracování reaktivních pryskyřic', 'Machines for processing reactive resins'),
('84778019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje a přístroje pro zhotovování pěnových výr.ost.,ne:reaktivních pryskyřic', 'Machines for the manufacture of foam products (excl. for processing reactive res'),
('84778091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje ostatní na zpracování kaučuku,plastů', 'Size reduction equipment for working rubber or plastics'),
('84778093', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje na zpracování kaučuku,plastů-mixery,hnětače,míchače', 'Mixers, kneaders and agitators, for preparing rubber or plastics'),
('84778095', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje na zpracování kaučuku,plastů ostatní-řezací,štípací,loupací', 'Cutting, splitting and peeling machines for working rubber or plastics or for th'),
('84778099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje na zpracování kaučuku,plastů ostatní,ne:viz sazebník', 'Machinery for working rubber or plastics or for the manufacture of products from'),
('84779010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti strojů na zpracování kaučuku,plastů z litiny,lité oceli', 'Parts of machinery for working rubber or plastics or for the manufacture of prod'),
('84779080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti strojů na zpracování kaučuku,plastů ostatní,ne:viz sazebník', 'Parts of machinery for working rubber or plastics or for the manufacture of prod'),
('84781000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje k přípravě a zpracování tabáku', 'Machinery for preparing or making up tobacco (excl. dryers and other heating equ'),
('84789000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části strojů,přístrojů k přípravě a zpracování tabáku', 'Parts of machinery for preparing or making up tobacco, n.e.s.'),
('84791000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje s vlastní individ.funkcí pro práce veřejné,stavebnictví apod.', 'Machinery for public works, building or the like, n.e.s.'),
('84792000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje k extrakci nebo přípravu živočišných,ztužených rostlinných tuků,olejů', 'Machinery for the extraction or preparation of animal or fixed vegetable fats or'),
('84793010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lisy k výrobě desek dřevovláknitých,třískových z dřeva,korku', 'Presses for the manufacture of particle board or fibre building board of wood or'),
('84793090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje pro zpracování dřeva,korku ostatní,ne:lisy,pol.8465', 'Machinery for treating wood or cork (excl. dryers, spray guns and the like, mach'),
('84794000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje k výrobě lan,provazů,kabelů', 'Rope or cable-making machines (excl. twisting machines of the type used in spinn'),
('84795000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Průmyslové roboty jinde neuvedené ani nezahrnuté', 'Industrial robots, n.e.s.'),
('84796000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zařízení k ochlazovaní vzduchu odpařováním', 'Evaporative air coolers, n.e.s.'),
('84798100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje k opracov.kovů ost.vč.navíječek elektr.vodičů,ne:čísla 8455-8463', 'Machinery for treating metal, incl. electric wire coil-winders, n.e.s. (excl. in'),
('84798200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje ost.k hnětení,drcení,třídění,míchání apod.nerostů,ne:číslo 8474', 'Mixing, kneading, crushing, grinding, screening, sifting, homogenising, emulsify'),
('84798930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výztuhy důlních chodeb pojízdné ovládané hydraulicky', 'Mobile hydraulic powered mine roof supports'),
('84798960', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Systém mazací centrální', 'Central greasing systems'),
('84798997', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje mechanické ostatní s individuální funkcí,ne:viz sazebník', 'Machines, apparatus and mechanical appliances, n.e.s.'),
('84799020', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti strojů,přístrojů mechanických ost.s indiv.funkcí,z litiny,lité oceli', 'Parts of machines and mechanical appliances having individual functions, of cast'),
('84799080', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti strojů,přístrojů mechanických ost.s indiv.funkcí,ne:z litiny,lité oceli', 'Parts of machines and mechanical appliances having individual functions, n.e.s.'),
('84801000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rámy formovací pro slévárny kovů', 'Moulding boxes for metal foundry'),
('84802000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Formovací základny', 'Mould bases (other than of graphite or other carbon, ceramic meterials or glass)'),
('84803010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Modely pro formy ze dřeva', 'Moulding patterns of wood'),
('84803090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Modely pro formy ostatní,ne:ze dřeva', 'Moulding patterns (excl. moulding patterns of graphite or other carbons and cera'),
('84804100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Formy pro formování kovů,karbidů kovů vstřikovacího,kompresního typu', 'Injection or compression-type moulds for metal or metal carbides (excl. moulds o'),
('84804900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Formy pro formování kovů,karbidů kovů ostatní,ne:vstřikovacího,kompresního typu', 'Moulds for metal or metal carbides (excl. moulds of graphite or other carbons, c'),
('84805000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Formy na sklo', 'Moulds for glass (excl. moulds of graphite or other carbons and ceramic moulds)'),
('84806000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Formy na nerostné materiály', 'Moulds for mineral materials (excl. moulds of graphite or other carbons, ceramic'),
('84807100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Formy na kaučuk,plasty vstřikovacího,kompresního typu', 'Injection or compression-type moulds for rubber or plastics'),
('84807900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Formy na kaučuk,plasty ostatní,ne:vstřikovacího,kompresního typu', 'Moulds for rubber or plastics (other than injection or compression types)'),
('84811005', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Redukční ventily kombinované s filtry nebo maznicemi', 'Pressure-reducing valves combined with filters or lubricators'),
('84811019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Redukční ventily z litiny,oceli ost.,ne:kombinované s filtry nebo maznicemi', 'Pressure-reducing valves of cast iron or steel (not combined with filters or lub'),
('84811099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ventily redukční ostatní,ne:z litiny,oceli,kombinované s filtry,maznicemi', 'Pressure-reducing valves of base metal (not combined with filters or lubricators'),
('84812010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ventily pro regulaci převodovek olejovzduchových', 'Valves for the control of oleohydraulic power transmission'),
('84812090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ventily pro regulaci převodovek pneumatických', 'Valves for the control of pneumatic power transmission'),
('84813091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ventily zpětné ostatní z litiny,oceli,ne:pro pneumatiky,duše pneumatik', 'Check "non-return" valves for pipes, boiler shells, tanks, vats or the like, of'),
('84813099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ventily zpětné ostatní,ne:z litiny,oceli,pro pneumatiky,duše pneumatik', 'Check "non-return" valves for pipes, boiler shells, tanks, vats or the like (exc'),
('84814010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ventily pojistné,odvzdušňovací z litiny,oceli', 'Safety or relief valves of cast iron or steel'),
('84814090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ventily pojistné,odvzdušňovací ostatní,ne:z litiny,oceli', 'Safety or relief valves (excl. those of cast iron or steel)'),
('84818011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ventily mixážní pro umyvadla,dřezy,vany,bidety apod.výrobky', 'Mixing valves for sinks, washbasins, bidets, water cisterns, baths and similar f'),
('84818019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ventily,kohouty vodovodní ost.,ne:mixážní', 'Taps, cocks and valves for sinks, washbasins, bidets, water cisterns, baths and'),
('84818031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ventily termostatické radiátorů ústředního topení', 'Thermostatic valves for central heating radiators'),
('84818039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ventily radiátorů ústředního topení ostatní,ne:termostatické', 'Central heating radiator valves (excl. thermostatic valves)'),
('84818040', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ventily pro pneumatiky a duše pneumatik', 'Valves for pneumatic tyres and inner-tubes'),
('84818051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ventily regulační-regulátory teploty', 'Temperature regulators (excl. thermostatic valves for central heating radiators)'),
('84818059', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ventily regulační ostatní,ne:regulátory teploty', 'Process control valves (excl. temperature regulators, pressure-reducing valves,'),
('84818061', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ventily uzavírací (šoupátka) z litiny', 'Gate valves of cast iron for pipes, boiler shells, tanks, vats or the like (excl'),
('84818063', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ventily uzavírací (šoupátka) z oceli', 'Gate valves of steel for pipes, boiler shells, tanks, vats or the like (excl. ta'),
('84818069', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ventily uzavírací (šoupátka) ostatní,ne:z litiny,oceli', 'Gate valves for pipes, boiler shells, tanks, vats or the like (excl. of cast iro'),
('84818071', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ventily kulové (přímé) z litiny', 'Globe valves of cast iron (excl. temperature regulators, pressure-reducing valve'),
('84818073', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ventily kulové (přímé) z oceli', 'Globe valves of steel (excl. temperature regulators, pressure-reducing valves, v'),
('84818079', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ventily kulové (přímé) ostatní,ne:z litiny,oceli', 'Globe valves (excl. valves of cast iron or steel, temperature regulators, pressu'),
('84818081', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ventily kuličkové,kuželové', 'Ball and plug valves for pipes, boiler shells, tanks, vats or the like (excl. ta'),
('84818085', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ventily škrtící', 'Butterfly valves for pipes, boiler shells, tanks, vats or the like (excl. check'),
('84818087', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ventily membránové', 'Diaphragm valves for pipes, boiler shells, tanks, vats or the like'),
('84818099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky armaturní ostatní,ne:viz sazebník', 'Appliances for pipes, boiler shells, tanks, vats or the like (excl. pressure-red'),
('84819000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části kohoutů,ventilů a jiných armaturních výrobků', 'Parts of valves and similar articles for pipes, boiler shells, tanks, vats or th'),
('84821010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ložiska kuličková,vnější průměr do 30mm', 'Ball bearings with greatest external diameter <= 30 mm'),
('84821090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ložiska kuličková,vnější průměr nad 30mm', 'Ball bearings with greatest external diameter > 30 mm'),
('84822000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ložiska kuželíková včetně souboru válečkových a kuželíkových ložisek', 'Tapered roller bearings, incl. cone and tapered roller assemblies'),
('84823000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ložiska soudečková', 'Spherical roller bearings'),
('84824000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ložiska jehlová', 'Needle roller bearings'),
('84825000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ložiska válečková ostatní,ne:viz sazebník', 'Cylindrical roller bearings (excl. needle roller bearings)'),
('84828000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ložiska ostatní včetně kombinací kuličkových a válečkových ložisek,ne:viz sazebník', 'Roller bearings, incl. combined ball-roller bearings (excl. ball bearings, taper'),
('84829110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kuželíky do ložisek', 'Tapered rollers for bearings'),
('84829190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kuličky,jehly,válečky ložisek ostatní,ne:kuželíky', 'Balls, needles and rollers for bearings (excl. tapered rollers and steel balls o'),
('84829900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti ložisek ostatní,ne:kuželíky,kuličky,jehly,válečky', 'Parts of ball or roller bearings (excl. balls, needles and rollers), n.e.s.'),
('84831021', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kliky,klikové hřídele z litiny,oceli lité,ne:klikové hřídele složené', 'Cranks and crank shafts, of cast iron or cast steel'),
('84831025', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kliky,klikové hřídele z oceli kované v otevř.zápustce,ne:klikové hřídele složené', 'Cranks and crank shafts, of open-die forged steel'),
('84831029', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kliky a klikové hřídele ostatní,ne:viz sazebník', 'Cranks and crank shafts (excl. of open-die forged steel or cast iron or cast ste'),
('84831050', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kloubové hřídele', 'Articulated shafts'),
('84831095', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hřídele ostatní,ne:kliky,klikové hřídele,kloubové hřídele', 'Main shafts or driving shafts, counter shafts, cam shafts, eccentric shafts and'),
('84832000', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pouzdra ložisková s ložisky valivými', 'Bearing housings, incorporating ball or roller bearings, for machinery'),
('84833032', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pouzdra ložisková pro ložiska valivá', 'Bearing housings for machinery, for ball or roller bearings'),
('84833038', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pouzdra ložisková pro ložiska ostatní,ne:pro ložiska valivá', 'Bearing housings not incorporating ball or roller bearings, for machinery and pl'),
('84833080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pánve ložiskové', 'Plain shaft bearings for machinery'),
('84834021', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ozubená kola,ozubené převody (ne třecí) přímozubé a šikmozubé', 'Spur and helical gears and gearing, for machinery (excl. friction gears, gear bo'),
('84834023', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ozubená kola,ozubené převody (ne třecí) kuželové', 'Bevel and bevel-spur gears and gearing, for machinery (excl. friction gears, gea'),
('84834025', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ozubená kola,ozubené převody (ne třecí) šnekové', 'Worm gear for machinery (excl. friction gears, gear boxes and other speed change'),
('84834029', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ozubená kola,ozubené převody (ne třecí) ostatní,ne:viz sazebník', 'Gears and gearing, for machinery (excl. friction gears, spur, helical, bevel, be'),
('84834030', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Šrouby pohybové s kuličkovou nebo válečkovou maticí', 'Ball or roller screws, for machinery'),
('84834051', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Převodovky,převodové skříně', 'Gear boxes for machinery'),
('84834059', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Měniče rychlosti ostatní,ne:převodovky,převodové skříně', 'Speed changers, incl. torque converters, for machinery (excl. gear boxes)'),
('84834090', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Řetězová kola,součásti převodu ost.,měniče kroutícího momentu apod.,ne:viz sazebník', 'Gears and gearing, for machinery (excl. ball or roller screws and gears and gear'),
('84835020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Setrvačníky,řemenice včetně kladnic z litiny,lité oceli', 'Flywheels and pulleys, incl. pulley blocks, of cast iron or cast steel'),
('84835080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Setrvačníky,řemenice včetně kladnic ost.,ne:litina,ocel litá', 'Flywheels and pulleys, incl. pulley blocks (excl. of cast iron or cast steel)'),
('84836020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Spojky i hřídelové vč.kloubů kardanových z litiny,oceli lité', 'Clutches and shaft couplings, incl. universal joints, of cast iron or cast steel'),
('84836080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Spojky i hřídelové vč.kloubů kardanových ostatní,ne:litina,ocel litá', 'Clutches and shaft couplings, incl. universal joints (excl. of cast iron or cast'),
('84839020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části ložiskových pouzder', 'Parts of bearing housings, n.e.s.'),
('84839081', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kola ozubená,řetězová a jiné části převodů z litiny,lité oceli,ne:části ložiskových pouzder', 'Toothed wheels, chain sprockets and other transmission elements presented separa'),
('84839089', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kola ozubená,řetězová a jiné části převodů ostatní,ne:viz sazebník', 'Toothed wheels, chain sprockets and other transmission elements presented separa'),
('84841000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Těsnění kovoplastická', 'Gaskets and similar joints of metal sheeting combined with other material or of'),
('84842000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mechanické ucpávky', 'Mechanical seals'),
('84849000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Soubory,sestavy těsnění v sáčcích,pouzdrech a podobných obalech', 'Sets or assortments of gaskets and similar joints, dissimilar in composition, pu'),
('84861000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje pro výrobu polov.ingotů,destiček', 'Machines and apparatus for the manufacture of boules or wafers'),
('84862010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje,přístroje pro výrobu polov.součástek,el.integr.obvodů,ultrazvukové', 'Machine tools for working any material by removal of material, operated by ultra'),
('84862090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje výrobu polov.součástek,el.integr.obvodů ost.,ne:ultrazvukové', 'Machines and apparatus for the manufacture of semiconductor devices or of electr'),
('84863010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje pro chemické pokovování podložek LCD srážením kovových par', 'Apparatus for chemical vapour deposition on liquid crystal devices "LCD" substra'),
('84863030', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje pro suché leptání předloh na podložky LCD', 'Apparatus for dry-etching patterns on liquid cristal devices "LCD" substrates, f'),
('84863050', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje pro fyzykální pokovování podložek LCD rozprašováním', 'Apparatus for physical deposition by sputtering on liquid cristal devices "LCD"'),
('84863090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje,zařízení pro výrobu plochých panelových displejů ost.,ne viz sazebník', 'Machines and apparatus for the manufacture of flat panel displays (excl. apparat'),
('84864000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje,zařízení specifikované v poznámce 9 C) kapitoly 84 sazebníku', 'Machines and apparatus specified in NoteÂ 9 C to chapter 84'),
('84869010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástrojové držáky,samočinné závitořez.hlavy,upínací zařízení pro stroje čísla 8486', 'Tool holders, self-opening dieheads and workholders of a kind used solely or pri'),
('84869020', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti odstředivek na povlékání podložek LCD fotogr.emulzemi', 'Parts of spinners for coating photographic emulsions on liquid crystal devices "'),
('84869030', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti tryskacích strojů na čištění kov.ploch polov.součástí před el.pokovováním', 'Parts of deflash machines for cleaning the metal leads of semiconductor packages'),
('84869040', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti přístrojů pro fyz.pokovování podložek LCD rozprašováním', 'Parts of apparatus for physical deposition by sputtering on liquid crystal devic'),
('84869050', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti přístrojů pro suché leptání předloh na podložky LCD', 'Parts and accessories for apparatus for dry-etching patterns on liquid crystal d'),
('84869060', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti přístrojů pro chem.pokovování podložek LCD srážením kovových par', 'Parts and accessories for apparatus for chemical vapour deposition on liquid cry'),
('84869070', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti ultrazvukových obr.strojů pro výrobu polov.součástek,el.integr.obvodů', 'Parts and accessories for machine-tools operated by ultrasonic processes, n.e.s.'),
('84869090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části strojů,přístr.pro výr.polov.souč,el.integr.obvodů,LCD displejů,ostatní,ne:viz sazebník', 'Parts and accessories for machines and apparatus of a kind used solely or princi'),
('84871010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Lodní vrtule,jejich lopatky z bronzu', 'Ships'' or boats'' propellers and blades therefor, of bronze'),
('84871090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Lodní vrtule,jejich lopatky ostatní,ne:z bronzu', 'Ships'' or boats'' propellers and blades therefor (excl. those of bronze)'),
('84879010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části strojů neobs.el.prvky,z litiny nekujné,ne:viz sazebník', 'Parts of machinery of chapter 84, not intended for a specific purpose, of non-ma'),
('84879030', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části strojů neobs.el.prvky,z litiny kujné,ne:viz sazebník', 'Parts of machinery of chapter 84, not intended for a specific purpose, of mallea'),
('84879051', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části strojů neobs.el.prvky,z oceli lité,ne:viz sazebník', 'Parts of machinery of chapter 84, not intended for a specific purpose, of cast s'),
('84879053', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části strojů neobs.el.prvky,ze železa,oceli kovaných v otev.zápustce,ne:viz sazebník', 'Parts of machinery of chapter 84, not intended for a specific purpose, of open-d'),
('84879055', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části strojů neobs.el.prvky,ze železa,oceli kovaných v uzav.zápustce,ne:viz sazebník', 'Parts of machinery of chapter 84, not intended for a specific purpose, of closed'),
('84879059', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části strojů neobs.el.prvky,ze železa,oceli ostatní,ne:viz sazebník', 'Parts of machinery of chapter 84, not intended for a specific purpose, of iron o'),
('84879090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části strojů neobs.el.prvky ostatní,ne:z litiny,oceli,železa,jinde zařazené', 'Machinery parts of chapter 84, not intended for a specific purpose, n.e.s.'),
('85011010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory synchronní elektrické,výkon do 18 W', 'Synchronous motors of an output <= 18 W'),
('85011091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory univerzální elektrické na střídavý i stejnosměrný proud,výkon do 37,5W', 'Universal AC-DC motors of an output <= 37,5 W'),
('85011093', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory elektrické,střídavý proud,výkon do 37,5 W', 'AC motors of an output <= 37,5 W (excl. synchronous motors of an output <= 18 W)'),
('85011099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory elektrické,stejnosměrný proud,výkon do 37,5 W', 'DC motors of an output <= 37,5 W'),
('85012000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory elektrické univerzální,výkon nad 37,5W', 'Universal AC-DC motors of an output > 37,5 W'),
('85013100', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory elektrické,generátory,stejnosměrný proud,nad 37,5-750W', 'DC motors of an output > 37,5 W but <= 750 W and DC generators of an output <= 7'),
('85013220', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory elektrické,generátory,stejnosměrný proud,nad 750W-7,5kW', 'DC motors and generators, of an output > 750 W but <= 7,5 kW'),
('85013280', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory elektrické,generátory,stejnosměrný proud,nad 7,5W-75kW', 'DC motors and generators, of an output > 7,5 kW but <= 75 kW'),
('85013300', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory elektrické,generátory,stejnosměrný proud,nad 75-375kW', 'DC motors and DC generators of an output > 75 kW but <= 375 kW'),
('85013450', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory trakční,stejnosměrný proud,výkon nad 375kW', 'DC traction motors of an output > 375 kW'),
('85013492', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory elektrické,generátory,stejnosměrný proud,nad 375-750kW,ne:trakční', 'DC motors and generators, of an output > 375 kW but <= 750 kW (excl. traction mo'),
('85013498', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory elektrické,generátory,stejnosměrný proud,nad 750kW,ne:trakční', 'DC motors and generators, of an output > 750 kW (excl. traction motors)'),
('85014020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory elektrické jednofázové,střídavý proud,výkon nad 37,5-750W', 'AC motors, single phase, of an output of > 37,5 W but <= 750 W'),
('85014080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory elektrické jednofázové,střídavý proud,výkon nad 750W', 'AC motors, single phase, of an output of > 750 W'),
('85015100', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory elektrické vícefázové,střídavý proud,nad 37,5-750W', 'AC motors, multi-phase, of an output > 37,5 W but <= 750 W'),
('85015220', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory elektrické vícefázové,střídavý proud,nad 750W-7,5kW', 'AC motors, multi-phase, of an output > 750 W but <= 7,5 kW'),
('85015230', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory elektrické vícefázové,střídavý proud,nad 7,5-37kW', 'AC motors, multi-phase, of an output > 7,5 kW but <= 37 kW'),
('85015290', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory elektrické vícefázové,střídavý proud,nad 37-75kW', 'AC motors, multi-phase, of an output > 37 kW but <= 75 kW'),
('85015350', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory trakční,střídavý proud,výkon nad 75 kW', 'AC traction motors, multi-phase, of an output > 75 kW'),
('85015381', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory elektrické vícefázové,střídavý proud,nad 75-375kW,ne:trakční', 'AC motors, multi-phase, of an output of > 75 kW but <= 375 kW (excl. traction mo'),
('85015394', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory elektrické vícefázové,střídavý proud,nad 375-750kW,ne:trakční', 'AC motors, multi-phase, of an output of > 375 kW but <= 750 kW (excl. traction m'),
('85015399', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motory elektrické vícefázové,střídavý proud,nad 750kW,ne:trakční', 'AC motors, multi-phase, of an output > 750 kW (excl. traction motors)'),
('85016120', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Generátory střídavého proudu,výkon do 7,5kVA', 'AC generators "alternators", of an output <= 7,5 kVA'),
('85016180', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Generátory střídavého proudu,výkon nad 7,5-75kVA', 'AC generators "alternators", of an output > 7,5 kVA but <= 75 kVA'),
('85016200', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Generátory střídavého proudu,výkon nad 75-375kVA', 'AC generators "alternators", of an output > 75 kVA but <= 375 kVA'),
('85016300', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Generátory střídavého proudu,výkon nad 375-750kVA', 'AC generators "alternators", of an output > 375 kVA but <= 750 kVA'),
('85016400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Generátory střídavého proudu,výkon nad 750 kVA', 'AC generators "alternators", of an output > 750 kVA'),
('85021120', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Soustrojí generátorová elektrická,motor vznětový,výkon do 7,5kVA', 'Generating sets with compression-ignition internal combustion piston engine "die'),
('85021180', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Soustrojí generátorová elektrická,motor vznětový,výkon nad 7,5-75kVA', 'Generating sets with compression-ignition internal combustion piston engine "die'),
('85021200', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Soustrojí generátorová elektrická,motor vznětový,výkon nad 75-375kVA', 'Generating sets with compression-ignition internal combustion piston engine "die'),
('85021320', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Soustrojí generátorová elektrická,motor vznětový,výkon nad 375-750kVA', 'Generating sets with compression-ignition internal combustion piston engine "die'),
('85021340', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Soustrojí generátorová elektrická,motor vznětový,výkon nad 750-2000kVA', 'Generating sets with compression-ignition internal combustion piston engine "die'),
('85021380', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Soustrojí generátorová elektrická,motor vznětový,výkon nad 2000kVA', 'Generating sets with compression-ignition internal combustion piston engine "die'),
('85022020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Soustrojí generátorová elektrická,motor zážehový,výkon do 7,5kVA', 'Generating sets with spark-ignition internal combustion piston engine, of an out'),
('85022040', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Soustrojí generátorová elektrická,motor zážehový,výkon nad 7,5-375kVA', 'Generating sets with spark-ignition internal combustion piston engine, of an out'),
('85022060', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Soustrojí generátorová elektrická,motor zážehový,výkon nad 375-750kVA', 'Generating sets with spark-ignition internal combustion piston engine, of an out'),
('85022080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Soustrojí generátorová elektrická,motor zážehový,výkon nad 750kVA', 'Generating sets with spark-ignition internal combustion piston engine, of an out'),
('85023100', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Soustrojí generátorová poháněná větrem', 'Generating sets, wind-powered'),
('85023920', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Turbogenerátory', 'Turbogenerators'),
('85023980', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Generátorová soustrojí ostatní,ne:viz sazebník', 'Generating sets, non-wind-powered and non-powered by spark-ignition internal com'),
('85024000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Měniče rotační elektrické', 'Electric rotary converters'),
('85030010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kroužky nemagnetické přídržné pro elektrické motory a generátory', 'Non-magnetic retaining rings for electric motors and electric generating sets'),
('85030091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části motorů elektrických,generátorů z litiny,oceli lité,ne:nemagnet.kroužky', 'Parts suitable for use solely or principally with electric motors and generators'),
('85030099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části motorů elektrických,generátorů,ne:litina,ocel litá,nemagnet.kroužky', 'Parts suitable for use solely or principally with electric motors and generators'),
('85041020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Induktory i s kondenzátorem', 'Inductors, whether or not connected with a capacitor'),
('85041080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Předřadníky (odpory) pro výbojky,trubice výbojkové ost.,ne:induktory i s kondenzátorem', 'Ballasts for discharge lamps or tubes (excl. inductors, whether or not connected'),
('85042100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Transformátory s kapalinovým dielektrikem,výkon do 650 kVA', 'Liquid dielectric transformers, having a power handling capacity <= 650 kVA'),
('85042210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Transformátory s kapalinovým dielektrikem,výkon nad 650-1600 kVA', 'Liquid dielectric transformers, having a power handling capacity > 650 kVA but <'),
('85042290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Transformátory s kapalinovým dielektrikem,výkon nad 1600-10 000 kVA', 'Liquid dielectric transformers, having a power handling capacity > 1.600 kVA but'),
('85042300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Transformátory s kapalinovým dielektrikem,výkon nad 10 000 kVA', 'Liquid dielectric transformers, having a power handling capacity > 10.000 kVA'),
('85043121', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Transformátory pro měření napětí,výkon do 1kVA,ne:s kapalin.dielektrikem', 'Measuring transformers for voltage measurement, having a power handling capacity'),
('85043129', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Transformátory měřicí ost.,výkon do 1kVA,ne:pro měření napětí,s kapalin.dielektrikem', 'Measuring transformers having a power handling capacity <= 1 kVA (other than for'),
('85043180', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Transformátory ostatní,výkon do 1kVA,ne:měřicí,s kapalin.dielektrikem', 'Transformers having a power handling capacity <= 1 kVA (excl. liquid dielectric'),
('85043220', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Transformátory pro měření napětí,výkon nad 1-16kVA,ne:s kapalin.dielektrikem', 'Measuring transformers having a power handling capacity of > 1 kVA but <= 16 kVA'),
('85043280', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Transformátory měřicí ost.,výkon nad 1-16kVA,ne:pro měření napětí,s kapalin.dielektrikem', 'Transformers having a power handling capacity > 1 kVA but <= 16 kVA (excl. liqui'),
('85043300', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Transformátory ostatní,výkon nad 16-500kVA,ne:s kapalin.dielektrikem', 'Transformers having a power handling capacity > 16 kVA but <= 500 kVA (excl. liq'),
('85043400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Transformátory,výkon nad 500 kVA,ne:s kapalinovým dielektrikem', 'Transformers having a power handling capacity > 500 kVA (excl. liquid dielectric'),
('85044030', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Statické měniče použ.s telekom.přístroji,zařízeními pro autom.zpracování dat', 'Static converters of a kind used with telecommunication apparatus, automatic dat'),
('85044040', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Usměrňovače polovodičové polykrystalické', 'Polycrystalline semiconductor rectifiers'),
('85044055', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Nabíječe akumulátorů', 'Accumulator chargers (excl. of a kind used with telecommunication apparatus, aut'),
('85044081', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Měniče statické-usměrňovače', 'Rectifiers (excl. polycrystalline semiconductor rectifiers and other than of a k'),
('85044084', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Měniče statické-invertory,výkon do 7,5kVA', 'Inverters having power handling capacity <= 7,5 kVA (excl. of a kind used with t'),
('85044088', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Měniče statické-invertory,výkon nad 7,5kVA', 'Inverters having power handling capacity > 7,5 kVA (excl. of a kind used with te'),
('85044090', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Měniče statické ostatní,ne:viz sazebník', 'Static converters (excl. of a kind used with telecommunication apparatus, automa'),
('85045020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Induktory k telekomunikačním přístrojům a zařízením pro autom.zpracování dat', 'Inductors of a kind used with telecommunication apparatus and for power supplies'),
('85045095', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Induktory ostatní,ne:viz sazebník', 'Inductors (excl. of a kind used with telecommunication apparatus and for power s'),
('85049005', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti - sestavy tištěných obvodů pro výr. podpoložky 8504 50 30', 'Electronic assemblies of inductors of a kind used with telecommunication apparat'),
('85049011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jádra ferritová', 'Ferrite cores for transformers and inductors'),
('85049018', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti transformátorů,induktorů ostatní,ne:viz sazebník', 'Parts of transformers and inductors, n.e.s. (excl. electronic assemblies of indu'),
('85049091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,souč.-sestavy tištěných obvodů pro výr.podpoložek 8504 40 30,8504 40 35', 'Electronic assemblies of static converters of a kind used with telecommunication'),
('85049099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti statických měničů ostatní,ne:viz sazebník', 'Parts of static converters, n.e.s. (excl. electronic assemblies of a kind used w'),
('85051100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Magnety permanentní,výrobky určené ke zmagnetizování kovové', 'Permanent magnets of metal and articles intended to become permanent magnets aft'),
('85051910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Magnety permanentní z aglomerovaných ferritů', 'Permanent magnets of agglomerated ferrite'),
('85051990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Magnety permanentní,výrobky určené ke zmagnetizování ost.,ne:viz sazebník', 'Permanent magnets and articles intended to become permanent magnets after magnet'),
('85052000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Spojky,převody,brzdy elektromagnetické', 'Electromagnetic couplings, clutches and brakes'),
('85059010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Elektromagnety', 'Electromagnets (excl. magnets for medical use)'),
('85059030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sklíčidla,svěradla apod.výrobky elektromagnetická,pernamentně magnetická', 'Electromagnetic or permanent magnet chucks, clamps and similar holding devices'),
('85059050', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hlavy zdvihací elektromagnetické', 'Electromagnetic lifting heads'),
('85059090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části elektromagnetů,pernamentních magnetů,zařízení s magnety apod.', 'Parts of permanent magnets, electromagnets, electromagnetic clutches, couplings,'),
('85061011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Články galvanické-baterie alkalické,válcové na bázi oxidu manganičitého', 'Manganese dioxide cells and batteries, alkaline, in the form of cylindrical cell'),
('85061015', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Články galvanické-baterie alkalické,knoflíkové na bázi oxidu manganičitého', 'Manganese dioxide cells and batteries, alkaline, in the form of button cells (ex'),
('85061019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Články galvanické-baterie alkalické ost.na bázi oxidu Mn,ne:válcové,knoflíkové', 'Manganese dioxide cells and batteries, alkaline (excl. spent, and in the form of'),
('85061091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Články galvanické-baterie ost.válcové na bázi oxidu Mn,ne:alkalické', 'Manganese dioxide cells and batteries, non-alkaline, in the form of cylindrical'),
('85061095', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Články galvanické-baterie ost.knoflíkové na bázi oxidu Mn,ne:alkalické', 'Manganese dioxide cells and batteries, non-alkaline, in the form of button cells'),
('85061099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Články galvanické-baterie ost.na bázi oxidu Mn,ne:alkalické,válcové,knoflíkové', 'Manganese dioxide cells and batteries, non-alkaline (excl. spent, and in the for'),
('85063010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Články galvanické-baterie válcové na bázi oxidu rtuťnatého', 'Mercuric oxide cells and batteries, in the form of cylindrical cells (excl. spen'),
('85063030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Články galvanické-baterie knoflíkové na bázi oxidu rtuťnatého', 'Mercuric oxide cells and batteries, in the form of button cells (excl. spent)'),
('85063090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Články galvanické-baterie ost.na bázi oxidu rtuťnatého,ne:válcové,knoflíkové', 'Mercuric oxide cells and batteries (excl. spent, and in the form of cylindrical'),
('85064010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Články galvanické-baterie válcové na bázi oxidu stříbrného', 'Silver oxide cells and batteries, in the form of cylindrical cells (excl. spent)'),
('85064030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Články galvanické-baterie knoflíkové na bázi oxidu stříbrného', 'Silver oxide cells and batteries, in the form of button cells (excl. spent)'),
('85064090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Články galvanické-baterie ost.na bázi oxidu stříbrného,ne:válcové,knoflíkové', 'Silver oxide cells and batteries (excl. spent, and in the form of cylindrical or'),
('85065010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Články galvanické-baterie válcové lithiové', 'Lithium cells and batteries, in the form of cylindrical cells (excl. spent)'),
('85065030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Články galvanické-baterie knoflíkové lithiové', 'Lithium cells and batteries, in the form of button cells (excl. spent)'),
('85065090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Články galvanické-baterie ostatní lithiové,ne:válcové,knoflíkové', 'Lithium cells and batteries (excl. spent, and in the form of cylindrical or butt'),
('85066010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zinkovzdušné válcové články', 'Air-zinc cells and batteries, in the form of cylindrical cells (excl. spent)'),
('85066030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zinkovzdušné knoflíkové články', 'Air-zinc cells and batteries, in the form of button cells (excl. spent)'),
('85066090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Ostatní zinkovzdušné články', 'Air-zinc cells and batteries (excl. spent, and in the form of cylindrical or but'),
('85068005', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Články galvanické-baterie zinko-uhlíkové suché,napětí 5,5-6,5V', 'Dry zinc-carbon batteries of a voltage of >= 5,5 V but <= 6,5 V (excl. spent)'),
('85068011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Články galvanické-baterie válcové ostatní,ne:na bázi oxidů Mn,Hg,Ag,Li,Zn,Zn-C', 'Primary cells and primary batteries, electric, in the form of cylindrical cells'),
('85068015', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Články galvanické-baterie knoflík.ost.,ne:na bázi oxidů Mn,Hg,Ag,Li,Zn,Zn-C', 'Primary cells and primary batteries, electric, in the form of button cells (excl'),
('85068090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Články galvanické-baterie ostatní,ne:viz sazebník', 'Primary cells and primary batteries, electric (excl. spent, and those in the for'),
('85069000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti článků galvanických,baterií', 'Parts of primary cells and primary batteries, n.e.s.'),
('85071041', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Akumulátory el.olověné ke startování píst.motorů,hm.do 5kg,tekutý elektrolyt', 'Lead-acid accumulators of a kind used for starting piston engine "starter batter'),
('85071049', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Akumulátory el.olověné ke startování píst.motorů,hm.do 5kg,ne:tekutý elektrolyt', 'Lead-acid accumulators of a kind used for starting piston engine "starter batter'),
('85071092', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Akumulátory el.olověné ke startování píst.motorů,hm.nad 5kg,tekutý elektrolyt', 'Lead-acid accumulators of a kind used for starting piston engine "starter batter'),
('85071098', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Akumulátory el.olověné ke startování píst.motorů,hm.nad 5kg,ne:tekutý elektrolyt', 'Lead-acid accumulators of a kind used for starting piston engine "starter batter'),
('85072041', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'NEL'), 'Akumulátory el.olověné trakční,tekutý elektrolyt', 'Lead-acid traction accumulators, working with liquid electrolyte (excl. spent an'),
('85072049', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'NEL'), 'Akumulátory el.olověné trakční,ne:tekutý elektrolyt', 'Lead-acid traction accumulators, working with non-liquid electrolyte (excl. spen'),
('85072092', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'NEL'), 'Akumulátory el.olověné ost.,tekutý elektrolyt,ne:ke startování píst.motorů,trakční', 'Lead-acid accumulators, working with liquid electrolyte (excl. spent, starter ba'),
('85072098', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'NEL'), 'Akumulátory el.olověné ost.,ne:ke startování píst.motorů,trakční,tekutý elektrolyt', 'Lead-acid accumulators, working with non-liquid electrolyte (excl. spent, starte'),
('85073020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Akumulátory el.niklo-kadmiové,hermeticky uzavřené', 'Hermetically sealed nickel-cadmium accumulators (excl. spent)'),
('85073081', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'NEL'), 'Akumulátory el.niklo-kadmiové trakční,ne:hermeticky uzavřené', 'Nickel-cadmium traction accumulators, not hermetically sealed (excl. spent)'),
('85073089', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'NEL'), 'Akumulátory el.niklo-kadmiové,ne:hermeticky uzavřené,trakční', 'Nickel-cadmium accumulators, not hermetically sealed (excl. spent and traction a'),
('85074000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Akumulátory el.niklo-železné', 'Nickel-iron accumulators (excl. spent)'),
('85078020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Akumulátory el.na bázi hydridu niklu', 'Nickel-hydride accumulators (excl. spent)'),
('85078030', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Akumulátory el.lithium-iontové', 'Lithium-ion accumulators (excl. spent)'),
('85078080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Akumulátory el.ostatní,ne:viz sazebník', 'Electric accumulators (excl. spent, lead-acid, nickel-cadmium, nickel-iron, nick'),
('85079020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Desky pro akumulátory elektrické', 'Plates for electric accumulators (excl. plates of vulcanised rubber other than h'),
('85079030', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Separátory elektrických akumulátorů', 'Separators for electric accumulators (excl. separators of vulcanised rubber othe'),
('85079090', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti elektrických akumulátorů ost.,ne:desky,separátory', 'Parts of electric accumulators (excl. plates and separators)'),
('85081100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vysavače s vest.el.motorem,výkon <1500W,nádoba na prach <20l', 'Vacuum cleaners, incl. dry cleaners and wet vacuum cleaners, with self-contained'),
('85081900', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vysavače s vest.el.motorem,ost.,ne:výkon <1500W,nádoba na prach <20l', 'Vacuum cleaners, incl. dry cleaners and wet vacuum cleaners, with self-contained'),
('85086000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vysavače bez vest.el.motoru', 'Vacuum cleaners, incl. dry cleaners and wet vacuum cleaners (excl. with self-con'),
('85087000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti vysavačů', 'Parts of vacuum cleaners, dry cleaners and wet vacuum cleaners, n.e.s.'),
('85094000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Mlýnky k mletí potravin,mixéry,lisy na ovoce,zeleninu elektrické pro domácnost', 'Domestic food grinders and mixers and fruit or vegetable juice extractors, with'),
('85098000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje elektromechanické pro domácnost ostatní,ne:viz sazebník', 'Electromechanical domestic appliances, with self-contained electric motor (excl.'),
('85099000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části přístrojů elektromechanických pro domácnost,ne:vysavačů,leštičů podlah', 'Parts of electromechanical domestic appliances, with self-contained electric mot'),
('85101000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Strojky holicí elektrické', 'Shavers, electric'),
('85102000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Strojky na stříhání vlasů,srsti elektrické', 'Hair clippers with self-contained electric motor'),
('85103000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Depilační přístroje elektrické', 'Hair-removing appliances with self-contained electric motor'),
('85109000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části strojků holicích,na stříhání vlasů,srsti,depilačních přístr.elektrických', 'Parts of electric shavers, hair clippers and hair-removing appliances, with self'),
('85111000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Svíčky zapalovací', 'Sparking plugs of a kind used for spark-ignition or compression-ignition interna'),
('85112000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zapalovače magnetické,dynama a setrvačníky s magnetem', 'Ignition magnetos, magneto-dynamos and magnetic flywheels, for spark-ignition or'),
('85113000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rozdělovače,zapalovací cívky pro motory', 'Distributors and ignition coils of a kind used for spark-ignition or compression'),
('85114000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Spouštěče i pracující jako startovací generátory', 'Starter motors and dual purpose starter-generators of a kind used for spark-igni'),
('85115000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Generátory ostatní pro motory,ne:viz sazebník', 'Generators of a kind used for internal combustion engines (excl. magneto dynamos'),
('85118000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zařízení elektrická zapalovací apod.pro spalovací motory ost.,ne:viz sazebník', 'Electrical ignition or starting equipment, incl. cut-outs, of a kind used for sp'),
('85119000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části zařízení zapalovacího,spouštěcího elektrického', 'Parts of electrical ignition or starting equipment, generators, etc. of heading'),
('85121000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Světelné nebo vizuální signalizační přístroje pro jízdní kola', 'Electric lighting or visual signalling equipment of a kind used for bicycles (ot'),
('85122000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Světelné nebo vizuální signalizační přístroje pro vozidla motorová', 'Electrical lighting or visual signalling equipment for motor vehicles (excl. lam'),
('85123010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení poplašná na ochranu proti vloupání,pro motorová vozidla', 'Sound signalling burglar alarms, electrical, of a kind used for motor vehicles'),
('85123090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje a zařízení signalizační zvukové,ne:pro motorová vozidla', 'Electrical sound signalling equipment for cycles or motor vehicles (excl. burgla'),
('85124000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stěrače,rozmrazovače,odmlžovače elektrické pro motorová vozidla', 'Electrical windscreen wipers, defrosters and demisters, for motor vehicles'),
('85129010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části přístrojů signal.el.akustických,vizuálních s plochým panel.displ.(podpol.8531 80 20)', 'Parts of electrical burglar alarms of a kind used for motor vehicles, n.e.s.'),
('85129090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části přístrojů osvětlovacích,signaliz.,stěračů apod.ostatní,ne:viz sazebník', 'Parts of electrical lighting or signalling equipment, windscreen wipers, defrost'),
('85131000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Svítidla přenosná elektrická s vlastním zdrojem energie', 'Portable electrical lamps designed to function by their own source of energy'),
('85139000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části svítidel přenosných elektrických s vlastním zdrojem energie', 'Parts of portable electrical lamps designed to function by their own source of e'),
('85141010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pece prům,labor.elektrické vyhřívané působením odporů,k pečení chleba,pekařských výrobků', 'Resistance heated bakery and biscuit ovens'),
('85141080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pece prům,labor.elektrické vyhřívané působením odporů,ostatní,ne:k pečení chleba apod.', 'Industrial and laboratory furnaces and ovens, resistance heated (other than for'),
('85142010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pece prům,labor.elektrické indukční', 'Furnaces and ovens functioning by induction'),
('85142080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pece prům,labor.dielektrické', 'Furnaces and ovens functioning by dielectric  loss (other than for the manufactu'),
('85143019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pece prům,labor.elektrické využívající infračervené záření', 'Infra-red ovens (excl. dry ovens, devices for heating rooms or floors or for sim'),
('85143099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pece prům,labor.elektrické ostatní,ne:viz sazebník', 'Electric industrial and laboratory furnaces and ovens (excl. resistance heated f'),
('85144000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zařízení el.indukční,dielektrická ost.k tepelnému zpracování hmot,ne:viz sazebník', 'Equipment for the heat treatment of materials by induction or dielectric loss (e'),
('85149000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti pecí prům,labor.elektrických apod.', 'Parts of electric industrial or laboratory furnaces and ovens, incl. of those fu'),
('85151100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pájedla, pistole pájecí elektrické', 'Soldering irons and guns, electric'),
('85151900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje pájecí elektrické ostatní,ne:pájedla,pájecí pistole', 'Brazing or soldering machines (excl. soldering irons and guns)'),
('85152100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje elektrické pro odporové sváření kovů plně,částečně automatizované', 'Fully or partly automatic machines for resistance welding of metals'),
('85152910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje elektrické pro odporové svařování kovů na tupo,ne:automatizované', 'Machines for butt welding of metals, neither fully nor partly automatic'),
('85152990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje elektrické pro odporové svařování kovů ost.,ne:na tupo,automatizované', 'Machines for resistance welding of metals, neither fully nor partly automatic (e'),
('85153100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje elektrické pro obloukové sváření kovů plně,částečně automatizované', 'Fully or partly automatic machines for arc welding of metals, incl. plasma arc w'),
('85153913', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje elektrické pro ruční obloukové svařování kovů s transformátory', 'Machines for manual arc welding of metals, with coated electrodes, complete with'),
('85153918', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje el.pro ruční obloukové svařování kovů s generátory,měniči,usměrňovači', 'Machines and apparatus for manual arc welding of metals with coated electrodes,'),
('85153990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje elektrické pro obloukové svařování kovů ostatní,ne:viz sazebník', 'Fully or partly automatic machines for arc welding of metals, incl. plasma arc w'),
('85158011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje elektrické,laser,ultrazvuk,magnet,plazm.pro svařování kovů ostatní,ne:viz sazebník', 'Electrical machines and apparatus for welding metals (excl. machines and apparat'),
('85158019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje elektrické,laser,ultrazvuk,magnet,plazm.pro opracování kovů ostatní,ne:viz sazebník', 'Electrical machines and apparatus for hot spraying of metals or metal carbides ('),
('85158090', 2010, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje elektrické svařovací,na opracování materiálů ostatní,ne:viz sazebník', 'Electrical machines and apparatus for welding thermoplastic materials (excl. wir'),
('85159000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti strojů el.,laser,ultrazvuk,magnet,plazm.pro opracovávání kovů,ne:viz sazebník', 'Parts of machines and apparatus for soldering or welding or for hot spraying of'),
('85161011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Ohřívače vody elektrické průtokové', 'Electric instantaneous water heaters'),
('85161019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Ohřívače vody elektrické zásobníkové', 'Electric water heaters (excl. instantaneous water heaters and immersion heaters)'),
('85161090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Ohřívače ponorné elektrické', 'Electric immersion heaters'),
('85162100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Radiátory elektrické akumulační', 'Electric storage heating radiators, for space-heating'),
('85162910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Radiátory elektrické plněné kapalinou', 'Liquid filled electric radiators, for space-heating and soil-heating'),
('85162950', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Konvektory elektrické', 'Electric convection heaters, for space-heating and soil-heating'),
('85162991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje el.pro vytápění prostor,zeminy se zabudovaným větrákem,ne:viz sazebník', 'Electric space-heating and soil-heating apparatus, with built-in fan (excl. stor'),
('85162999', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje el.pro vytápění prostor,zeminy ost.,ne:viz sazebník', 'Electric space-heating and soil-heating apparatus, without built-in fan (excl. c'),
('85163110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pokrývky hlavy vysoušecí elektrotepelné', 'Electric drying hoods'),
('85163190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vysoušeče vlasů elektrotepelné ostatní,ne:pokrývky hlavy', 'Electric hairdryers (excl. drying hoods)'),
('85163200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje k úpravě vlasů elektrotepelné ostatní,ne:vysoušeče', 'Electro-thermic hairdressing apparatus (excl. hairdryers)'),
('85163300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vysoušeče rukou elektrotepelné', 'Electric hand-drying apparatus'),
('85164010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Žehličky elektrické napařovací', 'Electric steam smoothing irons'),
('85164090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Žehličky elektrické ostatní,ne:napařovací', 'Smoothing irons, electric (excl. steam smoothing irons)'),
('85165000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Trouby,pece mikrovlnné elektrické', 'Microwave ovens'),
('85166010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vařiče elektrické,minimálně 1 spirála', 'Electric cookers incorporating at least an oven and a hob, for domestic use'),
('85166051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Tělíska elektrická ohřívací k zabudování', 'Electric cooking plates, boiling rings and hobs for building in, for domestic us'),
('85166059', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Varné desky,spirály elektrické', 'Electric cooking plates, boiling rings and hobs, for domestic use (excl. those f'),
('85166070', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Grily,opékače elektrické', 'Electric grillers and roasters, for domestic use'),
('85166080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Ohřívače,pece elektrické k zabudování', 'Electric ovens for building in, for domestic use'),
('85166090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Ohřívače,pece,vařiče,trouby apod.elektrické ostatní,ne:viz sazebník', 'Electric ovens, for domestic use (excl. space-heating stoves, electric cookers i'),
('85167100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje k přípravě kávy,čaje elektrotepelné', 'Electro-thermic coffee or tea makers, for domestic use'),
('85167200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Opékače topinek elektrotepelné', 'Electric toasters, for domestic use'),
('85167920', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Ponorné fritézy elektrotepelné', 'Electric deep fat fryers, for domestic use'),
('85167970', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Ostatní elektrotepelné přístroje používané v domácnostech', 'Electro-thermic appliances, for domestic use (excl. hairdressing appliances and'),
('85168020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpory topné elektrické spojené izolovaným rámem', 'Electric heating resistors, assembled with an insulated former'),
('85168080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpory topné elektrické ostatní,ne:spojené izolovaným rámem', 'Electric heating resistors (excl. electric heating resistors assembled with an i'),
('85169000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části přístrojů elektrotepelných zejména pro domácnost', 'Parts of electric water heaters, immersion heaters, space-heating apparatus and'),
('85171100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje telefonní drátové s bezdrátovými mikrotelefony', 'Line telephone sets with cordless handsets'),
('85171200', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje telefonní pro celulární nebo jiné bezdrátové sítě', 'Telephones for cellular networks "mobile telephones" or for other wireless netwo'),
('85171800', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje telefonní ostatní,ne:viz sazebník', 'Telephone sets (excl. line telephone sets with cordless handsets and telephones'),
('85176100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Základní stanice', 'Base stations of apparatus for the transmission or reception of voice, images or'),
('85176200', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zařízení pro příjem,konverzi,vysílání,regeneraci hlasu,dat,vč.přepínacích přístrojů', 'Machines for the reception, conversion and transmission or regeneration of voice'),
('85176910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Videotelefony', 'Videophones'),
('85176920', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Systémy vstupní telefonické', 'Entry-phone systems'),
('85176931', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přijímače přenosné pro volání,upozorňování nebo vyhledávání osob', 'Portable receivers for calling, alerting or paging'),
('85176939', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje přijímací pro radiotelefonii nebo radiotelegrafii ostatní,ne:viz sazebník', 'Reception apparatus for radio-telephony or radio-telegraphy (excl. portable rece'),
('85176990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje na vysílání,přijímání hlasu,dat ostatní,ne:viz sazebník', 'Apparatus for the transmission or reception of voice, images or other data, incl'),
('85177011', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Antény pro přístroje radiotelegrafické,radiotelefonní', 'Aerials for radio-telegraphic or radio-telephonic apparatus'),
('85177015', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Antény teleskopické,prutové pro přenosné přístr.i k zabudov.do vozidel motor.', 'Telescopic and whip-type aerials for portable apparatus or for apparatus for fit'),
('85177019', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Antény vč.parabolických a jejich části,součásti ostatní,ne:viz sazebník', 'Aerials and aerial reflectors of all kinds and parts suitable for use with aeria'),
('85177090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti přístrojů na vysílání,přijímání hlasu,dat ostatní,ne:antény', 'Parts of telephone sets, telephones for cellular networks or for other wireless'),
('85181030', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mikrofony o frekv.300Hz-3,4KHz,průměr do 10mm,výška do 3mm,pro telekomunikace', 'Microphones having a frequency range of 300 Hz to 3,4 kHz, of a diameter <= 10 m'),
('85181095', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mikrofony a jejich stojany ostatní,ne:viz sazebník', 'Microphones and stands therefor (excl. microphones having a frequency range of 3'),
('85182100', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Reproduktory jednoduché vestavěné', 'Single loudspeakers, mounted in their enclosures'),
('85182200', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Reproduktory složené vestavěné', 'Multiple loudspeakers, mounted in the same enclosure'),
('85182930', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Reproduktory o frekv.300Hz-3,4KHz,průměr do 10mm,výška do 3mm,pro telekomunikace', 'Loudspeakers, without enclosure, having a frequency range of 300 Hz to 3,4 kHz,'),
('85182995', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Reproduktory ostatní,ne:viz sazebník', 'Loudspeakers, without enclosure (excl. those having a frequency range of 300 Hz'),
('85183020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Drátové mikrotelefony', 'Line telephone handsets, whether or not incorporating a microphone, and sets con'),
('85183095', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sluchátka všech druhů,kombinované řečnické soupravy ostatní,ne:drátové mikrotelefony', 'Headphones and earphones, whether or not combined with microphone, and sets cons'),
('85184030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zesilovače elektrické telefonní,měřicí nízkofrekvenční', 'Audio-frequency electric telephonic and measurement amplifiers'),
('85184081', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zesilovače elektrické nízkofrekvenční ostatní s 1 kanálem,ne:telefonní,měřicí', 'Audio-frequency electric amplifiers, with only one channel (excl. telephonic or'),
('85184089', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zesilovače elektrické nízkofrekvenční ostatní,ne:telefonní,měřicí,s 1 kanálem', 'Audio-frequency electric amplifiers, with more than one channel (excl. telephoni'),
('85185000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zesilovače zvuku elektrické', 'Electric sound amplifier sets'),
('85189000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části mikrofonů,reproduktorů,zesilovačů,sluchátek apod.', 'Parts of microphones, loudspeakers, headphones and earphones, earphones, audio-f'),
('85192010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Gramofony spouštěné mincí,známkou', 'Coin-operated or disc-operated record-players'),
('85192091', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje s laserovým snímacím systémem spouštěné mincí,známkou', 'Sound recording or sound reproducing apparatus, operated by coins, banknotes, ba'),
('85192099', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje pro záznam,reprodukci zvuku,spouštěné mincemi aj.platidly ost.,ne:viz sazebník', 'Sound recording or sound reproducing apparatus, operated by coins, banknotes, ba'),
('85193000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Chassis gramofonová', 'Turntables "record-decks"'),
('85195000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje odpovídající na telefonáty (telefonní záznamníky)', 'Telephone answering machines'),
('85198111', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje na přepis záznamu použ.magnetická,optická,polovodičová média', 'Transcribing machines "play only", incl. cassette-players, using magnetic, optic'),
('85198115', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přehrávače zvuku kazetové kapesní', 'Pocket-size cassette players "play only" [dimensions <= 170 mm x 100 mm x 45 mm]'),
('85198121', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přehrávače zvuku kazetové s analogovým a digitálním snímacím systémem,ne:kapesní', 'Cassette-tape players "play only" using magnetic, optical or semiconductor media'),
('85198125', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přehrávače zvuku kazetové ostatní,ne:kapesní,s analogovým a digitálním snímacím systémem', 'Cassette-tape players "play only" using magnetic, optical or semiconductor media'),
('85198131', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přehrávače zvuku s laserovým snímacím systémem,pro motor.vozidla,průměr disku <=6,5cm', 'Sound-reproducing apparatus with laser reading system "CD-players", of a kind us'),
('85198135', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přehrávače zvuku s laserovým snímacím systémem ost,ne:pro motor.vozidla,průměr disku <=6,5cm', 'Sound-reproducing apparatus with laser reading system "CD-players", without soun'),
('85198145', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přehrávače zvuku použ.magnetická,optická,polovodičová média,ostatní,ne:viz sazebník', 'Sound-reproducing apparatus, using magnetic, optical or semiconductor media, wit'),
('85198151', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Diktafony provozuschopné jen s vnějším zdrojem napájení', 'Dictating machines using magnetic, optical or semiconductor media, incorporating'),
('85198155', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Magnetofony ost.kazetové,vest.zesil.,min.1 zabud.repro.,provoz i bez vnějš.zdroje napájení', 'Magnetic tape cassette recorders, with built-in amplifier and one or more built-'),
('85198161', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Magnetofony ost.kazetové,vest.zesil.,min.1 zabud.repro.,vnější zdroj napájení', 'Magnetic tape cassette recorders, with built-in amplifier and one or more built-'),
('85198165', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Magnetofony ost.kazetové,s reprod.zař.,kapesní', 'Magnetic tape pocket size cassette recorders "dimensions <= 170 mm x 100 mm x 45'),
('85198175', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Magnetofony ost.kazetové,s reprod.zař.,ne:vest.zesil.,min.1 zabud.repro.,kapesní', 'Magnetic tape cassette recorders incorporating sound reproducing apparatus (excl'),
('85198181', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Magnetofony ost.cívkové,s reprod.zař.,rychlost záznamu,reprodukce 19cm/s,vícerychl.<=19cm/s', 'Magnetic tape recorders using magnetic tapes on reels, allowing sound recording'),
('85198185', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Magnetofony ostatní,s reprod.zař.,ne:viz sazebník', 'Magnetic tape recorders incorporating sound reproducing apparatus (excl. those o'),
('85198195', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje pro záznam,reprodukci zvuku,použ.magnet,optic,polovod.média,ost.,ne:viz sazebník', 'Sound recording or sound reproducing apparatus, using magnetic, optical or semic'),
('85198911', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Gramofony jiné než spouštěné mincí,známkou', 'Record players (excl. using magnetic, optical or semiconductor media record play'),
('85198915', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje na přepis záznamu,ne:použ.magnetická,optická,polovodičová média', 'Transcribing machines "play only", without sound recording device (excl. using m'),
('85198919', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přehrávače zvuku ostatní,ne:viz sazebník', 'Sound reproducing apparatus, without sound recording device (excl. using magneti'),
('85198990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje pro záznam,reprodukci zvuku nepouž.magnet,optic,polovod.média,ost.,ne:viz sazebník', 'Sound recording or sound reproducing apparatus (excl. using magnetic, optical or'),
('85211020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístr.pro videof.záznam,reprodukci,magnet.páska šíře do 1,3cm,posun do 50mm/s', 'Video recording or reproducing apparatus, whether or not incorporating a video t'),
('85211095', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístr.ost.pro videof.záznam,reprodukci,magnet.páska,ne:viz sazebník', 'Magnetic tape-type video recording or reproducing apparatus, whether or not inco'),
('85219000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Videopřístroje pro záznam,reprodukci ostatní,ne:používající magnetickou pásku', 'Video recording or reproducing apparatus, whether or not incorporating a video t'),
('85221000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přenosky na gramofony', 'Pick-up cartridges'),
('85229030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hroty,diamanty,safíry apod.(polo)drahokamy pro hroty i zabudované', 'Styli; diamonds, sapphires and other precious or semi-precious stones "natural,'),
('85229041', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sestavy elektronické ze 2 a více částí přístrojů podpoložky 8520 20 00', 'Electronic assemblies of telephone answering machines, n.e.s.'),
('85229049', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sestavy elektronické ze 2 a více částí přístrojů jiných než podpoložky 8520 20 00', 'Electronic assemblies for sound reproducing and recording apparatus and for vide'),
('85229070', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sestavy elektron.kazetové jednoduché do síly 53mm,pro přístr.pro zázn.a reprod.zvuku', 'Single cassette-deck assemblies with a total thickness <= 53 mm, of a kind used'),
('85229080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sestavy elektronické ostatní,ne:viz sazebník', 'Parts and accessories suitable for use solely or principally with sound reproduc'),
('85232100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Karty se zabudovaným magnet.proužkem', 'Cards incorporating a magnetic stripe for the recording of sound or of other phe'),
('85232915', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pásky,disky magnet,nenahrané', 'Magnetic tapes and magnetic discs, unrecorded, for the recording of sound or of'),
('85232931', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pásky,disky magnet,nahrané,záznam jiný než zvuk,obraz', 'Magnetic tapes and magnetic discs, recorded, for reproducing phenomena (excl. th'),
('85232933', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pásky,disky magnet,nahrané,pro reprod.instrukcí,dat,zvuku,obrazu v binár.formě,ovl.uživateli', 'Magnetic tapes and magnetic discs, recorded, for reproducing representations of'),
('85232939', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pásky,disky magnet,nahrané,ostatní,ne:viz sazebník', 'Magnetic tapes and magnetic discs, recorded, for reproducing sound or image (exc'),
('85232990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Média magnet.ostatní,ne:karty se zabudovaným magnet.proužkem,pásky,disky', 'Magnetic media for sound or image reproducing phenomena (excl. cards incorporati'),
('85234011', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Disky pro laser.snímací syst,nenahrané,kapacita <=900MB,ne:mazatelné', 'Optical discs for laser reading systems, unrecorded, of a recording capacity <='),
('85234013', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Disky pro laser.snímací syst,nenahrané,kapacita >900MB,<=18GB,ne:mazatelné', 'Optical discs for laser reading systems, unrecorded, of a recording capacity > 9'),
('85234019', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Média optic.nenahraná ostatní,ne:disky pro laser.snímací syst.s kapacitou <=18GB,mazatelné', 'Optical media, unrecorded, for the recording of sound or of other phenomena "e.g'),
('85234025', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Disky pro laser.snímací syst,nahrané,záznam jiný než zvuk,obraz', 'Optical discs for laser reading systems, recorded, for reproducing phenomena (ex'),
('85234031', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Disky pro laser.snímací syst,nahrané,pouze pro reprod.zvuku,průměr <=6,5cm', 'Optical discs for laser reading systems, recorded, for reproducing sound only, o'),
('85234039', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Disky pro laser.snímací syst,nahrané,pouze pro reprod.zvuku,průměr >6,5cm', 'Optical discs for laser reading systems, recorded, for reproducing sound only, o'),
('85234045', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Disky pro laser.snímací syst,nahrané,pro reprod.instrukcí,dat,zvuku,obrazu,ovl.uživateli', 'Optical discs for laser reading systems, recorded, for reproducing representatio'),
('85234051', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Disky pro laser.snímací syst,nahrané-digitální víceúčelové disky (DVD)', 'Digital versatile discs "DVD", recorded'),
('85234059', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Disky pro laser.snímací syst,nahrané,ostatní,ne:viz sazebník', 'Optical discs for laser reading systems, recorded, for reproducing sound and ima'),
('85234091', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Média optic.mimo disků pro laser.sním,nahraná,záznam jiný než zvuk,obraz', 'Optical media, recorded, for reproducing phenomena (excl. discs for laser readin'),
('85234093', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Média optic.mimo disků pro laser.sním,nahraná,repr.instrukcí,dat,zvuku,obrazu,ovl.uživateli', 'Optical media, recorded, for reproducing representations of instructions, data,'),
('85234099', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Média optic.mimo disků pro laser.sním,nahraná ostatní,ne:viz sazebník', 'Optical media, recorded, for reproducing sound or image (excl. discs for laser r'),
('85235110', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení paměť.polovodič,energ.nezáv,nenahraná', 'Solid-state, non-volatile data storage devices for recording data from an extern'),
('85235191', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení paměť.polovodič,energ.nezáv,nahraná,záznam jiný než zvuk,obraz', 'Solid-state, non-volatile data storage devices for recording data from an extern'),
('85235193', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení paměť.polovodič,energ.nezáv,nahraná,repr.instrukcí,dat,zvuku,obrazu,ovl.uživateli', 'Solid-state, non-volatile data storage devices for recording data from an extern'),
('85235199', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení paměť.polovodič.energ.nezáv,nahraná,ostatní,ne:viz sazebník', 'Solid-state, non-volatile data storage devices for recording data from an extern'),
('85235210', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Karty čipové se dvěma a více el.integr.obvody', 'Cards incorporating two or more electronic integrated circuits "smart cards"'),
('85235290', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Karty čipové ostatní,ne:se dvěma a více el.integr.obvody', 'Cards and tags incorporating only one electronic integrated circuit "smart cards'),
('85235910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení paměť.polovodič,energ.záv,nenahraná', 'Semiconductor media, unrecorded, for the recording of sound or of other phenomen'),
('85235991', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení paměť.polovodič.energ.záv,nahraná,záznam jiný než zvuk,obraz', 'Semiconductor media, recorded, for reproducing phenomena (excl. those for reprod'),
('85235993', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení paměť.polovodič.energ.záv,nahraná,repr.instrukcí,dat,zvuku,obrazu,ovl.uživateli', 'Semiconductor media, recorded, for reproducing representations of instructions,'),
('85235999', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení paměť.polovodič.energ.záv,nahraná,ostatní,ne:viz sazebník', 'Semiconductor media, recorded, for reproducing sound or image (excl. for reprodu'),
('85238010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Média j.n.pro záznam,nenahraná', 'Media for the recording of sound or of other phenomena, unrecorded, incl. matric'),
('85238091', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Média j.n.pro záznam,nahraná,záznam jiný než zvuk,obraz', 'Recorded media for reproducing phenomena (excl. those for reproducing sound or i'),
('85238093', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Média j.n.pro záznam,nahraná,pro reprod.instrukcí,dat,zvuku,obrazu,ovl.uživateli', 'Recorded media for reproducing representations of instructions, data, sound, and'),
('85238099', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Média j.n.pro záznam,nahraná,ostatní,ne:viz sazebník', 'Media, recorded, for reproducing sound or image, incl. matrices and masters for'),
('85255000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje vysílací pro rozhlas,televizi,ne:obs.přijímací zařízení', 'Transmission apparatus for radio-broadcasting or television, not incorporating r'),
('85256000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje vysílací pro rozhlas,televizi,obs.přijímací zařízení', 'Transmission apparatus for radio-broadcasting or television, incorporating recep'),
('85258011', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kamery televizní se třemi a více snímacími elektronkami', 'Television cameras, with 3 or more camera tubes'),
('85258019', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kamery televizní ostatní,ne:se třemi a více snímacími elektronkami', 'Television cameras (excl. those with 3 or more camera tubes and video recorders)'),
('85258030', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Fotoaparáty digitální', 'Digital cameras'),
('85258091', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Videokamery (kamkordéry) pouze pro záznam zvuku,obrazu snímaných televizní kamerou', 'Video camera recorders only able to record sound and images taken by the televis'),
('85258099', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Videokamery (kamkordéry) ost.,ne:pouze pro záznam zvuku,obrazu snímaných televizní kamerou', 'Video camera recorders able to record television programmes and sound and images'),
('85261000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje radiolokační,radiosondážní (radary)', 'Radar apparatus'),
('85269120', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přijímače radionavigační', 'Radio navigational receivers (excl. radar apparatus)'),
('85269180', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje radionavigační ostatní,ne:přijímače', 'Radio navigational aid apparatus (excl. receivers and radar apparatus)'),
('85269200', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje radiové pro dálkové řízení', 'Radio remote control apparatus'),
('85271210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Radiokazetové přehrávače kapesní s analog.,digit.sním.systémem bez vněj.zdroje', 'Pocket-size radiocassette players [dimensions <= 170 mm x 100 mm x 45 mm], with'),
('85271290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Radiokazetové přehrávače kapesní bez analog.,digit.sním.systému bez vněj.zdroje', 'Pocket-size radiocassette players [dimensions <= 170 mm x 100 mm x 45 mm], with'),
('85271310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Radia s magnetofonem,laserový snímací systém bez vněj.zdroje napáj,ne:kapesní', 'Radio-broadcast receivers capable of operating without an external source of pow'),
('85271391', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Radia s magnetof.kazetové,analog.,digit.sním.systémem bez vn.zdroje,ne:kapesní', 'Cassette radios, capable of operating without an external source of power, combi'),
('85271399', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Radia s magnetof.kazetové bez analog.,digit.sním.syst.bez vn.zdroje,ne:kapesní', 'Radio-broadcast receivers capable of operating without an external source of pow'),
('85271900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Radia bez magnetofonu bez vnějšího zdroje energie', 'Radio-broadcast receivers capable of operating without an external source of pow'),
('85272120', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Radia s magnetof.pro vozidla motorová,laserový sním.systém,vnější zdroj', 'Radio-broadcast receivers capable of receiving and decoding digital Radio Data S'),
('85272152', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Radia s kazet.magnetofonem,digitálně analog.sním.syst.,vn.zdroj,pro motor.vozidla', 'Cassette-radio-broadcast receivers capable of receiving and decoding digital Rad'),
('85272159', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Radia s kazet.magnetof.bez digit.analog.sním.syst.,vnější zdroj pro motor.vozidla', 'Radio-broadcast receivers capable of receiving and decoding digital Radio Data S'),
('85272170', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Radia s magnetofonem pro vozidla motorová,laserový sním.systém,vnější zdroj', 'Radio-broadcast receivers of a type used in motor vehicles, only capable of bein'),
('85272192', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Radia s kazet.magnetof.,digit.analog.sním.syst.,vnější zdroj,pro motor.vozidla', 'Cassette-radio-broadcast receivers of a kind used in motor vehicles, only capabl'),
('85272198', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Radia s kazet.magnetof.bez digit.analog.sním.syst.,vnější zdroj,pro motor.vozidla', 'Radio-broadcast receivers of a kind used in motor vehicles, only capable of bein'),
('85272900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Radia bez megnetofonu pro vozidla motorová,vnější zdroj', 'Radio-broadcast receivers not capable of operating without an external source of'),
('85279111', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Rádia v uzavření s reproduktory,s magnetofonem s analog.a digitál.snímacím syst.', 'Cassette radios, only mains-operated, with, in the same housing, one or more lou'),
('85279119', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Rádia v uzavření reproduktory,ne:s magnetofonem s analog.a digitál.snímacím syst.', 'Radio receivers, only mains-operated, with, in the same housing, one or more lou'),
('85279135', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Rádia s laser.snímacím syst.,ne:v uzavření reproduktory', 'Radio-broadcast receivers, for mains operation only, without built-in loudspeake'),
('85279191', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Rádia s magnetofonem s analog.adigitál.snímacím syst.,ne:v uzavření s reproduktory', 'Cassette radios, only mains-operated, without built-in loudspeakers, combined wi'),
('85279199', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Rádia s přístrojem pro zázn,reprod.zvuku,ostatní,ne:viz sazebník', 'Radio receivers, only mains-operated, without built-in loudspeakers, combined wi'),
('85279210', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Rádia bez přístroje pro zázn,reprod.zvuku,s budíkem', 'Alarm clock radios, for mains operation only, not combined with sound recording'),
('85279290', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Rádia bez přístroje pro zázn,reprod.zvuku,s hodinami,ne:s budíkem', 'Radio-broadcast receivers, for mains operation only, not combined with sound rec'),
('85279900', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Rádia bez přístroje pro zázn,reprod.zvuku ostatní,ne:s hodinami,budíkem', 'Radio-broadcast receivers, for mains operation only, not combined with sound rec'),
('85284100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Monitory CRT pro syst.autom.zprac.dat HS 8471', 'Cathode-ray tube monitors of a kind solely or principally used in an automatic d'),
('85284910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Monitory CRT černobílé,monochromní,ne:pro syst.autom.zprac.dat HS 8471', 'Cathode-ray tube monitors, black and white or other monochrome, not incorporatin'),
('85284935', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Monitory CRT barevné,obrazovka š/v <1,5,ne:pro syst.autom.zprac.dat HS 8471', 'Cathode-ray tube monitors, colour, with cathode ray tube with a screen width/hei'),
('85284991', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Monitory CRT barevné,obrazovka š/v >=1,5,zobr.<=625 ř.,ne:pro syst.autom.zprac.dat HS 8471', 'Cathode-ray tube monitors, colour, with cathode ray tube with a screen width/hei'),
('85284999', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Monitory CRT barevné,obrazovka š/v >=1,5,zobr.>625 ř.,ne:pro syst.autom.zprac.dat HS 8472', 'Cathode-ray tube monitors, colour, with cathode ray tube with a screen width/hei'),
('85285100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Monitory ost.pro syst.autom.zprac.dat HS 8471,ne:CRT', 'Monitors of a kind solely or principally used in an automatic data-processing ma'),
('85285910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Monitory ost.černobílé,monochromní,ne:pro syst.autom.zprac.dat HS 8471,CRT', 'Monitors, black and white or other monochrome, not incorporating television rece'),
('85285990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Monitory ost.barevné,ne:pro syst.autom.zprac.dat HS 8471,CRT', 'Monitors, colour, not incorporating television reception apparatus (excl. with c'),
('85286100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Projektory pro systémy autom.zprac.dat čísla 8471', 'Projectors of a kind solely or principally used in an automatic data-processing'),
('85286910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Projektory prac.pomocí plochého panel.displeje,zobr.digit.info ze zař.pro autom.zprac.dat', 'Projectors, operating by means of flat panel display [e.g. a liquid crystal devi'),
('85286991', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Projektory černobílé,monochormní ostatní,ne:viz sazebník', 'Projectors, black and white or other monochrome, not incorporating television re'),
('85286999', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Projektory barevné ostatní,ne:viz sazebník', 'Projectors, colour, not incorporating television reception apparatus (excl. of a'),
('85287111', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Videotunery - el.sestavy k zabudování do zař.pro autom.zprac.dat', 'Video tuners electronic assemblies for incorporation into automatic data-process'),
('85287113', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Videotunery - set-top box s komunik.fcí (mikroprocesor,modem,interakt.výměna info,příjem TV)', 'Apparatus with a microprocessor-based device incorporating a modem for gaining a'),
('85287119', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Videotunery ostatní,ne:viz sazebník', 'Video tuners (excl. electronic assemblies for incorporation into automatic data-'),
('85287190', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přijímače televizní bez vestav.displeje,obrazovky ostatní,ne:videotunery', 'Reception apparatus for television, whether or not incorporating radio-broadcast'),
('85287210', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení projekční televizní,barevné', 'Television projection equipment, colour, designed to incorporate a video display'),
('85287220', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přijímače televizní barevné,s vestavěným videorekordérem,videopřehrávačem', 'Reception apparatus for television, colour, incorporating a video recorder or re'),
('85287231', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přijímače televizní barevné,integrální obrazovka š/v <1,5,úhlopříčka <=42cm', 'Reception apparatus for television, colour, with integral tube, with a screen wi'),
('85287233', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přijímače televizní barevné,integrální obrazovka š/v <1,5,úhlopříčka >42cm,<=52cm', 'Reception apparatus for television, colour, with integral tube, with a screen wi'),
('85287235', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přijímače televizní barevné,integrální obrazovka š/v <1,5,úhlopříčka >52cm,<=72cm', 'Reception apparatus for television, colour, with integral tube, with a screen wi'),
('85287239', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přijímače televizní barevné,integrální obrazovka š/v <1,5,úhlopříčka >72cm', 'Reception apparatus for television, colour, with integral tube, with a screen wi'),
('85287251', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přijímače televizní barevné,integrální obrazovka š/v >=1,5,zobr.<=625 ř.,úhlopříčka <=75cm', 'Reception apparatus for televisions, colour, with integral tube, with a screen w'),
('85287259', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přijímače televizní barevné,integrální obrazovka š/v >=1,5,zobr.<=625 ř.,úhlopříčka >75cm', 'Reception apparatus for television, colour, with integral tube, with a screen wi'),
('85287275', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přijímače televizní barevné,integrální obrazovka š/v >=1,5,zobr.>625 ř.', 'Reception apparatus for television, colour, with integral tube, with a screen wi'),
('85287291', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přijímače televizní barevné ostatní,obrazovka š/v <1,5,ne:integrální obrazovka', 'Reception apparatus for television, colour, with a screen width/height ratio < 1'),
('85287299', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přijímače televizní barevné ostatní,obrazovka š/v >=1,5,ne:integrální obrazovka', 'Reception apparatus for television, colour, with a screen width/height ratio >='),
('85287300', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přijímače televizní černobílé,monochromní', 'Reception apparatus for television, black and white or other monochrome, whether'),
('85291011', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Antény teleskopické,prutové pro přenosné přístr.i k zabudov.do vozidel motor.', 'Telescopic and whip-type aerials for portable apparatus or for apparatus for fit'),
('85291031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Antény venkovní pro rozhlasové,televizní přijímače pro příjem satelitů', 'Outside aerials for radio or television broadcast receivers, for reception via s'),
('85291039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Antény venkovní pro rozhlasové,televizní přijímače,ne:pro příjem satelitů', 'Outside aerials for radio or television broadcast receivers (excl. those for sat'),
('85291065', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Antény vnitřní včetně vestavěných pro rozhlasové,televizní přijímače', 'Inside aerials for radio or television broadcast receivers, incl. built-in types'),
('85291069', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Antény ostatní,ne:viz sazebník', 'Aerials (excl. inside and outside aerials for radio or television broadcast rece'),
('85291080', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Filtry,separátory anténní', 'Aerial filters and separators'),
('85291095', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti antén všech druhů,ne:filtry,separátory', 'Aerial reflectors and parts suitable for use with aerials or aerial reflectors,'),
('85299020', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti přístrojů podpoložek 85256000,85258030,85284100,85285100,85286100', 'Parts suitable for use solely or principally with transmission apparatus incorpo'),
('85299041', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skříně,pouzdra pro přístroje rozhlasové,televizní ze dřeva', 'Cabinets and cases of wood, for transmission and reception apparatus for radio-b'),
('85299049', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skříně,pouzdra pro přístroje rozhlasové,televizní ostatní,ne:ze dřeva', 'Cabinets and cases other than of wood, for transmission and reception apparatus'),
('85299065', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Elektronické sestavy přístrojů čísel 8525 až 8528 podpoložek viz sazebník', 'Electronic assemblies suitable for use solely or principally with transmission a'),
('85299092', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti pro televizní kamery podpol.85258011,85258019,přístroje čísel 8527,8528', 'Parts suitable for use solely or principally with television cameras, reception'),
('85299097', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti přístrojů čísel 8525 až 8528 ostatní,ne:viz sazebník', 'Parts suitable for use solely or principally with transmission apparatus not inc'),
('85301000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje el.signalizační,bezpečnostní apod.pro dopravu železniční,tramvajovou', 'Electrical signalling, safety or traffic control equipment for railways or tramw'),
('85308000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje el.signal.,bezpeč.apod.pro parkoviště,dopravu silniční,říční,letiště', 'Electrical signalling, safety or traffic control equipment (excl. that for railw'),
('85309000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části přístrojů elektrických signalizačních,bezpečnostních apod.pro dopravu', 'Parts of electrical signalling, safety or traffic control equipment, n.e.s.'),
('85311030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení elektrická poplachová,proti krádeži,požáru apod.pro zabezpečení budov', 'Burglar or fire alarms and similar apparatus, for use in buildings'),
('85311095', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zařízení elektrická poplachová,proti krádeži,požáru apod.ost.,ne:pro budovy,motor.vozidla', 'Burglar or fire alarms and similar apparatus (excl. those for use in motor vehic'),
('85312020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Panely návěstní se zabudovanými diodami vyzařujícími světlo (LED)', 'Indicator panels with light emitting diodes "LED" (excl. those of a kind used fo'),
('85312040', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Panely návěstní se zabud.zařízeními z kapalných krystalů (LCD) s aktivní maticí', 'Indicator panels with matrix liquid crystal devices "LCD", active (excl. those o'),
('85312095', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Panely návěstní se zabud.zařízeními z kapalných krystalů (LCD),ne:s aktivní maticí', 'Indicator panels with liquid crystal devices "LCD" (excl. active matrix liquid c'),
('85318020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje s plochým panelovým displejem', 'Electric sound or visual signalling apparatus, with flat panel display devices ('),
('85318095', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje elektrické akustické nebo vizuální signalizační ostatní', 'Electric sound or visual signalling apparatus (excl. with flat panel display dev'),
('85319020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti přístrojů položky 8531 20 a podpoložky 8531 80 30', 'Parts of indicator panels with liquid crystal displays "LCD" or light-emitting d'),
('85319085', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti signalizačních přístrojů ostatních,ne:viz sazebník', 'Parts of electric sound or visual signalling equipment, n.e.s. (excl. of indicat'),
('85321000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kondenzátory elektrické pevné (silové),pro 50/60 Hz,jalový výkon nad 0,5 kVar', 'Fixed capacitors designed for use in 50/60 Hz circuits and having a reactive pow'),
('85322100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kondenzátory elektrické pevné tantalové', 'Fixed electrical capacitors, tantalum (excl. power capacitors)'),
('85322200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kondenzátory elektrické pevné aluminiové s elektrolytem', 'Fixed electrical capacitors, aluminium electrolytic (excl. power capacitors)'),
('85322300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kondenzátory elektrické pevné-keramické dielektrikum jednovrstvé', 'Fixed electrical capacitors, ceramic dielectric, single layer (excl. power capac'),
('85322400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Keramické dielektrikum,vícevrstvé', 'Fixed electrical capacitors, ceramic dielectric, multilayer (excl. power capacit'),
('85322500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kondenzátory elektrické pevné-dielektrikum papírové nebo z plastu', 'Fixed electrical capacitors, dielectric of paper or plastics (excl. power capaci'),
('85322900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kondenzátory elektrické pevné ostatní,ne:viz sazebník', 'Fixed electrical capacitors (excl. tantalum, aluminium electrolytic, ceramic, pa'),
('85323000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kondenzátory elektrické otočné nebo dolaďovací,ne:pevné', 'Variable or adjustable "pre-set" electrical capacitors'),
('85329000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části kondenzátorů elektrických pevných,otočných,dolaďovacích', 'Parts of electrical "pre-set" capacitors, fixed, variable or adjustable, n.e.s.'),
('85331000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'rezistory uhlíkové stálé,aglomerované,vrstvené', 'Fixed carbon resistors, composition or film types (excl. heating resistors)'),
('85332100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rezistory stálé,výkon do 20 W,ne:uhlíkové', 'Fixed electrical resistors for a power handling capacity <= 20 W (excl. heating'),
('85332900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rezistory stálé,výkon nad 20 W,ne:uhlíkové', 'Fixed electrical resistors for a power handling capacity > 20 W (excl. heating r'),
('85333100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rezistory proměnné drátové (navíjené) vč.reostatů,potenciometrů,výkon do 20 W', 'Wirewound variable electrical resistors, incl. rheostats and potentiometers, for'),
('85333900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rezistory proměnné drátové (navíjené) vč.reostatů,potenciometrů,výkon nad 20 W', 'Wirewound variable electrical resistors, incl. rheostats and potentiometers, for'),
('85334010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rezistory proměnné ost.vč.reostatů,potenciometrů,výkon do 20 W,ne:drátové', 'Electrical variable resistors, incl. rheostats and potentiometers, for a power h'),
('85334090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rezistory proměnné ost.vč.reostatů,potenciometrů,výkon nad 20 W,ne:drátové', 'Electrical variable resistors, incl. rheostats and potentiometers, for a power h'),
('85339000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části odporů elektrických,reostatů,potenciometrů', 'Parts of electrical resistors, incl. rheostats and potentiometers, n.e.s.'),
('85340011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Obvody tištěné,vícevrstvé,sestávající pouze z polovodič.prvků a kontaktů', 'Multilayer printed circuits, consisting only of conductor elements and contacts'),
('85340019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Obvody tištěné obsahující jen polovodičové prvky,kontakty ost.,ne:vícenásobné', 'Printed circuits consisting only of conductor elements and contacts (excl. multi'),
('85340090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Obvody tištěné ostatní,ne:obsahující jen polovodičové prvky,kontakty', 'Printed circuits consisting of conductor elements, contacts and other passive el'),
('85351000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pojistky pro napětí nad 1000 V', 'Fuses for a voltage > 1.000 V'),
('85352100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vypínače elektrických obvodů automatické pro napětí nad 1-72,5 kV', 'Automatic circuit breakers for a voltage > 1.000 V but < 72,5 kV'),
('85352900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vypínače elektrických obvodů automatické pro napětí nad 72,5 kV', 'Automatic circuit breakers for a voltage >= 72,5 kV'),
('85353010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vypínače zátěže pro napětí nad 1-72,5 kV', 'Isolating switches and make-and-break switches, for a voltage > 1.000 V but < 72'),
('85353090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vypínače zátěže pro napětí nad 72,5 kV', 'Isolating switches and make-and-break switches, for a voltage >= 72,5 kV'),
('85354000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bleskojistky,omezovače napětí,proudu pro napětí nad 1 000 V', 'Lightning arresters, voltage limiters and surge suppressors, for a voltage > 1.0'),
('85359000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zařízení elektrické k ochraně elektrických obvodů ostatní nad 1 000 V,ne:viz sazebník', 'Electrical apparatus for switching or protecting electrical circuits, or for mak'),
('85361010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pojistky pro napětí do 1 000 V,intenzita do 10 A', 'Fuses for a current <= 10 A, for a voltage <= 1.000 V'),
('85361050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pojistky pro napětí do 1 000 V,intenzita nad 10-63 A', 'Fuses for a current > 10 A but <= 63 A, for a voltage <= 1.000 V'),
('85361090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pojistky pro napětí do 1 000 V,intenzita nad 63 A', 'Fuses for a current > 63 A, for a voltage <= 1.000 V'),
('85362010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vypínače elektrických obvodů automatické pro napětí do 1000V,intenzita do 63A', 'Automatic circuit breakers for a voltage <= 1.000 V, for a current <= 63 A'),
('85362090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vypínače elektrických obvodů automatické pro napětí do 1000V,intenzita nad 63A', 'Automatic circuit breakers for a voltage <= 1.000 V, for a current > 63 A'),
('85363010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zařízení k ochraně el.obvodů ost.,napětí do 1000V,intenzita do 16A,ne:pojistky', 'Apparatus for protecting electrical circuits for a voltage <= 1.000 V, for a cur'),
('85363030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zaříz.k ochraně el.obvodů ost.,napětí do 1000V,intenz.nad 16-125A,ne:pojistky', 'Apparatus for protecting electrical circuits for a voltage <= 1.000 V, for a cur'),
('85363090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zaříz.k ochraně el.obvodů ost.,napětí do 1000V,intenz.nad 125A,ne:pojistky', 'Apparatus for protecting electrical circuits for a voltage <= 1.000 V, for a cur'),
('85364110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Relé,napětí do 60 V,intenzita do 2 A', 'Relays for a voltage <= 60 V, for a current <= 2 A'),
('85364190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Relé,napětí do 60 V,intenzita nad 2 A', 'Relays for a voltage <= 60 V, for a current > 2 A'),
('85364900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Relé ostatní,napětí nad 60-1 000 V', 'Relays for a voltage > 60 V but <= 1.000 V'),
('85365003', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Elektronické AC vypínače,spínače z opticky spoj.vstupních,výstupních obvodů', 'Electronic AC switches consisting of optically coupled input and output circuits'),
('85365005', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Elektronické vypínače,spínače (chip-on-chip technologie) - viz sazebník', 'Electronic switches, incl. temperature protected electronic switches, consisting'),
('85365007', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Elektromechanické stiskací vypínače a spínače pro proud nepřesahující 11A', 'Electromechanical snap-action switches for a current <= 11 A (excl. relays and a'),
('85365011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vypínače,spínače stiskací,napětí do 60 V', 'Push-button switches for a voltage of <= 60 V'),
('85365015', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vypínače,spínače otočné,napětí do 60 V', 'Rotary switches for a voltage of <= 60 V'),
('85365019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vypínače,spínače ostatní,napětí do 60 V;ne:otočné,stiskací,automatické', 'Switches for a voltage of <= 60 V (excl. relays, push-button switches and rotary'),
('85365080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vypínače,spínače ostatní,ne:viz sazebník', 'Switches for a voltage of > 60 V and <= 1.000 V (excl. relays, automatic circuit'),
('85366110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Objímky žárovek s paticí šroubovanou do 1 000 V', 'Edison lamp holders, electric'),
('85366190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Objímky žárovek ostatní do 1 000 V,ne:patice šroubovaná', 'Lamp holders for a voltage <= 1.000 V (excl. Edison lamp holders)'),
('85366910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zástrčky,zásuvky pro koaxiální kabely', 'Plugs and sockets for a voltage of <= 1.000 V, for coaxial cables'),
('85366930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zástrčky,zásuvky pro tištěné obvody', 'Plugs and sockets for a voltage of <= 1.000 V, for printed circuits'),
('85366990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zástrčky,zásuvky ostatní;ne:pro koaxiální kabely,tištěné obvody', 'Plugs and sockets for a voltage of <= 1.000 V (excl. those for coaxial cables an'),
('85367000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Konektory pro opt.vlákna,pro svazky opt.vláken,pro kabely z opt.vláken', 'Connectors for optical fibres, optical fibre bundles or cables'),
('85369001', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prvky prefabrikované pro obvody elektrické do 1 000 V', 'Prefabricated elements for electrical circuits, for a voltage of <= 1.000 V'),
('85369010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Propojky,kontakty pro dráty,kabely', 'Connections and contact elements, for wire and cables, for a voltage of <= 1.000'),
('85369020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zařízení pro zkoušení polovodičových destiček', 'Wafer probers'),
('85369085', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zařízení elektricá k vypínání,spínání,ochraně obvodů ostatní,ne:viz sazebník', 'Electrical apparatus for making connections to or in electrical circuits, for a'),
('85371010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Panely,pulty apod.číslic.říz.se zaříz.pro aut.zprac.dat elektrické,do 1 000V', 'Numerical control panels with built-in automatic data-processing machines'),
('85371091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prvky řídící programovatelné paměťové pro zařízení do 1 000 V', 'Programmable memory controllers (excl. numerical control panels with built-in au'),
('85371099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rozvaděče,rozvod.panely apod.pro zařízení,rozvody el.ost.do 1 000V,ne:viz sazebník', 'Boards, cabinets and similar combinations of apparatus for electric control or t'),
('85372091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rozvaděče,rozvod.panely apod.pro zařízení,rozvody elektrické,napětí 1-72,5 kV', 'Boards, cabinets and similar combinations of apparatus for electric control or t'),
('85372099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rozvaděče,rozvod.panely apod.pro zařízení,rozvody elektrické,napětí nad 72,5kV', 'Boards, cabinets and similar combinations of apparatus for electric control or t'),
('85381000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rozvaděče,rozvod.panely,pulty,skříně apod.bez přístrojů', 'Boards, panels, consoles, desks, cabinets and other bases for the goods of headi'),
('85389011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Elektronické sestavy přístrojů podpoložky 85369020', 'Electronic assemblies for wafer probers of subheading 8536.90.20'),
('85389019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti podpoložky 85369020 ostatní,ne:elektronické sestavy', 'Parts for wafer probers of subheading 8536.90.20, n.e.s. (excl. electronic assem'),
('85389091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Elektronické sestavy přístrojů čísel 8536 nebo 8537 ostatní,ne:viz sazebník', 'Electronic assemblies for electrical apparatus for switching or protecting elect'),
('85389099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části součásti přístrojů čísel 8536 nebo 8537 ostatní,ne:viz sazebník', 'Parts suitable for use solely or principally with the apparatus of heading 8535,'),
('85391000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Žárovky pro světlomety tzv.zapečetěné světlomety', 'Sealed beam lamp units'),
('85392130', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Žárovky halogenové s wolframovým vláknem pro vozidla motorová', 'Tungsten halogen filament lamps for motorcycles or other motor vehicles (excl. s'),
('85392192', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Žárovky a podobně halogenové s wolramovým vláknem ostatní do 100 V', 'Tungsten halogen filament lamps for a voltage > 100 V'),
('85392198', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Žárovky halogenové s wolfram.vláknem do 100W ost.,ne:pro motorová vozidla', 'Tungsten halogen filament lamps for a voltage <= 100 V (excl. those for motorcyc'),
('85392210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Žárovky do reflektorů ost.,výkon do 200 W,napětí nad 100 V,ne:halogenové', 'Reflector filament lamps of a power <= 200 W and for a voltage > 100 V (excl. tu'),
('85392290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Žárovky,zářivky ost.,výkon do 200W,napětí nad 100V,ne:halogenové,do reflektorů', 'Filament lamps of a power <= 200 W and for a voltage > 100 V (excl. tungsten hal'),
('85392930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Žárovky ost.pro motocykly,vozidla motorová,ne:viz sazebník', 'Filament lamps for motorcycles or other motor vehicles (excl. tungsten halogen l'),
('85392992', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Žárovky,zářivky ostatní,výkon nad 200W,napětí nad 100V,ne:halogenové,motor.vozidel', 'Filament lamps for a voltage > 100 V (excl. tungsten halogen lamps, lamps of a p'),
('85392998', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Žárovky,zářivky ostatní,napětí do 100V,ne:halogenové,pro motor.voz.', 'Filament lamps for a voltage <= 100 V (excl. tungsten halogen lamps and lamps fo'),
('85393110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Výbojky fluorescenční s horkou katodou s oboustrannou paticí,ne:ultrafialové', 'Discharge lamps, fluorescent, hot cathode, with double ended cap'),
('85393190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Výbojky fluorescenční s horkou katodou ost.,ne:patice oboustranné,ultrafialové', 'Discharge lamps, fluorescent, hot cathode (excl. with double ended cap)'),
('85393210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Výbojky rtuťové', 'Mercury vapour lamps'),
('85393250', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Výbojky sodíkové', 'Sodium vapour lamps'),
('85393290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kovové halogenové žarovky opstatní,ne:s wolframovým vláknem,rtuťové,sodíkové', 'Metal halide lamps'),
('85393900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Výbojky ostatní,ne:viz sazebník', 'Discharge lamps (excl. flourescent, hot cathode lamps, mercury or sodium vapour'),
('85394100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Obloukovky', 'Arc lamps'),
('85394910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Žárovky ultrafialové', 'Ultraviolet lamps'),
('85394930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Žárovky infračervené', 'Infra-red lamps'),
('85399010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Patice žárovek, elektronek', 'Lamp bases for filament or discharge lamps and other lamps of heading 8539, n.e.'),
('85399090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části žárovek, výbojek, obloukovek, ne patice', 'Parts of electric filament or discharge lamps, sealed beam lamp units, ultraviol'),
('85401111', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Obrazovky pro TV,monitory barevné,šířka/výška pod 1,5,úhlopříčka do 42cm', 'Cathode ray television picture tubes, incl. video monitor cathode ray tubes, col'),
('85401113', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Obrazovky pro TV,monitory barevné,šířka/výška pod 1,5,úhlopříčka nad 42-52cm', 'Cathode ray television picture tubes, incl. video monitor cathode ray tubes, col'),
('85401115', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Obrazovky pro TV,monitory barevné,šířka/výška pod 1,5,úhlopříčka nad 52-72cm', 'Cathode ray television picture tubes, incl. video monitor cathode ray tubes, col'),
('85401119', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Obrazovky pro TV,monitory barevné,šířka/výška pod 1,5,úhlopříčka nad 72cm', 'Cathode ray television picture tubes, incl. video monitor cathode ray tubes, col'),
('85401191', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Televizní obrazovky barevné,úhlopříčka nepřesahující 75 cm;ne:viz saz', 'Cathode ray television picture tubes, incl. video monitor cathode ray tubes, col'),
('85401199', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Televizní obrazovky barevné,úhlopříčka přesahující 75 cm;ne:viz sazeb', 'Cathode ray television picture tubes, incl. video monitor cathode ray tubes, col'),
('85401200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Obrazovky pro TV,monitory černmobílé nebo ostatní monochromní', 'Cathode ray television picture tubes, incl. video monitor cathode ray tubes, bla'),
('85402010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Elektronky televizních kamer snímací', 'Television camera tubes'),
('85402080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Elektronové měniče a zesilovače obrazu;ost.fotokatodové elektronky', 'Image converters and intensifiers and other photo cathode tubes (excl. televisio'),
('85404000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Obrazovky s grafickým zobrazením barevné,luminoformní bod pod 0,4mm,ne:televizní', 'Data-graphic display tubes, colour, with a phosphor dot screen pitch of < 0,4 mm'),
('85405000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Obrazovky s grafickým zobrazením černobílé,jiné monochromní,ne:televizní', 'Data-graphic display tubes, black and white or other monochrome (excl. photo cat'),
('85406000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Obrazovky ostatní,ne:viz sazebník', 'Cathoderay tubes (excl. television and video-monitor cathoderay tubes, televisio'),
('85407100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Magnetrony', 'Magnetrons'),
('85407200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Klystrony', 'Klystrons'),
('85407900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Elektronky mikrovlnné ostatní,ne:s řídící mřížkou,magnetrony,klystrony', 'Microwave tubes, e.g. travelling wave tubes and carcinotrons (excl. magnetrons,'),
('85408100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Elektronky,trubice přijímací,zesilovací', 'Receiver or amplifier valves and tubes (excl. microwave tubes, photo-cathode tub'),
('85408900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Elektronky a trubice ostatní,ne:viz sazebník', 'Electronic valves and tubes (excl. receiver or amplifier valves and tubes, micro'),
('85409100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti obrazovek', 'Parts of cathode ray tubes, n.e.s.'),
('85409900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti elektronek,trubic,ne:obrazovek', 'Parts of thermionic, cold cathode or photo cathode valves and tubes, n.e.s. (exc'),
('85411000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Diody,jiné než fotosenzitivní nebo diody vyzařující světlo(LED)', 'Diodes (excl. photosensitive or light emitting diodes)'),
('85412100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tranzistory,jiné než fotosenzitivní se ztrátovým výkonem menším než 1W', 'Transistors with a dissipation rate < 1 W (excl. photosensitive transistors)'),
('85412900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tranzistory,jiné než fotosenzitivní ost.,ne:se ztrátovým výkonem menším než 1W', 'Transistors with a dissipation rate >= 1 W (excl. photosensitive transistors)'),
('85413000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyristory,diaky a triaky,jiné než fotosenzitivní zařízení', 'Thyristors, diacs and triacs (excl. photosensitive semiconductor devices)'),
('85414010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Diody vyzařující světlo(LED),včetně laserových diod', 'Light-emitting diodes, incl. laser diodes'),
('85414090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Fotosenzitivní polovodičová zařízení ostatní,ne:viz sazebník', 'Photosensitive semiconductor devices, incl. photovoltaic cells'),
('85415000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polovodičová zařízení ostatní,ne:viz sazebník', 'Semiconductor devices, n.e.s.'),
('85416000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Krystaly piezoelektrické zamontované', 'Mounted piezoelectric crystals'),
('85419000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části diod,tranzistorů apod.polovodičových zařízení', 'Parts of diodes, transistors and similar semiconductor devices; photosensitive s'),
('85423110', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Procesory a řídicí jedn.multičip.- propoj.monolit.integr.obv.neodděl.,bez jiných obv.prvků', 'Electronic integrated circuits as processors and controllers, whether or not com'),
('85423190', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Procesory a řídicí jedn.ostatní,též komb.s paměťmi,zesilovači aj.obvody,ne:viz sazebník', 'Electronic integrated circuits as processors and controllers, whether or not com'),
('85423210', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Paměti multičip.- propoj.monolit.integr.obv.neodděl.,bez jiných obv.prvků', 'Electronic integrated circuits as memories in the form of multichip integrated c'),
('85423231', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Paměti dynamické s přímým vstupem (D-RAM),kapacita <=512Mbit', 'Electronic integrated circuits as dynamic random-access memories "D-RAMs", with'),
('85423239', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Paměti dynamické s přímým vstupem (D-RAM),kapacita >512Mbit', 'Electronic integrated circuits as dynamic random-access memories "D-RAMs", with'),
('85423245', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Paměti statické s přímým přístupem (S-RAM),vč.rychlé vyrovn.paměti (cache-RAM)', 'Electronic integrated circuits as static random access memories "static RAMs", i'),
('85423255', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Paměti programovatelné permanentní,vymaz.UV paprsky (EPROM)', 'Electronic integrated circuits as UV erasable, programmable read-only memories "'),
('85423261', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Paměti programovatelné permanentní,vymaz.elektricky (E2PROM),Flash,kapacita <=512Mbit', 'Electronic integrated circuits as electrically erasable, programmable read-only'),
('85423269', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Paměti programovatelné permanentní,vymaz.elektricky (E2PROM),Flash,kapacita >512Mbit', 'Electronic integrated circuits as electrically erasable, programmable read-only'),
('85423275', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Paměti programovatelné permanentní,vymaz.elektricky (E2PROM),ostatní,ne:Flash', 'Electronic integrated circuits as electrically erasable, programmable read-only'),
('85423290', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Paměti ostatní,ne:viz sazebník', 'Memories in multicombinational forms such as stack D-RAMs and modules (excl. in'),
('85423300', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zesilovače', 'Electronic integrated circuits as amplifiers'),
('85423910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Obvody integr.elektronické j.n.multičip.- propoj.monolit.integr.obv.neodděl.,bez j.obv.prvků', 'Electronic integrated circuits in the form of multichip integrated circuits cons'),
('85423990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Obvody integr.elektronické ostatní,ne:viz sazebník', 'Electronic integrated circuits (excl.  in the form of multichip integrated circu'),
('85429000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části obvodů integrovaných elektronických,mikrosestav', 'Parts of electronic integrated circuits, n.e.s.'),
('85431000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Urychlovače částic', 'Electrical particle accelerators for electrons, protons, etc. (excl. ion implant'),
('85432000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vysílače měřící', 'Signal generators, electrical'),
('85433000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje ke galvanickému pokovování,elektroanalýze,elektroforéze', 'Machines and apparatus for electroplating, electrolysis or electrophoresis'),
('85437010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zařízení elektronická s překladatelskými,slovníkovými funkcemi', 'Electrical machines with translation or dictionary functions'),
('85437030', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zesilovače anténní', 'Aerial amplifiers'),
('85437051', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Lůžka,lampy solární apod.,fluorescenční trubice s UV-A paprsky <=100cm', 'Sunbeds, sunlamps and similar suntanning equipment, for fluorescent tubes using'),
('85437055', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Lůžka,lampy solární apod.,fluorescenční trubice s UV-A paprsky >100cm', 'Sunbeds, sunlamps and similar suntanning equipment, for fluorescent tubes using'),
('85437059', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Lůžka,lampy solární apod.,ostatní,ne:fluorescenční trubice s UV-A paprsky', 'Sunbeds, sunlamps and similar suntanning equipment (other than for fluorescent t'),
('85437060', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ohrady (ploty) elektricky napájené', 'Electric fence energisers'),
('85437090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje,přístroje elektrické s vlastní individuální funkcí ostatní,ne:viz sazebník', 'Electrical machines and apparatus, having individual functions, n.e.s. in chap.'),
('85439000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti strojů,přístrojů elektrických s vlastní individuální funkcí,ne:viz sazebník', 'Parts of electrical machines and apparatus, having individual functions, n.e.s.'),
('85441110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dráty s el.izolací k navíjení měděné lakované,smaltované', 'Winding wire for electrical purposes, of copper, lacquered or enamelled'),
('85441190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dráty s el.izolací k navíjení měděné ost.,ne:lakované,smaltované', 'Winding wire for electrical purposes, of copper, insulated (excl. lacquered or e'),
('85441910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dráty s el.izolací k navíjení z ost.kovů lakované,smaltované,ne:měděné', 'Winding wire for electrical purposes, of material other than copper, lacquered o'),
('85441990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dráty s el.izolací k navíjení z ost.kovů,ne:lakované,smaltované,měděné', 'Winding wire for electrical purposes, of material other than copper, insulated ('),
('85442000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Koaxiální kabely,ostatní koaxiální vodiče', 'Coaxial cable and other coaxial electric conductors, insulated'),
('85443000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Soupravy kabelů zapalovacích,ost.soupravy el.izolovaných drátů pro vozidla,letadla a lodě', 'Ignition wiring sets and other wiring sets for vehicles, aircraft or ships'),
('85444210', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vodiče elektrické ost,napětí <=1000V,s přípojkami,pro telekomunikace,ne:viz sazebník', 'Electric conductors of a kind used for telecommunications, for a voltage <= 1.00'),
('85444290', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vodiče elektrické ost,napětí <=1000V,s přípojkami,ne:pro telekomunikace,viz sazebník', 'Electric conductors, for a voltage <= 1.000 V, insulated, fitted with connectors'),
('85444920', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vodiče elektrické ost,napětí <=80V,bez přípojek,pro telekomunikace,ne:viz sazebník', 'Conductors, electric, for a voltage <= 80 V, insulated, not fitted with connecto'),
('85444991', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dráty,kabely elektrické ost,napětí <=1000V,bez přípojek,průměr >0,51mm,ne:viz sazebník', 'Electric wire and cables, for a voltage <= 1.000 V, insulated, not fitted with c'),
('85444993', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vodiče elektrické ost,napětí <=80V,bez přípojek,průměr drátu <=0,51mm,ne:viz sazebník', 'Conductors, electric, for a voltage <= 80 V, insulated, not fitted with connecto'),
('85444995', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vodiče elektrické ost,napětí >80V,<=1000V,bez přípojek,průměr drátu <=0,51mm,ne:viz sazebník', 'Electric conductors for a voltage > 80 V but < 1.000 V, insulated, not fitted wi'),
('85444999', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vodiče elektrické ost,napětí 1000V,bez přípojek,průměr drátu <=0,51mm,ne:viz sazebník', 'Electric conductors for a voltage 1.000 V, insulated, not fitted with connectors'),
('85446010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vodiče měděné elektrické pro napětí nad 1 000 V', 'Electric conductors for a voltage > 1.000 V, insulated, with copper conductors,'),
('85446090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vodiče elektrické z ostatních materiálů pro napětí nad 1 000 V,ne:měděné', 'Electric conductors for a voltage > 1.000 V, insulated, not with copper conducto'),
('85447000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kabely z vláken optických', 'Optical fibre cables made up of individually sheathed fibres, whether or not con'),
('85451100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Elektrody uhlíkové pro pece', 'Electrodes of graphite or other carbon, for electric furnaces'),
('85451910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Elektrody uhlíkové pro elektrolytická zařízení', 'Electrodes of graphite or other carbon, for electrolysis installations'),
('85451990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Elektrody uhlíkové ostatní,ne:pro elektrolytická zařízení,pece', 'Electrodes of graphite or other carbon, for electrical purposes (excl. those for'),
('85452000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kartáčky uhlíkové', 'Carbon brushes for electrical purposes'),
('85459010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpory uhlíkové topné', 'Heating resistors for electrical purposes, of graphite or other carbon'),
('85459090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Uhlíky osvětlovací,pro elektrické baterie,výr.z uhlíku pro el.účely,ne:viz sazebník', 'Articles of graphite or other carbon, for electrical purposes (excl. electrodes,'),
('85461000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Izolátory elektrické skleněné', 'Electrical insulators of glass (excl. insulating fittings)'),
('85462010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Izolátory elektrické keramické bez kovových částí', 'Electrical insulators of ceramics, with no metal parts (excl. insulating fitting'),
('85462091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Izolátory elektrické keramické s kovem pro vrchní přenosové,trakční vedení', 'Electrical insulators of ceramics, with metal parts, for overhead power transmis'),
('85462099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Izolátory elektrické keramické s kovem ostatní,ne:viz sazebník', 'Electrical insulators of ceramics, with metal parts (excl. those for overhead po'),
('85469010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Izolátory elektrické plastové', 'Electrical insulators of plastics (excl. insulating fittings)'),
('85469090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Izolátory elektrické ostatní,ne skleněné,keramické,plastové', 'Electrical insulators (excl. those of glass, ceramics or plastics and insulating'),
('85471010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Součásti izolační keramické,obsah nad 80 % oxidy kovů', 'Insulating fittings for electrical purposes, of ceramics, containing >= 80% by w'),
('85471090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Součásti izolační keramické,obsah do 80 % oxidy kovů', 'Insulating fittings for electrical purposes, of ceramics, containing < 80% by we'),
('85472000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Součásti izolační z plastů pro elektrické stroje', 'Insulating fittings for electrical purposes, of plastics'),
('85479000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Izolační části ostatní,el.instalační trubky s vnitřní izolací,ne:viz sazebník', 'Insulating fittings for electrical purposes, of materials other than ceramics or'),
('85481010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Články galvanické,baterie nepoužitelné', 'Spent primary cells and spent primary batteries, electrical'),
('85481021', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NEL'), 'Akumulátory olověné,nepoužitelné', 'Spent electric lead-acid accumulators'),
('85481029', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NEL'), 'Akumulátory elektrické nepoužitelné ostatní,ne:olověné', 'Spent electric accumulators (excl. lead-acid accumulators)'),
('85481091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,zbytky galvanických článků,baterií,el.akumulátorů obsahující olovo', 'Waste and scrap of electric primary cells, primary batteries and accumulators, c'),
('85481099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Odpad,zbytky galvanických článků,baterií,el.akumulátorů ost.,ne:obsah.olovo', 'Waste and scrap of electric primary cells, primary batteries and accumulators (e'),
('85489020', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Paměti v multikombinovaných formách (např.zásobníkové D-RAM a moduly)', 'Memories in multicombinational forms such as stack D-RAMs and modules'),
('85489090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'El.části a součásti strojů,přístrojů jinde neuvedené,ne:viz sazebník', 'Electrical parts of machinery or apparatus, n.e.s. in chapter 85'),
('86011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Lokomotivy i malé posuvné elektrické závislé na vnějším zdroji proudu', 'Rail locomotives powered from an external source of electricity'),
('86012000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Lokomotivy i malé posuvné elektrické akumulátorové', 'Rail locomotives powered by electric accumulators'),
('86021000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lokomotivy i malé posuvné dieselelektrické', 'Diesel-electric locomotives'),
('86029000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lokomotivy i malé posuvné ostatní,tendry,ne:dieselektrické', 'Rail locomotives (excl. those powered from an external source of electricity or'),
('86031000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozy motorové železniční a jiné kolejové dopravy s vnějším zdrojem proudu', 'Self-propelled railway or tramway coaches, vans and trucks, powered from an exte'),
('86039000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozy motorové železniční a jiné kolej.dopravy nezávis.na vnějším zdroji proudu', 'Self-propelled railway or tramway coaches, vans and trucks (excl. those powered'),
('86040000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla k údržbě tratí železničních a jiných kolejových i s vlastním pohonem', 'Railway or tramway maintenance or service vehicles, whether or not self-propelle'),
('86050000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozy osobní,poštovní,zavazadlové apod.železniční,jiné kolej.dopravy bez pohonu', 'Railway or tramway passenger coaches, luggage vans, post office coaches and othe'),
('86061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vagóny cisternové a podobné bez pohonu', 'Railway or tramway tank wagons and the like (excl. self-propelled)'),
('86063000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vagóny samovýsypné bez pohonu,ne:cisternové', 'Railway or tramway self-discharging goods vans and wagons (excl. tank wagons and'),
('86069110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vagóny nákladní kryté,uzavřené k přepravě materiálu radioaktivního bez pohonu', 'Railway or tramway goods vans and wagons, covered and closed, specially designed'),
('86069180', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vagóny nákladní kryté,uzavřené bez pohonu,ne:přeprava materiálu radioaktivního', 'Railway or tramway goods vans and wagons, covered and closed (excl. those specia'),
('86069200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vagóny nákladní bez pohonu otevřené,nesnímatelné bočnice výšky nad 60 cm', 'Railway or tramway goods vans and wagons, open, with non-removable sides of a he'),
('86069900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vagóny nákladní ostatní bez pohonu,ne:viz sazebník', 'Railway or tramway goods vans and wagons (excl. those specially designed for the'),
('86071100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Podvozky hnací,Bisselovy železniční a jiné kolejové dopravy', 'Driving bogies and bissel-bogies for railway or tramway locomotives or rolling s'),
('86071200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Podvozky ostatní,Bisselovy železniční a jiné kolej.dopravy,ne:hnací', 'Bogies and driving bissel-bogies for railway or tramway locomotives or rolling s'),
('86071901', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nápravy,kola,jejich části lité z litiny,železa,oceli', 'Axles, assembled or not; wheels and parts thereof, of cast iron or cast steel, o'),
('86071911', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nápravy,kola,jejich části z oceli kované v zápustce', 'Axles, assembled or not, wheels and parts thereof, of closed-die forged steel, f'),
('86071918', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nápravy,kola,jejich části ost.,ne:lité z litiny,železa,oceli,kované v zápustce', 'Axles, assembled or not; wheels and parts thereof (excl. 8607.19.01 and 8607.19.'),
('86071991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části podvozků a podobných výrobků lité z litiny,železa,oceli', 'Parts of bogies, bissel-bogies and the like, of railway or tramway locomotives o'),
('86071999', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části podvozků a podobných výrobků ostatní,ne:lité z litiny,železa,oceli', 'Parts of bogies, bissel-bogies and the like, of railway or tramway locomotives o'),
('86072110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brzdy (i části) pneumatické železniční apod.dopravy lité z litiny,železa,oceli', 'Air brakes and parts thereof, of railway or tramway locomotives or rolling stock'),
('86072190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brzdy (i části) pneumat.železniční apod.dopr.ost.,ne:lité z litiny,železa,oceli', 'Air brakes and parts thereof, of railway or tramway locomotives or rolling stock'),
('86072910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brzdy (části) železniční apod.dopravy lité z litiny,železa,oceli,ne:pneumat.', 'Brakes and parts thereof, of cast iron or cast steel (excl. air brakes), of rail'),
('86072990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brzdy (části) žezniční apod.dopravy ost.,ne:pneumatické,litá litina,ocel,železo', 'Brakes and parts thereof (excl. air brakes and of cast iron or cast steel), of r'),
('86073001', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Háky,systémy spřáhlové,nárazníky,jejich části lité z litiny,železa,oceli', 'Hooks and other coupling devices, buffers, and parts thereof, of cast iron or ca'),
('86073099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Háky,systémy spřáhlové,nárazníky,jejich části ost.,ne:litá litina,ocel,železo', 'Hooks and other coupling devices, buffers and parts thereof, for railway or tram'),
('86079110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skříně ložisek pro nápravy lokomotiv,jejich části', 'Axle-boxes and parts thereof, for locomotives, n.e.s.'),
('86079191', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části lokomotiv,lokotraktorů lité z litiny,železa,oceli,ne:skříně ložisek náprav', 'Parts of railway or tramway locomotives, of cast iron or cast steel, n.e.s.'),
('86079199', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části lokomotiv,lokotraktorů ost.,ne:litá litina,železo,ocel,skříně ložis.náprav', 'Parts of railway or tramway locomotives, n.e.s.'),
('86079910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skříně ložisek pro nápravy,jejich části,ne:pro lokomotivy', 'Axle-boxes and parts thereof, of railway or tramway locomotives or rolling stock'),
('86079930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Karosérie vozidel železničních a jejich části', 'Bodies and parts thereof, for rolling stock of heading 8603, 8604, 8605 or 8606,'),
('86079950', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Podvozky vozidel železničních a jejich části', 'Chassis and parts thereof, of railway or tramway locomotives or rolling stock of'),
('86079990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti ostatních vozidel železničních apod.kolej.dopravy ost.,ne:sazebník', 'Parts of rolling stock of heading 8603, 8604, 8605 or 8606, n.e.s.'),
('86080010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kolejový svrškový upevňovací materiál pro dopravu železniční,tramvajovou', 'Track fixtures and fittings and mechanical signalling, safety or traffic control'),
('86080030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje mechanické návěstní,bezpečnostní,kontrolní apod.pro dopravu,parkoviště', 'Mechanical, incl. electromechanical, traffic signalling, safety or control equip'),
('86080090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části a souč.kolej.svršků,mechanických.přístr.pro železnice,letiště,přístavy,parkoviště', 'Parts of railway or tramway track fixtures and fittings, mechanical, incl. elect'),
('86090010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kontejnery s antiradiačním olověným krytem k přepravě materiálů radioaktivních', 'Containers with an anti-radiation lead covering, for the transport of radioactiv'),
('86090090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kontejnery zvláště upravené pro 1 a více druhů přeprav,ne:mater.radioaktivních', 'Containers specially designed and equipped for carriage by one or more modes of'),
('87011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Jednonápravové kultivační malotraktory,zahradnické traktory', 'Pedestrian-controlled agricultural tractors and similar tractors for industry (e'),
('87012010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Silniční návěsové tahače nové', 'Road tractors for semi-trailers, new'),
('87012090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Silniční návěsové tahače použité', 'Road tractors for semi-trailers, used'),
('87013000', 2009, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Traktory a tahače pásové', 'Track-laying tractors (excl. pedestrian-controlled)'),
('87019011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Traktory zemědělské,lesnické kolové nové,výkon do 18,ne:kultivační,zahradnické', 'Agricultural tractors and forestry tractors, wheeled, new, of an engine power <='),
('87019020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Traktory a tahače ostatní,nové,výkon nad 18-37kW', 'Agricultural tractors and forestry tractors, wheeled, new, of an engine power >'),
('87019025', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zemědělské,lesnické traktory kolové nové,výkon nad 37-59kW', 'Agricultural tractors and forestry tractors, wheeled, new, of an engine power >'),
('87019031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Traktory zemědělské,lesnické kolové nové,výkon nad 90 kW', 'Agricultural tractors and forestry tractors, wheeled, new, of an engine power >'),
('87019035', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zemědělské,lesnické traktory kolové nové,výkon nad 75-90kW', 'Agricultural tractors and forestry tractors, wheeled, new, of an engine power >'),
('87019039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Traktory zemědělské,lesnické kolové nové,výkon nad 90 kW', 'Agricultural tractors and forestry tractors, wheeled, new, of an engine power >'),
('87019050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Traktory zemědělské,lesnické kolové použité,ne:kultivační,zahradnické', 'Agricultural tractors and forestry tractors, wheeled, used (excl. tractor units'),
('87019090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Traktory kolové ost.,ne:jednonápravové kultivační,zahradnické,zemědělské,lesnické', 'Tractors, incl. tractor units for articulated lorries (excl. tractors of heading'),
('87021011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla motorová pro 10 a více osob nová,motor vznětový,obsah nad 2 500 cm3', 'Motor vehicles for the transport of >= 10 persons, incl. driver, with compressio'),
('87021019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla motorová pro 10 a více osob použitá,motor vznětový,obsah nad 2 500 cm3', 'Motor vehicles for the transport of >= 10 persons, incl. driver, with compressio'),
('87021091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla motorová pro 10 a více osob nová,motor vznětový,obsah do 2 500 cm3', 'Motor vehicles for the transport of >= 10 persons, incl. driver, with compressio'),
('87021099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla motorová pro 10 a více osob použitá,motor vznětový,obsah do 2 500 cm3', 'Motor vehicles for the transport of >= 10 persons, incl. driver, with compressio'),
('87029011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla motorová pro 10 a více osob nová,motor zážehový,obsah nad 2800cm3', 'Motor vehicles for the transport of >= 10 persons, incl. driver, with spark-igni'),
('87029019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla motorová pro 10 a více osob použitá,motor zážehový,obsah nad 2 800 cm3', 'Motor vehicles for the transport of >= 10 persons, incl. driver, with spark-igni'),
('87029031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla motorová pro 10 a více osob nová,motor zážehový,obsah do 2 800 cm3', 'Motor vehicles for the transport of >= 10 persons, incl. driver, with spark-igni'),
('87029039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla motorová pro 10 a více osob použitá,motor zážehový,obsah do 2 800 cm3', 'Motor vehicles for the transport of >= 10 persons, incl. driver, with spark-igni'),
('87029090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla motorová pro 10 a více osob ost.,ne:motor vznětový či zážehový', 'Motor vehicles for the transport of >= 10 persons, incl. driver, not with intern'),
('87031011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla motorová zvlášť konstruovaná pro jízdu na sněhu,motor vznětový,zážehový', 'Vehicles specially designed for travelling on snow, with internal combustion pis'),
('87031018', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla speciální pro přepravu osob ostatní;ne:viz sazebník', 'Vehicles for the transport of persons on snow, not with internal combustion pist'),
('87032110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla osob.nova,motor vrat.zazeh.do 1000cm3', 'Motor cars and other motor vehicles principally designed for the transport of pe'),
('87032190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla osob.pouz,motor vrat.zazeh.do 1000cm3', 'Motor cars and other motor vehicles principally designed for the transport of pe'),
('87032210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Ost.vozidla se zážeh.motorem,obs.válců 1000-1500cm3', 'Motor cars and other motor vehicles principally designed for the transport of pe'),
('87032290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla osob.pouz,motor vrat.zaz.1000-1500cm3', 'Motor cars and other motor vehicles principally designed for the transport of pe'),
('87032311', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Karavany motorové nové, motor vratný pístový zážehový,nad 1500-3000 cm3', 'Motors caravans with spark-ignition internal combustion reciprocating piston eng'),
('87032319', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla osob.nova,motor vrat.zaz.1500-3000cm3', 'Motor cars and other motor vehicles principally designed for the transport of pe'),
('87032390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla osob.pouz,motor vrat.zaz.1500-3000cm3', 'Motor cars and other motor vehicles principally designed for the transport of pe'),
('87032410', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla osob.nova,motor vrat.zaz.nad 3000cm3,', 'Motor cars and other motor vehicles principally designed for the transport of pe'),
('87032490', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla osob.pouz,motor vrat.zaz.nad 3000cm3', 'Motor cars and other motor vehicles principally designed for the transport of pe'),
('87033110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla osob.nova,motor pist.vznet.do 1500cm3', 'Motor cars and other motor vehicles principally designed for the transport of pe'),
('87033190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla osob.pouz,motor pist.vznet.do 1500cm3', 'Motor cars and other motor vehicles principally designed for the transport of pe'),
('87033211', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Karavany motorové nové,motor pístový vznětový,nad 1500-2500 cm3', 'Motor caravans with compression-ignition internal combustion piston engine "dies'),
('87033219', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla osob.nova,mot.pist.vznet.1500-2500cm3', 'Motor cars and other motor vehicles, principally designed for the transport of p'),
('87033290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla osob.pouz,mot.pist.vznet.1500-2500cm3', 'Motor cars and other motor vehicles principally designed for the transport of pe'),
('87033311', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Karavany motorové nové,motor pístový vznětový nad 2500 cm3', 'Motor caravans with compression-ignition internal combustion piston engine "dies'),
('87033319', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla osob.nova,mot.pist.vznet.nad 2500cm3', 'Motor cars and other motor vehicles, principally designed for the transport of p'),
('87033390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla osob.pouz,mot.pist.vznet.nad 2500cm3', 'Motor cars and other motor vehicles principally designed for the transport of pe'),
('87039010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla osobní ostatní,dodávková,závodní,motor elektrický,ne:viz sazebník', 'Motor cars and other vehicles principally designed for the transport of persons,'),
('87039090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla osobní ostatní, dodávková, závodní, motor neelektrický', 'Motor cars and other motor vehicles principally designed for the transport of pe'),
('87041010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Terénní vyklápěcí vozy (dampry) s píst.vznět.,zážeh.motorem', 'Dumpers for off-highway use, with compression-ignition internal combustion pisto'),
('87041090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozy terénní vyklápěcí ostatní,ne:motor vznětový,zážehový', 'Dumpers for off-highway use with engines other than internal combustion piston e'),
('87042110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla nákladní k dopravě radioaktivních mater.,nosnost do 5t,motor vznětový', 'Motor vehicles for the transport of highly radioactive materials [Euratom], with'),
('87042131', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla nákladní nová,nosnost do 5t,motor vznětový nad 2 500 cm3,ne:vyklápěcí', 'Motor vehicles for the transport of goods, with compression-ignition internal co'),
('87042139', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla nákladní použ.,nosnost do 5t,motor vznětový nad 2 500cm3,ne:vyklápěcí', 'Motor vehicles for the transport of goods, with compression-ignition internal co'),
('87042191', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla nákladní nová,nosnost do 5t,motor vznětový do 2 500cm3,ne:vyklápěcí', 'Motor vehicles for the transport of goods, with compression-ignition internal co'),
('87042199', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla nákladní použitá,nosnost do 5t,motor vznětový do 2 500cm3,ne:vyklápěcí', 'Motor vehicles for the transport of goods, with compression-ignition internal co'),
('87042210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla nákladní k dopravě radioaktiv.mater.,nosnost nad 5-20t,motor vznětový', 'Motor vehicles, with compression-ignition internal combustion piston engine "die'),
('87042291', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motorová vozidla pro nákladní dopravu,nosnost nad 5-20t,nová', 'Motor vehicles for the transport of goods, with compression-ignition internal co'),
('87042299', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motorová vozidla pro nákladní dopravu,nosnost nad 5-20t,použitá', 'Motor vehicles for the transport of goods, with compression-ignition internal co'),
('87042310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla nákladní k dopravě radioaktivních mater.,nad 20t,motor pístový vznětový', 'Motor vehicles with compression-ignition internal combustion piston engine "dies'),
('87042391', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motorová vozidla pro nákladní dopravu,nosnost nad 20t,nová', 'Motor vehicles for the transport of goods, with compression-ignition internal co'),
('87042399', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motorová vozidla pro nákladní dopravu,nosnost nad 20t,použitá', 'Motor vehicles for the transport of goods, with compression-ignition internal co'),
('87043110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla nákladní k dopravě radioaktivních mater.,do 5t,motor pístový zážehový', 'Motor vehicles, with spark-ignition internal combustion piston engine, of a gros'),
('87043131', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla nákladní nová,do 5t,motor pístový zážehový,nad 2 800 cm3', 'Motor vehicles for the transport of goods, with spark-ignition internal combusti'),
('87043139', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla nákladní použ.,do 5t,motor pístový zážehový,nad 2 800 cm3', 'Motor vehicles for the transport of goods, with spark-ignition internal combusti'),
('87043191', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla nákladní nová,do 5t,motor pístový zážehový,do 2 800 cm3', 'Motor vehicles for the transport of goods, with spark-ignition internal combusti'),
('87043199', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla nákladní pož.,do 5t,motor pístový zážehový,do 2 800 cm3', 'Motor vehicles for the transport of goods, with spark-ignition internal combusti'),
('87043210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla nákladní k dopravě radioaktivních mater.,nad 5t,motor pístový zážehový', 'Motor vehicles, with spark-ignition internal combustion piston engine, of a gros'),
('87043291', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla nákladní nová,nad 5t,motor pístový zážehový', 'Motor vehicles for the transport of goods, with spark-ignition internal combusti'),
('87043299', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla nákladní použitá,nad 5t,motor pístový zážehový', 'Motor vehicles for the transport of goods, with spark-ignition internal combusti'),
('87049000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla nákladní motorová ostatní,ne:viz sazebník', 'Motor vehicles for the transport of goods, with engines other than internal comb'),
('87051000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Jeřábové automobily', 'Crane lorries (excl. breakdown lorries)'),
('87052000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Jeřáby vrtné pojízdné', 'Mobile drilling derricks'),
('87053000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Požární automobily', 'Fire fighting vehicles (excl. vehicles for transporting persons)'),
('87054000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Automobily nákladní s míchačkou na beton', 'Concrete-mixer lorries'),
('87059010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozy vyprošťovací', 'Breakdown lorries'),
('87059030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozy s čerpadlem na beton', 'Concrete-pumping vehicles'),
('87059090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozidla motorová pro zvláštní účely ostatní,ne:viz sazebník', 'Special purpose motor vehicles (other than those principally designed for the tr'),
('87060011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Chassis motorových vozidel čísel 8702 nebo 8704', 'Chassis with compression ignition internal combustion engines, of cylinder capac'),
('87060019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Chassis traktorů,motorových vozidel osobních-obsah viz sazebník', 'Chassis with compression ignition internal combustion engines, of cylinder capac'),
('87060091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Chassis motorových vozidel osobních', 'Chassis with compression ignition internal combustion engines, of cylinder capac'),
('87060099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Chassis motorových vozidel ostatní,ne:viz sazebník', 'Chassis with compression ignition internal combustion engines, of cylinder capac'),
('87071010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Karosérie motorových vozidel osobních pro průmyslové účely', 'Bodies for the industrial assembly of motor cars and other motor vehicles princi'),
('87071090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Karosérie motorových vozidel osobních ostatní,ne:pro průmyslové účely', 'Bodies for motor cars and other motor vehicles principally designed for the tran'),
('87079010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Karosérie traktorů,vozidel nákladních pro průmyslovou montáž,typy viz sazebník', 'Bodies for the industrial assembly of pedestrian controlled tractors of subheadi'),
('87079090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Karosérie traktorů,vozidel nákladních apod.ostatní,ne:viz sazebník', 'Bodies for tractors, motor vehicles for the transport of ten or more persons, mo'),
('87081010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nárazníky traktorů,vozidel osobních,nákladních apod.k průmysl.mont.,viz sazebník', 'Bumpers and parts thereof, for the industrial assembly of motor cars and other m'),
('87081090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nárazníky traktorů,vozidel osobních,nákladních apod.ostatní,ne:viz sazebník', 'Bumpers and parts thereof for tractors, motor vehicles for the transport of ten'),
('87082110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pásy bezpečnostní vozidel osobních,nákladních apod.k průmysl.mont.,viz sazebník', 'Safety seat belts for the industrial assembly of : motor cars and other motor ve'),
('87082190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pásy bezpečnostní ostatní,ne:viz sazebník', 'Safety seat belts for motor vehicles (excl. those for the industrial assembly of'),
('87082910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části karosérií traktorů,vozidel osobních,nákladních apod.k průmyslové montáži', 'Parts and accessories for the industrial assembly of bodies of: pedestrian-contr'),
('87082990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části karosérií traktorů,vozidel osobních,nákladních apod.ost.,ne:viz sazebník', 'Parts and accessories for the industrial assembly of bodies of: tractors, motor'),
('87083010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brzdy,servobrzdy,části,součásti k prům.montáži,vozidla viz sazebník', 'Brakes and servo-brakes and their parts, for the industrial assembly of: pedestr'),
('87083091', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brzdy,servobrzdy,části,součásti pro brzdy kotoučové,ne:viz sazebník', 'Parts for disc brakes, for tractors, motor vehicles for the transport of ten or'),
('87083099', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brzdy,servobrzdy,části,součásti ostatní,ne:viz sazebník', 'Brakes and servo-brakes and their parts, for tractors, motor vehicles for the tr'),
('87084020', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Převodovky,převodové skříně,části,součásti k prům.montáži,vozidla viz sazebník', 'Gear boxes and parts thereof, for the industrial assembly of: pedestrian-control'),
('87084050', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Převodovky,převodové skříně ostatní,ne:viz sazebník', 'Gear boxes for tractors, motor vehicles for the transport of ten or more persons'),
('87084091', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti převodovek,převodových skříní,z oceli kované v uzav.zápustce,ne:viz sazebník', 'Parts for gear boxes of closed-die forged steel, for tractors, motor vehicles fo'),
('87084099', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti převodovek,převodových skříní ostatní,ne:viz sazebník', 'Parts for gear boxes for tractors, motor vehicles for the transport of ten or mo'),
('87085020', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nápravy hnací s diferenciálem,běhounové k prům.montáži,vozidla viz sazebník', 'Drive-axles with differential, whether or not provided with other transmission c'),
('87085035', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nápravy hnací s diferenciálem,běhounové ostatní,ne:viz sazebník', 'Drive-axles with differential, whether or not provided with other transmission c'),
('87085055', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti náprav hnacích s diferenciálem,běhounových,z oceli kované v uzav.zápustce,ost', 'Parts for drive-axles with differential, whether or not provided with other tran'),
('87085091', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti pro běhounové nápravy ostatní,ne:viz sazebník', 'Parts for non-driving axles, for tractors, motor vehicles for the transport of t'),
('87085099', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti pro nápravy hnací s diferenciálem ostatní,ne:viz sazebník', 'Parts for drive-axles with differential, whether or not provided with other tran'),
('87087010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kola,části,součásti k průmyslové montáži,typy vozidel viz sazebník', 'Road wheels and parts and accessories thereof, for the industrial assembly of: p'),
('87087050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kola,části,součásti,příslušenství z hliníku,ne:viz sazebník', 'Aluminium road wheels, aluminium parts and accessories thereof, for tractors, mo'),
('87087091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hvězdice kol odlévané z litiny,železa,oceli,ne:viz sazebník', 'Wheel centres in star form, cast in one piece, of iron or steel, for tractors, m'),
('87087099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kola,části,součásti ostatní,ne:viz sazebník', 'Road wheels and parts and accessories thereof, for tractors, motor vehicles for'),
('87088020', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sytémy závěsné,části,součásti (vč.tlumičů pérování) k prům.montáži,vozidla viz sazebník', 'Suspension systems and parts thereof, incl. shock-absorbers, for the industrial'),
('87088035', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tlumiče pérování ostatní,ne:viz sazebník', 'Suspension shock-absorbers for tractors, motor vehicles for the transport of ten'),
('87088055', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče stabilizační příčné,tyče torzní ostatní,ne:viz sazebník', 'Anti roll bars and torsion bars, for tractors, motor vehicles for the transport'),
('87088091', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Systémy závěsné,části,součásti,z oceli kované v uzav.zápustce,ne:viz sazebník', 'Suspension systems and parts thereof, of closed-die forged steel, for tractors,'),
('87088099', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Systémy závěsné,části,součásti ostatní,ne:viz sazebník', 'Suspension systems and parts thereof, for tractors, motor vehicles for the trans'),
('87089120', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chladiče,části,součásti k prům.montáži,vozidla viz sazebník', 'Radiators and parts thereof, for the industrial assembly of: pedestrian-controll'),
('87089135', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chladiče ostatní,ne:viz sazebník', 'Radiators for tractors, motor vehicles for the transport of ten or more persons,'),
('87089191', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti chladičů,z oceli kované v uzav.zápustce,ne:viz sazebník', 'Parts for radiators, of closed-die forged steel, for tractors, motor vehicles fo'),
('87089199', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části součásti chladičů ostatní,ne:viz sazebník', 'Parts for radiators, for tractors, motor vehicles for the transport of ten or mo'),
('87089220', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tlumiče výfuku,potrubí výfukové,části,součásti k prům.montáži,vozidla viz sazebník', 'Silencers "mufflers" and exhaust pipes, and parts thereof, for the industrial as'),
('87089235', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tlumiče výfuku,potrubí výfukové ostatní,ne:viz sazebník', 'Silencers "mufflers" and exhaust pipes, for tractors, motor vehicles for the tra'),
('87089291', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti tlumičů výfuku,potrubí výfuk.,z oceli kované v uzav.zápustce,ne:viz sazebník', 'Parts for silencers "mufflers" and exhaust pipes, of closed-die forged steel, fo'),
('87089299', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti tlumičů výfuku,potrubí výfuk.ostatní,ne:viz sazebník', 'Parts for silencers "mufflers" and exhaust pipes, for tractors, motor vehicles f'),
('87089310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Spojky,části,součásti k průmyslové montáži,typy vozidel viz sazebník', 'Clutches and parts thereof, for the industrial assembly of: pedestrian-controlle'),
('87089390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Spojky,části,součásti ostatní,ne:viz sazebník', 'Clutches and parts thereof, for tractors, motor vehicles for the transport of te'),
('87089420', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Volanty,sloupky,skříně řízení,části,součásti k prům.montáži,vozidla viz sazebník', 'Steering wheels, steering columns and steering boxes, and parts thereof, for the'),
('87089435', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Volanty,sloupky,skříně řízení ostatní,ne:viz sazebník', 'Steering wheels, columns and boxes, for tractors, motor vehicles for the transpo'),
('87089491', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti volantů,sloupků,skříní řízení,z oceli kované v uzav.zápustce,ne:viz sazebník', 'Parts for steering wheels, steering columns and steering boxes, of closed-die fo'),
('87089499', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti volantů,sloupků,skříní řízení ostatní,ne:viz sazebník', 'Parts for steering wheels, steering columns and steering boxes, for tractors, mo'),
('87089510', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Airbagy záchranné s nafuk.syst,části,součásti,k prům.montáži,vozidla viz sazebník', 'Safety airbags with inflator system and parts thereof, for the industrial assemb'),
('87089591', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Airbagy záchranné s nafuk.syst,části,součásti,z oceli kované v uzav.zápustce,ne:viz sazebník', 'Safety airbags with inflator system and parts thereof, of closed-die forged stee'),
('87089599', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Airbagy záchranné s nafuk.syst,části,součásti ostatní,ne:viz sazebník', 'Safety airbags with inflator system and parts thereof, for tractors, motor vehic'),
('87089910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,příslušenství motor.vozidel ostatní,k prům.montáži', 'Parts and accessories for the industrial assembly of: pedestrian-controlled trac'),
('87089993', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,příslušenství motor.vozidel ostatní,z oceli kované v uzav.zápustce,ne:viz sazebník', 'Parts and accessories of closed-die forged steel, for tractors, motor vehicles f'),
('87089997', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,příslušenství motor.vozidel ostatní,ne:k prům.montáži,z oceli kované v uzav.zápustce', 'Parts and accessories for tractors, motor vehicles for the transport of ten or m'),
('87091110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozíky elektrické s vlastním pohonem k dopravě radioaktivních materiálů', 'Electrical vehicles, not fitted with lifting or handling equipment, for the tran'),
('87091190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozíky el.s vlastním pohonem ost.bez zařízení zdvihacího,ne:na radioaktivní mat.', 'Electrical vehicles, not fitted with lifting or handling equipment, of the type'),
('87091910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozíky s vlastním pohonem k dopravě radioaktivních materiálů ost.,ne:elektrické', 'Works trucks, self-propelled, not fitted with lifting or handling equipment, for'),
('87091990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozíky s vl.pohonem bez zař.zdvihacího ost.,ne:elektrické,na radioaktivní mat.', 'Works trucks, self-propelled, not fitted with lifting or handling equipment, of'),
('87099000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti vozidel bez manipulačního zař. pro přepravu na malou vzdálenost', 'Parts of self-propelled works trucks, not fitted with lifting or handling equipm'),
('87100000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tanky a jiná vozidla bojová obrněná motorová i se zbraněmi,části,součásti', 'Tanks and other armoured fighting vehicles, motorised, whether or not fitted wit'),
('87111000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motocykly,motor pístový,obsah do 50 cm3', 'Motorcycles, incl. mopeds, and cycles fitted with an auxiliary motor, with recip'),
('87112010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Skútry,motor pístový,obsah nad 50-250 cm3', 'Scooters of cylinder capacity > 50 cm3 but <= 250 cm3'),
('87112091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motocykly,motor pístový,obsah nad 50-80 cm3,ne:skútry', 'Motorcycles, incl. mopeds, with reciprocating internal combustion piston engine'),
('87112093', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motocykly,motor pístový,obsah nad 80-125 cm3,ne:skútry', 'Motorcycles, incl. mopeds, with reciprocating internal combustion piston engine'),
('87112098', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motocykly,motor pístový,obsah nad 125-250 cm3,ne:skútry', 'Motorcycles, incl. mopeds, with reciprocating internal combustion piston engine'),
('87113010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motocykly,motor pístový,obsah nad 250-380 cm3', 'Motorcycles, incl. mopeds, with reciprocating internal combustion piston engine'),
('87113090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motocykly,motor pístový,obsah nad 380-500 cm3', 'Motorcycles, incl. mopeds, with reciprocating internal combustion piston engine'),
('87114000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motocykly,motor pístový,obsah nad 500-800 cm3', 'Motorcycles, incl. mopeds, with reciprocating internal combustion piston engine'),
('87115000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Motocykly,motor pístový,obsah nad 800 cm3', 'Motorcycles, incl. mopeds, with reciprocating internal combustion piston engine'),
('87119000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kola jízdní s pomocným motorem,vozíky přívěsné', 'Side cars for motorcycles'),
('87120010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kola jízdní a jiná vč.dodávkových tříkolek bez motoru,bez ložisek kuličkových', 'Bicycles without ball bearings'),
('87120030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kola jízdní bez motoru,s kuličkovými ložisky', 'Bicycles, not motorised, with ball bearings'),
('87120080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kola jiná bez motoru s kuličkovými ložisky,ne:kola jízdní', 'Cycles, incl. delivery tricycles, not motorised, with ball bearings (excl. bicyc'),
('87131000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozíky invalidní bez zařízení pro mechanický pohon', 'Carriages for disabled persons, not mechanically propelled'),
('87139000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vozíky invalidní s motorem nebo jiným mechanickým pohonným zařízením', 'Carriages for disabled persons, motorised or otherwise mechanically propelled (e'),
('87141100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Sedla motocyklů včetně mopedů', 'Saddles for motorcycles, incl. mopeds'),
('87141900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti,příslušenství motocyklů včetně mopedů ostatní,ne:sedla', 'Parts and accessories for motorcycles, incl. mopeds, n.e.s.'),
('87142000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části křesel pojízdných apod.vozíků invalidních', 'Parts and accessories for carriages for disabled persons, n.e.s.'),
('87149110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Rámy jízdních kol', 'Frames for bicycles, not motorised'),
('87149130', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vidlice přední jízdních kol', 'Front forks for bicycles'),
('87149190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti rámů,vidlic jízdních kol', 'Parts of front forks, for bicycles'),
('87149210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Ráfky jízdních kol', 'Rims for bicycles'),
('87149290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Paprsky kol jízdních kol', 'Spokes for bicycles'),
('87149310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Hlavy jízdních kol bez řetězových kol volnoběžek nebo středových brzd', 'Hubs without free-wheel or braking device, for bicycles'),
('87149390', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kola volnoběžek řetězová jízdních kol', 'Free-wheel sprocket-wheels, for bicycles'),
('87149410', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Brzdy středové jízdních kol', 'Coaster braking hubs and hub brakes, for bicycles'),
('87149430', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brzdy jízdních kol ostatní,ne:středové', 'Brakes (other than coaster braking hubs) and hub brakes, for bicycles'),
('87149490', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti brzd jízdních kol', 'Parts of brakes, incl. coaster braking hubs and hub-brakes, for bicycles, n.e.s.'),
('87149500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sedla jízdních kol', 'Saddles for bicycles'),
('87149610', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Pedály jízdních kol', 'Pedals for bicycles'),
('87149630', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ústrojí pedálová jízdních kol', 'Crank-gear for bicycles'),
('87149690', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti pedálů,ústrojí pedálových jízdních kol', 'Parts of pedals and crank-gear for bicycles, n.e.s.'),
('87149910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Řídítka jízdních kol', 'Handlebars for bicycles'),
('87149930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Nosiče zavazadel jízdních kol', 'Luggage carriers for bicycles'),
('87149950', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Převody vyrovnávací jízdních kol', 'Derailleur gears for bicycles'),
('87149990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti ostatní jízdních kol,ne:viz sazebník', 'Parts and accessories for bicycles, and parts thereof, n.e.s.'),
('87150010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kočárky dětské,sportovní a podobná vozidla dětská', 'Baby carriages'),
('87150090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti kočárků dětských,sportovních apod.', 'Parts of baby carriages, n.e.s.'),
('87161010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přívěsy stanové', 'Trailers and semi-trailers of the caravan type, for housing or camping, folding'),
('87161091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přívěsy,návěsy obytné karavanního typu,hmotnost do 750 kg,ne:stanové', 'Trailers and semi-trailers of the caravan type, for housing or camping, not fold'),
('87161094', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přívěsy,návěsy obytné karavanního typu,hmotnost nad 750-1600 kg,ne:stanové', 'Trailers and semi-trailers of the caravan type, for housing or camping, of a wei'),
('87161096', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přívěsy,návěsy obytné karavanního typu,hmotnost nad 1600-3500 kg,ne:stanové', 'Trailers and semi-trailers of the caravan type, for housing or camping, of a wei'),
('87161099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přívěsy,návěsy obytné karavanního typu,hmotnost nad 3 500 kg,ne:stanové', 'Trailers and semi-trailers of the caravan type, for housing or camping, not fold'),
('87162000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Samonakládací nebo samovýklopné přívěsy,návěsy pro zemědˇ.účely', 'Self-loading or self-unloading trailers and semi-trailers for agricultural purpo'),
('87163100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přívěsy,návěsy nádržkové pro přepravu zboží', 'Tanker trailers and tanker semi-trailers, not designed for running on rails'),
('87163910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přívěsy,návěsy k dopravě radioaktivních materiálů', 'Trailers and semi-trailers, not designed for running on rails, for the transport'),
('87163930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Návěsy nové k přepravě zboží', 'Semi-trailers for the transport of goods, new (excl. self-loading or self-unload'),
('87163951', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přívěsy nové jednonápravové k přepravě zboží', 'Trailers for the transport of goods, with a single axle, new (excl. self-loading'),
('87163959', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přívěsy nové ostatní k přepravě zboží,ne:jednonápravové', 'Trailers for the transport of goods, with multiple-axle, new (excl. self-loading'),
('87163980', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přívěsy,návěsy použité,k přepravě zboží', 'Trailers and semi-trailers for the transport of goods, used (excl. self-loading'),
('87164000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přívěsy,návěsy ostatní,ne:viz sazebník', 'Trailers and semi-trailers, not designed for running on rails (excl. trailers an'),
('87168000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vozidla ostatní bez mechanického pohonu,ne:viz sazebník', 'Vehicles pushed or drawn by hand and other vehicles not mechanically propelled ('),
('87169010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chassis přívěsů,návěsů,vozidel bez mechanického pohonu', 'Chassis of trailers, semi-trailers and other vehicles not mechanically propelled'),
('87169030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Karoserie přívěsů,návěsů,vozidel bez mechanického pohonu', 'Bodies of trailers, semi-trailers and other vehicles not mechanically propelled,'),
('87169050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nápravy přívěsů,návěsů,vozidel bez mechanického pohonu', 'Axles of trailers, semi-trailers and other vehicles not mechanically propelled,'),
('87169090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti ostatní přívěsů,návěsů,vozidel bez mechanického pohonu,ne:viz sazebník', 'Parts of trailers, semi-trailers and other vehicles not mechanically propelled,'),
('88010010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Balony,vzducholodě;kluzáky,rogala', 'Gliders, without motor and not capable of being fitted with a motor, and hang gl'),
('88010090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Prostředky pro létání (letouny) bezmotorové ostatní,ne:balony,vzducholodě,kluzáky,rogala', 'Kites and other non-powered aircraft (excl. gliders, hang gliders, balloons and'),
('88021100', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vrtulníky,vlastní hmotnost do 2.000 kg', 'Helicopters of an unladen weight <= 2.000 kg'),
('88021200', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vrtulníky,vlastní hmotnost nad 2.000 kg', 'Helicopters of an unladen weight > 2.000 kg'),
('88022000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Letouny a jiná letadla,vlastní hmotnost do 2.000 kg', 'Aeroplanes and other powered aircraft of an unladen weight <= 2.000 kg (excl. he'),
('88023000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Letouny a jiná letadla,vlastní hmotnost nad 2.000 - 15.000 kg', 'Aeroplanes and other powered aircraft of an unladen weight > 2.000 kg but <= 15.'),
('88024000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Letouny a jiná letadla,vlastní hmotnost nad 15.000 kg', 'Aeroplanes and other powered aircraft of an of an unladen weight > 15.000 kg (ex'),
('88026010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kosmické lodě (včetně družic)', 'Spacecraft, incl. satellites'),
('88026090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Balistické a kosmické nosné rakety', 'Suborbital and spacecraft launch vehicles'),
('88031000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vrtule,rotory,jejich části,součásti', 'Propellers and rotors and parts thereof, for aircraft, n.e.s.'),
('88032000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Podvozky,jejich části,součásti', 'Under-carriages and parts thereof, for aircraft, n.e.s.'),
('88033000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části letounů,vrtulníků ostatní,ne:vrtule,rotory,podvozky', 'Parts of aeroplanes or helicopters, n.e.s. (excl. those for gliders)'),
('88039010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti draků', 'Parts of kites'),
('88039020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části kosmických lodí (včetně družic)', 'Parts of spacecraft, incl. satellites, n.e.s.'),
('88039030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části balistických a kosmických nosných raket', 'Parts of suborbital and spacecraft launch vehicles, n.e.s.'),
('88039090', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části letadel,balonů,vzducholodí,kosmic.lodí,raket apod.ostatní,ne:viz sazebník', 'Parts of aircraft, n.e.s. (excl. of spacecraft, incl. satellites, and suborbital'),
('88040000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Padáky (včetně řiditelných,paraglidingů) i rotující,části,příslušenství', 'Parachutes, incl. dirigible parachutes and paragliders, and rotochutes; parts th'),
('88051010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Katapulty letecké apod.zařízení,části,součásti', 'Aircraft launching gear and parts thereof, n.e.s. (excl. motor winches for launc'),
('88051090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zařízení k přistání aerodynů na letadlové lodi apod.,části,součásti', 'Deck-arrestor or similar gear for aircraft and parts thereof, n.e.s.'),
('88052100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Letecké bojové simulátory,jejich části a součásti', 'Air combat simulators and parts thereof'),
('88052900', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje pozemní pro letecký výcvik a jejich části a součásti,ne:bojové simulátory', 'Ground flying trainers and parts thereof, n.e.s. (excl. air combat simulators an'),
('89011010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GTO'), 'Lodě osobní,poštovní,turistické,trajekty apod.námořní', 'Sea-going cruise ships, excursion boats and similar vessels principally designed'),
('89011090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Lodě osobní,poštovní,turistické,trajekty apod.ostatní,ne:námořní', 'Cruise ships, excursion boats and similar vessels principally designed for the t'),
('89012010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GTO'), 'Lodě cisternové námořní', 'Sea-going tankers'),
('89012090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'CCT'), 'Lodě cisternové ostatní,ne:námořní', 'Tankers (excl. seagoing tankers)'),
('89013010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GTO'), 'Lodě chladírenské námořní,ne:cisternové', 'Sea-going refrigerated vessels (excl. tankers)'),
('89013090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'CCT'), 'Lodě chladírenské ostatní,ne:námořní,cisternové', 'Refrigerated vessels (excl. seagoing vessels and tankers)'),
('89019010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GTO'), 'Plavidla pro nákladní dopravu,ostatní pro osobní přepravu námořní,ne:sazebník', 'Sea-going vessels for the transport of goods and seagoing vessels for the transp'),
('89019091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'CCT'), 'Plavidla nákladní,osobní dopravy bez mechanického pohonu ost.,ne:viz sazebník', 'Vessels for the transport of goods and vessels for the transport of both persons'),
('89019099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'CCT'), 'Plavidla nákladní,osobní dopravy s mechanickým pohonem ost.,ne:viz sazebník', 'Vessels for the transport of goods and vessels for the transport of both persons'),
('89020012', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'GTO'), 'Plavidla rybářská,k průmyslovému zpracování ryb námořní,výtlak nad 250t (BRT)', 'Sea-going fishing vessels, factory ships and other vessels for processing or pre'),
('89020018', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Plavidla rybářská,k průmyslovému zpracování ryb námořní,výtlak do 250t (BRT)', 'Sea-going fishing vessels, factory ships and other vessels for processing or pre'),
('89020090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Plavidla rybářská,k průmyslovému zpracování ryb ostatní,ne:námořní', 'Fishing vessels; factory ships and other vessels for processing or preserving fi'),
('89031010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Člun nafukovací,hmotnost do 100kg', 'Inflatable vessels for pleasure or sports, of a weight <= 100 kg each'),
('89031090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Člun nafukovací,hmotnost nad 100 kg', 'Inflatable vessels, for pleasure or sports, of a weight > 100 kg each'),
('89039110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Plachetnice i s pomocným motorem pro námořní plavbu', 'Sea-going sailboats and yachts, with or without auxiliary motor, for pleasure or'),
('89039192', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Plachetnice jiné než námořní, též s pomocným motorem, délka do 7,5m', 'Sailboats, with or without auxiliary motor, of a length <= 7,5 m'),
('89039199', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Plachetnice i s pomocným motorem,hmotnost nad 100 kg,délka nad 7,5m,ne:námořní', 'Sailboats and yachts, with or without auxiliary motor, for pleasure or sports, o'),
('89039210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čluny motorové pro námořní plavbu,ne:s přívěsným motorem', 'Sea-going motor boats and motor yachts, for pleasure or sports (other than outbo'),
('89039291', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čluny motorové ostatní,délka do 7,5m,ne:s přívěsným motorem,námořní', 'Motor boats for pleasure or sports, of a length <= 7,5 m (other than outboard mo'),
('89039299', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čluny motorové ostatní,délka nad 7,5m,ne:s přívěsným motorem,námořní', 'Motor boats for pleasure or sports, of a length > 7,5 m (other than outboard mot'),
('89039910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Jachty,plavidla pro zábavu,sport ostatní,hmotnost <=100kg,ne:viz sazebník', 'Vessels for pleasure or sports, rowing boats and canoes, of a weight <= 100 kg e'),
('89039991', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Jachty,plavidla pro zábavu,sport ostatní,hmotnost >100kg,délka <=7,5m,ne:viz sazebník', 'Vessels for pleasure or sports, rowing boats and canoes, of a weight > 100 kg, o'),
('89039999', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Jachty,plavidla pro zábavu,sport ostatní,hmotnost >100kg,délka >7,5m,ne:viz sazebník', 'Vessels for pleasure or sports , rowing boats and canoes, of a weight > 100 kg,'),
('89040010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lodě k vlečení jiných lodí', 'Tugs, seagoing and for inland waterways'),
('89040091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lodě k tlačení jiných lodí pro námořní plavbu', 'Sea-going pusher craft'),
('89040099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lodě k tlačení jiných lodí ostatní,ne:pro námořní plavbu', 'Pusher craft (excl. seagoing)'),
('89051010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Bagry plovoucí sací pro námořní plavbu', 'Sea-going dredgers'),
('89051090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Bagry plovoucí sací ostatní,ne:pro námořní plavbu', 'Dredgers (excl. seagoing)'),
('89052000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Plošiny ponorné nebo plovoucí vrtné nebo těžební', 'Floating or submersible drilling or production platforms'),
('89059010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Plavidla ostatní kde plavba je vedlejší činnost námořní,ne:viz sazebník', 'Sea-going light vessels, fire-floats, floating cranes and other vessels, the nav'),
('89059090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Plavidla ostatní kde plavba je vedlejší činnost,ne:viz sazebník', 'Light vessels, fire-floats, floating cranes and other vessels, the navigability'),
('89061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lodě válečné', 'Warships of all kinds'),
('89069010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Lodě ostatní včetně člunů záchranných k námořní plavbě,ne:viz sazebník', 'Sea-going vessels, incl. lifeboats (excl. warships, rowing boats and other vesse'),
('89069091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Lodě,čluny ostatní včetně záchranných,hmotnost do 100 kg,ne:viz sazebník', 'Vessels, incl. lifeboats, of a weight <= 100 kg each (excl. rowing boats and oth'),
('89069099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Lodě,čluny ostatní včetně záchranných,hmotnost nad 100 kg,ne:viz sazebník', 'Vessels, incl. lifeboats, of a weight > 100 kg each (excl. seagoing vessels, war'),
('89071000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Prámy nafukovací', 'Inflatable rafts'),
('89079000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nádrže,kesony,přístavní můstky,bóje,výstražné světelné plováky', 'Rafts, tanks, coffer-dams, landing stages, buoys, beacons and other floating str'),
('89080000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lodě,čluny a jiná plavidla určená do šrotu', 'Vessels and other floating structures for breaking up'),
('90011010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kabely z optických vláken pro přenos obrazu', 'Image conductor cables of optical fibres (excl. cables made up of individually s'),
('90011090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlákna optická,svazky,kabely ost.z vláken optických,ne:kabely pro přenos obrazu', 'Optical fibres, optical fibre bundles and cables (excl. made up of individually'),
('90012000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Materiál polarizační v listech,deskách', 'Sheets and plates of polarising material'),
('90013000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čočky kontaktní', 'Contact lenses'),
('90014020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čočky brýlové ze skla,ne:ke korekci zraku', 'Spectacle lenses of glass, not for the correction of vision'),
('90014041', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čočky brýlové ze skla ke korekci zraku,oboustranně opracované jednoohniskové', 'Spectacle lenses of glass, both sides finished, for the correction of vision, si'),
('90014049', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čočky brýlové ze skla,ke korekci zraku,oboustranně opracované,ne:jednoohniskové', 'Spectacle lenses of glass, both sides finished, for the correction of vision, bi'),
('90014080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čočky brýlové ze skla,ke korekci zraku neopracované oboustranně', 'Spectacle lenses of glass (excl. both sides finished)'),
('90015020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čočky brýlové ostatní,ne:skleněné,ke korekci zraku', 'Spectacle lenses of materials other than glass, not for the correction of vision'),
('90015041', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čočky brýlové ke korekci zraku,oboustranně opracované,jednoohniskové,ne:sklo', 'Spectacle lenses of materials other than glass, both sides finished, for the cor'),
('90015049', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čočky brýlové ke korekci zraku,oboustranně opracované,ne:sklo,jednoohniskové', 'Spectacle lenses of materials other than glass, both sides finished, for the cor'),
('90015080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Čočky brýlové ke korekci zraku neopracované oboustranně,ne:skleněné', 'Spectacle lenses of materials (excl. glass), partly finished'),
('90019000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hranoly,zrcadla a jiné optické články nezasazené', 'Lenses, prisms, mirrors and other optical elements, of any material, unmounted ('),
('90021100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Objektivy pro přístroje fotografické,promítací,kinematografické apod.', 'Objective lenses for cameras, projectors or photographic enlargers or reducers'),
('90021900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Objektivy ostatní,ne:pro přístroje fotografické,kinematografické,promítací apod.', 'Objective lenses (excl. for cameras, projectors or photographic enlargers or red'),
('90022000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Filtry pro optické přístroje zasazené', 'Filters, optical, being parts of or fittings for instruments, apparatus and appl'),
('90029000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hranoly,zrcadla a jiné optické články zasazené,ne:objektivy,filtry', 'Lenses, prisms, mirrors and other optical elements, mounted, of any material, be'),
('90031100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Obruby,obroučky na brýle a podobné výrobky z plastů', 'Frames and mountings for spectacles, goggles or the like, of plastics'),
('90031910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Obruby,obroučky na brýle apod.výrobky z drahých kovů,plátované drahými kovy', 'Frames and mountings for spectacles, goggles or the like, of precious metal or r'),
('90031930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Obruby,obroučky na brýle a pod.výrobky z obecných kovů', 'Frames and mountings for spectacles, goggles or the like, of base metal'),
('90031990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Obruby,obroučky na brýle a pod.výrobky z ost.materiálů,ne:viz sazebník', 'Frames and mountings for spectacles, goggles or the like (excl. of metal or plas'),
('90039000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti obrub,obrouček na brýle apod.výrobky', 'Parts of frames and mountings for spectacles, goggles or the like, n.e.s.'),
('90041010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Brýle sluneční se skly opticky opracovanými', 'Sunglasses with optically worked lenses'),
('90041091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Brýle sluneční s čočkami z plastů ostatní,ne:se skly opticky opracovanými', 'Sunglasses with lenses of plastics, not optically worked'),
('90041099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Brýle sluneční s čočkami z ost.materiálů,ne:z plastu,opticky opracované', 'Sunglasses with lenses of glass, not optically worked'),
('90049010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brýle korekční,ochranné apod.s čočkami z plastů,ne:sluneční', 'Spectacles, goggles and the like, corrective, protective or other, with lenses o'),
('90049090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Brýle korekční,ochranné apod.s čočkami z ost.materiálů,ne:z plastů,sluneční', 'Spectacles, goggles and the like, corrective, protective or other (other than wi'),
('90051000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Dalekohledy binokulární', 'Binoculars'),
('90058000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dalekohledy,teleskopy optické ost.,přístroje astronomické,ne:binokulární dalekohledy', 'Monoculars, astronomical and other optical telescopes and other astronomical ins'),
('90059000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části dalekohledů,teleskopů,přístrojů astronomických vč.podstavců,rámů', 'Parts and accessories, incl. mountings, for binoculars, monoculars, astronomical'),
('90061000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Fotopřístroje k zhotovení štočků,válců tiskařských', 'Cameras of a kind used for preparing printing plates or cylinders'),
('90063000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Fotopřístroje speciální (lékařské,podmořské,letecké a podobně)', 'Cameras specially designed for underwater use, for aerial survey or for medical'),
('90064000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Fotopřístroje k okamžitému vyvolání,kopírování', 'Instant print cameras (excl. special cameras of subheading 9006.10 or 9006.30)'),
('90065100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Fotopřístroje (zrcadlovky jednooké) pro svitkové filmy o šířce pod 35 mm', 'Cameras with a through-the-lens viewfinder [single lens reflex "SLR"] for roll f'),
('90065200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Fotopřístroje ostatní pro svitkové filmy o šířce pod 35mm,ne:jednooké zrcadlové', 'Cameras for roll film of a width of < 35 mm (excl. instant print cameras, single'),
('90065310', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Fotopřístroje pro jednorázové použití,svitkový film šíře 35 mm', 'Disposable cameras for roll film of a width of 35 mm'),
('90065380', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Fotopřístroje ostatní,svitkový film šíře 35 mm,ne:jednorázové použití', 'Cameras for roll film of a width of 35 mm (excl. instant print cameras, single l'),
('90065900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Fotopřístroje ostatní,ne:viz sazebník', 'Cameras for roll film of a width of > 35 mm or for film in the flat (excl. insta'),
('90066100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje k fotografickým účelům s výbojkou pro bleskové světlo', 'Electronic discharge lamp flashlight apparatus for photographic purposes'),
('90066900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje ostatní pro účely fotografické,ne:viz sazebník', 'Photographic flashlights and flashlight apparatus (excl. with electronic dischar'),
('90069100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti,příslušenství fotograf.přístrojů', 'Parts and accessories for photographic cameras, n.e.s.'),
('90069900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti,příslušenství přístr.pro fotograf.účely ost.,ne:viz sazebník', 'Parts and accessories for photographic flashlights and flashlight apparatus, n.e'),
('90071100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kamery kinematografické,šíře filmu pod 16 mm nebo filmy dvakrát 8 mm', 'Cinematographic cameras for film of < 16 mm width or for double-8 mm film'),
('90071900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kamery kinematografické ost.,ne:šíře filmu pod 16mm nebo filmy dvakrát 8mm', 'Cinematographic cameras for film of >= 16 mm width (excl. for double-8 mm film)'),
('90072000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje promítací', 'Cinematographic projectors'),
('90079100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti kamer kinematografických', 'Parts and accessories for cinematographic cameras, n.e.s.'),
('90079200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,příslušenství přístrojů promítacích', 'Parts and accessories for cinematographic projectors, n.e.s.'),
('90081000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Promítací přístroje pro diapozitivy', 'Slide projectors'),
('90082000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje čtecí pro mikrofilmy,mikrofiše,mikroformáty,i se zhotovením kopií', 'Microfilm, microfiche or other microform readers, whether or not capable of prod'),
('90083000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje promítací ostatní pro snímky statické,ne:pro diapozitivy,čtecí mikro', 'Image projectors (excl. slide projectors and microfilm, microfiche or other micr'),
('90084000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Fotopřístroje zvětšovací,zmenšovací,ne:kinematografické', 'Photographic enlargers and reducers'),
('90089000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části přístrojů promítacích statické snímky,zvětšovacích,čtecích apod.přístroj', 'Parts and accessories for image projectors, photographic enlargers and reducers,'),
('90101000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje,vybavení k automatickému vyvolávání filmů,papíru', 'Apparatus and equipment for automatically developing photographic or cinematogra'),
('90105000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje,vybavení pro fotografické laboratoře ostatní,negatoskopy', 'Apparatus and equipment for photographic or cinematographic laboratories, n.e.s.'),
('90106000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Plátna promítací', 'Projection screens'),
('90109000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části přístrojů,vybavení pro fotografické laboratoře,negatoskopy,promítací plátna', 'Parts and accessories for apparatus and equipment for photographic or cinematogr'),
('90111010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stereoskopické mikroskopy vybavené zař.konstr.pro manipul.,přepr.polovod.destiček', 'Stereoscopic optical microscopes fitted with equipment specifically designed for'),
('90111090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stereoskopické mikroskopy ostatní,ne:viz sazebník', 'Stereoscopic optical microscopes (excl. fitted with equipment specifically desig'),
('90112010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Mikroskopy ost.vybavené zař.konstr.pro manipul.,přepr.polovod.destiček,ne:viz sazebník', 'Photomicrographic optical microscopes fitted with equipment specifically designe'),
('90112090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Mikroskopy ostatní,ne:viz sazebník', 'Optical microscopes for photomicrography, cinephotomicrography or microprojectio'),
('90118000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Mikroskopy optické ostatní,ne:viz sazebník', 'Optical microscopes (excl. for photomicrography, cinephotomicrography or micropr'),
('90119010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti přístrojů podpoložek 9011 10 10 nebo 9011 20 10', 'Parts and accessories of stereoscopic optical microscopes and photomicrographic'),
('90119090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti přístrojů ostatní,ne:viz sazebník', 'Parts and accessories for compound optical microscopes, n.e.s. (excl. of stereos'),
('90121010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mikroskopy elektronové vybavené zař.konstr.pro manipul.,přepr.polovod.destiček', 'Electron microscopes fitted with equipment specifically designed for the handlin'),
('90121090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mikroskopy jiné než optické ostatní,difraktory,ne:viz sazebník', 'Electron microscopes, proton microscopes and diffraction apparatus (excl. electr'),
('90129010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti přístrojů podpoložky 9012 10 10', 'Parts and accessories of electron microscopes fitted with equipment specifically'),
('90129090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti mikroskopů jiných než optických,difraktorů ost.,ne:viz sazebník', 'Parts and accessories for electron microscopes, proton microscopes and diffracti'),
('90131000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Periskopy, dalekohledy ke zbraním, strojům a podobně', 'Telescopic sights for fitting to arms; periscopes; telescopes designed to form p'),
('90132000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lasery, ne diody laserové', 'Lasers (excl. laser diodes)'),
('90138020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky s kapalnými aktivními krystaly ostatní,ne:viz sazebník', 'Matrix liquid crystal devices, active'),
('90138030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní optické přístroje bez aktivních kapalných krystalů', 'Liquid crystal devices, n.e.s.'),
('90138090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje, nástroje optické ostatní; ne s tekutými krystaly', 'Magnifying glasses, thread counters, stereoscopes, kaleidoscopes and other optic'),
('90139010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti pro zařízení na bázi kapalných krystalů (LCD)', 'Parts and accessories for liquid crystal displays "LCD"'),
('90139090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti přístrojů čísla 9013 ostatní,ne:viz sazebník', 'Parts and accessories for lasers and other instruments, apparatus and appliances'),
('90141000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Busoly včetně navigačních kompasů', 'Direction finding compasses'),
('90142020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Inerciální navigační systémy', 'Inertial navigation systems for aeronautical or space navigation (excl. compasse'),
('90142080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje,přístroje pro letec.a kosmic.navigaci ost.,ne:inerciální navigační systémy', 'Instruments and appliances for aeronautical or space navigation (excl. inertial'),
('90148000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje,nástroje navigační ostatní,ne:busoly,pro leteckou,kosmickou navigaci', 'Navigational instruments and apparatus (excl. for aeronautical or space navigati'),
('90149000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části busol,přístrojů navigačních', 'Parts and accessories for compasses and other navigational instruments and appli'),
('90151010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dálkoměry elektronické', 'Electronic rangefinders'),
('90151090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dálkoměry ostatní,ne:elektronické', 'Non-electronic rangefinders'),
('90152010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Teodolity,tacheometry elektronické', 'Electronic theodolites and tachymeters "tacheometers"'),
('90152090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Teodolity,tacheometry ostatní,ne:elektronické', 'Non-electronic theodolites and tachymeters "tacheometers"'),
('90153010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Libely elektronické', 'Electronic levels'),
('90153090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Libely ostatní,ne:elektronické', 'Non-electronic levels'),
('90154010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje,přístroje fotogrammetrické elektronické', 'Electronic photogrammetrical surveying instruments and appliances'),
('90154090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje,přístroje fotogrammetrické ostatní,ne:elektronické', 'Non-electronic photogrammetrical surveying instruments and appliances'),
('90158011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje meteorologické,hydrologické,geofyzikální elektronické', 'Electronic meteorological, hydrological and geophysical instruments and apparatu'),
('90158019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje geodetické,topografické,nivelační apod.elektronické ost.,ne:viz sazebník', 'Electronic instruments and appliances used in geodesy, topography, hydrography o'),
('90158091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje ostatní nivelační,oceánografické apod.,ne:elektronické', 'Non-electronic instruments and appliances used in geodesy, topography surveying'),
('90158093', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje meteorologické,hydrologické,geofyzikální,ne:elektronické', 'Non-electronic meteorological, hydrological and geophysical instruments and appa'),
('90158099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje ostatní nivelační,oceánografické apod.,ne:elektronické', 'Non-electronic instruments and appliances used in oceanography (excl. compasses,'),
('90159000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části přístrojů geodetických,topografických apod.,dálkoměrů,libel,teodol.apod.', 'Parts and accessories for instruments and appliances used in geodesy, topography'),
('90160010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Váhy i se závažími o citlivosti 5 mg a citlivější', 'Balances of a sensitivity of 50 mg or better, with or without weights'),
('90160090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,příslušenství vah o citlivosti 5 mg a citlivějších', 'Parts and accessories for balances of a sensitivity of 50 mg or better, n.e.s.'),
('90171010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kreslicí (rýsovací) stoly a stroje - souřadnicové zapisovače (plottery)', 'Plotters as drafting machines'),
('90171090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kreslicí (rýsovací) stoly a stroje ost.,ne:souřadnicové zapisovače (plottery)', 'Drafting tables and machines, whether or not automatic (excl. plotters)'),
('90172005', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kreslicí nástroje ost.-souřadnicové zapisovače (plottery),ne:kreslicí stoly,stroje', 'Plotters as drawing or marking-out instruments'),
('90172011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Soupravy rýsovací,kreslicí', 'Drawing sets'),
('90172019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje kreslicí ostatní,ne:soupravy rýsovací,kreslicí', 'Drawing instruments (excl. drafting tables and machines, plotters and drawing se'),
('90172039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Nástroje,přístroje označovací', 'Marking-out instruments'),
('90172090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje počítací matematické vč.logaritmických pravítek,počít.kotoučů apod.', 'Mathematical calculating instruments, incl. slide rules, disc calculators and th'),
('90173010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Mikrometry,měřítka posuvná', 'Micrometers and callipers'),
('90173090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kalibry,měrky,ne:výrobky podpoložky 9031 80 51', 'Gauges (excl. gauges without adjustable devices)'),
('90178010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tyče (laťky),pásma měřící,dělená měřidla', 'Measuring rods and tapes and divided scales'),
('90178090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Měřidla délková ostatní,ne:viz sazebník', 'Hand-held instruments for measuring length, n.e.s.'),
('90179000', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti nástrojů,přístrojů kreslicích,matem.počítacích apod.,měřidel délk.ručních', 'Parts and accessories for drawing, marking-out or mathematical calculating instr'),
('90181100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Elektrokardiografy', 'Electro-cardiographs'),
('90181200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ultrazvukové sonografy', 'Ultrasonic scanning apparatus'),
('90181300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Diagnostické přístroje pracující na základě magnetické rezonance', 'Magnetic resonance imaging apparatus'),
('90181400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Scintigrafické přístroje', 'Scintigraphic apparatus'),
('90181910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Monitorovací přístroje pro simultání monitorovánídvou nebo více parametrů', 'Electro-diagnostic monitoring apparatus for simultaneous monitoring of two or mo'),
('90181990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Elektrodiagnostické přístroje ostatní,ne:viz sazebník', 'Electro-diagnostic apparatus, incl. apparatus for functional exploratory examina'),
('90182000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zářiče ultrafialové,infračervené', 'Ultraviolet or infra-red ray apparatus used in medical, surgical, dental or vete'),
('90183110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stříkačky injekční z plastů i s jehlami', 'Syringes of plastics, with or without needles, used in medical, surgical, dental'),
('90183190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stříkačky injekční z ostatních materiálů i s jehlami,ne:z plastů', 'Syringes, with or without needles, used in medical, surgical, dental or veterina'),
('90183210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jehly trubkové kovové', 'Tubular metal needles, used in medical, surgical, dental or veterinary sciences'),
('90183290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Jehly sešívací kovové', 'Needles for sutures, used in medical, surgical, dental or veterinary sciences'),
('90183900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Katétry,kanyly a podobné výrobky', 'Needles, catheters, cannulae and the like, used in medical, surgical, dental or'),
('90184100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vrtačky zubní i kombinované s jiným zubolékařským zařízením', 'Dental drill engines, whether or not combined on a single base with other dental'),
('90184910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vrtáčky,hroty,kotoučky,kartáčky pro zubní vrtačky', 'Burrs, discs, drills and brushes, for use in dental drills'),
('90184990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje zubolékařské ostatní,ne:zubní vrtačky,vrtáčky,hroty,kotoučky,kartáčky', 'Instruments and appliances used in dental sciences, n.e.s.'),
('90185010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje,přístroje oftamologické,ne:optické', 'Ophthalmic instruments and appliances, non-optical, n.e.s.'),
('90185090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje,přístroje oftamologické optické', 'Ophthalmic instruments and appliances, optical, n.e.s.'),
('90189010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje,nástroje k měření tlaku krve', 'Instruments and apparatus for measuring blood-pressure'),
('90189020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Endoskopy', 'Endoscopes used in medical, surgical or veterinary sciences'),
('90189030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje pro dialýzu ledvin (umělé ledviny,dialyzační přístroje)', 'Renal dialysis equipment "artificial kidneys, kidney machines and dialysers"'),
('90189041', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje pro diatermii ultrazvukové', 'Ultrasonic diathermic apparatus'),
('90189049', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje pro diatermii ostatní,ne:ultrazvukové', 'Diathermic apparatus (excl. ultrasonic and ultraviolet or infra-red apparatus)'),
('90189050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje,zařízení transfúzní', 'Transfusion apparatus used in medical sciences'),
('90189060', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje,nástroje,zařízení pro anestézii', 'Anaesthetic apparatus and instruments'),
('90189070', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje,nástroje lékařské ultrazvukové pro litotrypsii', 'Ultrasonic lithotripsy instruments'),
('90189075', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje pro nervovou stimulaci', 'Apparatus for nerve stimulation'),
('90189085', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje a přístroje lékařské ostatní,ne:viz sazebník', 'Instruments and appliances used in medical, surgical or veterinary sciences, n.e'),
('90191010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Strojky masážní vibrační elektrické', 'Electrical vibratory-massage apparatus'),
('90191090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje pro mechanoterapii,masážní,psychotechnické,ne:el.vibrační masážní strojky', 'Mechano-therapy appliances; massage apparatus; psychological aptitude-testing ap'),
('90192000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístr.oživovací dýchací,pro léčbu ozónem,kyslíkem apod.,léčebné dýchací přístroje', 'Ozone therapy, oxygen therapy, aerosol therapy, artificial respiration or other'),
('90200000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje dýchací,masky plynové', 'Breathing appliances and gas masks (excl. protective masks having neither mechan'),
('90211010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ortopedické pomůcky a přístroje', 'Orthopaedic appliances'),
('90211090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dlahy a jiné potřeby,přístroje pro léčbu zlomenin', 'Splints and other fracture appliances'),
('90212110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'CEN'), 'Zuby umělé z plastů', 'Artificial teeth of plastics'),
('90212190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'CEN'), 'Zuby umělé z materiálů ostatních,ne:z plastů', 'Artificial teeth of materials other than plastics'),
('90212900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pomůcky a přístroje pro zubní náhrady ostatní,ne:umělé zuby', 'Dental fittings (excl. artificial teeth)'),
('90213100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Umělé klouby', 'Artificial joints for orthopaedic purposes'),
('90213910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Oční protézy', 'Ocular protheses'),
('90213990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Umělé části těla ostatní,ne:umělé klouby,oční protézy', 'Artificial parts of the body (excl. artificial teeth and dental fittings, artifi'),
('90214000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje pro nedoslýchavé,ne:části,příslušenství', 'Hearing aids (excl. parts and accessories)'),
('90215000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stimulátory srdeční,ne:části,příslušenství', 'Pacemakers for stimulating heart muscles (excl. parts and accessories)'),
('90219010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,příslušenství pomůcek pro nedoslýchavé', 'Parts and accessories of hearing aids, n.e.s.'),
('90219090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje ostatní ke kompenzaci vad apod.,části,příslušenství,ne:viz sazebník', 'Articles and appliances, which are worn or carried, or implanted in the body, to'),
('90221200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Tomografické přístroje řízené strojem na automatické zpracování dat', 'Computer tomography apparatus'),
('90221300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'RTG přístroje ostatní pro zubolékařské účely,ne:tomograf řízený počítačem', 'Apparatus based on the use of X-rays for dental uses'),
('90221400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'RTG přístroje ostatní pro lékařské,chirurgické,zvěrolékařské účely,ne:tomograf', 'Apparatus based on the use of X-rays, for medical, surgical or veterinary uses ('),
('90221900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'RTG přístroje pro ostatní účely,ne:viz sazebník', 'Apparatus based on the use of X-rays (other than for medical, surgical, dental o'),
('90222100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje se zářením alfa,beta apod.pro lékařské,chirurgické,zubolék.,zvěrolékařské účely', 'Apparatus based on the use of alpha, beta or gamma radiations, for medical, surg'),
('90222900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje se zářením alfa,beta apod.pro ostatní účely,ne:viz sazebník', 'Apparatus based on the use of alpha, beta or gamma radiations (other than for me'),
('90223000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Rentgenky', 'X-ray tubes'),
('90229010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'RTG obrazovky fluorescenční,stěny prosvěcovací RTG,ochranné štíty,mřížky', 'X-ray fluorescent screens and X-ray intensifying screens; anti-scatter shields a'),
('90229090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,přísluš.výrobků pro vyšetřování,léčení apod.použ.záření alfa,beta,gama', 'X-ray generators other than X-ray tubes, high tension generators, control panels'),
('90230010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Modely,přístroje apod.pro výuku fyziky,chemie,technických předmětů', 'Instruments, apparatus and models for teaching physics, chemistry or technical s'),
('90230080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Modely,přístroje a pod.k předvádění ost.,ne:výuka fyziky,chemie,techn.předmětů', 'Instruments, apparatus and models designed for demonstrational purposes, e.g. in'),
('90241011', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje ke zkoušení mechanických vlastností kovů elektronické univerzální nebo pro zkoušky tahem', 'Electronic machines and appliances for universal testing of mechanical propertie'),
('90241013', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje ke zkoušení mechanických vlastností kovů elektronické pro zkoušky tvrdosti', 'Electronic machines and appliances for testing the hardness of metals'),
('90241019', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje ke zkoušení mechanických vlastností kovů elektronické ostatní,ne:viz sazebník', 'Electronic machines and appliances for testing the mechanical properties of meta'),
('90241090', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje ke zkoušení mechanických vlastností kovů jiné než elektronické', 'Machines and appliances for testing the mechanical properties of metals, non-ele'),
('90248011', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje ke zkoušení mechanických vlastností materiálů elektronické pro textil.materiály,papír,karton,lepenku', 'Electronic machines and appliances for testing the mechanical properties of text'),
('90248019', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje ke zkoušení mechanických vlastností materiálů elektronické ostatní,ne:kovů,viz sazebník', 'Electronic machines and appliances for testing the mechanical properties of mate'),
('90248090', 2008, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje ke zkoušení mechanických vlastností materiálů jiné než elektronické ostatní,ne:kovů', 'Machines and appliances for testing the mechanical properties of materials, non-'),
('90249000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti přístrojů k zkoušení mechanických vlastností materiálů', 'Parts and accessories for machines and appliances for testing the mechanical pro'),
('90251120', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Teploměry kapalinové nekomb.s jinými přístr.klinické,veterinární,přímé čtení', 'Clinical or veterinary thermometers, liquid-filled, for direct reading'),
('90251180', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Teploměry kapalinové nekomb.s jinými přístr.ostatní,přímé čtení,ne:viz sazebník', 'Thermometers, liquid-filled, for direct reading, not combined with other instrum'),
('90251920', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Teploměry elektronické nekomb.s jinými přístroji', 'Thermometers and pyrometers, not combined with other instruments, electronic'),
('90251980', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Teploměry ostatní nekomb.s jinými přístr.,ne:kapalinové,elektronické', 'Thermometers and pyrometers, not combined with other instruments, non-electronic'),
('90258020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Tlakoměry nekombinované s jinými přístroji ostatní,ne:pro letadla civilní', 'Barometers, not combined with other instruments'),
('90258040', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hydrometry,žároměry,vlhkoměry,tlakoměry apod.elektronické', 'Hydrometers, areometers and similar floating instruments, hygrometers and psychr'),
('90258080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hydrometry,žároměry,vlhkoměry,tlakoměry apod.ostatní,ne:elektronické', 'Hydrometers, areometers and similar floating instruments, hygrometers and psychr'),
('90259000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části teploměrů,tlakoměrů,vlhkoměrů,žároměrů apod.', 'Parts and accessories for hydrometers, areometers and similar floating instrumen'),
('90261021', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Průtokoměry elektronické', 'Electronic flow meters for measuring or checking the flow or level of liquids (e'),
('90261029', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje na měření,kontrolu hladiny kapalin elektronické', 'Electronic instruments and apparatus for measuring or checking the flow or level'),
('90261081', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Průtokoměry ostatní,ne:elektronické', 'Flow meters for measuring or checking the flow or level of liquids, non-electron'),
('90261089', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje na měření,kontrolu hladiny kapalin ost.,ne:elektronické', 'Instruments and apparatus for measuring or checking the flow or level of liquids'),
('90262020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje na kontrolu,měření tlaku elektronické', 'Electronic instruments and apparatus for measuring or checking pressure of liqui'),
('90262040', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje na měření tlaku vybavené spirálou nebo kovovou membránou', 'Spiral or metal diaphragm type pressure gauges'),
('90262080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje na kontrolu,měření tlaku ostatní,ne:viz sazebník', 'Instruments and apparatus for measuring or checking pressure of liquids or gases'),
('90268020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje k měření proměn.charakteristik kapalin,plynů ost.elektronické,ne:viz sazebník', 'Electronic instruments or apparatus for measuring or checking variables of liqui'),
('90268080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje k měření proměn.charakteristik kapalin,plynů ost.,ne:elektronické,viz sazebník', 'Non-electronic instruments or apparatus for measuring or checking variables of l'),
('90269000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části přístrojů měření,kontroly kapalin,plynů', 'Parts and accessories for instruments and apparatus for measuring or checking th'),
('90271010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Analyzátory plynů,kouře elektronické', 'Electronic gas or smoke analysis apparatus'),
('90271090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Analyzátory plynu,kouře ostatní,ne:elektronické', 'Non-electronic gas or smoke analysis apparatus'),
('90272000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Chromatografy a přístroje pro elektroforézu', 'Chromatographs and electrophoresis instruments'),
('90273000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Spektrometry,spektrofotometry,spektrografy používající optické záření', 'Spectrometers, spectrophotometers and spectrographs using optical radiations, su'),
('90275000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje ost.využív.optické záření,ne:spektrometry,-fotomery,-grafy,expozimetry', 'Instruments and apparatus for physical or chemical analysis, using UV, visible o'),
('90278005', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Expozimetry', 'Exposure meters'),
('90278011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje elektronické na měření pH,rH,měření vodivosti', 'Electronic pH meters, rH meters and other apparatus for measuring conductivity'),
('90278013', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístr.pro měření fyzik.vlastn.polovodič.mater.,LCD apod.elektronické', 'Electronic apparatus and equipment for performing measurements of the physical p'),
('90278017', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje pro fyzikální,chemické rozbory elektronické ostatní,ne:viz sazebník', 'Electronic instruments and apparatus for physical or chemical analysis or for me'),
('90278091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Viskozimetry,porozimetry,expanzometry,ne:elektronické', 'Non-electronic viscometers, porosimeters and expansion meters'),
('90278093', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístr.pro měření fyzik.vlastn.polovodič.mater.,LCD apod.ost.;ne:viz sazebník', 'Apparatus and equipment for performing measurements of the physical properties o'),
('90278097', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje pro fyzikální,chemické rozbory ostatní,ne:viz sazebník', 'Non-electronic instruments and apparatus for physical or chemical analysis or fo'),
('90279010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Mikrotomy', 'Microtomes'),
('90279050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti přístrojů položek 9027 20 až 9027 80', 'Parts and accessories of instruments and apparatus for physical or chemical anal'),
('90279080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti mikrotomů nebo analyzátorů plynů nebo kouře', 'Parts and accessories of microtomes or of gas or smoke analysis apparatus, n.e.s'),
('90281000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Plynoměry', 'Gas meters, incl. calibrating meters therefor'),
('90282000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Vodoměry na teplou a studenou vodu pro domácnost', 'Liquid meters, incl. calibrating meters therefor'),
('90283011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Elektroměry pro proud střídavý jednofázový', 'Electricity supply or production meters for alternating current, single-phase, i'),
('90283019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Elektroměry pro proud střídavý vícefázový', 'Electricity supply or production meters for alternating current, multi-phase, in'),
('90283090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Elektroměry ostatní,ne:pro proud střídavý', 'Electricity supply or production meters for continuous current, incl. calibratin'),
('90289010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,příslušenství elektroměrů', 'Parts and accessories for electricity meters, n.e.s.'),
('90289090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,příslušenství plynoměrů,měřičů kapalin', 'Parts and accessories for gas or liquid meters, n.e.s.'),
('90291000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Otáčkoměry,počítače výrobků,taxametry,krokoměry apod.', 'Revolution counters, production counters, taximeters, milometers, pedometers and'),
('90292031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rychloměry pro vozidla', 'Speed indicators for land vehicles'),
('90292038', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rychloměry ostatní,tachometry,ne:rychloměry pro vozidla', 'Speed indicators and tachometers (excl. for land vehicles)'),
('90292090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroboskopy', 'Stroboscopes'),
('90299000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části otáčkoměrů,počítačů výrobků,rychloměrů,stroboskopů a podobných zařízení', 'Parts and accessories for revolution counters, production counters, taximeters,'),
('90301000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje k měření,zjišťování ionizujícího záření', 'Instruments and apparatus for measuring or detecting ionising radiations'),
('90302010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Osciloskopy,oscilografy katodové', 'Cathode ray oscilloscopes and cathode ray oscillographs'),
('90302030', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Osciloskopy,oscilografy jiné než katodové,s registrač.zařízením', 'Oscilloscopes and oscillographs, with recording device (excl. cathode ray oscill'),
('90302091', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Osciloskopy,oscilografy jiné než katodové,bez registrač.zařízení,elektronické', 'Electronic oscilloscopes and oscillographs, without recording device (excl. cath'),
('90302099', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Osciloskopy,oscilografy jiné než katodové,bez registrač.zařízení ostatní,ne:elektronické', 'Oscilloscopes and oscillographs, non-electronic, without recording device (excl.'),
('90303100', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje měřicí (napětí,odpor ap) víceúčelové,bez registr.zařízení', 'Multimeters for voltage, current, resistance or electrical power, without record'),
('90303200', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje měřicí (napětí,odpor ap) víceúčelové,s registr.zařízením', 'Multimeters with recording device'),
('90303310', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje měřicí (napětí,odpor ap) jednoúčelové,bez registr.zařízení,elektronické', 'Electronic instruments and apparatus for measuring or checking voltage, current,'),
('90303391', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Voltmetry,bez registr.zařízení', 'Voltmeters without recording device'),
('90303399', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje měřicí (proud,odpor ap) jednoúčelové,bez registr.zařízení ost.,ne:voltmetry', 'Instruments and apparatus for measuring or checking voltage, current, resistance'),
('90303900', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje měřicí (napětí,odpor ap) jednoúčelové,s registr.zařízením', 'Instruments and apparatus for measuring or checking voltage, current, resistance'),
('90304000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje měřicí určené pro sdělovací techniku', 'Instruments and apparatus for measuring or checking electrical quantities, speci'),
('90308200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje pro měření,kontrolu polovodičových destiček,zařízení', 'Instruments and apparatus for measuring or checking semiconductor wafers or devi'),
('90308400', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje měřicí (el.veličiny,záření) ost,s registr.zařízením,ne:viz sazebník', 'Instruments and apparatus for measuring or checking electrical quantities, with'),
('90308930', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje měřicí (el.veličiny,záření) ost,bez registr.zařízení,elektronické,ne:viz sazebník', 'Electronic instruments and appliances for measuring or checking electrical quant'),
('90308990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje měřicí (el.veličiny,záření) ost,bez registr.zařízení,ne:elektronické,viz sazebník', 'Instruments and apparatus for measuring or checking electrical quantities, witho'),
('90309020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti přístrojů podpoložky 9030 82 00', 'Parts and accessories for instruments and apparatus for measuring or checking se'),
('90309085', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti přístrojů k měření,kontrole el.veličin,záření,ne:viz sazebník', 'Parts and accessories for instruments and apparatus for measuring or checking el'),
('90311000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stroje k vyvažování mechanických součástí', 'Machines for balancing mechanical parts'),
('90312000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zařízení zkušební', 'Test benches for motors, generators, pumps, etc.'),
('90314100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje optické ostatní pro kontrolu masek pro polovodiče,ne:viz sazebník', 'Optical instruments and appliances for inspecting semiconductor wafers or device'),
('90314910', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Projektory na kontrolu profilů', 'Profile projectors'),
('90314990', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Optické nástroje a přístroje ostatní,ne:viz sazebník', 'Optical instruments, appliances and machines for measuring or checking, not else'),
('90318032', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje pro kontrolu polovodič.destiček,zařízení apod.', 'Electronic instruments, apparatus and machines for inspecting semiconductor wafe'),
('90318034', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Měřící,kontrolní elektronické přístroje ostatní,ne:viz sazebník', 'Electronic instruments, apparatus and machines for measuring or checking geometr'),
('90318038', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje k měření,kontrole ostatní elektronické,ne:viz sazebník', 'Electronic instruments, apparatus and machines for measuring or checking, n.e.s.'),
('90318091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje pro měření,kontrolu geometrických velečin ostatní,ne:viz sazebník', 'Instruments, appliances and machines for measuring or checking geometrical quant'),
('90318098', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje k měření,kontrole ostatní,ne:elektronické,viz sazebník', 'Non-electronic and non-optical instruments, apparatus and machines for measuring'),
('90319020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti přístrojů podpoložek 9031 41 00 a 9031 49 10', 'Parts and accessories for optical instruments and appliances for inspecting semi'),
('90319030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti přístrojů podpoložky 9031 80 32', 'Parts and accessories for electronic instruments, apparatus and machines for ins'),
('90319085', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti přístrojů k měření,kontrole veličin ostatních,ne:viz sazebník', 'Parts and accessories for instruments, appliances and machines for measuring and'),
('90321020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Termostaty elektronické', 'Electronic thermostats'),
('90321081', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Termostaty s elektrickým spouštěcím zařízením', 'Non-electronic thermostats, automatic regulating or controlling, with electrical'),
('90321089', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Termostaty ostatní,ne:elektronické,s elektrickým spouštěcím zařízením', 'Non-electronic thermostats, without electrical triggering device'),
('90322000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Manostaty (presostaty)', 'Manostats (excl. taps, cocks and valves of heading 8481)'),
('90328100', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje automatické regulační,kontrolní hydraulické,pneumatické', 'Hydraulic or pneumatic regulating or controlling instruments and apparatus (excl'),
('90328900', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Přístroje automatické regulační,kontrolní ostatní,ne:viz sazebník', 'Regulating or controlling instruments and apparatus (excl. hydraulic or pneumati'),
('90329000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části přístrojů automatických regulačních,kontrolních', 'Parts and accessories for regulating or controlling instruments and apparatus, n'),
('90330000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části strojů,přístrojů kapitoly 90 jinde neuvedené ani nezahrnuté,ne:viz sazebník', 'Parts and accessories for machines, appliances, instruments or other apparatus i'),
('91011100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Hodinky náramkové z drahých kovů řízené elektricky-mechanické zobrazení', 'Wrist-watches of precious metal or of metal clad with precious metal, whether or'),
('91011900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Hodinky náramkové z drahých kovů,řízené elektricky ostatní,ne:viz sazebník', 'Wrist-watches of precious metal or of metal clad with precious metal, whether or'),
('91012100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Hodinky náramkové z drahých kovů i se stopkami,automatické natahování', 'Wrist-watches of precious metal or of metal clad with precious metal, whether or'),
('91012900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Hodinky náramkové z drahých kovů i se stopkami ostatní,ne:viz sazebník', 'Wrist-watches of precious metal or of metal clad with precious metal, whether or'),
('91019100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Hodinky kapesní,stopky apod.z drahých kovů řízené elektricky', 'Pocket-watches and the like, incl. stop-watches, of precious metal or of metal c'),
('91019900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Hodinky kapesní,stopky apod.z drahých kovů ostatní,ne:řízené elektricky', 'Pocket-watches and the like, incl. stop-watches, of precious metal or of metal c'),
('91021100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Hodinky náramkové řízené elektricky i se stopkami,mech.zobraz.,ne:drahý kov', 'Wrist-watches, whether or not incorporating a stop-watch facility, electrically'),
('91021200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Hodinky náramkové řízené elektricky-optoelektronické zobrazení,ne:drahý kov', 'Wrist-watches, whether or not incorporating a stop-watch facility, electrically'),
('91021900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Hodinky náramkové řízené elektricky ostatní,ne:viz sazebník', 'Wrist-watches, whether or not incorporating a stop-watch facility, electrically'),
('91022100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Hodinky náramkové,automatické natahování i se stopkami,ne:z drakého kovu', 'Wrist-watches, whether or not incorporating a stop-watch facility, with automati'),
('91022900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Hodinky náramkové ostatní i se stopkami,ne:viz sazebník', 'Wrist-watches, whether or not incorporating a stop-watch facility, with hand win'),
('91029100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Hodinky kapesní řízené elektricky i se stopkami,ne:z drahého kovu', 'Pocket-watches and the like, incl. stop-watches, electrically operated (excl. of'),
('91029900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Hodinky kapesni,stopky ostatni,ne baterie ap', 'Pocket-watches and the like, incl. stop-watches, with hand or automatic winding'),
('91031000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Budíky,malé hodiny kyvadlové s hodinkovým strojkem řízené elektricky', 'Clocks with watch movements, electrically operated (excl. wrist-watches, pocket-'),
('91039000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Budiky,hodiny kyvadlove s hodin.strojkem ost.', 'Clocks with watch movements (excl. electrically operated, wrist-watches, pocket-'),
('91040000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Hodiny do přístrojových desek pro vozidla,letadla,kosmické lodě,plavidla apod.', 'Instrument panel clocks and clocks of a similar type for vehicles, aircraft, ves'),
('91051100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Budíky řízené elektricky,ne:hodinkový strojek', 'Alarm clocks, electrically operated'),
('91051900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Budíky ostatní,ne:řízené elektricky,hodinový strojek', 'Alarm clocks (excl. electrically operated)'),
('91052100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Hodiny nástěnné elektrické,ne:hodinový strojek', 'Wall clocks, electrically operated'),
('91052900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Hodiny nástěnné ostatní,ne:řízené elektricky,hodinový strojek', 'Wall clocks (excl. electrically operated)'),
('91059100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Hodiny ostatní řízené elektricky,ne:viz sazebník', 'Clocks, electrically operated (excl. wrist-watches, pocket-watches and other wat'),
('91059910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Hodiny na stolní desku,římsu krbu,ne:hodinkový strojek,řízené elektricky', 'Table-top or mantelpiece clocks, non-electrically operated (excl. alarm clocks)'),
('91059990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Přístroje hodinářské,hodiny ostatní,ne:viz sazebník', 'Clocks, non-electrically operated (excl. wrist-watches, pocket-watches and other'),
('91061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Hodiny kontrolní registrační,hodiny zaznamenávající datum a hodinu', 'Time registers and time recorders'),
('91069010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Časovače procesní,stopky a podobné hodiny', 'Process-timers, stop-clocks and the like'),
('91069080', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Časové kontrolní přístroje,počitadla apod.s hodin.strojkem ost.,ne:viz sazebník', 'Time of day recording apparatus and apparatus for measuring, recording or otherw'),
('91070000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Spínače,vypínače spouštěče apod.časové s hodinkovým strojkem,ne:viz sazebník', 'Time switches with clock or watch movement or with synchronous motor'),
('91081100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Strojky hodinkové řízené elektricky pouze s mechanickým zobrazením,smontované', 'Watch movements, complete and assembled, electrically operated, with mechanical'),
('91081200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Strojky hodinkové řízené elektricky s optoelektronickým zobrazením,smontované', 'Watch movements, complete and assembled, electrically operated, with opto-electr'),
('91081900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Strojky hodinkové řízené elektricky ostatní smontované,ne:viz sazebník', 'Watch movements, complete and assembled, electrically operated, with combined op'),
('91082000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Strojky hodinkové s automatickým natahováním,smontované', 'Watch movements, complete and assembled, with automatic winding'),
('91089000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Strojky hodinkové smontované ostatní,ne:viz sazebník', 'Watch movements, complete and assembled, with hand winding only'),
('91091100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje hodinové budíkové řízené elektricky smontované', 'Clock movements of alarm clocks, complete and assembled, electrically operated,'),
('91091900', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje hodinové řízené elektricky smontované ostatní,ne:budíkové', 'Clock movements, complete and assembled, electrically operated (excl. alarm cloc'),
('91099000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Stroje hodinové,smontované ostatní,ne:řízené elektricky', 'Clock movements, complete and assembled (excl. electrically operated and watch m'),
('91101110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Strojky hodinkové s nepokojem a s vláskem úplné nesmontované,částečně smontované', 'Complete watch movements, unassembled or partly assembled "movement sets", with'),
('91101190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Strojky hodinkové úplné nesmontované,částečně smont.,ne:s nepokojem a vláskem', 'Complete watch movements, unassembled or partly assembled "movement sets" (excl.'),
('91101200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Strojky hodinkové neúplné,smontované', 'Incomplete watch movements, assembled'),
('91101900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Strojky hodinkové neúplné,nesmontované', 'Rough clock movements'),
('91109000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Strojky hodinové úplné,neúplné,smontované,nesmontované ostatní,ne:viz sazebník', 'Complete, unassembled or partly assembled clock movements "movement sets"; incom'),
('91111000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pouzdra hodinková z drahých kovů,plátovaná drahými kovy', 'Cases for wrist-watches, pocket-watches and other watches of heading 9101 or 910'),
('91112000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Hodinková pouzdra z obecných kovů, i pozlacená, postříbřená', 'Cases for wrist-watches, pocket-watches and other watches of heading 9101 or 910'),
('91118000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pouzdra hodinková ostatní,ne:z obecných,drahých kovů,pozlacená,postříbřená', 'Cases for wrist-watches, pocket-watches and other watches of heading 9101 or 910'),
('91119000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti pouzder hodinkových', 'Parts of cases for wrist-watches, pocket-watches and other watches of heading 91'),
('91122000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kryty,skříňky k výrobkům hodinářským', 'Clock and watch cases (excl. for wrist-watches, pocket-watches and other watches'),
('91129000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti krytů,skříněk k výrobkům hodinářským', 'Parts of clock and watch cases, n.e.s. (excl. for wrist-watches, pocket-watches'),
('91131010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Řemínky,pásky,náramky hodinkové z drahých kovů', 'Watch straps, watch bands and watch bracelets, and parts thereof, of precious me'),
('91131090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Řemínky,pásky,náramky hodink.z drahých kovů plátovaných,pokovených drahými kovy', 'Watch straps, watch bands and watch bracelets, and parts thereof, of metal clad'),
('91132000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Řemínky,pásky,náramky hodinkové z obecných kovů i pozlacené,postříbřené', 'Watch straps, watch bands and watch bracelets, and parts thereof, of base metal,'),
('91139010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Řemínky,pásky,náramky hodinkové z kůže i umělé', 'Watch straps, watch bands and watch bracelets, and parts thereof, of leather or'),
('91139080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní hodinkové řemínky,pásky,náramky,jiné než z kovů, (umělé) kůže', 'Watch straps, watch bands and watch bracelets, and parts thereof, n.e.s.'),
('91141000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pera hodinářská včetně vlásků', 'Springs for clocks or watches, incl. hairsprings'),
('91142000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kameny hodinkové', 'Jewels for clocks or watches (excl. gems for clock and watch cases)'),
('91143000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Číselníky hodinkové', 'Dials for clocks or watches'),
('91144000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Destičky (platiny),můstky ložiskové hodinářské', 'Plates and bridges for clocks or watches'),
('91149000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti hodinářské ostatní,ne:pera,kameny,číselníky,destičky,lož.můstky', 'Clock or watch parts, n.e.s.'),
('92011010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pianina nová i automatická', 'New upright pianos'),
('92011090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pianina použitá i automatická', 'Used upright pianos'),
('92012000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Křídla klavírní i automatická', 'Grand pianos'),
('92019000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Cembala,nástroje strunné s klaviaturou ostatní,ne:pianina,křídla', 'Harpsichords and other keyboard stringed instruments (excl. pianos)'),
('92021010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Housle', 'Violins'),
('92021090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Hudební nástroje smyčcové ostatní,ne:housle', 'String musical instruments played with a bow (excl. violins)'),
('92029030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kytary', 'Guitars'),
('92029080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Ostatní strunné hudební nástroje jiné než křídla,cembala,smyčce,kytary', 'Mandolins, zithers and other string musical instruments (excl. with keyboard, th'),
('92051000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Nástroje hudební dechové žesťové', 'Brass-wind instruments'),
('92059010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Harmoniky tahací a podobné nástroje', 'Accordions and similar instruments'),
('92059030', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Harmoniky foukací', 'Mouth organs'),
('92059050', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Píšťalové varhany s klaviaturou; harmonia a podobné nástroje', 'Keyboard pipe organs; harmoniums and similar keyboard instruments with free meta'),
('92059090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje hudební dechové ostatní,ne:žesťové', 'Wind musical instruments (excl. brass-wind instruments, accordions and similar i'),
('92060000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hudební nástroje bicí', 'Percussion musical instruments, e.g. drums, xylophones, cymbals, castanets, mara'),
('92071010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Varhany,zvuk zesílen elektricky', 'Keyboard organs, the sound of which is produced, or must be amplified, electrica'),
('92071030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Klavíry digitální', 'Digital pianos, with keyboard'),
('92071050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Syntetizátory', 'Synthesisers with keyboard'),
('92071080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Klávesové hudební nástroje elektrické ostatní,ne:viz sazebník', 'Musical instruments, the sound of which is produced, or must be amplified, elect'),
('92079010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kytary elektrické', 'Guitars, the sound of which is produced, or must be amplified, electrically'),
('92079090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje hudební elektrické ostatní,ne:klávesové,kytary', 'Accordions and musical instruments without keyboards, the sound of which is prod'),
('92081000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skříňky hrací', 'Musical boxes'),
('92089000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nástroje hudební ostatní,ne:viz sazebník', 'Fairground organs, mechanical street organs, mechanical singing birds, musical s'),
('92093000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Struny pro hudební nástroje', 'Musical instrument strings'),
('92099100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti,příslušenství klavírů,pianin', 'Parts and accessories for pianos, n.e.s.'),
('92099200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti,příslušenství nástrojů hudebních strunných,ne:klavírů,pianin', 'Parts and accessories for string musical instruments without keyboards, n.e.s. ('),
('92099400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,příslušenství nástrojů hudebních elektrických', 'Parts and accessories for musical instruments, the sound of which is produced, o'),
('92099920', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti,příslušenství nástrojů hudebních dechových', 'Parts and accessories for clarinets, trumpets, bagpipes, keyboard pipe organs, h'),
('92099940', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Metronomy,ladičky', 'Metronomes, tuning forks and pitch pipes'),
('92099950', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Mechanismy hracích skříněk', 'Mechanisms for musical boxes'),
('92099970', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti hudebních nástrojů ostatní,ne:viz sazebník', 'Parts and accessories for musical instruments "e.g. cards, discs and rolls for m'),
('93011100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zbraně dělostřelecké (např.kanóny,houfnice,minomety) samohybné', 'Artillery weapons "e.g. guns, howitzers and mortars", self-propelled'),
('93011900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zbraně dělostřelecké ostatní (např.kanóny,houfnice,minomety),ne:samohybné', 'Artillery weapons "e.g. guns, howitzers and mortars",  not self-propelled'),
('93012000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Raketová odpalovací zařízení,na torpéda,plamenomety,granátomety apod.', 'Rocket launchers; flame-throwers; grenade launchers; torpedo tubes and similar p'),
('93019000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zbraně vojenské ostatní,ne:viz sazebník', 'Military weapons, incl. sub-machine guns (excl. artillery weapons, rocket launch'),
('93020000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Revolvery a pistole, jiné než čísel 9303 nebo 9304', 'Revolvers and pistols (excl. those of heading 9303 or 9304 and sub-machine guns'),
('93031000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zbraně střelné nabíjené ústím hlavně', 'Muzzle-loading firearms, neither designed nor suitable for projecting cartridges'),
('93032010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pušky sportovní,lovecké,ke střelbě na cíl s jednoduchou hladkou hlavní', 'Sporting, hunting or target-shooting shotguns, single-barrelled, smooth bore (ex'),
('93032095', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pušky sportovní,lovecké,ke střelbě na cíl ost.,ne:s jednoduchou hladkou hlavní', 'Sporting, hunting or target-shooting shotguns, with one or two smooth bore combi'),
('93033000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pušky,karabiny sport.,lovecké,na cíl ostatní,ne:s hladkou hlavní', 'Sporting, hunting and target-shooting shotguns with one or more rifled bores (ot'),
('93039000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zbraně,zařízení ostatní užívající výbuchu střelného prachu', 'Firearms and similar devices which operate by the firing of an explosive charge'),
('93040000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zbraně ostatní,ne:užívající výbuchu střelného prachu,sečné,bodné', 'Spring, air or gas guns and pistols, truncheons and other non-firearms (excl. sw'),
('93051000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti,příslušenství revolverů,pistolí', 'Parts and accessories for revolvers or pistols, n.e.s.'),
('93052100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Části,součásti,příslušenství pušek,karabin s nejméně jednou hladkou hlavní', 'Smooth barrels for sporting, hunting and target-shooting rifles of heading 9303'),
('93052900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní části, součásti a příslušenství pušek a karabin č. 9303', 'Parts and accessories for sporting, hunting and target-shooting rifles of headin'),
('93059100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,příslušenství pro vojenské zbraně čísla 9301', 'Parts and accessories of military weapons of heading 9301, n.e.s.'),
('93059900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části, součásti zbraní ostatních,ne:viz sazebník', 'Parts and accessories for weapons and the like of heading 9303 or 9304, n.e.s. ('),
('93062100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MIL'), 'Náboje pro pušky,karabiny s hladkou hlavní,části,souč.,broky pro vzduchovky', 'Cartridges for smooth-barrelled shotguns'),
('93062940', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MIL'), 'Nábojky pro pušky', 'Cases for shotgun cartridges'),
('93062970', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti nábojů,ne:nábojky', 'Parts of cartridges for smooth-bore shotguns or rifles, n.e.s.; lead pellets for'),
('93063010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Náboje,části,součásti pro samopaly,pistole,revolvery:ne:nabíjené ústím', 'Cartridges and parts thereof for revolvers and pistols of heading 9302 and for s'),
('93063030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Náboje,části,součásti pro zbraně vojenské ostatní,ne:pistole,revolvery,samopaly', 'Cartridges and parts thereof for military weapons'),
('93063091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MIL'), 'Náboje se středovým zápalem,ne:pro pušky,samopaly,pistole,revolvery,vojenské', 'Centrefire cartridges for rifle-barrelled shotguns'),
('93063093', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MIL'), 'Náboje s okrajovým zápalem,ne:pro pušky,samopaly,pistole,revolvery,vojenské', 'Rimfire cartridges for rifle-barrelled shotguns'),
('93063097', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Náboje ostatní,ne:viz sazebník', 'Cartridges and parts thereof, n.e.s.'),
('93069010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bomby,granáty,torpéda,miny řízené střely a podobně pro vojenské účely', 'Bombs, grenades, torpedos, mines, missiles and other ammunition and projectiles,'),
('93069090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Bomby,granáty,torpéda,miny,řízené střely apod.ostatní,ne:pro vojenské účely', 'Ammunition and projectiles and parts thereof, n.e.s. (excl. for military purpose'),
('93070000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Meče,tesáky,bodáky,kopí a podobné zbraně sečné,bodné,jejich části,pochvy', 'Swords, cutlasses, bayonets, lances and similar arms and parts thereof, and scab'),
('94011000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sedadla používaná v letadlech', 'Seats for aircraft'),
('94012000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sedadla používaná v motorových vozidlech', 'Seats for motor vehicles'),
('94013010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sedadla otáčivá,nastavitelná na výšku,vycpávaná s opěradly s kolečky,sanicemi', 'Swivel seats with variable height adjustments, upholstered, with backrest and fi'),
('94013090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sedadla otáčivá,nastavitelná na výšku,ne:vycpávaná,s kolečky,sanicemi', 'Swivel seats with variable height adjustments (excl. upholstered, with backrest'),
('94014000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sedadla proměnitelná v lůžka,ne:zahradní,campingová', 'Seats, convertible into beds (excl. garden seats and camping equipment, and medi'),
('94015100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sedadla z bambusu,ratanu (španělského rákosu)', 'Seats of bamboo or rattan'),
('94015900', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sedadla z materiálů ostatní (vč.indického rákosu,vrbového proutí),ne:z bambusu,ratanu', 'Seats of cane, osier or similar materials (excl. of bamboo or rattan)'),
('94016100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sedadla s kostrou dřevěnou vycpávaná', 'Upholstered seats, with wooden frames (excl. convertible into beds)'),
('94016900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sedadla s kostrou dřevěnou ostatní,ne:vycpávaná', 'Seats, with wooden frames (excl. upholstered)'),
('94017100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sedadla s kostrou kovovou vycpávaná', 'Upholstered seats, with metal frames (excl. seats for aircraft or motor vehicles'),
('94017900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sedadla s kostrou kovovou ostatní,ne:vycpávaná', 'Seats, with metal frames (excl. upholstered, swivel seats with variable height a'),
('94018000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sedadla ostatní,ne:viz sazebník', 'Seats, n.e.s.'),
('94019010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti sedadel používaných v letadlech civilních', 'Parts of seats used for aircraft, n.e.s.'),
('94019030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti sedadel ze dřeva', 'Parts of seats, of wood, n.e.s.'),
('94019080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti sedadel ostatních,ne:pro letadla civilní,ze dřeva', 'Parts of seats, not of wood, n.e.s.'),
('94021000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kresla zubolekarska,holicska ap,casti', 'Dentists'', barbers'' or similar chairs having rotating as well as both reclinin'),
('94029000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nábytek lékařský,chirurgický,zubolékařský,zvěrolékařský,jejich části,součásti', 'Operating tables, examination tables, and other medical, dental, surgical or vet'),
('94031010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stoly rýsovací kovové kancelářské,ne:výrobky čísla 9017', 'Drawing tables for offices, with metal frames (excl. tables with special fitting'),
('94031051', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stoly psací kovové kancelářské,výška do 80 cm', 'Office desks, with metal frames'),
('94031059', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nábytek kovový kancelářský ostatní,výška do 80 cm,ne:psací stoly', 'Metal furniture for offices, of <= 80 cm in height (excl. desks and drawing tabl'),
('94031091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skříně kovové s dveřmi,žaluziemi,sklopnýmí deskami,výška nad 80 cm', 'Metal cupboards with doors, shutters or flaps, for offices, of > 80 cm in height'),
('94031093', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Registratury,lístkovnice apod.kartoteční skříně kovové,výška nad 80 cm', 'Metal filing, card-index and other cabinets, for offices, of > 80 cm in height'),
('94031099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nábytek kancelářský kovový ostatní,výška nad 80 cm,ne:viz sazebník', 'Metal furniture for offices, of > 80 cm in height (excl. drawing tables, cupboar'),
('94032020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lůžka kovová', 'Metal beds (excl. hospital beds with mechanical fittings)'),
('94032080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nábytek kovový ostatní,ne:kancelářský,lůžka', 'Metal furniture (excl. for offices, medical, surgical, dental or veterinary furn'),
('94033011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stoly psací dřevěné kancelářské,výška do 80 cm', 'Desks for offices, with wooden frames'),
('94033019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nábytek dřevěný kancelářský ostatní,výška do 80 cm,ne:stoly', 'Wooden furniture for offices, of <= 80 cm in height (excl. desks and seats)'),
('94033091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skříně dřevěné s dveřmi,žaluziemi,registratury,kartot.skř.apod.,výška nad 80cm', 'Wooden cupboards for offices, of > 80 cm in height'),
('94033099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nábytek dřevěný kancelářský ostatní,výška nad 80 cm,ne:viz sazebník', 'Wooden furniture for offices, of > 80 cm in height (excl. cupboards)'),
('94034010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nábytek dřevěný kuchyňský-vestavěné kuchyňské jednotky', 'Fitted kitchen units'),
('94034090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nábytek dřevěný kuchyňský ostatní,ne:vestavěné kuchyňské jednotky', 'Wooden furniture of a kind used in kitchens (excl. seats and fitted kitchen unit'),
('94035000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nábytek dřevěný ložnicový', 'Wooden furniture for bedrooms (excl. seats)'),
('94036010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nábytek dřevěný pro jídelny bytové,pokoje obývací', 'Wooden furniture for dining rooms and living rooms (excl. seats)'),
('94036030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nábytek dřevěný pro obchody', 'Wooden furniture for shops (excl. seats)'),
('94036090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nábytek dřevěný ostatní,ne:pro kanceláře,domácnost,obchody', 'Wooden furniture (excl. for offices or shops, kitchens, dining rooms, living roo'),
('94037000', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nábytek z plastů', 'Furniture of plastics (excl. medical, dental, surgical or veterinary, and seats)'),
('94038100', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nábytek z bambusu,ratanu (španělského rákosu)', 'Furniture of bamboo or rattan (excl. seats and medical, surgical, dental or vete'),
('94038900', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Nábytek z materiálů ostatní (vč.indického rákosu,vrbového proutí),ne:z bambusu,ratanu', 'Furniture of cane, osier or similar materials (excl. of bamboo, rattan, metal, w'),
('94039010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti nábytku z kovu', 'Parts of furniture, of metal, n.e.s. (excl. of seats and medical, surgical, dent'),
('94039030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti nábytku ze dřeva', 'Parts of furniture, of wood, n.e.s. (excl. seats)'),
('94039090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti nábytku z materiálů ostatních,ne:kov,dřevo', 'Parts of furniture, n.e.s. (excl. of metal or wood, and of seats and medical, su'),
('94041000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vložky pružné do postelí', 'Mattress supports for bed frames (excl. spring interiors for seats)'),
('94042110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Matrace z lehčené pryže i povlečené', 'Mattresses of cellular rubber'),
('94042190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Matrace z lehčených plastů i povlečené', 'Mattresses of cellular plastics'),
('94042910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Matrace z materiálů ost.s pružinami kovovými i povlečené,ne:lehčená pryž,plast', 'Mattresses with spring interiors'),
('94042990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Matrace z materiálů ost.i povlečené,ne:pružiny kovové,lehčená pryž,plast', 'Mattresses, stuffed or internally filled with any material (excl. cellular rubbe'),
('94043000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pytle spací', 'Sleeping bags, whether or non-electrically heated'),
('94049010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Peřiny,polštáře,prošívané deky,podušky apod.plněné peřím draným,prachovým', 'Articles of bedding and similar furnishing, filled with feather or down (excl. m'),
('94049090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Peřiny,polštáře,prošívané deky apod.plněné ost.mater.,ne:peří drané,prachové', 'Articles of bedding and similar furnishing, fitted with springs or stuffed or in'),
('94051021', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Svítidla stropní,nástěnná z plastů s žárovkou,ne:veřej.osvětlení,letadla civil', 'Electric ceiling or wall lighting fittings, of plastics, used with filament lamp'),
('94051028', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Svítidla stropní,nástěnná z plastů ost.,ne:žárovka,veřejné osvětlení', 'Electric ceiling or wall lighting fittings, of plastics, used with discharge lam'),
('94051030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Svítidla stropní,nástěnná z mater.keramických,ne:veřej.osvětlení,letadla civi', 'Electric ceiling or wall lighting fittings, of ceramic materials'),
('94051050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Svítidla stropní,nástěnná ze skla,ne:veřejné osvětlení,pro letadla civilní', 'Chandeliers and other electric ceiling or wall lighting fittings, of glass'),
('94051091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Svítidla stropní,nástěnná z materiálů ost.se žárovkou,ne:viz sazebník', 'Electric ceiling or wall lighting fittings, used with filament lamps (excl. ligh'),
('94051098', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Svítidla stropní,nástěnná z materiálů ost.,ne:žárovka,viz sazebník', 'Electric ceiling or wall lighting fittings, used with discharge lamps (excl. lig'),
('94052011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lampy elektrické noční,stojací,kancelářské z plastů se žárovkou', 'Electric table, desk, bedside or floor-standing lamps, of plastics, used with fi'),
('94052019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lampy elektrické noční,stojací,kancelářské z plastů ost.,ne:se žárovkou', 'Electric table, desk, bedside or floor-standing lamps, of plastics, used with di'),
('94052030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lampy elektrické noční,stojací,kancelářské z materiálů keramických', 'Electric table, desk, bedside or floor-standing lamps, of ceramic materials'),
('94052050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lampy elektrické noční,stojací,kancelářské ze skla', 'Electric table, desk, bedside or floor-standing lamps, of glass'),
('94052091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lampy elektrické noční,stojací,kancel.z mater.ostatních se žárovkou,ne:viz sazebník', 'Electric table, desk, bedside or floor-standing lamps, used with filament lamps'),
('94052099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lampy elektrické noční,stojací,kancel.z mater.ost.bez žárovky,ne:viz sazebník', 'Electric table, desk, bedside or floor-standing lamps, used with discharge lamps'),
('94053000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Svítidla elektrická pro vánoční stromky', 'Electric lighting sets of a kind used for Christmas trees'),
('94054010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Světlomety elektrické', 'Electric searchlights and spotlights (excl. for aircraft, motor vehicles or bicy'),
('94054031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Svítidla elektrická ostatní z plastů se žárovkami,ne:viz sazebník', 'Electric lamps and lighting fittings, of plastics, used with filament lamps, n.e'),
('94054035', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Svítidla elektrická ostatní z plastů se zářivkovými trubicemi,ne:viz sazebník', 'Electric lamps and lighting fittings, of plastics, used with tubular fluorescent'),
('94054039', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Svítidla elektrická ostatní z plastů,ne:viz sazebník', 'Electric lamps and lighting fittings, of plastics, n.e.s.'),
('94054091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Svítidla elektrická ostatní z jiných materiálů se žárovkami,ne:viz sazebník', 'Electric lamps and lighting fittings, used with filament lamps, n.e.s. (excl. of'),
('94054095', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Svítidla elektrická ostatní z jiných mater.se zářivkovými trubicemi,ne:viz sazebník', 'Electric lamps and lighting fittings, used with tubular fluorescent lamps, n.e.s'),
('94054099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Svítidla elektrická ostatní z jiných materiálů,ne:viz sazebník', 'Electric lamps and lighting fittings, n.e.s. (excl. of plastics)'),
('94055000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Svítidla neelektrická', 'Non-electrical lamps and lighting fittings, n.e.s.'),
('94056020', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Reklamy,znaky,ukazatele a podobné světelné výrobky z plastů', 'Illuminated signs, illuminated nameplates and the like, with a permanently fixed'),
('94056080', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Reklamy,znaky,ukazatele a podobné světelné výrobky,ne:z plastů', 'Illuminated signs, illuminated nameplates and the like, with a permanently fixed'),
('94059111', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sklo fasetové,ověsy apod.ozdoby skleněné pro lustry ověskové elektrické', 'Facetted glass, plates, balls, pear-shaped drops, flower-shaped pieces, pendants'),
('94059119', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části ze skla pro svítidla elektrická ost.(např.stínidla,koule,misky apod.)', 'Diffusers, ceiling lights, bowls, cups, lamp shades, globes, tulip-shaped pieces'),
('94059190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části skleněné pro světelné reklamy,znaky,ukazatele apod.', 'Parts of lamps and lighting fittings, illuminated signs and nameplates and the l'),
('94059200', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části el.svítidel,reklam a jiných světelných výrobků z plastů', 'Parts of lamps and lighting fittings, illuminated signs and nameplates and the l'),
('94059900', 2006, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části el.svítidel,reklam a jiných světelných výrobků z ost.materiálů,ne:viz sazebník', 'Parts of lamps and lighting fittings, illuminated signs and nameplates and the l'),
('94060011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pojízdná obydlí', 'Mobile homes'),
('94060020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Montované stavby ze dřeva', 'Prefabricated buildings made entirely or mainly of wood, whether or not complete'),
('94060031', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Skleníky ze železa,oceli', 'Greenhouses, prefabricated, whether or not complete or already assembled, made e'),
('94060038', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní montované stavby ze železa a oceli', 'Buildings, prefabricated, whether or not complete or already assembled, made ent'),
('94060080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stavby montované z jiných materiálů než dřevo, železo a ocel', 'Prefabricated buildings, whether or not complete or already assembled (excl. mob'),
('95030010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tříkolky,koloběžky,šlapací auta ap.vozidla,vozítka jako hračky;kočárky pro panenky', 'Tricycles, scooters, pedal cars and similar wheeled toys, and dolls'' carriages'),
('95030021', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Panenky,loutky představující pouze lidské bytosti', 'Dolls representing only human beings, whether or not clothed'),
('95030029', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti,příslušenství k panenkám,loutkám představujícím pouze lidské bytosti', 'Parts and accessories for dolls representing only human beings, n.e.s.'),
('95030030', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vláčky elektrické,vč.kolejnic,signal.zař.apod.,modely zmenš.k sestavování', 'Electric trains, incl. tracks, signals and other accessories therefor; reduced-s'),
('95030035', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sady stavebnic,hračky stavební ostatní,z plastů,ne:el.vláčky,modely zmenš.k sestavování', 'Construction sets and constructional toys, of plastics (excl. scale model assemb'),
('95030039', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sady stavebnic,hračky stavební ostatní,ost.,ne:z plastů,el.vláčky,modely zmenš.k sestavování', 'Construction sets and constructional toys (excl. of plastic and scale model asse'),
('95030041', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hračky představující zvířata apod.,vycpané,ne:představující lidské bytosti', 'Stuffed toys representing animals or non-human creatures'),
('95030049', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hračky představující zvířata apod.,ostatní,ne:vycpané,představující lidské bytosti', 'Toys representing animals or non-human creatures (excl. stuffed)'),
('95030055', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hračky - nástroje,přístroje hudební', 'Toy musical instruments and apparatus'),
('95030061', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hračky - skládanky ze dřeva', 'Wooden puzzles'),
('95030069', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hračky - skládanky z jiných materiálů než ze dřeva', 'Puzzles (excl. of wood)'),
('95030070', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hračky ostatní tvořící soupravy,sbírky', 'Toys, put up in sets or outfits (excl. electric trains, incl. accessories, scale'),
('95030075', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hračky,modely ostatní s vestavěným motorem,z plastů', 'Plastic toys and models, incorporating a motor (excl. electric trains, scale mod'),
('95030079', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hračky,modely ostatní s vestavěným motorem,z jiných materiálů než z plastů', 'Toys and models, incorporating a motor (excl. plastic, electric trains, scale mo'),
('95030081', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hračky - zbraně', 'Toy weapons'),
('95030085', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Modely miniaturní z kovů lité pod tlakem', 'Die-cast metal miniature models'),
('95030095', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hračky ostatní z plastů,ne:viz sazebník', 'Plastic toys, n.e.s.'),
('95030099', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hračky ostatní z jiných materiálů než z plastů,ne:viz sazebník', 'Toys, n.e.s.'),
('95041000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Videohry pro přijímače televizní', 'Video games for use with a television receiver'),
('95042010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Stoly kulečníkové', 'Billiard tables'),
('95042090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Příslušenství kulečníku,ne:stoly', 'Billiards of all kinds and accessories (excl. tables)'),
('95043010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Hry s obrazovkou na mince,známky', 'Games with screen, operated by coins, banknotes, bank cards, tokens or by other'),
('95043030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Flipper (mechanická hra) na mince,známky', 'Flipper operated by coins, banknotes, bank cards, tokens or by other means of pa'),
('95043050', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Hry na mince,známky ostatní,ne:s obrazovkou,flipper,zař.pro automat.kuželník', 'Games without screen, operated by coins, banknotes, bank cards, tokens or by oth'),
('95043090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti her na mince,známky', 'Parts of games, operated by coins, banknotes, bank cards, tokens or by other mea'),
('95044000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Karty hrací', 'Playing cards'),
('95049010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sady autíček elektrických závodních,které mají povahu soutěžní hry', 'Electric car racing sets, having the character of competitive games'),
('95049090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Potřeby pro herny,lunaparkové,společenské hry ostatní,ne:viz sazebník', 'Tables for casino games, automatic bowling alley equipment, and other funfair, t'),
('95051010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky vánoční ze skla', 'Christmas articles, of glass (excl. electric lighting sets)'),
('95051090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky vánoční z ostatních materiálů,ne:ze skla', 'Christmas articles (excl. of glass, candles and electric lighting sets, natural'),
('95059000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky pro slavnosti,karnevaly apod.,kouzelnické rekvizity,žertovné předměty', 'Festival, carnival or other entertainment articles, incl. conjuring tricks and n'),
('95061110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Lyže (sněhové)-běžky', 'Cross-country skis'),
('95061121', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Lyže (sněhové) sjezdové-monoski a snowboardy', 'Monoskis and snowboards'),
('95061129', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Lyže a lyžařské potřeby ostatní,ne:viz sazebník', 'Downhill skis (excl. monoskis and snowboards)'),
('95061180', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Lyže (sněhové) ostatní,ne:sjezdové,běžky', 'Skis for ski-jumping'),
('95061200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vázání na lyže sněhové', 'Ski bindings'),
('95061900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lyžařské potřeby na sníh ostatní,ne:lyže,vázání', 'Ski equipment for winter sports (other than skis and ski-fastenings [ski-binding'),
('95062100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Windsurfing', 'Sailboards'),
('95062900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Lyže vodní,saně vodní,potřeby ost.pro vodní sporty,ne:windsurfing', 'Water-skis, surfboards and other water-sport equipment (other than sailboards)'),
('95063100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Hole golfové-úplné sady', 'Golf clubs, complete'),
('95063200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Míčky golfové', 'Golf balls'),
('95063910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části holí golfových', 'Parts of golf clubs'),
('95063990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Potřeby pro golf ostatní,ne:úplné sady holí,části holí,míčky', 'Golf equipment (excl. balls, clubs and parts thereof)'),
('95064010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pálky,míčky,síťky pro stolní tenis', 'Bats, balls and nets for table-tennis'),
('95064090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky,potřeby ostatní pro stolní tenis,ne:pálky,míčky,síťky', 'Articles and equipment for table-tennis (excl. bats, balls and nets)'),
('95065100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rakety tenisové i bez výpletu', 'Tennis rackets, whether or not strung (excl. table-tennis bats)'),
('95065900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rakety badmintonové apod.i bez výpletu,ne:tenisové', 'Badminton and similar rackets, whether or not strung (other than tennis rackets'),
('95066100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Míčky tenisové,ne:pro stolní tenis', 'Tennis balls (excl. table tennis balls)'),
('95066210', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Míče,míčky nafukovací z kůže', 'Inflatable leather balls'),
('95066290', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Míče,míčky nafukovací z ostatních materiálů,ne:z kůže', 'Inflatable balls (excl. of leather)'),
('95066910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Míčky kriketové,míče pro pólo', 'Cricket and polo balls'),
('95066990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Míče,míčky ostatní pro sport,ne:golf,tenis i stolní,nafukovací,kriketové,pólo', 'Balls (excl. inflatable, golf, table-tennis, tennis, cricket and polo balls)'),
('95067010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Brusle včetně obuvi ke které jsou připevněny,ne:kolečkové', 'Ice skates, incl. skating boots with skates attached'),
('95067030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'NPR'), 'Brusle kolečkové včetně obuvi ke které jsou připevněny', 'Roller skates, incl. skating boots with rollers attached'),
('95067090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,příslušenství bruslí i kolečkových', 'Parts and accessories for ice skates and roller skates, n.e.s.'),
('95069110', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zařízení pro tělesné cvičení s mechanismem pro nastavení odporu', 'Exercising apparatus with adjustable resistance mechanisms'),
('95069190', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Výrobky,potřeby pro těles.cvičení, gymnastiku,atletiku ost.,ne:s mechan.pro nastavení odporu', 'Articles and equipment for general physical exercise, gymnastics or athletics (e'),
('95069910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vybavení pro kriket,pólo,ne:míče', 'Cricket and polo equipment (excl. balls)'),
('95069990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Potřeby pro sport,hry pod širým nebem ostatní,ne:viz sazebník', 'Articles and equipment for sport and outdoor games n.e.s; swimming and paddling'),
('95071000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pruty rybářské', 'Fishing rods'),
('95072010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Háčky rybářské nenavázané', 'Fish-hooks, whether or not snelled, unmounted'),
('95072090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Udice i navázané na nástavce,ne:háčky nenavázané', 'Fish-hooks, whether or not snelled, mounted'),
('95073000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Navijáky rybářské', 'Fishing reels'),
('95079000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Potřeby rybářské,lovecké ostatní,ne:viz sazebník', 'Line fishing tackle n.e.s; fish landing nets, butterfly nets and similar nets; d'),
('95081000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kočovné cirkusy a kočovné zvěřince', 'Travelling circuses and travelling menageries'),
('95089000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kolotoče,houpačky,střelnice a ost.pouťové atrakce, divadla,ne:zvěřince, cirkusy', 'Roundabouts, swings, shooting galleries and other fairground amusements; travell'),
('96011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Slonovina opracovaná,výrobky ze slonoviny', 'Worked ivory and articles of ivory, n.e.s.'),
('96019010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Korál přírodní,rekonstituovaný,výrobky z nich', 'Worked coral, natural or agglomerated, and articles of coral, n.e.s.'),
('96019090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Želvovina,perleť,kost a jiný materiál živočišný řezbářský,výrobky z nich', 'Worked bone, tortoiseshell, horn, antlers, mother-of-pearl and other animal carv'),
('96020000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Materiály rostlinné,nerostné řezbářské opracované,výrobky z nich', 'Worked vegetable or mineral carving material and articles of these materials n.e'),
('96031000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Košťata,smetáčky z materiálů rostlinných svázaných ve svazcích i s násadou', 'Brooms and brushes, consisting of twigs or other vegetable materials bound toget'),
('96032100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kartáčky na zuby vč.kartáčků na zubní protézy', 'Tooth brushes, incl. dental-plate brushes'),
('96032930', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kartáče na vlasy', 'Hair brushes'),
('96032980', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kartáče pro toaletní potřeby ostatní,ne:kartášky na zuby,na vlasy', 'Shaving brushes, nail brushes, eyelash brushes and other brushes for use on the'),
('96033010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Štětce,kartáče pro umělce,štětce k psaní', 'Artists'' and writing brushes'),
('96033090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Štětce k nanášení kosmetických výrobků', 'Brushes for the application of cosmetics'),
('96034010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Kartáče,štětce malířské,natěračské,lakovací apod.', 'Paint, distemper, varnish or similar brushes (excl. artists'' and similar brushe'),
('96034090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Podložky (polštářky),válečky malířské', 'Paint pads and rollers'),
('96035000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kartáče tvořící součást strojů,přístrojů,vozidel', 'Brushes constituting parts of machines, appliances or vehicles'),
('96039010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Košťata ruční mechanická,ne:s motorem', 'Hand-operated mechanical floor sweepers, not motorised'),
('96039091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Kartáče i zametací pro domácnost,ulici,na oděvy,boty,hřebelcování,mytí zvířat', 'Road-sweeping brushes; household type brooms and brushes, incl. shoe brushes and'),
('96039099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zboží kartáčnické ostatní,ne:viz sazebník', 'Mops and leather dusters; prepared knots and tufts for broom or brush making; sq'),
('96040000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Síta,řešeta ruční', 'Hand sieves and hand riddles (excl. colanders)'),
('96050000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Soupravy cestovní pro toaletu,šití,čištění obuvi,oděvů', 'Travel sets for personal toilet, sewing or shoe or clothes cleaning (excl. manic'),
('96061000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Knoflíky stiskací,jejich části,součásti', 'Press-fasteners, snap-fasteners and press studs and parts therefor'),
('96062100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Knoflíky z plastů nepotažené materiály textilními', 'Buttons of plastics, not covered with textile material (excl. press-fasteners, s'),
('96062200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Knoflíky z kovů obecných nepotažené materiály textilními', 'Buttons of base metal, not covered with textile material (excl. press-fasteners,'),
('96062900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Knoflíky ostatní,ne:z kovu nebo plastu nepotažené textilními materiály', 'Buttons (excl. of plastics or base metal, not covered with textile material, pre'),
('96063000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Formy na knoflíky,jejich části,součásti,polotovary knoflíkové', 'Button moulds and other parts of buttons; button blanks'),
('96071100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTR'), 'Zdrhovadla s články z obecných kovů', 'Slide fasteners fitted with chain scoops of base metal'),
('96071900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'MTR'), 'Zdrhovadla ostatní,ne:s články z obecných kovů', 'Slide fasteners (excl. fitted with chain scoops of base metal)'),
('96072010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti zdrhovadel z obecných kovů', 'Parts of slide fasteners of base metal'),
('96072090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti zdrhovadel z ostatních materiálů,ne:z obecných kovů', 'Parts of slide fasteners (other than of base metal)'),
('96081010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pera kuličková na tekutý inkoust', 'Ball-point pens with liquid ink'),
('96081030', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pera kuličková,tělo,klobouček z drahých kovů,plátované,potažené drahými kovy', 'Ball-point pens with body or cap of precious metal or rolled precious metal (exc'),
('96081091', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pera kuličková ostatní,ne:na tekutý inkoust,s vyměnitel.náplní,z drahých kovů', 'Ball-point pens with replaceable refill (excl. with body or cap of precious meta'),
('96081099', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pera kuličková ostatní,ne:na tekutý inkoust,s vyměnitel.náplní,z drahých kovů', 'Ball-point pens (excl. with replaceable refill, and with liquid ink)'),
('96082000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Popisovače,značkovače,zvýrazňovače s plstěným,jiným pórovitým hrotem', 'Felt-tipped and other porous-tipped pens and markers'),
('96083100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pera plnicí s perem k rýsování tuší', 'Indian ink drawing pens'),
('96083910', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pera plnicí s perem,tělo,klobouček z drahých kovů,plátované,potažené drahými kovy', 'Fountain pens, stylograph pens and other pens, with body or cap of precious meta'),
('96083990', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Pera plnicí ostatní,ne:na tuš,z drahých kovů i plátované,potažené drahými kovy', 'Fountain pens, stylograph pens and other pens (excl. with body or cap of preciou'),
('96084000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Tužky patentní', 'Propelling or sliding pencils'),
('96085000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Soupravy minim.dvou výrobků z:per plnicích,kuličkových,tužek patentních apod.', 'Sets of articles from two or more of the following: ball-point pens, felt or fib'),
('96086010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Náplně náhradní s tekutým inkoustem do kuličkových per spojené se špičkou', 'Refills for ball-point pens, comprising the ball-point and ink-reservoir, with l'),
('96086090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Náplně náhradní do kuličkových per spojené se špičkou ost.,ne:tekutý inkoust', 'Refills for ball-point pens, comprising the ball-point and ink-reservoir (excl.'),
('96089100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pera psací,špičky pro pera ostatní,ne:kuličková,plnicí', 'Pen nibs and nib points'),
('96089920', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ostatní výrobky typu per,tužek,značkovačů,jejich části,součásti,z kovu', 'Parts of ball point pens, felt-tipped and other porous-tipped pens and markers,'),
('96089980', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Ost. výrobky typu per,tužek,značkovačů,jejich části,součásti,ne:z kovu', 'Parts of ball point pens, felt-tipped and other porous-tipped pens and markers,'),
('96091010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tužky s tuhou z grafitu v pevné pochvě', 'Pencils, with leads of graphite encased in a rigid sheath'),
('96091090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tužky s tuhou ostatní v pevné pochvě,ne:z grafitu', 'Pencils and crayons, with leads encased in a rigid sheath (excl. with leads of g'),
('96092000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tuhy pro tužky i patentní černé i barevné', 'Pencil leads, black or coloured'),
('96099010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pastelky,uhly kreslicí', 'Pastels and drawing charcoals'),
('96099090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pastely,křídy psací,kreslicí,krejčovské apod.', 'Pencils, writing or drawing chalks and tailors'' chalks'),
('96100000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Tabule,tabulky břidlicové k psaní,kreslení i zarámované', 'Slates and boards, with writing or drawing surfaces, whether or not framed'),
('96110000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Razítka i datovací,pečetítka,číslovačky,sázítka,ruční tiskárničky apod.', 'Hand-operated date, sealing or numbering stamps, and the like; hand-operated com'),
('96121010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pásky do psacích strojů apod.barvicí z plastů', 'Typewriter or similar ribbons, inked or otherwise prepared for giving impression'),
('96121020', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pásky do automat.psacích strojů,tiskáren PC z chem.vláken v kazetách,pod 30mm', 'Ribbons made from man-made fibres, of a width of < 30 mm, permanently enclosed i'),
('96121080', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pásky do psacích strojů ostatní,ne:viz sazebník', 'Typewriter or similar ribbons, inked or otherwise prepared for giving impression'),
('96122000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Polštářky razítkové', 'Ink-pads, whether or not inked, with or without boxes'),
('96131000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zapalovače kapesní plynové znovu nenaplnitelné', 'Pocket lighters, gas fuelled, non-refillable'),
('96132010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zapalovače kapesní plynové znovu naplnitelné s elektrickým zapalováním', 'Pocket lighters, gas fuelled, refillable, with electrical ignition system'),
('96132090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'PCE'), 'Zapalovače kapesní plynové znovu naplnitelné se zapalováním ost.,ne:elektrické', 'Pocket lighters, gas fuelled, refillable, with mechanical ignition system'),
('96138000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zapalovače ostatní,ne:kapesní plynové,stolní', 'Lighters (excl. gas fuelled pocket lighters, and fuses and primers for propellen'),
('96139000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části,součásti zapalovačů', 'Parts of lighters, n.e.s.'),
('96140010', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Špalky ze dřeva nebo kořenů pro výrobu dýmek,hrubě tvarované', 'Roughly shaped blocks of wood or root, for the manufacture of pipes'),
('96140090', 2007, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Dýmky,špičky doutník.,cigaret.,části,ne:špalky ze dřeva,kořenů pro výrobu dýmek,hrubě oprac.', 'Smoking pipes, incl. pipe bowls, cigar or cigarette holders, and parts thereof,'),
('96151100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hřebeny,sponky na vlasy,do vlasů z tvrdé pryže,plastů', 'Combs, hair-slides and the like of hard rubber or plastics'),
('96151900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Hřebeny,sponky na vlasy,do vlasů ostatní,ne:z tvrdé pryže,plastů', 'Combs, hair-slides and the like (excl. of hard rubber or plastics)'),
('96159000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Vlásničky,natáčky na vlasy apod.výrobky pro účesy,části,součásti', 'Hairpins, curling pins, curling grips, hair-curlers and the like, and parts ther'),
('96161010', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rozprašovače toaletní', 'Scent sprays and similar toilet sprays (excl. coin or token-operated)'),
('96161090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zařízení rozprašovací,hlavy pro ně', 'Mounts and heads for scent sprays and similar toilet sprays (excl. for coin or t'),
('96162000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Pudrovátka,labutěnky k nanášení přípravků kosmetických,toaletních', 'Powder puffs and pads for the application of cosmetics or toilet preparations'),
('96170011', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Láhve izolační a jiné nádoby vakuové tepelně izolační,obsah nad 0,75 l', 'Vacuum flasks and other vacuum vessels, having a capacity of <= 0,75 l'),
('96170019', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Láhve izolační a jiné nádoby vakuové tepelně izolační,obsah nad 0,75 l', 'Vacuum flasks and other vacuum vessels, having a capacity of > 0,75 l'),
('96170090', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Části lahví izolačních,nádob vakuových,ne:vložky skleněné', 'Parts of vacuum flasks and other vacuum vessels (excl. glass inners)'),
('96180000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Panny,figuríny apod.krejčovské,automaty a oživené scény pro výkladní skříně', 'Tailors'' dummies and other lay figures, automata and other animated displays us'),
('97011000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Obrazy,malby,kresby zhotovené zcela ručně', 'Paintings, e.g. oil paintings, watercolours and pastels, and drawings executed e'),
('97019000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Koláže a podobné obrázky', 'Collages and similar decorative plaques'),
('97020000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Rytiny,tisky,litografie původní', 'Original engravings, prints and lithographs'),
('97030000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Díla původní sochařská,výtvarného modelářství z jakéhokoli materiálu', 'Original sculptures and statuary, in any material'),
('97040000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Známky poštovní,kolky,otisky razítek poštovních apod.(ne)orazítkované-sběratelské', 'Postage or revenue stamps, stamp-postmarks, first-day covers, postal stationery,'),
('97050000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Sbírky,předměty sběratelské pro vědní obory-viz sazebník', 'Collections and collector''s pieces of zoological, botanical, mineralogical, ana'),
('97060000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Starožitnosti starší než 100 let', 'Antiques of > 100 years old'),
('98800100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Zvířata živá', 'INDUSTRY COMPLEX-LIVE ANIMALS'),
('98800200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Maso a droby poživatelné', 'INDUSTRY COMPLEX-MEAT AND EDIBLE MEAT OFFAL'),
('98800300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Ryby, korýši, měkkýši a ostatní vodní bezobratlí', 'INDUSTRY COMPLEX-FISH AND CRUSTACEANS, MOLLUSCS AND OTHER AQUATIC INVERTEBRATES'),
('98800400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Mléko, vejce, med, výrobky jedlé živočišného původu', 'INDUSTRY COMPLEX-DAIRY PRODUCE; BIRDS'' EGGS; NATURAL HONEY; EDIBLE PRODUCTS OF'),
('98800500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Výrobky živočišného původu jinde neuvedené', 'INDUSTRY COMPLEX-PRODUCTS OF ANIMAL ORIGIN, NOT ELSEWHERE SPECIFIED OR INCLUDED'),
('98800600', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Rostliny živé a výrobky květinářské', 'INDUSTRY COMPLEX-LIVE TREES AND OTHER PLANTS; BULBS, ROOTS AND THE LIKE; CUT FLO'),
('98800700', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Zelenina, rostliny, hlízy, kořeny, poživatelné', 'INDUSTRY COMPLEX-EDIBLE VEGETABLES AND CERTAIN ROOTS AND TUBERS'),
('98800800', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Ovoce, ořechy, jedlé slupky citrusových plodů, melounů', 'INDUSTRY COMPLEX-EDIBLE FRUIT AND NUTS; PEEL OF CITRUS FRUIT OR MELONS'),
('98800900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Káva, čaj, maté, koření', 'INDUSTRY COMPLEX-COFFEE, TEA, MATĂo/oo AND SPICES'),
('98801000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Obilí', 'INDUSTRY COMPLEX-CEREALS'),
('98801100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Výrobky mlýnské, slad, škroby, inulin, lepek pšeničný', 'INDUSTRY COMPLEX-PRODUCTS OF THE MILLING INDUSTRY; MALT; STARCHES; INULIN; WHEAT'),
('98801200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Semena, plody, rostliny léčivé, průmyslové, sláma apod.', 'INDUSTRY COMPLEX-OIL SEEDS AND OLEAGINOUS FRUITS; MISCELLANEOUS GRAINS, SEEDS AN'),
('98801300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Šelak, gumy, pryskyřice a jiné štávy, výtažky rostlinné', 'INDUSTRY COMPLEX-LAC; GUMS, RESINS AND OTHER VEGETABLE SAPS AND EXTRACTS'),
('98801400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Materiály rostlinné pletací a jiné výrobky rostlinné', 'INDUSTRY COMPLEX-VEGETABLE PLAITING MATERIALS; VEGETABLE PRODUCTS NOT ELSEWHERE'),
('98801500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Tuky a oleje živočišné nebo rostlinné, pokrmové vosky', 'INDUSTRY COMPLEX-ANIMAL OR VEGETABLE FATS AND OILS AND THEIR CLEAVAGE PRODUCTS;'),
('98801600', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Přípravky z masa, ryb, korýšů a jiných vodních bezobratlých', 'INDUSTRY COMPLEX-PREPARATIONS OF MEAT, OF FISH OR OF CRUSTACEANS, MOLLUSCS OR OT'),
('98801700', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Cukr a cukrovinky', 'INDUSTRY COMPLEX-SUGARS AND SUGAR CONFECTIONERY'),
('98801800', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Kakao a přípravky kakaové', 'INDUSTRY COMPLEX-COCOA AND COCOA PREPARATIONS'),
('98801900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Přípravky z obilovin, mouky, škrobu nebo mléka, pečivo', 'INDUSTRY COMPLEX-PREPARATIONS OF CEREALS, FLOUR, STARCH OR MILK; PASTRYCOOKS'' P'),
('98802000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Přípravky ze zeleniny, ovoce, ořechů', 'INDUSTRY COMPLEX-PREPARATIONS OF VEGETABLES, FRUIT, NUTS OR OTHER PARTS OF PLANT'),
('98802100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Přípravky potravinové různé', 'INDUSTRY COMPLEX-MISCELLANEOUS EDIBLE PREPARATIONS'),
('98802200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Nápoje, tekutiny lihové, ocet', 'INDUSTRY COMPLEX-BEVERAGES, SPIRITS AND VINEGAR'),
('98802300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Zbytky a odpady v potravinářském průmyslu, krmivo', 'INDUSTRY COMPLEX-RESIDUES AND WASTE FROM THE FOOD INDUSTRIES; PREPARED ANIMAL FO'),
('98802400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Tabák, náhražky tabákové vyrobené', 'INDUSTRY COMPLEX-TOBACCO AND MANUFACTURED TOBACCO SUBSTITUTES'),
('98802500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Sůl, síra, zeminy a kameny, sádra, vápno, cement', 'INDUSTRY COMPLEX-SALT; SULPHUR; EARTHS AND STONE; PLASTERING MATERIALS, LIME AND'),
('98802600', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Rudy kovů, strusky, popely', 'INDUSTRY COMPLEX-ORES, SLAG AND ASH'),
('98802700', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Paliva, oleje a výrobky z nich, látky živičné, vosk', 'INDUSTRY COMPLEX-MINERAL FUELS, MINERAL OILS AND PRODUCTS OF THEIR DISTILLATION;'),
('98802800', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Výrobky chemické, sloučeniny kovů, zemin, prvků', 'INDUSTRY COMPLEX-INORGANIC CHEMICALS; ORGANIC OR INORGANIC COMPOUNDS OF PRECIOUS'),
('98802900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Výrobky chemické organické', 'INDUSTRY COMPLEX-ORGANIC CHEMICALS'),
('98803000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Výrobky farmaceutické', 'INDUSTRY COMPLEX-PHARMACEUTICAL PRODUCTS'),
('98803100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Hnojiva', 'INDUSTRY COMPLEX-FERTILISERS'),
('98803200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Výtažky, taniny, barvy, pigmenty, laky, tmely apod.', 'INDUSTRY COMPLEX-TANNING OR DYEING EXTRACTS; TANNINS AND THEIR DERIVATIVES; DYES'),
('98803300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Silice, pryskyřice, přípravky kosmetické nebo toaletní apod.', 'INDUSTRY COMPLEX-ESSENTIAL OILS AND RESINOIDS; PERFUMERY, COSMETIC OR TOILET PRE'),
('98803400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Mýdlo, přípravky prací, mazací, lešticí aj., vosk', 'INDUSTRY COMPLEX-SOAP, ORGANIC SURFACE-ACTIVE AGENTS, WASHING PREPARATIONS, LUBR'),
('98803500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Látky albuminoidní, škroby, klihy, enzymy', 'INDUSTRY COMPLEX-ALBUMINOIDAL SUBSTANCES; MODIFIED STARCHES; GLUES; ENZYMES'),
('98803600', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Výbušniny, výrobky pyrotechnické, zápalky apod.', 'INDUSTRY COMPLEX-EXPLOSIVES; PYROTECHNIC PRODUCTS; MATCHES; PYROPHORIC ALLOYS; C'),
('98803700', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Výrobky fotografické a kinematografické', 'INDUSTRY COMPLEX-PHOTOGRAPHIC OR CINEMATOGRAPHIC GOODS'),
('98803800', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Výrobky chemické různé', 'INDUSTRY COMPLEX-MISCELLANEOUS CHEMICAL PRODUCTS'),
('98803900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Plasty a výrobky z nich', 'INDUSTRY COMPLEX-PLASTICS AND ARTICLES THEREOF'),
('98804000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Kaučuk a výrobky z něj', 'INDUSTRY COMPLEX-RUBBER AND ARTICLES THEREOF'),
('98804100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Kůže surové a kožky (jiné než kožešiny) a usně', 'INDUSTRY COMPLEX-RAW HIDES AND SKINS (OTHER THAN FURSKINS) AND LEATHER'),
('98804200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Výrobky kožené, sedlářské, řemenářské apod.', 'INDUSTRY COMPLEX-ARTICLES OF LEATHER; SADDLERY AND HARNESS; TRAVEL GOODS, HANDBA'),
('98804300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Kožešiny, umělé kožešiny, výrobky z nich', 'INDUSTRY COMPLEX-FURSKINS AND ARTIFICIAL FUR; MANUFACTURES THEREOF'),
('98804400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Dřevo, uhlí dřevěné, výrobky dřevěné', 'INDUSTRY COMPLEX-WOOD AND ARTICLES OF WOOD; WOOD CHARCOAL'),
('98804500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Korek, výrobky korkové', 'INDUSTRY COMPLEX-CORK AND ARTICLES OF CORK'),
('98804600', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Výrobky ze slámy a jiných materiálů, výrobky košíkářské', 'INDUSTRY COMPLEX-MANUFACTURES OF STRAW, OF ESPARTO OR OF OTHER PLAITING MATERIAL'),
('98804700', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Vláknina ze dřeva aj., odpady z papíru, lepenky', 'INDUSTRY COMPLEX-PULP OF WOOD OR OF OTHER FIBROUS CELLULOSIC MATERIAL; RECOVERED'),
('98804800', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Papír, karton, lepenka a výrobky z nich', 'INDUSTRY COMPLEX-PAPER AND PAPERBOARD; ARTICLES OF PAPER PULP, OF PAPER OR OF PA'),
('98804900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Knihy, noviny, obrazy a jiné výrobky polygrafické tištěné', 'INDUSTRY COMPLEX-PRINTED BOOKS, NEWSPAPERS, PICTURES AND OTHER PRODUCTS OF THE P'),
('98805000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Hedvábí přírodní', 'INDUSTRY COMPLEX-SILK'),
('98805100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Vlna, chlupy zvířecí, příze a tkaniny žíněné', 'INDUSTRY COMPLEX-WOOL, FINE OR COARSE ANIMAL HAIR; HORSEHAIR YARN AND WOVEN FABR'),
('98805200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Bavlna', 'INDUSTRY COMPLEX-COTTON'),
('98805300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Vlákna textilní rostlinná jiná, příze papírové', 'INDUSTRY COMPLEX-OTHER VEGETABLE TEXTILE FIBRES; PAPER YARN AND WOVEN FABRICS OF'),
('98805400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Hedvábí chemické (syntetické nebo umělé)', 'INDUSTRY COMPLEX-MAN-MADE FILAMENTS; STRIP AND THE LIKE OF MAN-MADE TEXTILE MATE'),
('98805500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Vlákna střižová chemická (syntetická nebo umělá)', 'INDUSTRY COMPLEX-MAN-MADE STAPLE FIBRES'),
('98805600', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Vata, plsť, textilie netkané, lana, provazy apod.', 'INDUSTRY COMPLEX-WADDING, FELT AND NONWOVENS; SPECIAL YARNS; TWINE, CORDAGE, ROP'),
('98805700', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Koberce a jiné krytiny podlahové textilní', 'INDUSTRY COMPLEX-CARPETS AND OTHER TEXTILE FLOOR COVERINGS'),
('98805800', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Tkaniny speciální, textilie všívané, krajky apod.', 'INDUSTRY COMPLEX-SPECIAL WOVEN FABRICS; TUFTED TEXTILE FABRICS; LACE; TAPESTRIES'),
('98805900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Textilie impregnované, natřené, povlečené apod.', 'INDUSTRY COMPLEX-IMPREGNATED, COATED, COVERED OR LAMINATED TEXTILE FABRICS; TEXT'),
('98806000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Textilie pletené nebo háčkované', 'INDUSTRY COMPLEX-KNITTED OR CROCHETED FABRICS'),
('98806100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Oděvy a doplňky oděvní pletené, háčkované', 'INDUSTRY COMPLEX-ARTICLES OF APPAREL AND CLOTHING ACCESSORIES, KNITTED OR CROCHE'),
('98806200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Oděvy a doplňky oděvní jiné než pletené, háčkované', 'INDUSTRY COMPLEX-ARTICLES OF APPAREL AND CLOTHING ACCESSORIES, NOT KNITTED OR CR'),
('98806300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Výrobky textilní jiné, oděvy obnošené, hadry', 'INDUSTRY COMPLEX-OTHER MADE-UP TEXTILE ARTICLES; SETS; WORN CLOTHING AND WORN TE'),
('98806400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Obuv, kamaše a podobné výrobky, části těchto výrobků', 'INDUSTRY COMPLEX-FOOTWEAR, GAITERS AND THE LIKE; PARTS OF SUCH ARTICLES'),
('98806500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Pokrývky hlavy a jejich součásti', 'INDUSTRY COMPLEX-HEADGEAR AND PARTS THEREOF'),
('98806600', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Deštníky, slunečníky, hole, biče a jejich části a součásti', 'INDUSTRY COMPLEX-UMBRELLAS, SUN UMBRELLAS, WALKING STICKS, SEAT-STICKS, WHIPS, R'),
('98806700', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Péra, peří, květiny umělé, výrobky z lidských vlasů', 'INDUSTRY COMPLEX-PREPARED FEATHERS AND DOWN AND ARTICLES MADE OF FEATHERS OR OF'),
('98806800', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Výrobky z kamene, sádry, cementu, osinku, slídy', 'INDUSTRY COMPLEX-ARTICLES OF STONE, PLASTER, CEMENT, ASBESTOS, MICA OR SIMILAR M'),
('98806900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Výrobky keramické', 'INDUSTRY COMPLEX-CERAMIC PRODUCTS'),
('98807000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Sklo a výrobky skleněné', 'INDUSTRY COMPLEX-GLASS AND GLASSWARE'),
('98807100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Perly, drahokamy, drahé kovy a výrobky z nich, bižuterie', 'INDUSTRY COMPLEX-NATURAL OR CULTURED PEARLS, PRECIOUS OR SEMI-PRECIOUS STONES, P'),
('98807200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Železo a ocel', 'INDUSTRY COMPLEX-IRON AND STEEL'),
('98807300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Výrobky ze železa nebo oceli', 'INDUSTRY COMPLEX-ARTICLES OF IRON OR STEEL'),
('98807400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Měď a výrobky z mědi', 'INDUSTRY COMPLEX-COPPER AND ARTICLES THEREOF'),
('98807500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Nikl a výrobky z niklu', 'INDUSTRY COMPLEX-NICKEL AND ARTICLES THEREOF'),
('98807600', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Hliník a výrobky z hliníku', 'INDUSTRY COMPLEX-ALUMINIUM AND ARTICLES THEREOF'),
('98807700', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Určeno pro případnou budoucí potřebu Harmonizovaného systému', 'INDUSTRY COMPLEX-RESERVED FOR FUTURE NEEDS OF HS'),
('98807800', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Olovo a výrobky z olova', 'INDUSTRY COMPLEX-LEAD AND ARTICLES THEREOF'),
('98807900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Zinek a výrobky ze zinku', 'INDUSTRY COMPLEX-ZINC AND ARTICLES THEREOF'),
('98808000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Cín a výrobky z cínu', 'INDUSTRY COMPLEX-TIN AND ARTICLES THEREOF'),
('98808100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Kovy obecné ostatní, cermety, výrobky z nich', 'INDUSTRY COMPLEX-OTHER BASE METALS; CERMETS; ARTICLES THEREOF'),
('98808200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Nástroje, náčiní, výrobky nožířské, z kovů obecných', 'INDUSTRY COMPLEX-TOOLS, IMPLEMENTS, CUTLERY, SPOONS AND FORKS, OF BASE METAL; PA'),
('98808300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Výrobky různé z kovů obecných', 'INDUSTRY COMPLEX-MISCELLANEOUS ARTICLES OF BASE METAL'),
('98808400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Reaktory, kotle, stroje, zařízení mechanická', 'INDUSTRY COMPLEX-NUCLEAR REACTORS, BOILERS, MACHINERY AND MECHANICAL APPLIANCES;'),
('98808500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Stroje a přístroje el., přístroje pro záznam a reprodukci zvuku, TV obrazu', 'INDUSTRY COMPLEX-ELECTRICAL MACHINERY AND EQUIPMENT AND PARTS THEREOF; SOUND REC'),
('98808600', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Lokomotivy, vozidla kolejová, zařízení dopravní mechanická', 'INDUSTRY COMPLEX-RAILWAY OR TRAMWAY LOCOMOTIVES, ROLLING STOCK AND PARTS THEREOF'),
('98808700', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Vozidla motorová, traktory, kola a jiná vozidla', 'INDUSTRY COMPLEX-VEHICLES OTHER THAN RAILWAY OR TRAMWAY ROLLING STOCK, AND PARTS'),
('98808800', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Letadla, kosmické lodě, jejich části a součásti', 'INDUSTRY COMPLEX-AIRCRAFT, SPACECRAFT, AND PARTS THEREOF'),
('98808900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Plavidla námořní a říční', 'INDUSTRY COMPLEX-SHIPS, BOATS AND FLOATING STRUCTURES'),
('98809000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Přístroje optické, fotografické, kinematografické, měřicí, kontrolní, lékařské, chirurg', 'INDUSTRY COMPLEX-OPTICAL, PHOTOGRAPHIC, CINEMATOGRAPHIC, MEASURING, CHECKING, PR'),
('98809100', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Hodiny, hodinky a jejich části', 'INDUSTRY COMPLEX-CLOCKS AND WATCHES AND PARTS THEREOF'),
('98809200', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Nástroje hudební a jejich části, součásti a příslušenství', 'INDUSTRY COMPLEX-MUSICAL INSTRUMENTS; PARTS AND ACCESSORIES OF SUCH ARTICLES'),
('98809300', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Zbraně a střelivo a jejich části, součásti a příslušenství', 'INDUSTRY COMPLEX-ARMS AND AMMUNITION; PARTS AND ACCESSORIES THEREOF'),
('98809400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Nábytek, lůžkoviny, svítidla, stavby montované', 'INDUSTRY COMPLEX-FURNITURE; BEDDING, MATTRESSES, MATTRESS SUPPORTS, CUSHIONS AND'),
('98809500', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Hračky, hry, potřeby sportovní', 'INDUSTRY COMPLEX-TOYS, GAMES AND SPORTS REQUISITES; PARTS AND ACCESSORIES THEREO'),
('98809600', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Výrobky různé', 'INDUSTRY COMPLEX-MISCELLANEOUS MANUFACTURED ARTICLES'),
('98809700', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Díla umělecká, předměty sběratelské, starožitnosti', 'INDUSTRY COMPLEX-WORKS OF ART, COLLECTORS'' PIECES AND ANTIQUES'),
('98809900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'IC - Nezatříděno dle druhu (jen za r. 1986-1990)', 'not available'),
('99302400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zboží do letadel a lodí z kapitol 1 - 24 kombinované nomenklatury', 'Material for airplanes and ships, chapter 1-24'),
('99302700', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zboží do letadel a lodí z kapitoly 27 kombinované nomenklatury', 'Material for airplanes and ships, chapter 27'),
('99309900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zboží do letadel a lodí zařazené jinde', 'Material for airplanes and ships, ordered elsewhere'),
('99312400', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zboží do zařízení na moři z kapitol 1 - 24 kombinované nomenklatury', 'Equipments in the open sea, chapter 1-24'),
('99312700', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zboží do zařízení na moři z kapitoly 27 kombinované nomenklatury', 'Equipments in the open sea, chapter 27'),
('99319900', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zboží do zařízení na moři zařazené jinde', 'Equipments in the open sea, ordered elsewhere'),
('99500000', 2005, 2999, (select idintrmerjed from iintrmerjed where kod = 'ZZZ'), 'Zásilky malé hodnoty', 'Consignments of small value');

INSERT INTO iobchtrans(kod, nazev, platiod, platido, nazeva)
 VALUES
('1', 'Obchod s převodem vlastnictví a protiplněním (ne 2, 7, 8)', 2005, 2008, 'Transactions involving actual or intended transfer of ownership against compensation (financial or otherwise) (except the transactions listed under 2, 7 and 8)'),
('11', 'Přímý prodej nebo nákup za protiplnění', 2009, 2999, 'Outright purchase or sale against compensation'),
('12', '"Prodej nebo nákup s vyzkoušením, schválením; zprostředkovaný  "', 2009, 2999, 'Supply on approval, after trial, with intermediation of a commission agent'),
('13', 'Výměnný obchod (např. barterový)', 2009, 2999, 'Barter trade (compensation in kind)'),
('14', 'Prodej nebo nákup s neplátci DPH', 2009, 2999, 'Purchase and sale - goods by non-taxable person'),
('15', 'Finanční leasing, prodej nebo nákup na splátky', 2009, 2999, 'Financial leasing (hire-purchase)'),
('2', 'Vrácení zboží a náhrada za dodané zboží', 2005, 2008, 'Return of goods after registration of the original transaction under code 1; replacement of goods free of charge'),
('21', 'Vrácení zboží původně vykázaného pod kódem začínajícím 1', 2009, 2999, 'Return of goods after transaction under code 1x'),
('22', 'Bezúplatná náhrada za vrácené zboží s kódem 21', 2009, 2999, 'Replacement for returned goods (after code 21)'),
('23', 'Bezúplat.náhrada za nevrácené zboží vykázané pod kódem 1', 2009, 2999, 'Replacement (e.g. warranty) for goods not being returned (after code 21)'),
('3', 'Obchod s převodem vlastnictví bez protiplnění', 2005, 2008, 'Others transactions without compensation involving transfer of ownership'),
('31', 'Dodávky v rámci programů EU bez protiplnění (bezúplatné)', 2009, 2999, 'Transaction without compensation under programmes EC'),
('32', 'Dodávky veřejné vládní pomoci bez protiplnění (bezúplatné)', 2009, 2999, 'Transaction without compensation - aid under governmental programmes'),
('33', 'Dodávky osobní a nevládní pomoci bez protiplnění (bezúplatné)', 2009, 2999, 'Transaction without compensation - aid individuals and non-governmental'),
('34', 'Ostatní bezúplatné dodávky s převodem vlastnictví', 2009, 2999, 'Others transactions without compensation involving transfer of ownership'),
('4', 'K aktivnímu a pasivnímu zušlechtění - ne k opravě', 2005, 2008, 'Operations with a view to processing under contract (except those recorded under 7)'),
('40', 'Zboží ke zpracování dle smlouvy (k aktiv. a pasiv.zušlechtění)', 2009, 2999, 'Operations with a view to processing under contract'),
('42', 'Vrácení nezpracovaného zboží určeného k zušlechtění', 2009, 2999, 'Return of goods without processing after transaction under code 40'),
('5', 'Po aktivním a pasivním zušlechtění - ne opravě', 2005, 2008, 'Operations following processing under contract (except those recorded under 7)'),
('50', 'Zpětné přijetí a odeslání zušlechtěného zboží (po kódu 40)', 2009, 2999, 'Operations following processing under contract (after code 40)'),
('52', 'Vrácení zboží obdrženého po zušlechtění (reklamace)', 2009, 2999, 'Return of goods after transaction under code 50'),
('6', '', 2005, 2005, ''),
('7', '', 2005, 2005, ''),
('70', 'Projekty společné obrany a mezivládních výrobních programů', 2009, 2999, 'Defence projects and intergovernmental production programs'),
('8', 'Obchod s investičními celky (na společné faktury)', 2005, 2008, 'Supply of building materials and equipment for works that are part of a general construction or engineering contract'),
('80', 'Dodávky investičních celků na souhrnné faktury', 2009, 2999, 'Not separately invoiced materials and equipment for general construction'),
('82', 'Vrácení zboží původně vykázaného pod kódem 80', 2009, 2999, 'Return of goods after transaction under code 80'),
('83', 'Náhradní zboží za původně vykázané pod kódem 80', 2009, 2999, 'Replacement for goods after registration transaction under code 80'),
('9', 'Ostatní transakce', 2005, 2008, 'Other transactions'),
('91', 'Dovoz/vývoz zboží mimo EU je-li celně propouštěné mimo ČR', 2009, 2999, 'Export + Import - customs proceedings is held outside CZ (in other MS)'),
('92', 'Dodávky vlastního majetku sobě samému', 2009, 2999, 'Dispatches and arrivals of own property'),
('93', 'Prodej nebo nákup mezi provázanými a jinak spojenými osobami', 2009, 2999, 'Purchase and sale when the buyer and seller are related'),
('94', 'Zboží neměnící vlastníka k použití při výrobě nakupovaného zboží', 2009, 2999, 'Goods not changing owner for use in production of sold or bought product'),
('95', 'Třístranný obchod přiznáný k DPH jako přímé pořízení a dodání', 2009, 2999, 'Triangular trade-transport through CZ-VAT as direct trade (no simpl.approach)'),
('96', 'Dočasné dodávky nad 2 roky spojené s náhradou (např.pronájem)', 2009, 2999, 'Temporary use against compensation - longer than 2 years (e.g. hire)'),
('97', 'Dočasné bezúplatné dodávky nad 2 roky (zapůjčení,skladování ap)', 2009, 2999, 'Temporary use without compensation - longer than 2 years (e.g.storage)'),
('99', 'Ostatní transakce neoznačené jinými kódy', 2009, 2999, 'Other transactions');

INSERT INTO izvlpoh(kod, nazev, platiod, platido, nazeva)
 VALUES
('MZ', 'Malé zásilky uvedené pod kódem 99500000', 2005, 2999, 'Small shipments with goods given under code number 99 50 00 00'),
('NN', 'Negativní deklarace', 2005, 2999, 'Negative declaration'),
('ST', 'Běžný typ věty', 2005, 2999, 'Standard record'),
('ZI', 'Průmyslové celky (investiční celky)', 2005, 2999, 'Industrial units (investment units ), if the Czech Statistic Office allows for simplified classification'),
('ZK', 'Kosmické lodi', 2005, 2999, 'Space vehicle'),
('ZL', 'Letadla (převod vlastnictví)', 2005, 2999, 'Airplanes (transfer of ownership)'),
('ZM', 'Mořské produkty', 2005, 2999, 'Sea products'),
('ZO', 'Odpady (s opačným směrem úhrady)', 2005, 2999, 'Waste (with compensation in opposite direction)'),
('ZP', 'Lodě (převod vlastnictví)', 2005, 2999, 'Ships (transfer of ownership)'),
('ZR', 'Rozložené zásilky (zboží v rozebraném stavu)', 2005, 2999, 'Split shipments (goods in split conditions)'),
('ZT', 'Zařízení na moři', 2005, 2999, 'Facility on sea'),
('ZZ', 'Zboží dodávané do lodí a letadel', 2005, 2999, 'Goods delivered into ships and planes');
-- konec ceskeho bloku
  end if; 
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 392, 't');