--------------------------------------------------------------------------------
-- Bug 35500 – [WinStrom] Minimální mzda 8500 od 1.8.2013
--------------------------------------------------------------------------------

create or replace function runupgrade()
    returns void as $$
declare
    stat character varying(10);
    pocet integer;
begin
  select a.uuid into stat from nnastav n  left join utyporg u on u.idtyporg = n.idtyporg left join astaty a on a.idstatu = u.idstatu
    where ((select max(platioddata) from nnastav) is null or (select max(platioddata) from nnastav) = platioddata);
  
  -- kalkulacku aktualizujeme jen pro cechy
  if (stat = 'CZ_CZ') then
-- zacatek ceskeho bloku
-- update slozek
-- ukonceni platnosti kalkulacky
UPDATE pmzdcalchlav SET platido = '2013-07-31' WHERE idmzdcalchlav = 4;

--------------------------------------------------------------------------------
-- Kalkulacka 2013/08
--------------------------------------------------------------------------------
INSERT INTO pmzdcalchlav (idmzdcalchlav, lastupdate, kod, nazev, poznam, popis, show, platiod)
 VALUES (5, '2013-07-30 00:00:00.000', 'ČESKÉ MZDY 2013/08', 'Výpočet mzdy pro rok 2013 od srpna', e'vyřazení nulování zdravotky pro zaměstnání malého rozsahu u \nstandardního pracovního poměru - pořadí 50', e'1-DPP nad 10 000 Kč - sociálka a zdravotka \n2-sleva na poplatníka z 1970 na 2070\n3-sleva na dítě - 1117\n4-sociálka pro 4.', true, '2013-08-01');

-- inicializace
INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
 VALUES (120, '2013-07-30 00:00:00.000', 'SLEVA NA POPLATNÍKA', 'Sleva na poplatníka (podepsal prohlášení k dani)', true, 1, 'mzdCalcZdroj.osoba', 'slevaPoplat', 'procMzd', 'mzdCalcPlatnost.vzdy', 5, 110);
INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
 VALUES (121, '2013-07-30 00:00:00.000', 'PRAC.PRÁVNÍ  PRŮMĚR ', 'Pracovně právní hodinový průměr pro náhradu mzdy za nemoc, dovolenou ', true, 2, 'mzdCalcZdroj.pracPom', 'predHrubPrijem', 'prumNaHodNem', 'mzdCalcPlatnost.vzdy', 5, 172);
INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
 VALUES (122, '2013-07-30 00:00:00.000', 'DOVOLENÁ POČÁTEK', 'Počáteční stav dovolené ', true, 3, 'mzdCalcZdroj.pracPom', 'dovoleneRocne', 'dnyPrac', 'mzdCalcPlatnost.vzdy', 5, 184);
INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
 VALUES (123, '2013-07-30 00:00:00.000', 'SLEVA ZTP/P', 'Sleva - Držitel průkaz ZTP/P', true, 4, 'mzdCalcZdroj.osoba', 'prukazZTP', 'procMzd', 'mzdCalcPlatnost.vzdy', 5, 113);
INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
 VALUES (124, '2013-07-30 00:00:00.000', 'ZDR.ZÁKLAD POČÁTEK', 'Základ pro zdravotního pojištění - hodnota základu z předchozího zaměstnání', true, 5, 'mzdCalcZdroj.osoba', 'minuleZdrav', 'zaklMzd', 'mzdCalcPlatnost.prvniMesic', 5, 198);
INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
 VALUES (125, '2013-07-30 00:00:00.000', 'SOC.ZÁKLAD POČÁTEK', 'Základ pro sociální pojištění - hodnota základu z předchozího zaměstnání', true, 6, 'mzdCalcZdroj.osoba', 'minuleSoc', 'zaklMzd', 'mzdCalcPlatnost.prvniMesic', 5, 196);
INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
 VALUES (126, '2013-07-30 00:00:00.000', 'SLEVA STUDENT', 'Sleva - Student připravující se na budoucí povolání', true, 7, 'mzdCalcZdroj.osoba', 'student', 'procMzd', 'mzdCalcPlatnost.vzdy', 5, 114);
INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
 VALUES (127, '2013-07-30 00:00:00.000', 'ODPOČET ZÁKLADU ZP', 'odpočet pro kryply', true, 8, 'mzdCalcZdroj.osoba', 'snizVymZaklZp', 'procMzd', 'mzdCalcPlatnost.vzdy', 5, 344);
INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
 VALUES (128, '2013-07-30 00:00:00.000', 'SLEVA IN.DŮCH. 1.2. ', 'Sleva na invalidní důchod 1. a 2. stupně', true, 8, 'mzdCalcZdroj.osoba', 'invalCast', 'procMzd', 'mzdCalcPlatnost.vzdy', 5, 111);
INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
 VALUES (129, '2013-07-30 00:00:00.000', 'SLEVA IN.DŮCH.3.', 'Sleva na invalidní důchod 3. stupně', true, 9, 'mzdCalcZdroj.osoba', 'invalPlna', 'procMzd', 'mzdCalcPlatnost.vzdy', 5, 112);
INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, popis, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
 VALUES (130, '2013-07-30 00:00:00.000', '% PŘÍSP.NA PEN.POJ', '% příspěvku firmy na penzijní pojištění zaměstnance', 'Načtení parametru z nastavení', true, 10, 'mzdCalcZdroj.nastaveni', 'mzdPenzPripProc', 'procMzd', 'mzdCalcPlatnost.vzdy', 5, 237);
INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, popis, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
 VALUES (131, '2013-07-30 00:00:00.000', 'DOV. ZA DEN ABSENCE', 'Odečet dovolené za neomluvenou absenci', 'Načtení parametru z nastavení', true, 11, 'mzdCalcZdroj.nastaveni', 'mzdDnuDovolAbs', 'dnyPrac', 'mzdCalcPlatnost.vzdy', 5, 236);
INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
 VALUES (132, '2013-07-30 00:00:00.000', 'DOVOLENÁ NÁROK', 'Nárok na dovolenou v roce', true, 13, 'mzdCalcZdroj.pracPom', 'dovoleneRocne', 'dnyPrac', 'mzdCalcPlatnost.vzdy', 5, 244);
INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
 VALUES (133, '2013-07-30 00:00:00.000', 'SLEVA NA DÍTĚ', 'Sleva na dítě ', true, 14, 'mzdCalcZdroj.osoba', 'odpocetDeti', 'castMzd', 'mzdCalcPlatnost.vzdy', 5, 116);
INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
 VALUES (134, '2013-07-30 00:00:00.000', 'SLEVA NA DÍTĚ ZTP/P', 'Sleva na dítě ZTP/P', true, 14, 'mzdCalcZdroj.osoba', 'odpocetDetiZtp', 'castMzd', 'mzdCalcPlatnost.vzdy', 5, 251);
INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, popis, show, cisrad, zdrojk, polein, poleout, platnostk, zpracdatumk, idmzdcalchlav, idmzdslozout)
 VALUES (135, '2013-07-30 00:00:00.000', 'MĚSÍC POČÁTEK', 'Měsíc počátku pracovního poměru v aktuálním roce - slouží pro výpočet poměrné dovolené - pokud je den v měsíci > 1 bere se následující měsíc', 'inicializace měsíce počátku - slouží k výpočtu poměrné části dovolené', true, 15, 'mzdCalcZdroj.pracPom', 'zacatek', 'dnyKal', 'mzdCalcPlatnost.zacatekPrvniRok', 'mzdCalcZpracDatum.mesicNaslPoc', 5, 340);
INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, popis, show, cisrad, zdrojk, polein, poleout, zpracdatumk, idmzdcalchlav, idmzdslozout)
 VALUES (136, '2013-07-30 00:00:00.000', 'MĚSÍC KONEC', 'Měsíc konce pracovního poměru v aktuálním roce - slouží pro výpočet poměrné dovolené - pokud je den v měsíci > 1 bere se následující měsíc', 'inicializace měsíce konce - slouží k výpočtu poměrné části dovolené', true, 15, 'mzdCalcZdroj.pracPom', 'konecPomeru', 'dnyKal', 'mzdCalcZpracDatum.mesicPredKon', 5, 341);
INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, popis, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
 VALUES (137, '2013-07-30 00:00:00.000', 'NÁHRADA ZA SVÁTEK', 'Náhráda za svátek', '', true, 16, 'mzdCalcZdroj.pracPom', 'svatkyPrumer', 'procMzd', 'mzdCalcPlatnost.vzdy', 5, 21);
INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, popis, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
 VALUES (138, '2013-07-30 00:00:00.000', 'SVÁTEK', 'Svátek', '', true, 17, 'mzdCalcZdroj.pracPom', 'svatkyPrumer', 'procMzd', 'mzdCalcPlatnost.vzdy', 5, 256);
INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
 VALUES (139, '2013-07-30 00:00:00.000', 'UPLATNIT.REF.NÁHRADY', 'Uplatnit refundaci mzdy', true, 18, 'mzdCalcZdroj.nastaveni', 'mzdRefundNahrNemoc', 'procMzd', 'mzdCalcPlatnost.vzdy', 5, 336);
INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
 VALUES (140, '2013-07-30 00:00:00.000', 'JE DŮCHODOVÉ SPOŘENÍ', 'Je účastem důchodového spořeníi', true, 19, 'mzdCalcZdroj.osoba', 'ucastnikDuchSpor', 'procMzd', 'mzdCalcPlatnost.vzdy', 5, 360);
INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
 VALUES (141, '2013-07-30 00:00:00.000', 'STAROBNÍ DŮCHOD', 'Starobní důchod', true, 20, 'mzdCalcZdroj.osoba', 'starobniDuch', 'procMzd', 'mzdCalcPlatnost.vzdy', 5, 148);
INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
 VALUES (142, '2013-07-30 00:00:00.000', 'PŘEDČAS.STAR.DŮCHOD', 'Předčasný starobní důchod', true, 21, 'mzdCalcZdroj.osoba', 'starobniDuch', 'procMzd', 'mzdCalcPlatnost.vzdy', 5, 358);

-- radky
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4000, '2013-07-30 00:00:00.000', 'KOEF. PRO MĚS.MZDU ', '----- Připočtení dnů ve svátek', true, 1, 1.0, 0.0, 0.0, 'dnyPrac;dnyKal;dnySvatek;hodiny;hodinySvatek', '', 'dnyPrac;dnyKal;dnySvatek;hodiny;hodinySvatek', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 1, 188);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4001, '2013-07-30 00:00:00.000', 'KOEF. PRO MĚS.MZDU ', '----- Fond pracovní  doby v aktuálním měsíci', true, 2, 1.0, 1.0, 0.0, 'hodinySvatek;dnySvatek', '', 'hodiny;dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 1, 188);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4002, '2013-07-30 00:00:00.000', 'SVÁTEK', 'Fond pracovní doby', true, 3, 1.0, 0.0, 0.0, 'hodinySvatek;dnySvatek;hodinySvatek;dnySvatek', 'hodiny;dnyPrac;hodinySvatek;dnySvatek', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 1, 256);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4003, '2013-07-30 00:00:00.000', 'PŘED NÁSTUPEM (PRAC)', 'Dny před nástupem (měsíci) do zaměstnání pro výpočet podílu měsíční nebo hodinové mzdy ', true, 4, 1.0, 0.0, 0.0, 'dnyKal;dnyPrac;dnySvatek;hodiny;hodinySvatek', 'dnyKal;dnyPrac;dnySvatek;hodiny;hodinySvatek', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 227, 287);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4004, '2013-07-30 00:00:00.000', '365', '----- počet dní v roce', 'koeficient pro výpočet zbývající dovolené', true, 5, 0.0, 0.0, 365.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'dnyKal', '', 'dnyKal', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 245, 245);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4005, '2013-07-30 00:00:00.000', 'SVÁTEK V NEMOCI', 'Dny před nástupem (měsíci) do zaměstnání pro výpočet podílu měsíční nebo hodinové mzdy ', true, 6, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 287, 343);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4006, '2013-07-30 00:00:00.000', 'PŘED NÁSTUPEM (PRAC)', 'Dny před nástupem (měsíci) do zaměstnání pro výpočet podílu měsíční nebo hodinové mzdy ', true, 7, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek', 'dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 287, 287);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4007, '2013-07-30 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 8, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 3, 343);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4008, '2013-07-30 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 9, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 4, 343);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4009, '2013-07-30 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK...', true, 10, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 7, 343);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4010, '2013-07-30 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 11, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 12, 343);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4011, '2013-07-30 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 12, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 14, 343);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4012, '2013-07-30 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 13, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 150, 343);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4013, '2013-07-30 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 14, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 151, 343);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4014, '2013-07-30 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 15, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 13, 343);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4015, '2013-07-30 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 16, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 15, 343);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4016, '2013-07-30 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 17, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 5, 343);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4017, '2013-07-30 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 18, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 6, 343);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4018, '2013-07-30 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 19, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 152, 343);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4019, '2013-07-30 00:00:00.000', 'SVÁTEK V NEMOCI', 'Vojenské cvičení neplacené', true, 20, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 295, 343);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4020, '2013-07-30 00:00:00.000', 'SVÁTEK V NEMOCI', 'Ostatní překážky v práci neplacené', true, 21, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 296, 343);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4021, '2013-07-30 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 22, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 238, 343);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4022, '2013-07-30 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 23, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 239, 343);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4023, '2013-07-30 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 24, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 240, 343);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4024, '2013-07-30 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 25, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 241, 343);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4025, '2013-07-30 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 26, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 153, 343);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4026, '2013-07-30 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 27, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 9, 343);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4027, '2013-07-30 00:00:00.000', 'SVÁTEK V NEMOCI', 'Školení', true, 28, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 363, 343);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4028, '2013-07-30 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 29, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 10, 343);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4029, '2013-07-30 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 30, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 11, 343);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4030, '2013-07-30 00:00:00.000', 'SVÁTEK', 'svátek sumovaná z nemoci', 'do hodinySvatek nekopirujeme - dostava nahradu mzdy za svatek a ne dovolenou', true, 31, -1.0, 1.0, 0.0, 'dnySvatek;dnySvatek;hodinySvatek', 'dnySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 343, 256);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4031, '2013-07-30 00:00:00.000', 'SVÁTEK', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', 'do hodinySvatek nekopirujeme - dostava nahradu mzdy za svatek a ne dovolenou', true, 32, -1.0, 1.0, 0.0, 'dnySvatek;dnySvatek;hodinySvatek', 'dnySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 2, 256);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4032, '2013-07-30 00:00:00.000', '1', '----- Nemoc  do neodpracované doby (čas)', true, 33, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 3, 16);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4033, '2013-07-30 00:00:00.000', '1', '----- Karanténa  do neodpracované doby (čas)', true, 34, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 12, 16);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4034, '2013-07-30 00:00:00.000', '1', '----- Nemoc - nepracovní úraz  do neodpracované doby (čas)', true, 35, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 13, 16);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4035, '2013-07-30 00:00:00.000', '1', '----- Nemoc - pracovní úraz  do neodpracované doby (čas)', true, 36, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 14, 16);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4036, '2013-07-30 00:00:00.000', '1', '----- Nemoc z povolání do neodpracované doby (čas)', true, 37, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 15, 16);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4037, '2013-07-30 00:00:00.000', '1', '----- Dovolená do neodpracované doby (čas)', true, 38, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 2, 16);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4038, '2013-07-30 00:00:00.000', '1', '----- Překážky z důvodů obecného zájmu  do neodpracované doby (čas)', true, 39, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 11, 16);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4039, '2013-07-30 00:00:00.000', '1', '----- Absence neomluvená  do neodpracované doby (čas)', true, 40, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 5, 16);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4040, '2013-07-30 00:00:00.000', '1', '----- Volno placené  do neodpracované doby (čas)', true, 41, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 6, 16);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4041, '2013-07-30 00:00:00.000', '1', '----- Důležité osobní překážky v práci  do neodpracované doby (čas)', true, 42, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 10, 16);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4042, '2013-07-30 00:00:00.000', 'CELKOVÁ NEPŘÍTOMNOST', 'Svátek', true, 43, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;dnySvatek;hodiny;hodinySvatek', 'dnyPrac;dnyKal;dnySvatek;hodiny;hodinySvatek', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 256, 16);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4043, '2013-07-30 00:00:00.000', '1', '----- Volno neplacené  do neodpracované doby (čas)', true, 44, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 7, 16);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4044, '2013-07-30 00:00:00.000', 'NEPŘÍTOMNOST - SUM ', '----- Ošetřování člena rodiny  do neodpracované doby (čas)', true, 45, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 4, 16);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4045, '2013-07-30 00:00:00.000', '1', '----- Mateřská dovolená (vstupuje do vyloučených dob v ELDP)', true, 46, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 150, 16);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4046, '2013-07-30 00:00:00.000', '1', 'Mimo evidenci (pro všechny pracovní poměry) ', true, 47, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 152, 16);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4047, '2013-07-30 00:00:00.000', '1', 'Vojenské cvičení neplacené', true, 48, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 295, 16);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4048, '2013-07-30 00:00:00.000', '1', 'Ostatní překážky v práci neplacené', true, 49, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 296, 16);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4049, '2013-07-30 00:00:00.000', '1', 'Mimo evidenci neomluveno (pro všechny pracovní poměry) ', true, 50, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 153, 16);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4050, '2013-07-30 00:00:00.000', '1', 'Prostoj 60% nebo částečná nezaměstnanost', true, 51, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 238, 16);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4051, '2013-07-30 00:00:00.000', '1', 'Prostoj 80%', true, 52, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 239, 16);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4052, '2013-07-30 00:00:00.000', '1', 'Prostoj 100%', true, 53, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 240, 16);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4053, '2013-07-30 00:00:00.000', '1', '----- Rodičovská dovolená  (nevstupuje do vyloučených dob v ELDP) ', true, 54, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 151, 16);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4054, '2013-07-30 00:00:00.000', '1', 'Dny před nástupem (měsíci) do zaměstnání pro výpočet podílu měsíční nebo hodinové mzdy ', true, 55, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;dnySvatek;hodiny;hodinySvatek', 'dnyPrac;dnyKal;dnySvatek;hodiny;hodinySvatek', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 287, 16);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4055, '2013-07-30 00:00:00.000', 'ODPR.DOBA VYPOČ.', '----- Vypočtená odpracovaná doba = od fondu je odečtena  neodpracovaná doba', 'doplněno odečtení svátku obsažených v nepřítonosti', true, 56, -1.0, 1.0, 0.0, 'dnyKal;dnyPrac;dnySvatek;hodiny;hodinySvatek', 'dnyKal;dnyPrac;dnySvatek;hodiny;hodinySvatek', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 16, 179);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4056, '2013-07-30 00:00:00.000', '2', 'Koeficient vypočtený z toho, co zbývá na měsíční mzdu (fond-neodpracovaná doba-hodnová mzda-úkolová mzda)', true, 57, 1.0, 1.0, 0.0, 'dnyKal;dnyPrac;dnySvatek;hodiny;hodiny;hodinySvatek', 'dnyKal;dnyPrac;dnySvatek;hodiny;castMzd;hodinySvatek', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 188, 179);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4057, '2013-07-30 00:00:00.000', '2', 'Fond pracovní  doby v aktuálním měsíci', true, 58, 1.0, 0.0, 0.0, 'hodinySvatek;dnySvatek;hodinySvatek;dnySvatek', '', 'hodinySvatek;dnySvatek;hodiny;dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 1, 21);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4058, '2013-07-30 00:00:00.000', 'NÁHRADA ZA SVÁTEK', 'svátek sumovaná z nemoci', true, 59, -1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 343, 21);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4059, '2013-07-30 00:00:00.000', '2', '----- Vynulování hodin náhrady za svátek', 'Do pole procMzd si nastavim hodontu - 1 bude náhrada za svátek 0 nebude náhrada', true, 60, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'hodinySvatek;dnySvatek', 'procMzd', 'hodinySvatek;dnySvatek', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 21, 21, 21);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4060, '2013-07-30 00:00:00.000', '2', 'Odpracovaná doba celkem - rozdíl mezi fondem pracovní doby a neodpracovanou dobou', true, 61, 1.0, 0.0, 0.0, 'dnyPrac;dnyKal;dnySvatek;hodiny;hodinySvatek', 'dnyPrac;dnyKal;dnySvatek;hodiny;hodinySvatek', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 179, 17);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4061, '2013-07-30 00:00:00.000', '2', '----- Negace pole procmzd (z inicializace je 1 když je náhrada za svátek)', true, 62, 1.0, 0.0, 1.0, 'procMzd', 'procMzd', 0.0, 0.0, 'mzdCalcOper.rovno', false, 0, false, 5, 256, 256);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4062, '2013-07-30 00:00:00.000', 'SVÁTEK V NEMOCI', '----- nulování hodin svátek', true, 63, 1.0, 0.0, 0.0, 'procMzd', 'hodinySvatek', 'procMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 256, 343, 343);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4063, '2013-07-30 00:00:00.000', '2', '----- nulování hodin svátek', true, 64, 1.0, 0.0, 0.0, 'procMzd', 'hodinySvatek', 'hodinySvatek', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 256, 256, 256);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4064, '2013-07-30 00:00:00.000', '2', '----- Přičtení svátku do odpracované doby když za něj není náhrada', true, 65, 1.0, 1.0, 0.0, 'hodinySvatek', '', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 256, 179);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4065, '2013-07-30 00:00:00.000', '2', 'svátek sumovaná z nemoci', 'přidáno 6.10.2011', true, 66, -1.0, 1.0, 0.0, 'procMzd', '', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 343, 179);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4066, '2013-07-30 00:00:00.000', '2', '----- odpracovaná doba  / fond = koeficient ke krácení měsíční a hodinové mzdy', true, 67, 1.0, 0.0, 0.0, 'hodiny', 'hodiny', 'procMzd', 0.0, 0.0, 'mzdCalcOper.lomeno', false, 0, false, 5, 179, 188, 188);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4067, '2013-07-30 00:00:00.000', '2', '----- výpočet odpracopvané doby pro dopaltek ZP do 8500', true, 68, 1.0, 0.0, 0.0, 'dnyKal', '', 'prumNaDenNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 179, 188);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4068, '2013-07-30 00:00:00.000', '2', '----- výpočet odpracopvané doby pro dopaltek ZP do 8500', true, 69, 1.0, 1.0, 0.0, 'dnyKal', '', 'prumNaDenNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 2, 188);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4069, '2013-07-30 00:00:00.000', '2', '----- výpočet odpracopvané doby pro dopaltek ZP do 8500', true, 70, 1.0, 1.0, 0.0, 'dnyKal', '', 'prumNaDenNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 6, 188);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4070, '2013-07-30 00:00:00.000', '2', '----- výpočet odpracopvané doby pro dopaltek ZP do 8500', true, 71, 1.0, 0.0, 0.0, 'prumNaDenNem', 'dnyKal', 'prumNaDenNem', 0.0, 0.0, 'mzdCalcOper.lomeno', false, 0, false, 5, 188, 188, 188);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4071, '2013-07-30 00:00:00.000', '2', '----- vrácení pole ODPRACOVÁNO VÝPOČET  do původního stavu', true, 72, -1.0, 1.0, 0.0, 'hodinySvatek', '', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 256, 179);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4072, '2013-07-30 00:00:00.000', '2', '----- vrácení pole ODPRACOVÁNO VÝPOČET  do původního stavu', 'přidáno 6.10.2011', true, 73, 1.0, 1.0, 0.0, 'procMzd', '', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 3, 179);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4073, '2013-07-30 00:00:00.000', 'ODPRACOVÁNO VÝPOČET', 'Odpracovaná doba', true, 74, 0.0, 0.0, 1.0, 'hodiny', 'procMzd', 0.0, 0.0, 'mzdCalcOper.mensi', false, 0, false, 5, 179, 179);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4074, '2013-07-30 00:00:00.000', 'ODPRACOVÁNO VÝPOČET', 'Odpracovaná doba', true, 75, 1.0, 0.0, 0.0, 'hodiny', 'procMzd', 'hodiny', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 179, 179, 179);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4075, '2013-07-30 00:00:00.000', '2', 'Odpracovaná doba', true, 76, 1.0, 0.0, 0.0, 'dnyKal;dnyPrac;dnySvatek;hodiny;hodinySvatek', '', 'dnyKal;dnyPrac;dnySvatek;hodiny;hodinySvatek', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, false, 5, 179, 335);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4076, '2013-07-30 00:00:00.000', 'ODPRAC.OD ZAČ.ROKU', 'Odpracovaná doba', true, 77, 1.0, 1.0, 0.0, 'dnyKal;dnyPrac;dnySvatek;hodiny;hodinySvatek', '', 'dnyKal;dnyPrac;dnySvatek;hodiny;hodinySvatek', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 179, 335);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4077, '2013-07-30 00:00:00.000', 'PRAC.PRÁVNÍ PRŮMER', '----- Suma základu pro průměrný výdělek za minulé čtvrtletí', '', true, 78, 1.0, 0.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.obdobi', 3, false, 5, 90, 182);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4078, '2013-07-30 00:00:00.000', '3', '----- Odpracovaná doba za minulé čtvrtletí', '', true, 79, 1.0, 0.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.obdobi', 3, false, 5, 179, 183);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4079, '2013-07-30 00:00:00.000', '3', 'Mzda za práci přesčas', '31.5.2010', true, 80, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.obdobi', 3, false, 5, 22, 183);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4080, '2013-07-30 00:00:00.000', 'SVÁTEK 4 MM  ', '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!', '01.06.2010 nakrmení pracovní složky kvůli tomu abych jí mohl ulovat, když není měsíční mzda', true, 81, 1.0, 1.0, 0.0, 'hodinySvatek', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 256, 334);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4081, '2013-07-30 00:00:00.000', 'SVÁTEK 4 MM  ', 'Hodinová mzda', 'vynulování hoin svátků pro hodinovou mzdu', true, 82, 1.0, 0.0, 0.0, 'procMzd', 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.krat', false, 3, false, 5, 18, 334, 334);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4082, '2013-07-30 00:00:00.000', '3', 'Svátek pro měsíční mzdu do PPP', '01.06.2010', true, 83, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.obdobi', 3, false, 5, 334, 183);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4083, '2013-07-30 00:00:00.000', '3', 'Čtvrtletní suma základu pro průměrný výdělek', 'suma odpracované doby za minulé čtvrtletí', true, 84, 1.0, 0.0, 0.0, 'castMzd', 'hodiny', 'prumNaHodNem', 0.0, 0.0, 'mzdCalcOper.lomeno', false, 0, false, 5, 182, 183, 172);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4084, '2013-07-30 00:00:00.000', '3', 'Kontrola a dopočet PPP do 48.10 Kč (mninimální PPP)', '27.12.2010', 'rozdíl mezi vzpočteným průměrem a minimem 48,1', true, 85, 1.0, 0.0, -48.1, 'prumNaHodNem', '', 'procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 172, 172);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4085, '2013-07-30 00:00:00.000', '3', 'Oprava pracovně právního hodinového průměru', '27.12.2010', 'Vynukuji přebytek nad 48,1 nebo převrátím znaménko', true, 86, 1.0, 1.0, 0.0, 'castkaHod;castkaHod', '', 'castkaHod;prumNaHodNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 364, 172);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4086, '2013-07-30 00:00:00.000', '3', '----', '27.12.2010', e'do castka za hodinu si uložim koeficient pro výpočet \n0 ... průměr je větší\n1 ...průměr je menší ', true, 87, 0.0, -1.0, 0.0, 'procMzd', '', 'castkaDen', 0.0, 0.0, 'mzdCalcOper.mensiRovno', false, 0, false, 5, 172, 172);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4087, '2013-07-30 00:00:00.000', '3', '-----', '27.12.2010', 'Vynukuji přebytek nad 48,1 nebo převrátím znaménko', true, 88, 1.0, 0.0, 0.0, 'procMzd', 'castkaDen', 'procMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 172, 172, 172);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4088, '2013-07-30 00:00:00.000', '3', '-----', '27.12.2010', 'Vynukuji přebytek nad 48,1 nebo převrátím znaménko', true, 89, 1.0, 1.0, 0.0, 'procMzd', '', 'prumNaHodNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 172, 172);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4089, '2013-07-30 00:00:00.000', '3', 'Měsíční mzda (plat)', true, 90, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;dnySvatek;hodiny', 'dnyPrac;dnyKal;dnySvatek;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 17, 63);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4090, '2013-07-30 00:00:00.000', '3', '----- Časová (hodinová) mzda do odpracované doby', true, 91, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;dnySvatek;hodiny', 'dnyPrac;dnyKal;dnySvatek;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 18, 63);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4091, '2013-07-30 00:00:00.000', '3', '----- Úkolová mzda  do odpracované doby', true, 92, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;dnySvatek;hodiny', 'dnyPrac;dnyKal;dnySvatek;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 19, 63);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4092, '2013-07-30 00:00:00.000', 'ISPV **************', 'Odpracovaná doba', true, 93, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 179, 312);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4093, '2013-07-30 00:00:00.000', 'ISPV **************', 'Odpracovaná doba', true, 94, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 179, 312);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4094, '2013-07-30 00:00:00.000', 'ISPV **************', 'Mzda za práci přesčas', true, 95, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 22, 313);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4095, '2013-07-30 00:00:00.000', 'ISPV **************', 'Mzda za práci přesčas', true, 96, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 22, 313);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4096, '2013-07-30 00:00:00.000', 'ISPV **************', 'Mzda za práci přesčas', true, 97, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 22, 312);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4097, '2013-07-30 00:00:00.000', 'ISPV **************', 'Mzda za práci přesčas', true, 98, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 22, 312);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4098, '2013-07-30 00:00:00.000', 'ISPV **************', 'Neodpracovaná doba', true, 99, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 16, 314);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4099, '2013-07-30 00:00:00.000', 'ISPV **************', 'Neodpracovaná doba', true, 100, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 16, 314);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4100, '2013-07-30 00:00:00.000', 'ISPV **************', 'Dovolená', true, 101, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 2, 316);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4101, '2013-07-30 00:00:00.000', 'ISPV **************', 'Dovolená', true, 102, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 2, 316);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4102, '2013-07-30 00:00:00.000', 'POMĚR.MĚSÍČNÍ MZDA', 'Měsíční mzda ', true, 103, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 17, 188, 17);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4103, '2013-07-30 00:00:00.000', '3', 'Měsíční mzda  - výpočet částky za hodinu', true, 104, 1.0, 0.0, 0.0, 'zaklMzd', 'hodiny', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.lomeno', false, 0, false, 5, 17, 188, 17);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4104, '2013-07-30 00:00:00.000', '4', 'Odpracovaná doba celkem - rozdíl mezi fondem pracovní doby a neodpracovanou dobou', true, 105, 1.0, 0.0, 0.0, 'dnyPrac;dnyKal;dnySvatek;hodiny;hodinySvatek', 'dnyPrac;dnyKal;dnySvatek;hodiny;hodinySvatek', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 179, 18);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4105, '2013-07-30 00:00:00.000', '4', 'Hodinová mzda', true, 106, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castkaHod', 'hodiny', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 18, 179, 18);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4106, '2013-07-30 00:00:00.000', '5', '----- Měsíční odměna', true, 107, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 23, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4107, '2013-07-30 00:00:00.000', 'PRÉMIE %', '----- Prémie % ze základní mzdy', true, 108, 0.01, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 25, 25, 25);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4108, '2013-07-30 00:00:00.000', 'PRÉMIE % UKAZATELE', 'Prémie % z ukazatele / základu ', true, 109, 0.01, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 27, 27, 27);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4109, '2013-07-30 00:00:00.000', 'PODÍLOVÁ MZDA', 'Podílová (provizní) mzda', true, 110, 0.01, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 20, 20, 20);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4110, '2013-07-30 00:00:00.000', 'PODÍL NA ZISKU', 'Podíly % ze zisku / základu ', true, 111, 0.01, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 28, 28, 28);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4111, '2013-07-30 00:00:00.000', '5', '----- Prémie % ze základní mzdy', true, 112, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 25, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4112, '2013-07-30 00:00:00.000', '5', '----- Odměna členů statutárního orgánu-nerezident', true, 113, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 32, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4113, '2013-07-30 00:00:00.000', '5', '----- Odměna podle zákona o vynálezech a ZN', true, 114, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 30, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4114, '2013-07-30 00:00:00.000', '5', '----- Mimořádná odměna ', true, 115, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 24, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4115, '2013-07-30 00:00:00.000', 'PRESČAS', 'Měsíční mzda ', true, 116, 1.0, 0.0, 0.0, 'castkaHod', '', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 17, 22);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4116, '2013-07-30 00:00:00.000', 'PRESČAS', 'Hodinová mzda', true, 117, 1.0, 0.0, 0.0, 'castkaHod', '', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 18, 22);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4117, '2013-07-30 00:00:00.000', 'PRESČAS', 'Úkolová mzda ', true, 118, 1.0, 0.0, 0.0, 'castkaHod', '', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 19, 22);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4118, '2013-07-30 00:00:00.000', 'PRESČAS', 'Mzda za práci přesčas', true, 119, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castkaHod', 'hodiny', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 22, 22, 22);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4119, '2013-07-30 00:00:00.000', '5', '----- Mzda za práci přesčas', true, 120, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 22, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4120, '2013-07-30 00:00:00.000', '5', '----- Ostatní odměny', true, 121, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 33, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4121, '2013-07-30 00:00:00.000', '5', '----- Uživatelem zadaná odměna', true, 122, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 267, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4122, '2013-07-30 00:00:00.000', '5', '----- Uživatelem zadaná odměna', true, 123, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 268, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4123, '2013-07-30 00:00:00.000', '5', '----- Uživatelem zadaná odměna', true, 124, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 269, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4124, '2013-07-30 00:00:00.000', '5', '----- Uživatelem zadaná odměna', true, 125, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 270, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4125, '2013-07-30 00:00:00.000', '5', '----- Uživatelem zadaná odměna', true, 126, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 271, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4126, '2013-07-30 00:00:00.000', '5', '----- Uživatelem zadaná odměna', true, 127, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 272, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4127, '2013-07-30 00:00:00.000', '5', '----- Uživatelem zadaná odměna', true, 128, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 273, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4128, '2013-07-30 00:00:00.000', '5', '----- Uživatelem zadaná odměna', true, 129, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 274, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4129, '2013-07-30 00:00:00.000', '5', '----- Uživatelem zadaná odměna', true, 130, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 275, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4130, '2013-07-30 00:00:00.000', '5', '----- Uživatelem zadaná odměna', true, 131, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 285, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4131, '2013-07-30 00:00:00.000', '5', '----- Podíly % ze zisku - základu ', true, 132, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 28, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4132, '2013-07-30 00:00:00.000', '5', '----- Prémie % z ukazatele - základu ', true, 133, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 27, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4133, '2013-07-30 00:00:00.000', 'HRUBÁ MZDA', 'Patří do základu pro výpočet pracocně právního průměru', true, 134, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 17, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4134, '2013-07-30 00:00:00.000', '5', '----- Časová (hodinová) mzda', true, 135, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 18, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4135, '2013-07-30 00:00:00.000', '5', '----- Podílová (provizní) mzda', true, 136, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 20, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4136, '2013-07-30 00:00:00.000', '5', '----- Úkolová mzda ', true, 137, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 19, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4137, '2013-07-30 00:00:00.000', 'NÁHRADA ZA SVÁTEK', 'Pracovně právní hodinový průměr pro náhradu mzdy za nemoc, dovolenou ', true, 138, 1.0, 0.0, 0.0, 'prumNaHodNem', '', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 172, 21);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4138, '2013-07-30 00:00:00.000', 'PŘÍPLATEK ZA S+N', 'Pracovně právní hodinový průměr pro náhradu mzdy za nemoc, dovolenou ', true, 139, 1.0, 0.0, 0.0, 'prumNaHodNem', '', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 172, 34);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4139, '2013-07-30 00:00:00.000', 'PŘÍPLATEK ZA PŘESČAS', 'Pracovně právní hodinový průměr pro náhradu mzdy za nemoc, dovolenou ', true, 140, 1.0, 0.0, 0.0, 'prumNaHodNem', '', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 172, 216);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4140, '2013-07-30 00:00:00.000', 'NEČERPANÁ DOVOLENÁ', 'Pracovně právní hodinový průměr pro náhradu mzdy za nemoc, dovolenou ', true, 141, 1.0, 0.0, 0.0, 'prumNaHodNem', '', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 172, 47);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4141, '2013-07-30 00:00:00.000', 'DOVOLENÁ', 'Pracovně právní hodinový průměr pro náhradu mzdy za nemoc, dovolenou ', true, 142, 1.0, 0.0, 0.0, 'prumNaHodNem', '', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 172, 2);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4142, '2013-07-30 00:00:00.000', 'NOČNÍ PŘÍPLATEK', 'Pracovně právní hodinový průměr pro náhradu mzdy za nemoc, dovolenou ', true, 143, 1.0, 0.0, 0.0, 'prumNaHodNem', '', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 172, 36);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4143, '2013-07-30 00:00:00.000', 'NÁHRADA ZA SVÁTEK', 'Náhráda za svátek', true, 144, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'hodinySvatek', 'prumNaHodNem', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 21, 172, 21);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4144, '2013-07-30 00:00:00.000', 'NEPATŘÍ DO PPP ', 'Náhráda za svátek', true, 145, 1.0, 1.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castMzd', '', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 21, 89);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4145, '2013-07-30 00:00:00.000', '5', '-----  hodiny  *  průměr =  základ', 'suma odpracované doby za minulé čtvrtletí', true, 146, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'hodiny', 'prumNaHodNem', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 216, 172, 216);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4146, '2013-07-30 00:00:00.000', '5', '-----  Procenta  *  základ = výsledek', 'suma odpracované doby za minulé čtvrtletí', true, 147, 0.01, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'procMzd', 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 216, 216, 216);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4147, '2013-07-30 00:00:00.000', '5', '----- do hrubé mzdy', true, 148, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 216, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4148, '2013-07-30 00:00:00.000', 'PŘIPLATEK ZA SVÁTEK', 'Pracovně právní hodinový průměr pro náhradu mzdy za nemoc, dovolenou ', true, 149, 1.0, 0.0, 0.0, 'prumNaHodNem', '', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 172, 38);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4149, '2013-07-30 00:00:00.000', '5', '----- výpočet základu', 'suma odpracované doby za minulé čtvrtletí', true, 150, 1.0, 0.0, 0.0, 'hodiny', 'prumNaHodNem', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 38, 172, 38);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4150, '2013-07-30 00:00:00.000', 'PŘÍPLATEK ZA PŘESČAS', '----- základ x procenta', '', true, 151, 0.01, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 38, 38, 38);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4151, '2013-07-30 00:00:00.000', '5', '----- do hrubé mzdy', true, 152, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 38, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4152, '2013-07-30 00:00:00.000', '5', '----- výpočet základu', 'suma odpracované doby za minulé čtvrtletí', true, 153, 1.0, 0.0, 0.0, 'hodiny', 'prumNaHodNem', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 34, 172, 34);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4153, '2013-07-30 00:00:00.000', 'PŘÍPLATEK ZA S+N', '----- základ x procenta', 'suma odpracované doby za minulé čtvrtletí', true, 154, 0.01, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'procMzd', 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 34, 34, 34);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4154, '2013-07-30 00:00:00.000', '5', '----- do hrubé mzdy', true, 155, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 34, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4155, '2013-07-30 00:00:00.000', '5', '----- výpočet základu', 'suma odpracované doby za minulé čtvrtletí', true, 156, 1.0, 0.0, 0.0, 'hodiny', 'prumNaHodNem', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 36, 172, 36);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4156, '2013-07-30 00:00:00.000', 'NOČNÍ PŘÍPLATEK', '-----  Procenta  *  základ = výsledek', 'suma odpracované doby za minulé čtvrtletí', true, 157, 0.01, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'procMzd', 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 36, 36, 36);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4157, '2013-07-30 00:00:00.000', '5', '----- do hrubé mzdy', true, 158, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 36, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4158, '2013-07-30 00:00:00.000', 'POHOTOVOST', '-----  Kč/hod  *  hodiny = výsledek', true, 159, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castkaHod', 'hodiny', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 39, 39, 39);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4159, '2013-07-30 00:00:00.000', '5', '----- do hrubé mzdy', true, 160, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 39, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4160, '2013-07-30 00:00:00.000', 'POHOTOVOST MIMO', '-----  Kč/hod  *  hodiny = výsledek', true, 161, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'hodiny', 'castkaHod', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 205, 205, 205);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4161, '2013-07-30 00:00:00.000', '5', '----- do hrubé mzdy', true, 162, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 205, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4162, '2013-07-30 00:00:00.000', 'PŘÍPL.ZA PROSTŘEDÍ', '-----  Kč/hod  *  hodiny = výsledek', true, 163, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castkaHod', 'hodiny', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 35, 35, 35);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4163, '2013-07-30 00:00:00.000', '5', '----- do hrubé mzdy', true, 164, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 35, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4164, '2013-07-30 00:00:00.000', 'OSOBNÍ PŘÍPLATEK', 'Koeficient vypočtený z toho, co zbývá na měsíční mzdu (fond-neodpracovaná doba-hodnová mzda-úkolová mzda)', true, 165, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'procMzd', 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 188, 41, 41);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4165, '2013-07-30 00:00:00.000', 'PŘÍPLATEK ZA VEDENÍ', 'Koeficient vypočtený z toho, co zbývá na měsíční mzdu (fond-neodpracovaná doba-hodnová mzda-úkolová mzda)', true, 166, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'procMzd', 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 188, 42, 42);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4166, '2013-07-30 00:00:00.000', 'PRÉMIE PEVNÁ', 'Koeficient vypočtený z toho, co zbývá na měsíční mzdu (fond-neodpracovaná doba-hodnová mzda-úkolová mzda)', true, 167, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'procMzd', 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 188, 26, 26);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4167, '2013-07-30 00:00:00.000', '5', '----- Prémie pevnou částkou ', true, 168, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 26, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4168, '2013-07-30 00:00:00.000', '5', '----- Osobní příplatek', true, 169, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 41, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4169, '2013-07-30 00:00:00.000', '5', '----- Zvláštní příplatek', true, 170, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 40, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4170, '2013-07-30 00:00:00.000', '5', '----- Příplatek za rozdělenou směnu', true, 171, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 37, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4171, '2013-07-30 00:00:00.000', '5', '----- Příplatek za vedení a zastupování', true, 172, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 42, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4172, '2013-07-30 00:00:00.000', '5', '¨něco za něco', true, 173, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 257, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4173, '2013-07-30 00:00:00.000', '5', '----- Uživatelský příplatek', true, 174, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 258, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4174, '2013-07-30 00:00:00.000', '5', '----- Uživatelský příplatek', true, 175, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 259, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4175, '2013-07-30 00:00:00.000', '5', '----- Uživatelský příplatek', true, 176, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 260, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4176, '2013-07-30 00:00:00.000', '5', '----- Uživatelský příplatek', true, 177, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 261, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4177, '2013-07-30 00:00:00.000', '5', '----- Uživatelský příplatek', true, 178, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 262, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4178, '2013-07-30 00:00:00.000', '5', '----- Uživatelský příplatek', true, 179, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 263, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4179, '2013-07-30 00:00:00.000', '5', '----- Uživatelský příplatek', true, 180, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 264, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4180, '2013-07-30 00:00:00.000', '5', '----- Uživatelský příplatek', true, 181, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 265, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4181, '2013-07-30 00:00:00.000', '5', '----- Uživatelský příplatek', true, 182, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 266, 90);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4182, '2013-07-30 00:00:00.000', '6', 'NEpatří do základu pro výpočet pracocně právního průměru - Odměna členů statutárního orgánu', true, 183, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 31, 89);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4183, '2013-07-30 00:00:00.000', '6', '----- Odměna členů statutárního orgánu-nerezident', true, 184, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 32, 89);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4184, '2013-07-30 00:00:00.000', '6', '----- Náhrada škod podle zákoníku práce', true, 185, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 51, 89);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4185, '2013-07-30 00:00:00.000', '6', '----- Odstupné, odchodné, odbytné', true, 186, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 44, 89);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4186, '2013-07-30 00:00:00.000', '6', '----- Odměna k živ, prac. jubileu, odchodu do důch.', true, 187, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 29, 89);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4187, '2013-07-30 00:00:00.000', '6', '----- Cestovní náhrady nadlimit', true, 188, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 46, 89);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4188, '2013-07-30 00:00:00.000', '6', '----- Srážka za přečerpanou dovolenou', true, 189, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 48, 89);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4189, '2013-07-30 00:00:00.000', '6', '----- Doplatek do průměrného výdělku', true, 190, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 49, 89);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4190, '2013-07-30 00:00:00.000', '6', '----- Doplatek do minimální mzdy', true, 191, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 50, 89);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4191, '2013-07-30 00:00:00.000', '6', '----- Jednorázová sociální výpomoc', true, 192, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 52, 89);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4192, '2013-07-30 00:00:00.000', '6', '----- 1%  vstupní ceny vozu ', true, 193, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 54, 89);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4193, '2013-07-30 00:00:00.000', '6', '----- Peněž dar z FKSP', true, 194, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 55, 89);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4194, '2013-07-30 00:00:00.000', '6', '----- Naturálni mzda', true, 195, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 56, 89);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4195, '2013-07-30 00:00:00.000', 'PŘEKÁŽKY OSOBNÍ', 'Důležité osobní překážky v práci  (svatba, narození dítěte, vyšetření ve zdravotnickém zařízení aj. § 128) ', '', true, 196, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'hodiny', 'prumNaHodNem', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 10, 172, 10);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4196, '2013-07-30 00:00:00.000', '6', 'Důležité osobní překážky v práci  (svatba, narození dítěte, vyšetření ve zdravotnickém zařízení aj. § 128) ', '', true, 197, 1.0, 1.0, 0.0, 'castMzd', '', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 10, 89);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4197, '2013-07-30 00:00:00.000', '6', 'Pracovně právní hodinový průměr pro náhradu mzdy za nemoc, dovolenou ', '', true, 198, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'prumNaHodNem', '', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 172, 10);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4198, '2013-07-30 00:00:00.000', 'VOLNO PLACENÉ', 'Volno placené', '', true, 199, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'hodiny', 'prumNaHodNem', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 6, 172, 6);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4199, '2013-07-30 00:00:00.000', 'NEPATŘÍ DO PPP ', 'Volno placené', '', true, 200, 1.0, 1.0, 0.0, 'castMzd', '', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 6, 89);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4200, '2013-07-30 00:00:00.000', 'VOLNO PLACENÉ', 'Pracovně právní hodinový průměr pro náhradu mzdy za nemoc, dovolenou ', '', true, 201, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'prumNaHodNem', '', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 172, 6);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4201, '2013-07-30 00:00:00.000', 'OBECNÝ ZÁJEM', 'Překážky z důvodů obecného zájmu placené ', '', true, 202, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'hodiny', 'prumNaHodNem', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 11, 172, 11);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4202, '2013-07-30 00:00:00.000', '6', 'Překážky z důvodů obecného zájmu placené ', '', true, 203, 1.0, 1.0, 0.0, 'castMzd', '', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 11, 89);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4203, '2013-07-30 00:00:00.000', '6', 'Pracovně právní hodinový průměr pro náhradu mzdy za nemoc, dovolenou ', '', true, 204, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'prumNaHodNem', '', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 172, 11);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4204, '2013-07-30 00:00:00.000', 'DOVOLENÁ', 'Dovolená', '!!!!!!!!!!!!  11.5. zrušeno zaokrouhlování - test', true, 205, 1.0, 0.0, 0.0, 'hodiny', 'prumNaHodNem', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 2, 172, 2);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4205, '2013-07-30 00:00:00.000', 'DOVOLENÁ CELKEM', 'Dovolená', '!!!!!!!!!!!!  11.5. zrušeno zaokrouhlování - test', true, 206, 1.0, 1.0, 0.0, 'castMzd;castkaHod;dnyKal;dnyPrac;dnySvatek;hodiny;hodinySvatek;prumNaHodNem', '', 'castMzd;castkaHod;dnyKal;dnyPrac;dnySvatek;hodiny;hodinySvatek;prumNaHodNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 2, 346);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4206, '2013-07-30 00:00:00.000', 'DOVOLENÁ CELKEM', 'Celková dovolená zaokrouhlená na Kč nahoru', '!!!!!!!!!!!!  11.5. zrušeno zaokrouhlování - test', true, 207, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castMzd', '', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 346, 346);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4207, '2013-07-30 00:00:00.000', 'NEPATŘÍ DO PPP ', 'Celková dovolená zaokrouhlená na Kč nahoru', '', true, 208, 1.0, 1.0, 0.0, 'castMzd', '', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 346, 89);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4208, '2013-07-30 00:00:00.000', 'NEČERPANÁ DOVOLENÁ', 'Proplacení nevyčerpané dovolené', '', true, 209, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'hodiny', 'prumNaHodNem', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 47, 172, 47);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4209, '2013-07-30 00:00:00.000', 'NEPATŘÍ DO PPP ', 'Proplacení nevyčerpané dovolené', '', true, 210, 1.0, 1.0, 0.0, 'castMzd', '', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 47, 89);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4210, '2013-07-30 00:00:00.000', '6', '----- Příspěvek firmy na penzijní a životní pojištění zaměstnance v měsíci', true, 211, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 248, 89);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4211, '2013-07-30 00:00:00.000', 'PROSTOJ  60%', '----- Pracovně právní hodinový průměr do prostoje', true, 212, 1.0, 0.0, 0.0, 'prumNaHodNem', '', 'prumNaHodNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 172, 238);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4212, '2013-07-30 00:00:00.000', '6 - 1', 'Prostoj 60% nebo částečná nezaměstnanost', true, 213, 1.0, 1.0, 0.0, 'hodiny', 'prumNaHodNem', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 238, 172, 238);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4213, '2013-07-30 00:00:00.000', '6 - 2', 'Prostoj 60% nebo částečná nezaměstnanost', true, 214, 0.01, 1.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 238, 238, 238);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4214, '2013-07-30 00:00:00.000', '6 - 3', 'Prostoj 60% nebo částečná nezaměstnanost', true, 215, 1.0, 1.0, 0.0, 'castMzd', '', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 238, 89);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4215, '2013-07-30 00:00:00.000', 'PROSTOJ  80%', '----- Pracovně právní hodinový průměr do prostoje', true, 216, 1.0, 0.0, 0.0, 'prumNaHodNem', '', 'prumNaHodNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 172, 239);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4216, '2013-07-30 00:00:00.000', '6 - 2', 'Prostoj 80%', true, 217, 1.0, 1.0, 0.0, 'hodiny', 'prumNaHodNem', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 239, 172, 239);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4217, '2013-07-30 00:00:00.000', '6 - 3', 'Prostoj 80%', true, 218, 0.01, 1.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 239, 239, 239);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4218, '2013-07-30 00:00:00.000', '6 - 3', 'Prostoj 80%', true, 219, 1.0, 1.0, 0.0, 'castMzd', '', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 239, 89);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4219, '2013-07-30 00:00:00.000', 'PROSTOJ  100%', '----- Pracovně právní hodinový průměr do prostoje', true, 220, 1.0, 0.0, 0.0, 'prumNaHodNem', '', 'prumNaHodNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 172, 240);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4220, '2013-07-30 00:00:00.000', '6 - 1', 'Prostoj 100%', true, 221, 1.0, 1.0, 0.0, 'hodiny', 'prumNaHodNem', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 240, 172, 240);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4221, '2013-07-30 00:00:00.000', '6 - 2', 'Prostoj 100%', true, 222, 0.01, 1.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 240, 240, 240);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4222, '2013-07-30 00:00:00.000', '6 - 3', 'Prostoj 100%', true, 223, 1.0, 1.0, 0.0, 'castMzd', '', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 240, 89);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4223, '2013-07-30 00:00:00.000', '6', '----- Naturálni mzda', true, 224, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 56, 156);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4224, '2013-07-30 00:00:00.000', '6', '----- 1%  vstupní ceny vozu ', true, 225, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 54, 156);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4225, '2013-07-30 00:00:00.000', '8', '----- Odměna podle zákona o vynálezech a ZN', true, 226, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 30, 154);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4226, '2013-07-30 00:00:00.000', '8', '----- Odstupné, odchodné, odbytné', true, 227, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 44, 154);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4227, '2013-07-30 00:00:00.000', '8', '----- Odměna k životnímu, pracobnímu jubileu, odchodu do důchodu', true, 228, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 29, 154);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4228, '2013-07-30 00:00:00.000', '8', '----- Náhrada škod podle zákoníku práce', true, 229, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 51, 154);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4229, '2013-07-30 00:00:00.000', '8', '----- Jednorázová sociální výpomoc', true, 230, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 52, 154);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4230, '2013-07-30 00:00:00.000', '8', '----- Odstupné, odchodné, odbytné', true, 231, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 44, 155);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4231, '2013-07-30 00:00:00.000', '8', '----- Odměna k životnímu, pracobnímu jubileu, odchodu do důchodu', true, 232, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 29, 155);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4232, '2013-07-30 00:00:00.000', '8', '----- Odměna podle zákona o vynálezech a ZN', true, 233, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 30, 155);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4233, '2013-07-30 00:00:00.000', '8', '----- Náhrada škod podle zákoníku práce', true, 234, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 51, 155);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4234, '2013-07-30 00:00:00.000', '8', '----- Jednorázová sociální výpomoc', true, 235, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 52, 155);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4235, '2013-07-30 00:00:00.000', '8', '----- Základ pro průměrný výdělek', true, 236, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 90, 87);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4236, '2013-07-30 00:00:00.000', '8', '----- Nepatří do základu pro průměrný výdělek', true, 237, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 89, 87);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4237, '2013-07-30 00:00:00.000', '8', '----- Hrubá mzda celkem pro všechny pracovní poměry', true, 238, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 87, 167);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4238, '2013-07-30 00:00:00.000', 'ISPV **************', 'Hrubá mzda celkem ', true, 239, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 167, 319);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4239, '2013-07-30 00:00:00.000', 'ISPV **************', 'Hrubá mzda celkem ', true, 240, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 167, 319);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4240, '2013-07-30 00:00:00.000', 'ISPV **************', 'Mimořádná odměna ', true, 241, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 24, 321);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4241, '2013-07-30 00:00:00.000', 'ISPV **************', 'Mimořádná odměna ', true, 242, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 24, 321);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4242, '2013-07-30 00:00:00.000', 'PRIPPCAS', 'Příplatek za práci přesčas', true, 243, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 216, 322);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4243, '2013-07-30 00:00:00.000', 'PRIPPCAS', 'Příplatek za práci přesčas', true, 244, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 216, 322);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4244, '2013-07-30 00:00:00.000', 'ISPV **************', 'Nepatří do základu pro průměrný výdělek', true, 245, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 89, 324);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4245, '2013-07-30 00:00:00.000', 'ISPV **************', 'Nepatří do základu pro průměrný výdělek', true, 246, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 89, 324);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4246, '2013-07-30 00:00:00.000', 'ISPV **************', 'Náhrada za pr.neschopnost', true, 247, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 294, 325);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4247, '2013-07-30 00:00:00.000', 'ISPV **************', 'Náhrada za pr.neschopnost', true, 248, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 294, 325);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4248, '2013-07-30 00:00:00.000', 'ISPV **************', 'Odměna za prac. pohot.na pracovišti', true, 249, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 39, 326);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4249, '2013-07-30 00:00:00.000', 'ISPV **************', 'Odměna za prac. pohot.na pracovišti', true, 250, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 39, 326);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4250, '2013-07-30 00:00:00.000', 'ISPV **************', 'Pracovně právní hodinový průměr', true, 251, 1.0, 0.0, 0.0, 'prumNaHodNem', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 172, 327);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4251, '2013-07-30 00:00:00.000', 'SOC.ZÁKLAD STD', 'Výpočet sociálky', true, 252, 1.0, 1.0, 0.0, 'castMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 87, 162);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4252, '2013-07-30 00:00:00.000', '1', '% příspěvku firmy na penzijní pojištění zaměstnance', true, 253, 0.01, 0.0, 0.0, 'procMzd', 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 'mzdCalcSuma.rokPred', 0, false, 5, 237, 167, 250);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4253, '2013-07-30 00:00:00.000', '2', 'Příspěvek firmy / zamětnavatele na penzijní pojištění zaměstnance procentem', true, 254, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 250, 248);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4254, '2013-07-30 00:00:00.000', 'PENZIJ.+ŽIVOT.', 'Příspěvek firmy / zamětnavatele na životní  pojištění zaměstnance fixní', true, 255, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 180, 248);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4255, '2013-07-30 00:00:00.000', '4', 'Příspěvek firmy / zamětnavatele na penzijní pojištění zaměstnance fixní', true, 256, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 126, 248);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4256, '2013-07-30 00:00:00.000', 'PEN.+ŽIV.FIRMA SUMA', 'Příspěvek firmy na penzijní a životní pojištění zaměstnance v měsíci', true, 257, 1.0, 0.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, false, 5, 248, 247);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4257, '2013-07-30 00:00:00.000', '*', 'Příspěvek firmy na penzijní a životní pojištění zaměstnance v měsíci', true, 258, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 248, 247);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4258, '2013-07-30 00:00:00.000', '*', 'Příspěvek firmy na penzijní a životní pojištění zaměstnance celkem za minulé měsíce', true, 259, -1.0, 0.0, 0.0, 'castMzd', 'castMzd', 30000.0, 9.99999999999999E12, 'mzdCalcOper.plus', false, 0, false, 5, 247, 249);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4259, '2013-07-30 00:00:00.000', '*', 'Příspěvek firmy na penzijní a životní pojištění zaměstnance v měsíci', true, 260, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 9.999999999999E12, 'mzdCalcOper.plus', false, 0, false, 5, 248, 249);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4260, '2013-07-30 00:00:00.000', 'PENZ.+ŽIV.DANĚNO', 'Příspěvek firmy na penzijní a životní pojištění zaměstnance v měsíci', true, 261, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 9.999999999999E12, 'mzdCalcOper.plus', false, 0, false, 5, 248, 65);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4261, '2013-07-30 00:00:00.000', 'PENZ.+ŽIV.DANĚNO', 'Příspěvek firmy na penzijní a životní pojištění do limitu', true, 262, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 9.999999999999E12, 'mzdCalcOper.plus', false, 0, false, 5, 249, 65);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4262, '2013-07-30 00:00:00.000', 'HRUBA MZDA CELKEM ', '---- do nákladů firmy (hrubá mzda ) - příspěvek firmy na penzijní a životní pojištění do limitu', true, 263, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 249, 167);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4263, '2013-07-30 00:00:00.000', 'HRUBÁ MZDA CELKEM ', 'Příspěvek firmy na penzijní a životní pojištění do limitu', true, 264, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 249, 167);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4264, '2013-07-30 00:00:00.000', '6', 'Příspěvek firmy na penzijní a životní pojištění do limitu', true, 265, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 249, 88);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4265, '2013-07-30 00:00:00.000', '9', '----- Nepatří do základu pro sociální pojištění', true, 266, -1.0, 1.0, 0.0, 'castMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 155, 162);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4266, '2013-07-30 00:00:00.000', '9', '---- Přidání počátku ', e'\nbyl na řádku  266\n\n03.01.2011 Oprava  - vyhozen typ sumace - kumuloval špatně počátek o d začátku roku', true, 267, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 196, 199);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4267, '2013-07-30 00:00:00.000', '9', '----- -----***** inicializace plátce soc.pojištění ', 'pro dpp, malý rozsah do 2000 atd se nuluje', true, 268, 0.0, 1.0, 0.0, 'procMzd', 'procMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 162, 162);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4268, '2013-07-30 00:00:00.000', 'ZÁKL.SP-1 PRAC.POMĚR', '1 pracovní poměr  - základ pro sociální pojištění ', true, 269, 1.0, 0.0, 0.0, 'zaklMzd', 'procMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 162, 162, 162);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4269, '2013-07-30 00:00:00.000', '9', '----- *', true, 270, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 162, 94);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4270, '2013-07-30 00:00:00.000', 'SOC.POJ.ZÁKLAD', 'Penzijní připojištění Skupina.Dan - Daněno', true, 271, 1.0, 1.0, 0.0, 'castMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 65, 94);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4271, '2013-07-30 00:00:00.000', '9', 'Základ pro výpočet sociální pojištění, který nepřekračuje roční limit', 'byl na řádku 265', true, 272, 1.0, 0.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, false, 5, 201, 199);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4272, '2013-07-30 00:00:00.000', '9', '---- Přidání aktuálního měsíce', true, 273, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 94, 199);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4273, '2013-07-30 00:00:00.000', '9', '---- Odečtu od limitu sumu vyýpočtového základu od začátku roku', '01.01.2012 změna částky', true, 274, -1.0, 0.0, 0.0, 'zaklMzd', 'zaklMzd', 1242432.0, 9.99999999999999E12, 'mzdCalcOper.plus', false, 0, false, 5, 199, 201);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4274, '2013-07-30 00:00:00.000', '9', '---- Výpočet toho co zbyde do limitu aktuální měsíc', true, 275, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 9.999999999999E12, 'mzdCalcOper.plus', false, 0, false, 5, 94, 201);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4275, '2013-07-30 00:00:00.000', 'ZÁKLAD PRO VÝPOČET', '----- Sociální pojištění - oprava základu', true, 276, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 9.999999999999E12, 'mzdCalcOper.plus', false, 0, false, 5, 164, 201);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4276, '2013-07-30 00:00:00.000', 'S.PRA.DŮCHOD-SAZBA %', 'Je účastem důchodového spořeníi', true, 277, 1.0, 3.5, 6.5, 'procMzd', 'procMzd', 0.0, 0.0, 'mzdCalcOper.rovno', false, 0, false, 5, 360, 361);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4277, '2013-07-30 00:00:00.000', '9', '---- Základ pro sociální pojištění po akceptování limitu', true, 278, 0.215, 1.0, 0.0, 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 201, 99);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4278, '2013-07-30 00:00:00.000', '9', 'Uplatnit refundaci mzdy', '03.01.2011 nastavení základní sazby  - 0.023', true, 279, 0.01, 0.0, 0.023, 'procMzd', 'procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 336, 100);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4279, '2013-07-30 00:00:00.000', '9', '---- Základ pro sociální pojištění  (pro všechny pracovní poměry) ', e'03.01.2011\nVýměna konstanty 0.023 za proměnnou která nabývá hodnoty 0.023 nebo 0.033\npodle nastavení mazd - uplatnit refundaci náhrady za nemoc', true, 280, 1.0, 0.0, 1.0, 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 201, 100, 100);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4280, '2013-07-30 00:00:00.000', '9', '---- Základ pro sociální pojištění  (pro všechny pracovní poměry) ', true, 281, 0.012, 1.0, 0.0, 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 201, 101);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4281, '2013-07-30 00:00:00.000', 'SPOŘENÍ DŮCHOD', '---- Základ pro sociální pojištění  (pro všechny pracovní poměry) ', true, 282, 0.05, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', '', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 201, 362);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4282, '2013-07-30 00:00:00.000', 'SOC.PRAC.DŮCHOD', '---- Základ pro sociální pojištění  (pro všechny pracovní poměry) ', true, 283, 0.01, 0.0, 0.0, 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 201, 361, 95);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4283, '2013-07-30 00:00:00.000', 'SOC.POJ.FIRMA PRAC.', 'Soc. pojištění - Firma - důchodové  (pro všechny pracovní poměry) ', true, 284, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 99, 102);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4284, '2013-07-30 00:00:00.000', '9', '----- Soc. pojištění - Firma - nemocenské   (pro všechny pracovní poměry) ', true, 285, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 100, 102);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4285, '2013-07-30 00:00:00.000', '9', '----- Soc. pojištění - Firma - Stát.pol.zaměs.   (pro všechny pracovní poměry) ', true, 286, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 101, 102);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4286, '2013-07-30 00:00:00.000', '9', 'Soc. pojištění - Firma - pro JD', true, 287, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 222, 102);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4287, '2013-07-30 00:00:00.000', '9', '----- Oprava soc. pojištění - zaměstnavatel', true, 288, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 76, 102);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4288, '2013-07-30 00:00:00.000', '9', '----- Sociálka výpočet', true, 289, 1.0, 1.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 95, 98);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4289, '2013-07-30 00:00:00.000', '9', '----- Oprava soc. pojištění - pracovník', true, 290, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 75, 98);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4290, '2013-07-30 00:00:00.000', 'ZÁKL.SOC.POJ.1 POMĚR', '1 pracovní poměr  - základ pro sociální pojištění ', '', true, 291, 1.0, 1.0, 0.0, 'zaklMzd', '', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 162, 350);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4291, '2013-07-30 00:00:00.000', '9', 'Soc. pojištění - Zaměstnanec -JD', true, 292, 1.0, 1.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 223, 98);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4292, '2013-07-30 00:00:00.000', 'ZDRAVOTNÍ POJIŠTĚNÍ', 'Výpočet zdravotky *********************************************', true, 293, 1.0, 1.0, 0.0, 'castMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 87, 163);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4293, '2013-07-30 00:00:00.000', '10', '---- Základ zdravotního pojištění', true, 294, -1.0, 1.0, 0.0, 'castMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 154, 163);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4294, '2013-07-30 00:00:00.000', '10', '--', true, 295, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 165, 92);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4295, '2013-07-30 00:00:00.000', '10', '--', true, 296, 1.0, 1.0, 0.0, 'castMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 65, 92);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4296, '2013-07-30 00:00:00.000', 'ODPOČET ZÁKLADU ZP', '11.5.           odpočet pro kryply', true, 297, 0.0, 0.0, 5355.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 344, 344);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4297, '2013-07-30 00:00:00.000', 'ODPOČET ZÁKLADU ZP', 'odpočet pro kryply', true, 298, 1.0, 0.0, 0.0, 'zaklMzd', 'procMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 344, 344, 344);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4298, '2013-07-30 00:00:00.000', '10', '11.5.           odpočet pro kryply', true, 299, -1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 344, 92);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4299, '2013-07-30 00:00:00.000', '10', '--', true, 300, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 163, 92);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4300, '2013-07-30 00:00:00.000', 'ZP-JE POJIŠTĚN 1 POM', 'Identifikace zdravotního pojištění pro jeden pracovní poměr', true, 301, 0.0, 0.0, 1.0, 'procMzd', 'procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 352, 352);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4301, '2013-07-30 00:00:00.000', '10', '--', true, 302, 1.0, 0.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, false, 5, 202, 204);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4302, '2013-07-30 00:00:00.000', '10', '--', true, 303, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 198, 204);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4303, '2013-07-30 00:00:00.000', 'ZP-JE POJIŠTĚN 1 POM', '1 pracovní poměr  - základ pro zdravotní pojištění  ', true, 304, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 163, 352);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4304, '2013-07-30 00:00:00.000', '10', '--', true, 305, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 9.999999999999E12, 'mzdCalcOper.plus', false, 0, false, 5, 92, 202);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4305, '2013-07-30 00:00:00.000', '10', '--', true, 306, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 9.999999999999E12, 'mzdCalcOper.plus', false, 0, false, 5, 202, 234);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4306, '2013-07-30 00:00:00.000', '10', '----- Základ pro neplacené volno - pouze pracovník', true, 307, 0.0, 0.0, 8500.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 106, 106);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4307, '2013-07-30 00:00:00.000', '10', '--', true, 308, 1.0, 0.0, 0.0, 'zaklMzd', 'dnyKal', 'castkaDen', 0.0, 0.0, 'mzdCalcOper.lomeno', false, 0, false, 5, 106, 188, 106);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4308, '2013-07-30 00:00:00.000', '10', '--', true, 309, 1.0, 0.0, 0.0, 'castkaDen', 'castkaDen', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 106, 105);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4309, '2013-07-30 00:00:00.000', 'VOLNO NEPLACENÉ', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK...', true, 310, 1.0, 0.0, -0.49, 'zaokrJak.matem', 'zaokrNa.jednotky', 'dnyPrac', 'procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 7, 7);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4310, '2013-07-30 00:00:00.000', '10', '----- Základ = dny neplaceného volna * částka na den (8500 / kal.dny)', true, 311, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castkaDen', 'procMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 106, 7, 106);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4311, '2013-07-30 00:00:00.000', '10', '----- Základ je stejný pro neomlucenou absenci', true, 312, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castkaDen', 'dnyPrac', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 105, 5, 105);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4312, '2013-07-30 00:00:00.000', '10', '----- Poměrný základ pro doplatek ZDR do minimální mzdy ', 'Hodnotu minimální mzdy násobím keficientem stejným pro měsíční mzdu ', true, 313, 8500.0, 0.0, 0.0, 'zaokrJak.matem', 'zaokrNa.jednotky', 'prumNaDenNem', '', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 188, 93);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4313, '2013-07-30 00:00:00.000', '10', '----- Výpočet rozdílu oproti vypočtenému základu pracovníka', true, 314, -1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 234, 93);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4314, '2013-07-30 00:00:00.000', '10', '----- Nulování když je prázdný', true, 315, 1.0, 0.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 9.999999999999E12, 'mzdCalcOper.plus', false, 0, false, 5, 93, 93);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4315, '2013-07-30 00:00:00.000', '10', '----- Doplatek - zvýšení základu pracovníka', true, 316, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 93, 234);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4316, '2013-07-30 00:00:00.000', '10', '----- Neplacené volno - zvýšení základu pracovníka', true, 317, 1.0, 1.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 106, 234);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4317, '2013-07-30 00:00:00.000', '10', '----- Absence - zvýšení základu pracovníka', true, 318, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 105, 234);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4318, '2013-07-30 00:00:00.000', '10', '----- Výpočet celkového zdravotního pojištění', true, 319, 0.135, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 234, 218);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4319, '2013-07-30 00:00:00.000', '10', '----- Překopírování základu do výsledného pojištění ', true, 320, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 234, 218);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4320, '2013-07-30 00:00:00.000', '10', '== Zdravotní zdravotního  pojištění firmy - zaokrouhlená matematicky', true, 321, 0.09, 0.0, 0.0, 'zaokrJak.matem', 'zaokrNa.jednotky', 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 202, 104);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4321, '2013-07-30 00:00:00.000', '10', '----- Překopírování základu do výsledného pojištění firmy', true, 322, 1.0, 0.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 202, 104);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4322, '2013-07-30 00:00:00.000', '10', '----- Oprava pojištění firmy', true, 323, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 78, 104);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4323, '2013-07-30 00:00:00.000', '10', '----- Celkové zdravotní pojištění do pracovníka', true, 324, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 218, 103);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4324, '2013-07-30 00:00:00.000', '10', '== ZDRAV.POJ.PRAC.= ZDRAV.POJ.CELKEM - ZDRAV.POJ.FIRMA', true, 325, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 104, 103);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4325, '2013-07-30 00:00:00.000', '10', '----- Překopírování základu do výsledného pojištění pracovníka', true, 326, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 234, 103);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4326, '2013-07-30 00:00:00.000', '10', '----- Oprava pojištění pracovníka', true, 327, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 77, 103);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4327, '2013-07-30 00:00:00.000', '10', '----- Oprava pojištění pracovníka', true, 328, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 77, 218);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4328, '2013-07-30 00:00:00.000', '10', 'Oprava zdrav. pojištění - firma', true, 329, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 78, 218);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4329, '2013-07-30 00:00:00.000', 'ZDRAV.POJ.ZÁKLAD', 'Zdrav. pojištění - pracovník', true, 330, 1.0, 0.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 103, 92);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4330, '2013-07-30 00:00:00.000', 'ZP-JE POJIŠTĚN', 'Identifikace zdravotního pojištění pro jeden pracovní poměr', true, 331, 1.0, 1.0, 0.0, 'procMzd', 'procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 352, 353);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4331, '2013-07-30 00:00:00.000', 'ZP-JE POJIŠTĚN', 'Identifikace zdravotního pojištění pro osobu', true, 332, 1.0, 0.0, 0.0, 'procMzd', 'procMzd', 'procMzd', 0.0, 0.0, 'mzdCalcOper.lomeno', false, 0, true, 5, 353, 353, 353);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4332, '2013-07-30 00:00:00.000', 'DANĚ', 'Výpočet daně', true, 333, 1.0, 0.0, 0.0, 'castMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 87, 158);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4333, '2013-07-30 00:00:00.000', '11', '----- inicializace slevy', e'1.1.2011 sníženo o 100 Kč z 2070\n1.1.2012 vráceno na 2070', true, 334, 2070.0, 0.0, 0.0, 'procMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 110, 110, 110);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4334, '2013-07-30 00:00:00.000', '11', '----- inicialůizace slevy', true, 335, 335.0, 0.0, 0.0, 'procMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 114, 114, 114);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4335, '2013-07-30 00:00:00.000', '11', '----- inicializace slevy', true, 336, 0.0, 0.0, 0.0, 'procMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 115, 115, 115);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4336, '2013-07-30 00:00:00.000', '11', '----- inicializace slevy', true, 337, 1345.0, 0.0, 0.0, 'procMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 113, 113, 113);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4337, '2013-07-30 00:00:00.000', 'SLEVA NA DÍTĚ ZTP/P', '----- inicilizace slevy', true, 338, 0.0, 0.0, 1117.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 251, 251);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4338, '2013-07-30 00:00:00.000', '11', '----- inicializace slevy', true, 339, 0.0, 0.0, 1117.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 116, 116);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4339, '2013-07-30 00:00:00.000', '11', '----- inicializace slevy', true, 340, 210.0, 0.0, 0.0, 'procMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 111, 111, 111);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4340, '2013-07-30 00:00:00.000', '11', '----- inicializace slevy', true, 341, 420.0, 0.0, 0.0, 'procMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 112, 112, 112);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4341, '2013-07-30 00:00:00.000', 'NEZDAN.ČÁSTKY CELKEM', 'Cestovní náhrady do limitu', true, 342, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 45, 88);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4342, '2013-07-30 00:00:00.000', '11', '----- Oprava zdanitelných příjmů', true, 343, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 79, 158);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4343, '2013-07-30 00:00:00.000', 'ZÁKLAD NAD 100 000 ', 'Základ daně ', true, 344, 1.0, 1.0, -103536.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 158, 355);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4344, '2013-07-30 00:00:00.000', 'ZÁLOHA NAD 100 000 ', 'Nulovani zapornych hodnot', true, 345, 1.0, 0.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 9.99999999999999E12, 'mzdCalcOper.plus', false, 0, false, 5, 355, 355);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4345, '2013-07-30 00:00:00.000', 'ZÁLOHA NAD 100 000 ', 'Základ daně nad 100 000 Kč pro solidární zadaněná', true, 346, 0.07, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 355, 355);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4346, '2013-07-30 00:00:00.000', '11', 'Sociální pojištění - firma / zaměstnavatel', true, 347, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castMzd;castMzd', 'zaklMzd;procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 102, 107);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4347, '2013-07-30 00:00:00.000', '11', 'Penzijní připojištění Skupina.Dan - Daněno', true, 348, 1.0, 1.0, 0.0, 'castMzd;castMzd', 'zaklMzd;procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 65, 107);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4348, '2013-07-30 00:00:00.000', '11', '----- Základ pro výpočet daně ', true, 349, 1.0, 1.0, 0.0, 'zaklMzd;zaklMzd;zaklMzd', 'zaklMzd;procMzd;castkaDen', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 158, 107);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4349, '2013-07-30 00:00:00.000', '11', '----- Zdrav. pojištění - zaměstnavatel', true, 350, 1.0, 1.0, 0.0, 'castMzd;castMzd', 'zaklMzd;procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 104, 107);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4350, '2013-07-30 00:00:00.000', '11', 'Základ pro výpočet daně - superhubá mzda', true, 351, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.stovky', 'procMzd', 'procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 107, 107);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4351, '2013-07-30 00:00:00.000', '11', '----- Základ pro výpočet daně', true, 352, 0.15, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 107, 108);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4352, '2013-07-30 00:00:00.000', '11', '----- Sleva - poplatníka', true, 353, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 110, 117);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4353, '2013-07-30 00:00:00.000', '11', '----- Sleva - Student připravující se na budoucí povolání', true, 354, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 114, 117);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4354, '2013-07-30 00:00:00.000', '11', '----- Sleva - Osoba, za kterou platí zdrav. pojištění stát', true, 355, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 115, 117);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4355, '2013-07-30 00:00:00.000', '11', '----- Sleva - Držitel průkaz ZTP-P', true, 356, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 113, 117);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4356, '2013-07-30 00:00:00.000', '11', '----- Oprava slevy na dani celkem', true, 357, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 81, 117);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4357, '2013-07-30 00:00:00.000', '11', 'Sleva na dítě ZTP/P', true, 358, 1.0, 0.0, 0.0, 'castMzd', '', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 251, 189);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4358, '2013-07-30 00:00:00.000', '11', '----- Sleva - Dítě', true, 359, 1.0, 1.0, 0.0, 'castMzd', '', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 116, 189);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4359, '2013-07-30 00:00:00.000', '11', '----- Sleva na invalidní důchod 1. a 2. stupně', true, 360, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 111, 117);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4360, '2013-07-30 00:00:00.000', '11', '----- Sleva na invalidní důchod 3. stupně', true, 361, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 112, 117);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4361, '2013-07-30 00:00:00.000', 'ZÁLOHA NA DAŇ DÍLČÍ', '----- Vypočtená daň', true, 362, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 108, 356);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4362, '2013-07-30 00:00:00.000', 'ZÁLOHA NA DAŇ DÍLČÍ', '----- Odpočet celkové slevy na dani', true, 363, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 117, 356);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4363, '2013-07-30 00:00:00.000', '11', 'Bonus', true, 364, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 189, 109);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4364, '2013-07-30 00:00:00.000', 'HRUBA MZDA CELKEM ', 'Hrubá mzda celkem ', 'do konstatnty dám, zda je hrubá mzda menší než polovina minimální mzdy', true, 365, 3999.0, 0.0, 1.0, 'castMzd', 'procMzd', 0.0, 0.0, 'mzdCalcOper.mensiRovno', false, 0, false, 5, 167, 167);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4365, '2013-07-30 00:00:00.000', 'ZÁLOHA NA DAŇ DÍLČÍ', 'Záloha na daň  dílčí', true, 366, 1.0, 0.0, 0.0, 'castMzd', 'castMzd', 0.0, 9.999999999999E12, 'mzdCalcOper.plus', false, 0, false, 5, 356, 356);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4366, '2013-07-30 00:00:00.000', 'ZÁLOHA NA DAŇ DÍLČÍ', 'Základ pro výpočet daně - superhubá mzda', true, 367, 1.0, 0.0, 0.0, 'procMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 107, 356);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4367, '2013-07-30 00:00:00.000', 'ZÁLOHA NA DAŇ', 'Připočtení do výsledku celkovou daň', true, 368, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 355, 118);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4368, '2013-07-30 00:00:00.000', 'ZÁLOHA NA DAŇ', 'Záloha na daň  dílčí', true, 369, 1.0, 1.0, 0.0, 'castMzd;zaklMzd;procMzd', 'castMzd;zaklMzd;procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 356, 118);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4369, '2013-07-30 00:00:00.000', '11', 'Záloha na daň  dílčí', true, 370, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 356, 109);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4370, '2013-07-30 00:00:00.000', '11', '----- Omezení rozsahu bonusu na 100 - 4350 Kč', '2012-02-29', true, 371, 1.0, 0.0, 0.0, 'castMzd', 'castMzd', 0.0, 5025.0, 'mzdCalcOper.plus', false, 0, false, 5, 109, 109);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4371, '2013-07-30 00:00:00.000', '11', '----- když je bonus 0, pak koeficient  násobící daň = 1, jinak 0 (daň se vynuluje )', '2012-02-29', true, 372, 0.0, 1.0, 0.0, 'castMzd', 'procMzd', 0.0, 5025.0, 'mzdCalcOper.rovno', false, 0, false, 5, 109, 190);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, vyslodhodnoty, vysldohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4372, '2013-07-30 00:00:00.000', 'BONUS', 'Daňový bonus', 'nuluji bonus, když je hrubá pod 1/2 minimalní mzdy', true, 373, 1.0, 0.0, 0.0, 'castMzd', 'procMzd', 'castMzd', 0.0, 0.0, 50.0, 9.999999999999E12, 'mzdCalcOper.krat', false, 0, false, 5, 109, 167, 109);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4373, '2013-07-30 00:00:00.000', 'BONUS -', '----- záporný bonus', true, 374, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 109, 228);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4374, '2013-07-30 00:00:00.000', 'ZŮČTOVÁNÍ DANĚ ', 'Přeplatek daně z ročního zúčtování', 'Posunuto z konce sem a zároveň byla složka PŘEPLATEK DANĚ označena jako společná pro pracovní poměry', true, 375, -1.0, 0.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 254, 255);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4375, '2013-07-30 00:00:00.000', '11', '----- Nulování daně na základě nenulového bonusu', true, 376, 1.0, 0.0, 0.0, 'castMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 118, 190, 118);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4376, '2013-07-30 00:00:00.000', '11', '----- Daňové zvýhodnění na děti', true, 377, 1.0, 0.0, 0.0, 'castMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 189, 190, 191);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4377, '2013-07-30 00:00:00.000', '11', '----- Odečtení slevy ne děti, když není bonus', true, 378, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 191, 118);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4378, '2013-07-30 00:00:00.000', '11', '----- Oprava zálohy na daň', true, 379, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 82, 118);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4379, '2013-07-30 00:00:00.000', '12', 'Srážková daň', true, 380, 1.0, 1.0, 0.0, 'castMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 87, 159);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4380, '2013-07-30 00:00:00.000', '12', '----- Základ pro výpočet srážkové daně pro pracovní poměr', true, 381, 1.0, 1.0, 0.0, 'zaklMzd;zaklMzd', 'zaklMzd;procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 159, 157);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4381, '2013-07-30 00:00:00.000', 'ZÁKL.SRÁŽKOVÉ DANĚ', 'Sociální pojištění - firma před zaokrouhlením', '10.2.2010', true, 382, 1.0, 1.0, 0.0, 'castMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 102, 157);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4382, '2013-07-30 00:00:00.000', 'ZÁKL.SRÁŽKOVÉ DANĚ', 'Zdravotní  pojištění - firma', '10.2.2010; 15.2.2010 - zrušeno zaokrouhlování základu srážkové daně na 100 Kč', true, 383, 1.0, 1.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 104, 157);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4383, '2013-07-30 00:00:00.000', '12', '----- Základ pro výpočet srážkové daně', true, 384, 0.15, 1.0, 0.0, 'zaokrJak.dolu', 'zaokrNa.jednotky', 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 157, 145);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4384, '2013-07-30 00:00:00.000', '12', '----- Oprava srážkové daně', true, 385, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 83, 145);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4385, '2013-07-30 00:00:00.000', '13', '----- Hrubá mzda celkem pro všechny pracovní poměry', true, 386, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 167, 140);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4386, '2013-07-30 00:00:00.000', 'MZDA', 'Čistá mzda', true, 387, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 118, 140);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4387, '2013-07-30 00:00:00.000', '13', '----- Soc. pojištění - pracovník   (pro všechny pracovní poměry) ', true, 388, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 98, 140);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4388, '2013-07-30 00:00:00.000', '13', '----- Zdrav. pojištění - pracovník', true, 389, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 103, 140);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4389, '2013-07-30 00:00:00.000', '13', '----- Srážková daň ', true, 390, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 145, 140);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4390, '2013-07-30 00:00:00.000', 'ČISTÁ MZDA', 'K výplatě = čistý příjem - suma srážek', true, 391, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 140, 292);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4391, '2013-07-30 00:00:00.000', '13', 'Cestovní náhrady do limitu', 'původně 343', true, 392, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 45, 140);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4392, '2013-07-30 00:00:00.000', '13', 'Příspěvek firmy na penzijní a životní pojištění do limitu', 'původně 343', true, 393, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 249, 140);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4393, '2013-07-30 00:00:00.000', '13', '----- Nepatří do hrubé mzdy', true, 394, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 156, 140);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4394, '2013-07-30 00:00:00.000', 'REDUKOVANÝ PRŮMĚR', '----- Výpočet redukovaného průměru pro náhradu za nemoc - 1. redukční hranice', '03.01.2013 - změna 1. redukční hranice', true, 395, 0.9, 1.0, 0.0, 'prumNaHodNem', 'prumNaHodNem', 0.0, 151.03, 'mzdCalcOper.plus', false, 0, false, 5, 172, 173);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4395, '2013-07-30 00:00:00.000', '15', '----- 2. redukční hranice', '03.01.2013 - změna 2. redukční hranice', true, 396, 0.6, 1.0, 0.0, 'prumNaHodNem', 'prumNaHodNem', 151.03, 226.63, 'mzdCalcOper.plus', false, 0, false, 5, 172, 174);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4396, '2013-07-30 00:00:00.000', '15', '----- 3. redukční hranice', '03.01.2013 - změna 3. redukční hranice', true, 397, 0.3, 1.0, 0.0, 'prumNaHodNem', 'prumNaHodNem', 226.63, 453.08, 'mzdCalcOper.plus', false, 0, false, 5, 172, 175);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4397, '2013-07-30 00:00:00.000', '15', '----- Sumace redukčních hranic', true, 398, 1.0, 1.0, 0.0, 'prumNaHodNem', 'prumNaHodNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 173, 176);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4398, '2013-07-30 00:00:00.000', '15', '-----', true, 399, 1.0, 1.0, 0.0, 'prumNaHodNem', 'prumNaHodNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 174, 176);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4399, '2013-07-30 00:00:00.000', '15', '-----', true, 400, 1.0, 1.0, 0.0, 'prumNaHodNem', 'prumNaHodNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 175, 176);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4400, '2013-07-30 00:00:00.000', '15', 'Pracovně právní hodinový průměr - redukovaný', true, 401, 1.0, 0.0, 0.0, 'zaokrJak.matem', 'zaokrNa.setiny', 'prumNaHodNem', 'prumNaHodNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 176, 176);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4401, '2013-07-30 00:00:00.000', 'NÁHR.NEMOC 1-3', '-----     Výpočet pčesahu nemoci přes 24 hodiny první 3 dny', true, 402, 1.0, 0.0, 0.0, 'hodiny', 'procMzd', 24.0, 9.999999999999E12, 'mzdCalcOper.plus', false, 0, false, 5, 69, 69);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4402, '2013-07-30 00:00:00.000', 'NÁHR.NEMOC 1-3', '----- Přesun redukovaného PPP do  výpočtu náhrady za nemoc', true, 403, 1.0, 0.0, 0.0, 'prumNaHodNem;prumNaHodNem', 'castMzd;castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 176, 69);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4403, '2013-07-30 00:00:00.000', 'NÁHR.NEMOC 1-3', 'Náhrada mzdy za nemoc  - první 3 dny', true, 404, 0.6, 0.0, 0.0, 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 69, 69);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4404, '2013-07-30 00:00:00.000', 'NÁHR.NEMOC 1-3', 'Náhrada mzdy za nemoc  - první 3 dny', true, 405, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 69, 69);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4405, '2013-07-30 00:00:00.000', 'NÁHR.NEMOC 4-15', '----- Přesun redukovaného PPP do  výpočtu náhrady za nemoc', '02.01.2011', e'\n', true, 406, 1.0, 0.0, 0.0, 'prumNaHodNem;prumNaHodNem', 'castMzd;castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 176, 338);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4406, '2013-07-30 00:00:00.000', 'NÁHR.NEMOC 4-15', 'Náhrada za nemoc - 4 až 15 den', '02.01.2011', '', true, 407, 0.6, 0.0, 0.0, 'hodiny', 'castkaHod', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 338, 338, 338);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4407, '2013-07-30 00:00:00.000', 'NÁHR.NEMOC 4-15', 'Náhrada za nemoc - 4 až 15 den', '02.01.2011', '', true, 408, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 338, 338);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4408, '2013-07-30 00:00:00.000', 'NÁHR.KARANTÉNA 1-3', 'Náhrada mzdy za karanténu - první 3 dny', true, 409, 1.0, 0.0, -24.0, 'hodiny', 'procMzd', 0.0, 9.999999999999E12, 'mzdCalcOper.plus', false, 0, false, 5, 171, 171);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4409, '2013-07-30 00:00:00.000', 'NÁHR.KARANTÉNA 1-3', '----- Přesun redukovaného PPP do  výpočtu náhrady za nemoc', true, 410, 1.0, 0.0, 0.0, 'prumNaHodNem;prumNaHodNem', 'castMzd;castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 176, 171);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4410, '2013-07-30 00:00:00.000', 'NÁHR.KARANTÉNA 1-3', 'Náhrada mzdy za karanténu - první 3 dny', true, 411, 0.6, 0.0, 0.0, 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 171, 171);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4411, '2013-07-30 00:00:00.000', 'NÁHR.KARANTÉNA 1-3', 'Náhrada mzdy za karanténu - první 3 dny', true, 412, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 171, 171);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4412, '2013-07-30 00:00:00.000', 'NÁHR.KARANTÉNA 4-15', '----- Přesun redukovaného PPP do  výpočtu náhrady karantény', '02.01.2011', '', true, 413, 1.0, 0.0, 0.0, 'prumNaHodNem;prumNaHodNem', 'castMzd;castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 176, 337);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4413, '2013-07-30 00:00:00.000', 'NÁHR.KARANTÉNA 4-15', 'Náhrada za karanténu - 4 až 15 den', '02.01.2011', '', true, 414, 0.6, 0.0, 0.0, 'hodiny', 'castkaHod', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 337, 337, 337);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4414, '2013-07-30 00:00:00.000', 'NÁHR.KARANTÉNA 4-15', 'Náhrada za karanténu - 4 až 15 den', '02.01.2011', '', true, 415, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 337, 337);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4415, '2013-07-30 00:00:00.000', '15', 'Daňový bonus', true, 416, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 109, 140);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4416, '2013-07-30 00:00:00.000', '15', 'Přeplatek daně z ročního zúčtování', 'Posunuto z konce sem a zároveň byla složka PŘEPLATEK DANĚ označena jako společná pro pracovní poměry', true, 417, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 254, 140);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4417, '2013-07-30 00:00:00.000', 'DOVOLENÁ PŘEVOD', 'Zbývající dovolená', true, 418, 1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.konecPredchoziRok', 1, false, 5, 186, 339);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4418, '2013-07-30 00:00:00.000', 'MĚSÍC POČÁTEK', 'Měsíc počátku pracovního poměru v aktuálním roce - slouží pro výpočet poměrné dovolené - pokud je den v měsíci > 1 bere se následující měsíc', 'Pokud je měsíc 0 připravíme si k přičtení 1, aby jsme byli na lednu', true, 419, 0.0, 1.0, 0.0, 'dnyKal', 'procMzd', 0.0, 0.0, 'mzdCalcOper.rovno', false, 0, false, 5, 340, 340);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4419, '2013-07-30 00:00:00.000', 'MĚSÍC POČÁTEK', 'Měsíc počátku pracovního poměru v aktuálním roce - slouží pro výpočet poměrné dovolené - pokud je den v měsíci > 1 bere se následující měsíc', 'Přičteme konstantu z předchozího kroku, aby byl počátek v lednu vždy 1', true, 420, 1.0, 1.0, 0.0, 'procMzd', 'dnyKal', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 340, 340);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4420, '2013-07-30 00:00:00.000', 'MĚSÍC KONEC', 'Měsíc konce pracovního poměru v aktuálním roce - slouží pro výpočet poměrné dovolené - pokud je den v měsíci > 1 bere se následující měsíc', 'Pokud je měsíc 0 připravíme si k přičtení 12, aby jsme byli na prosinci', true, 421, 0.0, 12.0, 0.0, 'dnyKal', 'procMzd', 0.0, 0.0, 'mzdCalcOper.rovno', false, 0, false, 5, 341, 341);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4421, '2013-07-30 00:00:00.000', 'MĚSÍC KONEC', 'Měsíc konce pracovního poměru v aktuálním roce - slouží pro výpočet poměrné dovolené - pokud je den v měsíci > 1 bere se následující měsíc', 'Přičteme konstantu z předchozího kroku, aby byl konec v prosinci vždy 12', true, 422, 1.0, 1.0, 0.0, 'procMzd', 'dnyKal', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 341, 341);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4422, '2013-07-30 00:00:00.000', 'MĚSÍCŮ PRACUJE', 'Měsíc konce pracovního poměru v aktuálním roce - slouží pro výpočet poměrné dovolené - pokud je den v měsíci > 1 bere se následující měsíc', 'Spočteme kolik měsíců v roce fakt pracoval', true, 423, 1.0, -1.0, 1.0, 'dnyKal', 'dnyKal', 'dnyKal', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 341, 340, 342);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4423, '2013-07-30 00:00:00.000', 'DOVOLENÁ POČÁTEK', 'Nárok na dovolenou', 'koeficient pro výpočet zbývající dovolené', true, 424, 0.166666, 0.0, 0.0, 'zaokrJak.matem', 'zaokrNa.jednotky', 'dnyPrac', 'dnyKal', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 244, 342, 184);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4424, '2013-07-30 00:00:00.000', 'DOVOLENÁ POČÁTEK', 'Nárok na dovolenou - poměrná část', 'koeficient pro výpočet zbývající dovolené', true, 425, 0.5, 0.0, 0.0, 'zaokrJak.matem', 'zaokrNa.setiny', 'dnyPrac', '', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 184, 184);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4425, '2013-07-30 00:00:00.000', 'DOVOLENÁ POČÁTEK', 'Převod dovolené z minulého roku - inicializační složka ', true, 426, 1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 351, 184);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4426, '2013-07-30 00:00:00.000', 'DOVOLENÁ POČÁTEK', 'Převod dovolené z minulého roku - inicializační složka ', true, 427, 1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', true, 'mzdCalcSuma.rokPred', 0, false, 5, 351, 184);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4427, '2013-07-30 00:00:00.000', 'DOVOLENÁ POČÁTEK', 'Převod dovolené z minulého roku', true, 428, 1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 339, 184);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4428, '2013-07-30 00:00:00.000', 'DOVOLENÁ', '----- Dovolená', '', true, 429, 1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 184, 186);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4429, '2013-07-30 00:00:00.000', 'DOVOLENÁ ZBÝVÁ', 'Opravava nároku na dovolenou', 'suma za minulé měsíce', true, 430, 1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, false, 5, 297, 186);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4430, '2013-07-30 00:00:00.000', 'DOVOLENÁ ZBÝVÁ', 'Opravava nároku na dovolenou', 'suma za minulé měsíce', true, 431, 1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 297, 186);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4431, '2013-07-30 00:00:00.000', 'SUMA OPRAV DOVOLENÉ ', 'Opravava nároku na dovolenou', 'suma za minulé měsíce', true, 432, 1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, false, 5, 297, 298);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4432, '2013-07-30 00:00:00.000', 'SUMA OPRAV DOVOLENÉ ', 'Opravava nároku na dovolenou', 'suma za minulé měsíce', true, 433, 1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 297, 298);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4433, '2013-07-30 00:00:00.000', '16', '----- Přičtení aktuálního měsíce', 'suma za minulé měsíce', true, 434, 1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, false, 5, 2, 185);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4434, '2013-07-30 00:00:00.000', '16', '----- Sumace dovolené od začátku roku', '', true, 435, 1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 2, 185);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4435, '2013-07-30 00:00:00.000', 'DOVOLENÁ VYBRÁNO', 'Proplacení nevyčerpané dovolené', '', true, 436, 1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 47, 185);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4436, '2013-07-30 00:00:00.000', 'DOVOLENÁ VYBRÁNO', 'Proplacení nevyčerpané dovolené', 'suma za minulé měsíce', true, 437, 1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, false, 5, 47, 185);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4437, '2013-07-30 00:00:00.000', 'ODEČET DOVOL.ZA ABS.', 'Absence neomluvená', 'sumaa odpracované doby za minulé čtvrtletí', true, 438, 1.0, 0.0, 1.0, 'dnyPrac', 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 5, 236, 235);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4438, '2013-07-30 00:00:00.000', 'DOVOLENÁ VYBRÁNO', 'Odečet dovolené za neomluvenou absenci', 'sumaa odpracované doby za minulé čtvrtletí', true, 439, 1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 235, 185);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4439, '2013-07-30 00:00:00.000', 'DOVOLENÁ VYBRÁNO', 'Odečet dovolené za neomluvenou absenci', 'sumaa odpracované doby za minulé čtvrtletí', true, 440, 1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, false, 5, 235, 185);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4440, '2013-07-30 00:00:00.000', '16', '----- Počáteční satv dovolené - vybráno od začátku roku', 'sumaa odpracované doby za minulé čtvrtletí', true, 441, -1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', true, 0, false, 5, 185, 186);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4441, '2013-07-30 00:00:00.000', '17', '----- Sumace náhrady za nemoc', true, 442, 1.0, 1.0, 0.0, 'castMzd;dnyKal;dnyPrac;hodiny', 'castMzd;dnyKal;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.obdProplat', 0, false, 5, 171, 226);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4442, '2013-07-30 00:00:00.000', '17', 'Náhrada za karanténu - 4 až 15 den', true, 443, 1.0, 1.0, 0.0, 'castMzd;dnyKal;dnyPrac;hodiny', 'castMzd;dnyKal;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.obdProplat', 0, false, 5, 337, 226);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4443, '2013-07-30 00:00:00.000', '17', 'Náhrada mzdy za nemoc  - první 3 dny', true, 444, 1.0, 1.0, 0.0, 'castMzd;dnyKal;dnyPrac;hodiny', 'castMzd;dnyKal;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.obdProplat', 0, false, 5, 69, 226);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4444, '2013-07-30 00:00:00.000', '17', 'Náhrada za nemoc - 4 až 15 den', true, 445, 1.0, 1.0, 0.0, 'castMzd;dnyKal;dnyPrac;hodiny', 'castMzd;dnyKal;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.obdProplat', 0, false, 5, 338, 226);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4445, '2013-07-30 00:00:00.000', '17', 'Oprava - Náhrada mzdy za nemoc', true, 446, 1.0, 1.0, 0.0, 'castMzd;dnyKal;dnyPrac;hodiny', 'castMzd;dnyKal;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 72, 226);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4446, '2013-07-30 00:00:00.000', 'NÁHR. ZA PRAC.NESCH.', 'Celková náhrada za pracovní neschopnost', true, 447, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 226, 294);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4447, '2013-07-30 00:00:00.000', '15', 'Celková náhrada za nemoc', true, 448, 0.5, 1.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 226, 178);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4448, '2013-07-30 00:00:00.000', 'REFUNDACE NÁHRADY', 'Uplatnit refundaci mzdy', e'02.01.2011 nulování náhrady mzdy - viz nastavení firmy\npro frimu nad 25 zaměstnanců je to vždy\npro firmu do 25 podle přání uživatele', true, 449, 1.0, 0.0, 0.0, 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 336, 178);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4449, '2013-07-30 00:00:00.000', 'SOC.POJ.CELKEM', '...', true, 450, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 9.9999999999999E12, 'mzdCalcOper.plus', false, 0, false, 5, 178, 217);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4450, '2013-07-30 00:00:00.000', '15', 'Celková náhrada za nemoc', true, 451, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 226, 140);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4451, '2013-07-30 00:00:00.000', '4', 'Odpracovaná doba celkem - rozdíl mezi fondem pracovní doby a neodpracovanou dobou', true, 452, 1.0, 0.0, 0.0, 'dnyPrac;dnyKal;dnySvatek;hodiny;hodinySvatek', 'dnyPrac;dnyKal;dnySvatek;hodiny;hodinySvatek', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 179, 18);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4452, '2013-07-30 00:00:00.000', 'SRÁŽKY CELKEM', 'Výživné ', true, 453, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 119, 135);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4453, '2013-07-30 00:00:00.000', '18', 'Náhrada škod', true, 454, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 120, 135);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4454, '2013-07-30 00:00:00.000', '18', 'Pojištění ', true, 455, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 125, 135);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4455, '2013-07-30 00:00:00.000', '18', 'Penzijní pojištění zaměstnance', true, 456, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 127, 135);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4456, '2013-07-30 00:00:00.000', '18', 'Odbory částka ', true, 457, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 128, 135);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4457, '2013-07-30 00:00:00.000', '18', 'Čistá mzda ', true, 458, 1.0, 0.0, 0.0, 'castMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 140, 129);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4458, '2013-07-30 00:00:00.000', '18', 'Odbory % ze mzdy', true, 459, 0.01, 0.0, 0.0, 'zaokrJak.matem', 'zaokrNa.jednotky', 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 129, 129, 129);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4459, '2013-07-30 00:00:00.000', '18', 'Odbory % ze mzdy', true, 460, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 129, 135);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4460, '2013-07-30 00:00:00.000', '18', 'Životní pojištění', true, 461, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 130, 135);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4461, '2013-07-30 00:00:00.000', '18', 'Hrubá mzda celkem ', true, 462, 1.0, 0.0, 0.0, 'castMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 167, 134);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4462, '2013-07-30 00:00:00.000', 'STRAVNÉ VYPOČTENÉ', 'Stravné dle odprac. dnů ', true, 463, 0.0, 0.0, 0.0, 'dnyPrac', '', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 133, 133);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4463, '2013-07-30 00:00:00.000', 'STRAVNÉ VYPOČTENÉ', 'Odpracovaná doba', true, 464, 1.0, 0.0, 1.0, 'dnyPrac', '', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.max', false, 0, false, 5, 179, 133);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4464, '2013-07-30 00:00:00.000', 'STRAVNÉ VYPOČTENÉ', 'Studium nebo  jiné formy přípravy', 'při studiu nemá nárok na stravenky', true, 465, -1.0, 1.0, 0.0, 'dnyPrac', '', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 9, 133);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4465, '2013-07-30 00:00:00.000', 'STRAVNÉ VYPOČTENÉ', 'Stravné vypočet dle odprac. dnů ', true, 466, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'procMzd', 'dnyPrac', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 5, 133, 133, 133);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4466, '2013-07-30 00:00:00.000', 'ČISTÝ PŘÍJEM', 'K výplatě = čistý příjem - suma srážek', true, 467, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 140, 293);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4467, '2013-07-30 00:00:00.000', '18', 'Stravné vypočet dle odprac. dnů ', true, 468, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 133, 135);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4468, '2013-07-30 00:00:00.000', 'CELKOVÁ DAŇ', 'Záloha na daň - výsledek po slevách a opravách', true, 469, 1.0, 1.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 118, 242);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4469, '2013-07-30 00:00:00.000', '18', 'Srážky% z hrubé mzdy ', true, 470, 0.01, 1.0, 0.0, 'zaokrJak.matem', 'zaokrNa.jednotky', 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 134, 134, 134);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4470, '2013-07-30 00:00:00.000', '18', 'Srážky% z hrubé mzdy ', true, 471, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 134, 135);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4471, '2013-07-30 00:00:00.000', '18', 'Půjčky ', true, 472, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 124, 135);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4472, '2013-07-30 00:00:00.000', '18', 'Přeplatky ', true, 473, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 121, 135);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4473, '2013-07-30 00:00:00.000', '18', 'Ostattní exekuce', true, 474, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 122, 135);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4474, '2013-07-30 00:00:00.000', '18', 'Stravné', true, 475, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 132, 135);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4475, '2013-07-30 00:00:00.000', '18', 'Spoření', true, 476, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 123, 135);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4476, '2013-07-30 00:00:00.000', '18', 'Osobní účet ', true, 477, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 131, 135);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4477, '2013-07-30 00:00:00.000', '18', 'Uživatelsky definovaná srážka', true, 478, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 276, 135);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4478, '2013-07-30 00:00:00.000', '18', 'Uživatelsky definovaná srážka', true, 479, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 277, 135);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4479, '2013-07-30 00:00:00.000', '18', 'Uživatelsky definovaná srážka', true, 480, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 278, 135);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4480, '2013-07-30 00:00:00.000', '18', 'Uživatelsky definovaná srážka', true, 481, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 279, 135);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4481, '2013-07-30 00:00:00.000', '18', 'Uživatelsky definovaná srážka', true, 482, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 280, 135);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4482, '2013-07-30 00:00:00.000', '18', 'Uživatelsky definovaná srážka', true, 483, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 281, 135);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4483, '2013-07-30 00:00:00.000', '18', 'Uživatelsky definovaná srážka', true, 484, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 282, 135);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4484, '2013-07-30 00:00:00.000', '18', 'Uživatelsky definovaná srážka', true, 485, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 283, 135);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4485, '2013-07-30 00:00:00.000', '18', 'Uživatelsky definovaná srážka', true, 486, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 284, 135);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4486, '2013-07-30 00:00:00.000', '18', 'Uživatelsky definovaná srážka', true, 487, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 286, 135);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4487, '2013-07-30 00:00:00.000', '18', 'spoření důchod', true, 488, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 362, 135);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4488, '2013-07-30 00:00:00.000', 'K VÝPLATĚ', 'Celkové srážky', true, 489, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 135, 140);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4489, '2013-07-30 00:00:00.000', 'K VÝPLATĚ', 'Příspěvek firmy na penzijní a životní pojištění do limitu', true, 490, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 249, 140);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4490, '2013-07-30 00:00:00.000', 'POJISTNÉ PRACOVNÍK', 'Sociální pojištění - pracovník  ', true, 491, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 98, 290);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4491, '2013-07-30 00:00:00.000', 'POJISTNÉ PRACOVNÍK', 'Zdrav. pojištění - pracovník', true, 492, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 103, 290);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4492, '2013-07-30 00:00:00.000', 'DOBÍRKA', 'Čistá mzda ', true, 493, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 140, 139);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4493, '2013-07-30 00:00:00.000', 'DOBÍRKA', 'Záloha mimořádná', true, 494, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 137, 139);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4494, '2013-07-30 00:00:00.000', 'DOBÍRKA', 'Záloha řádná', true, 495, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 136, 139);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4495, '2013-07-30 00:00:00.000', '2', '---- Nulování částky mzdy v odpracováno výpočet', true, 496, 0.0, 0.0, 0.0, 'castMzd', '', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 179, 179);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4496, '2013-07-30 00:00:00.000', 'CELKOVÁ DAŇ', 'Srážková daň ', true, 497, 1.0, 1.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 145, 242);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4497, '2013-07-30 00:00:00.000', 'DAŇOVÝ BONUS', 'Daňový bonus', 'nuluji bonus, když je hrubá pod 1/2 minimalní mzdy', true, 498, 1.0, 0.0, 0.0, 'castMzd', '', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 109, 291);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4498, '2013-07-30 00:00:00.000', 'HRUBA MZDA CELKEM ', '1%  vstupní ceny vozu ', true, 499, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 54, 167);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4499, '2013-07-30 00:00:00.000', '9', '---- Základ pro sociální pojištění po akceptování limitu', true, 500, 1.0, 0.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 201, 99);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4500, '2013-07-30 00:00:00.000', 'SOC.FIR.NEMOC', '---- Základ pro sociální pojištění po akceptování limitu', true, 501, 1.0, 0.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 201, 100);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4501, '2013-07-30 00:00:00.000', 'SOC.FIR.NEZAM.', '---- Základ pro sociální pojištění po akceptování limitu', true, 502, 1.0, 0.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 201, 101);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4502, '2013-07-30 00:00:00.000', 'SOC.POJ.CELKEM', '---- Základ pro sociální pojištění po akceptování limitu', true, 503, 1.0, 0.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 201, 217);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4503, '2013-07-30 00:00:00.000', 'SOC.POJ.PRACOVNÍK', '---- Základ pro sociální pojištění po akceptování limitu', true, 504, 1.0, 0.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 201, 98);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4504, '2013-07-30 00:00:00.000', 'SOC.POJ.FIRMA ', '---- Základ pro sociální pojištění po akceptování limitu', true, 505, 1.0, 0.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 201, 229);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4505, '2013-07-30 00:00:00.000', 'SOC.FIR.DŮCHOD', '---- Základ pro sociální pojištění po akceptování limitu', true, 506, 1.0, 0.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 201, 99);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4506, '2013-07-30 00:00:00.000', 'PRAC.PRÁVNÍ  PRŮMĚR ', 'Pracovně právní hodinový průměr', true, 507, 1.0, 0.0, 0.0, 'prumNaHodNem', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 172, 172);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4507, '2013-07-30 00:00:00.000', 'DÍLČÍ HRUBÁ MZDA', '1%  vstupní ceny vozu ', true, 508, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 54, 87);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4508, '2013-07-30 00:00:00.000', 'SOC.POJ.CELKEM', '----- *', true, 509, 1.0, 1.0, 0.0, 'procMzd', 'procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 162, 217);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4509, '2013-07-30 00:00:00.000', 'ISPV **************', 'Hrubá mzda celkem ', true, 510, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.obdobiAkt', 3, true, 5, 167, 299);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4510, '2013-07-30 00:00:00.000', 'ISPV **************', 'Hrubá mzda celkem ', true, 511, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 167, 299);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4511, '2013-07-30 00:00:00.000', 'ISPV **************', 'Odpracovaná doba', true, 512, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.obdobiAkt', 3, true, 5, 179, 301);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4512, '2013-07-30 00:00:00.000', 'ISPV **************', 'Odpracovaná doba', true, 513, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 179, 301);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4513, '2013-07-30 00:00:00.000', 'ISPV **************', 'Mimořádná odměna ', true, 514, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.obdobiAkt', 3, true, 5, 24, 300);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4514, '2013-07-30 00:00:00.000', 'ISPV **************', 'Mimořádná odměna ', true, 515, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 24, 300);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4515, '2013-07-30 00:00:00.000', 'ISPV **************', 'Mzda za práci přesčas', true, 516, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.obdobiAkt', 3, true, 5, 22, 302);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4516, '2013-07-30 00:00:00.000', 'ISPV **************', 'Mzda za práci přesčas', true, 517, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 22, 302);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4517, '2013-07-30 00:00:00.000', 'ISPV **************', 'Neodpracovaná doba', true, 518, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.obdobiAkt', 3, true, 5, 16, 303);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4518, '2013-07-30 00:00:00.000', 'ISPV **************', 'Neodpracovaná doba', true, 519, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 16, 303);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4519, '2013-07-30 00:00:00.000', 'ISPV **************', 'Fond pracovní doby', true, 520, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 1, 311);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4520, '2013-07-30 00:00:00.000', 'ISPV **************', 'Fond pracovní doby', true, 521, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 1, 311);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4521, '2013-07-30 00:00:00.000', 'ISPV **************', 'Sjednaný fond je plánovaný hodinový fond pracovní doby zaměstnance', 'Když jsou hodiny z fondu pracovní doby tak koeficient pro úkolovou mzdu je 1, jinak je 0', true, 522, 0.0, 1.0, 0.0, 'hodiny', 'procMzd', 0.0, 0.0, 'mzdCalcOper.mensiRovno', false, 0, true, 5, 311, 311);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4522, '2013-07-30 00:00:00.000', 'ISPV **************', 'Úkolová mzda ', 'úkolová mzda do FONDSJE', true, 523, 1.0, 1.0, 0.0, 'hodiny', 'prumNaHodNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 19, 311);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4523, '2013-07-30 00:00:00.000', 'ISPV **************', 'Úkolová mzda ', 'úkolová mzda do FONDSJE', true, 524, 1.0, 1.0, 0.0, 'hodiny', 'prumNaHodNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 19, 311);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4524, '2013-07-30 00:00:00.000', 'ISPV **************', 'Sjednaný fond je plánovaný hodinový fond pracovní doby zaměstnance', 'Přičtení úkolové mzdy do FONDSJE (pouze když není zadaný fond pracovní doby)', true, 525, 1.0, 0.0, 1.0, 'prumNaHodNem', 'procMzd', 'hodiny', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, true, 5, 311, 311, 311);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4525, '2013-07-30 00:00:00.000', 'ISPV **************', 'Sjednaný fond je plánovaný hodinový fond pracovní doby zaměstnance', 'úkolová mzda do FONDSJE', true, 526, 1.0, 1.0, 0.0, 'hodiny', 'prumNaHodNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 311, 312);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4526, '2013-07-30 00:00:00.000', 'ISPV **************', 'Odpracovaná doba zaměstnance v daném pracovním poměru (podle § 353 odst. 2 a 3 ZP) ', 'úkolová mzda do FONDSJE', true, 527, 0.0, 1.0, 0.0, 'hodiny', 'procMzd', 0.0, 0.0, 'mzdCalcOper.mensiRovno', false, 0, true, 5, 312, 312);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4527, '2013-07-30 00:00:00.000', 'ISPV **************', 'Odpracovaná doba zaměstnance v daném pracovním poměru (podle § 353 odst. 2 a 3 ZP) ', 'Přičtení úkolové mzdy do FONDSJE (pouze když není zadaný fond pracovní doby)', true, 528, 1.0, 0.0, 1.0, 'prumNaHodNem', 'procMzd', 'hodiny', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, true, 5, 312, 312, 312);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4528, '2013-07-30 00:00:00.000', 'ISPV **************', 'Celkový počet neodpracovaných hodin', '', true, 529, -1.0, 0.0, 1.0, 'hodiny', 'procMzd', 'hodiny', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, true, 5, 314, 312, 312);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4529, '2013-07-30 00:00:00.000', 'ISPV **************', 'Odpracovaná doba zaměstnance v daném pracovním poměru (podle § 353 odst. 2 a 3 ZP) ', '', true, 530, 0.0, 0.0, 1.0, 'hodiny', '', 'castkaDen', 0.0, 0.0, 'mzdCalcOper.mensiRovno', false, 0, true, 5, 312, 312);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4530, '2013-07-30 00:00:00.000', 'ISPV **************', 'Odpracovaná doba zaměstnance v daném pracovním poměru (podle § 353 odst. 2 a 3 ZP) ', '', true, 531, 1.0, 0.0, 0.0, 'hodiny', 'castkaDen', 'hodiny', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, true, 5, 312, 312, 312);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4531, '2013-07-30 00:00:00.000', 'FONDSJE', 'Odpracovaná doba zaměstnance v daném pracovním poměru (podle § 353 odst. 2 a 3 ZP) ', 'úkolová mzda do FONDSJE', true, 532, 1.0, 0.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 312, 311);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4532, '2013-07-30 00:00:00.000', 'FONDSJE', 'Počet přesčasových hodin (podle § 78 odst. 1 písm. i/ ZP)v', 'úkolová mzda do FONDSJE', true, 533, -1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 313, 311);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4533, '2013-07-30 00:00:00.000', 'FONDSJE', 'Celkový počet neodpracovaných hodin', 'úkolová mzda do FONDSJE', true, 534, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 314, 311);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4534, '2013-07-30 00:00:00.000', 'ISPV **************', '----- Nemoc  do neodpracované doby (čas)', true, 535, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 3, 317);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4535, '2013-07-30 00:00:00.000', 'ISPV **************', '----- Karanténa  do neodpracované doby (čas)', true, 536, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 12, 317);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4536, '2013-07-30 00:00:00.000', 'ISPV **************', '----- Nemoc - nepracovní úraz  do neodpracované doby (čas)', true, 537, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 13, 317);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4537, '2013-07-30 00:00:00.000', 'ISPV **************', '----- Nemoc - pracovní úraz  do neodpracované doby (čas)', true, 538, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 14, 317);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4538, '2013-07-30 00:00:00.000', 'ISPV **************', '----- Nemoc z povolání do neodpracované doby (čas)', true, 539, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 15, 317);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4539, '2013-07-30 00:00:00.000', 'ISPV **************', '----- Nemoc  do neodpracované doby (čas)', true, 540, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 3, 317);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4540, '2013-07-30 00:00:00.000', 'ISPV **************', '----- Karanténa  do neodpracované doby (čas)', true, 541, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 12, 317);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4541, '2013-07-30 00:00:00.000', 'ISPV **************', '----- Nemoc - nepracovní úraz  do neodpracované doby (čas)', true, 542, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 13, 317);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4542, '2013-07-30 00:00:00.000', 'ISPV **************', '----- Nemoc - pracovní úraz  do neodpracované doby (čas)', true, 543, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 14, 317);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4543, '2013-07-30 00:00:00.000', 'ISPV **************', '----- Nemoc z povolání do neodpracované doby (čas)', true, 544, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 15, 317);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4544, '2013-07-30 00:00:00.000', 'ISPV **************', '----- Dovolená do neodpracované doby (čas)', true, 545, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 2, 315);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4545, '2013-07-30 00:00:00.000', 'ISPV **************', '----- Překážky z důvodů obecného zájmu  do neodpracované doby (čas)', true, 546, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 11, 315);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4546, '2013-07-30 00:00:00.000', 'ISPV **************', '----- Volno placené  do neodpracované doby (čas)', true, 547, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 6, 315);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4547, '2013-07-30 00:00:00.000', 'ISPV **************', '----- Důležité osobní překážky v práci  do neodpracované doby (čas)', true, 548, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 10, 315);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4548, '2013-07-30 00:00:00.000', 'ISPV **************', '----- Dovolená do neodpracované doby (čas)', true, 549, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 2, 315);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4549, '2013-07-30 00:00:00.000', 'ISPV **************', '----- Překážky z důvodů obecného zájmu  do neodpracované doby (čas)', true, 550, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 11, 315);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4550, '2013-07-30 00:00:00.000', 'ISPV **************', '----- Volno placené  do neodpracované doby (čas)', true, 551, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 6, 315);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4551, '2013-07-30 00:00:00.000', 'ISPV **************', '----- Důležité osobní překážky v práci  do neodpracované doby (čas)', true, 552, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 10, 315);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4552, '2013-07-30 00:00:00.000', 'ISPV **************', '----- Mzda za práci přesčas', true, 553, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 22, 320);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4553, '2013-07-30 00:00:00.000', 'ISPV **************', '----- Ostatní odměny', true, 554, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 33, 320);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4554, '2013-07-30 00:00:00.000', 'ISPV **************', '----- Uživatelem zadaná odměna', true, 555, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 267, 320);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4555, '2013-07-30 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 556, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 268, 320);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4556, '2013-07-30 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 557, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 269, 320);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4557, '2013-07-30 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 558, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 270, 320);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4558, '2013-07-30 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 559, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 271, 320);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4559, '2013-07-30 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 560, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 272, 320);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4560, '2013-07-30 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 561, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 273, 320);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4561, '2013-07-30 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 562, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 274, 320);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4562, '2013-07-30 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 563, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 275, 320);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4563, '2013-07-30 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 564, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 285, 320);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4564, '2013-07-30 00:00:00.000', 'ISPV **************', '----- Mzda za práci přesčas', true, 565, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 22, 320);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4565, '2013-07-30 00:00:00.000', 'ISPV **************', '----- Ostatní odměny', true, 566, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 33, 320);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4566, '2013-07-30 00:00:00.000', 'ISPV **************', '----- Uživatelem zadaná odměna', true, 567, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 267, 320);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4567, '2013-07-30 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 568, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 268, 320);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4568, '2013-07-30 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 569, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 269, 320);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4569, '2013-07-30 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 570, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 270, 320);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4570, '2013-07-30 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 571, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 271, 320);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4571, '2013-07-30 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 572, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 272, 320);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4572, '2013-07-30 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 573, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 273, 320);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4573, '2013-07-30 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 574, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 274, 320);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4574, '2013-07-30 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 575, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 275, 320);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4575, '2013-07-30 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 576, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 285, 320);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4576, '2013-07-30 00:00:00.000', 'ISPV **************', '----- Dovolená do neodpracované doby (čas)', true, 577, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 2, 304);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4577, '2013-07-30 00:00:00.000', 'ISPV **************', '----- Překážky z důvodů obecného zájmu  do neodpracované doby (čas)', true, 578, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 11, 304);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4578, '2013-07-30 00:00:00.000', 'ISPV **************', '----- Volno placené  do neodpracované doby (čas)', true, 579, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 6, 304);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4579, '2013-07-30 00:00:00.000', 'ISPV **************', '----- Důležité osobní překážky v práci  do neodpracované doby (čas)', true, 580, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 10, 304);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4580, '2013-07-30 00:00:00.000', 'ISPV **************', '...se neposkytuje nemocenská dávka podle zákona o nemocenském pojištění (zákon č. 187/2006 Sb.).', true, 581, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 69, 318);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4581, '2013-07-30 00:00:00.000', 'ISPV **************', '...se neposkytuje nemocenská dávka podle zákona o nemocenském pojištění (zákon č. 187/2006 Sb.).', true, 582, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 69, 318);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4582, '2013-07-30 00:00:00.000', 'ISPV **************', '...se neposkytuje nemocenská dávka podle zákona o nemocenském pojištění (zákon č. 187/2006 Sb.).', true, 583, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 338, 318);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4583, '2013-07-30 00:00:00.000', 'ISPV **************', '...se neposkytuje nemocenská dávka podle zákona o nemocenském pojištění (zákon č. 187/2006 Sb.).', true, 584, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 338, 318);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4584, '2013-07-30 00:00:00.000', 'ISPV **************', '...se neposkytuje nemocenská dávka podle zákona o nemocenském pojištění (zákon č. 187/2006 Sb.).', true, 585, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 171, 318);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4585, '2013-07-30 00:00:00.000', 'ISPV **************', '...se neposkytuje nemocenská dávka podle zákona o nemocenském pojištění (zákon č. 187/2006 Sb.).', true, 586, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 171, 318);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4586, '2013-07-30 00:00:00.000', 'ISPV **************', '...se neposkytuje nemocenská dávka podle zákona o nemocenském pojištění (zákon č. 187/2006 Sb.).', true, 587, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 337, 318);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4587, '2013-07-30 00:00:00.000', 'ISPV **************', '...se neposkytuje nemocenská dávka podle zákona o nemocenském pojištění (zákon č. 187/2006 Sb.).', true, 588, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 337, 318);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4588, '2013-07-30 00:00:00.000', 'ISPV **************', 'svátek sumovaná z nemoci', true, 589, -1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 5, 343, 318);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4589, '2013-07-30 00:00:00.000', 'ISPV **************', 'svátek sumovaná z nemoci', true, 590, -1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 5, 343, 318);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4590, '2013-07-30 00:00:00.000', 'ISPV **************', 'Počet hodin z fondu pracovní doby neodpracovaných z důvodu dočasné pracovní neschopnosti (příp. karantény), za které se neposkytuje nemocenská dávka podle zákona o nemocenském pojištění (zákon č. 187/2006 Sb.).', true, 591, 0.0, 0.0, 1.0, 'hodiny', 'procMzd', 0.0, 0.0, 'mzdCalcOper.mensi', false, 0, true, 5, 318, 318);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4591, '2013-07-30 00:00:00.000', 'ISPV **************', 'Počet hodin z fondu pracovní doby neodpracovaných z důvodu dočasné pracovní neschopnosti (příp. karantény), za které se neposkytuje nemocenská dávka podle zákona o nemocenském pojištění (zákon č. 187/2006 Sb.).', true, 592, 1.0, 0.0, 0.0, 'hodiny', 'procMzd', 'hodiny', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, true, 5, 318, 318, 318);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4592, '2013-07-30 00:00:00.000', 'ISPV **************', '----- do hrubé mzdy', true, 593, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 35, 354);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4593, '2013-07-30 00:00:00.000', 'ISPV **************', 'Příplatek za práci v sobotu a neděli', true, 594, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 34, 354);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4594, '2013-07-30 00:00:00.000', 'ISPV **************', 'Příplatek za práci ve ztíženém prac. prostředí', true, 595, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 35, 354);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4595, '2013-07-30 00:00:00.000', 'ISPV **************', 'Příplatek za noční práci', true, 596, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 36, 354);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4596, '2013-07-30 00:00:00.000', 'ISPV **************', 'Příplatek za rozdělenou směnu', true, 597, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 37, 354);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4597, '2013-07-30 00:00:00.000', 'ISPV **************', 'Zvláštní příplatek', true, 598, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 40, 354);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4598, '2013-07-30 00:00:00.000', 'ISPV **************', 'Osobní hodnocení - příplatek (je počítán poměrně podobně jako měsíční mzda)', true, 599, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 41, 354);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4599, '2013-07-30 00:00:00.000', 'ISPV **************', 'Příplatek za vedení a zastupování (je počítán poměrně podobně jako měsíční mzda)', true, 600, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 42, 354);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4600, '2013-07-30 00:00:00.000', 'ISPV **************', 'Uživatelský příplatek ', true, 601, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 257, 354);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4601, '2013-07-30 00:00:00.000', 'ISPV **************', 'Uživatelský příplatek', true, 602, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 258, 354);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4602, '2013-07-30 00:00:00.000', 'ISPV **************', 'Uživatelský příplatek', true, 603, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 259, 354);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4603, '2013-07-30 00:00:00.000', 'ISPV **************', 'Uživatelský příplatek', true, 604, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 260, 354);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4604, '2013-07-30 00:00:00.000', 'ISPV **************', 'Uživatelský příplatek', true, 605, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 261, 354);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4605, '2013-07-30 00:00:00.000', 'ISPV **************', 'Uživatelský příplatek', true, 606, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 262, 354);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4606, '2013-07-30 00:00:00.000', 'ISPV **************', 'Uživatelský příplatek', true, 607, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 263, 354);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4607, '2013-07-30 00:00:00.000', 'ISPV **************', 'Uživatelský příplatek', true, 608, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 264, 354);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4608, '2013-07-30 00:00:00.000', 'ISPV **************', 'Uživatelský příplatek', true, 609, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 265, 354);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4609, '2013-07-30 00:00:00.000', 'ISPV **************', 'příplatek pro sumarizaci ISPV', true, 610, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, false, 5, 354, 323);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4610, '2013-07-30 00:00:00.000', 'ISPV **************', 'příplatek pro sumarizaci ISPV', true, 611, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 354, 323);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4611, '2013-07-30 00:00:00.000', 'ZÁKL.ZP-1 PRAC.POMĚR', 'Celkové zdravotní pojištění', true, 612, 1.0, 1.0, 0.0, 'castMzd', 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.rozdelPomer', false, 0, false, 5, 218, 163, 163);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4612, '2013-07-30 00:00:00.000', 'ZÁKL.ZP-1 PRAC.POMĚR', 'Zdravotní  pojištění - firma', true, 613, 1.0, 1.0, 0.0, 'castMzd', 'zaklMzd', 'procMzd', 0.0, 0.0, 'mzdCalcOper.rozdelPomer', false, 0, false, 5, 104, 163, 163);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4613, '2013-07-30 00:00:00.000', '17', '----- Sumace sociálního pojištění  A 2013', true, 614, 1.0, 0.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 102, 229);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4614, '2013-07-30 00:00:00.000', '17', '----- Sumace sociálního pojištění  B', true, 615, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 181, 229);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4615, '2013-07-30 00:00:00.000', '17', '----- Sumace sociálního pojištění  D', true, 616, 1.0, 0.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 98, 217);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (4616, '2013-07-30 00:00:00.000', '17', '----- Sumace sociálního pojištění  C', true, 617, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 5, 229, 217);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4617, '2013-07-30 00:00:00.000', 'ZÁKL.SOC.POJ.1 POMĚR', 'Celkové sociální pojištění', true, 618, 1.0, 1.0, 0.0, 'castMzd', 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.rozdelPomer', false, 0, false, 5, 217, 350, 350);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4618, '2013-07-30 00:00:00.000', 'ZÁKL.SOC.POJ.1 POMĚR', 'Sociální pojištění - firma', true, 619, 1.0, 1.0, 0.0, 'castMzd', 'zaklMzd', 'procMzd', 0.0, 0.0, 'mzdCalcOper.rozdelPomer', false, 0, false, 5, 229, 350, 350);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (4619, '2013-07-30 00:00:00.000', 'ZÁKL.SP-1 PRAC.POMĚR', 'Celkové sociální pojištění', true, 620, 1.0, 1.0, 0.0, 'castMzd;zaklMzd', 'zaklMzd;zaklMzd', 'castMzd;zaklMzd', 0.0, 0.0, 'mzdCalcOper.rozdelPomer', false, 0, false, 5, 217, 350, 162);

-- parametry pomeru
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idcismzdsloz)
 VALUES (120, '2013-07-30 00:00:00.000', '*', 'Nulování zálohové daně pro NEpodepisovatele do 5000', true, 10, 0.0, 5000.0, 0.0, 'castkaDen', 'procMzd', true, true, false, true, true, true, true, true, 5, 107);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idcismzdsloz)
 VALUES (121, '2013-07-30 00:00:00.000', 'ZÁKL.SRÁŽKOVÉ DANĚ', 'Základ pro výpočet srážkové daně', true, 20, 0.0, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd', true, true, true, false, true, true, true, true, 5, 157);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idcismzdsloz)
 VALUES (122, '2013-07-30 00:00:00.000', 'ZÁKL.SRÁŽKOVÉ DANĚ', 'Základ pro výpočet srážkové daně', '10.2.2010', true, 30, 5000.0001, 9.999999999999E12, 0.0, 'procMzd', 'zaklMzd;procMzd', true, true, false, true, true, true, true, true, 5, 157);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idcismzdsloz)
 VALUES (123, '2013-07-30 00:00:00.000', '*', 'Nulování doplatku do vyměřovacího základu zdravotního pojištění', true, 35, 0.0, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd', true, true, true, true, true, true, false, true, 5, 93);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
 VALUES (124, '2013-07-30 00:00:00.000', '*', 'Nulování sociálky pro malý rozsah do 2500', '', true, 40, 0.0, 2499.0, 0.0, 'zaklMzd', 'zaklMzd;procMzd', true, false, true, true, true, true, true, true, 5, 1, 162);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
 VALUES (125, '2013-07-30 00:00:00.000', '*', 'Nulování základu pro sociální pojištění  - pro pracovní poměry platící jen DP - společníci, jednatelé atd.  ', '', true, 41, 0.0, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd;procMzd', true, true, true, true, true, true, true, true, 5, 2, 221);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
 VALUES (126, '2013-07-30 00:00:00.000', '*', 'Nulování základu pro sociální pojištění  - pro pracovní poměry platící jen DP - společníci, jednatelé atd.  ', '', true, 42, 0.0, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd', true, true, true, true, true, true, true, true, 5, 4, 221);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
 VALUES (127, '2013-07-30 00:00:00.000', '*', 'Nulování základu pro sociální pojištění  - pro pracovní poměry platící jen DP - společníci, jednatelé atd.  ', '', true, 42, 0.0, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd;procMzd', true, true, true, true, true, true, true, true, 5, 1, 221);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
 VALUES (128, '2013-07-30 00:00:00.000', '*', 'Nulování základu pro sociální pojištění  - pro pracovní poměry platící jen DP - společníci, jednatelé atd.  ', '.... jen DP přestává být tímto využíván', true, 43, 0.0, 9.9999999999E10, 0.0, 'zaklMzd', 'zaklMzd;procMzd', true, true, false, true, true, true, true, true, 5, 5, 221);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
 VALUES (129, '2013-07-30 00:00:00.000', '*', 'Nulování základu pro sociální pojištění  - pro pracovní poměry platící jen DP - společníci, jednatelé atd.  ', '', true, 44, 0.0, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd;procMzd', true, true, true, true, true, true, true, true, 5, 7, 221);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
 VALUES (130, '2013-07-30 00:00:00.000', '*', 'Nulování základu pro sociální pojištění  - pro pracovní poměry platící jen DP - společníci, jednatelé atd.  ', 'doplněno 19.4.2011', true, 45, 0.0, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd;procMzd', true, true, true, true, true, true, true, true, 5, 8, 221);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
 VALUES (131, '2013-07-30 00:00:00.000', '*', 'Nulování základu pro sociální pojištění  - pro pracovní poměry platící jen DP - společníci, jednatelé atd.  ', '', true, 45, 0.0, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd;procMzd', true, true, true, true, true, true, true, true, 5, 6, 221);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
 VALUES (132, '2013-07-30 00:00:00.000', '*', 'Nulování základu pro sociální pojištění  - pro pracovní poměry platící jen DP - společníci, jednatelé atd.  ', 'doplněno 19.4.2011', true, 45, 0.0, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd;procMzd', true, true, true, true, true, true, true, true, 5, 10, 221);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
 VALUES (133, '2013-07-30 00:00:00.000', '*', 'Nulování základu pro sociální pojištění  - pro pracovní poměry platící jen DP - společníci, jednatelé atd.  ', 'doplněno 19.4.2011', true, 45, 0.0, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd;procMzd', true, true, true, true, true, true, true, true, 5, 9, 221);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
 VALUES (134, '2013-07-30 00:00:00.000', '*', 'Zdravotka se nuluje u DPP do 10 000 Kč - od roku 2012', '', true, 60, 0.0, 10000.0, 0.0, 'zaklMzd', 'zaklMzd;castMzd', true, true, true, true, true, true, true, true, 5, 2, 163);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
 VALUES (135, '2013-07-30 00:00:00.000', 'ZP-JE POJIŠTĚN 1 POM', 'Identifikace zdravotního pojištění pro jeden pracovní poměr', '', true, 62, 0.0, 10000.0, 0.0, 'zaklMzd', 'procMzd', true, true, true, true, false, true, true, true, 5, 2, 352);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
 VALUES (136, '2013-07-30 00:00:00.000', '*', 'Sociálka se nuluje u DPP do 10 000 Kč od roku 2012', '', true, 70, 0.0, 10000.0, 0.0, 'zaklMzd', 'zaklMzd;castMzd;procMzd', true, true, true, true, true, true, true, true, 5, 2, 162);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
 VALUES (137, '2013-07-30 00:00:00.000', '*', 'Nulování slevy na sociálce pro DPČ', '', true, 80, 0.0, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd', true, true, true, true, true, true, true, true, 5, 4, 219);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
 VALUES (138, '2013-07-30 00:00:00.000', '*', 'Nulování sociálky pro zaměstnání malého rozsahu', '', true, 90, 0.0, 2499.0, 0.0, 'zaklMzd', 'zaklMzd;procMzd', true, false, true, true, true, true, true, true, 5, 4, 162);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
 VALUES (139, '2013-07-30 00:00:00.000', '*', 'Nulování zdravotky vždy do 2500', '', true, 100, 0.0, 2499.0, 0.0, 'zaklMzd', 'zaklMzd', true, true, true, true, true, true, true, true, 5, 4, 163);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
 VALUES (140, '2013-07-30 00:00:00.000', '*', 'Nulování základu pro sociální pojištění  pro standardní pracovní poměry  ', '', true, 110, 0.0, 2499.0, 0.0, 'zaklMzd', 'zaklMzd', true, true, true, true, true, true, true, true, 5, 7, 162);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
 VALUES (141, '2013-07-30 00:00:00.000', 'ZÁKL.SP-1 PRAC.POMĚR', 'Nulování sociálního pojištění do částky 2499', '2012-02-29', true, 120, 0.0, 2499.0, 0.0, 'zaklMzd', 'zaklMzd', true, true, true, true, true, true, true, true, 5, 5, 162);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
 VALUES (142, '2013-07-30 00:00:00.000', '*', 'Nulování zdravotky vždy do 2500', '', true, 130, 0.0, 2499.0, 0.0, 'zaklMzd', 'zaklMzd', true, true, true, true, true, true, true, true, 5, 8, 163);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
 VALUES (143, '2013-07-30 00:00:00.000', '*', 'Sociálka se nuluje u krátkodobého zaměstnání vždy', '', true, 140, 0.0, 9.999999999999E12, 0.0, 'castMzd', 'zaklMzd;castMzd;procMzd', true, true, true, true, true, true, true, true, 5, 9, 162);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
 VALUES (144, '2013-07-30 00:00:00.000', '*', 'Nulování zdravotky vždy ', '', true, 150, 0.0, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd', true, true, true, true, true, true, true, true, 5, 6, 163);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
 VALUES (145, '2013-07-30 00:00:00.000', 'ZP-JE POJIŠTĚN 1 POM', 'Identifikace zdravotního pojištění pro jeden pracovní poměr', '', true, 155, 0.0, 9.999999999E9, 0.0, 'zaklMzd', 'procMzd', true, true, true, true, false, true, true, true, 5, 6, 352);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
 VALUES (146, '2013-07-30 00:00:00.000', '*', 'Nulování zdravotky vždy do 2500', '', true, 160, 0.0, 2499.0, 0.0, 'zaklMzd', 'zaklMzd', true, true, true, true, true, true, true, true, 5, 10, 163);

-- hromadne
INSERT INTO pmzdcalchrom (idmzdcalchrom, lastupdate, kod, nazev, popis, show, cisrad, zaokrjakk, zaokrnak, polein, poleout, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (40, '2013-07-30 00:00:00.000', 'SOC.FIRMA ZAOKR.', 'Soc. pojištění - Firma (pro všechny pracovní poměry) ', 'Dojde k celkovému zaokrouuhlení sumy sociálky firmy  a k rozpuštění mezi jednotlivé zaměstnance ', true, 1, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castMzd', 'castMzd', 5, 102, 181);

PERFORM pg_catalog.setval('seq_pmzdcalchlav', 5, true);
PERFORM pg_catalog.setval('seq_pmzdcalcinit', 142, true);
PERFORM pg_catalog.setval('seq_pmzdcalc', 4619, true);
PERFORM pg_catalog.setval('seq_ptyppracpomparam', 146, true);
PERFORM pg_catalog.setval('seq_pmzdcalchrom', 40, true);

-- nastavime hromadnou radku do hlavicky
UPDATE pmzdcalchlav SET idradkahromadne = 4613 WHERE idmzdcalchlav = 5;

-- konec ceskeho bloku
  end if; 
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 764, 't', %appVersion%, clock_timestamp());
