--------------------------------------------------------------------------------
-- Bug 43798 - Nová rozvaha platná od 1.1.2016 (CZ) 
-- Bug 43799 - Nový výkaz zisku a ztráty platný od 1.1.2016 
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION vytvorSestavaVysledovkaCzPodnikatele2016()
RETURNS void AS $$
DECLARE
  _idtyporgread integer;
BEGIN
  select idtyporg into _idtyporgread from nnastav limit 1;

  -- sestavy aktualizujeme jen pro cechy
  IF (_idtyporgread = 1) THEN
  -- zacatek bloku ceskych podnikatelu
update usestavy set platiDo = 2015 where kod in ('ROZVAHA2006', 'VÝSLEDOVKA2003');

UPDATE usestavy SET kod = kod || '_UZIV' WHERE kod IN ('ROZVAHA2016', 'VÝSLEDOVKA2016');

INSERT INTO usestavy (idsestavy, lastupdate, kod, nazev, nazeva, show, platiod, platido, typsesk, standard, vypminobd, nazevsloup1, nazevsloupa1, zobrazit1, nazevsloup2, nazevsloupa2, zobrazit2, nazevsloup3, nazevsloupa3, zobrazit3, zobrazit4, zobrazit5, nazevsloup6, nazevsloupa6, zobrazit6, sloupec3sum12, sloupec6sum45, rokod, rokdo, mesicod, mesicdo, predrokod, predrokdo, predmesicod, predmesicdo, typjednotkymikro, idtyporg, uuid)
 VALUES (6, '2016-03-22 00:00:00.000', 'ROZVAHA2016', 'Rozvaha v plném rozsahu od r. 2016', 'INCOME STATEMENT', true, 2016, 9999, 'typSestavy.rozvaha', true, true, 'brutto', 'Gross', true, 'korekce', 'Adjustments', true, 'netto', 'Net', true, false, false, 'minulé období netto', 'Prev. Acc. Period Net', true, true, true, 0, 0, 0, 0, 0, 0, 0, 0, false, 1, 'CZ_PODNIKATELE_ROZVAHA_2016');
INSERT INTO usestavy (idsestavy, lastupdate, kod, nazev, show, platiod, platido, typsesk, standard, vypminobd, nazevsloup1, zobrazit1, zobrazit2, zobrazit3, nazevsloup4, zobrazit4, zobrazit5, zobrazit6, sloupec3sum12, sloupec6sum45, rokod, rokdo, mesicod, mesicdo, predrokod, predrokdo, predmesicod, predmesicdo, typjednotkymikro, idtyporg, uuid)
 VALUES (7, '2016-03-22 00:00:00.000', 'VÝSLEDOVKA2016', 'Výkaz zisku a ztráty - druhové členění od r.2016', true, 2016, 9999, 'typSestavy.vysledov', true, true, 'Aktuální účetní období', true, false, false, 'Minulé účetní období', true, false, false, true, true, 0, 0, 0, 0, 0, 0, 0, 0, false, 1, 'CZ_PODNIKATELE_VYSLEDOVKA_2016');

 
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (201, '2016-03-22 00:00:00.000', 1, 'A', 'AKTIVA CELKEM', '', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (202, '2016-03-22 00:00:00.000', 2, 'A A.', 'Pohledávky za upsaný základní kapitál', '', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (203, '2016-03-22 00:00:00.000', 3, 'A B.', 'Dlouhodobý majetek', '', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (204, '2016-03-22 00:00:00.000', 4, 'A B.I.', 'Dlouhodobý nehmotný majetek', '', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (205, '2016-03-22 00:00:00.000', 5, 'A B.I.1.', 'Nehmotné výsledky výzkumu a vývoje', '', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (206, '2016-03-22 00:00:00.000', 6, 'A B.I.2.', 'Ocenitelná práva', '', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (207, '2016-03-22 00:00:00.000', 7, 'A B.I.2.1.', 'Software', '', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (208, '2016-03-22 00:00:00.000', 8, 'A B.I.2.2.', 'Ostatní ocenitelná práva', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (209, '2016-03-22 00:00:00.000', 9, 'A B.I.3.', 'Goodwill', '', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (210, '2016-03-22 00:00:00.000', 10, 'A B.I.4.', 'Ostatní dlouhodobý nehmotný majetek', '', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (211, '2016-03-22 00:00:00.000', 11, 'A B.I.5.', 'Poskytnuté zálohy na dlouhodobý nehmotný majetek a nedokončený nehmotný majetek', '', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (212, '2016-03-22 00:00:00.000', 12, 'A B.I.5.1.', 'Poskytnuté zálohy na dlouhodobý majetek', '', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (213, '2016-03-22 00:00:00.000', 13, 'A B.I.5.2.', 'Nedokončený dlouhodobý nehmotný majetek', '', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (214, '2016-03-22 00:00:00.000', 14, 'A B.II.', 'Dlouhodobý hmotný majetek', '', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (215, '2016-03-22 00:00:00.000', 15, 'A B.II.1.', 'Pozemky a stavby', '', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (216, '2016-03-22 00:00:00.000', 16, 'A B.II.1.1.', 'Pozemky', '', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (217, '2016-03-22 00:00:00.000', 17, 'A B.II.1.2.', 'Stavby', '', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (218, '2016-03-22 00:00:00.000', 18, 'A B.II.2.', 'Hmotné movité věci a jejich soubory', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (219, '2016-03-22 00:00:00.000', 19, 'A B.II.3', 'Oceňovací rozdíl k nabytému majetku', '', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (220, '2016-03-22 00:00:00.000', 20, 'A B.II.4.', 'Ostatní dlouhodobý hmotný majetek', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (221, '2016-03-22 00:00:00.000', 21, 'A B.II.4.1.', 'Pěstitelské celky trvalých porostů', '', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (222, '2016-03-22 00:00:00.000', 22, 'A B.II.4.2.', 'Dospělá zvířata a jejich skupiny', '', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (223, '2016-03-22 00:00:00.000', 23, 'A B.II.4.3.', 'Jiný dlouhodobý hmotný majetek', '', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (224, '2016-03-22 00:00:00.000', 24, 'A B.II.5.', 'Poskytnuté zálohy na dlouhodobý hmotný majetek a nedokončený dlouhodobý hmotný majetek', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (225, '2016-03-22 00:00:00.000', 25, 'A B.II.5.1.', 'Poskytnuté zálohy na dlouhodobý hmotný majetek', '', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (226, '2016-03-22 00:00:00.000', 26, 'A B.II.5.2.', 'Nedokončený dlouhodobý hmotný majetek', '', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (227, '2016-03-22 00:00:00.000', 27, 'A B.III.', 'Dlouhodobý finanční majetek', '', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (228, '2016-03-22 00:00:00.000', 28, 'A B.III.1.', 'Podíly - ovládaná nebo ovládající osoba', '', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (229, '2016-03-22 00:00:00.000', 29, 'A B.III.2.', 'Zápůjčky a úvěry - ovládaná nebo ovládající osoba', '', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (230, '2016-03-22 00:00:00.000', 30, 'A B.III.3.', 'Podíly - podstatný vliv', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (231, '2016-03-22 00:00:00.000', 31, 'A B.III.4.', 'Zápůjčky a úvěry - podstatný vliv', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (232, '2016-03-22 00:00:00.000', 32, 'A B.III.5.', 'Ostatní dlouhodobé cenné papíry a podíly', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (233, '2016-03-22 00:00:00.000', 33, 'A B.III.6.', 'Zápůjčky a úvěry - ostatní', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (234, '2016-03-22 00:00:00.000', 34, 'A B.III.7.', 'Ostatní dlouhodobý finanční majetek', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (235, '2016-03-22 00:00:00.000', 35, 'A B.III.7.1.', 'Jiný dlouhodobý finanční majetek', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (236, '2016-03-22 00:00:00.000', 36, 'A B.III.7.2.', 'Poskytnuté zálohy na dlouhodobý finanční majetek', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (237, '2016-03-22 00:00:00.000', 37, 'A C.', 'Oběžná aktiva', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (238, '2016-03-22 00:00:00.000', 38, 'A C.I.', 'Zásoby', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (239, '2016-03-22 00:00:00.000', 39, 'A C.I.1.', 'Materiál', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (240, '2016-03-22 00:00:00.000', 40, 'A C.I.2.', 'Nedokončená výroba a polotovary', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (241, '2016-03-22 00:00:00.000', 41, 'A C.I.3.', 'Výrobky a zboží', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (242, '2016-03-22 00:00:00.000', 42, 'A C.I.3.1.', 'Výrobky', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (243, '2016-03-22 00:00:00.000', 43, 'A C.I.3.2.', 'Zboží', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (244, '2016-03-22 00:00:00.000', 44, 'A C.I.4.', 'Mladá a ostatní zvířata a jejich skupiny', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (245, '2016-03-22 00:00:00.000', 45, 'A C.I.5.', 'Poskytnuté zálohy na zásoby', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (246, '2016-03-22 00:00:00.000', 46, 'A C.II.', 'Pohledávky', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (247, '2016-03-22 00:00:00.000', 47, 'A C.II.1.', 'Dlouhodobé pohledávky', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (248, '2016-03-22 00:00:00.000', 48, 'A C.II.1.1.', 'Pohledávky z obchodních vztahů', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (249, '2016-03-22 00:00:00.000', 49, 'A C.II.1.2.', 'Pohledávky - ovládaná nebo ovládající osoba', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (250, '2016-03-22 00:00:00.000', 50, 'A C.II.1.3.', 'Pohledávky - podstatný vliv', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (251, '2016-03-22 00:00:00.000', 51, 'A C.II.1.4.', 'Odložená daňová pohledávka', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (252, '2016-03-22 00:00:00.000', 52, 'A C.II.1.5.', 'Pohledávky - ostatní', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (253, '2016-03-22 00:00:00.000', 53, 'A C.II.1.5.1.', 'Pohledávky za společníky', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (254, '2016-03-22 00:00:00.000', 54, 'A C.II.1.5.2.', 'Dlouhodobé poskytnuté zálohy', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (255, '2016-03-22 00:00:00.000', 55, 'A C.II.1.5.3.', 'Dohadné účty aktivní', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (256, '2016-03-22 00:00:00.000', 56, 'A C.II.1.5.4.', 'Jiné pohledávky', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (257, '2016-03-22 00:00:00.000', 57, 'A C.II.2.', 'Krátkodobé pohledávky', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (258, '2016-03-22 00:00:00.000', 58, 'A C.II.2.1.', 'Pohledávky z obchodních vztahů', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (259, '2016-03-22 00:00:00.000', 59, 'A C.II.2.2.', 'Pohledávky - ovládaná nebo ovládající osoba', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (260, '2016-03-22 00:00:00.000', 60, 'A C.II.2.3.', 'Pohledávky - podstatný vliv', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (261, '2016-03-22 00:00:00.000', 61, 'A C.II.2.4.', 'Pohledávky - ostatní', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (262, '2016-03-22 00:00:00.000', 62, 'A C.II.2.4.1.', 'Pohledávky za společníky', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (263, '2016-03-22 00:00:00.000', 63, 'A C.II.2.4.2.', 'Sociální zabezpečení a zdravotní pojištění', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (264, '2016-03-22 00:00:00.000', 64, 'A C.II.2.4.3.', 'Stát - daňové pohledávky', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (265, '2016-03-22 00:00:00.000', 65, 'A C.II.2.4.4.', 'Krátkodobé poskytnuté zálohy', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (266, '2016-03-22 00:00:00.000', 66, 'A C.II.2.4.5.', 'Dohadné účty aktivní', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (267, '2016-03-22 00:00:00.000', 67, 'A C.II.2.4.6.', 'Jiné pohledávky', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (268, '2016-03-22 00:00:00.000', 68, 'A C.III.', 'Krátkodobý finanční majetek', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (269, '2016-03-22 00:00:00.000', 69, 'A C.III.1.', 'Podíly - ovládaná nebo ovládající osoba', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (270, '2016-03-22 00:00:00.000', 70, 'A C.III.2.', 'Ostatní krátkodobý finanční majetek', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (271, '2016-03-22 00:00:00.000', 71, 'A C.IV.', 'Peněžní prostředky', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (272, '2016-03-22 00:00:00.000', 72, 'A C.IV.1.', 'Peněžní prostředky v pokladně', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (273, '2016-03-22 00:00:00.000', 73, 'A C.IV.2.', 'Peněžní prostředky na účtech', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (274, '2016-03-22 00:00:00.000', 74, 'A D.', 'Časové rozlišení aktiv', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (275, '2016-03-22 00:00:00.000', 75, 'A D.1.', 'Náklady příštích období', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (276, '2016-03-22 00:00:00.000', 76, 'A D.2.', 'komplexní náklady příštích období', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (277, '2016-03-22 00:00:00.000', 77, 'A D.3.', 'Příjmy příštích období', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (278, '2016-03-22 00:00:00.000', 78, 'P', 'PASIVA CELKEM', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (279, '2016-03-22 00:00:00.000', 79, 'P A.', 'Vlastní kapitál', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (280, '2016-03-22 00:00:00.000', 80, 'P A.I.', 'Základní kapitál', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (281, '2016-03-22 00:00:00.000', 81, 'P A.I.1.', 'Základní kapitál', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (282, '2016-03-22 00:00:00.000', 82, 'P A.I.2.', 'Vlastní podíly', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (283, '2016-03-22 00:00:00.000', 83, 'P A.I.3.', 'Změny základního kapitálu', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (284, '2016-03-22 00:00:00.000', 84, 'P A.II.', 'Ážio a kapitálové fondy', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (285, '2016-03-22 00:00:00.000', 85, 'P A.II.1.', 'Ážio', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (286, '2016-03-22 00:00:00.000', 86, 'P A.II.2.', 'Kapitálové fondy', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (287, '2016-03-22 00:00:00.000', 87, 'P A.II.2.1.', 'Ostatní kapitálové fondy', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (288, '2016-03-22 00:00:00.000', 88, 'P A.II.2.2.', 'Oceňovací rozdíly z přecenění majetku a závazků (+/-)', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (289, '2016-03-22 00:00:00.000', 89, 'P A.II.2.3.', 'Oceňovací rozdíly z přecenění při přeměnách obchodních korporací (+/-)', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (290, '2016-03-22 00:00:00.000', 90, 'P A.II.2.4.', 'Rozdíly z přeměn obchodních korporací (+/-)', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (291, '2016-03-22 00:00:00.000', 91, 'P A.II.2.5.', 'Rozdíly z ocenění při přeměnách obchodních korporací (+/-)', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (292, '2016-03-22 00:00:00.000', 92, 'P A.III.', 'Fodny ze zisku', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (293, '2016-03-22 00:00:00.000', 93, 'P A.III.1.', 'Ostatní rezervní fondy', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (294, '2016-03-22 00:00:00.000', 94, 'P A.III.2.', 'Statutární a ostatní fondy', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (295, '2016-03-22 00:00:00.000', 95, 'P A.IV.', 'Výsledek hospodaření z minulých let (+/-)', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (296, '2016-03-22 00:00:00.000', 96, 'P A.IV.1.', 'Nerozdělený zisk minulých let', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (297, '2016-03-22 00:00:00.000', 97, 'P A.IV.2.', 'Neuhrazená ztráta minulých let (-)', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (298, '2016-03-22 00:00:00.000', 98, 'P A.IV.3.', 'Jiný výsledek hospodaření minulých let (+/-)', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (299, '2016-03-22 00:00:00.000', 99, 'P A.V.', 'Výsledek hospodaření běžného účetního období', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (300, '2016-03-22 00:00:00.000', 100, 'P A.VI.', 'Rozhodnuto o zálohové výplatě podílu ze zisku', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (301, '2016-03-22 00:00:00.000', 101, 'P B+C', 'CIZÍ ZDROJE', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (302, '2016-03-22 00:00:00.000', 102, 'P B.', 'Rezervy', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (303, '2016-03-22 00:00:00.000', 103, 'P B.1.', 'Rezervy na důchody a podobné závazky', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (304, '2016-03-22 00:00:00.000', 104, 'P B.2.', 'Rezerva na daň z příjmů', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (305, '2016-03-22 00:00:00.000', 105, 'P B.3.', 'Rezervy podle zvláštních právních předpisů', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (306, '2016-03-22 00:00:00.000', 106, 'P B.4.', 'Ostatní rezervy', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (307, '2016-03-22 00:00:00.000', 107, 'P C.', 'Závazky', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (308, '2016-03-22 00:00:00.000', 108, 'P C.I.', 'Dlouhodobé závazky', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (309, '2016-03-22 00:00:00.000', 109, 'P C.I.1.', 'Vydané dluhopisy', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (310, '2016-03-22 00:00:00.000', 110, 'P C.I.1.1.', 'Vyměnitelné dluhopisy', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (311, '2016-03-22 00:00:00.000', 111, 'P C.I.1.2.', 'Ostatní dluhopisy', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (312, '2016-03-22 00:00:00.000', 112, 'P C.I.2.', 'Závazky k úvěrovým institucím', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (313, '2016-03-22 00:00:00.000', 113, 'P C.I.3.', 'Dlouhodobé přijaté zálohy', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (314, '2016-03-22 00:00:00.000', 114, 'P C.I.4.', 'Závazky z obchodních vztahů', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (315, '2016-03-22 00:00:00.000', 115, 'P C.I.5.', 'Dlouhodobé směnky k úhradě', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (316, '2016-03-22 00:00:00.000', 116, 'P C.I.6.', 'Závazky - ovládaná nebo ovládající osoba', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (317, '2016-03-22 00:00:00.000', 117, 'P C.I.7.', 'Závazky - podstatný vliv', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (318, '2016-03-22 00:00:00.000', 118, 'P C.I.8.', 'Odložený daňový závazek', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (319, '2016-03-22 00:00:00.000', 119, 'P C.I.9.', 'Závazky - ostatní', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (320, '2016-03-22 00:00:00.000', 120, 'P C.I.9.1.', 'Závazky ke společníkům', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (321, '2016-03-22 00:00:00.000', 121, 'P C.I.9.2.', 'Dohadné účty pasivní', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (322, '2016-03-22 00:00:00.000', 122, 'P C.I.9.3.', 'Jiné závazky', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (323, '2016-03-22 00:00:00.000', 123, 'P C.II.', 'Krátkodobé závazky', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (324, '2016-03-22 00:00:00.000', 124, 'P C.II.1.', 'Vydané dluhopisy', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (325, '2016-03-22 00:00:00.000', 125, 'P C.II.1.1.', 'Vyměnitelné dluhopisy', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (326, '2016-03-22 00:00:00.000', 126, 'P C.II.1.2.', 'Ostatní dluhopisy', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (327, '2016-03-31 00:00:00.000', 127, 'P C.II.2.', 'Závazky k úvěrovým institucím', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (328, '2016-03-22 00:00:00.000', 128, 'P C.II.3.', 'Krátkodobé přijaté zálohy', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (329, '2016-03-22 00:00:00.000', 129, 'P C.II.4.', 'Závazky z obchodních vztahů', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (330, '2016-03-22 00:00:00.000', 130, 'P C.II.5.', 'Krátkodobé směnky k úhradě', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (331, '2016-03-22 00:00:00.000', 131, 'P C.II.6.', 'Závazky - ovládaná nebo ovládající osoba', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (332, '2016-03-22 00:00:00.000', 132, 'P C.II.7.', 'Závazky - podstatný vliv', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (333, '2016-03-22 00:00:00.000', 133, 'P C.II.8.', 'Závazky ostatní', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (334, '2016-03-22 00:00:00.000', 134, 'P C.II.8.1.', 'Závazky ke společníkům', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (335, '2016-03-22 00:00:00.000', 135, 'P C.II.8.2.', 'Krátkodobé finanční výpomoci', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (336, '2016-03-22 00:00:00.000', 136, 'P C.II.8.3.', 'Závazky k zaměstnancům', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (337, '2016-03-22 00:00:00.000', 137, 'P C.II.8.4.', 'Závazky ze sociálního zabezpečení a zdravotního pojištění', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (338, '2016-03-22 00:00:00.000', 138, 'P C.II.8.5.', 'Stát - daňové závazky a dotace', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (339, '2016-03-22 00:00:00.000', 139, 'P C.II.8.6.', 'Dohadné účty pasivní', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (340, '2016-03-22 00:00:00.000', 140, 'P C.II.8.7.', 'Jiné závazky', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (341, '2016-03-22 00:00:00.000', 141, 'P D.', 'Časové rozlišení pasiv', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (342, '2016-03-22 00:00:00.000', 142, 'P D.1.', 'Výdaje příštích období', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (343, '2016-03-22 00:00:00.000', 143, 'P D.2.', 'Výnosy příštích období', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 6);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (344, '2016-03-22 00:00:00.000', 1, 'I.', 'Tržby z prodeje výrobků a služeb', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (345, '2016-03-22 00:00:00.000', 2, 'II.', 'Tržby za prodej zboží', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (346, '2016-03-22 00:00:00.000', 3, 'A.', 'Výkonová spotřeba', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (347, '2016-03-22 00:00:00.000', 4, 'A.1.', 'Náklady vynaložené na prodané zboží', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (348, '2016-03-22 00:00:00.000', 5, 'A.2.', 'Spotřeba materiálu a energie', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (349, '2016-03-22 00:00:00.000', 6, 'A.3.', 'Služby', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (350, '2016-03-22 00:00:00.000', 7, 'B.', 'Změna stavu vlastní činnosti (+/-)', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (351, '2016-03-22 00:00:00.000', 8, 'C.', 'Aktivace (-)', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (352, '2016-03-22 00:00:00.000', 9, 'D.', 'Ostatní náklady', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (353, '2016-03-22 00:00:00.000', 10, 'D.1.', 'Mzdové náklady', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (354, '2016-03-22 00:00:00.000', 11, 'D.2.', 'Náklady na sociální zabezpečení, zdravotní pojištění a ostatní náklady', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (355, '2016-03-22 00:00:00.000', 12, 'D.2.1.', 'Náklady na sociální zabezpečení a zdravotní pojištění', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (356, '2016-03-22 00:00:00.000', 13, 'D.2.2.', 'Ostatní náklady', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (357, '2016-03-22 00:00:00.000', 14, 'E.', 'Úpravy hodnot v provozní oblasti', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (358, '2016-03-22 00:00:00.000', 15, 'E.1.', 'Úpravy hodnot dlouhodobého nehmotného a hmotného majetku', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (359, '2016-03-22 00:00:00.000', 16, 'E.1.1.', 'Úpravy hodnot dlouhodobého nehmotného a hmotného majetku - trvalé', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (360, '2016-03-22 00:00:00.000', 17, 'E.1.2.', 'Úpravy hodnot dlouhodobého nehmotného a hmotného majetku - dočasné', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (361, '2016-03-22 00:00:00.000', 18, 'E.2.', 'Úpravy hodnot zásob', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (362, '2016-03-22 00:00:00.000', 19, 'E.3.', 'Úpravy hodnot pohledávek', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (363, '2016-03-22 00:00:00.000', 20, 'III.', 'Ostatní provozní výnosy', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (364, '2016-03-22 00:00:00.000', 21, 'III.1.', 'Tržby z prodaného dlouhodobého majetku', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (365, '2016-03-22 00:00:00.000', 22, 'III.2.', 'Tržby z prodaného materiálu', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (366, '2016-03-22 00:00:00.000', 23, 'III.3.', 'JIné provozní výnosy', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (367, '2016-03-22 00:00:00.000', 24, 'F.', 'Ostatní provozní náklady', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (368, '2016-03-22 00:00:00.000', 25, 'F.1.', 'Zůstatková cena prodaného dlouhodobého majetku', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (369, '2016-03-22 00:00:00.000', 26, 'F.2.', 'Zůstatková cena prodaného materiálu', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (370, '2016-03-22 00:00:00.000', 27, 'F.3.', 'Daně a poplatky', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (371, '2016-03-22 00:00:00.000', 28, 'F.4.', 'Rezervy v provozní oblasti a komplexní náklady příštích období', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (372, '2016-03-22 00:00:00.000', 29, 'F.5.', 'Jiné provozní náklady', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (373, '2016-03-22 00:00:00.000', 30, '*', 'Provozní výsledek hospodaření (+/-)', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (374, '2016-03-22 00:00:00.000', 31, 'IV.', 'Výnosy z dlouhodobého finančního majetku - podíly', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (375, '2016-03-22 00:00:00.000', 32, 'IV.1.', 'Výnosy z podílů - ovládaná nebo ovládající osoba', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (376, '2016-03-22 00:00:00.000', 33, 'IV.2.', 'Ostatní výnosy z podílů', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (377, '2016-03-22 00:00:00.000', 34, 'G.', 'Náklady vynaložené na prodané podíly', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (378, '2016-03-22 00:00:00.000', 35, 'V.', 'Výnosy ostatního dlouhodobého finančního majetku', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (379, '2016-03-22 00:00:00.000', 36, 'V.1.', 'Výnosy z ostatního dlouhodobého majetku - ovládaná nebo ovládající osoba', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (380, '2016-03-22 00:00:00.000', 37, 'V.2.', 'Ostatní výnosy z ostatního dlouhodobého finančního majetku', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (381, '2016-03-22 00:00:00.000', 38, 'H.', 'Náklady související s ostatním dlouhodobým finančním majetkem', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (382, '2016-03-22 00:00:00.000', 39, 'VI.', 'Výnosové úroky a podobné výnosy', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (383, '2016-03-22 00:00:00.000', 40, 'VI.1.', 'Výnosové úroky a podobné výnosy - ovládaná nebo ovládající osoba', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (384, '2016-03-22 00:00:00.000', 41, 'VI.2.', 'Ostatní výnosové úroky a podobné výnosy', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (385, '2016-03-22 00:00:00.000', 42, 'I.', 'Úpravy hodnot a rezervy ve finanční oblasti', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (386, '2016-03-22 00:00:00.000', 43, 'J.', 'Nákladové úroky a podobné náklady', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (387, '2016-03-22 00:00:00.000', 44, 'J.1.', 'Nákladové úroky a podobné náklady - ovládaná nebo ovládající osoba', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (388, '2016-03-22 00:00:00.000', 45, 'J.2.', 'Ostatní nákladové úroky a podobné náklady', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (389, '2016-03-22 00:00:00.000', 46, 'VII.', 'Ostatní finanční výnosy', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (390, '2016-03-22 00:00:00.000', 47, 'K.', 'Ostatní finanční náklady', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, popis, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (391, '2016-03-22 00:00:00.000', 48, '*', 'Finanční výsledek hospodaření (+/-)', true, '', 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (392, '2016-03-22 00:00:00.000', 49, '**', 'Výsledek hospodaření před zdaněním (+/-)', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (393, '2016-03-22 00:00:00.000', 50, 'L.', 'Daň z příjmů', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (394, '2016-03-22 00:00:00.000', 51, 'L.1.', 'Daň z příjmů splatná', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (395, '2016-03-22 00:00:00.000', 52, 'L.2.', 'Daň z příjmů odložená (+/-)', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (396, '2016-03-22 00:00:00.000', 53, '**', 'Výsledek hospodaření po zdanění (+/-)', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (397, '2016-03-22 00:00:00.000', 54, 'M.', 'Převod podílu na výsledku hospodaření společníkům', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (398, '2016-03-22 00:00:00.000', 55, '***', 'Výsledek hospodaření za účetní období (+/-)', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (399, '2016-03-22 00:00:00.000', 56, '*', 'Čistý obrat za účetní období', true, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 7);


INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (501, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 202, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_353'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (502, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 205, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_012'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (503, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 205, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_072'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (504, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 205, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_091'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (505, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 207, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_013'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (506, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 207, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_073'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (507, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 207, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_091'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (508, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 208, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_014'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (509, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 208, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_074'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (510, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 208, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_091'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (511, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 209, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_015'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (512, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 209, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_075'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (513, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 209, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_091'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (514, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 210, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_019'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (515, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 210, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_079'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (516, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 210, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_091'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (517, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 212, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_051'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (518, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 212, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_095'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (519, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 213, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_041'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (520, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 213, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_093'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (521, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 216, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_031'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (522, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 216, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_092'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (523, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 217, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_021'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (524, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 217, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_081'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (525, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 217, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_092'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (526, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 218, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_022'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (527, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 218, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_082'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (528, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 218, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_092'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (529, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 219, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_097'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (530, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 219, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_098'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (531, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 221, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_025'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (532, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 221, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_085'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (533, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 221, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_092'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (534, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 222, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_026'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (535, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 222, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_086'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (536, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 222, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_092'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (537, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 223, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_029'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (538, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 223, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_032'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (539, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 223, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_089'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (540, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 223, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_092'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (541, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 225, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_052'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (542, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 225, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_095'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (543, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 226, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_042'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (544, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 226, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_094'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (545, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 228, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_061'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (546, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 228, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_043'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (547, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 228, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_096'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (548, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 229, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_066'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (549, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 229, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_096'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (550, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 230, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_062'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (551, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 230, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_043'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (552, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 230, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_096'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (553, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 231, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_067'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (554, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 231, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_096'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (555, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 232, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_063'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (556, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 232, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_065'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (557, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 232, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_043'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (558, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 232, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_096'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (559, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 233, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_068'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (560, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 233, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_096'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (561, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 235, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_069'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (562, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 235, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_043'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (563, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 235, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_096'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (564, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 236, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_053'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (565, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 236, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_095'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (566, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 239, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_112'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (567, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 239, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_119'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (568, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 239, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_191'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (569, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 240, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_121'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (570, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 240, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_122'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (571, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 240, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_192'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (572, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 240, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_193'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (573, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 242, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_123'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (574, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 242, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_194'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (575, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 243, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_132'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (576, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 243, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_139'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (577, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 243, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_196'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (578, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 244, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_124'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (579, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 244, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_195'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (580, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 245, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_151'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (581, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 245, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_152'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (582, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 245, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_153'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (583, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 245, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_197'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (584, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 245, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_198'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (585, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 245, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_199'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (586, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 248, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_311'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (587, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 248, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_313'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (588, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 248, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_315'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (589, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 248, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_391'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (590, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 249, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_351'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (591, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 249, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_391'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (592, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 250, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_352'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (593, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 250, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_391'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (594, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, true, 251, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_481'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (595, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 253, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_354'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (596, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 253, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_355'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (597, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 253, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_358'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (598, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 253, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_391'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (599, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 254, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_314'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (600, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 254, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_391'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (601, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 255, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_388'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (602, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 256, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_335'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (603, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 256, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_371'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (604, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, true, 256, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_373'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (605, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 256, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_374'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (606, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 256, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_375'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (607, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 256, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_376'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (608, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 256, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_378'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (609, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 256, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_391'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (610, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 258, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_311'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (611, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 258, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_313'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (612, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 258, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_315'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (613, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 258, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_391'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (614, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 259, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_351'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (615, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 259, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_391'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (616, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 260, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_352'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (617, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 260, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_391'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (618, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 262, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_354'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (619, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 262, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_355'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (620, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 262, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_358'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (621, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, true, 262, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_398'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (622, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 262, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_391'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (623, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, true, 263, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_336'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (624, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 263, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_391'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (625, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, true, 264, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_341'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (626, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, true, 264, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_342'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (627, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, true, 264, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_343'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (628, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, true, 264, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_345'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (629, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 264, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_391'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (630, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 265, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_314'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (631, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 265, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_391'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (632, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 266, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_388'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (633, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 267, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_335'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (634, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 267, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_371'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (635, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, true, 267, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_373'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (636, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 267, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_374'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (637, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 267, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_375'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (638, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 267, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_376'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (639, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 267, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_378'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (640, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 267, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_391'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (641, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 269, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_254'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (642, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 269, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_259'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (643, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 269, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_291'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (644, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 270, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_251'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (645, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 270, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_253'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (646, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 270, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_256'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (647, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 270, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_257'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (648, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 270, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_259'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (649, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 2, 'zpusobVypo.stavKon', false, false, 270, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_291'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (650, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 272, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_211'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (651, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 272, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_213'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (652, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 272, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_261'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (653, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 273, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_221'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (654, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 273, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_261'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (655, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 275, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_381'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (656, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 276, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_382'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (657, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 277, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_385'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (658, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 281, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_411'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (659, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 281, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_491'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (660, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 282, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_252'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (661, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 283, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_419'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (662, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 285, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_412'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (663, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 287, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_413'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (664, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 288, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_414'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (665, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 289, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_418'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (666, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 290, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_417'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (667, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 291, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_416'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (668, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 293, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_421'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (669, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 294, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_423'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (670, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 294, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_427'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (671, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 296, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_428'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (672, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 297, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_429'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (673, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 298, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_426'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (674, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 300, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_432'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (675, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 303, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_459'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (676, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 304, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_453'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (677, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 305, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_451'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (678, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 306, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_459'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (679, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 310, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_473'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (680, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 310, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_255'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (681, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 311, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_473'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (682, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 311, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_255'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (683, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 312, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_461'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (684, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 313, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_475'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (685, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 314, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_479'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (686, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 315, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_478'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (687, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 316, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_471'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (688, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 317, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_472'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (689, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, true, 318, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_481'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (690, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 320, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_364'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (691, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 320, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_365'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (692, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 320, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_366'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (693, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 320, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_367'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (694, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 320, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_368'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (695, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 321, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_389'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (696, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 322, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_372'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (697, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, true, 322, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_373'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (698, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 322, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_377'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (699, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 322, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_379'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (700, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 322, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_474'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (701, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 322, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_479'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (702, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 325, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_241'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (703, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 325, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_473'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (704, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 325, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_255'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (705, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 326, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_241'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (706, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 326, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_473'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (707, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 326, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_255'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (708, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 327, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_231'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (709, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 327, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_232'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (710, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 327, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_461'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (711, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 328, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_324'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (712, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 328, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_475'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (713, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 329, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_321'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (714, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 329, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_325'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (715, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 329, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_479'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (716, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 330, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_322'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (717, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 330, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_478'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (718, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 331, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_361'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (719, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 331, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_471'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (720, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 332, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_362'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (721, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 332, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_472'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (722, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 334, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_364'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (723, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 334, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_365'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (724, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 334, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_366'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (725, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 334, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_367'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (726, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 334, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_368'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (727, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, true, 334, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_398'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (728, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 335, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_249'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (729, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 336, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_331'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (730, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 336, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_333'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (731, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 336, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_479'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (732, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, true, 337, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_336'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (733, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, true, 338, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_341'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (734, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, true, 338, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_342'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (735, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, true, 338, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_343'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (736, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, true, 338, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_345'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (737, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, true, 338, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_346'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (738, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 338, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_347'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (739, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 339, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_389'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (740, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 340, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_372'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (741, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, true, 340, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_373'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (742, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 340, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_377'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (743, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 340, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_379'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (744, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 340, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_474'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (745, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 340, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_479'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (746, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 342, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_383'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (747, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 343, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_384'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (748, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 239, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_111'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (749, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 243, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_131'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (750, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 248, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_395'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (751, '2016-03-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 258, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_395'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (752, '2016-03-22 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 296, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_431'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (753, '2016-03-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 344, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_601'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (754, '2016-03-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 344, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_602'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (755, '2016-03-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 345, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_604'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (756, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 347, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_504'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (757, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 348, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_501'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (758, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 348, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_502'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (759, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 348, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_503'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (760, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 349, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_511'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (761, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 349, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_512'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (762, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 349, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_513'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (763, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 349, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_518'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (764, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 350, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_581'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (765, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 350, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_582'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (766, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 350, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_583'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (767, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 350, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_584'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (768, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 351, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_585'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (769, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 351, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_586'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (770, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 351, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_587'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (771, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 351, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_588'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (772, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 353, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_521'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (773, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 353, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_522'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (774, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 353, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_523'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (775, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 355, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_524'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (776, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 355, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_525'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (777, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 355, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_526'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (778, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 356, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_527'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (779, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 356, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_528'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (780, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 359, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_551'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (781, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 359, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_557'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (782, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 360, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_559'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (783, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 361, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_559'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (784, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 362, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_558'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (785, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 362, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_559'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (786, '2016-03-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 364, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_641'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (787, '2016-03-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 365, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_642'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (788, '2016-03-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 366, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_644'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (789, '2016-03-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 366, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_646'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (790, '2016-03-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 366, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_648'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (791, '2016-03-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 366, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_649'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (792, '2016-03-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 366, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_697'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (793, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 368, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_541'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (794, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 369, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_542'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (795, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 370, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_531'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (796, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 370, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_532'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (797, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 370, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_538'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (798, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 371, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_552'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (799, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 371, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_554'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (800, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 371, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_555'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (801, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 372, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_543'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (802, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 372, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_544'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (803, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 372, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_545'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (804, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 372, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_546'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (805, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 372, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_547'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (806, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 372, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_548'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (807, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 372, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_549'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (808, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 372, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_597'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (809, '2016-03-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 375, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_661'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (810, '2016-03-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 375, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_665'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (811, '2016-03-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 376, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_661'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (812, '2016-03-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 376, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_665'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (813, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 377, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_561'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (814, '2016-03-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 379, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_661'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (815, '2016-03-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 379, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_665'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (816, '2016-03-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 380, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_661'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (817, '2016-03-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 380, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_665'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (818, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 381, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_561'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (819, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 381, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_566'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (820, '2016-03-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 383, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_662'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (821, '2016-03-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 383, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_665'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (822, '2016-03-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 384, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_662'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (823, '2016-03-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 384, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_665'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (824, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 385, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_574'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (825, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 385, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_579'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (826, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 387, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_562'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (827, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 388, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_562'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (828, '2016-03-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 389, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_661'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (829, '2016-03-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 389, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_663'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (830, '2016-03-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 389, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_664'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (831, '2016-03-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 389, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_666'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (832, '2016-03-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 389, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_667'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (833, '2016-03-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 389, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_668'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (834, '2016-03-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 389, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_669'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (835, '2016-03-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 389, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_698'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (836, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 390, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_561'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (837, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 390, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_563'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (838, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 390, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_564'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (839, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 390, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_565'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (840, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 390, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_566'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (841, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 390, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_567'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (842, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 390, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_568'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (843, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 390, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_569'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (844, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 390, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_598'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (845, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 394, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_591'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (846, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 394, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_595'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (847, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 394, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_599'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (848, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 395, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_592'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (849, '2016-03-22 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 397, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_596'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (850, '2016-03-31 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 327, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_221'));
 

INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (401, '2016-03-22 00:00:00.000', false, 201, 202);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (402, '2016-03-22 00:00:00.000', false, 201, 203);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (403, '2016-03-22 00:00:00.000', false, 203, 204);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (404, '2016-03-22 00:00:00.000', false, 204, 205);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (405, '2016-03-22 00:00:00.000', false, 204, 206);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (406, '2016-03-22 00:00:00.000', false, 206, 207);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (407, '2016-03-22 00:00:00.000', false, 206, 208);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (408, '2016-03-22 00:00:00.000', false, 211, 212);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (409, '2016-03-22 00:00:00.000', false, 211, 213);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (410, '2016-03-22 00:00:00.000', false, 204, 209);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (411, '2016-03-22 00:00:00.000', false, 204, 210);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (412, '2016-03-22 00:00:00.000', false, 204, 211);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (413, '2016-03-22 00:00:00.000', false, 215, 216);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (414, '2016-03-22 00:00:00.000', false, 214, 215);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (415, '2016-03-22 00:00:00.000', false, 203, 214);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (416, '2016-03-22 00:00:00.000', false, 215, 217);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (417, '2016-03-22 00:00:00.000', false, 220, 221);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (418, '2016-03-22 00:00:00.000', false, 220, 222);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (419, '2016-03-22 00:00:00.000', false, 220, 223);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (420, '2016-03-22 00:00:00.000', false, 214, 218);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (421, '2016-03-22 00:00:00.000', false, 214, 219);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (422, '2016-03-22 00:00:00.000', false, 214, 220);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (423, '2016-03-22 00:00:00.000', false, 224, 225);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (424, '2016-03-22 00:00:00.000', false, 224, 226);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (425, '2016-03-22 00:00:00.000', false, 214, 224);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (426, '2016-03-22 00:00:00.000', false, 234, 235);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (427, '2016-03-22 00:00:00.000', false, 234, 236);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (428, '2016-03-22 00:00:00.000', false, 227, 228);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (429, '2016-03-22 00:00:00.000', false, 227, 229);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (430, '2016-03-22 00:00:00.000', false, 227, 230);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (431, '2016-03-22 00:00:00.000', false, 227, 231);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (432, '2016-03-22 00:00:00.000', false, 227, 232);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (433, '2016-03-22 00:00:00.000', false, 227, 233);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (434, '2016-03-22 00:00:00.000', false, 227, 234);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (435, '2016-03-22 00:00:00.000', false, 203, 227);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (436, '2016-03-22 00:00:00.000', false, 241, 242);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (437, '2016-03-22 00:00:00.000', false, 241, 243);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (438, '2016-03-22 00:00:00.000', false, 238, 239);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (439, '2016-03-22 00:00:00.000', false, 238, 240);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (440, '2016-03-22 00:00:00.000', false, 238, 241);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (441, '2016-03-22 00:00:00.000', false, 238, 244);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (442, '2016-03-22 00:00:00.000', false, 238, 245);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (443, '2016-03-22 00:00:00.000', false, 237, 238);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (444, '2016-03-22 00:00:00.000', false, 252, 253);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (445, '2016-03-22 00:00:00.000', false, 252, 254);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (446, '2016-03-22 00:00:00.000', false, 252, 255);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (447, '2016-03-22 00:00:00.000', false, 252, 256);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (448, '2016-03-22 00:00:00.000', false, 247, 248);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (449, '2016-03-22 00:00:00.000', false, 247, 249);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (450, '2016-03-22 00:00:00.000', false, 247, 250);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (451, '2016-03-22 00:00:00.000', false, 247, 251);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (452, '2016-03-22 00:00:00.000', false, 247, 252);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (453, '2016-03-22 00:00:00.000', false, 246, 247);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (454, '2016-03-22 00:00:00.000', false, 237, 246);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (455, '2016-03-22 00:00:00.000', false, 257, 258);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (456, '2016-03-22 00:00:00.000', false, 257, 259);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (457, '2016-03-22 00:00:00.000', false, 257, 260);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (458, '2016-03-22 00:00:00.000', false, 261, 262);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (459, '2016-03-22 00:00:00.000', false, 261, 263);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (460, '2016-03-22 00:00:00.000', false, 261, 264);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (461, '2016-03-22 00:00:00.000', false, 261, 265);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (462, '2016-03-22 00:00:00.000', false, 261, 266);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (463, '2016-03-22 00:00:00.000', false, 261, 267);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (464, '2016-03-22 00:00:00.000', false, 257, 261);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (465, '2016-03-22 00:00:00.000', false, 268, 269);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (466, '2016-03-22 00:00:00.000', false, 268, 270);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (467, '2016-03-22 00:00:00.000', false, 237, 268);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (468, '2016-03-22 00:00:00.000', false, 271, 272);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (469, '2016-03-22 00:00:00.000', false, 271, 273);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (470, '2016-03-22 00:00:00.000', false, 237, 271);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (471, '2016-03-22 00:00:00.000', false, 274, 275);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (472, '2016-03-22 00:00:00.000', false, 274, 276);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (473, '2016-03-22 00:00:00.000', false, 274, 277);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (474, '2016-03-22 00:00:00.000', false, 201, 237);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (475, '2016-03-22 00:00:00.000', false, 201, 274);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (476, '2016-03-22 00:00:00.000', false, 246, 257);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (477, '2016-03-22 00:00:00.000', false, 278, 279);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (478, '2016-03-22 00:00:00.000', false, 280, 281);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (479, '2016-03-22 00:00:00.000', false, 280, 282);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (480, '2016-03-22 00:00:00.000', false, 280, 283);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (481, '2016-03-22 00:00:00.000', false, 279, 280);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (482, '2016-03-22 00:00:00.000', false, 286, 287);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (483, '2016-03-22 00:00:00.000', false, 286, 288);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (484, '2016-03-22 00:00:00.000', false, 286, 289);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (485, '2016-03-22 00:00:00.000', false, 286, 290);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (486, '2016-03-22 00:00:00.000', false, 286, 291);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (487, '2016-03-22 00:00:00.000', false, 284, 285);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (488, '2016-03-22 00:00:00.000', false, 284, 286);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (489, '2016-03-22 00:00:00.000', false, 279, 284);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (490, '2016-03-22 00:00:00.000', false, 292, 293);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (491, '2016-03-22 00:00:00.000', false, 292, 294);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (492, '2016-03-22 00:00:00.000', false, 279, 292);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (493, '2016-03-22 00:00:00.000', false, 295, 296);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (494, '2016-03-22 00:00:00.000', false, 295, 297);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (495, '2016-03-22 00:00:00.000', false, 295, 298);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (496, '2016-03-22 00:00:00.000', false, 279, 295);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (497, '2016-03-22 00:00:00.000', false, 302, 303);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (498, '2016-03-22 00:00:00.000', false, 302, 304);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (499, '2016-03-22 00:00:00.000', false, 302, 305);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (500, '2016-03-22 00:00:00.000', false, 302, 306);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (501, '2016-03-22 00:00:00.000', false, 301, 302);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (502, '2016-03-22 00:00:00.000', false, 278, 301);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (503, '2016-03-22 00:00:00.000', false, 309, 310);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (504, '2016-03-22 00:00:00.000', false, 309, 311);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (505, '2016-03-22 00:00:00.000', false, 308, 309);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (506, '2016-03-22 00:00:00.000', false, 307, 308);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (507, '2016-03-22 00:00:00.000', false, 301, 307);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (508, '2016-03-22 00:00:00.000', false, 319, 320);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (509, '2016-03-22 00:00:00.000', false, 319, 321);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (510, '2016-03-22 00:00:00.000', false, 319, 322);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (511, '2016-03-22 00:00:00.000', false, 308, 312);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (512, '2016-03-22 00:00:00.000', false, 308, 313);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (513, '2016-03-22 00:00:00.000', false, 308, 314);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (514, '2016-03-22 00:00:00.000', false, 308, 315);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (515, '2016-03-22 00:00:00.000', false, 308, 316);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (516, '2016-03-22 00:00:00.000', false, 308, 317);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (517, '2016-03-22 00:00:00.000', false, 308, 318);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (518, '2016-03-22 00:00:00.000', false, 308, 319);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (519, '2016-03-22 00:00:00.000', false, 307, 323);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (520, '2016-03-22 00:00:00.000', false, 324, 325);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (521, '2016-03-22 00:00:00.000', false, 324, 326);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (522, '2016-03-22 00:00:00.000', false, 323, 324);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (523, '2016-03-22 00:00:00.000', false, 333, 334);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (524, '2016-03-22 00:00:00.000', false, 333, 335);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (525, '2016-03-22 00:00:00.000', false, 333, 336);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (526, '2016-03-22 00:00:00.000', false, 333, 337);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (527, '2016-03-22 00:00:00.000', false, 333, 338);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (528, '2016-03-22 00:00:00.000', false, 333, 339);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (529, '2016-03-22 00:00:00.000', false, 333, 340);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (530, '2016-03-22 00:00:00.000', false, 323, 327);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (531, '2016-03-22 00:00:00.000', false, 323, 328);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (532, '2016-03-22 00:00:00.000', false, 323, 329);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (533, '2016-03-22 00:00:00.000', false, 323, 330);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (534, '2016-03-22 00:00:00.000', false, 323, 331);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (535, '2016-03-22 00:00:00.000', false, 323, 332);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (536, '2016-03-22 00:00:00.000', false, 323, 333);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (537, '2016-03-22 00:00:00.000', false, 341, 342);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (538, '2016-03-22 00:00:00.000', false, 341, 343);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (539, '2016-03-22 00:00:00.000', false, 278, 341);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (540, '2016-03-22 00:00:00.000', false, 279, 299);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (541, '2016-03-22 00:00:00.000', false, 279, 300);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (542, '2016-03-22 00:00:00.000', false, 346, 347);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (543, '2016-03-22 00:00:00.000', false, 346, 348);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (544, '2016-03-22 00:00:00.000', false, 346, 349);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (545, '2016-03-22 00:00:00.000', false, 354, 355);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (546, '2016-03-22 00:00:00.000', false, 354, 356);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (547, '2016-03-22 00:00:00.000', false, 352, 353);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (548, '2016-03-22 00:00:00.000', false, 352, 354);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (549, '2016-03-22 00:00:00.000', false, 358, 359);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (550, '2016-03-22 00:00:00.000', false, 358, 360);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (551, '2016-03-22 00:00:00.000', false, 357, 358);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (552, '2016-03-22 00:00:00.000', false, 357, 361);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (553, '2016-03-22 00:00:00.000', false, 357, 362);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (554, '2016-03-22 00:00:00.000', false, 363, 364);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (555, '2016-03-22 00:00:00.000', false, 363, 365);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (556, '2016-03-22 00:00:00.000', false, 363, 366);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (557, '2016-03-22 00:00:00.000', false, 367, 368);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (558, '2016-03-22 00:00:00.000', false, 367, 369);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (559, '2016-03-22 00:00:00.000', false, 367, 370);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (560, '2016-03-22 00:00:00.000', false, 367, 371);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (561, '2016-03-22 00:00:00.000', false, 367, 372);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (562, '2016-03-22 00:00:00.000', false, 374, 375);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (563, '2016-03-22 00:00:00.000', false, 374, 376);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (564, '2016-03-22 00:00:00.000', false, 382, 383);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (565, '2016-03-22 00:00:00.000', false, 382, 384);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (566, '2016-03-22 00:00:00.000', false, 386, 387);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (567, '2016-03-22 00:00:00.000', false, 386, 388);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (568, '2016-03-22 00:00:00.000', false, 393, 394);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (569, '2016-03-22 00:00:00.000', false, 393, 395);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (570, '2016-03-22 00:00:00.000', false, 399, 344);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (571, '2016-03-22 00:00:00.000', false, 399, 345);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (572, '2016-03-22 00:00:00.000', false, 399, 363);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (573, '2016-03-22 00:00:00.000', false, 399, 374);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (574, '2016-03-22 00:00:00.000', false, 399, 378);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (575, '2016-03-22 00:00:00.000', false, 399, 382);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (576, '2016-03-22 00:00:00.000', false, 399, 389);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (577, '2016-03-22 00:00:00.000', false, 373, 344);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (578, '2016-03-22 00:00:00.000', false, 373, 345);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (579, '2016-03-22 00:00:00.000', false, 373, 363);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (580, '2016-03-22 00:00:00.000', true, 373, 346);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (581, '2016-03-22 00:00:00.000', true, 373, 350);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (582, '2016-03-22 00:00:00.000', true, 373, 351);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (583, '2016-03-22 00:00:00.000', true, 373, 352);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (584, '2016-03-22 00:00:00.000', true, 373, 357);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (585, '2016-03-22 00:00:00.000', true, 373, 367);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (586, '2016-03-22 00:00:00.000', false, 391, 374);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (587, '2016-03-22 00:00:00.000', false, 391, 378);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (588, '2016-03-22 00:00:00.000', false, 391, 382);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (589, '2016-03-22 00:00:00.000', false, 391, 389);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (590, '2016-03-22 00:00:00.000', true, 391, 377);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (591, '2016-03-22 00:00:00.000', true, 391, 381);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (592, '2016-03-22 00:00:00.000', true, 391, 385);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (593, '2016-03-22 00:00:00.000', true, 391, 386);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (594, '2016-03-22 00:00:00.000', true, 391, 390);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (595, '2016-03-22 00:00:00.000', false, 392, 373);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (596, '2016-03-22 00:00:00.000', false, 392, 391);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (597, '2016-03-22 00:00:00.000', false, 396, 392);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (598, '2016-03-22 00:00:00.000', true, 396, 393);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (599, '2016-03-22 00:00:00.000', false, 398, 396);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (600, '2016-03-22 00:00:00.000', true, 398, 397);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (601, '2016-03-22 00:00:00.000', false, 378, 379);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (602, '2016-03-22 00:00:00.000', false, 378, 380);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (603, '2016-03-22 00:00:00.000', false, 299, 201);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (604, '2016-03-22 00:00:00.000', true, 299, 280);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (605, '2016-03-22 00:00:00.000', true, 299, 284);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (606, '2016-03-22 00:00:00.000', true, 299, 292);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (607, '2016-03-22 00:00:00.000', true, 299, 295);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (608, '2016-03-22 00:00:00.000', true, 299, 301);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (609, '2016-03-22 00:00:00.000', true, 299, 341);
INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
 VALUES (610, '2016-03-22 00:00:00.000', true, 299, 300);

update usestavy as S set idRadRozdil1 = 201,
                         idRadRozdil2 = 278,
                         idradzaokr1 = 201,
                         idradzaokr2 = 297
 where uuid = 'CZ_PODNIKATELE_ROZVAHA_2016';

update usestavy as S set idradzaokr1 = 398
 where uuid = 'CZ_PODNIKATELE_VYSLEDOVKA_2016';

   
  END IF;
  RETURN;
 END;
 $$ LANGUAGE plpgsql;
 ALTER FUNCTION vytvorSestavaVysledovkaCzPodnikatele2016() OWNER TO %firmaRole%;
   
select vytvorSestavaVysledovkaCzPodnikatele2016();
drop function vytvorSestavaVysledovkaCzPodnikatele2016();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
values (nextval('seq_dbversion'), 992, 't', %appVersion%, clock_timestamp());
